BEGIN TRY
IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[HospitalsTemp]') AND type in (N'U'))
	DROP TABLE [HospitalsTemp]

IF NOT EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[HospitalsTemp]') AND type in (N'U'))
BEGIN
CREATE TABLE [HospitalsTemp](
	[Id] [int] IDENTITY(1,1) NOT NULL,
	[Name] [nvarchar](255) NOT NULL,
	[IsSourcedFromBaseData] [bit] NOT NULL,
	[Version] [decimal](19, 5) NULL,
	[CCR] [decimal](19, 4) NULL,
	[CmsProviderID] [nvarchar](10) NULL,
	[LocalHospitalId] [nvarchar](20) NULL,
	[Description] [nvarchar](1000) NULL,
	[Employees] [int] NULL,
	[TotalBeds] [int] NULL,
	[HospitalOwnership] [nvarchar](100) NULL,
	[PhoneNumber] [nvarchar](50) NULL,
	[FaxNumber] [nvarchar](50) NULL,
	[MedicareMedicaidProvider] [bit] NULL,
	[EmergencyService] [bit] NULL,
	[TraumaService] [bit] NULL,
	[UrgentCareService] [bit] NULL,
	[PediatricService] [bit] NULL,
	[PediatricICUService] [bit] NULL,
	[CardiacCatherizationService] [bit] NULL,
	[PharmacyService] [bit] NULL,
	[DiagnosticXRayService] [bit] NULL,
	[ForceLocalHospitalIdValidation] [bit] NULL,
	[IsDeleted] [bit] NULL,
	[IsArchived] [bit] NULL,
	[ArchiveDate] [datetime] NULL,
	[LinkedHospitalId] [int] NULL,
	[Address] [nvarchar](100) NULL,
	[City] [nvarchar](100) NULL,
	[State] [nvarchar](10) NULL,
	[County] [nvarchar](10) NULL,
	[Zip] [nvarchar](12) NULL,
	[Latitude] [float] NULL,
	[Longitude] [float] NULL,
	[HospitalServiceArea_Id] [int] NULL,
	[HealthReferralRegion_Id] [int] NULL,
	[CustomRegion_Id] [int] NULL,
	[Registry_Id] [int] NULL
) ON [PRIMARY]
END

SET IDENTITY_INSERT [HospitalsTemp] ON 

INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1, N'Southeast Alabama Medical Center', 1, NULL, NULL, N'010001', NULL, NULL, 0, 420, NULL, N'3347938701', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1108 Ross Clark Circle', N'Dothan', N'AL', N'01069', N'36301', 31.215378, -85.361534, 327, 2, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2, N'Marshall Medical Center South', 1, NULL, NULL, N'010005', NULL, NULL, 0, 240, NULL, N'2565938310', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2505 U S Highway 431 North', N'Boaz', N'AL', N'01095', N'35957', 34.16637, -86.170841, 316, 1, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3, N'Eliza Coffee Memorial Hospital', 1, NULL, NULL, N'010006', NULL, NULL, 0, 358, NULL, N'2567688400', NULL, 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'205 Marengo Street', N'Florence', N'AL', N'01077', N'35631', 34.79981, -87.677251, 335, 1, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4, N'Mizell Memorial Hospital', 1, NULL, NULL, N'010007', NULL, NULL, 0, 99, NULL, N'3344933541', NULL, 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'702 N Main St', N'Opp', N'AL', N'01039', N'36467', 31.291666, -86.255347, 357, 2, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5, N'Crenshaw Community Hospital', 1, NULL, NULL, N'010008', NULL, NULL, 0, 65, NULL, N'3343353374', NULL, 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'101 Hospital Circle', N'Luverne', N'AL', N'01041', N'36049', 31.716546, -86.263849, 349, 5, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6, N'St Vincent''s East', 1, NULL, NULL, N'010011', NULL, NULL, 0, 362, NULL, N'2058383122', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'50 Medical Park East Drive', N'Birmingham', N'AL', N'01073', N'35235', 33.520682, -86.802433, 315, 1, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (7, N'Dekalb Regional Medical Center', 1, NULL, NULL, N'010012', NULL, NULL, 0, 134, NULL, N'2568453150', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'200 Med Center Drive', N'Fort Payne', N'AL', N'01049', N'35968', 34.444255, -85.719689, 337, 1, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (8, N'Shelby Baptist Medical Center', 1, NULL, NULL, N'010016', NULL, NULL, 0, 192, NULL, N'2056208100', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1000 First Street North', N'Alabaster', N'AL', N'01117', N'35007', 33.208678, -86.761857, 307, 1, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (9, N'Callahan Eye Hospital', 1, NULL, NULL, N'010018', NULL, NULL, 0, 106, NULL, N'2053258100', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1720 University Blvd', N'Birmingham', N'AL', N'01073', N'35233', 33.502958, -86.803155, 315, 1, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (10, N'Helen Keller Memorial Hospital', 1, NULL, NULL, N'010019', NULL, NULL, 0, 185, NULL, N'2563864556', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1300 South Montgomery Avenue', N'Sheffield', N'AL', N'01033', N'35660', 34.74589, -87.699002, 354, 1, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (11, N'Dale Medical Center', 1, NULL, NULL, N'010021', NULL, NULL, 0, 89, NULL, N'3347742601', NULL, 1, 1, 0, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'126 Hospital Ave', N'Ozark', N'AL', N'01045', N'36360', 31.451723, -85.631043, 358, 2, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (12, N'Cherokee Medical Center', 1, NULL, NULL, N'010022', NULL, NULL, 0, 60, NULL, N'2569275531', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'400 Northwood Dr', N'Centre', N'AL', N'01019', N'35960', 34.162688, -85.650835, 321, 76, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (13, N'Baptist Medical Center South', 1, NULL, NULL, N'010023', NULL, NULL, 0, 454, NULL, N'3342882100', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2105 East South Boulevard', N'Montgomery', N'AL', N'01101', N'36116', 32.326526, -86.303366, 352, 5, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (14, N'Jackson Hospital & Clinic Inc', 1, NULL, NULL, N'010024', NULL, NULL, 0, 349, NULL, N'3342938000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1725 Pine Street', N'Montgomery', N'AL', N'01101', N'36106', 32.366629, -86.285936, 352, 5, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (15, N'East Alabama Medical Center', 1, NULL, NULL, N'010029', NULL, NULL, 0, 314, NULL, N'3347493411', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2000 Pepperell Parkway', N'Opelika', N'AL', N'01081', N'36801', 32.638073, -85.405397, 356, 1, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (16, N'Wedowee Hospital', 1, NULL, NULL, N'010032', NULL, NULL, 0, 34, NULL, N'2563572111', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'209 North Main Street', N'Wedowee', N'AL', N'01111', N'36278', 33.310209, -85.485011, 375, 1, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (17, N'University Of Alabama Hospital', 1, NULL, NULL, N'010033', NULL, NULL, 0, 1127, NULL, N'2059344011', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'619 South 19Th Street', N'Birmingham', N'AL', N'01073', N'35233', 33.520682, -86.802433, 315, 1, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (18, N'Community Hospital Inc', 1, NULL, NULL, N'010034', NULL, NULL, 0, 69, NULL, N'3342836541', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'805 Friendship Road', N'Tallassee', N'AL', N'01051', N'36078', 32.535968, -85.893292, 368, 5, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (19, N'Cullman Regional Medical Center', 1, NULL, NULL, N'010035', NULL, NULL, 0, 115, NULL, N'2567372000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1912 Alabama Highway 157', N'Cullman', N'AL', N'01043', N'35058', 34.192697, -86.794376, 323, 1, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (20, N'Andalusia Regional Hospital', 1, NULL, NULL, N'010036', NULL, NULL, 0, 100, NULL, N'3342228466', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'849 South Three Notch Street', N'Andalusia', N'AL', N'01039', N'36420', 31.296571, -86.496801, 309, 66, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (21, N'Stringfellow Memorial Hospital', 1, NULL, NULL, N'010038', NULL, NULL, 0, 125, NULL, N'2562358900', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'301 East 18Th St', N'Anniston', N'AL', N'01015', N'36201', 33.668006, -85.823674, 310, 1, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (22, N'Huntsville Hospital', 1, NULL, NULL, N'010039', NULL, NULL, 0, 881, NULL, N'2562651000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'101 Sivley Rd', N'Huntsville', N'AL', N'01089', N'35801', 34.615232, -86.807343, 346, 3, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (23, N'Gadsden Regional Medical Center', 1, NULL, NULL, N'010040', NULL, NULL, 0, 346, NULL, N'2564944000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1007 Goodyear Avenue', N'Gadsden', N'AL', N'01055', N'35903', 34.009353, -85.970961, 338, 1, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (24, N'Marion Regional Medical Center', 1, NULL, NULL, N'010044', NULL, NULL, 0, 57, NULL, N'2059216200', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1256 Military Street South', N'Hamilton', N'AL', N'01093', N'35570', 34.127512, -87.989736, 344, 161, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (25, N'Fayette Medical Center', 1, NULL, NULL, N'010045', NULL, NULL, 0, 61, NULL, N'2059325966', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1653 Temple Avenue North', N'Fayette', N'AL', N'01057', N'35555', 33.707207, -87.824192, 333, 6, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (26, N'Riverview Regional Medical Center', 1, NULL, NULL, N'010046', NULL, NULL, 0, 281, NULL, N'2565435200', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'600 South Third Street', N'Gadsden', N'AL', N'01055', N'35901', 33.957312, -86.067814, 338, 1, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (27, N'Georgiana Medical Center', 1, NULL, NULL, N'010047', NULL, NULL, 0, 22, NULL, N'3343762205', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'515 N Miranda Avenue', N'Georgiana', N'AL', N'01013', N'36033', 31.637103, -86.741917, 340, 5, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (28, N'Medical Center Enterprise', 1, NULL, NULL, N'010049', NULL, NULL, 0, 131, NULL, N'3343470584', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'400 N Edwards Street', N'Enterprise', N'AL', N'01031', N'36330', 31.318217, -85.855214, 329, 2, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (29, N'St Vincents Blount', 1, NULL, NULL, N'010050', NULL, NULL, 0, 40, NULL, N'2052743000', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'150 Gilbreath Drive', N'Oneonta', N'AL', N'01009', N'35121', 33.9334, -86.495001, 355, 1, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (30, N'Greene County Hospital', 1, NULL, NULL, N'010051', NULL, NULL, 0, 20, NULL, N'2053723388', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'509 Wilson Avenue', N'Eutaw', N'AL', N'01063', N'35462', 32.843283, -87.889577, 371, 6, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (31, N'Lake Martin Community Hospital', 1, NULL, NULL, N'010052', NULL, NULL, 0, 46, NULL, N'2568257821', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'201 Mariarden Road', N'Dadeville', N'AL', N'01123', N'36853', 32.817208, -85.74115, 324, 1, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (32, N'Flowers Hospital', 1, NULL, NULL, N'010055', NULL, NULL, 0, 235, NULL, N'3347935000', N'3346158419', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4370 West Main Street', N'Dothan', N'AL', N'01069', N'36305', 31.236498, -85.459303, 327, 2, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (33, N'St Vincent''s Birmingham', 1, NULL, NULL, N'010056', NULL, NULL, 0, 409, NULL, N'2059397000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'810 St Vincent''s Drive', N'Birmingham', N'AL', N'01073', N'35205', 33.507969, -86.787961, 315, 1, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (34, N'Bibb Medical Center', 1, NULL, NULL, N'010058', NULL, NULL, 0, 35, NULL, N'2059264881', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'208 Pierson Ave', N'Centreville', N'AL', N'01007', N'35042', 32.951456, -87.147038, 322, 6, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (35, N'Lawrence Medical Center', 1, NULL, NULL, N'010059', NULL, NULL, 0, 98, NULL, N'2569742200', N'2569742240', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'202 Hospital Street', N'Moulton', N'AL', N'01079', N'35650', 34.483576, -87.285908, 353, 1, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (36, N'Highlands Medical Center', 1, NULL, NULL, N'010061', NULL, NULL, 0, 170, NULL, N'2562594444', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'380 Woods Cove Road', N'Scottsboro', N'AL', N'01071', N'35768', 34.659366, -86.049409, 364, 3, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (37, N'Wiregrass Medical Center', 1, NULL, NULL, N'010062', NULL, NULL, 0, 83, NULL, N'3346843655', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1200 W Maple Avenue', N'Geneva', N'AL', N'01061', N'36340', 31.048265, -85.890262, 339, 2, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (38, N'Russell Hospital', 1, NULL, NULL, N'010065', NULL, NULL, 0, 81, NULL, N'2563297100', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3316 Highway 280', N'Alexander City', N'AL', N'01123', N'35010', 32.944012, -85.953853, 308, 1, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (39, N'Medical Center Barbour', 1, NULL, NULL, N'010069', NULL, NULL, 0, 74, NULL, N'3346887271', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'820 W Washington St', N'Eufaula', N'AL', N'01005', N'36027', 31.888033, -85.157902, 330, 2, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (40, N'Clay County Hospital', 1, NULL, NULL, N'010073', NULL, NULL, 0, 53, NULL, N'2563542131', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'83825 Highway 9    P O Box 1270', N'Ashland', N'AL', N'01027', N'36251', 34.799257, -86.516102, 311, 1, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (41, N'Northeast Alabama Regional Med Center', 1, NULL, NULL, N'010078', NULL, NULL, 0, 338, NULL, N'2562355121', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'400 East 10Th Street', N'Anniston', N'AL', N'01015', N'36207', 33.655982, -85.822589, 310, 1, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (42, N'Athens-Limestone Hospital', 1, NULL, NULL, N'010079', NULL, NULL, 0, 101, NULL, N'2562339292', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'700 West Market Street', N'Athens', N'AL', N'01083', N'35611', 34.828383, -86.917134, 312, 3, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (43, N'South Baldwin Regional Medical Center', 1, NULL, NULL, N'010083', NULL, NULL, 0, 112, NULL, N'2519493400', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1613 North Mckenzie Street', N'Foley', N'AL', N'01003', N'36535', 30.406587, -87.683597, 336, 4, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (44, N'Decatur Morgan Hospital-Decatur Campus', 1, NULL, NULL, N'010085', NULL, NULL, 0, 337, NULL, N'2563412000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1201 7Th Street Se', N'Decatur', N'AL', N'01103', N'35601', 34.591117, -86.972577, 325, 3, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (45, N'Northwest Medical Center', 1, NULL, NULL, N'010086', NULL, NULL, 0, 71, NULL, N'2054877736', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1530 U S Highway 43', N'Winfield', N'AL', N'01093', N'35594', 33.928993, -87.817246, 376, 1, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (46, N'University Of South Alabama Medical Center', 1, NULL, NULL, N'010087', NULL, NULL, 0, 406, NULL, N'2514717110', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2451 Fillingim Street', N'Mobile', N'AL', N'01097', N'36617', 30.708015, -88.099581, 350, 4, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (47, N'Walker Baptist Medical Center', 1, NULL, NULL, N'010089', NULL, NULL, 0, 267, NULL, N'2053874000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3400 Highway 78 East', N'Jasper', N'AL', N'01127', N'35502', 33.887519, -87.264105, 348, 1, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (48, N'Providence Hospital', 1, NULL, NULL, N'010090', NULL, NULL, 0, 349, NULL, N'2516331000', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6801 Airport Boulevard', N'Mobile', N'AL', N'01097', N'36608', 30.682719, -88.200769, 350, 4, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (49, N'Grove Hill Memorial Hospital', 1, NULL, NULL, N'010091', NULL, NULL, 0, 50, NULL, N'2512753191', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'295 Jackson Hwy S', N'Grove Hill', N'AL', N'01025', N'36451', 31.708768, -87.777222, 341, 4, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (50, N'D C H Regional Medical Center', 1, NULL, NULL, N'010092', NULL, NULL, 0, 787, NULL, N'2057597111', NULL, 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'809 University Boulevard East', N'Tuscaloosa', N'AL', N'01125', N'35401', 33.206052, -87.525314, 371, 6, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (51, N'Hale County Hospital', 1, NULL, NULL, N'010095', NULL, NULL, 0, 39, NULL, N'3346243024', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'508 Green Street', N'Greensboro', N'AL', N'01065', N'36744', 32.704575, -87.59584, 371, 6, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (52, N'Elmore Community Hospital', 1, NULL, NULL, N'010097', NULL, NULL, 0, 69, NULL, N'3345674311', N'3345674312', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'500 Hospital Drive', N'Wetumpka', N'AL', N'01051', N'36092', 32.551159, -86.190032, 352, 5, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (53, N'D W Mcmillan Memorial Hospital', 1, NULL, NULL, N'010099', NULL, NULL, 0, 65, NULL, N'2518678061', N'2518098459', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1301 Belleville Avenue', N'Brewton', N'AL', N'01053', N'36426', 31.127222, -87.072525, 317, 66, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (54, N'Thomas Hospital', 1, NULL, NULL, N'010100', NULL, NULL, 0, 150, NULL, N'2519282375', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'750 Morphy Avenue', N'Fairhope', N'AL', N'01003', N'36532', 30.519906, -87.888303, 332, 4, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (55, N'Citizens Baptist Medical Center', 1, NULL, NULL, N'010101', NULL, NULL, 0, 122, NULL, N'2567614542', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'604 Stone Avenue', N'Talladega', N'AL', N'01121', N'35161', 33.439862, -86.090084, 367, 1, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (56, N'J Paul Jones Hospital', 1, NULL, NULL, N'010102', NULL, NULL, 0, 30, NULL, N'3346824131', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'317 Mcwilliams Avenue', N'Camden', N'AL', N'01131', N'36726', 31.990981, -87.290546, 319, 1, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (57, N'Baptist Medical Center-Princeton', 1, NULL, NULL, N'010103', NULL, NULL, 0, 505, NULL, N'2057833800', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'701 Princeton Avenue Southwest', N'Birmingham', N'AL', N'01073', N'35211', 33.499436, -86.845365, 315, 1, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (58, N'Trinity Medical Center', 1, NULL, NULL, N'010104', NULL, NULL, 0, 534, NULL, N'2055921000', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'800 Montclair Rd', N'Birmingham', N'AL', N'01073', N'35213', 33.513855, -86.748985, 315, 1, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (59, N'Prattville Baptist Hospital', 1, NULL, NULL, N'010108', NULL, NULL, 0, 85, NULL, N'3343614267', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'124 S Memorial Dr', N'Prattville', N'AL', N'01001', N'36067', 32.464479, -86.451032, 360, 5, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (60, N'Pickens County Medical Center', 1, NULL, NULL, N'010109', NULL, NULL, 0, 56, NULL, N'2053678111', N'2053672121', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'241 Robert K Wilson Drive', N'Carrollton', N'AL', N'01107', N'35447', 33.261787, -88.095026, 320, 6, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (61, N'Bullock County Hospital', 1, NULL, NULL, N'010110', NULL, NULL, 0, 54, NULL, N'3347382140', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'102 West Conecuh Avenue', N'Union Springs', N'AL', N'01011', N'36089', 32.146233, -85.713575, 372, 5, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (62, N'Bryan W. Whitfield Memorial Hospital', 1, NULL, NULL, N'010112', NULL, NULL, 0, 99, NULL, N'3342894000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'105 Highway 80 East', N'Demopolis', N'AL', N'01091', N'36732', 32.517828, -87.83682, 326, 1, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (63, N'Mobile Infirmary', 1, NULL, NULL, N'010113', NULL, NULL, 0, 689, NULL, N'2514354700', NULL, 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5 Mobile Infirmary Circle', N'Mobile', N'AL', N'01097', N'36652', 30.696401, -88.078851, 350, 4, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (64, N'Medical West  An Affiliate Of Uab Health System', 1, NULL, NULL, N'010114', NULL, NULL, 0, 300, NULL, N'2054817000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'995 9Th Avenue Southwest', N'Bessemer', N'AL', N'01073', N'35021', 33.369488, -86.995485, 314, 1, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (65, N'Vaughan Regional Medical Center Parkway Campus', 1, NULL, NULL, N'010118', NULL, NULL, 0, 214, NULL, N'3344184100', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1015 Medical Center Parkway', N'Selma', N'AL', N'01047', N'36701', 32.42814, -87.052787, 365, 1, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (66, N'Monroe County Hospital', 1, NULL, NULL, N'010120', NULL, NULL, 0, 94, NULL, N'2515753111', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2016 South Alabama Avenue  Box 886', N'Monroeville', N'AL', N'01099', N'36460', 31.52794, -87.324708, 351, 4, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (67, N'Lakeland Community Hospital', 1, NULL, NULL, N'010125', NULL, NULL, 0, 50, NULL, N'2054857117', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'42024 Highway 195 E     Post Office Box 780', N'Haleyville', N'AL', N'01133', N'35565', 34.226488, -87.621413, 343, 1, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (68, N'Troy Regional Medical Center', 1, NULL, NULL, N'010126', NULL, NULL, 0, 97, NULL, N'3346705000', N'3345667490', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1330 Highway 231 South', N'Troy', N'AL', N'01109', N'36081', 31.808768, -85.969951, 370, 5, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (69, N'Jackson Medical Center', 1, NULL, NULL, N'010128', NULL, NULL, 0, 35, NULL, N'2512469021', NULL, 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'220 Hospital Drive', N'Jackson', N'AL', N'01025', N'36545', 31.530266, -87.892618, 350, 4, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (70, N'North Baldwin Infirmary', 1, NULL, NULL, N'010129', NULL, NULL, 0, 70, NULL, N'2519375521', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1815 Hand Avenue', N'Bay Minette', N'AL', N'01003', N'36507', 30.901717, -87.783075, 350, 4, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (71, N'St Vincent''s St Clair', 1, NULL, NULL, N'010130', NULL, NULL, 0, 40, NULL, N'2053383301', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7063 Veterans Parkway', N'Pell City', N'AL', N'01115', N'35125', 33.607001, -86.290967, 315, 1, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (72, N'Crestwood Medical Center', 1, NULL, NULL, N'010131', NULL, NULL, 0, 147, NULL, N'2568823100', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'One Hospital Dr Se', N'Huntsville', N'AL', N'01089', N'35801', 34.615232, -86.807343, 346, 3, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (73, N'Hill Hospital Of Sumter County', 1, NULL, NULL, N'010138', NULL, NULL, 0, 33, NULL, N'2053925263', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'751 Derby Drive', N'York', N'AL', N'01119', N'36925', 32.491471, -88.296738, 2038, 159, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (74, N'Brookwood Medical Center', 1, NULL, NULL, N'010139', NULL, NULL, 0, 586, NULL, N'2058771000', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2010 Brookwood Medical Center Drive', N'Birmingham', N'AL', N'01073', N'35209', 33.520682, -86.802433, 315, 1, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (75, N'Springhill Memorial Hospital', 1, NULL, NULL, N'010144', NULL, NULL, 0, 252, NULL, N'2513449630', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3719 Dauphin Street', N'Mobile', N'AL', N'01097', N'36608', 30.685389, -88.136099, 350, 4, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (76, N'Rmc Jacksonville', 1, NULL, NULL, N'010146', NULL, NULL, 0, 89, NULL, N'2567824538', N'2567824589', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1701 South Pelham Road', N'Jacksonville', N'AL', N'01015', N'36265', 33.813716, -85.761348, 347, 1, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (77, N'Evergreen Medical Center', 1, NULL, NULL, N'010148', NULL, NULL, 0, 44, NULL, N'2515782480', N'2515782480', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'101 Crestview Avenue', N'Evergreen', N'AL', N'01035', N'36401', 31.433499, -86.956918, 331, 5, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (78, N'Baptist Medical Center East', 1, NULL, NULL, N'010149', NULL, NULL, 0, 150, NULL, N'3342448330', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'400 Taylor Road', N'Montgomery', N'AL', N'01101', N'36117', 32.357715, -86.171391, 352, 5, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (79, N'L V Stabler Memorial Hospital', 1, NULL, NULL, N'010150', NULL, NULL, 0, 72, NULL, N'3343822200', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'29 L V Stabler Drive', N'Greenville', N'AL', N'01013', N'36037', 31.82851, -86.646283, 340, 5, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (80, N'Shoals Hospital', 1, NULL, NULL, N'010157', NULL, NULL, 0, 178, NULL, N'2563861601', NULL, 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'201 West Avalon Avenue', N'Muscle Shoals', N'AL', N'01033', N'35661', 34.744903, -87.672471, 354, 1, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (81, N'Russellville Hospital', 1, NULL, NULL, N'010158', NULL, NULL, 0, 100, NULL, N'2563321611', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'15155 Highway 43', N'Russellville', N'AL', N'01059', N'35653', 34.506811, -87.728999, 363, 1, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (82, N'Coosa Valley Medical Center', 1, NULL, NULL, N'010164', NULL, NULL, 0, 163, NULL, N'2562495000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'315 W Hickory St', N'Sylacauga', N'AL', N'01121', N'35150', 33.164604, -86.254094, 366, 1, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (83, N'Uab Highlands', 1, NULL, NULL, N'010167', NULL, NULL, 0, 219, NULL, N'2059307000', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1201 11Th Avenue South', N'Birmingham', N'AL', N'01073', N'35205', 33.495347, -86.807202, 315, 1, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (84, N'Jack Hughston Memorial Hospital', 1, NULL, NULL, N'010168', NULL, NULL, 0, 70, NULL, N'3347323000', N'3347323020', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4401 River Chase Drive', N'Phenix City', N'AL', N'01113', N'36867', 32.504616, -85.003499, 359, 74, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (85, N'Atmore Community Hospital', 1, NULL, NULL, N'010169', NULL, NULL, 0, 49, NULL, N'2513682500', N'2513686237', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'401 Medical Park Drive', N'Atmore', N'AL', N'01053', N'36502', 31.016193, -87.479823, 313, 66, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (86, N'Washington County Hospital', 1, NULL, NULL, N'011300', NULL, NULL, 0, 25, NULL, N'2518472223', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'14600 St. Stephens Avenue', N'Chatom', N'AL', N'01129', N'36518', 31.465165, -88.254456, 350, 4, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (87, N'Red Bay Hospital', 1, NULL, NULL, N'011302', NULL, NULL, 0, 25, NULL, N'2563569532', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'211 Hospital Road', N'Red Bay', N'AL', N'01059', N'35582', 34.457346, -88.145432, 361, 1, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (88, N'Choctaw General Hospital', 1, NULL, NULL, N'011304', NULL, NULL, 0, 25, NULL, N'2054599100', N'2054599190', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'401 Vanity Fair Lane  Po Box 618', N'Butler', N'AL', N'01023', N'36904', 32.089591, -88.221965, 2038, 159, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (89, N'Infirmary Ltac Hospital', 1, NULL, NULL, N'012006', NULL, NULL, 0, 38, NULL, N'2516605611', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5 Mobile Infirmary Circle', N'Mobile', N'AL', N'01097', N'36607', 30.696401, -88.078851, 350, 4, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (90, N'Noland Hospital Montgomery  Llc', 1, NULL, NULL, N'012007', NULL, NULL, 0, 60, NULL, N'3342400532', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1725 Pine Street 5Th Floor North Wing', N'Montgomery', N'AL', N'01101', N'36106', 32.366966, -86.300648, 352, 5, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (91, N'Select Specialty Hosp-Birmingham', 1, NULL, NULL, N'012008', NULL, NULL, 0, 38, NULL, N'2055994595', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'800 Montclair Road 9Th Floor', N'Birmingham', N'AL', N'01073', N'35213', 33.520682, -86.802433, 315, 1, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (92, N'Noland Hospital Birmingham  Llc', 1, NULL, NULL, N'012009', NULL, NULL, 0, 45, NULL, N'2058385100', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'50 Medical Park East Drive 8Th Floor', N'Birmingham', N'AL', N'01073', N'35235', 33.520682, -86.802433, 315, 1, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (93, N'Noland Hospital Dothan Ii  Llc', 1, NULL, NULL, N'012010', NULL, NULL, 0, 35, NULL, N'3346994300', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1108 Ross Clark Circle 4Th Floor', N'Dothan', N'AL', N'01069', N'36302', 31.223231, -85.390489, 327, 2, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (94, N'Noland Hospital Anniston  Llc', 1, NULL, NULL, N'012011', NULL, NULL, 0, 38, NULL, N'2567416141', N'2567416158', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'400 East 10Th Street 4Th Floor', N'Anniston', N'AL', N'01015', N'36202', 33.659442, -85.831633, 310, 1, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (95, N'Noland Hospital Tuscaloosa  Llc', 1, NULL, NULL, N'012012', NULL, NULL, 0, 32, NULL, N'2057597241', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'809 University Boulevard East 4Th Floor', N'Tuscaloosa', N'AL', N'01125', N'35401', 33.209561, -87.567526, 371, 6, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (96, N'Noland Hospital Shelby  Llc', 1, NULL, NULL, N'012013', NULL, NULL, 0, 52, NULL, N'2056208641', NULL, 1, 0, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1000 First Street 3Rd Floor', N'Alabaster', N'AL', N'01117', N'35007', 33.208678, -86.761857, 307, 1, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (97, N'Healthsouth Lakeshore Rehabilitation Hospital', 1, NULL, NULL, N'013025', NULL, NULL, 0, 100, NULL, N'2058682000', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3800 Ridgeway Drive', N'Birmingham', N'AL', N'01073', N'35209', 33.520682, -86.802433, 315, 1, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (98, N'Healthsouth Rehabilitation Hospital Of Montgomery', 1, NULL, NULL, N'013028', NULL, NULL, 0, 70, NULL, N'3342847821', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4465 Narrow Lane Rd', N'Montgomery', N'AL', N'01101', N'36116', 32.319885, -86.282036, 352, 5, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (99, N'Healthsouth Rehabilitation Hospital Of North Al', 1, NULL, NULL, N'013029', NULL, NULL, 0, 70, NULL, N'2055352300', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'107 Governors Drive', N'Huntsville', N'AL', N'01089', N'35801', 34.720218, -86.619723, 346, 3, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (100, N'Healthsouth Rehabilitation Hospital', 1, NULL, NULL, N'013030', NULL, NULL, 0, 51, NULL, N'3347126333', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1736 East Main Street', N'Dothan', N'AL', N'01069', N'36301', 31.223325, -85.389699, 327, 2, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (101, N'Healthsouth Rehabilitation Hospital Of Gadsden', 1, NULL, NULL, N'013032', NULL, NULL, 0, 44, NULL, N'2564395000', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'801 Goodyear Ave', N'Gadsden', N'AL', N'01055', N'35903', 34.001631, -85.949158, 338, 1, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (102, N'Regional Rehabilitation Hospital', 1, NULL, NULL, N'013033', NULL, NULL, 0, 48, NULL, N'3347322200', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3715 Highway 280', N'Phenix City', N'AL', N'01113', N'36869', 32.470976, -85.000765, 359, 74, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (103, N'Children''s Hospital Of Alabama', 1, NULL, NULL, N'013300', NULL, NULL, 0, 332, NULL, N'2059399100', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1600 Seventh Avenue South', N'Birmingham', N'AL', N'01073', N'35233', 33.520682, -86.802433, 315, 1, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (104, N'University Of S A Children''s And Women''s Hos', 1, NULL, NULL, N'013301', NULL, NULL, 0, 152, NULL, N'2514151000', NULL, 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1700 Center Street', N'Mobile', N'AL', N'01097', N'36604', 30.696206, -88.076978, 350, 4, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (105, N'Hill Crest Behavioral Health Services', 1, NULL, NULL, N'014000', NULL, NULL, 0, 94, NULL, N'2058339000', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6869 Fifth Avenue South', N'Birmingham', N'AL', N'01073', N'35212', 33.520682, -86.802433, 315, 1, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (106, N'Mountain View Hospital', 1, NULL, NULL, N'014006', NULL, NULL, 0, 68, NULL, N'2565469265', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3201 Scenic Highway', N'Gadsden', N'AL', N'01055', N'35902', 34.108974, -85.982199, 338, 1, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (107, N'Bryce Hospital', 1, NULL, NULL, N'014007', NULL, NULL, 0, 268, NULL, N'2057590750', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'200 University Blvd', N'Tuscaloosa', N'AL', N'01125', N'35401', 33.210662, -87.565588, 371, 6, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (108, N'North Alabama Regional Hospital', 1, NULL, NULL, N'014009', NULL, NULL, 0, 74, NULL, N'2563539433', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4218 Hwy 31 South', N'Decatur', N'AL', N'01103', N'35609', 34.542533, -86.909061, 325, 3, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (109, N'Mary S Harper Geriatric Psychiatry Center', 1, NULL, NULL, N'014012', NULL, NULL, 0, 96, NULL, N'2057590900', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'201 University Blvd', N'Tuscaloosa', N'AL', N'01125', N'35401', 33.210662, -87.565588, 371, 6, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (110, N'Laurel Oaks Behavioral Health Center', 1, NULL, NULL, N'014013', NULL, NULL, 0, 24, NULL, N'3347947393', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'700 East Cottonwood Rd', N'Dothan', N'AL', N'01069', N'36301', 31.20484, -85.384179, 327, 2, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (111, N'Baypointe Behavioral Health', 1, NULL, NULL, N'014014', NULL, NULL, 0, 60, NULL, N'2516627998', N'2516667537', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5800 Southland Drive', N'Mobile', N'AL', N'01097', N'36693', 30.623903, -88.177561, 350, 4, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (112, N'Beacon Children''s Hospital', 1, NULL, NULL, N'014015', NULL, NULL, 0, 28, NULL, N'3343355040', NULL, 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'150 Hospital Drive', N'Luverne', N'AL', N'01041', N'36049', 31.716546, -86.263849, 349, 5, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (113, N'Sanctuary At The Woodlands  The', 1, NULL, NULL, N'014016', NULL, NULL, 0, 20, NULL, N'2567391239', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1910 Cherokee Avenue  Sw', N'Cullman', N'AL', N'01043', N'35055', 34.142068, -86.84824, 323, 1, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (114, N'Eastpointe Hospital', 1, NULL, NULL, N'014017', NULL, NULL, 0, 66, NULL, N'2513786500', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7400 Roper Lane', N'Daphne', N'AL', N'01003', N'36526', 30.635236, -87.898021, 350, 4, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (115, N'Behavioral Healthcare Center At Huntsville Inc', 1, NULL, NULL, N'014018', NULL, NULL, 0, 20, NULL, N'2569646700', NULL, 1, 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5315 Millenium Drive Nw', N'Huntsville', N'AL', N'01089', N'35806', 34.615232, -86.807343, 346, 3, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (116, N'Children''s Hospital Of Alabama', 1, NULL, NULL, N'019801', NULL, NULL, 0, 0, NULL, N'2056389828', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'1600 Seventh Avenue South', N'Birmingham', N'AL', N'01073', N'35233', 33.520682, -86.802433, 315, 1, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (117, N'Providence Alaska Medical Center', 1, NULL, NULL, N'020001', NULL, NULL, 0, 401, NULL, N'9072613675', N'9072613041', 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Box 196604', N'Anchorage', N'AK', N'02020', N'99508', 61.624327, -149.77812, 377, 7, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (118, N'Mat-Su Regional Medical Center', 1, NULL, NULL, N'020006', NULL, NULL, 0, 39, NULL, N'9077468600', N'9077468653', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2500 South Woodworth Loop', N'Palmer', N'AK', N'02170', N'99645', 61.59808, -149.109967, 385, 7, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (119, N'Bartlett Regional Hospital', 1, NULL, NULL, N'020008', NULL, NULL, 0, 57, NULL, N'9077968900', N'9074634919', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3260 Hospital Dr', N'Juneau', N'AK', N'02110', N'99801', 58.330026, -134.470129, 381, 7, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (120, N'Fairbanks Memorial Hospital', 1, NULL, NULL, N'020012', NULL, NULL, 0, 162, NULL, N'9074528181', N'9074585324', 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1650 Cowles Street', N'Fairbanks', N'AK', N'02090', N'99701', 64.834606, -147.739213, 379, 7, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (121, N'Alaska Regional Hospital', 1, NULL, NULL, N'020017', NULL, NULL, 0, 238, NULL, N'9072761131', N'9072641143', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2801 Debarr Road', N'Anchorage', N'AK', N'02020', N'99508', 61.209797, -149.82876, 377, 7, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (122, N'Yukon Kuskokwim Delta Reg Hospital', 1, NULL, NULL, N'020018', NULL, NULL, 0, 50, NULL, N'9075436300', N'9075436366', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Po Box 287', N'Bethel', N'AK', N'02050', N'99559', 60.792222, -161.755833, 393, 7, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (123, N'Central Peninsula General Hospital', 1, NULL, NULL, N'020024', NULL, NULL, 0, 49, NULL, N'9072624404', N'9072628184', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'250 Hospital Place', N'Soldotna', N'AK', NULL, N'99669', 60.494319, -151.0778, 389, 7, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (124, N'Alaska Native Medical Center', 1, NULL, NULL, N'020026', NULL, NULL, 0, 143, NULL, N'9075632662', N'9077291984', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4315 Diplomacy Dr', N'Anchorage', N'AK', N'02020', N'99508', 61.181961, -149.795906, 377, 7, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (125, N'Mt Edgecumbe Hospital', 1, NULL, NULL, N'020027', NULL, NULL, 0, 27, NULL, N'9079662411', N'9079668656', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'222 Tongass Dr', N'Sitka', N'AK', N'02220', N'99835', 57.051662, -135.355063, 388, 7, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (126, N'Providence Valdez Medical Center', 1, NULL, NULL, N'021301', NULL, NULL, 0, 15, NULL, N'9078352249', N'9078353735', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Po Box 550', N'Valdez', N'AK', NULL, N'99686', 61.139617, -146.384148, 390, 7, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (127, N'Providence Seward Hospital', 1, NULL, NULL, N'021302', NULL, NULL, 0, 6, NULL, N'9072245205', N'9072247248', 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'417 First Avenue Po Box 365', N'Seward', N'AK', NULL, N'99664', 60.119514, -149.414954, 387, 7, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (128, N'Sitka Community Hospital', 1, NULL, NULL, N'021303', NULL, NULL, 0, 24, NULL, N'9077473241', N'9077471794', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'209 Moller Drive', N'Sitka', N'AK', N'02220', N'99835', 57.058896, -135.345658, 388, 7, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (129, N'Petersburg Medical Center', 1, NULL, NULL, N'021304', NULL, NULL, 0, 12, NULL, N'9077724291', N'9077723085', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Po Box 589', N'Petersburg', N'AK', NULL, N'99833', 56.812797, -132.95547, 386, 7, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (130, N'Wrangell Medical Center', 1, NULL, NULL, N'021305', NULL, NULL, 0, 8, NULL, N'9078747000', N'9078747122', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'310 Bennett Street Po Box 1081', N'Wrangell', N'AK', NULL, N'99929', 56.415623, -132.300945, 391, 7, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (131, N'Providence Kodiak Island Medical Ctr', 1, NULL, NULL, N'021306', NULL, NULL, 0, 25, NULL, N'9074869592', N'9074862336', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1915 East Rezanof Drive', N'Kodiak', N'AK', N'02150', N'99615', 57.801692, -152.372908, 383, 7, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (132, N'Cordova Community Medical Center', 1, NULL, NULL, N'021307', NULL, NULL, 0, 13, NULL, N'9074248000', N'9074248160', 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'Po Box 160 - 602 Chase Avenue', N'Cordova', N'AK', NULL, N'99574', 60.55301, -145.6883, 378, 7, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (133, N'Norton Sound Regional Hospital', 1, NULL, NULL, N'021308', NULL, NULL, 0, 21, NULL, N'9074433311', N'9074433139', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1000 Greg Kruschek Avenue (P O Box 966)', N'Nome', N'AK', N'02180', N'99762', 64.501111, -165.406389, 384, 7, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (134, N'Kanakanak Hospital', 1, NULL, NULL, N'021309', NULL, NULL, 0, 15, NULL, N'9078425201', N'9078429354', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'P O Box 130', N'Dillingham', N'AK', N'02070', N'99576', 59.047936, -158.520708, 394, 7, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (135, N'Maniilaq Health Center', 1, NULL, NULL, N'021310', NULL, NULL, 0, 17, NULL, N'9074423321', N'9074427250', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Po Box 43', N'Kotzebue', N'AK', NULL, N'99752', 66.898206, -162.597762, 395, 7, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (136, N'Ketchikan Medical Center', 1, NULL, NULL, N'021311', NULL, NULL, 0, 25, NULL, N'9072255171', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3100 Tongass Avenue', N'Ketchikan', N'AK', N'02130', N'99901', 55.353392, -131.686465, 382, 7, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (137, N'Samuel Simmonds Memorial Hospital', 1, NULL, NULL, N'021312', NULL, NULL, 0, 14, NULL, N'9078524611', N'9078529231', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7000 Uula St', N'Barrow', N'AK', NULL, N'99723', 71.300465, -156.730897, 392, 7, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (138, N'South Peninsula Hospital', 1, NULL, NULL, N'021313', NULL, NULL, 0, 22, NULL, N'9072358101', N'9072350253', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4300 Bartlett St', N'Homer', N'AK', NULL, N'99603', 59.652237, -151.550027, 380, 7, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (139, N'St Elias Specialty Hospital', 1, NULL, NULL, N'022001', NULL, NULL, 0, 60, NULL, N'9075613333', N'9075613332', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4800 Cordova Street', N'Anchorage', N'AK', N'02020', N'99503', 61.176766, -149.879115, 377, 7, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (140, N'North Star Hospital', 1, NULL, NULL, N'024001', NULL, NULL, 0, 110, NULL, N'9072643526', N'9072777844', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2530 Debarr Rd', N'Anchorage', N'AK', N'02020', N'99508', 61.20875, -149.8329, 377, 7, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (141, N'Alaska Psychiatric Institute', 1, NULL, NULL, N'024002', NULL, NULL, 0, 95, NULL, N'9072697100', N'9072697521', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3700 Piper Street', N'Anchorage', N'AK', N'02020', N'99508', 61.18654, -149.82655, 377, 7, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (142, N'Abrazo Maryvale Campus', 1, NULL, NULL, N'030001', NULL, NULL, 0, 232, NULL, N'6238485957', N'6238485553', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5102 West Campbell Avenue', N'Phoenix', N'AZ', N'04013', N'85031', 33.502222, -112.168939, 411, 9, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (143, N'Banner - University Medical Center Phoenix Campus', 1, NULL, NULL, N'030002', NULL, NULL, 0, 668, NULL, N'6022392000', N'6022393749', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1111 East Mcdowell Road', N'Phoenix', N'AZ', N'04013', N'85006', 33.46563, -112.059908, 411, 9, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (144, N'Tucson Medical Center', 1, NULL, NULL, N'030006', NULL, NULL, 0, 616, NULL, N'5203242931', N'5203241999', 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5301 East Grant Road', N'Tucson', N'AZ', N'04019', N'85712', 32.25075, -110.879685, 419, 11, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (145, N'Verde Valley Medical Center', 1, NULL, NULL, N'030007', NULL, NULL, 0, 110, NULL, N'9286396058', N'9287732348', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'269 South Candy Lane', N'Cottonwood', N'AZ', N'04025', N'86326', 34.738261, -112.031195, 400, 9, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (146, N'Carondelet St  Marys Hospital', 1, NULL, NULL, N'030010', NULL, NULL, 0, 400, NULL, N'5208723000', N'5208733921', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1601 West St Mary''s Road', N'Tucson', N'AZ', N'04019', N'85745', 32.228693, -111.001196, 419, 11, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (147, N'Carondelet St Joseph''s Hospital', 1, NULL, NULL, N'030011', NULL, NULL, 0, 471, NULL, N'5208733000', N'5208733921', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'350 North Wilmot Road', N'Tucson', N'AZ', N'04019', N'85711', 32.225907, -110.857834, 419, 11, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (148, N'Yavapai Regional Medical Center', 1, NULL, NULL, N'030012', NULL, NULL, 0, 134, NULL, N'9287715676', N'9284582015', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1003 Willow Creek Road', N'Prescott', N'AZ', N'04025', N'86301', 34.560232, -112.482272, 412, 9, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (149, N'Yuma Regional Medical Center', 1, NULL, NULL, N'030013', NULL, NULL, 0, 369, NULL, N'9283367275', N'9283367337', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2400 South Avenue A', N'Yuma', N'AZ', N'04027', N'85364', 32.683826, -114.633353, 423, 9, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (150, N'John C Lincoln Medical Center', 1, NULL, NULL, N'030014', NULL, NULL, 0, 266, NULL, N'6028706010', N'6029449610', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'250 East Dunlap Avenue', N'Phoenix', N'AZ', N'04013', N'85020', 33.567836, -112.070768, 411, 9, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (151, N'Banner Casa Grande Medical Center', 1, NULL, NULL, N'030016', NULL, NULL, 0, 201, NULL, N'5203816453', N'5203816435', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1800 East Florence Boulevard', N'Casa Grande', N'AZ', N'04021', N'85222', 32.88057, -111.709772, NULL, NULL, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (152, N'Maricopa Medical Center', 1, NULL, NULL, N'030022', NULL, NULL, 0, 522, NULL, N'6023445011', N'6023445190', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2601 East Roosevelt Street', N'Phoenix', N'AZ', N'04013', N'85008', 33.458639, -112.038097, 411, 9, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (153, N'Flagstaff Medical Center', 1, NULL, NULL, N'030023', NULL, NULL, 0, 267, NULL, N'9287732378', N'9287732348', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1200 North Beaver Street', N'Flagstaff', N'AZ', N'04005', N'86001', 35.209183, -111.644853, 402, 9, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (154, N'St Joseph''s Hospital And Medical Center', 1, NULL, NULL, N'030024', NULL, NULL, 0, 607, NULL, N'6024063000', N'6024067143', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'350 West Thomas Road', N'Phoenix', N'AZ', N'04013', N'85013', 33.480391, -112.07884, 411, 9, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (155, N'Abrazo Central Campus', 1, NULL, NULL, N'030030', NULL, NULL, 0, 221, NULL, N'6022490212', N'6022465849', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2000 West Bethany Home Road', N'Phoenix', N'AZ', N'04013', N'85015', 33.525276, -112.102077, 411, 9, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (156, N'Payson Regional Medical Center', 1, NULL, NULL, N'030033', NULL, NULL, 0, 44, NULL, N'9284743222', N'9284721295', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'807 South Ponderosa Drive', N'Payson', N'AZ', N'04007', N'85541', 34.230868, -111.325135, 410, 9, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (157, N'Chandler Regional Medical Center', 1, NULL, NULL, N'030036', NULL, NULL, 0, 243, NULL, N'4809634561', N'4808995548', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1955 West Frye Road', N'Chandler', N'AZ', N'04013', N'85224', 33.298614, -111.875436, 399, 8, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (158, N'St Luke''s Medical Center', 1, NULL, NULL, N'030037', NULL, NULL, 0, 226, NULL, N'6022518156', N'6022518685', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1800 East Van Buren Street', N'Phoenix', N'AZ', N'04013', N'85006', 33.45151, -112.043225, 411, 9, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (159, N'Scottsdale Osborn Medical Center', 1, NULL, NULL, N'030038', NULL, NULL, 0, 340, NULL, N'4808824000', N'4808824989', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7400 East Osborn Road', N'Scottsdale', N'AZ', N'04013', N'85251', 33.488573, -111.922983, 414, 9, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (160, N'Sierra Vista Regional Health Center', 1, NULL, NULL, N'030043', NULL, NULL, 0, 88, NULL, N'5204173001', N'5204173297', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'300 El Camino Real', N'Sierra Vista', N'AZ', N'04003', N'85635', 31.551104, -110.272492, 416, 11, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (161, N'Kingman Regional Medical Center', 1, NULL, NULL, N'030055', NULL, NULL, 0, 235, NULL, N'9287572101', N'9287570604', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3269 Stockton Hill Road', N'Kingman', N'AZ', N'04015', N'86409', 35.216244, -114.035382, 405, 9, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (162, N'Banner Boswell Medical Center', 1, NULL, NULL, N'030061', NULL, NULL, 0, 430, NULL, N'6239777211', N'6238765795', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'10401 West Thunderbird Boulevard', N'Sun City', N'AZ', N'04013', N'85351', 33.602847, -112.283781, 418, 10, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (163, N'Summit Healthcare Regional Medical Center', 1, NULL, NULL, N'030062', NULL, NULL, 0, 89, NULL, N'9285374375', N'9285378839', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2200 Show Low Lake Road', N'Show Low', N'AZ', N'04017', N'85901', 34.254208, -110.029833, 415, 9, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (164, N'Banner-University Medical Center Tucson Campus', 1, NULL, NULL, N'030064', NULL, NULL, 0, 487, NULL, N'5208744189', N'5206944085', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1501 North Campbell Avenue', N'Tucson', N'AZ', N'04019', N'85724', 32.24053, -110.944076, 419, 11, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (165, N'Banner Desert Medical Center', 1, NULL, NULL, N'030065', NULL, NULL, 0, 639, NULL, N'4804123000', N'4804128711', 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1400 South  Dobson Road', N'Mesa', N'AZ', N'04013', N'85202', 33.389063, -111.874756, 407, 8, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (166, N'Mt Graham Regional Medical Center', 1, NULL, NULL, N'030068', NULL, NULL, 0, 49, NULL, N'9283484000', N'9283485701', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1600  South 20Th Avenue', N'Safford', N'AZ', N'04009', N'85546', 32.821748, -109.733089, 413, 11, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (167, N'Havasu Regional Medical Center', 1, NULL, NULL, N'030069', NULL, NULL, 0, 162, NULL, N'9288558185', N'9285055768', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'101 Civic Center Lane', N'Lake Havasu City', N'AZ', N'04015', N'86403', 34.479803, -114.339501, 406, 9, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (168, N'Fort Defiance Indian Hospital', 1, NULL, NULL, N'030071', NULL, NULL, 0, 70, NULL, N'9287298000', N'6022631618', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Po Box 649', N'Fort Defiance', N'AZ', N'04001', N'86504', 35.74446, -109.076483, 404, 184, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (169, N'Tuba City Regional Health Care Corporation', 1, NULL, NULL, N'030073', NULL, NULL, 0, 103, NULL, N'9282832501', N'9282832828', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Po Box 600', N'Tuba City', N'AZ', N'04005', N'86045', 36.135582, -111.240303, 427, 9, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (170, N'Sells Indian Health Service Hospital', 1, NULL, NULL, N'030074', NULL, NULL, 0, 32, NULL, N'5203837200', N'5203837325', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Po Box 548', N'Sells', N'AZ', N'04019', N'85634', 31.915626, -111.886639, 419, 11, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (171, N'San Carlos Indian Hospital', 1, NULL, NULL, N'030077', NULL, NULL, 0, 36, NULL, N'9284757347', N'9284757370', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'223 Cibecue Circle Road', N'San Carlos', N'AZ', N'04007', N'85550', -2.516667, -79.45, 426, 9, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (172, N'Phoenix Indian Medical Center', 1, NULL, NULL, N'030078', NULL, NULL, 0, 179, NULL, N'6022631200', N'6022631618', 1, 0, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4212 North 16Th Street', N'Phoenix', N'AZ', N'04013', N'85016', 33.503707, -112.047582, 411, 9, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (173, N'Abrazo Scottsdale Campus', 1, NULL, NULL, N'030083', NULL, NULL, 0, 136, NULL, N'6029235000', N'6029235657', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3929 East Bell Road', N'Phoenix', N'AZ', N'04013', N'85032', 33.640611, -111.997691, 411, 9, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (174, N'Chinle Comprehensive Health Care Facility', 1, NULL, NULL, N'030084', NULL, NULL, 0, 10, NULL, N'9286747001', NULL, 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Us Hwy 191 Hospital Road', N'Chinle', N'AZ', N'04001', N'86503', 36.162132, -109.581274, 424, 184, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (175, N'Northwest Medical Center', 1, NULL, NULL, N'030085', NULL, NULL, 0, 300, NULL, N'5204698100', N'5204698101', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6200 North La Cholla Boulevard', N'Tucson', N'AZ', N'04019', N'85741', 32.301611, -111.012107, 419, 11, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (176, N'Scottsdale Shea Medical Center', 1, NULL, NULL, N'030087', NULL, NULL, 0, 432, NULL, N'4803233009', N'4803233510', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'9003 East Shea Boulevard', N'Scottsdale', N'AZ', N'04013', N'85260', 33.582472, -111.886053, 414, 9, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (177, N'Banner Baywood Medical Center', 1, NULL, NULL, N'030088', NULL, NULL, 0, 340, NULL, N'4803212000', N'4809814198', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6644 East Baywood Avenue', N'Mesa', N'AZ', N'04013', N'85206', 33.410937, -111.687145, 407, 8, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (178, N'Banner Thunderbird Medical Center', 1, NULL, NULL, N'030089', NULL, NULL, 0, 561, NULL, N'6028655555', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5555 West Thunderbird Road', N'Glendale', N'AZ', N'04013', N'85306', 33.609009, -112.179701, 411, 9, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (179, N'Deer Valley Medical Center', 1, NULL, NULL, N'030092', NULL, NULL, 0, 204, NULL, N'6238796100', N'6238795410', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'19829 North 27Th Avenue', N'Phoenix', N'AZ', N'04013', N'85027', 33.667618, -112.117141, 411, 9, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (180, N'Banner Del E Webb Medical Center', 1, NULL, NULL, N'030093', NULL, NULL, 0, 375, NULL, N'6232144000', N'6235244105', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'14502 West Meeker Boulevard', N'Sun City West', N'AZ', N'04013', N'85375', 33.667369, -112.340999, 418, 10, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (181, N'Abrazo Arrowhead Campus', 1, NULL, NULL, N'030094', NULL, NULL, 0, 217, NULL, N'6235611000', N'6235617142', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'18701 North 67Th Avenue', N'Glendale', N'AZ', N'04013', N'85308', 33.620968, -112.202532, 411, 9, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (182, N'Western Arizona Regional Medical Center', 1, NULL, NULL, N'030101', NULL, NULL, 0, 139, NULL, N'9287632273', N'9287046785', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2735 Silver Creek Road', N'Bullhead City', N'AZ', N'04015', N'86442', 35.109912, -114.55421, 397, 173, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (183, N'Mayo Clinic Hospital', 1, NULL, NULL, N'030103', NULL, NULL, 0, 268, NULL, N'4803422000', N'4803422525', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5777 East Mayo Boulevard', N'Phoenix', N'AZ', N'04013', N'85054', 33.663713, -111.959332, 411, 9, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (184, N'Banner Heart Hospital', 1, NULL, NULL, N'030105', NULL, NULL, 0, 111, NULL, N'4808545050', N'4808545011', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6750 East Baywood Avenue', N'Mesa', N'AZ', N'04013', N'85206', 33.411566, -111.686024, 407, 8, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (185, N'Arizona Spine And Joint Hospital', 1, NULL, NULL, N'030107', NULL, NULL, 0, 23, NULL, N'4808324770', N'4808241269', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4620 East Baseline Road', N'Mesa', N'AZ', N'04013', N'85206', 33.379134, -111.733086, 407, 8, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (186, N'Surgical Hospital Of Phoenix The', 1, NULL, NULL, N'030108', NULL, NULL, 0, 33, NULL, N'6027956020', N'6027956022', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6501 North 19Th Avenue', N'Phoenix', N'AZ', N'04013', N'85015', 33.531513, -112.09954, 411, 9, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (187, N'Abrazo West Campus', 1, NULL, NULL, N'030110', NULL, NULL, 0, 164, NULL, N'6238821500', N'6238821510', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'13677 West Mcdowell Road', N'Goodyear', N'AZ', N'04013', N'85395', 33.464317, -112.356771, 411, 9, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (188, N'Banner-University Medical Center South Campus', 1, NULL, NULL, N'030111', NULL, NULL, 0, 197, NULL, N'5202944471', N'5207414042', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2800 East Ajo Way', N'Tucson', N'AZ', N'04019', N'85713', 32.177863, -110.931867, 419, 11, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (189, N'Arizona Orthopedic And Surgical Speciality Hosp', 1, NULL, NULL, N'030112', NULL, NULL, 0, 24, NULL, N'4806039000', N'4806039107', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2905 West Warner Road', N'Chandler', N'AZ', N'04013', N'85224', 33.334838, -111.891492, 399, 8, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (190, N'Whiteriver Phs Indian Hospital', 1, NULL, NULL, N'030113', NULL, NULL, 0, 40, NULL, N'9283384911', N'9283383530', 1, 0, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'200 West Hospital Drive  (Po Box 860)', N'Whiteriver', N'AZ', N'04017', N'85941', 33.836994, -109.964266, 415, 9, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (191, N'Oro Valley Hospital', 1, NULL, NULL, N'030114', NULL, NULL, 0, 146, NULL, N'5209013549', N'5209013525', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1551 East Tangerine Road', N'Oro Valley', N'AZ', N'04019', N'85755', 32.429411, -110.948913, 419, 11, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (192, N'Banner Estrella Medical Center', 1, NULL, NULL, N'030115', NULL, NULL, 0, 214, NULL, N'6233274000', N'6233275110', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'9201 West Thomas Road', N'Phoenix', N'AZ', N'04013', N'85037', 33.478367, -112.257355, 411, 9, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (193, N'Valley View Medical Center', 1, NULL, NULL, N'030117', NULL, NULL, 0, 90, NULL, N'9287882273', N'9287887828', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5330 South Highway 95', N'Fort Mohave', N'AZ', N'04015', N'86426', 34.395342, -111.763275, 397, 173, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (194, N'Yavapai Regional Medical Center-East Campus', 1, NULL, NULL, N'030118', NULL, NULL, 0, 72, NULL, N'9287715676', N'9284582015', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7700 East Florentine Road', N'Prescott Valley', N'AZ', N'04025', N'86314', 34.587799, -112.325351, 412, 9, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (195, N'Mercy Gilbert Medical Center', 1, NULL, NULL, N'030119', NULL, NULL, 0, 212, NULL, N'4807288327', N'4807289600', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3555 South Val Vista Drive', N'Gilbert', N'AZ', N'04013', N'85296', 33.287018, -111.752335, 407, 8, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (196, N'Gilbert Hospital', 1, NULL, NULL, N'030120', NULL, NULL, 0, 19, NULL, N'4808403715', N'4802795836', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5656 South Power Road', N'Gilbert', N'AZ', N'04013', N'85295', 33.302714, -111.68758, 407, 8, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (197, N'Mountain Vista Medical Center Lp', 1, NULL, NULL, N'030121', NULL, NULL, 0, 178, NULL, N'4803586100', N'4803542678', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1301 South Crismon Road', N'Mesa', N'AZ', N'04013', N'85209', 33.38906, -111.61533, 407, 8, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (198, N'Banner Gateway Medical Center', 1, NULL, NULL, N'030122', NULL, NULL, 0, 177, NULL, N'4805432000', N'4805432299', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1900 North Higley Road', N'Gilbert', N'AZ', N'04013', N'85234', 33.366967, -111.721924, 407, 8, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (199, N'Scottsdale Thompson Peak Medical Center', 1, NULL, NULL, N'030123', NULL, NULL, 0, 64, NULL, N'4803247004', N'4803247010', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7400 East Thompson Peak Parkway', N'Scottsdale', N'AZ', N'04013', N'85255', 33.669879, -111.92212, 414, 9, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (200, N'Banner Ironwood Medical Center', 1, NULL, NULL, N'030130', NULL, NULL, 0, 47, NULL, N'4803944030', N'4803944571', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'37000 North Gantzel Road', N'San Tan Valley', N'AZ', N'04021', N'85140', 34.395342, -111.763275, 407, 8, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (201, N'Oasis Hospital', 1, NULL, NULL, N'030131', NULL, NULL, 0, 64, NULL, N'6027977703', N'6027977979', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'750 North 40Th Street', N'Phoenix', N'AZ', N'04013', N'85008', 33.455786, -111.995342, 411, 9, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (202, N'Florence Hospital At Anthem Llc', 1, NULL, NULL, N'030132', NULL, NULL, 0, 36, NULL, N'5204242060', N'5204242507', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4545 North Hunt Highway', N'Florence', N'AZ', N'04021', N'85132', 33.059919, -111.430382, 403, 8, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (203, N'Banner Goldfield Medical Center', 1, NULL, NULL, N'030134', NULL, NULL, 0, 30, NULL, N'4807333300', N'4802373206', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2050 West Southern Avenue', N'Apache Junction', N'AZ', N'04021', N'85120', 33.394391, -111.56718, 407, 8, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (204, N'Freedom Pain Hospital', 1, NULL, NULL, N'030135', NULL, NULL, 0, 12, NULL, N'4805862300', N'4805862211', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'17500 North Perimeter Drive', N'Scottsdale', N'AZ', N'04013', N'85255', 33.645166, -111.898069, 414, 9, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (205, N'Dignity Health - Arizona  General Hospital', 1, NULL, NULL, N'030136', NULL, NULL, 0, 16, NULL, N'8157273355', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7171 South 51St Avenue', N'Laveen', N'AZ', N'04013', N'85339', 33.381529, -112.168048, 411, 9, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (206, N'Wickenburg Community Hospital', 1, NULL, NULL, N'031300', NULL, NULL, 0, 19, NULL, N'9286845421', N'9286845081', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'520 Rose Lane', N'Wickenburg', N'AZ', N'04013', N'85390', 33.978133, -112.739938, 420, 10, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (207, N'Benson Hospital', 1, NULL, NULL, N'031301', NULL, NULL, 0, 22, NULL, N'5205862261', N'5205862265', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'450 South Ocotillo Street', N'Benson', N'AZ', N'04003', N'85602', 31.967864, -110.294513, 419, 11, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (208, N'Northern Cochise Community Hospital', 1, NULL, NULL, N'031302', NULL, NULL, 0, 24, NULL, N'5203843541', N'5203846365', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'901 West Rex Allen Drive', N'Willcox', N'AZ', N'04003', N'85643', 32.26418, -109.836954, 421, 11, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (209, N'Cochise Regional Hospital', 1, NULL, NULL, N'031303', NULL, NULL, 0, 25, NULL, N'5203647931', N'5203642551', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2174 West Oak Avenue', N'Douglas', N'AZ', N'04003', N'85607', 31.344551, -109.545346, 401, 11, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (210, N'Page Hospital', 1, NULL, NULL, N'031304', NULL, NULL, 0, 25, NULL, N'9286452424', N'9286453549', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'501 North Navajo Drive', N'Page', N'AZ', N'04005', N'86040', 36.916901, -111.464027, 408, 9, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (211, N'Hopi Health Care Center', 1, NULL, NULL, N'031305', NULL, NULL, 0, 15, NULL, N'9287376000', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Highway 264 Milepost 388', N'Polacca', N'AZ', N'04017', N'86042', 35.836672, -110.38152, 425, 9, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (212, N'Parker Indian Health Center', 1, NULL, NULL, N'031307', NULL, NULL, 0, 20, NULL, N'9286692137', N'9286695860', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'12033 Agency Road', N'Parker', N'AZ', N'04012', N'85344', 34.150016, -114.289118, 409, 9, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (213, N'Huhu Kam Memorial Hospital', 1, NULL, NULL, N'031308', NULL, NULL, 0, 15, NULL, N'5205623321', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'483 West Seed Farm Road', N'Sacaton', N'AZ', N'04021', N'85147', 33.076723, -111.739299, 411, 9, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (214, N'Sage Memorial Hospital', 1, NULL, NULL, N'031309', NULL, NULL, 0, 25, NULL, N'9287554559', N'9287554659', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'State Route 264 South 191 Po Box 457', N'Ganado', N'AZ', N'04001', N'86505', 35.71162, -109.542122, 404, 184, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (215, N'Little Colorado Medical Center', 1, NULL, NULL, N'031311', NULL, NULL, 0, 25, NULL, N'9282894691', N'9282893855', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1501 North Williamson Avenue', N'Winslow', N'AZ', N'04017', N'86047', 35.034889, -110.691821, 422, 9, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (216, N'Copper Queen Community Hospital', 1, NULL, NULL, N'031312', NULL, NULL, 0, 14, NULL, N'5204326401', N'5204321724', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'101 Cole Avenue', N'Bisbee', N'AZ', N'04003', N'85603', 31.417227, -109.88323, 396, 11, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (217, N'Carondelet Holy Cross Hospital', 1, NULL, NULL, N'031313', NULL, NULL, 0, 25, NULL, N'5202853000', N'5202858015', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1171 West Target Range Road', N'Nogales', N'AZ', N'04023', N'85621', 31.34139, -110.957795, 419, 11, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (218, N'Cobre Valley Regional Medical Center', 1, NULL, NULL, N'031314', NULL, NULL, 0, 25, NULL, N'9284253261', N'9284257903', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5880 South Hospital Drive', N'Globe', N'AZ', N'04007', N'85501', 33.394222, -110.786498, 428, 9, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (219, N'White Mountain Regional Medical Center', 1, NULL, NULL, N'031315', NULL, NULL, 0, 25, NULL, N'9283334368', N'9283334369', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'118 South Mountain Avenue', N'Springerville', N'AZ', N'04001', N'85938', 34.131665, -109.286927, 417, 9, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (220, N'La Paz Regional Hospital', 1, NULL, NULL, N'031317', NULL, NULL, 0, 25, NULL, N'9286699201', N'9286697417', 1, 1, 1, 1, 0, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1200 West Mohave Road', N'Parker', N'AZ', N'04012', N'85344', 34.150016, -114.289118, 409, 9, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (221, N'Kindred Hospital Arizona Phoenix', 1, NULL, NULL, N'032000', NULL, NULL, 0, 116, NULL, N'6022807000', N'6022807299', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'40 East Indianola Avenue', N'Phoenix', N'AZ', N'04013', N'85012', 33.492466, -112.073274, 411, 9, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (222, N'Select Specialty Hospital Phoenix', 1, NULL, NULL, N'032001', NULL, NULL, 0, 48, NULL, N'6024066800', N'6024066891', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'350 West Thomas Road', N'Phoenix', N'AZ', N'04013', N'85013', 33.480391, -112.07884, 411, 9, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (223, N'Kindred Hospital - Tucson', 1, NULL, NULL, N'032002', NULL, NULL, 0, 51, NULL, N'5205844500', N'5207908133', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'355 North Wilmot Road', N'Tucson', N'AZ', N'04019', N'85711', 32.227034, -110.858047, 419, 11, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (224, N'Chg Hospital Tucson Llc', 1, NULL, NULL, N'032004', NULL, NULL, 0, 34, NULL, N'5205464595', N'5202967630', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7220 East Rosewood Street', N'Tucson', N'AZ', N'04019', N'85710', 32.232702, -110.839003, 419, 11, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (225, N'Select Specialty Hospital Arizona', 1, NULL, NULL, N'032005', NULL, NULL, 0, 62, NULL, N'4808826040', N'4808826041', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7400 East Osborn Rd 3Rd Floor', N'Scottsdale', N'AZ', N'04013', N'85251', 33.50921, -111.89903, 414, 9, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (226, N'Promise Hospital Of Phoenix Inc', 1, NULL, NULL, N'032006', NULL, NULL, 0, 48, NULL, N'4804273000', N'4804273030', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'433 East 6Th Street', N'Mesa', N'AZ', N'04013', N'85203', 33.42591, -111.822114, 407, 8, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (227, N'Acuity Specialty Hospital Of Arizona At Mesa', 1, NULL, NULL, N'032007', NULL, NULL, 0, 69, NULL, N'4809856992', N'4809818390', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'215 South Power Road', N'Mesa', N'AZ', N'04013', N'85206', 33.411279, -111.684443, 407, 8, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (228, N'Acuity Specialty Hospital Of Arizona At Sun City', 1, NULL, NULL, N'032008', NULL, NULL, 0, 49, NULL, N'6239771325', N'6239743984', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'13818 North Thunderbird Boulevard', N'Sun City', N'AZ', N'04013', N'85351', 33.609194, -112.297751, 418, 10, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (229, N'Healthsouth Scottsdale Rehabilitation Hospital', 1, NULL, NULL, N'033025', NULL, NULL, 0, 60, NULL, N'4805515400', N'4806142155', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'9630 East Shea Boulevard', N'Scottsdale', N'AZ', N'04013', N'85260', 33.582615, -111.87344, 414, 9, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (230, N'Healthsouth Rehabilitation Institute Of Tucson', 1, NULL, NULL, N'033028', NULL, NULL, 0, 80, NULL, N'5203251300', N'5203224400', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2650 North Wyatt Drive', N'Tucson', N'AZ', N'04019', N'85712', 32.255246, -110.883497, 419, 11, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (231, N'Healthsouth Rehabilitation Hospital Of Southern Az', 1, NULL, NULL, N'033029', NULL, NULL, 0, 60, NULL, N'5207422800', N'5207422639', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1921 West Hospital Drive', N'Tucson', N'AZ', N'04019', N'85704', 32.319199, -111.008284, 419, 11, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (232, N'Healthsouth Valley Of The Sun Rehabilitation', 1, NULL, NULL, N'033032', NULL, NULL, 0, 75, NULL, N'6238788800', N'6238785254', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'13460 North 67Th Avenue', N'Glendale', N'AZ', N'04013', N'85304', 33.607671, -112.202729, 411, 9, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (233, N'Yuma Rehabilitation Hospital', 1, NULL, NULL, N'033034', NULL, NULL, 0, 41, NULL, N'9287265000', N'9287265001', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'901 West 24Th Street', N'Yuma', N'AZ', N'04027', N'85364', 32.683887, -114.629933, 423, 9, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (234, N'Mountain Valley Regional Rehabilitation Hospital', 1, NULL, NULL, N'033036', NULL, NULL, 0, 40, NULL, N'9287598800', N'9287598806', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3700 North Windsong Drive', N'Prescott Valley', N'AZ', N'04025', N'86314', 34.590701, -112.326747, 412, 9, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (235, N'Healthsouth East Valley Rehabilitation Hospital', 1, NULL, NULL, N'033037', NULL, NULL, 0, 60, NULL, N'4805670350', N'4805670352', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5652 East Baseline Road', N'Mesa', N'AZ', N'04013', N'85206', 33.379228, -111.713828, 407, 8, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (236, N'Scottsdale Healthcare Rehabilitation Hospital', 1, NULL, NULL, N'033038', NULL, NULL, 0, 50, NULL, N'4808003900', N'4808003986', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'8850 East Pima Center Parkway', N'Scottsdale', N'AZ', N'04013', N'85258', 33.50921, -111.89903, 414, 9, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (237, N'Los Ninos Hospital Inc', 1, NULL, NULL, N'033301', NULL, NULL, 0, 15, NULL, N'6029547311', N'6029547355', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2303 East Thomas', N'Phoenix', N'AZ', N'04013', N'85016', 33.446768, -112.075672, 411, 9, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (238, N'Phoenix Children''s Hospital', 1, NULL, NULL, N'033302', NULL, NULL, 0, 385, NULL, N'6029331000', N'6029330394', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1919 East Thomas Road', N'Phoenix', N'AZ', N'04013', N'85016', 33.480201, -112.040414, 411, 9, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (239, N'Banner Behavioral Health Hospital', 1, NULL, NULL, N'034004', NULL, NULL, 0, 78, NULL, N'4809417500', N'4809417548', 1, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'7575 East Earll Drive', N'Scottsdale', N'AZ', N'04013', N'85251', 33.483002, -111.918606, 414, 9, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (240, N'St Lukes Behavioral Hospital', 1, NULL, NULL, N'034013', NULL, NULL, 0, 124, NULL, N'6022518535', N'6022518707', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1800 East Van Buren', N'Phoenix', N'AZ', N'04013', N'85006', 33.446768, -112.075672, 411, 9, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (241, N'Haven Senior Horizons', 1, NULL, NULL, N'034020', NULL, NULL, 0, 19, NULL, N'6232362000', N'6022520032', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1201 South 7Th Avenue Suite 200', N'Phoenix', N'AZ', N'04013', N'85007', 33.446768, -112.075672, 411, 9, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (242, N'Arizona State Hospital', 1, NULL, NULL, N'034021', NULL, NULL, 0, 475, NULL, N'6022206000', N'6022206292', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2500 East Van Buren Street', N'Phoenix', N'AZ', N'04013', N'85008', 33.451427, -112.027658, 411, 9, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (243, N'Sonora Behavioral Health Hospital', 1, NULL, NULL, N'034022', NULL, NULL, 0, 56, NULL, N'5204698700', N'5208782320', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6050 North Corona Road', N'Tucson', N'AZ', N'04019', N'85704', 32.316672, -111.007814, 419, 11, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (244, N'Guidance Center The', 1, NULL, NULL, N'034023', NULL, NULL, 0, 16, NULL, N'9285271899', N'9287146480', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2187 North Vickey Street', N'Flagstaff', N'AZ', N'04005', N'86004', 35.206532, -111.605856, 402, 9, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (245, N'Aurora Behavioral Health System', 1, NULL, NULL, N'034024', NULL, NULL, 0, 90, NULL, N'6233444400', N'6237760343', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6015 West Peoria  Avenue', N'Glendale', N'AZ', N'04013', N'85302', 33.582005, -112.183918, 411, 9, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (246, N'Windhaven Psychiatric Hospital', 1, NULL, NULL, N'034025', NULL, NULL, 0, 16, NULL, N'9284455211', N'9284459522', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3347 North Windsong Drive', N'Prescott Valley', N'AZ', N'04025', N'86314', 34.590701, -112.326747, 412, 9, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (247, N'Valley Hospital', 1, NULL, NULL, N'034026', NULL, NULL, 0, 122, NULL, N'6029574000', N'6029523921', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3550 East Pinchot Avenue', N'Phoenix', N'AZ', N'04013', N'85018', 33.482386, -112.005262, 411, 9, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (248, N'Community Counseling Ctrs Inc At Pineview Hospital', 1, NULL, NULL, N'034027', NULL, NULL, 0, 16, NULL, N'9283684110', N'9283684112', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1920 West Commerce Drive', N'Lakeside', N'AZ', N'04017', N'85929', 34.154488, -109.97344, 415, 9, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (249, N'Aurora Behavioral Healthcare-Tempe', 1, NULL, NULL, N'034028', NULL, NULL, 0, 75, NULL, N'4803455400', N'4803455450', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6350 South Maple Avenue', N'Tempe', N'AZ', N'04013', N'85283', 33.36463, -111.938533, 407, 8, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (250, N'Oasis Behavioral Health Hospital', 1, NULL, NULL, N'034029', NULL, NULL, 0, 47, NULL, N'4809179301', N'4809170503', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2190 North Grace Boulevard', N'Chandler', N'AZ', N'04013', N'85225', 33.337643, -111.847175, 399, 8, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (251, N'Palo Verde Behavioral Health', 1, NULL, NULL, N'034030', NULL, NULL, 0, 48, NULL, N'5203222888', N'5203222792', 1, 1, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'2695 North Craycroft Road', N'Tucson', N'AZ', N'04019', N'85712', 32.255807, -110.875369, 419, 11, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (252, N'University Medical Center At The Arizona Health Sc', 1, NULL, NULL, N'039800', NULL, NULL, 0, 0, NULL, N'5206947367', N'5206947368', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'1501 North Campbell Avenue', N'Tucson', N'AZ', N'04019', N'85724', 32.24053, -110.944076, 419, 11, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (253, N'Mayo Clinic Hospital', 1, NULL, NULL, N'039801', NULL, NULL, 0, 0, NULL, N'4803421900', N'4803422525', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'5777 East Mayo Boulevard', N'Phoenix', N'AZ', N'04013', N'85054', 33.663713, -111.959332, 411, 9, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (254, N'Banner Good Samaritan Medical Center', 1, NULL, NULL, N'039802', NULL, NULL, 0, 0, NULL, N'6022392716', N'6022393749', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'1300 North 12Th Street Suite 404', N'Phoenix', N'AZ', N'04013', N'85006', 33.446768, -112.075672, 411, 9, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (255, N'St Joseph''s Hospital And Medical Center', 1, NULL, NULL, N'039803', NULL, NULL, 0, 0, NULL, N'6024063792', N'6027989884', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'350 West Thomas Road Suite #500', N'Phoenix', N'AZ', N'04013', N'85013', 33.446768, -112.075672, 411, 9, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (256, N'Phoenix Childrens Hospital', 1, NULL, NULL, N'039804', NULL, NULL, 0, 0, NULL, N'6025461000', N'6025460394', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'1919 East Thomas Road', N'Phoenix', N'AZ', N'04013', N'85016', 33.480201, -112.040414, 411, 9, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (257, N'Siloam Springs Regional Hospital', 1, NULL, NULL, N'040001', NULL, NULL, 0, 73, NULL, N'4795244141', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'603 North Progress Avenue', N'Siloam Springs', N'AR', N'05007', N'72761', 36.190433, -94.509798, 487, 15, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (258, N'Johnson Regional Medical Center', 1, NULL, NULL, N'040002', NULL, NULL, 0, 80, NULL, N'4797545454', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1100 East Poplar Street', N'Clarksville', N'AR', N'05071', N'72830', 35.464433, -93.443292, 440, 14, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (259, N'Washington Regional Med Ctr At North Hills', 1, NULL, NULL, N'040004', NULL, NULL, 0, 269, NULL, N'4794635113', NULL, 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3215 N North Hills Blvd', N'Fayetteville', N'AR', N'05143', N'72703', 36.111508, -94.209867, 450, 15, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (260, N'St Vincent Infirmary Medical Center', 1, NULL, NULL, N'040007', NULL, NULL, 0, 897, NULL, N'5015523000', NULL, 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Two St Vincent Circle', N'Little Rock', N'AR', N'05119', N'72205', 34.746481, -92.289595, 463, 14, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (261, N'Mercy Hospital Northwest Arkansas', 1, NULL, NULL, N'040010', NULL, NULL, 0, 208, NULL, N'4793388000', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2710 Rife Medical Lane', N'Rogers', N'AR', N'05007', N'72758', 36.309289, -94.183287, 483, 15, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (262, N'Chambers Memorial Hospital', 1, NULL, NULL, N'040011', NULL, NULL, 0, 41, NULL, N'4794952241', NULL, 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'719 Detroit Street', N'Danville', N'AR', N'05149', N'72833', 35.054307, -93.388463, 443, 14, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (263, N'White County Medical Center', 1, NULL, NULL, N'040014', NULL, NULL, 0, 438, NULL, N'5012783100', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3214 East Race Avenue', N'Searcy', N'AR', N'05145', N'72143', 35.250375, -91.697018, 486, 14, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (264, N'Mena Regional Health System', 1, NULL, NULL, N'040015', NULL, NULL, 0, 65, NULL, N'4793946100', N'4793944577', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'311 North Morrow Street', N'Mena', N'AR', N'05113', N'71953', 34.586217, -94.239655, 467, 12, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (265, N'Uams Medical Center', 1, NULL, NULL, N'040016', NULL, NULL, 0, 430, NULL, N'5016865000', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4301 West Markham Street Mail Slot 612', N'Little Rock', N'AR', N'05119', N'72205', 34.746481, -92.289595, 463, 14, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (266, N'North Arkansas Regional Medical Center', 1, NULL, NULL, N'040017', NULL, NULL, 0, 174, NULL, N'8704144000', N'8704145129', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'620 North Main Street', N'Harrison', N'AR', N'05009', N'72601', 36.235823, -93.107256, 455, 15, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (267, N'Sparks Medical Center - Van Buren', 1, NULL, NULL, N'040018', NULL, NULL, 0, 103, NULL, N'4794714300', N'4794740113', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'East Main And South 20Th Street', N'Van Buren', N'AR', N'05033', N'72956', 35.436756, -94.348268, 453, 12, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (268, N'Forrest City Medical Center', 1, NULL, NULL, N'040019', NULL, NULL, 0, 118, NULL, N'8702610000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1601 Newcastle Road', N'Forrest City', N'AR', N'05123', N'72335', 35.008147, -90.789834, 452, 253, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (269, N'St Bernards Medical Center', 1, NULL, NULL, N'040020', NULL, NULL, 0, 378, NULL, N'8709724100', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'225 E Jackson', N'Jonesboro', N'AR', N'05031', N'72401', 35.837481, -90.702869, 461, 13, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (270, N'Northwest Medical Center-Springdale', 1, NULL, NULL, N'040022', NULL, NULL, 0, 414, NULL, N'4797515711', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'609 West Maple Avenue', N'Springdale', N'AR', N'05143', N'72764', 36.186744, -94.128814, 488, 15, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (271, N'Mercy Hospital Hot Springs', 1, NULL, NULL, N'040026', NULL, NULL, 0, 282, NULL, N'5016221000', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'300 Werner Street', N'Hot Springs', N'AR', N'05051', N'71903', 34.466148, -93.068649, 459, 14, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (272, N'Baxter Regional Medical Center', 1, NULL, NULL, N'040027', NULL, NULL, 0, 268, NULL, N'8705081000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'624 Hospital Drive', N'Mountain Home', N'AR', N'05005', N'72653', 36.342909, -92.395185, 470, 166, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (273, N'Conway Regional Medical Center', 1, NULL, NULL, N'040029', NULL, NULL, 0, 154, NULL, N'5013293831', NULL, 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2302 College Avenue', N'Conway', N'AR', N'05045', N'72034', 35.084941, -92.4584, 441, 14, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (274, N'Baptist Health Medical Center North Little Rock', 1, NULL, NULL, N'040036', NULL, NULL, 0, 225, NULL, N'5012023000', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3333 Springhill Drive', N'North Little Rock', N'AR', N'05119', N'72117', 34.782672, -92.217994, 475, 14, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (275, N'Arkansas Methodist Medical Center', 1, NULL, NULL, N'040039', NULL, NULL, 0, 129, NULL, N'8702397000', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'900 West Kingshighway', N'Paragould', N'AR', N'05055', N'72450', 36.058402, -90.497329, 478, 13, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (276, N'St Marys Regional Medical Center', 1, NULL, NULL, N'040041', NULL, NULL, 0, 170, NULL, N'4799682841', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1808 West Main Street', N'Russellville', N'AR', N'05115', N'72801', 35.282986, -93.150038, 484, 14, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (277, N'Five Rivers Medical Center', 1, NULL, NULL, N'040047', NULL, NULL, 0, 50, NULL, N'8708926000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2801 Medical Center Drive', N'Pocahontas', N'AR', N'05121', N'72455', 36.290646, -90.997109, 481, 13, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (278, N'Ouachita County Medical Center', 1, NULL, NULL, N'040050', NULL, NULL, 0, 98, NULL, N'8708361000', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'638 California Avenue', N'Camden', N'AR', N'05103', N'71701', 33.584558, -92.834329, 438, 14, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (279, N'Drew Memorial Hospital', 1, NULL, NULL, N'040051', NULL, NULL, 0, 49, NULL, N'8703672411', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'778 Scogin Drive', N'Monticello', N'AR', N'05043', N'71655', 33.610953, -91.815089, 468, 14, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (280, N'Sparks Regional Medical Center', 1, NULL, NULL, N'040055', NULL, NULL, 0, 492, NULL, N'5014414000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1001 Towson Avenue', N'Fort Smith', N'AR', N'05131', N'72902', 35.374599, -94.421223, 453, 12, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (281, N'St Edward Mercy Medical Center', 1, NULL, NULL, N'040062', NULL, NULL, 0, 360, NULL, N'4793146000', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7301 Rogers Ave', N'Fort Smith', N'AR', N'05131', N'72917', 35.35297, -94.351235, 453, 12, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (282, N'Magnolia Hospital', 1, NULL, NULL, N'040067', NULL, NULL, 0, 70, NULL, N'8702353000', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'101 Hospital Drive', N'Magnolia', N'AR', N'05027', N'71754', 33.274987, -93.239657, 464, 14, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (283, N'Great River Medical Center', 1, NULL, NULL, N'040069', NULL, NULL, 0, 168, NULL, N'8708387300', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1520 N Division Street', N'Blytheville', N'AR', N'05093', N'72315', 35.941546, -89.918736, 435, 253, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (284, N'Jefferson Regional Medical Center', 1, NULL, NULL, N'040071', NULL, NULL, 0, 471, NULL, N'8705417100', NULL, 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1600 West 40Th Avenue', N'Pine Bluff', N'AR', N'05069', N'71603', 34.188993, -92.018217, 480, 14, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (285, N'Baptist Health Medical Center-Stuttgart', 1, NULL, NULL, N'040072', NULL, NULL, 0, 49, NULL, N'8706733511', NULL, 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1703 North Buerkle Road', N'Stuttgart', N'AR', N'05001', N'72160', 34.500375, -91.552628, 489, 14, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (286, N'North Metro Medical Center', 1, NULL, NULL, N'040074', NULL, NULL, 0, 118, NULL, N'5019857000', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1400 Braden Street', N'Jacksonville', N'AR', N'05119', N'72076', 34.872461, -92.124655, 460, 14, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (287, N'Baptist Health Medical Center-Hot Springs County', 1, NULL, NULL, N'040076', NULL, NULL, 0, 72, NULL, N'5013321000', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1001 Schneider Drive', N'Malvern', N'AR', N'05059', N'72104', 34.360513, -92.78547, 465, 14, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (288, N'National Park Medical Center', 1, NULL, NULL, N'040078', NULL, NULL, 0, 176, NULL, N'5013211000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1910 Malvern Avenue', N'Hot Springs', N'AR', N'05051', N'71901', 34.471242, -92.987296, 459, 14, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (289, N'Harris Hospital', 1, NULL, NULL, N'040080', NULL, NULL, 0, 133, NULL, N'8705238911', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1205 Mclain Street', N'Newport', N'AR', N'05067', N'72112', 35.608128, -91.264334, 474, 14, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (290, N'Saline Memorial Hospital', 1, NULL, NULL, N'040084', NULL, NULL, 0, 177, NULL, N'5017766000', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'#1 Medical Park Drive', N'Benton', N'AR', N'05125', N'72015', 34.575712, -92.585255, 432, 14, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (291, N'Helena Regional Medical Center', 1, NULL, NULL, N'040085', NULL, NULL, 0, 155, NULL, N'8703385800', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1801 Martin Luther King Jr Drive', N'Helena', N'AR', N'05107', N'72342', 34.499814, -90.601569, 457, 253, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (292, N'Medical Center South Arkansas', 1, NULL, NULL, N'040088', NULL, NULL, 0, 149, NULL, N'8708632000', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'700 West Grove Street', N'El Dorado', N'AR', N'05139', N'71731', 33.218463, -92.672413, 448, 14, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (293, N'Baptist Health Medical Center-Little Rock', 1, NULL, NULL, N'040114', NULL, NULL, 0, 843, NULL, N'5012022000', NULL, 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'9601 Interstate 630 Exit 7', N'Little Rock', N'AR', N'05119', N'72205', 34.746481, -92.289595, 463, 14, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (294, N'Nea Baptist Memorial Hospital', 1, NULL, NULL, N'040118', NULL, NULL, 0, 100, NULL, N'8709727000', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4800 East Johnson Avenue', N'Jonesboro', N'AR', N'05031', N'72401', 35.865933, -90.637169, 461, 13, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (295, N'White River Medical Center', 1, NULL, NULL, N'040119', NULL, NULL, 0, 224, NULL, N'8702621200', N'5012621458', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1710 Harrison Street', N'Batesville', N'AR', N'05063', N'72503', 35.769465, -91.633038, 431, 14, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (296, N'Leo N Levi National Arthritis Hospital', 1, NULL, NULL, N'040132', NULL, NULL, 0, 50, NULL, N'5016241281', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'300 Prospect Ave', N'Hot Springs', N'AR', N'05051', N'71901', 34.509983, -93.057038, 459, 14, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (297, N'Arkansas Heart Hospital Llc', 1, NULL, NULL, N'040134', NULL, NULL, 0, 110, NULL, N'5012197000', N'5012197402', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1701 S Shackleford Road', N'Little Rock', N'AR', N'05119', N'72211', 34.746481, -92.289595, 463, 14, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (298, N'St Vincent Medical Center/North', 1, NULL, NULL, N'040137', NULL, NULL, 0, 69, NULL, N'5015527100', NULL, 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2215 Wildwood Avenue', N'Sherwood', N'AR', N'05119', N'72120', 34.814266, -92.206035, 475, 14, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (299, N'Arkansas Surgical Hospital', 1, NULL, NULL, N'040147', NULL, NULL, 0, 51, NULL, N'5017488000', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5201 North Shore Drive', N'No Little Rock', N'AR', N'05119', N'72118', 35.204888, -92.447911, 475, 14, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (300, N'Physicians'' Specialty Hospital', 1, NULL, NULL, N'040152', NULL, NULL, 0, 21, NULL, N'4795717002', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3873 North Parkview Drive', N'Fayetteville', N'AR', N'05143', N'72703', 36.111508, -94.209867, 450, 15, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (301, N'Wadley Regional Medical Center At Hope', 1, NULL, NULL, N'040153', NULL, NULL, 0, 79, NULL, N'8707223800', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2001 South Main', N'Hope', N'AR', N'05057', N'71801', 33.688382, -93.583834, 458, 16, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (302, N'North Logan Mercy Hospital', 1, NULL, NULL, N'041300', NULL, NULL, 0, 16, NULL, N'4799636101', NULL, 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'500 East Academy', N'Paris', N'AR', N'05083', N'72855', 35.290794, -93.719036, 453, 12, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (303, N'River Valley Medical Center', 1, NULL, NULL, N'041302', NULL, NULL, 0, 35, NULL, N'4792294677', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'200 North Third Street', N'Dardanelle', N'AR', N'05149', N'72834', 35.223141, -93.157953, 444, 14, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (304, N'Mercy Hospital Turner Memorial', 1, NULL, NULL, N'041303', NULL, NULL, 0, 25, NULL, N'4796674138', N'4796679778', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'801 West River Street', N'Ozark', N'AR', N'05047', N'72949', 35.486118, -93.833264, 477, 12, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (305, N'Eureka Springs Hospital Llc', 1, NULL, NULL, N'041304', NULL, NULL, 0, 15, NULL, N'4792537400', NULL, 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'24 Norris Street', N'Eureka Springs', N'AR', N'05015', N'72632', 36.400518, -93.744457, 449, 166, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (306, N'St Edward Health Facilities Of Scott County', 1, NULL, NULL, N'041305', NULL, NULL, 0, 24, NULL, N'4796374135', NULL, 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1341 West Sixth Street', N'Waldron', N'AR', N'05127', N'72958', 34.898432, -94.090763, 491, 12, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (307, N'Community Medical Center Izard County', 1, NULL, NULL, N'041306', NULL, NULL, 0, 25, NULL, N'8702973726', NULL, 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'103 Grasse Street', N'Calico Rock', N'AR', N'05065', N'72519', 36.12772, -92.128154, 437, 14, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (308, N'Crossridge Community Hospital', 1, NULL, NULL, N'041307', NULL, NULL, 0, 25, NULL, N'8702383300', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'310 South Falls Boulevard', N'Wynne', N'AR', N'05037', N'72396', 35.220658, -90.787305, 494, 253, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (309, N'Mcgehee Hospital', 1, NULL, NULL, N'041308', NULL, NULL, 0, 25, NULL, N'8702225600', N'8702224260', 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'900 South Third Street', N'Mcgehee', N'AR', N'05041', N'71654', 33.628999, -91.399564, 466, 14, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (310, N'Lawrence Memorial Hospital', 1, NULL, NULL, N'041309', NULL, NULL, 0, 25, NULL, N'8708861200', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1309 West Main', N'Walnut Ridge', N'AR', N'05075', N'72476', 36.068024, -90.9561, 461, 13, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (311, N'Stone County Medical Center', 1, NULL, NULL, N'041310', NULL, NULL, 0, 25, NULL, N'8702694361', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Highway 14 East', N'Mountain View', N'AR', N'05137', N'72560', 35.868408, -92.117652, 471, 14, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (312, N'Howard Memorial Hospital', 1, NULL, NULL, N'041311', NULL, NULL, 0, 25, NULL, N'8708454400', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'130 Medical Circle', N'Nashville', N'AR', N'05061', N'71852', 33.945669, -93.847129, 473, 16, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (313, N'Baptist Health Medical Center Heber Spings', 1, NULL, NULL, N'041312', NULL, NULL, 0, 25, NULL, N'5018873000', NULL, 1, 1, 1, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1800 Bypass Road', N'Heber Springs', N'AR', N'05023', N'72543', 35.491468, -92.03126, 456, 14, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (314, N'Ozark Health', 1, NULL, NULL, N'041313', NULL, NULL, 0, 25, NULL, N'5017457004', N'5017452472', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2500 Highway 65 South', N'Clinton', N'AR', N'05141', N'72031', 35.591467, -92.460436, 463, 14, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (315, N'Dewitt Hospital & Nursing Home Inc', 1, NULL, NULL, N'041314', NULL, NULL, 0, 25, NULL, N'8709463571', N'8709464577', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1641 Whitehead Drive', N'De Witt', N'AR', N'05001', N'72042', 34.292877, -91.337899, 446, 14, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (316, N'South Missississpi County Regional Medical Center', 1, NULL, NULL, N'041316', NULL, NULL, 0, 25, NULL, N'8705637000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'611 West Lee Avenue', N'Osceola', N'AR', N'05093', N'72370', 35.700144, -89.975054, 476, 253, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (317, N'Dallas County Medical Center', 1, NULL, NULL, N'041317', NULL, NULL, 0, 25, NULL, N'8703526300', NULL, 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'201 Clifton Street', N'Fordyce', N'AR', N'05039', N'71742', 33.813716, -92.41293, 451, 14, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (318, N'Mercy Hospital Booneville', 1, NULL, NULL, N'041318', NULL, NULL, 0, 25, NULL, N'4796752800', N'4796753406', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'880 West Main', N'Booneville', N'AR', N'05083', N'72927', 35.140093, -93.921591, 436, 12, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (319, N'De Queen Medical Center Inc', 1, NULL, NULL, N'041319', NULL, NULL, 0, 35, NULL, N'8705844111', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1306 West Collin Raye Drive', N'De Queen', N'AR', N'05133', N'71832', 34.037892, -94.341317, 445, 16, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (320, N'Little River Memorial Hospital', 1, NULL, NULL, N'041320', NULL, NULL, 0, 25, NULL, N'8708985011', NULL, 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'451 West Locke Street', N'Ashdown', N'AR', N'05081', N'71822', 33.669503, -94.134884, 430, 16, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (321, N'Baptist Health Medical Center-Arkadelphia', 1, NULL, NULL, N'041321', NULL, NULL, 0, 25, NULL, N'8702452622', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3050 Twin Rivers Drive', N'Arkadelphia', N'AR', N'05019', N'71923', 34.126259, -93.083315, 429, 14, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (322, N'Fulton County Hospital', 1, NULL, NULL, N'041322', NULL, NULL, 0, 25, NULL, N'8708952691', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'679 North Main Street', N'Salem', N'AR', N'05049', N'72576', 36.384304, -91.809364, 485, 14, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (323, N'Ashley County Medical Center', 1, NULL, NULL, N'041323', NULL, NULL, 0, 33, NULL, N'8703644111', NULL, 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1015 Unity Road', N'Crossett', N'AR', N'05003', N'71635', 33.136198, -91.948828, 442, 14, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (324, N'St Vincent Morrilton', 1, NULL, NULL, N'041324', NULL, NULL, 0, 35, NULL, N'5019772300', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'#4 Hospital Drive', N'Morrilton', N'AR', N'05029', N'72110', 35.167569, -92.720273, 469, 14, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (325, N'Delta Memorial Hospital', 1, NULL, NULL, N'041326', NULL, NULL, 0, 25, NULL, N'8703824303', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'811 Highway 65 South', N'Dumas', N'AR', N'05041', N'71639', 33.887048, -91.49179, 447, 14, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (326, N'Bradley County Medical Center', 1, NULL, NULL, N'041327', NULL, NULL, 0, 35, NULL, N'8702263731', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'404 South Bradley Street', N'Warren', N'AR', N'05011', N'71671', 33.609952, -92.05875, 492, 14, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (327, N'Chicot Memorial Medical Center', 1, NULL, NULL, N'041328', NULL, NULL, 0, 25, NULL, N'8702655351', N'8702652091', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2729 South Highway 65 & 82', N'Lake Village', N'AR', N'05017', N'71653', 33.334123, -91.284001, 462, 14, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (328, N'Mercy Hospital Berryville', 1, NULL, NULL, N'041329', NULL, NULL, 0, 25, NULL, N'8704233355', N'8704235268', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'214 Carter Street', N'Berryville', N'AR', N'05015', N'72616', 36.357639, -93.552118, 434, 15, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (329, N'Piggott Community Hospital', 1, NULL, NULL, N'041330', NULL, NULL, 0, 25, NULL, N'8705983881', NULL, 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1206 Gordon Duckworth Drive', N'Piggott', N'AR', N'05021', N'72454', 36.390537, -90.204522, 479, 13, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (330, N'Ozarks Community Hospital Of Gravette', 1, NULL, NULL, N'041331', NULL, NULL, 0, 25, NULL, N'4797875291', N'4797877890', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1101 Jackson Street Sw', N'Gravette', N'AR', N'05007', N'72736', 36.408617, -94.460545, 454, 15, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (331, N'Christus Dubuis Hospital Of Hot Springs', 1, NULL, NULL, N'042004', NULL, NULL, 0, 27, NULL, N'5016094333', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'300 Werner Street 3Rd Floor', N'Hot Springs', N'AR', N'05051', N'71913', 34.448065, -93.04685, 459, 14, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (332, N'Select Speciality Hospital-Fort Smith Inc', 1, NULL, NULL, N'042006', NULL, NULL, 0, 34, NULL, N'4794413960', N'4794413961', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1001 Towson Avenue', N'Fort Smith', N'AR', N'05131', N'72901', 35.374599, -94.421223, 453, 12, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (333, N'Christus Dubuis Hospital Of Fort Smith', 1, NULL, NULL, N'042008', NULL, NULL, 0, 25, NULL, N'4793144900', N'4793144999', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7301 Rogers Avenue # 4', N'Fort Smith', N'AR', N'05131', N'72903', 35.387222, -94.424898, 453, 12, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (334, N'Regency Hospital Of Northwest Arkansas', 1, NULL, NULL, N'042009', NULL, NULL, 0, 50, NULL, N'4797137000', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'609 West Maple Avenue', N'Springdale', N'AR', N'05143', N'72764', 36.186744, -94.128814, 488, 15, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (335, N'Cornerstone Hospital Of North Little Rock', 1, NULL, NULL, N'042010', NULL, NULL, 0, 40, NULL, N'5019857000', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1400 Braden Street', N'Jacksonville', N'AR', N'05119', N'72076', 34.872461, -92.124655, 460, 14, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (336, N'Advanced Care Hospital White County', 1, NULL, NULL, N'042011', NULL, NULL, 0, 27, NULL, N'5012783155', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1200 South Main Street', N'Searcy', N'AR', N'05145', N'72143', 35.226916, -91.732221, 486, 14, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (337, N'Baptist Health Extended Care Hospital-Lr Inc', 1, NULL, NULL, N'042012', NULL, NULL, 0, 37, NULL, N'5012026000', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'9601 I-630 Exit 7 10Th Fl', N'Little Rock', N'AR', N'05119', N'72205', 34.746481, -92.289595, 463, 14, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (338, N'Baptist Health Rehabilitation Institute', 1, NULL, NULL, N'043026', NULL, NULL, 0, 120, NULL, N'5012027578', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'9601 Interstate 630 Exit 7', N'Little Rock', N'AR', N'05119', N'72205', 34.746481, -92.289595, 463, 14, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (339, N'Healthsouth Rehabilitation Hospital Of Fort Smith', 1, NULL, NULL, N'043028', NULL, NULL, 0, 80, NULL, N'4797853300', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1401 South J Street', N'Fort Smith', N'AR', N'05131', N'72901', 35.387222, -94.424898, 453, 12, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (340, N'Healthsouth Rehabilitation Hospital Of Jonesboro', 1, NULL, NULL, N'043029', NULL, NULL, 0, 67, NULL, N'8709320440', N'8709326792', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1201 Fleming Ave', N'Jonesboro', N'AR', N'05031', N'72401', 35.833155, -90.692542, 461, 13, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (341, N'St Vincent Rehab Hosp In Part Hlthsout', 1, NULL, NULL, N'043031', NULL, NULL, 0, 60, NULL, N'5018341800', N'5018342227', 1, 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2201 Wildwood Avenue', N'Sherwood', N'AR', N'05119', N'72120', 34.814354, -92.206206, 475, 14, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (342, N'Healthsouth Rehab Hosp In Part W/Washington Region', 1, NULL, NULL, N'043032', NULL, NULL, 0, 60, NULL, N'4794442200', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'153 E Monte Painter Drive', N'Fayetteville', N'AR', N'05143', N'72703', 36.109085, -94.154829, 450, 15, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (343, N'Conway Regional Rehabilitation Hospital', 1, NULL, NULL, N'043033', NULL, NULL, 0, 26, NULL, N'5019323500', NULL, 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2210 Robinson Street', N'Conway', N'AR', N'05045', N'72034', 35.088696, -92.442101, 441, 14, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (344, N'Southeast Rehabilitation Hospital', 1, NULL, NULL, N'043034', NULL, NULL, 0, 15, NULL, N'8702655343', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2729 A Highway 65 & 82 South', N'Lake Village', N'AR', N'05017', N'71653', 33.334123, -91.284001, 462, 14, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (345, N'Arkansas Children''s Hospital', 1, NULL, NULL, N'043300', NULL, NULL, 0, 280, NULL, N'5013641100', NULL, 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'800 Marshall Street Slot 301', N'Little Rock', N'AR', N'05119', N'72202', 34.746481, -92.289595, 463, 14, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (346, N'Vista Health', 1, NULL, NULL, N'044004', NULL, NULL, 0, 108, NULL, N'4795215731', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4253 Crossover Road', N'Fayetteville', N'AR', N'05143', N'72703', 36.111508, -94.209867, 450, 15, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (347, N'Bridgeway Inc The', 1, NULL, NULL, N'044005', NULL, NULL, 0, 103, NULL, N'5017711500', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'21 Bridgeway Road', N'North Little Rock', N'AR', N'05119', N'72113', 34.822704, -92.353883, 463, 14, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (348, N'Valley Behavioral Health System', 1, NULL, NULL, N'044006', NULL, NULL, 0, 75, NULL, N'4794945700', N'4794945777', 1, 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'10301 Mayo Drive', N'Barling', N'AR', N'05131', N'72923', 35.338778, -94.318523, 453, 12, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (349, N'Rivendell Behavioral Health Services Of Arkansas', 1, NULL, NULL, N'044007', NULL, NULL, 0, 77, NULL, N'5013161255', N'5017940908', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'100 Rivendell Drive', N'Benton', N'AR', N'05125', N'72019', 34.612071, -92.530695, 432, 14, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (350, N'Arkansas State Hospital', 1, NULL, NULL, N'044011', NULL, NULL, 0, 321, NULL, N'5016869000', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'305 S Palm Street', N'Little Rock', N'AR', N'05119', N'72205', 34.746481, -92.289595, 463, 14, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (351, N'Pinnacle Pointe Hospital', 1, NULL, NULL, N'044013', NULL, NULL, 0, 124, NULL, N'5012233322', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'11501 Financial Centre Parkway', N'Little Rock', N'AR', N'05119', N'72211', 34.746481, -92.289595, 463, 14, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (352, N'United Methodist Behavioral Hospital', 1, NULL, NULL, N'044017', NULL, NULL, 0, 60, NULL, N'5018033388', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1601 Murphy Drive', N'Maumelle', N'AR', N'05119', N'72113', 34.877447, -92.39423, 463, 14, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (353, N'Springwoods Behavioral Health Services', 1, NULL, NULL, N'044019', NULL, NULL, 0, 80, NULL, N'4799736000', NULL, 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1955 West Trucker''s Drive', N'Fayetteville', N'AR', N'05143', N'72704', 36.111508, -94.209867, 450, 15, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (354, N'Riverview Behavioral Health', 1, NULL, NULL, N'044020', NULL, NULL, 0, 62, NULL, N'8707725028', N'8707722138', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'701 Arkansas Boulevard Suite 300', N'Texarkana', N'AR', N'05091', N'71854', 33.441795, -94.037692, 490, 16, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (355, N'Arkansas Children''s Hospital', 1, NULL, NULL, N'049801', NULL, NULL, 0, 0, NULL, N'5013641847', N'5013641780', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'800 Marshall Street', N'Little Rock', N'AR', N'05119', N'72202', 34.743407, -92.291362, 463, 14, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (356, N'Baptist Health Medical Center', 1, NULL, NULL, N'049802', NULL, NULL, 0, 0, NULL, N'5012021500', N'5012021357', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'9601 Interstate 630 Exit 7', N'Little Rock', N'AR', N'05119', N'72205', 34.746481, -92.289595, 463, 14, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (357, N'University Of Arkansas Medical Sciences-Transplant', 1, NULL, NULL, N'049803', NULL, NULL, 0, 0, NULL, N'5016031074', N'5016865725', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'Transplant Surgery Slot 520-44301 W Markham', N'Little Rock', N'AR', N'05119', N'72205', 34.746481, -92.289595, 463, 14, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (358, N'St Rose Hospital', 1, NULL, NULL, N'050002', NULL, NULL, 0, 129, NULL, N'5107826200', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'27200 Calaroga Ave', N'Hayward', N'CA', N'06001', N'94545', 37.632908, -122.089677, 572, 25, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (359, N'St Joseph Hospital', 1, NULL, NULL, N'050006', NULL, NULL, 0, 140, NULL, N'7074458121', N'7072693897', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2700 Dolbeer St', N'Eureka', N'CA', N'06023', N'95501', 40.783739, -124.142561, 546, 27, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (360, N'Mills-Peninsula Medical Center', 1, NULL, NULL, N'050007', NULL, NULL, 0, 301, NULL, N'6506965270', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1501 Trousdale Drive', N'Burlingame', N'CA', N'06081', N'94010', 37.594392, -122.383214, 515, 35, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (361, N'California Pacific Medical Ctr-Davies Campus Hosp', 1, NULL, NULL, N'050008', NULL, NULL, 0, 341, NULL, N'4156006000', N'4156008666', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'601 Duboce Ave', N'San Francisco', N'CA', N'06075', N'94117', 37.769088, -122.433721, 657, 32, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (362, N'Queen Of The Valley Medical Center', 1, NULL, NULL, N'050009', NULL, NULL, 0, 171, NULL, N'7072524411', N'7072574173', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1000 Trancas St', N'Napa', N'CA', N'06055', N'94558', 38.323485, -122.296674, 614, 24, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (363, N'St Helena Hospital', 1, NULL, NULL, N'050013', NULL, NULL, 0, 181, NULL, N'7079633611', N'7079675712', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'10 Woodland Road', N'Saint Helena', N'CA', N'06055', N'94574', 38.505229, -122.470042, 537, 24, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (364, N'Sutter Amador Hospital', 1, NULL, NULL, N'050014', NULL, NULL, 0, 84, NULL, N'2092237500', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'200 Mission Blvd', N'Jackson', N'CA', N'06005', N'95642', 38.351109, -120.766536, 579, 28, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (365, N'Marian Regional Medical Center Arroyo Grande', 1, NULL, NULL, N'050016', NULL, NULL, 0, 67, NULL, N'8054894261', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'345 S Halcyon Rd', N'Arroyo Grande', N'CA', N'06079', N'93420', 35.114419, -120.591474, 502, 34, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (366, N'Mercy General Hospital', 1, NULL, NULL, N'050017', NULL, NULL, 0, 300, NULL, N'9164534545', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4001 J St', N'Sacramento', N'CA', N'06067', N'95819', 38.569747, -121.453552, 650, 28, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (367, N'Pacific Alliance Medical Center', 1, NULL, NULL, N'050018', NULL, NULL, 0, 155, NULL, N'2136248411', NULL, 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'531 W College St', N'Los Angeles', N'CA', N'06037', N'90012', 34.064668, -118.239099, 597, 22, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (368, N'Riverside Community Hospital', 1, NULL, NULL, N'050022', NULL, NULL, 0, 369, NULL, N'9517883000', N'9517883494', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4445 Magnolia Avenue', N'Riverside', N'CA', N'06065', N'92501', 33.976257, -117.378381, 648, 30, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (369, N'Paradise Valley Hospital', 1, NULL, NULL, N'050024', NULL, NULL, 0, 237, NULL, N'6194704321', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2400 East 4Th St', N'National City', N'CA', N'06073', N'91950', 32.685626, -117.082218, 615, 31, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (370, N'University Of California San Diego Medical Center', 1, NULL, NULL, N'050025', NULL, NULL, 0, 600, NULL, N'6195436222', NULL, 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'200 West Arbor Drive', N'San Diego', N'CA', N'06073', N'92103', 32.754871, -117.166515, 655, 31, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (371, N'Grossmont Hospital', 1, NULL, NULL, N'050026', NULL, NULL, 0, 536, NULL, N'6194650711', N'6194617191', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5555 Grossmont Center Drive Box 58', N'La Mesa', N'CA', N'06073', N'91942', 32.767829, -117.023084, 583, 31, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (372, N'Mad River Community Hospital', 1, NULL, NULL, N'050028', NULL, NULL, 0, 80, NULL, N'7078223621', N'7078226311', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3800 Janes Rd', N'Arcata', N'CA', N'06023', N'95521', 40.866517, -124.08284, 501, 27, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (373, N'Oroville Hospital', 1, NULL, NULL, N'050030', NULL, NULL, 0, 153, NULL, N'5305338500', NULL, 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2767 Olive Highway', N'Oroville', N'CA', N'06007', N'95966', 39.513775, -121.556359, 626, 19, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (374, N'Bakersfield Memorial Hospital', 1, NULL, NULL, N'050036', NULL, NULL, 0, 367, NULL, N'6613271792', N'6613260706', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'420 34Th St Box 1888', N'Bakersfield', N'CA', N'06029', N'93301', 35.373871, -119.019464, 505, 18, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (375, N'Santa Clara Valley Medical Center', 1, NULL, NULL, N'050038', NULL, NULL, 0, 574, NULL, N'4088855000', NULL, 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'751 South Bascom Avenue', N'San Jose', N'CA', N'06085', N'95128', 37.316307, -121.93194, 659, 33, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (376, N'Enloe Medical Center', 1, NULL, NULL, N'050039', NULL, NULL, 0, 298, NULL, N'5303327300', NULL, 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1531 Esplanade', N'Chico', N'CA', N'06007', N'95926', 39.742384, -121.849057, 522, 19, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (377, N'Lac/Olive View-Ucla Medical Center', 1, NULL, NULL, N'050040', NULL, NULL, 0, 324, NULL, N'8183641555', NULL, 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'14445 Olive View Drive', N'Sylmar', N'CA', N'06037', N'91342', 34.324475, -118.446494, 606, 22, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (378, N'St Elizabeth Community Hospital', 1, NULL, NULL, N'050042', NULL, NULL, 0, 76, NULL, N'5305298012', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2550 Sister Mary Columba Drive', N'Red Bluff', N'CA', N'06103', N'96080', 40.148898, -122.217973, 643, 19, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (379, N'Alta Bates Summit Medical Center', 1, NULL, NULL, N'050043', NULL, NULL, 0, 569, NULL, N'5106554000', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'350 Hawthorne Avenue', N'Oakland', N'CA', N'06001', N'94609', 37.820872, -122.263106, 622, 25, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (380, N'El Centro Regional Medical Center', 1, NULL, NULL, N'050045', NULL, NULL, 0, 107, NULL, N'7603397100', NULL, 1, 1, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'1415 Ross Avenue', N'El Centro', N'CA', N'06025', N'92243', 32.781417, -115.568703, 542, 31, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (381, N'California Pacific Medical Ctr-Pacific Campus Hosp', 1, NULL, NULL, N'050047', NULL, NULL, 0, 806, NULL, N'4156006000', N'4156008666', 1, 1, 0, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2333 Buchanan Street', N'San Francisco', N'CA', N'06075', N'94115', 37.7905, -122.432309, 657, 32, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (382, N'San Gorgonio Memorial Hospital', 1, NULL, NULL, N'050054', NULL, NULL, 0, 72, NULL, N'9518451121', N'9518452836', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'600 North Highland Springs Avenue', N'Banning', N'CA', N'06065', N'92220', 33.958015, -116.946757, 506, 30, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (383, N'California Pacific Medical Ctr - St. Luke''s Campus', 1, NULL, NULL, N'050055', NULL, NULL, 0, 229, NULL, N'4156416562', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3555 Cesar Chavez Street', N'San Francisco', N'CA', N'06075', N'94110', 37.747074, -122.420842, 657, 32, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (384, N'Antelope Valley Hospital', 1, NULL, NULL, N'050056', NULL, NULL, 0, 341, NULL, N'6619495000', N'6619495510', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1600 W Ave J', N'Lancaster', N'CA', N'06037', N'93534', 34.688442, -118.158425, 588, 22, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (385, N'Kaweah Delta Medical Center', 1, NULL, NULL, N'050057', NULL, NULL, 0, 419, NULL, N'5596242000', N'5596354064', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'400 W Mineral King Ave', N'Visalia', N'CA', N'06107', N'93291', 36.327521, -119.31475, 701, 18, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (386, N'Glendale Mem Hospital & Hlth Center', 1, NULL, NULL, N'050058', NULL, NULL, 0, 334, NULL, N'8185021900', N'8185027314', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1420 S Central Ave', N'Glendale', N'CA', N'06037', N'91204', 34.142346, -118.248367, 562, 22, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (387, N'Community Regional Medical Center', 1, NULL, NULL, N'050060', NULL, NULL, 0, 794, NULL, N'5594596000', NULL, 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2823 Fresno Street', N'Fresno', N'CA', N'06019', N'93715', 36.741951, -119.783933, 556, 21, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (388, N'Hollywood Presbyterian Medical Center', 1, NULL, NULL, N'050063', NULL, NULL, 0, 345, NULL, N'2134133000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1300 N Vermont Ave', N'Los Angeles', N'CA', N'06037', N'90027', 34.106152, -118.291807, 597, 22, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (389, N'Oak Valley District Hospital', 1, NULL, NULL, N'050067', NULL, NULL, 0, 39, NULL, N'2098473011', N'2098484110', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'350 S Oak Ave', N'Oakdale', N'CA', N'06099', N'95361', 37.769661, -120.862798, 621, 23, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (390, N'St Joseph Hospital', 1, NULL, NULL, N'050069', NULL, NULL, 0, 462, NULL, N'7146339111', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1100 West Stewart Dr', N'Orange', N'CA', N'06059', N'92868', 33.782298, -117.865226, 625, 17, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (391, N'Kaiser Foundation Hospital - South San Francisco', 1, NULL, NULL, N'050070', NULL, NULL, 0, 120, NULL, N'6507423200', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1200 El Camino Real', N'South San Francisco', N'CA', N'06081', N'94080', 37.657313, -122.437473, 681, 35, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (392, N'Kaiser Foundation Hospital-Santa Clara', 1, NULL, NULL, N'050071', NULL, NULL, 0, 286, NULL, N'4082366400', NULL, 1, 1, 0, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'700 Lawrence Expressway', N'Santa Clara', N'CA', N'06085', N'95051', 37.33778, -121.99571, 659, 33, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (393, N'Kaiser Foundation Hospital - Walnut Creek', 1, NULL, NULL, N'050072', NULL, NULL, 0, 362, NULL, N'9252954000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1425 S Main Street', N'Walnut Creek', N'CA', N'06013', N'94596', 37.894912, -122.059282, 702, 20, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (394, N'Kaiser Foundation Hospital And Rehab Center', 1, NULL, NULL, N'050073', NULL, NULL, 0, 475, NULL, N'7076511000', N'7076512223', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'975 Sereno Dr', N'Vallejo', N'CA', N'06095', N'94589', 38.128462, -122.246958, 697, 32, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (395, N'Kaiser Foundation Hospital - Oakland/Richmond', 1, NULL, NULL, N'050075', NULL, NULL, 0, 396, NULL, N'5107521000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'275 W Macarthur Boulevard', N'Oakland', N'CA', N'06001', N'94611', 37.823936, -122.257921, 622, 25, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (396, N'Kaiser Foundation Hospital - San Francisco', 1, NULL, NULL, N'050076', NULL, NULL, 0, 542, NULL, N'4158332646', NULL, 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2425 Geary Blvd', N'San Francisco', N'CA', N'06075', N'94115', 37.782862, -122.440659, 657, 32, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (397, N'Scripps Mercy Hospital', 1, NULL, NULL, N'050077', NULL, NULL, 0, 700, NULL, N'6192948111', NULL, 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4077 5Th Ave', N'San Diego', N'CA', N'06073', N'92103', 32.75133, -117.161045, 655, 31, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (398, N'Providence Little Co Of Mary Med Ctr San Pedro', 1, NULL, NULL, N'050078', NULL, NULL, 0, 387, NULL, N'3108323311', N'3105145314', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1300 W 7Th St', N'San Pedro', N'CA', N'06037', N'90732', 33.737907, -118.305407, 664, 22, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (399, N'Doctors Medical Center - San Pablo', 1, NULL, NULL, N'050079', NULL, NULL, 0, 326, NULL, N'5109705000', N'5109705728', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2000 Vale Rd', N'San Pablo', N'CA', N'06013', N'94806', 37.952886, -122.338578, 663, 32, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (400, N'St Johns Regional Medical Center', 1, NULL, NULL, N'050082', NULL, NULL, 0, 265, NULL, N'8059882500', NULL, 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1600 N Rose Ave', N'Oxnard', N'CA', N'06111', N'93030', 34.216462, -119.158299, 627, 40, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (401, N'St Josephs Medical Center Of Stockton', 1, NULL, NULL, N'050084', NULL, NULL, 0, 294, NULL, N'2099432000', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1800 N California St', N'Stockton', N'CA', N'06077', N'95204', 37.98518, -121.295495, 683, 39, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (402, N'Community Hospital Of San Bernardino', 1, NULL, NULL, N'050089', NULL, NULL, 0, 347, NULL, N'9098876333', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1805 Medical Center Drive', N'San Bernardino', N'CA', N'06071', N'92411', 34.1313, -117.322473, 653, 30, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (403, N'Sonoma Valley Hospital', 1, NULL, NULL, N'050090', NULL, NULL, 0, 83, NULL, N'7079355000', N'7079355433', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'347 Andrieux St', N'Sonoma', N'CA', N'06097', N'95476', 38.288435, -122.46534, 676, 38, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (404, N'Community Hospital Of Huntington Park', 1, NULL, NULL, N'050091', NULL, NULL, 0, 226, NULL, N'3235831931', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2623 E Slauson Ave', N'Huntington Park', N'CA', N'06037', N'90255', 33.981681, -118.225072, 599, 22, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (405, N'Saint Agnes Medical Center', 1, NULL, NULL, N'050093', NULL, NULL, 0, 436, NULL, N'5594503000', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1303 E Herndon Ave', N'Fresno', N'CA', N'06019', N'93710', 36.837409, -119.763041, 556, 21, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (406, N'Doctors Hospital Of West Covina Inc', 1, NULL, NULL, N'050096', NULL, NULL, 0, 57, NULL, N'6263388481', N'6269609178', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'725 S Orange Ave', N'West Covina', N'CA', N'06037', N'91790', 34.071095, -117.944049, 705, 22, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (407, N'San Antonio Community Hospital', 1, NULL, NULL, N'050099', NULL, NULL, 0, 281, NULL, N'7149852811', N'9099857659', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'999 San Bernardino Rd', N'Upland', N'CA', N'06071', N'91786', 34.101759, -117.637293, 694, 30, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (408, N'Sharp Memorial Hospital', 1, NULL, NULL, N'050100', NULL, NULL, 0, 881, NULL, N'8589393400', N'8585413919', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7901 Frost St', N'San Diego', N'CA', N'06073', N'92123', 32.80017, -117.154197, 655, 31, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (409, N'Sutter Solano Medical Center', 1, NULL, NULL, N'050101', NULL, NULL, 0, 111, NULL, N'7075545280', N'7076483227', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'300 Hospital Dr', N'Vallejo', N'CA', N'06095', N'94589', 38.131167, -122.239068, 697, 32, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (410, N'Parkview Community Hospital Medical Center', 1, NULL, NULL, N'050102', NULL, NULL, 0, 193, NULL, N'9516882211', N'9513525427', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3865 Jackson Street', N'Riverside', N'CA', N'06065', N'92503', 33.925836, -117.440008, 648, 30, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (411, N'White Memorial Medical Center', 1, NULL, NULL, N'050103', NULL, NULL, 0, 377, NULL, N'3232685000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1720 E Cesar Avenue', N'Los Angeles', N'CA', N'06037', N'90033', 34.053717, -118.242727, 597, 22, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (412, N'Saint Francis Medical Center', 1, NULL, NULL, N'050104', NULL, NULL, 0, 448, NULL, N'3109008900', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3630 East Imperial Highway', N'Lynwood', N'CA', N'06037', N'90262', 33.930569, -118.175216, 599, 22, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (413, N'Marian Regional Medical Center', 1, NULL, NULL, N'050107', NULL, NULL, 0, 227, NULL, N'8057393000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1400 E Church St', N'Santa Maria', N'CA', N'06083', N'93454', 34.951985, -120.412309, 668, 36, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (414, N'Sutter General Hospital', 1, NULL, NULL, N'050108', NULL, NULL, 0, 754, NULL, N'9167338999', NULL, 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2801 L Street', N'Sacramento', N'CA', N'06067', N'95816', 38.571686, -121.46998, 650, 28, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (415, N'Lompoc Valley Medical Center', 1, NULL, NULL, N'050110', NULL, NULL, 0, 170, NULL, N'8057373300', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1515 E Ocean Avenue', N'Lompoc', N'CA', N'06083', N'93436', 34.639321, -120.439662, 593, 36, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (416, N'Temple Community Hospital', 1, NULL, NULL, N'050111', NULL, NULL, 0, 170, NULL, N'2133827252', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'235 N Hoover St', N'Los Angeles', N'CA', N'06037', N'90004', 34.075377, -118.283571, 597, 22, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (417, N'Santa Monica - Ucla Med Ctr & Orthopaedic Hospital', 1, NULL, NULL, N'050112', NULL, NULL, 0, 363, NULL, N'3103194000', N'4242596626', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1250 16Th Street', N'Santa Monica', N'CA', N'06037', N'90404', 34.027248, -118.486634, 669, 22, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (418, N'San Mateo Medical Center', 1, NULL, NULL, N'050113', NULL, NULL, 0, 134, NULL, N'6505732222', NULL, 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'222 W 39Th Ave', N'San Mateo', N'CA', N'06081', N'94403', 37.530534, -122.298593, 662, 35, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (419, N'Palomar Health Downtown Campus', 1, NULL, NULL, N'050115', NULL, NULL, 0, 679, NULL, N'7607393000', N'7607393107', 1, 1, 1, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'555 E Valley Parkway', N'Escondido', N'CA', N'06073', N'92025', 33.124056, -117.079189, 545, 31, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (420, N'Northridge Hospital Medical Center', 1, NULL, NULL, N'050116', NULL, NULL, 0, 435, NULL, N'8188858500', N'8188855439', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'18300 Roscoe Blvd', N'Northridge', N'CA', N'06037', N'91325', 34.220922, -118.522987, 618, 22, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (421, N'Doctors Hospital Of Manteca', 1, NULL, NULL, N'050118', NULL, NULL, 0, 73, NULL, N'2098233111', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1205 E North St', N'Manteca', N'CA', N'06077', N'95336', 37.801149, -121.198084, 602, 39, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (422, N'Adventist Medical Center', 1, NULL, NULL, N'050121', NULL, NULL, 0, 199, NULL, N'2094107200', N'2094107280', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'115 Mall Drive', N'Hanford', N'CA', N'06031', N'93230', 36.323862, -119.666955, 569, 21, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (423, N'Dameron Hospital', 1, NULL, NULL, N'050122', NULL, NULL, 0, 211, NULL, N'2099445550', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'525 West Acacia Street', N'Stockton', N'CA', N'06077', N'95203', 37.957702, -121.29078, 683, 39, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (424, N'Usc Verdugo Hills Hospital', 1, NULL, NULL, N'050124', NULL, NULL, 0, 158, NULL, N'8187907100', N'8189524649', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1812 Verdugo Blvd', N'Glendale', N'CA', N'06037', N'91209', 34.20547, -118.216905, 562, 22, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (425, N'Regional Medical Center Of San Jose', 1, NULL, NULL, N'050125', NULL, NULL, 0, 204, NULL, N'4082595000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'225 N Jackson Avenue', N'San Jose', N'CA', N'06085', N'95116', 37.362659, -121.847732, 659, 33, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (426, N'Valley Presbyterian Hospital', 1, NULL, NULL, N'050126', NULL, NULL, 0, 362, NULL, N'8189023906', N'8189023974', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'15107 Vanowen St', N'Van Nuys', N'CA', N'06037', N'91406', 34.194001, -118.462705, 698, 22, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (427, N'Woodland Memorial Hospital', 1, NULL, NULL, N'050127', NULL, NULL, 0, 122, NULL, N'5306623961', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1325 Cottonwood Street', N'Woodland', N'CA', N'06113', N'95695', 38.681645, -121.793237, 709, 28, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (428, N'Tri-City Medical Center', 1, NULL, NULL, N'050128', NULL, NULL, 0, 397, NULL, N'7607248411', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4002 Vista Way', N'Oceanside', N'CA', N'06073', N'92056', 33.184253, -117.291784, 623, 31, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (429, N'St Bernardine Medical Center', 1, NULL, NULL, N'050129', NULL, NULL, 0, 291, NULL, N'9098814440', NULL, 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2101 N Waterman Ave', N'San Bernardino', N'CA', N'06071', N'92404', 34.108345, -117.289765, 653, 30, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (430, N'Novato Community Hospital', 1, NULL, NULL, N'050131', NULL, NULL, 0, 75, NULL, N'4152091300', N'4152091321', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'180 Rowland Way', N'Novato', N'CA', N'06041', N'94945', 38.097886, -122.559273, 620, 32, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (431, N'San Gabriel Valley Medical Center', 1, NULL, NULL, N'050132', NULL, NULL, 0, 273, NULL, N'6262895454', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'438 W Las Tunas Drive', N'San Gabriel', N'CA', N'06037', N'91776', 34.099133, -118.108604, 658, 22, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (432, N'Rideout Memorial Hospital', 1, NULL, NULL, N'050133', NULL, NULL, 0, 149, NULL, N'5307494300', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'726 4Th St', N'Marysville', N'CA', N'06115', N'95901', 39.138635, -121.595095, 604, 28, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (433, N'Southern California Hospital At Hollywood', 1, NULL, NULL, N'050135', NULL, NULL, 0, 579, NULL, N'3234622271', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6245 De Longpre Ave', N'Hollywood', N'CA', N'06037', N'90028', 34.096271, -118.325045, 597, 22, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (434, N'Petaluma Valley Hospital', 1, NULL, NULL, N'050136', NULL, NULL, 0, 99, NULL, N'7077781111', N'7077789117', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'400 N Mcdowell Blvd', N'Petaluma', N'CA', N'06097', N'94954', 38.253464, -122.633245, 633, 38, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (435, N'Kaiser Foundation Hospital - Panorama City', 1, NULL, NULL, N'050137', NULL, NULL, 0, 325, NULL, N'8183753333', N'8183753480', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'13652 Cantara St', N'Panorama City', N'CA', N'06037', N'91402', 34.219332, -118.456388, 629, 22, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (436, N'Kaiser Foundation Hospital - Los Angeles', 1, NULL, NULL, N'050138', NULL, NULL, 0, 613, NULL, N'3237834011', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4867 Sunset Blvd', N'Los Angeles', N'CA', N'06037', N'90027', 34.098223, -118.295439, 597, 22, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (437, N'Kaiser Foundation Hospital - Downey', 1, NULL, NULL, N'050139', NULL, NULL, 0, 453, NULL, N'5624616007', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'9333 Imperial Highway', N'Downey', N'CA', N'06037', N'90242', 33.940014, -118.132569, 540, 22, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (438, N'Kaiser Foundation Hospital Fontana', 1, NULL, NULL, N'050140', NULL, NULL, 0, 438, NULL, N'9094275500', NULL, 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'9961 Sierra Ave', N'Fontana', N'CA', N'06071', N'92335', 34.073507, -117.435578, 551, 30, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (439, N'Community Hospital Of The Monterey Peninsula', 1, NULL, NULL, N'050145', NULL, NULL, 0, 173, NULL, N'8316245311', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'23625 W R Holman Highway', N'Monterey', N'CA', N'06053', N'93940', 36.584417, -121.866793, 610, 29, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (440, N'City Of Hope Helford Clinical Research Hospital', 1, NULL, NULL, N'050146', NULL, NULL, 0, 212, NULL, N'6263598111', N'6263018889', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1500 E Duarte Road', N'Duarte', N'CA', N'06037', N'91010', 34.132332, -117.97755, 541, 22, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (441, N'California Hospital Medical Center La', 1, NULL, NULL, N'050149', NULL, NULL, 0, 309, NULL, N'2137482411', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1401 South Grand Avenue', N'Los Angeles', N'CA', N'06037', N'90015', 34.037125, -118.26554, 597, 22, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (442, N'Sierra Nevada Memorial Hospital', 1, NULL, NULL, N'050150', NULL, NULL, 0, 124, NULL, N'5302746000', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'155 Glasson Way', N'Grass Valley', N'CA', N'06057', N'95945', 39.208666, -121.053123, 565, 28, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (443, N'Saint Francis Memorial Hospital', 1, NULL, NULL, N'050152', NULL, NULL, 0, 362, NULL, N'4153536000', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'900 Hyde St', N'San Francisco', N'CA', N'06075', N'94109', 37.789635, -122.416534, 657, 32, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (444, N'O''connor Hospital', 1, NULL, NULL, N'050153', NULL, NULL, 0, 358, NULL, N'4089472500', NULL, 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2105 Forest Avenue', N'San Jose', N'CA', N'06085', N'95128', 37.327137, -121.937431, 659, 33, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (445, N'Encino Hospital Medical Center', 1, NULL, NULL, N'050158', NULL, NULL, 0, 150, NULL, N'8189955000', N'8189078630', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'16237 Ventura Blvd', N'Encino', N'CA', N'06037', N'91436', 34.156858, -118.48658, 544, 22, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (446, N'Ventura County Medical Center', 1, NULL, NULL, N'050159', NULL, NULL, 0, 272, NULL, N'8056526075', NULL, 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3291 Loma Vista Rd', N'Ventura', N'CA', N'06111', N'93003', 34.276394, -119.251989, 699, 40, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (447, N'San Joaquin General Hospital', 1, NULL, NULL, N'050167', NULL, NULL, 0, 212, NULL, N'2094686000', N'2094687011', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'500 W Hospital Road', N'French Camp', N'CA', N'06077', N'95231', 37.885178, -121.284639, 683, 39, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (448, N'St Jude Medical Center', 1, NULL, NULL, N'050168', NULL, NULL, 0, 301, NULL, N'7149923000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'101 E Valencia Mesa Drive', N'Fullerton', N'CA', N'06059', N'92835', 33.893541, -117.928269, 557, 17, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (449, N'Presbyterian Intercommunity Hospital', 1, NULL, NULL, N'050169', NULL, NULL, 0, 343, NULL, N'5266980811', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'12401 E Washington Blvd', N'Whittier', N'CA', N'06037', N'90602', 33.974893, -118.033697, 706, 22, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (450, N'Santa Rosa Memorial Hospital', 1, NULL, NULL, N'050174', NULL, NULL, 0, 346, NULL, N'7075255300', NULL, 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1165 Montgomery Dr', N'Santa Rosa', N'CA', N'06097', N'95405', 38.442916, -122.70265, 671, 38, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (451, N'Emanuel Medical Center', 1, NULL, NULL, N'050179', NULL, NULL, 0, 354, NULL, N'2096674200', N'2096349336', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'825 Delbon Ave', N'Turlock', N'CA', N'06099', N'95382', 37.510561, -120.839444, 692, 23, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (452, N'John Muir Medical Center - Walnut Creek Campus', 1, NULL, NULL, N'050180', NULL, NULL, 0, 296, NULL, N'9259393000', NULL, 1, 1, 0, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1601 Ygnacio Valley Rd', N'Walnut Creek', N'CA', N'06013', N'94598', 37.913252, -122.043768, 702, 20, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (453, N'George L Mee Memorial Hospital', 1, NULL, NULL, N'050189', NULL, NULL, 0, 68, NULL, N'8313856000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'300 Canal Street', N'King City', N'CA', N'06053', N'93930', 36.206098, -121.131649, 581, 29, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (454, N'St Mary Medical Center', 1, NULL, NULL, N'050191', NULL, NULL, 0, 539, NULL, N'5624919000', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1050 Linden Ave', N'Long Beach', N'CA', N'06037', N'90813', 33.780008, -118.186121, 595, 22, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (455, N'Adventist Medical Center - Reedley', 1, NULL, NULL, N'050192', NULL, NULL, 0, 44, NULL, N'5596388155', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'372 W Cypress Ave', N'Reedley', N'CA', N'06019', N'93654', 36.607877, -119.451422, 556, 21, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (456, N'Watsonville Community Hospital', 1, NULL, NULL, N'050194', NULL, NULL, 0, 106, NULL, N'8317244741', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'75 Nielson Street', N'Watsonville', N'CA', N'06087', N'95076', 36.95299, -121.769609, 703, 37, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (457, N'Washington Hospital', 1, NULL, NULL, N'050195', NULL, NULL, 0, 265, NULL, N'5107971111', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2000 Mowry Ave', N'Fremont', N'CA', N'06001', N'94538', 37.558487, -121.980293, 555, 25, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (458, N'Central Valley General Hospital', 1, NULL, NULL, N'050196', NULL, NULL, 0, 49, NULL, N'5595832100', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1025 N Douty St', N'Hanford', N'CA', N'06031', N'93230', 36.336125, -119.64561, 569, 21, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (459, N'Sequoia Hospital', 1, NULL, NULL, N'050197', NULL, NULL, 0, 189, NULL, N'6503675551', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'170 Alameda De Las Pulgas', N'Redwood City', N'CA', N'06081', N'94062', 37.479464, -122.255241, 646, 35, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (460, N'Palmdale Regional Medical Center', 1, NULL, NULL, N'050204', NULL, NULL, 0, 123, NULL, N'6613825000', N'6613826178', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'38600 Medical Center Drive', N'Palmdale', N'CA', N'06037', N'93552', 34.579313, -118.117111, 588, 22, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (461, N'Glendora Community Hospital', 1, NULL, NULL, N'050205', NULL, NULL, 0, 128, NULL, N'6263350231', N'6268525055', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'150 West Route 66', N'Glendora', N'CA', N'06037', N'91740', 34.136119, -117.865339, 563, 22, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (462, N'Alameda Hospital', 1, NULL, NULL, N'050211', NULL, NULL, 0, 145, NULL, N'5105223700', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2070 Clinton Ave', N'Alameda', N'CA', N'06001', N'94501', 37.763193, -122.253734, 495, 25, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (463, N'Sharp Chula Vista Medical Center', 1, NULL, NULL, N'050222', NULL, NULL, 0, 306, NULL, N'6195025800', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'751 Medical Center Court', N'Chula Vista', N'CA', N'06073', N'91911', 32.617395, -117.022586, 524, 31, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (464, N'Hoag Memorial Hospital Presbyterian', 1, NULL, NULL, N'050224', NULL, NULL, 0, 409, NULL, N'9497644624', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'One Hoag Drive', N'Newport Beach', N'CA', N'06059', N'92663', 33.617009, -117.92944, 617, 17, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (465, N'Feather River Hospital', 1, NULL, NULL, N'050225', NULL, NULL, 0, 100, NULL, N'5308779361', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5974 Pentz Road', N'Paradise', N'CA', N'06007', N'95969', 39.759606, -121.621918, 630, 19, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (466, N'Ahmc Anaheim Regional Medical Center', 1, NULL, NULL, N'050226', NULL, NULL, 0, 224, NULL, N'7147741450', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1111 W La Palma Avenue', N'Anaheim', N'CA', N'06059', N'92801', 33.847217, -117.93263, 497, 17, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (467, N'San Francisco General Hospital', 1, NULL, NULL, N'050228', NULL, NULL, 0, 509, NULL, N'4152068000', NULL, 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1001 Potrero Avenue', N'San Francisco', N'CA', N'06075', N'94110', 37.75681, -122.405253, 657, 32, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (468, N'Garden Grove Hospital & Medical Center', 1, NULL, NULL, N'050230', NULL, NULL, 0, 167, NULL, N'7145375160', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'12601 Garden Grove Blvd', N'Garden Grove', N'CA', N'06059', N'92843', 33.774328, -117.911587, 559, 17, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (469, N'Pomona Valley Hospital Medical Center', 1, NULL, NULL, N'050231', NULL, NULL, 0, 447, NULL, N'9098659500', N'9098659796', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1798 N Garey Ave', N'Pomona', N'CA', N'06037', N'91767', 34.078368, -117.752509, 637, 22, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (470, N'French Hospital Medical Center', 1, NULL, NULL, N'050232', NULL, NULL, 0, 135, NULL, N'8055435353', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1911 Johnson Ave', N'San Luis Obispo', N'CA', N'06079', N'93401', 35.27803, -120.651004, 661, 34, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (471, N'Sharp Coronado Hospital And Hlthcr Ctr', 1, NULL, NULL, N'050234', NULL, NULL, 0, 204, NULL, N'6194356251', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'250 Prospect Place', N'Coronado', N'CA', N'06073', N'92118', 32.694273, -117.168071, 531, 31, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (472, N'Providence Saint Joseph Medical Ctr', 1, NULL, NULL, N'050235', NULL, NULL, 0, 360, NULL, N'8188435111', N'8188476514', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'501 South Buena Vista', N'Burbank', N'CA', N'06037', N'91505', 34.181648, -118.325855, 514, 22, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (473, N'Simi Valley Hospital & Health Care Services', 1, NULL, NULL, N'050236', NULL, NULL, 0, 149, NULL, N'8059556000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2975 N Sycamore Dr', N'Simi Valley', N'CA', N'06111', N'93065', 34.269447, -118.781482, 674, 40, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (474, N'Methodist Hospital Of Southern Ca', 1, NULL, NULL, N'050238', NULL, NULL, 0, 351, NULL, N'6264454441', N'6265743767', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'300 W Huntington Dr', N'Arcadia', N'CA', N'06037', N'91006', 34.140022, -118.033553, 500, 22, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (475, N'Glendale Adventist Medical Center', 1, NULL, NULL, N'050239', NULL, NULL, 0, 450, NULL, N'8184098202', N'8185465600', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1509 E Wilson Terrace', N'Glendale', N'CA', N'06037', N'91206', 34.142346, -118.248367, 562, 22, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (476, N'Dominican Hospital', 1, NULL, NULL, N'050242', NULL, NULL, 0, 288, NULL, N'8314627700', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1555 Soquel Drive', N'Santa Cruz', N'CA', N'06087', N'95065', 36.988704, -121.983042, 667, 37, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (477, N'Desert Regional Medical Center', 1, NULL, NULL, N'050243', NULL, NULL, 0, 367, NULL, N'7603236511', N'7603236725', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1150 North Indian Canyon Drive', N'Palm Springs', N'CA', N'06065', N'92262', 33.839062, -116.545482, 628, 26, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (478, N'Arrowhead Regional Medical Center', 1, NULL, NULL, N'050245', NULL, NULL, 0, 456, NULL, N'9095801000', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'400 North Pepper Avenue', N'Colton', N'CA', N'06071', N'92324', 34.106915, -117.353027, 592, 30, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (479, N'Natividad Medical Center', 1, NULL, NULL, N'050248', NULL, NULL, 0, 172, NULL, N'8317554195', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1441 Constitution Boulevard', N'Salinas', N'CA', N'06053', N'93906', 36.700036, -121.623315, 651, 29, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (480, N'Marshall Medical Center', 1, NULL, NULL, N'050254', NULL, NULL, 0, 107, NULL, N'5306221441', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1100 Marshall Way', N'Placerville', N'CA', N'06017', N'95667', 38.724622, -120.791327, 636, 28, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (481, N'Good Samaritan Hospital', 1, NULL, NULL, N'050257', NULL, NULL, 0, 64, NULL, N'6613994461', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'901 Olive Drive', N'Bakersfield', N'CA', N'06029', N'93308', 35.413909, -119.101092, 505, 18, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (482, N'Sierra View Medical Center', 1, NULL, NULL, N'050261', NULL, NULL, 0, 120, NULL, N'5597841110', NULL, 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'465 W Putnam Ave', N'Porterville', N'CA', N'06107', N'93257', 36.069449, -119.027449, 638, 18, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (483, N'Ronald Reagan U C L A Medical Center', 1, NULL, NULL, N'050262', NULL, NULL, 0, 466, NULL, N'3108256301', N'3107943284', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'757 Westwood Plaza', N'Los Angeles', N'CA', N'06037', N'90095', 34.066465, -118.446507, 597, 22, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (484, N'Redlands Community Hospital', 1, NULL, NULL, N'050272', NULL, NULL, 0, 229, NULL, N'9093355500', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'350 Terracina Blvd', N'Redlands', N'CA', N'06071', N'92373', 34.037131, -117.204305, 645, 30, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (485, N'Contra Costa Regional Medical Center', 1, NULL, NULL, N'050276', NULL, NULL, 0, 164, NULL, N'9253705000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2500 Alhambra Ave', N'Martinez', N'CA', N'06013', N'94553', 37.983345, -122.122883, 603, 20, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (486, N'Providence Holy Cross Medical Center', 1, NULL, NULL, N'050278', NULL, NULL, 0, 257, NULL, N'8183658051', N'8184964477', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'15031 Rinaldi St', N'Mission Hills', N'CA', N'06037', N'91346', 34.280828, -118.453229, 606, 22, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (487, N'Hi-Desert Medical Center', 1, NULL, NULL, N'050279', NULL, NULL, 0, 175, NULL, N'7603663711', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6601 White Feather Road', N'Joshua Tree', N'CA', N'06071', N'92252', 33.895564, -115.947319, 580, 26, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (488, N'Mercy Medical Center Redding', 1, NULL, NULL, N'050280', NULL, NULL, 0, 267, NULL, N'5302256102', N'5302425453', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2175 Rosaline Ave Clairmont Hgts', N'Redding', N'CA', N'06089', N'96001', 40.586356, -122.391675, 644, 27, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (489, N'Alhambra Hospital Medical Center', 1, NULL, NULL, N'050281', NULL, NULL, 0, 144, NULL, N'6265701606', N'6265708825', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'100 S Raymond Ave', N'Alhambra', N'CA', N'06037', N'91801', 34.091716, -118.144981, 658, 22, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (490, N'Valleycare Medical Center', 1, NULL, NULL, N'050283', NULL, NULL, 0, 175, NULL, N'9254477000', N'9253734025', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5555 West Las Positas Boulevard', N'Pleasanton', N'CA', N'06001', N'94588', 37.687492, -121.887666, 714, 25, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (491, N'Seton Medical Center', 1, NULL, NULL, N'050289', NULL, NULL, 0, 279, NULL, N'6509924000', NULL, 1, 1, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1900 Sullivan Avenue', N'Daly City', N'CA', N'06081', N'94015', 37.679932, -122.474199, 535, 35, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (492, N'Providence Saint John''s Health Center', 1, NULL, NULL, N'050290', NULL, NULL, 0, 317, NULL, N'3108295511', N'3108298062', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2121 Santa Monica Blvd', N'Santa Monica', N'CA', N'06037', N'90404', 34.018729, -118.492333, 669, 22, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (493, N'Sutter Santa Rosa Regional Hospital', 1, NULL, NULL, N'050291', NULL, NULL, 0, 170, NULL, N'7075764000', N'7075764318', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'30 Mark West Springs Road', N'Santa Rosa', N'CA', N'06097', N'95403', 38.440468, -122.714431, 671, 38, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (494, N'Riverside County Regional Medical Center', 1, NULL, NULL, N'050292', NULL, NULL, 0, 439, NULL, N'9514864000', N'9514864475', 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'26520 Cactus Avenue', N'Moreno Valley', N'CA', N'06065', N'92555', 33.9102, -117.197079, 648, 30, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (495, N'Mercy Hospital', 1, NULL, NULL, N'050295', NULL, NULL, 0, 211, NULL, N'6616325000', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2215 Truxtun Avenue', N'Bakersfield', N'CA', N'06029', N'93301', 35.373286, -119.027304, 505, 18, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (496, N'Hazel Hawkins Memorial Hospital', 1, NULL, NULL, N'050296', NULL, NULL, 0, 49, NULL, N'8316375711', N'8316375601', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'911 Sunset Drive', N'Hollister', N'CA', N'06069', N'95023', 36.833493, -121.385924, 575, 33, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (497, N'Barstow Community Hospital', 1, NULL, NULL, N'050298', NULL, NULL, 0, 56, NULL, N'7602561761', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'820 E Mountain View Street', N'Barstow', N'CA', N'06071', N'92311', 34.895768, -117.017208, 507, 30, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (498, N'St Mary Medical Center', 1, NULL, NULL, N'050300', NULL, NULL, 0, 208, NULL, N'7602422311', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'18300 Highway 18', N'Apple Valley', N'CA', N'06071', N'92307', 34.500831, -117.185876, 499, 30, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (499, N'Ukiah Valley Medical Center/Hospital D', 1, NULL, NULL, N'050301', NULL, NULL, 0, 127, NULL, N'7074623111', N'7074637384', 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'275 Hospital Drive', N'Ukiah', N'CA', N'06045', N'95482', 39.152314, -123.203612, 693, 24, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (500, N'Alta Bates Summit Medical Center - Alta Bates Camp', 1, NULL, NULL, N'050305', NULL, NULL, 0, 555, NULL, N'5102044444', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2450 Ashby Ave', N'Berkeley', N'CA', N'06001', N'94705', 37.855168, -122.266866, 509, 25, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (501, N'El Camino Hospital', 1, NULL, NULL, N'050308', NULL, NULL, 0, 443, NULL, N'6509407000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2500 Grant Road', N'Mountain View', N'CA', N'06085', N'94040', 37.369149, -122.07928, 613, 33, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (502, N'Sutter Roseville Medical Center', 1, NULL, NULL, N'050309', NULL, NULL, 0, 298, NULL, N'9167811000', N'9167811200', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'One Medical Plaza', N'Roseville', N'CA', N'06061', N'95661', 38.752124, -121.288006, 649, 28, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (503, N'Sutter Tracy Community Hospital', 1, NULL, NULL, N'050313', NULL, NULL, 0, 82, NULL, N'2098351500', N'2098326091', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1420 N Tracy Blvd', N'Tracy', N'CA', N'06077', N'95376', 37.718829, -121.434284, 689, 39, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (504, N'Kern Medical Center', 1, NULL, NULL, N'050315', NULL, NULL, 0, 222, NULL, N'6613262000', N'6613262100', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1700 Mount Vernon Avenue', N'Bakersfield', N'CA', N'06029', N'93306', 35.381742, -118.967531, 505, 18, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (505, N'Highland Hospital', 1, NULL, NULL, N'050320', NULL, NULL, 0, 613, NULL, N'5104374800', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1411 E 31St Street', N'Oakland', N'CA', N'06001', N'94602', 37.799475, -122.23293, 622, 25, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (506, N'Scripps Memorial Hospital La Jolla', 1, NULL, NULL, N'050324', NULL, NULL, 0, 332, NULL, N'8586264123', N'8586266122', 1, 1, 1, 0, 0, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'9888 Genesee Avenue', N'La Jolla', N'CA', N'06073', N'92037', 32.885158, -117.22509, 582, 31, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (507, N'Loma Linda University Medical Center', 1, NULL, NULL, N'050327', NULL, NULL, 0, 881, NULL, N'9095584000', NULL, 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'11234 Anderson St', N'Loma Linda', N'CA', N'06071', N'92354', 34.049664, -117.261229, 592, 30, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (508, N'Corona Regional Medical Center', 1, NULL, NULL, N'050329', NULL, NULL, 0, 240, NULL, N'9517374343', N'9517366310', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'800 South Main Street', N'Corona', N'CA', N'06065', N'92882', 33.838648, -117.57205, 530, 17, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (509, N'Salinas Valley Memorial Hospital', 1, NULL, NULL, N'050334', NULL, NULL, 0, 269, NULL, N'8317574333', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'450 East Romie Lane', N'Salinas', N'CA', N'06053', N'93901', 36.660312, -121.648069, 651, 29, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (510, N'Sonora Regional Medical Center', 1, NULL, NULL, N'050335', NULL, NULL, 0, 143, NULL, N'2095323161', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1000 Greenley Road', N'Sonora', N'CA', N'06109', N'95370', 37.980889, -120.368617, 677, 23, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (511, N'Lodi Memorial Hospital', 1, NULL, NULL, N'050336', NULL, NULL, 0, 71, NULL, N'2093343411', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'975 S Fairmont Avenue', N'Lodi', N'CA', N'06077', N'95240', 38.120469, -121.285928, 591, 28, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (512, N'Pioneers Memorial Healthcare District', 1, NULL, NULL, N'050342', NULL, NULL, 0, 99, NULL, N'7603513333', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'207 West Legion Road', N'Brawley', N'CA', N'06025', N'92227', 32.959866, -115.553108, 513, 31, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (513, N'University Of California Irvine Med Center', 1, NULL, NULL, N'050348', NULL, NULL, 0, 415, NULL, N'7144566112', NULL, 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'101 City Drive South', N'Orange', N'CA', N'06059', N'92868', 33.787228, -117.888413, 625, 17, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (514, N'Beverly Hospital', 1, NULL, NULL, N'050350', NULL, NULL, 0, 214, NULL, N'3237261222', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'309 W Beverly Blvd', N'Montebello', N'CA', N'06037', N'90640', 34.015959, -118.100595, 609, 22, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (515, N'Torrance Memorial Medical Center', 1, NULL, NULL, N'050351', NULL, NULL, 0, 380, NULL, N'3103259110', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3330 Lomita Blvd', N'Torrance', N'CA', N'06037', N'90509', 33.812597, -118.343803, 688, 22, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (516, N'Barton Memorial Hospital', 1, NULL, NULL, N'050352', NULL, NULL, 0, 64, NULL, N'5305413420', N'5305442605', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2170 South Avenue', N'South Lake Tahoe', N'CA', N'06017', N'96150', 38.912272, -119.996788, 680, 28, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (517, N'Providence Little Company Of Mary Med Ctr Torrance', 1, NULL, NULL, N'050353', NULL, NULL, 0, 366, NULL, N'3105407676', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4101 Torrance Blvd', N'Torrance', N'CA', N'06037', N'90503', 33.837657, -118.358142, 688, 22, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (518, N'Goleta Valley Cottage Hospital', 1, NULL, NULL, N'050357', NULL, NULL, 0, 122, NULL, N'8056816446', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'351 S Patterson Ave', N'Santa Barbara', N'CA', N'06083', N'93111', 34.433144, -119.809772, 666, 36, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (519, N'Tulare Regional Medical Center', 1, NULL, NULL, N'050359', NULL, NULL, 0, 112, NULL, N'5596880821', N'5596853835', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'869 Cherry Avenue', N'Tulare', N'CA', N'06107', N'93274', 36.207735, -119.347342, 691, 18, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (520, N'Marin General Hospital', 1, NULL, NULL, N'050360', NULL, NULL, 0, 325, NULL, N'4159257900', N'4159257933', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'250 Bon Air Road Po Box 8010', N'Greenbrae', N'CA', N'06041', N'94904', 37.948536, -122.524703, 566, 32, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (521, N'Northbay Medical Center', 1, NULL, NULL, N'050367', NULL, NULL, 0, 123, NULL, N'7076465000', N'7076465002', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1200 B  Gale Wilson Blvd', N'Fairfield', N'CA', N'06095', N'94533', 38.261078, -122.047497, 547, 20, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (522, N'Lac+Usc Medical Center', 1, NULL, NULL, N'050373', NULL, NULL, 0, 1395, NULL, N'3232262800', NULL, 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1200 N State St Room C2k100', N'Los Angeles', N'CA', N'06037', N'90033', 34.053717, -118.242727, 597, 22, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (523, N'Lac/Harbor-Ucla Med Center', 1, NULL, NULL, N'050376', NULL, NULL, 0, 553, NULL, N'3102222101', NULL, 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1000 W Carson St', N'Torrance', N'CA', N'06037', N'90509', 33.831502, -118.292216, 688, 22, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (524, N'Pacifica Hospital Of The Valley', 1, NULL, NULL, N'050378', NULL, NULL, 0, 242, NULL, N'8187673310', N'8182522478', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'9449 San Fernando Rd', N'Sun Valley', N'CA', N'06037', N'91352', 34.240287, -118.393953, 514, 22, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (525, N'Good Samaritan Hospital', 1, NULL, NULL, N'050380', NULL, NULL, 0, 429, NULL, N'4085592011', NULL, 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2425 Samaritan Drive', N'San Jose', N'CA', N'06085', N'95124', 37.251175, -121.944725, 659, 33, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (526, N'Citrus Valley Medical Center-Ic Campus', 1, NULL, NULL, N'050382', NULL, NULL, 0, 193, NULL, N'6268142468', N'6268595865', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'210 W  San Bernardino Road', N'Covina', N'CA', N'06037', N'91723', 34.089945, -117.892721, 532, 22, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (527, N'Hemet Valley Medical Center', 1, NULL, NULL, N'050390', NULL, NULL, 0, 433, NULL, N'9516522811', N'9517666419', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1117 East Devonshire', N'Hemet', N'CA', N'06065', N'92543', 33.778562, -117.035767, 574, 30, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (528, N'Pih Hospital - Downey', 1, NULL, NULL, N'050393', NULL, NULL, 0, 199, NULL, N'5269045000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'11500 Brookshire Avenue', N'Downey', N'CA', N'06037', N'90241', 33.935083, -118.131945, 540, 22, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (529, N'Community Memorial Hospital San Buenaventura', 1, NULL, NULL, N'050394', NULL, NULL, 0, 242, NULL, N'8056525011', NULL, 1, 1, 0, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'147 N Brent St', N'Ventura', N'CA', N'06111', N'93003', 34.27424, -119.257311, 699, 40, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (530, N'Santa Barbara Cottage Hospital', 1, NULL, NULL, N'050396', NULL, NULL, 0, 450, NULL, N'8056827111', NULL, 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'400 West Pueblo', N'Santa Barbara', N'CA', N'06083', N'93102', 34.432543, -119.719628, 666, 36, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (531, N'Coalinga Regional Medical Center', 1, NULL, NULL, N'050397', NULL, NULL, 0, 138, NULL, N'5599356400', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1191 Phelps Avenue', N'Coalinga', N'CA', N'06019', N'93210', 36.161906, -120.294693, 526, 21, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (532, N'Chinese Hospital', 1, NULL, NULL, N'050407', NULL, NULL, 0, 54, NULL, N'4159822400', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'845 Jackson St', N'San Francisco', N'CA', N'06075', N'94133', 37.795544, -122.408876, 657, 32, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (533, N'Kaiser Foundation Hospital - South Bay', 1, NULL, NULL, N'050411', NULL, NULL, 0, 251, NULL, N'3105176441', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'25825 South Vermont Avenue', N'Harbor City', N'CA', N'06037', N'90710', 33.789002, -118.294068, 570, 22, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (534, N'Mercy Hospital Of Folsom', 1, NULL, NULL, N'050414', NULL, NULL, 0, 106, NULL, N'9169837400', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1650 Creekside Drive', N'Folsom', N'CA', N'06067', N'95630', 38.670783, -121.146302, 550, 28, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (535, N'Sutter Coast Hospital', 1, NULL, NULL, N'050417', NULL, NULL, 0, 49, NULL, N'7074648880', N'7074648886', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'800 E Washington Blvd', N'Crescent City', N'CA', N'06015', N'95531', 41.754497, -124.202627, 533, 223, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (536, N'Palo Verde Hospital', 1, NULL, NULL, N'050423', NULL, NULL, 0, 51, NULL, N'7609224115', N'7609215201', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'250 North First Street', N'Blythe', N'CA', N'06065', N'92225', 33.560286, -114.912073, 512, 9, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (537, N'Scripps Green Hospital', 1, NULL, NULL, N'050424', NULL, NULL, 0, 173, NULL, N'8584559100', N'8585543636', 1, 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'10666 North Torrey Pines Road', N'La Jolla', N'CA', N'06073', N'92037', 32.870564, -117.242784, 582, 31, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (538, N'Kaiser Foundation Hospital - Sacramento', 1, NULL, NULL, N'050425', NULL, NULL, 0, 628, NULL, N'9169735000', N'9169734405', 1, 0, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2025 Morse Avenue', N'Sacramento', N'CA', N'06067', N'95825', 38.601685, -121.392504, 650, 28, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (539, N'West Anaheim Medical Center', 1, NULL, NULL, N'050426', NULL, NULL, 0, 219, NULL, N'7148273000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3033 W Orange Avenue', N'Anaheim', N'CA', N'06059', N'92804', 33.824817, -117.99505, 497, 17, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (540, N'Colusa Regional Medical Center', 1, NULL, NULL, N'050434', NULL, NULL, 0, 48, NULL, N'5304585821', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'199 East Webster St', N'Colusa', N'CA', N'06011', N'95932', 39.20701, -121.999102, 527, 28, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (541, N'Fallbrook Hospital District', 1, NULL, NULL, N'050435', NULL, NULL, 0, 140, NULL, N'7607281191', N'7607236214', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'624 E Elder St', N'Fallbrook', N'CA', N'06073', N'92028', 33.380913, -117.244459, 549, 31, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (542, N'Huntington Memorial Hospital', 1, NULL, NULL, N'050438', NULL, NULL, 0, 625, NULL, N'6263975000', N'6263972995', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'100 W  California Blvd', N'Pasadena', N'CA', N'06037', N'91109', 34.135682, -118.153304, 632, 22, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (543, N'Stanford Hospital', 1, NULL, NULL, N'050441', NULL, NULL, 0, 613, NULL, N'6507235708', NULL, 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'300 Pasteur Drive', N'Stanford', N'CA', N'06085', N'94305', 37.433094, -122.174472, 682, 35, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (544, N'Mercy Medical Center', 1, NULL, NULL, N'050444', NULL, NULL, 0, 287, NULL, N'2095645000', N'2095845096', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'333 Mercy Avenue', N'Merced', N'CA', N'06047', N'95340', 37.339974, -120.467323, 605, 23, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (545, N'Ucsf Medical Center', 1, NULL, NULL, N'050454', NULL, NULL, 0, 722, NULL, N'4153532733', N'4153538645', 1, 1, 0, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'505 Parnassus Ave Box 0296', N'San Francisco', N'CA', N'06075', N'94143', 37.779277, -122.41927, 657, 32, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (546, N'San Joaquin Community Hospital', 1, NULL, NULL, N'050455', NULL, NULL, 0, 255, NULL, N'6613953000', N'6613245162', 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2615 Chester Avenue', N'Bakersfield', N'CA', N'06029', N'93301', 35.383116, -119.018872, 505, 18, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (547, N'St Mary''s Medical Center', 1, NULL, NULL, N'050457', NULL, NULL, 0, 371, NULL, N'4156681000', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'450 Stanyan St', N'San Francisco', N'CA', N'06075', N'94117', 37.773765, -122.453616, 657, 32, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (548, N'Doctors Medical Center', 1, NULL, NULL, N'050464', NULL, NULL, 0, 461, NULL, N'2095781211', N'2095763910', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1441 Florida Avenue', N'Modesto', N'CA', N'06099', N'95350', 37.66564, -120.996321, 608, 23, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (549, N'Memorial Hospital Of Gardena', 1, NULL, NULL, N'050468', NULL, NULL, 0, 180, NULL, N'3105324200', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1145 W Redondo Beach Blvd', N'Gardena', N'CA', N'06037', N'90247', 33.892301, -118.295456, 560, 22, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (550, N'Good Samaritan Hospital', 1, NULL, NULL, N'050471', NULL, NULL, 0, 408, NULL, N'2139772121', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1225 Wilshire Boulevard', N'Los Angeles', N'CA', N'06037', N'90017', 34.053294, -118.265311, 597, 22, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (551, N'West Hills Hospital & Medical Center', 1, NULL, NULL, N'050481', NULL, NULL, 0, 236, NULL, N'8186764100', N'8187043880', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7300 Medical Center Dr', N'West Hills', N'CA', N'06037', N'91307', 34.203796, -118.630759, 517, 22, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (552, N'Long Beach Memorial Medical Center', 1, NULL, NULL, N'050485', NULL, NULL, 0, 570, NULL, N'5629332000', NULL, 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2801 Atlantic Ave', N'Long Beach', N'CA', N'06037', N'90806', 33.807885, -118.18511, 595, 22, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (553, N'Eden Medical Center', 1, NULL, NULL, N'050488', NULL, NULL, 0, 155, NULL, N'5105371234', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'20103 Lake Chabot Road', N'Castro Valley', N'CA', N'06001', N'94546', 37.698279, -122.087448, 519, 25, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (554, N'Clovis Community Medical Center', 1, NULL, NULL, N'050492', NULL, NULL, 0, 109, NULL, N'5593244000', NULL, 1, 1, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2755 Herndon Ave', N'Clovis', N'CA', N'06019', N'93611', 36.837404, -119.70179, 556, 21, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (555, N'John Muir Medical Center - Concord Campus', 1, NULL, NULL, N'050496', NULL, NULL, 0, 303, NULL, N'9256742002', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2540 East St', N'Concord', N'CA', N'06013', N'94520', 37.983718, -122.034693, 528, 20, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (556, N'Sutter Auburn Faith Hospital', 1, NULL, NULL, N'050498', NULL, NULL, 0, 97, NULL, N'5308884500', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'11815 Education Street', N'Auburn', N'CA', N'06061', N'95603', 38.894594, -121.07399, 503, 28, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (557, N'Saint Vincent Medical Center', 1, NULL, NULL, N'050502', NULL, NULL, 0, 381, NULL, N'2134847111', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2131 W 3Rd St', N'Los Angeles', N'CA', N'06037', N'90057', 34.063925, -118.273812, 597, 22, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (558, N'Scripps Memorial Hospital - Encinitas', 1, NULL, NULL, N'050503', NULL, NULL, 0, 158, NULL, N'7607536501', N'7606337356', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'354 Santa Fe Drive', N'Encinitas', N'CA', N'06073', N'92024', 33.037762, -117.283415, 543, 31, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (559, N'Sierra Vista Regional Medical Center', 1, NULL, NULL, N'050506', NULL, NULL, 0, 186, NULL, N'8505467600', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1010 Murray St', N'San Luis Obispo', N'CA', N'06079', N'93405', 35.291006, -120.665017, 661, 34, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (560, N'Kaiser Foundation Hospital', 1, NULL, NULL, N'050510', NULL, NULL, 0, 120, NULL, N'4154442000', N'4154444731', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'99 Montecillo Rd', N'San Rafael', N'CA', N'06041', N'94903', 38.004193, -122.553869, 566, 32, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (561, N'Kaiser Foundation Hospital - Fremont', 1, NULL, NULL, N'050512', NULL, NULL, 0, 193, NULL, N'5107844000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'39400 Paseo Padre Pkwy', N'Fremont', N'CA', N'06001', N'94538', 37.552818, -121.979809, 555, 25, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (562, N'Kaiser Foundation Hospital - San Diego', 1, NULL, NULL, N'050515', NULL, NULL, 0, 397, NULL, N'6195285000', N'6195285317', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4647 Zion Ave', N'San Diego', N'CA', N'06073', N'92120', 32.791576, -117.095033, 655, 31, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (563, N'Mercy San Juan Medical Center', 1, NULL, NULL, N'050516', NULL, NULL, 0, 254, NULL, N'9165375000', N'9165375111', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6501 Coyle Ave', N'Carmichael', N'CA', N'06067', N'95608', 38.617127, -121.328284, 518, 28, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (564, N'Victor Valley Global Medical Center', 1, NULL, NULL, N'050517', NULL, NULL, 0, 101, NULL, N'7602458691', NULL, 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'15248 11Th St', N'Victorville', N'CA', N'06071', N'92392', 34.52797, -117.292608, 700, 30, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (565, N'Sutter Delta Medical Center', 1, NULL, NULL, N'050523', NULL, NULL, 0, 111, NULL, N'9257797200', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3901 Lone Tree Way', N'Antioch', N'CA', N'06013', N'94509', 37.964328, -121.774859, 498, 20, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (566, N'Huntington Beach Hospital', 1, NULL, NULL, N'050526', NULL, NULL, 0, 131, NULL, N'7148435000', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'17772 Beach Blvd', N'Huntington Beach', N'CA', N'06059', N'92647', 33.704333, -117.988976, 576, 17, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (567, N'Memorial Hospital Los Banos', 1, NULL, NULL, N'050528', NULL, NULL, 0, 48, NULL, N'2098260591', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'520 West I St', N'Los Banos', N'CA', N'06047', N'93635', 37.064129, -120.859168, 598, 23, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (568, N'John F Kennedy Memorial Hospital', 1, NULL, NULL, N'050534', NULL, NULL, 0, 156, NULL, N'7603476191', N'7607758014', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'47111 Monroe Street', N'Indio', N'CA', N'06065', N'92201', 33.706191, -116.23397, 577, 31, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (569, N'Sutter Davis Hospital', 1, NULL, NULL, N'050537', NULL, NULL, 0, 48, NULL, N'5307566440', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2000 Sutter Place', N'Davis', N'CA', N'06113', N'95616', 38.545379, -121.744583, 536, 28, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (570, N'Kaiser Foundation Hospital - Redwood City', 1, NULL, NULL, N'050541', NULL, NULL, 0, 213, NULL, N'6502992000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1100 Veterans Boulevard', N'Redwood City', N'CA', N'06081', N'94063', 37.48967, -122.224557, 646, 35, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (571, N'College Hospital Costa Mesa', 1, NULL, NULL, N'050543', NULL, NULL, 0, 122, NULL, N'9496422734', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'301 Victoria Street', N'Costa Mesa', N'CA', N'06059', N'92627', 33.65254, -117.912048, 617, 17, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (572, N'Lanterman Developmental Center', 1, NULL, NULL, N'050545', NULL, NULL, 0, 39, NULL, N'9095951221', NULL, 1, 0, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3530 Pomona Boulevard', N'Pomona', N'CA', N'06037', N'91768', 34.04616, -117.812141, 637, 22, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (573, N'Porterville Developmental Center', 1, NULL, NULL, N'050546', NULL, NULL, 0, 1194, NULL, N'5597822222', N'5597822193', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'26501 Avenue 140', N'Porterville', N'CA', N'06107', N'93257', 36.043808, -118.93755, 638, 18, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (574, N'Sonoma Developmental Center', 1, NULL, NULL, N'050547', NULL, NULL, 0, 13, NULL, N'7079386393', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'P O Box 1493', N'Eldridge', N'CA', N'06097', N'95431', 38.348802, -122.510815, 676, 38, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (575, N'Fairview Developmental Center', 1, NULL, NULL, N'050548', NULL, NULL, 0, 1228, NULL, N'7149575000', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2501 Harbor Boulevard', N'Costa Mesa', N'CA', N'06059', N'92626', 33.713644, -117.919926, 617, 17, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (576, N'Los Robles Hospital & Medical Center', 1, NULL, NULL, N'050549', NULL, NULL, 0, 273, NULL, N'8054972727', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'215 W Janss Rd', N'Thousand Oaks', N'CA', N'06111', N'91360', 34.206546, -118.882385, 687, 40, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (577, N'Los Alamitos Medical Center', 1, NULL, NULL, N'050551', NULL, NULL, 0, 167, NULL, N'5627993220', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3751 Katella Avenue', N'Los Alamitos', N'CA', N'06059', N'90720', 33.803742, -118.078053, 596, 17, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (578, N'Motion Picture & Television Hospital', 1, NULL, NULL, N'050552', NULL, NULL, 0, 256, NULL, N'8188761888', N'8188761079', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'23388 Mulholland Drive', N'Woodland Hills', N'CA', N'06037', N'91364', 34.157695, -118.635575, 517, 22, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (579, N'Memorial  Medical Center', 1, NULL, NULL, N'050557', NULL, NULL, 0, 275, NULL, N'2095264500', N'2095697417', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1700 Coffee Rd', N'Modesto', N'CA', N'06099', N'95355', 37.668545, -120.975579, 608, 23, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (580, N'Kaiser Foundation Hospital - West La', 1, NULL, NULL, N'050561', NULL, NULL, 0, 293, NULL, N'2138572201', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6041 Cadillac Ave', N'Los Angeles', N'CA', N'06037', N'90034', 34.037859, -118.375498, 597, 22, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (581, N'Mission Hospital Regional Med Center', 1, NULL, NULL, N'050567', NULL, NULL, 0, 565, NULL, N'9493641400', NULL, 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'27700 Medical Center Rd', N'Mission Viejo', N'CA', N'06059', N'92691', 33.561279, -117.666946, 607, 17, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (582, N'Madera Community Hospital', 1, NULL, NULL, N'050568', NULL, NULL, 0, 106, NULL, N'5596755555', N'5596755574', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1250 E Almond Ave', N'Madera', N'CA', N'06039', N'93637', 36.945215, -120.043876, 600, 21, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (583, N'Fountain Valley Regional Hospital & Medical Center', 1, NULL, NULL, N'050570', NULL, NULL, 0, 405, NULL, N'7149667200', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'17100 Euclid Street', N'Fountain Valley', N'CA', N'06059', N'92708', 33.712606, -117.937076, 554, 17, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (584, N'Eisenhower Medical Center', 1, NULL, NULL, N'050573', NULL, NULL, 0, 289, NULL, N'7603403911', N'7607734336', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'39-000 Bob Hope Drive', N'Rancho Mirage', N'CA', N'06065', N'92270', 33.763346, -116.42286, 642, 26, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (585, N'Gardens Regional Hospital And Medical Center', 1, NULL, NULL, N'050575', NULL, NULL, 0, 107, NULL, N'5628600401', N'5629245871', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'21530 S Pioneer Blvd', N'Hawaiian Gardens', N'CA', N'06037', N'90716', 33.828479, -118.074314, 595, 22, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (586, N'La Palma Intercommunity Hospital', 1, NULL, NULL, N'050580', NULL, NULL, 0, 141, NULL, N'7146707400', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7901 Walker Street', N'La Palma', N'CA', N'06059', N'90623', 33.844052, -118.037196, 497, 17, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (587, N'Lakewood Regional Medical Center', 1, NULL, NULL, N'050581', NULL, NULL, 0, 170, NULL, N'5626026751', N'5626020083', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3700 E South St', N'Lakewood', N'CA', N'06037', N'90712', 33.850346, -118.117191, 587, 22, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (588, N'Chino Valley Medical Center', 1, NULL, NULL, N'050586', NULL, NULL, 0, 126, NULL, N'9096276111', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5451 Walnut Ave', N'Chino', N'CA', N'06071', N'91710', 34.024511, -117.728626, 523, 30, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (589, N'San Dimas Community Hospital', 1, NULL, NULL, N'050588', NULL, NULL, 0, 93, NULL, N'9095996811', N'9093942789', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1350 W Covina Blvd', N'San Dimas', N'CA', N'06037', N'91773', 34.106676, -117.806726, 656, 22, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (590, N'Placentia Linda Hospital', 1, NULL, NULL, N'050589', NULL, NULL, 0, 114, NULL, N'7149932000', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1301 N Rose Drive', N'Placentia', N'CA', N'06059', N'92870', 33.878105, -117.843513, 557, 17, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (591, N'Methodist Hospital Of Sacramento', 1, NULL, NULL, N'050590', NULL, NULL, 0, 158, NULL, N'9164236010', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7500 Hospital Drive', N'Sacramento', N'CA', N'06067', N'95823', 38.46415, -121.417374, 650, 28, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (592, N'Foothill Presbyterian Hospital', 1, NULL, NULL, N'050597', NULL, NULL, 0, 106, NULL, N'6269638411', N'6268595865', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'250 S Grand Ave', N'Glendora', N'CA', N'06037', N'91740', 34.133149, -117.872442, 563, 22, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (593, N'University Of California Davis Medical Center', 1, NULL, NULL, N'050599', NULL, NULL, 0, 631, NULL, N'9167342011', N'9167347411', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2315 Stockton Boulevard', N'Sacramento', N'CA', N'06067', N'95817', 38.554321, -121.457345, 650, 28, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (594, N'Saddleback Memorial Medical Center', 1, NULL, NULL, N'050603', NULL, NULL, 0, 325, NULL, N'9498374500', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'24451 Health Center Drive', N'Laguna Hills', N'CA', N'06059', N'92653', 33.608061, -117.708181, 584, 17, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (595, N'Kaiser Foundation Hospital-San Jose', 1, NULL, NULL, N'050604', NULL, NULL, 0, 228, NULL, N'4089727000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'250 Hospital Parkway', N'San Jose', N'CA', N'06085', N'95119', 37.239464, -121.802972, 659, 33, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (596, N'Delano Regional Medical Center', 1, NULL, NULL, N'050608', NULL, NULL, 0, 156, NULL, N'6617254800', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1401 Garces Highway', N'Delano', N'CA', N'06029', N'93215', 35.761376, -119.249433, 538, 18, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (597, N'Kaiser Foundation Hospital - Anaheim', 1, NULL, NULL, N'050609', NULL, NULL, 0, 200, NULL, N'7142794000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3440 E La Palma Ave', N'Anaheim', N'CA', N'06059', N'92806', 33.847269, -117.893544, 497, 17, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (598, N'St Johns Pleasant Valley Hospital', 1, NULL, NULL, N'050616', NULL, NULL, 0, 180, NULL, N'8053895800', N'8053837450', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2309 Antonio Ave', N'Camarillo', N'CA', N'06111', N'93010', 34.24178, -119.018004, 516, 40, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (599, N'Henry Mayo Newhall  Hospital', 1, NULL, NULL, N'050624', NULL, NULL, 0, 227, NULL, N'6612538000', N'6612001042', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'23845  Mcbean Pkwy', N'Valencia', N'CA', N'06037', N'91355', 10.170488, -68.001121, 696, 22, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (600, N'Cedars-Sinai Medical Center', 1, NULL, NULL, N'050625', NULL, NULL, 0, 877, NULL, N'3104235000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'8700 Beverly Blvd', N'Los Angeles', N'CA', N'06037', N'90048', 34.07693, -118.381118, 597, 22, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (601, N'Twin Cities Community Hospital', 1, NULL, NULL, N'050633', NULL, NULL, 0, 114, NULL, N'8054343500', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1100 Las Tablas Rd', N'Templeton', N'CA', N'06079', N'93465', 35.555328, -120.719589, 686, 34, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (602, N'Pomerado Hospital', 1, NULL, NULL, N'050636', NULL, NULL, 0, 236, NULL, N'8584856511', N'8586134764', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'15615 Pomerado Road', N'Poway', N'CA', N'06073', N'92064', 32.996822, -117.055952, 640, 31, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (603, N'East Los Angeles Doctors Hospital', 1, NULL, NULL, N'050641', NULL, NULL, 0, 127, NULL, N'3232685514', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4060 Whittier Blvd', N'Los Angeles', N'CA', N'06037', N'90023', 34.02384, -118.184178, 597, 22, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (604, N'Usc Kenneth Norris Jr Cancer Hospital', 1, NULL, NULL, N'050660', NULL, NULL, 0, 60, NULL, N'3238653000', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1441 Eastlake Ave', N'Los Angeles', N'CA', N'06037', N'90089', 34.061458, -118.204333, 597, 22, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (605, N'Los Angeles Community Hospital', 1, NULL, NULL, N'050663', NULL, NULL, 0, 180, NULL, N'3232670477', NULL, 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4081 E Olympic Blvd', N'Los Angeles', N'CA', N'06037', N'90023', 34.01898, -118.186335, 597, 22, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (606, N'Laguna Honda Hospital & Rehabilitation Center', 1, NULL, NULL, N'050668', NULL, NULL, 0, 11, NULL, N'4157592300', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'375 Laguna Honda Blvd', N'San Francisco', N'CA', N'06075', N'94116', 37.750113, -122.460637, 657, 32, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (607, N'Kaiser Foundation Hosp So Sacramento', 1, NULL, NULL, N'050674', NULL, NULL, 0, 223, NULL, N'9166882000', N'9166277015', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6600 Bruceville Road', N'Sacramento', N'CA', N'06067', N'95823', 38.471952, -121.42276, 650, 28, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (608, N'Kaiser Foundation Hospital - Woodland Hills', 1, NULL, NULL, N'050677', NULL, NULL, 0, 218, NULL, N'8187193800', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5601 De Soto', N'Woodland Hills', N'CA', N'06037', N'91367', 34.168339, -118.60592, 517, 22, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (609, N'Orange Coast Memorial Medical Center', 1, NULL, NULL, N'050678', NULL, NULL, 0, 210, NULL, N'7143787406', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'9920 Talbert Avenue', N'Fountain Valley', N'CA', N'06059', N'92708', 33.701578, -117.955682, 554, 17, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (610, N'Northbay Vacavalley Hospital', 1, NULL, NULL, N'050680', NULL, NULL, 0, 50, NULL, N'7076247000', N'7076247002', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1000 Nut Tree Road', N'Vacaville', N'CA', N'06095', N'95688', 38.367197, -121.955222, 695, 20, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (611, N'Menifee Valley Medical Center', 1, NULL, NULL, N'050684', NULL, NULL, 0, 84, NULL, N'9516798888', N'9517666419', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'28400 Mccall B0ulevard', N'Sun City', N'CA', N'06065', N'92585', 33.701022, -117.202787, 716, 30, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (612, N'Kaiser Foundation Hospital Riverside', 1, NULL, NULL, N'050686', NULL, NULL, 0, 215, NULL, N'9513532000', N'9513534611', 1, 1, 0, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'10800 Magnolia Avenue', N'Riverside', N'CA', N'06065', N'92505', 33.906875, -117.470094, 648, 30, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (613, N'Saint Louise Regional Hospital', 1, NULL, NULL, N'050688', NULL, NULL, 0, 93, NULL, N'4088482000', NULL, 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'9400 No Name Uno', N'Gilroy', N'CA', N'06085', N'95020', 37.036542, -121.573714, 561, 33, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (614, N'San Ramon Regional Medical Ctr', 1, NULL, NULL, N'050689', NULL, NULL, 0, 123, NULL, N'9252759200', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6001 Norris Canyon Road', N'San Ramon', N'CA', N'06013', N'94583', 37.77392, -121.966389, 715, 20, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (615, N'Kaiser Foundation Hospital-Santa Rosa', 1, NULL, NULL, N'050690', NULL, NULL, 0, 173, NULL, N'7075714000', N'7075714693', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'401 Bicentennial Way', N'Santa Rosa', N'CA', N'06097', N'95403', 38.470134, -122.725347, 671, 38, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (616, N'Keck Hospital Of Usc', 1, NULL, NULL, N'050696', NULL, NULL, 0, 285, NULL, N'3234428656', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1500 San Pablo St', N'Los Angeles', N'CA', N'06037', N'90033', 34.062618, -118.202928, 597, 22, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (617, N'Patients'' Hospital Of Redding', 1, NULL, NULL, N'050697', NULL, NULL, 0, 10, NULL, N'5302258700', NULL, 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2900 Eureka Way', N'Redding', N'CA', N'06089', N'96001', 40.58561, -122.416404, 644, 27, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (618, N'Southwest Healthcare System', 1, NULL, NULL, N'050701', NULL, NULL, 0, 218, NULL, N'9516966000', N'9516987721', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'25500 Medical Center Drive', N'Murrieta', N'CA', N'06065', N'92562', 33.557843, -117.184717, 707, 31, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (619, N'Mission Community Hospital', 1, NULL, NULL, N'050704', NULL, NULL, 0, 96, NULL, N'8189043100', N'8183048646', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'14850 Roscoe Blvd', N'Panorama City', N'CA', N'06037', N'91402', 34.221399, -118.456399, 629, 22, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (620, N'Fresno Surgical Hospital', 1, NULL, NULL, N'050708', NULL, NULL, 0, 31, NULL, N'5594318000', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6125 North Fresno St', N'Fresno', N'CA', N'06019', N'93710', 36.825275, -119.781424, 556, 21, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (621, N'Desert Valley Hospital', 1, NULL, NULL, N'050709', NULL, NULL, 0, 148, NULL, N'7602418000', NULL, 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'16850 Bear Valley Rd', N'Victorville', N'CA', N'06071', N'92395', 34.471333, -117.279284, 700, 30, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (622, N'Kaiser Foundation Hospital - Fresno', 1, NULL, NULL, N'050710', NULL, NULL, 0, 169, NULL, N'5594484500', NULL, 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7300 North Fresno St', N'Fresno', N'CA', N'06019', N'93720', 36.843237, -119.783574, 556, 21, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (623, N'Sutter Maternity & Surgery Center Of Santa Cruz', 1, NULL, NULL, N'050714', NULL, NULL, 0, 30, NULL, N'8314772200', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2900 Chanticleer Avenue', N'Santa Cruz', N'CA', N'06087', N'95065', 36.987702, -121.978125, 667, 37, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (624, N'Lac/Rancho Los Amigos National Rehabilitation  Ctr', 1, NULL, NULL, N'050717', NULL, NULL, 0, 395, NULL, N'5624017022', NULL, 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7601 East Imperial Highway', N'Downey', N'CA', N'06059', N'90242', 33.927111, -118.158005, 540, 22, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (625, N'Kaiser Foundation Hospital - Baldwin Park', 1, NULL, NULL, N'050723', NULL, NULL, 0, 269, NULL, N'6268511011', N'6264056281', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1011 Baldwin Park Blvd', N'Baldwin Park', N'CA', N'06037', N'91706', 34.065607, -117.985846, 705, 22, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (626, N'Bakersfield Heart Hospital', 1, NULL, NULL, N'050724', NULL, NULL, 0, 47, NULL, N'6613166000', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3001 Sillect Avenue', N'Bakersfield', N'CA', N'06029', N'93308', 35.38606, -119.043017, 505, 18, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (627, N'Stanislaus Surgical Hospital', 1, NULL, NULL, N'050726', NULL, NULL, 0, 23, NULL, N'2095722700', NULL, 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1421 Oakdale Road', N'Modesto', N'CA', N'06099', N'95355', 37.639097, -120.996878, 608, 23, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (628, N'Community Hospital Of Long Beach', 1, NULL, NULL, N'050727', NULL, NULL, 0, 258, NULL, N'5624940600', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1720 Termino Avenue', N'Long Beach', N'CA', N'06037', N'90804', 33.7889, -118.144898, 595, 22, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (629, N'Fresno Heart And Surgical Hospital', 1, NULL, NULL, N'050732', NULL, NULL, 0, 57, NULL, N'5594338000', NULL, 1, 0, 0, 0, 0, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'15 East Audubon Drive', N'Fresno', N'CA', N'06019', N'93720', 36.860959, -119.791039, 556, 21, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (630, N'Whittier Hospital Medical Center', 1, NULL, NULL, N'050735', NULL, NULL, 0, 178, NULL, N'5629453561', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'9080 Colima Rd', N'Whittier', N'CA', N'06037', N'90605', 33.92152, -118.025297, 706, 22, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (631, N'Monterey Park Hospital', 1, NULL, NULL, N'050736', NULL, NULL, 0, 102, NULL, N'6265709000', N'6262814719', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'900 S Atlantic Blvd', N'Monterey Park', N'CA', N'06037', N'91754', 34.061122, -118.133911, 611, 22, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (632, N'Garfield Medical Center', 1, NULL, NULL, N'050737', NULL, NULL, 0, 210, NULL, N'6265732222', N'6265718972', 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'525 N Garfield Ave', N'Monterey Park', N'CA', N'06037', N'91754', 34.051216, -118.129229, 611, 22, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (633, N'Greater El Monte Community Hospital', 1, NULL, NULL, N'050738', NULL, NULL, 0, 104, NULL, N'6263507975', N'6263500368', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1701 Santa Anita Ave', N'South El Monte', N'CA', N'06037', N'91733', 34.048139, -118.043412, 678, 22, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (634, N'Centinela Hospital Medical Center', 1, NULL, NULL, N'050739', NULL, NULL, 0, 346, NULL, N'3106734660', NULL, 1, 1, 0, 0, 0, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'555 East Hardy Street', N'Inglewood', N'CA', N'06037', N'90301', 33.949173, -118.348192, 578, 22, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (635, N'Marina Del Rey Hospital', 1, NULL, NULL, N'050740', NULL, NULL, 0, 145, NULL, N'3108238911', NULL, 1, 1, 0, 0, 0, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4650 Lincoln Blvd', N'Marina Del Rey', N'CA', N'06037', N'90291', 33.981085, -118.439428, 669, 22, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (636, N'Olympia Medical Center', 1, NULL, NULL, N'050742', NULL, NULL, 0, 204, NULL, N'3106575900', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5900 West Olympic Boulevard', N'Los Angeles', N'CA', N'06037', N'90036', 34.057463, -118.360021, 597, 22, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (637, N'Western Medical Center  Anaheim', 1, NULL, NULL, N'050744', NULL, NULL, 0, 188, NULL, N'7145336220', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1025 S Anaheim Blvd', N'Anaheim', N'CA', N'06059', N'92805', 33.824213, -117.910156, 497, 17, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (638, N'Chapman Medical Center', 1, NULL, NULL, N'050745', NULL, NULL, 0, 84, NULL, N'7146330011', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2601 E Chapman Ave', N'Orange', N'CA', N'06059', N'92869', 33.787884, -117.824444, 625, 17, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (639, N'Western Medical Center Santa Ana', 1, NULL, NULL, N'050746', NULL, NULL, 0, 282, NULL, N'7149533331', N'7149533613', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1001 North Tustin Avenue', N'Santa Ana', N'CA', N'06059', N'92705', 33.769548, -117.835759, 665, 17, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (640, N'Coastal Communities Hospital', 1, NULL, NULL, N'050747', NULL, NULL, 0, 178, NULL, N'7147545454', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2701 S Bristol St', N'Santa Ana', N'CA', N'06059', N'92704', 33.751499, -117.885108, 554, 17, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (641, N'Kaiser Foundation Hospital Manteca', 1, NULL, NULL, N'050748', NULL, NULL, 0, 224, NULL, N'2098253700', N'2098253524', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1777 West Yosemite Ave', N'Manteca', N'CA', N'06077', N'95337', 37.798618, -121.211715, 602, 39, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (642, N'Miracle Mile Medical Center', 1, NULL, NULL, N'050751', NULL, NULL, 0, 17, NULL, N'3239301040', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6000 San Vicente Blvd', N'Los Angeles', N'CA', N'06037', N'90036', 34.057307, -118.362073, 597, 22, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (643, N'Menlo Park Surgical Hospital', 1, NULL, NULL, N'050754', NULL, NULL, 0, 16, NULL, N'6503248500', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'570 Willow Road', N'Menlo Park', N'CA', N'06081', N'94025', 37.48215, -122.150378, 682, 35, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (644, N'Sherman Oaks Hospital', 1, NULL, NULL, N'050755', NULL, NULL, 0, 153, NULL, N'8189817111', N'8185015316', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4929 Van Nuys Blvd', N'Sherman Oaks', N'CA', N'06037', N'91403', 34.159986, -118.448796, 698, 22, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (645, N'Alvarado Hospital Medical Center', 1, NULL, NULL, N'050757', NULL, NULL, 0, 311, NULL, N'6192293172', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6655 Alvarado Road', N'San Diego', N'CA', N'06073', N'92120', 32.776095, -117.057405, 655, 31, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (646, N'Montclair Hospital Medical Center', 1, NULL, NULL, N'050758', NULL, NULL, 0, 102, NULL, N'9096258300', N'9096264777', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5000 San Bernardino St', N'Montclair', N'CA', N'06071', N'91763', 34.077755, -117.696381, 637, 22, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (647, N'Kaiser Foundation Hospital - Antioch', 1, NULL, NULL, N'050760', NULL, NULL, 0, 150, NULL, N'9258136500', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4501 Sand Creek Road', N'Antioch', N'CA', N'06013', N'94531', 38.004921, -121.805789, 498, 20, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (648, N'Providence Tarzana Medical Center', 1, NULL, NULL, N'050761', NULL, NULL, 0, 245, NULL, N'8188810800', N'8187085382', 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'18321 Clark Street', N'Tarzana', N'CA', N'06037', N'91356', 34.169856, -118.533042, 685, 22, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (649, N'Silver Lake Medical Center', 1, NULL, NULL, N'050763', NULL, NULL, 0, 187, NULL, N'2139896123', NULL, 1, 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1711 West Temple Street', N'Los Angeles', N'CA', N'06037', N'90026', 34.055791, -118.243678, 597, 22, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (650, N'Shasta Regional Medical Center', 1, NULL, NULL, N'050764', NULL, NULL, 0, 246, NULL, N'5302445454', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1100 Butte St', N'Redding', N'CA', N'06089', N'96001', 40.585343, -122.387061, 644, 27, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (651, N'Kaiser Foundation Hospital-Moreno Valley', 1, NULL, NULL, N'050765', NULL, NULL, 0, 101, NULL, N'9512510811', N'9512512005', 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'27300 Iris Avenue', N'Moreno Valley', N'CA', N'06065', N'92555', 33.897335, -117.186014, 648, 30, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (652, N'Sutter Surgical Hospital - North Valley', 1, NULL, NULL, N'050766', NULL, NULL, 0, 14, NULL, N'5307495700', N'5307495720', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'455 Plumas Blvd', N'Yuba City', N'CA', N'06101', N'95991', 39.133241, -121.614205, 711, 28, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (653, N'Kaiser Foundation Hospital - Vacaville', 1, NULL, NULL, N'050767', NULL, NULL, 0, 72, NULL, N'7076244000', N'7076242051', 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'1 Quality Drive', N'Vacaville', N'CA', N'06095', N'95688', 38.376044, -121.99547, 695, 20, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (654, N'Hoag Orthopedic Institute', 1, NULL, NULL, N'050769', NULL, NULL, 0, 70, NULL, N'9497275000', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'16250 Sand Canyon Avenue', N'Irvine', N'CA', N'06059', N'92618', 33.66228, -117.773239, 665, 17, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (655, N'Loma Linda University Medical Center-Murrieta', 1, NULL, NULL, N'050770', NULL, NULL, 0, 106, NULL, N'9512904000', N'9516723366', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'28062 Baxter Road', N'Murrieta', N'CA', N'06065', N'92563', 33.613558, -117.169616, 707, 31, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (656, N'Coast Plaza Hospital', 1, NULL, NULL, N'050771', NULL, NULL, 0, 117, NULL, N'3103560550', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'13100 Studerbaker Road', N'Norwalk', N'CA', N'06037', N'90650', 33.90928, -118.084917, 619, 22, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (657, N'Kaiser Foundation Hospital - Roseville', 1, NULL, NULL, N'050772', NULL, NULL, 0, 340, NULL, N'9167844000', NULL, 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1600 Eureka Road', N'Roseville', N'CA', N'06061', N'95661', 38.748241, -121.247729, 649, 28, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (658, N'San Leandro Hospital', 1, NULL, NULL, N'050773', NULL, NULL, 0, 10, NULL, N'5103576500', NULL, 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'13855 E 14Th Street', N'San Leandro', N'CA', N'06001', N'94578', 37.715049, -122.14247, 660, 25, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (659, N'Temecula Valley Hospital', 1, NULL, NULL, N'050775', NULL, NULL, 0, 140, NULL, N'9513312200', N'9513312202', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'31700 Temecula Pkwy', N'Temecula', N'CA', N'06065', N'92592', 33.481754, -117.095532, 707, 31, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (660, N'College Medical Center', 1, NULL, NULL, N'050776', NULL, NULL, 0, 157, NULL, N'5625951911', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2776 Pacific Avenue', N'Long Beach', N'CA', N'06037', N'90806', 33.807536, -118.193604, 595, 22, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (661, N'Kaiser Foundation Hospital - San Leandro', 1, NULL, NULL, N'050777', NULL, NULL, 0, 108, NULL, N'5104541000', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2500 Merced Street', N'San Leandro', N'CA', N'06001', N'94577', 37.706602, -122.164742, 660, 25, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (662, N'Eastern Plumas Hospital - Portola Campus', 1, NULL, NULL, N'051300', NULL, NULL, 0, 9, NULL, N'5308324277', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'500 First Avenue', N'Portola', N'CA', N'06063', N'96122', 39.810457, -120.469103, 639, 174, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (663, N'Tehachapi Hospital', 1, NULL, NULL, N'051301', NULL, NULL, 0, 24, NULL, N'6618223241', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'115 West E Street', N'Tehachapi', N'CA', N'06029', N'93561', 35.130036, -118.448282, 505, 18, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (664, N'Southern Inyo Hospital', 1, NULL, NULL, N'051302', NULL, NULL, 0, 25, NULL, N'7608765501', NULL, 1, 1, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'501 East Locust Street', N'Lone Pine', N'CA', N'06027', N'93545', 36.608412, -118.057999, 594, 173, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (665, N'Mammoth Hospital', 1, NULL, NULL, N'051303', NULL, NULL, 0, 17, NULL, N'7609343311', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'85 Sierra Park Road Po Box 660', N'Mammoth Lakes', N'CA', N'06051', N'93546', 37.643253, -118.966851, 601, 174, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (666, N'John C Fremont Healthcare District', 1, NULL, NULL, N'051304', NULL, NULL, 0, 34, NULL, N'2099663631', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5189 Hospital Road', N'Mariposa', N'CA', N'06043', N'95338', 37.503736, -119.97725, 605, 23, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (667, N'Mayers Memorial Hospital', 1, NULL, NULL, N'051305', NULL, NULL, 0, 121, NULL, N'5303365511', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'43563 Hwy 299 East', N'Fall River Mills', N'CA', N'06089', N'96028', 41.004608, -121.438314, 548, 27, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (668, N'Glenn Medical Center', 1, NULL, NULL, N'051306', NULL, NULL, 0, 47, NULL, N'5309341818', N'5309341818', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1133 W Sycamore St', N'Willows', N'CA', N'06021', N'95988', 39.520553, -122.207831, 522, 19, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (669, N'Catalina Island Medical Center', 1, NULL, NULL, N'051307', NULL, NULL, 0, 12, NULL, N'3105100700', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'100 Falls Canyon Road', N'Avalon', N'CA', N'06037', N'90704', 33.339518, -118.333074, 504, 22, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (670, N'Surprise Valley Community Hospital', 1, NULL, NULL, N'051308', NULL, NULL, 0, 26, NULL, N'5302796111', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'741 North Main Street', N'Cedarville', N'CA', N'06049', N'96104', 41.529061, -120.173278, 520, 174, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (671, N'Jerold Phelps Community Hospital', 1, NULL, NULL, N'051309', NULL, NULL, 0, 16, NULL, N'7079233921', N'7079231456', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'733 Cedar St', N'Garberville', N'CA', N'06023', N'95542', 36.701463, -118.755997, 558, 24, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (672, N'Frank R Howard Memorial Hospital', 1, NULL, NULL, N'051310', NULL, NULL, 0, 25, NULL, N'7074596801', N'7074599486', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1 Madrone Street', N'Willits', N'CA', N'06045', N'95490', 39.400808, -123.351156, 708, 24, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (673, N'Biggs Gridley Memorial Hospital', 1, NULL, NULL, N'051311', NULL, NULL, 0, 24, NULL, N'5308465671', NULL, 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'240 Spruce Street', N'Gridley', N'CA', N'06007', N'95948', 39.365697, -121.697265, 568, 28, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (674, N'Mountains Community Hospital', 1, NULL, NULL, N'051312', NULL, NULL, 0, 17, NULL, N'9093363651', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'29101 Hospital Road', N'Lake Arrowhead', N'CA', N'06071', N'92352', 34.248968, -117.191332, 653, 30, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (675, N'Kern Valley Healthcare District', 1, NULL, NULL, N'051314', NULL, NULL, 0, 27, NULL, N'7603792681', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6412 Laurel Ave', N'Lake Isabella', N'CA', N'06029', N'93240', 36.701463, -118.755997, 585, 18, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (676, N'Trinity Hospital', 1, NULL, NULL, N'051315', NULL, NULL, 0, 25, NULL, N'5306235541', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'60 Easter Avenue', N'Weaverville', N'CA', N'06105', N'96093', 40.737481, -122.948533, 704, 27, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (677, N'Fairchild Medical Center', 1, NULL, NULL, N'051316', NULL, NULL, 0, 28, NULL, N'5308424121', N'5308410913', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'444 Bruce Street', N'Yreka', N'CA', N'06093', N'96097', 41.718677, -122.646256, 710, 223, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (678, N'St Helena Hospital-Clearlake', 1, NULL, NULL, N'051317', NULL, NULL, 0, 32, NULL, N'7079946486', N'7079953516', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'15630 18Th Ave - Hwy 53', N'Clearlake', N'CA', N'06033', N'95422', 38.958231, -122.626373, 525, 24, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (679, N'Redwood Memorial Hospital', 1, NULL, NULL, N'051318', NULL, NULL, 0, 25, NULL, N'7074458121', N'7077257212', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3300 Renner Drive', N'Fortuna', N'CA', N'06023', N'95540', 40.582664, -124.135334, 553, 27, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (680, N'Mercy Medical Center Mt Shasta', 1, NULL, NULL, N'051319', NULL, NULL, 0, 25, NULL, N'5309266111', NULL, 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'914 Pine Street', N'Mount Shasta', N'CA', N'06093', N'96067', 41.318693, -122.322623, 612, 27, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (681, N'Banner Lassen Medical Center', 1, NULL, NULL, N'051320', NULL, NULL, 0, 38, NULL, N'5302522000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1800 Spring Ridge Drive', N'Susanville', N'CA', N'06035', N'96130', 40.416284, -120.653006, 684, 174, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (682, N'Healdsburg District Hospital', 1, NULL, NULL, N'051321', NULL, NULL, 0, 43, NULL, N'7074316500', N'7074316588', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1375 University Avenue', N'Healdsburg', N'CA', N'06097', N'95448', 38.629836, -122.859002, 573, 38, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (683, N'Colorado River Medical Center', 1, NULL, NULL, N'051323', NULL, NULL, 0, 25, NULL, N'7603264531', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1401 Bailey Ave', N'Needles', N'CA', N'06071', N'92363', 34.830282, -114.618188, 616, 173, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (684, N'Northern Inyo Hospital', 1, NULL, NULL, N'051324', NULL, NULL, 0, 25, NULL, N'7608735811', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'150 Pioneer Lane', N'Bishop', N'CA', N'06027', N'93514', 37.362191, -118.407229, 511, 174, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (685, N'Mendocino Coast District Hospital', 1, NULL, NULL, N'051325', NULL, NULL, 0, 25, NULL, N'7079611234', N'7079614794', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'700 River Dr', N'Fort Bragg', N'CA', N'06045', N'95437', 39.430917, -123.800681, 552, 24, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (686, N'Plumas District Hospital', 1, NULL, NULL, N'051326', NULL, NULL, 0, 26, NULL, N'5302832121', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1065 Bucks Lake Road', N'Quincy', N'CA', N'06063', N'95971', 39.936836, -120.947176, 641, 174, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (687, N'Seneca District Hospital', 1, NULL, NULL, N'051327', NULL, NULL, 0, 26, NULL, N'5302582121', NULL, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'130 Brentwood Drive', N'Chester', N'CA', N'06063', N'96020', 40.305474, -121.234647, 521, 19, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (688, N'Tahoe Forest Hospital', 1, NULL, NULL, N'051328', NULL, NULL, 0, 72, NULL, N'5305876011', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'10121 Pine Ave', N'Truckee', N'CA', N'06057', N'96161', 39.324832, -120.200949, 690, 174, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (689, N'Sutter Lakeside Hospital', 1, NULL, NULL, N'051329', NULL, NULL, 0, 30, NULL, N'7072625000', N'7072625003', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5176 Hill Road East', N'Lakeport', N'CA', N'06033', N'95453', 39.042951, -122.915829, 586, 24, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (690, N'Modoc Medical Center', 1, NULL, NULL, N'051330', NULL, NULL, 0, 16, NULL, N'5302335131', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'228 W Mcdowell Ave', N'Alturas', N'CA', N'06049', N'96101', 41.479893, -120.546067, 496, 174, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (691, N'Santa Ynez Valley Cottage Hospital', 1, NULL, NULL, N'051331', NULL, NULL, 0, 10, NULL, N'8056886431', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2050 Viborg Rd', N'Solvang', N'CA', N'06083', N'93463', 34.602384, -120.127327, 675, 36, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (692, N'Mark Twain Medical Center', 1, NULL, NULL, N'051332', NULL, NULL, 0, 25, NULL, N'2097542515', N'2097542626', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'768 Mountain Ranch Rd', N'San Andreas', N'CA', N'06009', N'95249', 38.19603, -120.680487, 652, 39, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (693, N'Ridgecrest Regional Hospital', 1, NULL, NULL, N'051333', NULL, NULL, 0, 98, NULL, N'7604463551', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1081 North China Lake Blvd', N'Ridgecrest', N'CA', N'06029', N'93555', 35.641292, -117.67115, 647, 30, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (694, N'Ojai Valley Community Hospital', 1, NULL, NULL, N'051334', NULL, NULL, 0, 110, NULL, N'8056402280', N'8056401051', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1306 Maricopa Hwy', N'Ojai', N'CA', N'06111', N'93023', 34.442822, -119.266675, 624, 40, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (695, N'Bear Valley Community Hospital', 1, NULL, NULL, N'051335', NULL, NULL, 0, 30, NULL, N'9098666501', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'41870 Garstin Dr', N'Big Bear Lake', N'CA', N'06071', N'92315', 34.246375, -116.889735, 510, 30, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (696, N'Sunland Home Corporation', 1, NULL, NULL, N'051990', NULL, NULL, 0, 20, NULL, N'7609442976', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'691 Sparta Drive', N'Encinitas', N'CA', N'06073', N'92024', 33.070119, -117.291337, 543, 31, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (697, N'Broadview Inc', 1, NULL, NULL, N'051991', NULL, NULL, 0, 42, NULL, N'2132219174', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'4570 Griffin Avenue', N'Los Angeles', N'CA', N'06037', N'90031', 34.095478, -118.201709, 597, 22, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (698, N'Arden Wood Inc', 1, NULL, NULL, N'051993', NULL, NULL, 0, 13, NULL, N'4156815500', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'445 Wawona Street', N'San Francisco', N'CA', N'06075', N'94116', 37.736991, -122.47235, 657, 32, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (699, N'Fern Lodge Inc', 1, NULL, NULL, N'051994', NULL, NULL, 0, 28, NULL, N'5108862448', N'5108865992', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'18457 Madison Avenue', N'Castro Valley', N'CA', N'06001', N'94546', 37.712175, -122.063529, 519, 25, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (700, N'Barlow Respiratory Hospital', 1, NULL, NULL, N'052031', NULL, NULL, 0, 99, NULL, N'2132504200', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2000 Stadium Way', N'Los Angeles', N'CA', N'06037', N'90026', 34.07523, -118.248275, 597, 22, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (701, N'Kindred - Los Angeles', 1, NULL, NULL, N'052032', NULL, NULL, 0, 81, NULL, N'3106420325', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5525  W Slauson Avenue', N'Los Angeles', N'CA', N'06037', N'90056', 33.989053, -118.378361, 597, 22, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (702, N'Vibra Hospital Of Sacramento', 1, NULL, NULL, N'052033', NULL, NULL, 0, 58, NULL, N'9163519151', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'330 Montrose Drive', N'Folsom', N'CA', N'06067', N'95630', 38.681583, -121.158175, 550, 28, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (703, N'Kindred Hospital - San Francisco Bay Area', 1, NULL, NULL, N'052034', NULL, NULL, 0, 99, NULL, N'5103578300', N'5103571284', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2800 Benedict Drive', N'San Leandro', N'CA', N'06001', N'94577', 37.716124, -122.131164, 660, 25, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (704, N'Kindred Hospital Westminster', 1, NULL, NULL, N'052035', NULL, NULL, 0, 109, NULL, N'7148934541', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'200 Hospital Circle', N'Westminster', N'CA', N'06059', N'92683', 33.762847, -117.995912, 554, 17, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (705, N'Kindred Hospital - San Diego', 1, NULL, NULL, N'052036', NULL, NULL, 0, 70, NULL, N'6195434500', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1940 El Cajon Blvd', N'San Diego', N'CA', N'06073', N'92104', 32.755333, -117.144471, 655, 31, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (706, N'Kindred Hospital Ontario', 1, NULL, NULL, N'052037', NULL, NULL, 0, 91, NULL, N'9093910333', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'550 North Monterey', N'Ontario', N'CA', N'06071', N'91764', 34.063344, -117.650888, 694, 30, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (707, N'Kindred Hospital -- La Mirada', 1, NULL, NULL, N'052038', NULL, NULL, 0, 277, NULL, N'5629441900', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'14900 E Imperial Hwy', N'La Mirada', N'CA', N'06037', N'90637', 33.91704, -118.012757, 706, 22, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (708, N'Kindred Hospital Brea', 1, NULL, NULL, N'052039', NULL, NULL, 0, 48, NULL, N'7145296842', NULL, 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'875 N Brea Blvd', N'Brea', N'CA', N'06059', N'92821', 33.93411, -117.893402, 557, 17, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (709, N'Kentfield Rehabilitation & Specialty Hospital', 1, NULL, NULL, N'052043', NULL, NULL, 0, 60, NULL, N'4154569680', N'4154853622', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1125 Sir Francis Drake Blvd', N'Kentfield', N'CA', N'06041', N'94904', 37.953646, -122.543499, 566, 32, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (710, N'Vibra Hospital Of San Diego', 1, NULL, NULL, N'052044', NULL, NULL, 0, 88, NULL, N'6192608300', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'555 Washington Street', N'San Diego', N'CA', N'06073', N'92103', 32.749886, -117.159742, 655, 31, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (711, N'Kindred Hospital Baldwin Park', 1, NULL, NULL, N'052045', NULL, NULL, 0, 95, NULL, N'6263882700', N'8558375738', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'14148 East Francisquito Avenue', N'Baldwin Park', N'CA', N'06037', N'91706', 34.080332, -117.966214, 705, 22, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (712, N'Promise Hospital Of East Los Angeles', 1, NULL, NULL, N'052046', NULL, NULL, 0, 177, NULL, N'3232611181', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'443 South Soto Street', N'Los Angeles', N'CA', N'06037', N'90033', 34.053717, -118.242727, 597, 22, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (713, N'Vibra Hospital Of Northern California', 1, NULL, NULL, N'052047', NULL, NULL, 0, 56, NULL, N'5302469000', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2801 Eureka Way', N'Redding', N'CA', N'06089', N'96001', 40.585634, -122.413093, 644, 27, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (714, N'Kindred Hospital Rancho', 1, NULL, NULL, N'052049', NULL, NULL, 0, 55, NULL, N'9095816400', N'9095816418', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'10841 White Oak Avenue', N'Rancho Cucamonga', N'CA', N'06071', N'91730', 34.104628, -117.566327, 694, 30, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (715, N'Kindred Hospital South Bay', 1, NULL, NULL, N'052050', NULL, NULL, 0, 58, NULL, N'3103235330', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'1246 West 155Th Street', N'Gardena', N'CA', N'06037', N'90247', 33.890425, -118.29743, 560, 22, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (716, N'Promise Hospital Of San Diego', 1, NULL, NULL, N'052051', NULL, NULL, 0, 100, NULL, N'6195823800', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5550 University Avenue', N'San Diego', N'CA', N'06073', N'92105', 32.749642, -117.076557, 655, 31, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (717, N'Kindred Hospital Riverside', 1, NULL, NULL, N'052052', NULL, NULL, 0, 40, NULL, N'9514363535', N'9516573968', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2224 Medical Center Drive', N'Perris', N'CA', N'06065', N'92571', 33.810388, -117.221822, 648, 30, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (718, N'Monrovia Memorial Hospital', 1, NULL, NULL, N'052054', NULL, NULL, 0, 49, NULL, N'6263599341', N'6264089809', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'323 South Heliotrope Avenue', N'Monrovia', N'CA', N'06037', N'91016', 34.149097, -117.992276, 500, 22, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (719, N'Casa Colina Hosp For Rehab Medicine', 1, NULL, NULL, N'053027', NULL, NULL, 0, 68, NULL, N'9095967733', N'9095967845', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'255 E Bonita Ave', N'Pomona', N'CA', N'06037', N'91767', 34.096136, -117.735373, 637, 22, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (720, N'Healthsouth Bakersfield Rehabilitation Hospital', 1, NULL, NULL, N'053031', NULL, NULL, 0, 60, NULL, N'6613235500', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5001 Commerce Drive', N'Bakersfield', N'CA', N'06029', N'93309', 35.367704, -119.058309, 505, 18, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (721, N'San Joaquin Valley Rehabilitation Hosp', 1, NULL, NULL, N'053032', NULL, NULL, 0, 62, NULL, N'5594363600', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7173 N Sharon Avenue', N'Fresno', N'CA', N'06019', N'93720', 36.839921, -119.759616, 556, 21, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (722, N'Healthsouth Tustin Rehabilitation Hospital', 1, NULL, NULL, N'053034', NULL, NULL, 0, 117, NULL, N'7148329200', NULL, 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'14851 Yorba Street', N'Tustin', N'CA', N'06059', N'92780', 33.75314, -117.830294, 665, 17, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (723, N'Ballard Rehabilitation Hospital', 1, NULL, NULL, N'053037', NULL, NULL, 0, 60, NULL, N'9094731275', NULL, 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1760 West 16Th St', N'San Bernardino', N'CA', N'06071', N'92411', 34.128713, -117.325062, 653, 30, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (724, N'Childrens Hospital Central California', 1, NULL, NULL, N'053300', NULL, NULL, 0, 348, NULL, N'5593535116', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'9300 Valley Childrens Place', N'Madera', N'CA', N'06019', N'93636', 36.892822, -119.794335, 600, 21, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (725, N'Children''s Hospital & Research Center Oakland', 1, NULL, NULL, N'053301', NULL, NULL, 0, 190, NULL, N'5104283000', NULL, 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'747 52Nd Street', N'Oakland', N'CA', N'06001', N'94609', 37.837244, -122.268071, 622, 25, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (726, N'Children''s Hosp Of Los Angeles', 1, NULL, NULL, N'053302', NULL, NULL, 0, 568, NULL, N'3236692164', N'3233614002', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4650 Sunset Blvd', N'Los Angeles', N'CA', N'06037', N'90027', 34.098073, -118.290687, 597, 22, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (727, N'Rady Children''s Hospital - San Diego', 1, NULL, NULL, N'053303', NULL, NULL, 0, 518, NULL, N'8585761700', N'8589668590', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3020 Childrens Way', N'San Diego', N'CA', N'06073', N'92123', 32.798648, -117.150897, 655, 31, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (728, N'Children''s Hospital Of Orange County', 1, NULL, NULL, N'053304', NULL, NULL, 0, 192, NULL, N'7149973000', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1201 W La Veta Ave', N'Orange', N'CA', N'06059', N'92868', 33.780405, -117.865987, 625, 17, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (729, N'Lucile Salter Packard Children''s Hsp At Stanford', 1, NULL, NULL, N'053305', NULL, NULL, 0, 287, NULL, N'6504978000', NULL, 1, 0, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'725 Welch Road', N'Palo Alto', N'CA', N'06085', N'94304', 37.435679, -122.175119, 682, 35, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (730, N'Children''s Hospital At Mission', 1, NULL, NULL, N'053306', NULL, NULL, 0, 48, NULL, N'9493652408', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'27700 Medical Center Rd 5Th Floor', N'Mission Viejo', N'CA', N'06059', N'92691', 33.596569, -117.659405, 607, 17, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (731, N'Healthbridge Children''s Hospital - Orange', 1, NULL, NULL, N'053308', NULL, NULL, 0, 6, NULL, N'7142892400', NULL, 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'393 S Tustin Street', N'Orange', N'CA', N'06059', N'92866', 33.783267, -117.835633, 625, 17, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (732, N'Miller Children''s Hospital', 1, NULL, NULL, N'053309', NULL, NULL, 0, 171, NULL, N'5629338001', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2801 Atlantic Avenue', N'Long Beach', N'CA', N'06037', N'90806', 33.807885, -118.18511, 595, 22, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (733, N'Shriners Hospitals For Children', 1, NULL, NULL, N'053310', NULL, NULL, 0, 60, NULL, N'2133883151', N'2133877528', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3160 Geneva Street', N'Los Angeles', N'CA', N'06037', N'90020', 34.067638, -118.286008, 597, 22, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (734, N'Shriners Hospitals For Children Northern Calif', 1, NULL, NULL, N'053311', NULL, NULL, 0, 80, NULL, N'9164532000', N'9164532388', 1, 0, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2425 Stockton Boulevard', N'Sacramento', N'CA', N'06067', N'95817', 38.552889, -121.456107, 650, 28, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (735, N'Resnick Neuropsychiatric Hospital At Ucla', 1, NULL, NULL, N'054009', NULL, NULL, 0, 209, NULL, N'3108256962', N'3102679092', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'150 Medical Plaza', N'Los Angeles', N'CA', N'06037', N'90095', 34.053717, -118.242727, 597, 22, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (736, N'Gateways Hosp  Mental Health Ctr', 1, NULL, NULL, N'054028', NULL, NULL, 0, 55, NULL, N'2136660171', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'1891 Effie St', N'Los Angeles', N'CA', N'06037', N'90026', 34.084502, -118.256752, 597, 22, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (737, N'Bhc Alhambra Hosp', 1, NULL, NULL, N'054032', NULL, NULL, 0, 85, NULL, N'6262861191', N'6262862489', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4619 N Rosemead Blvd', N'Rosemead', N'CA', N'06037', N'91770', 34.067617, -118.087976, 658, 22, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (738, N'Del Amo Hospital', 1, NULL, NULL, N'054053', NULL, NULL, 0, 166, NULL, N'3105301151', NULL, 1, 1, 0, 1, 1, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'23700 Camino Del Sol', N'Torrance', N'CA', N'06037', N'90505', 33.808846, -118.344031, 688, 22, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (739, N'College Hospital', 1, NULL, NULL, N'054055', NULL, NULL, 0, 157, NULL, N'5625951911', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'10802 College Pl', N'Cerritos', N'CA', N'06037', N'90703', 33.88517, -118.102252, 508, 22, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (740, N'Aurora Charter Oak', 1, NULL, NULL, N'054069', NULL, NULL, 0, 95, NULL, N'6269661632', N'6268595292', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1161 E Covina Blvd', N'Covina', N'CA', N'06037', N'91724', 34.099412, -117.88531, 532, 22, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (741, N'St. Helena Hospital Center For Behavioral Health', 1, NULL, NULL, N'054074', NULL, NULL, 0, 61, NULL, N'7076482200', N'7076494014', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'525 Oregon St', N'Vallejo', N'CA', N'06095', N'94590', 38.118363, -122.251037, 697, 32, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (742, N'Alvarado Parkway Institute Behavioral Health Syste', 1, NULL, NULL, N'054075', NULL, NULL, 0, 66, NULL, N'6194654411', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7050 Parkway Drive', N'La Mesa', N'CA', N'06073', N'91942', 32.774583, -117.044143, 583, 31, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (743, N'Aurora Vista Del Mar Hospital', 1, NULL, NULL, N'054077', NULL, NULL, 0, 87, NULL, N'8056536434', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'801 Seneca St', N'Ventura', N'CA', N'06111', N'93001', 34.305606, -119.283792, 699, 40, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (744, N'Aurora Las Encinas Hospital', 1, NULL, NULL, N'054078', NULL, NULL, 0, 118, NULL, N'8662793709', N'6263562503', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'2900 E Del Mar Blvd', N'Pasadena', N'CA', N'06037', N'91107', 34.142204, -118.086027, 632, 22, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (745, N'Kedren Community Mental Health Center', 1, NULL, NULL, N'054083', NULL, NULL, 0, 72, NULL, N'3232330425', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4211 South Avalon Blvd', N'Los Angeles', N'CA', N'06037', N'90011', 33.768494, -118.260906, 597, 22, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (746, N'Sierra Vista Hospital Inc', 1, NULL, NULL, N'054087', NULL, NULL, 0, 72, NULL, N'9164232000', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'8001 Bruceville Road', N'Sacramento', N'CA', N'06067', N'95823', 38.46588, -121.417645, 650, 28, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (747, N'Jewish Home', 1, NULL, NULL, N'054089', NULL, NULL, 0, 13, NULL, N'4153342500', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'302  Silver Ave', N'San Francisco', N'CA', N'06075', N'94112', 37.72861, -122.431122, 657, 32, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (748, N'Loma Linda Behavioral Med Ctr', 1, NULL, NULL, N'054093', NULL, NULL, 0, 89, NULL, N'9095589200', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1710 Barton Road', N'Redlands', N'CA', N'06071', N'92373', 34.04795, -117.21047, 645, 30, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (749, N'Aurora San Diego', 1, NULL, NULL, N'054095', NULL, NULL, 0, 80, NULL, N'8584873200', N'8584855418', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'11878 Avenue Of Industry', N'San Diego', N'CA', N'06073', N'92128', 32.991603, -117.074722, 640, 31, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (750, N'Sutter Center For Psychiatry', 1, NULL, NULL, N'054096', NULL, NULL, 0, 69, NULL, N'9163863000', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7700 Folsom Blvd', N'Sacramento', N'CA', N'06067', N'95826', 38.550749, -121.414928, 650, 28, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (751, N'Heritage Oaks Hospital', 1, NULL, NULL, N'054104', NULL, NULL, 0, 76, NULL, N'9164893336', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4250 Auburn Blvd', N'Sacramento', N'CA', N'06067', N'95841', 38.643411, -121.365456, 518, 28, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (752, N'Fremont Hospital', 1, NULL, NULL, N'054110', NULL, NULL, 0, 96, NULL, N'5107961100', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'39001 Sundale Drive', N'Fremont', N'CA', N'06001', N'94538', 37.546123, -121.979006, 555, 25, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (753, N'Canyon Ridge Hospital', 1, NULL, NULL, N'054111', NULL, NULL, 0, 106, NULL, N'9095903700', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5353 G Street', N'Chino', N'CA', N'06071', N'91710', 34.009856, -117.688262, 523, 30, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (754, N'San Diego County Psychiatric Hospital', 1, NULL, NULL, N'054114', NULL, NULL, 0, 109, NULL, N'6196928211', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3851 Rosecrans St', N'San Diego', N'CA', N'06073', N'92110', 32.753627, -117.202586, 655, 31, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (755, N'Dept Of State Hospitals - Napa', 1, NULL, NULL, N'054122', NULL, NULL, 0, 1362, NULL, N'7072535454', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2100 Napa-Vallejo Highway', N'Napa', N'CA', N'06055', N'94558', 38.269988, -122.271634, 614, 24, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (756, N'St Joseph''s Behavioral Health Center', 1, NULL, NULL, N'054123', NULL, NULL, 0, 35, NULL, N'2094612000', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2510 N  California St', N'Stockton', N'CA', N'06077', N'95204', 37.950653, -121.283779, 683, 39, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (757, N'Sempervirens', 1, NULL, NULL, N'054124', NULL, NULL, 0, 16, NULL, N'7072682990', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'720 Wood St', N'Eureka', N'CA', N'06023', N'95501', 40.78111, -124.160953, 546, 27, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (758, N'Santa Barbara County Psychiatric Health Facility', 1, NULL, NULL, N'054125', NULL, NULL, 0, 16, NULL, N'8056815244', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'315 Camino Del Remedio', N'Santa Barbara', N'CA', N'06083', N'93110', 34.445112, -119.779451, 666, 36, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (759, N'Pacific Grove Hospital', 1, NULL, NULL, N'054130', NULL, NULL, 0, 68, NULL, N'9512758400', N'9517860293', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5900 Brockton Ave', N'Riverside', N'CA', N'06065', N'92506', 33.963008, -117.395259, 648, 30, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (760, N'John Muir Behavioral Health Center', 1, NULL, NULL, N'054131', NULL, NULL, 0, 73, NULL, N'9256744101', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2740 Grant St', N'Concord', N'CA', N'06013', N'94524', 37.986674, -122.039066, 528, 20, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (761, N'Dept Of State Hospitals - Metropolitan - Psy', 1, NULL, NULL, N'054133', NULL, NULL, 0, 1254, NULL, N'5626512245', NULL, 1, 1, 1, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'11400 S Norwalk Blvd', N'Norwalk', N'CA', N'06037', N'90650', 33.90928, -118.084917, 619, 22, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (762, N'Newport Bay Hospital', 1, NULL, NULL, N'054135', NULL, NULL, 0, 34, NULL, N'9496509750', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1501 E 16Th St', N'Newport Beach', N'CA', N'06059', N'92663', 33.617009, -117.92944, 617, 17, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (763, N'Langley Porter Psychiatric Institute', 1, NULL, NULL, N'054144', NULL, NULL, 0, 67, NULL, N'4154767000', N'4154767404', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'401 Parnassus Avenue', N'San Francisco', N'CA', N'06075', N'94143', 37.76323, -122.458407, 657, 32, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (764, N'Sharp Mesa Vista Hospital', 1, NULL, NULL, N'054145', NULL, NULL, 0, 149, NULL, N'8582784110', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7850 Vista Hill Avenue', N'San Diego', N'CA', N'06073', N'92123', 32.795679, -117.155228, 655, 31, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (765, N'Telecare Heritage Psychiatric Health Facility', 1, NULL, NULL, N'054146', NULL, NULL, 0, 26, NULL, N'5105355115', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2633 E 27Th Street Building B', N'Oakland', N'CA', N'06001', N'94601', 37.804456, -122.271356, 622, 25, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (766, N'Joyce Eisenberg Keefer Medical Center', 1, NULL, NULL, N'054147', NULL, NULL, 0, 10, NULL, N'8187743314', N'8187574408', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7150 Tampa Avenue', N'Reseda', N'CA', N'06037', N'91335', 34.200062, -118.553416, 618, 22, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (767, N'Tarzana Treatment Center', 1, NULL, NULL, N'054148', NULL, NULL, 0, 60, NULL, N'8189961051', N'8189963051', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'18646 Oxnard Street', N'Tarzana', N'CA', N'06037', N'91356', 34.179904, -118.539036, 685, 22, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (768, N'Willow Rock Center', 1, NULL, NULL, N'054149', NULL, NULL, 0, 16, NULL, N'5108955502', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'2050 Fairmont Drive', N'San Leandro', N'CA', N'06001', N'94578', 37.703373, -122.125889, 660, 25, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (769, N'Kaiser Permanente Psychiatric Health Facility-Sant', 1, NULL, NULL, N'054150', NULL, NULL, 0, 24, NULL, N'4088514850', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3840 Homestead Road', N'Santa Clara', N'CA', N'06085', N'95051', 37.337835, -121.988497, 659, 33, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (770, N'Aurora Behavioral Healthcare-Santa Rosa Llc', 1, NULL, NULL, N'054151', NULL, NULL, 0, 95, NULL, N'7078007700', N'7078007797', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1287 Fulton Road', N'Santa Rosa', N'CA', N'06097', N'95401', 38.440468, -122.714431, 671, 38, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (771, N'Santa Cruz County Psychiatric Health Facility', 1, NULL, NULL, N'054152', NULL, NULL, 0, 16, NULL, N'8316002801', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2250 Soquel Avenue Suite 150', N'Santa Cruz', N'CA', N'06087', N'95062', 36.97461, -122.029426, 667, 37, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (772, N'Ocean View Psychiatric Health Facility', 1, NULL, NULL, N'054153', NULL, NULL, 0, 20, NULL, N'7146140474', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2600 Redondo Avenue Suite 500', N'Long Beach', N'CA', N'06037', N'90806', 33.777466, -118.188487, 595, 22, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (773, N'Sharp Memorial Hospital-Transplant', 1, NULL, NULL, N'059800', NULL, NULL, 0, 521, NULL, N'8589393400', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'7901 Frost Street', N'San Diego', N'CA', N'06073', N'92123', 32.80017, -117.154197, 655, 31, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (774, N'Cedars-Sinai Medical Center - Transplant Services', 1, NULL, NULL, N'059801', NULL, NULL, 0, 0, NULL, N'3104233277', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'8700 Beverly Boulevard', N'Los Angeles', N'CA', N'06037', N'90048', 34.07693, -118.381118, 597, 22, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (775, N'Western Medical Transplant Center', 1, NULL, NULL, N'059802', NULL, NULL, 0, 0, NULL, N'7148353555', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'1001 North Tustin Avenue', N'Santa Ana', N'CA', N'06059', N'92705', 33.769548, -117.835759, 665, 17, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (776, N'Stanford Hospital Transplant', 1, NULL, NULL, N'059803', NULL, NULL, 0, 0, NULL, N'6507235708', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'300 Pasteur Drive', N'Stanford', N'CA', N'06085', N'94305', 37.433094, -122.174472, 682, 35, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (777, N'Lucile Salter Packard Children''s Hospital At Stanf', 1, NULL, NULL, N'059804', NULL, NULL, 0, 0, NULL, N'6504978705', N'6504978612', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'725 Welch Road', N'Palo Alto', N'CA', N'06085', N'94304', 37.435679, -122.175119, 682, 35, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (778, N'Rady Children''s Hospital San Diego', 1, NULL, NULL, N'059805', NULL, NULL, 0, 0, NULL, N'8585761700', N'8589665815', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'3020 Children''s Way Mail Code 5115', N'San Diego', N'CA', N'06073', N'92123', 32.717421, -117.162771, 655, 31, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (779, N'California Pacific Medical Center', 1, NULL, NULL, N'059806', NULL, NULL, 0, 0, NULL, N'4156001522', N'4156006575', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'2333 Buchanan Street', N'San Francisco', N'CA', N'06075', N'94115', 37.7905, -122.432309, 657, 32, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (780, N'University Of California San Francisco', 1, NULL, NULL, N'059807', NULL, NULL, 0, 0, NULL, N'4153539162', N'4153538645', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'505 Parnassus Avenue', N'San Francisco', N'CA', N'06075', N'94143', 37.763513, -122.457805, 657, 32, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (781, N'University Of California Davis Medical Center', 1, NULL, NULL, N'059808', NULL, NULL, 0, 0, NULL, N'9167345693', N'9167347945', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'2315 Stockton Blvd Rm 1018', N'Sacramento', N'CA', N'06067', N'95817', 38.581572, -121.4944, 650, 28, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (782, N'Sutter Memorial Hospital', 1, NULL, NULL, N'059809', NULL, NULL, 0, 0, NULL, N'9167338133', N'9167331967', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'5151 F Street 1 South', N'Sacramento', N'CA', N'06067', N'95819', 38.581572, -121.4944, 650, 28, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (783, N'University Of California San Diego Medical Center', 1, NULL, NULL, N'059810', NULL, NULL, 0, 0, NULL, N'6195748612', N'6192987985', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'200 West Arbor Drive #8745', N'San Diego', N'CA', N'06073', N'92103', 32.717421, -117.162771, 655, 31, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (784, N'University Of California Irvine Medical Center', 1, NULL, NULL, N'059811', NULL, NULL, 0, 0, NULL, N'7144565841', N'7144568441', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'101 The City Drive', N'Orange', N'CA', N'06059', N'92868', 33.783338, -117.888781, 625, 17, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (785, N'Ronald Reagan Ucla Medical Center - Transplant Svs', 1, NULL, NULL, N'059812', NULL, NULL, 0, 0, NULL, N'3108255041', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'757 Westwood Plaza', N'Los Angeles', N'CA', N'06037', N'90095', 34.066465, -118.446507, 597, 22, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (786, N'Children''s Hospital Of Los Angeles', 1, NULL, NULL, N'059813', NULL, NULL, 0, 0, NULL, N'3233615954', N'3233713612', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'4650 Sunset Blvd Ms#72', N'Los Angeles', N'CA', N'06037', N'90027', 34.053717, -118.242727, 597, 22, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (787, N'Loma Linda University Medical Center Transplant I', 1, NULL, NULL, N'059814', NULL, NULL, 0, 0, NULL, N'9095588068', N'9095580702', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'11234 Anderson Street', N'Loma Linda', N'CA', N'06071', N'92354', 34.049664, -117.261229, 592, 30, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (788, N'Green Hospital Of Scripps Clinic', 1, NULL, NULL, N'059815', NULL, NULL, 0, 0, NULL, N'8585544310', N'8585544311', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'10666 North Torrey Pines Road', N'La Jolla', N'CA', N'06073', N'92037', 32.870564, -117.242784, 582, 31, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (789, N'St Joseph Hospital', 1, NULL, NULL, N'059816', NULL, NULL, 0, 0, NULL, N'7147718087', N'7147448636', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'1100 Stewart Drive', N'Orange', N'CA', N'06059', N'92868', 33.787855, -117.853091, 625, 17, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (790, N'Riverside Community Hospital', 1, NULL, NULL, N'059817', NULL, NULL, 0, 0, NULL, N'9516841415', N'9517886107', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'4445 Magnolia Avenue', N'Riverside', N'CA', N'06065', N'92501', 33.976257, -117.378381, 648, 30, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (791, N'Lac Harbor-Ucla Medical Center', 1, NULL, NULL, N'059818', NULL, NULL, 0, 0, NULL, N'3102222155', N'3103289624', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'1000 W Carson Street', N'Torrance', N'CA', N'06037', N'90509', 33.831502, -118.292216, 688, 22, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (792, N'Keck Hospital Of Usc', 1, NULL, NULL, N'059819', NULL, NULL, 0, 0, NULL, N'3234425901', N'3234427515', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'1500 San Pablo Street', N'Los Angeles', N'CA', N'06037', N'90033', 34.062618, -118.202928, 597, 22, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (793, N'Saint Vincent Medical Center - Transplant Center', 1, NULL, NULL, N'059820', NULL, NULL, 0, 0, NULL, N'2132075681', N'2134845588', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'2131 W Third Street', N'Los Angeles', N'CA', N'06037', N'90057', 34.053717, -118.242727, 597, 22, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (794, N'North Colorado Medical Center', 1, NULL, NULL, N'060001', NULL, NULL, 0, 378, NULL, N'9703524121', N'9703506644', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1801 16Th Street', N'Greeley', N'CO', N'08123', N'80631', 40.413916, -104.707695, 738, 46, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (795, N'Longmont United Hospital', 1, NULL, NULL, N'060003', NULL, NULL, 0, 186, NULL, N'3036515111', N'3036784050', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1950 Mountain View Avenue', N'Longmont', N'CO', N'08013', N'80501', 40.181409, -105.12751, 749, 41, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (796, N'Platte Valley Medical Center', 1, NULL, NULL, N'060004', NULL, NULL, 0, 98, NULL, N'3034981601', N'3034981608', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1600 Prairie Center Parkway', N'Brighton', N'CO', N'08001', N'80601', 39.964658, -104.768522, 721, 43, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (797, N'Montrose Memorial Hospital', 1, NULL, NULL, N'060006', NULL, NULL, 0, 75, NULL, N'9702492211', N'9702522525', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'800 S 3Rd St', N'Montrose', N'CO', N'08085', N'81401', 38.480111, -107.869737, 752, 45, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (798, N'San Luis Valley Health', 1, NULL, NULL, N'060008', NULL, NULL, 0, 59, NULL, N'7195892511', N'7195871372', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'106 Blanca Ave', N'Alamosa', N'CO', N'08003', N'81101', 37.471714, -105.883398, 717, 42, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (799, N'Lutheran Medical Center', 1, NULL, NULL, N'060009', NULL, NULL, 0, 364, NULL, N'3034254500', N'3034258198', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'8300 W 38Th Ave', N'Wheat Ridge', N'CO', N'08059', N'80033', 39.769381, -105.075468, 763, 43, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (800, N'Poudre Valley Hospital', 1, NULL, NULL, N'060010', NULL, NULL, 0, 281, NULL, N'9704957000', N'9704957663', 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1024 S Lemay Ave', N'Fort Collins', N'CO', N'08069', N'80524', 40.577473, -105.057919, 734, 44, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (801, N'Denver Health Medical Center', 1, NULL, NULL, N'060011', NULL, NULL, 0, 398, NULL, N'3034366000', N'3034365131', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'777 Bannock St', N'Denver', N'CO', N'08031', N'80204', 39.727514, -104.991565, 730, 43, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (802, N'Centura Health-St Mary Corwin Medical Center', 1, NULL, NULL, N'060012', NULL, NULL, 0, 408, NULL, N'7195574000', N'7195575823', 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1008 Minnequa Ave', N'Pueblo', N'CO', N'08101', N'81004', 38.23313, -104.622181, 753, 47, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (803, N'Mercy Regional Medical Center', 1, NULL, NULL, N'060013', NULL, NULL, 0, 82, NULL, N'9702474311', N'9707643919', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1010 Three Springs Blvd', N'Durango', N'CO', N'08067', N'81301', 37.2358, -107.825812, 731, 184, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (804, N'Presbyterian St Lukes Medical Center', 1, NULL, NULL, N'060014', NULL, NULL, 0, 680, NULL, N'3038396000', N'3038692428', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1719 E 19Th Ave', N'Denver', N'CO', N'08031', N'80218', 39.747157, -104.966598, 730, 43, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (805, N'Centura Health-St Anthony Hospital', 1, NULL, NULL, N'060015', NULL, NULL, 0, 593, NULL, N'7203210000', N'7203211621', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'11600 West 2Nd Place', N'Lakewood', N'CO', N'08059', N'80228', 39.718634, -105.134555, 730, 43, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (806, N'Centura Health-St Thomas More Hospital', 1, NULL, NULL, N'060016', NULL, NULL, 0, 55, NULL, N'7192852000', N'7192852370', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1338 Phay Ave', N'Canon City', N'CO', N'08043', N'81212', 38.455657, -105.229678, 724, 42, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (807, N'Parkview Medical Center Inc', 1, NULL, NULL, N'060020', NULL, NULL, 0, 350, NULL, N'7195844000', N'7195449799', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'400 W 16Th Street', N'Pueblo', N'CO', N'08101', N'81003', 38.281838, -104.61253, 753, 47, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (808, N'University Colo Health Memorial Hospital Central', 1, NULL, NULL, N'060022', NULL, NULL, 0, 583, NULL, N'7193655000', N'7193656870', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1400 E Boulder St', N'Colorado Springs', N'CO', N'08041', N'80909', 38.839378, -104.799593, 726, 42, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (809, N'St Marys Hospital And Medical Center', 1, NULL, NULL, N'060023', NULL, NULL, 0, 346, NULL, N'9702981950', N'9702987510', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2635 N 7Th Street', N'Grand Junction', N'CO', N'08077', N'81502', 39.090262, -108.563051, 737, 45, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (810, N'University Of Colorado Hospital Anschutz Inpatient', 1, NULL, NULL, N'060024', NULL, NULL, 0, 568, NULL, N'7208480000', N'7208485502', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'12605 East 16Th Avenue', N'Aurora', N'CO', N'08001', N'80045', 39.742544, -104.841661, 719, 43, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (811, N'Boulder Community Foothills Hospital', 1, NULL, NULL, N'060027', NULL, NULL, 0, 211, NULL, N'3034402273', N'3034402435', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4747 Arapahoe Avenue', N'Boulder', N'CO', N'08013', N'80304', 40.014555, -105.260774, 720, 41, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (812, N'Saint Joseph Hospital', 1, NULL, NULL, N'060028', NULL, NULL, 0, 565, NULL, N'3038377111', N'3038377123', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1375 East 19Th Ave', N'Denver', N'CO', N'08031', N'80218', 39.74647, -104.973708, 730, 43, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (813, N'Mckee Medical Center', 1, NULL, NULL, N'060030', NULL, NULL, 0, 115, NULL, N'9706694640', N'9706354137', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2000 Boise Ave', N'Loveland', N'CO', N'08069', N'80538', 40.412618, -105.053643, 750, 46, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (814, N'Centura Health-Penrose St Francis Health Services', 1, NULL, NULL, N'060031', NULL, NULL, 0, 522, NULL, N'7197765000', N'7197765914', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2222 N Nevada Ave', N'Colorado Springs', N'CO', N'08041', N'80907', 38.86561, -104.822883, 726, 42, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (815, N'Rose Medical Center', 1, NULL, NULL, N'060032', NULL, NULL, 0, 422, NULL, N'3033202121', N'3033202200', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4567 E 9Th Avenue', N'Denver', N'CO', N'08031', N'80220', 39.731024, -104.936297, 730, 43, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (816, N'Swedish Medical Center', 1, NULL, NULL, N'060034', NULL, NULL, 0, 368, NULL, N'3037885000', N'3037886269', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'501 E Hampden Avenue', N'Englewood', N'CO', N'08005', N'80113', 39.654033, -104.98068, 730, 43, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (817, N'Arkansas Valley Regional Medical Center', 1, NULL, NULL, N'060036', NULL, NULL, 0, 78, NULL, N'7193836000', N'7193836005', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1100 Carson Avenue', N'La Junta', N'CO', N'08089', N'81050', 37.978605, -103.548801, 746, 42, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (818, N'Keefe Memorial Hospital', 1, NULL, NULL, N'060043', NULL, NULL, 0, 32, NULL, N'7197675661', N'7197678042', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'602 N 6Th W St', N'Cheyenne Wells', N'CO', N'08017', N'80810', 38.821395, -102.353243, 725, 42, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (819, N'Colorado Plains Medical Center', 1, NULL, NULL, N'060044', NULL, NULL, 0, 50, NULL, N'9708673391', N'9705423306', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1000 Lincoln St', N'Fort Morgan', N'CO', N'08087', N'80701', 40.259443, -103.796057, 735, 46, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (820, N'Yampa Valley Medical Center', 1, NULL, NULL, N'060049', NULL, NULL, 0, 39, NULL, N'9708791322', N'9708701223', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1024 Central Park Dr', N'Steamboat Springs', N'CO', N'08107', N'80487', 40.462287, -106.818022, 757, 43, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (821, N'Community Hospital', 1, NULL, NULL, N'060054', NULL, NULL, 0, 78, NULL, N'9702566201', N'9702566501', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2021 N 12Th St', N'Grand Junction', N'CO', N'08077', N'81501', 39.085776, -108.55247, 737, 45, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (822, N'Centura Health-Porter Adventist Hospital', 1, NULL, NULL, N'060064', NULL, NULL, 0, 368, NULL, N'3037781955', N'3037785252', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2525 S Downing St', N'Denver', N'CO', N'08031', N'80210', 39.670424, -104.974769, 730, 43, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (823, N'North Suburban Medical Center', 1, NULL, NULL, N'060065', NULL, NULL, 0, 157, NULL, N'3034517800', N'3034504458', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'9191 Grant St', N'Thornton', N'CO', N'08001', N'80229', 39.868192, -104.982971, 759, 43, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (824, N'Delta County Memorial Hospital', 1, NULL, NULL, N'060071', NULL, NULL, 0, 49, NULL, N'9708747681', N'9708742227', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1501 E 3Rd Street', N'Delta', N'CO', N'08029', N'81416', 38.743097, -108.056154, 729, 45, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (825, N'Valley View Hospital Association', 1, NULL, NULL, N'060075', NULL, NULL, 0, 78, NULL, N'9709456535', N'9703844235', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1906 Blake Ave', N'Glenwood Springs', N'CO', N'08045', N'81601', 39.532239, -107.322795, 736, 45, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (826, N'Sterling Regional Medcenter', 1, NULL, NULL, N'060076', NULL, NULL, 0, 36, NULL, N'9705220122', N'9705228532', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'615 Fairhurst St', N'Sterling', N'CO', N'08075', N'80751', 40.613582, -103.221131, 758, 46, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (827, N'Vail Valley Medical Center', 1, NULL, NULL, N'060096', NULL, NULL, 0, 58, NULL, N'9704762451', N'9704797192', 1, 1, 0, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'181 W Meadow Drive', N'Vail', N'CO', N'08037', N'81657', 39.625569, -106.286462, 761, 43, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (828, N'Medical Center Of Aurora The', 1, NULL, NULL, N'060100', NULL, NULL, 0, 346, NULL, N'3036952600', N'3033682500', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1501 S Potomac St', N'Aurora', N'CO', N'08005', N'80012', 39.689351, -104.832083, 719, 43, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (829, N'Centura Health-Avista Adventist Hospital', 1, NULL, NULL, N'060103', NULL, NULL, 0, 66, NULL, N'3036731000', N'3036731048', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'100 Health Park Drive', N'Louisville', N'CO', N'08013', N'80027', 39.952083, -105.151862, 720, 41, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (830, N'St Anthony North Health Campus', 1, NULL, NULL, N'060104', NULL, NULL, 0, 196, NULL, N'3034303201', N'3034262155', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'14300 Orchard Parkway', N'Broomfield', N'CO', N'08001', N'80023', 39.921132, -105.06956, 730, 43, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (831, N'National Jewish Health', 1, NULL, NULL, N'060107', NULL, NULL, 0, 46, NULL, N'3033884461', N'3032702165', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1400 Jackson St', N'Denver', N'CO', N'08031', N'80206', 39.739612, -104.942497, 730, 43, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (832, N'Sky Ridge Medical Center', 1, NULL, NULL, N'060112', NULL, NULL, 0, 186, NULL, N'7202251000', N'7202251009', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'10101 Ridge Gate Parkway', N'Lone Tree', N'CO', N'08035', N'80124', 39.528382, -104.873096, 730, 43, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (833, N'Centura Health-Littleton Adventist Hospital', 1, NULL, NULL, N'060113', NULL, NULL, 0, 231, NULL, N'3037305888', N'3037305858', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7700 S Broadway', N'Littleton', N'CO', N'08005', N'80122', 39.577763, -104.988283, 730, 43, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (834, N'Parker Adventist Hospital', 1, NULL, NULL, N'060114', NULL, NULL, 0, 104, NULL, N'3032694000', N'3032694019', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'9395 Crown Crest Blvd', N'Parker', N'CO', N'08035', N'80138', 39.548511, -104.771203, 730, 43, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (835, N'Colorado Mental Health Institute At Pueblo', 1, NULL, NULL, N'060115', NULL, NULL, 0, 35, NULL, N'7195464147', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1600 W 24Th St', N'Pueblo', N'CO', N'08101', N'81003', 38.290955, -104.627732, 753, 47, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (836, N'Good Samaritan Medical Center', 1, NULL, NULL, N'060116', NULL, NULL, 0, 234, NULL, N'3036894000', N'3036895241', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'200 Exempla Circle', N'Lafayette', N'CO', N'08013', N'80026', 39.970895, -105.086254, 720, 41, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (837, N'Animas Surgical Hospital Llc', 1, NULL, NULL, N'060117', NULL, NULL, 0, 12, NULL, N'9702473537', N'9703852355', 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'575 Rivergate Lane', N'Durango', N'CO', N'08067', N'81301', 37.27528, -107.880067, 731, 184, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (838, N'St Anthony Summit Medical Center', 1, NULL, NULL, N'060118', NULL, NULL, 0, 35, NULL, N'9706683300', N'9706681517', 1, 0, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'340 Peak One Drive', N'Frisco', N'CO', N'08117', N'80443', 39.574431, -106.09752, 730, 43, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (839, N'Medical Center Of The Rockies', 1, NULL, NULL, N'060119', NULL, NULL, 0, 136, NULL, N'9706242500', N'9706241290', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2500 Rocky Mountain Avenue', N'Loveland', N'CO', N'08069', N'80538', 40.423585, -105.001942, 750, 46, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (840, N'Orthocolorado Hospital At St Anthony Med Campus', 1, NULL, NULL, N'060124', NULL, NULL, 0, 48, NULL, N'7203215000', N'7203215011', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'11650 W 2Nd Place', N'Lakewood', N'CO', N'08059', N'80228', 39.718634, -105.134555, 730, 43, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (841, N'Castle Rock Adventist Hospital', 1, NULL, NULL, N'060125', NULL, NULL, 0, 50, NULL, N'7204552500', N'7204552555', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2350 Meadows Blvd', N'Castle Rock', N'CO', N'08035', N'80109', 39.40494, -104.886698, 730, 43, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (842, N'Weisbrod Memorial County Hospital', 1, NULL, NULL, N'061300', NULL, NULL, 0, 25, NULL, N'7194385401', N'7194385697', 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'1208 Luther Street', N'Eads', N'CO', N'08061', N'81036', 38.480143, -102.784503, 732, 42, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (843, N'Rio Grande Hospital', 1, NULL, NULL, N'061301', NULL, NULL, 0, 17, NULL, N'7196572510', N'7196572511', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'310 County Rd 14', N'Del Norte', N'CO', N'08105', N'81132', 37.678892, -106.353368, 717, 42, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (844, N'Colorado Canyons Hospital And Medical Center', 1, NULL, NULL, N'061302', NULL, NULL, 0, 10, NULL, N'9708589871', N'9708582224', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'300 West Ottley Avenue', N'Fruita', N'CO', N'08077', N'81521', 39.164246, -108.738202, 737, 45, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (845, N'East Morgan County Hospital', 1, NULL, NULL, N'061303', NULL, NULL, 0, 25, NULL, N'9708426200', N'9708423572', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2400 W Edison St', N'Brush', N'CO', N'08087', N'80723', 40.258869, -103.623837, 722, 46, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (846, N'Haxtun Hospital District', 1, NULL, NULL, N'061304', NULL, NULL, 0, 25, NULL, N'9707746123', N'9707746158', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'235 W Fletcher Street', N'Haxtun', N'CO', N'08095', N'80731', 40.641477, -102.631491, 740, 46, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (847, N'Melissa Memorial Hospital', 1, NULL, NULL, N'061305', NULL, NULL, 0, 16, NULL, N'9708542241', N'9708543821', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1001 E Johnson Street', N'Holyoke', N'CO', N'08095', N'80734', 40.578487, -102.289655, 741, 46, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (848, N'Lincoln Community Hospital', 1, NULL, NULL, N'061306', NULL, NULL, 0, 15, NULL, N'7197432421', N'7197432880', 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'111 6Th St', N'Hugo', N'CO', N'08073', N'80821', 39.137961, -103.473899, 742, 43, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (849, N'Rangely District Hospital', 1, NULL, NULL, N'061307', NULL, NULL, 0, 25, NULL, N'9706755011', N'9706755224', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'225 Eaglecrest', N'Rangely', N'CO', N'08103', N'81648', 40.087476, -108.804829, 754, 279, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (850, N'San Luis Valley Health Conejos County Hospital', 1, NULL, NULL, N'061308', NULL, NULL, 0, 17, NULL, N'7192745121', N'7192746003', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'19021 Us Hwy 285', N'La Jara', N'CO', N'08021', N'81140', 37.275008, -105.960301, 745, 42, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (851, N'Wray Community District Hospital', 1, NULL, NULL, N'061309', NULL, NULL, 0, 15, NULL, N'9703324811', N'9703324800', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1017 W 7Th St', N'Wray', N'CO', N'08125', N'80758', 40.076212, -102.234875, 764, 46, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (852, N'Sedgwick County Memorial Hospital', 1, NULL, NULL, N'061310', NULL, NULL, 0, 25, NULL, N'9704743323', N'9704742758', 1, 0, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'900 Cedar Street', N'Julesburg', N'CO', N'08115', N'80737', 40.99397, -102.268488, 743, 46, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (853, N'Southeast Colorado Hospital', 1, NULL, NULL, N'061311', NULL, NULL, 0, 23, NULL, N'7195234501', N'7195239972', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'373 E Tenth Ave', N'Springfield', N'CO', N'08009', N'81073', 37.408349, -102.614362, 756, 42, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (854, N'Estes Park Medical Center', 1, NULL, NULL, N'061312', NULL, NULL, 0, 23, NULL, N'9705862317', N'9705869514', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'555 Prospect Avenue', N'Estes Park', N'CO', N'08069', N'80517', 40.372333, -105.51439, 733, 44, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (855, N'Kit Carson County Memorial Hospital', 1, NULL, NULL, N'061313', NULL, NULL, 0, 19, NULL, N'7193465311', N'7193464880', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'286 16Th Street', N'Burlington', N'CO', N'08063', N'80807', 39.302825, -102.270669, 723, 43, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (856, N'Memorial Hospital The', 1, NULL, NULL, N'061314', NULL, NULL, 0, 25, NULL, N'9708249411', N'9708263119', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'750 Hospital Loop', N'Craig', N'CO', N'08081', N'81625', 40.518499, -107.580929, 728, 43, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (857, N'Yuma District Hospital', 1, NULL, NULL, N'061315', NULL, NULL, 0, 22, NULL, N'9708485405', N'9708484952', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1000 West 8Th Avenue', N'Yuma', N'CO', N'08125', N'80759', 40.118521, -102.736496, 765, 46, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (858, N'Spanish Peaks Regional Health Center', 1, NULL, NULL, N'061316', NULL, NULL, 0, 25, NULL, N'7197385100', N'7197385138', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'23500 Us Hwy 160', N'Walsenburg', N'CO', N'08055', N'81089', 37.624533, -104.780326, 762, 47, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (859, N'Grand River Medical Center', 1, NULL, NULL, N'061317', NULL, NULL, 0, 25, NULL, N'9706251510', N'9706256486', 1, 1, 1, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'501 Airport Road', N'Rifle', N'CO', N'08045', N'81650', 39.52273, -107.769623, 736, 45, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (860, N'Middle Park Medical Center', 1, NULL, NULL, N'061318', NULL, NULL, 0, 25, NULL, N'9707243442', N'9707249606', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'214 S 4Th Street', N'Kremmling', N'CO', N'08049', N'80459', 40.058874, -106.38892, 744, 43, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (861, N'St Vincent Hospital General District', 1, NULL, NULL, N'061319', NULL, NULL, 0, 25, NULL, N'7194860230', N'7194861077', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'822 W 4Th Street', N'Leadville', N'CO', N'08065', N'80461', 39.244834, -106.303598, 748, 43, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (862, N'Gunnison Valley Hospital', 1, NULL, NULL, N'061320', NULL, NULL, 0, 24, NULL, N'9706411456', N'9706417233', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'711 N Taylor Street', N'Gunnison', N'CO', N'08051', N'81230', 38.552264, -106.924465, 739, 45, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (863, N'Mt San Rafael Hospital', 1, NULL, NULL, N'061321', NULL, NULL, 0, 25, NULL, N'7198469213', N'7198462752', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'410 Benedicta Avenue', N'Trinidad', N'CO', N'08071', N'81082', 37.174251, -104.489166, 760, 42, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (864, N'Heart Of The Rockies Regional Medical Center', 1, NULL, NULL, N'061322', NULL, NULL, 0, 25, NULL, N'7195302200', N'7195302232', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1000 Rush Drive', N'Salida', N'CO', N'08015', N'81201', 38.534719, -105.998902, 755, 42, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (865, N'Prowers Medical Center', 1, NULL, NULL, N'061323', NULL, NULL, 0, 25, NULL, N'7193364343', N'7193367207', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'401 Kendall Drive', N'Lamar', N'CO', N'08099', N'81052', 38.069966, -102.60853, 747, 42, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (866, N'Aspen Valley Hospital', 1, NULL, NULL, N'061324', NULL, NULL, 0, 25, NULL, N'9705441261', N'9705441585', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'0401 Castle Creek Road', N'Aspen', N'CO', N'08097', N'81611', 39.184114, -106.836631, 718, 43, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (867, N'Pioneers Medical Center', 1, NULL, NULL, N'061325', NULL, NULL, 0, 15, NULL, N'9708785047', N'9708783285', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'345 Cleveland Street', N'Meeker', N'CO', N'08103', N'81641', 40.041193, -107.91128, 751, 45, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (868, N'Pikes Peak Regional Hospital', 1, NULL, NULL, N'061326', NULL, NULL, 0, 15, NULL, N'7196879999', N'7196865725', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'16420 Highway 24', N'Woodland Park', N'CO', N'08119', N'80863', 39.009936, -105.045003, 726, 42, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (869, N'Southwest Memorial Hospital', 1, NULL, NULL, N'061327', NULL, NULL, 0, 25, NULL, N'9705656666', N'9705642149', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1311 N Mildred Rd', N'Cortez', N'CO', N'08083', N'81321', 37.36181, -108.572827, 727, 184, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (870, N'Pagosa Springs Medical Center', 1, NULL, NULL, N'061328', NULL, NULL, 0, 11, NULL, N'9707313700', N'9707313707', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'95 South Pagosa Boulevard', N'Pagosa Springs', N'CO', N'08007', N'81147', 37.269566, -107.010816, 731, 184, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (871, N'Wide Horizon', 1, NULL, NULL, N'061990', NULL, NULL, 0, 24, NULL, N'3034244445', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'8900 West 38Th Avenue', N'Wheat Ridge', N'CO', N'08059', N'80033', 39.769381, -105.075468, 763, 43, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (872, N'Kindred Hospital-Denver', 1, NULL, NULL, N'062009', NULL, NULL, 0, 68, NULL, N'3033315219', N'3033315220', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1920 High St', N'Denver', N'CO', N'08031', N'80218', 39.74628, -104.964447, 730, 43, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (873, N'Craig Hospital', 1, NULL, NULL, N'062011', NULL, NULL, 0, 93, NULL, N'3037898000', N'3037898219', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3425 S Clarkson St', N'Englewood', N'CO', N'08005', N'80113', 39.654221, -104.978454, 730, 43, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (874, N'Colorado Acute Long Term Hospital', 1, NULL, NULL, N'062012', NULL, NULL, 0, 63, NULL, N'3032646865', N'3032646853', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1690 N Meade St', N'Denver', N'CO', N'08031', N'80204', 39.739154, -104.984703, 730, 43, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (875, N'Kindred Hospital Aurora', 1, NULL, NULL, N'062013', NULL, NULL, 0, 37, NULL, N'7208578333', N'7208580366', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'700 Potomac St 2Nd Floor', N'Aurora', N'CO', N'08001', N'80011', 39.729432, -104.83192, 719, 43, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (876, N'Vibra Long Term Acute Care Hospital', 1, NULL, NULL, N'062014', NULL, NULL, 0, 54, NULL, N'3032883000', N'3032865029', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'8451 Pearl St', N'Thornton', N'CO', N'08001', N'80229', 39.850403, -104.979412, 759, 43, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (877, N'Select Specialty Hospital-Denver', 1, NULL, NULL, N'062015', NULL, NULL, 0, 65, NULL, N'3038980369', N'3037157398', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1719 East 19Th Ave 5B', N'Denver', N'CO', N'08031', N'80218', 39.739154, -104.984703, 730, 43, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (878, N'Select Long Term Care Hospital-Colorado Springs', 1, NULL, NULL, N'062016', NULL, NULL, 0, 30, NULL, N'7195716000', N'7195716182', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6001 East Woodmen Road', N'Colorado Springs', N'CO', N'08041', N'80923', 38.938559, -104.716966, 726, 42, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (879, N'Northern Colorado Long Term Acute Hosp - Long Term', 1, NULL, NULL, N'062017', NULL, NULL, 0, 20, NULL, N'9706193400', N'9702789340', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4401 Union Street', N'Johnstown', N'CO', N'08069', N'80534', 40.33503, -104.909284, 738, 46, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (880, N'Spalding Rehabilitation Hospital', 1, NULL, NULL, N'063027', NULL, NULL, 0, 122, NULL, N'3033671166', N'3033608208', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'900 Potomac Street', N'Aurora', N'CO', N'08001', N'80011', 39.731093, -104.8274, 719, 43, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (881, N'Healthsouth Rehabilitation Hospital Of Co Spgs', 1, NULL, NULL, N'063030', NULL, NULL, 0, 64, NULL, N'7196308000', N'7195200387', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'325 Parkside Drive', N'Colorado Springs', N'CO', N'08041', N'80910', 40.799638, -106.938986, 726, 42, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (882, N'Northern Colorado Rehabilitation Hospital', 1, NULL, NULL, N'063033', NULL, NULL, 0, 40, NULL, N'9706193400', N'9702789340', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4401 Union Street', N'Johnstown', N'CO', N'08123', N'80534', 40.33503, -104.909284, 738, 46, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (883, N'Healthsouth Rehabilitation Hospital Of Littleton', 1, NULL, NULL, N'063034', NULL, NULL, 0, 40, NULL, N'3033341100', N'2052628547', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1001 West Mineral Avenue', N'Littleton', N'CO', N'08005', N'80120', 39.573619, -105.00026, 730, 43, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (884, N'Childrens Hospital Colorado', 1, NULL, NULL, N'063301', NULL, NULL, 0, 414, NULL, N'7207771234', N'7207777267', 1, 0, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'13123 East 16Th Avenue', N'Aurora', N'CO', N'08001', N'80045', 39.742217, -104.836153, 719, 43, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (885, N'Colorado Mental Health Institute At Pueblo-Psych', 1, NULL, NULL, N'064001', NULL, NULL, 0, 438, NULL, N'7195464443', N'7195464770', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1600 West 24Th St', N'Pueblo', N'CO', N'08101', N'81003', 38.290955, -104.627732, 753, 47, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (886, N'Colorado Mental Health Institute At Ft Logan', 1, NULL, NULL, N'064003', NULL, NULL, 0, 173, NULL, N'3038667066', N'3038667088', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3520 W Oxford Ave', N'Denver', N'CO', N'08031', N'80236', 39.64219, -105.032558, 730, 43, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (887, N'Centennial Peaks Hospital', 1, NULL, NULL, N'064007', NULL, NULL, 0, 72, NULL, N'3036739990', N'3036739703', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2255 S 88Th St', N'Louisville', N'CO', N'08013', N'80027', 39.952058, -105.148206, 720, 41, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (888, N'Cedar Springs Behavioral Health System', 1, NULL, NULL, N'064009', NULL, NULL, 0, 52, NULL, N'7196334114', N'7193295315', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2135 Southgate Rd', N'Colorado Springs', N'CO', N'08041', N'80906', 38.806366, -104.821689, 726, 42, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (889, N'West Springs Hospital', 1, NULL, NULL, N'064023', NULL, NULL, 0, 46, NULL, N'9702634918', N'9706837280', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'515 28 3/4 Road', N'Grand Junction', N'CO', N'08077', N'81501', 39.079624, -108.519932, 737, 45, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (890, N'Highlands Behavioral Health System', 1, NULL, NULL, N'064024', NULL, NULL, 0, 86, NULL, N'7203482800', N'7203482803', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'8565 S Poplar Way', N'Littleton', N'CO', N'08035', N'80130', 44.306173, -71.770088, 730, 43, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (891, N'Haven Behavioral Hospital Of Southern Colo', 1, NULL, NULL, N'064025', NULL, NULL, 0, 30, NULL, N'7195466000', N'7195654021', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1008 Minnequa Avenue Suite 6100', N'Pueblo', N'CO', N'08101', N'81004', 38.254447, -104.609141, 753, 47, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (892, N'Peak View Behavioral Health', 1, NULL, NULL, N'064026', NULL, NULL, 0, 24, NULL, N'7194448484', N'7195444842', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7353 Sisters Grove', N'Colorado Springs', N'CO', N'08041', N'80918', 38.833958, -104.825348, 726, 42, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (893, N'Centura Health-Porter Adventist Hospital', 1, NULL, NULL, N'069864', NULL, NULL, 0, 0, NULL, N'3037785671', N'3037785205', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'2535 South Downing Street #380', N'Denver', N'CO', N'08031', N'80210', 39.739154, -104.984703, 730, 43, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (894, N'Presbyterian St Luke''s Medical Center', 1, NULL, NULL, N'069865', NULL, NULL, 0, 0, NULL, N'3038396100', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'1719 East 19Th Avenue', N'Denver', N'CO', N'08031', N'80218', 39.747157, -104.966598, 730, 43, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (895, N'University Of Colorado Hospital Anschutz Inpatient', 1, NULL, NULL, N'069866', NULL, NULL, 0, 0, NULL, N'7208487800', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'12605 East 16Th Avenue', N'Aurora', N'CO', N'08001', N'80045', 39.742544, -104.841661, 719, 43, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (896, N'St Francis Hospital & Medical Center', 1, NULL, NULL, N'070002', NULL, NULL, 0, 617, NULL, N'8607144000', NULL, 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'114 Woodland Street', N'Hartford', N'CT', N'09003', N'06105', 41.77285, -72.698947, 771, 49, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (897, N'Day Kimball Hospital', 1, NULL, NULL, N'070003', NULL, NULL, 0, 104, NULL, N'8609286541', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'320 Pomfret Street', N'Putnam', N'CT', N'09015', N'06260', 41.907228, -71.91523, 782, 49, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (898, N'Sharon Hospital', 1, NULL, NULL, N'070004', NULL, NULL, 0, 78, NULL, N'8603644228', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'50 Hospital Hill Road Po Box 789', N'Sharon', N'CT', N'09005', N'06069', 41.87926, -73.47679, 784, 49, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (899, N'Waterbury Hospital', 1, NULL, NULL, N'070005', NULL, NULL, 0, 357, NULL, N'2035736000', NULL, 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'64 Robbins St', N'Waterbury', N'CT', N'09009', N'06721', 41.558088, -73.060654, 789, 50, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (900, N'Stamford Hospital', 1, NULL, NULL, N'070006', NULL, NULL, 0, 305, NULL, N'2032761000', NULL, 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'30 Shelburne Road', N'Stamford', N'CT', N'09001', N'06904', 41.054482, -73.553932, 787, 48, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (901, N'Lawrence & Memorial Hospital', 1, NULL, NULL, N'070007', NULL, NULL, 0, 280, NULL, N'8604420711', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'365 Montauk Ave', N'New London', N'CT', N'09011', N'06320', 41.337019, -72.103727, 778, 50, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (902, N'Johnson Memorial Hospital', 1, NULL, NULL, N'070008', NULL, NULL, 0, 92, NULL, N'8606844251', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'201 Chestnut Hill Rd', N'Stafford Springs', N'CT', N'09013', N'06076', 41.954263, -72.302302, 786, 49, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (903, N'Bridgeport Hospital', 1, NULL, NULL, N'070010', NULL, NULL, 0, 395, NULL, N'2033843000', NULL, 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'267 Grant Street', N'Bridgeport', N'CT', N'09001', N'06610', 41.188939, -73.166492, 766, 48, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (904, N'Charlotte Hungerford Hospital', 1, NULL, NULL, N'070011', NULL, NULL, 0, 109, NULL, N'8604966666', NULL, 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'540 Litchfield St', N'Torrington', N'CT', N'09005', N'06790', 41.79093, -73.133247, 788, 49, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (905, N'Rockville General Hospital', 1, NULL, NULL, N'070012', NULL, NULL, 0, 102, NULL, N'8608725160', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'31 Union St', N'Rockville', N'CT', N'09013', N'06066', 41.867984, -72.466214, 783, 49, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (906, N'Saint Marys Hospital', 1, NULL, NULL, N'070016', NULL, NULL, 0, 347, NULL, N'2035746000', NULL, 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'56 Franklin St', N'Waterbury', N'CT', N'09009', N'06706', 41.551276, -73.036912, 789, 50, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (907, N'Midstate Medical Center', 1, NULL, NULL, N'070017', NULL, NULL, 0, 144, NULL, N'2036948200', NULL, 1, 1, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'435 Lewis Ave', N'Meriden', N'CT', N'09009', N'06450', 41.550262, -72.803618, 773, 50, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (908, N'Greenwich Hospital Association', 1, NULL, NULL, N'070018', NULL, NULL, 0, 206, NULL, N'2038633000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5 Perryridge Rd', N'Greenwich', N'CT', N'09001', N'06830', 41.034826, -73.629278, 770, 48, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (909, N'Milford Hospital Inc', 1, NULL, NULL, N'070019', NULL, NULL, 0, 106, NULL, N'2038764000', NULL, 1, 1, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'300 Seaside Avenue', N'Milford', N'CT', N'09009', N'06460', 41.216603, -73.064106, 775, 50, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (910, N'Middlesex Hospital', 1, NULL, NULL, N'070020', NULL, NULL, 0, 275, NULL, N'8603446000', NULL, 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'28 Crescent St', N'Middletown', N'CT', N'09007', N'06457', 41.554717, -72.648111, 774, 49, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (911, N'Windham Comm Mem Hosp & Hatch Hosp', 1, NULL, NULL, N'070021', NULL, NULL, 0, 130, NULL, N'8604569116', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'112 Mansfield Ave', N'Willimantic', N'CT', N'09015', N'06226', 41.7167, -72.224123, 790, 49, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (912, N'Yale-New Haven Hospital', 1, NULL, NULL, N'070022', NULL, NULL, 0, 874, NULL, N'2036884242', NULL, 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'20 York St', N'New Haven', N'CT', N'09009', N'06504', 41.304312, -72.935992, 777, 50, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (913, N'William W Backus Hospital', 1, NULL, NULL, N'070024', NULL, NULL, 0, 213, NULL, N'8608898331', N'8608236329', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'326 Washington St', N'Norwich', N'CT', N'09011', N'06360', 41.543395, -72.086877, 781, 49, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (914, N'Hartford Hospital', 1, NULL, NULL, N'070025', NULL, NULL, 0, 819, NULL, N'8605455000', NULL, 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'80 Seymour Street', N'Hartford', N'CT', N'09003', N'06102', 41.75486, -72.680582, 771, 49, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (915, N'Manchester Memorial Hospital', 1, NULL, NULL, N'070027', NULL, NULL, 0, 249, NULL, N'8606474780', NULL, 1, 1, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'71 Haynes St', N'Manchester', N'CT', N'09003', N'06040', 41.78124, -72.524782, 772, 49, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (916, N'St Vincent''s Medical Center', 1, NULL, NULL, N'070028', NULL, NULL, 0, 397, NULL, N'2035765551', NULL, 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2800 Main St', N'Bridgeport', N'CT', N'09001', N'06606', 41.201264, -73.201344, 766, 48, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (917, N'Bristol Hospital', 1, NULL, NULL, N'070029', NULL, NULL, 0, 134, NULL, N'8605853000', NULL, 1, 1, 0, 0, 0, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Brewster Rd', N'Bristol', N'CT', N'09003', N'06010', 41.675528, -72.930577, 767, 49, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (918, N'Griffin Hospital', 1, NULL, NULL, N'070031', NULL, NULL, 0, 160, NULL, N'2037327500', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'130 Division St', N'Derby', N'CT', N'09009', N'06418', 41.335379, -73.089282, 769, 50, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (919, N'Danbury Hospital', 1, NULL, NULL, N'070033', NULL, NULL, 0, 345, NULL, N'2037977000', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'24 Hospital Ave', N'Danbury', N'CT', N'09001', N'06810', 41.405968, -73.446578, 768, 50, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (920, N'Norwalk Hospital Association', 1, NULL, NULL, N'070034', NULL, NULL, 0, 328, NULL, N'2038522000', NULL, 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'24 Stevens Street', N'Norwalk', N'CT', N'09001', N'06856', 41.110744, -73.420467, 780, 48, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (921, N'Hospital Of Central Connecticut The', 1, NULL, NULL, N'070035', NULL, NULL, 0, 330, NULL, N'8602245011', NULL, 1, 1, 0, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'100 Grand Street', N'New Britain', N'CT', N'09003', N'06050', 41.661411, -72.786939, 776, 49, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (922, N'John Dempsey Hospital', 1, NULL, NULL, N'070036', NULL, NULL, 0, 204, NULL, N'8606791145', NULL, 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'263 Farmington Ave', N'Farmington', N'CT', N'09003', N'06032', 41.726065, -72.820776, 771, 49, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (923, N'Connecticut Hospice Incthe', 1, NULL, NULL, N'070038', NULL, NULL, 0, 52, NULL, N'2033157500', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'100 Double Beach Road', N'Branford', N'CT', N'09009', N'06405', 41.279541, -72.815099, 777, 50, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (924, N'Masonic Home And Hospital', 1, NULL, NULL, N'070039', NULL, NULL, 0, 91, NULL, N'2036795900', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'22 Masonic Ave', N'Wallingford', N'CT', N'09009', N'06492', 41.459489, -72.837358, 773, 50, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (925, N'Hebrew Home And Hospital Inc', 1, NULL, NULL, N'070040', NULL, NULL, 0, 45, NULL, N'8605233800', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1 Abrahms Boulevard', N'West Hartford', N'CT', N'09003', N'06117', 41.801578, -72.727064, 771, 49, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (926, N'Gaylord Hospital Inc', 1, NULL, NULL, N'072003', NULL, NULL, 0, 137, NULL, N'2032842800', NULL, 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Gaylord Farm Rd', N'Wallingford', N'CT', N'09009', N'06492', 41.474532, -72.859133, 773, 50, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (927, N'Hospital For Special Care', 1, NULL, NULL, N'072004', NULL, NULL, 0, 228, NULL, N'8602232761', NULL, 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2150 Corbin Ave', N'New Britain', N'CT', N'09003', N'06050', 41.688295, -72.800607, 776, 49, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (928, N'State Of Connecticut Dept Of Veterans'' Affairs', 1, NULL, NULL, N'072006', NULL, NULL, 0, 350, NULL, N'8605292571', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'287 West Street', N'Rocky Hill', N'CT', N'09003', N'06067', 41.653415, -72.650806, 771, 49, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (929, N'Mount Sinai Rehabilitation Hospital Inc', 1, NULL, NULL, N'073025', NULL, NULL, 0, 60, NULL, N'8607143500', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'490 Blue Hills Avenue', N'Hartford', N'CT', N'09003', N'06112', 41.800004, -72.693822, 771, 49, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (930, N'Connecticut Childrens Medical Center', 1, NULL, NULL, N'073300', NULL, NULL, 0, 129, NULL, N'8605459000', NULL, 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'282 Washington Street', N'Hartford', N'CT', N'09003', N'06106', 41.754985, -72.682553, 771, 49, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (931, N'Connecticut Valley Hosp', 1, NULL, NULL, N'074003', NULL, NULL, 0, 604, NULL, N'2033442666', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Silver St', N'Middletown', N'CT', N'09007', N'06457', 41.552253, -72.637942, 774, 49, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (932, N'Natchaug Hospital', 1, NULL, NULL, N'074008', NULL, NULL, 0, 60, NULL, N'8604561311', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'189 Storrs Rd', N'Mansfield Center', N'CT', N'09013', N'06250', 41.765376, -72.198133, 790, 49, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (933, N'Connecticut Mental Health Center', 1, NULL, NULL, N'074011', NULL, NULL, 0, 70, NULL, N'2039743000', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'34 Park St', N'New Haven', N'CT', N'09009', N'06508', 41.305456, -72.936831, 777, 50, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (934, N'Southwest Connecticut Mental Health', 1, NULL, NULL, N'074012', NULL, NULL, 0, 62, NULL, N'2035796646', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1635 Central Ave', N'Bridgeport', N'CT', N'09001', N'06610', 41.18953, -73.167593, 766, 48, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (935, N'Silver Hill Hospital Inc', 1, NULL, NULL, N'074014', NULL, NULL, 0, 129, NULL, N'2039663561', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'208 Valley Road', N'New Canaan', N'CT', N'09001', N'06840', 42.050301, -73.256329, 780, 48, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (936, N'Yale-New Haven Hospital -  Transplant Center', 1, NULL, NULL, N'079801', NULL, NULL, 0, 0, NULL, N'2037852611', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'20 York Street', N'New Haven', N'CT', N'09009', N'06504', 41.304312, -72.935992, 777, 50, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (937, N'Hartford Hospital - Transplant Center', 1, NULL, NULL, N'079802', NULL, NULL, 0, 0, NULL, N'8605454339', N'8605454366', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'80 Seymour Street Po Box 5037', N'Hartford', N'CT', N'09003', N'06106', 41.763494, -72.683052, 771, 49, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (938, N'Christiana Care Health Services Inc.', 1, NULL, NULL, N'080001', NULL, NULL, 0, 1196, NULL, N'3027331000', N'3027331366', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4755 Ogletown-Stanton Road', N'Newark', N'DE', N'10003', N'19718', 39.685219, -75.750829, 796, 51, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (939, N'St Francis Hospital', 1, NULL, NULL, N'080003', NULL, NULL, 0, 395, NULL, N'3024214100', N'3025758335', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7Th And Clayton Sts', N'Wilmington', N'DE', N'10003', N'19805', 39.745947, -75.546589, 796, 51, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (940, N'Bayhealth - Kent General Hospital', 1, NULL, NULL, N'080004', NULL, NULL, 0, 304, NULL, N'3027447001', N'3026740703', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'640 S State Street', N'Dover', N'DE', N'10001', N'19901', 39.151496, -75.522374, 792, 51, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (941, N'Nanticoke Memorial Hospital', 1, NULL, NULL, N'080006', NULL, NULL, 0, 119, NULL, N'3026296611', N'3026292493', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'801 Middleford Rd', N'Seaford', N'DE', N'10005', N'19973', 38.642294, -75.607938, 795, 131, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (942, N'Beebe Medical Center', 1, NULL, NULL, N'080007', NULL, NULL, 0, 155, NULL, N'3026453300', N'3026453635', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'424 Savannah Rd', N'Lewes', N'DE', N'10005', N'19958', 38.774557, -75.13935, 793, 131, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (943, N'Bayhealth - Milford Memorial Hospital', 1, NULL, NULL, N'080009', NULL, NULL, 0, 168, NULL, N'3024223311', NULL, 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'21 West Clarke Avenue', N'Milford', N'DE', N'10005', N'19963', 38.905895, -75.432743, 794, 131, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (944, N'Select Specialty Hospital Wilmington', 1, NULL, NULL, N'082000', NULL, NULL, 0, 35, NULL, N'3024214591', N'7179759981', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7Th & Clayton Streets  5Th Floor', N'Wilmington', N'DE', N'10003', N'19805', 39.745947, -75.546589, 796, 51, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (945, N'Healthsouth Rehabilitation Hospital Of Middletown', 1, NULL, NULL, N'083026', NULL, NULL, 0, 34, NULL, N'4848899815', N'2052624216', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'250 East Hampden Road', N'Middletown', N'DE', N'10003', N'19709', 39.4416, -75.725037, 796, 51, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (946, N'Alfred I Dupont Hospital For Children', 1, NULL, NULL, N'083300', NULL, NULL, 0, 180, NULL, N'3026514000', N'3026514055', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1600 Rockland Rd Po Box 269', N'Wilmington', N'DE', N'10003', N'19899', 39.745947, -75.546589, 796, 51, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (947, N'Delaware Psychiatric Center', 1, NULL, NULL, N'084001', NULL, NULL, 0, 281, NULL, N'3022552700', N'3022554422', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1901 N Dupont Highway', N'New Castle', N'DE', N'10003', N'19720', 39.698644, -75.574344, 796, 51, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (948, N'Rockford Center', 1, NULL, NULL, N'084002', NULL, NULL, 0, 92, NULL, N'3029965480', N'3029960269', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'100 Rockford Drive', N'Newark', N'DE', N'10003', N'19713', 39.685219, -75.750829, 796, 51, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (949, N'Meadowwood Behavioral Health System', 1, NULL, NULL, N'084003', NULL, NULL, 0, 58, NULL, N'3023283330', N'3023289336', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'575 South Dupont Highway', N'New Castle', N'DE', N'10003', N'19720', 39.644655, -75.624868, 796, 51, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (950, N'Dover Behavioral Health System', 1, NULL, NULL, N'084004', NULL, NULL, 0, 73, NULL, N'3027410140', N'3027418551', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'725 Horsepond Road', N'Dover', N'DE', N'10001', N'19901', 39.151271, -75.485814, 792, 51, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (951, N'George Washington Univ Hospital', 1, NULL, NULL, N'090001', NULL, NULL, 0, 371, NULL, N'2027164605', NULL, 1, 1, 1, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'900 23Rd St Nw', N'Washington', N'DC', N'11001', N'20037', 38.901514, -77.050552, 797, 52, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (952, N'Howard University Hospital', 1, NULL, NULL, N'090003', NULL, NULL, 0, 479, NULL, N'2027456100', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2041 Georgia Ave Nw', N'Washington', N'DC', N'11001', N'20060', 38.917548, -77.020094, 797, 52, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (953, N'Medstar Georgetown University Hospital', 1, NULL, NULL, N'090004', NULL, NULL, 0, 535, NULL, N'2027843000', NULL, 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3800 Reservoir Rd', N'Washington', N'DC', N'11001', N'20007', 38.894955, -77.036646, 797, 52, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (954, N'Sibley Memorial Hospital', 1, NULL, NULL, N'090005', NULL, NULL, 0, 362, NULL, N'2025374680', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5255 Loughboro Rd Nw', N'Washington', N'DC', N'11001', N'20016', 38.93235, -77.095282, 797, 52, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (955, N'Providence Hospital', 1, NULL, NULL, N'090006', NULL, NULL, 0, 408, NULL, N'2022697000', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1150 Varnum St Ne', N'Washington', N'DC', N'11001', N'20017', 38.943287, -76.991229, 797, 52, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (956, N'United Medical Center', 1, NULL, NULL, N'090008', NULL, NULL, 0, 184, NULL, N'2025746611', N'2025747188', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1310 Southern Avenue  Se', N'Washington', N'DC', N'11001', N'20032', 38.836019, -76.984751, 797, 52, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (957, N'Medstar Washington Hospital Center', 1, NULL, NULL, N'090011', NULL, NULL, 0, 818, NULL, N'2028777000', NULL, 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'110 Irving St Nw', N'Washington', N'DC', N'11001', N'20010', 38.929652, -77.015648, 797, 52, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (958, N'Specialty Hospital Capitol Hill', 1, NULL, NULL, N'092002', NULL, NULL, 0, 60, NULL, N'2026750400', NULL, 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'700 Constitution Avenue Ne', N'Washington', N'DC', N'11001', N'20002', 38.892322, -76.995357, 797, 52, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (959, N'Specialty Hospital  Hadley', 1, NULL, NULL, N'092003', NULL, NULL, 0, 82, NULL, N'2025745770', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4601 Martin Luther King Jr Avenue', N'Washington', N'DC', N'11001', N'20032', 38.894955, -77.036646, 797, 52, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (960, N'Medstar National Rehabilitation Hospital', 1, NULL, NULL, N'093025', NULL, NULL, 0, 137, NULL, N'2028771737', NULL, 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'102 Irving Street Nw', N'Washington', N'DC', N'11001', N'20010', 38.930483, -77.013355, 797, 52, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (961, N'Children''s Hospital Nmc', 1, NULL, NULL, N'093300', NULL, NULL, 0, 303, NULL, N'2024765000', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'111 Michigan Ave Nw', N'Washington', N'DC', N'11001', N'20010', 38.9273, -77.0147, 797, 52, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (962, N'St Elizabeths Hospital', 1, NULL, NULL, N'094001', NULL, NULL, 0, 600, NULL, N'2022995500', N'2025616957', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1100 Alabama Avenue Se', N'Washington', N'DC', N'11001', N'20032', 38.848308, -76.986917, 797, 52, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (963, N'Psychiatric Institute Of Washington Dc', 1, NULL, NULL, N'094004', NULL, NULL, 0, 104, NULL, N'2028855600', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4228 Wisconsin Avenue Nw', N'Washington', N'DC', N'11001', N'20016', 38.94384, -77.0779, 797, 52, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (964, N'Medstar Washington Hospital Center', 1, NULL, NULL, N'099800', NULL, NULL, 0, 0, NULL, N'2028776102', N'2028777826', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'110 Irving St Nw', N'Washington', N'DC', N'11001', N'20010', 38.929652, -77.015648, 797, 52, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (965, N'Children''s National Medical Center', 1, NULL, NULL, N'099801', NULL, NULL, 0, 0, NULL, N'2028845058', N'2028842090', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'111 Michigan Ave Nw', N'Washington', N'DC', N'11001', N'20010', 38.9273, -77.0147, 797, 52, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (966, N'Medstar Georgetown University Hospital', 1, NULL, NULL, N'099802', NULL, NULL, 0, 0, NULL, N'2024448054', N'2024443095', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'3800 Reservoir Rd Nw Ste 2 Main', N'Washington', N'DC', N'11001', N'20007', 38.894955, -77.036646, 797, 52, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (967, N'Uf Health Jacksonville', 1, NULL, NULL, N'100001', NULL, NULL, 0, 695, NULL, N'9042440411', NULL, 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'655 W 8Th St', N'Jacksonville', N'FL', N'12031', N'32209', 30.3466, -81.663323, 843, 59, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (968, N'Bethesda Hospital East', 1, NULL, NULL, N'100002', NULL, NULL, 0, 481, NULL, N'5617377733', NULL, 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2815 S Seacrest Blvd', N'Boynton Beach', N'FL', N'12099', N'33435', 26.503621, -80.069078, 806, 55, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (969, N'Orlando Health', 1, NULL, NULL, N'100006', NULL, NULL, 0, 1690, NULL, N'3218438000', NULL, 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1414 Kuhl Ave', N'Orlando', N'FL', N'12095', N'32806', 28.52029, -81.378504, 871, 63, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (970, N'Florida Hospital', 1, NULL, NULL, N'100007', NULL, NULL, 0, 2449, NULL, N'4073031976', NULL, 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'601 E Rollins St', N'Orlando', N'FL', N'12095', N'32803', 28.542118, -81.379046, 871, 63, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (971, N'Baptist Hospital Of Miami Inc', 1, NULL, NULL, N'100008', NULL, NULL, 0, 728, NULL, N'7865961960', NULL, 1, 1, 0, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'8900 N Kendall Dr', N'Miami', N'FL', NULL, N'33176', 25.689062, -80.302502, 861, 61, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (972, N'University Of Miami Hospital', 1, NULL, NULL, N'100009', NULL, NULL, 0, 560, NULL, N'3053255511', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1400 Nw 12Th Ave', N'Miami', N'FL', NULL, N'33136', 25.787717, -80.215096, 861, 61, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (973, N'Lee Memorial Hospital', 1, NULL, NULL, N'100012', NULL, NULL, 0, 783, NULL, N'2393321111', NULL, 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2776 Cleveland Ave', N'Fort Myers', N'FL', N'12071', N'33901', 26.627798, -81.874085, 832, 56, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (974, N'Bert Fish Medical Center', 1, NULL, NULL, N'100014', NULL, NULL, 0, 112, NULL, N'3864245000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'401 Palmetto St', N'New Smyrna Beach', N'FL', N'12127', N'32170', 29.021622, -80.923019, 866, 64, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (975, N'Halifax Health Medical Center', 1, NULL, NULL, N'100017', NULL, NULL, 0, 638, NULL, N'3862544000', NULL, 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'303 N Clyde Morris Blvd', N'Daytona Beach', N'FL', N'12127', N'32114', 29.20081, -81.05367, 822, 64, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (976, N'Naples Community Hospital', 1, NULL, NULL, N'100018', NULL, NULL, 0, 716, NULL, N'2394365000', NULL, 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'350 7Th St N', N'Naples', N'FL', N'12021', N'34102', 26.150261, -81.799403, 864, 56, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (977, N'Holmes Regional Medical Center', 1, NULL, NULL, N'100019', NULL, NULL, 0, 514, NULL, N'3214347000', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1350 S Hickory St', N'Melbourne', N'FL', N'12009', N'32901', 28.067912, -80.612912, 860, 63, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (978, N'Jackson Memorial Hospital', 1, NULL, NULL, N'100022', NULL, NULL, 0, 2101, NULL, N'3055851111', NULL, 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1611 Nw 12Th Ave', N'Miami', N'FL', NULL, N'33136', 25.790662, -80.214959, 861, 61, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (979, N'Citrus Memorial Hospital', 1, NULL, NULL, N'100023', NULL, NULL, 0, 198, NULL, N'3527261551', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'502 W Highland Blvd', N'Inverness', N'FL', N'12017', N'34452', 28.832236, -82.335273, 842, 62, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (980, N'Sacred Heart Hospital', 1, NULL, NULL, N'100025', NULL, NULL, 0, 466, NULL, N'8504167000', NULL, 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5151 N 9Th Ave', N'Pensacola', N'FL', N'12033', N'32504', 30.477772, -87.21144, 878, 66, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (981, N'Bay Medical Center Sacred Heart Health System', 1, NULL, NULL, N'100026', NULL, NULL, 0, 323, NULL, N'8507691511', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'615 N Bonita Ave', N'Panama City', N'FL', N'12005', N'32401', 30.159151, -85.647168, 876, 65, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (982, N'Parrish Medical Center', 1, NULL, NULL, N'100028', NULL, NULL, 0, 210, NULL, N'3212686111', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'951 N Washington Ave', N'Titusville', N'FL', N'12009', N'32796', 28.629854, -80.825512, 904, 63, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (983, N'North Shore Medical Center', 1, NULL, NULL, N'100029', NULL, NULL, 0, 816, NULL, N'3058356000', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1100 Nw 95Th St', N'Miami', N'FL', NULL, N'33150', 25.861551, -80.214748, 861, 61, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (984, N'Health Central', 1, NULL, NULL, N'100030', NULL, NULL, 0, 171, NULL, N'4072961820', NULL, 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'10000 W Colonial Dr', N'Ocoee', N'FL', N'12095', N'34761', 28.551702, -81.52551, 911, 63, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (985, N'Bayfront Health - St Petersburg', 1, NULL, NULL, N'100032', NULL, NULL, 0, 480, NULL, N'7278231234', NULL, 1, 1, 1, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'701 6Th St S', N'Saint Petersburg', N'FL', N'12103', N'33701', 27.763742, -82.641802, 896, 68, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (986, N'Mount Sinai Medical Center', 1, NULL, NULL, N'100034', NULL, NULL, 0, 672, NULL, N'3056742121', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4300 Alton Rd', N'Miami Beach', N'FL', NULL, N'33140', 25.834285, -80.129129, 862, 61, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (987, N'Manatee Memorial Hospital', 1, NULL, NULL, N'100035', NULL, NULL, 0, 319, NULL, N'9417465111', NULL, 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'206 2Nd St E', N'Bradenton', N'FL', N'12081', N'34208', 27.497142, -82.562168, 807, 53, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (988, N'Memorial Regional Hospital', 1, NULL, NULL, N'100038', NULL, NULL, 0, 993, NULL, N'9549872000', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3501 Johnson St', N'Hollywood', N'FL', N'12011', N'33021', 26.018303, -80.180647, 839, 61, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (989, N'Broward Health Medical Center', 1, NULL, NULL, N'100039', NULL, NULL, 0, 716, NULL, N'9543554400', NULL, 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1600 S Andrews Ave', N'Fort Lauderdale', N'FL', N'12011', N'33316', 26.102733, -80.141167, 831, 55, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (990, N'St Vincent''s Medical Center', 1, NULL, NULL, N'100040', NULL, NULL, 0, 528, NULL, N'9043087300', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1 Shircliff Way', N'Jacksonville', N'FL', N'12031', N'32204', 30.332184, -81.655651, 843, 59, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (991, N'Mease Dunedin Hospital', 1, NULL, NULL, N'100043', NULL, NULL, 0, 120, NULL, N'7277331111', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'601 Main St', N'Dunedin', N'FL', N'12103', N'34698', 28.014078, -82.783616, 827, 54, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (992, N'Martin Medical Center', 1, NULL, NULL, N'100044', NULL, NULL, 0, 344, NULL, N'7722875200', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'200 Se Hospital Ave', N'Stuart', N'FL', N'12085', N'34995', 27.198512, -80.243105, 897, 55, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (993, N'Florida Hospital Deland', 1, NULL, NULL, N'100045', NULL, NULL, 0, 156, NULL, N'3869434772', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'701 W Plymouth Ave', N'Deland', N'FL', N'12127', N'32720', 29.042691, -81.316483, 824, 63, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (994, N'Florida Hospital Zephyrhills', 1, NULL, NULL, N'100046', NULL, NULL, 0, 139, NULL, N'8137880411', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7050 Gall Blvd', N'Zephyrhills', N'FL', N'12101', N'33541', 28.234475, -82.182144, 910, 70, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (995, N'Bayfront Health Punta Gorda', 1, NULL, NULL, N'100047', NULL, NULL, 0, 208, NULL, N'9416393131', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'809 E Marion Ave', N'Punta Gorda', N'FL', N'12015', N'33950', 26.937286, -82.047998, 885, 56, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (996, N'Jay Hospital', 1, NULL, NULL, N'100048', NULL, NULL, 0, 55, NULL, N'8506754532', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'14114 Alabama St', N'Jay', N'FL', N'12113', N'32565', 28.627776, -80.828509, 846, 66, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (997, N'Highlands Regional Medical Center', 1, NULL, NULL, N'100049', NULL, NULL, 0, 126, NULL, N'8633856101', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3600 S Highlands Ave', N'Sebring', N'FL', N'12055', N'33870', 27.48576, -81.433466, 891, 63, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (998, N'Palm Springs General Hospital', 1, NULL, NULL, N'100050', NULL, NULL, 0, 247, NULL, N'3055582500', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1475 W 49Th St', N'Hialeah', N'FL', NULL, N'33012', 25.86667, -80.312413, 838, 61, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (999, N'South Lake Hospital', 1, NULL, NULL, N'100051', NULL, NULL, 0, 122, NULL, N'3523944071', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1900 Don Wickham Dr', N'Clermont', N'FL', N'12069', N'34711', 28.551644, -81.719406, 814, 63, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1000, N'Winter Haven Hospital', 1, NULL, NULL, N'100052', NULL, NULL, 0, 529, NULL, N'8632931121', NULL, 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'200 Ave F Ne', N'Winter Haven', N'FL', N'12105', N'33881', 28.027591, -81.726717, 908, 63, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1001, N'Hialeah Hospital', 1, NULL, NULL, N'100053', NULL, NULL, 0, 378, NULL, N'3056936100', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'651 E 25Th St', N'Hialeah', N'FL', NULL, N'33013', 25.844968, -80.268226, 838, 61, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1002, N'Twin Cities Hospital', 1, NULL, NULL, N'100054', NULL, NULL, 0, 65, NULL, N'8506784131', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2190 Hwy 85 N', N'Niceville', N'FL', N'12091', N'32578', 30.522651, -86.491453, 867, 66, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1003, N'Florida Hospital North Pinellas', 1, NULL, NULL, N'100055', NULL, NULL, 0, 168, NULL, N'7279425000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1395 S Pinellas Ave', N'Tarpon Springs', N'FL', N'12103', N'34689', 28.13225, -82.758573, 902, 54, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1004, N'Florida Hospital Waterman', 1, NULL, NULL, N'100057', NULL, NULL, 0, 269, NULL, N'3522533300', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1000 Waterman Way', N'Tavares', N'FL', N'12069', N'32778', 28.822962, -81.710227, 829, 63, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1005, N'Munroe Regional Medical Center', 1, NULL, NULL, N'100062', NULL, NULL, 0, 421, NULL, N'3523517200', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1500 Sw 1St Ave', N'Ocala', N'FL', N'12083', N'34474', 29.174177, -82.137965, 868, 62, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1006, N'Morton Plant North Bay Hospital', 1, NULL, NULL, N'100063', NULL, NULL, 0, 226, NULL, N'7278428468', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6600 Madison St', N'New Port Richey', N'FL', N'12101', N'34652', 28.254141, -82.715315, 865, 58, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1007, N'St Anthonys Hospital', 1, NULL, NULL, N'100067', NULL, NULL, 0, 395, NULL, N'7278251100', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1200 Seventh Ave N', N'Saint Petersburg', N'FL', N'12103', N'33705', 27.770861, -82.679266, 896, 68, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1008, N'Florida Hospital Memorial Medical Center', 1, NULL, NULL, N'100068', NULL, NULL, 0, 396, NULL, N'3866766000', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'301 Memorial Medical Parkway', N'Daytona Beach', N'FL', N'12127', N'32117', 29.210815, -81.022833, 822, 64, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1009, N'Florida Hospital Carrollwood', 1, NULL, NULL, N'100069', NULL, NULL, 0, 120, NULL, N'8139322222', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7171 N Dale Mabry Hwy', N'Tampa', N'FL', N'12057', N'33614', 27.94776, -82.458444, 901, 70, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1010, N'Venice Regional Medical Center - Bayfront Health', 1, NULL, NULL, N'100070', NULL, NULL, 0, 312, NULL, N'9414857711', NULL, 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'540 The Rialto', N'Venice', N'FL', N'12115', N'34285', 27.090948, -82.444489, 905, 67, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1011, N'Bayfront Health Brooksville', 1, NULL, NULL, N'100071', NULL, NULL, 0, 244, NULL, N'3527965111', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'17240 Cortez Blvd', N'Brooksville', N'FL', N'12053', N'34601', 28.5397, -82.401282, 809, 58, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1012, N'Florida Hospital Fish Memorial', 1, NULL, NULL, N'100072', NULL, NULL, 0, 175, NULL, N'3869175000', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1055 Saxon Blvd', N'Orange City', N'FL', N'12127', N'32763', 28.911374, -81.283673, 824, 63, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1013, N'Holy Cross Hospital Inc', 1, NULL, NULL, N'100073', NULL, NULL, 0, 559, NULL, N'9547718000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4725 N Federal Hwy', N'Fort Lauderdale', N'FL', N'12011', N'33308', 26.122308, -80.143379, 831, 55, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1014, N'St Josephs Hospital', 1, NULL, NULL, N'100075', NULL, NULL, 0, 1006, NULL, N'8138704398', NULL, 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3001 W Martin Luther King Jr Blvd', N'Tampa', N'FL', N'12057', N'33677', 27.981218, -82.478254, 901, 70, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1015, N'Metropolitan Hospital Of Miami', 1, NULL, NULL, N'100076', NULL, NULL, 0, 146, NULL, N'3052641000', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5959 Nw 7Th St', N'Miami', N'FL', NULL, N'33126', 25.777919, -80.293084, 861, 61, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1016, N'Bayfront Health Port Charlotte', 1, NULL, NULL, N'100077', NULL, NULL, 0, 254, NULL, N'9417664122', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2500 Harbor Blvd', N'Port Charlotte', N'FL', N'12015', N'33952', 26.988004, -82.096695, 882, 56, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1017, N'University Of Miami Hospital And Clinics', 1, NULL, NULL, N'100079', NULL, NULL, 0, 40, NULL, N'3052431000', NULL, 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1475 Nw 12Th Ave', N'Miami', N'FL', NULL, N'33136', 25.792502, -80.214978, 861, 61, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1018, N'Jfk Medical Center', 1, NULL, NULL, N'100080', NULL, NULL, 0, 460, NULL, N'5619657300', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5301 S Congress Ave', N'Atlantis', N'FL', N'12099', N'33462', 26.590903, -80.100876, 800, 55, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1019, N'Healthmark Regional Medical Center', 1, NULL, NULL, N'100081', NULL, NULL, 0, 50, NULL, N'8509514500', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4413 Us Hwy 331 S', N'Defuniak Springs', N'FL', N'12131', N'32435', 30.721023, -86.115218, 823, 66, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1020, N'Leesburg Regional Medical Center', 1, NULL, NULL, N'100084', NULL, NULL, 0, 316, NULL, N'3523235762', NULL, 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'600 E Dixie Ave', N'Leesburg', N'FL', N'12069', N'34748', 28.789337, -81.8727, 854, 63, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1021, N'Broward Health North', 1, NULL, NULL, N'100086', NULL, NULL, 0, 409, NULL, N'9547866950', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'201 E Sample Rd', N'Pompano Beach', N'FL', N'12011', N'33064', 26.274973, -80.120196, 881, 55, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1022, N'Sarasota Memorial Hospital', 1, NULL, NULL, N'100087', NULL, NULL, 0, 819, NULL, N'9419179000', NULL, 1, 1, 0, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1700 S Tamiami Trl', N'Sarasota', N'FL', N'12115', N'34239', 27.336435, -82.530653, 889, 67, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1023, N'Baptist Medical Center', 1, NULL, NULL, N'100088', NULL, NULL, 0, 901, NULL, N'9042022000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'800 Prudential Dr', N'Jacksonville', N'FL', N'12031', N'32207', 30.316306, -81.66055, 843, 59, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1024, N'Flagler Hospital', 1, NULL, NULL, N'100090', NULL, NULL, 0, 335, NULL, N'9048194426', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'400 Health Park Blvd', N'Saint Augustine', N'FL', N'12109', N'32086', 29.894691, -81.314517, 894, 59, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1025, N'Wuesthoff Medical Center  Rockledge', 1, NULL, NULL, N'100092', NULL, NULL, 0, 298, NULL, N'3216372603', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'110 Longwood Ave', N'Rockledge', N'FL', N'12009', N'32955', 28.334617, -80.724413, 886, 63, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1026, N'Baptist Hospital', 1, NULL, NULL, N'100093', NULL, NULL, 0, 569, NULL, N'8504344011', NULL, 1, 0, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1000 W Moreno St', N'Pensacola', N'FL', N'12033', N'32501', 30.428397, -87.22192, 878, 66, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1027, N'Lake Wales Medical Center', 1, NULL, NULL, N'100099', NULL, NULL, 0, 160, NULL, N'8636761433', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'410 S 11Th St', N'Lake Wales', N'FL', N'12105', N'33853', 27.896462, -81.564758, 851, 63, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1028, N'Shands Lake Shore Regional Medical Center', 1, NULL, NULL, N'100102', NULL, NULL, 0, 99, NULL, N'3862928000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'368 Ne Franklin St', N'Lake City', N'FL', N'12023', N'32055', 30.189676, -82.63929, 850, 57, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1029, N'Indian River Medical Center', 1, NULL, NULL, N'100105', NULL, NULL, 0, 339, NULL, N'7725674311', NULL, 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1000 36Th St', N'Vero Beach', N'FL', N'12061', N'32960', 27.638716, -80.39754, 906, 63, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1030, N'Doctor''s Memorial Hospital Inc', 1, NULL, NULL, N'100106', NULL, NULL, 0, 48, NULL, N'8505840800', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'333 N Byron Butler Pkwy', N'Perry', N'FL', N'12123', N'32348', 30.117435, -83.581815, 899, 69, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1031, N'Lehigh Regional Medical Center', 1, NULL, NULL, N'100107', NULL, NULL, 0, 88, NULL, N'2393692101', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1500 Lee Blvd', N'Lehigh Acres', N'FL', N'12071', N'33936', 26.602983, -81.638944, 855, 56, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1032, N'Florida Hospital Heartland Medical Center', 1, NULL, NULL, N'100109', NULL, NULL, 0, 197, NULL, N'8633144466', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4200 Sun N Lake Blvd', N'Sebring', N'FL', N'12055', N'33871', 27.495745, -81.441042, 891, 63, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1033, N'Osceola Regional Medical Center', 1, NULL, NULL, N'100110', NULL, NULL, 0, 257, NULL, N'4078462266', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'700 West Oak Street', N'Kissimmee', N'FL', N'12097', N'34741', 28.292025, -81.407801, 849, 63, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1034, N'Uf Health Shands Hospital', 1, NULL, NULL, N'100113', NULL, NULL, 0, 996, NULL, N'3522658000', NULL, 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1600 Sw Archer Rd', N'Gainesville', N'FL', N'12001', N'32610', 29.651907, -82.324798, 835, 57, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1035, N'Baptist Medical Center  Beaches', 1, NULL, NULL, N'100117', NULL, NULL, 0, 146, NULL, N'9042472900', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1350 13Th Ave S', N'Jacksonville Beach', N'FL', N'12031', N'32250', 30.274661, -81.39752, 844, 59, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1036, N'Florida Hospital Flagler', 1, NULL, NULL, N'100118', NULL, NULL, 0, 99, NULL, N'3865862000', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'60 Memorial Medical Pkwy', N'Palm Coast', N'FL', N'12035', N'32164', 29.478844, -81.190699, 810, 64, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1037, N'Bartow Regional Medical Center', 1, NULL, NULL, N'100121', NULL, NULL, 0, 72, NULL, N'8635338111', N'8635191420', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2200 Osprey Blvd', N'Bartow', N'FL', N'12105', N'33831', 27.898184, -81.785636, 802, 60, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1038, N'North Okaloosa Medical Center', 1, NULL, NULL, N'100122', NULL, NULL, 0, 110, NULL, N'8506898100', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'151 Redstone Ave Se', N'Crestview', N'FL', N'12091', N'32539', 30.762133, -86.570508, 819, 66, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1039, N'Santa Rosa Medical Center', 1, NULL, NULL, N'100124', NULL, NULL, 0, 129, NULL, N'8506267762', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6002 Berryhill Rd', N'Milton', N'FL', N'12113', N'32570', 30.625792, -87.048432, 863, 66, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1040, N'Homestead Hospital', 1, NULL, NULL, N'100125', NULL, NULL, 0, 142, NULL, N'7862438000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'975 Baptist Way', N'Homestead', N'FL', NULL, N'33033', 25.468722, -80.477557, 861, 61, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1041, N'Palms Of Pasadena Hospital', 1, NULL, NULL, N'100126', NULL, NULL, 0, 307, NULL, N'7273811000', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1501 Pasadena Ave S', N'Saint Petersburg', N'FL', N'12103', N'33707', 27.767514, -82.733119, 896, 68, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1042, N'Morton Plant Hospital', 1, NULL, NULL, N'100127', NULL, NULL, 0, 687, NULL, N'7274627000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'300 Pinellas St', N'Clearwater', N'FL', N'12103', N'33756', 27.951679, -82.785495, 813, 54, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1043, N'Tampa General Hospital', 1, NULL, NULL, N'100128', NULL, NULL, 0, 1018, NULL, N'8138447000', NULL, 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1 Tampa General Cir', N'Tampa', N'FL', N'12057', N'33606', 27.94776, -82.458444, 901, 70, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1044, N'Lakeside Medical Center', 1, NULL, NULL, N'100130', NULL, NULL, 0, 70, NULL, N'5619966571', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'39200 Hooker Hwy', N'Belle Glade', N'FL', N'12099', N'33430', 26.725704, -80.683908, 803, 55, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1045, N'Aventura Hospital And Medical Center', 1, NULL, NULL, N'100131', NULL, NULL, 0, 407, NULL, N'3056827000', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'20900 Biscayne Blvd', N'Aventura', N'FL', NULL, N'33180', 25.969814, -80.144768, 861, 61, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1046, N'South Florida Baptist Hospital', 1, NULL, NULL, N'100132', NULL, NULL, 0, 147, NULL, N'8137571200', NULL, 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'301 N Alexander St', N'Plant City', N'FL', N'12057', N'33563', 28.015645, -82.13805, 879, 60, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1047, N'Ed Fraser Memorial Hospital', 1, NULL, NULL, N'100134', NULL, NULL, 0, 25, NULL, N'9042593151', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'159 N 3Rd St', N'Macclenny', N'FL', N'12003', N'32063', 30.285801, -82.1195, 843, 59, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1048, N'Tallahassee Memorial Hospital', 1, NULL, NULL, N'100135', NULL, NULL, 0, 772, NULL, N'8504311155', NULL, 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1300 Miccosukee Rd', N'Tallahassee', N'FL', N'12073', N'32308', 30.457632, -84.261044, 899, 69, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1049, N'Heart Of Florida Regional Medical Center', 1, NULL, NULL, N'100137', NULL, NULL, 0, 193, NULL, N'8634224971', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'40100 Us Hwy 27 N', N'Davenport', N'FL', N'12105', N'33837', 28.161405, -81.601742, 908, 63, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1050, N'Baptist Medical Center - Nassau', 1, NULL, NULL, N'100140', NULL, NULL, 0, 62, NULL, N'9043213500', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1250 S 18Th St', N'Fernandina Beach', N'FL', N'12089', N'32034', 30.652499, -81.44943, 830, 59, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1051, N'Jackson Hospital', 1, NULL, NULL, N'100142', NULL, NULL, 0, 100, NULL, N'8507182620', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4250 Hospital Dr', N'Marianna', N'FL', N'12063', N'32446', 30.786352, -85.240992, 859, 2, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1052, N'Lower Keys Medical Center', 1, NULL, NULL, N'100150', NULL, NULL, 0, 167, NULL, N'3052945531', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5900 College Road', N'Key West', N'FL', N'12087', N'33040', 24.580902, -81.74296, 848, 61, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1053, N'Mayo Clinic', 1, NULL, NULL, N'100151', NULL, NULL, 0, 304, NULL, N'9049532000', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4500 San Pablo Rd', N'Jacksonville', N'FL', N'12031', N'32224', 30.313431, -81.447723, 843, 59, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1054, N'South Miami Hospital', 1, NULL, NULL, N'100154', NULL, NULL, 0, 452, NULL, N'7866624000', NULL, 1, 1, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6200 Sw 73Rd St', N'South Miami', N'FL', NULL, N'33143', 25.702937, -80.2935, 892, 61, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1055, N'Lake City Medical Center', 1, NULL, NULL, N'100156', NULL, NULL, 0, 67, NULL, N'3867199000', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'340 Nw Commerce Dr', N'Lake City', N'FL', N'12023', N'32055', 30.183596, -82.686296, 850, 57, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1056, N'Lakeland Regional Medical Center', 1, NULL, NULL, N'100157', NULL, NULL, 0, 851, NULL, N'8636871100', NULL, 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1324 Lakeland Hills Blvd', N'Lakeland', N'FL', N'12105', N'33805', 28.061256, -81.953344, 852, 60, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1057, N'Central Florida Regional Hospital', 1, NULL, NULL, N'100161', NULL, NULL, 0, 221, NULL, N'4073214500', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1401 W Seminole Blvd', N'Sanford', N'FL', N'12117', N'32771', 28.811718, -81.268033, 888, 63, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1058, N'Doctors Hospital Of Sarasota', 1, NULL, NULL, N'100166', NULL, NULL, 0, 155, NULL, N'9413421100', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5731 Bee Ridge Rd', N'Sarasota', N'FL', N'12115', N'34233', 27.298933, -82.455376, 889, 67, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1059, N'Plantation General Hospital', 1, NULL, NULL, N'100167', NULL, NULL, 0, 737, NULL, N'9545875010', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'401 Nw 42Nd Ave', N'Plantation', N'FL', N'12011', N'33317', 26.12793, -80.204323, 880, 55, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1060, N'Boca Raton Regional Hospital', 1, NULL, NULL, N'100168', NULL, NULL, 0, 400, NULL, N'5613625002', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'800 Meadows Rd', N'Boca Raton', N'FL', N'12099', N'33486', 26.358689, -80.083098, 805, 55, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1061, N'Florida Hospital Tampa', 1, NULL, NULL, N'100173', NULL, NULL, 0, 493, NULL, N'8136157200', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3100 E Fletcher Ave', N'Tampa', N'FL', N'12057', N'33613', 28.06927, -82.397626, 901, 70, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1062, N'Desoto Memorial Hospital', 1, NULL, NULL, N'100175', NULL, NULL, 0, 49, NULL, N'8634943535', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'900 N Robert Ave', N'Arcadia', N'FL', N'12027', N'34265', 27.215883, -81.858416, 799, 67, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1063, N'Palm Beach Gardens Medical Center', 1, NULL, NULL, N'100176', NULL, NULL, 0, 199, NULL, N'5616221411', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3360 Burns Rd', N'Palm Beach Gardens', N'FL', N'12099', N'33410', 26.830602, -80.087425, 875, 55, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1064, N'Cape Canaveral Hospital', 1, NULL, NULL, N'100177', NULL, NULL, 0, 150, NULL, N'3217997111', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'701 W Cocoa Beach Causeway', N'Cocoa Beach', N'FL', N'12009', N'32932', 28.357947, -80.623712, 816, 63, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1065, N'Memorial Hospital Jacksonville', 1, NULL, NULL, N'100179', NULL, NULL, 0, 418, NULL, N'9043996111', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3625 University Blvd S', N'Jacksonville', N'FL', N'12031', N'32216', 30.289886, -81.602295, 843, 59, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1066, N'St Petersburg General Hospital', 1, NULL, NULL, N'100180', NULL, NULL, 0, 215, NULL, N'7273841414', NULL, 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6500 38Th Ave N', N'Saint Petersburg', N'FL', N'12103', N'33710', 27.806262, -82.728494, 896, 68, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1067, N'Larkin Community Hospital', 1, NULL, NULL, N'100181', NULL, NULL, 0, 146, NULL, N'3052847500', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7031 Sw 62Nd Ave', N'South Miami', N'FL', NULL, N'33143', 25.705578, -80.293394, 892, 61, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1068, N'Coral Gables Hospital', 1, NULL, NULL, N'100183', NULL, NULL, 0, 245, NULL, N'3054458461', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3100 Douglas Rd', N'Coral Gables', N'FL', NULL, N'33134', 25.768211, -80.255285, 861, 61, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1069, N'Palmetto General Hospital', 1, NULL, NULL, N'100187', NULL, NULL, 0, 360, NULL, N'3058235000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2001 W 68Th St', N'Hialeah', N'FL', NULL, N'33016', 25.884157, -80.324123, 838, 61, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1070, N'Northwest Medical Center', 1, NULL, NULL, N'100189', NULL, NULL, 0, 223, NULL, N'9549740400', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2801 N State Rd 7', N'Margate', N'FL', N'12011', N'33063', 26.242509, -80.214148, 858, 55, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1071, N'Medical Center Of Trinity', 1, NULL, NULL, N'100191', NULL, NULL, 0, 282, NULL, N'7278481733', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'9332 Sr 54 Ste 401', N'Trinity', N'FL', N'12101', N'34655', 28.180846, -82.681766, 865, 58, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1072, N'Broward Health Imperial Point', 1, NULL, NULL, N'100200', NULL, NULL, 0, 204, NULL, N'9547768500', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6401 N Federal Hwy', N'Fort Lauderdale', N'FL', N'12011', N'33308', 26.122308, -80.143379, 831, 55, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1073, N'North Florida Regional Medical Center', 1, NULL, NULL, N'100204', NULL, NULL, 0, 353, NULL, N'3523334100', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6500 Newberry Rd', N'Gainesville', N'FL', N'12001', N'32605', 29.652645, -82.381528, 835, 57, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1074, N'Memorial Hospital Of Tampa', 1, NULL, NULL, N'100206', NULL, NULL, 0, 183, NULL, N'8138736400', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2901 W Swann Ave', N'Tampa', N'FL', N'12057', N'33609', 27.937515, -82.489357, 901, 70, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1075, N'Kendall Regional Medical Center', 1, NULL, NULL, N'100209', NULL, NULL, 0, 417, NULL, N'3052233000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'11750 Bird Rd', N'Miami', N'FL', NULL, N'33175', 25.735042, -80.255024, 861, 61, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1076, N'Bayfront Health Dade City', 1, NULL, NULL, N'100211', NULL, NULL, 0, 120, NULL, N'3525683174', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'13100 Ft King Rd', N'Dade City', N'FL', N'12101', N'33525', 28.364725, -82.195918, 821, 70, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1077, N'Ocala Regional Medical Center', 1, NULL, NULL, N'100212', NULL, NULL, 0, 270, NULL, N'3524011000', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1431 Sw 1St Ave', N'Ocala', N'FL', N'12083', N'34478', 29.168791, -82.137293, 868, 62, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1078, N'Blake Medical Center', 1, NULL, NULL, N'100213', NULL, NULL, 0, 383, NULL, N'9417926611', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2020 59Th St W', N'Bradenton', N'FL', N'12081', N'34209', 27.482107, -82.620562, 807, 53, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1079, N'Sebastian River Medical Center', 1, NULL, NULL, N'100217', NULL, NULL, 0, 154, NULL, N'7725893187', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'13695 Us Hwy 1', N'Sebastian', N'FL', N'12061', N'32978', 27.816415, -80.470608, 890, 63, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1080, N'Gulf Coast Medical Center Lee Mem Health System', 1, NULL, NULL, N'100220', NULL, NULL, 0, 349, NULL, N'2397685000', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'13681 Doctor''s Way', N'Fort Myers', N'FL', N'12071', N'33912', 26.640628, -81.872308, 832, 56, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1081, N'Fort Walton Beach Medical Center', 1, NULL, NULL, N'100223', NULL, NULL, 0, 257, NULL, N'8508621111', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1000 Mar-Walt Dr', N'Fort Walton Beach', N'FL', N'12091', N'32547', 30.405755, -86.618842, 834, 66, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1082, N'University Hospital And Medical Center', 1, NULL, NULL, N'100224', NULL, NULL, 0, 317, NULL, N'9547212200', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7201 N University Dr', N'Tamarac', N'FL', N'12011', N'33321', 26.211508, -80.252452, 900, 55, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1083, N'Orange Park Medical Center', 1, NULL, NULL, N'100226', NULL, NULL, 0, 297, NULL, N'9042768500', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2001 Kingsley Ave', N'Orange Park', N'FL', N'12019', N'32073', 30.165358, -81.720807, 870, 59, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1084, N'Westside Regional Medical Center', 1, NULL, NULL, N'100228', NULL, NULL, 0, 224, NULL, N'9544736600', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'8201 W Broward Blvd', N'Plantation', N'FL', N'12011', N'33324', 26.12083, -80.259401, 880, 55, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1085, N'Memorial Hospital Pembroke', 1, NULL, NULL, N'100230', NULL, NULL, 0, 301, NULL, N'9549629650', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7800 Sheridan St', N'Pembroke Pines', N'FL', N'12011', N'33024', 26.031033, -80.244573, 839, 61, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1086, N'West Florida Hospital', 1, NULL, NULL, N'100231', NULL, NULL, 0, 515, NULL, N'8504944000', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'8383 N Davis Hwy', N'Pensacola', N'FL', N'12033', N'32514', 30.483371, -87.222806, 878, 66, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1087, N'Putnam Community Medical Center', 1, NULL, NULL, N'100232', NULL, NULL, 0, 99, NULL, N'3863268500', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'611 Zeagler Dr', N'Palatka', N'FL', N'12107', N'32177', 29.641925, -81.693398, 874, 57, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1088, N'West Palm Hospital', 1, NULL, NULL, N'100234', NULL, NULL, 0, 245, NULL, N'5618446141', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2201 45Th St', N'West Palm Beach', N'FL', N'12099', N'33407', 26.75903, -80.088822, 907, 55, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1089, N'Fawcett Memorial Hospital', 1, NULL, NULL, N'100236', NULL, NULL, 0, 237, NULL, N'9416291181', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'21298 Olean Blvd', N'Port Charlotte', N'FL', N'12015', N'33952', 26.987963, -82.096928, 882, 56, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1090, N'Northside Hospital', 1, NULL, NULL, N'100238', NULL, NULL, 0, 288, NULL, N'8135215000', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6000 49Th St N', N'Saint Petersburg', N'FL', N'12103', N'33709', 27.794627, -82.69993, 896, 68, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1091, N'Anne Bates Leach Eye Hospital', 1, NULL, NULL, N'100240', NULL, NULL, 0, 100, NULL, N'3053266000', NULL, 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'900 Nw 17Th St', N'Miami', N'FL', NULL, N'33136', 25.791325, -80.210351, 861, 61, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1092, N'Gulf Coast Regional Medical Center', 1, NULL, NULL, N'100242', NULL, NULL, 0, 218, NULL, N'8507477926', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'449 W 23Rd St', N'Panama City', N'FL', N'12005', N'32405', 30.189624, -85.667443, 876, 65, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1093, N'Brandon Regional Hospital', 1, NULL, NULL, N'100243', NULL, NULL, 0, 398, NULL, N'8136815551', NULL, 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'119 Oakfield Dr', N'Brandon', N'FL', N'12057', N'33511', 27.93384, -82.288313, 808, 70, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1094, N'Cape Coral Hospital', 1, NULL, NULL, N'100244', NULL, NULL, 0, 291, NULL, N'2395742323', NULL, 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'636 Del Prado Blvd', N'Cape Coral', N'FL', N'12071', N'33990', 26.606923, -81.980263, 811, 56, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1095, N'Lawnwood Regional Medical Center & Heart Institute', 1, NULL, NULL, N'100246', NULL, NULL, 0, 370, NULL, N'7724614000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1700 S 23Rd St', N'Fort Pierce', N'FL', N'12111', N'34950', 27.430465, -80.3473, 833, 63, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1096, N'Largo Medical Center', 1, NULL, NULL, N'100248', NULL, NULL, 0, 425, NULL, N'7275885200', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'201 14Th St Sw', N'Largo', N'FL', N'12103', N'33770', 27.914858, -82.802742, 853, 54, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1097, N'Seven Rivers Regional Medical Center', 1, NULL, NULL, N'100249', NULL, NULL, 0, 128, NULL, N'3527956560', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6201 N Suncoast Blvd', N'Crystal River', N'FL', N'12017', N'34428', 28.902479, -82.592601, 820, 62, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1098, N'Raulerson Hospital', 1, NULL, NULL, N'100252', NULL, NULL, 0, 100, NULL, N'8637632151', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1796 Hwy 441 North', N'Okeechobee', N'FL', N'12093', N'34972', 27.243935, -80.829783, 869, 63, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1099, N'Jupiter Medical Center', 1, NULL, NULL, N'100253', NULL, NULL, 0, 163, NULL, N'5617472234', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1210 S Old Dixie Hwy', N'Jupiter', N'FL', N'12099', N'33458', 26.925728, -80.094513, 847, 55, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1100, N'Capital Regional Medical Center', 1, NULL, NULL, N'100254', NULL, NULL, 0, 246, NULL, N'8506565000', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2626 Capital Medical Blvd', N'Tallahassee', N'FL', N'12073', N'32308', 30.475924, -84.231969, 899, 69, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1101, N'Tampa Community Hospital', 1, NULL, NULL, N'100255', NULL, NULL, 0, 201, NULL, N'8138827159', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6001 Webb Rd', N'Tampa', N'FL', N'12057', N'33615', 27.94776, -82.458444, 901, 70, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1102, N'Regional Medical Center Bayonet Point', 1, NULL, NULL, N'100256', NULL, NULL, 0, 290, NULL, N'7278192929', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'14000 Fivay Rd', N'Hudson', N'FL', N'12101', N'34667', 28.361789, -82.690676, 841, 58, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1103, N'Delray Medical Center', 1, NULL, NULL, N'100258', NULL, NULL, 0, 493, NULL, N'5614984440', NULL, 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5352 Linton Blvd', N'Delray Beach', N'FL', N'12099', N'33484', 26.43949, -80.114478, 825, 55, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1104, N'South Bay Hospital', 1, NULL, NULL, N'100259', NULL, NULL, 0, 112, NULL, N'8136343301', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4016 Sun City Center Blvd', N'Sun City Center', N'FL', N'12057', N'33573', 27.712187, -82.362014, 898, 70, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1105, N'St Lucie Medical Center', 1, NULL, NULL, N'100260', NULL, NULL, 0, 229, NULL, N'7723354000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1800 Se Tiffany Ave', N'Port Saint Lucie', N'FL', N'12111', N'34952', 27.288898, -80.295566, 884, 55, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1106, N'Oak Hill Hospital', 1, NULL, NULL, N'100264', NULL, NULL, 0, 262, NULL, N'3525966632', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'11375 Cortez Blvd', N'Brooksville', N'FL', N'12053', N'34613', 28.551936, -82.422739, 893, 58, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1107, N'Mease Countryside Hospital', 1, NULL, NULL, N'100265', NULL, NULL, 0, 300, NULL, N'7277346950', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3231 Mcmullen Booth Rd', N'Safety Harbor', N'FL', N'12103', N'34695', 28.040326, -82.708971, 887, 54, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1108, N'Gulf Breeze Hospital', 1, NULL, NULL, N'100266', NULL, NULL, 0, 77, NULL, N'8509342000', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1110 Gulf Breeze Pkwy', N'Gulf Breeze', N'FL', N'12113', N'32561', 30.35767, -87.160203, 837, 66, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1109, N'Englewood Community Hospital', 1, NULL, NULL, N'100267', NULL, NULL, 0, 100, NULL, N'9414756571', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'700 Medical Blvd', N'Englewood', N'FL', N'12115', N'34223', 26.949059, -82.327779, 828, 67, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1110, N'West Boca Medical Center', 1, NULL, NULL, N'100268', NULL, NULL, 0, 195, NULL, N'5614888000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'21644 State Rd 7', N'Boca Raton', N'FL', N'12099', N'33428', 26.571774, -80.205794, 805, 55, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1111, N'Palms West Hospital', 1, NULL, NULL, N'100269', NULL, NULL, 0, 204, NULL, N'5617534245', NULL, 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'13001 Southern Blvd', N'Loxahatchee', N'FL', N'12099', N'33470', 26.683677, -80.27977, 907, 55, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1112, N'H Lee Moffitt Cancer Center & Research Institute I', 1, NULL, NULL, N'100271', NULL, NULL, 0, 206, NULL, N'8139793054', NULL, 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'12902 Magnolia Dr', N'Tampa', N'FL', N'12057', N'33612', 28.062422, -82.419564, 901, 70, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1113, N'Wellington Regional Medical Center', 1, NULL, NULL, N'100275', NULL, NULL, 0, 233, NULL, N'5617988500', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'10101 Forest Hill Blvd', N'Wellington', N'FL', N'12099', N'33414', 26.651702, -80.219363, 907, 55, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1114, N'Broward Health Coral Springs', 1, NULL, NULL, N'100276', NULL, NULL, 0, 200, NULL, N'9543443000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3000 Coral Hills Dr', N'Coral Springs', N'FL', N'12011', N'33065', 26.268204, -80.254235, 818, 55, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1115, N'Douglas Gardens Hospital', 1, NULL, NULL, N'100277', NULL, NULL, 0, 32, NULL, N'3057518626', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5200 Ne 2Nd Ave', N'Miami', N'FL', NULL, N'33137', 25.823547, -80.191877, 861, 61, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1116, N'Memorial Hospital West', 1, NULL, NULL, N'100281', NULL, NULL, 0, 384, NULL, N'9544365000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'703 N Flamingo Rd', N'Pembroke Pines', N'FL', N'12011', N'33028', 26.009478, -80.311972, 877, 61, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1117, N'Westchester General Hospital', 1, NULL, NULL, N'100284', NULL, NULL, 0, 125, NULL, N'3052639270', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2500 Sw 75Th Ave', N'Miami', N'FL', NULL, N'33155', 25.74716, -80.317313, 861, 61, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1118, N'Memorial Hospital Miramar', 1, NULL, NULL, N'100285', NULL, NULL, 0, 178, NULL, N'9545384810', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1901 Sw 172Nd Ave', N'Miramar', N'FL', N'12011', N'33029', 25.99116, -80.376256, 877, 61, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1119, N'Physicians Regional Medical Center - Pine Ridge', 1, NULL, NULL, N'100286', NULL, NULL, 0, 201, NULL, N'2393484000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6101 Pine Ridge Road', N'Naples', N'FL', N'12021', N'34119', 26.211719, -81.751579, 864, 56, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1120, N'Good Samaritan Medical Center', 1, NULL, NULL, N'100287', NULL, NULL, 0, 333, NULL, N'5616555511', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1309 N Flagler Dr', N'West Palm Beach', N'FL', N'12099', N'33401', 26.724993, -80.051567, 907, 55, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1121, N'St Mary''s Medical Center', 1, NULL, NULL, N'100288', NULL, NULL, 0, 464, NULL, N'5618406202', NULL, 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'901 45Th St', N'West Palm Beach', N'FL', N'12099', N'33407', 26.753202, -80.062815, 907, 55, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1122, N'Cleveland Clinic Hospital', 1, NULL, NULL, N'100289', NULL, NULL, 0, 155, NULL, N'9546895000', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3100 Weston Rd', N'Weston', N'FL', N'12011', N'33331', 26.081582, -80.364492, 877, 61, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1123, N'Villages Regional Hospital The', 1, NULL, NULL, N'100290', NULL, NULL, 0, 223, NULL, N'3527518000', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1451 El Camino Real', N'The Villages', N'FL', N'12119', N'32159', 26.462296, -80.152822, 854, 63, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1124, N'Wuesthoff Medical Center - Melbourne', 1, NULL, NULL, N'100291', NULL, NULL, 0, 119, NULL, N'3217521200', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'250 North Wickham Road', N'Melbourne', N'FL', N'12009', N'32935', 28.109032, -80.674423, 860, 63, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1125, N'Sacred Heart Hospital On The Emerald Coast', 1, NULL, NULL, N'100292', NULL, NULL, 0, 58, NULL, N'8502783600', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7800 Us Hwy 98 W', N'Miramar Beach', N'FL', N'12131', N'32550', 30.374367, -86.358558, 826, 66, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1126, N'Doctors Hospital Inc', 1, NULL, NULL, N'100296', NULL, NULL, 0, 281, NULL, N'3056662111', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5000 University Dr', N'Coral Gables', N'FL', NULL, N'33146', 25.724626, -80.27327, 817, 61, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1127, N'Florida State Hospital Unit 31 Med', 1, NULL, NULL, N'100298', NULL, NULL, 0, 1230, NULL, N'8506637536', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'100 N Main St', N'Chattahoochee', N'FL', N'12039', N'32324', 30.698022, -84.840732, 899, 69, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1128, N'Lakewood Ranch Medical Center', 1, NULL, NULL, N'100299', NULL, NULL, 0, 120, NULL, N'9417822100', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'8330 Lakewood Ranch Blvd', N'Bradenton', N'FL', N'12081', N'34202', 27.458781, -82.432342, 807, 53, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1129, N'St Cloud Regional Medical Center', 1, NULL, NULL, N'100302', NULL, NULL, 0, 84, NULL, N'4074983432', N'4078924835', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2906 17Th Street', N'Saint Cloud', N'FL', N'12097', N'34769', 28.24243, -81.30035, 895, 63, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1130, N'St Vincent''s Medical Center Southside', 1, NULL, NULL, N'100307', NULL, NULL, 0, 311, NULL, N'9042963700', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4201 Belfort Rd', N'Jacksonville', N'FL', N'12031', N'32216', 30.252824, -81.584124, 843, 59, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1131, N'Sacred Heart Hospital On The Gulf', 1, NULL, NULL, N'100313', NULL, NULL, 0, 19, NULL, N'8502295600', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3801 E Hwy 98', N'Port Saint Joe', N'FL', N'12045', N'32456', 29.811876, -85.302974, 883, 65, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1132, N'West Kendall Baptist Hospital', 1, NULL, NULL, N'100314', NULL, NULL, 0, 133, NULL, N'7864672011', N'7864672012', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'9555 Sw 162 Ave', N'Miami', N'FL', NULL, N'33196', 25.774266, -80.193659, 861, 61, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1133, N'Viera Hospital', 1, NULL, NULL, N'100315', NULL, NULL, 0, 84, NULL, N'3214349000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'8745 N Wickham Rd', N'Melbourne', N'FL', N'12009', N'32940', 28.186663, -80.67216, 860, 63, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1134, N'Palm Bay Hospital', 1, NULL, NULL, N'100316', NULL, NULL, 0, 152, NULL, N'3214348000', N'3214348110', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1425 Malabar Rd Ne', N'Palm Bay', N'FL', N'12009', N'32907', 28.033189, -80.642969, 860, 63, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1135, N'Florida Hospital Wesley Chapel', 1, NULL, NULL, N'100319', NULL, NULL, 0, 83, NULL, N'8139295490', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2600 Bruce B Downs Blvd', N'Wesley Chapel', N'FL', N'12101', N'33544', 28.212163, -82.353507, 901, 70, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1136, N'Poinciana Medical Center', 1, NULL, NULL, N'100320', NULL, NULL, 0, 30, NULL, N'4075302000', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'325 Cypress Pkwy', N'Kissimmee', N'FL', N'12097', N'34758', 28.292025, -81.407801, 849, 63, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1137, N'St Vincents Medical Center - Clay County Inc', 1, NULL, NULL, N'100321', NULL, NULL, 0, 64, NULL, N'9043087164', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1670 St Vincents Way', N'Middleburg', N'FL', N'12019', N'32068', 30.068851, -81.860378, 870, 59, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1138, N'Regional General Hospital Williston', 1, NULL, NULL, N'100322', NULL, NULL, 0, 40, NULL, N'3525282801', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'125 Sw 7Th St', N'Williston', N'FL', N'12075', N'32696', 29.384784, -82.455911, 835, 57, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1139, N'Promise Hospital Of Fort Myers', 1, NULL, NULL, N'100324', NULL, NULL, 0, 60, NULL, N'7083634925', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3050 Champion Ring Rd', N'Fort Myers', N'FL', N'12071', N'33905', 26.626135, -81.801349, 832, 56, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1140, N'Florida Hospital Wauchula', 1, NULL, NULL, N'101300', NULL, NULL, 0, 25, NULL, N'8637733101', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'533 Carlton St', N'Wauchula', N'FL', N'12049', N'33873', 27.536385, -81.816545, 801, 63, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1141, N'Shands Live Oak Regional Medical Center', 1, NULL, NULL, N'101301', NULL, NULL, 0, 25, NULL, N'9043621413', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1100 Sw 11Th St', N'Live Oak', N'FL', N'12121', N'32060', 30.294946, -82.98402, 835, 57, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1142, N'Campbellton-Graceville Hospital', 1, NULL, NULL, N'101302', NULL, NULL, 0, 25, NULL, N'8502637201', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5429 College Dr', N'Graceville', N'FL', N'12063', N'32440', 30.963661, -85.505743, 836, 2, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1143, N'Lake Butler Hospital', 1, NULL, NULL, N'101303', NULL, NULL, 0, 25, NULL, N'3864962323', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'850 E Main St', N'Lake Butler', N'FL', N'12125', N'32054', 30.023472, -82.328439, 835, 57, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1144, N'Calhoun-Liberty Hospital Inc', 1, NULL, NULL, N'101304', NULL, NULL, 0, 25, NULL, N'8506743493', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'20370 Ne Burns Ave', N'Blountstown', N'FL', N'12013', N'32424', 30.443529, -85.045195, 804, 69, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1145, N'George E Weems Memorial Hospital', 1, NULL, NULL, N'101305', NULL, NULL, 0, 25, NULL, N'8506538853', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'135 Ave G', N'Apalachicola', N'FL', N'12037', N'32320', 29.724353, -84.992039, 798, 65, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1146, N'Doctors Memorial Hospital', 1, NULL, NULL, N'101307', NULL, NULL, 0, 20, NULL, N'8505471120', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2600 Hospital Dr', N'Bonifay', N'FL', N'12059', N'32425', 30.791856, -85.679653, 327, 2, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1147, N'Northwest Florida Community Hospital', 1, NULL, NULL, N'101308', NULL, NULL, 0, 25, NULL, N'8506381610', NULL, 1, 1, 0, 0, 0, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1360 Brickyard Rd', N'Chipley', N'FL', N'12133', N'32428', 30.764628, -85.542066, 812, 65, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1148, N'Hendry Regional Medical Center', 1, NULL, NULL, N'101309', NULL, NULL, 0, 25, NULL, N'8639023033', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'524 W Sagamore Ave', N'Clewiston', N'FL', N'12051', N'33440', 26.753262, -80.940227, 815, 56, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1149, N'Shands Starke Regional Medical Center', 1, NULL, NULL, N'101310', NULL, NULL, 0, 25, NULL, N'9043682300', NULL, 1, 1, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'922 E Call St', N'Starke', N'FL', N'12007', N'32091', 29.9419, -82.101945, 835, 57, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1150, N'Madison County Memorial Hospital', 1, NULL, NULL, N'101311', NULL, NULL, 0, 25, NULL, N'8509732271', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'309 Ne Marion St', N'Madison', N'FL', N'12079', N'32340', 30.469377, -83.412925, 856, 69, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1151, N'Fishermen''s Hospital', 1, NULL, NULL, N'101312', NULL, NULL, 0, 25, NULL, N'3057435533', N'3057432373', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3301 Overseas Hwy', N'Marathon', N'FL', N'12087', N'33050', 24.710148, -81.094747, 857, 61, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1152, N'Mariners Hospital', 1, NULL, NULL, N'101313', NULL, NULL, 0, 25, NULL, N'3054343000', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'91500 Overseas Highway', N'Tavernier', N'FL', N'12087', N'33070', 25.011519, -80.515061, 903, 61, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1153, N'Daystar Inc', 1, NULL, NULL, N'101993', NULL, NULL, 0, 14, NULL, N'9544730167', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'3800 South Flamingo Road', N'Fort Lauderdale', N'FL', N'12011', N'33330', 26.122308, -80.143379, 877, 61, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1154, N'Select Specialty Hospital-Miami', 1, NULL, NULL, N'102001', NULL, NULL, 0, 47, NULL, N'3054165700', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'955 Nw 3Rd Street 8Th Floor', N'Miami', N'FL', NULL, N'33128', 25.774266, -80.193659, 861, 61, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1155, N'Select Specialty Hospital - Orlando', 1, NULL, NULL, N'102003', NULL, NULL, 0, 75, NULL, N'4073031766', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5579 S Orange Ave', N'Orlando', N'FL', N'12095', N'32809', 28.445126, -81.365269, 871, 63, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1156, N'Kindred Hospital-Bay Area-Tampa', 1, NULL, NULL, N'102009', NULL, NULL, 0, 155, NULL, N'8138396341', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4555 S Manhattan Ave', N'Tampa', N'FL', N'12057', N'33611', 27.898028, -82.518527, 901, 70, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1157, N'Kindred Hospital-South Florida-Ft Lauderdale', 1, NULL, NULL, N'102010', NULL, NULL, 0, 249, NULL, N'9547648900', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1516 E Las Olas Blvd', N'Fort Lauderdale', N'FL', N'12011', N'33301', 26.119325, -80.12825, 831, 55, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1158, N'Specialty Hospital Jacksonville', 1, NULL, NULL, N'102012', NULL, NULL, 0, 107, NULL, N'9047373120', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4901 Richard St', N'Jacksonville', N'FL', N'12031', N'32207', 30.264875, -81.612406, 843, 59, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1159, N'Kindred Hospital-Central Tampa', 1, NULL, NULL, N'102013', NULL, NULL, 0, 102, NULL, N'8138747575', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4801 N Howard Ave', N'Tampa', N'FL', N'12057', N'33603', 27.990707, -82.482441, 901, 70, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1160, N'Kindred Hospital-North Florida', 1, NULL, NULL, N'102015', NULL, NULL, 0, 80, NULL, N'9042849230', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'801 Oak St', N'Green Cove Springs', N'FL', N'12019', N'32043', 29.988295, -81.682817, 870, 59, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1161, N'Sister Emmanuel Hospital', 1, NULL, NULL, N'102016', NULL, NULL, 0, 29, NULL, N'3052852939', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3663 S Miami Ave 4Th Floor', N'Miami', N'FL', NULL, N'33133', 25.774266, -80.193659, 861, 61, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1162, N'Select Specialty Hospital-Panama City Inc', 1, NULL, NULL, N'102017', NULL, NULL, 0, 30, NULL, N'8507673180', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'615 N Bonita Ave', N'Panama City', N'FL', N'12005', N'32401', 30.159151, -85.647168, 876, 65, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1163, N'Complex Care Hospital At Ridgelake', 1, NULL, NULL, N'102018', NULL, NULL, 0, 40, NULL, N'9413423200', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6150 Edgelake Dr', N'Sarasota', N'FL', N'12115', N'34240', 27.336435, -82.530653, 889, 67, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1164, N'Kindred Hospital Ocala', 1, NULL, NULL, N'102019', NULL, NULL, 0, 31, NULL, N'3523690513', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1500 Sw 1St Avenue 5Th Floor', N'Ocala', N'FL', N'12083', N'34474', 29.187199, -82.140092, 868, 62, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1165, N'Select Specialty Hospital - Tallahassee', 1, NULL, NULL, N'102020', NULL, NULL, 0, 29, NULL, N'8502196800', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1554 Surgeons Dr', N'Tallahassee', N'FL', N'12073', N'32308', 30.459277, -84.260105, 899, 69, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1166, N'Baycare Alliant Hospital', 1, NULL, NULL, N'102021', NULL, NULL, 0, 48, NULL, N'7277346302', NULL, 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'601 Main St', N'Dunedin', N'FL', N'12103', N'34698', 28.014078, -82.783616, 827, 54, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1167, N'Select Specialty Hospital Gainesville Inc', 1, NULL, NULL, N'102022', NULL, NULL, 0, 44, NULL, N'3525865303', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2708 Sw Archer Rd', N'Gainesville', N'FL', N'12001', N'32608', 29.651907, -82.324798, 835, 57, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1168, N'Select Specialty Hospital-Palm Beach', 1, NULL, NULL, N'102023', NULL, NULL, 0, 60, NULL, N'5613577200', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3060 Melaleuca Lane', N'Lake Worth', N'FL', N'12099', N'33461', 26.606222, -80.090421, 800, 55, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1169, N'Select Specialty Hospital Pensacola', 1, NULL, NULL, N'102024', NULL, NULL, 0, 54, NULL, N'8504795938', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7000 Cobble Creek Dr', N'Pensacola', N'FL', N'12033', N'32504', 30.478514, -87.215681, 878, 66, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1170, N'Kindred Hospital The Palm Beaches', 1, NULL, NULL, N'102025', NULL, NULL, 0, 70, NULL, N'5618400754', N'5618420271', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5555 W Blue Heron Blvd', N'Riviera Beach', N'FL', N'12099', N'33418', 26.783176, -80.09488, 875, 55, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1171, N'Florida Hospital At Connerton Long Term Acute Care', 1, NULL, NULL, N'102026', NULL, NULL, 0, 50, NULL, N'8139716000', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'9441 Health Center Dr', N'Land O Lakes', N'FL', N'12101', N'34637', 28.218899, -82.457594, 901, 70, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1172, N'Kindred Hospital Melbourne', 1, NULL, NULL, N'102027', NULL, NULL, 0, 60, NULL, N'3217335725', N'3217335799', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'765 W Nasa Blvd', N'Melbourne', N'FL', N'12009', N'32901', 28.092833, -80.634551, 860, 63, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1173, N'Promise Hospital Of Florida At The Villages', 1, NULL, NULL, N'102028', NULL, NULL, 0, 40, NULL, N'5618693100', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5050 County Road 472', N'Oxford', N'FL', N'12119', N'34484', 28.48043, -81.576346, 868, 62, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1174, N'St Catherine''s Rehabilitation Hospital', 1, NULL, NULL, N'103026', NULL, NULL, 0, 62, NULL, N'3058918850', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1050 Ne 125Th St', N'North Miami', N'FL', NULL, N'33161', 25.890566, -80.177316, 861, 61, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1175, N'St Anthony''s Rehabilitation Hospital', 1, NULL, NULL, N'103027', NULL, NULL, 0, 26, NULL, N'9547396233', NULL, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'3487 Nw 30Th St', N'Lauderdale Lakes', N'FL', N'12011', N'33311', 26.162625, -80.193159, 831, 55, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1176, N'Healthsouth Sunrise Rehab Hospital', 1, NULL, NULL, N'103028', NULL, NULL, 0, 126, NULL, N'9547490300', NULL, 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4399 Nob Hill Rd', N'Sunrise', N'FL', N'12011', N'33351', 26.165374, -80.283639, 831, 55, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1177, N'Healthsouth Rehabilitation Hospital Of Sarasota', 1, NULL, NULL, N'103031', NULL, NULL, 0, 96, NULL, N'9419218600', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6400 Edgelake Dr', N'Sarasota', N'FL', N'12115', N'34240', 27.336435, -82.530653, 889, 67, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1178, N'Healthsouth Treasure Coast Rehabilitation Hospital', 1, NULL, NULL, N'103032', NULL, NULL, 0, 80, NULL, N'7727782100', NULL, 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1600 37Th St', N'Vero Beach', N'FL', N'12061', N'32960', 27.638716, -80.39754, 906, 63, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1179, N'Healthsouth Rehabilitation Hospital Of Tallahassee', 1, NULL, NULL, N'103033', NULL, NULL, 0, 76, NULL, N'8506564800', NULL, 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1675 Riggins Rd', N'Tallahassee', N'FL', N'12073', N'32308', 30.459551, -84.237068, 899, 69, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1180, N'Healthsouth Sea Pines Rehabilitation Hospital', 1, NULL, NULL, N'103034', NULL, NULL, 0, 90, NULL, N'3219844600', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'101 E Florida Avenue', N'Melbourne', N'FL', N'12009', N'32901', 28.056861, -80.620654, 860, 63, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1181, N'West Gables Rehabilitation Hospital', 1, NULL, NULL, N'103036', NULL, NULL, 0, 60, NULL, N'3052601816', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2525 Sw 75Th Ave', N'Miami', N'FL', NULL, N'33155', 25.747354, -80.317108, 861, 61, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1182, N'Healthsouth Rehabilitation Hospital Of Largo', 1, NULL, NULL, N'103037', NULL, NULL, 0, 70, NULL, N'7275862999', NULL, 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'901 Clearwater Largo Rd N', N'Largo', N'FL', N'12103', N'34641', 27.925106, -82.796338, NULL, NULL, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1183, N'Healthsouth Rehabilitation Hospital Of Miami', 1, NULL, NULL, N'103038', NULL, NULL, 0, 60, NULL, N'3052513800', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'20601 Old Cutler Rd', N'Miami', N'FL', NULL, N'33189', 25.576507, -80.34019, 861, 61, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1184, N'Brooks Rehabilitation Hospital', 1, NULL, NULL, N'103039', NULL, NULL, 0, 157, NULL, N'9048587625', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3599 University Blvd S', N'Jacksonville', N'FL', N'12031', N'32216', 30.2902, -81.602079, 843, 59, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1185, N'Healthsouth Emerald Coast Rehabilitation Hospital', 1, NULL, NULL, N'103040', NULL, NULL, 0, 75, NULL, N'8509148653', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1847 Florida Ave', N'Panama City', N'FL', N'12005', N'32403', 30.182189, -85.668334, 876, 65, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1186, N'Healthsouth Rehab Hosp Of Spring Hill', 1, NULL, NULL, N'103042', NULL, NULL, 0, 80, NULL, N'3525924250', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'12440 Cortez Blvd', N'Brooksville', N'FL', N'12053', N'34613', 28.551936, -82.422739, 893, 58, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1187, N'Healthsouth Rehab Hospital Of Ocala', 1, NULL, NULL, N'103043', NULL, NULL, 0, 40, NULL, N'3522824000', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2275 Sw 22Nd Lane', N'Ocala', N'FL', N'12083', N'34471', 29.187199, -82.140092, 868, 62, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1188, N'Healthsouth Rehabilitation Hospital At Martin Heal', 1, NULL, NULL, N'103044', NULL, NULL, 0, 34, NULL, N'7723243522', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5850 Se Community Dr', N'Stuart', N'FL', N'12085', N'34997', 27.197983, -80.251917, 897, 55, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1189, N'Healthsouth Rehabilitation Hospital Of Altamonte S', 1, NULL, NULL, N'103045', NULL, NULL, 0, 50, NULL, N'4075878600', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'831 S State Rd 434', N'Altamonte', N'FL', N'12117', N'32714', 28.664906, -81.376269, 871, 63, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1190, N'All Children''s Hospital Inc', 1, NULL, NULL, N'103300', NULL, NULL, 0, 259, NULL, N'8138987451', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'501 Sixth Avenue South', N'Saint Petersburg', N'FL', N'12103', N'33701', 27.770861, -82.679266, 896, 68, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1191, N'Miami Children''s Hospital', 1, NULL, NULL, N'103301', NULL, NULL, 0, 289, NULL, N'3056666511', NULL, 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3100 Sw 62Nd Ave', N'Miami', N'FL', NULL, N'33155', 25.745407, -80.295306, 861, 61, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1192, N'Shriners Hospitals For Children-Tampa', 1, NULL, NULL, N'103303', NULL, NULL, 0, 60, NULL, N'8139722250', NULL, 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'12502 Usf Pine Dr', N'Tampa', N'FL', N'12057', N'33612', 28.056982, -82.425048, 901, 70, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1193, N'Nemours Childrens Hospital', 1, NULL, NULL, N'103304', NULL, NULL, 0, 95, NULL, N'4075674000', NULL, 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'13535 Nemours Pkwy', N'Orlando', N'FL', N'12095', N'32827', 28.375112, -81.27667, 871, 63, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1194, N'Florida State Hospital Unit 14 Psych', 1, NULL, NULL, N'104000', NULL, NULL, 0, 1230, NULL, N'8506637536', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'100 N Main St', N'Chattahoochee', N'FL', N'12039', N'32324', 30.698022, -84.840732, 899, 69, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1195, N'South Florida State Hospital', 1, NULL, NULL, N'104001', NULL, NULL, 0, 350, NULL, N'3059677000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'800 E Cypress Dr', N'Pembroke Pines', N'FL', N'12011', N'33025', 26.002666, -80.256273, 839, 61, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1196, N'Northeast Florida State Hospital', 1, NULL, NULL, N'104007', NULL, NULL, 0, 1138, NULL, N'9042596211', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7487 S State Rd 121', N'Macclenny', N'FL', N'12003', N'32063', 30.282181, -82.122057, 843, 59, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1197, N'The Jerome Golden Center For Behavioral Health In', 1, NULL, NULL, N'104008', NULL, NULL, 0, 44, NULL, N'5618449741', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1041 45Th St', N'West Palm Beach', N'FL', N'12099', N'33407', 26.758811, -80.088379, 907, 55, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1198, N'River Point Behavioral Health', 1, NULL, NULL, N'104016', NULL, NULL, 0, 93, NULL, N'8003427552', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6300 Beach Blvd', N'Jacksonville', N'FL', N'12031', N'32216', 30.291067, -81.597278, 843, 59, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1199, N'Windmoor Healthcare Of Clearwater', 1, NULL, NULL, N'104017', NULL, NULL, 0, 144, NULL, N'7275412646', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'11300 Us 19 N', N'Clearwater', N'FL', N'12103', N'33764', 27.965853, -82.800103, 813, 54, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1200, N'Lifestream Behavioral Center', 1, NULL, NULL, N'104018', NULL, NULL, 0, 46, NULL, N'3523606598', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'2020 Tally Rd', N'Leesburg', N'FL', N'12069', N'34749', 28.835968, -81.895012, 854, 63, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1201, N'Circles Of Care Inc', 1, NULL, NULL, N'104024', NULL, NULL, 0, 52, NULL, N'3219844900', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'400 E Sheridan Rd', N'Melbourne', N'FL', N'12009', N'32901', 28.088962, -80.617114, 860, 63, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1202, N'Fort Lauderdale Hospital', 1, NULL, NULL, N'104026', NULL, NULL, 0, 100, NULL, N'9544634321', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1601 E Las Olas Blvd', N'Fort Lauderdale', N'FL', N'12011', N'33301', 26.119487, -80.127055, 831, 55, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1203, N'West Florida Community Care Center', 1, NULL, NULL, N'104027', NULL, NULL, 0, 100, NULL, N'9046234990', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5500 Stewart St', N'Milton', N'FL', N'12113', N'32570', 30.644464, -87.043904, 863, 66, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1204, N'Gulf Coast Treatment Center', 1, NULL, NULL, N'104032', NULL, NULL, 0, 24, NULL, N'8508634160', NULL, 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1015 Mar Walt Dr', N'Fort Walton Beach', N'FL', N'12091', N'32547', 30.405755, -86.618842, 834, 66, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1205, N'Manatee Glens Hospital & Addiction Center', 1, NULL, NULL, N'104040', NULL, NULL, 0, 30, NULL, N'9417413805', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'2020 26Th Ave E', N'Bradenton', N'FL', N'12081', N'34208', 27.47673, -82.531371, 807, 53, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1206, N'Southern Winds Hospital', 1, NULL, NULL, N'104049', NULL, NULL, 0, 72, NULL, N'3055589700', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4225 W 20Th Ave', N'Hialeah', N'FL', NULL, N'33012', 25.86018, -80.322248, 838, 61, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1207, N'Springbrook Hospital', 1, NULL, NULL, N'104057', NULL, NULL, 0, 66, NULL, N'3525964306', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7007 Grove Rd', N'Brooksville', N'FL', N'12053', N'34609', 28.555272, -82.387871, 893, 58, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1208, N'Eastside Psychiatric Hospital', 1, NULL, NULL, N'104059', NULL, NULL, 0, 46, NULL, N'9044872930', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2634B Capital Circle Ne 2Nd Flr', N'Tallahassee', N'FL', N'12073', N'32308', 30.438083, -84.280933, 899, 69, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1209, N'Willough At Naples The', 1, NULL, NULL, N'104063', NULL, NULL, 0, 63, NULL, N'9417754500', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'9001 Tamiami Trail East', N'Naples', N'FL', N'12021', N'34113', 26.142036, -81.79481, 864, 56, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1210, N'Atlantic Shores Hospital', 1, NULL, NULL, N'104065', NULL, NULL, 0, 42, NULL, N'9547712711', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'4545 N Federal Hwy', N'Fort Lauderdale', N'FL', N'12011', N'33308', 26.122308, -80.143379, 831, 55, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1211, N'Lakeside Behavioral Healthcare Inc', 1, NULL, NULL, N'104067', NULL, NULL, 0, 56, NULL, N'4078753700', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1800 Mercy Drive', N'Orlando', N'FL', N'12095', N'32808', 28.56746, -81.430672, 871, 63, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1212, N'Centers Inc The', 1, NULL, NULL, N'104068', NULL, NULL, 0, 15, NULL, N'3522915555', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'5664 Sw 60Th Ave', N'Ocala', N'FL', N'12083', N'34474', 29.179171, -82.218642, 868, 62, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1213, N'Wekiva Springs', 1, NULL, NULL, N'104069', NULL, NULL, 0, 68, NULL, N'9042963533', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3947 Salisbury Rd', N'Jacksonville', N'FL', N'12031', N'32216', 30.25824, -81.596269, 843, 59, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1214, N'Port St Lucie Hospital', 1, NULL, NULL, N'104070', NULL, NULL, 0, 75, NULL, N'7723350400', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2550 Se Walton Rd', N'Port Saint Lucie', N'FL', N'12111', N'34952', 27.298681, -80.256744, 884, 55, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1215, N'Vines Hospital', 1, NULL, NULL, N'104071', NULL, NULL, 0, 64, NULL, N'3526713130', N'3528613134', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3130 Sw 27Th Ave', N'Ocala', N'FL', N'12001', N'34474', 29.158247, -82.169014, 868, 62, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1216, N'Central Florida Behavioral Hospital', 1, NULL, NULL, N'104072', NULL, NULL, 0, 126, NULL, N'4073700111', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6601 Central Florida Parkway', N'Orlando', N'FL', N'12095', N'32821', 28.409267, -81.469647, 871, 63, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1217, N'Emerald Coast Behavioral Hospital', 1, NULL, NULL, N'104073', NULL, NULL, 0, 86, NULL, N'8507630017', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1940 Harrison Ave', N'Panama City', N'FL', N'12005', N'32405', 30.188735, -85.6583, 876, 65, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1218, N'Park Royal Hospital', 1, NULL, NULL, N'104074', NULL, NULL, 0, 103, NULL, N'2393320125', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'9241 Park Royal Dr', N'Fort Myers', N'FL', N'12071', N'33908', 26.640628, -81.872308, 832, 56, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1219, N'North Tampa Behavioral Health', 1, NULL, NULL, N'104075', NULL, NULL, 0, 75, NULL, N'8133330000', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'29910 Sr 56', N'Wesley Chapel', N'FL', N'12101', N'33543', 28.23973, -82.327866, 901, 70, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1220, N'University Behavioral Center', 1, NULL, NULL, N'104076', NULL, NULL, 0, 112, NULL, N'4072817000', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'2500 Discovery Drive', N'Orlando', N'FL', N'12095', N'32826', 28.542118, -81.379046, 871, 63, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1221, N'Tampa General Hospital', 1, NULL, NULL, N'109801', NULL, NULL, 0, 0, NULL, N'8138444602', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'1 Tampa General Cir', N'Tampa', N'FL', N'12057', N'33601', 27.94776, -82.458444, 901, 70, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1222, N'Florida Hospital', 1, NULL, NULL, N'109802', NULL, NULL, 0, 0, NULL, N'4073039659', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'601 E Rollins Street', N'Orlando', N'FL', N'12095', N'32803', 28.542118, -81.379046, 871, 63, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1223, N'Shands Hospital At The University Of Florida', 1, NULL, NULL, N'109803', NULL, NULL, 0, 0, NULL, N'3522650111', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'1600 Sw Archer Rd', N'Gainesville', N'FL', N'12001', N'32610', 29.651907, -82.324798, 835, 57, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1224, N'Jackson Memorial Hospital', 1, NULL, NULL, N'109804', NULL, NULL, 0, 0, NULL, N'3055856754', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'1611 Nw 12Th Avenue Ww117', N'Miami', N'FL', NULL, N'33136', 25.774266, -80.193659, 861, 61, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1225, N'Broward Health Broward General Medical Center', 1, NULL, NULL, N'109805', NULL, NULL, 0, 0, NULL, N'9543555610', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'1600 South Andrews Ave', N'Fort Lauderdale', N'FL', N'12011', N'33316', 26.102733, -80.141167, 831, 55, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1226, N'Mayo Clinic', 1, NULL, NULL, N'109806', NULL, NULL, 0, 0, NULL, N'9049532000', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'4500 San Pablo Road', N'Jacksonville', N'FL', N'12031', N'32224', 30.313431, -81.447723, 843, 59, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1227, N'Halifax Health Medical Center', 1, NULL, NULL, N'109807', NULL, NULL, 0, 0, NULL, N'3862544060', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'303 N Clyde Morris Blvd', N'Daytona Beach', N'FL', N'12127', N'32114', 29.20081, -81.05367, 822, 64, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1228, N'All Children''s Hospital', 1, NULL, NULL, N'109808', NULL, NULL, 0, 0, NULL, N'7277674474', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'801 Sixth St S', N'Saint Petersburg', N'FL', N'12103', N'33701', 27.770861, -82.679266, 896, 68, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1229, N'Gulf Coast Medical Center Lee Mem Health System', 1, NULL, NULL, N'109809', NULL, NULL, 0, 0, NULL, N'2399391147', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'13681 Doctor''s Way', N'Fort Myers', N'FL', N'12071', N'33912', 26.640628, -81.872308, 832, 56, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1230, N'Memorial Regional Hospital', 1, NULL, NULL, N'109810', NULL, NULL, 0, 0, NULL, N'9542655814', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'3501 Johnson St', N'Hollywood', N'FL', N'12011', N'33021', 26.018303, -80.180647, 839, 61, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1231, N'Cleveland Clinic Florida', 1, NULL, NULL, N'109811', NULL, NULL, 0, 0, NULL, N'9546895000', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'2950 Cleveland Clinic Blvd', N'Weston', N'FL', N'12011', N'33331', 26.080444, -80.36426, 877, 61, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1232, N'Hamilton Medical Center', 1, NULL, NULL, N'110001', NULL, NULL, 0, 282, NULL, N'7062726105', N'7062726110', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1200 Memorial Drive', N'Dalton', N'GA', N'13313', N'30720', 34.788794, -84.983804, 945, 72, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1233, N'Upson Regional Medical Center', 1, NULL, NULL, N'110002', NULL, NULL, 0, 119, NULL, N'7066478111', N'7066463310', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'801 W Gordon Street', N'Thomaston', N'GA', N'13293', N'30286', 32.887127, -84.333552, 1010, 75, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1234, N'Mayo Clinic Health System In Waycross Inc', 1, NULL, NULL, N'110003', NULL, NULL, 0, 237, NULL, N'9122872500', N'9122872505', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1900 Tebeau Street', N'Waycross', N'GA', N'13299', N'31501', 31.226747, -82.348152, 1021, 59, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1235, N'Hutcheson Medical Center', 1, NULL, NULL, N'110004', NULL, NULL, 0, 179, NULL, N'7068582101', N'7068582864', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'100 Gross Crescent', N'Fort Oglethorpe', N'GA', N'13047', N'30742', 34.946813, -85.262844, 960, 248, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1236, N'Northside Hospital Forsyth', 1, NULL, NULL, N'110005', NULL, NULL, 0, 78, NULL, N'4048518700', N'7708443227', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1200 Northside Forsyth Drive', N'Cumming', N'GA', N'13117', N'30041', 34.20732, -84.140193, 998, 72, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1237, N'St Mary''s Hospital', 1, NULL, NULL, N'110006', NULL, NULL, 0, 196, NULL, N'7063893930', N'7063893931', 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1230 Baxter Street', N'Athens', N'GA', N'13059', N'30606', 33.945984, -83.40449, 917, 72, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1238, N'Phoebe Putney Memorial Hospital', 1, NULL, NULL, N'110007', NULL, NULL, 0, 691, NULL, N'2293124068', N'2293124115', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'417 Third Avenue', N'Albany', N'GA', N'13095', N'31703', 31.578206, -84.155681, 913, 71, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1239, N'Northside Hospital Cherokee', 1, NULL, NULL, N'110008', NULL, NULL, 0, 84, NULL, N'7707205298', N'7704793670', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'201 Hospital Road', N'Canton', N'GA', N'13057', N'30114', 34.245056, -84.49263, 930, 72, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1240, N'Emory University Hospital', 1, NULL, NULL, N'110010', NULL, NULL, 0, 661, NULL, N'4046868500', N'4046868535', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1364 Clifton Road Ne', N'Atlanta', N'GA', N'13089', N'30322', 33.795478, -84.321354, 918, 72, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1241, N'Tanner Medical Center - Carrollton', 1, NULL, NULL, N'110011', NULL, NULL, 0, 182, NULL, N'7708369580', N'7708369897', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'705 Dixie Street', N'Carrollton', N'GA', N'13045', N'30117', 33.569799, -85.072562, 931, 72, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1242, N'Tanner Medical Center Villa Rica', 1, NULL, NULL, N'110015', NULL, NULL, 0, 40, NULL, N'7704563101', N'7704563390', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'601 Dallas Highway', N'Villa Rica', N'GA', N'13045', N'30180', 33.74429, -84.918796, 1018, 72, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1243, N'West Georgia Medical Center', 1, NULL, NULL, N'110016', NULL, NULL, 0, 276, NULL, N'7068821411', N'7068458918', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1514 Vernon Road', N'Lagrange', N'GA', N'13285', N'30240', 33.039291, -85.031327, 976, 72, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1244, N'Newton Medical Center', 1, NULL, NULL, N'110018', NULL, NULL, 0, 90, NULL, N'7707867053', N'7707879059', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5126 Hospital Drive Ne', N'Covington', N'GA', N'13217', N'30014', 33.602455, -83.84807, 941, 72, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1245, N'Gordon Hospital', 1, NULL, NULL, N'110023', NULL, NULL, 0, 69, NULL, N'7066292895', N'7066294842', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1035 Red Bud Road', N'Calhoun', N'GA', N'13129', N'30701', 34.502587, -84.951054, 929, 76, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1246, N'Candler Hospital', 1, NULL, NULL, N'110024', NULL, NULL, 0, 320, NULL, N'9128196000', N'9128195887', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5353 Reynolds Street', N'Savannah', N'GA', N'13051', N'31412', 32.036798, -81.098354, 1001, 77, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1247, N'Southeast Georgia Health System- Brunswick Campus', 1, NULL, NULL, N'110025', NULL, NULL, 0, 300, NULL, N'9124667000', N'9124667013', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2415 Parkwood Drive', N'Brunswick', N'GA', N'13127', N'31520', 31.173708, -81.483368, 927, 59, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1248, N'Elbert Memorial Hospital', 1, NULL, NULL, N'110026', NULL, NULL, 0, 52, NULL, N'7062132535', N'7062132578', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4 Medical Drive', N'Elberton', N'GA', N'13105', N'30635', 34.113184, -82.875455, 955, 72, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1249, N'Ty Cobb Regional Medical Center Llc', 1, NULL, NULL, N'110027', NULL, NULL, 0, 56, NULL, N'7063567800', N'7063567828', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'367 Clear Creek Parkway', N'Lavonia', N'GA', N'13119', N'30553', 34.435936, -83.106818, 999, 72, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1250, N'University Hospital', 1, NULL, NULL, N'110028', NULL, NULL, 0, 551, NULL, N'7067229011', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1350 Walton Way', N'Augusta', N'GA', N'13245', N'30901', 33.472977, -81.981499, 919, 73, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1251, N'Northeast Georgia Medical Center Inc', 1, NULL, NULL, N'110029', NULL, NULL, 0, 461, NULL, N'7705353553', N'7705353566', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'743 Spring Street', N'Gainesville', N'GA', N'13139', N'30501', 34.297879, -83.824066, 962, 72, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1252, N'Cartersville Medical Center', 1, NULL, NULL, N'110030', NULL, NULL, 0, 112, NULL, N'7703878182', N'7706062127', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'960 Joe Frank Harris Parkway', N'Cartersville', N'GA', N'13015', N'30120', 34.199147, -84.79389, 932, 72, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1253, N'Spalding Regional Hospital', 1, NULL, NULL, N'110031', NULL, NULL, 0, 160, NULL, N'7702282721', N'7702296953', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'601 South 8Th Street', N'Griffin', N'GA', N'13255', N'30223', 33.239818, -84.265794, 965, 72, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1254, N'Stephens County Hospital', 1, NULL, NULL, N'110032', NULL, NULL, 0, 99, NULL, N'7062824250', N'7062824334', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'163 Hospital Drive', N'Toccoa', N'GA', N'13257', N'30577', 34.592997, -83.348035, 1014, 72, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1255, N'Medical College Of Ga Hospitals And Clinics', 1, NULL, NULL, N'110034', NULL, NULL, 0, 632, NULL, N'7067216569', N'7067216572', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1120 15Th Street', N'Augusta', N'GA', N'13245', N'30912', 33.476223, -81.986475, 919, 73, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1256, N'Wellstar Kennestone Hospital', 1, NULL, NULL, N'110035', NULL, NULL, 0, 633, NULL, N'7707935000', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'677 Church Street', N'Marietta', N'GA', N'13067', N'30060', 33.969268, -84.555211, 981, 72, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1257, N'Memorial Health Univ Med Cen Inc', 1, NULL, NULL, N'110036', NULL, NULL, 0, 530, NULL, N'9123508000', N'9123507073', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4700 Waters Avenue', N'Savannah', N'GA', N'13051', N'31403', 32.032254, -81.091565, 1001, 77, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1258, N'John D Archbold Memorial Hospital', 1, NULL, NULL, N'110038', NULL, NULL, 0, 264, NULL, N'2292282880', N'2295518741', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'915 Gordon Avenue & Mimosa Drive', N'Thomasville', N'GA', N'13275', N'31792', 30.836582, -83.978781, 1011, 69, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1259, N'Trinity Hospital Of Augusta', 1, NULL, NULL, N'110039', NULL, NULL, 0, 231, NULL, N'7064817000', N'7064817599', 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2260 Wrightsboro Rd', N'Augusta', N'GA', N'13245', N'30904', 33.467496, -82.016979, 919, 73, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1260, N'Northridge Medical Center', 1, NULL, NULL, N'110040', NULL, NULL, 0, 90, NULL, N'7063351100', N'7703357701', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'70 Medical Center Drive', N'Commerce', N'GA', N'13157', N'30529', 34.203997, -83.457106, 938, 72, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1261, N'Habersham County Medical Ctr', 1, NULL, NULL, N'110041', NULL, NULL, 0, 53, NULL, N'7067542161', N'7067547300', 1, 1, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'541 Historic Highway 441-North', N'Demorest', N'GA', N'13137', N'30535', 34.565193, -83.545332, 947, 72, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1262, N'Wellstar Paulding Hospital', 1, NULL, NULL, N'110042', NULL, NULL, 0, 83, NULL, N'4706447000', N'4706447399', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2518 Jimmy Lee Smith Parkway', N'Hiram', N'GA', N'13223', N'30141', 33.900644, -84.781273, 920, 72, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1263, N'St Joseph''s Hospital - Savannah', 1, NULL, NULL, N'110043', NULL, NULL, 0, 294, NULL, N'9128194100', N'9128192188', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'11705 Mercy Boulevard', N'Savannah', N'GA', N'13051', N'31419', 31.988277, -81.153469, 1001, 77, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1264, N'Phoebe Sumter Medical Center', 1, NULL, NULL, N'110044', NULL, NULL, 0, 143, NULL, N'2299311280', N'2299241014', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'126 Highway 280 W', N'Americus', N'GA', N'13261', N'31719', 32.072386, -84.232688, 915, 71, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1265, N'Barrow Regional Medical Center', 1, NULL, NULL, N'110045', NULL, NULL, 0, 56, NULL, N'7703075210', N'7703075221', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'316 North Broad Street', N'Winder', N'GA', N'13013', N'30680', 34.002733, -83.707664, 1023, 72, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1266, N'Clearview  Regional Medical Center', 1, NULL, NULL, N'110046', NULL, NULL, 0, 77, NULL, N'7702671792', N'7702671888', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2151 West Spring Street', N'Monroe', N'GA', N'13297', N'30655', 33.79437, -83.741718, 986, 72, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1267, N'Murray Medical Center', 1, NULL, NULL, N'110050', NULL, NULL, 0, 42, NULL, N'7065172031', N'7065172076', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'707 Old Dalton Ellijay Road Po Box 1406', N'Chatsworth', N'GA', N'13213', N'30705', 34.765915, -84.769938, 945, 72, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1268, N'Union General Hospital', 1, NULL, NULL, N'110051', NULL, NULL, 0, 45, NULL, N'7067452111', N'7067457677', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'35 Hospital Road', N'Blairsville', N'GA', N'13291', N'30512', 34.875907, -83.958371, 923, 72, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1269, N'Floyd Medical Center', 1, NULL, NULL, N'110054', NULL, NULL, 0, 284, NULL, N'7065096900', N'7065096901', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'304 Turner Mccall Blvd P O Box 233', N'Rome', N'GA', N'13115', N'30162', 34.257038, -85.164673, 997, 76, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1270, N'Midtown Medical Center', 1, NULL, NULL, N'110064', NULL, NULL, 0, 417, NULL, N'7065711000', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'710 Center St Box 951', N'Columbus', N'GA', N'13215', N'31901', 32.460976, -84.987709, 937, 74, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1271, N'Houston Medical Center', 1, NULL, NULL, N'110069', NULL, NULL, 0, 186, NULL, N'4789224281', N'4783225174', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1601 Watson Boulevard', N'Warner Robins', N'GA', N'13153', N'31093', 32.618128, -83.630422, 1019, 75, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1272, N'Appling Hospital', 1, NULL, NULL, N'110071', NULL, NULL, 0, 49, NULL, N'9123679841', N'9123671272', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'163 E Tollison Street', N'Baxley', N'GA', N'13001', N'31513', 31.768581, -82.357771, 922, 77, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1273, N'Dorminy Medical Center', 1, NULL, NULL, N'110073', NULL, NULL, 0, 75, NULL, N'2294247100', N'2294247281', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'200 Perry House Road Box 1447', N'Fitzgerald', N'GA', N'13017', N'31750', 31.714908, -83.252654, 957, 75, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1274, N'Athens Regional Medical Center', 1, NULL, NULL, N'110074', NULL, NULL, 0, 315, NULL, N'7064757000', N'7064756775', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1199 Prince Avenue', N'Athens', N'GA', N'13059', N'30606', 33.960939, -83.399313, 917, 72, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1275, N'East Georgia Regional Medical Center', 1, NULL, NULL, N'110075', NULL, NULL, 0, 150, NULL, N'9124861500', N'9128712354', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1499 Fair Road', N'Statesboro', N'GA', N'13031', N'30458', 32.41459, -81.769923, 1006, 77, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1276, N'Dekalb Medical Center', 1, NULL, NULL, N'110076', NULL, NULL, 0, 451, NULL, N'4045011000', N'4045015627', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2701 N Decatur Road', N'Decatur', N'GA', N'13089', N'30033', 33.791758, -84.298124, 946, 72, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1277, N'Emory University Hospital Midtown', 1, NULL, NULL, N'110078', NULL, NULL, 0, 481, NULL, N'4046864411', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'550 Peachtree St Ne', N'Atlanta', N'GA', N'13121', N'30308', 33.7695, -84.38527, 918, 72, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1278, N'Grady Memorial Hospital', 1, NULL, NULL, N'110079', NULL, NULL, 0, 953, NULL, N'4046164252', NULL, 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'80 Jesse Hill Jr Drive Se', N'Atlanta', N'GA', N'13121', N'30303', 33.749858, -84.385034, 918, 72, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1279, N'Saint Joseph''s Hospital Of Atlanta Inc', 1, NULL, NULL, N'110082', NULL, NULL, 0, 410, NULL, N'6788435720', N'6788437339', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5665 Peachtree Dunwoody Road', N'Atlanta', N'GA', N'13121', N'30342', 33.873418, -84.357932, 918, 72, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1280, N'Piedmont Hospital', 1, NULL, NULL, N'110083', NULL, NULL, 0, 458, NULL, N'4046055000', N'4046096699', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1968 Peachtree Rd Nw', N'Atlanta', N'GA', N'13121', N'30309', 33.749099, -84.390185, 918, 72, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1281, N'Washington County Regional Medical Center', 1, NULL, NULL, N'110086', NULL, NULL, 0, 56, NULL, N'4782402100', N'4782402390', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'610 Sparta Road', N'Sandersville', N'GA', N'13303', N'31082', 32.99338, -82.809203, 1000, 73, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1282, N'Gwinnett Medical Center', 1, NULL, NULL, N'110087', NULL, NULL, 0, 353, NULL, N'6783121000', N'7706822257', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1000 Medical Center Boulevard', N'Lawrenceville', N'GA', N'13135', N'30045', 33.961061, -84.020143, 978, 72, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1283, N'Coffee Regional Medical Center', 1, NULL, NULL, N'110089', NULL, NULL, 0, 88, NULL, N'2293841900', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1101 Ocilla Road', N'Douglas', N'GA', N'13069', N'31533', 31.51075, -82.866641, 949, 59, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1284, N'Rockdale Medical Center', 1, NULL, NULL, N'110091', NULL, NULL, 0, 107, NULL, N'7709183000', N'7709183104', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1412 Milstead Avenue Ne', N'Conyers', N'GA', N'13247', N'30012', 33.679044, -84.006175, 939, 72, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1285, N'Dodge County Hospital', 1, NULL, NULL, N'110092', NULL, NULL, 0, 94, NULL, N'4784484067', N'4783749411', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'901 Griffin Ave', N'Eastman', N'GA', N'13091', N'31023', 32.192813, -83.175215, 953, 75, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1286, N'Tift Regional Medical Center', 1, NULL, NULL, N'110095', NULL, NULL, 0, 176, NULL, N'2293827120', N'2293536192', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'901 E 18Th Street', N'Tifton', N'GA', N'13277', N'31793', 31.469911, -83.500615, 1013, 69, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1287, N'Jefferson Hospital', 1, NULL, NULL, N'110100', NULL, NULL, 0, 65, NULL, N'4786257000', N'4786258907', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1067 Peachtree St', N'Louisville', N'GA', N'13163', N'30434', 33.015566, -82.404185, 979, 73, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1288, N'Cook  Medical Center  A Campus Of Tift Reg Med Ctr', 1, NULL, NULL, N'110101', NULL, NULL, 0, 60, NULL, N'2298968077', N'2298968001', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'706 N Parrish Ave', N'Adel', N'GA', N'13075', N'31620', 31.144375, -83.424857, 912, 69, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1289, N'Crisp Regional Hospital', 1, NULL, NULL, N'110104', NULL, NULL, 0, 65, NULL, N'2292763100', N'2292763108', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'902 7Th Street North', N'Cordele', N'GA', N'13081', N'31015', 31.97691, -83.782754, 940, 75, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1290, N'Colquitt Regional Medical Center', 1, NULL, NULL, N'110105', NULL, NULL, 0, 99, NULL, N'2299853420', N'2298919338', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3131 Thomasville Hwy Box 40', N'Moultrie', N'GA', N'13071', N'31768', 31.181152, -83.787881, 988, 69, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1291, N'Medical Center Of Central Georgia', 1, NULL, NULL, N'110107', NULL, NULL, 0, 637, NULL, N'4786336805', N'4786335348', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'777 Hemlock Street', N'Macon', N'GA', N'13021', N'31201', 32.833044, -83.636114, 980, 75, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1292, N'Emanuel Medical Center', 1, NULL, NULL, N'110109', NULL, NULL, 0, 72, NULL, N'4782891304', N'4782891300', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'117 Kite Road', N'Swainsboro', N'GA', N'13107', N'30401', 32.592884, -82.346303, 1008, 73, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1293, N'University Mcduffie County Regional Medical Center', 1, NULL, NULL, N'110111', NULL, NULL, 0, 47, NULL, N'7065951411', N'7065975139', 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2460 Washington Road', N'Thomson', N'GA', N'13189', N'30824', 33.477884, -82.505856, 1012, 73, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1294, N'Burke Medical Center', 1, NULL, NULL, N'110113', NULL, NULL, 0, 40, NULL, N'7065544435', N'7065544854', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'351 Liberty Street', N'Waynesboro', N'GA', N'13033', N'30830', 33.08219, -82.010622, 1022, 73, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1295, N'Atlanta Medical Center', 1, NULL, NULL, N'110115', NULL, NULL, 0, 762, NULL, N'4042654000', N'4042653903', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'303 Parkway Dr Ne', N'Atlanta', N'GA', N'13121', N'30312', 33.763208, -84.373908, 918, 72, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1296, N'Grady General Hospital', 1, NULL, NULL, N'110121', NULL, NULL, 0, 60, NULL, N'2293770251', N'2293777953', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1155 5Th Street Se', N'Cairo', N'GA', N'13131', N'39828', 30.863241, -84.200048, 928, 69, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1297, N'South Georgia Medical Center', 1, NULL, NULL, N'110122', NULL, NULL, 0, 335, NULL, N'2293331020', N'2293331007', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2501 North Patterson Street Po Box 1727', N'Valdosta', N'GA', N'13185', N'31603', 30.832702, -83.278485, 1015, 69, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1298, N'Wayne Memorial Hospital', 1, NULL, NULL, N'110124', NULL, NULL, 0, 88, NULL, N'9125303302', N'9125303495', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'865 South First Street', N'Jesup', N'GA', N'13305', N'31545', 31.607437, -81.885392, 975, 77, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1299, N'Fairview Park Hospital', 1, NULL, NULL, N'110125', NULL, NULL, 0, 190, NULL, N'4782743100', N'4782720211', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'200 Industrial Boulevard', N'Dublin', N'GA', N'13175', N'31021', 32.526542, -82.941058, 951, 75, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1300, N'Meadows Regional Medical Center', 1, NULL, NULL, N'110128', NULL, NULL, 0, 87, NULL, N'9125355828', N'9125355830', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'One Meadows Parkway', N'Vidalia', N'GA', N'13279', N'30474', 32.217686, -82.413461, 1016, 77, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1301, N'St Francis Hospital Inc', 1, NULL, NULL, N'110129', NULL, NULL, 0, 376, NULL, N'7065964020', N'7065964481', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2122 Manchester Expressway', N'Columbus', N'GA', N'13215', N'31995', 32.460976, -84.987709, 937, 74, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1302, N'Irwin County Hospital', 1, NULL, NULL, N'110130', NULL, NULL, 0, 34, NULL, N'2294683845', N'2284683973', 1, 0, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'710 N Irwin Avenue', N'Ocilla', N'GA', N'13155', N'31774', 31.602928, -83.250132, 991, 75, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1303, N'Memorial Hospital And Manor', 1, NULL, NULL, N'110132', NULL, NULL, 0, 80, NULL, N'2292463500', N'2292468142', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1500 E Shotwell Street', N'Bainbridge', N'GA', N'13087', N'39819', 30.903763, -84.550885, 921, 69, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1304, N'Taylor Regional Hospital', 1, NULL, NULL, N'110135', NULL, NULL, 0, 55, NULL, N'4787830200', N'4788920518', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'222 Perry Hwy', N'Hawkinsville', N'GA', N'13235', N'31036', 32.283773, -83.472118, 968, 75, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1305, N'Evans Memorial Hospital', 1, NULL, NULL, N'110142', NULL, NULL, 0, 49, NULL, N'9127395105', N'9127395101', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'200 N River Street', N'Claxton', N'GA', N'13109', N'30417', 32.168174, -81.900284, 933, 77, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1306, N'Wellstar Cobb Hospital', 1, NULL, NULL, N'110143', NULL, NULL, 0, 382, NULL, N'7707324000', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3950 Austell Rd', N'Austell', N'GA', N'13067', N'30106', 33.816935, -84.617876, 920, 72, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1307, N'Southeast Georgia Health System- Camden Campus', 1, NULL, NULL, N'110146', NULL, NULL, 0, 40, NULL, N'9125766401', N'9125766404', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2000 Dan Proctor Drive', N'Saint Marys', N'GA', N'13039', N'31558', 30.781632, -81.613812, 1005, 59, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1308, N'Oconee Regional Medical Center', 1, NULL, NULL, N'110150', NULL, NULL, 0, 140, NULL, N'4784543550', N'4784543555', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'821 N Cobb Street  Post Office Box 690', N'Milledgeville', N'GA', N'13009', N'31061', 33.080143, -83.232099, 984, 75, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1309, N'Perry Hospital', 1, NULL, NULL, N'110153', NULL, NULL, 0, 39, NULL, N'4789873600', N'4783225174', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1120 Morningside Dr', N'Perry', N'GA', N'13153', N'31069', 32.465166, -83.711242, 992, 75, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1310, N'Northside Hospital', 1, NULL, NULL, N'110161', NULL, NULL, 0, 444, NULL, N'4048518000', N'4043033820', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1000 Johnson Ferry Road Ne', N'Atlanta', N'GA', N'13121', N'30342', 33.749099, -84.390185, 918, 72, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1311, N'Coliseum Medical Centers', 1, NULL, NULL, N'110164', NULL, NULL, 0, 250, NULL, N'4787657000', N'4787421247', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'350 Hospital Drive', N'Macon', N'GA', N'13021', N'31217', 32.845773, -83.617984, 980, 75, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1312, N'Southern Regional Medical Center', 1, NULL, NULL, N'110165', NULL, NULL, 0, 376, NULL, N'7709918160', N'7709973304', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'11 Upper Riverdale Road Sw', N'Riverdale', N'GA', N'13063', N'30274', 33.572611, -84.413259, 996, 72, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1313, N'Redmond Regional Medical Center', 1, NULL, NULL, N'110168', NULL, NULL, 0, 201, NULL, N'7068023012', N'7062910971', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'501 Redmond Road', N'Rome', N'GA', N'13115', N'30165', 34.27812, -85.193407, 997, 76, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1314, N'Doctors Hospital', 1, NULL, NULL, N'110177', NULL, NULL, 0, 354, NULL, N'7066516008', N'7066512041', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3651 Wheeler Road', N'Augusta', N'GA', N'13245', N'30909', 33.470971, -81.974843, 919, 73, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1315, N'Emory-Adventist Hospital', 1, NULL, NULL, N'110183', NULL, NULL, 0, 88, NULL, N'7704340710', N'7704324260', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3949 South Cobb Drive', N'Smyrna', N'GA', N'13067', N'30080', 33.841364, -84.497775, 1002, 72, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1316, N'Wellstar Douglas Hospital', 1, NULL, NULL, N'110184', NULL, NULL, 0, 108, NULL, N'7709491500', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'8954 Hospital Drive', N'Douglasville', N'GA', N'13097', N'30134', 33.738997, -84.731324, 950, 72, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1317, N'Chestatee Regional Hospital', 1, NULL, NULL, N'110187', NULL, NULL, 0, 49, NULL, N'7068646136', N'7068641356', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'227 Mountain Dr', N'Dahlonega', N'GA', N'13187', N'30533', 34.521641, -83.978051, 943, 72, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1318, N'Fannin Regional Hospital', 1, NULL, NULL, N'110189', NULL, NULL, 0, 50, NULL, N'7066323711', N'7066327216', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2855 Old Highway 5 North', N'Blue Ridge', N'GA', N'13111', N'30513', 34.863972, -84.324087, 925, 72, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1319, N'Flint River Community Hospital', 1, NULL, NULL, N'110190', NULL, NULL, 0, 49, NULL, N'4784723100', N'4784722412', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'509 Sumter Street Box 770', N'Montezuma', N'GA', N'13193', N'31063', 9.603301, -85.140599, 987, 75, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1320, N'Piedmont Henry Hospital', 1, NULL, NULL, N'110191', NULL, NULL, 0, 122, NULL, N'6786041000', N'6786045580', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1133 Eagle''s Landing Parkway', N'Stockbridge', N'GA', N'13151', N'30281', 33.518479, -84.193059, 1007, 72, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1321, N'Eastside Medical Center', 1, NULL, NULL, N'110192', NULL, NULL, 0, 200, NULL, N'7707362498', N'7707362395', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1700 Medical Way', N'Snellville', N'GA', N'13135', N'30078', 33.876442, -84.019022, 1003, 72, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1322, N'Donalsonville Hospital Inc', 1, NULL, NULL, N'110194', NULL, NULL, 0, 65, NULL, N'2295245217', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'102 Hospital Cir', N'Donalsonville', N'GA', N'13253', N'39845', 31.040463, -84.879091, 948, 2, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1323, N'North Fulton Hospital', 1, NULL, NULL, N'110198', NULL, NULL, 0, 167, NULL, N'7707512500', N'7707512912', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3000 Hospital Boulevard', N'Roswell', N'GA', N'13121', N'30076', 34.063275, -84.319996, 998, 72, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1324, N'Northside Medical Center', 1, NULL, NULL, N'110200', NULL, NULL, 0, 100, NULL, N'7064942100', N'7064942446', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'100 Frist Court', N'Columbus', N'GA', N'13215', N'31909', 32.536066, -84.954634, 937, 74, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1325, N'Coliseum Northside Hospital', 1, NULL, NULL, N'110201', NULL, NULL, 0, 103, NULL, N'4787578200', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'400 Charter Boulevard', N'Macon', N'GA', N'13021', N'31210', 32.869963, -83.694419, 980, 75, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1326, N'North Georgia Medical Center', 1, NULL, NULL, N'110205', NULL, NULL, 0, 49, NULL, N'7062764741', N'7062763698', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1362 South Main Street', N'Ellijay', N'GA', N'13123', N'30540', 34.68222, -84.493248, 956, 72, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1327, N'Turning Point Hospital', 1, NULL, NULL, N'110209', NULL, NULL, 0, 59, NULL, N'2299854815', N'2298901614', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3015 Veterans Parkway', N'Moultrie', N'GA', N'13071', N'31788', 31.197388, -83.76873, 988, 69, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1328, N'Piedmont Fayette Hospital', 1, NULL, NULL, N'110215', NULL, NULL, 0, 100, NULL, N'7707197071', N'7707197092', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1255 Highway 54 West', N'Fayetteville', N'GA', N'13113', N'30214', 33.448726, -84.454926, 918, 72, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1329, N'Piedmont Mountainside Hospital Inc', 1, NULL, NULL, N'110225', NULL, NULL, 0, 35, NULL, N'7063015269', N'7066920939', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1266 Highway 515 South', N'Jasper', N'GA', N'13227', N'30143', 34.467869, -84.429092, 974, 72, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1330, N'Dekalb Medical Center At Hillandale', 1, NULL, NULL, N'110226', NULL, NULL, 0, 84, NULL, N'4045018040', N'4045018797', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2801 Dekalb Medical Parkway', N'Lithonia', N'GA', N'13089', N'30058', 33.712331, -84.105194, 918, 72, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1331, N'Piedmont Newnan Hospital Inc', 1, NULL, NULL, N'110229', NULL, NULL, 0, 143, NULL, N'7704002300', N'7702538845', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'745 Poplar Road', N'Newnan', N'GA', N'13077', N'30265', 33.361389, -84.769101, 990, 72, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1332, N'Emory Johns Creek Hospital', 1, NULL, NULL, N'110230', NULL, NULL, 0, 110, NULL, N'6784747000', N'6784747026', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6325 Hospital Parkway', N'Johns Creek', N'GA', N'13055', N'30097', 34.018156, -84.190196, 978, 72, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1333, N'Southeastern Regional Medical Center', 1, NULL, NULL, N'110233', NULL, NULL, 0, 25, NULL, N'4048448334', N'7706033040', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'600 Parkway North', N'Newnan', N'GA', N'13077', N'30265', 33.380672, -84.799657, 990, 72, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1334, N'Sgmc Berrien Campus', 1, NULL, NULL, N'110234', NULL, NULL, 0, 63, NULL, N'2295437100', NULL, 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1221 E Mcpherson Avenue', N'Nashville', N'GA', N'13019', N'31639', 31.20742, -83.250155, 989, 69, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1335, N'Landmark Hospital Of Savannah', 1, NULL, NULL, N'110235', NULL, NULL, 0, 50, NULL, N'5733318420', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'800 E 68Th Street', N'Savannah', N'GA', N'13051', N'31405', 32.028446, -81.095346, 1001, 77, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1336, N'Southwest Georgia Regional Medical Center', 1, NULL, NULL, N'111300', NULL, NULL, 0, 25, NULL, N'2297322181', N'2297326759', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'361 Randolph Street', N'Cuthbert', N'GA', N'13243', N'39840', 31.774977, -84.79622, 942, 74, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1337, N'Bleckley Memorial Hospital', 1, NULL, NULL, N'111302', NULL, NULL, 0, 25, NULL, N'4789346211', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'145 East Peacock Street', N'Cochran', N'GA', N'13023', N'31014', 32.386828, -83.35461, 935, 75, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1338, N'Jasper Memorial Hospital', 1, NULL, NULL, N'111303', NULL, NULL, 0, 17, NULL, N'7064686411', N'7064689880', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'898 College Street', N'Monticello', N'GA', N'13159', N'31064', 33.313905, -83.686757, 980, 75, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1339, N'Morgan Memorial Hospital', 1, NULL, NULL, N'111304', NULL, NULL, 0, 25, NULL, N'7063421667', N'7063422345', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1077 South Main Street', N'Madison', N'GA', N'13211', N'30650', 33.583757, -83.480336, 917, 72, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1340, N'Miller County Hospital', 1, NULL, NULL, N'111305', NULL, NULL, 0, 25, NULL, N'2297584231', N'2297586623', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'209 N Cuthbert Street', N'Colquitt', N'GA', N'13201', N'39837', 31.174609, -84.734661, 936, 69, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1341, N'Effingham Hospital', 1, NULL, NULL, N'111306', NULL, NULL, 0, 25, NULL, N'9127540160', N'9127549901', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'459 Ga Highway 119 South', N'Springfield', N'GA', N'13103', N'31329', 33.473748, -82.08234, 1001, 77, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1342, N'Clinch Memorial Hospital', 1, NULL, NULL, N'111308', NULL, NULL, 0, 25, NULL, N'9124875211', N'9124873769', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1050 Valdosta Highway', N'Homerville', N'GA', N'13065', N'31634', 31.036598, -82.747085, 972, 59, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1343, N'Medical Center Of Peach County The', 1, NULL, NULL, N'111310', NULL, NULL, 0, 25, NULL, N'4786542000', N'4786542001', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1960 Highway 247 Connector', N'Byron', N'GA', N'13225', N'31008', 32.653756, -83.759629, 980, 75, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1344, N'Optim Medical Center - Jenkins', 1, NULL, NULL, N'111311', NULL, NULL, 0, 25, NULL, N'4784784221', N'4789822478', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'931 East Winthrope Avenue', N'Millen', N'GA', N'13165', N'30442', 32.803767, -81.935602, 985, 73, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1345, N'Optim Medical Center - Screven', 1, NULL, NULL, N'111312', NULL, NULL, 0, 25, NULL, N'9125647426', N'9125640010', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'215 Mims Road', N'Sylvania', N'GA', N'13251', N'30467', 32.75001, -81.645906, 1009, 77, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1346, N'Putnam General Hospital', 1, NULL, NULL, N'111313', NULL, NULL, 0, 25, NULL, N'7064852711', N'7069232139', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'101 Lake Oconee Parkway', N'Eatonton', N'GA', N'13237', N'31024', 33.3268, -83.388496, 954, 72, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1347, N'Pioneer Community Hospital Of Early', 1, NULL, NULL, N'111314', NULL, NULL, 0, 25, NULL, N'2297234241', N'2297232930', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'11740 Columbia Street', N'Blakely', N'GA', N'13099', N'39823', 31.377675, -84.934092, 924, 2, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1348, N'Warm Springs Medical Center', 1, NULL, NULL, N'111316', NULL, NULL, 0, 25, NULL, N'7066559351', N'7066559233', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5995 Spring Street', N'Warm Springs', N'GA', N'13199', N'31830', 32.890697, -84.682702, 976, 72, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1349, N'Monroe County Hospital', 1, NULL, NULL, N'111318', NULL, NULL, 0, 25, NULL, N'4789942521', N'4789948798', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'88 Martin Luther King Jr Drive', N'Forsyth', N'GA', N'13207', N'31029', 33.027713, -83.948657, 959, 75, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1350, N'Sylvan Grove Hospital', 1, NULL, NULL, N'111319', NULL, NULL, 0, 25, NULL, N'7707757861', N'7707754478', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1050 Mcdonough Road', N'Jackson', N'GA', N'13035', N'30233', 33.304274, -83.979469, 973, 72, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1351, N'Higgins General Hospital', 1, NULL, NULL, N'111320', NULL, NULL, 0, 25, NULL, N'7708242210', N'7708242309', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'200 Allen Memorial Drive', N'Bremen', N'GA', N'13143', N'30110', 33.715943, -85.145831, 926, 76, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1352, N'Optim Medical Center - Tattnall', 1, NULL, NULL, N'111323', NULL, NULL, 0, 25, NULL, N'9125571000', N'9125571009', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'247 S Main Street', N'Reidsville', N'GA', N'13267', N'30453', 32.080191, -82.110503, 994, 77, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1353, N'Chatuge Regional Hospital', 1, NULL, NULL, N'111324', NULL, NULL, 0, 25, NULL, N'7068962222', N'7068967872', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'110 East Main Street', N'Hiawassee', N'GA', N'13281', N'30546', 34.949259, -83.757395, 970, 72, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1354, N'Wills Memorial Hospital', 1, NULL, NULL, N'111325', NULL, NULL, 0, 25, NULL, N'7066789212', N'7066781546', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'120 Gordon Street', N'Washington', N'GA', N'13317', N'30673', 33.729081, -82.741553, 1020, 73, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1355, N'Sgmc Lanier Campus', 1, NULL, NULL, N'111326', NULL, NULL, 0, 25, NULL, N'2294828402', N'2294828539', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'116 West Thigpen Avenue', N'Lakeland', N'GA', N'13173', N'31635', 31.041395, -83.083884, 977, 69, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1356, N'Bacon County Hospital', 1, NULL, NULL, N'111327', NULL, NULL, 0, 25, NULL, N'9126328961', N'9126325000', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'302 South Wayne Street', N'Alma', N'GA', N'13005', N'31510', 31.540393, -82.459332, 914, 59, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1357, N'Phoebe Worth Medical Center', 1, NULL, NULL, N'111328', NULL, NULL, 0, 25, NULL, N'2297773851', N'2297760057', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'807 South Isabella Street', N'Sylvester', N'GA', N'13321', N'31791', 31.513396, -83.839658, 913, 71, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1358, N'St Mary''s Good Samaritan Hospital', 1, NULL, NULL, N'111329', NULL, NULL, 0, 25, NULL, N'7064537331', N'7064532812', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5401 Lake Oconee Parkway', N'Greensboro', N'GA', N'13133', N'30642', 33.575683, -83.182379, 964, 72, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1359, N'Polk Medical Center', 1, NULL, NULL, N'111330', NULL, NULL, 0, 25, NULL, N'7707482500', N'7707498574', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2360 Rockmart Highway', N'Cedartown', N'GA', N'13233', N'30125', 34.018099, -85.20948, 997, 76, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1360, N'Mitchell County Hospital', 1, NULL, NULL, N'111331', NULL, NULL, 0, 25, NULL, N'2293365284', N'2293364682', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'90 Stephens Street', N'Camilla', N'GA', N'13205', N'31730', 31.231293, -84.210461, 913, 71, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1361, N'Brooks County Hospital', 1, NULL, NULL, N'111332', NULL, NULL, 0, 25, NULL, N'9122636309', N'2292636335', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'903 N Court St', N'Quitman', N'GA', N'13027', N'31643', 30.79545, -83.559427, 993, 69, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1362, N'Jeff Davis Hospital', 1, NULL, NULL, N'111333', NULL, NULL, 0, 25, NULL, N'9123757781', N'9123754055', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'163 South Tallahassee Street P O Box 1690', N'Hazlehurst', N'GA', N'13161', N'31539', 30.913565, -81.838443, 969, 77, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1363, N'Candler County Hospital', 1, NULL, NULL, N'111334', NULL, NULL, 0, 25, NULL, N'9126855741', N'9126853905', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'400 Cedar Street', N'Metter', N'GA', N'13043', N'30439', 32.407111, -82.066505, 983, 77, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1364, N'Liberty Regional Medical Center', 1, NULL, NULL, N'111335', NULL, NULL, 0, 25, NULL, N'9123699438', N'9128779438', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'462 E G Miles Parkway', N'Hinesville', N'GA', N'13179', N'31310', 31.84773, -81.596035, 971, 77, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1365, N'Mountain Lakes Medical Center', 1, NULL, NULL, N'111336', NULL, NULL, 0, 25, NULL, N'7067820400', N'7067820451', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'196 Ridgecrest Circle', N'Clayton', N'GA', N'13241', N'30525', 34.883853, -83.415049, 934, 72, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1366, N'Roosevelt Warm Springs Ltac Hospital', 1, NULL, NULL, N'112000', NULL, NULL, 0, 32, NULL, N'7066555515', N'7066555011', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6135 Roosevelt Highway', N'Warm Springs', N'GA', N'13199', N'31830', 32.890408, -84.681038, 976, 72, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1367, N'Shepherd Center', 1, NULL, NULL, N'112003', NULL, NULL, 0, 132, NULL, N'4043527311', N'4043507341', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2020 Peachtree Rd Nw', N'Atlanta', N'GA', N'13121', N'30309', 33.749099, -84.390185, 918, 72, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1368, N'Kindred Hospital - Atlanta', 1, NULL, NULL, N'112004', NULL, NULL, 0, 72, NULL, N'4048732871', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'705 Juniper Street Ne', N'Atlanta', N'GA', N'13089', N'30308', 33.773888, -84.382687, 918, 72, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1369, N'Select Specialty Hospital - Northeast Atlanta', 1, NULL, NULL, N'112005', NULL, NULL, 0, 18, NULL, N'4047286200', N'4047286828', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1821 Clifton Road Ne', N'Atlanta', N'GA', N'13089', N'30329', 33.795478, -84.321354, 918, 72, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1370, N'Dekalb Medical Center At Decatur', 1, NULL, NULL, N'112006', NULL, NULL, 0, 76, NULL, N'4043770221', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'450 North Candler Street', N'Decatur', N'GA', N'13089', N'30030', 33.776677, -84.292747, 946, 72, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1371, N'Wellstar Windy Hill Hospital', 1, NULL, NULL, N'112007', NULL, NULL, 0, 115, NULL, N'7706441081', N'7706441082', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2540 Windy Hill Rd', N'Marietta', N'GA', N'13067', N'30067', 33.952847, -84.549615, 981, 72, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1372, N'Select Specialty Hospital - Atlanta', 1, NULL, NULL, N'112009', NULL, NULL, 0, 30, NULL, N'4046862270', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'550 Peachtree Street Ne 7Th Floor', N'Atlanta', N'GA', N'13121', N'30308', 33.749099, -84.390185, 918, 72, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1373, N'Kindred Hospital Rome', 1, NULL, NULL, N'112010', NULL, NULL, 0, 45, NULL, N'7065094100', N'7065094150', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'320 Turner Mccall Boulevard', N'Rome', N'GA', N'13115', N'30165', 34.244931, -85.161225, 997, 76, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1374, N'Select Specialty Hospital - Savannah Inc', 1, NULL, NULL, N'112011', NULL, NULL, 0, 40, NULL, N'9128197986', N'9128195972', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5353 Reynolds Street 4 South', N'Savannah', N'GA', N'13051', N'31405', 32.083541, -81.099834, 1001, 77, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1375, N'Columbus Specialty Hospital Inc', 1, NULL, NULL, N'112012', NULL, NULL, 0, 30, NULL, N'7063216709', N'7063216616', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'710 Center Street 9Th & 10Th Floors', N'Columbus', N'GA', N'13215', N'31901', 32.460976, -84.987709, 937, 74, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1376, N'Select Specialty Hospital - Augusta Inc', 1, NULL, NULL, N'112013', NULL, NULL, 0, 30, NULL, N'7067311200', N'7067367087', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1537 Walton Way', N'Augusta', N'GA', N'13245', N'30909', 33.475481, -81.989939, 919, 73, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1377, N'Regency Hospital Of South Atlanta', 1, NULL, NULL, N'112014', NULL, NULL, 0, 40, NULL, N'4044666264', N'4044666267', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1170 Cleveland Ave 4Th Floor', N'East Point', N'GA', N'13121', N'30344', 33.665434, -84.486489, 952, 72, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1378, N'Southern Crescent Hospital For Specialty Care', 1, NULL, NULL, N'112015', NULL, NULL, 0, 30, NULL, N'7708977600', N'7708977606', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'11 Upper Riverdale Road Sw 6Th Floor', N'Riverdale', N'GA', N'13063', N'30274', 33.572611, -84.413259, 996, 72, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1379, N'Regency Hospital Company Of Macon Llc', 1, NULL, NULL, N'112016', NULL, NULL, 0, 34, NULL, N'4788037300', N'4788037531', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'535 Coliseum Drive', N'Macon', N'GA', N'13021', N'31217', 32.844133, -83.617348, 980, 75, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1380, N'Landmark Hospital Of Athens Llc', 1, NULL, NULL, N'112017', NULL, NULL, 0, 42, NULL, N'7064251518', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'775 Sunset Drive', N'Athens', N'GA', N'13059', N'30606', 33.962105, -83.410513, 917, 72, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1381, N'Roosevelt Warm Springs Rehabilitation Hospital', 1, NULL, NULL, N'113028', NULL, NULL, 0, 52, NULL, N'7066555515', N'7066555011', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6135 Roosevelt Highway', N'Warm Springs', N'GA', N'13199', N'31830', 32.890408, -84.681038, 976, 72, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1382, N'Central Georgia Rehabilitation Hospital Llc', 1, NULL, NULL, N'113029', NULL, NULL, 0, 58, NULL, N'4784716500', N'4787570876', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3351 Northside Drive', N'Macon', N'GA', N'13021', N'31210', 32.894155, -83.684371, 980, 75, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1383, N'Healthsouth Walton Rehabilitation Hospital', 1, NULL, NULL, N'113030', NULL, NULL, 0, 58, NULL, N'7067247746', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1355 Independence Drive', N'Augusta', N'GA', N'13245', N'30901', 33.474364, -81.979605, 919, 73, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1384, N'Emory Rehabilitation Hospital', 1, NULL, NULL, N'113031', NULL, NULL, 0, 56, NULL, N'4047125512', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1441 Clifton Road', N'Atlanta', N'GA', N'13089', N'30322', 33.749099, -84.390185, 918, 72, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1385, N'Healthsouth Rehabilitation Hospital Of Newnan', 1, NULL, NULL, N'113032', NULL, NULL, 0, 50, NULL, N'6785526200', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2101 East Newnan Crossing Blvd', N'Newnan', N'GA', N'13077', N'30265', 33.380672, -84.799657, 990, 72, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1386, N'Children''s Healthcare Of Atlanta At Egleston', 1, NULL, NULL, N'113300', NULL, NULL, 0, 249, NULL, N'4047856101', N'4047851922', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1405 Clifton Road Ne', N'Atlanta', N'GA', N'13089', N'30322', 33.795478, -84.321354, 918, 72, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1387, N'Childrens Healthcare Of Atlanta At Scottish Rite', 1, NULL, NULL, N'113301', NULL, NULL, 0, 234, NULL, N'4047855252', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1001 Johnson Ferry Rd', N'Atlanta', N'GA', N'13121', N'30342', 33.749099, -84.390185, 918, 72, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1388, N'Summitridge Center- Psychiatry & Addictive Med', 1, NULL, NULL, N'114004', NULL, NULL, 0, 76, NULL, N'6784425800', N'6783125909', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'250 Scenic Highway', N'Lawrenceville', N'GA', N'13135', N'30046', 33.943442, -83.989863, 978, 72, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1389, N'Coastal Harbor Treatment Center', 1, NULL, NULL, N'114008', NULL, NULL, 0, 7, NULL, N'9123543911', N'9123551336', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'1150 Cornell Ave', N'Savannah', N'GA', N'13051', N'31406', 32.011427, -81.097977, 1001, 77, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1390, N'Peachford Behavioral Health System Of Atlanta', 1, NULL, NULL, N'114010', NULL, NULL, 0, 246, NULL, N'7704553200', N'7704542362', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2151 Peachford Road', N'Atlanta', N'GA', N'13089', N'30338', 33.749099, -84.390185, 918, 72, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1391, N'Ridgeview Institute', 1, NULL, NULL, N'114012', NULL, NULL, 0, 148, NULL, N'7704344567', N'7704317088', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3995 S Cobb Drive', N'Smyrna', N'GA', N'13067', N'30080', 33.841364, -84.497775, 1002, 72, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1392, N'West Central Georgia Regional Hospital', 1, NULL, NULL, N'114013', NULL, NULL, 0, 300, NULL, N'7065685203', N'7065682257', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3000 Schatulga Rd Box 12435', N'Columbus', N'GA', N'13215', N'31917', 32.460976, -84.987709, 937, 74, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1393, N'Coliseum Center For Behavioral Health', 1, NULL, NULL, N'114015', NULL, NULL, 0, 92, NULL, N'4784641294', N'4784648100', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'340 Hospital Drive', N'Macon', N'GA', N'13021', N'31201', 32.845853, -83.617848, 980, 75, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1394, N'St Simons-By-The-Sea', 1, NULL, NULL, N'114016', NULL, NULL, 0, 101, NULL, N'9126381999', N'9126382112', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2927 Demere Road', N'Saint Simons Island', N'GA', N'13127', N'31522', 31.15051, -81.36954, 927, 59, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1395, N'Georgia Regional Hospital Atlanta', 1, NULL, NULL, N'114019', NULL, NULL, 0, 347, NULL, N'4042432100', N'4042124621', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3073 Panthersville Road', N'Decatur', N'GA', N'13089', N'30034', 33.773758, -84.296069, 918, 72, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1396, N'Georgia Regional Hosp Savannah', 1, NULL, NULL, N'114028', NULL, NULL, 0, 202, NULL, N'9123562045', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1915 Eisenhower Dr', N'Savannah', N'GA', N'13051', N'31416', 32.001985, -81.084339, 1001, 77, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1397, N'East Central Regional Hospital', 1, NULL, NULL, N'114029', NULL, NULL, 0, 355, NULL, N'7067927066', N'7067902025', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3405 Mike Padgett Hwy', N'Augusta', N'GA', N'13245', N'30906', 33.34577, -81.975796, 919, 73, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1398, N'So Crescent Beh Hlth Sys - Anchor Hospital Campus', 1, NULL, NULL, N'114032', NULL, NULL, 0, 92, NULL, N'7709916044', N'7709972757', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5454 Yorktowne Drive', N'College Park', N'GA', N'13063', N'30349', 33.611475, -84.453712, 952, 72, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1399, N'Riverwoods Behavioral Health System', 1, NULL, NULL, N'114035', NULL, NULL, 0, 45, NULL, N'7709918500', N'7709918507', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'223 Medical Center Drive', N'Riverdale', N'GA', N'13063', N'30274', 33.572611, -84.413259, 996, 72, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1400, N'Greenleaf Center', 1, NULL, NULL, N'114036', NULL, NULL, 0, 50, NULL, N'2292474357', N'2296716636', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'2209 Pineview Drive', N'Valdosta', N'GA', N'13185', N'31602', 30.865464, -83.264606, 1015, 69, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1401, N'Emory University Hospital', 1, NULL, NULL, N'119800', NULL, NULL, 0, 0, NULL, N'4046868500', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'1364 Clifton Road Ne', N'Atlanta', N'GA', N'13089', N'30322', 33.795478, -84.321354, 918, 72, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1402, N'Medical College Of Georgia- Transplant', 1, NULL, NULL, N'119801', NULL, NULL, 0, 0, NULL, N'7067214716', N'7067217877', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'1120 Fifteenth St', N'Augusta', N'GA', N'13245', N'30912', 33.470971, -81.974843, 919, 73, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1403, N'Children''s Healthcare Of Atlanta', 1, NULL, NULL, N'119802', NULL, NULL, 0, 0, NULL, N'4047856121', N'4047856747', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'1405 Clifton Road Ne 6Th Floor Transplant Servi', N'Atlanta', N'GA', N'13089', N'30322', 33.749099, -84.390185, 918, 72, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1404, N'Piedmont Hospital', 1, NULL, NULL, N'119803', NULL, NULL, 0, 0, NULL, N'4046053775', N'4046096699', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'1968 Peachtree Road Nw', N'Atlanta', N'GA', N'13121', N'30309', 33.749099, -84.390185, 918, 72, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1405, N'The Queens Medical Center', 1, NULL, NULL, N'120001', NULL, NULL, 0, 505, NULL, N'8085389011', N'8085474018', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1301 Punchbowl St', N'Honolulu', N'HI', N'15003', N'96813', 21.307613, -157.855094, 1025, 78, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1406, N'Maui Memorial Medical Center', 1, NULL, NULL, N'120002', NULL, NULL, 0, 213, NULL, N'8084425101', N'8084425112', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'221 Mahalani Street', N'Wailuku', N'HI', N'15009', N'96793', 20.881967, -156.492319, 1031, 78, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1407, N'Wahiawa General Hospital', 1, NULL, NULL, N'120004', NULL, NULL, 0, 53, NULL, N'8086218411', N'8086214490', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'128 Lehua Street', N'Wahiawa', N'HI', N'15003', N'96786', 21.497703, -158.026824, 1030, 78, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1408, N'Hilo Medical Center', 1, NULL, NULL, N'120005', NULL, NULL, 0, 142, NULL, N'8089323000', N'8089744746', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1190 Waianuenue Avenue', N'Hilo', N'HI', N'15001', N'96720', 19.717448, -155.108121, 1024, 78, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1409, N'Castle Medical Center', 1, NULL, NULL, N'120006', NULL, NULL, 0, 160, NULL, N'8082635500', N'8082635123', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'640 Ulukahiki St', N'Kailua', N'HI', N'15003', N'96734', 21.379585, -157.758693, 1026, 78, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1410, N'Kuakini Medical Center', 1, NULL, NULL, N'120007', NULL, NULL, 0, 212, NULL, N'8085362236', N'8085479547', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'347 North Kuakini Street', N'Honolulu', N'HI', N'15003', N'96817', 21.32207, -157.856192, 1025, 78, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1411, N'Kaiser Foundation Hospital', 1, NULL, NULL, N'120011', NULL, NULL, 0, 250, NULL, N'8084320000', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3288 Moanalua Rd', N'Honolulu', N'HI', N'15003', N'96819', 21.365517, -157.903849, 1025, 78, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1412, N'Wilcox Memorial Hospital', 1, NULL, NULL, N'120014', NULL, NULL, 0, 71, NULL, N'8082451103', N'8082451171', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3-3420 Kuhio Highway', N'Lihue', N'HI', N'15007', N'96766', 21.981111, -159.371111, 1029, 78, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1413, N'Kona Community Hospital', 1, NULL, NULL, N'120019', NULL, NULL, 0, 60, NULL, N'8083229311', N'8083224488', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'79-1019 Haukapila Street', N'Kealakekua', N'HI', N'15001', N'96750', 19.51763, -155.920726, 1027, 78, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1414, N'Straub Clinic And Hospital', 1, NULL, NULL, N'120022', NULL, NULL, 0, 159, NULL, N'8085224000', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'888 So King Street', N'Honolulu', N'HI', N'15003', N'96813', 21.304547, -157.855676, 1025, 78, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1415, N'Pali Momi Medical Center', 1, NULL, NULL, N'120026', NULL, NULL, 0, 116, NULL, N'8084866000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'98-1079 Moanalua Road', N'Aiea', N'HI', N'15003', N'96701', 21.216044, -157.975203, 1025, 78, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1416, N'North Hawaii Community Hospital', 1, NULL, NULL, N'120028', NULL, NULL, 0, 33, NULL, N'8088854444', N'8088814404', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'67 1125 Mamalahoa Highway', N'Kamuela', N'HI', N'15001', N'96743', 21.216044, -157.975203, 1024, 78, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1417, N'Kauai Veterans Memorial Hospital', 1, NULL, NULL, N'121300', NULL, NULL, 0, 25, NULL, N'8083389431', N'8083389420', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4643 Waimea Canyon Drive', N'Waimea', N'HI', N'15007', N'96796', 21.96235, -159.66677, 1032, 78, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1418, N'Kau Hospital', 1, NULL, NULL, N'121301', NULL, NULL, 0, 5, NULL, N'8089288331', N'8089288980', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1 Kamani Street', N'Pahala', N'HI', N'15001', N'96777', 19.200619, -155.472231, 1024, 78, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1419, N'Kohala Hospital', 1, NULL, NULL, N'121302', NULL, NULL, 0, 4, NULL, N'8088896211', N'8088896978', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'54-383 Hospital Road', N'Kapaau', N'HI', N'15001', N'96755', 20.231128, -155.797777, 1028, 78, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1420, N'Molokai General Hospital', 1, NULL, NULL, N'121303', NULL, NULL, 0, 13, NULL, N'8085535331', N'8085533133', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'280 Home Olu Place', N'Kaunakakai', N'HI', N'15009', N'96748', 21.092818, -157.018662, 1025, 78, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1421, N'Kahuku Medical Center', 1, NULL, NULL, N'121304', NULL, NULL, 0, 11, NULL, N'8082939221', N'8082932262', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'56-117 Pualalea Street', N'Kahuku', N'HI', N'15003', N'96731', 21.675751, -157.951802, 1025, 78, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1422, N'Lanai Community Hospital', 1, NULL, NULL, N'121305', NULL, NULL, 0, 4, NULL, N'8085658450', N'8085658474', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'628 7Th Street', N'Lanai City', N'HI', N'15009', N'96763', 20.825875, -156.920109, 1025, 78, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1423, N'Samuel Mahelona Memorial Hospital', 1, NULL, NULL, N'121306', NULL, NULL, 0, 14, NULL, N'8088224961', N'8088234100', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4800 Kawaihau Road', N'Kapaa', N'HI', N'15007', N'96746', 22.082617, -159.312362, 1029, 78, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1424, N'Hale Ho''ola Hamakua', 1, NULL, NULL, N'121307', NULL, NULL, 0, 11, NULL, N'8089324100', N'8087759977', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'45-547 Plumeria Street', N'Honokaa', N'HI', N'15001', N'96727', 20.078061, -155.468344, 1024, 78, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1425, N'Kula Hospital', 1, NULL, NULL, N'121308', NULL, NULL, 0, 5, NULL, N'8088781221', N'8088781791', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'100 Kokea Place', N'Kula', N'HI', N'15009', N'96790', 21.216044, -157.975203, 1031, 78, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1426, N'Leahi Hospital', 1, NULL, NULL, N'122001', NULL, NULL, 0, 9, NULL, N'8087338000', N'8087337914', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3675 Kilauea Avenue', N'Honolulu', N'HI', N'15003', N'96816', 21.273593, -157.801233, 1025, 78, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1427, N'Rehabilitation Hospital Of The Pacific', 1, NULL, NULL, N'123025', NULL, NULL, 0, 100, NULL, N'8085313511', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'226 N Kuakini Street', N'Honolulu', N'HI', N'15003', N'96817', 21.321137, -157.855107, 1025, 78, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1428, N'Kapiolani Medical Center For Women & Children', 1, NULL, NULL, N'123300', NULL, NULL, 0, 207, NULL, N'8089836000', N'8089838071', 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1319 Punahou Street', N'Honolulu', N'HI', N'15003', N'96826', 21.300274, -157.83382, 1025, 78, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1429, N'Shriners Hospital For Children', 1, NULL, NULL, N'123301', NULL, NULL, 0, 24, NULL, N'8089414466', N'8089428573', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1310 Punahou Street', N'Honolulu', N'HI', N'15003', N'96826', 21.300816, -157.835512, 1025, 78, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1430, N'Kahi Mohala', 1, NULL, NULL, N'124001', NULL, NULL, 0, 88, NULL, N'8086718511', N'8086772570', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'91-2301 Fort Weaver Road', N'Ewa Beach', N'HI', N'15003', N'96706', 21.315544, -158.008177, 1025, 78, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1431, N'The Queen''s Medical Center', 1, NULL, NULL, N'129801', NULL, NULL, 0, 0, NULL, N'8086917066', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'1301 Punchbowl Street', N'Hon', N'HI', N'15003', N'96813', 21.216044, -157.975203, 1025, 78, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1432, N'St Luke''s Magic Valley Rmc', 1, NULL, NULL, N'130002', NULL, NULL, 0, 226, NULL, N'2088141000', N'2088140902', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'801 Pole Line Road West', N'Twin Falls', N'ID', N'16083', N'83301', 42.591993, -114.497052, 1061, 79, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1433, N'St Joseph Regional Medical Center', 1, NULL, NULL, N'130003', NULL, NULL, 0, 145, NULL, N'2087995300', N'2087995528', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'415 Sixth Street', N'Lewiston', N'ID', N'16069', N'83501', 46.416551, -117.017657, 1044, 292, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1434, N'St Luke''s Regional Medical Center', 1, NULL, NULL, N'130006', NULL, NULL, 0, 544, NULL, N'2083812222', N'2084932360', 1, 1, 0, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'190 East Bannock Street', N'Boise', N'ID', N'16001', N'83712', 43.612516, -116.192674, 1034, 79, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1435, N'St Alphonsus Regional Medical Center', 1, NULL, NULL, N'130007', NULL, NULL, 0, 365, NULL, N'2083672121', N'2083674299', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1055 North Curtis Road', N'Boise', N'ID', N'16001', N'83706', 43.612931, -116.253743, 1034, 79, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1436, N'Saint Alphonsus Medical Center - Nampa', 1, NULL, NULL, N'130013', NULL, NULL, 0, 152, NULL, N'2084635000', N'2084635530', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1512 Twelfth Avenue Road', N'Nampa', N'ID', N'16027', N'83686', 43.573736, -116.559642, 1050, 79, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1437, N'West Valley Medical Center', 1, NULL, NULL, N'130014', NULL, NULL, 0, 150, NULL, N'2084594641', N'2084553717', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1717 Arlington Street', N'Caldwell', N'ID', N'16027', N'83605', 43.667874, -116.689416, 1037, 79, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1438, N'Eastern Idaho Regional Medical Center', 1, NULL, NULL, N'130018', NULL, NULL, 0, 330, NULL, N'2085296111', N'2085297021', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3100 Channing Way', N'Idaho Falls', N'ID', N'16019', N'83404', 43.469881, -111.992149, 1042, 80, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1439, N'Madison Memorial Hospital', 1, NULL, NULL, N'130025', NULL, NULL, 0, 49, NULL, N'2083596900', N'2083599879', 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'255 N 3Rd E', N'Rexburg', N'ID', N'16065', N'83440', 43.831268, -111.775313, 1054, 80, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1440, N'Portneuf Medical Center', 1, NULL, NULL, N'130028', NULL, NULL, 0, 187, NULL, N'2082391452', N'2082391958', 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'777 Hospital Way', N'Pocatello', N'ID', N'16005', N'83201', 42.87155, -112.418384, 1052, 279, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1441, N'Kootenai Health', 1, NULL, NULL, N'130049', NULL, NULL, 0, 254, NULL, N'2086254000', N'2086254012', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2003 Kootenai Health Way', N'Coeur D''alene', N'ID', N'16055', N'83814', 47.677683, -116.780466, 1038, 292, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1442, N'Treasure Valley Hospital', 1, NULL, NULL, N'130063', NULL, NULL, 0, 9, NULL, N'2083735000', N'2083735089', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'8800 West Emerald Street', N'Boise', N'ID', N'16001', N'83704', 43.615046, -116.204443, 1034, 79, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1443, N'Mountain View Hospital', 1, NULL, NULL, N'130065', NULL, NULL, 0, 43, NULL, N'2085572711', N'2085427052', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2325 Coronado Street', N'Idaho Falls', N'ID', N'16019', N'83404', 43.474263, -111.987818, 1042, 80, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1444, N'Northwest Specialty Hospital', 1, NULL, NULL, N'130066', NULL, NULL, 0, 34, NULL, N'2082622300', N'2082622390', 1, 0, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1593 East Polston Avenue', N'Post Falls', N'ID', N'16055', N'83854', 47.714833, -116.929213, 1038, 292, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1445, N'Idaho Doctors Hospital', 1, NULL, NULL, N'130067', NULL, NULL, 0, 8, NULL, N'2087822900', N'2087822901', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'350 North Meridian Street', N'Blackfoot', N'ID', N'16011', N'83221', 43.197828, -112.356073, 1033, 80, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1446, N'Boundary Community Hospital', 1, NULL, NULL, N'131301', NULL, NULL, 0, 14, NULL, N'2082674850', N'2082672202', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6640 Kaniksu Street', N'Bonners Ferry', N'ID', N'16021', N'83805', 48.702668, -116.322435, 1035, 292, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1447, N'North Canyon Medical Center', 1, NULL, NULL, N'131302', NULL, NULL, 0, 14, NULL, N'2089344433', N'2089349389', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'267 North Canyon Dr', N'Gooding', N'ID', N'16047', N'83330', 42.938792, -114.713108, 1061, 79, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1448, N'Oneida County Hospital', 1, NULL, NULL, N'131303', NULL, NULL, 0, 11, NULL, N'2087662231', N'2087664819', 1, 1, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'150 North 200 West', N'Malad', N'ID', N'16071', N'83252', 42.194859, -112.250624, 1045, 279, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1449, N'Harms Memorial Hospital', 1, NULL, NULL, N'131304', NULL, NULL, 0, 10, NULL, N'2082263200', N'2082263206', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'510 Roosevelt Street', N'American Falls', N'ID', N'16077', N'83211', 42.781818, -112.849094, 1052, 279, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1450, N'Steele Memorial Medical Center', 1, NULL, NULL, N'131305', NULL, NULL, 0, 18, NULL, N'2087565612', N'2087565656', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'203 South Daisy Street', N'Salmon', N'ID', N'16059', N'83467', 45.173708, -113.890516, 1056, 170, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1451, N'Weiser Memorial Hospital', 1, NULL, NULL, N'131307', NULL, NULL, 0, 25, NULL, N'2085490370', N'2085494429', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'645 East 5Th Street', N'Weiser', N'ID', N'16087', N'83672', 44.248546, -116.961812, 1062, 79, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1452, N'Cascade Medical Center', 1, NULL, NULL, N'131308', NULL, NULL, 0, 10, NULL, N'2083824242', N'2083825081', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'402 Lake Cascade Parkway', N'Cascade', N'ID', N'16085', N'83611', 44.516282, -116.041798, 1034, 79, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1453, N'Caribou Memorial Hospital', 1, NULL, NULL, N'131309', NULL, NULL, 0, 25, NULL, N'2085473341', N'2085472790', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'300 South 3Rd West', N'Soda Springs', N'ID', N'16029', N'83276', 42.654365, -111.604669, 1058, 279, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1454, N'St Luke''s Jerome', 1, NULL, NULL, N'131310', NULL, NULL, 0, 25, NULL, N'2088140007', N'2088140902', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'709 North Lincoln Avenue', N'Jerome', N'ID', N'16053', N'83338', 42.731399, -114.518481, 1061, 79, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1455, N'St Luke''s Elmore Medical Center', 1, NULL, NULL, N'131311', NULL, NULL, 0, 25, NULL, N'2085878401', N'2085878406', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'895 North 6Th East', N'Mountain Home', N'ID', N'16039', N'83647', 43.13295, -115.691197, 1049, 79, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1456, N'St Luke''s Mccall', 1, NULL, NULL, N'131312', NULL, NULL, 0, 15, NULL, N'2084932306', N'2084932360', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1000 State Street', N'Mc Call', N'ID', N'16085', N'83638', 43.644764, -114.015407, 1046, 79, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1457, N'Teton Valley Hospital', 1, NULL, NULL, N'131313', NULL, NULL, 0, 13, NULL, N'2083542383', N'2083543158', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'120 East Howard Dr', N'Driggs', N'ID', N'16081', N'83422', 43.723252, -111.111333, 1040, 80, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1458, N'Shoshone Medical Center', 1, NULL, NULL, N'131314', NULL, NULL, 0, 25, NULL, N'2087841221', N'2087838930', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'25 Jacobs Gulch Road', N'Kellogg', N'ID', N'16079', N'83837', 47.546855, -116.131892, 1043, 292, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1459, N'Syringa General Hospital', 1, NULL, NULL, N'131315', NULL, NULL, 0, 16, NULL, N'2089831700', N'2089838520', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'607 W Main Street', N'Grangeville', N'ID', N'16049', N'83530', 45.926866, -116.127138, 1041, 292, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1460, N'Bear Lake Memorial Hospital', 1, NULL, NULL, N'131316', NULL, NULL, 0, 21, NULL, N'2088471630', N'2088472201', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'164 South Fifth Street', N'Montpelier', N'ID', N'16007', N'83254', 42.32215, -111.297704, 1047, 279, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1461, N'Benewah Community Hospital', 1, NULL, NULL, N'131317', NULL, NULL, 0, 19, NULL, N'2082457614', N'2082452262', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'229 South 7Th Street', N'St Maries', N'ID', N'16009', N'83861', 47.315093, -116.56682, 1059, 292, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1462, N'Walter Knox Memorial Hospital', 1, NULL, NULL, N'131318', NULL, NULL, 0, 16, NULL, N'2083653561', N'2083654176', 1, 1, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1202 East Locust Street', N'Emmett', N'ID', N'16045', N'83617', 43.873498, -116.499301, 1034, 79, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1463, N'Minidoka Memorial Hospital', 1, NULL, NULL, N'131319', NULL, NULL, 0, 25, NULL, N'2084360481', N'2084366038', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1224 8Th Street', N'Rupert', N'ID', N'16067', N'83350', 42.619647, -113.684731, 1055, 279, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1464, N'Clearwater Valley Hospital & Clinics', 1, NULL, NULL, N'131320', NULL, NULL, 0, 23, NULL, N'2084764555', N'2084765385', 1, 1, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'301 Cedar Street', N'Orofino', N'ID', N'16035', N'83544', 46.486966, -116.259746, 1051, 292, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1465, N'St Mary''s Hospital', 1, NULL, NULL, N'131321', NULL, NULL, 0, 23, NULL, N'2089623251', N'2089623722', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'701 Lewiston St', N'Cottonwood', N'ID', N'16049', N'83522', 46.056088, -116.351666, 1039, 292, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1466, N'Franklin County Medical Center', 1, NULL, NULL, N'131322', NULL, NULL, 0, 20, NULL, N'2088520137', N'2088523812', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'44 North First East', N'Preston', N'ID', N'16041', N'83263', 42.096313, -111.876617, 1053, 279, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1467, N'St Luke''s Wood River Medical Center', 1, NULL, NULL, N'131323', NULL, NULL, 0, 25, NULL, N'2084932308', N'2084932360', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'100 Hospital Drive', N'Ketchum', N'ID', N'16013', N'83340', 43.680741, -114.363662, 1060, 79, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1468, N'Lost Rivers Medical Center', 1, NULL, NULL, N'131324', NULL, NULL, 0, 14, NULL, N'2085278206', N'2085273105', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'551 Highland Drive', N'Arco', N'ID', N'16023', N'83213', 43.638972, -113.297661, 1042, 80, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1469, N'Bingham Memorial Hospital', 1, NULL, NULL, N'131325', NULL, NULL, 0, 25, NULL, N'2087853804', N'2087853806', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'98 Poplar Street', N'Blackfoot', N'ID', N'16011', N'83221', 43.193572, -112.347349, 1033, 80, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1470, N'Cassia Regional Medical Center', 1, NULL, NULL, N'131326', NULL, NULL, 0, 25, NULL, N'2086784444', N'2086776555', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1501 Hiland Avenue', N'Burley', N'ID', N'16031', N'83318', 42.535743, -113.792795, 1036, 279, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1471, N'Gritman Medical Center', 1, NULL, NULL, N'131327', NULL, NULL, 0, 25, NULL, N'2088824511', N'2088836571', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'700 South Main Street', N'Moscow', N'ID', N'16057', N'83843', 46.725804, -117.000406, 1048, 292, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1472, N'Bonner General Hospital', 1, NULL, NULL, N'131328', NULL, NULL, 0, 48, NULL, N'2082631441', N'2082651277', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'520 North Third Avenue', N'Sandpoint', N'ID', N'16017', N'83864', 48.27659, -116.553248, 1057, 292, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1473, N'Northern Idaho Advanced Care Hospital', 1, NULL, NULL, N'132001', NULL, NULL, 0, 40, NULL, N'2082622800', N'2082622813', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'600 North Cecil Road', N'Post Falls', N'ID', N'16055', N'83854', 47.715147, -116.948065, 1038, 292, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1474, N'Vibra Hospital Of Boise', 1, NULL, NULL, N'132002', NULL, NULL, 0, 60, NULL, N'2084899500', N'2084899599', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2131 South Bonito Way', N'Meridian', N'ID', N'16001', N'83642', 43.58739, -116.357653, 1034, 79, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1475, N'Southwest Idaho Advanced Care Hospital', 1, NULL, NULL, N'132003', NULL, NULL, 0, 40, NULL, N'2086852400', N'2086852369', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6651 West Franklin Road', N'Boise', N'ID', N'16001', N'83709', 43.615046, -116.204443, 1034, 79, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1476, N'Elks Rehab System', 1, NULL, NULL, N'133025', NULL, NULL, 0, 56, NULL, N'2084894444', N'2084894062', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'600 N Robbins Road', N'Boise', N'ID', N'16001', N'83702', 43.616192, -116.192966, 1034, 79, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1477, N'Rehabilitation Hospital Of The Northwest', 1, NULL, NULL, N'133027', NULL, NULL, 0, 30, NULL, N'2082628700', N'2082628675', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3372 E Jenalan Ave', N'Post Falls', N'ID', N'16055', N'83854', 47.715147, -116.948065, 1038, 292, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1478, N'Intermountain Hospital', 1, NULL, NULL, N'134002', NULL, NULL, 0, 155, NULL, N'2083502354', N'2083773520', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'303 North Allumbaugh Street', N'Boise', N'ID', N'16001', N'83704', 43.615046, -116.204443, 1034, 79, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1479, N'Safe Haven Hospital Of Treasure Valley', 1, NULL, NULL, N'134009', NULL, NULL, 0, 22, NULL, N'2083270504', N'2087269024', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'8050 West Northview Street', N'Boise', N'ID', N'16001', N'83704', 43.626476, -116.264156, 1034, 79, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1480, N'State Hospital South', 1, NULL, NULL, N'134010', NULL, NULL, 0, 120, NULL, N'2087851200', N'2087858409', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'700 East Alice Street', N'Blackfoot', N'ID', N'16011', N'83221', 43.188346, -112.338522, 1033, 80, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1481, N'Safe Haven Hospital Of Pocatello', 1, NULL, NULL, N'134011', NULL, NULL, 0, 14, NULL, N'2082322570', N'2082336769', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1200 Hospital Way', N'Pocatello', N'ID', N'16005', N'83201', 42.868507, -112.417109, 1052, 279, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1482, N'Graham Hospital Association', 1, NULL, NULL, N'140001', NULL, NULL, 0, 144, NULL, N'3096475240', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'210 West Walnut Street', N'Canton', N'IL', N'17057', N'61520', 40.553245, -90.039414, 1076, 89, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1483, N'Alton Memorial Hospital', 1, NULL, NULL, N'140002', NULL, NULL, 0, 222, NULL, N'6184637300', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'One Memorial Drive', N'Alton', N'IL', N'17119', N'62002', 38.890604, -90.184276, 1064, 167, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1484, N'Presence Saint Joseph Medical Center', 1, NULL, NULL, N'140007', NULL, NULL, 0, 443, NULL, N'8157257133', NULL, 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'333 N Madison', N'Joliet', N'IL', N'17197', N'60435', 41.525031, -88.081725, 1123, 87, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1485, N'Loyola Gottlieb Memorial Hospital', 1, NULL, NULL, N'140008', NULL, NULL, 0, 274, NULL, N'7084504924', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'701 West North Ave', N'Melrose Park', N'IL', N'17031', N'60160', 41.900587, -87.856728, 1138, 88, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1486, N'Evanston Hospital', 1, NULL, NULL, N'140010', NULL, NULL, 0, 466, NULL, N'8474328000', NULL, 1, 1, 0, 0, 1, 1, 0, 0, 0, 0, 0, 0, NULL, NULL, N'2650 Ridge Ave', N'Evanston', N'IL', N'17031', N'60201', 42.065997, -87.683949, 1098, 85, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1487, N'Herrin Hospital', 1, NULL, NULL, N'140011', NULL, NULL, 0, 104, NULL, N'6189422171', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'201 S 14Th St', N'Herrin', N'IL', N'17199', N'62948', 37.803034, -89.026458, 1113, 167, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1488, N'Katherine Shaw Bethea Hospital', 1, NULL, NULL, N'140012', NULL, NULL, 0, 80, NULL, N'8152885531', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'403 E 1St St', N'Dixon', N'IL', N'17103', N'61021', 41.843913, -89.481384, 1090, 90, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1489, N'Proctor Hospital', 1, NULL, NULL, N'140013', NULL, NULL, 0, 305, NULL, N'3096911000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5409 N Knoxville Ave', N'Peoria', N'IL', N'17143', N'61614', 40.752355, -89.593408, 1158, 89, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1490, N'Blessing Hospital', 1, NULL, NULL, N'140015', NULL, NULL, 0, 312, NULL, N'2172235811', NULL, 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Broadway At 11Th Street', N'Quincy', N'IL', N'17001', N'62301', 39.935602, -91.409873, 1164, 91, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1491, N'Mt Sinai Hospital Medical Center', 1, NULL, NULL, N'140018', NULL, NULL, 0, 431, NULL, N'7732576751', NULL, 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'15Th Street At California', N'Chicago', N'IL', N'17031', N'60608', 41.875555, -87.624421, 1084, 83, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1492, N'Shelby Memorial Hospital', 1, NULL, NULL, N'140019', NULL, NULL, 0, 30, NULL, N'2177743961', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'200 S Cedar St', N'Shelbyville', N'IL', N'17173', N'62565', 39.406392, -88.807246, 1174, 91, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1493, N'St Marys Hospital', 1, NULL, NULL, N'140026', NULL, NULL, 0, 251, NULL, N'8156732311', NULL, 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'111  Spring Street', N'Streator', N'IL', N'17099', N'61364', 41.114257, -88.8352, 1182, 89, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1494, N'Copley Memorial Hospital', 1, NULL, NULL, N'140029', NULL, NULL, 0, 210, NULL, N'6309786200', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2000 Ogden Avenue', N'Aurora', N'IL', N'17089', N'60504', 41.720302, -88.279175, 1067, 81, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1495, N'Sherman Hospital', 1, NULL, NULL, N'140030', NULL, NULL, 0, 255, NULL, N'8477429800', NULL, 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1425 North Randall Road', N'Elgin', N'IL', N'17089', N'60123', 42.037249, -88.281189, 1095, 84, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1496, N'St Anthonys Memorial Hospital', 1, NULL, NULL, N'140032', NULL, NULL, 0, 146, NULL, N'2173422121', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'503 N Maple Street', N'Effingham', N'IL', N'17049', N'62401', 39.125857, -88.549345, 1093, 91, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1497, N'Vista Medical Center West', 1, NULL, NULL, N'140033', NULL, NULL, 0, 386, NULL, N'8472493900', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2615 Washington St', N'Waukegan', N'IL', N'17097', N'60085', 42.359339, -87.865815, 1187, 303, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1498, N'St Marys Hospital', 1, NULL, NULL, N'140034', NULL, NULL, 0, 125, NULL, N'6184366519', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'400 North Pleasant Avenue', N'Centralia', N'IL', N'17121', N'62801', 38.529152, -89.116129, 1082, 167, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1499, N'Galesburg Cottage Hospital', 1, NULL, NULL, N'140040', NULL, NULL, 0, 140, NULL, N'3093454555', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'695 N Kellogg St', N'Galesburg', N'IL', N'17095', N'61401', 40.955582, -90.366094, 1102, 89, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1500, N'Cgh Medical Center', 1, NULL, NULL, N'140043', NULL, NULL, 0, 99, NULL, N'8156250400', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'100 East Lefevre Road', N'Sterling', N'IL', N'17195', N'61081', 41.788642, -89.696219, 1181, 90, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1501, N'Good Samaritan Regional Hlth Center', 1, NULL, NULL, N'140046', NULL, NULL, 0, 175, NULL, N'6188991469', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1 Good Samaritan Way', N'Mount Vernon', N'IL', N'17081', N'62864', 38.317272, -88.90312, 1145, 167, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1502, N'Advocate Trinity Hospital', 1, NULL, NULL, N'140048', NULL, NULL, 0, 263, NULL, N'7739672000', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2320 E 93Rd St', N'Chicago', N'IL', N'17031', N'60617', 41.726596, -87.56713, 1084, 83, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1503, N'West Suburban Medical Center', 1, NULL, NULL, N'140049', NULL, NULL, 0, 287, NULL, N'7083836200', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3 Erie Court', N'Oak Park', N'IL', N'17031', N'60302', 40.781749, -73.55362, 1150, 88, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1504, N'Saint Anthony''s Health Center', 1, NULL, NULL, N'140052', NULL, NULL, 0, 296, NULL, N'6184652571', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'St Anthony''s Way', N'Alton', N'IL', N'17119', N'62002', 38.908402, -90.172306, 1064, 167, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1505, N'St Johns Hospital', 1, NULL, NULL, N'140053', NULL, NULL, 0, 731, NULL, N'2175446464', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'800 E Carpenter St', N'Springfield', N'IL', N'17167', N'62769', 39.807194, -89.645028, 1179, 91, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1506, N'Macneal  Hospital', 1, NULL, NULL, N'140054', NULL, NULL, 0, 427, NULL, N'7087839100', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3249 South Oak Park Avenue', N'Berwyn', N'IL', N'17031', N'60402', 41.777415, -87.791019, 1072, 88, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1507, N'Passavant Area Hospital', 1, NULL, NULL, N'140058', NULL, NULL, 0, 93, NULL, N'2172459551', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1600 W Walnut St', N'Jacksonville', N'IL', N'17137', N'62650', 39.74536, -90.259635, 1121, 91, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1508, N'Jersey Community Hospital', 1, NULL, NULL, N'140059', NULL, NULL, 0, 67, NULL, N'6184986402', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'400 Maple Summit Road', N'Jerseyville', N'IL', N'17083', N'62052', 39.120047, -90.328448, 1122, 167, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1509, N'Palos Community Hospital', 1, NULL, NULL, N'140062', NULL, NULL, 0, 436, NULL, N'7089234000', NULL, 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'12251 South 80Th Avenue', N'Palos Heights', N'IL', N'17031', N'60463', 41.668163, -87.796281, 1153, 82, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1510, N'Rush Oak Park Hospital', 1, NULL, NULL, N'140063', NULL, NULL, 0, 296, NULL, N'7083839300', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'520 S Maple Ave', N'Oak Park', N'IL', N'17031', N'60304', 41.879011, -87.803731, 1150, 88, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1511, N'St Mary Medical Center', 1, NULL, NULL, N'140064', NULL, NULL, 0, 166, NULL, N'3093443161', NULL, 1, 0, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3333 North Seminary', N'Galesburg', N'IL', N'17095', N'61401', 40.947816, -90.371239, 1102, 89, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1512, N'Adventist La Grange Memorial Hospital', 1, NULL, NULL, N'140065', NULL, NULL, 0, 223, NULL, N'7083521200', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5101 S Willow Springs Rd', N'La Grange', N'IL', N'17031', N'60525', 41.805458, -87.874864, 1126, 88, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1513, N'Saint Francis Medical Center', 1, NULL, NULL, N'140067', NULL, NULL, 0, 730, NULL, N'3096552000', NULL, 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'530 Ne Glen Oak Ave', N'Peoria', N'IL', N'17143', N'61637', 40.70198, -89.591405, 1158, 89, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1514, N'Roseland Community Hospital', 1, NULL, NULL, N'140068', NULL, NULL, 0, 162, NULL, N'7739953000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'45 W 111Th Street', N'Chicago', N'IL', N'17031', N'60628', 41.692296, -87.62598, 1084, 83, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1515, N'Touchette Regional Hospital Inc', 1, NULL, NULL, N'140077', NULL, NULL, 0, 109, NULL, N'6183323060', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5900 Bond Avenue', N'Centreville', N'IL', N'17163', N'62207', 38.840391, -77.428877, 1069, 167, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1516, N'Presence Saint Francis Hospital', 1, NULL, NULL, N'140080', NULL, NULL, 0, 427, NULL, N'8473164000', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'355 Ridge Ave', N'Evanston', N'IL', N'17031', N'60202', 42.024535, -87.684832, 1098, 85, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1517, N'Louis A Weiss Memorial Hospital', 1, NULL, NULL, N'140082', NULL, NULL, 0, 236, NULL, N'7738788700', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4646 N Marine Drive', N'Chicago', N'IL', N'17031', N'60640', 41.966877, -87.649565, 1084, 83, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1518, N'Loretto Hospital', 1, NULL, NULL, N'140083', NULL, NULL, 0, 176, NULL, N'7736264300', NULL, 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'645 South Central Ave', N'Chicago', N'IL', N'17031', N'60644', 41.872109, -87.763571, 1084, 83, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1519, N'Vista Medical Center East', 1, NULL, NULL, N'140084', NULL, NULL, 0, 388, NULL, N'8473604000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1324 North Sheridan Road', N'Waukegan', N'IL', N'17097', N'60085', 42.377933, -87.830954, 1187, 303, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1520, N'The University Of Chicago Medical Center', 1, NULL, NULL, N'140088', NULL, NULL, 0, 633, NULL, N'7737021000', NULL, 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5841 South Maryland', N'Chicago', N'IL', N'17031', N'60637', 41.875555, -87.624421, 1084, 83, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1521, N'Mc Donough District Hospital', 1, NULL, NULL, N'140089', NULL, NULL, 0, 144, NULL, N'3098334101', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'525 East Grant Street', N'Macomb', N'IL', N'17109', N'61455', 40.44801, -90.664515, 1132, 91, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1522, N'The Carle Foundation Hospital', 1, NULL, NULL, N'140091', NULL, NULL, 0, 316, NULL, N'2173833311', NULL, 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'611 West Park Street', N'Urbana', N'IL', N'17019', N'61801', 40.117303, -88.214709, 1184, 92, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1523, N'Presence United Samaritans Medical Center', 1, NULL, NULL, N'140093', NULL, NULL, 0, 210, NULL, N'2174435000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'812 N Logan', N'Danville', N'IL', N'17183', N'61832', 40.125222, -87.630461, 1087, 92, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1524, N'Saint Anthony Hospital', 1, NULL, NULL, N'140095', NULL, NULL, 0, 176, NULL, N'7735211710', N'7734844174', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2875 West 19Th Street', N'Chicago', N'IL', N'17031', N'60623', 41.85526, -87.697827, 1084, 83, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1525, N'Midwestern Region Med Center', 1, NULL, NULL, N'140100', NULL, NULL, 0, 95, NULL, N'8478724561', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2520 Elisha Avenue', N'Zion', N'IL', N'17097', N'60099', 42.449325, -87.826989, 1187, 303, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1526, N'Morris Hospital & Healthcare Centers', 1, NULL, NULL, N'140101', NULL, NULL, 0, 82, NULL, N'8159422932', N'8159411621', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'150 W High St', N'Morris', N'IL', N'17063', N'60450', 41.369034, -88.425589, 1143, 87, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1527, N'St Bernard Hospital', 1, NULL, NULL, N'140103', NULL, NULL, 0, 210, NULL, N'7739623900', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'326 W 64Th St', N'Chicago', N'IL', N'17031', N'60621', 41.778738, -87.632727, 1084, 83, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1528, N'Ottawa Regional Hospital & Healthcare Center', 1, NULL, NULL, N'140110', NULL, NULL, 0, 50, NULL, N'8154333100', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1100 East Norris Drive', N'Ottawa', N'IL', N'17099', N'61350', 41.356462, -88.825633, 1152, 89, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1529, N'Presence Covenant Medical Center', 1, NULL, NULL, N'140113', NULL, NULL, 0, 268, NULL, N'2173372000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1400 West Park Avenue', N'Urbana', N'IL', N'17019', N'61801', 40.111717, -88.207301, 1184, 92, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1530, N'Swedish Covenant Hospital', 1, NULL, NULL, N'140114', NULL, NULL, 0, 284, NULL, N'7738788200', NULL, 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5145 N California Ave', N'Chicago', N'IL', N'17031', N'60625', 41.975235, -87.698791, 1084, 83, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1531, N'Thorek Memorial Hospital', 1, NULL, NULL, N'140115', NULL, NULL, 0, 218, NULL, N'3125256780', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'850 W Irving Park Rd', N'Chicago', N'IL', N'17031', N'60613', 41.954602, -87.652291, 1084, 83, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1532, N'Centegra Health System - Mc Henry Hospital', 1, NULL, NULL, N'140116', NULL, NULL, 0, 177, NULL, N'8153445000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4201 Medical Center Drive', N'Mchenry', N'IL', N'17111', N'60050', 42.333355, -88.266753, 1136, 84, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1533, N'Presence Resurrection Medical Center', 1, NULL, NULL, N'140117', NULL, NULL, 0, 443, NULL, N'7737748000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7435 W Talcott Avenue', N'Chicago', N'IL', N'17031', N'60631', 41.98637, -87.814619, 1084, 83, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1534, N'Metrosouth Medical Center', 1, NULL, NULL, N'140118', NULL, NULL, 0, 309, NULL, N'7085972000', NULL, 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'12935 S Gregory', N'Blue Island', N'IL', N'17031', N'60406', 41.655308, -87.67759, 1074, 82, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1535, N'Rush University Medical Center', 1, NULL, NULL, N'140119', NULL, NULL, 0, 53, NULL, N'3129425000', NULL, 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1653 West Congress Parkway', N'Chicago', N'IL', N'17031', N'60612', 41.875067, -87.668382, 1084, 83, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1536, N'Pekin Memorial Hospital', 1, NULL, NULL, N'140120', NULL, NULL, 0, 132, NULL, N'3093471151', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'600 South 13Th Street', N'Pekin', N'IL', N'17179', N'61554', 40.562279, -89.633062, 1157, 89, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1537, N'Hinsdale Hospital', 1, NULL, NULL, N'140122', NULL, NULL, 0, 338, NULL, N'6308569000', NULL, 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'120 North Oak St', N'Hinsdale', N'IL', N'17043', N'60521', 41.805681, -87.9213, 1117, 86, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1538, N'John H Stroger Jr Hospital', 1, NULL, NULL, N'140124', NULL, NULL, 0, 918, NULL, N'3128646000', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1901 W Harrison St', N'Chicago', N'IL', N'17031', N'60612', 41.873985, -87.674802, 1084, 83, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1539, N'Gateway Regional Medical Center', 1, NULL, NULL, N'140125', NULL, NULL, 0, 406, NULL, N'6187983175', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2100 Madison Avenue', N'Granite City', N'IL', N'17119', N'62040', 38.709199, -90.13444, 1106, 167, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1540, N'Advocate Bromenn Medical Center', 1, NULL, NULL, N'140127', NULL, NULL, 0, 176, NULL, N'3094541400', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1304 Franklin Avenue', N'Normal', N'IL', N'17113', N'61761', 40.501543, -88.991044, 1073, 93, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1541, N'Northwestern Lake Forest Hospital', 1, NULL, NULL, N'140130', NULL, NULL, 0, 222, NULL, N'8472345600', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'660 N Westmoreland Road', N'Lake Forest', N'IL', N'17097', N'60045', 42.25242, -87.862948, 1127, 85, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1542, N'Holy Cross Hospital', 1, NULL, NULL, N'140133', NULL, NULL, 0, 311, NULL, N'7734718000', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2701 W 68Th Street', N'Chicago', N'IL', N'17031', N'60629', 41.769955, -87.690885, 1084, 83, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1543, N'Decatur Memorial Hospital', 1, NULL, NULL, N'140135', NULL, NULL, 0, 372, NULL, N'2178778121', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2300 North Edward Street', N'Decatur', N'IL', N'17115', N'62526', 39.853548, -88.9607, 1089, 91, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1544, N'Greenville Regional Hospital', 1, NULL, NULL, N'140137', NULL, NULL, 0, 60, NULL, N'6186641230', N'6186649707', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'200 Healthcare Dr', N'Greenville', N'IL', N'17005', N'62246', 38.902548, -89.40859, 1107, 167, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1545, N'St Margarets Hospital', 1, NULL, NULL, N'140143', NULL, NULL, 0, 90, NULL, N'8156641176', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'600 E 1St St', N'Spring Valley', N'IL', N'17011', N'61362', 41.328756, -89.192445, 1178, 89, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1546, N'St Josephs Hospital', 1, NULL, NULL, N'140145', NULL, NULL, 0, 96, NULL, N'6185264511', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'9515 Holy Cross Ln', N'Breese', N'IL', N'17027', N'62230', 38.625312, -89.525859, 1075, 167, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1547, N'Richland Memorial Hospital', 1, NULL, NULL, N'140147', NULL, NULL, 0, 151, NULL, N'6183952131', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'800 East Locust', N'Olney', N'IL', N'17159', N'62450', 38.735213, -88.072476, 1151, 94, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1548, N'Memorial Medical Center', 1, NULL, NULL, N'140148', NULL, NULL, 0, 562, NULL, N'2177883000', N'2177885591', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'701 N First St', N'Springfield', N'IL', N'17167', N'62781', 42.154909, -72.535797, 1179, 91, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1549, N'University Of Illinois Hospital', 1, NULL, NULL, N'140150', NULL, NULL, 0, 507, NULL, N'3129963900', NULL, 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1740 West Taylor St Suite 1400', N'Chicago', N'IL', N'17031', N'60612', 41.875555, -87.624421, 1084, 83, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1550, N'Presence St Marys Hospital', 1, NULL, NULL, N'140155', NULL, NULL, 0, 170, NULL, N'8159372490', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'500 W Court St', N'Kankakee', N'IL', N'17091', N'60901', 41.121111, -87.871941, 1124, 87, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1551, N'Mercy Hospital And Medical Center', 1, NULL, NULL, N'140158', NULL, NULL, 0, 494, NULL, N'3125672000', NULL, 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2525 S Michigan Ave', N'Chicago', N'IL', N'17031', N'60616', 41.846847, -87.621305, 1084, 83, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1552, N'Fhn Memorial Hospital', 1, NULL, NULL, N'140160', NULL, NULL, 0, 203, NULL, N'8152354131', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1045 West Stephenson Street', N'Freeport', N'IL', N'17177', N'61032', 42.295749, -89.638329, 1101, 90, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1553, N'Saint James Hospital', 1, NULL, NULL, N'140161', NULL, NULL, 0, 81, NULL, N'8158422828', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2500 West Reynolds Street', N'Pontiac', N'IL', N'17105', N'61764', 40.873485, -88.670854, 1162, 93, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1554, N'St Joseph Medical Center', 1, NULL, NULL, N'140162', NULL, NULL, 0, 180, NULL, N'3096623311', NULL, 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2200 E Washington', N'Bloomington', N'IL', N'17113', N'61701', 40.473107, -88.99414, 1073, 93, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1555, N'Memorial Hospital Of Carbondale', 1, NULL, NULL, N'140164', NULL, NULL, 0, 140, NULL, N'6185490721', NULL, 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'405 W Jackson', N'Carbondale', N'IL', N'17077', N'62902', 37.727469, -89.216655, 1077, 167, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1556, N'St Marys Hospital', 1, NULL, NULL, N'140166', NULL, NULL, 0, 355, NULL, N'2174647000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1800 E Lake Shore Dr', N'Decatur', N'IL', N'17115', N'62521', 39.827647, -88.931915, 1089, 91, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1557, N'Iroquois Memorial Hospital', 1, NULL, NULL, N'140167', NULL, NULL, 0, 94, NULL, N'8154325201', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'200 Fairman Street', N'Watseka', N'IL', N'17075', N'60970', 40.776147, -87.736422, 1186, 92, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1558, N'Franciscan St James Health', 1, NULL, NULL, N'140172', NULL, NULL, 0, 200, NULL, N'7087474000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'20201 S Crawford Avenue', N'Olympia Fields', N'IL', N'17031', N'60461', 41.516405, -87.702896, 1085, 82, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1559, N'Presence Mercy Medical Center', 1, NULL, NULL, N'140174', NULL, NULL, 0, 315, NULL, N'6308592222', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1325 N Highland Avenue', N'Aurora', N'IL', N'17089', N'60506', 41.787634, -88.328796, 1067, 81, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1560, N'Centegra Health System - Woodstock Hospital', 1, NULL, NULL, N'140176', NULL, NULL, 0, 190, NULL, N'8157885823', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3701 Doty Road', N'Woodstock', N'IL', N'17111', N'60098', 42.274775, -88.399043, 1190, 90, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1561, N'Jackson Park Hospital', 1, NULL, NULL, N'140177', NULL, NULL, 0, 336, NULL, N'7739477500', NULL, 1, 1, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7531 S Stony Island Ave', N'Chicago', N'IL', N'17031', N'60649', 41.757675, -87.585171, 1084, 83, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1562, N'Little Company Of Mary Hospital', 1, NULL, NULL, N'140179', NULL, NULL, 0, 298, NULL, N'7084226200', NULL, 1, 1, 0, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2800 W 95Th St', N'Evergreen Park', N'IL', N'17031', N'60805', 41.720921, -87.692133, 1149, 82, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1563, N'Presence Saints Mary And Elizabeth Medical Center', 1, NULL, NULL, N'140180', NULL, NULL, 0, 493, NULL, N'3127702000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2233 W Division St', N'Chicago', N'IL', N'17031', N'60622', 41.902506, -87.683275, 1084, 83, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1564, N'South Shore Hospital', 1, NULL, NULL, N'140181', NULL, NULL, 0, 125, NULL, N'7737680810', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'8012 South Crandon Avenue', N'Chicago', N'IL', N'17031', N'60617', 41.749379, -87.569458, 1084, 83, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1565, N'Advocate Illinois Masonic Medical Center', 1, NULL, NULL, N'140182', NULL, NULL, 0, 997, NULL, N'7739751600', NULL, 1, 1, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, NULL, NULL, N'836 West Wellington Avenue', N'Chicago', N'IL', N'17031', N'60657', 41.936699, -87.651444, 1084, 83, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1566, N'Heartland Regional Medical Center', 1, NULL, NULL, N'140184', NULL, NULL, 0, 92, NULL, N'6189987000', N'6189976589', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3333 W De Young', N'Marion', N'IL', N'17199', N'62959', 37.730605, -88.933126, 1133, 117, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1567, N'Memorial Hospital', 1, NULL, NULL, N'140185', NULL, NULL, 0, 341, NULL, N'6182337750', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4500 Memorial Drive', N'Belleville', N'IL', N'17163', N'62226', 38.548816, -90.020455, 1069, 167, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1568, N'Riverside Medical Center', 1, NULL, NULL, N'140186', NULL, NULL, 0, 341, NULL, N'8159331671', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'350 N Wall St', N'Kankakee', N'IL', N'17091', N'60901', 41.12949, -87.885966, 1124, 87, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1569, N'St Elizabeth Hospital', 1, NULL, NULL, N'140187', NULL, NULL, 0, 260, NULL, N'6182342120', NULL, 1, 1, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'211 S Third St', N'Belleville', N'IL', N'17163', N'62220', 38.52005, -89.983993, 1069, 167, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1570, N'Sarah Bush Lincoln Health Center', 1, NULL, NULL, N'140189', NULL, NULL, 0, 203, NULL, N'2172582572', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1000 Health Center Drive P O Box 372', N'Mattoon', N'IL', N'17029', N'61938', 39.484282, -88.377328, 1135, 92, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1571, N'Ingalls Memorial Hospital', 1, NULL, NULL, N'140191', NULL, NULL, 0, 582, NULL, N'7083332300', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'One Ingalls Drive', N'Harvey', N'IL', N'17031', N'60426', 41.610034, -87.646713, 1110, 82, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1572, N'Methodist Hospital Of Chicago', 1, NULL, NULL, N'140197', NULL, NULL, 0, 245, NULL, N'7732719040', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5025 N Paulina Street', N'Chicago', N'IL', N'17031', N'60640', 41.97291, -87.670555, 1084, 83, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1573, N'Elmhurst Memorial Hospital', 1, NULL, NULL, N'140200', NULL, NULL, 0, 247, NULL, N'6308331400', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'155 East Brush Hill Road', N'Elmhurst', N'IL', N'17043', N'60126', 41.863803, -87.935226, 1097, 88, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1574, N'Advocate Condell Medical Center', 1, NULL, NULL, N'140202', NULL, NULL, 0, 284, NULL, N'8479905200', NULL, 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'801 S Milwaukee Ave', N'Libertyville', N'IL', N'17097', N'60048', 42.273221, -87.951306, 1129, 303, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1575, N'Norwegian-American Hospital', 1, NULL, NULL, N'140206', NULL, NULL, 0, 270, NULL, N'7732928200', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1044 N Francisco Ave', N'Chicago', N'IL', N'17031', N'60622', 41.900624, -87.699402, 1084, 83, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1576, N'Advocate Christ Hospital & Medical Center', 1, NULL, NULL, N'140208', NULL, NULL, 0, 695, NULL, N'7086848000', N'7086845012', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4440 W 95Th Street', N'Oak Lawn', N'IL', N'17031', N'60453', 41.720328, -87.732137, 1149, 82, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1577, N'Methodist Medical Center Of Illinois', 1, NULL, NULL, N'140209', NULL, NULL, 0, 485, NULL, N'3096725522', NULL, 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'221 N E Glen Oak Ave', N'Peoria', N'IL', N'17143', N'61636', 40.693861, -89.589101, 1158, 89, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1578, N'Harrisburg Medical Center', 1, NULL, NULL, N'140210', NULL, NULL, 0, 78, NULL, N'6182537671', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'100 Doctor Warren Tuttle Dr', N'Harrisburg', N'IL', N'17165', N'62946', 37.7385, -88.540521, 1108, 94, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1579, N'Delnor Community Hospital', 1, NULL, NULL, N'140211', NULL, NULL, 0, 118, NULL, N'6302083000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'300 Randall Rd', N'Geneva', N'IL', N'17089', N'60134', 41.886691, -88.34049, 1192, 88, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1580, N'Silver Cross Hospital  And Medical Centers', 1, NULL, NULL, N'140213', NULL, NULL, 0, 304, NULL, N'8153001100', NULL, 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1900 Silver Cross Blvd', N'New Lenox', N'IL', N'17197', N'60451', 41.511976, -87.96561, 1123, 87, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1581, N'Presence Saint Joseph Hospital - Elgin', 1, NULL, NULL, N'140217', NULL, NULL, 0, 277, NULL, N'8476953200', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'77 N Airlite Street', N'Elgin', N'IL', N'17089', N'60123', 42.042317, -88.328586, 1095, 84, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1582, N'Advocate Lutheran General Hospital', 1, NULL, NULL, N'140223', NULL, NULL, 0, 608, NULL, N'8477232210', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1775 Dempster St', N'Park Ridge', N'IL', N'17031', N'60068', 42.041241, -87.697127, 1156, 85, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1583, N'Presence Saint Joseph Hospital - Chicago', 1, NULL, NULL, N'140224', NULL, NULL, 0, 402, NULL, N'7736653000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2900 North Lake Shore Drive', N'Chicago', N'IL', N'17031', N'60657', 41.934972, -87.637347, 1084, 83, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1584, N'Swedish American Hospital', 1, NULL, NULL, N'140228', NULL, NULL, 0, 397, NULL, N'8159684400', NULL, 1, 0, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1401 East State Street', N'Rockford', N'IL', N'17201', N'61104', 42.266855, -89.073391, 1169, 90, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1585, N'Edward Hospital', 1, NULL, NULL, N'140231', NULL, NULL, 0, 159, NULL, N'6305273000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'801 South Washington', N'Naperville', N'IL', N'17043', N'60540', 41.772911, -88.147867, 1147, 86, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1586, N'Saint Anthony Medical Center', 1, NULL, NULL, N'140233', NULL, NULL, 0, 254, NULL, N'8152262000', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5666 East State Street', N'Rockford', N'IL', N'17201', N'61108', 42.26604, -89.00633, 1169, 90, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1587, N'Illinois Valley Community Hospital', 1, NULL, NULL, N'140234', NULL, NULL, 0, 65, NULL, N'8152233300', NULL, 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'925 West St', N'Peru', N'IL', N'17099', N'61354', 41.329177, -89.125115, 1159, 89, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1588, N'Rockford Memorial Hospital', 1, NULL, NULL, N'140239', NULL, NULL, 0, 431, NULL, N'8159686861', NULL, 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2400 North Rockton Avenue', N'Rockford', N'IL', N'17201', N'61103', 42.298127, -89.096872, 1169, 90, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1589, N'Westlake Community Hospital', 1, NULL, NULL, N'140240', NULL, NULL, 0, 282, NULL, N'7089384000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1225 Lake St', N'Melrose Park', N'IL', N'17031', N'60160', 41.900587, -87.856728, 1138, 88, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1590, N'Central Dupage Hospital', 1, NULL, NULL, N'140242', NULL, NULL, 0, 361, NULL, N'6306821600', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'25 North Winfield Road', N'Winfield', N'IL', N'17043', N'60190', 41.864336, -88.158337, 1189, 88, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1591, N'Advocate South Suburban Hospital', 1, NULL, NULL, N'140250', NULL, NULL, 0, 286, NULL, N'7087998000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'17800 S Kedzie Ave', N'Hazel Crest', N'IL', N'17031', N'60429', 41.571701, -87.694491, 1112, 82, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1592, N'Presence Our Lady Of The Resurrection Med Ctr', 1, NULL, NULL, N'140251', NULL, NULL, 0, 299, NULL, N'7732827000', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5645 W Addison', N'Chicago', N'IL', N'17031', N'60634', 41.875555, -87.624421, 1084, 83, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1593, N'Northwest Community Hospital 1', 1, NULL, NULL, N'140252', NULL, NULL, 0, 563, NULL, N'8476181000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'800 W Central Road', N'Arlington Heights', N'IL', N'17031', N'60005', 42.06668, -87.993473, 1066, 85, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1594, N'Alexian Brothers Medical Center 1', 1, NULL, NULL, N'140258', NULL, NULL, 0, 483, NULL, N'8474375500', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'800 W Biesterfield Rd', N'Elk Grove Village', N'IL', N'17031', N'60007', 42.004124, -87.970646, 1096, 88, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1595, N'Genesis Health System', 1, NULL, NULL, N'140275', NULL, NULL, 0, 149, NULL, N'3097929363', NULL, 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'801 Illini Drive', N'Silvis', N'IL', N'17161', N'61282', 41.512256, -90.41513, 1175, 104, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1596, N'Loyola University Medical Center', 1, NULL, NULL, N'140276', NULL, NULL, 0, 507, NULL, N'7082169000', NULL, 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2160 S 1St Avenue', N'Maywood', N'IL', N'17031', N'60153', 41.879198, -87.843115, 1138, 88, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1597, N'Trinity Rock Island', 1, NULL, NULL, N'140280', NULL, NULL, 0, 71, NULL, N'3097795000', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2701 17Th St', N'Rock Island', N'IL', N'17161', N'61201', 41.483425, -90.57268, 1168, 104, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1598, N'Northwestern Memorial Hospital', 1, NULL, NULL, N'140281', NULL, NULL, 0, 773, NULL, N'3129262000', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'251 E Huron St', N'Chicago', N'IL', N'17031', N'60611', 41.894401, -87.621241, 1084, 83, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1599, N'Kishwaukee Community Hospital', 1, NULL, NULL, N'140286', NULL, NULL, 0, 94, NULL, N'8157561521', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'One Kish Hospital Drive', N'Dekalb', N'IL', N'17037', N'60115', 41.929474, -88.750365, 1088, 90, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1600, N'Advocate Good Samaritan Hospital', 1, NULL, NULL, N'140288', NULL, NULL, 0, 366, NULL, N'6302755900', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3815 Highland Avenue', N'Downers Grove', N'IL', N'17043', N'60515', 41.818548, -88.010118, 1091, 86, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1601, N'Anderson Hospital', 1, NULL, NULL, N'140289', NULL, NULL, 0, 151, NULL, N'6182885711', NULL, 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6800 State Route 162', N'Maryville', N'IL', N'17119', N'62062', 40.346102, -94.872471, 1134, 167, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1602, N'St Alexius Medical Center', 1, NULL, NULL, N'140290', NULL, NULL, 0, 342, NULL, N'8478432000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1555 N Barrington Rd', N'Hoffman Estates', N'IL', N'17031', N'60194', 42.073816, -88.140935, 1118, 84, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1603, N'Advocate Good Shepherd Hospital', 1, NULL, NULL, N'140291', NULL, NULL, 0, 154, NULL, N'8473819600', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'450 West Highway 22', N'Barrington', N'IL', N'17097', N'60010', 42.153914, -88.136189, 1068, 84, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1604, N'Adventist Glenoaks', 1, NULL, NULL, N'140292', NULL, NULL, 0, 186, NULL, N'6305456160', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'701 Winthrop Avenue', N'Glendale Heights', N'IL', N'17043', N'60139', 41.914819, -88.059885, 1105, 88, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1605, N'Crossroads Community Hospital', 1, NULL, NULL, N'140294', NULL, NULL, 0, 56, NULL, N'6182445500', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'8 Doctors Park Road', N'Mount Vernon', N'IL', N'17081', N'62864', 38.311863, -88.935616, 1145, 167, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1606, N'Provident Hospital Of Chicago', 1, NULL, NULL, N'140300', NULL, NULL, 0, 222, NULL, N'3125722000', NULL, 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'500 E 51St St', N'Chicago', N'IL', N'17031', N'60615', 41.802211, -87.614029, 1084, 83, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1607, N'Adventist Bolingbrook Hospital', 1, NULL, NULL, N'140304', NULL, NULL, 0, 138, NULL, N'6302268100', N'6303126985', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'500 Remington Boulevard', N'Bolingbrook', N'IL', N'17197', N'60440', 41.677922, -88.095491, 1147, 86, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1608, N'Thc - Chicago Inc D/B/A Kindred Hosp Springfield', 1, NULL, NULL, N'140306', NULL, NULL, 0, 50, NULL, N'2175281217', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'701 North Walnut Street', N'Springfield', N'IL', N'17167', N'62702', 39.808965, -89.663653, 1179, 91, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1609, N'Thomas H Boyd Memorial Hospital', 1, NULL, NULL, N'141300', NULL, NULL, 0, 25, NULL, N'2179426946', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'800 School St', N'Carrollton', N'IL', N'17061', N'62016', 39.296279, -90.412491, 1080, 91, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1610, N'Kirby Medical Center', 1, NULL, NULL, N'141301', NULL, NULL, 0, 16, NULL, N'2177622115', NULL, 1, 1, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1111 N State St', N'Monticello', N'IL', N'17147', N'61856', 40.034472, -88.570566, 1142, 92, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1611, N'Midwest Medical Center', 1, NULL, NULL, N'141302', NULL, NULL, 0, 19, NULL, N'8157771340', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'One Medical Center Drive', N'Galena', N'IL', N'17085', N'61036', 42.416674, -90.429017, 1309, 106, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1612, N'Dr John Warner Hospital', 1, NULL, NULL, N'141303', NULL, NULL, 0, 25, NULL, N'2179359571', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'422 W White St', N'Clinton', N'IL', N'17039', N'61727', 40.148863, -88.965244, 1086, 91, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1613, N'Genesis Medical Center Aledo', 1, NULL, NULL, N'141304', NULL, NULL, 0, 22, NULL, N'3095825301', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'409 Nw 9Th Avenue', N'Aledo', N'IL', N'17131', N'61231', 41.205183, -90.758611, 1063, 104, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1614, N'Memorial Hospital L', 1, NULL, NULL, N'141305', NULL, NULL, 0, 48, NULL, N'2173573131', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'South Adams St Po Box 160', N'Carthage', N'IL', N'17067', N'62321', 36.851627, 10.330441, 1081, 91, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1615, N'Community Memorial Hospital', 1, NULL, NULL, N'141306', NULL, NULL, 0, 25, NULL, N'6186352200', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'400 Caldwell', N'Staunton', N'IL', N'17117', N'62088', 39.015203, -89.789804, 1180, 167, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1616, N'Pinckneyville Community Hospital', 1, NULL, NULL, N'141307', NULL, NULL, 0, 25, NULL, N'6183572187', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'101 N Walnut', N'Pinckneyville', N'IL', N'17145', N'62274', 38.080329, -89.382032, 1160, 167, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1617, N'Washington County Hospital*', 1, NULL, NULL, N'141308', NULL, NULL, 0, 15, NULL, N'6183272264', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'705 S Grand', N'Nashville', N'IL', N'17189', N'62263', 36.16223, -86.774353, 1148, 167, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1618, N'Advocate Eureka  Hospital', 1, NULL, NULL, N'141309', NULL, NULL, 0, 18, NULL, N'3094672371', NULL, 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'101 S Major St', N'Eureka', N'IL', N'17203', N'61530', 40.721288, -89.271557, 1191, 89, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1619, N'Mendota Community Hospital', 1, NULL, NULL, N'141310', NULL, NULL, 0, 25, NULL, N'8155397461', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1401 E 12Th Street', N'Mendota', N'IL', N'17099', N'61342', 41.554865, -89.097971, 1139, 90, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1620, N'Fairfield Memorial Hospital 1', 1, NULL, NULL, N'141311', NULL, NULL, 0, 15, NULL, N'6188422611', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'303 N W 11Th Street', N'Fairfield', N'IL', N'17191', N'62837', 38.249358, -122.039966, 1099, 94, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1621, N'Rochelle Community Hospital', 1, NULL, NULL, N'141312', NULL, NULL, 0, 25, NULL, N'8155622181', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'900 N 2Nd St', N'Rochelle', N'IL', N'17141', N'61068', 41.929241, -89.062947, 1167, 90, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1622, N'Mason District Hospital', 1, NULL, NULL, N'141313', NULL, NULL, 0, 25, NULL, N'3095434431', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'615 North Promenade Street P O Box 530', N'Havana', N'IL', N'17125', N'62644', 23.137991, -82.365856, 1111, 91, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1623, N'Illini Community Hospital', 1, NULL, NULL, N'141315', NULL, NULL, 0, 25, NULL, N'2172852113', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'640 W Washington', N'Pittsfield', N'IL', N'17149', N'62363', 42.450085, -73.245382, 1161, 91, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1624, N'Hoopeston Community Memorial Hospital', 1, NULL, NULL, N'141316', NULL, NULL, 0, 23, NULL, N'2172835531', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'701 East Orange Street', N'Hoopeston', N'IL', N'17183', N'60942', 40.458838, -87.680878, 1119, 92, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1625, N'Gibson Community Hospital', 1, NULL, NULL, N'141317', NULL, NULL, 0, 25, NULL, N'2177844251', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1120 N Melvin Street', N'Gibson City', N'IL', N'17053', N'60936', 40.478004, -88.370577, 1104, 92, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1626, N'Osf Holy Family Medical Center', 1, NULL, NULL, N'141318', NULL, NULL, 0, 23, NULL, N'3097343141', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1000 W Harlem Avenue', N'Monmouth', N'IL', N'17187', N'61462', 40.921369, -90.658404, 1141, 89, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1627, N'Hammond Henry Hospital', 1, NULL, NULL, N'141319', NULL, NULL, 0, 25, NULL, N'3099446431', NULL, 1, 0, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'600 N College Avenue', N'Geneseo', N'IL', N'17073', N'61254', 41.460035, -90.157618, 1103, 104, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1628, N'Paris Community Hospital', 1, NULL, NULL, N'141320', NULL, NULL, 0, 15, NULL, N'2174654141', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'721 E Court Street', N'Paris', N'IL', N'17045', N'61944', 39.606778, -87.678629, 1155, 92, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1629, N'Franklin Hospital', 1, NULL, NULL, N'141321', NULL, NULL, 0, 25, NULL, N'6184393761', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'201 Bailey Lane', N'Benton', N'IL', N'17055', N'62812', 38.009224, -88.919469, 1071, 167, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1630, N'Abraham Lincoln Memorial Hospital', 1, NULL, NULL, N'141322', NULL, NULL, 0, 15, NULL, N'2177322161', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'200 Stahlhut Drive', N'Lincoln', N'IL', N'17107', N'62656', 40.148377, -89.364818, 1130, 91, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1631, N'Massac Memorial Hospital', 1, NULL, NULL, N'141323', NULL, NULL, 0, 25, NULL, N'6185242176', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'28 Chick Street Po Box 850', N'Metropolis', N'IL', N'17127', N'62960', 37.151166, -88.731998, 1140, 117, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1632, N'Ferrell Hospital Community Foundations', 1, NULL, NULL, N'141324', NULL, NULL, 0, 25, NULL, N'6182733361', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1201 Pine Street', N'Eldorado', N'IL', N'17165', N'62930', 37.815333, -88.441546, 1094, 94, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1633, N'Osf St Lukes Medical Center', 1, NULL, NULL, N'141325', NULL, NULL, 0, 25, NULL, N'3098533361', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1051 West South Street', N'Kewanee', N'IL', N'17073', N'61443', 41.222091, -89.948787, 1125, 89, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1634, N'Hamilton Memorial Hospital District', 1, NULL, NULL, N'141326', NULL, NULL, 0, 25, NULL, N'6186432361', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'611 S Marshall Avenue', N'Mcleansboro', N'IL', N'17065', N'62859', 38.087276, -88.541113, 1137, 94, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1635, N'Wabash General Hospital 1', 1, NULL, NULL, N'141327', NULL, NULL, 0, 25, NULL, N'6182628621', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1418 College Drive', N'Mount Carmel', N'IL', N'17185', N'62863', 38.41088, -87.761417, 1144, 94, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1636, N'Hardin County General Hospital', 1, NULL, NULL, N'141328', NULL, NULL, 0, 25, NULL, N'6182856634', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Ferrell Road', N'Rosiclare', N'IL', N'17069', N'62982', 37.410873, -88.35511, 1170, 94, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1637, N'Morrison Community Hospital', 1, NULL, NULL, N'141329', NULL, NULL, 0, 25, NULL, N'8157724003', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'303 N Jackson Street', N'Morrison', N'IL', N'17195', N'61270', 41.806728, -89.957798, 1181, 90, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1638, N'Hopedale Medical Complex', 1, NULL, NULL, N'141330', NULL, NULL, 0, 25, NULL, N'3094493321', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'107 Tremont Street', N'Hopedale', N'IL', N'17179', N'61747', 40.418186, -89.417617, 1120, 89, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1639, N'Marshall Browning Hospital', 1, NULL, NULL, N'141331', NULL, NULL, 0, 25, NULL, N'6185422146', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'900 North Washington Street', N'Du Quoin', N'IL', N'17145', N'62832', 38.024751, -89.236219, 1092, 167, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1640, N'Hillsboro Area Hospital', 1, NULL, NULL, N'141332', NULL, NULL, 0, 25, NULL, N'2175326111', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1200 E Tremont Street', N'Hillsboro', N'IL', N'17135', N'62049', 39.153474, -89.481013, 1116, 91, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1641, N'Sarah D Culbertson Memorial Hospital', 1, NULL, NULL, N'141333', NULL, NULL, 0, 22, NULL, N'2173224321', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'238 South Congress Street', N'Rushville', N'IL', N'17169', N'62681', 40.118663, -90.563681, 1171, 91, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1642, N'St Joseph Memorial Hospital', 1, NULL, NULL, N'141334', NULL, NULL, 0, 25, NULL, N'6186843156', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2 South Hospital Drive', N'Murphysboro', N'IL', N'17077', N'62966', 37.773235, -89.326157, 1146, 162, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1643, N'Mercy Harvard Hospital', 1, NULL, NULL, N'141335', NULL, NULL, 0, 25, NULL, N'8159435431', NULL, 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'901 Grant Street', N'Harvard', N'IL', N'17111', N'60033', 42.425818, -88.607593, 1109, 90, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1644, N'St Joseph''s Hospital', 1, NULL, NULL, N'141336', NULL, NULL, 0, 25, NULL, N'6186512600', N'6186512533', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'12866 Troxler Avenue', N'Highland', N'IL', N'17119', N'62249', 38.739492, -89.671201, 1114, 167, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1645, N'Perry Memorial Hospital', 1, NULL, NULL, N'141337', NULL, NULL, 0, 25, NULL, N'8158752811', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'530 Park Avenue East', N'Princeton', N'IL', N'17011', N'61356', 41.367924, -89.455692, 1163, 90, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1646, N'Memorial Hospital', 1, NULL, NULL, N'141338', NULL, NULL, 0, 25, NULL, N'6188264581', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1900 State Street', N'Chester', N'IL', N'17157', N'62233', 37.918939, -89.811977, 1083, 167, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1647, N'Taylorville Memorial Hospital', 1, NULL, NULL, N'141339', NULL, NULL, 0, 25, NULL, N'2178243331', N'2178242099', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'201 East Pleasant Street', N'Taylorville', N'IL', N'17021', N'62568', 39.553825, -89.294401, 1183, 91, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1648, N'Valley West Community Hospital', 1, NULL, NULL, N'141340', NULL, NULL, 0, 25, NULL, N'8157868484', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1301 North Main Street', N'Sandwich', N'IL', N'17037', N'60548', 41.652665, -88.621866, 1173, 81, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1649, N'Pana Community Hospital', 1, NULL, NULL, N'141341', NULL, NULL, 0, 25, NULL, N'2175622131', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'101 E Ninth Street', N'Pana', N'IL', N'17021', N'62557', 39.388931, -89.080081, 1154, 91, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1650, N'Union County Hospital', 1, NULL, NULL, N'141342', NULL, NULL, 0, 25, NULL, N'6188334511', N'6188338481', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'517 North Main Street', N'Anna', N'IL', N'17181', N'62906', 37.468612, -89.244987, 1065, 162, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1651, N'Crawford Memorial Hospital', 1, NULL, NULL, N'141343', NULL, NULL, 0, 25, NULL, N'6185462514', NULL, 1, 1, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'1000 North Allen Street', N'Robinson', N'IL', N'17033', N'62454', 39.016845, -87.749006, 1166, 94, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1652, N'Lawrence County Memorial Hospital', 1, NULL, NULL, N'141344', NULL, NULL, 0, 25, NULL, N'6189431000', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2200 W State St', N'Lawrenceville', N'IL', N'17101', N'62439', 33.956215, -83.987962, 1128, 94, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1653, N'Salem Township Hospital', 1, NULL, NULL, N'141345', NULL, NULL, 0, 25, NULL, N'6185483194', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1201 Ricker Drive', N'Salem', N'IL', N'17121', N'62881', 38.641218, -88.94803, 1172, 167, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1654, N'Fayette County Hospital', 1, NULL, NULL, N'141346', NULL, NULL, 0, 25, NULL, N'6182831231', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7Th And Taylor', N'Vandalia', N'IL', N'17051', N'62471', 38.960601, -89.093678, 1185, 91, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1655, N'Carlinville Area Hospital', 1, NULL, NULL, N'141347', NULL, NULL, 0, 25, NULL, N'2178543141', N'2178547027', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'20733 N Broad Street', N'Carlinville', N'IL', N'17117', N'62626', 39.283817, -89.881629, 1078, 91, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1656, N'Red Bud Regional Hospital', 1, NULL, NULL, N'141348', NULL, NULL, 0, 25, NULL, N'6182823831', N'6182826101', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'325 Spring Street', N'Red Bud', N'IL', N'17157', N'62278', 38.209611, -89.996294, 1165, 167, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1657, N'Sparta Community Hospital', 1, NULL, NULL, N'141349', NULL, NULL, 0, 25, NULL, N'6184432177', N'6184431337', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'818 E Broadway', N'Sparta', N'IL', N'17157', N'62286', 38.123105, -89.701766, 1177, 167, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1658, N'St Francis Hospital', 1, NULL, NULL, N'141350', NULL, NULL, 0, 25, NULL, N'2173242191', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1215 Franciscan Dr', N'Litchfield', N'IL', N'17135', N'62056', 39.180347, -89.63712, 1131, 91, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1659, N'Clay County Hospital', 1, NULL, NULL, N'141351', NULL, NULL, 0, 18, NULL, N'6186622131', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'911 Stacy Burk Drive', N'Flora', N'IL', N'17025', N'62839', 38.668936, -88.485604, 1100, 91, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1660, N'Thc Chicago Inc Dba Kindred Hosp', 1, NULL, NULL, N'142006', NULL, NULL, 0, 69, NULL, N'8158952144', N'8158957054', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'225 Edward Street', N'Sycamore', N'IL', N'17037', N'60178', 41.982703, -88.688715, 1088, 90, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1661, N'Thc Chicago Inc Dba Kindred Hosp Chgo', 1, NULL, NULL, N'142008', NULL, NULL, 0, 258, NULL, N'7732672620', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'365 E North Ave', N'Northlake', N'IL', N'17031', N'60164', 41.917253, -87.895618, 1097, 88, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1662, N'Thc Chicago Inc Dba Kindred Chicago', 1, NULL, NULL, N'142009', NULL, NULL, 0, 94, NULL, N'7737367000', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4058 W Melrose', N'Chicago', N'IL', N'17031', N'60641', 41.875555, -87.624421, 1084, 83, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1663, N'Rml Specialty Hospital', 1, NULL, NULL, N'142010', NULL, NULL, 0, 189, NULL, N'6302864000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5601 S County Line Rd', N'Hinsdale', N'IL', N'17043', N'60521', 41.787232, -87.917034, 1117, 86, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1664, N'Presence Holy Family Medical Center', 1, NULL, NULL, N'142011', NULL, NULL, 0, 238, NULL, N'8472971800', N'8472971863', 1, 1, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'100 North River Road', N'Des Plaines', N'IL', N'17031', N'60016', 42.054542, -87.888253, 1156, 85, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1665, N'Greater Peoria Specialty Hospital', 1, NULL, NULL, N'142013', NULL, NULL, 0, 50, NULL, N'3096801500', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'500 W Romeo B Garrett Avenue', N'Peoria', N'IL', N'17143', N'61605', 40.693328, -89.601115, 1158, 89, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1666, N'Vibra Hospital Of Springfield', 1, NULL, NULL, N'142014', NULL, NULL, 0, 50, NULL, N'2175281217', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'701 N Walnut', N'Springfield', N'IL', N'17167', N'62702', 39.820079, -89.663912, 1179, 91, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1667, N'Schwab Rehabilitation Hospital', 1, NULL, NULL, N'143025', NULL, NULL, 0, 125, NULL, N'7735222010', NULL, 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1401 S California Blvd', N'Chicago', N'IL', N'17031', N'60608', 41.841433, -87.694434, 1084, 83, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1668, N'Rehabilitation Institute Of Chicago', 1, NULL, NULL, N'143026', NULL, NULL, 0, 182, NULL, N'3122383305', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'345 E Superior St', N'Chicago', N'IL', N'17031', N'60611', 41.89544, -87.618329, 1084, 83, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1669, N'Marianjoy Rehabilitation Hospital', 1, NULL, NULL, N'143027', NULL, NULL, 0, 101, NULL, N'6305887817', NULL, 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'26 W 171 Roosevelt Road', N'Wheaton', N'IL', N'17043', N'60187', 41.863923, -88.112951, 1189, 88, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1670, N'Van Matre Healthsouth Rehabilitation Hospital', 1, NULL, NULL, N'143028', NULL, NULL, 0, 37, NULL, N'8153818548', N'8154849035', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'950 S Mulford Rd', N'Rockford', N'IL', N'17201', N'61108', 42.260821, -88.999573, 1169, 90, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1671, N'Ann & Robert H Lurie Childrens Hospital Of Chicago', 1, NULL, NULL, N'143300', NULL, NULL, 0, 262, NULL, N'7738804000', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'225 E Chicago', N'Chicago', N'IL', N'17031', N'60611', 41.896844, -87.616893, 1084, 83, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1672, N'Larabida Childrens Hospital I', 1, NULL, NULL, N'143301', NULL, NULL, 0, 77, NULL, N'7733636700', NULL, 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'E 65Th St At Lake Michigan', N'Chicago', N'IL', N'17031', N'60649', 41.875555, -87.624421, 1084, 83, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1673, N'Shriners Hospital For Children', 1, NULL, NULL, N'143302', NULL, NULL, 0, 60, NULL, N'7736225400', NULL, 1, 0, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2211 North Oak Park Ave', N'Chicago', N'IL', N'17031', N'60707', 41.92002, -87.793302, 1138, 88, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1674, N'Aurora Chicago Lakeshore Hospital', 1, NULL, NULL, N'144005', NULL, NULL, 0, 147, NULL, N'7738789700', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4840 N Marine Dr', N'Chicago', N'IL', N'17031', N'60640', 41.970339, -87.6506, 1084, 83, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1675, N'Riveredge Hospital', 1, NULL, NULL, N'144009', NULL, NULL, 0, 210, NULL, N'7087717000', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'8311 West Roosevelt Road', N'Forest Park', N'IL', N'17031', N'60130', 43.779974, -85.888483, 1150, 88, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1676, N'Chicago-Read Mental Health Center', 1, NULL, NULL, N'144010', NULL, NULL, 0, 130, NULL, N'7737944000', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'4200 N Oak Park Ave', N'Chicago', N'IL', N'17031', N'60634', 41.955135, -87.799236, 1084, 83, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1677, N'Alton Mental Health Center', 1, NULL, NULL, N'144016', NULL, NULL, 0, 24, NULL, N'6184743800', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4500 College Avenue', N'Alton', N'IL', N'17119', N'62002', 38.907701, -90.122408, 1064, 167, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1678, N'Andrew Mcfarland Mental Hlth Ctr', 1, NULL, NULL, N'144021', NULL, NULL, 0, 146, NULL, N'2177866900', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'901 Southwind Rd', N'Springfield', N'IL', N'17167', N'62703', 39.728278, -89.64457, 1179, 91, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1679, N'Hartgrove Hospital', 1, NULL, NULL, N'144026', NULL, NULL, 0, 160, NULL, N'7734131700', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'5730 W Roosevelt Road', N'Chicago', N'IL', N'17031', N'60644', 41.866304, -87.767379, 1084, 83, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1680, N'John J Madden Mental Health Center', 1, NULL, NULL, N'144028', NULL, NULL, 0, 269, NULL, N'7085317202', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1200 S First Ave', N'Hines', N'IL', N'17031', N'60141', 41.853643, -87.839503, 1138, 88, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1681, N'Pavilion Foundation The', 1, NULL, NULL, N'144029', NULL, NULL, 0, 46, NULL, N'2173731700', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'809 W Church St', N'Champaign', N'IL', N'17019', N'61820', 40.117753, -88.257315, 1184, 92, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1682, N'Alexian Brothers Behavioral Hlth Hosp', 1, NULL, NULL, N'144031', NULL, NULL, 0, 136, NULL, N'8478821600', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1650 Moon Lake Blvd', N'Hoffman Estates', N'IL', N'17031', N'60194', 42.054139, -88.137218, 1118, 84, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1683, N'Bhc Streamwood Hospital Inc', 1, NULL, NULL, N'144034', NULL, NULL, 0, 162, NULL, N'6308379000', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1400 E Irving Park Road', N'Streamwood', N'IL', N'17031', N'60107', 42.00796, -88.152435, 1118, 84, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1684, N'Linden Oaks Hospital', 1, NULL, NULL, N'144035', NULL, NULL, 0, 96, NULL, N'6303055500', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'801 South Washington St', N'Naperville', N'IL', N'17043', N'60540', 41.757794, -88.145566, 1147, 86, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1685, N'Elgin Mental Health Center', 1, NULL, NULL, N'144037', NULL, NULL, 0, 582, NULL, N'8477421040', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'750 S State St', N'Elgin', N'IL', N'17089', N'60123', 42.021006, -88.28368, 1095, 84, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1686, N'Choate Mental Health & Development Ctr', 1, NULL, NULL, N'144038', NULL, NULL, 0, 113, NULL, N'6188335161', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'1000 N Main St', N'Anna', N'IL', N'17181', N'62906', 37.474478, -89.245031, 1065, 162, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1687, N'Garfield Park Hospital', 1, NULL, NULL, N'144039', NULL, NULL, 0, 88, NULL, N'7732653700', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'520 N Ridgeway Ave', N'Chicago', N'IL', N'17031', N'60624', 41.890484, -87.720198, 1084, 83, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1688, N'University Of Chicago Hospitals', 1, NULL, NULL, N'149801', NULL, NULL, 0, 0, NULL, N'7737021000', N'7737021213', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'5841 South Maryland', N'Chicago', N'IL', N'17031', N'60637', 41.875555, -87.624421, 1084, 83, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1689, N'Loyola University Medical Center', 1, NULL, NULL, N'149802', NULL, NULL, 0, 0, NULL, N'7082169000', N'7082166227', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'2160 South 1St Avenue', N'Maywood', N'IL', N'17031', N'60153', 41.879198, -87.843115, 1138, 88, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1690, N'Rush University Medical Center', 1, NULL, NULL, N'149803', NULL, NULL, 0, 0, NULL, N'3129425000', N'3129422055', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'1653 West Congress Parkway', N'Chicago', N'IL', N'17031', N'60612', 41.875067, -87.668382, 1084, 83, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1691, N'Children''s Memorial Hospital', 1, NULL, NULL, N'149804', NULL, NULL, 0, 0, NULL, N'7738804092', N'7739758534', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'2300 Childrens Plaza Box #37', N'Chicago', N'IL', N'17031', N'60614', 41.875555, -87.624421, 1084, 83, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1692, N'University Of Illinois Medical Center', 1, NULL, NULL, N'149805', NULL, NULL, 0, 0, NULL, N'3129963900', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'1740 West Taylor Suite 1400', N'Chicago', N'IL', N'17031', N'60612', 41.875555, -87.624421, 1084, 83, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1693, N'Northwestern Memorial Hospital', 1, NULL, NULL, N'149806', NULL, NULL, 0, 0, NULL, N'3126951705', N'3126951817', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'251 East Huron Street', N'Chicago', N'IL', N'17031', N'60611', 41.894401, -87.621241, 1084, 83, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1694, N'St Francis Medical Center Transplant', 1, NULL, NULL, N'149807', NULL, NULL, 0, 0, NULL, N'3096554101', N'3096552597', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'530 Ne Glen Oak Avenue', N'Peoria', N'IL', N'17143', N'61637', 40.70198, -89.591405, 1158, 89, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1695, N'Memorial Medical Center', 1, NULL, NULL, N'149808', NULL, NULL, 0, 0, NULL, N'2177577886', N'2175273120', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'701 North First Street - Transplant Services', N'Springfield', N'IL', N'17167', N'62781', 39.798976, -89.644369, 1179, 91, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1696, N'Advocate Christ Medical Center', 1, NULL, NULL, N'149809', NULL, NULL, 0, 0, NULL, N'7086842653', N'7086845012', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'4400 West 95Th Street', N'Oak Lawn', N'IL', N'17031', N'60453', 41.720346, -87.731252, 1149, 82, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1697, N'Johnson Memorial Hospital', 1, NULL, NULL, N'150001', NULL, NULL, 0, 125, NULL, N'3177363300', N'3177362692', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1125 W Jefferson St', N'Franklin', N'IN', N'18081', N'46131', 39.479904, -86.066497, 1221, 97, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1698, N'Methodist Hospitals Inc', 1, NULL, NULL, N'150002', NULL, NULL, 0, 536, NULL, N'2198864642', N'2198864209', 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'600 Grant St', N'Gary', N'IN', N'18089', N'46402', 41.599363, -87.35703, 1222, 96, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1699, N'Franciscan St Margaret Health - Hammond', 1, NULL, NULL, N'150004', NULL, NULL, 0, 215, NULL, N'2199322300', N'2199332585', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5454 Hohman Ave', N'Hammond', N'IN', N'18089', N'46320', 41.614478, -87.522126, 1227, 100, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1700, N'Hendricks Regional Health', 1, NULL, NULL, N'150005', NULL, NULL, 0, 160, NULL, N'3177454451', N'3177458352', 1, 1, 0, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1000 E Main St', N'Danville', N'IN', N'18063', N'46122', 39.75757, -86.506768, 1212, 97, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1701, N'Indiana University Health La Porte Hospital', 1, NULL, NULL, N'150006', NULL, NULL, 0, 227, NULL, N'2193261234', N'2193255403', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1007 Lincolnway', N'La Porte', N'IN', N'18091', N'46350', 41.60931, -86.725164, 1239, 101, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1702, N'Community Howard Regional Health Inc', 1, NULL, NULL, N'150007', NULL, NULL, 0, 162, NULL, N'7654538371', N'7654538087', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3500 S Lafountain St', N'Kokomo', N'IN', N'18067', N'46902', 40.437985, -86.127238, 1236, 97, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1703, N'St Catherine Hospital Inc', 1, NULL, NULL, N'150008', NULL, NULL, 0, 189, NULL, N'2193927004', N'2193927002', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4321 Fir St', N'East Chicago', N'IN', N'18089', N'46312', 41.642613, -87.448555, 1215, 100, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1704, N'Clark Memorial Hospital', 1, NULL, NULL, N'150009', NULL, NULL, 0, 241, NULL, N'8122832142', N'8122832688', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1220 Missouri Ave', N'Jeffersonville', N'IN', N'18019', N'47130', 38.272793, -85.750214, 1233, 115, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1705, N'St Joseph Hospital & Health Center Inc', 1, NULL, NULL, N'150010', NULL, NULL, 0, 167, NULL, N'7654565300', N'7654565083', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1907 W Sycamore St', N'Kokomo', N'IN', N'18067', N'46904', 40.487143, -86.155632, 1236, 97, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1706, N'Marion General Hospital', 1, NULL, NULL, N'150011', NULL, NULL, 0, 99, NULL, N'7656607000', N'7656517351', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'441 N Wabash Ave', N'Marion', N'IN', N'18053', N'46952', 40.563744, -85.665163, 1245, 97, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1707, N'Saint Joseph Regional Medical Center', 1, NULL, NULL, N'150012', NULL, NULL, 0, 301, NULL, N'5743355000', N'5743351002', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5215 Holy Cross Pkwy', N'Mishawaka', N'IN', N'18141', N'46545', 41.705323, -86.173591, 1267, 101, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1708, N'Franciscan St Anthony Health - Michigan City', 1, NULL, NULL, N'150015', NULL, NULL, 0, 310, NULL, N'2198798511', N'2198771409', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'301 W Homer St', N'Michigan City', N'IN', N'18091', N'46360', 41.706549, -86.898999, 1247, 96, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1709, N'Lutheran Hospital Of Indiana', 1, NULL, NULL, N'150017', NULL, NULL, 0, 396, NULL, N'2604357001', N'2604357632', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7950 W Jefferson Blvd', N'Fort Wayne', N'IN', N'18003', N'46804', 41.0388, -85.248702, 1219, 95, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1710, N'Elkhart General Hospital', 1, NULL, NULL, N'150018', NULL, NULL, 0, 297, NULL, N'5742942621', N'5745233495', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'600 E Blvd', N'Elkhart', N'IN', N'18039', N'46514', 41.683131, -85.990835, 1216, 101, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1711, N'Parkview Regional Medical Center', 1, NULL, NULL, N'150021', NULL, NULL, 0, 600, NULL, N'2602661000', N'2602661010', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'11109 Parkview Plaza Drive', N'Fort Wayne', N'IN', N'18003', N'46845', 41.07999, -85.138601, 1219, 95, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1712, N'Franciscan St Elizabeth Health - Crawfordsville', 1, NULL, NULL, N'150022', NULL, NULL, 0, 103, NULL, N'7653622800', N'7653643189', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1710 Lafayette Rd', N'Crawfordsville', N'IN', N'18107', N'47933', 40.040199, -86.899025, 1210, 97, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1713, N'Union Hospital Inc', 1, NULL, NULL, N'150023', NULL, NULL, 0, 318, NULL, N'8122387606', N'8122387113', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1606 N Seventh St', N'Terre Haute', N'IN', N'18167', N'47804', 39.466703, -87.413912, 1270, 102, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1714, N'Eskenazi Health', 1, NULL, NULL, N'150024', NULL, NULL, 0, 343, NULL, N'3178804818', N'3178800308', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'720 Eskenazi Avenue', N'Indianapolis', N'IN', N'18097', N'46202', 39.776496, -86.182851, 1231, 97, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1715, N'Iu Health Goshen Hospital', 1, NULL, NULL, N'150026', NULL, NULL, 0, 123, NULL, N'5743641000', N'5743642849', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'200 High Park Ave', N'Goshen', N'IN', N'18039', N'46526', 41.563864, -85.83034, 1223, 101, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1716, N'Henry County Memorial Hospital', 1, NULL, NULL, N'150030', NULL, NULL, 0, 90, NULL, N'7655210890', N'7655211555', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1000 N 16Th St', N'New Castle', N'IN', N'18065', N'47362', 39.942768, -85.364902, 1252, 97, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1717, N'St Mary Medical Center Inc', 1, NULL, NULL, N'150034', NULL, NULL, 0, 176, NULL, N'2199420551', N'2199476037', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1500 S Lake Park Ave', N'Hobart', N'IN', N'18089', N'46342', 41.514841, -87.259081, 1222, 96, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1718, N'Porter Regional Hospital', 1, NULL, NULL, N'150035', NULL, NULL, 0, 301, NULL, N'2199838300', N'2199838080', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'85 East Us Hwy 6', N'Valparaiso', N'IN', N'18127', N'46383', 41.473095, -87.061141, 1272, 96, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1719, N'Hancock Regional Hospital', 1, NULL, NULL, N'150037', NULL, NULL, 0, 69, NULL, N'3174625544', N'3174684077', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'801 N State St', N'Greenfield', N'IN', N'18059', N'46140', 39.806755, -85.769818, 1225, 97, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1720, N'Indiana University Health Morgan Hospital Inc', 1, NULL, NULL, N'150038', NULL, NULL, 0, 116, NULL, N'7653496938', N'7653495168', 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2209 John R Wooden Dr', N'Martinsville', N'IN', N'18109', N'46151', 39.427171, -86.405953, 1246, 97, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1721, N'Good Samaritan Hospital', 1, NULL, NULL, N'150042', NULL, NULL, 0, 165, NULL, N'8128825220', N'8128853737', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'520 S 7Th St', N'Vincennes', N'IN', N'18083', N'47591', 38.673758, -87.532387, 1273, 94, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1722, N'Floyd Memorial Hospital And Health Services', 1, NULL, NULL, N'150044', NULL, NULL, 0, 211, NULL, N'8129495500', N'8129495607', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1850 State St', N'New Albany', N'IN', N'18043', N'47150', 38.300815, -85.835233, 1251, 115, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1723, N'Dekalb Health', 1, NULL, NULL, N'150045', NULL, NULL, 0, 45, NULL, N'2609254600', N'2609258350', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1316 E Seventh St', N'Auburn', N'IN', N'18033', N'46706', 41.36699, -85.058863, 1195, 95, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1724, N'Terre Haute Regional Hospital', 1, NULL, NULL, N'150046', NULL, NULL, 0, 278, NULL, N'8122320021', N'8122379514', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3901 S Seventh St', N'Terre Haute', N'IN', N'18167', N'47802', 39.466703, -87.413912, 1270, 102, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1725, N'St Joseph Hospital', 1, NULL, NULL, N'150047', NULL, NULL, 0, 191, NULL, N'2604253000', N'2604253222', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'700 Broadway', N'Fort Wayne', N'IN', N'18003', N'46802', 41.078766, -85.148953, 1219, 95, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1726, N'Reid Hospital & Health Care Services', 1, NULL, NULL, N'150048', NULL, NULL, 0, 223, NULL, N'7659833000', N'7659833324', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1100 Reid Pkwy', N'Richmond', N'IN', N'18177', N'47374', 39.862811, -84.881147, 1261, 97, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1727, N'Indiana University Health Bloomington Hospital', 1, NULL, NULL, N'150051', NULL, NULL, 0, 297, NULL, N'8123539555', N'8123539339', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'601 W Second St', N'Bloomington', N'IN', N'18105', N'47403', 39.16704, -86.534288, 1199, 97, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1728, N'Indiana University Health', 1, NULL, NULL, N'150056', NULL, NULL, 0, 1733, NULL, N'3179625900', N'3179622276', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1701 N Senate Blvd', N'Indianapolis', N'IN', N'18097', N'46202', 39.768333, -86.15835, 1231, 97, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1729, N'Franciscan St Francis Health - Mooresville', 1, NULL, NULL, N'150057', NULL, NULL, 0, 82, NULL, N'3178311160', N'3178319315', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1201 Hadley Rd', N'Mooresville', N'IN', N'18109', N'46158', 39.609166, -86.358459, 1231, 97, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1730, N'Memorial Hospital Of South Bend', 1, NULL, NULL, N'150058', NULL, NULL, 0, 463, NULL, N'5746471000', N'5746476898', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'615 N Michigan St', N'South Bend', N'IN', N'18141', N'46601', 41.683867, -86.250617, 1267, 101, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1731, N'Riverview Health', 1, NULL, NULL, N'150059', NULL, NULL, 0, 162, NULL, N'3177767108', N'3177767134', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'395 Westfield Rd', N'Noblesville', N'IN', N'18057', N'46060', 40.046943, -86.023928, 1253, 97, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1732, N'Daviess Community Hospital', 1, NULL, NULL, N'150061', NULL, NULL, 0, 80, NULL, N'8122542760', N'8122548850', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1314 E Walnut St', N'Washington', N'IN', N'18027', N'47501', 38.658759, -87.159528, 1276, 94, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1733, N'Fayette Regional Health System', 1, NULL, NULL, N'150064', NULL, NULL, 0, 105, NULL, N'7658255131', N'7658277775', 1, 1, 0, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1941 Virginia Ave', N'Connersville', N'IN', N'18041', N'47331', 39.656037, -85.132066, 1208, 97, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1734, N'Schneck Medical Center', 1, NULL, NULL, N'150065', NULL, NULL, 0, 93, NULL, N'8125222349', N'8125220792', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'411 W Tipton St', N'Seymour', N'IN', N'18071', N'47274', 38.956781, -85.891427, 1265, 97, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1735, N'King''s Daughters'' Health', 1, NULL, NULL, N'150069', NULL, NULL, 0, 67, NULL, N'8128010105', N'8128010680', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1373 East Sr 62', N'Madison', N'IN', N'18077', N'47250', 38.735893, -85.379958, 1244, 115, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1736, N'Memorial Hospital', 1, NULL, NULL, N'150072', NULL, NULL, 0, 83, NULL, N'5747537541', N'5747531402', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1101 Michigan Ave', N'Logansport', N'IN', N'18017', N'46947', 40.763095, -86.362222, 1243, 97, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1737, N'Community Hospital East', 1, NULL, NULL, N'150074', NULL, NULL, 0, 263, NULL, N'3173555411', N'3173517723', 1, 1, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1500 N Ritter Ave', N'Indianapolis', N'IN', N'18097', N'46219', 39.787653, -86.073908, 1231, 97, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1738, N'Bluffton Regional Medical Center', 1, NULL, NULL, N'150075', NULL, NULL, 0, 79, NULL, N'2608243210', N'2609193201', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'303 S Main St', N'Bluffton', N'IN', N'18179', N'46714', 40.737259, -85.171385, 1200, 95, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1739, N'Saint Joseph Regional Medical Center - Plymouth', 1, NULL, NULL, N'150076', NULL, NULL, 0, 58, NULL, N'5749484000', N'5749485478', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1915 Lake Ave', N'Plymouth', N'IN', N'18099', N'46563', 41.335664, -86.331121, 1257, 101, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1740, N'Deaconess Hospital Inc', 1, NULL, NULL, N'150082', NULL, NULL, 0, 558, NULL, N'8124505000', N'8124502155', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'600 Mary St', N'Evansville', N'IN', N'18163', N'47747', 37.987508, -87.570958, 1218, 94, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1741, N'St Vincent Hospital & Health Services', 1, NULL, NULL, N'150084', NULL, NULL, 0, 779, NULL, N'3173387000', N'3173387005', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2001 W 86Th St', N'Indianapolis', N'IN', N'18097', N'46260', 39.768333, -86.15835, 1231, 97, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1742, N'Dearborn County Hospital', 1, NULL, NULL, N'150086', NULL, NULL, 0, 78, NULL, N'8125371010', N'8125372897', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'600 Wilson Creek Rd', N'Lawrenceburg', N'IN', N'18029', N'47025', 39.090891, -84.84995, 1240, 210, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1743, N'St Vincent Anderson Regional Hospital Inc', 1, NULL, NULL, N'150088', NULL, NULL, 0, 195, NULL, N'7656468373', N'7656468504', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2015 Jackson St', N'Anderson', N'IN', N'18095', N'46016', 40.112812, -85.680591, 1193, 97, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1744, N'Indiana University Health Ball Memorial Hospital', 1, NULL, NULL, N'150089', NULL, NULL, 0, 379, NULL, N'7657473111', N'7657512506', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2401 University Ave', N'Muncie', N'IN', N'18035', N'47303', 40.193668, -85.386511, 1249, 99, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1745, N'Franciscan St Margaret Health - Dyer', 1, NULL, NULL, N'150090', NULL, NULL, 0, 198, NULL, N'2198652141', N'2198642585', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'24 Joliet St', N'Dyer', N'IN', N'18089', N'46311', 41.494148, -87.523456, 1214, 100, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1746, N'Parkview Huntington Hospital', 1, NULL, NULL, N'150091', NULL, NULL, 0, 36, NULL, N'2603553000', N'2603353310', 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2001 Stults Rd', N'Huntington', N'IN', N'18069', N'46750', 40.899463, -85.490424, 1230, 95, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1747, N'Major Hospital', 1, NULL, NULL, N'150097', NULL, NULL, 0, 51, NULL, N'3173923211', N'3173981800', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'150 W Washington St', N'Shelbyville', N'IN', N'18145', N'46176', 39.524525, -85.78036, 1266, 97, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1748, N'St Mary''s Medical Center', 1, NULL, NULL, N'150100', NULL, NULL, 0, 414, NULL, N'8124854000', N'8124857800', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3700 Washington Ave', N'Evansville', N'IN', N'18163', N'47750', 37.962484, -87.505593, 1218, 94, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1749, N'Parkview Whitley Hospital', 1, NULL, NULL, N'150101', NULL, NULL, 0, 30, NULL, N'2602489301', N'2602489107', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1260 E Sr 205', N'Columbia City', N'IN', N'18183', N'46725', 41.157264, -85.488307, 1206, 95, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1750, N'Indiana University Health Starke Hospital', 1, NULL, NULL, N'150102', NULL, NULL, 0, 53, NULL, N'5747721102', N'5747725948', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'102 E Culver Rd', N'Knox', N'IN', N'18149', N'46534', 41.288131, -86.621803, 1235, 96, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1751, N'Witham Health Services', 1, NULL, NULL, N'150104', NULL, NULL, 0, 52, NULL, N'7654858000', N'7654858118', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2605 N Lebanon St', N'Lebanon', N'IN', N'18011', N'46052', 40.049372, -86.469202, 1241, 97, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1752, N'Franciscan St Elizabeth Health - Lafayette East', 1, NULL, NULL, N'150109', NULL, NULL, 0, 186, NULL, N'7655024334', N'7655024494', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1701 S Creasy Ln', N'Lafayette', N'IN', N'18157', N'47905', 40.399453, -86.838489, 1237, 98, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1753, N'Columbus Regional Hospital', 1, NULL, NULL, N'150112', NULL, NULL, 0, 160, NULL, N'8123794441', N'8123765001', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2400 E 17Th St', N'Columbus', N'IN', N'18005', N'47201', 39.216126, -85.895469, 1207, 97, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1754, N'Community Hospital Of Anderson And Madison County', 1, NULL, NULL, N'150113', NULL, NULL, 0, 137, NULL, N'7652984242', N'7652985848', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1515 N Madison Ave', N'Anderson', N'IN', N'18095', N'46011', 40.130016, -85.691682, 1193, 97, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1755, N'Memorial Hospital And Health Care Center', 1, NULL, NULL, N'150115', NULL, NULL, 0, 123, NULL, N'8129962345', N'8129960302', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'800 W 9Th St', N'Jasper', N'IN', N'18037', N'47546', 38.393738, -86.938001, 1232, 94, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1756, N'Community Hospital', 1, NULL, NULL, N'150125', NULL, NULL, 0, 437, NULL, N'2198361600', N'2198366380', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'901 Macarthur Blvd', N'Munster', N'IN', N'18089', N'46321', 41.56448, -87.512541, 1250, 100, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1757, N'Franciscan St Anthony Health - Crown Point', 1, NULL, NULL, N'150126', NULL, NULL, 0, 208, NULL, N'2197576100', N'2197576242', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1201 S Main St', N'Crown Point', N'IN', N'18089', N'46307', 41.398313, -87.364527, 1211, 96, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1758, N'Community Hospital South', 1, NULL, NULL, N'150128', NULL, NULL, 0, 127, NULL, N'3178877000', N'3178877112', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1402 E County Line Rd S', N'Indianapolis', N'IN', N'18097', N'46227', 39.636761, -86.068292, 1198, 97, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1759, N'Community Westview Hospital', 1, NULL, NULL, N'150129', NULL, NULL, 0, 120, NULL, N'3179207288', N'3179207550', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3630 Guion Rd', N'Indianapolis', N'IN', N'18097', N'46222', 39.768333, -86.15835, 1231, 97, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1760, N'Kosciusko Community Hospital', 1, NULL, NULL, N'150133', NULL, NULL, 0, 72, NULL, N'5742673200', N'5743727692', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2101 E Dubois Dr', N'Warsaw', N'IN', N'18085', N'46580', 41.238102, -85.853054, 1275, 95, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1761, N'Parkview Noble Hospital', 1, NULL, NULL, N'150146', NULL, NULL, 0, 31, NULL, N'2603478700', N'2603478148', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'401 Sawyer Rd', N'Kendallville', N'IN', N'18113', N'46755', 41.448537, -85.295525, 1234, 95, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1762, N'Women''s Hospital The', 1, NULL, NULL, N'150149', NULL, NULL, 0, 74, NULL, N'8128424200', N'8128424250', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4199 Gateway Blvd', N'Newburgh', N'IN', N'18173', N'47630', 37.945682, -87.404657, 1218, 94, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1763, N'Dupont Hospital Llc', 1, NULL, NULL, N'150150', NULL, NULL, 0, 131, NULL, N'2604163000', N'2604163300', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2520 E Dupont Rd', N'Fort Wayne', N'IN', N'18003', N'46825', 41.179059, -85.094257, 1219, 95, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1764, N'St Vincent Heart Center Of Indiana Llc', 1, NULL, NULL, N'150153', NULL, NULL, 0, 107, NULL, N'3175835000', N'3175835405', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'10580 N Meridian St', N'Indianapolis', N'IN', N'18057', N'46290', 39.778333, -86.157655, 1231, 97, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1765, N'St Vincent Carmel Hospital Inc', 1, NULL, NULL, N'150157', NULL, NULL, 0, 107, NULL, N'3175827000', N'3175827492', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'13500 N Meridian St', N'Carmel', N'IN', N'18057', N'46032', 39.992983, -86.127105, 1231, 97, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1766, N'Iu Health West Hospital', 1, NULL, NULL, N'150158', NULL, NULL, 0, 127, NULL, N'3172173000', N'3172173026', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1111 N Ronald Reagan Pkwy', N'Avon', N'IN', N'18063', N'46123', 39.762823, -86.399717, 1212, 97, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1767, N'Indiana Orthopaedic Hospital', 1, NULL, NULL, N'150160', NULL, NULL, 0, 38, NULL, N'3179561000', N'3179561001', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'8400 Northwest Blvd', N'Indianapolis', N'IN', N'18097', N'46278', 39.768333, -86.15835, 1231, 97, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1768, N'Indiana University Health North Hospital', 1, NULL, NULL, N'150161', NULL, NULL, 0, 149, NULL, N'3176882000', N'3176882001', 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'11700 N Meridian St', N'Carmel', N'IN', N'18057', N'46032', 39.961929, -86.158044, 1231, 97, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1769, N'Franciscan St Francis Health - Indianapolis', 1, NULL, NULL, N'150162', NULL, NULL, 0, 385, NULL, N'3175285000', N'3175286696', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'8111 S Emerson Ave', N'Indianapolis', N'IN', N'18097', N'46237', 39.650312, -86.082547, 1198, 97, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1770, N'Saint Catherine Regional Hospital', 1, NULL, NULL, N'150163', NULL, NULL, 0, 67, NULL, N'8122563301', N'8122566859', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2200  Market St', N'Charlestown', N'IN', N'18019', N'47111', 38.44241, -85.661537, 1204, 115, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1771, N'Monroe Hospital', 1, NULL, NULL, N'150164', NULL, NULL, 0, 32, NULL, N'8128251111', N'8128250750', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4011 S Monroe Medical Park Blvd', N'Bloomington', N'IN', N'18105', N'47403', 39.16704, -86.534288, 1199, 97, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1772, N'Franciscan Healthcare - Munster', 1, NULL, NULL, N'150165', NULL, NULL, 0, 63, NULL, N'2199224200', N'2199226809', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'701 Superior Ave', N'Munster', N'IN', N'18089', N'46321', 41.53735, -87.513297, 1250, 100, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1773, N'Pinnacle Hospital', 1, NULL, NULL, N'150166', NULL, NULL, 0, 18, NULL, N'2197562100', N'2197560412', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'9301 Connecticut Dr', N'Crown Point', N'IN', N'18089', N'46307', 41.416981, -87.365314, 1211, 96, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1774, N'Orthopaedic Hospital At Parkview North Llc', 1, NULL, NULL, N'150167', NULL, NULL, 0, 49, NULL, N'2606724050', N'2606724859', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'11130 Parkview Circle Dr', N'Fort Wayne', N'IN', N'18003', N'46845', 41.07999, -85.138601, 1219, 95, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1775, N'The Orthopaedic Hospital Of Lutheran Health Networ', 1, NULL, NULL, N'150168', NULL, NULL, 0, 44, NULL, N'2604352999', N'2604352557', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7952 W Jefferson Blvd', N'Fort Wayne', N'IN', N'18003', N'46804', 41.039152, -85.243563, 1219, 95, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1776, N'Community Hospital North', 1, NULL, NULL, N'150169', NULL, NULL, 0, 298, NULL, N'3176215335', N'3176217878', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7150 Clearvista Dr', N'Indianapolis', N'IN', N'18097', N'46256', 39.768333, -86.15835, 1231, 97, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1777, N'Physicians'' Medical Center Llc', 1, NULL, NULL, N'150172', NULL, NULL, 0, 12, NULL, N'8122067660', N'8122067650', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4023 Reas Ln', N'New Albany', N'IN', N'18043', N'47150', 38.338879, -85.826973, 1251, 115, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1778, N'Indiana University Health Arnett Hospital', 1, NULL, NULL, N'150173', NULL, NULL, 0, 191, NULL, N'7654488000', N'7654487660', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5165 Mccarty Ln', N'Lafayette', N'IN', N'18157', N'47905', 40.416702, -86.875287, 1237, 98, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1779, N'The Heart Hospital At Deaconess Gateway Llc', 1, NULL, NULL, N'150175', NULL, NULL, 0, 24, NULL, N'8128424784', N'8128423921', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4007 Gateway Blvd', N'Newburgh', N'IN', N'18173', N'47630', 37.945682, -87.404657, 1218, 94, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1780, N'Kentuckiana Medical Center Llc', 1, NULL, NULL, N'150176', NULL, NULL, 0, 42, NULL, N'8122803300', N'8122805960', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4601 Medical Plaza Way', N'Clarksville', N'IN', N'18019', N'47129', 38.296736, -85.759963, 1233, 115, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1781, N'Unity Medical And Surgical Hospital', 1, NULL, NULL, N'150177', NULL, NULL, 0, 29, NULL, N'5742316800', N'5742316845', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4455 Edison Lakes Pkwy', N'Mishawaka', N'IN', N'18141', N'46545', 41.701717, -86.17754, 1267, 101, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1782, N'Fairbanks', 1, NULL, NULL, N'150179', NULL, NULL, 0, 62, NULL, N'3178498222', N'3178491455', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'8102 Clearvista Parkway', N'Indianapolis', N'IN', N'18097', N'46256', 39.768333, -86.15835, 1231, 97, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1783, N'St Vincent Fishers Hospital Inc', 1, NULL, NULL, N'150181', NULL, NULL, 0, 46, NULL, N'3174159000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'13861 Olio Road', N'Fishers', N'IN', N'18057', N'46037', 39.977641, -85.916106, 1193, 97, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1784, N'Franciscan St Francis Health - Carmel', 1, NULL, NULL, N'150182', NULL, NULL, 0, 6, NULL, N'3177054500', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'12188 B North Meridian Street', N'Carmel', N'IN', N'18057', N'46032', 39.978371, -86.118043, 1231, 97, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1785, N'Community Hospital Of Bremen Inc', 1, NULL, NULL, N'151300', NULL, NULL, 0, 24, NULL, N'5745462211', N'5745464312', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1020 High Rd', N'Bremen', N'IN', N'18099', N'46506', 41.455431, -86.151758, 1203, 101, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1786, N'St Vincent Randolph Hospital Inc', 1, NULL, NULL, N'151301', NULL, NULL, 0, 25, NULL, N'7655840004', N'7655840066', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'473 E Greenville Ave', N'Winchester', N'IN', N'18135', N'47394', 40.168431, -84.970949, 1279, 99, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1787, N'Indiana University Health Blackford Hospital', 1, NULL, NULL, N'151302', NULL, NULL, 0, 15, NULL, N'7653480300', N'7653480574', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'410 Pilgrim Blvd', N'Hartford City', N'IN', N'18009', N'47348', 40.468937, -85.372024, 1228, 99, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1788, N'St Vincent Jennings Hospital Inc', 1, NULL, NULL, N'151303', NULL, NULL, 0, 19, NULL, N'8123524200', N'8123524201', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'301 Henry St', N'North Vernon', N'IN', N'18079', N'47265', 39.011261, -85.641203, 1254, 97, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1789, N'Rush Memorial Hospital', 1, NULL, NULL, N'151304', NULL, NULL, 0, 25, NULL, N'7659327513', N'7659327523', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1300 N Main St', N'Rushville', N'IN', N'18139', N'46173', 39.608756, -85.446975, 1263, 97, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1790, N'Pulaski Memorial Hospital', 1, NULL, NULL, N'151305', NULL, NULL, 0, 25, NULL, N'5749462100', N'5749462134', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'616 E 13Th St', N'Winamac', N'IN', N'18131', N'46996', 41.057732, -86.6046, 1278, 97, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1791, N'Indiana University Health Paoli Hospital', 1, NULL, NULL, N'151306', NULL, NULL, 0, 25, NULL, N'8127232811', N'8127237500', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'642 W Hospital Rd', N'Paoli', N'IN', N'18117', N'47454', 38.56778, -86.476171, 1255, 115, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1792, N'St Vincent Williamsport Hospital Inc', 1, NULL, NULL, N'151307', NULL, NULL, 0, 16, NULL, N'7657624000', N'7657624126', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'412 N Monroe St', N'Williamsport', N'IN', N'18171', N'47993', 40.290604, -87.295756, 1277, 98, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1793, N'St Vincent Mercy Hospital', 1, NULL, NULL, N'151308', NULL, NULL, 0, 25, NULL, N'7655524743', N'7655832162', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1331 S A St', N'Elwood', N'IN', N'18095', N'46036', 40.275906, -85.843874, 1217, 97, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1794, N'St Vincent Clay Hospital Inc', 1, NULL, NULL, N'151309', NULL, NULL, 0, 25, NULL, N'8124422500', N'8124422605', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1206 E National Ave', N'Brazil', N'IN', N'18021', N'47834', 39.526851, -87.111368, 1202, 97, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1795, N'Parkview Wabash Hospital Inc', 1, NULL, NULL, N'151310', NULL, NULL, 0, 50, NULL, N'2605633131', N'2605692338', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'710 N East St', N'Wabash', N'IN', N'18169', N'46992', 40.797821, -85.820541, 1274, 95, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1796, N'Indiana University Health Tipton Hospital Inc', 1, NULL, NULL, N'151311', NULL, NULL, 0, 25, NULL, N'7656758500', N'7656758199', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1000 S Main St', N'Tipton', N'IN', N'18159', N'46072', 40.272672, -86.0411, 1271, 97, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1797, N'Indiana University Health White Memorial Hospital', 1, NULL, NULL, N'151312', NULL, NULL, 0, 25, NULL, N'5745837111', N'5745831703', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'720 South Sixth St', N'Monticello', N'IN', N'18181', N'47960', 40.745317, -86.764734, 1248, 97, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1798, N'Woodlawn Hospital', 1, NULL, NULL, N'151313', NULL, NULL, 0, 25, NULL, N'5742233141', N'5742235318', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1400 E 9Th St', N'Rochester', N'IN', N'18049', N'46975', 41.061746, -86.195742, 1262, 101, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1799, N'St Vincent Salem Hospital Inc', 1, NULL, NULL, N'151314', NULL, NULL, 0, 25, NULL, N'8128835881', N'8128838563', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'911 N Shelby St', N'Salem', N'IN', N'18175', N'47167', 38.610113, -86.107785, 1264, 115, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1800, N'Cameron Memorial Community Hospital Inc', 1, NULL, NULL, N'151315', NULL, NULL, 0, 25, NULL, N'2606652141', N'2606657803', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'416 E Maumee St', N'Angola', N'IN', N'18151', N'46703', 41.634815, -84.995533, 1194, 95, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1801, N'St Vincent Frankfort Hospital Inc', 1, NULL, NULL, N'151316', NULL, NULL, 0, 25, NULL, N'7656563000', N'7656563020', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1300 S Jackson St', N'Frankfort', N'IN', N'18023', N'46041', 40.269159, -86.510651, 1220, 97, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1802, N'Greene County General Hospital', 1, NULL, NULL, N'151317', NULL, NULL, 0, 25, NULL, N'8128472281', N'8128476166', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1185 N 1000 W', N'Linton', N'IN', N'18055', N'47441', 39.034767, -87.165846, 1242, 97, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1803, N'Dukes Memorial Hospital', 1, NULL, NULL, N'151318', NULL, NULL, 0, 25, NULL, N'7654728000', N'7654738244', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'275 W 12Th St', N'Peru', N'IN', N'18103', N'46970', 40.756347, -86.084074, 1256, 97, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1804, N'Gibson General Hospital', 1, NULL, NULL, N'151319', NULL, NULL, 0, 25, NULL, N'8123853401', N'8123859323', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1808 Sherman Dr', N'Princeton', N'IN', N'18051', N'47670', 38.360351, -87.590827, 1259, 94, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1805, N'Jay County Hospital', 1, NULL, NULL, N'151320', NULL, NULL, 0, 35, NULL, N'2607267131', N'2607261975', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'500 W Votaw St', N'Portland', N'IN', N'18075', N'47371', 40.439459, -84.984066, 1258, 95, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1806, N'Perry County Memorial Hospital', 1, NULL, NULL, N'151322', NULL, NULL, 0, 25, NULL, N'8125477011', N'8125470169', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'One Hospital Rd', N'Tell City', N'IN', N'18123', N'47586', 37.951445, -86.767766, 1269, 94, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1807, N'Parkview Lagrange Hospital', 1, NULL, NULL, N'151323', NULL, NULL, 0, 25, NULL, N'2604639000', N'2604639420', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'207 N Townline Rd', N'Lagrange', N'IN', N'18087', N'46761', 41.644603, -85.424824, 1238, 95, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1808, N'Jasper County Hospital', 1, NULL, NULL, N'151324', NULL, NULL, 0, 46, NULL, N'2198665141', N'2198663234', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1104 E Grace St', N'Rensselaer', N'IN', N'18073', N'47978', 40.933501, -87.138216, 1260, 98, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1809, N'St Mary''s Warrick Hospital Inc', 1, NULL, NULL, N'151325', NULL, NULL, 0, 35, NULL, N'8128974800', N'8128977375', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1116 Millis Ave', N'Boonville', N'IN', N'18173', N'47601', 38.041263, -87.26327, 1201, 94, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1810, N'Union Hospital Clinton', 1, NULL, NULL, N'151326', NULL, NULL, 0, 25, NULL, N'7658321234', N'7658321382', 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'801 S Main St', N'Clinton', N'IN', N'18165', N'47842', 39.656491, -87.39824, 1205, 102, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1811, N'Sullivan County Community Hospital', 1, NULL, NULL, N'151327', NULL, NULL, 0, 25, NULL, N'8122684311', N'8122682650', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2200 N Section St', N'Sullivan', N'IN', N'18153', N'47882', 39.125676, -87.412167, 1268, 102, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1812, N'Indiana University Health Bedford Hospital', 1, NULL, NULL, N'151328', NULL, NULL, 0, 25, NULL, N'8122751200', N'8122751391', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2900 W 16Th St', N'Bedford', N'IN', N'18093', N'47421', 38.861162, -86.487215, 1197, 97, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1813, N'Margaret Mary Health', 1, NULL, NULL, N'151329', NULL, NULL, 0, 25, NULL, N'8129346624', N'8129335017', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'321 Mitchell Ave', N'Batesville', N'IN', N'18137', N'47006', 39.30407, -85.226308, 1196, 210, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1814, N'Adams Memorial Hospital', 1, NULL, NULL, N'151330', NULL, NULL, 0, 50, NULL, N'2607242145', N'2607283865', 1, 1, 0, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1100 Mercer Ave', N'Decatur', N'IN', N'18001', N'46733', 40.830603, -84.929133, 1213, 95, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1815, N'Harrison County Hospital', 1, NULL, NULL, N'151331', NULL, NULL, 0, 25, NULL, N'8127384251', N'8127387829', 1, 1, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1141 Hospital Dr Nw', N'Corydon', N'IN', N'18061', N'47112', 38.212012, -86.121915, 1209, 115, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1816, N'Decatur County Memorial Hospital', 1, NULL, NULL, N'151332', NULL, NULL, 0, 25, NULL, N'8126634331', N'8126639738', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'720 N Lincoln St', N'Greensburg', N'IN', N'18031', N'47240', 39.343241, -85.479326, 1226, 97, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1817, N'Putnam County Hospital', 1, NULL, NULL, N'151333', NULL, NULL, 0, 25, NULL, N'7656552620', N'7656552625', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1542 S Bloomington St', N'Greencastle', N'IN', N'18133', N'46135', 39.62224, -86.846123, 1224, 97, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1818, N'Scott Memorial Hospital', 1, NULL, NULL, N'151334', NULL, NULL, 0, 25, NULL, N'8127523456', N'8127525884', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1451 N Gardner St', N'Scottsburg', N'IN', N'18143', N'47170', 38.69149, -85.779628, 1281, 115, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1819, N'St Vincent Dunn Hospital Inc', 1, NULL, NULL, N'151335', NULL, NULL, 0, 25, NULL, N'8122753331', N'8122761265', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1600 23Rd St', N'Bedford', N'IN', N'18093', N'47421', 38.853383, -86.494725, 1197, 97, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1820, N'Kindred Hospital Indianapolis', 1, NULL, NULL, N'152007', NULL, NULL, 0, 59, NULL, N'3176364400', N'3176364422', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1700 W 10Th St', N'Indianapolis', N'IN', N'18097', N'46222', 39.779669, -86.188224, 1231, 97, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1821, N'Kindred Hospital- Indianapolis South', 1, NULL, NULL, N'152008', NULL, NULL, 0, 60, NULL, N'3178888155', N'3178887382', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'607 Greenwood Springs Drive', N'Greenwood', N'IN', N'18081', N'46143', 39.630666, -86.076528, 1231, 97, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1822, N'Kindred Hospital Northwest Indiana', 1, NULL, NULL, N'152012', NULL, NULL, 0, 70, NULL, N'2198525305', N'2199332298', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5454 Hohman Ave  5Th Fl', N'Hammond', N'IN', N'18089', N'46320', 41.583366, -87.500043, 1227, 100, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1823, N'Select Specialty Hospital- Indianapolis', 1, NULL, NULL, N'152013', NULL, NULL, 0, 45, NULL, N'3177826669', N'3177838913', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'8060 Knue Road', N'Indianapolis', N'IN', N'18097', N'46250', 39.768333, -86.15835, 1231, 97, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1824, N'Select Specialty Hospital-Evansville', 1, NULL, NULL, N'152014', NULL, NULL, 0, 60, NULL, N'8124212330', N'8124212333', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'400  Se 4Th St', N'Evansville', N'IN', N'18163', N'47713', 37.968155, -87.568207, 1218, 94, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1825, N'Select Specialty Hospital-Fort Wayne', 1, NULL, NULL, N'152016', NULL, NULL, 0, 32, NULL, N'2604253840', N'2604253812', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'700 Broadway 7Th Fl E', N'Fort Wayne', N'IN', N'18003', N'46802', 41.07999, -85.138601, 1219, 95, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1826, N'Kindred Hospital Northern Indiana', 1, NULL, NULL, N'152018', NULL, NULL, 0, 32, NULL, N'5742522000', N'5742522012', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'215 W 4Th St Ste 200', N'Mishawaka', N'IN', N'18141', N'46544', 41.661993, -86.158616, 1280, 101, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1827, N'St Vincent Seton Specialty Hospital Indianapolis', 1, NULL, NULL, N'152020', NULL, NULL, 0, 74, NULL, N'3174158500', N'3174158400', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'8050 Township Line Rd', N'Indianapolis', N'IN', N'18097', N'46260', 39.768333, -86.15835, 1231, 97, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1828, N'Regency Hospital Of Northwest Indiana', 1, NULL, NULL, N'152024', NULL, NULL, 0, 61, NULL, N'2193927790', N'2193984251', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4321 Fir St 4Th Fl', N'East Chicago', N'IN', N'18089', N'46312', 41.639786, -87.454847, 1215, 100, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1829, N'Central Indiana  Amg Specialty Hospital Llc', 1, NULL, NULL, N'152025', NULL, NULL, 0, 32, NULL, N'7657515253', N'7652897251', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2401 W University Ave 8Th Fl', N'Muncie', N'IN', N'18035', N'47303', 40.193668, -85.386511, 1249, 99, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1830, N'Vibra Hospital Of Fort Wayne', 1, NULL, NULL, N'152027', NULL, NULL, 0, 48, NULL, N'2603992900', N'2603992958', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2200 Randallia Drive 5Th Floor', N'Fort Wayne', N'IN', N'18003', N'46805', 41.07999, -85.138601, 1219, 95, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1831, N'Vibra Hospital Of Northwestern Indiana', 1, NULL, NULL, N'152028', NULL, NULL, 0, 40, NULL, N'2194722200', N'2194722148', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'9509 Georgia St', N'Crown Point', N'IN', N'18089', N'46307', 41.416981, -87.365314, 1211, 96, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1832, N'Healthsouth Deaconess Rehabilitation Hospital', 1, NULL, NULL, N'153025', NULL, NULL, 0, 85, NULL, N'8124769983', N'8124764270', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4100 Covert Ave', N'Evansville', N'IN', N'18163', N'47714', 37.955103, -87.500086, 1218, 94, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1833, N'Rehabilitation Hospital Of Indiana Inc', 1, NULL, NULL, N'153028', NULL, NULL, 0, 91, NULL, N'3173292000', N'3173292600', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4141 Shore Dr', N'Indianapolis', N'IN', N'18097', N'46254', 39.768333, -86.15835, 1231, 97, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1834, N'Rehabilitation Hospital Of Fort Wayne General Par', 1, NULL, NULL, N'153030', NULL, NULL, 0, 36, NULL, N'2604356100', N'2604326128', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7970 W Jefferson Blvd', N'Fort Wayne', N'IN', N'18003', N'46804', 41.03905, -85.243674, 1219, 95, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1835, N'Southern Indiana Rehabilitation Hospital', 1, NULL, NULL, N'153037', NULL, NULL, 0, 60, NULL, N'8129416106', N'8129416276', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3104 Blackiston Blvd', N'New Albany', N'IN', N'18043', N'47150', 38.336141, -85.795314, 1251, 115, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1836, N'Community Howard Specialty Hospital', 1, NULL, NULL, N'153039', NULL, NULL, 0, 30, NULL, N'7654526700', N'7654527470', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'829 N Dixon Rd', N'Kokomo', N'IN', N'18067', N'46901', 40.487884, -86.164993, 1236, 97, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1837, N'Lafayette Regional Rehabilitation Hospital', 1, NULL, NULL, N'153042', NULL, NULL, 0, 40, NULL, N'7654474040', N'7654474042', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'950 Park East Blvd', N'Lafayette', N'IN', N'18157', N'47905', 40.409822, -86.82901, 1237, 98, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1838, N'Community Health Network Rehabilitation Hospital', 1, NULL, NULL, N'153043', NULL, NULL, 0, 60, NULL, N'3175855000', N'6158469585', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7343 Clearvista Drive', N'Indianapolis', N'IN', N'18097', N'46250', 39.768333, -86.15835, 1231, 97, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1839, N'River Bend Hospital', 1, NULL, NULL, N'154005', NULL, NULL, 0, 16, NULL, N'7654632555', N'3174973960', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2900 N River Rd', N'West Lafayette', N'IN', N'18157', N'47906', 40.423684, -86.903318, 1237, 98, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1840, N'Larue D Carter Memorial Hospital', 1, NULL, NULL, N'154008', NULL, NULL, 0, 159, NULL, N'3179414000', N'3179414010', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2601 Cold Spring Rd', N'Indianapolis', N'IN', N'18097', N'46222', 39.768333, -86.15835, 1231, 97, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1841, N'Hamilton Center Inc', 1, NULL, NULL, N'154009', NULL, NULL, 0, 16, NULL, N'8122318285', N'8122318411', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'620 8Th Ave', N'Terre Haute', N'IN', N'18167', N'47804', 39.484857, -87.409946, 1270, 102, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1842, N'Community Mental Health Center Inc', 1, NULL, NULL, N'154011', NULL, NULL, 0, 16, NULL, N'8125371302', N'8125370194', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'285 Bielby Rd', N'Lawrenceburg', N'IN', N'18029', N'47025', 39.109506, -84.879328, 1240, 210, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1843, N'Otis R Bowen Center For Human Services Inc', 1, NULL, NULL, N'154014', NULL, NULL, 0, 16, NULL, N'5742677169', N'5742693995', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1535 Provident Dr', N'Warsaw', N'IN', N'18085', N'46580', 41.252537, -85.830817, 1275, 95, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1844, N'Richmond State Hospital', 1, NULL, NULL, N'154018', NULL, NULL, 0, 312, NULL, N'7659660511', N'3179664593', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'498 Nw 18Th St', N'Richmond', N'IN', N'18177', N'47374', 39.834613, -84.926969, 1261, 97, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1845, N'Madison State Hospital', 1, NULL, NULL, N'154019', NULL, NULL, 0, 332, NULL, N'8122652611', N'8122657227', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'711 Green Rd', N'Madison', N'IN', N'18077', N'47250', 38.761666, -85.399884, 1244, 115, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1846, N'Regional Mental Health Center', 1, NULL, NULL, N'154020', NULL, NULL, 0, 16, NULL, N'2197694005', N'2197692508', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'8555 Taft St', N'Merrillville', N'IN', N'18089', N'46410', 41.462641, -87.365077, 1222, 96, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1847, N'Grant-Blackford Mental Health Inc', 1, NULL, NULL, N'154021', NULL, NULL, 0, 16, NULL, N'7656623971', N'7656627480', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'505 Wabash Ave', N'Marion', N'IN', N'18053', N'46952', 39.466397, -87.411478, 1245, 97, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1848, N'Valle Vista Health System', 1, NULL, NULL, N'154024', NULL, NULL, 0, 96, NULL, N'3178835300', N'3178881104', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'898 E Main St', N'Greenwood', N'IN', N'18081', N'46143', 39.613658, -86.106653, 1231, 97, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1849, N'Oaklawn Psychiatric Center Inc', 1, NULL, NULL, N'154031', NULL, NULL, 0, 16, NULL, N'5745331234', N'5745372673', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'330 Lakeview Dr', N'Goshen', N'IN', N'18039', N'46527', 41.603388, -85.835353, 1223, 101, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1850, N'Four County Counseling Center', 1, NULL, NULL, N'154035', NULL, NULL, 0, 15, NULL, N'5747225151', N'5747229523', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1015 Michigan Ave', N'Logansport', N'IN', N'18017', N'46947', 40.76194, -86.361678, 1243, 97, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1851, N'Bloomington Meadows Hospital', 1, NULL, NULL, N'154041', NULL, NULL, 0, 52, NULL, N'8123318000', N'8123318056', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3600 N Prow Rd', N'Bloomington', N'IN', N'18105', N'47404', 39.16704, -86.534288, 1199, 97, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1852, N'Michiana Behavioral Health Center', 1, NULL, NULL, N'154047', NULL, NULL, 0, 51, NULL, N'5749363784', N'5749359076', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1800 N Oak Rd', N'Plymouth', N'IN', N'18099', N'46563', 41.337418, -86.328668, 1257, 101, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1853, N'Northeastern Center', 1, NULL, NULL, N'154050', NULL, NULL, 0, 16, NULL, N'2609270726', N'2609270760', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1850 Wesley Rd', N'Auburn', N'IN', N'18033', N'46706', 41.370679, -85.033389, 1195, 95, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1854, N'Wellstone Regional Hospital', 1, NULL, NULL, N'154051', NULL, NULL, 0, 100, NULL, N'8122848000', N'8122581094', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2700 Vissing Park Rd', N'Jeffersonville', N'IN', N'18019', N'47130', 38.328811, -85.711153, 1233, 115, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1855, N'Porter-Starke Services Inc', 1, NULL, NULL, N'154052', NULL, NULL, 0, 16, NULL, N'2195313500', N'2195314729', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'701 Wall St', N'Valparaiso', N'IN', N'18127', N'46383', 41.489191, -87.052707, 1272, 96, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1856, N'Meridian Services Corp', 1, NULL, NULL, N'154053', NULL, NULL, 0, 20, NULL, N'7657515377', N'7657511701', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2401 W University Ave', N'Muncie', N'IN', N'18035', N'47303', 40.19752, -85.414121, 1249, 99, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1857, N'Harsha Behavioral Center Inc', 1, NULL, NULL, N'154054', NULL, NULL, 0, 44, NULL, N'8122988888', N'8122315252', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1420 E Crossing Blvd', N'Terre Haute', N'IN', N'18167', N'47802', 39.466703, -87.413912, 1270, 102, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1858, N'Brentwood Meadows Llc', 1, NULL, NULL, N'154055', NULL, NULL, 0, 48, NULL, N'8128587200', N'3178414425', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4488 Roslin Rd', N'Newburgh', N'IN', N'18173', N'47630', 37.945682, -87.404657, 1218, 94, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1859, N'Evansville State Hospital', 1, NULL, NULL, N'154056', NULL, NULL, 0, 168, NULL, N'8124696800', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3400 Lincoln Avenue', N'Evansville', N'IN', N'18163', N'47714', 37.969729, -87.502237, 1218, 94, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1860, N'Options Behavioral Health System', 1, NULL, NULL, N'154057', NULL, NULL, 0, 40, NULL, N'3175444340', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5602 Caito Drive', N'Indianapolis', N'IN', N'18097', N'46226', 39.768333, -86.15835, 1231, 97, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1861, N'Doctors Neuropsychiatric Hospital', 1, NULL, NULL, N'154058', NULL, NULL, 0, 20, NULL, N'5745460330', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'417 S Whitlock St', N'Bremen', N'IN', N'18099', N'46506', 41.443328, -86.150076, 1203, 101, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1862, N'Sycamore Springs', 1, NULL, NULL, N'154059', NULL, NULL, 0, 48, NULL, N'7657434400', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'833 Park East Blvd', N'Lafayette', N'IN', N'18157', N'47905', 40.409822, -86.82901, 1237, 98, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1863, N'Rivercrest Specialty Hospital Llc', 1, NULL, NULL, N'154061', NULL, NULL, 0, 30, NULL, N'5744851703', N'5744851778', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1625 East Jefferson Blvd', N'Mishawaka', N'IN', N'18141', N'46545', 41.673038, -86.157214, 1267, 101, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1864, N'Lutheran Hospital Of Indiana Th', 1, NULL, NULL, N'159801', NULL, NULL, 0, 0, NULL, N'2604357101', N'2604357632', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'7950 W Jefferson Blvd', N'Fort Wayne', N'IN', N'18003', N'46804', 41.0388, -85.248702, 1219, 95, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1865, N'St Vincent Hospital', 1, NULL, NULL, N'159802', NULL, NULL, 0, 0, NULL, N'3172809566', N'3173389710', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'2001 W 86Th St', N'Indianapolis', N'IN', N'18097', N'46260', 39.768333, -86.15835, 1231, 97, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1866, N'Indiana University Health Transplant', 1, NULL, NULL, N'159803', NULL, NULL, 0, 0, NULL, N'3179628677', N'3179625768', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'1701 North Senate Blvd', N'Indianapolis', N'IN', N'18097', N'46206', 39.768333, -86.15835, 1198, 97, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1867, N'Evansville Psychiatric Children''s Center', 1, NULL, NULL, N'15J200', NULL, NULL, 0, 28, NULL, N'8124776436', N'8124744248', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3300 E Morgan Ave', N'Evansville', N'IN', N'18163', N'47715', 37.991484, -87.509252, 1218, 94, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1868, N'Marshalltown Medical & Surgical Center', 1, NULL, NULL, N'160001', NULL, NULL, 0, 70, NULL, N'6417545151', N'6418446208', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3 South 4Th Avenue', N'Marshalltown', N'IA', N'19127', N'50158', 42.046084, -92.906404, 1340, 105, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1869, N'St Anthony Regional Hospital & Nursing Home', 1, NULL, NULL, N'160005', NULL, NULL, 0, 142, NULL, N'7127923581', N'7127923119', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'311 South Clark Street', N'Carroll', N'IA', N'19027', N'51401', 42.057422, -94.867695, 1291, 105, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1870, N'Keokuk Area Hospital', 1, NULL, NULL, N'160008', NULL, NULL, 0, 71, NULL, N'3195247150', N'3195245317', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1600 Morgan Street', N'Keokuk', N'IA', N'19111', N'52632', 40.401472, -91.382431, 1331, 107, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1871, N'Trinity Muscatine', 1, NULL, NULL, N'160013', NULL, NULL, 0, 80, NULL, N'5632649100', N'5632649484', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1518 Mulberry Avenue', N'Muscatine', N'IA', N'19139', N'52761', 41.433955, -91.052534, 1344, 107, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1872, N'Trinity Regional Medical Center', 1, NULL, NULL, N'160016', NULL, NULL, 0, 174, NULL, N'5155733101', N'5155738710', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'802 Kenyon Rd', N'Fort Dodge', N'IA', N'19187', N'50501', 42.494167, -94.189105, 1315, 105, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1873, N'Iowa Lutheran Hospital', 1, NULL, NULL, N'160024', NULL, NULL, 0, 205, NULL, N'5152635612', N'5152635295', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'700 East University Avenue', N'Des Moines', N'IA', N'19153', N'50316', 41.600351, -93.614384, 1308, 105, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1874, N'Chi Health Mercy Council Bluffs', 1, NULL, NULL, N'160028', NULL, NULL, 0, 194, NULL, N'7123285000', N'7123252425', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'800 Mercy Drive', N'Council Bluffs', N'IA', N'19155', N'51503', 41.268632, -95.838921, 1302, 172, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1875, N'Mercy Hospital', 1, NULL, NULL, N'160029', NULL, NULL, 0, 234, NULL, N'3193390300', N'3193393788', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'500 E Market Street', N'Iowa City', N'IA', N'19103', N'52245', 41.663633, -91.528497, 1328, 107, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1876, N'Mary Greeley Medical Center', 1, NULL, NULL, N'160030', NULL, NULL, 0, 220, NULL, N'5152392011', N'5152392007', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1111 Duff Avenue', N'Ames', N'IA', N'19169', N'50010', 42.032251, -93.61071, 1284, 105, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1877, N'Skiff Medical Center', 1, NULL, NULL, N'160032', NULL, NULL, 0, 68, NULL, N'6417921273', N'6417914895', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'204 North 4Th Avenue East', N'Newton', N'IA', N'19099', N'50208', 41.702482, -93.052115, 1346, 105, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1878, N'Genesis Medical Center-Davenport', 1, NULL, NULL, N'160033', NULL, NULL, 0, 502, NULL, N'5634211000', N'5634216500', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1227 East Rusholme Street', N'Davenport', N'IA', N'19163', N'52803', 41.542763, -90.557508, 1305, 104, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1879, N'Sartori Memorial Hospital', 1, NULL, NULL, N'160040', NULL, NULL, 0, 83, NULL, N'3192683000', N'3192683270', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'515 College Street', N'Cedar Falls', N'IA', N'19013', N'50613', 42.534092, -92.456418, 1292, 110, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1880, N'St Lukes Hospital', 1, NULL, NULL, N'160045', NULL, NULL, 0, 414, NULL, N'3193697211', N'3193698997', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1026 A Ave Ne', N'Cedar Rapids', N'IA', N'19113', N'52402', 41.984944, -91.660464, 1293, 103, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1881, N'Methodist Jennie Edmundson', 1, NULL, NULL, N'160047', NULL, NULL, 0, 112, NULL, N'7123966000', N'7123966288', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'933 East Pierce Street', N'Council Bluffs', N'IA', N'19155', N'51503', 41.268399, -95.83454, 1302, 172, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1882, N'Great River Medical Center', 1, NULL, NULL, N'160057', NULL, NULL, 0, 173, NULL, N'3197681000', N'3197683266', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1221 South Gear Avenue', N'West Burlington', N'IA', N'19057', N'52655', 40.811317, -91.170321, 1290, 104, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1883, N'University Of Iowa Hospital & Clinics', 1, NULL, NULL, N'160058', NULL, NULL, 0, 1103, NULL, N'3193561616', N'3193563862', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'200 Hawkins Drive', N'Iowa City', N'IA', N'19103', N'52242', 41.657527, -91.549811, 1328, 107, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1884, N'Mercy Medical Center-North Iowa', 1, NULL, NULL, N'160064', NULL, NULL, 0, 350, NULL, N'6414287000', N'6414287827', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1000 Fourth Street Sw', N'Mason City', N'IA', N'19033', N'50401', 43.153573, -93.201037, 1341, 108, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1885, N'Covenant Medical Center', 1, NULL, NULL, N'160067', NULL, NULL, 0, 423, NULL, N'3192728000', N'3192727313', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3421 West Ninth Street', N'Waterloo', N'IA', N'19013', N'50702', 42.492764, -92.342963, 1371, 110, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1886, N'Mercy Medical Center-Dubuque', 1, NULL, NULL, N'160069', NULL, NULL, 0, 524, NULL, N'5635898000', N'5635898073', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'250 Mercy Drive', N'Dubuque', N'IA', N'19061', N'52001', 42.492254, -90.674559, 1309, 106, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1887, N'Mercy Medical Center - Cedar Rapids', 1, NULL, NULL, N'160079', NULL, NULL, 0, 347, NULL, N'3193986011', N'3193986912', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'701 10Th Street Se', N'Cedar Rapids', N'IA', N'19113', N'52403', 41.978929, -91.654958, 1293, 103, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1888, N'Mercy Medical Center-Clinton', 1, NULL, NULL, N'160080', NULL, NULL, 0, 147, NULL, N'5632445555', N'5632445996', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1410 North 4Th Street', N'Clinton', N'IA', N'19045', N'52732', 41.8608, -90.188159, 1299, 104, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1889, N'Iowa Methodist Medical Center', 1, NULL, NULL, N'160082', NULL, NULL, 0, 674, NULL, N'5152416212', N'5152415994', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1200 Pleasant Street', N'Des Moines', N'IA', N'19153', N'50309', 41.589777, -93.636535, 1308, 105, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1890, N'Mercy Medical Center-Des Moines', 1, NULL, NULL, N'160083', NULL, NULL, 0, 649, NULL, N'5152473121', N'5152478899', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1111 6Th Ave', N'Des Moines', N'IA', N'19153', N'50314', 41.597811, -93.625562, 1308, 105, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1891, N'Ottumwa Regional Health Center', 1, NULL, NULL, N'160089', NULL, NULL, 0, 235, NULL, N'6416827511', N'6416842324', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1001 E Pennsylvania', N'Ottumwa', N'IA', N'19179', N'52501', 41.020015, -92.411296, 1353, 107, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1892, N'Broadlawns Medical Center', 1, NULL, NULL, N'160101', NULL, NULL, 0, 200, NULL, N'5152822200', N'5152824580', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1801 Hickman Road', N'Des Moines', N'IA', N'19153', N'50314', 41.616658, -93.641952, 1308, 105, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1893, N'Trinity Bettendorf', 1, NULL, NULL, N'160104', NULL, NULL, 0, 150, NULL, N'5637425000', N'5637422005', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4500 Utica Ridge Road', N'Bettendorf', N'IA', N'19163', N'52722', 41.566689, -90.51737, 1305, 104, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1894, N'Allen Hospital', 1, NULL, NULL, N'160110', NULL, NULL, 0, 234, NULL, N'3192353941', N'3192353906', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1825 Logan Avenue', N'Waterloo', N'IA', N'19013', N'50703', 42.548638, -92.337503, 1371, 110, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1895, N'Spencer Municipal Hospital', 1, NULL, NULL, N'160112', NULL, NULL, 0, 93, NULL, N'7122648300', N'7122646404', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1200 1St Avenue East', N'Spencer', N'IA', N'19041', N'51301', 43.149981, -95.143752, 1366, 247, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1896, N'Finley Hospital', 1, NULL, NULL, N'160117', NULL, NULL, 0, 158, NULL, N'5635821881', N'5635892562', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'350 North Grandview Avenue', N'Dubuque', N'IA', N'19061', N'52001', 42.495406, -90.687637, 1309, 106, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1897, N'Fort Madison Community Hospital', 1, NULL, NULL, N'160122', NULL, NULL, 0, 50, NULL, N'3193726530', N'3193729119', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5445 Ave O', N'Fort Madison', N'IA', N'19111', N'52627', 40.624254, -91.382264, 1316, 107, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1898, N'Lakes Regional Healthcare', 1, NULL, NULL, N'160124', NULL, NULL, 0, 49, NULL, N'7123361230', N'7123368620', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2301 Highway 71', N'Spirit Lake', N'IA', N'19059', N'51360', 43.422184, -95.102217, 1367, 247, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1899, N'St Lukes Regional Medical Center', 1, NULL, NULL, N'160146', NULL, NULL, 0, 201, NULL, N'7122793500', N'7122797958', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2720 Stone Park Boulevard', N'Sioux City', N'IA', N'19193', N'51104', 42.518493, -96.40611, 1365, 109, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1900, N'Grinnell Regional Medical Center', 1, NULL, NULL, N'160147', NULL, NULL, 0, 49, NULL, N'6412367511', N'6412362995', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'210 Fourth Avenue', N'Grinnell', N'IA', N'19157', N'50112', 41.743055, -92.722421, 1318, 105, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1901, N'Mercy Medical Center-Sioux City', 1, NULL, NULL, N'160153', NULL, NULL, 0, 267, NULL, N'7122792010', N'7122792034', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'801 5Th St', N'Sioux City', N'IA', N'19193', N'51101', 42.495347, -96.40069, 1365, 109, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1902, N'Select Specialty Hospital- Des Moines', 1, NULL, NULL, N'160157', NULL, NULL, 0, 21, NULL, N'5152474400', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1111 6Th Avenue 4Th Floor Main South', N'Des Moines', N'IA', N'19153', N'50314', 41.591064, -93.603715, 1308, 105, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1903, N'Baum Harmon Mercy Hospital', 1, NULL, NULL, N'161300', NULL, NULL, 0, 14, NULL, N'7129572300', N'7127570300', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'255 N Welch Avenue', N'Primghar', N'IA', N'19141', N'51245', 43.088732, -95.622926, 1357, 109, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1904, N'Iowa Specialty Hospital - Belmond', 1, NULL, NULL, N'161301', NULL, NULL, 0, 25, NULL, N'6414443223', N'6414445614', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'403 First Street Se', N'Belmond', N'IA', N'19197', N'50421', 42.846202, -93.612908, 1341, 108, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1905, N'Iowa Specialty Hospital-Clarion', 1, NULL, NULL, N'161302', NULL, NULL, 0, 25, NULL, N'5155322811', N'5155323443', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1316 South Main Street', N'Clarion', N'IA', N'19197', N'50525', 42.721388, -93.732747, 1298, 108, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1906, N'Grundy County Memorial Hospital', 1, NULL, NULL, N'161303', NULL, NULL, 0, 25, NULL, N'3198245421', N'3198246291', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'201 East J Avenue', N'Grundy Center', N'IA', N'19075', N'50638', 42.358808, -92.762137, 1371, 110, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1907, N'Chi Health  - Mercy Corning', 1, NULL, NULL, N'161304', NULL, NULL, 0, 22, NULL, N'6413223121', N'6413223616', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'603 Rosary Drive', N'Corning', N'IA', N'19003', N'50841', 40.988209, -94.747944, 1300, 105, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1908, N'Pocahontas Community Hospital', 1, NULL, NULL, N'161305', NULL, NULL, 0, 25, NULL, N'7123353501', N'7123354745', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'606 N W 7Th Street', N'Pocahontas', N'IA', N'19151', N'50574', 42.73553, -94.669147, 1356, 105, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1909, N'Jones Regional Medical Center', 1, NULL, NULL, N'161306', NULL, NULL, 0, 25, NULL, N'3194626131', N'3194816332', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1795 Highway 64 East', N'Anamosa', N'IA', N'19105', N'52205', 42.104032, -91.268216, 1293, 103, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1910, N'Hancock County Health System', 1, NULL, NULL, N'161307', NULL, NULL, 0, 25, NULL, N'6418435000', N'6418435100', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'532 1St St Nw', N'Britt', N'IA', N'19081', N'50423', 43.097908, -93.808282, 1289, 108, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1911, N'Franklin General Hospital', 1, NULL, NULL, N'161308', NULL, NULL, 0, 77, NULL, N'6414565000', N'6414565005', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1720 Central Avenue East', N'Hampton', N'IA', N'19069', N'50441', 42.740876, -93.185678, 1322, 108, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1912, N'Chi Health Missouri Valley', 1, NULL, NULL, N'161309', NULL, NULL, 0, 25, NULL, N'7126422784', N'7126429259', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'631 N 8Th St', N'Missouri Valley', N'IA', N'19085', N'51555', 41.562227, -95.885207, 1342, 172, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1913, N'Adair County Memorial Hospital', 1, NULL, NULL, N'161310', NULL, NULL, 0, 25, NULL, N'6417432123', N'6417437292', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'609 Se Kent', N'Greenfield', N'IA', N'19001', N'50849', 41.305266, -94.461354, 1317, 105, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1914, N'Hawarden Regional Healthcare', 1, NULL, NULL, N'161311', NULL, NULL, 0, 25, NULL, N'7125513100', N'7125513106', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1111 11Th Street', N'Hawarden', N'IA', N'19167', N'51023', 42.998102, -96.479624, 1324, 247, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1915, N'Guttenberg Municipal Hospital', 1, NULL, NULL, N'161312', NULL, NULL, 0, 25, NULL, N'5632521121', N'5632523955', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'200 Main Street', N'Guttenberg', N'IA', N'19043', N'52052', 42.785485, -91.09991, 1320, 106, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1916, N'Genesis Medical Center-Dewitt', 1, NULL, NULL, N'161313', NULL, NULL, 0, 90, NULL, N'5636594200', N'5636594201', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1118 11Th Street', N'Dewitt', N'IA', N'19045', N'52742', 41.82599, -90.546925, 1305, 104, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1917, N'Guthrie County Hospital', 1, NULL, NULL, N'161314', NULL, NULL, 0, 25, NULL, N'6413322201', N'6417472702', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'710 North 12Th Street', N'Guthrie Center', N'IA', N'19077', N'50115', 41.683351, -94.494281, 1319, 105, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1918, N'Keokuk County Health Center', 1, NULL, NULL, N'161315', NULL, NULL, 0, 14, NULL, N'6416222720', N'6416221187', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'23019 Highway 149', N'Sigourney', N'IA', N'19107', N'52591', 41.333345, -92.204625, 1328, 107, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1919, N'Palmer Lutheran Health Center', 1, NULL, NULL, N'161316', NULL, NULL, 0, 25, NULL, N'5634223811', N'5634229754', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'112 Jefferson Street', N'West Union', N'IA', N'19065', N'52175', 42.962756, -91.808217, 1375, 300, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1920, N'Marengo Memorial Hospital', 1, NULL, NULL, N'161317', NULL, NULL, 0, 25, NULL, N'3196425543', N'3196428069', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'300 W May St', N'Marengo', N'IA', N'19095', N'52301', 41.801755, -92.072152, 1293, 103, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1921, N'Veterans Memorial Hospital', 1, NULL, NULL, N'161318', NULL, NULL, 0, 25, NULL, N'5635683411', N'5635685550', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'40 1St Street Se', N'Waukon', N'IA', N'19005', N'52172', 43.267839, -91.474463, 1372, 300, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1922, N'Central Community Hospital', 1, NULL, NULL, N'161319', NULL, NULL, 0, 25, NULL, N'5632457000', N'5632457080', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'901 Davidson Street Nw', N'Elkader', N'IA', N'19043', N'52043', 42.853874, -91.405416, 1311, 103, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1923, N'Community Memorial Hospital Medical Center', 1, NULL, NULL, N'161320', NULL, NULL, 0, 25, NULL, N'5635783275', N'3195783279', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'909 West First Street', N'Sumner', N'IA', N'19017', N'50674', 42.854864, -92.097634, 1369, 110, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1924, N'Sanford Rock Rapids Medical Center', 1, NULL, NULL, N'161321', NULL, NULL, 0, 25, NULL, N'7124722591', N'7124726199', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'801 South Greene Street', N'Rock Rapids', N'IA', N'19119', N'51246', 43.423722, -96.171189, 3101, 247, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1925, N'Dallas County Hospital', 1, NULL, NULL, N'161322', NULL, NULL, 0, 25, NULL, N'5154653547', N'5154657654', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'610 Tenth Street', N'Perry', N'IA', N'19049', N'50220', 41.838599, -94.107181, 1355, 105, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1926, N'Mitchell County Regional Health', 1, NULL, NULL, N'161323', NULL, NULL, 0, 25, NULL, N'6417326000', N'6417326028', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'616 North Eighth Street', N'Osage', N'IA', N'19131', N'50461', 43.284138, -92.811028, 1350, 108, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1927, N'George C Grape Community Hospital', 1, NULL, NULL, N'161324', NULL, NULL, 0, 25, NULL, N'7123821515', N'7123822023', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2959 Us Highway 275', N'Hamburg', N'IA', N'19071', N'51640', 40.604446, -95.657771, 1321, 172, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1928, N'Greene County Medical Center', 1, NULL, NULL, N'161325', NULL, NULL, 0, 25, NULL, N'5153862114', N'5153863271', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1000 West Lincolnway', N'Jefferson', N'IA', N'19073', N'50129', 42.015261, -94.377468, 1330, 105, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1929, N'Madison County Memorial Hospital', 1, NULL, NULL, N'161326', NULL, NULL, 0, 25, NULL, N'5154622373', N'5154629060', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'300 West Hutchings Street', N'Winterset', N'IA', N'19121', N'50273', 41.328712, -94.017123, 1308, 105, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1930, N'Davis County Hospital', 1, NULL, NULL, N'161327', NULL, NULL, 0, 25, NULL, N'6416642145', N'6416641669', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'509 North Madison Street', N'Bloomfield', N'IA', N'19051', N'52537', 40.758506, -92.415127, 1287, 105, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1931, N'Regional Health Services Of Howard County', 1, NULL, NULL, N'161328', NULL, NULL, 0, 25, NULL, N'5635472101', N'5635473448', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'235 8Th Avenue West', N'Cresco', N'IA', N'19089', N'52136', 43.381803, -92.116569, 1303, 153, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1932, N'Jackson County Regional Health Center', 1, NULL, NULL, N'161329', NULL, NULL, 0, 25, NULL, N'5636522474', N'5636524073', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'700 W Grove St', N'Maquoketa', N'IA', N'19097', N'52060', 42.073773, -90.673667, 1339, 104, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1933, N'Audubon County Memorial Hospital', 1, NULL, NULL, N'161330', NULL, NULL, 0, 25, NULL, N'7125632611', N'7125635277', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'515 Pacific Street', N'Audubon', N'IA', N'19009', N'50025', 41.480096, -95.224397, 1286, 105, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1934, N'Mercy Medical Center-New Hampton', 1, NULL, NULL, N'161331', NULL, NULL, 0, 25, NULL, N'6413944121', N'6413941669', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'308 North Maple Avenue', N'New Hampton', N'IA', N'19037', N'50659', 43.062169, -92.32052, 1345, 153, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1935, N'Manning Regional Healthcare Center', 1, NULL, NULL, N'161332', NULL, NULL, 0, 17, NULL, N'7126552072', N'7126553330', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1550 Sixth Street', N'Manning', N'IA', N'19027', N'51455', 41.909153, -95.064992, 1338, 172, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1936, N'Story County Hospital', 1, NULL, NULL, N'161333', NULL, NULL, 0, 25, NULL, N'5153822111', N'5153827760', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'640 South 19Th Street', N'Nevada', N'IA', N'19169', N'50201', 42.022765, -93.452434, 1284, 105, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1937, N'Humboldt County Memorial Hospital', 1, NULL, NULL, N'161334', NULL, NULL, 0, 25, NULL, N'5153324200', N'5153324820', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1000 North 15Th Street', N'Humboldt', N'IA', N'19091', N'50548', 42.731963, -94.23021, 1325, 105, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1938, N'Buchanan County Health Center', 1, NULL, NULL, N'161335', NULL, NULL, 0, 25, NULL, N'3193320999', N'3193320958', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1600 First St East', N'Independence', N'IA', N'19019', N'50644', 42.468598, -91.889339, 1327, 110, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1939, N'Hegg Memorial Health Center', 1, NULL, NULL, N'161336', NULL, NULL, 0, 25, NULL, N'7124768000', N'7124768024', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1202 21St Avenue', N'Rock Valley', N'IA', N'19167', N'51247', 43.202247, -96.284981, 1359, 247, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1940, N'Van Buren County Hospital', 1, NULL, NULL, N'161337', NULL, NULL, 0, 25, NULL, N'3192933171', N'3192936314', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'304 Franklin Street', N'Keosauqua', N'IA', N'19177', N'52565', 40.735905, -91.958927, 1332, 107, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1941, N'Mercy Hospital Of Franciscan Sisters-Oelwein', 1, NULL, NULL, N'161338', NULL, NULL, 0, 25, NULL, N'3192836000', N'3192836004', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'201 Eighth Avenue Se', N'Oelwein', N'IA', N'19065', N'50662', 42.673317, -91.913504, 1347, 110, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1942, N'Waverly Health Center', 1, NULL, NULL, N'161339', NULL, NULL, 0, 25, NULL, N'3193524120', N'3193523992', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'312  9Th Street Sw', N'Waverly', N'IA', N'19017', N'50677', 42.724259, -92.481892, 1373, 110, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1943, N'Decatur County Hospital', 1, NULL, NULL, N'161340', NULL, NULL, 0, 25, NULL, N'6414464871', N'6414462201', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1405 Nw Church Street', N'Leon', N'IA', N'19053', N'50144', 40.750929, -93.747671, 1336, 105, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1944, N'Lucas County Health Center', 1, NULL, NULL, N'161341', NULL, NULL, 0, 25, NULL, N'6417743000', N'6417743233', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1200 North 7Th Street', N'Chariton', N'IA', N'19117', N'50049', 41.028481, -93.303303, 1308, 105, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1945, N'Monroe County Hospital', 1, NULL, NULL, N'161342', NULL, NULL, 0, 25, NULL, N'6419322134', N'6419321665', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6580 165Th Street', N'Albia', N'IA', N'19135', N'52531', 41.026675, -92.805751, 1282, 105, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1946, N'Regional Medical Center', 1, NULL, NULL, N'161343', NULL, NULL, 0, 25, NULL, N'5639273232', N'5639277577', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'709 W Main Street', N'Manchester', N'IA', N'19055', N'52057', 42.483975, -91.466093, 1337, 103, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1947, N'Washington County Hospital And Clinics', 1, NULL, NULL, N'161344', NULL, NULL, 0, 25, NULL, N'3196535481', N'3198633976', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'400 East Polk Street', N'Washington', N'IA', N'19183', N'52353', 41.288577, -91.688533, 1370, 107, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1948, N'Osceola Community Hospital', 1, NULL, NULL, N'161345', NULL, NULL, 0, 25, NULL, N'7127542574', N'7127542151', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'600 9Th Avenue North', N'Sibley', N'IA', N'19143', N'51249', 43.399136, -95.75196, 1363, 247, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1949, N'Sioux Center Health', 1, NULL, NULL, N'161346', NULL, NULL, 0, 25, NULL, N'7127221271', N'7127224107', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1101 9Th Street Se', N'Sioux Center', N'IA', N'19167', N'51250', 43.06963, -96.160385, 1364, 109, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1950, N'Floyd County Medical Center', 1, NULL, NULL, N'161347', NULL, NULL, 0, 25, NULL, N'6412286830', N'6412574386', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'800 11Th St', N'Charles City', N'IA', N'19067', N'50616', 43.052635, -92.688239, 1295, 153, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1951, N'Clarke County Hospital', 1, NULL, NULL, N'161348', NULL, NULL, 0, 25, NULL, N'6413422184', N'6413425331', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'800 S Fillmore St', N'Osceola', N'IA', N'19039', N'50213', 41.026658, -93.767637, 1351, 105, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1952, N'Virginia Gay Hospital', 1, NULL, NULL, N'161349', NULL, NULL, 0, 83, NULL, N'3194726200', N'3194726321', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'502 North 9Th Avenue', N'Vinton', N'IA', N'19011', N'52349', 42.173012, -92.013263, 1293, 103, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1953, N'Stewart Memorial Community Hospital', 1, NULL, NULL, N'161350', NULL, NULL, 0, 25, NULL, N'7124643171', N'7124643269', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1301 West Main Street', N'Lake City', N'IA', N'19025', N'51449', 42.267327, -94.741032, 1334, 105, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1954, N'Avera Holy Family Hospital', 1, NULL, NULL, N'161351', NULL, NULL, 0, 25, NULL, N'7123622631', N'7123626183', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'826 North 8Th Street', N'Estherville', N'IA', N'19063', N'51334', 43.410822, -94.833683, 1313, 247, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1955, N'Clarinda Regional Health Center', 1, NULL, NULL, N'161352', NULL, NULL, 0, 25, NULL, N'7125422176', N'7125423380', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'220 Essie Davison Drive', N'Clarinda', N'IA', N'19145', N'51632', 40.741935, -95.038313, 1297, 172, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1956, N'Kossuth Regional Health Center', 1, NULL, NULL, N'161353', NULL, NULL, 0, 25, NULL, N'5152952451', N'5152959515', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1515 South Phillips Street', N'Algona', N'IA', N'19109', N'50511', 43.063318, -94.226941, 1283, 108, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1957, N'Horn Memorial Hospital', 1, NULL, NULL, N'161354', NULL, NULL, 0, 25, NULL, N'7123643311', N'7123643363', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'701 E 2Nd St', N'Ida Grove', N'IA', N'19093', N'51445', 42.33891, -95.45893, 1326, 109, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1958, N'Knoxville Hospital & Clinics', 1, NULL, NULL, N'161355', NULL, NULL, 0, 25, NULL, N'6418422151', N'6418421470', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1002 South Lincoln Street', N'Knoxville', N'IA', N'19125', N'50138', 41.32083, -93.109371, 1333, 105, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1959, N'Henry County Health Center', 1, NULL, NULL, N'161356', NULL, NULL, 0, 74, NULL, N'3193853141', N'3193856731', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'407 S White St', N'Mount Pleasant', N'IA', N'19087', N'52641', 40.963261, -91.558068, 1343, 107, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1960, N'Palo Alto County Hospital', 1, NULL, NULL, N'161357', NULL, NULL, 0, 25, NULL, N'7128525500', N'7128525409', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3201 1St Street', N'Emmetsburg', N'IA', N'19147', N'50536', 43.119263, -94.690679, 1312, 108, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1961, N'Wayne County Hospital', 1, NULL, NULL, N'161358', NULL, NULL, 0, 25, NULL, N'6418722260', N'6418723116', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'417 South East Street', N'Corydon', N'IA', N'19185', N'50060', 40.754632, -93.312223, 1301, 105, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1962, N'Burgess Health Center', 1, NULL, NULL, N'161359', NULL, NULL, 0, 25, NULL, N'7124232311', N'7124239199', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1600 Diamond Street', N'Onawa', N'IA', N'19133', N'51040', 42.025887, -96.105937, 1348, 172, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1963, N'Orange City Area Health System', 1, NULL, NULL, N'161360', NULL, NULL, 0, 25, NULL, N'7127374984', N'7127375291', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1000 Lincoln Circle Se', N'Orange City', N'IA', N'19167', N'51041', 43.007242, -96.058314, 1349, 109, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1964, N'Van Diest Medical Center', 1, NULL, NULL, N'161361', NULL, NULL, 0, 25, NULL, N'5158329400', N'5158329420', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2350 Hospital Drive', N'Webster City', N'IA', N'19079', N'50595', 42.453559, -93.813469, 1374, 105, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1965, N'Cherokee Regional Medical Center', 1, NULL, NULL, N'161362', NULL, NULL, 0, 25, NULL, N'7122255101', N'7122256870', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'300 Sioux Valley Drive', N'Cherokee', N'IA', N'19035', N'51012', 42.758686, -95.549365, 1296, 109, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1966, N'Montgomery County Memorial Hospital', 1, NULL, NULL, N'161363', NULL, NULL, 0, 25, NULL, N'7126237000', N'7122637228', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2301 Eastern Avenue', N'Red Oak', N'IA', N'19137', N'51566', 41.026317, -95.213784, 1358, 172, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1967, N'Jefferson County Health Center', 1, NULL, NULL, N'161364', NULL, NULL, 0, 25, NULL, N'6414724111', N'6414694375', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2000 S Main', N'Fairfield', N'IA', N'19101', N'52556', 41.008631, -91.962673, 1314, 107, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1968, N'Greater Regional Medical Center', 1, NULL, NULL, N'161365', NULL, NULL, 0, 25, NULL, N'6417827091', N'6417823866', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1700 West Townline Road', N'Creston', N'IA', N'19175', N'50801', 41.0586, -94.361347, 1304, 105, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1969, N'Shenandoah Medical Center', 1, NULL, NULL, N'161366', NULL, NULL, 0, 25, NULL, N'7122461230', N'7122467357', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'300 Pershing Avenue', N'Shenandoah', N'IA', N'19145', N'51601', 40.753532, -95.370245, 1362, 172, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1970, N'Pella Regional Health Center', 1, NULL, NULL, N'161367', NULL, NULL, 0, 25, NULL, N'6416283150', N'5156287241', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'404 Jefferson Street', N'Pella', N'IA', N'19125', N'50219', 41.412394, -92.911199, 1354, 105, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1971, N'Floyd Valley Hospital', 1, NULL, NULL, N'161368', NULL, NULL, 0, 25, NULL, N'7125467871', N'7125463352', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'714 Lincoln St Ne', N'Le Mars', N'IA', N'19149', N'51031', 42.797253, -96.155855, 1335, 109, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1972, N'Crawford County Memorial Hospital', 1, NULL, NULL, N'161369', NULL, NULL, 0, 25, NULL, N'7122652500', N'7122652511', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'100 Medical Parkway', N'Denison', N'IA', N'19047', N'51442', 42.017766, -95.355276, 1307, 172, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1973, N'Loring Hospital', 1, NULL, NULL, N'161370', NULL, NULL, 0, 25, NULL, N'7126627105', N'7126626418', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'211 Highland Avenue Po Box 217', N'Sac City', N'IA', N'19161', N'50583', 42.422203, -94.989711, 1360, 109, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1974, N'Winneshiek Medical Center', 1, NULL, NULL, N'161371', NULL, NULL, 0, 25, NULL, N'5633822911', N'5633873102', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'901 Montgomery Street', N'Decorah', N'IA', N'19191', N'52101', 43.293224, -91.770328, 1306, 300, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1975, N'Boone County Hospital', 1, NULL, NULL, N'161372', NULL, NULL, 0, 25, NULL, N'5154323140', N'5154338926', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1015 Union Street', N'Boone', N'IA', N'19015', N'50036', 42.05565, -93.878129, 1288, 105, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1976, N'Ringgold County Hospital', 1, NULL, NULL, N'161373', NULL, NULL, 0, 25, NULL, N'6414643226', N'6414644414', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'504 North Cleveland Street', N'Mount Ayr', N'IA', N'19159', N'50854', 40.714715, -94.235232, 1308, 105, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1977, N'Myrtue Medical Center', 1, NULL, NULL, N'161374', NULL, NULL, 0, 25, NULL, N'7127555161', N'7127554412', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1213 Garfield Avenue', N'Harlan', N'IA', N'19165', N'51537', 41.647395, -95.325959, 1323, 172, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1978, N'Buena Vista Regional Medical Center', 1, NULL, NULL, N'161375', NULL, NULL, 0, 35, NULL, N'7127324030', N'7122131233', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1525 West 5Th Street', N'Storm Lake', N'IA', N'19021', N'50588', 42.644424, -95.222997, 1368, 109, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1979, N'Cass County Memorial Hospital', 1, NULL, NULL, N'161376', NULL, NULL, 0, 33, NULL, N'7122433250', N'7122437587', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1501 East Tenth Street', N'Atlantic', N'IA', N'19029', N'50022', 41.403601, -95.013878, 1285, 172, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1980, N'Mercy Medical Center-Centerville', 1, NULL, NULL, N'161377', NULL, NULL, 0, 25, NULL, N'6414374111', N'6414373304', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'One St Joseph''s Drive', N'Centerville', N'IA', N'19007', N'52544', 40.73418, -92.874088, 1294, 105, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1981, N'Mercy Medical Center-Dyersville', 1, NULL, NULL, N'161378', NULL, NULL, 0, 25, NULL, N'5638757101', N'5638752957', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1111 3Rd Street Sw', N'Dyersville', N'IA', N'19061', N'52040', 42.475728, -91.129777, 1309, 106, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1982, N'Mahaska  Health Partnership', 1, NULL, NULL, N'161379', NULL, NULL, 0, 33, NULL, N'6416723100', N'6416723339', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1229 C Avenue East', N'Oskaloosa', N'IA', N'19123', N'52577', 41.298637, -92.630321, 1352, 105, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1983, N'Hansen Family Hospital', 1, NULL, NULL, N'161380', NULL, NULL, 0, 35, NULL, N'6416484631', N'6416482850', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'920 South Oak Street', N'Iowa Falls', N'IA', N'19083', N'50126', 42.500871, -93.260864, 1329, 105, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1984, N'Sanford Sheldon Medical Center', 1, NULL, NULL, N'161381', NULL, NULL, 0, 25, NULL, N'7123245041', N'7123246025', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'118 North 7Th Avenue', N'Sheldon', N'IA', N'19141', N'51201', 43.18184, -95.848533, 1361, 109, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1985, N'Select Specialty Hospital - Quad Cities', 1, NULL, NULL, N'162001', NULL, NULL, 0, 50, NULL, N'5634682000', N'5633868175', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1111 West Kimberly Road', N'Davenport', N'IA', N'19163', N'52806', 41.560274, -90.575314, 1305, 104, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1986, N'Continuing Care Hospital', 1, NULL, NULL, N'162002', NULL, NULL, 0, 24, NULL, N'3193698142', N'3192864320', 1, 0, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1026 A Avenue Northeast Sixth Floor', N'Cedar Rapids', N'IA', N'19113', N'52402', 41.975887, -91.670405, 1293, 103, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1987, N'Mental Health Institute', 1, NULL, NULL, N'164002', NULL, NULL, 0, 97, NULL, N'7122252594', N'7122256933', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1251 North Cedar Loop', N'Cherokee', N'IA', N'19035', N'51012', 42.749428, -95.551674, 1296, 109, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1988, N'Mental Health Institute', 1, NULL, NULL, N'164003', NULL, NULL, 0, 130, NULL, N'3193342583', N'3193345252', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2277 Iowa Avenue', N'Independence', N'IA', N'19019', N'50644', 42.468598, -91.889339, 1327, 110, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1989, N'Mental Health Institute', 1, NULL, NULL, N'164004', NULL, NULL, 0, 40, NULL, N'3193857231', N'3193858465', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1200 East Washington Street', N'Mount Pleasant', N'IA', N'19087', N'52641', 40.963632, -91.536067, 1343, 107, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1990, N'Mental Health Institute', 1, NULL, NULL, N'164005', NULL, NULL, 0, 20, NULL, N'7125422161', N'7125426101', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1800 North 16Th Street', N'Clarinda', N'IA', N'19145', N'51632', 40.740762, -95.037872, 1297, 172, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1991, N'Iowa Methodist Medical Center Transplant Center', 1, NULL, NULL, N'169800', NULL, NULL, 0, 0, NULL, N'5152416212', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'1200 Pleasant Street', N'Des Moines', N'IA', N'19153', N'50309', 41.589777, -93.636535, 1308, 105, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1992, N'Mercy Hospital Medical Center - Transplant', 1, NULL, NULL, N'169801', NULL, NULL, 0, 0, NULL, N'5152474261', N'5156438870', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'1111 Sixth Ave', N'Des Moines', N'IA', N'19153', N'50314', 41.591064, -93.603715, 1308, 105, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1993, N'The University Of Iowa Hospitals And Clinics', 1, NULL, NULL, N'169802', NULL, NULL, 0, 0, NULL, N'3193560537', N'3193561556', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'200 Hawkins Drive', N'Iowa City', N'IA', N'19103', N'52242', 41.657527, -91.549811, 1328, 107, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1994, N'Via Christi Hospital Pittsburg Inc', 1, NULL, NULL, N'170006', NULL, NULL, 0, 168, NULL, N'6202316100', N'6202320493', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1 Mt Carmel Way', N'Pittsburg', N'KS', N'20037', N'66762', 37.410884, -94.70496, 1462, 164, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1995, N'Saint John Hospital', 1, NULL, NULL, N'170009', NULL, NULL, 0, 76, NULL, N'9136806000', N'9135964098', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3500 South 4Th Street', N'Leavenworth', N'KS', N'20103', N'66048', 39.283971, -94.903832, 1435, 165, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1996, N'Mercy Hospital Independence', 1, NULL, NULL, N'170010', NULL, NULL, 0, 75, NULL, N'6203312200', N'6203323270', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'800 West Myrtle Street', N'Independence', N'KS', N'20125', N'67301', 37.224528, -95.71635, 1423, 112, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1997, N'Salina Regional Health Center', 1, NULL, NULL, N'170012', NULL, NULL, 0, 353, NULL, N'7854527000', N'7854526963', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'400 South Santa Fe Avenue', N'Salina', N'KS', N'20169', N'67401', 38.830399, -97.609309, 1469, 112, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1998, N'Hays Medical Center', 1, NULL, NULL, N'170013', NULL, NULL, 0, 194, NULL, N'7856235000', N'7856232291', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2220 Canterbury Drive', N'Hays', N'KS', N'20051', N'67601', 38.885458, -99.299192, 1413, 112, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1999, N'Ransom Memorial Hospital', 1, NULL, NULL, N'170014', NULL, NULL, 0, 49, NULL, N'7852298200', N'7852298416', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1301 S Main Street', N'Ottawa', N'KS', N'20059', N'66067', 38.59714, -95.268674, 1459, 165, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2000, N'St Francis Health Center Inc', 1, NULL, NULL, N'170016', NULL, NULL, 0, 378, NULL, N'7852958000', N'7852955479', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1700 Sw 7Th Street', N'Topeka', N'KS', N'20177', N'66606', 39.056763, -95.696428, 1479, 111, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2001, N'Susan B Allen Memorial Hospital', 1, NULL, NULL, N'170017', NULL, NULL, 0, 80, NULL, N'3163224557', N'3163212916', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'720 W Central St', N'El Dorado', N'KS', N'20015', N'67042', 37.81724, -96.862252, 1396, 112, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2002, N'Hutchinson Regional Medical Center Inc', 1, NULL, NULL, N'170020', NULL, NULL, 0, 199, NULL, N'6206652001', N'6205133811', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1701 E 23Rd Avenue', N'Hutchinson', N'KS', N'20155', N'67502', 38.079401, -97.894458, 1422, 112, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2003, N'Atchison Hospital', 1, NULL, NULL, N'170022', NULL, NULL, 0, 74, NULL, N'9133676600', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1301 North Second Street', N'Atchison', N'KS', N'20005', N'66002', 39.563372, -95.121291, 1380, 165, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2004, N'St Catherine Hospital', 1, NULL, NULL, N'170023', NULL, NULL, 0, 132, NULL, N'6202722561', N'6202722566', 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'401 East Spruce', N'Garden City', N'KS', N'20055', N'67846', 37.967626, -100.83542, 1404, 112, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2005, N'Pratt Regional Medical Center', 1, NULL, NULL, N'170027', NULL, NULL, 0, 69, NULL, N'6204501160', N'6206722113', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'200 Commodore St', N'Pratt', N'KS', N'20151', N'67124', 37.641759, -98.729426, 1464, 112, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2006, N'Sumner Regional Medical Center', 1, NULL, NULL, N'170039', NULL, NULL, 0, 62, NULL, N'6203991299', N'6203262225', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1323 North A St', N'Wellington', N'KS', N'20191', N'67152', 37.277957, -97.39411, 1485, 112, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2007, N'University Of Kansas Hospital', 1, NULL, NULL, N'170040', NULL, NULL, 0, 620, NULL, N'9135887332', N'9135881280', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3901 Rainbow Blvd', N'Kansas City', N'KS', N'20209', N'66103', 39.053776, -94.611212, 1428, 165, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2008, N'Olathe Medical Center', 1, NULL, NULL, N'170049', NULL, NULL, 0, 300, NULL, N'9137914200', N'9137914313', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'20333 West 151St Street', N'Olathe', N'KS', N'20091', N'66061', 38.854555, -94.823368, 1456, 165, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2009, N'Mercy Hospital-Fort Scott', 1, NULL, NULL, N'170058', NULL, NULL, 0, 49, NULL, N'6202237057', N'6202235327', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'401 Woodland Hills Blvd', N'Fort Scott', N'KS', N'20011', N'66701', 37.839979, -94.708288, 1402, 164, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2010, N'Southwest Medical Center', 1, NULL, NULL, N'170068', NULL, NULL, 0, 80, NULL, N'6206296291', N'6206292425', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'315 West 15Th Street', N'Liberal', N'KS', N'20175', N'67901', 37.054287, -100.92639, 1437, 112, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2011, N'Geary Community Hospital', 1, NULL, NULL, N'170074', NULL, NULL, 0, 92, NULL, N'7852103301', N'7852103444', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1102 St Mary''s Road', N'Junction City', N'KS', N'20061', N'66441', 39.012536, -96.850905, 1427, 111, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2012, N'Mercy Hospital', 1, NULL, NULL, N'170075', NULL, NULL, 0, 21, NULL, N'6203456391', N'6203456344', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'218 E Pack St', N'Moundridge', N'KS', N'20113', N'67107', 38.205155, -97.517364, 1449, 112, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2013, N'Stormont-Vail Healthcare', 1, NULL, NULL, N'170086', NULL, NULL, 0, 506, NULL, N'7853546121', N'7853545361', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1500 Sw 10Th St', N'Topeka', N'KS', N'20177', N'66604', 39.049011, -95.677556, 1479, 111, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2014, N'Coffey County Hospital', 1, NULL, NULL, N'170094', NULL, NULL, 0, 36, NULL, N'6203642121', N'6203648425', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'801 North 4Th Street', N'Burlington', N'KS', N'20031', N'66839', 38.200968, -95.738434, 1384, 111, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2015, N'Newton Medical Center', 1, NULL, NULL, N'170103', NULL, NULL, 0, 55, NULL, N'3168046001', N'3168046260', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'600 Medical Center Drive', N'Newton', N'KS', N'20079', N'67114', 38.046917, -97.344724, 1452, 112, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2016, N'Shawnee Mission Medical Center', 1, NULL, NULL, N'170104', NULL, NULL, 0, 363, NULL, N'9136762151', N'9136767792', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'9100 W 74Th Street', N'Shawnee Mission', N'KS', N'20091', N'66204', 38.983601, -94.805609, 1474, 165, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2017, N'Mcpherson Hospital Inc', 1, NULL, NULL, N'170105', NULL, NULL, 0, 49, NULL, N'6202412250', N'6207982613', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1000 Hospital Drive', N'Mcpherson', N'KS', N'20113', N'67460', 38.378996, -97.672378, 1444, 112, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2018, N'Miami County Medical Center', 1, NULL, NULL, N'170109', NULL, NULL, 0, 39, NULL, N'9135574385', N'9132949897', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2100 Baptiste Drive', N'Paola', N'KS', N'20121', N'66071', 38.571563, -94.857217, 1456, 165, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2019, N'Bob Wilson Memorial Grant County Hospital', 1, NULL, NULL, N'170110', NULL, NULL, 0, 45, NULL, N'6203561266', N'6204246314', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'415 N Main Street', N'Ulysses', N'KS', N'20067', N'67880', 37.583922, -101.35811, 1481, 112, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2020, N'Labette Health', 1, NULL, NULL, N'170120', NULL, NULL, 0, 109, NULL, N'6204214880', N'6208205042', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1902 South Us Hwy 59', N'Parsons', N'KS', N'20099', N'67357', 37.340784, -95.259629, 1460, 112, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2021, N'Via Christi Hospitals Wichita Inc', 1, NULL, NULL, N'170122', NULL, NULL, 0, 1268, NULL, N'3162681381', N'3162681385', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'929 North St Francis Street', N'Wichita', N'KS', N'20173', N'67214', 37.700209, -97.331766, 1487, 112, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2022, N'Wesley Medical Center', 1, NULL, NULL, N'170123', NULL, NULL, 0, 520, NULL, N'3169622000', N'3169627076', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'550 N Hillside Street', N'Wichita', N'KS', N'20173', N'67214', 37.695716, -97.298943, 1487, 112, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2023, N'Saint Luke''s Cushing Hospital', 1, NULL, NULL, N'170133', NULL, NULL, 0, 58, NULL, N'9136841102', N'9136841239', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'711 Marshall Street', N'Leavenworth', N'KS', N'20103', N'66048', 39.307611, -94.91811, 1435, 165, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2024, N'Lawrence Memorial Hospital', 1, NULL, NULL, N'170137', NULL, NULL, 0, 146, NULL, N'7855056100', N'7855056126', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'325 Maine Street', N'Lawrence', N'KS', N'20045', N'66044', 38.980041, -95.248348, 1434, 165, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2025, N'Mercy Regional Health Center', 1, NULL, NULL, N'170142', NULL, NULL, 0, 150, NULL, N'7857762831', N'7857762804', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1823 College Ave', N'Manhattan', N'KS', N'20161', N'66502', 39.201288, -96.599293, 1441, 111, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2026, N'Coffeyville Regional Medical Center', 1, NULL, NULL, N'170145', NULL, NULL, 0, 110, NULL, N'6202511200', N'6202521651', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1400 W 4Th St', N'Coffeyville', N'KS', N'20125', N'67337', 37.040506, -95.640035, 1389, 220, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2027, N'Providence Medical Center', 1, NULL, NULL, N'170146', NULL, NULL, 0, 400, NULL, N'9135963930', N'9135964098', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'8929 Parallel Parkway', N'Kansas City', N'KS', N'20209', N'66112', 39.128464, -94.739174, 1428, 165, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2028, N'South Central Ks  Med Center', 1, NULL, NULL, N'170150', NULL, NULL, 0, 49, NULL, N'6204422500', N'6204415953', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6401 Patterson Parkway', N'Arkansas City', N'KS', N'20035', N'67005', 37.132947, -97.038913, 1378, 112, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2029, N'Morton County Hospital', 1, NULL, NULL, N'170166', NULL, NULL, 0, 40, NULL, N'6206972141', N'6206974766', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'445 N Hilltop', N'Elkhart', N'KS', N'20129', N'67950', 37.008079, -101.890166, 1397, 256, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2030, N'Western Plains Medical Complex', 1, NULL, NULL, N'170175', NULL, NULL, 0, 99, NULL, N'6202258400', N'6202258403', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3001 Avenue A', N'Dodge City', N'KS', N'20057', N'67801', 37.787592, -100.014967, 1395, 112, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2031, N'Overland Park Reg Med Ctr', 1, NULL, NULL, N'170176', NULL, NULL, 0, 343, NULL, N'9135415000', N'9135415035', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'10500 Quivira Road', N'Overland Park', N'KS', N'20091', N'66215', 38.934815, -94.723517, 1474, 165, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2032, N'Meadowbrook Rehabilitation Hospital', 1, NULL, NULL, N'170180', NULL, NULL, 0, 23, NULL, N'9138568747', N'9138568339', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'427 West Main Street', N'Gardner', N'KS', N'20091', N'66030', 38.809474, -94.94174, 1456, 165, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2033, N'Menorah Medical Center', 1, NULL, NULL, N'170182', NULL, NULL, 0, 158, NULL, N'9134986773', N'9134987106', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5721 West 119Th Street', N'Overland Park', N'KS', N'20091', N'66209', 38.91287, -94.654804, 2091, 165, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2034, N'Kansas Surgery & Recovery Center', 1, NULL, NULL, N'170183', NULL, NULL, 0, 34, NULL, N'3166340090', N'3166341964', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2770 North Webb Road', N'Wichita', N'KS', N'20173', N'67226', 37.747533, -97.226357, 1487, 112, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2035, N'Saint Luke''s South Hospital', 1, NULL, NULL, N'170185', NULL, NULL, 0, 75, NULL, N'9133177904', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'12300 Metcalf Avenue', N'Overland Park', N'KS', N'20091', N'66213', 38.876486, -94.667736, 2091, 165, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2036, N'Kansas Heart Hospital', 1, NULL, NULL, N'170186', NULL, NULL, 0, 54, NULL, N'3166305000', N'3166305050', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3601 North Webb Road', N'Wichita', N'KS', N'20173', N'67226', 37.752169, -97.226488, 1487, 112, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2037, N'Salina Surgical Hospital', 1, NULL, NULL, N'170187', NULL, NULL, 0, 16, NULL, N'7858270610', N'7858278608', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'401 South Santa Fe Avenue', N'Salina', N'KS', N'20169', N'67401', 38.830398, -97.609098, 1469, 112, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2038, N'Kansas City Orthopaedic Institute', 1, NULL, NULL, N'170188', NULL, NULL, 0, 9, NULL, N'9133197633', N'9132531745', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3651 College Blvd', N'Leawood', N'KS', N'20091', N'66211', 38.929589, -94.608683, 2091, 165, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2039, N'Manhattan Surgical Hospital Llc', 1, NULL, NULL, N'170190', NULL, NULL, 0, 7, NULL, N'7857765100', N'7857765101', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1829 College Avenue', N'Manhattan', N'KS', N'20161', N'66502', 39.202826, -96.598949, 1441, 111, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2040, N'Great Bend Regional Hospital', 1, NULL, NULL, N'170191', NULL, NULL, 0, 33, NULL, N'6207928833', N'6207916876', 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'514 Cleveland Street', N'Great Bend', N'KS', N'20009', N'67530', 38.356604, -98.791493, 1408, 112, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2041, N'Doctors Hospital Llc', 1, NULL, NULL, N'170194', NULL, NULL, 0, 10, NULL, N'9135291801', N'9135294520', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4901 College Blvd', N'Leawood', N'KS', N'20091', N'66211', 38.929589, -94.608683, 2091, 165, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2042, N'Heartland Surgical Spec Hospital', 1, NULL, NULL, N'170195', NULL, NULL, 0, 19, NULL, N'9137545000', N'9137540455', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4901 College Boulevard', N'Leawood', N'KS', N'20091', N'66211', 38.929589, -94.608683, 2091, 165, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2043, N'Kansas Spine & Specialty Hospital Llc', 1, NULL, NULL, N'170196', NULL, NULL, 0, 22, NULL, N'3164625326', N'3164625267', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3333 North Webb Road', N'Wichita', N'KS', N'20173', N'67226', 37.743451, -97.225626, 1487, 112, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2044, N'Kansas Medical Center Llc', 1, NULL, NULL, N'170197', NULL, NULL, 0, 58, NULL, N'3163004000', N'3163304040', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1124 West 21St Street', N'Andover', N'KS', N'20015', N'67002', 37.723341, -97.150514, 1487, 112, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2045, N'Summit Surgical Llc', 1, NULL, NULL, N'170198', NULL, NULL, 0, 10, NULL, N'6206626000', N'6206634803', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1818 East 23Rd Avenue', N'Hutchinson', N'KS', N'20155', N'67502', 38.079587, -97.891862, 1422, 112, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2046, N'Minimally Invasive Surgery Hospital', 1, NULL, NULL, N'170199', NULL, NULL, 0, 9, NULL, N'9133227401', N'9133227410', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'11217 Lakeview Avenue', N'Lenexa', N'KS', N'20091', N'66219', 38.925949, -94.76928, 1474, 165, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2047, N'Via Christi Hospital Wichita St Teresa Llc', 1, NULL, NULL, N'170200', NULL, NULL, 0, 68, NULL, N'3167967800', N'3167967802', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'14800 West St Teresa', N'Wichita', N'KS', N'20173', N'67235', 37.692236, -97.337545, 1487, 112, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2048, N'Blue Valley Hospital Llc', 1, NULL, NULL, N'170201', NULL, NULL, 0, 4, NULL, N'9134920160', N'9134285573', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'12850 Metcalf Avenue', N'Overland Park', N'KS', N'20091', N'66213', 38.876486, -94.667736, 2091, 165, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2049, N'Premier Surgical Institute', 1, NULL, NULL, N'170203', NULL, NULL, 0, 16, NULL, N'6207831732', N'6207831733', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1619 K Highway 66 Po Box 127', N'Galena', N'KS', N'20021', N'66739', 37.075895, -94.639671, 2090, 164, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2050, N'Grisell Memorial Hospital', 1, NULL, NULL, N'171300', NULL, NULL, 0, 12, NULL, N'7857312231', N'7857312895', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'210 South Vermont Avenue', N'Ransom', N'KS', N'20135', N'67572', 38.636125, -99.933734, 1466, 112, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2051, N'Ellinwood District Hospital', 1, NULL, NULL, N'171301', NULL, NULL, 0, 24, NULL, N'6205642548', N'6205643117', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'605 N Main Street', N'Ellinwood', N'KS', N'20009', N'67526', 38.360045, -98.581063, 1398, 112, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2052, N'Oswego Community Hospital', 1, NULL, NULL, N'171302', NULL, NULL, 0, 12, NULL, N'6207952921', N'6207953094', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'800 Barker Drive', N'Oswego', N'KS', N'20099', N'67356', 37.167565, -95.109964, 1460, 112, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2053, N'Lane County Hospital', 1, NULL, NULL, N'171303', NULL, NULL, 0, 10, NULL, N'6203975321', N'6203973569', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'235 West Vine  Po Box 969', N'Dighton', N'KS', N'20101', N'67839', 38.481961, -100.467084, 1394, 112, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2054, N'Ashland Health Center', 1, NULL, NULL, N'171304', NULL, NULL, 0, 24, NULL, N'6206352241', N'6206352229', 1, 0, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'709 Oak Street', N'Ashland', N'KS', N'20025', N'67831', 37.188055, -99.771937, 1379, 112, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2055, N'Wichita County Health Center', 1, NULL, NULL, N'171306', NULL, NULL, 0, 25, NULL, N'6203752233', N'6203754954', 1, 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'211 E Earl Street', N'Leoti', N'KS', N'20203', N'67861', 38.479741, -101.358771, 1436, 112, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2056, N'Rawlins County Health Center', 1, NULL, NULL, N'171307', NULL, NULL, 0, 24, NULL, N'7856263211', N'7856269414', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'707 Grant St', N'Atwood', N'KS', N'20153', N'67730', 39.81321, -101.041048, 1381, 43, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2057, N'Mercy Hospital Columbus', 1, NULL, NULL, N'171308', NULL, NULL, 0, 25, NULL, N'6204292545', N'6204291984', 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'220 N Pennsylvania Avenue', N'Columbus', N'KS', N'20021', N'66725', 37.176909, -94.843762, 2090, 164, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2058, N'Jewell County Hospital', 1, NULL, NULL, N'171309', NULL, NULL, 0, 12, NULL, N'7853783137', N'7853783450', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'100 Crestvue Ave', N'Mankato', N'KS', N'20089', N'66956', 39.786905, -98.201171, 1383, 112, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2059, N'Cheyenne County Hospital', 1, NULL, NULL, N'171310', NULL, NULL, 0, 16, NULL, N'7853322104', N'7853323255', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'210 West 1St Street', N'St Francis', N'KS', N'20023', N'67756', 39.771071, -101.804659, 1476, 43, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2060, N'Rooks County Health Center', 1, NULL, NULL, N'171311', NULL, NULL, 0, 25, NULL, N'7854344553', N'7854344499', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1210 North Washington', N'Plainville', N'KS', N'20163', N'67663', 39.234732, -99.298156, 1463, 112, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2061, N'Comanche County Hospital', 1, NULL, NULL, N'171312', NULL, NULL, 0, 14, NULL, N'6205822144', N'6205822572', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2Nd & Frisco Street', N'Coldwater', N'KS', N'20033', N'67029', 37.268913, -99.326781, 1391, 112, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2062, N'Kearny County Hospital', 1, NULL, NULL, N'171313', NULL, NULL, 0, 25, NULL, N'6203557111', N'6203551527', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'500 Thorpe Street', N'Lakin', N'KS', N'20093', N'67860', 37.940575, -101.254892, 1433, 112, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2063, N'Fw Huston Medical Center', 1, NULL, NULL, N'171314', NULL, NULL, 0, 25, NULL, N'9137744340', N'9137743379', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'408 Delaware Street', N'Winchester', N'KS', N'20087', N'66097', 39.32532, -95.27061, 1488, 111, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2064, N'Nemaha Valley Community Hospital', 1, NULL, NULL, N'171315', NULL, NULL, 0, 24, NULL, N'7853366181', N'7853363052', 1, 1, 1, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1600 Community Dr', N'Seneca', N'KS', N'20131', N'66538', 39.840112, -96.080096, 1473, 111, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2065, N'Anderson County Hospital', 1, NULL, NULL, N'171316', NULL, NULL, 0, 25, NULL, N'7852044000', N'7854483118', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'421 S Maple', N'Garnett', N'KS', N'20003', N'66032', 38.280577, -95.241919, 1405, 165, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2066, N'Edwards County Hospital', 1, NULL, NULL, N'171317', NULL, NULL, 0, 12, NULL, N'6206593621', N'6206593869', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'620 West Eighth Street', N'Kinsley', N'KS', N'20047', N'67547', 37.923072, -99.409838, 1430, 112, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2067, N'Sedan City Hospital', 1, NULL, NULL, N'171318', NULL, NULL, 0, 25, NULL, N'6207253115', N'6207253297', 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'300 North Street', N'Sedan', N'KS', N'20019', N'67361', 37.133071, -96.190348, 1472, 220, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2068, N'Holton Community Hospital', 1, NULL, NULL, N'171319', NULL, NULL, 0, 12, NULL, N'7853642116', N'7853649613', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1110 Columbine Drive', N'Holton', N'KS', N'20085', N'66436', 39.479119, -95.748323, 1479, 111, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2069, N'Horton Community Hospital', 1, NULL, NULL, N'171320', NULL, NULL, 0, 25, NULL, N'7854862642', N'7854863620', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'240 West 18Th Street', N'Horton', N'KS', N'20013', N'66439', 39.672865, -95.529711, 1419, 165, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2070, N'Meade District Hospital', 1, NULL, NULL, N'171321', NULL, NULL, 0, 25, NULL, N'6208732141', N'6208732576', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'510 East Carthage', N'Meade', N'KS', N'20119', N'67864', 37.28558, -100.340146, 1445, 112, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2071, N'Hamilton County Hospital', 1, NULL, NULL, N'171322', NULL, NULL, 0, 25, NULL, N'6203847461', N'6203845500', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'700 North Huser', N'Syracuse', N'KS', N'20075', N'67878', 37.980569, -101.752672, 1478, 112, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2072, N'Stafford County Hospital', 1, NULL, NULL, N'171323', NULL, NULL, 0, 25, NULL, N'6202345221', N'6202345792', 1, 1, 0, 0, 0, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'502 S Buckeye', N'Stafford', N'KS', N'20185', N'67578', 37.962237, -98.600637, 1477, 112, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2073, N'Satanta District Hospital', 1, NULL, NULL, N'171324', NULL, NULL, 0, 13, NULL, N'6206492761', N'6206492776', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Cheyenne & Apache', N'Satanta', N'KS', N'20081', N'67870', 37.437065, -100.988276, 1470, 112, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2074, N'Graham County Hospital', 1, NULL, NULL, N'171325', NULL, NULL, 0, 25, NULL, N'7854212121', N'7854212034', 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'304 West Prout Street', N'Hill City', N'KS', N'20065', N'67642', 39.371711, -99.844706, 1416, 112, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2075, N'Logan County Hospital', 1, NULL, NULL, N'171326', NULL, NULL, 0, 25, NULL, N'7856723211', N'7856728184', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'211 Cherry Avenue', N'Oakley', N'KS', N'20109', N'67748', 39.127222, -100.863295, 1454, 112, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2076, N'Ellsworth County Medical Center', 1, NULL, NULL, N'171327', NULL, NULL, 0, 20, NULL, N'7854723111', N'7854725760', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1604 Aylward Avenue', N'Ellsworth', N'KS', N'20053', N'67439', 38.743714, -98.218985, 1399, 112, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2077, N'Ottawa County Health Center', 1, NULL, NULL, N'171328', NULL, NULL, 0, 25, NULL, N'7853922122', N'7853922852', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'215 E 8Th Street', N'Minneapolis', N'KS', N'20143', N'67467', 39.128872, -97.703899, 1447, 112, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2078, N'Sumner County Hospital District #1', 1, NULL, NULL, N'171329', NULL, NULL, 0, 25, NULL, N'6208456492', N'6208456475', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'601 South Osage Street', N'Caldwell', N'KS', N'20191', N'67022', 37.025898, -97.609545, 1385, 112, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2079, N'Hospital District #1 Of Rice County', 1, NULL, NULL, N'171330', NULL, NULL, 0, 25, NULL, N'6202575173', N'6202572608', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'619 South Clark Avenue', N'Lyons', N'KS', N'20159', N'67554', 38.341787, -98.216243, 1440, 112, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2080, N'Kiowa District Hospital', 1, NULL, NULL, N'171331', NULL, NULL, 0, 24, NULL, N'6208254131', N'6208254667', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1002 South 4Th Street', N'Kiowa', N'KS', N'20007', N'67070', 37.012801, -98.48928, 1431, 112, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2081, N'Kiowa County Memorial Hospital', 1, NULL, NULL, N'171332', NULL, NULL, 0, 35, NULL, N'6207233341', N'6207232195', 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'721 West Kansas', N'Greensburg', N'KS', N'20097', N'67054', 37.602796, -99.292613, 1409, 112, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2082, N'Clara Barton Hospital', 1, NULL, NULL, N'171333', NULL, NULL, 0, 25, NULL, N'6206532114', N'6206532350', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'250 W 9Th Street', N'Hoisington', N'KS', N'20009', N'67544', 38.521636, -98.7798, 1418, 112, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2083, N'Medicine Lodge Memorial Hospital', 1, NULL, NULL, N'171334', NULL, NULL, 0, 25, NULL, N'6208863771', N'6209303791', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'710 N Walnut Street', N'Medicine Lodge', N'KS', N'20007', N'67104', 37.289222, -98.577528, 1446, 112, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2084, N'Stevens County Hospital', 1, NULL, NULL, N'171335', NULL, NULL, 0, 17, NULL, N'6205446178', N'6205447822', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1006 S Jackson', N'Hugoton', N'KS', N'20189', N'67951', 37.175303, -101.349602, 1421, 112, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2085, N'Ness County Hospital District #2', 1, NULL, NULL, N'171336', NULL, NULL, 0, 20, NULL, N'7857982291', N'7857983435', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'312 Custer Street', N'Ness City', N'KS', N'20135', N'67560', 38.452794, -99.906514, 1451, 112, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2086, N'Wamego Health Center', 1, NULL, NULL, N'171337', NULL, NULL, 0, 25, NULL, N'7854587201', N'7854566916', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'711 Genn Drive', N'Wamego', N'KS', N'20149', N'66547', 39.204465, -96.318801, 1483, 111, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2087, N'Sabetha Community Hospital', 1, NULL, NULL, N'171338', NULL, NULL, 0, 25, NULL, N'7852842121', N'7852842516', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'14Th & Oregon', N'Sabetha', N'KS', N'20131', N'66534', 39.899723, -95.796512, 1468, 111, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2088, N'Greenwood County Hospital', 1, NULL, NULL, N'171339', NULL, NULL, 0, 25, NULL, N'6205837451', N'6205836702', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'100 W 16Th Street', N'Eureka', N'KS', N'20073', N'67045', 37.823917, -96.28917, 1401, 112, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2089, N'Herington Municipal Hospital', 1, NULL, NULL, N'171340', NULL, NULL, 0, 25, NULL, N'7852582207', N'7852585127', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'100 E Helen Street', N'Herington', N'KS', N'20041', N'67449', 38.678213, -96.928762, 1414, 112, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2090, N'Hiawatha Community Hospital', 1, NULL, NULL, N'171341', NULL, NULL, 0, 25, NULL, N'7857426283', N'7857426558', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'300 Utah Street', N'Hiawatha', N'KS', N'20013', N'66434', 39.851918, -95.530594, 1415, 111, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2091, N'Rush County Memorial Hospital', 1, NULL, NULL, N'171342', NULL, NULL, 0, 24, NULL, N'7852222545', N'7852222868', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'801 Locust St', N'La Crosse', N'KS', N'20165', N'67548', 38.530746, -99.316509, 1432, 112, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2092, N'Stanton County Hospital', 1, NULL, NULL, N'171343', NULL, NULL, 0, 25, NULL, N'6204926250', N'6204921447', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'404 N Chestnut', N'Johnson', N'KS', N'20187', N'67855', 37.570573, -101.751005, 1426, 112, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2093, N'Wilson Medical Center', 1, NULL, NULL, N'171344', NULL, NULL, 0, 35, NULL, N'6203258369', N'6203258462', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Reece Campus 2600 Ottawa Road', N'Neodesha', N'KS', N'20205', N'66757', 37.418393, -95.680258, 1450, 112, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2094, N'Pawnee  Valley Community Hospital', 1, NULL, NULL, N'171345', NULL, NULL, 0, 25, NULL, N'6202853162', N'6202858883', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'923 Carroll Avenue', N'Larned', N'KS', N'20145', N'67550', 38.182942, -99.106693, 1408, 112, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2095, N'Hospital District #6 Of Harper County', 1, NULL, NULL, N'171346', NULL, NULL, 0, 25, NULL, N'6208425111', N'6208423715', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1101 E Spring Street', N'Anthony', N'KS', N'20077', N'67003', 37.154509, -98.017713, 1377, 112, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2096, N'Sheridan County Hospital', 1, NULL, NULL, N'171347', NULL, NULL, 0, 25, NULL, N'7856753281', N'7856753840', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'826  18Th Street', N'Hoxie', N'KS', N'20179', N'67740', 39.354072, -100.432587, 1420, 112, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2097, N'Norton County Hospital', 1, NULL, NULL, N'171348', NULL, NULL, 0, 25, NULL, N'7858773351', N'7858772841', 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'102 E Holme Street', N'Norton', N'KS', N'20137', N'67654', 39.838461, -99.887839, 1453, 112, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2098, N'Cloud County Health Center', 1, NULL, NULL, N'171349', NULL, NULL, 0, 25, NULL, N'7852431234', N'7852438411', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1100 Highland Drive', N'Concordia', N'KS', N'20029', N'66901', 39.562365, -97.673963, 1392, 112, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2099, N'Russell Regional Hospital', 1, NULL, NULL, N'171350', NULL, NULL, 0, 25, NULL, N'7854833131', N'7854833125', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'200 S Main Street', N'Russell', N'KS', N'20167', N'67665', 39.115009, -98.91796, 1467, 112, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2100, N'Washington County Hospital', 1, NULL, NULL, N'171351', NULL, NULL, 0, 25, NULL, N'7853252211', N'7853253224', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'304 E 3Rd Street', N'Washington', N'KS', N'20201', N'66968', 39.817545, -97.045683, 1484, 171, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2101, N'Decatur County Hospital', 1, NULL, NULL, N'171352', NULL, NULL, 0, 25, NULL, N'7854752208', N'7854752453', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'810 W  Columbia Street', N'Oberlin', N'KS', N'20039', N'67749', 39.816098, -100.53725, 1455, 43, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2102, N'Phillips County Hospital', 1, NULL, NULL, N'171353', NULL, NULL, 0, 25, NULL, N'7855435226', N'7855436272', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1150 State Street', N'Phillipsburg', N'KS', N'20147', N'67661', 39.75593, -99.32511, 1461, 112, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2103, N'Community Hospital Onaga And St Marys Campus', 1, NULL, NULL, N'171354', NULL, NULL, 0, 25, NULL, N'7858894272', N'7858897163', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'120 West 8Th Street', N'Onaga', N'KS', N'20149', N'66521', 39.495153, -96.172253, 1457, 111, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2104, N'Trego County Lemke Memorial Hospital', 1, NULL, NULL, N'171355', NULL, NULL, 0, 25, NULL, N'7857432182', N'7857436317', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'320 Thirteenth St', N'Wa Keeney', N'KS', N'20195', N'67672', 38.27312, -98.582187, 1482, 112, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2105, N'St Luke Hospital & Living Center', 1, NULL, NULL, N'171356', NULL, NULL, 0, 22, NULL, N'6203822177', N'6203829401', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'535 South Freebron', N'Marion', N'KS', N'20115', N'66861', 38.347324, -97.019595, 1442, 112, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2106, N'Hillsboro Community Hospital', 1, NULL, NULL, N'171357', NULL, NULL, 0, 25, NULL, N'6209473114', N'6209475690', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'701 S Main Street', N'Hillsboro', N'KS', N'20115', N'67063', 38.346136, -97.204737, 1417, 112, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2107, N'Lindsborg Community Hospital', 1, NULL, NULL, N'171358', NULL, NULL, 0, 25, NULL, N'7852273308', N'7852274130', 1, 1, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'605 W Lincoln Street', N'Lindsborg', N'KS', N'20113', N'67456', 38.573329, -97.683773, 1439, 112, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2108, N'Greeley County Health Services', 1, NULL, NULL, N'171359', NULL, NULL, 0, 18, NULL, N'6203764221', N'6203762406', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'506 3Rd Street', N'Tribune', N'KS', N'20071', N'67879', 38.470013, -101.749876, 1480, 112, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2109, N'Lincoln County Hospital', 1, NULL, NULL, N'171360', NULL, NULL, 0, 14, NULL, N'7855244403', N'7855245296', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'624 N Second', N'Lincoln', N'KS', N'20105', N'67455', 39.04084, -98.144774, 1438, 112, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2110, N'Republic County Hospital', 1, NULL, NULL, N'171361', NULL, NULL, 0, 35, NULL, N'7855272254', N'7855272324', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2420 G Street', N'Belleville', N'KS', N'20157', N'66935', 39.819385, -97.63706, 1382, 112, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2111, N'Citizens Medical Center', 1, NULL, NULL, N'171362', NULL, NULL, 0, 25, NULL, N'7854627511', N'7854604895', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'100 E College Drive', N'Colby', N'KS', N'20193', N'67701', 39.379765, -101.037983, 1390, 43, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2112, N'Community Memorial Healthcare Inc', 1, NULL, NULL, N'171363', NULL, NULL, 0, 25, NULL, N'7855622311', N'7855622348', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'708 N 18Th Street', N'Marysville', N'KS', N'20117', N'66508', 39.844845, -96.636224, 1443, 171, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2113, N'Osborne County Memorial Hospital', 1, NULL, NULL, N'171364', NULL, NULL, 0, 25, NULL, N'7853462121', N'7853465498', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'424 W New Hampshire Street', N'Osborne', N'KS', N'20141', N'67473', 39.436766, -98.700948, 1458, 112, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2114, N'Hanover Hospital', 1, NULL, NULL, N'171365', NULL, NULL, 0, 16, NULL, N'7853372214', N'7853372727', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'205 S Hanover Street', N'Hanover', N'KS', N'20201', N'66945', 39.890492, -96.87493, 1411, 171, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2115, N'Harper Hospital District No 5', 1, NULL, NULL, N'171366', NULL, NULL, 0, 25, NULL, N'6208967324', N'6208967127', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'700 West 13Th', N'Harper', N'KS', N'20077', N'67058', 37.286791, -98.026274, 1412, 112, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2116, N'Gove County Medical Center', 1, NULL, NULL, N'171367', NULL, NULL, 0, 25, NULL, N'7857543341', N'7857543329', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'520 West 5Th Street', N'Quinter', N'KS', N'20063', N'67752', 39.06711, -100.240527, 1465, 112, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2117, N'Minneola District Hospital #2', 1, NULL, NULL, N'171368', NULL, NULL, 0, 18, NULL, N'6208854264', N'6208854602', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'212 Main', N'Minneola', N'KS', N'20025', N'67865', 37.443356, -100.015135, 1448, 112, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2118, N'Hodgeman County Health Center', 1, NULL, NULL, N'171369', NULL, NULL, 0, 16, NULL, N'6203578361', N'6203576120', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'809 Bramley', N'Jetmore', N'KS', N'20083', N'67854', 38.083551, -99.903445, 1425, 112, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2119, N'Goodland Regional Medical Center', 1, NULL, NULL, N'171370', NULL, NULL, 0, 25, NULL, N'7858903625', N'7858906373', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'220 West Second Street', N'Goodland', N'KS', N'20181', N'67735', 39.350833, -101.710172, 1407, 43, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2120, N'Clay County Medical Center', 1, NULL, NULL, N'171371', NULL, NULL, 0, 25, NULL, N'7856322144', N'7856323686', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'617 Liberty', N'Clay Center', N'KS', N'20027', N'67432', 39.391751, -97.123058, 1388, 111, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2121, N'Scott County Hospital', 1, NULL, NULL, N'171372', NULL, NULL, 0, 25, NULL, N'6208725811', N'6208727193', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'201 Albert Avenue', N'Scott City', N'KS', N'20171', N'67871', 38.482519, -100.907095, 1471, 112, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2122, N'Allen County Regional Hospital', 1, NULL, NULL, N'171373', NULL, NULL, 0, 25, NULL, N'6203651021', N'6203651032', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3066 North Kentucky Street', N'Iola', N'KS', N'20001', N'66749', 37.944418, -95.390605, 1424, 112, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2123, N'Fredonia Regional Hospital', 1, NULL, NULL, N'171374', NULL, NULL, 0, 32, NULL, N'6203782121', N'6203783169', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1527 Madison', N'Fredonia', N'KS', N'20205', N'66736', 37.533715, -95.814792, 1403, 112, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2124, N'Mitchell County Hospital Health Systems', 1, NULL, NULL, N'171375', NULL, NULL, 0, 35, NULL, N'7857382266', N'7857389503', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'400 W 8Th Street P O Box 399', N'Beloit', N'KS', N'20123', N'67420', 39.458684, -98.108282, 1383, 112, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2125, N'Girard Medical Center', 1, NULL, NULL, N'171376', NULL, NULL, 0, 25, NULL, N'6207248291', N'6207245195', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'302 North Hospital Drive', N'Girard', N'KS', N'20037', N'66743', 37.513939, -94.858321, 1406, 164, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2126, N'Smith County Memorial Hospital', 1, NULL, NULL, N'171377', NULL, NULL, 0, 25, NULL, N'7852826845', N'7852826331', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'614 South Main Street', N'Smith Center', N'KS', N'20183', N'66967', 39.774389, -98.785735, 1475, 112, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2127, N'Kingman Community Hospital', 1, NULL, NULL, N'171378', NULL, NULL, 0, 25, NULL, N'6205323147', N'6205320167', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'750 W Ave D', N'Kingman', N'KS', N'20095', N'67068', 37.645849, -98.113673, 1429, 112, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2128, N'Morris County Hospital', 1, NULL, NULL, N'171379', NULL, NULL, 0, 25, NULL, N'6207676811', N'6207675611', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'600 N Washington St', N'Council Grove', N'KS', N'20127', N'66846', 38.665288, -96.500096, 1393, 111, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2129, N'Neosho Memorial Regional Medical Center', 1, NULL, NULL, N'171380', NULL, NULL, 0, 25, NULL, N'6204314000', N'6204317556', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'629 South Plummer', N'Chanute', N'KS', N'20133', N'66720', 37.679214, -95.457203, 1387, 112, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2130, N'Memorial Hospital', 1, NULL, NULL, N'171381', NULL, NULL, 0, 25, NULL, N'7852636610', N'7852636622', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'511 Ne 10Th St', N'Abilene', N'KS', N'20041', N'67410', 38.924967, -97.206264, 1376, 111, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2131, N'Atchison Hospital', 1, NULL, NULL, N'171382', NULL, NULL, 0, 25, NULL, N'9133605581', N'9136742023', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'800 Ravin Hill Drive', N'Atchison', N'KS', N'20005', N'66002', 39.563372, -95.121291, 1380, 165, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2132, N'William Newton Hospital', 1, NULL, NULL, N'171383', NULL, NULL, 0, 25, NULL, N'6202212300', N'6202213594', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1300 East Fifth Avenue', N'Winfield', N'KS', N'20035', N'67156', 37.239749, -96.995592, 1489, 112, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2133, N'Newman Regional Health', 1, NULL, NULL, N'171384', NULL, NULL, 0, 53, NULL, N'6203436800', N'6203417801', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1201 West 12Th Avenue', N'Emporia', N'KS', N'20111', N'66801', 38.412224, -96.195246, 1400, 111, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2134, N'Wichita-Amg Specialty Hospital', 1, NULL, NULL, N'172003', NULL, NULL, 0, 26, NULL, N'3166820004', N'3166825790', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'8080 E Pawnee', N'Wichita', N'KS', N'20173', N'67207', 37.692236, -97.337545, 1487, 112, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2135, N'Promise Hospital Of Overland Park', 1, NULL, NULL, N'172004', NULL, NULL, 0, 56, NULL, N'9136493701', N'9136492408', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6509 West 103Rd Street', N'Overland Park', N'KS', N'20091', N'66212', 38.942236, -94.694054, 1474, 165, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2136, N'Select Specialty Hospital Of Ks City', 1, NULL, NULL, N'172005', NULL, NULL, 0, 40, NULL, N'9137325930', N'9137325939', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1731 North 90Th Street', N'Kansas City', N'KS', N'20209', N'66112', 39.124952, -94.788423, 1428, 165, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2137, N'Select Specialty Hospital Of Topeka', 1, NULL, NULL, N'172006', NULL, NULL, 0, 10, NULL, N'7852957848', N'7852955553', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1700 Sw 7Th St Suite 840', N'Topeka', N'KS', N'20177', N'66606', 39.049011, -95.677556, 1479, 111, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2138, N'Select Specialty Hospital Wichita', 1, NULL, NULL, N'172007', NULL, NULL, 0, 35, NULL, N'3169623930', N'3166923922', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'929 North St Francis 6Th Floor North Tower', N'Wichita', N'KS', N'20173', N'67214', 37.692236, -97.337545, 1487, 112, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2139, N'The Kansas Rehabilitation Hospital', 1, NULL, NULL, N'173025', NULL, NULL, 0, 72, NULL, N'7852356600', N'7852328545', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1504 Sw 8Th Avenue', N'Topeka', N'KS', N'20177', N'66606', 39.055232, -95.69441, 1479, 111, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2140, N'Mid America Rehabilitation Hospital', 1, NULL, NULL, N'173026', NULL, NULL, 0, 80, NULL, N'9134912410', N'9133383762', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5701 W 110Th Street', N'Overland Park', N'KS', N'20091', N'66211', 38.929526, -94.651309, 2091, 165, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2141, N'Wesley Rehabilitation Hospital', 1, NULL, NULL, N'173027', NULL, NULL, 0, 65, NULL, N'3167291121', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'8338 West 13Th Street', N'Wichita', N'KS', N'20173', N'67212', 37.692236, -97.337545, 1487, 112, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2142, N'Via Christi Rehabilitation Hospital Inc', 1, NULL, NULL, N'173028', NULL, NULL, 0, 40, NULL, N'3166343400', N'3166341141', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1151 N Rock Road', N'Wichita', N'KS', N'20173', N'67206', 37.7152, -97.244619, 1487, 112, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2143, N'Children''s Mercy  South', 1, NULL, NULL, N'173300', NULL, NULL, 0, 34, NULL, N'9132343000', N'8168426107', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5808 W 110Th Street', N'Overland Park', N'KS', N'20091', N'66211', 38.92918, -94.660652, 2091, 165, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2144, N'Osawatomie State Hospital Psychiatric', 1, NULL, NULL, N'174004', NULL, NULL, 0, 279, NULL, N'9137557000', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'500 State Hospital Drive', N'Osawatomie', N'KS', N'20121', N'66064', 38.51063, -94.942722, 1456, 165, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2145, N'Larned State Hospital', 1, NULL, NULL, N'174006', NULL, NULL, 0, 299, NULL, N'6202854360', N'6202854357', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1301 Ks Highway 264', N'Larned', N'KS', N'20145', N'67550', 38.180569, -99.098713, 1408, 112, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2146, N'Prairie View Inc', 1, NULL, NULL, N'174016', NULL, NULL, 0, 80, NULL, N'3162846400', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1901 E First Street Po Box 467', N'Newton', N'KS', N'20079', N'67114', 38.046917, -97.344724, 1452, 112, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2147, N'Via Christi Reg Med Ctr-Transplant Unit', 1, NULL, NULL, N'179800', NULL, NULL, 0, 0, NULL, N'3162685000', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'929 N St Francis', N'Wichita', N'KS', N'20173', N'67214', 37.692236, -97.337545, 1487, 112, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2148, N'University Of Kansas Hospital Transplant Center', 1, NULL, NULL, N'179801', NULL, NULL, 0, 0, NULL, N'9135886064', N'9135888763', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'3901 Rainbow Blvd', N'Kansas City', N'KS', N'20209', N'66106', 39.053776, -94.611212, 1428, 165, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2149, N'St Elizabeth Ft Thomas', 1, NULL, NULL, N'180001', NULL, NULL, 0, 312, NULL, N'8595723100', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'85 North Grand Avenue', N'Fort Thomas', N'KY', N'21037', N'41075', 39.078555, -84.465208, 1509, 113, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2150, N'Whitesburg Arh Hospital', 1, NULL, NULL, N'180002', NULL, NULL, 0, 90, NULL, N'6066333500', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'240 Hospital Road', N'Whitesburg', N'KY', N'21133', N'41858', 37.113521, -82.813153, 1568, 114, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2151, N'Muhlenberg Community Hospital', 1, NULL, NULL, N'180004', NULL, NULL, 0, 90, NULL, N'2703388000', N'2703388278', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'440 Hopkinsville Street', N'Greenville', N'KY', N'21177', N'42345', 37.19681, -87.190528, 1516, 254, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2152, N'Highlands Regional Medical Center', 1, NULL, NULL, N'180005', NULL, NULL, 0, 166, NULL, N'6068868511', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5000 Kentucky Route 321', N'Prestonsburg', N'KY', N'21071', N'41653', 37.665653, -82.771549, 1555, 114, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2153, N'King''s Daughters'' Medical Center', 1, NULL, NULL, N'180009', NULL, NULL, 0, 455, NULL, N'6064084000', NULL, 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2201 Lexington Avenue', N'Ashland', N'KY', N'21019', N'41101', 38.470383, -82.6358, 1491, 296, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2154, N'Saint Joseph Hospital', 1, NULL, NULL, N'180010', NULL, NULL, 0, 468, NULL, N'8593131000', N'8593133000', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'One Saint Joseph Drive', N'Lexington', N'KY', N'21067', N'40504', 38.046407, -84.497039, 1531, 114, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2155, N'Saint Joseph London', 1, NULL, NULL, N'180011', NULL, NULL, 0, 120, NULL, N'6063306000', N'6063306020', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1001 Saint Joseph Lane', N'London', N'KY', N'21125', N'40741', 37.128977, -84.083265, 1532, 114, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2156, N'Hardin Memorial Hospital', 1, NULL, NULL, N'180012', NULL, NULL, 0, 300, NULL, N'2707371212', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'913 North Dixie Avenue', N'Elizabethtown', N'KY', N'21093', N'42701', 37.693952, -85.859128, 1506, 115, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2157, N'The Medical Center At Bowling Green', 1, NULL, NULL, N'180013', NULL, NULL, 0, 382, NULL, N'2707451000', N'2708420765', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'250 Park Street', N'Bowling Green', N'KY', N'21227', N'42101', 36.994242, -86.433368, 1495, 254, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2158, N'Jewish Hospital - Shelbyville', 1, NULL, NULL, N'180016', NULL, NULL, 0, 68, NULL, N'5026474300', N'5026474039', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'727 Hospital Drive', N'Shelbyville', N'KY', N'21211', N'40065', 38.212081, -85.235956, 1561, 115, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2159, N'T J Samson Community Hospital', 1, NULL, NULL, N'180017', NULL, NULL, 0, 180, NULL, N'2706514159', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1301 North Race Street', N'Glasgow', N'KY', N'21009', N'42141', 37.010825, -85.90353, 1514, 115, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2160, N'St Claire Regional Medical Center', 1, NULL, NULL, N'180018', NULL, NULL, 0, 149, NULL, N'6067836500', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'222 Medical Circle', N'Morehead', N'KY', N'21205', N'40351', 38.180277, -83.443076, 1543, 114, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2161, N'Meadowview Regional Medical Center', 1, NULL, NULL, N'180019', NULL, NULL, 0, 111, NULL, N'6067595311', N'6067595616', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'989 Medical Park Drive', N'Maysville', N'KY', N'21161', N'41056', 38.638932, -83.807136, 1539, 114, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2162, N'Middlesboro Appalachian Regional Healthcare Hospit', 1, NULL, NULL, N'180020', NULL, NULL, 0, 96, NULL, N'6062421101', N'6062421472', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3600 West Cumberland Avenue', N'Middlesboro', N'KY', N'21013', N'40965', 36.605309, -83.738174, 1541, 252, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2163, N'Pineville Community Hospital', 1, NULL, NULL, N'180021', NULL, NULL, 0, 120, NULL, N'6063373051', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'850 Riverview Avenue', N'Pineville', N'KY', N'21013', N'40977', 36.763294, -83.707569, 1554, 252, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2164, N'Spring View Hospital', 1, NULL, NULL, N'180024', NULL, NULL, 0, 75, NULL, N'2706925145', N'2706925155', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'320 Loretto Road', N'Lebanon', N'KY', N'21155', N'40033', 37.569787, -85.252738, 1529, 115, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2165, N'Flaget Memorial Hospital (Member Of Saint Joseph H', 1, NULL, NULL, N'180025', NULL, NULL, 0, 40, NULL, N'5023505000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4305 New Shepherdsville Road', N'Bardstown', N'KY', N'21179', N'40004', 37.809228, -85.466902, 1493, 115, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2166, N'Murray-Calloway County Hospital', 1, NULL, NULL, N'180027', NULL, NULL, 0, 140, NULL, N'2707621100', N'2707673600', 1, 1, 0, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'803 Poplar Street', N'Murray', N'KY', N'21035', N'42071', 36.608565, -88.308729, 1547, 117, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2167, N'Hazard Arh Regional Medical Center', 1, NULL, NULL, N'180029', NULL, NULL, 0, 308, NULL, N'6064396600', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'100 Medical Center Drive', N'Hazard', N'KY', N'21193', N'41701', 37.277478, -83.227977, 1521, 114, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2168, N'St Elizabeth Medical Center', 1, NULL, NULL, N'180035', NULL, NULL, 0, 621, NULL, N'8593019901', NULL, 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1 Medical Village Drive', N'Edgewood', N'KY', N'21117', N'41017', 39.008047, -84.564784, 1503, 113, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2169, N'Our Lady Of Bellefonte Hospital', 1, NULL, NULL, N'180036', NULL, NULL, 0, 190, NULL, N'6068333600', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1000 Saint Christopher Drive', N'Ashland', N'KY', N'21019', N'41101', 38.478414, -82.637939, 1491, 296, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2170, N'Owensboro Health Regional Hospital', 1, NULL, NULL, N'180038', NULL, NULL, 0, 469, NULL, N'2704172000', NULL, 1, 1, 0, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1201 Pleasant Valley Road', N'Owensboro', N'KY', N'21059', N'42303', 37.774215, -87.11333, 1548, 116, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2171, N'Jewish Hospital & St Mary''s Healthcare', 1, NULL, NULL, N'180040', NULL, NULL, 0, 1261, NULL, N'5025874011', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'200 Abraham Flexner Way', N'Louisville', N'KY', N'21111', N'40202', 38.24917, -85.751246, 1534, 115, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2172, N'Memorial Hospital', 1, NULL, NULL, N'180043', NULL, NULL, 0, 63, NULL, N'6065985104', N'6065987008', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'210 Marie Langdon Drive', N'Manchester', N'KY', N'21051', N'40962', 37.162083, -83.761417, 1536, 114, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2173, N'Pikeville Medical Center', 1, NULL, NULL, N'180044', NULL, NULL, 0, 261, NULL, N'6062183500', N'6064374996', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'911 Bypass Road', N'Pikeville', N'KY', N'21195', N'41501', 37.479267, -82.518763, 1553, 114, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2174, N'St Elizabeth Florence', 1, NULL, NULL, N'180045', NULL, NULL, 0, 161, NULL, N'8592125220', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4900 Houston Road', N'Florence', N'KY', N'21015', N'41042', 39.013209, -84.640742, 1508, 113, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2175, N'Bourbon Community Hospital', 1, NULL, NULL, N'180046', NULL, NULL, 0, 58, NULL, N'8599873600', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'9 Linville Drive', N'Paris', N'KY', N'21017', N'40361', 38.221948, -84.238784, 1552, 114, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2176, N'Ephraim Mcdowell Regional Medical Center', 1, NULL, NULL, N'180048', NULL, NULL, 0, 197, NULL, N'8592392409', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'217 South Third Street', N'Danville', N'KY', N'21021', N'40422', 37.645633, -84.77217, 1505, 114, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2177, N'Baptist Health Richmond', 1, NULL, NULL, N'180049', NULL, NULL, 0, 105, NULL, N'8596233131', NULL, 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'801 Eastern Bypass', N'Richmond', N'KY', N'21151', N'40475', 37.731199, -84.286397, 1557, 114, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2178, N'Harlan Arh Hospital', 1, NULL, NULL, N'180050', NULL, NULL, 0, 150, NULL, N'6065738100', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'81 Ball Park Road', N'Harlan', N'KY', N'21095', N'40831', 36.953786, -82.885421, 1518, 114, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2179, N'Jennie Stuart Medical Center', 1, NULL, NULL, N'180051', NULL, NULL, 0, 194, NULL, N'2708870100', N'2708870223', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'320 West 18Th Street', N'Hopkinsville', N'KY', N'21047', N'42240', 36.860389, -87.495376, 1523, 254, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2180, N'Fleming County Hospital', 1, NULL, NULL, N'180053', NULL, NULL, 0, 52, NULL, N'6068492351', NULL, 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'55 Foundation Drive', N'Flemingsburg', N'KY', N'21069', N'41041', 38.4223, -83.733808, 1507, 114, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2181, N'Methodist Hospital', 1, NULL, NULL, N'180056', NULL, NULL, 0, 205, NULL, N'2708277700', N'2708277402', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1305 N Elm St', N'Henderson', N'KY', N'21101', N'42420', 37.864364, -87.575502, 1522, 94, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2182, N'Saint Joseph Mount Sterling', 1, NULL, NULL, N'180064', NULL, NULL, 0, 63, NULL, N'8594975018', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'225 Falcon Drive', N'Mount Sterling', N'KY', N'21173', N'40353', 38.056468, -83.943256, 1545, 114, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2183, N'Logan Memorial Hospital', 1, NULL, NULL, N'180066', NULL, NULL, 0, 92, NULL, N'2707264011', N'2707267465', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1625 Nashville Street', N'Russellville', N'KY', N'21141', N'42276', 36.837816, -86.89063, 1559, 254, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2184, N'University Of Kentucky Hospital', 1, NULL, NULL, N'180067', NULL, NULL, 0, 791, NULL, N'8593235000', N'8593232044', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'800 Rose Street', N'Lexington', N'KY', N'21067', N'40536', 38.032772, -84.506765, 1531, 114, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2185, N'Tug Valley Arh Regional Medical Center', 1, NULL, NULL, N'180069', NULL, NULL, 0, 113, NULL, N'6062371700', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'260 Hospital Drive', N'South Williamson', N'KY', N'21195', N'41503', 37.672081, -82.283925, 1563, 114, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2186, N'Twin Lakes Regional Medical Center', 1, NULL, NULL, N'180070', NULL, NULL, 0, 75, NULL, N'2702599400', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'910 Wallace Avenue', N'Leitchfield', N'KY', N'21085', N'42754', 37.475706, -86.286007, 1530, 115, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2187, N'Paul B Hall Regional Medical Center', 1, NULL, NULL, N'180078', NULL, NULL, 0, 72, NULL, N'6067893511', N'6067896486', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'625 James S Trimble Boulevard', N'Paintsville', N'KY', N'21115', N'41240', 37.814941, -82.812188, 1555, 114, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2188, N'Harrison Memorial Hospital', 1, NULL, NULL, N'180079', NULL, NULL, 0, 61, NULL, N'8592342300', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1210 Ky Hwy 36 E', N'Cynthiana', N'KY', N'21097', N'41031', 38.390353, -84.294101, 1504, 114, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2189, N'Baptist Health Corbin', 1, NULL, NULL, N'180080', NULL, NULL, 0, 240, NULL, N'6065281212', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'One Trillium Way', N'Corbin', N'KY', N'21121', N'40701', 36.948699, -84.096876, 1502, 114, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2190, N'Taylor Regional Hospital', 1, NULL, NULL, N'180087', NULL, NULL, 0, 90, NULL, N'2704653561', N'2704655386', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1700 Old Lebanon Road', N'Campbellsville', N'KY', N'21217', N'42718', 37.343397, -85.341907, 1498, 115, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2191, N'Norton Hospital/Norton Medical Pavilions/Kosair Ch', 1, NULL, NULL, N'180088', NULL, NULL, 0, 1730, NULL, N'5026298000', N'5026292016', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'200 East Chestnut Street', N'Louisville', N'KY', N'21111', N'40202', 38.24785, -85.750658, 1534, 115, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2192, N'Clark Regional Medical Center', 1, NULL, NULL, N'180092', NULL, NULL, 0, 75, NULL, N'8597378559', N'8597376601', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'175 Hospital Drive', N'Winchester', N'KY', N'21049', N'40391', 37.990079, -84.17965, 1570, 114, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2193, N'Baptist Health Madisonville', 1, NULL, NULL, N'180093', NULL, NULL, 0, 390, NULL, N'2708255100', NULL, 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'900 Hospital Drive', N'Madisonville', N'KY', N'21107', N'42431', 37.340377, -87.497543, 1535, 117, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2194, N'Crittenden Health System', 1, NULL, NULL, N'180095', NULL, NULL, 0, 48, NULL, N'2709655281', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'520 West Gum Street', N'Marion', N'KY', N'21055', N'42064', 37.32934, -88.088547, 1537, 117, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2195, N'Georgetown Community Hospital', 1, NULL, NULL, N'180101', NULL, NULL, 0, 75, NULL, N'5028681100', N'5028685607', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1140 Lexington Road', N'Georgetown', N'KY', N'21209', N'40324', 38.186485, -84.560422, 1513, 114, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2196, N'Lourdes Hospital', 1, NULL, NULL, N'180102', NULL, NULL, 0, 359, NULL, N'2704442444', N'2704442980', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1530 Lone Oak Road', N'Paducah', N'KY', N'21145', N'42003', 37.053766, -88.646419, 1550, 117, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2197, N'Baptist Health Lexington', 1, NULL, NULL, N'180103', NULL, NULL, 0, 371, NULL, N'8592606104', NULL, 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1740 Nicholasville Road', N'Lexington', N'KY', N'21067', N'40503', 38.030745, -84.509773, 1531, 114, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2198, N'Baptist Health Paducah', 1, NULL, NULL, N'180104', NULL, NULL, 0, 349, NULL, N'2705752100', NULL, 1, 1, 0, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2501 Kentucky Avenue', N'Paducah', N'KY', N'21145', N'42003', 37.073453, -88.626812, 1550, 117, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2199, N'Monroe County Medical Center', 1, NULL, NULL, N'180105', NULL, NULL, 0, 49, NULL, N'2704879231', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'529 Capp Harlan Road', N'Tompkinsville', N'KY', N'21171', N'42167', 36.699934, -85.678369, 1565, 115, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2200, N'Clinton County Hospital Inc', 1, NULL, NULL, N'180106', NULL, NULL, 0, 42, NULL, N'6063876421', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'723 Burkesville Road', N'Albany', N'KY', N'21053', N'42602', 36.697992, -85.144844, 1490, 115, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2201, N'Rockcastle Regional Hospital & Respiratory Care Ct', 1, NULL, NULL, N'180115', NULL, NULL, 0, 26, NULL, N'6062562195', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'145 Newcomb Avenue', N'Mount Vernon', N'KY', N'21203', N'40456', 37.357632, -84.33625, 1546, 114, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2202, N'Jackson Purchase Medical Center', 1, NULL, NULL, N'180116', NULL, NULL, 0, 93, NULL, N'2702514585', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1099 Medical Center Circle', N'Mayfield', N'KY', N'21083', N'42066', 36.758802, -88.651344, 1538, 117, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2203, N'Parkway Regional Hospital', 1, NULL, NULL, N'180117', NULL, NULL, 0, 70, NULL, N'2704722522', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2000 Holiday Lane', N'Fulton', N'KY', N'21075', N'42041', 36.517319, -88.896662, 1512, 117, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2204, N'Greenview Regional Hospital', 1, NULL, NULL, N'180124', NULL, NULL, 0, 211, NULL, N'2707931000', N'2707935205', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1801 Ashley Circle', N'Bowling Green', N'KY', N'21227', N'42104', 36.96592, -86.436128, 1495, 254, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2205, N'Frankfort Regional Medical Center', 1, NULL, NULL, N'180127', NULL, NULL, 0, 173, NULL, N'5028755240', N'5022267936', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'299 Kings Daughters Drive', N'Frankfort', N'KY', N'21073', N'40601', 38.159958, -84.906112, 1510, 114, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2206, N'Three Rivers Medical Center', 1, NULL, NULL, N'180128', NULL, NULL, 0, 90, NULL, N'6066389451', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2485 Highway 644', N'Louisa', N'KY', N'21127', N'41230', 38.114254, -82.603212, 1533, 296, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2207, N'Baptist Health Louisville', 1, NULL, NULL, N'180130', NULL, NULL, 0, 519, NULL, N'5028978100', NULL, 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4000 Kresge Way', N'Louisville', N'KY', N'21111', N'40207', 38.23806, -85.638633, 1534, 115, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2208, N'Lake Cumberland Regional Hospital', 1, NULL, NULL, N'180132', NULL, NULL, 0, 215, NULL, N'6066797441', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'305 Langdon Street', N'Somerset', N'KY', N'21199', N'42502', 37.08579, -84.620268, 1562, 114, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2209, N'Baptist Health La Grange', 1, NULL, NULL, N'180138', NULL, NULL, 0, 90, NULL, N'5022225388', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1025 New Moody Lane', N'La Grange', N'KY', N'21185', N'40031', 38.393948, -85.380788, 1527, 115, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2210, N'Kentucky River Medical Center', 1, NULL, NULL, N'180139', NULL, NULL, 0, 55, NULL, N'6066666000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'540 Jett Drive', N'Jackson', N'KY', N'21025', N'41339', 37.553474, -83.38226, 1571, 114, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2211, N'University Of Louisville Hospital', 1, NULL, NULL, N'180141', NULL, NULL, 0, 404, NULL, N'5025623000', N'5025623333', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'530 South Jackson Street', N'Louisville', N'KY', N'21111', N'40202', 38.249029, -85.74542, 1534, 115, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2212, N'Saint Joseph East', 1, NULL, NULL, N'180143', NULL, NULL, 0, 174, NULL, N'8599675000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'150 North Eagle Creek Drive', N'Lexington', N'KY', N'21067', N'40509', 37.998938, -84.44179, 1531, 114, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2213, N'Westlake Regional Hospital', 1, NULL, NULL, N'180149', NULL, NULL, 0, 77, NULL, N'2703844753', N'2703846228', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'901 Westlake Drive', N'Columbia', N'KY', N'21001', N'42728', 37.096343, -85.295204, 1501, 115, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2214, N'Marcum And Wallace Memorial Hospital', 1, NULL, NULL, N'181301', NULL, NULL, 0, 25, NULL, N'6067232115', N'6067232951', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'60 Mercy Court', N'Irvine', N'KY', N'21065', N'40336', 37.706076, -83.977725, 1525, 114, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2215, N'The James B Haggin Memorial Hospital', 1, NULL, NULL, N'181302', NULL, NULL, 0, 25, NULL, N'8597345441', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'464 Linden Avenue', N'Harrodsburg', N'KY', N'21167', N'40330', 37.756731, -84.848288, 1519, 114, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2216, N'Nicholas County Hospital', 1, NULL, NULL, N'181303', NULL, NULL, 0, 18, NULL, N'8592897181', N'8592894323', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2325 Concrete Road', N'Carlisle', N'KY', N'21181', N'40311', 38.31202, -84.027427, 1499, 114, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2217, N'Trigg County Hospital', 1, NULL, NULL, N'181304', NULL, NULL, 0, 25, NULL, N'2705223215', NULL, 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'254 Main Street', N'Cadiz', N'KY', N'21221', N'42211', 36.867065, -87.821946, 1497, 117, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2218, N'Saint Joseph Martin', 1, NULL, NULL, N'181305', NULL, NULL, 0, 25, NULL, N'6062856401', N'6062856409', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'11203 Main Street', N'Martin', N'KY', N'21071', N'41649', 37.570094, -82.754082, 1555, 114, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2219, N'Methodist Hospital Union County', 1, NULL, NULL, N'181306', NULL, NULL, 0, 25, NULL, N'2703893030', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4604 Us Highway 60 West', N'Morganfield', N'KY', N'21225', N'42437', 37.683378, -87.916692, 1544, 94, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2220, N'Morgan County Arh Hospital', 1, NULL, NULL, N'181307', NULL, NULL, 0, 20, NULL, N'6067433186', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'476 Liberty Road', N'West Liberty', N'KY', N'21175', N'41472', 37.921476, -83.259622, 1567, 114, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2221, N'Bluegrass Community Hospital', 1, NULL, NULL, N'181308', NULL, NULL, 0, 25, NULL, N'8598792300', N'8598731016', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'360 Amsden Avenue', N'Versailles', N'KY', N'21239', N'40383', 38.055239, -84.724323, 1566, 114, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2222, N'Casey County Hospital', 1, NULL, NULL, N'181309', NULL, NULL, 0, 24, NULL, N'6067876275', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'187 Wolford Avenue', N'Liberty', N'KY', N'21045', N'42539', 37.317653, -84.932012, 1505, 114, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2223, N'Carroll County Memorial Hospital', 1, NULL, NULL, N'181310', NULL, NULL, 0, 25, NULL, N'5027324321', N'5027323297', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'309 Eleventh Street', N'Carrollton', N'KY', N'21041', N'41008', 38.680896, -85.179398, 1500, 115, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2224, N'St Elizabeth Grant', 1, NULL, NULL, N'181311', NULL, NULL, 0, 15, NULL, N'8598248240', NULL, 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'238 Barnes Road', N'Williamstown', N'KY', N'21081', N'41097', 38.647347, -84.579044, 1569, 113, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2225, N'New Horizons Medical Center', 1, NULL, NULL, N'181312', NULL, NULL, 0, 25, NULL, N'5024844656', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'330 Roland Avenue', N'Owenton', N'KY', N'21187', N'40359', 38.541307, -84.841093, 1549, 114, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2226, N'Caverna Memorial Hospital', 1, NULL, NULL, N'181314', NULL, NULL, 0, 25, NULL, N'2707862191', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1501 South Dixie Street', N'Horse Cave', N'KY', N'21099', N'42749', 37.173362, -85.910054, 1514, 115, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2227, N'Ephraim Mcdowell Fort Logan Hospital', 1, NULL, NULL, N'181315', NULL, NULL, 0, 25, NULL, N'6063654600', N'6063654631', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'110 Metker Trail', N'Stanford', N'KY', N'21137', N'40484', 37.543647, -84.654107, 1564, 114, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2228, N'Mary Breckinridge Arh Hospital', 1, NULL, NULL, N'181316', NULL, NULL, 0, 25, NULL, N'6066722901', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'130 Kate Ireland Drive', N'Hyden', N'KY', N'21131', N'41749', 37.162743, -83.377835, 1524, 114, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2229, N'Cumberland County Hospital', 1, NULL, NULL, N'181317', NULL, NULL, 0, 25, NULL, N'2708642511', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'299 Glasgow Road', N'Burkesville', N'KY', N'21057', N'42717', 36.79034, -85.370519, 1496, 115, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2230, N'The Medical Center At Franklin', 1, NULL, NULL, N'181318', NULL, NULL, 0, 25, NULL, N'2705984800', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1100 Brookhaven Road', N'Franklin', N'KY', N'21213', N'42135', 36.702679, -86.575963, 1511, 254, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2231, N'Breckinridge Memorial Hospital', 1, NULL, NULL, N'181319', NULL, NULL, 0, 25, NULL, N'2707567000', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1011 Old Highway 60', N'Hardinsburg', N'KY', N'21027', N'40143', 37.780059, -86.460534, 1517, 115, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2232, N'Livingston Hospital And Healthcare Services Inc', 1, NULL, NULL, N'181320', NULL, NULL, 0, 25, NULL, N'2709882299', N'2709883900', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'131 Hospital Drive', N'Salem', N'KY', N'21139', N'42078', 37.263266, -88.229408, 1560, 117, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2233, N'Wayne County Hospital', 1, NULL, NULL, N'181321', NULL, NULL, 0, 25, NULL, N'6063489343', N'6063403291', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'166 Hospital Street', N'Monticello', N'KY', N'21231', N'42633', 36.820056, -84.868174, 1542, 114, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2234, N'Caldwell Medical Center', 1, NULL, NULL, N'181322', NULL, NULL, 0, 25, NULL, N'2703650300', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'100 Medical Center Drive', N'Princeton', N'KY', N'21033', N'42445', 37.109216, -87.881959, 1556, 117, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2235, N'Ohio County Hospital', 1, NULL, NULL, N'181323', NULL, NULL, 0, 25, NULL, N'2702987411', NULL, 1, 1, 0, 0, 0, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1211 Old Main Street', N'Hartford', N'KY', N'21183', N'42347', 37.447553, -86.896575, 1520, 116, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2236, N'The Medical Center At Scottsville', 1, NULL, NULL, N'181324', NULL, NULL, 0, 25, NULL, N'2706222800', N'2706222208', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'456 Burnley Road', N'Scottsville', N'KY', N'21003', N'42164', 36.757805, -86.213949, 1495, 254, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2237, N'Jane Todd Crawford Hospital', 1, NULL, NULL, N'181325', NULL, NULL, 0, 35, NULL, N'2709324211', N'2709323504', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'202-206 Milby Street', N'Greensburg', N'KY', N'21087', N'42743', 37.242802, -85.493791, 1515, 115, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2238, N'Marshall County Hospital', 1, NULL, NULL, N'181327', NULL, NULL, 0, 25, NULL, N'2705274800', N'2705274910', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'615 Old Symsonia Road', N'Benton', N'KY', N'21157', N'42025', 36.864726, -88.367372, 1550, 117, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2239, N'Knox County Hospital', 1, NULL, NULL, N'181328', NULL, NULL, 0, 25, NULL, N'6065464175', N'6065455511', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'80 Hospital Drive', N'Barbourville', N'KY', N'21121', N'40906', 36.852146, -83.870388, 1492, 114, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2240, N'Saint Joseph Berea', 1, NULL, NULL, N'181329', NULL, NULL, 0, 25, NULL, N'8599866500', N'8599866768', 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'305 Estill Street', N'Berea', N'KY', N'21151', N'40403', 37.57346, -84.287578, 1494, 114, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2241, N'Russell County Hospital', 1, NULL, NULL, N'181330', NULL, NULL, 0, 25, NULL, N'2708664141', N'2708662136', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'153 Dowell Road', N'Russell Springs', N'KY', N'21207', N'42642', 37.057992, -85.066976, 1558, 115, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2242, N'Mcdowell Arh Hospital', 1, NULL, NULL, N'181331', NULL, NULL, 0, 25, NULL, N'6063773400', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'9879 Kentucky Route 122', N'Mc Dowell', N'KY', N'21071', N'41647', 37.572603, -85.155141, 1540, 114, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2243, N'Kindred Hospital Louisville', 1, NULL, NULL, N'182001', NULL, NULL, 0, 367, NULL, N'5025877001', N'5025870060', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1313 Saint Anthony Place', N'Louisville', N'KY', N'21111', N'40204', 38.242555, -85.73178, 1534, 115, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2244, N'Continuing Care Hosp At St Joseph East', 1, NULL, NULL, N'182002', NULL, NULL, 0, 57, NULL, N'8592684800', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'150 N Eagle Creek Dr 5Th Floor', N'Lexington', N'KY', N'21067', N'40509', 38.046407, -84.497039, 1531, 114, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2245, N'Select Specialty Hospital Lexington', 1, NULL, NULL, N'182003', NULL, NULL, 0, 41, NULL, N'8592267178', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'310 South Limestone Street 3Rd Floor', N'Lexington', N'KY', N'21067', N'40509', 38.046407, -84.497039, 1531, 114, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2246, N'Select Specialty Hospital-Northern Kentucky', 1, NULL, NULL, N'182004', NULL, NULL, 0, 33, NULL, N'8595723880', NULL, 1, 1, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'85 North Grand Avenue Three Center 3Rd Flr Center', N'Fort Thomas', N'KY', N'21037', N'41075', 39.078624, -84.448343, 1509, 113, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2247, N'Commonwealth Regional Specialty Hospital', 1, NULL, NULL, N'182005', NULL, NULL, 0, 28, NULL, N'2707966200', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'250 Park Drive 5Th Floor', N'Bowling Green', N'KY', N'21227', N'42101', 36.99032, -86.443602, 1495, 254, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2248, N'Oak Tree Hosp At Bapt Regional Med Ctr', 1, NULL, NULL, N'182006', NULL, NULL, 0, 32, NULL, N'6065235150', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'One Trillium Way Lower Level', N'Corbin', N'KY', N'21121', N'40701', 36.948699, -84.096876, 1502, 114, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2249, N'Cardinal Hill Rehabilitation Hospital', 1, NULL, NULL, N'183026', NULL, NULL, 0, 108, NULL, N'8592545701', NULL, 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2050 Versailles Road', N'Lexington', N'KY', N'21067', N'40504', 38.049427, -84.527049, 1531, 114, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2250, N'Healthsouth Northern Kentucky Rehabilitation Hospi', 1, NULL, NULL, N'183027', NULL, NULL, 0, 40, NULL, N'8593442044', NULL, 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'201 Medical Village Drive', N'Edgewood', N'KY', N'21117', N'41017', 39.01281, -84.565521, 1503, 113, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2251, N'Healthsouth Lakeview Rehab Hospital Of Central Ky', 1, NULL, NULL, N'183028', NULL, NULL, 0, 40, NULL, N'2707693100', N'2707696870', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'134 Heartland Drive', N'Elizabethtown', N'KY', N'21093', N'42701', 37.713083, -85.87547, 1506, 115, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2252, N'Southern Kentucky Rehabilitation Hospital', 1, NULL, NULL, N'183029', NULL, NULL, 0, 60, NULL, N'2707826900', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1300 Campbell Lane', N'Bowling Green', N'KY', N'21227', N'42104', 36.954765, -86.444866, 1495, 254, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2253, N'Gateway Rehabilitation Hospital At Florence', 1, NULL, NULL, N'183030', NULL, NULL, 0, 40, NULL, N'8594262400', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5940 Merchants Street', N'Florence', N'KY', N'21015', N'41042', 39.008648, -84.655025, 1508, 113, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2254, N'Shriners Hospital For Children', 1, NULL, NULL, N'183300', NULL, NULL, 0, 50, NULL, N'8592662101', N'8592685753', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1900 Richmond Road', N'Lexington', N'KY', N'21067', N'40502', 38.004813, -84.449597, 1531, 114, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2255, N'Western State Hospital', 1, NULL, NULL, N'184002', NULL, NULL, 0, 495, NULL, N'2708896025', N'2708864487', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2400 Russellville Road', N'Hopkinsville', N'KY', N'21047', N'42240', 36.863902, -87.454917, 1523, 254, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2256, N'Eastern State Hospital', 1, NULL, NULL, N'184004', NULL, NULL, 0, 323, NULL, N'8592468000', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1350 Bull Lea Road', N'Lexington', N'KY', N'21067', N'40511', 38.089179, -84.493678, 1531, 114, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2257, N'Northkey Community Care Children''s Intensive Serv', 1, NULL, NULL, N'184006', NULL, NULL, 0, 51, NULL, N'8595783252', N'8595783256', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'502 Farrell Drive', N'Covington', N'KY', N'21117', N'41011', 39.049142, -84.529041, 1503, 113, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2258, N'The Brook Hospital - Dupont', 1, NULL, NULL, N'184007', NULL, NULL, 0, 94, NULL, N'5028960495', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1405 Browns Lane', N'Louisville', N'KY', N'21111', N'40207', 38.235713, -85.627311, 1534, 115, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2259, N'The Brook Hospital - Kmi', 1, NULL, NULL, N'184008', NULL, NULL, 0, 94, NULL, N'5024266380', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'8521 Lagrange Road', N'Louisville', N'KY', N'21111', N'40242', 38.254238, -85.759407, 1534, 115, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2260, N'The Ridge Behavioral Health System', 1, NULL, NULL, N'184009', NULL, NULL, 0, 110, NULL, N'8592692325', N'8592686451', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3050 Rio Dosa Drive', N'Lexington', N'KY', N'21067', N'40509', 38.005006, -84.441484, 1531, 114, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2261, N'Lincoln Trail Behavioral Health System', 1, NULL, NULL, N'184012', NULL, NULL, 0, 140, NULL, N'2703519444', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3909 S Wilson Rd', N'Radcliff', N'KY', N'21093', N'40160', 37.789008, -85.912944, 1506, 115, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2262, N'Rivervalley Behavioral Health Hospital', 1, NULL, NULL, N'184013', NULL, NULL, 0, 80, NULL, N'2706896800', N'2706896701', 1, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'1000 Industrial Drive', N'Owensboro', N'KY', N'21059', N'42302', 37.773545, -87.157485, 1548, 116, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2263, N'Cumberland Hall', 1, NULL, NULL, N'184014', NULL, NULL, 0, 97, NULL, N'2708861919', N'2708861335', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'270 Walton Way', N'Hopkinsville', N'KY', N'21047', N'42240', 36.738307, -87.468636, 1523, 254, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2264, N'Central State Hospital', 1, NULL, NULL, N'184015', NULL, NULL, 0, 192, NULL, N'5022537045', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'10510 Lagrange Road', N'Louisville', N'KY', N'21111', N'40223', 38.254238, -85.759407, 1534, 115, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2265, N'Rivendell Behavioral Health Services', 1, NULL, NULL, N'184017', NULL, NULL, 0, 84, NULL, N'2708431199', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1035 Porter Pike', N'Bowling Green', N'KY', N'21227', N'42103', 36.99032, -86.443602, 1495, 254, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2266, N'Jewish Hospital And St Mary''s Healthcare', 1, NULL, NULL, N'189800', NULL, NULL, 0, 0, NULL, N'5025818687', N'5025874537', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'200 Abraham Flexner Way', N'Louisville', N'KY', N'21111', N'40202', 38.24917, -85.751246, 1534, 115, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2267, N'Kosair Childrens Hosp/Norton', 1, NULL, NULL, N'189801', NULL, NULL, 0, 0, NULL, N'5026292087', N'5026298047', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'231 East Chestnut St', N'Louisville', N'KY', N'21111', N'40202', 38.248448, -85.749737, 1534, 115, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2268, N'University Of Kentucky Chandler Hospital', 1, NULL, NULL, N'189802', NULL, NULL, 0, 0, NULL, N'8593235470', N'8593232044', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'800 Rose Street', N'Lexington', N'KY', N'21067', N'40536', 38.032772, -84.506765, 1531, 114, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2269, N'Lafayette General Medical Center', 1, NULL, NULL, N'190002', NULL, NULL, 0, 299, NULL, N'3372897991', N'3372898671', 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1214 Coolidge Avenue', N'Lafayette', N'LA', N'22055', N'70503', 30.22409, -92.019843, 1600, 121, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2270, N'Dauterive Hospital', 1, NULL, NULL, N'190003', NULL, NULL, 0, 103, NULL, N'3373657311', N'3373744104', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'600 North Lewis Street', N'New Iberia', N'LA', N'22045', N'70563', 30.008092, -91.795233, 1617, 121, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2271, N'Thibodaux Regional Medical Center', 1, NULL, NULL, N'190004', NULL, NULL, 0, 180, NULL, N'9854475500', N'9854465033', 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'602 N Acadia Road', N'Thibodaux', N'LA', N'22057', N'70301', 29.781409, -90.807613, 1632, 120, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2272, N'Charity Hospital & Medical Center Of Louisiana At', 1, NULL, NULL, N'190005', NULL, NULL, 0, 390, NULL, N'5049033000', N'5049032837', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2021 Perdido St', N'New Orleans', N'LA', N'22071', N'70112', 29.956224, -90.084955, 1618, 125, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2273, N'University Hospital & Clinics', 1, NULL, NULL, N'190006', NULL, NULL, 0, 116, NULL, N'3372616000', N'3372616003', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2390 West Congress', N'Lafayette', N'LA', N'22055', N'70506', 30.22409, -92.019843, 1600, 121, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2274, N'Natchitoches Regional Medical Center', 1, NULL, NULL, N'190007', NULL, NULL, 0, 96, NULL, N'3182144200', N'3182144354', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'501 Keyser Ave', N'Natchitoches', N'LA', N'22069', N'71457', 31.752553, -93.078621, 1616, 126, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2275, N'Terrebonne General Medical Center', 1, NULL, NULL, N'190008', NULL, NULL, 0, 321, NULL, N'9858734141', N'9858734640', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'8166 Main Street', N'Houma', N'LA', N'22109', N'70360', 29.598265, -90.709202, 1596, 120, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2276, N'University Health Conway', 1, NULL, NULL, N'190011', NULL, NULL, 0, 247, NULL, N'3183307000', N'3183307591', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4864 Jackson Street', N'Monroe', N'LA', N'22073', N'71202', 32.448174, -92.105246, 1613, 124, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2277, N'West Calcasieu Cameron Hospital', 1, NULL, NULL, N'190013', NULL, NULL, 0, 110, NULL, N'3375277034', N'3375274163', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'701 East Cypress Street', N'Sulphur', N'LA', N'22019', N'70663', 34.507867, -96.96835, 1630, 122, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2278, N'Teche Regional Medical Center', 1, NULL, NULL, N'190014', NULL, NULL, 0, 165, NULL, N'9853842200', N'9853804546', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1125 Marguerite Street', N'Morgan City', N'LA', N'22101', N'70380', 29.706607, -91.201413, 1614, 120, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2279, N'North Oaks Medical Center L L C', 1, NULL, NULL, N'190015', NULL, NULL, 0, 330, NULL, N'9853452700', N'9852306482', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'15790 Paul Vega Md Drive', N'Hammond', N'LA', N'22105', N'70403', 41.583366, -87.500043, 1594, 119, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2280, N'Opelousas General Health System', 1, NULL, NULL, N'190017', NULL, NULL, 0, 207, NULL, N'3379483011', N'3379485126', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'539 East Prudhomme Street', N'Opelousas', N'LA', N'22097', N'70570', 30.53353, -92.081509, 1622, 121, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2281, N'Christus St Frances Cabrini Hospital', 1, NULL, NULL, N'190019', NULL, NULL, 0, 283, NULL, N'3184871122', N'3184486754', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3330 Masonic Drive', N'Alexandria', N'LA', N'22079', N'71301', 31.271835, -92.468534, 1573, 118, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2282, N'Lane Regional Medical Center', 1, NULL, NULL, N'190020', NULL, NULL, 0, 140, NULL, N'2256584000', N'2256584287', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6300 Main Street', N'Zachary', N'LA', N'22033', N'70791', 30.648789, -91.122317, 1638, 119, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2283, N'Savoy Medical Center', 1, NULL, NULL, N'190025', NULL, NULL, 0, 180, NULL, N'3374685261', N'3374683342', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'801 Poinciana Avenue', N'Mamou', N'LA', N'22039', N'70554', 30.641065, -92.423158, 1606, 121, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2284, N'Rapides Regional Medical Center', 1, NULL, NULL, N'190026', NULL, NULL, 0, 328, NULL, N'3187693000', N'3187693929', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'211 4Th Street', N'Alexandria', N'LA', N'22079', N'71301', 31.314846, -92.450085, 1573, 118, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2285, N'Christus St Patrick Hospital', 1, NULL, NULL, N'190027', NULL, NULL, 0, 264, NULL, N'3374362511', N'3374917157', 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'524 Dr Michael Debakey Street', N'Lake Charles', N'LA', N'22019', N'70601', 30.226595, -93.217376, 1601, 122, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2286, N'Abbeville General Hospital', 1, NULL, NULL, N'190034', NULL, NULL, 0, 60, NULL, N'3378935466', N'3378932801', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'118 N Hospital Dr', N'Abbeville', N'LA', N'22113', N'70510', 29.97383, -92.106887, 1572, 121, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2287, N'Ochsner Medical Center', 1, NULL, NULL, N'190036', NULL, NULL, 0, 838, NULL, N'5048423000', N'5048423065', 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1516 Jefferson Hwy', N'New Orleans', N'LA', N'22051', N'70121', 29.949932, -90.070116, 1618, 125, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2288, N'West Jefferson Medical Center', 1, NULL, NULL, N'190039', NULL, NULL, 0, 435, NULL, N'5043475511', N'5043496299', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1101 Medical Center Blvd', N'Marrero', N'LA', N'22051', N'70072', 29.8924, -90.096186, 1609, 125, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2289, N'Slidell Memorial Hospital', 1, NULL, NULL, N'190040', NULL, NULL, 0, 229, NULL, N'9856432200', N'9856498626', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1001 Gause Blvd', N'Slidell', N'LA', N'22103', N'70458', 30.284657, -89.770188, 1628, 127, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2290, N'Christus Health Shreveport - Bossier', 1, NULL, NULL, N'190041', NULL, NULL, 0, 169, NULL, N'3186815000', N'3186815475', 1, 1, 0, 0, 1, 1, 0, 0, 0, 0, 0, 0, NULL, NULL, N'1453 E Bert Kouns Industrial Drive', N'Shreveport', N'LA', N'22017', N'71105', 32.522183, -93.765194, 1627, 126, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2291, N'Acadia General Hospital', 1, NULL, NULL, N'190044', NULL, NULL, 0, 140, NULL, N'3377833222', N'3377886413', 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1305 Crowley Rayne Highway', N'Crowley', N'LA', N'22001', N'70526', 39.409053, -123.425566, 1583, 121, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2292, N'St Tammany Parish Hospital', 1, NULL, NULL, N'190045', NULL, NULL, 0, 223, NULL, N'9858984000', N'9858984394', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1202 S Tyler Street', N'Covington', N'LA', N'22103', N'70433', 30.468493, -90.114165, 1582, 123, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2293, N'Touro Infirmary', 1, NULL, NULL, N'190046', NULL, NULL, 0, 360, NULL, N'5048977011', N'5048978769', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1401 Foucher Street', N'New Orleans', N'LA', N'22071', N'70115', 29.925647, -90.092282, 1618, 125, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2294, N'Beauregard Memorial Hospital', 1, NULL, NULL, N'190050', NULL, NULL, 0, 60, NULL, N'3374627100', N'3374627479', 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'600 S Pine Street', N'Deridder', N'LA', N'22011', N'70634', 30.843843, -93.289108, 1585, 122, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2295, N'Jennings American Legion Hospital', 1, NULL, NULL, N'190053', NULL, NULL, 0, 60, NULL, N'3376167000', N'3376167034', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1634 Elton Road', N'Jennings', N'LA', N'22053', N'70546', 30.243044, -92.663588, 1598, 121, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2296, N'Iberia General Hospital And Medical Center', 1, NULL, NULL, N'190054', NULL, NULL, 0, 99, NULL, N'3373640441', N'3373747641', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2315 E Main Street', N'New Iberia', N'LA', N'22045', N'70562', 29.990146, -91.788004, 1617, 121, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2297, N'Lake Charles Memorial Hospital', 1, NULL, NULL, N'190060', NULL, NULL, 0, 336, NULL, N'3374943200', N'3374943299', 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1701 Oak Park Blvd', N'Lake Charles', N'LA', N'22019', N'70601', 30.20339, -93.193541, 1601, 122, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2298, N'Our Lady Of The Lake Regional Medical Center', 1, NULL, NULL, N'190064', NULL, NULL, 0, 857, NULL, N'2257656565', N'2257658305', 1, 1, 0, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5000 Hennessy Blvd', N'Baton Rouge', N'LA', N'22033', N'70808', 30.40308, -91.10828, 1576, 119, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2299, N'Baton Rouge General Medical Center', 1, NULL, NULL, N'190065', NULL, NULL, 0, 590, NULL, N'2253877767', N'2253816129', 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3600 Florida Street', N'Baton Rouge', N'LA', N'22033', N'70806', 30.449398, -91.185857, 1576, 119, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2300, N'St Charles Parish Hospital', 1, NULL, NULL, N'190079', NULL, NULL, 0, 59, NULL, N'9857856242', N'9857853642', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1057 Paul Maillard Road', N'Luling', N'LA', N'22089', N'70070', 29.917978, -90.376615, 1604, 125, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2301, N'West Carroll Memorial Hospital', 1, NULL, NULL, N'190081', NULL, NULL, 0, 33, NULL, N'3184283237', N'3184283230', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'706 Ross Street', N'Oak Grove', N'LA', N'22123', N'71263', 32.868117, -91.383107, 1613, 124, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2302, N'Northern Louisiana Medical Center', 1, NULL, NULL, N'190086', NULL, NULL, 0, 159, NULL, N'3182542100', N'3182542728', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'401 East Vaughn Avenue', N'Ruston', N'LA', N'22061', N'71270', 32.515589, -92.633163, 1626, 126, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2303, N'Springhill Medical Center', 1, NULL, NULL, N'190088', NULL, NULL, 0, 60, NULL, N'3185391000', N'3185394085', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2001 Doctors Drive', N'Springhill', N'LA', N'22119', N'71075', 33.010694, -93.442782, 1629, 126, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2304, N'Winn Parish Medical Center', 1, NULL, NULL, N'190090', NULL, NULL, 0, 60, NULL, N'3186483000', N'3186282035', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'301 W Boundary Street', N'Winnfield', N'LA', N'22127', N'71483', 31.925441, -92.639593, 1636, 126, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2305, N'University Health Shreveport', 1, NULL, NULL, N'190098', NULL, NULL, 0, 452, NULL, N'3186755000', N'3186755666', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1541 Kings Highway', N'Shreveport', N'LA', N'22017', N'71103', 32.481645, -93.761587, 1627, 126, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2306, N'Avoyelles Hospital', 1, NULL, NULL, N'190099', NULL, NULL, 0, 55, NULL, N'3182538611', N'3182406077', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4231 Highway 1192', N'Marksville', N'LA', N'22009', N'71351', 31.127965, -92.066236, 1573, 118, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2307, N'Our Lady Of Lourdes Regional Medical Center Inc', 1, NULL, NULL, N'190102', NULL, NULL, 0, 267, NULL, N'3374702000', N'3374702574', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4801 Ambassador Caffery Parkway', N'Lafayette', N'LA', N'22055', N'70508', 30.150733, -92.037199, 1600, 121, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2308, N'Oakdale Community Hospital', 1, NULL, NULL, N'190106', NULL, NULL, 0, 60, NULL, N'3183353700', N'3182153024', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'130 N Hospital Dr', N'Oakdale', N'LA', N'22003', N'71463', 37.766595, -120.847154, 1620, 118, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2309, N'Willis Knighton Medical Center', 1, NULL, NULL, N'190111', NULL, NULL, 0, 720, NULL, N'3182124000', N'3182124956', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2600 Greenwood Road', N'Shreveport', N'LA', N'22017', N'71103', 32.484002, -93.778844, 1627, 126, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2310, N'Claiborne Memorial Medical Center', 1, NULL, NULL, N'190114', NULL, NULL, 0, 60, NULL, N'3189272024', N'3189279212', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'620 East College Street', N'Homer', N'LA', N'22027', N'71040', 59.644088, -151.540148, 1595, 126, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2311, N'Morehouse General Hospital', 1, NULL, NULL, N'190116', NULL, NULL, 0, 49, NULL, N'3182833600', N'3182833663', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'323 W Walnut', N'Bastrop', N'LA', N'22067', N'71220', 30.110495, -97.31527, 1575, 124, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2312, N'Desoto Regional Health System', 1, NULL, NULL, N'190118', NULL, NULL, 0, 38, NULL, N'3188724610', N'3188726134', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'207 Jefferson Street', N'Mansfield', N'LA', N'22031', N'71052', 32.035089, -93.708991, 1607, 126, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2313, N'St Francis Medical Center', 1, NULL, NULL, N'190125', NULL, NULL, 0, 550, NULL, N'3189664000', N'3189664142', 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'309 Jackson Street', N'Monroe', N'LA', N'22073', N'71201', 32.50004, -92.114863, 1613, 124, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2314, N'Woman''s Hospital', 1, NULL, NULL, N'190128', NULL, NULL, 0, 168, NULL, N'2259271300', N'2259248777', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'100 Woman''s Way', N'Baton Rouge', N'LA', N'22033', N'70817', 30.383889, -91.03696, 1576, 119, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2315, N'Allen Parish Hospital', 1, NULL, NULL, N'190133', NULL, NULL, 0, 49, NULL, N'3377382527', N'3377385305', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'108 6Th Avenue', N'Kinder', N'LA', N'22003', N'70648', 30.49143, -92.856859, 1601, 122, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2316, N'Franklin Medical Center', 1, NULL, NULL, N'190140', NULL, NULL, 0, 39, NULL, N'3184359411', N'3184353842', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2106 Loop Road', N'Winnsboro', N'LA', N'22041', N'71295', 32.159134, -91.705338, 1637, 124, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2317, N'Minden Medical Center', 1, NULL, NULL, N'190144', NULL, NULL, 0, 161, NULL, N'3183772321', N'3183715606', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'No 1 Medical Plaza', N'Minden', N'LA', N'22119', N'71055', 52.288105, 8.916885, 1612, 126, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2318, N'Lasalle General Hospital', 1, NULL, NULL, N'190145', NULL, NULL, 0, 49, NULL, N'3189929200', N'3189929245', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'187 Ninth St/Hwy 84 West', N'Jena', N'LA', N'22059', N'71342', 50.93314, 11.583309, 1597, 118, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2319, N'East Jefferson General Hospital', 1, NULL, NULL, N'190146', NULL, NULL, 0, 407, NULL, N'5044544000', N'5044545591', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4200 Houma Blvd', N'Metairie', N'LA', N'22051', N'70006', 30.000894, -90.178977, 1611, 123, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2320, N'Richardson Medical Center', 1, NULL, NULL, N'190151', NULL, NULL, 0, 38, NULL, N'3187284181', N'3187288107', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'254 Highway 3048', N'Rayville', N'LA', N'22083', N'71269', 39.649271, -76.700806, 1625, 124, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2321, N'Glenwood Regional Medical Center', 1, NULL, NULL, N'190160', NULL, NULL, 0, 268, NULL, N'3183294600', N'3183294710', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'503 Mcmillan Road', N'West Monroe', N'LA', N'22073', N'71291', 32.514627, -92.152467, 1635, 124, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2322, N'Byrd Regional Hospital', 1, NULL, NULL, N'190164', NULL, NULL, 0, 60, NULL, N'3372399041', N'3372395360', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1020 Fertitta Blvd', N'Leesville', N'LA', N'22115', N'71446', 31.13726, -93.266139, 1603, 118, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2323, N'Mercy Regional Medical Center', 1, NULL, NULL, N'190167', NULL, NULL, 0, 109, NULL, N'3373635684', N'3373639488', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'800 E Main', N'Ville Platte', N'LA', N'22039', N'70586', 30.687975, -92.271516, 1633, 121, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2324, N'River Parishes Hospital', 1, NULL, NULL, N'190175', NULL, NULL, 0, 80, NULL, N'9856527000', N'9856525161', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'500 Rue De Sante', N'Laplace', N'LA', N'22095', N'70068', 48.836831, 2.341893, 1602, 123, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2325, N'Tulane Medical Center', 1, NULL, NULL, N'190176', NULL, NULL, 0, 339, NULL, N'5049881900', N'5049882316', 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1415 Tulane Ave', N'New Orleans', N'LA', N'22071', N'70112', 29.955461, -90.076017, 1618, 125, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2326, N'Lakeview Regional Medical Center', 1, NULL, NULL, N'190177', NULL, NULL, 0, 167, NULL, N'9858674443', N'9858674449', 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'95 Judge Tanner Boulevard', N'Covington', N'LA', N'22103', N'70433', 39.083749, -84.508622, 1582, 123, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2327, N'Leonard J Chabert Medical Center', 1, NULL, NULL, N'190183', NULL, NULL, 0, 156, NULL, N'9858731285', N'9858731262', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1978 Industrial Blvd', N'Houma', N'LA', N'22109', N'70363', 29.59577, -90.719535, 1596, 120, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2328, N'Citizens Medical Center', 1, NULL, NULL, N'190184', NULL, NULL, 0, 40, NULL, N'3186496106', N'3186492080', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7939 U S Hwy 165 South', N'Columbia', N'LA', N'22021', N'71418', 34.000749, -81.034331, 1581, 124, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2329, N'Caldwell Memorial Hospital', 1, NULL, NULL, N'190190', NULL, NULL, 0, 47, NULL, N'3186496111', N'3186495094', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'411 Main Street', N'Columbia', N'LA', N'22021', N'71418', 32.105139, -92.075368, 1581, 124, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2330, N'Villa Feliciana Medical Complex', 1, NULL, NULL, N'190199', NULL, NULL, 0, 297, NULL, N'2256344010', N'2256344191', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5002 Highway 10', N'Jackson', N'LA', N'22037', N'70748', 32.410438, -90.162065, 1638, 119, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2331, N'Lake Area Medical Center', 1, NULL, NULL, N'190201', NULL, NULL, 0, 88, NULL, N'3374746370', N'3374754143', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4200 Nelson Road', N'Lake Charles', N'LA', N'22019', N'70605', 30.180638, -93.249401, 1601, 122, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2332, N'Ochsner Medical Center - Baton Rouge', 1, NULL, NULL, N'190202', NULL, NULL, 0, 150, NULL, N'2257554876', N'2257554883', 1, 1, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'17000 Medical Center Dr', N'Baton Rouge', N'LA', N'22033', N'70816', 30.440976, -91.001498, 1576, 119, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2333, N'Ochsner Medical Center - Northshore L L C', 1, NULL, NULL, N'190204', NULL, NULL, 0, 165, NULL, N'9856497070', N'9856465552', 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'100 Medical Center Drive', N'Slidell', N'LA', N'22103', N'70461', 30.286254, -89.743049, 1628, 127, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2334, N'The Regional Medical Center Of Acadiana', 1, NULL, NULL, N'190205', NULL, NULL, 0, 241, NULL, N'3379812949', N'3379896703', 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2810 Ambassador Caffery Parkway', N'Lafayette', N'LA', N'22055', N'70506', 30.19809, -92.075351, 1600, 121, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2335, N'East Carroll Parish Hospital', 1, NULL, NULL, N'190208', NULL, NULL, 0, 23, NULL, N'3185594023', N'3185593761', 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'336 North Hood Street', N'Lake Providence', N'LA', N'22035', N'71254', 32.816902, -91.173297, 1613, 124, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2336, N'Sabine Medical Center', 1, NULL, NULL, N'190218', NULL, NULL, 0, 48, NULL, N'3182561232', N'3182561298', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'240 Highland Drive', N'Many', N'LA', N'22085', N'71449', 31.561403, -93.471653, 1608, 126, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2337, N'Willis Knighton Bossier Health Center', 1, NULL, NULL, N'190236', NULL, NULL, 0, 166, NULL, N'3182127000', N'3182127005', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2400 Hospital Dr', N'Bossier City', N'LA', N'22015', N'71111', 32.549943, -93.700959, 1627, 126, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2338, N'Physicians Medical Center', 1, NULL, NULL, N'190241', NULL, NULL, 0, 10, NULL, N'9858531390', N'9858577440', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'218 Corporate Drive', N'Houma', N'LA', N'22109', N'70360', 29.59577, -90.719535, 1596, 120, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2339, N'St Elizabeth Hospital', 1, NULL, NULL, N'190242', NULL, NULL, 0, 95, NULL, N'2256475000', N'2256479806', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1125 West Highway 30', N'Gonzales', N'LA', N'22005', N'70737', 29.501626, -97.452493, 1592, 119, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2340, N'Monroe Surgical Hospital', 1, NULL, NULL, N'190245', NULL, NULL, 0, 10, NULL, N'3184100002', N'3184101960', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2408 Broadmoor Blvd', N'Monroe', N'LA', N'22073', N'71201', 32.536407, -92.100248, 1613, 124, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2341, N'P & S Surgical Hospital', 1, NULL, NULL, N'190246', NULL, NULL, 0, 22, NULL, N'3183884040', N'3183884099', 1, 0, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'312 Grammont St Suite 101', N'Monroe', N'LA', N'22073', N'71201', 32.509311, -92.119301, 1613, 124, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2342, N'Louisiana Heart Hospital', 1, NULL, NULL, N'190250', NULL, NULL, 0, 136, NULL, N'9856407500', N'9856407530', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'64030 Highway 434', N'Lacombe', N'LA', N'22103', N'70445', 30.299093, -89.944152, 1628, 127, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2343, N'Surgical Specialty Center Of Baton Rouge', 1, NULL, NULL, N'190251', NULL, NULL, 0, 16, NULL, N'2254085730', N'2254085569', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'8080 Bluebonnet Blvd', N'Baton Rouge', N'LA', N'22033', N'70810', 30.374813, -91.099852, 1576, 119, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2344, N'Park Place Surgical Hospital', 1, NULL, NULL, N'190255', NULL, NULL, 0, 10, NULL, N'3372378119', N'3372674182', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4811 Ambassador Caffery Parkway', N'Lafayette', N'LA', N'22055', N'70508', 30.153149, -92.044269, 1600, 121, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2345, N'Sterling Surgical Hospital', 1, NULL, NULL, N'190256', NULL, NULL, 0, 10, NULL, N'5046908200', N'9856908259', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'989 Robert Blvd', N'Slidell', N'LA', N'22103', N'70458', 30.291807, -89.768554, 1628, 127, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2346, N'Green Clinic Surgical Hospital', 1, NULL, NULL, N'190257', NULL, NULL, 0, 12, NULL, N'3182327700', N'3182321092', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1118 Farmerville Street', N'Ruston', N'LA', N'22061', N'71270', 32.523205, -92.637927, 1626, 126, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2347, N'Lafayette Surgical Specialty Hospital', 1, NULL, NULL, N'190259', NULL, NULL, 0, 20, NULL, N'3377694100', N'3377694209', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1101 Kaliste Saloom Rd', N'Lafayette', N'LA', N'22055', N'70508', 30.177346, -92.027382, 1600, 121, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2348, N'Ouachita Community Hospital', 1, NULL, NULL, N'190261', NULL, NULL, 0, 10, NULL, N'3183221339', N'3183221693', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1275 Glennwood Drive', N'West Monroe', N'LA', N'22073', N'71291', 32.518478, -92.147635, 1635, 124, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2349, N'Heart Hospital Of Lafayette', 1, NULL, NULL, N'190263', NULL, NULL, 0, 32, NULL, N'3375211000', N'3375211006', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1105 Kaliste Saloom Road', N'Lafayette', N'LA', N'22055', N'70508', 30.177362, -92.027374, 1600, 121, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2350, N'The Neuromedical Center Hospital', 1, NULL, NULL, N'190266', NULL, NULL, 0, 23, NULL, N'2257639900', N'2259064818', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'10105 Park Row Circle', N'Baton Rouge', N'LA', N'22033', N'70810', 30.450746, -91.154551, 1576, 119, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2351, N'Fairway Medical Center', 1, NULL, NULL, N'190267', NULL, NULL, 0, 21, NULL, N'9858013010', N'9858013099', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'67252 Industry Lane', N'Covington', N'LA', N'22103', N'70433', 39.083749, -84.508622, 1582, 123, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2352, N'Lafayette General Surgical Hospital', 1, NULL, NULL, N'190268', NULL, NULL, 0, 10, NULL, N'3372898095', N'3372898059', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1000 W Pinhook Rd Suite 100', N'Lafayette', N'LA', N'22055', N'70503', 30.22409, -92.019843, 1600, 121, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2353, N'Southern Surgical Hospital', 1, NULL, NULL, N'190270', NULL, NULL, 0, 37, NULL, N'9856410600', N'9856437677', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1700 W Lindberg Drive', N'Slidell', N'LA', N'22103', N'70458', 30.275195, -89.781174, 1628, 127, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2354, N'Ochsner Medical Center-Kenner Llc', 1, NULL, NULL, N'190274', NULL, NULL, 0, 110, NULL, N'5044648065', N'5044648062', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'180 West Esplanade Avenue', N'Kenner', N'LA', N'22051', N'70065', 30.01921, -90.229393, 1611, 123, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2355, N'Specialists Hospital Shreveport', 1, NULL, NULL, N'190278', NULL, NULL, 0, 15, NULL, N'3182133800', N'3182133801', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1500 Line Avenue', N'Shreveport', N'LA', N'22017', N'71101', 32.498025, -93.746142, 1627, 126, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2356, N'Doctors Hospital At Deer Creek Llc', 1, NULL, NULL, N'190297', NULL, NULL, 0, 10, NULL, N'3373925088', N'3373924983', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'815 South 10Th Street', N'Leesville', N'LA', N'22115', N'71446', 31.136525, -93.269636, 1603, 118, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2357, N'Central Louisiana Surgical Hospital', 1, NULL, NULL, N'190298', NULL, NULL, 0, 24, NULL, N'3184496400', N'3184277930', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'651 North Bolton Ave', N'Alexandria', N'LA', N'22079', N'71301', 31.314476, -92.466492, 1573, 118, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2358, N'St Charles Surgical Hospital Llc', 1, NULL, NULL, N'190300', NULL, NULL, 0, 39, NULL, N'5045296600', N'5045296672', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1717 St Charles Ave', N'New Orleans', N'LA', N'22071', N'70130', 29.937301, -90.077104, 1618, 125, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2359, N'Omega Hospital Llc', 1, NULL, NULL, N'190302', NULL, NULL, 0, 16, NULL, N'5048494900', N'5048494868', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2525 Severn Avenue', N'Metairie', N'LA', N'22051', N'70002', 29.998426, -90.159499, 1611, 123, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2360, N'Cypress Pointe Surgical Hospital', 1, NULL, NULL, N'190303', NULL, NULL, 0, 30, NULL, N'9855106200', N'9855106202', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'42570 South Airport Rd', N'Hammond', N'LA', N'22105', N'70403', 41.583366, -87.500043, 1594, 119, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2361, N'Iberia Rehabilitation Hospital', 1, NULL, NULL, N'190304', NULL, NULL, 0, 24, NULL, N'3373646923', N'3376080361', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'532 Jefferson Terrace Street', N'New Iberia', N'LA', N'22045', N'70560', 30.003537, -91.818728, 1617, 121, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2362, N'South Cameron Memorial Hospital', 1, NULL, NULL, N'190307', NULL, NULL, 0, 49, NULL, N'3375424111', N'3375424110', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5360 West Creole Hwy', N'Cameron', N'LA', N'22023', N'70631', 29.807316, -93.164546, 1601, 122, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2363, N'St Bernard Parish Hospital', 1, NULL, NULL, N'190308', NULL, NULL, 0, 40, NULL, N'5048269500', N'5043091715', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'8000 West Judge Perez Drive', N'Chalmette', N'LA', N'22087', N'70043', 29.954133, -89.980432, 1580, 125, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2364, N'Our Lady Of The Angels Hospital', 1, NULL, NULL, N'190312', NULL, NULL, 0, 80, NULL, N'9857306706', N'9857306709', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'433 Plaza Street', N'Bogalusa', N'LA', N'22117', N'70427', 30.778873, -89.868363, 1578, 123, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2365, N'New Orleans East Hospital', 1, NULL, NULL, N'190313', NULL, NULL, 0, 80, NULL, N'5042412664', N'5042455857', 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5620 Read Blvd', N'New Orleans', N'LA', N'22071', N'70127', 30.031252, -89.972099, 1618, 125, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2366, N'St Helena Parish Hospital Cah', 1, NULL, NULL, N'191300', NULL, NULL, 0, 25, NULL, N'2252226111', N'2252224819', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'16874 Highway 43', N'Greensburg', N'LA', N'22091', N'70441', 40.301458, -79.538929, 1593, 119, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2367, N'Union General Hospital', 1, NULL, NULL, N'191301', NULL, NULL, 0, 25, NULL, N'3183689751', N'3183688270', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'901 James Ave', N'Farmerville', N'LA', N'22111', N'71241', 32.786497, -92.392189, 1613, 124, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2368, N'St Martin Hospital', 1, NULL, NULL, N'191302', NULL, NULL, 0, 25, NULL, N'3373322178', N'3373325092', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'210 Champagne Boulevard', N'Breaux Bridge', N'LA', N'22099', N'70517', 30.282681, -91.890587, 1600, 121, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2369, N'Assumption Community Hospital', 1, NULL, NULL, N'191303', NULL, NULL, 0, 15, NULL, N'9853693600', N'9853694236', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'135 Highway 402', N'Napoleonville', N'LA', N'22007', N'70390', 29.94048, -91.024821, 1615, 120, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2370, N'North Caddo Medical Center', 1, NULL, NULL, N'191304', NULL, NULL, 0, 25, NULL, N'3183753235', N'3183752440', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1000 South Spruce St', N'Vivian', N'LA', N'22017', N'71082', 32.86262, -93.989579, 1634, 126, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2371, N'St James Parish Hospital', 1, NULL, NULL, N'191305', NULL, NULL, 0, 25, NULL, N'2258695512', N'2258695271', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1645 Lutcher Avenue', N'Lutcher', N'LA', N'22093', N'70071', 30.050671, -90.701314, 1605, 123, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2372, N'West Feliciana Parish Hospital', 1, NULL, NULL, N'191306', NULL, NULL, 0, 22, NULL, N'2256353811', N'2256352442', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5266 Commerce Street', N'Saint Francisville', N'LA', N'22125', N'70775', 30.783038, -91.377982, 1576, 119, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2373, N'Dequincy Memorial Hospital', 1, NULL, NULL, N'191307', NULL, NULL, 0, 25, NULL, N'3377861200', N'3377861219', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'110 West 4Th Street', N'Dequincy', N'LA', N'22019', N'70633', 30.451921, -93.43697, 1584, 122, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2374, N'Prevost Memorial Hospital', 1, NULL, NULL, N'191308', NULL, NULL, 0, 25, NULL, N'2254737931', N'2254742138', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'301 Memorial Dr', N'Donaldsonville', N'LA', N'22005', N'70346', 30.089566, -91.003469, 1576, 119, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2375, N'Hood Memorial Hospital', 1, NULL, NULL, N'191309', NULL, NULL, 0, 25, NULL, N'9857489485', N'9857488144', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'301 W Walnut Street', N'Amite', N'LA', N'22105', N'70422', 31.199093, -91.02319, 1574, 119, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2376, N'Franklin Foundation Hospital', 1, NULL, NULL, N'191310', NULL, NULL, 0, 22, NULL, N'3378280760', N'3378285024', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1097 Northwest Blvd', N'Franklin', N'LA', N'22101', N'70538', 29.80103, -91.526395, 1589, 121, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2377, N'Bunkie General Hospital', 1, NULL, NULL, N'191311', NULL, NULL, 0, 25, NULL, N'3183466681', N'3183466780', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'427 Evergreen Street', N'Bunkie', N'LA', N'22009', N'71322', 30.951476, -92.172992, 1579, 118, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2378, N'Christus Coushatta Health Care Center', 1, NULL, NULL, N'191312', NULL, NULL, 0, 25, NULL, N'3189322000', N'3189322198', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1635 Marvel Street', N'Coushatta', N'LA', N'22081', N'71019', 32.020819, -93.34436, 1627, 126, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2379, N'Riverside Medical Center', 1, NULL, NULL, N'191313', NULL, NULL, 0, 25, NULL, N'9857954431', N'9858390319', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1900 South Main St', N'Franklinton', N'LA', N'22117', N'70438', 30.847128, -90.153141, 1590, 123, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2380, N'Madison Parish Hospital', 1, NULL, NULL, N'191314', NULL, NULL, 0, 25, NULL, N'3186515601', N'3185742396', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'900 Johnson Street', N'Tallulah', N'LA', N'22065', N'71282', 32.402515, -91.184783, 1631, 158, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2381, N'Hardtner Medical Center', 1, NULL, NULL, N'191315', NULL, NULL, 0, 35, NULL, N'3184953131', N'3184953229', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1102 N Pine Road', N'Olla', N'LA', N'22059', N'71465', 8.210944, 5.181528, 1621, 118, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2382, N'Pointe Coupee General Hospital', 1, NULL, NULL, N'191316', NULL, NULL, 0, 25, NULL, N'2253686386', N'2256385846', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2202 False River Drive', N'New Roads', N'LA', N'22077', N'70760', 30.683355, -91.459639, 1619, 119, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2383, N'Jackson Parish Hospital', 1, NULL, NULL, N'191317', NULL, NULL, 0, 25, NULL, N'3182594435', N'3183954259', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'165 Beech Springs Road', N'Jonesboro', N'LA', N'22049', N'71251', 33.521501, -84.353813, 1626, 126, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2384, N'Riverland Medical Center', 1, NULL, NULL, N'191318', NULL, NULL, 0, 25, NULL, N'3187576551', N'3187573467', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1700  Wallace Blvd', N'Ferriday', N'LA', N'22029', N'71334', 31.630166, -91.554565, 1588, 118, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2385, N'Acadia St Landry', 1, NULL, NULL, N'191319', NULL, NULL, 0, 33, NULL, N'3376845435', N'3376841175', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'810 South Broadway Street', N'Church Point', N'LA', N'22001', N'70525', 30.393872, -92.210741, 1600, 121, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2386, N'Bienville Medical Center', 1, NULL, NULL, N'191320', NULL, NULL, 0, 21, NULL, N'3182634700', N'3182639243', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1175 Pine Street', N'Arcadia', N'LA', N'22013', N'71001', 32.55266, -92.916208, 1626, 126, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2387, N'Lallie Kemp Medical Center', 1, NULL, NULL, N'191321', NULL, NULL, 0, 24, NULL, N'9858789421', N'9858781306', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'52579 Highway 51 South', N'Independence', N'LA', N'22105', N'70443', 37.224236, -95.708313, 1594, 119, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2388, N'Abrom Kaplan Memorial Hospital', 1, NULL, NULL, N'191322', NULL, NULL, 0, 35, NULL, N'3376438300', N'3376435233', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1310 West Seventh Street', N'Kaplan', N'LA', N'22113', N'70548', 40.225166, 31.810249, 1599, 121, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2389, N'Richland Parish Hospital-Delhi', 1, NULL, NULL, N'191323', NULL, NULL, 0, 25, NULL, N'3188785171', N'3188786427', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'407 Cincinnati Street', N'Delhi', N'LA', N'22083', N'71232', 32.453746, -91.493965, 1586, 124, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2390, N'Ochsner St Anne General Hospital', 1, NULL, NULL, N'191324', NULL, NULL, 0, 33, NULL, N'9855378377', N'9855378272', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4608 Highway 1', N'Raceland', N'LA', N'22057', N'70394', 38.54008, -82.728498, 1624, 120, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2391, N'Lady Of The Sea General Hospital', 1, NULL, NULL, N'191325', NULL, NULL, 0, 25, NULL, N'9856326401', N'9856328263', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'200 West 134Th Place', N'Cut Off', N'LA', N'22057', N'70345', 29.542717, -90.338136, 1591, 120, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2392, N'Reeves Memorial Medical Center', 1, NULL, NULL, N'191326', NULL, NULL, 0, 15, NULL, N'3182859066', N'3182859036', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'409 First Street', N'Bernice', N'LA', N'22111', N'71222', 37.207034, -83.75353, 1577, 126, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2393, N'Promise Hospital Baton Rouge', 1, NULL, NULL, N'192004', NULL, NULL, 0, 54, NULL, N'2254909637', N'2254909693', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5130 Mancuso Lane', N'Baton Rouge', N'LA', N'22033', N'70809', 30.397184, -91.102004, 1576, 119, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2394, N'Cornerstone Hospital Of Bossier City', 1, NULL, NULL, N'192006', NULL, NULL, 0, 62, NULL, N'3187479500', N'3187477878', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4900 Medical Drive', N'Bossier City', N'LA', N'22015', N'71112', 32.463457, -93.666512, 1627, 126, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2395, N'Louisiana Continuing Care Hospital', 1, NULL, NULL, N'192007', NULL, NULL, 0, 44, NULL, N'5043492584', N'5043491287', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1101 Medical Center Blvd 7Th Floor', N'Marrero', N'LA', N'22051', N'70072', 29.899372, -90.100351, 1609, 125, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2396, N'Denham Springs - A M G Specialty Hospital', 1, NULL, NULL, N'192008', NULL, NULL, 0, 59, NULL, N'2256652664', N'2256650736', 1, 0, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'8375 Florida Blvd', N'Denham Springs', N'LA', N'22063', N'70726', 30.483661, -90.906084, 1576, 119, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2397, N'Kindred Hospital New Orleans', 1, NULL, NULL, N'192009', NULL, NULL, 0, 168, NULL, N'5047625100', N'5047625506', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3601 Coliseum Street', N'New Orleans', N'LA', N'22071', N'70115', 29.924931, -90.093131, 1618, 125, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2398, N'Promise Hospital Of Louisiana Inc', 1, NULL, NULL, N'192010', NULL, NULL, 0, 196, NULL, N'3184254096', N'3184242627', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1800 Irving Place', N'Shreveport', N'LA', N'22017', N'71101', 32.494375, -93.744595, 1627, 126, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2399, N'Lifecare Hospitals Of Shreveport', 1, NULL, NULL, N'192011', NULL, NULL, 0, 119, NULL, N'3186888504', N'3186716859', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'9320 Linwood Avenue', N'Shreveport', N'LA', N'22017', N'71106', 32.399539, -93.763484, 1627, 126, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2400, N'Christus Dubuis Hospital Of Alexandria', 1, NULL, NULL, N'192012', NULL, NULL, 0, 25, NULL, N'3184484960', N'3184834033', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3330 Masonic Dr', N'Alexandria', N'LA', N'22079', N'71301', 31.271835, -92.468534, 1573, 118, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2401, N'Cornerstone Hospital Of Southwest La', 1, NULL, NULL, N'192013', NULL, NULL, 0, 30, NULL, N'3373106000', N'3373106049', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'703 Cypress Street', N'Sulphur', N'LA', N'22019', N'70663', 30.230984, -93.365113, 1630, 122, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2402, N'Ochsner Extended Care Hospital Of Kenner', 1, NULL, NULL, N'192015', NULL, NULL, 0, 32, NULL, N'5044648590', N'5044648675', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'180 West Esplanade Fifth Floor', N'Kenner', N'LA', N'22051', N'70065', 29.994092, -90.241743, 1611, 123, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2403, N'Specialty Hospital', 1, NULL, NULL, N'192016', NULL, NULL, 0, 32, NULL, N'3189664126', N'3189667031', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'309 Jackson Street 7Th Floor', N'Monroe', N'LA', N'22073', N'71201', 32.509311, -92.119301, 1613, 124, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2404, N'Extended Care Of Southwest Louisiana', 1, NULL, NULL, N'192019', NULL, NULL, 0, 29, NULL, N'3374808990', N'3374391133', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2837 Ernest Bldg B', N'Lake Charles', N'LA', N'22019', N'70601', 30.226595, -93.217376, 1601, 122, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2405, N'Community Rehabilitation Hospital Of Lafayette', 1, NULL, NULL, N'192020', NULL, NULL, 0, 22, NULL, N'3372344031', N'3374565630', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'408 Se Evangeline Thruway', N'Lafayette', N'LA', N'22055', N'70501', 30.219125, -92.00634, 1600, 121, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2406, N'Lifecare Specialty Hospital Of North Louisiana', 1, NULL, NULL, N'192022', NULL, NULL, 0, 55, NULL, N'3182513126', N'3182511594', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1401 Ezell Street', N'Ruston', N'LA', N'22061', N'71270', 32.523205, -92.637927, 1626, 126, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2407, N'St Catherine Memorial Hospital', 1, NULL, NULL, N'192023', NULL, NULL, 0, 21, NULL, N'5042103000', N'5042103006', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'14500 Hayne Blvd', N'New Orleans', N'LA', N'22071', N'70128', 30.071009, -89.947607, 1618, 125, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2408, N'Promise Hospital Of Miss Lou', 1, NULL, NULL, N'192028', NULL, NULL, 0, 40, NULL, N'3183366500', N'3183366676', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'209 Front Street', N'Vidalia', N'LA', N'22029', N'71373', 32.217686, -82.413461, 2040, 158, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2409, N'Lafayette - A M G Specialty Hospital', 1, NULL, NULL, N'192029', NULL, NULL, 0, 58, NULL, N'3378399880', N'3377692021', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'310 Youngsville Hwy', N'Lafayette', N'LA', N'22055', N'70508', 30.155676, -91.991128, 1600, 121, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2410, N'St Theresa Specialty Hospital Llc', 1, NULL, NULL, N'192030', NULL, NULL, 0, 73, NULL, N'5049047600', N'5049047601', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3601 Loyola Drive', N'Kenner', N'LA', N'22051', N'70065', 30.026028, -90.269143, 1611, 123, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2411, N'Cornerstone Hospital West Monroe', 1, NULL, NULL, N'192031', NULL, NULL, 0, 47, NULL, N'3183965600', N'3183962999', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6198 Cypress Street', N'West Monroe', N'LA', N'22073', N'71291', 32.513982, -92.176336, 1635, 124, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2412, N'Louisiana Extended Care Hospital Of Lafayette', 1, NULL, NULL, N'192032', NULL, NULL, 0, 76, NULL, N'3372898180', N'3372898181', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1214 Coolidge Blvd 9Th & 10Th Floors', N'Lafayette', N'LA', N'22055', N'70503', 30.22409, -92.019843, 1600, 121, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2413, N'Post Acute Specialty Hospital Of Lafayette', 1, NULL, NULL, N'192033', NULL, NULL, 0, 50, NULL, N'3372321905', N'3372611726', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'204 Energy Parkway', N'Lafayette', N'LA', N'22055', N'70508', 30.179142, -92.009937, 1600, 121, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2414, N'St Landry Extended Care Hospital', 1, NULL, NULL, N'192034', NULL, NULL, 0, 59, NULL, N'3379485184', N'3379483294', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3983 I-49 South Service Rd 2Nd Floor', N'Opelousas', N'LA', N'22097', N'70570', 30.53353, -92.081509, 1622, 121, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2415, N'Louisiana Extended Care Hospital Of Natchitoches', 1, NULL, NULL, N'192035', NULL, NULL, 0, 21, NULL, N'3183542044', N'3183542041', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'501 Keyser Ave 4Th Floor', N'Natchitoches', N'LA', N'22069', N'71457', 31.760673, -93.086021, 1616, 126, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2416, N'Post Acute Specialty Hospital Of Hammond', 1, NULL, NULL, N'192036', NULL, NULL, 0, 40, NULL, N'9859028148', N'9859029148', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'42074 Veterans Avenue', N'Hammond', N'LA', N'22105', N'70403', 30.474911, -90.457242, 1594, 119, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2417, N'Houma - Amg Specialty Hospital', 1, NULL, NULL, N'192037', NULL, NULL, 0, 40, NULL, N'9852740001', N'9852740003', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'629 Dunn Street', N'Houma', N'LA', N'22109', N'70360', 29.593161, -90.712203, 1596, 120, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2418, N'Southeast Regional Medical Center Inc', 1, NULL, NULL, N'192040', NULL, NULL, 0, 14, NULL, N'9852299193', N'9852299180', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'719 Avenue G', N'Kentwood', N'LA', N'22105', N'70444', 30.936796, -90.520417, 1594, 119, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2419, N'Feliciana - A M G Specialty Hospital', 1, NULL, NULL, N'192041', NULL, NULL, 0, 16, NULL, N'2256831600', N'2256861616', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'9725 Grace Lane', N'Clinton', N'LA', N'22037', N'70722', 35.615556, -92.485685, 1638, 119, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2420, N'Riverside Hospital Of Louisiana Inc', 1, NULL, NULL, N'192043', NULL, NULL, 0, 28, NULL, N'3187672900', N'3187672902', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'211 Fourth St Fifth Floor', N'Alexandria', N'LA', N'22079', N'71301', 31.199004, 29.894379, 1573, 118, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2421, N'Slidell - A M G Specialty Hospital', 1, NULL, NULL, N'192046', NULL, NULL, 0, 40, NULL, N'9853260440', N'9853260559', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1400 Lindberg Drive', N'Slidell', N'LA', N'22103', N'70458', 30.276889, -89.752937, 1628, 127, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2422, N'Northshore Specialty Hospital', 1, NULL, NULL, N'192048', NULL, NULL, 0, 58, NULL, N'9858757525', N'9858751934', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'20050 Crestwood Blvd', N'Claiborne', N'LA', N'22103', N'70433', 38.159854, -77.455539, 1582, 123, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2423, N'Promise Hospital Of Baton Rouge Inc', 1, NULL, NULL, N'192049', NULL, NULL, 0, 57, NULL, N'2252365440', N'2252365441', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'17000 Medical Center Dr 3Rd Floor', N'Baton Rouge', N'LA', N'22033', N'70816', 30.450746, -91.154551, 1576, 119, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2424, N'Kailo L T A C Hospital L  L C', 1, NULL, NULL, N'192050', NULL, NULL, 0, 15, NULL, N'3377832859', N'3377832891', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'713 North Avenue L', N'Crowley', N'LA', N'22001', N'70526', 30.219219, -92.368337, 1583, 121, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2425, N'Regency Hospital Of Covington', 1, NULL, NULL, N'192051', NULL, NULL, 0, 38, NULL, N'9858673977', N'9858673979', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'195 Highland Park Entrance', N'Covington', N'LA', N'22103', N'70433', 39.083749, -84.508622, 1582, 123, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2426, N'Speciality Hospital Of Winnfield Inc', 1, NULL, NULL, N'192052', NULL, NULL, 0, 20, NULL, N'3186483523', N'3182515343', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'915 1St Street', N'Winnfield', N'LA', N'22127', N'71483', 31.932084, -92.632039, 1636, 126, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2427, N'Louisiana Extended Care Hospital Of West Monroe', 1, NULL, NULL, N'192055', NULL, NULL, 0, 21, NULL, N'3183294300', N'3183294339', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'503 Mcmillian Road 3Rd Floor', N'West Monroe', N'LA', N'22073', N'71291', 32.518478, -92.147635, 1635, 124, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2428, N'Baton Rouge Rehab Hospital', 1, NULL, NULL, N'193028', NULL, NULL, 0, 80, NULL, N'2259270567', N'2259280317', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'8595 United Plaza Blvd', N'Baton Rouge', N'LA', N'22033', N'70809', 30.413109, -91.099503, 1576, 119, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2429, N'Healthsouth Rehabilitation Hospital Of Alexandria', 1, NULL, NULL, N'193031', NULL, NULL, 0, 47, NULL, N'3184491370', N'3184491369', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'104 North Third Street', N'Alexandria', N'LA', N'22079', N'71301', 31.199004, 29.894379, 1573, 118, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2430, N'North Oaks Rehabilitation Hospital L L C', 1, NULL, NULL, N'193044', NULL, NULL, 0, 27, NULL, N'9855427777', N'9852305670', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1900 S Morrison Blvd', N'Hammond', N'LA', N'22105', N'70403', 30.484276, -90.482802, 1594, 119, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2431, N'Tri Parish Rehabilitation Hospital L L C', 1, NULL, NULL, N'193050', NULL, NULL, 0, 36, NULL, N'3374628880', N'3374628818', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'8088 Hawks Rd', N'Leesville', N'LA', N'22115', N'71446', 38.141799, -77.046918, 1603, 118, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2432, N'Bastrop Rehabilitation Hospital - Monroe', 1, NULL, NULL, N'193058', NULL, NULL, 0, 12, NULL, N'3185568000', N'3182398001', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4310 South Grand Street', N'Monroe', N'LA', N'22073', N'71202', 32.457125, -92.115461, 1613, 124, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2433, N'Rehabilitation Hospital Of Jennings', 1, NULL, NULL, N'193067', NULL, NULL, 0, 16, NULL, N'3378215353', N'3378215366', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1 Hospital Drive Suite 101', N'Jennings', N'LA', N'22053', N'70546', 39.090388, -76.563297, 1598, 121, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2434, N'Sterlington Rehabilitation Hospital', 1, NULL, NULL, N'193069', NULL, NULL, 0, 10, NULL, N'3182814531', N'3182814535', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'370 W Hickory Street', N'Bastrop', N'LA', N'22067', N'71220', 30.265765, -97.094456, 1575, 124, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2435, N'M M O Rehabilitation And Wellness Center', 1, NULL, NULL, N'193070', NULL, NULL, 0, 13, NULL, N'2256878100', N'2256878110', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'59215 River West Drive', N'Plaquemine', N'LA', N'22047', N'70764', 30.289083, -91.234274, 1623, 119, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2436, N'United Medical Healthwest-New Orleans', 1, NULL, NULL, N'193074', NULL, NULL, 0, 26, NULL, N'5044335551', N'5044335535', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3201 Wall Blvd Ste B', N'Gretna', N'LA', N'22051', N'70056', 36.952841, -79.360234, 1618, 125, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2437, N'Sage Rehabilitation Hospital', 1, NULL, NULL, N'193078', NULL, NULL, 0, 42, NULL, N'2258190703', N'2259064085', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'8000 Summa Ave', N'Baton Rouge', N'LA', N'22033', N'70809', 30.397866, -91.098074, 1576, 119, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2438, N'United Medical Rehabilitation Hospital', 1, NULL, NULL, N'193079', NULL, NULL, 0, 40, NULL, N'9853405998', N'9853405911', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'15717 Belle Drive', N'Hammond', N'LA', N'22105', N'70403', 41.583366, -87.500043, 1594, 119, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2439, N'Specialty Rehabilitation Hospital', 1, NULL, NULL, N'193080', NULL, NULL, 0, 12, NULL, N'3189321770', N'3184240390', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1110 Ringgold Avenue', N'Coushatta', N'LA', N'22081', N'71019', 32.016906, -93.328036, 1627, 126, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2440, N'Leesville Rehabilitation Hospital', 1, NULL, NULL, N'193086', NULL, NULL, 0, 16, NULL, N'3373928118', N'3373928415', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'900 South Sixth Street', N'Leesville', N'LA', N'22115', N'71446', 38.141799, -77.046918, 1603, 118, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2441, N'The Neuromedical Center Rehabilitation Hospital L', 1, NULL, NULL, N'193090', NULL, NULL, 0, 27, NULL, N'2259062999', N'2259063837', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'10101 Park Rowe Avenue', N'Baton Rouge', N'LA', N'22033', N'70810', 30.450746, -91.154551, 1576, 119, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2442, N'Bethesda Rehabilitation Hospital', 1, NULL, NULL, N'193092', NULL, NULL, 0, 14, NULL, N'2257672034', N'2257672039', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'8225 Summa Ave', N'Baton Rouge', N'LA', N'22033', N'70809', 30.397866, -91.098074, 1576, 119, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2443, N'Lafayette Physical Rehabilitation Hospital', 1, NULL, NULL, N'193093', NULL, NULL, 0, 32, NULL, N'3373141111', N'3373141113', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'307 Polly Lane', N'Lafayette', N'LA', N'22055', N'70508', 30.173288, -92.023232, 1600, 121, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2444, N'Pathway Rehabilitation Hospital Of Bossier', 1, NULL, NULL, N'193094', NULL, NULL, 0, 24, NULL, N'3188415555', N'3188415563', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4900 Medical Drive', N'Bossier City', N'LA', N'22015', N'71112', 32.463457, -93.666512, 1627, 126, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2445, N'Pelican Rehabilitation Hospital Llc', 1, NULL, NULL, N'193095', NULL, NULL, 0, 16, NULL, N'5043785060', N'5043785061', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4201 Woodland Drive 3Rd Floor', N'New Orleans', N'LA', N'22071', N'70131', 29.949932, -90.070116, 1618, 125, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2446, N'Childrens Hospital', 1, NULL, NULL, N'193300', NULL, NULL, 0, 247, NULL, N'5048999511', N'5048969707', 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'200 Henry Clay Ave', N'New Orleans', N'LA', N'22071', N'70118', 29.917249, -90.127862, 1618, 125, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2447, N'Shriners Hospitals For Children', 1, NULL, NULL, N'193301', NULL, NULL, 0, 45, NULL, N'3182225704', N'3184247610', 1, 0, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3100 Samford Avenue', N'Shreveport', N'LA', N'22017', N'71103', 32.480357, -93.756736, 1627, 126, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2448, N'Northlake Behavioral Health System', 1, NULL, NULL, N'194007', NULL, NULL, 0, 140, NULL, N'9856266300', N'9856266559', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'23515 Highway 190', N'Mandeville', N'LA', N'22103', N'70448', 50.597775, -2.486505, 1582, 123, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2449, N'Eastern La Mental Health System', 1, NULL, NULL, N'194008', NULL, NULL, 0, 232, NULL, N'2256340100', N'2256344345', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4502 Highway 951', N'Jackson', N'LA', N'22037', N'70748', 32.410438, -90.162065, 1638, 119, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2450, N'Brentwood Hospital', 1, NULL, NULL, N'194020', NULL, NULL, 0, 200, NULL, N'3186787500', N'3182279296', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1006 Highland Avenue', N'Shreveport', N'LA', N'22017', N'71106', 32.463175, -93.739965, 1627, 126, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2451, N'Longleaf Hospital', 1, NULL, NULL, N'194022', NULL, NULL, 0, 68, NULL, N'3184455111', N'3184422261', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'44 Versailles Blvd', N'Alexandria', N'LA', N'22079', N'71303', 31.283373, -92.503989, 1573, 118, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2452, N'Central Louisiana State Hospital', 1, NULL, NULL, N'194025', NULL, NULL, 0, 196, NULL, N'3184846200', N'3184846501', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'242 W Shamrock Street', N'Pineville', N'LA', N'22079', N'71361', 31.322404, -92.434303, 1573, 118, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2453, N'River Oaks Hospital', 1, NULL, NULL, N'194031', NULL, NULL, 0, 126, NULL, N'5047341740', N'5047341730', 1, 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1525 River Oaks West', N'New Orleans', N'LA', N'22051', N'70123', 29.949932, -90.070116, 1618, 125, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2454, N'Acadia Vermilion Hospital', 1, NULL, NULL, N'194044', NULL, NULL, 0, 54, NULL, N'3372345614', N'3372101197', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2520 N University Avenue', N'Lafayette', N'LA', N'22055', N'70507', 30.272349, -92.047463, 1600, 121, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2455, N'Community Care Hospital', 1, NULL, NULL, N'194056', NULL, NULL, 0, 32, NULL, N'5048992500', N'5048997127', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1421 General Taylor', N'New Orleans', N'LA', N'22071', N'70115', 29.925862, -90.096037, 1618, 125, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2456, N'Greenbrier Behavioral Health', 1, NULL, NULL, N'194069', NULL, NULL, 0, 60, NULL, N'9858932970', N'9858671150', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'201 Greenbrier Blvd', N'Covington', N'LA', N'22103', N'70433', 39.083749, -84.508622, 1582, 123, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2457, N'Oceans Hospital Of Broussard', 1, NULL, NULL, N'194073', NULL, NULL, 0, 47, NULL, N'3378323764', N'3372376445', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'420 Albertsons Parkway', N'Broussard', N'LA', N'22055', N'70518', 30.147146, -91.961231, 1600, 121, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2458, N'Serenity Springs Specialty Hospital', 1, NULL, NULL, N'194074', NULL, NULL, 0, 18, NULL, N'3183680110', N'3183683959', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1495 Frazier Road', N'Ruston', N'LA', N'22061', N'71270', 32.523205, -92.637927, 1626, 126, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2459, N'Westend Hospital', 1, NULL, NULL, N'194075', NULL, NULL, 0, 20, NULL, N'3376168122', N'3376160590', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1530 Highway 90 West', N'Jennings', N'LA', N'22053', N'70546', 39.090388, -76.563297, 1598, 121, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2460, N'Optima Specialty Hospital', 1, NULL, NULL, N'194078', NULL, NULL, 0, 24, NULL, N'3379910571', N'3379919946', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1131 Rue Debelier', N'Lafayette', N'LA', N'22055', N'70506', 30.22409, -92.019843, 1600, 121, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2461, N'Red River Behavioral Center Llc', 1, NULL, NULL, N'194079', NULL, NULL, 0, 20, NULL, N'3185492033', N'3185493745', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2800 Melrose Avenue', N'Bossier City', N'LA', N'22015', N'71111', 32.549943, -93.700959, 1627, 126, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2462, N'Magnolia Behavioral Healthcare L L C', 1, NULL, NULL, N'194080', NULL, NULL, 0, 22, NULL, N'9858820226', N'9858829853', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'64026 Hwy 434 Suite 300 (3Rd Floor)', N'Lacombe', N'LA', N'22103', N'70445', 43.329524, 2.381766, 1628, 127, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2463, N'Oceans Behavioral Hospital Of Deridder', 1, NULL, NULL, N'194081', NULL, NULL, 0, 20, NULL, N'3374609472', N'3374609473', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1420 Blankenship Drive', N'Deridder', N'LA', N'22011', N'70634', 30.846306, -93.289053, 1585, 122, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2464, N'Jennings Senior Care Hospital', 1, NULL, NULL, N'194082', NULL, NULL, 0, 18, NULL, N'3377858003', N'3378241561', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1 Hospital Drive Suite 201', N'Jennings', N'LA', N'22053', N'70546', 39.090388, -76.563297, 1598, 121, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2465, N'Liberty Healthcare Systems Llc', 1, NULL, NULL, N'194083', NULL, NULL, 0, 60, NULL, N'3182812448', N'3182815445', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4673 Eugene Ware Road', N'Bastrop', N'LA', N'22067', N'71220', 30.110495, -97.31527, 1575, 124, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2466, N'Beacon Behavioral Hospital- New Orleans Inc', 1, NULL, NULL, N'194084', NULL, NULL, 0, 24, NULL, N'5042100460', N'5042100972', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'14500 Haynes Blvd', N'New Orleans', N'LA', N'22071', N'70128', 29.949932, -90.070116, 1618, 125, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2467, N'Compass Behavioral Center Of Crowley', 1, NULL, NULL, N'194085', NULL, NULL, 0, 34, NULL, N'3377883380', N'3377883338', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1526 North Avenue I', N'Crowley', N'LA', N'22001', N'70526', 30.225677, -92.37578, 1583, 121, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2468, N'Oceans Behavioral Hospital Of Baton Rouge', 1, NULL, NULL, N'194086', NULL, NULL, 0, 20, NULL, N'2253567030', N'2253567003', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'11135 Florida Blvd', N'Baton Rouge', N'LA', N'22033', N'70815', 30.458669, -91.060219, 1576, 119, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2469, N'Allegiance Health Center Of Ruston Llc', 1, NULL, NULL, N'194087', NULL, NULL, 0, 14, NULL, N'3182558085', N'3182552179', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1401 Ezell Street', N'Ruston', N'LA', N'22061', N'71270', 32.523205, -92.637927, 1626, 126, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2470, N'St James Behavioral Health Hospital Inc', 1, NULL, NULL, N'194088', NULL, NULL, 0, 28, NULL, N'2256477524', N'2256441070', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3136 South St Landry Road', N'Gonzales', N'LA', N'22005', N'70737', 29.501626, -97.452493, 1592, 119, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2471, N'Genesis Behavioral Hospital', 1, NULL, NULL, N'194089', NULL, NULL, 0, 18, NULL, N'3374426254', N'3374424674', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'606 Latiolais Road', N'Breaux Bridge', N'LA', N'22099', N'70517', 30.273532, -91.899284, 1600, 121, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2472, N'Oceans Behavioral Hospital Of Lake Charles', 1, NULL, NULL, N'194090', NULL, NULL, 0, 20, NULL, N'3374747581', N'3374747582', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'302 West Mcneese Street', N'Lake Charles', N'LA', N'22019', N'70605', 30.176249, -93.222794, 1601, 122, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2473, N'Oceans Behavioral Hospital Of Kentwood', 1, NULL, NULL, N'194091', NULL, NULL, 0, 16, NULL, N'9852290717', N'9852290713', 1, 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'921 Avenue G', N'Kentwood', N'LA', N'22105', N'70444', 30.936789, -90.514349, 1594, 119, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2474, N'Physicians Behavioral Hospital', 1, NULL, NULL, N'194094', NULL, NULL, 0, 24, NULL, N'3372334165', N'3372376729', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2025 Desoto St', N'Shreveport', N'LA', N'22017', N'71103', 32.47268, -93.770796, 1627, 126, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2475, N'Oceans Behavioral Hospital Of Opelousas', 1, NULL, NULL, N'194095', NULL, NULL, 0, 20, NULL, N'3379488820', N'3379488821', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1310 Heather Drive', N'Opelousas', N'LA', N'22097', N'70570', 30.50874, -92.073104, 1622, 121, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2476, N'Oceans Behavioral Hospital Of Alexandria', 1, NULL, NULL, N'194096', NULL, NULL, 0, 24, NULL, N'3184488473', N'3184488018', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2621 North Bolton Avenue', N'Alexandria', N'LA', N'22079', N'71303', 31.326112, -92.480946, 1573, 118, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2477, N'Phoenix Behavioral Hospital', 1, NULL, NULL, N'194097', NULL, NULL, 0, 16, NULL, N'3377880091', N'3377880092', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2021 Crowley Rayne Highway', N'Rayne', N'LA', N'22001', N'70578', 30.227227, -92.280516, 1600, 121, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2478, N'Oceans Behavioral Hospital Of Greater New Orleans', 1, NULL, NULL, N'194098', NULL, NULL, 0, 30, NULL, N'5044648895', N'5044648896', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'716 Village Road', N'Kenner', N'LA', N'22051', N'70065', 30.022461, -90.257921, 1611, 123, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2479, N'Seaside Behavioral Center', 1, NULL, NULL, N'194100', NULL, NULL, 0, 24, NULL, N'5043934223', N'5042675692', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4201 Woodland Drive', N'New Orleans', N'LA', N'22071', N'70131', 29.912392, -89.993193, 1618, 125, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2480, N'Beacon Behavioral Hospital Inc', 1, NULL, NULL, N'194102', NULL, NULL, 0, 34, NULL, N'2252586103', N'2252586116', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2471 Louisiana Ave', N'Lutcher', N'LA', N'22093', N'70071', 30.0464, -90.699336, 1605, 123, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2481, N'Seaside Health System', 1, NULL, NULL, N'194103', NULL, NULL, 0, 64, NULL, N'2255224076', N'2256211419', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4363 Convention Street', N'Baton Rouge', N'LA', N'22033', N'70806', 30.449473, -91.144731, 1576, 119, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2482, N'Apollo Behavioral Health Hospital L L C', 1, NULL, NULL, N'194105', NULL, NULL, 0, 18, NULL, N'2256632881', N'2256470108', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7414 Sumrall Drive Suite C', N'Baton Rouge', N'LA', N'22033', N'70812', 30.450746, -91.154551, 1576, 119, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2483, N'Compass Behavioral Center Of Alexandria Inc', 1, NULL, NULL, N'194106', NULL, NULL, 0, 16, NULL, N'3184423163', N'3184430220', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6410 Masonic Drive', N'Alexandria', N'LA', N'22079', N'71301', 31.271835, -92.468534, 1573, 118, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2484, N'Baton Rouge Behavioral Hospital', 1, NULL, NULL, N'194107', NULL, NULL, 0, 40, NULL, N'2253008470', N'2253308523', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4040 North Blvd.', N'Baton Rouge', N'LA', N'22033', N'70806', 30.447609, -91.177295, 1576, 119, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2485, N'Compass Behavioral Center Of Houma Inc', 1, NULL, NULL, N'194109', NULL, NULL, 0, 20, NULL, N'9858761715', N'9858761750', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4701 West Park Avenue', N'Houma', N'LA', N'22109', N'70364', 29.59577, -90.719535, 1596, 120, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2486, N'Kailo Behavioral Hospital L L C', 1, NULL, NULL, N'194111', NULL, NULL, 0, 12, NULL, N'3374667600', N'3374667604', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3859 Hwy 190', N'Eunice', N'LA', N'22097', N'70535', 30.494367, -92.417632, 1587, 121, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2487, N'Tulane University Hospital And Clinic', 1, NULL, NULL, N'199801', NULL, NULL, 0, 0, NULL, N'5049885800', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'1415 Tulane Ave', N'New Orleans', N'LA', N'22071', N'70112', 29.955461, -90.076017, 1618, 125, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2488, N'Ochsner Foundation Hospital', 1, NULL, NULL, N'199802', NULL, NULL, 0, 0, NULL, N'5048423925', N'5048423343', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'1514 Jefferson Highway', N'New Orleans', N'LA', N'22051', N'70121', 29.949932, -90.070116, 1618, 125, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2489, N'Children''s Hospital', 1, NULL, NULL, N'199803', NULL, NULL, 0, 0, NULL, N'5048969450', N'5048969707', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'200 Henry Clay Ave', N'New Orleans', N'LA', N'22071', N'70118', 29.917249, -90.127862, 1618, 125, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2490, N'Willis-Knighton Medical Center', 1, NULL, NULL, N'199804', NULL, NULL, 0, 0, NULL, N'3182124170', N'3182128511', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'2600 Greenwood Road', N'Shreveport', N'LA', N'22017', N'71103', 32.484002, -93.778844, 1627, 126, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2491, N'St Joseph Hospital', 1, NULL, NULL, N'200001', NULL, NULL, 0, 112, NULL, N'2072621000', N'2072621922', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'360 Broadway', N'Bangor', N'ME', N'23019', N'04401', 44.814792, -68.771533, 1640, 128, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2492, N'Miles Memorial Hospital Inc (Lincoln County Hc)', 1, NULL, NULL, N'200002', NULL, NULL, 0, 38, NULL, N'2075631234', N'2075633717', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'35 Miles Street', N'Damariscotta', N'ME', N'23015', N'04543', 44.026459, -69.530144, 1650, 129, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2493, N'Mercy Hospital', 1, NULL, NULL, N'200008', NULL, NULL, 0, 230, NULL, N'2078793000', N'2078793429', 1, 1, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'144 State Street', N'Portland', N'ME', N'23005', N'04101', 43.651929, -70.2651, 1662, 129, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2494, N'Maine Medical Center', 1, NULL, NULL, N'200009', NULL, NULL, 0, 606, NULL, N'2076620111', N'2076624610', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'22 Bramhall St', N'Portland', N'ME', N'23005', N'04102', 43.652538, -70.274839, 1662, 129, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2495, N'Aroostook Medical Center', 1, NULL, NULL, N'200018', NULL, NULL, 0, 89, NULL, N'2077684000', N'2077684252', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Po Box 151', N'Presque Isle', N'ME', N'23003', N'04769', 46.681153, -68.015862, 1663, 128, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2496, N'Southern Maine Health Care', 1, NULL, NULL, N'200019', NULL, NULL, 0, 150, NULL, N'2072837000', N'2072837020', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1 Medical Center Drive', N'Biddeford', N'ME', N'23031', N'04005', 43.476925, -70.493525, 1643, 129, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2497, N'York Hospital', 1, NULL, NULL, N'200020', NULL, NULL, 0, 79, NULL, N'2073634321', N'2073512308', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'15 Hospital Drive', N'York', N'ME', N'23031', N'03909', 43.143023, -70.651491, 1669, 129, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2498, N'Mid Coast Hospital', 1, NULL, NULL, N'200021', NULL, NULL, 0, 92, NULL, N'2077290181', N'2073736039', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'123 Medical Center Drive', N'Brunswick', N'ME', N'23005', N'04011', 43.914524, -69.965328, 1647, 129, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2499, N'Central Maine Medical Center', 1, NULL, NULL, N'200024', NULL, NULL, 0, 250, NULL, N'2077950111', N'2077952367', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'300 Main Street', N'Lewiston', N'ME', N'23001', N'04240', 44.10081, -70.214865, 1656, 129, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2500, N'Parkview Adventist Medical Center', 1, NULL, NULL, N'200025', NULL, NULL, 0, 55, NULL, N'2073732000', N'2073732161', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'329 Main St', N'Brunswick', N'ME', N'23005', N'04011', 43.912112, -69.998103, 1647, 129, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2501, N'Cary Medical Center', 1, NULL, NULL, N'200031', NULL, NULL, 0, 65, NULL, N'2074983111', N'2074962631', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'163 Van Buren Rd Suite 1', N'Caribou', N'ME', N'23003', N'04736', 46.860598, -68.011971, 1649, 128, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2502, N'Eastern Maine Medical Center', 1, NULL, NULL, N'200033', NULL, NULL, 0, 411, NULL, N'2079737000', N'2079737348', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Po Box 404', N'Bangor', N'ME', N'23019', N'04401', 44.801182, -68.777814, 1640, 128, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2503, N'St Marys Regional Medical Center', 1, NULL, NULL, N'200034', NULL, NULL, 0, 233, NULL, N'2077778100', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Campus Avenue - Po Box 291 (Hospital)', N'Lewiston', N'ME', N'23001', N'04240', 44.100351, -70.214776, 1656, 129, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2504, N'Franklin Memorial Hospital', 1, NULL, NULL, N'200037', NULL, NULL, 0, 70, NULL, N'2077786031', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'111 Franklin Health Commons', N'Farmington', N'ME', N'23007', N'04938', 44.625477, -70.161576, 1653, 129, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2505, N'Mainegeneral Medical Center', 1, NULL, NULL, N'200039', NULL, NULL, 0, 287, NULL, N'2078721000', N'2078721678', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'35 Medical Center Parkway', N'Augusta', N'ME', N'23011', N'04330', 44.310517, -69.77926, 1639, 129, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2506, N'Inland Hospital', 1, NULL, NULL, N'200041', NULL, NULL, 0, 48, NULL, N'2078613012', N'2078613039', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'200 Kennedy Memorial Drive', N'Waterville', N'ME', N'23011', N'04901', 44.542549, -69.661278, 1668, 129, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2507, N'Maine Coast Memorial Hospital', 1, NULL, NULL, N'200050', NULL, NULL, 0, 64, NULL, N'2076675311', N'2076645305', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'50 Union Street', N'Ellsworth', N'ME', N'23009', N'04605', 44.547089, -68.415411, 1652, 128, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2508, N'Northern Maine Medical Center', 1, NULL, NULL, N'200052', NULL, NULL, 0, 49, NULL, N'2078343195', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'194 E Main Street', N'Fort Kent', N'ME', N'23003', N'04743', 47.265914, -68.591471, 1654, 128, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2509, N'Penobscot Bay Medical Center', 1, NULL, NULL, N'200063', NULL, NULL, 0, 109, NULL, N'2075968000', N'2075935287', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6 Glen Cove Drive', N'Rockport', N'ME', N'23013', N'04856', 44.184524, -69.076149, 1664, 129, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2510, N'Blue Hill Memorial Hospital', 1, NULL, NULL, N'201300', NULL, NULL, 0, 25, NULL, N'2073742836', N'2073743992', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'57 Water Street', N'Blue Hill', N'ME', N'23009', N'04614', 44.411653, -68.586529, 1644, 128, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2511, N'Charles A Dean Memorial Hospital', 1, NULL, NULL, N'201301', NULL, NULL, 0, 25, NULL, N'2076955200', N'2076452329', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Pritham Avenue Po Box 1129', N'Greenville', N'ME', N'23021', N'04441', 45.459491, -69.59061, 1670, 128, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2512, N'St Andrews Hospital (Lincoln County Healthcare)', 1, NULL, NULL, N'201302', NULL, NULL, 0, 25, NULL, N'2076332121', N'2076334209', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Po Box 417', N'Boothbay Harbor', N'ME', N'23015', N'04538', 43.852266, -69.62809, 1645, 129, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2513, N'Penobscot Valley Hospital', 1, NULL, NULL, N'201303', NULL, NULL, 0, 25, NULL, N'2077943321', N'2077946488', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7 Transalpine Road Po Box 368', N'Lincoln', N'ME', N'23019', N'04457', 45.362121, -68.504351, 1657, 128, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2514, N'Mount Desert Island Hospital', 1, NULL, NULL, N'201304', NULL, NULL, 0, 25, NULL, N'2072885081', N'2072888600', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'10 Wayman Lane Po Box 8', N'Bar Harbor', N'ME', N'23009', N'04609', 44.386457, -68.211857, 1641, 128, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2515, N'Calais Regional Hospital', 1, NULL, NULL, N'201305', NULL, NULL, 0, 25, NULL, N'2074547521', N'2074549238', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'24 Hospital Lane', N'Calais', N'ME', N'23029', N'04619', 45.188963, -67.278604, 1648, 128, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2516, N'Rumford  Hospital', 1, NULL, NULL, N'201306', NULL, NULL, 0, 25, NULL, N'2073691000', N'2073690834', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'420 Franklin Street', N'Rumford', N'ME', N'23017', N'04276', 44.551308, -70.556502, 1665, 129, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2517, N'Millinocket Regional Hospital', 1, NULL, NULL, N'201307', NULL, NULL, 0, 25, NULL, N'2077235161', N'2077234913', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'200 Somerset Street', N'Millinocket', N'ME', N'23019', N'04462', 45.652873, -68.715224, 1659, 128, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2518, N'Houlton Regional Hospital', 1, NULL, NULL, N'201308', NULL, NULL, 0, 25, NULL, N'2075322900', N'2075327334', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'20 Hartford Street', N'Houlton', N'ME', N'23003', N'04730', 46.132353, -67.84296, 1655, 128, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2519, N'Mayo Regional Hospital', 1, NULL, NULL, N'201309', NULL, NULL, 0, 25, NULL, N'2075644251', N'2075644377', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'897 West Main Street', N'Dover Foxcroft', N'ME', N'23021', N'04426', 45.184277, -69.230575, 1651, 128, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2520, N'Bridgton Hospital', 1, NULL, NULL, N'201310', NULL, NULL, 0, 25, NULL, N'2076476000', NULL, 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'10 Hospital Drive', N'Bridgton', N'ME', N'23005', N'04009', 44.054793, -70.71284, 1646, 129, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2521, N'Down East Community Hospital', 1, NULL, NULL, N'201311', NULL, NULL, 0, 25, NULL, N'2072553356', N'2072550427', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'11 Hospital Drive', N'Machias', N'ME', N'23029', N'04654', 44.715077, -67.46138, 1658, 128, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2522, N'Waldo County General Hospital', 1, NULL, NULL, N'201312', NULL, NULL, 0, 25, NULL, N'2073382500', N'2073388600', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Po Box 287', N'Belfast', N'ME', N'23027', N'04915', 44.425909, -69.006423, 1642, 128, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2523, N'Sebasticook Valley Health', 1, NULL, NULL, N'201313', NULL, NULL, 0, 25, NULL, N'2074875141', N'2704873790', 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'447 North Main Street', N'Pittsfield', N'ME', N'23025', N'04967', 44.805525, -69.377221, 1661, 128, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2524, N'Redington Fairview General Hospital', 1, NULL, NULL, N'201314', NULL, NULL, 0, 25, NULL, N'2074745121', N'2074747004', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'46 Fairview Ave   Po Box 468', N'Skowhegan', N'ME', N'23025', N'04976', 44.765062, -69.719218, 1667, 128, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2525, N'Stephens Memorial Hospital', 1, NULL, NULL, N'201315', NULL, NULL, 0, 25, NULL, N'2077435933', N'2077431566', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'181 Main Street', N'Norway', N'ME', N'23017', N'04268', 44.213549, -70.546998, 1660, 129, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2526, N'Healthsouth/Maine Medical Center Llc', 1, NULL, NULL, N'203025', NULL, NULL, 0, 100, NULL, N'2077754000', N'2076628446', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'335 Brighton Avenue Unit 201', N'Portland', N'ME', N'23005', N'04102', 43.661028, -70.25486, 1662, 129, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2527, N'Dorothea Dix Psychiatric Center', 1, NULL, NULL, N'204004', NULL, NULL, 0, 100, NULL, N'2079414000', N'2079414062', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'656 State Street', N'Bangor', N'ME', N'23019', N'04401', 44.811995, -68.742607, 1640, 128, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2528, N'Spring Harbor Hospital', 1, NULL, NULL, N'204005', NULL, NULL, 0, 100, NULL, N'2077612200', N'2077612108', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'123 Andover Road', N'Westbrook', N'ME', N'23005', N'04092', 43.677025, -70.371162, 1662, 129, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2529, N'Acadia Hospital The', 1, NULL, NULL, N'204006', NULL, NULL, 0, 100, NULL, N'2079736100', N'2079736109', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'268 Stillwater Ave', N'Bangor', N'ME', N'23019', N'04401', 44.820475, -68.761808, 1640, 128, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2530, N'Maine Medical Center -Transplant Center', 1, NULL, NULL, N'209801', NULL, NULL, 0, 0, NULL, N'2076627181', N'2076627160', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'22 Bramhall St', N'Portland', N'ME', N'23005', N'04102', 43.652538, -70.274839, 1662, 129, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2531, N'Meritus Medical Center', 1, NULL, NULL, N'210001', NULL, NULL, 0, 271, NULL, N'2403139500', N'3017909480', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'11116 Medical Campus Road', N'Hagerstown', N'MD', N'24043', N'21742', 39.647257, -77.696613, 1686, 52, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2532, N'University Of Maryland Medical Center', 1, NULL, NULL, N'210002', NULL, NULL, 0, 705, NULL, N'4103288667', N'4103287595', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'22 South  Greene Street', N'Baltimore', N'MD', N'24510', N'21201', 39.287931, -76.625624, 1672, 130, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2533, N'Prince Georges  Hospital Center', 1, NULL, NULL, N'210003', NULL, NULL, 0, 224, NULL, N'3016182000', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3001 Hospital Drive', N'Cheverly', N'MD', N'24033', N'20785', 38.928167, -76.915807, 1676, 132, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2534, N'Holy Cross Hospital', 1, NULL, NULL, N'210004', NULL, NULL, 0, 444, NULL, N'3017547000', N'3017547012', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1500 Forest Glen Road', N'Silver Spring', N'MD', N'24031', N'20910', 39.016995, -77.02057, 1698, 132, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2535, N'Frederick Memorial Hospital', 1, NULL, NULL, N'210005', NULL, NULL, 0, 248, NULL, N'2405663300', NULL, 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'400 West Seventh St', N'Frederick', N'MD', N'24021', N'21701', 39.414443, -77.410578, 1684, 52, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2536, N'University Of Maryland Harford Memorial Hospital', 1, NULL, NULL, N'210006', NULL, NULL, 0, 101, NULL, N'4436433303', N'4436433334', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'501 South  Union Avenue', N'Havre De Grace', N'MD', N'24025', N'21078', 39.543359, -76.091417, 1687, 130, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2537, N'Mercy Medical Center Inc', 1, NULL, NULL, N'210008', NULL, NULL, 0, 285, NULL, N'4103329237', N'4103585148', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'301 Saint Paul Place', N'Baltimore', N'MD', N'24510', N'21202', 39.293333, -76.612778, 1672, 130, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2538, N'Johns Hopkins Hospital The', 1, NULL, NULL, N'210009', NULL, NULL, 0, 1025, NULL, N'4109559540', N'4109550856', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'600 North  Wolfe Street', N'Baltimore', N'MD', N'24510', N'21287', 39.296885, -76.592431, 1672, 130, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2539, N'Saint Agnes Hospital', 1, NULL, NULL, N'210011', NULL, NULL, 0, 407, NULL, N'4103682101', N'4103682109', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'900 Caton Avenue', N'Baltimore', N'MD', N'24510', N'21229', 39.269992, -76.66915, 1672, 130, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2540, N'Sinai Hospital Of Baltimore', 1, NULL, NULL, N'210012', NULL, NULL, 0, 466, NULL, N'4106015131', N'4106018801', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2401 West Belvedere Avenue', N'Baltimore', N'MD', N'24510', N'21215', 39.353871, -76.66205, 1672, 130, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2541, N'Bon Secours Hospital', 1, NULL, NULL, N'210013', NULL, NULL, 0, 208, NULL, N'4103623000', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2000 W Baltimore Street', N'Baltimore', N'MD', N'24510', N'21223', 39.289108, -76.649545, 1672, 130, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2542, N'Medstar Franklin Square Medical Center', 1, NULL, NULL, N'210015', NULL, NULL, 0, 405, NULL, N'4437777850', N'4437777904', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'9000 Franklin Square Drive', N'Baltimore', N'MD', N'24005', N'21237', 39.351329, -76.480199, 1672, 130, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2543, N'Adventist Healthcare Washington Adventist Hospital', 1, NULL, NULL, N'210016', NULL, NULL, 0, 298, NULL, N'3018915651', N'3018915991', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7600 Carroll Avenue', N'Takoma Park', N'MD', N'24031', N'20912', 38.983478, -77.000276, 1699, 132, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2544, N'Garrett County Memorial Hospital', 1, NULL, NULL, N'210017', NULL, NULL, 0, 33, NULL, N'3015334173', N'3015334175', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'251 North  Fourth Street', N'Oakland', N'MD', N'24023', N'21550', 39.407875, -79.406712, 1692, 297, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2545, N'Medstar Montgomery Medical Center', 1, NULL, NULL, N'210018', NULL, NULL, 0, 165, NULL, N'3017748882', N'3017748866', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'18101 Prince Philip Drive', N'Olney', N'MD', N'24031', N'20832', 39.155187, -77.057463, 1693, 132, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2546, N'Peninsula Regional Medical Center', 1, NULL, NULL, N'210019', NULL, NULL, 0, 400, NULL, N'4105437111', N'4105437102', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'100 East Carroll Avenue', N'Salisbury', N'MD', N'24045', N'21801', 38.366211, -75.600888, 1697, 131, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2547, N'Suburban Hospital', 1, NULL, NULL, N'210022', NULL, NULL, 0, 229, NULL, N'3018962576', N'3018971355', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'8600 Old Georgetown Road', N'Bethesda', N'MD', N'24031', N'20814', 38.996675, -77.109154, 1673, 52, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2548, N'Anne Arundel Medical Center', 1, NULL, NULL, N'210023', NULL, NULL, 0, 317, NULL, N'4434811307', N'4434811313', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2001 Medical Parkway', N'Annapolis', N'MD', N'24003', N'21401', 38.97864, -76.492786, 1671, 52, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2549, N'Medstar Union Memorial Hospital', 1, NULL, NULL, N'210024', NULL, NULL, 0, 370, NULL, N'4105542227', N'4105542652', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'201 East University Parkway', N'Baltimore', N'MD', N'24510', N'21218', 39.328996, -76.614134, 1672, 130, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2550, N'Church Hospital Corporation', 1, NULL, NULL, N'210026', NULL, NULL, 0, 216, NULL, N'4105228000', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'100 N Broadway', N'Baltimore', N'MD', N'24510', N'21231', 39.293125, -76.59434, 1672, 130, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2551, N'Western Maryland Regional Medical Center', 1, NULL, NULL, N'210027', NULL, NULL, 0, 240, NULL, N'2409648001', N'2409648080', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'12500 Willowbrook Road', N'Cumberland', N'MD', N'24001', N'21502', 39.657143, -78.748335, 1680, 52, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2552, N'Medstar Saint Mary''s Hospital', 1, NULL, NULL, N'210028', NULL, NULL, 0, 107, NULL, N'3014756001', N'3014756475', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'25500 Point Lookout Road', N'Leonardtown', N'MD', N'24037', N'20650', 38.299337, -76.640393, 1691, 52, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2553, N'Johns Hopkins Bayview Medical Center', 1, NULL, NULL, N'210029', NULL, NULL, 0, 397, NULL, N'4105500123', N'4105509096', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4940 Eastern Avenue', N'Baltimore', N'MD', N'24510', N'21224', 39.290148, -76.546326, 1672, 130, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2554, N'University Of Md Shore Medical Ctr At Chestertown', 1, NULL, NULL, N'210030', NULL, NULL, 0, 64, NULL, N'4107787668', N'4107787650', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'100 Brown Street', N'Chestertown', N'MD', N'24029', N'21620', 39.216936, -76.064997, 1675, 130, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2555, N'Union Hospital Of Cecil County', 1, NULL, NULL, N'210032', NULL, NULL, 0, 166, NULL, N'4103927009', N'4436741589', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'106 Bow Street', N'Elkton', N'MD', N'24015', N'21921', 39.609202, -75.831163, 1682, 51, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2556, N'Carroll Hospital Center', 1, NULL, NULL, N'210033', NULL, NULL, 0, 158, NULL, N'4108483000', N'4108717474', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'291 Stoner Avenue', N'Westminster', N'MD', N'24013', N'21157', 39.575264, -76.995928, 1700, 130, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2557, N'Medstar Harbor Hospital', 1, NULL, NULL, N'210034', NULL, NULL, 0, 376, NULL, N'4103503201', N'4103544440', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3001 South  Hanover Street', N'Baltimore', N'MD', N'24510', N'21225', 39.251862, -76.615202, 1672, 130, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2558, N'University Of Md Charles Regional  Medical Center', 1, NULL, NULL, N'210035', NULL, NULL, 0, 131, NULL, N'3016094265', N'3016094037', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5 Garrett Avenue', N'La Plata', N'MD', N'24017', N'20646', 38.529131, -76.972347, 1688, 52, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2559, N'University Of Md Shore Medical Center At Easton', 1, NULL, NULL, N'210037', NULL, NULL, 0, 189, NULL, N'4108221000', N'4108227834', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'219 South  Washington Street', N'Easton', N'MD', N'24041', N'21601', 38.76974, -76.076559, 1681, 130, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2560, N'University Of Md Medical Center Midtown Campus', 1, NULL, NULL, N'210038', NULL, NULL, 0, 276, NULL, N'4102258996', N'4104625834', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'827 Linden Avenue', N'Baltimore', N'MD', N'24510', N'21201', 39.299629, -76.620838, 1672, 130, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2561, N'Calvert Memorial Hospital', 1, NULL, NULL, N'210039', NULL, NULL, 0, 157, NULL, N'4105358239', N'4105358403', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'100 Hospital Road', N'Prince Frederick', N'MD', N'24009', N'20678', 38.559279, -76.596573, 1694, 52, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2562, N'Northwest Hospital Center', 1, NULL, NULL, N'210040', NULL, NULL, 0, 215, NULL, N'4105215995', N'4105217977', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5401 Old Court Road', N'Randallstown', N'MD', N'24005', N'21133', 39.361361, -76.778693, 1695, 130, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2563, N'Univerity Of Md Balto Washington  Medical Center', 1, NULL, NULL, N'210043', NULL, NULL, 0, 329, NULL, N'4105951967', N'4105951972', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'301 Hospital Drive', N'Glen Burnie', N'MD', N'24003', N'21061', 39.141894, -76.632159, 1685, 130, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2564, N'Greater Baltimore Medical Center', 1, NULL, NULL, N'210044', NULL, NULL, 0, 303, NULL, N'4438492000', N'4438498679', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6701 North  Charles Street', N'Baltimore', N'MD', N'24005', N'21204', 39.393286, -76.628137, 1672, 130, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2565, N'Edward Mccready Memorial Hospital', 1, NULL, NULL, N'210045', NULL, NULL, 0, 8, NULL, N'4107269496', N'4109680186', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'201 Hall Highway', N'Crisfield', N'MD', N'24039', N'21817', 37.995662, -75.852405, 1679, 131, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2566, N'Howard County General Hospital', 1, NULL, NULL, N'210048', NULL, NULL, 0, 233, NULL, N'4107407890', N'4107407240', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5755 Cedar Lane', N'Columbia', N'MD', N'24027', N'21044', 39.214211, -76.885873, 1678, 130, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2567, N'University Of M D Upper Chesapeake Medical Center', 1, NULL, NULL, N'210049', NULL, NULL, 0, 219, NULL, N'4436433303', N'4436433334', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'500 Upper Chesapeake Drive', N'Bel Air', N'MD', N'24025', N'21014', 39.535506, -76.34904, 1683, 130, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2568, N'Doctors''  Community Hospital', 1, NULL, NULL, N'210051', NULL, NULL, 0, 182, NULL, N'3015528085', N'3015529306', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'8118 Good Luck Road', N'Lanham', N'MD', N'24033', N'20706', 38.972291, -76.893413, 1689, 132, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2569, N'Laurel Regional Medical Center', 1, NULL, NULL, N'210055', NULL, NULL, 0, 87, NULL, N'3017254300', N'3014977953', 1, 1, 0, 1, 0, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7300 Van Dusen Road', N'Laurel', N'MD', N'24033', N'20707', 39.098083, -76.873383, 1690, 132, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2570, N'Medstar Good Samaritan Hospital', 1, NULL, NULL, N'210056', NULL, NULL, 0, 208, NULL, N'4434443902', N'4434444599', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5601 Loch Raven Boulevard', N'Baltimore', N'MD', N'24510', N'21239', 39.358754, -76.587688, 1672, 130, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2571, N'Adventist Healthcare Shady Grove Medical Center', 1, NULL, NULL, N'210057', NULL, NULL, 0, 253, NULL, N'2408266517', N'2408265811', 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'9901 Medical Center Drive', N'Rockville', N'MD', N'24031', N'20850', 39.084005, -77.152757, 1696, 52, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2572, N'Univ Of Md Rehabilitation &  Orthopaedic Institute', 1, NULL, NULL, N'210058', NULL, NULL, 0, 105, NULL, N'4104486701', N'4104482859', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2200 Kernan Drive', N'Baltimore', N'MD', N'24510', N'21207', 39.314043, -76.707609, 1672, 130, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2573, N'Fort Washington Hospital', 1, NULL, NULL, N'210060', NULL, NULL, 0, 37, NULL, N'3012927000', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'11711 Livingston Road', N'Fort Washington', N'MD', N'24033', N'20744', 38.729218, -76.991954, 797, 52, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2574, N'Atlantic General Hospital', 1, NULL, NULL, N'210061', NULL, NULL, 0, 55, NULL, N'4106419601', N'4106419670', 1, 1, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'9733 Healthway Drive', N'Berlin', N'MD', N'24047', N'21811', 38.337784, -75.210049, 1697, 131, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2575, N'Medstar Southern Maryland Hospital Center', 1, NULL, NULL, N'210062', NULL, NULL, 0, 239, NULL, N'3018688000', N'4434518538', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7503 Surratts Road', N'Clinton', N'MD', N'24033', N'20735', 38.750232, -76.879305, 1677, 52, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2576, N'University Of Maryland St Joseph Medical Center', 1, NULL, NULL, N'210063', NULL, NULL, 0, 247, NULL, N'4103371000', N'4103371569', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7601 Osler Drive', N'Towson', N'MD', N'24005', N'21204', 39.388603, -76.609955, 1672, 130, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2577, N'Levindale Hebrew Geriatric Center And Hospital', 1, NULL, NULL, N'210064', NULL, NULL, 0, 100, NULL, N'4106012400', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2434 West Belvedere Avenue', N'Baltimore', N'MD', N'24005', N'21215', 39.354426, -76.665246, 1672, 130, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2578, N'Holy Cross Germantown Hospital', 1, NULL, NULL, N'210065', NULL, NULL, 0, 93, NULL, N'3015551212', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'19801 Observation Drive', N'Germantown', N'MD', N'24031', N'20876', 39.178737, -77.242172, 1696, 52, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2579, N'Western Maryland Center', 1, NULL, NULL, N'212002', NULL, NULL, 0, 123, NULL, N'3017454140', N'3017914450', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1500 Pennsylvania Avenue', N'Hagerstown', N'MD', N'24043', N'21742', 39.652222, -77.717742, 1686, 52, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2580, N'Deer''s Head Center', 1, NULL, NULL, N'212003', NULL, NULL, 0, 66, NULL, N'4105434000', N'4105434110', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'315 Deer''s Head Hospital Road', N'Salisbury', N'MD', N'24045', N'21802', 38.366211, -75.600888, 1697, 131, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2581, N'Healthsouth Chesapeake Rehabilitation Hospital', 1, NULL, NULL, N'213028', NULL, NULL, 0, 54, NULL, N'4102195500', N'4105468388', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'220 Tilghman Road', N'Salisbury', N'MD', N'24045', N'21801', 38.368682, -75.547687, 1697, 131, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2582, N'Adventist Rehabilitation Hospital Of Maryland', 1, NULL, NULL, N'213029', NULL, NULL, 0, 87, NULL, N'2408646005', N'2408646009', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'9909 Medical Center Drive', N'Rockville', N'MD', N'24031', N'20850', 39.084005, -77.152757, 1696, 52, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2583, N'Mount Washington Pediatric Hospital', 1, NULL, NULL, N'213300', NULL, NULL, 0, 87, NULL, N'4105785050', N'4105780566', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1708 West Rogers Avenue', N'Baltimore', N'MD', N'24510', N'21209', 39.362873, -76.653048, 1672, 130, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2584, N'Kennedy Kreiger Institute', 1, NULL, NULL, N'213301', NULL, NULL, 0, 63, NULL, N'4439239305', N'4439239317', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'707 North  Broadway', N'Baltimore', N'MD', N'24510', N'21205', 39.298686, -76.593681, 1672, 130, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2585, N'Sheppard And Enoch Pratt Hospital The', 1, NULL, NULL, N'214000', NULL, NULL, 0, 322, NULL, N'4109383401', N'4109383450', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6501 North  Charles Street', N'Baltimore', N'MD', N'24005', N'21204', 39.38948, -76.622539, 1672, 130, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2586, N'Eastern Shore Hospital Center', 1, NULL, NULL, N'214002', NULL, NULL, 0, 80, NULL, N'4102212525', N'4102212534', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Post Office Box 800', N'Cambridge', N'MD', N'24019', N'21613', 38.563174, -76.078829, 1674, 131, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2587, N'Brook Lane Health Services', 1, NULL, NULL, N'214003', NULL, NULL, 0, 46, NULL, N'3017330330', N'3017334038', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'13218 Brook Lane Drive', N'Hagerstown', N'MD', N'24043', N'21740', 39.647257, -77.696613, 1686, 52, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2588, N'Springfield Hospital Center', 1, NULL, NULL, N'214004', NULL, NULL, 0, 522, NULL, N'4109707000', N'4109707005', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6655 Sykesville Road', N'Sykesville', N'MD', N'24013', N'21784', 39.37661, -76.966642, 1695, 130, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2589, N'Thomas B Finan Center', 1, NULL, NULL, N'214012', NULL, NULL, 0, 119, NULL, N'3017772240', N'3017772364', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Country Club Road  Post Office Box 1722', N'Cumberland', N'MD', N'24001', N'21502', 39.652851, -78.762471, 1680, 52, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2590, N'Adventist Healthcare Behavioral Health & Wellness', 1, NULL, NULL, N'214013', NULL, NULL, 0, 107, NULL, N'3018384959', N'3012516052', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'14901 Broschart Road', N'Rockville', N'MD', N'24031', N'20850', 39.084005, -77.152757, 1696, 52, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2591, N'Spring Grove Hospital Center', 1, NULL, NULL, N'214018', NULL, NULL, 0, 440, NULL, N'4104027455', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Wade Avenue', N'Catonsville', N'MD', N'24005', N'21228', 39.270016, -76.723935, 1672, 130, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2592, N'Johns Hopkins Hospital The', 1, NULL, NULL, N'219800', NULL, NULL, 0, 0, NULL, N'4106145477', N'4106149270', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'600 North Wolfe Street', N'Baltimore', N'MD', N'24510', N'21287', 39.296885, -76.592431, 1672, 130, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2593, N'University Of Maryland Medical Center', 1, NULL, NULL, N'219801', NULL, NULL, 0, 0, NULL, N'4103281715', N'4103281798', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'22 South Greene Street', N'Baltimore', N'MD', N'24510', N'21201', 39.287931, -76.625624, 1672, 130, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2594, N'Healthalliance Hospitals Inc', 1, NULL, NULL, N'220001', NULL, NULL, 0, 150, NULL, N'9784662000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'60 Hospital Road', N'Leominster', N'MA', N'25027', N'01453', 42.541047, -71.761207, 1723, 135, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2595, N'Mount Auburn Hospital', 1, NULL, NULL, N'220002', NULL, NULL, 0, 217, NULL, N'6174923500', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'330 Mount Auburn Street', N'Cambridge', N'MA', N'25017', N'02138', 42.374864, -71.134593, 1708, 133, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2596, N'Sturdy Memorial Hospital', 1, NULL, NULL, N'220008', NULL, NULL, 0, 126, NULL, N'5082225200', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'211 Park Street', N'Attleboro', N'MA', N'25005', N'02703', 41.942396, -71.273835, 1702, 240, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2597, N'Lawrence General Hospital', 1, NULL, NULL, N'220010', NULL, NULL, 0, 175, NULL, N'9786834000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'One General Street', N'Lawrence', N'MA', N'25009', N'01842', 42.707035, -71.163114, 1722, 133, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2598, N'Cambridge Health Alliance', 1, NULL, NULL, N'220011', NULL, NULL, 0, 159, NULL, N'6176652300', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1493 Cambridge Street', N'Cambridge', N'MA', N'25017', N'02138', 42.374107, -71.104372, 1708, 133, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2599, N'Cape Cod Hospital', 1, NULL, NULL, N'220012', NULL, NULL, 0, 259, NULL, N'5087711800', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'88 Lewis Bay Road', N'Hyannis', N'MA', N'25001', N'02601', 41.654195, -70.274962, 1721, 133, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2600, N'Cooley Dickinson Hospital Inc The', 1, NULL, NULL, N'220015', NULL, NULL, 0, 142, NULL, N'4135822000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'30 Locust Street', N'Northampton', N'MA', N'25015', N'01060', 42.331897, -72.654331, 1741, 134, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2601, N'Baystate Franklin Medical Center', 1, NULL, NULL, N'220016', NULL, NULL, 0, 92, NULL, N'4137730211', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'164 High Street', N'Greenfield', N'MA', N'25011', N'01301', 42.59574, -72.59127, 1718, 134, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2602, N'Carney Hospital', 1, NULL, NULL, N'220017', NULL, NULL, 0, 159, NULL, N'6175062000', NULL, 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2100 Dorchester Avenue', N'Boston', N'MA', N'25025', N'02124', 42.278623, -71.066178, 1705, 133, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2603, N'Harrington Memorial Hospital', 1, NULL, NULL, N'220019', NULL, NULL, 0, 113, NULL, N'5087659771', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'100 South Street', N'Southbridge', N'MA', N'25027', N'01550', 42.077071, -72.043318, 1751, 135, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2604, N'Saint Anne''s Hospital', 1, NULL, NULL, N'220020', NULL, NULL, 0, 160, NULL, N'5086745600', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'795 Middle Street', N'Fall River', N'MA', N'25005', N'02721', 41.693223, -71.163634, 1712, 133, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2605, N'Holyoke Medical Center', 1, NULL, NULL, N'220024', NULL, NULL, 0, 164, NULL, N'4135342500', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'575 Beech Street', N'Holyoke', N'MA', N'25013', N'01040', 42.199312, -72.629166, 1720, 134, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2606, N'Anna Jaques Hospital', 1, NULL, NULL, N'220029', NULL, NULL, 0, 123, NULL, N'9784631000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'25 Highland Avenue', N'Newburyport', N'MA', N'25009', N'01950', 42.814662, -70.890461, 1737, 133, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2607, N'Baystate Wing Hospital And Medical Centers', 1, NULL, NULL, N'220030', NULL, NULL, 0, 41, NULL, N'4132837651', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'40 Wright Street', N'Palmer', N'MA', N'25013', N'01069', 42.168596, -72.341321, 1744, 134, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2608, N'Boston Medical Center Corporation', 1, NULL, NULL, N'220031', NULL, NULL, 0, 185, NULL, N'6176388000', NULL, 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1 Boston Medical Center Place', N'Boston', N'MA', N'25025', N'02118', 42.360482, -71.059568, 1705, 133, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2609, N'Beverly Hospital Corporation', 1, NULL, NULL, N'220033', NULL, NULL, 0, 283, NULL, N'9789223000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'85 Herrick Street', N'Beverly', N'MA', N'25009', N'01915', 42.565135, -70.877136, 1704, 133, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2610, N'North Shore Medical Center', 1, NULL, NULL, N'220035', NULL, NULL, 0, 415, NULL, N'9787411215', NULL, 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'81 Highland Avenue', N'Salem', N'MA', N'25009', N'01970', 42.512426, -70.908039, 1748, 133, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2611, N'St Elizabeth''s Medical Center', 1, NULL, NULL, N'220036', NULL, NULL, 0, 252, NULL, N'6177893000', N'6175627568', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'736 Cambridge Street', N'Brighton', N'MA', N'25025', N'02135', 42.349742, -71.147961, 1705, 133, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2612, N'Berkshire Medical Center Inc', 1, NULL, NULL, N'220046', NULL, NULL, 0, 319, NULL, N'4134472000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'725 North Street', N'Pittsfield', N'MA', N'25003', N'01201', 42.458847, -73.248997, 1745, 185, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2613, N'Marlborough Hospital', 1, NULL, NULL, N'220049', NULL, NULL, 0, 79, NULL, N'5084815000', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'157 Union Street', N'Marlborough', N'MA', N'25017', N'01752', 42.354265, -71.554168, 1728, 135, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2614, N'Baystate Mary Lane Hospital', 1, NULL, NULL, N'220050', NULL, NULL, 0, 31, NULL, N'4139676211', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'85 South Street', N'Ware', N'MA', N'25015', N'01082', 42.252737, -72.241701, 1757, 134, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2615, N'Signature Healthcare Brockton Hospital', 1, NULL, NULL, N'220052', NULL, NULL, 0, 205, NULL, N'5089417000', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'680 Center Street', N'Brockton', N'MA', N'25023', N'02302', 42.086273, -70.991246, 1706, 133, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2616, N'Clinton Hospital Association', 1, NULL, NULL, N'220058', NULL, NULL, 0, 41, NULL, N'9783683000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'201 Highland Street', N'Clinton', N'MA', N'25027', N'01510', 42.426884, -71.693185, 1709, 135, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2617, N'Beth Israel Deaconess Hospital - Plymouth', 1, NULL, NULL, N'220060', NULL, NULL, 0, 155, NULL, N'5087462000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'275 Sandwich Street', N'Plymouth', N'MA', N'25023', N'02360', 41.944704, -70.645568, 1746, 133, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2618, N'Adcare Hospital Of Worcester Inc', 1, NULL, NULL, N'220062', NULL, NULL, 0, 114, NULL, N'5087999000', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'107 Lincoln Street', N'Worcester', N'MA', N'25027', N'01605', 42.276349, -71.794877, 1763, 135, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2619, N'Lowell General Hospital', 1, NULL, NULL, N'220063', NULL, NULL, 0, 158, NULL, N'9789376000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'295 Varnum Avenue', N'Lowell', N'MA', N'25017', N'01854', 42.646301, -71.341726, 1724, 133, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2620, N'Noble Hospital', 1, NULL, NULL, N'220065', NULL, NULL, 0, 97, NULL, N'4135682811', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'115 West Silver Street', N'Westfield', N'MA', N'25013', N'01085', 42.118319, -72.759533, 1760, 134, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2621, N'Mercy Medical Center', 1, NULL, NULL, N'220066', NULL, NULL, 0, 339, NULL, N'4137489000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'271 Carew Street', N'Springfield', N'MA', N'25013', N'01104', 42.149258, -72.564348, 1752, 134, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2622, N'Hallmark Health System', 1, NULL, NULL, N'220070', NULL, NULL, 0, 538, NULL, N'7819793000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'585 Lebanon Street', N'Melrose', N'MA', N'25017', N'02176', 42.460216, -71.061127, 1730, 133, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2623, N'Massachusetts General Hospital', 1, NULL, NULL, N'220071', NULL, NULL, 0, 907, NULL, N'6177262000', NULL, 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'55 Fruit Street', N'Boston', N'MA', N'25025', N'02114', 42.362507, -71.069707, 1705, 133, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2624, N'Morton Hospital', 1, NULL, NULL, N'220073', NULL, NULL, 0, 133, NULL, N'5088287000', NULL, 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'88 Washington Street', N'Taunton', N'MA', N'25005', N'02780', 41.904708, -71.095603, 1755, 133, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2625, N'Southcoast Hospital Group Inc', 1, NULL, NULL, N'220074', NULL, NULL, 0, 695, NULL, N'5086793131', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'363 Highland Avenue', N'Fall River', N'MA', N'25005', N'02720', 41.710394, -71.146583, 1712, 133, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2626, N'Massachusetts Eye And Ear Infirmary', 1, NULL, NULL, N'220075', NULL, NULL, 0, 42, NULL, N'6175237900', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'243 Charles Street', N'Boston', N'MA', N'25025', N'02114', 42.362602, -71.07053, 1705, 133, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2627, N'Baystate Medical Center', 1, NULL, NULL, N'220077', NULL, NULL, 0, 716, NULL, N'4137940000', NULL, 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'759 Chestnut Street', N'Springfield', N'MA', N'25013', N'01199', 42.119062, -72.604095, 1752, 134, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2628, N'Holy Family Hospital', 1, NULL, NULL, N'220080', NULL, NULL, 0, 222, NULL, N'9786870156', N'9786829908', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'70 East Street', N'Methuen', N'MA', N'25009', N'01844', 42.72758, -71.168106, 1731, 133, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2629, N'Saints  Medical Center Inc', 1, NULL, NULL, N'220082', NULL, NULL, 0, 225, NULL, N'9784581411', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1 Hospital Drive', N'Lowell', N'MA', N'25017', N'01852', 42.645331, -71.300399, 1724, 133, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2630, N'Beth Israel Deaconess Hospital - Needham', 1, NULL, NULL, N'220083', NULL, NULL, 0, 58, NULL, N'7814533002', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'148 Chestnut Street', N'Needham', N'MA', N'25021', N'02494', 42.25832, -71.237697, 1735, 133, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2631, N'Emerson Hospital', 1, NULL, NULL, N'220084', NULL, NULL, 0, 149, NULL, N'9783691400', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Old Road To 9 Acre Corner', N'W Concord', N'MA', N'25017', N'01742', 42.456686, -71.394232, 1710, 133, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2632, N'Beth Israel Deaconess Medical Center', 1, NULL, NULL, N'220086', NULL, NULL, 0, 597, NULL, N'6176677000', NULL, 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'330 Brookline Avenue', N'Boston', N'MA', N'25025', N'02215', 42.340345, -71.105894, 1705, 133, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2633, N'New England Baptist Hospital', 1, NULL, NULL, N'220088', NULL, NULL, 0, 92, NULL, N'6177545800', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'125 Parker Hill Avenue', N'Boston', N'MA', N'25025', N'02120', 42.330033, -71.106656, 1705, 133, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2634, N'Milford Regional Medical Center', 1, NULL, NULL, N'220090', NULL, NULL, 0, 121, NULL, N'5084731190', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'14 Prospect Street', N'Milford', N'MA', N'25027', N'01757', 42.135958, -71.532498, 1734, 133, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2635, N'Heywood Hospital', 1, NULL, NULL, N'220095', NULL, NULL, 0, 134, NULL, N'9786323420', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'242 Green Street', N'Gardner', N'MA', N'25027', N'01440', 42.61142, -71.999431, 1715, 135, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2636, N'Nashoba Valley Medical Center', 1, NULL, NULL, N'220098', NULL, NULL, 0, 57, NULL, N'9787849000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'200 Groton Road', N'Ayer', N'MA', N'25017', N'01432', 42.561202, -71.58979, 1703, 133, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2637, N'South Shore Hospital', 1, NULL, NULL, N'220100', NULL, NULL, 0, 284, NULL, N'7813408000', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'55 Fogg Road', N'South Weymouth', N'MA', N'25021', N'02190', 42.174813, -70.95436, 1750, 133, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2638, N'Newton-Wellesley Hospital', 1, NULL, NULL, N'220101', NULL, NULL, 0, 224, NULL, N'6172436000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2014 Washington Street', N'Newton', N'MA', N'25017', N'02462', 42.331848, -71.246987, 1738, 133, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2639, N'Winchester Hospital', 1, NULL, NULL, N'220105', NULL, NULL, 0, 189, NULL, N'7817299000', NULL, 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'41 Highland Avenue', N'Winchester', N'MA', N'25017', N'01890', 42.465887, -71.121299, 1761, 133, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2640, N'Beth Israel Deaconess Hospital-Milton Inc', 1, NULL, NULL, N'220108', NULL, NULL, 0, 81, NULL, N'6176964600', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'199 Reedsdale Road', N'Milton', N'MA', N'25021', N'02186', 42.253752, -71.076847, 1732, 133, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2641, N'Brigham And Women''s Hospital', 1, NULL, NULL, N'220110', NULL, NULL, 0, 663, NULL, N'6177325500', NULL, 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'75 Francis Street', N'Boston', N'MA', N'25025', N'02115', 42.334897, -71.105855, 1705, 133, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2642, N'Good Samaritan Medical Center', 1, NULL, NULL, N'220111', NULL, NULL, 0, 231, NULL, N'5084273000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'235 North Pearl Street', N'Brockton', N'MA', N'25023', N'02301', 42.09819, -71.065836, 1706, 133, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2643, N'Tufts Medical Center', 1, NULL, NULL, N'220116', NULL, NULL, 0, 415, NULL, N'6176365000', NULL, 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'800 Washington Street', N'Boston', N'MA', N'25025', N'02111', 42.349626, -71.063657, 1705, 133, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2644, N'Brigham And Women''s Faulkner Hospital', 1, NULL, NULL, N'220119', NULL, NULL, 0, 153, NULL, N'6179837000', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1153 Centre Street', N'Boston', N'MA', N'25025', N'02130', 42.301035, -71.127185, 1705, 133, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2645, N'Norwood Hospital', 1, NULL, NULL, N'220126', NULL, NULL, 0, 263, NULL, N'5087721000', N'5087721012', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'800 Washington Street', N'Norwood', N'MA', N'25021', N'02062', 42.18959, -71.202742, 1742, 133, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2646, N'Falmouth Hospital', 1, NULL, NULL, N'220135', NULL, NULL, 0, 95, NULL, N'5085485300', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'67 & 100 Ter Heun Drive', N'Falmouth', N'MA', N'25001', N'02540', 41.564932, -70.621015, 1713, 133, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2647, N'Dana-Farber Cancer Institute', 1, NULL, NULL, N'220162', NULL, NULL, 0, 27, NULL, N'6176323000', NULL, 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'450 Brookline Avenue', N'Boston', N'MA', N'25025', N'02115', 42.337795, -71.108375, 1705, 133, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2648, N'Umass Memorial Medical Center Inc', 1, NULL, NULL, N'220163', NULL, NULL, 0, 325, NULL, N'5083341000', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'55 Lake Avenue North', N'Worcester', N'MA', N'25027', N'01655', 42.278086, -71.759211, 1763, 135, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2649, N'Lahey Hospital & Medical Center Burlington', 1, NULL, NULL, N'220171', NULL, NULL, 0, 327, NULL, N'7817445100', NULL, 1, 1, 1, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'41 & 45 Mall Road', N'Burlington', N'MA', N'25017', N'01803', 42.504817, -71.195611, 1707, 133, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2650, N'Metrowest Medical Center', 1, NULL, NULL, N'220175', NULL, NULL, 0, 360, NULL, N'5083831000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'115 Lincoln Street', N'Framingham', N'MA', N'25017', N'01701', 42.28442, -71.41984, 1734, 133, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2651, N'St Vincent Hospital', 1, NULL, NULL, N'220176', NULL, NULL, 0, 321, NULL, N'5083635000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'123 Summer Street', N'Worcester', N'MA', N'25027', N'01608', 42.266753, -71.795735, 1763, 135, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2652, N'Nantucket Cottage Hospital', 1, NULL, NULL, N'220177', NULL, NULL, 0, 19, NULL, N'5082281200', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'57 Prospect Street', N'Nantucket', N'MA', N'25019', N'02554', 41.278037, -70.103565, 1733, 133, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2653, N'Martha''s Vineyard Hospital Inc', 1, NULL, NULL, N'221300', NULL, NULL, 0, 19, NULL, N'5086930410', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'One Hospital Road Po Box 1477', N'Oak Bluffs', N'MA', N'25007', N'02557', 41.454279, -70.561972, 1743, 133, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2654, N'Fairview Hospital', 1, NULL, NULL, N'221302', NULL, NULL, 0, 25, NULL, N'4135280790', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'29 Lewis Avenue', N'Great Barrington', N'MA', N'25003', N'01230', 42.192083, -73.370891, 1717, 134, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2655, N'Athol Memorial Hospital', 1, NULL, NULL, N'221303', NULL, NULL, 0, 25, NULL, N'9782493511', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2033 Main Street', N'Athol', N'MA', N'25027', N'01331', 42.585201, -72.206615, 1701, 135, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2656, N'Chestnut Hill Benevolent Association', 1, NULL, NULL, N'221990', NULL, NULL, 0, 28, NULL, N'6177345600', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'910 Boylston Street', N'Chestnut Hill', N'MA', N'25017', N'02167', 39.78373, -100.445882, NULL, NULL, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2657, N'Spaulding Hospital For Continuing Med Care-Camb', 1, NULL, NULL, N'222000', NULL, NULL, 0, 180, NULL, N'6178764344', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1575 Cambridge Street', N'Cambridge', N'MA', N'25017', N'02138', 42.374587, -71.106878, 1708, 133, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2658, N'Kindred Hospital Northeast - Stoughton', 1, NULL, NULL, N'222002', NULL, NULL, 0, 221, NULL, N'7818482600', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'909 Sumner Street 1St Floor', N'Stoughton', N'MA', N'25021', N'02072', 42.1251, -71.102271, 1754, 133, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2659, N'Tewksbury Hospital', 1, NULL, NULL, N'222003', NULL, NULL, 0, 760, NULL, N'9788517321', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'365 East Street', N'Tewksbury', N'MA', N'25017', N'01876', 42.612428, -71.21686, 1724, 133, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2660, N'Lemuel Shattuck Hospital', 1, NULL, NULL, N'222006', NULL, NULL, 0, 215, NULL, N'6175228110', NULL, 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'170 Morton Street', N'Jamaica Plain', N'MA', N'25025', N'02130', 42.289167, -71.095414, 1705, 133, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2661, N'Hebrew Rehabilitation Center', 1, NULL, NULL, N'222007', NULL, NULL, 0, 675, NULL, N'6173258000', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1200 Centre Street', N'Boston', N'MA', N'25025', N'02131', 42.29696, -71.132255, 1705, 133, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2662, N'Western Massachusetts Hospital', 1, NULL, NULL, N'222023', NULL, NULL, 0, 102, NULL, N'4135624131', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'91 East Mountain Road', N'Westfield', N'MA', N'25013', N'01085', 42.172407, -72.68933, 1760, 134, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2663, N'Massachusetts Hospital School', 1, NULL, NULL, N'222025', NULL, NULL, 0, 239, NULL, N'6178282440', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3 Randolph Street', N'Canton', N'MA', N'25021', N'02021', 42.174611, -71.123422, 1742, 133, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2664, N'Spaulding Hospital For Continuing Mc - North Shore', 1, NULL, NULL, N'222026', NULL, NULL, 0, 160, NULL, N'9787459000', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Dove Avenue', N'Salem', N'MA', N'25009', N'01970', 42.510326, -70.903291, 1748, 133, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2665, N'New England Sinai Hospital', 1, NULL, NULL, N'222027', NULL, NULL, 0, 212, NULL, N'7813644850', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'150 York Street', N'Stoughton', N'MA', N'25021', N'02072', 42.178044, -71.096355, 1754, 133, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2666, N'New Bedford Rehabilitation Hospital', 1, NULL, NULL, N'222043', NULL, NULL, 0, 90, NULL, N'5089956900', NULL, 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4499 Acushnet Avenue', N'New Bedford', N'MA', N'25005', N'02745', 41.73976, -70.944154, 1736, 133, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2667, N'Kindred Hospital - Boston North Shore', 1, NULL, NULL, N'222044', NULL, NULL, 0, 50, NULL, N'5085312900', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'15 King Street', N'Peabody', N'MA', N'25009', N'01960', 42.529165, -70.93675, 1748, 133, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2668, N'Kindred Hospital - Boston', 1, NULL, NULL, N'222045', NULL, NULL, 0, 59, NULL, N'6172541100', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1515 Commonwealth Avenue', N'Boston', N'MA', N'25025', N'02135', 42.34711, -71.141229, 1705, 133, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2669, N'Vibra Hospital Of Western Massachusetts', 1, NULL, NULL, N'222046', NULL, NULL, 0, 174, NULL, N'4137876700', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1400 State Street', N'Springfield', N'MA', N'25013', N'01109', 42.120037, -72.54602, 1752, 134, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2670, N'Whittier Rehabilitation Hospital - Bradford', 1, NULL, NULL, N'222047', NULL, NULL, 0, 60, NULL, N'9783728000', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'145 Ward Hill Avenue', N'Bradford', N'MA', N'25009', N'01835', 42.761646, -71.118947, 1719, 133, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2671, N'Whittier Rehabilitation Hospital', 1, NULL, NULL, N'222048', NULL, NULL, 0, 88, NULL, N'5088712063', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'150 Flanders Road', N'Westborough', N'MA', N'25027', N'01581', 42.276428, -71.567855, 1763, 135, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2672, N'New England Rehabilitation Hospital', 1, NULL, NULL, N'223026', NULL, NULL, 0, 210, NULL, N'7819355050', NULL, 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2 Rehabilitation Way', N'Woburn', N'MA', N'25017', N'01801', 42.461063, -71.165914, 1761, 133, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2673, N'Braintree Rehabilitation Hospital', 1, NULL, NULL, N'223027', NULL, NULL, 0, 187, NULL, N'7818485353', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'250 Pond Street', N'Braintree', N'MA', N'25021', N'02184', 42.199092, -71.018392, 1750, 133, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2674, N'Fairlawn Rehabilitation Hospital', 1, NULL, NULL, N'223029', NULL, NULL, 0, 110, NULL, N'5087916351', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'189 May Street', N'Worcester', N'MA', N'25027', N'01602', 42.273687, -71.841284, 1763, 135, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2675, N'Healthsouth Rehabilitation Hospital Of Western Ma', 1, NULL, NULL, N'223030', NULL, NULL, 0, 53, NULL, N'4135897581', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'222 State Street', N'Ludlow', N'MA', N'25013', N'01056', 42.156132, -72.472374, 1725, 134, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2676, N'Spaulding Rehabilitation Hospital - Cape Cod', 1, NULL, NULL, N'223032', NULL, NULL, 0, 60, NULL, N'5088334010', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'311 Service Road', N'East Sandwich', N'MA', N'25001', N'02537', 41.726594, -70.439408, 1713, 133, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2677, N'Spaulding Rehabilitation Hospital', 1, NULL, NULL, N'223034', NULL, NULL, 0, 132, NULL, N'6177206400', NULL, 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'300 First Avenue', N'Charlestown', N'MA', N'25025', N'02129', 42.375463, -71.053528, 1705, 133, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2678, N'Franciscan Children''s Hospital & Rehab Center', 1, NULL, NULL, N'223300', NULL, NULL, 0, 112, NULL, N'6172543800', NULL, 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'30 Warren Street', N'Brighton', N'MA', N'25025', N'02135', 42.349621, -71.143514, 1705, 133, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2679, N'Boston Children''s Hospital', 1, NULL, NULL, N'223302', NULL, NULL, 0, 395, NULL, N'6177356000', NULL, 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'300 Longwood Avenue', N'Boston', N'MA', N'25025', N'02115', 42.336433, -71.101633, 1705, 133, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2680, N'Shriners'' Hospital For Children (The)', 1, NULL, NULL, N'223303', NULL, NULL, 0, 40, NULL, N'4137872000', NULL, 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'516 Carew Street', N'Springfield', N'MA', N'25013', N'01104', 42.129817, -72.577998, 1752, 134, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2681, N'Shriners'' Hospital For Children - Boston The', 1, NULL, NULL, N'223304', NULL, NULL, 0, 30, NULL, N'6177223000', NULL, 1, 0, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'51 Blossom Street', N'Boston', N'MA', N'25025', N'02114', 42.362659, -71.066822, 1705, 133, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2682, N'Taunton State Hospital', 1, NULL, NULL, N'224001', NULL, NULL, 0, 45, NULL, N'5089773000', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'60 Hodges Avenue Box 151', N'Taunton', N'MA', N'25005', N'02780', 41.900101, -71.089767, 1755, 133, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2683, N'Mclean Hospital Corporation', 1, NULL, NULL, N'224007', NULL, NULL, 0, 324, NULL, N'6178553450', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'115 Mill Street', N'Belmont', N'MA', N'25017', N'02478', 42.396124, -71.194905, 1708, 133, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2684, N'Arbour Hospital The', 1, NULL, NULL, N'224013', NULL, NULL, 0, 118, NULL, N'6175224400', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'49 Robinwood Avenue', N'Boston', N'MA', N'25025', N'02130', 42.315317, -71.110219, 1705, 133, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2685, N'Arbour Human Resource Institute', 1, NULL, NULL, N'224018', NULL, NULL, 0, 68, NULL, N'6177313200', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'227 Babcock Street', N'Brookline', N'MA', N'25021', N'02146', 42.348021, -71.121069, NULL, NULL, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2686, N'Arbour-Fuller Hospital', 1, NULL, NULL, N'224021', NULL, NULL, 0, 86, NULL, N'5087618500', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'200 May Street', N'South Attleboro', N'MA', N'25005', N'02703', 41.926287, -71.360868, 1702, 240, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2687, N'Bournewood Hospital', 1, NULL, NULL, N'224022', NULL, NULL, 0, 90, NULL, N'6174690300', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'300 South Street', N'Brookline', N'MA', N'25021', N'02146', 42.297927, -71.150921, NULL, NULL, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2688, N'Westwood Pembroke Health Systems', 1, NULL, NULL, N'224023', NULL, NULL, 0, 248, NULL, N'6177627764', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'45 Clapboardtree Street', N'Westwood', N'MA', N'25021', N'02090', 42.208362, -71.224681, 1742, 133, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2689, N'Dr John C Corrigan Mental Health Center', 1, NULL, NULL, N'224028', NULL, NULL, 0, 16, NULL, N'5082357600', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'49 Hillside Street', N'Fall River', N'MA', N'25005', N'02720', 41.707814, -71.145658, 1712, 133, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2690, N'Cape Cod & Islands Community Mental Health Center', 1, NULL, NULL, N'224031', NULL, NULL, 0, 16, NULL, N'5085632276', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'830 County Road', N'Pocasset', N'MA', N'25001', N'02559', 41.689537, -70.601267, 1713, 133, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2691, N'Worcester State Hospital', 1, NULL, NULL, N'224032', NULL, NULL, 0, 166, NULL, N'5087524681', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'305 Belmont Street', N'Worcester', N'MA', N'25027', N'01604', 42.273782, -71.768766, 1763, 135, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2692, N'Baldpate Hospital', 1, NULL, NULL, N'224033', NULL, NULL, 0, 59, NULL, N'9783522131', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'83 Baldpate Road', N'Georgetown', N'MA', N'25009', N'01833', 42.695098, -71.007393, 1719, 133, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2693, N'Walden Behavioral Care Llc', 1, NULL, NULL, N'224038', NULL, NULL, 0, 45, NULL, N'7816476727', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'9 Hope Avenue', N'Waltham', N'MA', N'25017', N'02453', 42.370127, -71.248752, 1756, 133, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2694, N'Whittier Pavilion', 1, NULL, NULL, N'224039', NULL, NULL, 0, 65, NULL, N'9783738222', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'76 Summer Street', N'Haverhill', N'MA', N'25009', N'01830', 42.778639, -71.072806, 1719, 133, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2695, N'Dr Solomon Carter Fuller Mental Health Center', 1, NULL, NULL, N'224040', NULL, NULL, 0, 60, NULL, N'6172668800', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'85 East Newton Street', N'Boston', N'MA', N'25025', N'02118', 42.338722, -71.072662, 1705, 133, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2696, N'Brigham And Women''s Hospital -  Transplant Center', 1, NULL, NULL, N'229801', NULL, NULL, 0, 0, NULL, N'6177325500', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'75 Francis Street', N'Boston', N'MA', N'25025', N'02115', 42.334897, -71.105855, 1705, 133, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2697, N'Lahey Clinic - Transplant Center', 1, NULL, NULL, N'229802', NULL, NULL, 0, 0, NULL, N'7817445100', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'41 & 45 Mall Road', N'Burlington', N'MA', N'25017', N'01803', 42.504817, -71.195611, 1707, 133, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2698, N'Beth Israel Deaconess Med Ctr -  Transplant Center', 1, NULL, NULL, N'229803', NULL, NULL, 0, 0, NULL, N'6176677000', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'330 Brookline Avenue', N'Boston', N'MA', N'25025', N'02115', 42.335586, -71.110808, 1705, 133, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2699, N'Boston Medical Center - Transplant Center', 1, NULL, NULL, N'229804', NULL, NULL, 0, 0, NULL, N'6176388430', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'1 Boston Medical Place', N'Boston', N'MA', N'25025', N'02118', 42.360482, -71.059568, 1705, 133, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2700, N'University Of Mass Memorial Med Ctr - Transplant', 1, NULL, NULL, N'229805', NULL, NULL, 0, 0, NULL, N'5083347177', N'5083342017', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'55 Lake Avenue North', N'Worcester', N'MA', N'25027', N'01655', 42.278086, -71.759211, 1763, 135, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2701, N'Boston Children''s Hospital - Transplant Center', 1, NULL, NULL, N'229806', NULL, NULL, 0, 0, NULL, N'6173556128', N'6177300630', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'300 Longwood Ave', N'Boston', N'MA', N'25025', N'02115', 42.336433, -71.101633, 1705, 133, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2702, N'Tufts Medical Center - Transplant', 1, NULL, NULL, N'229807', NULL, NULL, 0, 0, NULL, N'6176364229', N'6176366489', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'750 Washington Street', N'Boston', N'MA', N'25025', N'02111', 42.350384, -71.063181, 1705, 133, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2703, N'Massachusetts General Hospital - Transplant Center', 1, NULL, NULL, N'229808', NULL, NULL, 0, 0, NULL, N'6177265111', N'6177243377', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'55 Fruit Street', N'Boston', N'MA', N'25025', N'02114', 42.362507, -71.069707, 1705, 133, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2704, N'Baystate Medical Center - Transplant Center', 1, NULL, NULL, N'229809', NULL, NULL, 0, 0, NULL, N'4137942602', N'4137942603', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'759 Chestnut Street', N'Springfield', N'MA', N'25013', N'01199', 42.119062, -72.604095, 1752, 134, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2705, N'St Mary Mercy Hospital', 1, NULL, NULL, N'230002', NULL, NULL, 0, 273, NULL, N'7346554800', N'7346553093', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'36475 Five Mile Road', N'Livonia', N'MI', N'26163', N'48154', 42.36837, -83.35271, 1822, 136, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2706, N'Spectrum Health Zeeland Community Hospital', 1, NULL, NULL, N'230003', NULL, NULL, 0, 57, NULL, N'6167724644', N'6167482828', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'8333 Felch St', N'Zeeland', N'MI', N'26139', N'49464', 42.812435, -86.028817, 1873, 140, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2707, N'Mercy Health Partners Mercy Campus', 1, NULL, NULL, N'230004', NULL, NULL, 0, 282, NULL, N'2316723901', N'2316723074', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1500 E Sherman Boulevard', N'Muskegon', N'MI', N'26121', N'49444', 43.207136, -86.20718, 1836, 144, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2708, N'Emma L Bixby Medical Center', 1, NULL, NULL, N'230005', NULL, NULL, 0, 88, NULL, N'5172650900', N'5172631839', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'818 Riverside Avenue', N'Adrian', N'MI', N'26091', N'49221', 41.914047, -84.049234, 1765, 136, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2709, N'Doctors'' Hospital Of Michigan', 1, NULL, NULL, N'230013', NULL, NULL, 0, 306, NULL, N'2488577200', N'2488576842', 1, 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'461 W Huron St', N'Pontiac', N'MI', N'26125', N'48341', 42.634343, -83.309368, 1845, 146, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2710, N'Three Rivers Health', 1, NULL, NULL, N'230015', NULL, NULL, 0, 60, NULL, N'2692739602', N'2692739611', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'701 S Health Parkway', N'Three Rivers', N'MI', N'26149', N'49093', 41.935358, -85.647932, 1864, 141, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2711, N'Bronson Methodist Hospital', 1, NULL, NULL, N'230017', NULL, NULL, 0, 380, NULL, N'2693416000', N'2693418314', 1, 1, 0, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'601 John Street 42', N'Kalamazoo', N'MI', N'26077', N'49007', 42.291707, -85.587229, 1816, 141, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2712, N'Providence Hospital And Medical Centers', 1, NULL, NULL, N'230019', NULL, NULL, 0, 434, NULL, N'2488493011', N'2488493035', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'16001 W Nine Mile Rd', N'Southfield', N'MI', N'26125', N'48075', 42.473369, -83.221873, 1855, 147, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2713, N'Oakwood Hospital - Dearborn', 1, NULL, NULL, N'230020', NULL, NULL, 0, 623, NULL, N'3135937125', N'3134362042', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'18101 Oakwood Blvd', N'Dearborn', N'MI', N'26163', N'48124', 42.289553, -83.21526, 1787, 137, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2714, N'Lakeland Hospital St Joseph', 1, NULL, NULL, N'230021', NULL, NULL, 0, 313, NULL, N'2699838300', N'2699824855', 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1234 Napier Avenue', N'St Joseph', N'MI', N'26021', N'49085', 42.088879, -86.478366, 1858, 149, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2715, N'Community Health Center Of Branch County', 1, NULL, NULL, N'230022', NULL, NULL, 0, 110, NULL, N'5172795400', N'5172797140', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'274 E Chicago St', N'Coldwater', N'MI', N'26023', N'49036', 41.937699, -84.989389, 1785, 141, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2716, N'Sinai-Grace Hospital', 1, NULL, NULL, N'230024', NULL, NULL, 0, 991, NULL, N'3139663300', N'3139663160', 1, 1, 1, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6071 W Outer Drive', N'Detroit', N'MI', N'26163', N'48235', 42.418894, -83.182376, 1789, 138, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2717, N'St Joseph Mercy Oakland', 1, NULL, NULL, N'230029', NULL, NULL, 0, 395, NULL, N'2488583000', N'2488583299', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'44405 Woodward Ave', N'Pontiac', N'MI', N'26125', N'48341', 42.615381, -83.276976, 1845, 146, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2718, N'Midmichigan Medical Center-Gratiot', 1, NULL, NULL, N'230030', NULL, NULL, 0, 142, NULL, N'9894631101', N'9894636948', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'300 E Warwick Dr', N'Alma', N'MI', N'26057', N'48801', 43.394414, -84.673138, 1768, 142, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2719, N'St Joseph Mercy Port Huron', 1, NULL, NULL, N'230031', NULL, NULL, 0, 119, NULL, N'8109851510', N'8109851579', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2601 Electric Avenue', N'Port Huron', N'MI', N'26147', N'48060', 42.956403, -82.435577, 1846, 138, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2720, N'Spectrum Health United Memorial - United Campus', 1, NULL, NULL, N'230035', NULL, NULL, 0, 48, NULL, N'6167544691', N'6167545054', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'615 S Bower Street', N'Greenville', N'MI', N'26117', N'48838', 43.175126, -85.268836, 1802, 140, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2721, N'Alpena Regional Medical Center', 1, NULL, NULL, N'230036', NULL, NULL, 0, 150, NULL, N'9893567390', N'9893567305', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1501 W Chisholm St', N'Alpena', N'MI', N'26007', N'49707', 45.077368, -83.449286, 1769, 148, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2722, N'Hillsdale Community Health Center', 1, NULL, NULL, N'230037', NULL, NULL, 0, 86, NULL, N'5174374451', N'5174370246', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'168 S Howell Street', N'Hillsdale', N'MI', N'26059', N'49242', 41.911717, -84.632722, 1807, 141, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2723, N'Spectrum Health - Butterworth Campus', 1, NULL, NULL, N'230038', NULL, NULL, 0, 634, NULL, N'6163911774', N'6163918729', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'100 Michigan St Ne', N'Grand Rapids', N'MI', N'26081', N'49503', 42.970427, -85.664874, 1800, 140, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2724, N'Pennock Hospital', 1, NULL, NULL, N'230040', NULL, NULL, 0, 89, NULL, N'2699453451', N'2699454130', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1009 W Green St', N'Hastings', N'MI', N'26015', N'49058', 42.644963, -85.302371, 1806, 140, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2725, N'Mclaren Bay Region', 1, NULL, NULL, N'230041', NULL, NULL, 0, 387, NULL, N'9898943000', N'9898918172', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1900 Columbus Ave', N'Bay City', N'MI', N'26017', N'48708', 43.586645, -83.867998, 1773, 148, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2726, N'University Of Michigan Health System', 1, NULL, NULL, N'230046', NULL, NULL, 0, 884, NULL, N'7347641505', N'7349360156', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1500 E Medical Center Drive Spc 5474', N'Ann Arbor', N'MI', N'26161', N'48109', 42.268157, -83.731229, 1770, 136, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2727, N'Henry Ford Macomb Hospital', 1, NULL, NULL, N'230047', NULL, NULL, 0, 350, NULL, N'5862632300', N'5862632255', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'15855 Nineteen Mile Rd', N'Clinton Township', N'MI', N'26099', N'48038', 42.58484, -82.934824, 1833, 138, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2728, N'Henry Ford Hospital', 1, NULL, NULL, N'230053', NULL, NULL, 0, 903, NULL, N'3139162600', N'3139168096', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2799 W Grand Blvd', N'Detroit', N'MI', N'26163', N'48202', 42.36708, -83.081557, 1789, 138, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2729, N'Marquette General Hospital', 1, NULL, NULL, N'230054', NULL, NULL, 0, 289, NULL, N'9062289440', N'9062253032', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'420 W Magnetic', N'Marquette', N'MI', N'26103', N'49855', 46.543491, -87.396433, 1828, 143, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2730, N'Dickinson County Memorial Hospital', 1, NULL, NULL, N'230055', NULL, NULL, 0, 96, NULL, N'9067741313', N'9067765427', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1721 S Stephenson Ave', N'Iron Mountain', N'MI', N'26043', N'49801', 45.809646, -88.044596, 1811, 299, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2731, N'Munson Healthcare Grayling Hospital', 1, NULL, NULL, N'230058', NULL, NULL, 0, 90, NULL, N'9893485461', N'9893480477', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1100 E Michigan Ave', N'Grayling', N'MI', N'26039', N'49738', 44.662154, -84.713776, 1801, 150, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2732, N'Saint Mary''s Health Care', 1, NULL, NULL, N'230059', NULL, NULL, 0, 230, NULL, N'6166855000', N'6166856151', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'200 Jefferson Avenue Se', N'Grand Rapids', N'MI', N'26081', N'49503', 42.958373, -85.662803, 1800, 140, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2733, N'Mercy Health Hackley Campus', 1, NULL, NULL, N'230066', NULL, NULL, 0, 154, NULL, N'2317263511', N'2317285818', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1700 Clinton Street', N'Muskegon', N'MI', N'26121', N'49442', 43.222403, -86.242192, 1836, 144, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2734, N'Saint Joseph Mercy Livingston Hospital', 1, NULL, NULL, N'230069', NULL, NULL, 0, 136, NULL, N'5175456000', N'5175456192', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'620 Byron Rd', N'Howell', N'MI', N'26093', N'48843', 42.615389, -83.94139, 1809, 136, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2735, N'Covenant Medical Center Inc', 1, NULL, NULL, N'230070', NULL, NULL, 0, 623, NULL, N'9895834000', N'9895832727', 1, 1, 0, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1447 N Harrison', N'Saginaw', N'MI', N'26145', N'48602', 43.420039, -83.949036, 1850, 148, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2736, N'Straith Hospital For Special Surgery', 1, NULL, NULL, N'230071', NULL, NULL, 0, 34, NULL, N'2483573360', N'2483570915', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'23901 Lahser', N'Southfield', N'MI', N'26125', N'48033', 42.4646, -83.261523, 1855, 147, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2737, N'Holland Community Hospital', 1, NULL, NULL, N'230072', NULL, NULL, 0, 193, NULL, N'6163925141', N'6163943477', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'602 Michigan Ave', N'Holland', N'MI', N'26139', N'49423', 42.774949, -86.112684, 1808, 140, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2738, N'Bronson Battle Creek Hospital', 1, NULL, NULL, N'230075', NULL, NULL, 0, 204, NULL, N'2699668000', N'2699668008', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'300 North Avenue', N'Battle Creek', N'MI', N'26025', N'49017', 42.319255, -85.182427, 1772, 141, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2739, N'St Mary''s Of Michigan Medical Center', 1, NULL, NULL, N'230077', NULL, NULL, 0, 268, NULL, N'9897768000', N'9897761704', 1, 1, 1, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'800 S Washington Avenue', N'Saginaw', N'MI', N'26145', N'48601', 43.424724, -83.938888, 1850, 148, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2740, N'Lakeland Community Hospital Watervliet', 1, NULL, NULL, N'230078', NULL, NULL, 0, 62, NULL, N'2694633111', N'2694635550', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'400 Medical Park Dr', N'Watervliet', N'MI', N'26021', N'49098', 42.186705, -86.260578, 1869, 149, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2741, N'Mclaren Central Michigan', 1, NULL, NULL, N'230080', NULL, NULL, 0, 151, NULL, N'9897726700', N'9897721150', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1221 South Drive', N'Mount Pleasant', N'MI', N'26073', N'48858', 43.598645, -84.76061, 1834, 142, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2742, N'Munson Healthcare Cadillac Hospital', 1, NULL, NULL, N'230081', NULL, NULL, 0, 117, NULL, N'2318767200', N'2318767239', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'400 Hobart St', N'Cadillac', N'MI', N'26165', N'49601', 44.246237, -85.390437, 1776, 140, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2743, N'South Haven Community Hospital', 1, NULL, NULL, N'230085', NULL, NULL, 0, 82, NULL, N'2696375271', N'2696392818', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'955 S Bailey Ave', N'South Haven', N'MI', N'26159', N'49090', 42.403087, -86.273641, 1854, 149, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2744, N'Beaumont Hospital Grosse Pointe', 1, NULL, NULL, N'230089', NULL, NULL, 0, 311, NULL, N'3133431000', N'3133431509', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'468 Cadieux Rd', N'Grosse Pointe', N'MI', N'26163', N'48230', 42.386149, -82.911859, 1803, 138, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2745, N'Allegiance Health', 1, NULL, NULL, N'230092', NULL, NULL, 0, 412, NULL, N'5177884800', N'5177884829', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'205 N East Ave', N'Jackson', N'MI', N'26075', N'49201', 32.410438, -90.162065, 1815, 136, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2746, N'Spectrum Health Big Rapids Hospital', 1, NULL, NULL, N'230093', NULL, NULL, 0, 74, NULL, N'2317968691', N'2315924421', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'605 Oak Street', N'Big Rapids', N'MI', N'26107', N'49307', 43.69503, -85.474451, 1775, 140, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2747, N'West Branch Regional Medical Center', 1, NULL, NULL, N'230095', NULL, NULL, 0, 88, NULL, N'9893456366', N'9893433113', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2463 South M-30', N'West Branch', N'MI', N'26129', N'48661', 44.276408, -84.238613, 1871, 148, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2748, N'Sturgis Hospital', 1, NULL, NULL, N'230096', NULL, NULL, 0, 94, NULL, N'2696517824', N'2696594493', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'916 Myrtle Ave', N'Sturgis', N'MI', N'26149', N'49091', 41.794902, -85.407238, 1860, 141, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2749, N'Munson Medical Center', 1, NULL, NULL, N'230097', NULL, NULL, 0, 377, NULL, N'2319355000', N'2319356548', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1105 Sixth Street', N'Traverse City', N'MI', N'26055', N'49684', 44.760906, -85.642541, 1865, 150, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2750, N'Promedica Monroe Regional Hospital', 1, NULL, NULL, N'230099', NULL, NULL, 0, 217, NULL, N'7342408400', N'7342404424', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'718 N Macomb St', N'Monroe', N'MI', N'26115', N'48162', 41.924612, -83.388094, 1832, 216, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2751, N'Tawas St Joseph Hospital', 1, NULL, NULL, N'230100', NULL, NULL, 0, 60, NULL, N'9893629301', N'5173627277', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'200 Hemlock', N'Tawas City', N'MI', N'26069', N'48764', 44.275246, -83.509683, 1861, 148, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2752, N'Harper University Hospital', 1, NULL, NULL, N'230104', NULL, NULL, 0, 712, NULL, N'3137456211', N'3137451520', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3990 John R Street', N'Detroit', N'MI', N'26163', N'48201', 42.350854, -83.057485, 1789, 138, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2753, N'Mclaren - Northern Michigan', 1, NULL, NULL, N'230105', NULL, NULL, 0, 243, NULL, N'2314874000', N'2314874552', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'416 Connable Ave', N'Petoskey', N'MI', N'26047', N'49770', 45.37292, -84.97083, 1843, 145, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2754, N'Portage Health', 1, NULL, NULL, N'230108', NULL, NULL, 0, 36, NULL, N'9064831000', N'9064831521', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'500 Campus Drive', N'Hancock', N'MI', N'26061', N'49930', 47.139951, -88.586805, 1804, 143, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2755, N'Memorial Medical Center Of West Michigan', 1, NULL, NULL, N'230110', NULL, NULL, 0, 81, NULL, N'2318432591', N'2318453607', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1 N Atkinson Drive', N'Ludington', N'MI', N'26105', N'49431', 43.958398, -86.430486, 1823, 144, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2756, N'Borgess Medical Center', 1, NULL, NULL, N'230117', NULL, NULL, 0, 372, NULL, N'2692267000', N'2692267396', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1521 Gull Road', N'Kalamazoo', N'MI', N'26077', N'49048', 42.30784, -85.559818, 1816, 141, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2757, N'Huron Medical Center', 1, NULL, NULL, N'230118', NULL, NULL, 0, 64, NULL, N'9892699521', N'9892695260', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1100 South Van Dyke Road', N'Bad Axe', N'MI', N'26063', N'48413', 43.801959, -83.000777, 1771, 148, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2758, N'Memorial Healthcare', 1, NULL, NULL, N'230121', NULL, NULL, 0, 115, NULL, N'9897235211', N'9897257902', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'826 West King Street', N'Owosso', N'MI', N'26155', N'48867', 43.005133, -84.181039, 1841, 142, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2759, N'Berrien General Hospital', 1, NULL, NULL, N'230125', NULL, NULL, 0, 55, NULL, N'6164717761', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6418 Deans Hill Rd', N'Berrien Center', N'MI', N'26021', N'49102', 41.955414, -86.301605, 1774, 149, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2760, N'Beaumont Hospital Royal Oak', 1, NULL, NULL, N'230130', NULL, NULL, 0, 1031, NULL, N'2488985000', N'2488985418', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3601 W Thirteen Mile Rd', N'Royal Oak', N'MI', N'26125', N'48073', 42.48948, -83.144648, 1849, 147, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2761, N'Hurley Medical Center', 1, NULL, NULL, N'230132', NULL, NULL, 0, 383, NULL, N'8102579000', N'8102579003', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'One Hurley Plaza', N'Flint', N'MI', N'26049', N'48503', 43.017177, -83.723602, 1793, 139, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2762, N'Otsego Memorial Hospital', 1, NULL, NULL, N'230133', NULL, NULL, 0, 53, NULL, N'9897312100', N'9897312217', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'825 N Center Ave', N'Gaylord', N'MI', N'26137', N'49735', 45.035297, -84.675526, 1797, 145, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2763, N'Mclaren Flint', 1, NULL, NULL, N'230141', NULL, NULL, 0, 368, NULL, N'8103422000', N'8103422428', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'401 S Ballenger Highway', N'Flint', N'MI', N'26049', N'48532', 43.013852, -83.732617, 1793, 139, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2764, N'Oakwood Hospital - Wayne', 1, NULL, NULL, N'230142', NULL, NULL, 0, 259, NULL, N'7344674175', N'7344674017', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'33155 Annapolis Ave', N'Wayne', N'MI', N'26163', N'48184', 42.281427, -83.386321, 1870, 136, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2765, N'Forest Health Medical Center', 1, NULL, NULL, N'230144', NULL, NULL, 0, 148, NULL, N'7345474700', N'7435474795', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'135 S Prospect St', N'Ypsilanti', N'MI', N'26161', N'48198', 42.238575, -83.601815, 1770, 136, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2766, N'Henry Ford Wyandotte Hospital', 1, NULL, NULL, N'230146', NULL, NULL, 0, 345, NULL, N'7342466000', N'7342468860', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2333 Biddle Ave', N'Wyandotte', N'MI', N'26163', N'48192', 42.210659, -83.148922, 1872, 137, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2767, N'Botsford Hospital', 1, NULL, NULL, N'230151', NULL, NULL, 0, 305, NULL, N'2484718000', N'2484718807', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'28050 Grand River Avenue', N'Farmington Hills', N'MI', N'26125', N'48336', 42.446432, -83.323021, 1792, 136, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2768, N'St Joseph Mercy Hospital', 1, NULL, NULL, N'230156', NULL, NULL, 0, 505, NULL, N'7347123456', N'7347125459', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5301 E Huron River Dr', N'Ann Arbor', N'MI', N'26161', N'48106', 42.265152, -83.683074, 1770, 136, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2769, N'St John Hospital And Medical Center', 1, NULL, NULL, N'230165', NULL, NULL, 0, 625, NULL, N'3133434000', N'3133437533', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'22101 Moross Rd', N'Detroit', N'MI', N'26163', N'48236', 42.419472, -82.913222, 1803, 138, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2770, N'Mclaren - Greater Lansing', 1, NULL, NULL, N'230167', NULL, NULL, 0, 363, NULL, N'5179756000', N'5179757560', 1, 1, 0, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'401 W Greenlawn Ave', N'Lansing', N'MI', N'26065', N'48910', 42.704959, -84.55757, 1819, 142, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2771, N'North Ottawa Community Health Center', 1, NULL, NULL, N'230174', NULL, NULL, 0, 81, NULL, N'6168423600', N'6168475621', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1309 Sheldon Rd', N'Grand Haven', N'MI', N'26139', N'49417', 43.050681, -86.228028, 1799, 144, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2772, N'Oakwood Hospital - Southshore', 1, NULL, NULL, N'230176', NULL, NULL, 0, 195, NULL, N'7346713800', N'7346713891', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5450 Fort Street', N'Trenton', N'MI', N'26163', N'48183', 42.13644, -83.194265, 1866, 137, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2773, N'Midmichigan Medical Center-Clare', 1, NULL, NULL, N'230180', NULL, NULL, 0, 64, NULL, N'9898025000', N'9898028800', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'703 N Mcewan St', N'Clare', N'MI', N'26035', N'48617', 43.81947, -84.768628, 1784, 142, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2774, N'Mclaren Lapeer Region', 1, NULL, NULL, N'230193', NULL, NULL, 0, 183, NULL, N'8106675500', N'8106675524', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1375 N Main St', N'Lapeer', N'MI', N'26087', N'48446', 43.058857, -83.31908, 1820, 139, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2775, N'St John Macomb-Oakland Hospital-Macomb Center', 1, NULL, NULL, N'230195', NULL, NULL, 0, 348, NULL, N'5865735000', N'5865735541', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'11800 East Twelve Mile Road', N'Warren', N'MI', N'26099', N'48093', 42.477536, -83.0277, 1868, 138, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2776, N'Genesys Regional Medical Center - Health Park', 1, NULL, NULL, N'230197', NULL, NULL, 0, 410, NULL, N'8106065000', N'8106066605', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'One Genesys Parkway', N'Grand Blanc', N'MI', N'26049', N'48439', 42.927528, -83.629952, 1793, 139, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2777, N'Mclaren Oakland', 1, NULL, NULL, N'230207', NULL, NULL, 0, 308, NULL, N'2483385000', N'2483385667', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'50 North Perry', N'Pontiac', N'MI', N'26125', N'48342', 42.638922, -83.291047, 1845, 146, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2778, N'Carson City Hospital', 1, NULL, NULL, N'230208', NULL, NULL, 0, 103, NULL, N'9895843131', N'9895843163', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'406 East Elm St', N'Carson City', N'MI', N'26117', N'48811', 43.175896, -84.84176, 1778, 142, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2779, N'Port Huron Hospital', 1, NULL, NULL, N'230216', NULL, NULL, 0, 163, NULL, N'8109875000', N'8109852675', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1221 Pine Grove Ave', N'Port Huron', N'MI', N'26147', N'48060', 42.987854, -82.429782, 1846, 138, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2780, N'Oaklawn Hospital', 1, NULL, NULL, N'230217', NULL, NULL, 0, 94, NULL, N'2697814271', N'2697817117', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'200 N Madison', N'Marshall', N'MI', N'26025', N'49068', 42.272036, -84.957764, 1829, 141, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2781, N'Midmichigan Medical Center-Midland', 1, NULL, NULL, N'230222', NULL, NULL, 0, 230, NULL, N'9898393000', N'9898393528', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4000 Wellness Drive', N'Midland', N'MI', N'26111', N'48670', 43.63503, -84.260453, 1830, 148, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2782, N'Mclaren Macomb', 1, NULL, NULL, N'230227', NULL, NULL, 0, 288, NULL, N'5864938000', N'5864938700', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1000 Harrington Blvd', N'Mount Clemens', N'MI', N'26099', N'48043', 42.597256, -82.877975, 1833, 138, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2783, N'Edward W Sparrow Hospital', 1, NULL, NULL, N'230230', NULL, NULL, 0, 617, NULL, N'5173641000', N'5173646009', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1215 E Michigan Avenue', N'Lansing', N'MI', N'26065', N'48912', 42.733672, -84.534944, 1819, 142, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2784, N'Metro Health Hospital', 1, NULL, NULL, N'230236', NULL, NULL, 0, 208, NULL, N'6162527200', N'6162520788', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5900 Byron Center Avenue Sw', N'Wyoming', N'MI', N'26081', N'49519', 42.857365, -85.717486, 1800, 140, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2785, N'Chippewa County War Memorial Hospital', 1, NULL, NULL, N'230239', NULL, NULL, 0, 82, NULL, N'9066354460', N'9066354467', 1, 1, 0, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'500 Osborn Blvd', N'Sault Sainte Marie', N'MI', N'26033', N'49783', 46.497541, -84.351505, 1853, 145, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2786, N'St John River District Hospital', 1, NULL, NULL, N'230241', NULL, NULL, 0, 68, NULL, N'8103297111', N'8103298920', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4100 River Rd', N'East China', N'MI', N'26147', N'48054', 43.621196, -84.682435, 1856, 138, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2787, N'Garden City Hospital', 1, NULL, NULL, N'230244', NULL, NULL, 0, 323, NULL, N'7344213300', N'7344213530', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6245 Inkster Rd', N'Garden City', N'MI', N'26163', N'48135', 42.325593, -83.331042, 1796, 137, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2788, N'Crittenton Hospital Medical Center', 1, NULL, NULL, N'230254', NULL, NULL, 0, 290, NULL, N'2486525000', N'2486525424', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1101 W University Drive', N'Rochester', N'MI', N'26125', N'48307', 42.678521, -83.14916, 1848, 147, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2789, N'St Joseph Mercy Chelsea', 1, NULL, NULL, N'230259', NULL, NULL, 0, 83, NULL, N'7344753911', N'7344754066', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'775 S Main St', N'Chelsea', N'MI', N'26161', N'48118', 42.310339, -84.015888, 1783, 136, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2790, N'Southeast Michigan Surgical Hospital', 1, NULL, NULL, N'230264', NULL, NULL, 0, 20, NULL, N'5864271000', N'5867590237', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'21230 Dequindre Road', N'Warren', N'MI', N'26099', N'48091', 42.477536, -83.0277, 1868, 138, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2791, N'Beaumont Hospital Troy', 1, NULL, NULL, N'230269', NULL, NULL, 0, 254, NULL, N'2489648800', N'2489648842', 1, 1, 0, 0, 1, 1, 0, 0, 0, 0, 0, 0, NULL, NULL, N'44201 Dequindre Road', N'Troy', N'MI', N'26125', N'48085', 42.563843, -83.088776, 1867, 147, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2792, N'Oakwood Hospital - Taylor', 1, NULL, NULL, N'230270', NULL, NULL, 0, 163, NULL, N'3132955253', N'3132955085', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'10000 Telegraph Road', N'Taylor', N'MI', N'26163', N'48180', 42.237076, -83.269924, 1862, 137, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2793, N'Detroit Receiving Hospital & Univ Health Center', 1, NULL, NULL, N'230273', NULL, NULL, 0, 320, NULL, N'3137453104', N'3139667206', 1, 1, 1, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4201 St Antoine St - 3M', N'Detroit', N'MI', N'26163', N'48201', 42.348664, -83.056737, 1789, 138, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2794, N'Healthsource Saginaw', 1, NULL, NULL, N'230275', NULL, NULL, 0, 278, NULL, N'9897907888', N'9897909297', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3340 Hospital Road', N'Saginaw', N'MI', N'26145', N'48603', 43.454812, -84.050137, 1850, 148, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2795, N'Huron Valley-Sinai Hospital', 1, NULL, NULL, N'230277', NULL, NULL, 0, 153, NULL, N'2489373370', N'2489373378', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'One William Carls Drive', N'Commerce Township', N'MI', N'26125', N'48382', 42.569521, -83.49969, 1831, 146, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2796, N'Brighton Hospital', 1, NULL, NULL, N'230279', NULL, NULL, 0, 63, NULL, N'8102271211', N'8102271869', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'12851 Grand River Rd', N'Brighton', N'MI', N'26093', N'48116', 42.531676, -83.784449, 1770, 136, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2797, N'Karmanos Cancer Center', 1, NULL, NULL, N'230297', NULL, NULL, 0, 123, NULL, N'8005766266', N'3135768661', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4100 John R', N'Detroit', N'MI', N'26163', N'48201', 42.348664, -83.056737, 1789, 138, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2798, N'Oakland Regional Hospital', 1, NULL, NULL, N'230301', NULL, NULL, 0, 45, NULL, N'2484235100', N'2484231467', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'22401 Foster Winter Drive', N'Southfield', N'MI', N'26125', N'48075', 42.457328, -83.202554, 1855, 147, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2799, N'Henry Ford West Bloomfield Hospital', 1, NULL, NULL, N'230302', NULL, NULL, 0, 191, NULL, N'2483251000', N'2486616494', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6777 West Maple Road', N'West Bloomfield', N'MI', N'26125', N'48322', 43.621196, -84.682435, 1849, 147, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2800, N'West Shore Medical Center', 1, NULL, NULL, N'230303', NULL, NULL, 0, 25, NULL, N'2313981000', N'2313981098', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1465 E Parkdale Ave', N'Manistee', N'MI', N'26101', N'49660', 44.271362, -86.274838, 1825, 150, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2801, N'Pioneer Specialty Hospital', 1, NULL, NULL, N'230304', NULL, NULL, 0, 30, NULL, N'2485931990', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'50 North Perry', N'Pontiac', N'MI', N'26125', N'48342', 42.638922, -83.291047, 1845, 146, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2802, N'Paul Oliver Memorial Hospital', 1, NULL, NULL, N'231300', NULL, NULL, 0, 8, NULL, N'2313522200', N'2313526141', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'224 Park Avenue', N'Frankfort', N'MI', N'26019', N'49635', 44.636832, -86.242388, 1794, 150, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2803, N'Kalkaska Memorial Health Center', 1, NULL, NULL, N'231301', NULL, NULL, 0, 8, NULL, N'2312587500', N'2312587527', 1, 1, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'419 S Coral', N'Kalkaska', N'MI', N'26079', N'49646', 44.734173, -85.175887, 1865, 150, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2804, N'Schoolcraft Memorial Hospital', 1, NULL, NULL, N'231303', NULL, NULL, 0, 25, NULL, N'9063413200', N'9063413297', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7870W Us Highway 2', N'Manistique', N'MI', N'26153', N'49854', 45.957751, -86.246252, 1826, 143, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2805, N'Helen Newberry Joy Hospital', 1, NULL, NULL, N'231304', NULL, NULL, 0, 25, NULL, N'9062939200', N'9062939208', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'502 W Harrie St', N'Newberry', N'MI', N'26095', N'49868', 46.353262, -85.515456, 1837, 143, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2806, N'Saint Mary''s Standish Community Hospital', 1, NULL, NULL, N'231305', NULL, NULL, 0, 25, NULL, N'5178464521', N'9898463549', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'805 W Cedar St', N'Standish', N'MI', N'26011', N'48658', 43.981438, -83.969065, 1859, 148, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2807, N'Mackinac Straits Hospital And Health Center', 1, NULL, NULL, N'231306', NULL, NULL, 0, 15, NULL, N'9066438585', N'9066430373', 1, 1, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1140 N State Street', N'Saint Ignace', N'MI', N'26097', N'49781', 45.890683, -84.728961, 1843, 145, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2808, N'Baraga County Memorial Hospital', 1, NULL, NULL, N'231307', NULL, NULL, 0, 24, NULL, N'9065243300', N'9065245466', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'18341 Us Highway 41', N'L'' Anse', N'MI', N'26013', N'49946', 43.621196, -84.682435, 1817, 143, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2809, N'Munising Memorial Hospital', 1, NULL, NULL, N'231308', NULL, NULL, 0, 25, NULL, N'9063874110', N'9063874649', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1500 Sand Point Rd', N'Munising', N'MI', N'26003', N'49862', 46.42516, -86.625267, 1835, 143, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2810, N'Aspirus Ontonagon Hospital Inc', 1, NULL, NULL, N'231309', NULL, NULL, 0, 25, NULL, N'9068848000', N'9068844384', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'601 S Seventh St', N'Ontonagon', N'MI', N'26131', N'49953', 46.871053, -89.31403, 1840, 143, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2811, N'Scheurer Hospital', 1, NULL, NULL, N'231310', NULL, NULL, 0, 25, NULL, N'9894533223', N'9894534451', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'170 N Caseville Rd', N'Pigeon', N'MI', N'26063', N'48755', 43.830338, -83.270837, 1844, 148, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2812, N'Deckerville Community Hospital', 1, NULL, NULL, N'231311', NULL, NULL, 0, 15, NULL, N'8103762835', N'8103764978', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3559 Pine St', N'Deckerville', N'MI', N'26151', N'48427', 43.527924, -82.733899, 1788, 148, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2813, N'Sheridan Community Hospital', 1, NULL, NULL, N'231312', NULL, NULL, 0, 25, NULL, N'9892913261', N'9892913062', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'301 N Main St', N'Sheridan', N'MI', N'26117', N'48884', 43.215795, -85.07364, 1800, 140, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2814, N'Harbor Beach Community Hospital', 1, NULL, NULL, N'231313', NULL, NULL, 0, 17, NULL, N'9894793201', N'9894795003', 1, 1, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'210 S First St', N'Harbor Beach', N'MI', N'26063', N'48441', 43.844737, -82.651319, 1805, 148, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2815, N'Mckenzie Health System', 1, NULL, NULL, N'231314', NULL, NULL, 0, 25, NULL, N'8106483770', N'8106485058', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'120 N Delaware Street', N'Sandusky', N'MI', N'26151', N'48471', 43.423002, -82.832888, 1852, 148, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2816, N'Borgess-Lee Memorial Hospital', 1, NULL, NULL, N'231315', NULL, NULL, 0, 25, NULL, N'2697828681', N'2697833097', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'420 W High Street', N'Dowagiac', N'MI', N'26027', N'49047', 41.983397, -86.115392, 1790, 141, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2817, N'Hills & Dales General Hospital', 1, NULL, NULL, N'231316', NULL, NULL, 0, 25, NULL, N'9898722121', N'9898725376', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4675 Hill Street', N'Cass City', N'MI', N'26157', N'48726', 43.604348, -83.181282, 1779, 148, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2818, N'Spectrum Health Kelsey Hospital', 1, NULL, NULL, N'231317', NULL, NULL, 0, 25, NULL, N'9893527211', N'9893526435', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'418 Washington', N'Lakeview', N'MI', N'26117', N'48850', 43.440104, -85.276728, 1818, 140, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2819, N'Northstar Health System', 1, NULL, NULL, N'231318', NULL, NULL, 0, 25, NULL, N'9062656121', N'9062650741', 1, 1, 0, 0, 0, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1400 W Ice Lake Road', N'Iron River', N'MI', N'26071', N'49935', 46.099876, -88.61924, 1812, 143, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2820, N'Aspirus Keweenaw Hospital', 1, NULL, NULL, N'231319', NULL, NULL, 0, 25, NULL, N'9063376500', N'9063376540', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'205 Osceola', N'Laurium', N'MI', N'26061', N'49913', 47.238889, -88.443333, 1821, 143, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2821, N'Mercy Health Lakeshore Campus', 1, NULL, NULL, N'231320', NULL, NULL, 0, 24, NULL, N'2318612156', N'2318613028', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'72 South State Street', N'Shelby', N'MI', N'26127', N'49455', 43.60705, -86.364514, 1836, 144, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2822, N'Bell Hospital', 1, NULL, NULL, N'231321', NULL, NULL, 0, 25, NULL, N'9064864431', N'9064866898', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'901 Lakeshore Drive', N'Ishpeming', N'MI', N'26103', N'49849', 46.505197, -87.68433, 1814, 143, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2823, N'Charlevoix Area Hospital', 1, NULL, NULL, N'231322', NULL, NULL, 0, 25, NULL, N'2315474024', N'2315478080', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'14700 Lakeshore Drive', N'Charlevoix', N'MI', N'26029', N'49720', 45.206769, -85.387035, 1780, 145, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2824, N'Spectrum Health Reed City Hospital', 1, NULL, NULL, N'231323', NULL, NULL, 0, 25, NULL, N'2318323271', N'2318321817', 1, 1, 0, 0, 1, 1, 0, 0, 0, 0, 0, 0, NULL, NULL, N'300 N Patterson Po Box 75', N'Reed City', N'MI', N'26133', N'49677', 43.875017, -85.51005, 1847, 140, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2825, N'Eaton Rapids Medical Center', 1, NULL, NULL, N'231324', NULL, NULL, 0, 25, NULL, N'5176632671', N'5176632472', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1500 S Main Street', N'Eaton Rapids', N'MI', N'26045', N'48827', 42.496701, -84.65738, 1819, 142, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2826, N'Midmichigan Medical Center-Gladwin', 1, NULL, NULL, N'231325', NULL, NULL, 0, 25, NULL, N'9894269286', N'9892466400', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'515 Quarter Street', N'Gladwin', N'MI', N'26051', N'48624', 43.976136, -84.493946, 1798, 148, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2827, N'Sparrow Clinton Hospital', 1, NULL, NULL, N'231326', NULL, NULL, 0, 25, NULL, N'9892246881', N'9892248744', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'805 S Oakland', N'Saint Johns', N'MI', N'26037', N'48879', 43.000928, -84.55851, 1857, 142, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2828, N'Hayes Green Beach Memorial Hospital', 1, NULL, NULL, N'231327', NULL, NULL, 0, 25, NULL, N'5175431050', N'5175410875', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'321 E Harris Street', N'Charlotte', N'MI', N'26045', N'48813', 42.564965, -84.831463, 1781, 142, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2829, N'Allegan General Hospital', 1, NULL, NULL, N'231328', NULL, NULL, 0, 25, NULL, N'2696864101', N'2696738179', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'555 Linn Street', N'Allegan', N'MI', N'26005', N'49010', 42.52141, -85.856338, 1767, 141, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2830, N'Caro Community Hospital', 1, NULL, NULL, N'231329', NULL, NULL, 0, 25, NULL, N'9896733141', N'9896738471', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'401 N Hooper Street', N'Caro', N'MI', N'26157', N'48723', 43.493238, -83.408191, 1777, 148, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2831, N'Marlette Regional Hospital', 1, NULL, NULL, N'231330', NULL, NULL, 0, 25, NULL, N'9896354000', N'9896355358', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2770 Main Street', N'Marlette', N'MI', N'26151', N'48453', 43.330317, -83.080063, 1827, 148, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2832, N'Sparrow Ionia Hospital', 1, NULL, NULL, N'231331', NULL, NULL, 0, 25, NULL, N'6165274200', N'6165275731', 1, 1, 0, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'520 E Washington Street', N'Ionia', N'MI', N'26067', N'48846', 42.984766, -85.051209, 1810, 140, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2833, N'Bronson Lakeview Hospital', 1, NULL, NULL, N'231332', NULL, NULL, 0, 25, NULL, N'2696571400', N'2696572278', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'408 Hazen Street', N'Paw Paw', N'MI', N'26159', N'49079', 42.221164, -85.897042, 1842, 141, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2834, N'Aspirus Grand View Hospital', 1, NULL, NULL, N'231333', NULL, NULL, 0, 25, NULL, N'9069322525', N'9069322290', 1, 1, 0, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'N10561 Grand View Lane', N'Ironwood', N'MI', N'26053', N'49938', 46.454571, -90.168582, 1813, 151, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2835, N'Promedica Herrick Hospital', 1, NULL, NULL, N'231334', NULL, NULL, 0, 25, NULL, N'5174243000', N'5174243916', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'500 E Pottawatamie Street', N'Tecumseh', N'MI', N'26091', N'49286', 42.002189, -83.93703, 1863, 136, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2836, N'St Francis Hospital', 1, NULL, NULL, N'231337', NULL, NULL, 0, 25, NULL, N'9067863311', N'9067864004', 1, 1, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3401 Ludington St', N'Escanaba', N'MI', N'26041', N'49829', 45.742775, -87.096026, 1791, 143, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2837, N'Spectrum Health Gerber Memorial', 1, NULL, NULL, N'231338', NULL, NULL, 0, 61, NULL, N'2319243300', N'2319241320', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'212 S Sullivan St', N'Fremont', N'MI', N'26123', N'49412', 43.467517, -85.942001, 1795, 140, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2838, N'Select Specialty Hospital-Flint', 1, NULL, NULL, N'232012', NULL, NULL, 0, 36, NULL, N'8103424550', N'8103424517', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'401 S Ballenger 5Th Floor', N'Flint', N'MI', N'26049', N'48532', 43.017177, -83.723602, 1793, 139, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2839, N'Vibra Of Southeastern Michigan', 1, NULL, NULL, N'232019', NULL, NULL, 0, 220, NULL, N'3135946000', N'3135946252', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'26400 W Outer Drive', N'Lincoln Park', N'MI', N'26163', N'48146', 42.261974, -83.167005, 1872, 137, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2840, N'Mclaren Bay Special Care Hospital', 1, NULL, NULL, N'232020', NULL, NULL, 0, 31, NULL, N'9896676802', N'9896676809', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3250 E Midland Rd Suite 1', N'Bay City', N'MI', N'26017', N'48706', 43.594468, -83.888865, 1773, 148, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2841, N'Great Lakes Specialty Hospital - Muskegon', 1, NULL, NULL, N'232021', NULL, NULL, 0, 31, NULL, N'2317285800', N'2317285820', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1700 Clinton Street 2 South And 3 South Floors', N'Muskegon', N'MI', N'26121', N'49442', 43.234181, -86.248392, 1836, 144, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2842, N'Select Specialty Hospital-Macomb County', 1, NULL, NULL, N'232023', NULL, NULL, 0, 36, NULL, N'5863079000', N'5863079001', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'215 North Ave Suite 200', N'Mount Clemens', N'MI', N'26099', N'48043', 42.597256, -82.877975, 1833, 138, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2843, N'Select Specialty Hospital-Ann Arbor', 1, NULL, NULL, N'232024', NULL, NULL, 0, 36, NULL, N'7347120500', N'7347120505', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5301 E Huron River Dr 7Th Fl', N'Ypsilanti', N'MI', N'26161', N'48197', 42.24115, -83.612994, 1770, 136, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2844, N'Great Lakes Specialty Hospital - Grand Rapids', 1, NULL, NULL, N'232026', NULL, NULL, 0, 20, NULL, N'2316726202', N'2316726358', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'200 Se Jefferson 5Th Floor', N'Grand Rapids', N'MI', N'26081', N'49503', 42.96336, -85.668086, 1800, 140, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2845, N'Kindred Hospital Detroit', 1, NULL, NULL, N'232027', NULL, NULL, 0, 77, NULL, N'3133695800', N'3133695876', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4777 E Outer Drive', N'Detroit', N'MI', N'26163', N'48234', 42.442138, -83.019793, 1789, 138, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2846, N'Spectrum Health Kent Community Campus', 1, NULL, NULL, N'232029', NULL, NULL, 0, 146, NULL, N'6164862453', N'6164862555', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'750 Fuller Ave Ne', N'Grand Rapids', N'MI', N'26081', N'49503', 42.973663, -85.63977, 1800, 140, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2847, N'Select Specialty Hospital-Pontiac', 1, NULL, NULL, N'232030', NULL, NULL, 0, 30, NULL, N'2484525200', N'2484525201', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'44405 Woodward Avenue 8Th Floor', N'Pontiac', N'MI', N'26125', N'48341', 42.638922, -83.291047, 1845, 146, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2848, N'Select Specialty Hospital-Wyandotte Llc', 1, NULL, NULL, N'232031', NULL, NULL, 0, 40, NULL, N'3133757075', N'3133757120', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2333 Biddle Avenue 8Th Floor', N'Wyandotte', N'MI', N'26163', N'48192', 42.200662, -83.151016, 1872, 137, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2849, N'Select Specialty Hospital-Northwest Detroit', 1, NULL, NULL, N'232032', NULL, NULL, 0, 36, NULL, N'3139663939', N'3139666137', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6071 West Outer Drive 7Th Floor', N'Detroit', N'MI', N'26163', N'48235', 42.348664, -83.056737, 1789, 138, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2850, N'Select Specialty Hospital-Saginaw', 1, NULL, NULL, N'232033', NULL, NULL, 0, 32, NULL, N'9895834667', N'9895834895', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1447 North Harrison 7Th & 8Th Floor', N'Saginaw', N'MI', N'26145', N'48602', 43.420039, -83.949036, 1850, 148, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2851, N'Borgess Pipp Hospital', 1, NULL, NULL, N'232034', NULL, NULL, 0, 43, NULL, N'2696850700', N'2696850800', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'411 Naomi Street', N'Plainwell', N'MI', N'26005', N'49080', 42.446954, -85.653941, 1816, 141, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2852, N'Select Specialty Hospital- Battle Creek', 1, NULL, NULL, N'232035', NULL, NULL, 0, 25, NULL, N'2692454675', N'2692454676', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'300 North Avenue 6Th Floor', N'Battle Creek', N'MI', N'26025', N'49016', 42.319255, -85.182427, 1772, 141, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2853, N'Carelink Of Jackson A Community-Owned Specialty H', 1, NULL, NULL, N'232036', NULL, NULL, 0, 64, NULL, N'5177964426', N'5177872480', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'110 N Elm Avenue', N'Jackson', N'MI', N'26075', N'49202', 42.281291, -84.384358, 1815, 136, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2854, N'Sparrow Specialty Hospital', 1, NULL, NULL, N'232037', NULL, NULL, 0, 36, NULL, N'5173646800', N'5173646874', 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'1215 E Michigan Ave 8W Sparrow Hospital Tower', N'Lansing', N'MI', N'26065', N'48912', 42.733771, -84.55538, 1819, 142, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2855, N'Select Specialty Hospital-Grosse Pointe', 1, NULL, NULL, N'232038', NULL, NULL, 0, 30, NULL, N'3136402220', N'3136402269', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'468 Cadieux Rd 3 Northeast', N'Grosse Pointe', N'MI', N'26163', N'48230', 42.386149, -82.911859, 1803, 138, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2856, N'Pioneer Specialty Hospital', 1, NULL, NULL, N'232039', NULL, NULL, 0, 30, NULL, N'2485931990', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'50 North Perry', N'Pontiac', N'MI', N'26125', N'48342', 42.638922, -83.291047, 1845, 146, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2857, N'Southwest Regional Rehabilitation Center', 1, NULL, NULL, N'233025', NULL, NULL, 0, 30, NULL, N'2699653206', N'2694414147', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'393 E Roosevelt Avenue', N'Battle Creek', N'MI', N'26025', N'49017', 42.339369, -85.178128, 1772, 141, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2858, N'Mary Free Bed Hospital & Rehabilitation Center', 1, NULL, NULL, N'233026', NULL, NULL, 0, 80, NULL, N'6162420300', N'6164543939', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'235 Wealthy Se', N'Grand Rapids', N'MI', N'26081', N'49503', 42.96336, -85.668086, 1800, 140, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2859, N'Rehabilitation Institute Of Michigan', 1, NULL, NULL, N'233027', NULL, NULL, 0, 94, NULL, N'3137459710', N'3137452376', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'261 Mack Blvd', N'Detroit', N'MI', N'26163', N'48201', 42.348664, -83.056737, 1789, 138, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2860, N'Children''s Hospital Of Michigan', 1, NULL, NULL, N'233300', NULL, NULL, 0, 228, NULL, N'3137455437', N'3139930389', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3901 Beaubien', N'Detroit', N'MI', N'26163', N'48201', 42.351743, -83.053884, 1789, 138, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2861, N'Pine Rest Christian Mental Health Services', 1, NULL, NULL, N'234006', NULL, NULL, 0, 118, NULL, N'6164555000', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'300 - 68Th Street Se', N'Grand Rapids', N'MI', N'26081', N'49548', 42.96336, -85.668086, 1800, 140, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2862, N'Henry Ford Kingswood Hospital', 1, NULL, NULL, N'234011', NULL, NULL, 0, 100, NULL, N'2486914868', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'10300 W Eight Mile Road', N'Ferndale', N'MI', N'26125', N'48220', 42.460592, -83.134648, 1849, 147, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2863, N'Harbor Oaks Hospital', 1, NULL, NULL, N'234021', NULL, NULL, 0, 64, NULL, N'5867255777', N'5867252080', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'35031 23 Mile Rd', N'New Baltimore', N'MI', N'26099', N'48047', 42.676069, -82.75636, 1833, 138, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2864, N'Havenwyck Hospital', 1, NULL, NULL, N'234023', NULL, NULL, 0, 120, NULL, N'2483739200', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1525 University Drive', N'Auburn Hills', N'MI', N'26125', N'48326', 42.669394, -83.234345, 1845, 146, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2865, N'Caro Center', 1, NULL, NULL, N'234025', NULL, NULL, 0, 208, NULL, N'9896733191', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2000 Chambers Box A', N'Caro', N'MI', N'26157', N'48723', 43.491132, -83.396897, 1777, 148, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2866, N'Kalamazoo Regional Psychiatric Hospital', 1, NULL, NULL, N'234026', NULL, NULL, 0, 210, NULL, N'2693373309', NULL, 1, 1, 1, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1312 Oakland Dr', N'Kalamazoo', N'MI', N'26077', N'49008', 42.279033, -85.605191, 1816, 141, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2867, N'Forest View Psychiatric Hospital', 1, NULL, NULL, N'234030', NULL, NULL, 0, 62, NULL, N'6169429610', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1055 Medical Park Se', N'Grand Rapids', N'MI', N'26081', N'49546', 42.96336, -85.668086, 1800, 140, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2868, N'Walter P Reuther Psychiatric Hospital', 1, NULL, NULL, N'234035', NULL, NULL, 0, 239, NULL, N'7343678400', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'30901 Palmer Rd', N'Westland', N'MI', N'26163', N'48185', 42.296559, -83.34556, 1870, 136, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2869, N'Bca Stonecrest Center', 1, NULL, NULL, N'234038', NULL, NULL, 0, 90, NULL, N'3132450600', N'3133728657', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'15000 Gratiot Avenue', N'Detroit', N'MI', N'26163', N'48205', 42.417651, -82.989157, 1789, 138, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2870, N'Samaritan Behavioral Center', 1, NULL, NULL, N'234040', NULL, NULL, 0, 55, NULL, N'3133447730', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5555 Conner Avenue Suite 3N', N'Detroit', N'MI', N'26163', N'48213', 42.348664, -83.056737, 1789, 138, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2871, N'The Center For Forensic Psychiatry', 1, NULL, NULL, N'234041', NULL, NULL, 0, 210, NULL, N'7344292531', N'7342954512', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'8303 Platt Road', N'Saline', N'MI', N'26161', N'48176', 42.166707, -83.781607, 1851, 136, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2872, N'The Behavioral Center Of Michigan', 1, NULL, NULL, N'234042', NULL, NULL, 0, 42, NULL, N'5862612266', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4050 E 12 Mile Road', N'Warren', N'MI', N'26099', N'48092', 42.505616, -83.067002, 1868, 138, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2873, N'Henry Ford Hospital', 1, NULL, NULL, N'239801', NULL, NULL, 0, 0, NULL, N'3139168058', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'2799 W Grand Blvd', N'Detroit', N'MI', N'26163', N'48202', 42.36708, -83.081557, 1789, 138, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2874, N'Childrens Of Mi Transplant', 1, NULL, NULL, N'239802', NULL, NULL, 0, 0, NULL, N'3137451401', N'3139930531', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'3901 Beaubien Blvd', N'Detroit', N'MI', N'26163', N'48201', 42.348664, -83.056737, 1789, 138, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2875, N'University Of Michigan Medical Center', 1, NULL, NULL, N'239803', NULL, NULL, 0, 0, NULL, N'7347644141', N'7346473417', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'1500 E Medical Ctr Dr 3868 Taubman Center Spc', N'Ann Arbor', N'MI', N'26161', N'48109', 42.268157, -83.731229, 1770, 136, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2876, N'St John Hospital - Transplant', 1, NULL, NULL, N'239804', NULL, NULL, 0, 0, NULL, N'3133433134', N'3133437349', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'22101 Moross', N'Detroit', N'MI', N'26163', N'48236', 42.419472, -82.913222, 1803, 138, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2877, N'Harper University Hospital', 1, NULL, NULL, N'239805', NULL, NULL, 0, 0, NULL, N'3137456211', N'3137451520', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'3990 John R', N'Detroit', N'MI', N'26163', N'48201', 42.348664, -83.056737, 1789, 138, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2878, N'Beaumont Health System', 1, NULL, NULL, N'239806', NULL, NULL, 0, 0, NULL, N'2485511033', N'2485512125', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'3601 W 13 Mile Rd', N'Royal Oak', N'MI', N'26125', N'48073', 42.514255, -83.192906, 1849, 147, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2879, N'Devos Childrens Hospital - Transplant Unit', 1, NULL, NULL, N'239807', NULL, NULL, 0, 0, NULL, N'6163919000', N'6163913105', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'100 Michigan Street Ne', N'Grand Rapids', N'MI', N'26081', N'49503', 42.970427, -85.664874, 1800, 140, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2880, N'Saint Mary''s Health Care', 1, NULL, NULL, N'239808', NULL, NULL, 0, 0, NULL, N'6167526889', N'6167327989', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'200 Jefferson St Se', N'Grand Rapids', N'MI', N'26081', N'49503', 42.96336, -85.668086, 1800, 140, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2881, N'Spectrum Health Adult Solid Organ Transplant Progr', 1, NULL, NULL, N'239809', NULL, NULL, 0, 0, NULL, N'6163910800', N'6163910801', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'100 Michigan St Ne Mc231', N'Grand Rapids', N'MI', N'26081', N'49503', 42.96336, -85.668086, 1800, 140, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2882, N'North Memorial Medical Center', 1, NULL, NULL, N'240001', NULL, NULL, 0, 518, NULL, N'7635205200', N'7635205006', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3300 Oakdale North', N'Robbinsdale', N'MN', N'27053', N'55422', 45.031696, -93.33532, 1960, 152, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2883, N'Essentia Health St Mary''s Medical Center', 1, NULL, NULL, N'240002', NULL, NULL, 0, 380, NULL, N'2187864000', N'2187864888', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'407 East Third Street', N'Duluth', N'MN', N'27137', N'55805', 46.772932, -92.125122, 1903, 151, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2884, N'Hennepin County Medical Center', 1, NULL, NULL, N'240004', NULL, NULL, 0, 894, NULL, N'6128733000', N'6129044214', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'701 Park Avenue', N'Minneapolis', N'MN', N'27053', N'55415', 44.972717, -93.262671, 1940, 152, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2885, N'Olmsted Medical Center', 1, NULL, NULL, N'240006', NULL, NULL, 0, 61, NULL, N'5072872761', N'5072872779', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1650 Fourth Street Southeast', N'Rochester', N'MN', N'27109', N'55904', 44.022621, -92.463009, 1961, 153, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2886, N'Mayo Clinic Hospital Rochester', 1, NULL, NULL, N'240010', NULL, NULL, 0, 2059, NULL, N'5072555123', N'5072556306', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1216 Second Street Southwest', N'Rochester', N'MN', N'27109', N'55902', 44.022621, -92.463009, 1961, 153, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2887, N'Northfield Hospital', 1, NULL, NULL, N'240014', NULL, NULL, 0, 37, NULL, N'5076461001', N'5076461392', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2000 North Avenue', N'Northfield', N'MN', N'27037', N'55057', 44.458204, -93.161159, 1948, 152, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2888, N'Mayo Clinic Health System In Red Wing', 1, NULL, NULL, N'240018', NULL, NULL, 0, 50, NULL, N'6512675000', N'6512675935', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'701 Hewitt Boulevard Po Box 95', N'Red Wing', N'MN', N'27049', N'55066', 44.562468, -92.533801, 1958, 153, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2889, N'Essentia Health Duluth', 1, NULL, NULL, N'240019', NULL, NULL, 0, 165, NULL, N'2187862646', N'2187865922', 1, 0, 0, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'502 East Second Street', N'Duluth', N'MN', N'27137', N'55805', 46.772932, -92.125122, 1903, 151, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2890, N'Cambridge Medical Center', 1, NULL, NULL, N'240020', NULL, NULL, 0, 1, NULL, N'7636897700', N'7636887941', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'701 South Dellwood Avenue', N'Cambridge', N'MN', N'27059', N'55008', 45.572741, -93.224392, 1892, 152, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2891, N'Sanford  Worthington Medical Center', 1, NULL, NULL, N'240022', NULL, NULL, 0, 48, NULL, N'5073723380', N'5073723240', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1018 Sixth Avenue Po Box 997', N'Worthington', N'MN', N'27105', N'56187', 43.620506, -95.595643, 1993, 247, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2892, N'Douglas County Hospital', 1, NULL, NULL, N'240030', NULL, NULL, 0, 127, NULL, N'3207621511', N'3207626120', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'111 17Th Avenue East', N'Alexandria', N'MN', N'27041', N'56308', 45.873364, -95.375852, 1877, 152, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2893, N'St Cloud Hospital', 1, NULL, NULL, N'240036', NULL, NULL, 0, 489, NULL, N'3202512700', N'3206567099', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1406 6Th Ave North', N'Saint Cloud', N'MN', N'27145', N'56303', 45.575347, -94.170293, 1970, 154, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2894, N'United Hospital', 1, NULL, NULL, N'240038', NULL, NULL, 0, 546, NULL, N'6512418802', N'6512415189', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'333 North Smith Avenue', N'Saint Paul', N'MN', N'27123', N'55102', 44.942645, -93.107468, 1973, 155, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2895, N'University Medical Center-Mesabi/ Mesaba Clinics', 1, NULL, NULL, N'240040', NULL, NULL, 0, 175, NULL, N'2183626659', N'2183626619', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'750 East 34Th St', N'Hibbing', N'MN', N'27137', N'55746', 47.410847, -92.931754, 1921, 152, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2896, N'Mayo Clinic Health System - Albert Lea', 1, NULL, NULL, N'240043', NULL, NULL, 0, 89, NULL, N'5073732384', N'5073776383', 1, 1, 0, 0, 1, 1, 0, 0, 0, 0, 0, 0, NULL, NULL, N'404 West Fountain Street', N'Albert Lea', N'MN', N'27047', N'56007', 43.651635, -93.36969, 1876, 153, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2897, N'Winona Health Services', 1, NULL, NULL, N'240044', NULL, NULL, 0, 99, NULL, N'5074543650', N'5074574159', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'855 Mankato Avenue', N'Winona', N'MN', N'27169', N'55987', 44.035094, -91.621662, 1992, 300, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2898, N'St Lukes Hospital', 1, NULL, NULL, N'240047', NULL, NULL, 0, 267, NULL, N'2182495555', N'2187332472', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'915 East 1St Street', N'Duluth', N'MN', N'27137', N'55805', 46.788558, -92.098001, 1903, 151, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2899, N'Fairview Lakes Medical Center', 1, NULL, NULL, N'240050', NULL, NULL, 0, 61, NULL, N'6519827104', N'6519827110', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5200 Fairview Boulevard', N'Wyoming', N'MN', N'27025', N'55092', 45.32225, -92.998666, 1940, 152, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2900, N'Lake Region Healthcare Corporation', 1, NULL, NULL, N'240052', NULL, NULL, 0, 100, NULL, N'2187368000', N'2187368765', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'712 South Cascade', N'Fergus Falls', N'MN', N'27111', N'56537', 46.283015, -96.077558, 1909, 205, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2901, N'Park Nicollet Methodist Hospital', 1, NULL, NULL, N'240053', NULL, NULL, 0, 426, NULL, N'9529935000', N'9529935936', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6500 Excelsior Blvd', N'Saint Louis Park', N'MN', N'27053', N'55426', 44.927075, -93.361391, 1972, 152, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2902, N'Ridgeview Medical Center', 1, NULL, NULL, N'240056', NULL, NULL, 0, 109, NULL, N'9524422191', N'9524426543', 1, 1, 0, 0, 1, 1, 0, 0, 0, 0, 0, 0, NULL, NULL, N'500 South Maple Street', N'Waconia', N'MN', N'27019', N'55387', 44.846334, -93.790719, 1984, 152, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2903, N'Abbott Northwestern Hospital', 1, NULL, NULL, N'240057', NULL, NULL, 0, 1017, NULL, N'6128634509', N'6128635667', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'800 East 28Th Street', N'Minneapolis', N'MN', N'27053', N'55407', 44.952026, -93.262437, 1940, 152, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2904, N'Regina Hospital', 1, NULL, NULL, N'240059', NULL, NULL, 0, 57, NULL, N'6514804100', N'6514041460', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1175 Nininger Road', N'Hastings', N'MN', N'27037', N'55033', 44.747137, -92.873048, 1919, 155, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2905, N'St Joseph''s Hospital', 1, NULL, NULL, N'240063', NULL, NULL, 0, 401, NULL, N'6512327707', N'6512323518', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'45 West 10Th Street', N'Saint Paul', N'MN', N'27123', N'55102', 44.949159, -93.099945, 1973, 155, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2906, N'Grand Itasca Clinic And Hospital', 1, NULL, NULL, N'240064', NULL, NULL, 0, 64, NULL, N'2183263401', N'2183267743', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1601 Golf Course Road', N'Grand Rapids', N'MN', N'27061', N'55744', 47.220991, -93.554498, 1916, 152, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2907, N'Lakeview Memorial Hospital', 1, NULL, NULL, N'240066', NULL, NULL, 0, 97, NULL, N'6514305330', N'6514304512', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'927 West Churchill Street', N'Stillwater', N'MN', N'27163', N'55082', 45.056404, -92.813498, 1977, 155, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2908, N'Owatonna Hospital', 1, NULL, NULL, N'240069', NULL, NULL, 0, 77, NULL, N'5074513850', N'5074446053', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2250 26Th Street Northwest', N'Owatonna', N'MN', N'27147', N'55060', 44.083994, -93.226108, 1952, 153, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2909, N'District One Hospital', 1, NULL, NULL, N'240071', NULL, NULL, 0, 99, NULL, N'5073346451', N'5073324848', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'200 State Avenue', N'Faribault', N'MN', N'27131', N'55021', 44.286945, -93.257135, 1907, 152, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2910, N'Essentia Health St Joseph''s Medical Center', 1, NULL, NULL, N'240075', NULL, NULL, 0, 162, NULL, N'2188292861', N'2188283103', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'523 North 3Rd Street', N'Brainerd', N'MN', N'27035', N'56401', 46.359263, -94.215535, 1888, 152, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2911, N'Buffalo Hospital', 1, NULL, NULL, N'240076', NULL, NULL, 0, 65, NULL, N'7636841212', N'7636847910', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'303 Catlin St', N'Buffalo', N'MN', N'27171', N'55313', 45.194011, -93.873761, 1890, 152, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2912, N'Fairview Southdale Hospital', 1, NULL, NULL, N'240078', NULL, NULL, 0, 390, NULL, N'9529245000', N'9529245382', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6401 France Avenue South', N'Edina', N'MN', N'27053', N'55435', 44.88654, -93.328843, 1940, 152, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2913, N'University Of Minnesota  Medical Center Fairview', 1, NULL, NULL, N'240080', NULL, NULL, 0, 1700, NULL, N'6122733000', N'6122734098', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2450 Riverside Avenue', N'Minneapolis', N'MN', N'27053', N'55454', 44.965908, -93.236885, 1940, 152, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2914, N'Essentia Health Virginia', 1, NULL, NULL, N'240084', NULL, NULL, 0, 83, NULL, N'2187413340', N'2187499427', 1, 0, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'901 9Th Street North', N'Virginia', N'MN', N'27137', N'55792', 47.530601, -92.54815, 1982, 151, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2915, N'Rice Memorial Hospital', 1, NULL, NULL, N'240088', NULL, NULL, 0, 136, NULL, N'3202314227', N'3202314869', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'301 Becker Ave Sw', N'Willmar', N'MN', N'27067', N'56201', 45.120263, -95.047573, 1990, 152, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2916, N'Mayo Clinic Health System - Mankato', 1, NULL, NULL, N'240093', NULL, NULL, 0, 272, NULL, N'5076254031', N'5073852908', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1025 Marsh Street', N'Mankato', N'MN', N'27013', N'56001', 44.16452, -93.985255, 1936, 152, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2917, N'Sanford Bemidji Medical Center', 1, NULL, NULL, N'240100', NULL, NULL, 0, 118, NULL, N'2187515430', N'2187595880', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1300 Anne St Nw', N'Bemidji', N'MN', N'27007', N'56601', 47.478654, -94.890802, 1884, 205, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2918, N'Essentia Health St Marys - Detroit Lakes', 1, NULL, NULL, N'240101', NULL, NULL, 0, 87, NULL, N'2188470852', N'2188477674', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1027 Washington Ave', N'Detroit Lakes', N'MN', N'27005', N'56501', 46.812018, -95.845512, 1902, 205, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2919, N'St Francis Regional Medical Center', 1, NULL, NULL, N'240104', NULL, NULL, 0, 93, NULL, N'9524033000', N'9524033820', 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1455 St Francis Avenue', N'Shakopee', N'MN', N'27139', N'55379', 44.770155, -93.504201, 1966, 152, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2920, N'Regions Hospital', 1, NULL, NULL, N'240106', NULL, NULL, 0, 480, NULL, N'6512543456', N'6512542194', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'640 Jackson Street', N'Saint Paul', N'MN', N'27123', N'55101', 44.961464, -93.098093, 1973, 155, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2921, N'Mercy Hospital', 1, NULL, NULL, N'240115', NULL, NULL, 0, 309, NULL, N'7632368205', N'7632368124', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4050 Coon Rapids Blvd', N'Coon Rapids', N'MN', N'27003', N'55433', 45.149756, -93.28813, 1940, 152, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2922, N'Unity Hospital', 1, NULL, NULL, N'240132', NULL, NULL, 0, 275, NULL, N'7632365000', N'7632363774', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'550 Osborne Road', N'Fridley', N'MN', N'27003', N'55432', 45.083829, -93.259039, 1940, 152, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2923, N'Fairview Northland Regional Hospital', 1, NULL, NULL, N'240141', NULL, NULL, 0, 54, NULL, N'7633891313', N'7633896306', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'911 Northland Dr', N'Princeton', N'MN', N'27141', N'55371', 45.572662, -93.585366, 1957, 152, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2924, N'Mayo Clinic Health System - Fairmont', 1, NULL, NULL, N'240166', NULL, NULL, 0, 57, NULL, N'5072388101', N'5072388686', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'800 Medical Center Drive Po Box 800', N'Fairmont', N'MN', N'27091', N'56031', 43.652178, -94.461083, 1906, 152, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2925, N'Hutchinson Health', 1, NULL, NULL, N'240187', NULL, NULL, 0, 66, NULL, N'3202345000', N'3202344667', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1095 Highway 15 South', N'Hutchinson', N'MN', N'27085', N'55350', 44.88774, -94.369706, 1922, 152, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2926, N'Phillips Eye Institute', 1, NULL, NULL, N'240196', NULL, NULL, 0, 20, NULL, N'6127758815', N'6127769601', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2215 Park Avenue South', N'Minneapolis', N'MN', N'27053', N'55404', 44.960678, -93.264998, 1940, 152, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2927, N'Red Lake Hospital A', 1, NULL, NULL, N'240206', NULL, NULL, 0, 23, NULL, N'2186793912', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Po Box 497', N'Redlake', N'MN', N'27007', N'56671', 45.989659, -94.611329, 1994, 205, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2928, N'Fairview Ridges Hospital', 1, NULL, NULL, N'240207', NULL, NULL, 0, 150, NULL, N'9528922000', N'9528922107', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'201 East Nicollet Boulevard', N'Burnsville', N'MN', N'27037', N'55337', 44.749953, -93.274681, 1891, 152, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2929, N'Healtheast St John''s Hospital', 1, NULL, NULL, N'240210', NULL, NULL, 0, 184, NULL, N'6512327000', N'6512327240', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1575 Beam Avenue', N'Maplewood', N'MN', N'27123', N'55109', 45.028135, -93.034567, 1937, 155, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2930, N'Healtheast Woodwinds Hospital', 1, NULL, NULL, N'240213', NULL, NULL, 0, 86, NULL, N'6512326880', N'6512326888', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1925 Woodwinds Drive', N'Woodbury', N'MN', N'27163', N'55125', 44.92174, -92.979749, 1973, 155, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2931, N'Maple Grove Hospital', 1, NULL, NULL, N'240214', NULL, NULL, 0, 90, NULL, N'7635811000', N'7635811555', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'9875 Hospital Drive', N'Maple Grove', N'MN', N'27053', N'55369', 45.132412, -93.480931, 1940, 152, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2932, N'Mahnomen Health Center', 1, NULL, NULL, N'241300', NULL, NULL, 0, 18, NULL, N'2189352511', N'2189355409', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'414 W Jefferson Po Box 396', N'Mahnomen', N'MN', N'27087', N'56557', 47.315239, -95.968654, 2619, 205, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2933, N'Lakewood Health Center', 1, NULL, NULL, N'241301', NULL, NULL, 0, 15, NULL, N'2186342120', N'2186341094', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'600 Main Ave S', N'Baudette', N'MN', N'27077', N'56623', 48.709511, -94.600089, 1883, 206, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2934, N'Sanford Westbrook Medical Center', 1, NULL, NULL, N'241302', NULL, NULL, 0, 8, NULL, N'5072746121', N'5072745671', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'920 Bell Avenue Po Box 188', N'Westbrook', N'MN', N'27033', N'56183', 44.040563, -95.43453, 1988, 247, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2935, N'Sanford Tracy', 1, NULL, NULL, N'241303', NULL, NULL, 0, 25, NULL, N'5076293200', N'5076293202', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'251 Fifth Street East', N'Tracy', N'MN', N'27083', N'56175', 44.232251, -95.606828, 1979, 247, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2936, N'Sanford Medical Center Wheaton', 1, NULL, NULL, N'241304', NULL, NULL, 0, 25, NULL, N'3205638226', N'3205638012', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'401 12Th Street North', N'Wheaton', N'MN', N'27155', N'56296', 45.809347, -96.500618, 1989, 152, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2937, N'Riverwood Healthcare Center', 1, NULL, NULL, N'241305', NULL, NULL, 0, 31, NULL, N'2189275501', N'2189275575', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'200 Bunker Hill Drive', N'Aitkin', N'MN', N'27001', N'56431', 46.531397, -93.692876, 1875, 152, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2938, N'Renville County Hospital And Clinics', 1, NULL, NULL, N'241306', NULL, NULL, 0, 35, NULL, N'3205231261', N'3205233458', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'611 East Fairview', N'Olivia', N'MN', N'27129', N'56277', 44.77635, -94.989721, 1949, 152, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2939, N'Lake View Memorial Hospital', 1, NULL, NULL, N'241308', NULL, NULL, 0, 25, NULL, N'2188347300', N'2188347388', 1, 1, 1, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'325 Eleventh Ave', N'Two Harbors', N'MN', N'27075', N'55616', 47.025654, -91.672918, 1980, 151, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2940, N'Essentia Health Sandstone', 1, NULL, NULL, N'241309', NULL, NULL, 0, 35, NULL, N'3202455601', N'3202455243', 1, 1, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'109 Court Ave South', N'Sandstone', N'MN', N'27115', N'55072', 46.126789, -92.866263, 1964, 152, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2941, N'Ridgeview Sibley Medical Center', 1, NULL, NULL, N'241311', NULL, NULL, 0, 20, NULL, N'5079642271', N'5079648490', 1, 1, 1, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'601 West Chandler', N'Arlington', N'MN', N'27143', N'55307', 44.608297, -94.080528, 1879, 152, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2942, N'Cook Hospital', 1, NULL, NULL, N'241312', NULL, NULL, 0, 14, NULL, N'2186665945', N'2186665949', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'10 Se Fifth St', N'Cook', N'MN', N'27137', N'55723', 47.852418, -92.689618, 1897, 151, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2943, N'Essentia Health Ada', 1, NULL, NULL, N'241313', NULL, NULL, 0, 14, NULL, N'2187845000', N'2187843855', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'201 9Th Street West', N'Ada', N'MN', N'27107', N'56510', 47.298066, -96.530304, 1874, 205, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2944, N'Johnson Memorial Hospital', 1, NULL, NULL, N'241314', NULL, NULL, 0, 24, NULL, N'3207694323', N'3207692972', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1282 Walnut Street', N'Dawson', N'MN', N'27073', N'56232', 44.930896, -96.057436, 1900, 152, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2945, N'Sanford Jackson Medical Center', 1, NULL, NULL, N'241315', NULL, NULL, 0, 20, NULL, N'5078472420', N'5078473728', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1430 North Highway', N'Jackson', N'MN', N'27063', N'56143', 43.623809, -95.004699, 1925, 247, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2946, N'Bigfork Valley Hospital', 1, NULL, NULL, N'241316', NULL, NULL, 0, 20, NULL, N'2187433177', N'2187433559', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'258 Pine Tree Drive Po Box 258', N'Bigfork', N'MN', N'27061', N'56628', 47.744387, -93.654085, 1886, 152, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2947, N'Cook County Northshore Hospital', 1, NULL, NULL, N'241317', NULL, NULL, 0, 16, NULL, N'2183873040', N'2183873270', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'515 5Th Ave West', N'Grand Marais', N'MN', N'27031', N'55604', 47.756489, -90.341452, 1915, 151, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2948, N'Ely Bloomenson Community Hospital', 1, NULL, NULL, N'241318', NULL, NULL, 0, 28, NULL, N'2183653271', N'2183658777', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'328 West Conan Street', N'Ely', N'MN', N'27137', N'55731', 47.900467, -91.87242, 1905, 151, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2949, N'Murray County Memorial Hospital', 1, NULL, NULL, N'241319', NULL, NULL, 0, 25, NULL, N'5078361277', N'5078366700', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2042 Juniper Avenue', N'Slayton', N'MN', N'27101', N'56172', 43.992673, -95.759334, 1967, 247, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2950, N'Riverview Hospital', 1, NULL, NULL, N'241320', NULL, NULL, 0, 49, NULL, N'2182819200', N'2182819222', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'323 South Minnesota', N'Crookston', N'MN', N'27119', N'56716', 47.774138, -96.608121, 1898, 206, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2951, N'Essentia Health Holy Trinity Hospital', 1, NULL, NULL, N'241321', NULL, NULL, 0, 15, NULL, N'3207488200', N'3207487240', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'115  Second Street West Box 157', N'Graceville', N'MN', N'27011', N'56240', 45.56913, -96.434506, 1914, 152, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2952, N'Rainy Lake Medical Center', 1, NULL, NULL, N'241322', NULL, NULL, 0, 25, NULL, N'2182835400', N'2182832281', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1400 Highway 71', N'International Falls', N'MN', N'27071', N'56649', 48.601049, -93.410982, 1923, 152, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2953, N'Madelia Community Hospital', 1, NULL, NULL, N'241323', NULL, NULL, 0, 25, NULL, N'5076423255', N'5076428516', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'121 Drew Avenue Southeast', N'Madelia', N'MN', N'27165', N'56062', 44.048897, -94.409439, 1934, 152, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2954, N'Chippewa County Hospital', 1, NULL, NULL, N'241325', NULL, NULL, 0, 30, NULL, N'3203218100', N'3202698186', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'824 North 11Th Street', N'Montevideo', N'MN', N'27023', N'56265', 44.953176, -95.713475, 1941, 152, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2955, N'Centracare Health System - Long Prairie', 1, NULL, NULL, N'241326', NULL, NULL, 0, 34, NULL, N'3207322141', N'3207323802', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'20 Ninth Street Southeast', N'Long Prairie', N'MN', N'27153', N'56347', 45.974687, -94.865577, 1932, 154, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2956, N'Sleepy Eye Municipal Hospital', 1, NULL, NULL, N'241327', NULL, NULL, 0, 16, NULL, N'5077948440', N'5077945462', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'400 Fourth Avenue Northwest', N'Sleepy Eye', N'MN', N'27015', N'56085', 44.297183, -94.72415, 1968, 152, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2957, N'Sanford Bagley Medical Center', 1, NULL, NULL, N'241328', NULL, NULL, 0, 25, NULL, N'2186946501', N'2186943528', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'203 4Th Street Northwest', N'Bagley', N'MN', N'27029', N'56621', 47.525705, -95.40077, 1882, 205, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2958, N'Lakewood Health System', 1, NULL, NULL, N'241329', NULL, NULL, 0, 37, NULL, N'2188941515', N'2188948355', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'49725 County Road 83', N'Staples', N'MN', N'27153', N'56479', 46.369341, -94.808326, 1975, 154, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2959, N'Centracare Health System - Melrose Hospital', 1, NULL, NULL, N'241330', NULL, NULL, 0, 28, NULL, N'3202564231', N'3202564949', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'525 West Main Street', N'Melrose', N'MN', N'27145', N'56352', 45.674889, -94.822352, 1939, 154, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2960, N'Albany Area Hospital', 1, NULL, NULL, N'241331', NULL, NULL, 0, 17, NULL, N'3208452121', N'3208456127', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'300 Third Avenue', N'Albany', N'MN', N'27145', N'56307', 45.629965, -94.570005, 1970, 154, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2961, N'Windom Area Hospital', 1, NULL, NULL, N'241332', NULL, NULL, 0, 18, NULL, N'5078312400', N'5078315749', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2150 Hospital Drive Po Box 339', N'Windom', N'MN', N'27033', N'56101', 44.898749, -93.282549, 1991, 247, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2962, N'Mayo Clinic Health System - St James', 1, NULL, NULL, N'241333', NULL, NULL, 0, 25, NULL, N'5073753261', N'5073758605', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1101 Moulton And Parsons Drive', N'St James', N'MN', N'27165', N'56081', 43.982458, -94.626918, 1971, 152, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2963, N'River''s Edge Hospital & Clinic', 1, NULL, NULL, N'241334', NULL, NULL, 0, 17, NULL, N'5079347602', N'5079347651', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1900 North Sunrise Drive', N'St Peter', N'MN', N'27103', N'56082', 44.354066, -93.970862, 1974, 152, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2964, N'St Elizabeth Medical Center', 1, NULL, NULL, N'241335', NULL, NULL, 0, 31, NULL, N'6515654531', N'6515652482', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1200 Grant Blvd W', N'Wabasha', N'MN', N'27157', N'55981', 44.383952, -92.042752, 1983, 153, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2965, N'Kittson Memorial Hospital', 1, NULL, NULL, N'241336', NULL, NULL, 0, 15, NULL, N'2188433612', N'2188438879', 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'1010 South Birch', N'Hallock', N'MN', N'27069', N'56728', 48.774426, -96.946447, 1918, 206, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2966, N'North Valley Health Center', 1, NULL, NULL, N'241337', NULL, NULL, 0, 12, NULL, N'2187454211', N'2187454215', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'300 West Good Samaritan Drive', N'Warren', N'MN', N'27089', N'56762', 48.190363, -96.773757, 1986, 206, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2967, N'Mayo Clinic Health System - Lake City', 1, NULL, NULL, N'241338', NULL, NULL, 0, 15, NULL, N'6513451114', N'6513451182', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'500 West Grant Street', N'Lake City', N'MN', N'27157', N'55041', 44.458965, -92.281793, 1927, 153, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2968, N'Hendricks Community Hospital', 1, NULL, NULL, N'241339', NULL, NULL, 0, 24, NULL, N'5072753134', N'5072753104', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'503 E Lincoln Street', N'Hendricks', N'MN', N'27081', N'56136', 44.506135, -96.418797, 1920, 247, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2969, N'Essentia Health Northern Pines Medical Center', 1, NULL, NULL, N'241340', NULL, NULL, 0, 20, NULL, N'2182292211', N'2182292042', 1, 0, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5211 Highway 110', N'Aurora', N'MN', N'27137', N'55705', 47.517054, -92.248423, 1880, 151, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2970, N'Appleton Municipal Hospital', 1, NULL, NULL, N'241341', NULL, NULL, 0, 15, NULL, N'3202891580', N'3202891585', 1, 1, 1, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'30 South Behl Street', N'Appleton', N'MN', N'27151', N'56208', 45.199664, -96.008705, 1878, 152, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2971, N'Ortonville Area Health Services', 1, NULL, NULL, N'241342', NULL, NULL, 0, 29, NULL, N'3208392502', N'3208394277', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'450 Eastvold Ave', N'Ortonville', N'MN', N'27011', N'56278', 45.314756, -96.445419, 1951, 247, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2972, N'Municipal Hospital And Granite Manor', 1, NULL, NULL, N'241343', NULL, NULL, 0, 30, NULL, N'3205643111', N'3205642169', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'345 Tenth Avenue', N'Granite Falls', N'MN', N'27173', N'56241', 44.809958, -95.545575, 1917, 152, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2973, N'Lifecare Medical Center', 1, NULL, NULL, N'241344', NULL, NULL, 0, 15, NULL, N'2184632500', N'2184631266', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'715 Delmore Drive', N'Roseau', N'MN', N'27135', N'56751', 48.839482, -95.759807, 1962, 206, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2974, N'Mayo Clinic Health System - Waseca', 1, NULL, NULL, N'241345', NULL, NULL, 0, 25, NULL, N'5078351210', N'5078373945', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'501 North State Street', N'Waseca', N'MN', N'27161', N'56093', 44.084012, -93.507326, 1987, 152, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2975, N'Mayo Clinic Health System - Cannon Falls', 1, NULL, NULL, N'241346', NULL, NULL, 0, 15, NULL, N'5072636000', N'5072639640', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'32021 County 24 Boulevard', N'Cannon Falls', N'MN', N'27049', N'55009', 44.482317, -92.909287, 1894, 153, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2976, N'Sanford Canby Medical Center', 1, NULL, NULL, N'241347', NULL, NULL, 0, 29, NULL, N'5072237277', N'5072235877', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'112 St Olaf Avenue South', N'Canby', N'MN', N'27173', N'56220', 44.707549, -96.278114, 1893, 247, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2977, N'Tyler Healthcare Center', 1, NULL, NULL, N'241348', NULL, NULL, 0, 20, NULL, N'5072475521', N'5072475972', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'240 Willow Street', N'Tyler', N'MN', N'27081', N'56178', 44.272232, -96.130806, 1981, 247, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2978, N'Centra Care Health Paynesville', 1, NULL, NULL, N'241349', NULL, NULL, 0, 30, NULL, N'3202433767', N'3202436707', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'200 1St Street West', N'Paynesville', N'MN', N'27145', N'56362', 45.380469, -94.711892, 1954, 154, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2979, N'Mercy Hospital', 1, NULL, NULL, N'241350', NULL, NULL, 0, 31, NULL, N'2184854481', N'2185865654', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4572 County Road 61', N'Moose Lake', N'MN', N'27017', N'55767', 46.454113, -92.761866, 1943, 151, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2980, N'Redwood Area Hospital', 1, NULL, NULL, N'241351', NULL, NULL, 0, 25, NULL, N'5076374500', N'5076376000', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'100 Fallwood Road', N'Redwood Falls', N'MN', N'27127', N'56283', 44.536942, -95.10773, 1959, 152, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2981, N'Mayo Clinic Health System - Springfield', 1, NULL, NULL, N'241352', NULL, NULL, 0, 24, NULL, N'5077236201', N'5077236447', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'625 Jackson Avenue North', N'Springfield', N'MN', N'27015', N'56087', 44.236127, -94.976633, 1969, 152, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2982, N'Cuyuna Regional Medical Center', 1, NULL, NULL, N'241353', NULL, NULL, 0, 42, NULL, N'2185467000', N'2185467268', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'320 East Main Street', N'Crosby', N'MN', N'27035', N'56441', 46.482429, -93.946734, 1899, 152, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2983, N'Tri County Hospital', 1, NULL, NULL, N'241354', NULL, NULL, 0, 49, NULL, N'2186313510', N'2186317503', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'415 Jefferson Street North', N'Wadena', N'MN', N'27159', N'56482', 46.445197, -95.133957, 1985, 152, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2984, N'Glencoe Regional Health Services', 1, NULL, NULL, N'241355', NULL, NULL, 0, 49, NULL, N'3208643121', N'3208647887', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1805 Hennepin Avenue North', N'Glencoe', N'MN', N'27085', N'55336', 44.771033, -94.151767, 1912, 152, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2985, N'Mille Lacs Health System', 1, NULL, NULL, N'241356', NULL, NULL, 0, 28, NULL, N'3205323154', N'3205323111', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'200 North Elm Street', N'Onamia', N'MN', N'27095', N'56359', 46.07286, -93.661775, 1950, 152, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2986, N'Essentia Health Fosston', 1, NULL, NULL, N'241357', NULL, NULL, 0, 43, NULL, N'2184351133', N'2184351134', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'900 Hilligoss Boulevard Se', N'Fosston', N'MN', N'27119', N'56542', 47.576348, -95.751415, 1911, 205, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2987, N'Cass Lake Indian Health Services Hospital', 1, NULL, NULL, N'241358', NULL, NULL, 0, 11, NULL, N'2183353200', N'2183353300', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'425 7Th Street Nw', N'Cass Lake', N'MN', N'27021', N'56633', 47.383987, -94.609466, 1884, 205, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2988, N'Avera Marshall Regional Medical Ctr', 1, NULL, NULL, N'241359', NULL, NULL, 0, 25, NULL, N'5075379661', N'5075379053', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'300 South Bruce Street', N'Marshall', N'MN', N'27083', N'56258', 44.448253, -95.776276, 1938, 247, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2989, N'Deer River Healthcare Center', 1, NULL, NULL, N'241360', NULL, NULL, 0, 20, NULL, N'2182462900', N'2182468279', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'115 10Th Avenue Northeast', N'Deer River', N'MN', N'27061', N'56636', 47.343555, -93.794924, 1901, 152, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2990, N'Mayo Clinic Health System - New Prague', 1, NULL, NULL, N'241361', NULL, NULL, 0, 25, NULL, N'9527588101', N'9527582166', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'301 2Nd Street Northeast', N'New Prague', N'MN', N'27139', N'56071', 44.546061, -93.573337, 1946, 152, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2991, N'Centracare Health - Monticello', 1, NULL, NULL, N'241362', NULL, NULL, 0, 39, NULL, N'7632952945', N'7632712299', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1013 Hart Boulevard', N'Monticello', N'MN', N'27171', N'55362', 45.299248, -93.777259, 1942, 152, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2992, N'Stevens Community Medical Center', 1, NULL, NULL, N'241363', NULL, NULL, 0, 54, NULL, N'3205891313', N'3205891065', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'400 East First Street Po Box 660', N'Morris', N'MN', N'27149', N'56267', 45.586072, -95.913941, 1945, 152, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2993, N'Community Memorial Hospital', 1, NULL, NULL, N'241364', NULL, NULL, 0, 36, NULL, N'2188794641', N'2188799167', 1, 1, 1, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'512 Skyline Boulevard', N'Cloquet', N'MN', N'27017', N'55720', 46.731829, -92.46324, 1896, 151, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2994, N'Swift County Benson Hospital', 1, NULL, NULL, N'241365', NULL, NULL, 0, 31, NULL, N'3208434232', N'3208434172', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1815 Wisconsin Avenue', N'Benson', N'MN', N'27151', N'56215', 45.314593, -95.608443, 1885, 154, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2995, N'Meeker Memorial Hospital', 1, NULL, NULL, N'241366', NULL, NULL, 0, 35, NULL, N'3206933242', N'3206934567', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'612 South Sibley Avenue', N'Litchfield', N'MN', N'27093', N'55355', 45.114104, -94.527987, 1930, 152, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2996, N'Firstlight Health System', 1, NULL, NULL, N'241367', NULL, NULL, 0, 49, NULL, N'3202253315', N'3202253320', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'301 South Highway 65', N'Mora', N'MN', N'27065', N'55051', 45.876903, -93.293835, 1944, 152, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2997, N'Centracare Health System - Sauk Centre', 1, NULL, NULL, N'241368', NULL, NULL, 0, 25, NULL, N'3203522221', N'3203525150', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'425 North Elm Street', N'Sauk Centre', N'MN', N'27145', N'56378', 45.737465, -94.952522, 1965, 154, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2998, N'United Hospital District', 1, NULL, NULL, N'241369', NULL, NULL, 0, 43, NULL, N'5075263273', N'5075263285', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'515 South Moore Street Po Box 160', N'Blue Earth', N'MN', N'27043', N'56013', 43.637455, -94.102182, 1887, 152, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2999, N'St Gabriels Hospital', 1, NULL, NULL, N'241370', NULL, NULL, 0, 49, NULL, N'3206325441', N'3203621190', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'815 Southeast Second Street', N'Little Falls', N'MN', N'27097', N'56345', 45.976355, -94.362502, 1931, 152, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3000, N'Sanford Luverne Medical Center', 1, NULL, NULL, N'241371', NULL, NULL, 0, 28, NULL, N'5072832321', N'5072832091', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1600 North Kniss Avenue P O Box 1019', N'Luverne', N'MN', N'27133', N'56156', 43.654148, -96.212697, 1933, 247, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3001, N'Madison Hospital', 1, NULL, NULL, N'241372', NULL, NULL, 0, 12, NULL, N'3205987536', N'3205983470', 1, 1, 1, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'820 Third Avenue', N'Madison', N'MN', N'27073', N'56256', 45.009685, -96.195876, 1935, 247, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3002, N'Perham Health', 1, NULL, NULL, N'241373', NULL, NULL, 0, 29, NULL, N'2183474500', N'2183474540', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1000 Coney Street West', N'Perham', N'MN', N'27111', N'56573', 46.594404, -95.572541, 1955, 205, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3003, N'Pipestone County  Medical Center', 1, NULL, NULL, N'241374', NULL, NULL, 0, 44, NULL, N'5078255811', N'5078255733', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'916 4Th Avenue Southwest', N'Pipestone', N'MN', N'27117', N'56164', 43.9916, -96.322222, 1956, 247, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3004, N'Minnesota Valley Health Center  Inc', 1, NULL, NULL, N'241375', NULL, NULL, 0, 15, NULL, N'5076653375', N'5076652191', 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'621 South Fourth Street', N'Le Sueur', N'MN', N'27079', N'56058', 44.461354, -93.915242, 1929, 152, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3005, N'Glacial Ridge Hospital', 1, NULL, NULL, N'241376', NULL, NULL, 0, 34, NULL, N'3206342208', N'3206342269', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'10 4Th Avenue Southeast', N'Glenwood', N'MN', N'27121', N'56334', 45.646545, -95.388738, 1913, 154, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3006, N'St Francis Medical Center', 1, NULL, NULL, N'241377', NULL, NULL, 0, 25, NULL, N'2186433000', N'2186437502', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2400 St Francis Drive', N'Breckenridge', N'MN', N'27167', N'56520', 46.265205, -96.581626, 1889, 205, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3007, N'New Ulm Medical Center', 1, NULL, NULL, N'241378', NULL, NULL, 0, 76, NULL, N'5072331000', N'5072331575', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1324 Fifth North Street', N'New Ulm', N'MN', N'27015', N'56073', 44.289604, -94.460707, 1947, 152, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3008, N'Prairie Ridge Hospital And Health Services', 1, NULL, NULL, N'241379', NULL, NULL, 0, 10, NULL, N'2186854461', N'2186856749', 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'1411 State Highway 793', N'Elbow Lake', N'MN', N'27051', N'56531', 47.148293, -95.546141, 1904, 205, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3009, N'St Josephs Area  Health Services', 1, NULL, NULL, N'241380', NULL, NULL, 0, 50, NULL, N'2187323311', N'2187321368', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'600 Pleasant Avenue', N'Park Rapids', N'MN', N'27057', N'56470', 46.922181, -95.058632, 1953, 205, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3010, N'Sanford Medical Center Thief River Falls', 1, NULL, NULL, N'241381', NULL, NULL, 0, 36, NULL, N'2186814240', N'2186834511', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3001 Sanford Parkway', N'Thief River Falls', N'MN', N'27113', N'56701', 48.11723, -96.177067, 1978, 205, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3011, N'Beacon Haven', 1, NULL, NULL, N'241991', NULL, NULL, 0, 8, NULL, N'6513790100', N'6513790601', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'1200 Long Lake Road', N'New Brighton', N'MN', N'27123', N'55112', 45.068647, -93.204335, 1940, 152, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3012, N'Healtheast Bethesda Hospital', 1, NULL, NULL, N'242004', NULL, NULL, 0, 254, NULL, N'6512322000', N'6512322118', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'559 Capitol Boulevard', N'Saint Paul', N'MN', N'27123', N'55103', 44.950404, -93.101503, 1973, 155, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3013, N'Regency Hospital Of Minneapolis Llc', 1, NULL, NULL, N'242005', NULL, NULL, 0, 92, NULL, N'7633028301', N'7635213805', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1300 Hidden Lakes Parkway', N'Golden Valley', N'MN', N'27053', N'55422', 44.992845, -93.332505, 1960, 152, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3014, N'Gillette Childrens Specialty Hospital', 1, NULL, NULL, N'243300', NULL, NULL, 0, 60, NULL, N'6122912848', N'6512293999', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'200 University Avenue East', N'Saint Paul', N'MN', N'27123', N'55106', 44.950404, -93.101503, 1973, 155, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3015, N'Children''s Hospitals & Clinics Of Mn', 1, NULL, NULL, N'243302', NULL, NULL, 0, 279, NULL, N'6128136112', N'6128136807', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2525 Chicago Avenue South', N'Minneapolis', N'MN', N'27053', N'55404', 44.956815, -93.262443, 1940, 152, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3016, N'Shriners Hospitals For Children', 1, NULL, NULL, N'243303', NULL, NULL, 0, 40, NULL, N'6125966100', N'6123397634', 1, 0, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2025 East River Parkway', N'Minneapolis', N'MN', N'27053', N'55414', 44.958598, -93.212464, 1940, 152, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3017, N'Anoka-Metro Reg Treatment Ctr', 1, NULL, NULL, N'244002', NULL, NULL, 0, 175, NULL, N'7637124000', N'7637124013', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3301 Seventh Ave North', N'Anoka', N'MN', N'27003', N'55303', 45.197743, -93.387176, 1940, 152, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3018, N'Child & Adolescent Behavioral Health Services', 1, NULL, NULL, N'244005', NULL, NULL, 0, 16, NULL, N'3202315421', N'2188252189', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1701 Technology Drive Ne', N'Willmar', N'MN', N'27067', N'56201', 45.141166, -95.019491, 1990, 152, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3019, N'Comm Behavioral Health Hosp - St Peter', 1, NULL, NULL, N'244010', NULL, NULL, 0, 16, NULL, N'5079335001', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'2000 Klein Street', N'Saint Peter', N'MN', N'27103', N'56082', 44.323838, -93.958529, 1974, 152, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3020, N'Community Behavioral Health Hospital Annandale', 1, NULL, NULL, N'244011', NULL, NULL, 0, 16, NULL, N'6512593850', N'3202747018', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'400 Annandale Boulevard', N'Annandale', N'MN', N'27171', N'55302', 45.262743, -94.124427, 1890, 152, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3021, N'Comm Behavioral Health Hosp', 1, NULL, NULL, N'244012', NULL, NULL, 0, 16, NULL, N'3203356201', N'3207591002', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'1610 8Th Avenue East', N'Alexandria', N'MN', N'27041', N'56308', 45.88355, -95.366086, 1877, 152, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3022, N'Community Behavioral Hospital Fergus Falls', 1, NULL, NULL, N'244013', NULL, NULL, 0, 16, NULL, N'2183325001', N'2187391329', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'1801 West Alcott', N'Fergus Falls', N'MN', N'27111', N'56537', 46.283015, -96.077558, 1909, 205, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3023, N'Community Behavioral Health Hospital - Bemidji', 1, NULL, NULL, N'244014', NULL, NULL, 0, 16, NULL, N'2183082400', N'2183336800', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'800 Bemidji Avenue North Suite 200', N'Bemidji', N'MN', N'27007', N'56601', 47.478654, -94.890802, 1884, 205, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3024, N'Community Behavioral Health Hospital - Baxter', 1, NULL, NULL, N'244015', NULL, NULL, 0, 16, NULL, N'2183163101', N'2188299141', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'14241 Grand Oaks Drive', N'Baxter', N'MN', N'27035', N'56425', 46.358151, -94.255988, 1888, 152, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3025, N'Prairiecare', 1, NULL, NULL, N'244016', NULL, NULL, 0, 20, NULL, N'7633835800', N'7633835801', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'12915 63Rd Avenue North', N'Maple Grove', N'MN', N'27053', N'55369', 45.068538, -93.44345, 1940, 152, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3026, N'Community Behavioral Health Hospital Rochester', 1, NULL, NULL, N'244017', NULL, NULL, 0, 16, NULL, N'5072062561', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'251 Wood Lake Drive Southeast', N'Rochester', N'MN', N'27109', N'55904', 43.972686, -92.456017, 1961, 153, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3027, N'Mayo Clinic Methodist Hospital', 1, NULL, NULL, N'249801', NULL, NULL, 0, 0, NULL, N'5072667890', N'5072553125', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'201 West Center Street', N'Rochester', N'MN', N'27109', N'55902', 44.023562, -92.465977, 1961, 153, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3028, N'Abbott Northwestern Organ Transplant Hospital', 1, NULL, NULL, N'249802', NULL, NULL, 0, 0, NULL, N'6128634000', N'6128635667', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'800 East 28Th Street', N'Minneapolis', N'MN', N'27053', N'55407', 44.952026, -93.262437, 1940, 152, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3029, N'St Marys Hospital Organ Transplant', 1, NULL, NULL, N'249803', NULL, NULL, 0, 0, NULL, N'5072555123', N'5072553125', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'1216 Second Street Southwest', N'Rochester', N'MN', N'27109', N'55902', 44.022621, -92.463009, 1961, 153, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3030, N'University Of Minnesota Medical Center Fairview', 1, NULL, NULL, N'249804', NULL, NULL, 0, 0, NULL, N'6122736150', N'6122734098', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'2450 Riverside Avenue', N'Minneapolis', N'MN', N'27053', N'55455', 44.965908, -93.236885, 1940, 152, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3031, N'Hennepin County Medical Center', 1, NULL, NULL, N'249805', NULL, NULL, 0, 0, NULL, N'6128739393', N'6128734214', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'701 Park Ave', N'Minneapolis', N'MN', N'27053', N'55415', 44.972717, -93.262671, 1940, 152, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3032, N'University Of Mississippi Med Center', 1, NULL, NULL, N'250001', NULL, NULL, 0, 710, NULL, N'6019844100', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2500 N State St', N'Jackson', N'MS', N'28049', N'39216', 32.331803, -90.175423, 2024, 158, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3033, N'Tishomingo Health Services Inc', 1, NULL, NULL, N'250002', NULL, NULL, 0, 48, NULL, N'6624236051', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1777 Curtis Drive', N'Iuka', N'MS', N'28141', N'38852', 34.803601, -88.208688, 2023, 1, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3034, N'North Mississippi Medical Center', 1, NULL, NULL, N'250004', NULL, NULL, 0, 650, NULL, N'6623773000', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'830 S Gloster', N'Tupelo', N'MS', N'28081', N'38801', 34.263462, -88.725027, 2052, 161, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3035, N'Baptist Memorial Hospital Union County', 1, NULL, NULL, N'250006', NULL, NULL, 0, 153, NULL, N'6625387631', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'200 Hwy 30 West', N'New Albany', N'MS', N'28145', N'38652', 34.494561, -89.016463, 2041, 161, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3036, N'Biloxi Regional Medical Center', 1, NULL, NULL, N'250007', NULL, NULL, 0, 153, NULL, N'2284321571', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'150 Reynoir Street', N'Biloxi', N'MS', N'28047', N'39530', 30.396002, -88.889574, 2000, 156, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3037, N'Magnolia Regional Health Center', 1, NULL, NULL, N'250009', NULL, NULL, 0, 164, NULL, N'6622931000', NULL, 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'611 Alcorn Drive', N'Corinth', N'MS', N'28003', N'38834', 34.943392, -88.517324, 2011, 253, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3038, N'Tippah County Hospital', 1, NULL, NULL, N'250010', NULL, NULL, 0, 45, NULL, N'6628379221', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1005 City Ave North', N'Ripley', N'MS', N'28139', N'38663', 34.73925, -88.949607, 2048, 253, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3039, N'Alliance Healthcare System', 1, NULL, NULL, N'250012', NULL, NULL, 0, 40, NULL, N'6622521212', N'6625513422', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1430 Highway 4 East / P O Box 6000', N'Holly Springs', N'MS', N'28093', N'38635', 34.769093, -89.441249, 3168, 253, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3040, N'Trace Regional Hosp And Swing Bed', 1, NULL, NULL, N'250017', NULL, NULL, 0, 84, NULL, N'6624563700', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1002 East Madison Street', N'Houston', N'MS', N'28017', N'38851', 33.89462, -88.984546, 2021, 160, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3041, N'Jasper General Hospital', 1, NULL, NULL, N'250018', NULL, NULL, 0, 20, NULL, N'6017642101', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'15 South 6Th Street', N'Bay Springs', N'MS', N'28061', N'39422', 31.976394, -89.290568, 2027, 157, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3042, N'Memorial Hospital At Gulfport', 1, NULL, NULL, N'250019', NULL, NULL, 0, 445, NULL, N'2288674000', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4500 13Th St-P O Box 1810', N'Gulfport', N'MS', N'28047', N'39502', 30.36742, -89.092815, 2018, 156, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3043, N'Webster General Hospital/Swing Bed', 1, NULL, NULL, N'250020', NULL, NULL, 0, 43, NULL, N'6622586221', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'70 Medical Plaza', N'Eupora', N'MS', N'28155', N'39744', 33.540677, -89.267012, 2012, 161, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3044, N'Gilmore Memorial Regional Medical Center', 1, NULL, NULL, N'250025', NULL, NULL, 0, 95, NULL, N'6622567111', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1105 Earl Frye Blvd', N'Amory', N'MS', N'28095', N'38821', 33.975576, -88.477471, 1996, 161, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3045, N'Winston Medical Center & Swingbed', 1, NULL, NULL, N'250027', NULL, NULL, 0, 41, NULL, N'6627736211', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'562 East Main Street', N'Louisville', N'MS', N'28159', N'39339', 33.124596, -89.030973, 2029, 158, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3046, N'River Region Health System', 1, NULL, NULL, N'250031', NULL, NULL, 0, 354, NULL, N'6018835000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2100 Hwy 61 N', N'Vicksburg', N'MS', N'28149', N'39183', 32.352842, -90.877734, 2054, 158, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3047, N'Baptist Memorial Hospital North Ms', 1, NULL, NULL, N'250034', NULL, NULL, 0, 217, NULL, N'6622328100', N'6622328391', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2301 South Lamar', N'Oxford', N'MS', N'28071', N'38655', 34.366413, -89.518766, 2042, 160, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3048, N'George Regional Health System', 1, NULL, NULL, N'250036', NULL, NULL, 0, 48, NULL, N'6019473161', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'859 Winter Street', N'Lucedale', N'MS', N'28039', N'39452', 30.921688, -88.592895, 2030, 4, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3049, N'Merit Health Madison', 1, NULL, NULL, N'250038', NULL, NULL, 0, 67, NULL, N'6018554000', N'6018555100', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'161 River Oaks Drive', N'Canton', N'MS', N'28089', N'39046', 32.607675, -90.011863, 2024, 158, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3050, N'Singing River Hospital', 1, NULL, NULL, N'250040', NULL, NULL, 0, 551, NULL, N'2288095000', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2809 Denny Av', N'Pascagoula', N'MS', N'28059', N'39581', 30.376206, -88.531078, 2043, 4, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3051, N'Northwest Mississippi Regional Medical Center', 1, NULL, NULL, N'250042', NULL, NULL, 0, 195, NULL, N'6626273211', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1970 Hospital Drive', N'Clarksdale', N'MS', N'28027', N'38614', 34.197069, -90.552507, 2007, 253, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3052, N'Neshoba County General Hospital', 1, NULL, NULL, N'250043', NULL, NULL, 0, 82, NULL, N'6016631200', NULL, 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1001 Holland Avenue', N'Philadelphia', N'MS', N'28099', N'39350', 32.770987, -89.106103, 2038, 159, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3053, N'Baptist Memorial Hospital Booneville', 1, NULL, NULL, N'250044', NULL, NULL, 0, 114, NULL, N'6627205000', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'100 Hospital Drive', N'Booneville', N'MS', N'28117', N'38829', 34.656452, -88.565575, 2001, 161, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3054, N'St Dominic-Jackson Memorial Hospital', 1, NULL, NULL, N'250048', NULL, NULL, 0, 571, NULL, N'6012002000', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'969 Lakeland Dr', N'Jackson', N'MS', N'28049', N'39216', 32.333755, -90.166252, 2024, 158, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3055, N'Beacham Memorial Hospital', 1, NULL, NULL, N'250049', NULL, NULL, 0, 37, NULL, N'6017832351', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'205 N Cherry St', N'Magnolia', N'MS', N'28113', N'39652', 31.145354, -90.45955, 2033, 158, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3056, N'Och Regional Medical Center', 1, NULL, NULL, N'250050', NULL, NULL, 0, 96, NULL, N'6623234320', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'400 Hospital Road', N'Starkville', N'MS', N'28105', N'39759', 33.474833, -88.821674, 2051, 161, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3057, N'King''s Daughters Medical Center-Brookhaven', 1, NULL, NULL, N'250057', NULL, NULL, 0, 122, NULL, N'6018336011', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'P O Box 948/427 Highway 51 North', N'Brookhaven', N'MS', N'28085', N'39601', 31.58369, -90.441809, 2002, 158, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3058, N'South Central Reg Med Ctr', 1, NULL, NULL, N'250058', NULL, NULL, 0, 285, NULL, N'6014264000', NULL, 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1220 Jefferson St Box 607', N'Laurel', N'MS', N'28067', N'39440', 31.694051, -89.130612, 2027, 157, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3059, N'Jefferson County Hospital', 1, NULL, NULL, N'250060', NULL, NULL, 0, 48, NULL, N'6017863401', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'870 S Main', N'Fayette', N'MS', N'28063', N'39069', 31.711553, -91.060661, 2013, 158, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3060, N'Yalobusha General Hospital', 1, NULL, NULL, N'250061', NULL, NULL, 0, 32, NULL, N'6624731411', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'630 South Main Street', N'Water Valley', N'MS', N'28161', N'38965', 34.130552, -89.641105, 2042, 160, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3061, N'Clay County Medical Center', 1, NULL, NULL, N'250067', NULL, NULL, 0, 60, NULL, N'6624952300', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'835 Medical Center Dr', N'West Point', N'MS', N'28025', N'39773', 33.61863, -88.6616, 2056, 161, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3062, N'Rush Foundation Hospital', 1, NULL, NULL, N'250069', NULL, NULL, 0, 215, NULL, N'6014830011', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1314 19Th Ave', N'Meridian', N'MS', N'28075', N'39301', 32.370088, -88.697721, 2038, 159, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3063, N'Merit Health Central', 1, NULL, NULL, N'250072', NULL, NULL, 0, 473, NULL, N'6013761000', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1850 Chadwick Dr', N'Jackson', N'MS', N'28049', N'39204', 32.28659, -90.253846, 2024, 158, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3064, N'Wayne General Hospital', 1, NULL, NULL, N'250077', NULL, NULL, 0, 80, NULL, N'6017355151', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'950 Matthew Dr', N'Waynesboro', N'MS', N'28153', N'39367', 31.674894, -88.635676, 2055, 157, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3065, N'Forrest General Hospital', 1, NULL, NULL, N'250078', NULL, NULL, 0, 537, NULL, N'6012887000', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6051 Us Highway 49', N'Hattiesburg', N'MS', N'28035', N'39404', 31.327119, -89.290339, 2019, 157, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3066, N'Sharkey Issaquena Community Hospital', 1, NULL, NULL, N'250079', NULL, NULL, 0, 29, NULL, N'6628734395', NULL, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'47 South 4 St', N'Rolling Fork', N'MS', N'28125', N'39159', 32.906517, -90.878157, 2049, 158, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3067, N'Anderson Rmc South', 1, NULL, NULL, N'250081', NULL, NULL, 0, 140, NULL, N'6014843590', N'6014843130', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1102 Constitution Avenue', N'Meridian', N'MS', N'28075', N'39301', 32.376096, -88.689786, 2038, 159, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3068, N'Delta Regional Medical Center', 1, NULL, NULL, N'250082', NULL, NULL, 0, 268, NULL, N'6623783783', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1400 E Union St', N'Greenville', N'MS', N'28151', N'38704', 33.40999, -91.036499, 2015, 253, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3069, N'Natchez Regional Medical Center', 1, NULL, NULL, N'250084', NULL, NULL, 0, 205, NULL, N'6014432100', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'52 Sergeant Prentiss Drive', N'Natchez', N'MS', N'28001', N'39120', 31.544502, -91.389135, 2040, 158, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3070, N'Marion General Hospital', 1, NULL, NULL, N'250085', NULL, NULL, 0, 79, NULL, N'6017366303', N'6017402244', 1, 1, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1560 Sumrall Rd', N'Columbia', N'MS', N'28091', N'39429', 31.255733, -89.806296, 2009, 158, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3071, N'Bolivar Medical Center', 1, NULL, NULL, N'250093', NULL, NULL, 0, 165, NULL, N'6628460061', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'901 E Sunflower Rd', N'Cleveland', N'MS', N'28011', N'38732', 33.747434, -90.710831, 2008, 253, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3072, N'Wesley Medical Center', 1, NULL, NULL, N'250094', NULL, NULL, 0, 211, NULL, N'6012688000', N'6012685008', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5001 W Hardy St', N'Hattiesburg', N'MS', N'28035', N'39402', 31.327119, -89.290339, 2019, 157, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3073, N'South Sunflower County Hospital', 1, NULL, NULL, N'250095', NULL, NULL, 0, 69, NULL, N'6628875235', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'121 E Baker St', N'Indianola', N'MS', N'28133', N'38751', 33.457309, -90.648952, 2022, 158, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3074, N'Merit Health Rankin', 1, NULL, NULL, N'250096', NULL, NULL, 0, 134, NULL, N'6018252811', N'6018248592', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'350 Crossgates Blvd', N'Brandon', N'MS', N'28121', N'39042', 32.288379, -90.036254, 2024, 158, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3075, N'Southwest Ms Regional Medical Center', 1, NULL, NULL, N'250097', NULL, NULL, 0, 160, NULL, N'6012495500', N'6012491800', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'215 Marion Av Box 1307', N'Mccomb', N'MS', N'28113', N'39649', 31.243787, -90.453154, 2035, 158, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3076, N'Greenwood Leflore Hospital', 1, NULL, NULL, N'250099', NULL, NULL, 0, 260, NULL, N'6624597000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1401 River Rd / Po Box 1410', N'Greenwood', N'MS', N'28083', N'38930', 33.516232, -90.179528, 2016, 158, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3077, N'Baptist Mem Hosp/ Golden Triangle Inc', 1, NULL, NULL, N'250100', NULL, NULL, 0, 328, NULL, N'6622441500', N'6622442028', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2520 5Th St N', N'Columbus', N'MS', N'28087', N'39701', 33.507352, -88.404734, 2010, 161, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3078, N'Mississippi Baptist Medical Center', 1, NULL, NULL, N'250102', NULL, NULL, 0, 639, NULL, N'6019681000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1225 N State St', N'Jackson', N'MS', N'28049', N'39202', 32.313855, -90.1783, 2024, 158, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3079, N'Anderson Regional Medical Ctr', 1, NULL, NULL, N'250104', NULL, NULL, 0, 260, NULL, N'6015536000', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2124 14 St', N'Meridian', N'MS', N'28075', N'39301', 32.376096, -88.689786, 2038, 159, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3080, N'Highland Community  Hospital', 1, NULL, NULL, N'250117', NULL, NULL, 0, 60, NULL, N'6013589400', N'6017994417', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'130 Highland Pkwy', N'Picayune', N'MS', N'28109', N'39466', 30.524888, -89.679152, 2044, 127, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3081, N'Natchez Community Hospital', 1, NULL, NULL, N'250122', NULL, NULL, 0, 101, NULL, N'6014456200', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'129 Jefferson Davis Blvd Box 1203', N'Natchez', N'MS', N'28001', N'39120', 31.544502, -91.389135, 2040, 158, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3082, N'Garden Park Medical Center', 1, NULL, NULL, N'250123', NULL, NULL, 0, 130, NULL, N'2285757000', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'15200 Community Road', N'Gulfport', N'MS', N'28047', N'39503', 30.444002, -89.093239, 2018, 156, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3083, N'Magee General Hospital', 1, NULL, NULL, N'250124', NULL, NULL, 0, 64, NULL, N'6018495070', N'6018490618', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'300 3Rd Ave Se', N'Magee', N'MS', N'28127', N'39111', 31.87092, -89.728619, 2032, 158, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3084, N'North Oak Regional Medical Center', 1, NULL, NULL, N'250126', NULL, NULL, 0, 76, NULL, N'6625623100', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'401 Getwell Dr', N'Senatobia', N'MS', N'28137', N'38668', 34.625425, -89.956425, 3168, 253, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3085, N'Choctaw Health Center', 1, NULL, NULL, N'250127', NULL, NULL, 0, 40, NULL, N'6016562211', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Route 7 Box R50', N'Philadelphia', N'MS', N'28099', N'39350', 32.781607, -89.115768, 2038, 159, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3086, N'Tri Lakes Medical Center', 1, NULL, NULL, N'250128', NULL, NULL, 0, 120, NULL, N'6625635611', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'303 Medical Center Drive', N'Batesville', N'MS', N'28107', N'38606', 34.307202, -89.915374, 1997, 160, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3087, N'Whitfield Medical Surgical Hospital', 1, NULL, NULL, N'250134', NULL, NULL, 0, 43, NULL, N'6013518023', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3550 Hwy 468 W Bldg 60', N'Whitfield', N'MS', N'28121', N'39193', 31.445171, -89.074501, 2024, 158, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3088, N'Merit Health Women''s Hospital', 1, NULL, NULL, N'250136', NULL, NULL, 0, 111, NULL, N'6019321000', N'6019363086', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1026 River Oaks Drive', N'Flowood', N'MS', N'28121', N'39232', 32.30959, -90.138976, 2024, 158, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3089, N'Merit Health River Oaks', 1, NULL, NULL, N'250138', NULL, NULL, 0, 106, NULL, N'6019321030', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1030 River Oaks Drive', N'Flowood', N'MS', N'28121', N'39232', 32.30959, -90.138976, 2024, 158, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3090, N'Baptist Memorial Hospital Desoto', 1, NULL, NULL, N'250141', NULL, NULL, 0, 161, NULL, N'6627724000', N'6627722111', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7601 Southcrest Parkway', N'Southaven', N'MS', N'28033', N'38671', 34.969846, -89.996751, 3168, 253, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3091, N'Alliance Health Center', 1, NULL, NULL, N'250151', NULL, NULL, 0, 134, NULL, N'6014836211', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5000 Highway 39 North', N'Meridian', N'MS', N'28075', N'39301', 32.376096, -88.689786, 2038, 159, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3092, N'Mississippi Methodist Rehab Ctr', 1, NULL, NULL, N'250152', NULL, NULL, 0, 124, NULL, N'6019812611', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1350 E Woodrow Wilson Dr', N'Jackson', N'MS', N'28049', N'39216', 32.299038, -90.184769, 2024, 158, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3093, N'Alliance Laird Hospital', 1, NULL, NULL, N'250159', NULL, NULL, 0, 49, NULL, N'6017748214', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'25117 Highway 15', N'Union', N'MS', N'28101', N'39365', 31.479336, -89.20117, 2038, 159, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3094, N'Hancock Medical Center', 1, NULL, NULL, N'250162', NULL, NULL, 0, 104, NULL, N'2284678600', N'2284678799', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'149 Drinkwater Blvd', N'Bay Saint Louis', N'MS', N'28045', N'39521', 30.30282, -89.337555, 1998, 127, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3095, N'Patients Choice Medical Center', 1, NULL, NULL, N'250163', NULL, NULL, 0, 29, NULL, N'6017829997', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'347 Magnolia Drive', N'Raleigh', N'MS', N'28129', N'39153', 32.004629, -89.521776, 2024, 158, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3096, N'Methodist Healthcare - Olive Branch Hospital', 1, NULL, NULL, N'250167', NULL, NULL, 0, 60, NULL, N'6629329000', NULL, 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4250 Bethel Road', N'Olive Branch', N'MS', N'28033', N'38654', 34.92468, -89.794898, 3168, 253, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3097, N'University Of Mississippi Medical Center- Grenada', 1, NULL, NULL, N'250168', NULL, NULL, 0, 156, NULL, N'6622277000', N'6622276519', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'960 Avent Drive', N'Grenada', N'MS', N'28043', N'38901', 33.782739, -89.818184, 2017, 160, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3098, N'Lackey Memorial Hospital', 1, NULL, NULL, N'251300', NULL, NULL, 0, 35, NULL, N'6014694151', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'330 N Broad Street', N'Forest', N'MS', N'28123', N'39074', 32.365801, -89.470863, 2014, 158, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3099, N'Pioneer Community Hospital Of Aberdeen', 1, NULL, NULL, N'251302', NULL, NULL, 0, 33, NULL, N'6623692455', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'400 S Chestnut Street', N'Aberdeen', N'MS', N'28095', N'39730', 33.820834, -88.540651, 2052, 161, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3100, N'Stone County Hospital', 1, NULL, NULL, N'251303', NULL, NULL, 0, 25, NULL, N'6019286600', NULL, 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1434 East Central Avenue', N'Wiggins', N'MS', N'28131', N'39577', 30.845597, -89.115266, 2019, 157, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3101, N'Tallahatchie Critical Access Hospital', 1, NULL, NULL, N'251304', NULL, NULL, 0, 18, NULL, N'6626475535', NULL, 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'201 South Market St / Po Box 230', N'Charleston', N'MS', N'28135', N'38921', 34.007008, -90.054892, 2006, 160, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3102, N'Lawrence County Hospital Cah', 1, NULL, NULL, N'251305', NULL, NULL, 0, 25, NULL, N'6015874051', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1065 East Broad St', N'Monticello', N'MS', N'28077', N'39654', 31.553441, -90.101918, 2039, 158, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3103, N'Perry County General Hosp', 1, NULL, NULL, N'251306', NULL, NULL, 0, 30, NULL, N'6017886316', NULL, 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'206 Bay St', N'Richton', N'MS', N'28111', N'39476', 31.349343, -88.940049, 2019, 157, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3104, N'Noxubee General Critical Access Hosp', 1, NULL, NULL, N'251307', NULL, NULL, 0, 25, NULL, N'6627264231', N'6627265784', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'606 North Jefferson Street', N'Macon', N'MS', N'28103', N'39341', 33.12129, -88.555479, 2031, 159, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3105, N'Pontotoc Health Service Cah', 1, NULL, NULL, N'251308', NULL, NULL, 0, 25, NULL, N'6624895510', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'176 South Main Street', N'Pontotoc', N'MS', N'28115', N'38863', 34.242862, -88.996748, 2052, 161, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3106, N'Field Memorial Community Hospital', 1, NULL, NULL, N'251309', NULL, NULL, 0, 25, NULL, N'6016455221', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'270 West Main Street P O Box 639', N'Centreville', N'MS', N'28157', N'39631', 31.08962, -91.068438, 2005, 119, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3107, N'Tyler Holmes Memorial Hospital Cah', 1, NULL, NULL, N'251312', NULL, NULL, 0, 25, NULL, N'6622834114', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'409 Tyler Holmes Drive', N'Winona', N'MS', N'28097', N'38967', 33.490141, -89.737681, 2057, 158, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3108, N'King''s Daughters Hospital', 1, NULL, NULL, N'251313', NULL, NULL, 0, 35, NULL, N'6627462261', N'6627464839', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'823 Grand Avenue', N'Yazoo City', N'MS', N'28163', N'39194', 32.858271, -90.403701, 2058, 158, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3109, N'Quitman County Hospital Cah', 1, NULL, NULL, N'251314', NULL, NULL, 0, 33, NULL, N'6623268031', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'340 Getwell Drive', N'Marks', N'MS', N'28119', N'38646', 34.24748, -90.277371, 2034, 253, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3110, N'Baptist Medical Center-Leake', 1, NULL, NULL, N'251315', NULL, NULL, 0, 25, NULL, N'6012671454', NULL, 1, 1, 1, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'310 Ellis Street', N'Carthage', N'MS', N'28079', N'39051', 32.74084, -89.519726, 2004, 158, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3111, N'H C Watkins Memorial Hospital Inc', 1, NULL, NULL, N'251316', NULL, NULL, 0, 25, NULL, N'6017766925', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'605 South Archusa Avenue', N'Quitman', N'MS', N'28023', N'39355', 32.035864, -88.727952, 2047, 159, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3112, N'Simpson General Hospital Cah', 1, NULL, NULL, N'251317', NULL, NULL, 0, 35, NULL, N'6018472221', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1842 Simpson Highway 149', N'Mendenhall', N'MS', N'28127', N'39114', 31.960606, -89.868369, 2037, 158, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3113, N'North Sunflower Medical Center Cah', 1, NULL, NULL, N'251318', NULL, NULL, 0, 35, NULL, N'6627562711', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'840 North Oak Avenue', N'Ruleville', N'MS', N'28133', N'38771', 33.734187, -90.54669, 2050, 158, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3114, N'Holmes County Hospital And Clinics', 1, NULL, NULL, N'251319', NULL, NULL, 0, 25, NULL, N'6628341321', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'239 Bowling Green Road', N'Lexington', N'MS', N'28051', N'39095', 33.116022, -90.051382, 2028, 158, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3115, N'Claiborne County Hospital', 1, NULL, NULL, N'251320', NULL, NULL, 0, 35, NULL, N'6014375141', NULL, 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'123 Mccomb Avenue', N'Port Gibson', N'MS', N'28021', N'39150', 31.958607, -90.982301, 2045, 158, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3116, N'Laird Hospital Inc', 1, NULL, NULL, N'251322', NULL, NULL, 0, 25, NULL, N'6017748214', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'25117 Highway 15', N'Union', N'MS', N'28099', N'39365', 31.479336, -89.20117, 2038, 159, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3117, N'Scott Regional Hospital Cah', 1, NULL, NULL, N'251323', NULL, NULL, 0, 30, NULL, N'6017326301', N'6017328970', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'317 Highway 13 South', N'Morton', N'MS', N'28123', N'39117', 32.353756, -89.654517, 2024, 158, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3118, N'Walthall County General Hospital Cah', 1, NULL, NULL, N'251324', NULL, NULL, 0, 35, NULL, N'6018762122', N'6012220432', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'100 Hospital Drive', N'Tylertown', N'MS', N'28147', N'39667', 31.120302, -90.156888, 2053, 158, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3119, N'Covington County Hospital Cah', 1, NULL, NULL, N'251325', NULL, NULL, 0, 35, NULL, N'6017656711', N'6016980180', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'701 South Holly Avenue', N'Collins', N'MS', N'28031', N'39428', 31.638119, -89.554377, 2019, 157, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3120, N'Jefferson Davis Community Hospital Cah', 1, NULL, NULL, N'251326', NULL, NULL, 0, 35, NULL, N'6017924276', N'6017922947', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1102 Rose Street', N'Prentiss', N'MS', N'28065', N'39474', 31.593852, -89.872359, 2046, 158, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3121, N'Hardy Wilson Memorial Hospital Cah', 1, NULL, NULL, N'251327', NULL, NULL, 0, 35, NULL, N'6018944541', N'6018946279', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'233 Magnolia Street', N'Hazlehurst', N'MS', N'28029', N'39083', 31.868912, -90.398854, 2020, 158, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3122, N'Greene County Hospital Cah', 1, NULL, NULL, N'251329', NULL, NULL, 0, 3, NULL, N'6013944135', N'6013945495', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1017 Jackson Street', N'Leakesville', N'MS', N'28041', N'39451', 31.154358, -88.557486, 2030, 4, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3123, N'Franklin County Memorial Hospital', 1, NULL, NULL, N'251330', NULL, NULL, 0, 36, NULL, N'6013845801', NULL, 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'40 Union Church Rd', N'Meadville', N'MS', N'28037', N'39653', 31.47437, -90.884859, 2036, 158, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3124, N'Calhoun Health Services', 1, NULL, NULL, N'251331', NULL, NULL, 0, 30, NULL, N'6626286611', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'140 Burke-Calhoun City Road', N'Calhoun City', N'MS', N'28013', N'38916', 33.870099, -89.318286, 2003, 160, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3125, N'Pioneer Health Services Of Newton', 1, NULL, NULL, N'251332', NULL, NULL, 0, 30, NULL, N'6016832031', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'9421 East Side Drive Extension Pob 299', N'Newton', N'MS', N'28101', N'39345', 32.321255, -89.163393, 2038, 159, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3126, N'Pearl River County Hospital', 1, NULL, NULL, N'251333', NULL, NULL, 0, 24, NULL, N'6017954543', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'305 West Moody Street', N'Poplarville', N'MS', N'28109', N'39470', 30.858515, -89.545701, 2019, 157, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3127, N'Choctaw Regional Medical Center', 1, NULL, NULL, N'251334', NULL, NULL, 0, 25, NULL, N'6622854400', N'6012859485', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'8613 Ms Hwy 12', N'Ackerman', N'MS', N'28019', N'39735', 33.311718, -89.171108, 1995, 158, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3128, N'John C Stennis Memorial Hospital', 1, NULL, NULL, N'251335', NULL, NULL, 0, 25, NULL, N'7694861000', NULL, 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'14365 Highway 16 West', N'De Kalb', N'MS', N'28069', N'39328', 32.767633, -88.650878, 2038, 159, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3129, N'Montfort Jones Memorial Hospital', 1, NULL, NULL, N'251336', NULL, NULL, 0, 25, NULL, N'6622894311', NULL, 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'220 Hwy 12 West', N'Kosciusko', N'MS', N'28007', N'39090', 33.058424, -89.588115, 2026, 158, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3130, N'Mississippi Hospital For Restorative Care', 1, NULL, NULL, N'252003', NULL, NULL, 0, 25, NULL, N'6019731660', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1225 North State St', N'Jackson', N'MS', N'28049', N'39202', 32.313855, -90.1783, 2024, 158, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3131, N'Speciality Hospital Of Meridian The', 1, NULL, NULL, N'252004', NULL, NULL, 0, 49, NULL, N'6017034211', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1314 19Th Avenue', N'Meridian', N'MS', N'28075', N'39301', 32.370088, -88.697721, 2038, 159, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3132, N'Select Specialty Hospital-Gulf Coast Inc', 1, NULL, NULL, N'252005', NULL, NULL, 0, 70, NULL, N'2285757500', N'2285757509', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1520 Broad Avenue Suite 300', N'Gulfport', N'MS', N'28047', N'39501', 30.36742, -89.092815, 2018, 156, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3133, N'Regency Hospital Of Meridian', 1, NULL, NULL, N'252006', NULL, NULL, 0, 40, NULL, N'6014847900', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1102 Constitution Avenue 2Nd Floor', N'Meridian', N'MS', N'28075', N'39301', 32.376096, -88.689786, 2038, 159, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3134, N'Select Specialty Hospital Jackson', 1, NULL, NULL, N'252007', NULL, NULL, 0, 53, NULL, N'6018993800', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5903 Ridgewood Road', N'Jackson', N'MS', N'28049', N'39211', 32.390113, -90.141727, 2024, 158, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3135, N'Promise Hospital Of Vicksburg Inc', 1, NULL, NULL, N'252008', NULL, NULL, 0, 35, NULL, N'6018833439', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1111 North Frontage Road 2D Floor', N'Vicksburg', N'MS', N'28149', N'39180', 32.352842, -90.877734, 2054, 158, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3136, N'Regency Hospital Of Hattiesburg', 1, NULL, NULL, N'252009', NULL, NULL, 0, 33, NULL, N'6012888510', N'6012282525', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6051 Us Highway 49 5Th Floor', N'Hattiesburg', N'MS', N'28035', N'39404', 31.327119, -89.290339, 2019, 157, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3137, N'Greenwood - Amg Specialty Hospital', 1, NULL, NULL, N'252010', NULL, NULL, 0, 40, NULL, N'6624515172', N'6624515173', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1401 River Road 2D Floor', N'Greenwood', N'MS', N'28083', N'38930', 33.516232, -90.179528, 2016, 158, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3138, N'Regency Hospital Of Jackson Llc', 1, NULL, NULL, N'252012', NULL, NULL, 0, 36, NULL, N'6013646200', NULL, 1, 1, 0, 0, 0, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'969 Lakeland Drive 6Th Floor', N'Jackson', N'MS', N'28049', N'39216', 32.299038, -90.184769, 2024, 158, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3139, N'Allegiance Specialty Hospital Of Greenville', 1, NULL, NULL, N'252013', NULL, NULL, 0, 39, NULL, N'6623327344', N'6623327295', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'300 South Washington Ave 3Rd Floor', N'Greenville', N'MS', N'28151', N'38701', 33.400063, -91.055131, 2015, 253, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3140, N'Parkwood Behavioral Health System', 1, NULL, NULL, N'254005', NULL, NULL, 0, 88, NULL, N'6628954900', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'8135 Goodman Road', N'Olive Branch', N'MS', N'28033', N'38654', 34.962113, -89.845739, 3168, 253, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3141, N'Brentwood Behavioral Healthcare Of Ms', 1, NULL, NULL, N'254007', NULL, NULL, 0, 1231, NULL, N'6019362024', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3531 East Lakeland Drive', N'Flowood', N'MS', N'28121', N'39232', 32.30959, -90.138976, 2024, 158, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3142, N'South Mississippi State Hospital', 1, NULL, NULL, N'254008', NULL, NULL, 0, 50, NULL, N'6017940100', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'823 Highway 589', N'Purvis', N'MS', N'28073', N'39475', 31.144335, -89.406955, 2019, 157, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3143, N'North Mississippi State Hospital', 1, NULL, NULL, N'254009', NULL, NULL, 0, 82, NULL, N'6626904200', N'6626904227', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1937 Briar Ridge Rd', N'Tupelo', N'MS', N'28081', N'38804', 34.235889, -88.671953, 2052, 161, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3144, N'Ms State Hospital-Whitfield', 1, NULL, NULL, N'254010', NULL, NULL, 0, 306, NULL, N'6013518000', N'6013518326', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3550 Highway 468 West', N'Whitfield', N'MS', N'28121', N'39193', 31.445171, -89.074501, 2024, 158, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3145, N'University Of Mississippi Medical Center', 1, NULL, NULL, N'259800', NULL, NULL, 0, 0, NULL, N'6019844100', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'2500 N State Street', N'Jackson', N'MS', N'28049', N'39216', 32.331803, -90.175423, 2024, 158, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3146, N'Mercy Hospital Joplin', 1, NULL, NULL, N'260001', NULL, NULL, 0, 367, NULL, N'4177812727', N'4176252910', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2817 St Johns Blvd', N'Joplin', N'MO', N'29097', N'64804', 37.084227, -94.513281, 2090, 164, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3147, N'Cooper County Memorial Hospital', 1, NULL, NULL, N'260004', NULL, NULL, 0, 46, NULL, N'6608827461', N'6608826093', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'17651 B Hwy', N'Boonville', N'MO', N'29053', N'65233', 38.973639, -92.743242, 2074, 163, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3148, N'Ssm St Joseph Health Center', 1, NULL, NULL, N'260005', NULL, NULL, 0, 362, NULL, N'6369475000', N'6369475090', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'300 1St Capitol Dr', N'Saint Charles', N'MO', N'29183', N'63301', 38.783194, -90.482368, 2122, 167, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3149, N'Heartland Regional Medical Center', 1, NULL, NULL, N'260006', NULL, NULL, 0, 353, NULL, N'8162716000', N'8162716656', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5325 Faraon Street', N'Saint Joseph', N'MO', N'29021', N'64506', 39.770219, -94.771613, 2123, 165, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3150, N'Bothwell Regional Health Center', 1, NULL, NULL, N'260009', NULL, NULL, 0, 185, NULL, N'6608268833', N'6608296695', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'601 E 14Th St', N'Sedalia', N'MO', N'29159', N'65302', 38.6991, -93.221686, 2118, 163, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3151, N'Ssm Health St. Mary''s Hospital - Jefferson City', 1, NULL, NULL, N'260011', NULL, NULL, 0, 167, NULL, N'5737617000', N'5736365733', 1, 1, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'100 St Mary''s Medical Plaza', N'Jefferson City', N'MO', N'29051', N'65101', 38.577359, -92.172426, 2089, 163, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3152, N'Twin Rivers Regional Medical Center', 1, NULL, NULL, N'260015', NULL, NULL, 0, 116, NULL, N'5738884522', N'5738885525', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1301 First St', N'Kennett', N'MO', N'29069', N'63857', 36.236176, -90.055649, 2092, 13, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3153, N'Phelps County Regional Medical Center', 1, NULL, NULL, N'260017', NULL, NULL, 0, 240, NULL, N'5734588899', N'5733645110', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1000 W 10Th St', N'Rolla', N'MO', N'29161', N'65401', 37.951507, -91.786544, 2116, 167, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3154, N'Mercy Hospital St Louis', 1, NULL, NULL, N'260020', NULL, NULL, 0, 859, NULL, N'3145696000', N'3145696910', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'615 New Ballas Road', N'Saint Louis', N'MO', N'29189', N'63141', 38.627273, -90.197889, 2124, 167, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3155, N'Northeast Regional Medical Center', 1, NULL, NULL, N'260022', NULL, NULL, 0, 194, NULL, N'6607851000', N'6607851110', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'315 S Osteopathy', N'Kirksville', N'MO', N'29001', N'63501', 40.19236, -92.590757, 2093, 163, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3156, N'Mercy Hospital Jefferson', 1, NULL, NULL, N'260023', NULL, NULL, 0, 240, NULL, N'6369331000', N'6369331119', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1400 Highway 61 South', N'Crystal City', N'MO', N'29099', N'63019', 38.221166, -90.379009, 2075, 167, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3157, N'Texas County Memorial Hospital', 1, NULL, NULL, N'260024', NULL, NULL, 0, 49, NULL, N'4179673311', N'4179673764', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1333 Sam Houston Boulevard', N'Houston', N'MO', N'29215', N'65483', 37.317273, -91.959335, 2087, 166, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3158, N'Hannibal Regional Hospital', 1, NULL, NULL, N'260025', NULL, NULL, 0, 91, NULL, N'5732481300', N'5732485264', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6000 Hospital Dr', N'Hannibal', N'MO', N'29127', N'63401', 39.708379, -91.358482, 2083, 163, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3159, N'Research Medical Center', 1, NULL, NULL, N'260027', NULL, NULL, 0, 545, NULL, N'8162764000', N'8162764387', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2316 E Meyer Blvd', N'Kansas City', N'MO', N'29095', N'64132', 39.007228, -94.559451, 2091, 165, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3160, N'Barnes Jewish Hospital', 1, NULL, NULL, N'260032', NULL, NULL, 0, 1737, NULL, N'3147473000', N'3143620468', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'One Barnes-Jewish Hospital Plaza', N'Saint Louis', N'MO', N'29510', N'63110', 38.627273, -90.197889, 2124, 167, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3161, N'Bates County Memorial Hospital', 1, NULL, NULL, N'260034', NULL, NULL, 0, 60, NULL, N'6602007000', N'6606794381', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'615 W Nursery St', N'Butler', N'MO', N'29013', N'64730', 38.249464, -94.34088, 2067, 165, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3162, N'Cox Medical Center', 1, NULL, NULL, N'260040', NULL, NULL, 0, 592, NULL, N'4172696000', N'4172694104', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3801 South National Avenue', N'Springfield', N'MO', N'29077', N'65807', 37.144674, -93.278034, 2121, 166, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3163, N'Capital Region Medical Center', 1, NULL, NULL, N'260047', NULL, NULL, 0, 135, NULL, N'5736325000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1125 Madison St', N'Jefferson City', N'MO', N'29051', N'65102', 38.564603, -92.184289, 2089, 163, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3164, N'Truman Medical Center Hospital Hill', 1, NULL, NULL, N'260048', NULL, NULL, 0, 283, NULL, N'8164041000', N'8164043508', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2301 Holmes Street', N'Kansas City', N'MO', N'29095', N'64108', 39.084938, -94.575686, 2091, 165, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3165, N'St Francis Hospital & Health Services', 1, NULL, NULL, N'260050', NULL, NULL, 0, 90, NULL, N'6605622600', N'6605627911', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2016 South Main St', N'Maryville', N'MO', N'29147', N'64468', 40.328133, -94.874071, 2102, 165, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3166, N'Mercy Hospital Washington', 1, NULL, NULL, N'260052', NULL, NULL, 0, 185, NULL, N'6362398000', N'6365696733', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'901 East 5Th Street', N'Washington', N'MO', N'29071', N'63090', 38.551695, -91.000798, 2124, 167, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3167, N'Cameron Regional Medical Center', 1, NULL, NULL, N'260057', NULL, NULL, 0, 49, NULL, N'8166322101', N'8166493362', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1600 E Evergreen', N'Cameron', N'MO', N'29049', N'64429', 39.767019, -80.94482, 2068, 165, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3168, N'Mercy Hospital Lebanon', 1, NULL, NULL, N'260059', NULL, NULL, 0, 48, NULL, N'4175336100', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'100 Hospital Drive', N'Lebanon', N'MO', N'29105', N'65536', 37.681361, -92.635782, 2121, 166, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3169, N'Nevada Regional Medical Center', 1, NULL, NULL, N'260061', NULL, NULL, 0, 71, NULL, N'4176673355', N'4174483848', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'800 S Ash St', N'Nevada', N'MO', N'29217', N'64772', 37.829822, -94.359849, 2107, 164, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3170, N'Saint Lukes Northland Hospital', 1, NULL, NULL, N'260062', NULL, NULL, 0, 147, NULL, N'8168916000', N'8168806155', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5830 N W Barry Road', N'Kansas City', N'MO', N'29165', N'64154', 39.084469, -94.56303, 2108, 165, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3171, N'Ssm Health St. Mary''s Hospital-Audrain', 1, NULL, NULL, N'260064', NULL, NULL, 0, 201, NULL, N'5735825000', N'5735823700', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'620 E Monroe', N'Mexico', N'MO', N'29007', N'65265', 39.169763, -91.882948, 2104, 163, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3172, N'Mercy Hospital Springfield', 1, NULL, NULL, N'260065', NULL, NULL, 0, 866, NULL, N'4178202000', N'4178888730', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1235 E Cherokee', N'Springfield', N'MO', N'29077', N'65804', 37.215331, -93.298252, 2121, 166, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3173, N'Boone Hospital Center', 1, NULL, NULL, N'260068', NULL, NULL, 0, 394, NULL, N'5738158000', N'5738152638', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1600 E Broadway', N'Columbia', N'MO', N'29019', N'65201', 38.950544, -92.316892, 2074, 163, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3174, N'Pemiscot County Memorial Hospital', 1, NULL, NULL, N'260070', NULL, NULL, 0, 102, NULL, N'5733591372', N'5733593601', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'946 East Reed', N'Hayti', N'MO', N'29155', N'63851', 36.233679, -89.749527, 2085, 162, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3175, N'Moberly Regional Medical Center', 1, NULL, NULL, N'260074', NULL, NULL, 0, 101, NULL, N'6602638400', N'6602693091', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1515 Union Ave', N'Moberly', N'MO', N'29175', N'65270', 39.423997, -92.42348, 2074, 163, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3176, N'St Anthony''s Medical Center', 1, NULL, NULL, N'260077', NULL, NULL, 0, 767, NULL, N'3145251000', N'3145251228', 1, 1, 1, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'10010 Kennerly Road', N'Saint Louis', N'MO', N'29189', N'63128', 38.509102, -90.377055, 2124, 167, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3177, N'Ozarks Medical Center', 1, NULL, NULL, N'260078', NULL, NULL, 0, 120, NULL, N'4172569111', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1100 Kentucky Ave', N'West Plains', N'MO', N'29091', N'65775', 36.737994, -91.875485, 2130, 166, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3178, N'Southeast Health Center Of Ripley County', 1, NULL, NULL, N'260080', NULL, NULL, 0, 30, NULL, N'5739962141', N'5439963949', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'109 Plum St', N'Doniphan', N'MO', N'29181', N'63935', 36.620907, -90.8255, 2113, 167, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3179, N'Ssm St Clare Health Center', 1, NULL, NULL, N'260081', NULL, NULL, 0, 180, NULL, N'6364962000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1015 Bowles', N'Fenton', N'MO', N'29099', N'63026', 38.54079, -90.473455, 2124, 167, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3180, N'St Joseph Medical Center', 1, NULL, NULL, N'260085', NULL, NULL, 0, 300, NULL, N'8169424000', N'8169433131', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1000 Carondelet Dr', N'Kansas City', N'MO', N'29095', N'64114', 38.933893, -94.604164, 2091, 165, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3181, N'Ssm St Marys Health Center', 1, NULL, NULL, N'260091', NULL, NULL, 0, 690, NULL, N'3147688000', N'3147688011', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6420 Clayton Rd', N'Richmond Heights', N'MO', N'29189', N'63117', 38.633885, -90.310249, 2124, 167, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3182, N'Cox Medical Center Branson', 1, NULL, NULL, N'260094', NULL, NULL, 0, 99, NULL, N'4173357000', N'4173341505', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'525 Branson Landing Blvd Po Box 650', N'Branson', N'MO', N'29213', N'65615', 36.64404, -93.217133, 2065, 166, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3183, N'Centerpoint Medical Center', 1, NULL, NULL, N'260095', NULL, NULL, 0, 366, NULL, N'8166987000', N'8168366603', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'19600 East 39Th Street', N'Independence', N'MO', N'29095', N'64057', 39.091116, -94.415507, 2088, 165, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3184, N'North Kansas City Hospital', 1, NULL, NULL, N'260096', NULL, NULL, 0, 451, NULL, N'8166912000', N'8166911097', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2800 Clay Edwards Drive', N'North Kansas City', N'MO', N'29047', N'64116', 39.149912, -94.551443, 2108, 165, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3185, N'Western Missouri Medical Center', 1, NULL, NULL, N'260097', NULL, NULL, 0, 104, NULL, N'6607472500', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'403 Burkarth Road', N'Warrensburg', N'MO', N'29101', N'64093', 38.765533, -93.723639, 2129, 165, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3186, N'Truman Medical Center Lakewood', 1, NULL, NULL, N'260102', NULL, NULL, 0, 304, NULL, N'8164047000', N'8164787500', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7900 Lee''s Summit Rd', N'Kansas City', N'MO', N'29095', N'64139', 38.974606, -94.390447, 2091, 165, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3187, N'Ssm Depaul Health Center', 1, NULL, NULL, N'260104', NULL, NULL, 0, 538, NULL, N'3143446000', N'3143446840', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'12303 Depaul Drive', N'Bridgeton', N'MO', N'29189', N'63044', 38.766995, -90.411506, 2124, 167, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3188, N'St Louis University Hospital', 1, NULL, NULL, N'260105', NULL, NULL, 0, 356, NULL, N'3145778000', N'3145778003', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3635 Vista Ave', N'Saint Louis', N'MO', N'29510', N'63110', 38.622635, -90.239517, 2124, 167, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3189, N'Missouri Baptist Medical Center', 1, NULL, NULL, N'260108', NULL, NULL, 0, 494, NULL, N'3149965000', N'3149965250', 1, 1, 0, 0, 1, 1, 0, 0, 0, 0, 0, 0, NULL, NULL, N'3015 N Ballas Rd', N'Town And Country', N'MO', N'29189', N'63131', 38.634307, -90.443636, 2124, 167, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3190, N'Southeasthealth', 1, NULL, NULL, N'260110', NULL, NULL, 0, 281, NULL, N'5733344822', N'5736515850', 1, 1, 0, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1701 Lacey St', N'Cape Girardeau', N'MO', N'29031', N'63701', 37.311685, -89.542938, 2069, 162, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3191, N'Missouri Delta Medical Center', 1, NULL, NULL, N'260113', NULL, NULL, 0, 188, NULL, N'5734711600', N'5734727606', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1008 North Main St', N'Sikeston', N'MO', N'29143', N'63801', 36.890168, -89.586281, 2119, 162, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3192, N'Mineral Area Regional Medical Center', 1, NULL, NULL, N'260116', NULL, NULL, 0, 127, NULL, N'5737564581', N'5737566007', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1212 Weber Rd', N'Farmington', N'MO', N'29187', N'63640', 37.794253, -90.435322, 2081, 167, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3193, N'Poplar Bluff Regional Medical Center', 1, NULL, NULL, N'260119', NULL, NULL, 0, 230, NULL, N'5737857721', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3100 Oak Grove Road', N'Poplar Bluff', N'MO', N'29023', N'63901', 36.788864, -90.438873, 2113, 167, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3194, N'Freeman Health System - Freeman West', 1, NULL, NULL, N'260137', NULL, NULL, 0, 322, NULL, N'4173471111', N'4173476646', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1102 West 32Nd Street', N'Joplin', N'MO', N'29097', N'64804', 37.054899, -94.524992, 2090, 164, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3195, N'St Lukes Hospital Of Kansas City', 1, NULL, NULL, N'260138', NULL, NULL, 0, 642, NULL, N'8169322000', N'8169325990', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4401 Wornall Road', N'Kansas City', N'MO', N'29095', N'64111', 39.046483, -94.590033, 2091, 165, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3196, N'University Of Missouri Health Care', 1, NULL, NULL, N'260141', NULL, NULL, 0, 368, NULL, N'5738824141', NULL, 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'One Hospital Drive Room Ce121 Dc0310', N'Columbia', N'MO', N'29019', N'65212', 38.951883, -92.333737, 2074, 163, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3197, N'Fitzgibbon Hospital', 1, NULL, NULL, N'260142', NULL, NULL, 0, 60, NULL, N'6608867431', N'6608869001', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2305 S 65 Highway', N'Marshall', N'MO', N'29195', N'65340', 39.123078, -93.19687, 2101, 163, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3198, N'Southeasthealth Center Of Stoddard County', 1, NULL, NULL, N'260160', NULL, NULL, 0, 50, NULL, N'5736245566', N'5736248895', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1200 N One Mile Rd', N'Dexter', N'MO', N'29207', N'63841', 36.806152, -89.97, 2076, 162, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3199, N'Barnes-Jewish West County Hospital', 1, NULL, NULL, N'260162', NULL, NULL, 0, 113, NULL, N'3149968000', N'3149968619', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'12634 Olive Boulevard', N'Creve Coeur', N'MO', N'29189', N'63141', 38.677706, -90.46822, 2124, 167, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3200, N'Parkland Health Center', 1, NULL, NULL, N'260163', NULL, NULL, 0, 133, NULL, N'5734316005', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1101 W Liberty', N'Farmington', N'MO', N'29187', N'63640', 36.730429, -108.208919, 2081, 167, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3201, N'Golden Valley Memorial Hospital', 1, NULL, NULL, N'260175', NULL, NULL, 0, 65, NULL, N'6608855511', N'6608558496', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1600 N 2Nd St', N'Clinton', N'MO', N'29083', N'64735', 38.378102, -93.773722, 2073, 165, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3202, N'Des Peres Hospital', 1, NULL, NULL, N'260176', NULL, NULL, 0, 143, NULL, N'3149669100', N'3149669274', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2345 Dougherty Ferry Road', N'Saint Louis', N'MO', N'29189', N'63122', 38.589952, -90.430419, 2124, 167, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3203, N'Liberty Hospital', 1, NULL, NULL, N'260177', NULL, NULL, 0, 250, NULL, N'8167817200', N'8167927117', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2525 Glenn Hendren Dr', N'Liberty', N'MO', N'29047', N'64069', 39.275501, -94.426274, 2098, 165, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3204, N'St Lukes Hospital', 1, NULL, NULL, N'260179', NULL, NULL, 0, 493, NULL, N'3144341500', N'3142056865', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'232 S Woods Mill Rd', N'Chesterfield', N'MO', N'29189', N'63017', 38.654702, -90.507554, 2124, 167, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3205, N'Christian Hospital Northeast-Northwest', 1, NULL, NULL, N'260180', NULL, NULL, 0, 475, NULL, N'3146535000', N'3146534408', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'11133 Dunn Road', N'Saint Louis', N'MO', N'29189', N'63136', 38.775329, -90.239381, 2124, 167, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3206, N'Saint Francis Medical Center', 1, NULL, NULL, N'260183', NULL, NULL, 0, 264, NULL, N'5733313000', N'5733315009', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'211 St Francis Dr', N'Cape Girardeau', N'MO', N'29031', N'63703', 37.301525, -89.572398, 2069, 162, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3207, N'Lake Regional Health System', 1, NULL, NULL, N'260186', NULL, NULL, 0, 99, NULL, N'5733488000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'54 Hospital Drive', N'Osage Beach', N'MO', N'29029', N'65065', 38.119233, -92.683171, 2109, 163, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3208, N'Lee''s Summit Medical Center', 1, NULL, NULL, N'260190', NULL, NULL, 0, 102, NULL, N'8162825000', N'8162825942', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2100 Se Blue Parkway', N'Lees Summit', N'MO', N'29095', N'64063', 38.903454, -94.363857, 2096, 165, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3209, N'Barnes-Jewish St Peters Hospital', 1, NULL, NULL, N'260191', NULL, NULL, 0, 111, NULL, N'6369169000', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'10 Hospital Dr', N'Saint Peters', N'MO', N'29183', N'63376', 38.792522, -90.579578, 2124, 167, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3210, N'St Mary''s Medical Center', 1, NULL, NULL, N'260193', NULL, NULL, 0, 111, NULL, N'8162285900', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'201 Nw R D Mize Rd', N'Blue Springs', N'MO', N'29095', N'64014', 39.023405, -94.264742, 2063, 165, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3211, N'Citizens Memorial Hospital', 1, NULL, NULL, N'260195', NULL, NULL, 0, 74, NULL, N'4173266000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1500 N Oakland', N'Bolivar', N'MO', N'29167', N'65613', 37.614484, -93.410475, 2064, 166, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3212, N'Ssm St Joseph Hospital West', 1, NULL, NULL, N'260200', NULL, NULL, 0, 100, NULL, N'6366255200', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'100 Medical Plaza', N'Lake Saint Louis', N'MO', N'29183', N'63367', 38.803063, -90.775224, 2094, 167, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3213, N'Ozarks Community Hospital', 1, NULL, NULL, N'260207', NULL, NULL, 0, 45, NULL, N'4178374000', N'4178374291', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2828 North National', N'Springfield', N'MO', N'29077', N'65803', 37.215331, -93.298252, 2121, 166, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3214, N'Callaway Community Hospital', 1, NULL, NULL, N'260209', NULL, NULL, 0, 49, NULL, N'5736423376', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'10 South Hospital Drive', N'Fulton', N'MO', N'29027', N'65251', 38.842265, -91.966029, 2074, 163, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3215, N'St Alexius Hospital', 1, NULL, NULL, N'260210', NULL, NULL, 0, 563, NULL, N'3148657000', N'3148657934', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3933 S Broadway', N'Saint Louis', N'MO', N'29510', N'63118', 38.583377, -90.227611, 2124, 167, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3216, N'Belton Regional Medical Center', 1, NULL, NULL, N'260214', NULL, NULL, 0, 71, NULL, N'8163481236', N'8163481271', 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'17065 S 71 Highway', N'Belton', N'MO', N'29037', N'64012', 38.811953, -94.531898, 2091, 165, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3217, N'Saint Luke''s East Lee''s Summit Hospital', 1, NULL, NULL, N'260216', NULL, NULL, 0, 52, NULL, N'8163475000', NULL, 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'100 N E Saint Luke''s Boulevard', N'Lees Summit', N'MO', N'29095', N'64086', 38.910841, -94.382172, 2096, 165, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3218, N'Progress West Hospital', 1, NULL, NULL, N'260219', NULL, NULL, 0, 72, NULL, N'6363441000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2 Progress Point Pkwy', N'O Fallon', N'MO', N'29183', N'63368', 38.760482, -92.561787, 2122, 167, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3219, N'Black River Community Medical Center', 1, NULL, NULL, N'260227', NULL, NULL, 0, 3, NULL, N'5736866001', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'217 Physicians Park Drive', N'Poplar Bluff', N'MO', N'29023', N'63901', 36.756999, -90.392888, 2113, 167, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3220, N'Mercy Mccune Brooks Hospital', 1, NULL, NULL, N'260228', NULL, NULL, 0, 49, NULL, N'4173588121', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3125 Dr Russell Smith Way', N'Carthage', N'MO', N'29097', N'64836', 37.176447, -94.310223, 2071, 164, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3221, N'Southeast Health Center Of Reynolds County', 1, NULL, NULL, N'260229', NULL, NULL, 0, 25, NULL, N'5733344822', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'100 Hwy 21 N', N'Ellington', N'MO', N'29179', N'63638', 37.241715, -90.968736, 2078, 167, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3222, N'Kindred Hospital-St Louis At Mercy', 1, NULL, NULL, N'260230', NULL, NULL, 0, 54, NULL, N'3145674326', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'615 S New Ballas Road 7Th Floor', N'Saint Louis', N'MO', N'29189', N'63141', 38.627273, -90.197889, 2124, 167, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3223, N'Ellett Memorial Hospital', 1, NULL, NULL, N'261301', NULL, NULL, 0, 12, NULL, N'6604762111', N'6604765591', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'610 N Ohio Ave', N'Appleton City', N'MO', N'29185', N'64724', 38.190582, -94.029387, 2060, 165, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3224, N'Madison Medical Center', 1, NULL, NULL, N'261302', NULL, NULL, 0, 25, NULL, N'5737813341', N'5737831096', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'611 W Main St', N'Fredericktown', N'MO', N'29123', N'63645', 37.559814, -90.301112, 2082, 167, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3225, N'Community Hospital Association', 1, NULL, NULL, N'261303', NULL, NULL, 0, 25, NULL, N'6606862111', N'6606862618', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'26136 Us Highway 59 Po Box 107', N'Fairfax', N'MO', N'29005', N'64446', 40.338609, -95.393314, 2080, 172, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3226, N'Putnam County Memorial Hospital', 1, NULL, NULL, N'261305', NULL, NULL, 0, 25, NULL, N'6609472411', N'6609473825', 1, 1, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'1926 Oak Street  Po Box 389', N'Unionville', N'MO', N'29171', N'63565', 40.476961, -93.003261, 2128, 163, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3227, N'Sullivan County Memorial Hospital', 1, NULL, NULL, N'261306', NULL, NULL, 0, 25, NULL, N'6602654212', N'6602654898', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'630 West Third Street', N'Milan', N'MO', N'29211', N'63556', 40.202241, -93.125209, 2105, 163, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3228, N'Pershing Memorial Hospital', 1, NULL, NULL, N'261307', NULL, NULL, 0, 25, NULL, N'6602582222', N'6602585668', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'130 East Lockling', N'Brookfield', N'MO', N'29115', N'64628', 39.775477, -93.066856, 2066, 163, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3229, N'Washington County Memorial Hospital', 1, NULL, NULL, N'261308', NULL, NULL, 0, 25, NULL, N'5734385451', N'5734382399', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'300 Health Way', N'Potosi', N'MO', N'29221', N'63664', 37.936438, -90.787909, 2114, 167, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3230, N'Wright Memorial Hospital', 1, NULL, NULL, N'261309', NULL, NULL, 0, 25, NULL, N'6603595621', N'6603593541', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'191 Iowa Boulevard', N'Trenton', N'MO', N'29079', N'64683', 40.072998, -93.579983, 2126, 165, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3231, N'Scotland County  Hospital', 1, NULL, NULL, N'261310', NULL, NULL, 0, 25, NULL, N'6604658511', N'6604652513', 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'450 E Sigler Avenue', N'Memphis', N'MO', N'29199', N'63555', 40.465856, -92.166448, 2103, 105, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3232, N'Perry County Memorial Hospital', 1, NULL, NULL, N'261311', NULL, NULL, 0, 25, NULL, N'5735472530', N'5735472530', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'434 North West Street', N'Perryville', N'MO', N'29157', N'63775', 37.731902, -89.864907, 2111, 162, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3233, N'Harrison County Community Hospital', 1, NULL, NULL, N'261312', NULL, NULL, 0, 19, NULL, N'6604250284', N'6604252366', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2600 Miller Street', N'Bethany', N'MO', N'29081', N'64424', 40.265197, -94.025787, 2062, 165, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3234, N'Macon County Samaritan Memorial Hospital', 1, NULL, NULL, N'261313', NULL, NULL, 0, 25, NULL, N'6603858700', N'6603854772', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1205 North Missouri St', N'Macon', N'MO', N'29121', N'63552', 39.747907, -92.468134, 2100, 163, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3235, N'Hermann Area District Hospital', 1, NULL, NULL, N'261314', NULL, NULL, 0, 25, NULL, N'5734862191', N'5734863743', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'509 W 18Th St', N'Hermann', N'MO', N'29073', N'65041', 38.704212, -91.437384, 2086, 163, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3236, N'Parkland Health Center - Bonne Terre', 1, NULL, NULL, N'261315', NULL, NULL, 0, 3, NULL, N'5733581400', N'5737608168', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7245 Raider Road', N'Bonne Terre', N'MO', N'29187', N'63628', 37.917133, -90.53831, 2081, 167, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3237, N'Mercy Hospital Aurora', 1, NULL, NULL, N'261316', NULL, NULL, 0, 25, NULL, N'4176782122', N'4176787877', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'500 Porter Avenue', N'Aurora', N'MO', N'29109', N'65605', 40.866888, -98.004508, 2061, 166, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3238, N'Mercy Hospital Cassville', 1, NULL, NULL, N'261317', NULL, NULL, 0, 18, NULL, N'4178476065', N'4178476073', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'94 Main Street', N'Cassville', N'MO', N'29009', N'65625', 36.673971, -93.872381, 2121, 166, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3239, N'Salem Memorial District Hospital', 1, NULL, NULL, N'261318', NULL, NULL, 0, 25, NULL, N'5737296626', N'5737294511', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Po Box 774', N'Salem', N'MO', N'29065', N'65560', 37.645599, -91.535981, 2117, 167, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3240, N'Lincoln County Medical Center', 1, NULL, NULL, N'261319', NULL, NULL, 0, 25, NULL, N'6365288551', N'6365283444', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1000 East Cherry Street', N'Troy', N'MO', N'29113', N'63379', 38.981925, -90.973884, 2127, 167, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3241, N'Lafayette Regional Health Center', 1, NULL, NULL, N'261320', NULL, NULL, 0, 25, NULL, N'6602592203', N'6602596819', 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1500 State Street', N'Lexington', N'MO', N'29107', N'64067', 39.188995, -93.874423, 2097, 165, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3242, N'Hedrick Medical Center', 1, NULL, NULL, N'261321', NULL, NULL, 0, 25, NULL, N'6606461480', N'6606466024', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2799 North Washington Street', N'Chillicothe', N'MO', N'29117', N'64601', 39.818669, -93.55218, 2072, 165, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3243, N'Excelsior Springs Hospital', 1, NULL, NULL, N'261322', NULL, NULL, 0, 25, NULL, N'8166306081', N'8166292701', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1700 Rainbow Boulevard', N'Excelsior Springs', N'MO', N'29047', N'64024', 39.363702, -94.236803, 2079, 165, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3244, N'Cedar County Memorial Hospital', 1, NULL, NULL, N'261323', NULL, NULL, 0, 25, NULL, N'4178762511', N'4178763812', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1401 South Park Street', N'El Dorado Springs', N'MO', N'29039', N'64744', 37.859451, -94.01845, 2077, 166, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3245, N'Cass Regional Medical Center', 1, NULL, NULL, N'261324', NULL, NULL, 0, 35, NULL, N'8163805888', N'8163804639', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2800 E Rock Haven Road', N'Harrisonville', N'MO', N'29037', N'64701', 38.663926, -94.376635, 2084, 165, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3246, N'Barton County Memorial Hospital', 1, NULL, NULL, N'261325', NULL, NULL, 0, 25, NULL, N'4176826081', N'4176822138', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'29 Nw 1St Lane', N'Lamar', N'MO', N'29011', N'64759', 37.504102, -94.299845, 2095, 164, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3247, N'Ray County Memorial Hospital', 1, NULL, NULL, N'261327', NULL, NULL, 0, 25, NULL, N'8164705432', N'8164702331', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'904 Wollard Boulevard', N'Richmond', N'MO', N'29177', N'64085', 39.269405, -93.959237, 2115, 165, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3248, N'Northwest Medical Center', 1, NULL, NULL, N'261328', NULL, NULL, 0, 25, NULL, N'6607263941', N'6607263647', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'705 N College Street', N'Albany', N'MO', N'29075', N'64402', 40.248607, -94.331068, 2059, 165, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3249, N'Cox Monett Hospital', 1, NULL, NULL, N'261329', NULL, NULL, 0, 25, NULL, N'4173541400', N'4173541412', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'801 North Lincoln Avenue', N'Monett', N'MO', N'29009', N'65708', 36.926784, -93.931148, 2121, 166, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3250, N'Ste Genevieve County Memorial Hospital', 1, NULL, NULL, N'261330', NULL, NULL, 0, 25, NULL, N'5738832751', N'5738837755', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'800 Ste Genevieve Drive Po Box 468', N'Sainte Genevieve', N'MO', NULL, N'63670', 37.981442, -90.041779, 2125, 167, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3251, N'Freeman Neosho Hospital', 1, NULL, NULL, N'261331', NULL, NULL, 0, 25, NULL, N'4174511234', N'4174554355', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'113 West Hickory Street', N'Neosho', N'MO', N'29145', N'64850', 36.867974, -94.376833, 2106, 164, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3252, N'Carroll County Memorial Hospital', 1, NULL, NULL, N'261332', NULL, NULL, 0, 25, NULL, N'6605421695', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1502 North Jefferson', N'Carrollton', N'MO', N'29033', N'64633', 39.358354, -93.495767, 2070, 165, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3253, N'Pike County Memorial Hospital', 1, NULL, NULL, N'261333', NULL, NULL, 0, 25, NULL, N'5737545531', N'5737545874', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2305 West Georgia Street', N'Louisiana', N'MO', N'29163', N'63353', 39.449215, -91.046574, 2099, 167, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3254, N'I-70 Community Hospital', 1, NULL, NULL, N'261334', NULL, NULL, 0, 15, NULL, N'6603354700', N'6603357487', 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'105 Hospital Drive Building B', N'Sweet Springs', N'MO', N'29195', N'65351', 38.963629, -93.414932, 2101, 163, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3255, N'Mercy St Francis Hospital', 1, NULL, NULL, N'261335', NULL, NULL, 0, 25, NULL, N'4179347000', N'4179347092', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'100 West Highway 60 Po Box 82', N'Mountain View', N'MO', N'29091', N'65548', 33.340101, -104.523302, 2121, 166, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3256, N'Iron County Hospital', 1, NULL, NULL, N'261336', NULL, NULL, 0, 15, NULL, N'5735461260', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'301 North Highway 21', N'Pilot Knob', N'MO', N'29093', N'63663', 37.621161, -90.640401, 2112, 167, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3257, N'Missouri Baptist Sullivan Hospital', 1, NULL, NULL, N'261337', NULL, NULL, 0, 50, NULL, N'5734684186', N'5738602696', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'751 Sappington Bridge Rd', N'Sullivan', N'MO', N'29071', N'63080', 38.195803, -91.169317, 2124, 167, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3258, N'Mercy Mccune-Brooks Hospital', 1, NULL, NULL, N'261338', NULL, NULL, 0, 49, NULL, N'4173588121', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3125 Dr Russell Smith Way', N'Carthage', N'MO', N'29097', N'64836', 37.176447, -94.310223, 2071, 164, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3259, N'Peace Haven Association', 1, NULL, NULL, N'261993', NULL, NULL, 0, 42, NULL, N'3149653833', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'12630 Rott Road', N'Saint Louis', N'MO', N'29189', N'63127', 38.550404, -90.418474, 2124, 167, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3260, N'Missouri Rehabilitation Ctr', 1, NULL, NULL, N'262001', NULL, NULL, 0, 104, NULL, N'4174663711', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'600 N Main', N'Mount Vernon', N'MO', N'29109', N'65712', 37.115788, -93.818527, 2121, 166, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3261, N'Kindred Hospital - St Louis', 1, NULL, NULL, N'262010', NULL, NULL, 0, 60, NULL, N'3143618700', N'3143611210', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4930 Lindell Boulevard', N'Saint Louis', N'MO', N'29510', N'63108', 38.643397, -90.262902, 2124, 167, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3262, N'Kindred Hospital - Kansas City', 1, NULL, NULL, N'262011', NULL, NULL, 0, 167, NULL, N'8169952000', N'8169952171', 1, 0, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'8701 Troost Avenue', N'Kansas City', N'MO', N'29095', N'64131', 38.969152, -94.576639, 2091, 165, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3263, N'Select Specialty Hospital-St Louis', 1, NULL, NULL, N'262013', NULL, NULL, 0, 33, NULL, N'3147683400', N'3147683002', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'300 First Capitol Drive', N'Saint Charles', N'MO', N'29183', N'63301', 38.780933, -90.484898, 2122, 167, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3264, N'Select Specialty Hospital - Western Missouri', 1, NULL, NULL, N'262014', NULL, NULL, 0, 34, NULL, N'8162769444', N'8162769777', 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'2316 East Meyer Boulevard 3-West', N'Kansas City', N'MO', N'29095', N'64132', 39.084469, -94.56303, 2091, 165, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3265, N'Landmark Hospital Of Cape Girardeau Llc', 1, NULL, NULL, N'262015', NULL, NULL, 0, 30, NULL, N'5733351091', N'5733318453', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3255 Independence', N'Cape Girardeau', N'MO', N'29031', N'63703', 37.308181, -89.575664, 2069, 162, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3266, N'Landmark Hospital Of Joplin Llc', 1, NULL, NULL, N'262016', NULL, NULL, 0, 30, NULL, N'4177814352', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2040 W 32Nd Street', N'Joplin', N'MO', N'29097', N'64804', 37.055319, -94.538297, 2090, 164, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3267, N'Select Specialty Hospital Springfield Inc', 1, NULL, NULL, N'262017', NULL, NULL, 0, 44, NULL, N'4178811657', N'4178854777', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1630 East Primrose', N'Springfield', N'MO', N'29077', N'65804', 37.215331, -93.298252, 2121, 166, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3268, N'Kindred Hospital Northland', 1, NULL, NULL, N'262018', NULL, NULL, 0, 35, NULL, N'8164206300', NULL, 1, 0, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'500 Nw 68Th Street', N'Kansas City', N'MO', N'29047', N'64118', 39.217494, -94.587433, 2108, 165, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3269, N'Heartland Long Term Acute Care Hospital', 1, NULL, NULL, N'262019', NULL, NULL, 0, 41, NULL, N'8162716480', N'8162714077', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5325 Faraon Street', N'Saint Joseph', N'MO', N'29021', N'64506', 39.770219, -94.771613, 2123, 165, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3270, N'Landmark Hospital Of Columbia Llc', 1, NULL, NULL, N'262020', NULL, NULL, 0, 42, NULL, N'5734996600', N'5734996651', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'604 Old Highway 63 North', N'Columbia', N'MO', N'29019', N'65201', 38.951883, -92.333737, 2074, 163, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3271, N'Rusk Rehabilitation Ctr', 1, NULL, NULL, N'263027', NULL, NULL, 0, 72, NULL, N'5738172703', N'5738174690', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'315 Business Loop 70 W', N'Columbia', N'MO', N'29019', N'65203', 38.967535, -92.361947, 2074, 163, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3272, N'The Rehabilitation Institute Of St Louis', 1, NULL, NULL, N'263028', NULL, NULL, 0, 80, NULL, N'3146583925', N'3145341132', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4455 Duncan Ave', N'Saint Louis', N'MO', N'29510', N'63110', 38.635478, -90.252432, 2124, 167, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3273, N'Mercy Rehabilitation Hospital St Louis', 1, NULL, NULL, N'263029', NULL, NULL, 0, 68, NULL, N'3148892704', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'14561 North Outer Forty', N'Chesterfield', N'MO', N'29189', N'63017', 38.656057, -90.574203, 2124, 167, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3274, N'St Luke''s Rehabilitation Hospital', 1, NULL, NULL, N'263030', NULL, NULL, 0, 35, NULL, N'3143175700', NULL, 1, 0, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'14709 Olive Boulevard', N'Chesterfield', N'MO', N'29189', N'63017', 38.674623, -90.532112, 2124, 167, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3275, N'Ssm Rehabilitation Hospital', 1, NULL, NULL, N'263031', NULL, NULL, 0, 95, NULL, N'3147685202', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1027 Bellevue Avenue', N'Richmond Heights', N'MO', N'29189', N'63117', 38.632958, -90.312166, 2124, 167, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3276, N'Mercy Rehabilitation Hospital Springfield', 1, NULL, NULL, N'263032', NULL, NULL, 0, 60, NULL, N'4178202973', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5904 S Southwood Rd', N'Springfield', N'MO', N'29077', N'65804', 37.215331, -93.298252, 2121, 166, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3277, N'St Louis Childrens Hospital', 1, NULL, NULL, N'263301', NULL, NULL, 0, 235, NULL, N'3144546000', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'One Childrens Place', N'Saint Louis', N'MO', N'29510', N'63110', 38.627273, -90.197889, 2124, 167, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3278, N'Childrens Mercy Hospital', 1, NULL, NULL, N'263302', NULL, NULL, 0, 263, NULL, N'8162343000', N'8162343793', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2401 Gillham Road', N'Kansas City', N'MO', N'29095', N'64108', 39.083487, -94.578741, 2091, 165, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3279, N'Ranken Jordan A Pediatric Rehab', 1, NULL, NULL, N'263303', NULL, NULL, 0, 30, NULL, N'3148726400', N'3148726500', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'11365 Dorsett Road', N'Maryland Heights', N'MO', N'29189', N'63043', 38.711047, -90.417431, 2124, 167, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3280, N'Shriners Hospitals For Children', 1, NULL, NULL, N'263304', NULL, NULL, 0, 80, NULL, N'3144323600', N'3144322930', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2001 South Lindbergh Boulevard', N'Town And Country', N'MO', N'29189', N'63131', 38.612275, -90.463453, 2124, 167, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3281, N'Fulton State Hospital', 1, NULL, NULL, N'264004', NULL, NULL, 0, 484, NULL, N'5735924100', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'600 East 5Th Street', N'Fulton', N'MO', N'29027', N'65251', 38.847019, -91.939708, 2074, 163, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3282, N'Southeast Missouri Mental Hlth Ctr', 1, NULL, NULL, N'264005', NULL, NULL, 0, 196, NULL, N'5732186792', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1010 West Columbia Street', N'Farmington', N'MO', N'29187', N'63640', 37.773927, -90.439018, 2081, 167, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3283, N'Northwest Mo Psychiatric Rehab Ctr', 1, NULL, NULL, N'264007', NULL, NULL, 0, 142, NULL, N'8163872300', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3505 Frederick Avenue', N'Saint Joseph', N'MO', N'29021', N'64502', 39.767542, -94.849154, 2123, 165, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3284, N'Center For Behavioral Medicine', 1, NULL, NULL, N'264008', NULL, NULL, 0, 160, NULL, N'8165127000', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1000 E 24Th Street', N'Kansas City', N'MO', N'29095', N'64108', 39.083813, -94.57207, 2091, 165, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3285, N'St Louis Psychiatric Rehab Center', 1, NULL, NULL, N'264010', NULL, NULL, 0, 216, NULL, N'3146448000', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5400 Arsenal St', N'Saint Louis', N'MO', N'29510', N'63139', 38.60594, -90.279496, 2124, 167, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3286, N'Centerpointe Hospital', 1, NULL, NULL, N'264012', NULL, NULL, 0, 104, NULL, N'6364417300', N'6364772165', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'4801 Weldon Spring Parkway', N'Saint Charles', N'MO', N'29183', N'63304', 38.783194, -90.482368, 2124, 167, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3287, N'Two Rivers Behavioral Health System', 1, NULL, NULL, N'264017', NULL, NULL, 0, 105, NULL, N'8163565688', N'8163566147', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5121 Raytown Road', N'Kansas City', N'MO', N'29095', N'64133', 39.044348, -94.488761, 2091, 165, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3288, N'Crittenton Children''s Center', 1, NULL, NULL, N'264018', NULL, NULL, 0, 75, NULL, N'8167656600', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'10918 Elm Avenue', N'Kansas City', N'MO', N'29095', N'64134', 38.924572, -94.477996, 2091, 165, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3289, N'Royal Oaks Hospital', 1, NULL, NULL, N'264020', NULL, NULL, 0, 41, NULL, N'6606472182', N'6606472217', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'307 N Main', N'Windsor', N'MO', N'29083', N'65360', 38.53224, -93.522154, 2073, 165, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3290, N'Lakeland Behavioral Health System', 1, NULL, NULL, N'264024', NULL, NULL, 0, 106, NULL, N'4178655581', N'4178655964', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'440 S Market', N'Springfield', N'MO', N'29077', N'65806', 37.215331, -93.298252, 2121, 166, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3291, N'Metropolitan St Louis Psychiatric Ctr', 1, NULL, NULL, N'264025', NULL, NULL, 0, 125, NULL, N'3148770500', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5351 Delmar Boulevard', N'Saint Louis', N'MO', N'29510', N'63112', 38.65307, -90.274735, 2124, 167, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3292, N'Hawthorn Children''s Psychiatric Hospital', 1, NULL, NULL, N'264028', NULL, NULL, 0, 44, NULL, N'3145127800', N'3145127812', 1, 0, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1901 Pennsylvania Avenue', N'Saint Louis', N'MO', N'29189', N'63133', 38.685942, -90.31256, 2124, 167, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3293, N'St Louis Regional Psychiatric Stabilization Center', 1, NULL, NULL, N'264029', NULL, NULL, 0, 25, NULL, N'3149327110', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5355 Delmar Blvd', N'Saint Louis', N'MO', N'29510', N'63112', 38.653071, -90.274743, 2124, 167, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3294, N'Signature Psychiatric Hospital', 1, NULL, NULL, N'264030', NULL, NULL, 0, 24, NULL, N'8166915101', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2900 Clay Edwards Drive', N'North Kansas City', N'MO', N'29047', N'64116', 39.150692, -94.550251, 2108, 165, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3295, N'St Luke''s Hospital Of Kansas City', 1, NULL, NULL, N'269800', NULL, NULL, 0, 0, NULL, N'8169322000', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'4401 Wornall Road', N'Kansas City', N'MO', N'29095', N'64111', 39.046483, -94.590033, 2091, 165, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3296, N'Research Medical Center', 1, NULL, NULL, N'269801', NULL, NULL, 0, 0, NULL, N'8162764000', N'8162764387', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'2316 East Meyer Boulevard', N'Kansas City', N'MO', N'29095', N'64132', 39.007228, -94.559451, 2091, 165, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3297, N'St Louis University Hospital', 1, NULL, NULL, N'269802', NULL, NULL, 0, 0, NULL, N'3145778000', N'3145778003', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'3635 Vista Ave Po Box 15250', N'Saint Louis', N'MO', N'29510', N'63111', 38.627273, -90.197889, 2124, 167, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3298, N'Barnes-Jewish Hospital', 1, NULL, NULL, N'269803', NULL, NULL, 0, 0, NULL, N'3147473000', N'3143620468', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'216 South Kingshighway', N'Saint Louis', N'MO', N'29510', N'63110', 38.627273, -90.197889, 2124, 167, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3299, N'University Of Mo Hospital & Clinics', 1, NULL, NULL, N'269804', NULL, NULL, 0, 0, NULL, N'5738824141', N'5738844174', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'One Hospital Drive Room Ce121 Dc0310', N'Columbia', N'MO', N'29019', N'65212', 38.951883, -92.333737, 2074, 163, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3300, N'St Louis Children''s Hospital', 1, NULL, NULL, N'269805', NULL, NULL, 0, 0, NULL, N'3144546000', N'3144542101', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'One Children''s Place', N'Saint Louis', N'MO', N'29510', N'63110', 38.627273, -90.197889, 2124, 167, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3301, N'The Children''s Mercy Hospital', 1, NULL, NULL, N'269806', NULL, NULL, 0, 0, NULL, N'8162343000', N'8162343793', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'2401 Gillham Road', N'Kansas City', N'MO', N'29095', N'64108', 39.083487, -94.578741, 2091, 165, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3302, N'Ssm Cardinal Glennon Children''s Hospital', 1, NULL, NULL, N'269807', NULL, NULL, 0, 0, NULL, N'3145775600', N'3145775304', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'1465 South Grand Boulevard', N'Saint Louis', N'MO', N'29510', N'63104', 38.621436, -90.23843, 2124, 167, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3303, N'St Peter''s Hospital', 1, NULL, NULL, N'270003', NULL, NULL, 0, 99, NULL, N'4064422480', N'4064442389', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2475 Broadway', N'Helena', N'MT', N'30049', N'59601', 46.584098, -111.995881, 2148, 168, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3304, N'Billings Clinic Hospital', 1, NULL, NULL, N'270004', NULL, NULL, 0, 285, NULL, N'4066574000', N'4062382785', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2800 10Th Ave N', N'Billings', N'MT', N'30111', N'59101', 45.789119, -108.513746, 2133, 168, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3305, N'Benefis Hospitals Inc', 1, NULL, NULL, N'270012', NULL, NULL, 0, 398, NULL, N'4064555000', N'4064554587', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1101 26Th St S', N'Great Falls', N'MT', N'30013', N'59405', 47.492596, -111.262422, 2144, 169, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3306, N'St Patrick Hospital', 1, NULL, NULL, N'270014', NULL, NULL, 0, 253, NULL, N'4065437271', N'4063295693', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'500 W Broadway', N'Missoula', N'MT', N'30063', N'59806', 46.879583, -113.921459, 2155, 170, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3307, N'St James Healthcare', 1, NULL, NULL, N'270017', NULL, NULL, 0, 98, NULL, N'4067232500', N'4067232486', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'400 S Clark St', N'Butte', N'MT', N'30093', N'59701', 46.022517, -112.546185, 2135, 170, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3308, N'Community Medical Center', 1, NULL, NULL, N'270023', NULL, NULL, 0, 151, NULL, N'4067284100', N'4063274545', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2827 Fort Missoula Rd', N'Missoula', N'MT', N'30063', N'59804', 46.845903, -114.046195, 2155, 170, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3309, N'Northern Montana Hospital', 1, NULL, NULL, N'270032', NULL, NULL, 0, 49, NULL, N'4062652211', N'4062651651', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'30 13Th St', N'Havre', N'MT', N'30041', N'59501', 48.539265, -109.687147, 2147, 169, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3310, N'St Vincent Healthcare', 1, NULL, NULL, N'270049', NULL, NULL, 0, 286, NULL, N'4066577000', N'4062373078', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1233 N 30Th St', N'Billings', N'MT', N'30111', N'59107', 45.792992, -108.519911, 2133, 168, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3311, N'Kalispell Regional Medical Center', 1, NULL, NULL, N'270051', NULL, NULL, 0, 160, NULL, N'4067525111', N'4067563690', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'310 Sunnyview Lane', N'Kalispell', N'MT', N'30029', N'59901', 48.21503, -114.326374, 2149, 170, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3312, N'Bozeman Deaconess Hospital', 1, NULL, NULL, N'270057', NULL, NULL, 0, 86, NULL, N'4065855000', N'4065851070', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'915 Highland Blvd', N'Bozeman', N'MT', N'30031', N'59715', 45.667641, -111.020476, 2134, 168, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3313, N'P H S Indian Hospital At Browning - Blackfeet', 1, NULL, NULL, N'270074', NULL, NULL, 0, 28, NULL, N'4063386157', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'760 Hospital Circle Post Office Box 760', N'Browning', N'MT', N'30035', N'59417', 48.556877, -113.013045, 2171, 169, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3314, N'Great Falls Clinic Medical Center', 1, NULL, NULL, N'270086', NULL, NULL, 0, 20, NULL, N'4062168000', N'4062168001', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1411 9Th St S', N'Great Falls', N'MT', N'30013', N'59405', 47.489773, -111.292078, 2144, 169, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3315, N'The Healthcenter', 1, NULL, NULL, N'270087', NULL, NULL, 0, 30, NULL, N'4067564720', N'4067515430', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'320 Sunnyview Lane', N'Kalispell', N'MT', N'30029', N'59901', 48.215025, -114.326267, 2149, 170, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3316, N'Poplar Community Hospital', 1, NULL, NULL, N'271300', NULL, NULL, 0, 20, NULL, N'4067686100', N'4067686160', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'211 H St E', N'Poplar', N'MT', N'30085', N'59255', 48.113074, -105.198315, 2159, 168, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3317, N'Fallon Medical Complex Hospital', 1, NULL, NULL, N'271301', NULL, NULL, 0, 25, NULL, N'4067783331', N'4067782488', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'202 S 4Th St W', N'Baker', N'MT', N'30025', N'59313', 46.364754, -104.281438, 2132, 168, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3318, N'Dahl Memorial Healthcare Assoc', 1, NULL, NULL, N'271302', NULL, NULL, 0, 8, NULL, N'4067758739', N'4067756706', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'215 Sandy St', N'Ekalaka', N'MT', N'30011', N'59324', 45.88762, -104.549067, 2132, 168, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3319, N'Granite County Medical Center', 1, NULL, NULL, N'271303', NULL, NULL, 0, 25, NULL, N'4068593271', N'4068593011', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'310 Sansome St', N'Philipsburg', N'MT', N'30039', N'59858', 46.332804, -113.294484, 2155, 170, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3320, N'Missouri River Medical Center', 1, NULL, NULL, N'271304', NULL, NULL, 0, 7, NULL, N'4066223331', N'4066225670', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1501 St Charles St', N'Fort Benton', N'MT', N'30015', N'59442', 47.820296, -110.672815, 2144, 169, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3321, N'Mccone County Health Center', 1, NULL, NULL, N'271305', NULL, NULL, 0, 25, NULL, N'4064853381', N'4064853383', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'605 Sullivan Ave', N'Circle', N'MT', N'30055', N'59215', 47.418932, -105.581797, 2165, 168, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3322, N'Mountainview Medical Center', 1, NULL, NULL, N'271306', NULL, NULL, 0, 25, NULL, N'4065473321', N'4065473589', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'16 W Main St', N'White Sulphur Spring', N'MT', N'30059', N'59645', 47.375267, -109.638758, 2168, 168, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3323, N'Teton Medical Center', 1, NULL, NULL, N'271307', NULL, NULL, 0, 10, NULL, N'4064665763', N'4064665852', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'915 4Th St Nw', N'Choteau', N'MT', N'30099', N'59422', 47.813426, -112.190803, 2144, 169, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3324, N'Roosevelt Medical Center', 1, NULL, NULL, N'271308', NULL, NULL, 0, 25, NULL, N'4067876401', N'4067876461', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'818 2Nd Ave E', N'Culbertson', N'MT', N'30085', N'59218', 48.15126, -104.515254, 2642, 207, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3325, N'Prairie Community Hospital', 1, NULL, NULL, N'271309', NULL, NULL, 0, 22, NULL, N'4066355511', N'4066355510', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'312 S Adams', N'Terry', N'MT', N'30079', N'59349', 46.793063, -105.312209, 2154, 168, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3326, N'Garfield County Health Center', 1, NULL, NULL, N'271310', NULL, NULL, 0, 4, NULL, N'4065572500', N'4065572950', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'332 Leavitt Ave', N'Jordan', N'MT', N'30033', N'59337', 47.322536, -106.91136, 2154, 168, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3327, N'Big Sandy Medical Center', 1, NULL, NULL, N'271311', NULL, NULL, 0, 8, NULL, N'4063782188', N'4063782180', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'166 Montana Ave E', N'Big Sandy', N'MT', N'30015', N'59520', 48.179976, -110.111445, 2144, 169, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3328, N'Phillips County Medical Center', 1, NULL, NULL, N'271312', NULL, NULL, 0, 6, NULL, N'4066541100', N'4066542876', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'311 S 8Th Ave E', N'Malta', N'MT', N'30071', N'59538', 48.357143, -107.860445, 2153, 169, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3329, N'Pioneer Medical Center', 1, NULL, NULL, N'271313', NULL, NULL, 0, 25, NULL, N'4069324603', N'4069325468', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'301 W 7Th Ave', N'Big Timber', N'MT', N'30097', N'59011', 45.828146, -109.952784, 2133, 168, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3330, N'Deer Lodge Medical Center', 1, NULL, NULL, N'271314', NULL, NULL, 0, 16, NULL, N'4068462212', N'4068463074', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1100 Hollenback Ln', N'Deer Lodge', N'MT', N'30077', N'59722', 46.395761, -112.730038, 2139, 170, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3331, N'P H S Indian Hospital-Ft Belknap At Harlem - Cah', 1, NULL, NULL, N'271315', NULL, NULL, 0, 6, NULL, N'4063533100', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'456 Gros Ventre Ave Rr 1', N'Harlem', N'MT', N'30005', N'59526', 48.533331, -108.784046, 2147, 169, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3332, N'Frances Mahon Deaconess Hospital', 1, NULL, NULL, N'271316', NULL, NULL, 0, 25, NULL, N'4062283500', N'4062283680', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'621 3Rd St S', N'Glasgow', N'MT', N'30105', N'59230', 48.1898, -106.636201, 2142, 168, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3333, N'Livingston Healthcare', 1, NULL, NULL, N'271317', NULL, NULL, 0, 25, NULL, N'4062223541', N'4062225099', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'504 S 13Th St', N'Livingston', N'MT', N'30067', N'59047', 45.649043, -110.568326, 2152, 168, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3334, N'Barrett Memorial Hospital', 1, NULL, NULL, N'271318', NULL, NULL, 0, 18, NULL, N'4066833000', N'4066833206', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'600 Mt Hwy 91 S', N'Dillon', N'MT', N'30001', N'59725', 45.216416, -112.637844, 2140, 170, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3335, N'Ruby Valley Hospital', 1, NULL, NULL, N'271319', NULL, NULL, 0, 10, NULL, N'4068425453', N'4068425455', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'220 E Crofoot', N'Sheridan', N'MT', N'30057', N'59749', 45.453127, -112.192841, 2164, 170, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3336, N'Cabinet Peaks Medical Center', 1, NULL, NULL, N'271320', NULL, NULL, 0, 25, NULL, N'4062930100', N'4062934428', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'209 Health Park Dr', N'Libby', N'MT', N'30053', N'59923', 48.388286, -115.555999, 2151, 170, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3337, N'Wheatland Memorial Hospital', 1, NULL, NULL, N'271321', NULL, NULL, 0, 25, NULL, N'4066324351', N'4066323172', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'530 3Rd St Nw', N'Harlowton', N'MT', N'30107', N'59036', 46.437104, -109.840645, 2133, 168, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3338, N'Sheridan Memorial Hosptial', 1, NULL, NULL, N'271322', NULL, NULL, 0, 19, NULL, N'4067653700', N'4067653800', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'440 W Laurel Ave', N'Plentywood', N'MT', N'30091', N'59254', 48.778763, -104.562937, 2157, 168, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3339, N'Clark Fork Valley Hospital', 1, NULL, NULL, N'271323', NULL, NULL, 0, 16, NULL, N'4068264800', N'4068264811', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'10 Kruger Rd', N'Plains', N'MT', N'30089', N'59859', 47.460543, -114.884789, 2156, 170, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3340, N'Pondera Medical Center', 1, NULL, NULL, N'271324', NULL, NULL, 0, 20, NULL, N'4062713211', N'4062713917', 1, 1, 1, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'805 Sunset Blvd', N'Conrad', N'MT', N'30073', N'59425', 48.173985, -111.956832, 2137, 169, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3341, N'St Luke Community Hospital', 1, NULL, NULL, N'271325', NULL, NULL, 0, 25, NULL, N'4066764441', N'4066760835', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'107 6Th Ave Sw', N'Ronan', N'MT', N'30047', N'59864', 47.529127, -114.106361, 2161, 170, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3342, N'Beartooth Billings Clinic', 1, NULL, NULL, N'271326', NULL, NULL, 0, 10, NULL, N'4064462345', N'4064460031', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2525 N Broadway', N'Red Lodge', N'MT', N'30009', N'59068', 45.185778, -109.246821, 2160, 168, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3343, N'Rosebud Health Care Center', 1, NULL, NULL, N'271327', NULL, NULL, 0, 24, NULL, N'4063462161', N'4063464255', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'383 N 17Th Av', N'Forsyth', N'MT', N'30087', N'59327', 46.271255, -106.670537, 2133, 168, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3344, N'Marias Medical Center', 1, NULL, NULL, N'271328', NULL, NULL, 0, 25, NULL, N'4064343200', N'4064343213', 1, 1, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'640 Park Dr', N'Shelby', N'MT', N'30101', N'59474', 48.508827, -111.849993, 2163, 169, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3345, N'Madison Valley Medical Center', 1, NULL, NULL, N'271329', NULL, NULL, 0, 10, NULL, N'4066824222', N'4066824756', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'305 N Main', N'Ennis', N'MT', N'30057', N'59729', 45.348817, -111.729697, 2141, 168, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3346, N'Stillwater Billings Clinic', 1, NULL, NULL, N'271330', NULL, NULL, 0, 10, NULL, N'4063225316', N'4063225207', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'710 N 11Th St', N'Columbus', N'MT', N'30095', N'59019', 45.636608, -109.252106, 2133, 168, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3347, N'Mineral Community Hospital', 1, NULL, NULL, N'271331', NULL, NULL, 0, 25, NULL, N'4068224841', N'4068224963', 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'1208 6Th Ave E', N'Superior', N'MT', N'30061', N'59872', 47.184996, -114.876722, 2166, 170, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3348, N'Glendive Medical Center', 1, NULL, NULL, N'271332', NULL, NULL, 0, 25, NULL, N'4063453306', N'4063453358', 1, 1, 0, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'202 Prospect Dr', N'Glendive', N'MT', N'30021', N'59330', 47.117816, -104.705193, 2143, 168, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3349, N'Broadwater Health Center', 1, NULL, NULL, N'271333', NULL, NULL, 0, 9, NULL, N'4062663186', N'4062663180', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'110 N Oak St', N'Townsend', N'MT', N'30007', N'59644', 46.321958, -111.516689, 2167, 168, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3350, N'Liberty Medical Center', 1, NULL, NULL, N'271334', NULL, NULL, 0, 25, NULL, N'4067595181', N'4067595799', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'315 W Madison Ave', N'Chester', N'MT', N'30051', N'59522', 48.510453, -110.970905, 2136, 169, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3351, N'Community Hospital Of Anaconda', 1, NULL, NULL, N'271335', NULL, NULL, 0, 25, NULL, N'4065638500', N'4065638565', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'401 W Pennsylvania', N'Anaconda', N'MT', N'30023', N'59711', 46.128794, -112.942369, 2131, 170, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3352, N'North Valley Hospital', 1, NULL, NULL, N'271336', NULL, NULL, 0, 25, NULL, N'4068633550', N'4068622532', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1600 Hospital Way', N'Whitefish', N'MT', N'30029', N'59937', 48.380362, -114.331248, 2169, 170, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3353, N'Northern Rockies Medical Center', 1, NULL, NULL, N'271337', NULL, NULL, 0, 20, NULL, N'4068732251', N'4068733118', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'802 2Nd St Se', N'Cut Bank', N'MT', N'30035', N'59427', 48.628575, -112.326036, 2138, 169, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3354, N'Big Horn Co Memorial Hospital', 1, NULL, NULL, N'271338', NULL, NULL, 0, 25, NULL, N'4066652310', N'4066659238', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'17 N Miles', N'Hardin', N'MT', N'30003', N'59034', 45.726882, -107.616967, 2146, 168, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3355, N'P H S Indian Hospital Crow / Northern Cheyenne', 1, NULL, NULL, N'271339', NULL, NULL, 0, 24, NULL, N'4066382626', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1010 South 7650 East Post Office Box 9', N'Crow Agency', N'MT', N'30003', N'59022', 45.601641, -107.461194, 2146, 168, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3356, N'Marcus Daly Memorial Hospital - Cah', 1, NULL, NULL, N'271340', NULL, NULL, 0, 25, NULL, N'4063754408', N'4063636536', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1200 Westwood Dr', N'Hamilton', N'MT', N'30081', N'59840', 46.247198, -114.172199, 2145, 170, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3357, N'Trinity Hospital', 1, NULL, NULL, N'271341', NULL, NULL, 0, 22, NULL, N'4066536500', N'4066536589', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'315 Knapp St', N'Wolf Point', N'MT', N'30085', N'59201', 48.100996, -105.641252, 2170, 168, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3358, N'Daniels Memorial Hospital', 1, NULL, NULL, N'271342', NULL, NULL, 0, 24, NULL, N'4064872296', N'4064872471', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'105 5Th Ave E', N'Scobey', N'MT', N'30019', N'59263', 48.792086, -105.419948, 2162, 168, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3359, N'Providence St Joseph Medical Center', 1, NULL, NULL, N'271343', NULL, NULL, 0, 22, NULL, N'4068835377', N'4068838488', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6 13Th Ave E', N'Polson', N'MT', N'30047', N'59860', 47.683513, -114.152009, 2158, 170, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3360, N'Sidney Health Center', 1, NULL, NULL, N'271344', NULL, NULL, 0, 25, NULL, N'4064882100', N'4064882125', 1, 1, 0, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'216 14Th Ave Sw', N'Sidney', N'MT', N'30083', N'59270', 47.715764, -104.174069, 2165, 168, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3361, N'Central Montana Medical Center', 1, NULL, NULL, N'271345', NULL, NULL, 0, 25, NULL, N'4065357711', N'4065352099', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'408 Wendell Ave', N'Lewistown', N'MT', N'30027', N'59457', 47.058304, -109.442121, 2150, 168, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3362, N'Roundup Memorial Healthcare', 1, NULL, NULL, N'271346', NULL, NULL, 0, 25, NULL, N'4063232301', N'4063233681', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1202 3Rd St W', N'Roundup', N'MT', N'30065', N'59072', 46.454207, -108.546228, 2133, 168, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3363, N'Holy Rosary Healthcare', 1, NULL, NULL, N'271347', NULL, NULL, 0, 25, NULL, N'4062332600', N'4062332611', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2600 Wilson St', N'Miles City', N'MT', N'30017', N'59301', 46.397265, -105.82739, 2154, 168, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3364, N'Advanced Care Hospital Of Montana', 1, NULL, NULL, N'272001', NULL, NULL, 0, 40, NULL, N'4063738000', N'4063738020', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3528 Gabel Rd', N'Billings', N'MT', N'30111', N'59102', 45.741646, -108.606751, 2133, 168, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3365, N'Shodair Children''s Hospital', 1, NULL, NULL, N'274004', NULL, NULL, 0, 20, NULL, N'4064447500', N'4064447588', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'2755 Colonial Dr', N'Helena', N'MT', N'30049', N'59601', 46.582611, -111.987659, 2148, 168, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3366, N'Montana State Hospital', 1, NULL, NULL, N'274086', NULL, NULL, 0, 166, NULL, N'4066937000', N'4066937069', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'100 Garnet Way', N'Warm Springs', N'MT', N'30023', N'59756', 46.181315, -112.78476, 2139, 170, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3367, N'Bryan Medical Center', 1, NULL, NULL, N'280003', NULL, NULL, 0, 630, NULL, N'4024811111', N'4024818306', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1600 South 48Th St', N'Lincoln', N'NE', N'31109', N'68506', 40.777161, -96.653989, 2213, 171, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3368, N'Chi Health Good Samaritan', 1, NULL, NULL, N'280009', NULL, NULL, 0, 165, NULL, N'3088657100', N'3088652913', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'P O Box 1990 10 East 31St St', N'Kearney', N'NE', N'31019', N'68848', 40.699457, -99.081477, 2210, 172, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3369, N'The Nebraska Medical Center Dba Nebraska Medicine', 1, NULL, NULL, N'280013', NULL, NULL, 0, 689, NULL, N'4025522040', N'4025522152', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'987400 Nebraska Medical Center', N'Omaha', N'NE', N'31055', N'68198', 41.258732, -95.937873, 2224, 172, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3370, N'Chi Health St Elizabeth', 1, NULL, NULL, N'280020', NULL, NULL, 0, 265, NULL, N'4022197700', N'4022198973', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'555 South 70Th St', N'Lincoln', N'NE', N'31109', N'68510', 40.808018, -96.627322, 2213, 171, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3371, N'Chi Health St Francis', 1, NULL, NULL, N'280023', NULL, NULL, 0, 130, NULL, N'3083844600', N'3083985589', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2620 West Faidley Ave', N'Grand Island', N'NE', N'31079', N'68803', 40.924311, -98.369926, 2202, 172, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3372, N'Chi Health Creighton University Medical Center', 1, NULL, NULL, N'280030', NULL, NULL, 0, 334, NULL, N'4024494000', N'4024495020', 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'601 North 30Th St', N'Omaha', N'NE', N'31055', N'68131', 41.265721, -95.956502, 2224, 172, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3373, N'Mary Lanning Healthcare', 1, NULL, NULL, N'280032', NULL, NULL, 0, 163, NULL, N'4024634521', N'4024615321', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'715 N St Joseph Ave', N'Hastings', N'NE', N'31001', N'68901', 40.591554, -98.387573, 2204, 171, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3374, N'The Nebraska Methodist Hospital', 1, NULL, NULL, N'280040', NULL, NULL, 0, 430, NULL, N'4023544000', N'4023548735', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'8303 Dodge St', N'Omaha', N'NE', N'31055', N'68114', 41.259598, -96.041627, 2224, 172, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3375, N'Chi Health Bergan Mercy', 1, NULL, NULL, N'280060', NULL, NULL, 0, 400, NULL, N'4023986060', N'4023986920', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7500 Mercy Rd', N'Omaha', N'NE', N'31055', N'68124', 41.237987, -96.02888, 2224, 172, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3376, N'Regional West Medical Center', 1, NULL, NULL, N'280061', NULL, NULL, 0, 166, NULL, N'3086353711', N'3086301815', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4021 Ave B', N'Scottsbluff', N'NE', N'31157', N'69361', 41.887493, -103.665713, 2235, 43, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3377, N'Great Plains Health', 1, NULL, NULL, N'280065', NULL, NULL, 0, 116, NULL, N'3086968000', N'3086967199', 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'601 West Leota St', N'North Platte', N'NE', N'31111', N'69101', 41.121659, -100.770169, 2220, 171, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3378, N'Fremont Health Medical Center', 1, NULL, NULL, N'280077', NULL, NULL, 0, 90, NULL, N'4027211610', N'4027273656', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'450 East 23Rd St', N'Fremont', N'NE', N'31053', N'68025', 41.45153, -96.492295, 2197, 172, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3379, N'Chi Health Immanuel', 1, NULL, NULL, N'280081', NULL, NULL, 0, 356, NULL, N'4025722121', N'4025723177', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6901 North 72Nd St', N'Omaha', N'NE', N'31055', N'68122', 41.268276, -96.023873, 2224, 172, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3380, N'Chi Health Midlands', 1, NULL, NULL, N'280105', NULL, NULL, 0, 131, NULL, N'4025933000', N'4025933117', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'11111 South 84Th St', N'Papillion', N'NE', N'31153', N'68046', 41.138557, -96.04282, 2224, 172, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3381, N'Columbus Community Hospital', 1, NULL, NULL, N'280111', NULL, NULL, 0, 47, NULL, N'4025647118', N'4025623378', 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4600 38Th St', N'Columbus', N'NE', N'31141', N'68601', 41.453346, -97.383868, 2188, 172, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3382, N'Winnebago Ihs Hospital', 1, NULL, NULL, N'280119', NULL, NULL, 0, 30, NULL, N'4028782231', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Hwy 77-75', N'Winnebago', N'NE', N'31173', N'68071', 42.235827, -96.472534, 1365, 109, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3383, N'Faith Regional Health Services', 1, NULL, NULL, N'280125', NULL, NULL, 0, 133, NULL, N'4023714880', N'4026447468', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2700 West Norfolk Ave', N'Norfolk', N'NE', N'31119', N'68701', 42.032614, -97.453211, 2219, 172, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3384, N'Lincoln Surgical Hospital', 1, NULL, NULL, N'280127', NULL, NULL, 0, 21, NULL, N'4024849090', N'4024830476', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1710 South 70Th St Suite 200', N'Lincoln', N'NE', N'31109', N'68506', 40.800055, -96.6674, 2213, 171, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3385, N'Chi Health Nebraska Heart', 1, NULL, NULL, N'280128', NULL, NULL, 0, 63, NULL, N'4023283000', N'4023283010', 1, 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7500 South 91St St', N'Lincoln', N'NE', N'31109', N'68526', 40.736564, -96.593324, 2213, 171, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3386, N'Nebraska Orthopaedic Hospital', 1, NULL, NULL, N'280129', NULL, NULL, 0, 24, NULL, N'4026091600', N'4026091020', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2808 South 143Rd Plz', N'Omaha', N'NE', N'31055', N'68144', 41.232872, -96.135667, 2224, 172, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3387, N'Chi Health Lakeside', 1, NULL, NULL, N'280130', NULL, NULL, 0, 157, NULL, N'4027178000', N'4027178108', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'16901 Lakeside Hills Ct', N'Omaha', N'NE', N'31055', N'68130', 41.237744, -96.180631, 2224, 172, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3388, N'Midwest Surgical Hospital Llc', 1, NULL, NULL, N'280131', NULL, NULL, 0, 19, NULL, N'4023991900', N'4023991999', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7915 Farnam Drive', N'Omaha', N'NE', N'31055', N'68114', 41.258594, -96.039856, 2224, 172, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3389, N'Bellevue Medical Center Dba Nebraska Medicine-Bell', 1, NULL, NULL, N'280132', NULL, NULL, 0, 91, NULL, N'4027633600', N'4027633619', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2500 Bellevue Medical Center Dr', N'Bellevue', N'NE', N'31153', N'68123', 41.136649, -95.890737, 2224, 172, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3390, N'Nebraska Spine Hospital Llc', 1, NULL, NULL, N'280133', NULL, NULL, 0, 34, NULL, N'4025723000', N'4025722657', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'P O Box 34400 6901 North 72Nd St Ste 20300', N'Omaha', N'NE', N'31055', N'68122', 41.258732, -95.937873, 2224, 172, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3391, N'Kearney Regional Medical Center', 1, NULL, NULL, N'280134', NULL, NULL, 0, 44, NULL, N'3084553600', N'3084553950', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'804 22Nd Avenue', N'Kearney', N'NE', N'31019', N'68845', 40.713489, -99.11153, 2210, 172, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3392, N'Select Speciality Hospital - Lincoln', 1, NULL, NULL, N'280135', NULL, NULL, 0, 24, NULL, N'4023615755', N'4028845284', 1, 1, 1, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2300 South 16Th Street - 7Th Floor', N'Lincoln', N'NE', N'31109', N'68502', 40.800055, -96.6674, 2213, 171, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3393, N'Madonna Rehabilitation Specialty Hospital', 1, NULL, NULL, N'280136', NULL, NULL, 0, 32, NULL, N'4028840006', N'4029910880', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2500 Bellevue Medical Center Drive 4Th Floor', N'Bellevue', N'NE', N'31153', N'68123', 41.136649, -95.890737, 2224, 172, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3394, N'Harlan County Health System', 1, NULL, NULL, N'281300', NULL, NULL, 0, 19, NULL, N'3089282151', N'3089289059', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'P O Box 836 717 North Brown St', N'Alma', N'NE', N'31083', N'68920', 40.097511, -99.362043, 2175, 171, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3395, N'Fillmore County Hospital', 1, NULL, NULL, N'281301', NULL, NULL, 0, 25, NULL, N'4027593167', N'4027593093', 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'P O Box 193 1900 F Street', N'Geneva', N'NE', N'31059', N'68361', 40.526951, -97.595882, 2198, 171, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3396, N'Pawnee County Memorial Hospital', 1, NULL, NULL, N'281302', NULL, NULL, 0, 17, NULL, N'4028522231', N'4028522098', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'P O Box 433  600 I St', N'Pawnee City', N'NE', N'31133', N'68420', 40.108333, -96.154451, 2229, 171, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3397, N'Niobrara Valley Hospital', 1, NULL, NULL, N'281303', NULL, NULL, 0, 20, NULL, N'4025692451', N'4025692474', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'P O Box 118 401 South 5Th Street', N'Lynch', N'NE', N'31015', N'68746', 42.830276, -98.466193, 2214, 172, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3398, N'Thayer County Health Services', 1, NULL, NULL, N'281304', NULL, NULL, 0, 19, NULL, N'4027686041', N'4027684697', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'120 Park Ave', N'Hebron', N'NE', N'31169', N'68370', 40.160194, -97.593571, 2205, 171, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3399, N'Kimball Health Services', 1, NULL, NULL, N'281305', NULL, NULL, 0, 20, NULL, N'3082351952', N'3082351955', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'505 South Burg St', N'Kimball', N'NE', N'31105', N'69145', 41.232159, -103.667059, 2211, 44, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3400, N'Kearney County Health Services Hospital', 1, NULL, NULL, N'281306', NULL, NULL, 0, 25, NULL, N'3088323400', N'3088323417', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'727 East 1St St', N'Minden', N'NE', N'31099', N'68959', 40.495742, -98.946249, 2216, 172, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3401, N'Saunders Medical Center', 1, NULL, NULL, N'281307', NULL, NULL, 0, 16, NULL, N'4024434191', N'4024431433', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1760 County Rd J', N'Wahoo', N'NE', N'31155', N'68066', 41.211392, -96.620302, 2243, 172, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3402, N'Henderson Health Care Services', 1, NULL, NULL, N'281308', NULL, NULL, 0, 13, NULL, N'4027234512', N'4027234520', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1621 Front Street', N'Henderson', N'NE', N'31185', N'68371', 40.78288, -97.80763, 2206, 171, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3403, N'Community Memorial Hospital', 1, NULL, NULL, N'281309', NULL, NULL, 0, 18, NULL, N'4022692011', N'4022692795', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'P O Box N 1579 Midland St', N'Syracuse', N'NE', N'31131', N'68446', 40.657224, -96.186397, 2240, 171, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3404, N'Regional West Garden County Hospital', 1, NULL, NULL, N'281310', NULL, NULL, 0, 20, NULL, N'3087723283', N'3087721079', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1100 West 2Nd St', N'Oshkosh', N'NE', N'31069', N'69154', 41.409298, -102.34755, 2227, 43, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3405, N'Franklin County Memorial Hospital', 1, NULL, NULL, N'281311', NULL, NULL, 0, 14, NULL, N'3084256221', N'3084253164', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'P O Box 315 1406 Q St', N'Franklin', N'NE', N'31061', N'68939', 40.096124, -98.952581, 2196, 171, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3406, N'Genoa Community Hospital', 1, NULL, NULL, N'281312', NULL, NULL, 0, 20, NULL, N'4029932283', N'4029932373', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'P O Box 310 606/706 Ewing Ave', N'Genoa', N'NE', N'31125', N'68640', 41.447948, -97.733255, 2199, 172, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3407, N'Gothenburg Memorial Hospital', 1, NULL, NULL, N'281313', NULL, NULL, 0, 12, NULL, N'3085373661', N'3085373074', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'910 20Th St', N'Gothenburg', N'NE', N'31047', N'69138', 40.938201, -100.15326, 2201, 171, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3408, N'Annie Jeffrey Memorial County Health Center', 1, NULL, NULL, N'281314', NULL, NULL, 0, 21, NULL, N'4027472031', N'4027471405', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'P O Box 428 531 Beebe St', N'Osceola', N'NE', N'31143', N'68651', 41.179989, -97.547319, 2226, 172, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3409, N'Brodstone Memorial Hosp', 1, NULL, NULL, N'281315', NULL, NULL, 0, 25, NULL, N'4028793281', N'4028793401', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'P O Box 187 520 East 10Th St', N'Superior', N'NE', N'31129', N'68978', 40.020847, -98.070044, 2239, 171, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3410, N'Webster County Community Hospital', 1, NULL, NULL, N'281316', NULL, NULL, 0, 16, NULL, N'4027465600', N'4027465687', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'P O Box 465 621 N Franklin St', N'Red Cloud', N'NE', N'31181', N'68970', 40.088903, -98.519505, 2232, 171, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3411, N'Morrill County Community Hospital', 1, NULL, NULL, N'281318', NULL, NULL, 0, 20, NULL, N'3082621616', N'3082620843', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1313 S Street', N'Bridgeport', N'NE', N'31123', N'69336', 41.661732, -103.091483, 2235, 43, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3412, N'Jefferson Community Health Center', 1, NULL, NULL, N'281319', NULL, NULL, 0, 17, NULL, N'4027293351', N'4027292102', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'P O Box 277 2200 H St', N'Fairbury', N'NE', N'31095', N'68352', 40.137225, -97.180591, 2194, 171, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3413, N'Memorial Hospital', 1, NULL, NULL, N'281320', NULL, NULL, 0, 25, NULL, N'4026943171', N'4026945024', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1423 Seventh St', N'Aurora', N'NE', N'31081', N'68818', 40.866888, -98.004508, 2178, 171, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3414, N'Oakland Mercy Hospital', 1, NULL, NULL, N'281321', NULL, NULL, 0, 23, NULL, N'4026855601', N'4026856223', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'601 East Second St', N'Oakland', N'NE', N'31021', N'68045', 41.835827, -96.466971, 2222, 172, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3415, N'St Francis Memorial Hospital', 1, NULL, NULL, N'281322', NULL, NULL, 0, 25, NULL, N'4023722404', N'4023722360', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'430 North Monitor St', N'West Point', N'NE', N'31039', N'68788', 41.843271, -96.706647, 2245, 172, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3416, N'Chi Health Schuyler', 1, NULL, NULL, N'281323', NULL, NULL, 0, 25, NULL, N'4023522441', N'4023522643', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'104 West 17Th St', N'Schuyler', N'NE', N'31037', N'68661', 41.454673, -97.061613, 2234, 172, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3417, N'Nemaha County Hospital', 1, NULL, NULL, N'281324', NULL, NULL, 0, 20, NULL, N'4022744366', N'4022744399', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2022  13Th St', N'Auburn', N'NE', N'31127', N'68305', 40.391752, -95.844688, 2177, 172, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3418, N'Brown County Hospital', 1, NULL, NULL, N'281325', NULL, NULL, 0, 25, NULL, N'4023872800', N'4023872804', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'945 East Zero St', N'Ainsworth', N'NE', N'31017', N'69210', 42.544826, -99.851317, 2172, 172, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3419, N'Antelope Memorial Hospital', 1, NULL, NULL, N'281326', NULL, NULL, 0, 25, NULL, N'4028874151', N'4028876397', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'P O Box 229 102 West 9Th St', N'Neligh', N'NE', N'31003', N'68756', 42.128618, -98.029789, 2218, 172, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3420, N'Cozad Community Hospital', 1, NULL, NULL, N'281327', NULL, NULL, 0, 21, NULL, N'3087842261', N'3087844691', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'P O Box 108 300 East 12Th St', N'Cozad', N'NE', N'31047', N'69130', 40.859729, -99.987344, 2189, 171, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3421, N'Litzenberg Memorial County Hospital', 1, NULL, NULL, N'281328', NULL, NULL, 0, 20, NULL, N'3089463015', N'3089462633', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1715  26Th St', N'Central City', N'NE', N'31121', N'68826', 41.10666, -98.003673, 2186, 172, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3422, N'Avera St Anthony''s Hospital', 1, NULL, NULL, N'281329', NULL, NULL, 0, 25, NULL, N'4023362611', N'4023365135', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'300 North 2Nd St', N'O'' Neill', N'NE', N'31089', N'68763', 42.460152, -98.651012, 2221, 172, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3423, N'Warren Memorial Hospital', 1, NULL, NULL, N'281330', NULL, NULL, 0, 14, NULL, N'4029472541', N'4029472811', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'905 Second St', N'Friend', N'NE', N'31151', N'68359', 40.653617, -97.286157, 2213, 171, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3424, N'Avera Creighton Hospital', 1, NULL, NULL, N'281331', NULL, NULL, 0, 23, NULL, N'4023585700', N'4023585769', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'P O Box 186 1503 Main St', N'Creighton', N'NE', N'31107', N'68729', 42.466671, -97.906178, 2191, 172, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3425, N'Butler County Health Care Center', 1, NULL, NULL, N'281332', NULL, NULL, 0, 20, NULL, N'4023671200', N'8552973221', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'372 South 9Th St', N'David City', N'NE', N'31023', N'68632', 41.246272, -97.122924, 2193, 171, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3426, N'Rock County Hospital', 1, NULL, NULL, N'281333', NULL, NULL, 0, 24, NULL, N'4026843366', N'4026843677', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'102 East South Street', N'Bassett', N'NE', N'31149', N'68714', 42.57582, -99.536676, 2179, 172, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3427, N'Boone County Health Center', 1, NULL, NULL, N'281334', NULL, NULL, 0, 25, NULL, N'4023952191', N'4023955165', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'P O Box 151 723 West Fairview St', N'Albion', N'NE', N'31011', N'68620', 41.690844, -98.003672, 2173, 172, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3428, N'Callaway District Hospital', 1, NULL, NULL, N'281335', NULL, NULL, 0, 12, NULL, N'3088362228', N'3088362733', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'P O Box 100 211 E Kimball St', N'Callaway', N'NE', N'31041', N'68825', 41.29195, -99.922621, 2184, 171, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3429, N'York General Hospital', 1, NULL, NULL, N'281336', NULL, NULL, 0, 25, NULL, N'4023626671', N'4023620499', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2222 Lincoln Ave', N'York', N'NE', N'31185', N'68467', 40.862856, -97.592971, 2246, 171, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3430, N'Howard County Medical Center', 1, NULL, NULL, N'281338', NULL, NULL, 0, 25, NULL, N'3087544421', N'3087544429', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'P O Box 406 1113 Sherman St', N'St Paul', N'NE', N'31093', N'68873', 41.214729, -98.457537, 2238, 172, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3431, N'Memorial Health Care Systems', 1, NULL, NULL, N'281339', NULL, NULL, 0, 25, NULL, N'4026432971', N'4026464605', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'300 North Columbia Ave', N'Seward', N'NE', N'31159', N'68434', 40.909533, -97.091806, 2236, 171, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3432, N'Dundy County Hospital', 1, NULL, NULL, N'281340', NULL, NULL, 0, 14, NULL, N'3084232204', N'3084235691', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'P O Box 626 1313 North Cheyenne St', N'Benkelman', N'NE', N'31057', N'69021', 40.049162, -101.532944, 2181, 43, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3433, N'Chadron Community Hospital And Health Services', 1, NULL, NULL, N'281341', NULL, NULL, 0, 25, NULL, N'3084325586', N'3084322737', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'825 Centennial Drive', N'Chadron', N'NE', N'31045', N'69337', 42.82117, -103.013275, 2187, 246, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3434, N'Chi Health St Mary''s', 1, NULL, NULL, N'281342', NULL, NULL, 0, 18, NULL, N'4028733321', N'4028739033', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1301 Grundman Blvd', N'Nebraska City', N'NE', N'31131', N'68410', 40.658471, -95.860337, 2217, 172, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3435, N'West Holt Memorial Hospital', 1, NULL, NULL, N'281343', NULL, NULL, 0, 18, NULL, N'4029252811', N'4029252810', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'406 W Neely St', N'Atkinson', N'NE', N'31089', N'68713', 42.528607, -98.981997, 2176, 172, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3436, N'Cherry County Hospital', 1, NULL, NULL, N'281344', NULL, NULL, 0, 25, NULL, N'4023762525', N'4023761627', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'P O Box 410 510 North Green St', N'Valentine', N'NE', N'31031', N'69201', 42.872783, -100.550967, 2242, 171, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3437, N'Providence Medical Center', 1, NULL, NULL, N'281345', NULL, NULL, 0, 25, NULL, N'4023753800', N'4023757989', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1200 Providence Rd', N'Wayne', N'NE', N'31179', N'68787', 42.241775, -97.008149, 2244, 109, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3438, N'Chi Health Plainview', 1, NULL, NULL, N'281346', NULL, NULL, 0, 19, NULL, N'4025824245', N'4025823940', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'P O Box 489 704 North Third St', N'Plainview', N'NE', N'31139', N'68769', 42.349727, -97.792009, 2231, 172, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3439, N'Osmond General Hospital', 1, NULL, NULL, N'281347', NULL, NULL, 0, 25, NULL, N'4027483393', N'4027483349', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'P O Box 429 402 North Maple St', N'Osmond', N'NE', N'31139', N'68765', 42.360003, -97.596728, 2228, 172, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3440, N'Tri Valley Health System', 1, NULL, NULL, N'281348', NULL, NULL, 0, 25, NULL, N'3086973329', N'3086973331', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1305 West Highway 6/34', N'Cambridge', N'NE', N'31065', N'69022', 40.281951, -100.165692, 2185, 171, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3441, N'Pender Community Hospital', 1, NULL, NULL, N'281349', NULL, NULL, 0, 25, NULL, N'4023853083', N'4023854041', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'P O Box 100 100 Hospital Drive', N'Pender', N'NE', N'31173', N'68047', 42.114165, -96.707258, 2230, 109, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3442, N'Johnson County Hospital', 1, NULL, NULL, N'281350', NULL, NULL, 0, 18, NULL, N'4023353361', N'4023356342', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'202 High St', N'Tecumseh', N'NE', N'31097', N'68450', 40.379259, -96.197162, 2241, 171, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3443, N'Chase County Community Hospital', 1, NULL, NULL, N'281351', NULL, NULL, 0, 22, NULL, N'3088827111', N'3088827342', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'P O Box 819 600 W 12Th St', N'Imperial', N'NE', N'31029', N'69033', 40.51694, -101.643225, 2209, 43, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3444, N'Community Medical Center Inc', 1, NULL, NULL, N'281352', NULL, NULL, 0, 25, NULL, N'4022452428', N'4022456640', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'P O Box 399 3307 Barada St', N'Falls City', N'NE', N'31147', N'68355', 40.060835, -95.601929, 2195, 172, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3445, N'Valley County Health System', 1, NULL, NULL, N'281353', NULL, NULL, 0, 25, NULL, N'3087284200', N'3087287809', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2707 L Street', N'Ord', N'NE', N'31175', N'68862', 41.603118, -98.943128, 2225, 172, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3446, N'Crete Area Medical Center', 1, NULL, NULL, N'281354', NULL, NULL, 0, 25, NULL, N'4028262102', N'4028267950', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'P O Box 220 2910 Betten Dr', N'Crete', N'NE', N'31151', N'68333', 40.627782, -96.961417, 2192, 171, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3447, N'Ogallala Community Hospital', 1, NULL, NULL, N'281355', NULL, NULL, 0, 18, NULL, N'3082844011', N'3082847262', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2601 North Spruce St', N'Ogallala', N'NE', N'31101', N'69153', 41.150815, -101.720338, 2223, 43, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3448, N'Perkins County Health Services', 1, NULL, NULL, N'281356', NULL, NULL, 0, 20, NULL, N'3083527200', N'3083527291', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'900 Lincoln Ave', N'Grant', N'NE', N'31135', N'69140', 40.848155, -101.727011, 2203, 43, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3449, N'Sidney Regional Medical Center', 1, NULL, NULL, N'281357', NULL, NULL, 0, 25, NULL, N'3082545825', N'3082542300', 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'645 Osage St', N'Sidney', N'NE', N'31033', N'69162', 41.138922, -102.972872, 2237, 43, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3450, N'Gordon Memorial Hospital District', 1, NULL, NULL, N'281358', NULL, NULL, 0, 25, NULL, N'3082820401', N'3082820431', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'300 East 8Th St', N'Gordon', N'NE', N'31161', N'69343', 42.811913, -102.199213, 2200, 246, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3451, N'Memorial Community Hospital', 1, NULL, NULL, N'281359', NULL, NULL, 0, 25, NULL, N'4024262182', N'4024261439', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'810 North 22Nd St', N'Blair', N'NE', N'31177', N'68008', 41.550911, -96.145531, 2182, 172, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3452, N'Box Butte General Hospital', 1, NULL, NULL, N'281360', NULL, NULL, 0, 25, NULL, N'3087626660', N'3087621923', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'P O Box 810 2101 Box Butte Ave', N'Alliance', N'NE', N'31013', N'69301', 42.101634, -102.872145, 2174, 43, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3453, N'Lexington Regional Health Center', 1, NULL, NULL, N'281361', NULL, NULL, 0, 25, NULL, N'3083245651', N'3083248359', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'P O Box 980 1201 North Erie St', N'Lexington', N'NE', N'31047', N'68850', 40.78084, -99.741504, 2212, 171, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3454, N'Phelps Memorial Health Center', 1, NULL, NULL, N'281362', NULL, NULL, 0, 25, NULL, N'3089952211', N'3089953336', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1215 Tibbals St', N'Holdrege', N'NE', N'31137', N'68949', 40.447161, -99.382135, 2207, 171, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3455, N'Community Hospital', 1, NULL, NULL, N'281363', NULL, NULL, 0, 25, NULL, N'3083442650', N'3083448572', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'P O Box 1328 1301 East H St', N'Mccook', N'NE', N'31145', N'69001', 40.201948, -100.625708, 2215, 43, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3456, N'Beatrice Community Hospital & Health Center Inc', 1, NULL, NULL, N'281364', NULL, NULL, 0, 25, NULL, N'4022283344', N'4022237299', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'P O Box 278 4800 Hospital Parkway', N'Beatrice', N'NE', N'31067', N'68310', 40.266029, -96.746912, 2180, 171, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3457, N'Jennie M Melham Memorial Medical Center', 1, NULL, NULL, N'281365', NULL, NULL, 0, 23, NULL, N'3088724100', N'3088724150', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'145 Memorial Drive', N'Broken Bow', N'NE', N'31041', N'68822', 41.409128, -99.635334, 2183, 171, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3458, N'Madonna Rehabilitation Ltc Hospital', 1, NULL, NULL, N'282000', NULL, NULL, 0, 96, NULL, N'4024133000', N'4024134604', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5401 South St', N'Lincoln', N'NE', N'31109', N'68506', 40.791553, -96.647932, 2213, 171, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3459, N'Select Specialty Hospital - Omaha (Central Campus)', 1, NULL, NULL, N'282001', NULL, NULL, 0, 52, NULL, N'4023615755', N'4023615777', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1870 South 75Th Street', N'Omaha', N'NE', N'31055', N'68124', 41.241424, -96.028838, 2224, 172, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3460, N'Madonna Rehabilitation Hospital', 1, NULL, NULL, N'283025', NULL, NULL, 0, 96, NULL, N'4024133000', N'4024134113', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5401 South St', N'Lincoln', N'NE', N'31109', N'68506', 40.791553, -96.647932, 2213, 171, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3461, N'Boys Town National Research Hospital', 1, NULL, NULL, N'283300', NULL, NULL, 0, 66, NULL, N'4024986362', N'4024986357', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'555 North 30Th St', N'Omaha', N'NE', N'31055', N'68131', 41.264666, -95.956504, 2224, 172, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3462, N'Children''s Hospital & Medical Center', 1, NULL, NULL, N'283301', NULL, NULL, 0, 134, NULL, N'4029555400', N'4029554100', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'8200 Dodge St', N'Omaha', N'NE', N'31055', N'68114', 41.259763, -96.040399, 2224, 172, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3463, N'Lincoln Regional Center', 1, NULL, NULL, N'284003', NULL, NULL, 0, 240, NULL, N'4024714444', N'4024795124', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Po Box 94949 Folsom & West Prospector', N'Lincoln', N'NE', N'31109', N'68509', 40.800055, -96.6674, 2213, 171, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3464, N'Douglas County Health Center', 1, NULL, NULL, N'284009', NULL, NULL, 0, 30, NULL, N'4024447676', N'4029968171', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4102 Woolworth Ave', N'Omaha', N'NE', N'31055', N'68105', 41.246217, -95.974429, 2224, 172, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3465, N'Children''s Hospital & Medical Center  Transplant', 1, NULL, NULL, N'289806', NULL, NULL, 0, 0, NULL, N'4029554374', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'8200 Dodge Street', N'Omaha', N'NE', N'31055', N'68114', 41.259763, -96.040399, 2224, 172, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3466, N'Renown Regional Medical Center', 1, NULL, NULL, N'290001', NULL, NULL, 0, 529, NULL, N'7759824100', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1155 Mill Street', N'Reno', N'NV', N'32031', N'89502', 39.517523, -119.777079, 2256, 174, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3467, N'South Lyon Medical Center', 1, NULL, NULL, N'290002', NULL, NULL, 0, 14, NULL, N'7757813761', N'7754637864', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'213 S Whitacre/Po Box 940', N'Yerington', N'NV', N'32019', N'89447', 38.993911, -119.163156, 2256, 174, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3468, N'Sunrise Hospital And Medical Center', 1, NULL, NULL, N'290003', NULL, NULL, 0, 701, NULL, N'7027318000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3186 S Maryland Pkwy', N'Las Vegas', N'NV', N'32003', N'89109', 36.156539, -115.137502, 2255, 173, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3469, N'North Vista Hospital', 1, NULL, NULL, N'290005', NULL, NULL, 0, 198, NULL, N'7026575504', N'7026575636', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1409 East Lake Mead Blvd', N'North Las Vegas', N'NV', N'32003', N'89030', 36.195721, -115.12441, 2255, 173, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3470, N'Banner Churchill Community Hospital', 1, NULL, NULL, N'290006', NULL, NULL, 0, 40, NULL, N'7754233151', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'801 East Williams Avenue', N'Fallon', N'NV', N'32001', N'89406', 39.474971, -118.766118, 2252, 174, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3471, N'University Medical Center', 1, NULL, NULL, N'290007', NULL, NULL, 0, 578, NULL, N'7023832000', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1800 W Charleston Blvd', N'Las Vegas', N'NV', N'32003', N'89102', 36.159016, -115.167522, 2255, 173, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3472, N'Northeastern Nevada Regional Hospital', 1, NULL, NULL, N'290008', NULL, NULL, 0, 75, NULL, N'7757385151', N'7757482002', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2001 Errecart Blvd', N'Elko', N'NV', N'32007', N'89801', 40.823056, -115.768222, 2250, 279, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3473, N'Saint Mary''s Regional Medical Center', 1, NULL, NULL, N'290009', NULL, NULL, 0, 380, NULL, N'7757703000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'235 W 6Th St', N'Reno', N'NV', N'32031', N'89503', 39.531735, -119.818114, 2256, 174, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3474, N'St Rose Dominican Hospitals - Rose De Lima Campus', 1, NULL, NULL, N'290012', NULL, NULL, 0, 145, NULL, N'7026165000', N'7026164699', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'102 E Lake Mead Dr', N'Henderson', N'NV', N'32003', N'89015', 36.039146, -114.981923, 2254, 173, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3475, N'Carson Tahoe Regional Medical Center', 1, NULL, NULL, N'290019', NULL, NULL, 0, 172, NULL, N'7754458000', NULL, 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1600 Medical Parkway', N'Carson City', N'NV', N'32510', N'89703', 39.19748, -119.77834, 2249, 174, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3476, N'Nye Regional Medical Center', 1, NULL, NULL, N'290020', NULL, NULL, 0, 44, NULL, N'7754826233', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'825 Erie Main St (Aka South Main)', N'Tonopah', N'NV', N'32023', N'89049', 38.068101, -117.23095, 2257, 174, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3477, N'Valley Hospital Medical Center', 1, NULL, NULL, N'290021', NULL, NULL, 0, 320, NULL, N'7023884000', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'620 Shadow Lane', N'Las Vegas', N'NV', N'32003', N'89106', 36.163828, -115.165548, 2255, 173, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3478, N'Desert Springs Hospital', 1, NULL, NULL, N'290022', NULL, NULL, 0, 346, NULL, N'7023697600', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2075 East Flamingo Road', N'Las Vegas', N'NV', N'32003', N'89119', 36.166286, -115.149225, 2255, 173, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3479, N'Northern Nevada Medical Center', 1, NULL, NULL, N'290032', NULL, NULL, 0, 108, NULL, N'7753317000', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2375 Prater Way', N'Sparks', N'NV', N'32031', N'89434', 39.535786, -119.776993, 2256, 174, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3480, N'Mountainview Hospital', 1, NULL, NULL, N'290039', NULL, NULL, 0, 235, NULL, N'7022555065', N'7022555074', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3100 N Tenaya Way', N'Las Vegas', N'NV', N'32003', N'89128', 36.184997, -115.250996, 2255, 173, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3481, N'Summerlin Hospital Medical Center', 1, NULL, NULL, N'290041', NULL, NULL, 0, 199, NULL, N'7022337500', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'657 Town Center Drive', N'Las Vegas', N'NV', N'32003', N'89144', 36.166286, -115.149225, 2255, 173, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3482, N'Harmon Hospital', 1, NULL, NULL, N'290042', NULL, NULL, 0, 116, NULL, N'7027940100', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2170 East Harmon Avenue', N'Las Vegas', N'NV', N'32003', N'89119', 36.166286, -115.149225, 2255, 173, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3483, N'St Rose Dominican Hospitals - Siena Campus', 1, NULL, NULL, N'290045', NULL, NULL, 0, 219, NULL, N'7026165000', NULL, 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3001 St Rose Parkway', N'Henderson', N'NV', N'32003', N'89052', 36.007187, -115.114113, 2255, 173, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3484, N'Spring Valley Hospital Medical Center', 1, NULL, NULL, N'290046', NULL, NULL, 0, 210, NULL, N'7028533000', NULL, 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5400 South Rainbow Blvd', N'Las Vegas', N'NV', N'32003', N'89118', 36.166286, -115.149225, 2255, 173, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3485, N'Southern Hills Hospital And Medical Center', 1, NULL, NULL, N'290047', NULL, NULL, 0, 130, NULL, N'7028802100', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'9300 West Sunset Rd', N'Las Vegas', N'NV', N'32003', N'89148', 36.166286, -115.149225, 2255, 173, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3486, N'Renown South Meadows Medical Center', 1, NULL, NULL, N'290049', NULL, NULL, 0, 118, NULL, N'7759827063', N'7759827072', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'10101 Double R Blvd', N'Reno', N'NV', N'32510', N'89521', 39.424983, -119.749425, 2256, 174, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3487, N'Sierra Surgery Hospital', 1, NULL, NULL, N'290051', NULL, NULL, 0, 15, NULL, N'7758831700', N'7758838905', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1400 Medical Pkwy', N'Carson City', N'NV', N'32510', N'89703', 39.19748, -119.77834, 2249, 174, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3488, N'St Rose Dominican Hospitals - San Martin Campus', 1, NULL, NULL, N'290053', NULL, NULL, 0, 145, NULL, N'7024928509', N'7024928511', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'8280 W Warm Springs Road', N'Las Vegas', N'NV', N'32003', N'89113', 36.166286, -115.149225, 2255, 173, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3489, N'Centennial Hills Hospital Medical Center', 1, NULL, NULL, N'290054', NULL, NULL, 0, 177, NULL, N'7028359700', N'7028359780', 1, 1, 0, 0, 0, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6900 N Durango Dr', N'Las Vegas', N'NV', N'32003', N'89149', 36.259787, -115.278843, 2255, 173, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3490, N'Mount Grant General Hospital', 1, NULL, NULL, N'291300', NULL, NULL, 0, 11, NULL, N'7029452461', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'First And A Streets', N'Hawthorne', N'NV', N'32021', N'89415', 38.524644, -118.624578, 2253, 174, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3491, N'Incline Village Health Center', 1, NULL, NULL, N'291301', NULL, NULL, 0, 8, NULL, N'7758334100', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'880 Alder Street', N'Incline Village', N'NV', N'32031', N'89451', 39.251597, -119.972343, 2256, 174, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3492, N'William Bee Ririe Hospital', 1, NULL, NULL, N'291302', NULL, NULL, 0, 25, NULL, N'7752893001', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1500 Avenue H', N'Ely', N'NV', N'32033', N'89301', 39.255871, -114.860391, 2251, 279, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3493, N'Battle Mountain General Hospital', 1, NULL, NULL, N'291303', NULL, NULL, 0, 7, NULL, N'7756352550', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'535 South Humboldt Street', N'Batte Mtn', N'NV', N'32015', N'89820', 39.515883, -116.853723, 2247, 174, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3494, N'Pershing General Hospital', 1, NULL, NULL, N'291304', NULL, NULL, 0, 17, NULL, N'7752732621', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'855 6Th Street/Po Box 661', N'Lovelock', N'NV', N'32027', N'89419', 40.179527, -118.474198, 2256, 174, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3495, N'Carson Valley Medical Center', 1, NULL, NULL, N'291306', NULL, NULL, 0, 15, NULL, N'7757821500', N'7757834849', 1, 1, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1107 Highway 395', N'Gardnerville', N'NV', N'32005', N'89410', 38.941296, -119.749622, 2249, 174, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3496, N'Mesa View Regional Hospital', 1, NULL, NULL, N'291307', NULL, NULL, 0, 25, NULL, N'7023468040', N'7023467031', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1299 Bertha Howe Avenue', N'Mesquite', N'NV', N'32003', N'89027', 36.809659, -114.123674, 2255, 173, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3497, N'Humboldt General Hospital', 1, NULL, NULL, N'291308', NULL, NULL, 0, 22, NULL, N'7756235222', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'118 East Haskell Street', N'Winnemucca', N'NV', N'32013', N'89445', 40.971655, -117.728475, 2258, 174, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3498, N'Boulder City Hospital', 1, NULL, NULL, N'291309', NULL, NULL, 0, 67, NULL, N'7022934111', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'901 Adams Blvd', N'Boulder City', N'NV', N'32003', N'89005', 35.968883, -114.832658, 2248, 173, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3499, N'Desert View Regional Medical Center', 1, NULL, NULL, N'291311', NULL, NULL, 0, 24, NULL, N'7757517500', N'7757517835', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'360 South Lola Lane', N'Pahrump', N'NV', N'32023', N'89048', 36.208218, -116.023252, 2255, 173, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3500, N'Grover C Dils Medical Center', 1, NULL, NULL, N'291312', NULL, NULL, 0, 20, NULL, N'7757263171', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'700 N Spring St Box 1010-C-Adm Bldg', N'Caliente', N'NV', N'32017', N'89008', 37.614965, -114.511938, 3433, 279, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3501, N'Kindred Hospital - Las Vegas (Sahara Campus)', 1, NULL, NULL, N'292002', NULL, NULL, 0, 52, NULL, N'7028352926', N'7028714713', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5110 W Sahara Ave', N'Las Vegas', N'NV', N'32003', N'89146', 36.144321, -115.225269, 2255, 173, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3502, N'Horizon Specialty Hospital', 1, NULL, NULL, N'292003', NULL, NULL, 0, 199, NULL, N'7023823155', N'7024051995', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'640 Desert Lane', N'Las Vegas', N'NV', N'32003', N'89106', 36.163674, -115.162192, 2255, 173, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3503, N'Tahoe Pacific Hospital - Meadows', 1, NULL, NULL, N'292004', NULL, NULL, 0, 39, NULL, N'7753311044', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'10101 Double R Blvd-1St Floor', N'Reno', N'NV', N'32031', N'89521', 39.52927, -119.813674, 2256, 174, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3504, N'Complex Care Hospital At Tenaya', 1, NULL, NULL, N'292006', NULL, NULL, 0, 70, NULL, N'7025622021', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2500 Tenaya Way', N'Las Vegas', N'NV', N'32003', N'89128', 36.166286, -115.149225, 2255, 173, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3505, N'Progressive Hospital', 1, NULL, NULL, N'292007', NULL, NULL, 0, 24, NULL, N'7024332200', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4015 South Mcleod', N'Las Vegas', N'NV', N'32003', N'89121', 36.166286, -115.149225, 2255, 173, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3506, N'Carson Tahoe Continuing Care Hospital', 1, NULL, NULL, N'292008', NULL, NULL, 0, 29, NULL, N'7754457783', N'7758854141', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'775 Fleischmann Way 2Nd Flr', N'Carson City', N'NV', N'32510', N'89703', 39.163798, -119.767403, 2249, 174, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3507, N'Healthsouth Rehabilitation Hospital Of Las Vegas', 1, NULL, NULL, N'293026', NULL, NULL, 0, 79, NULL, N'7028778898', N'7022593402', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1250 S Valley View Blvd', N'Las Vegas', N'NV', N'32003', N'89102', 36.139295, -115.184432, 2255, 173, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3508, N'Healthsouth Rehabilitiation Hospital Of Henderson', 1, NULL, NULL, N'293032', NULL, NULL, 0, 60, NULL, N'7029399400', N'7029399746', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'10301 Jeffreys St', N'Henderson', N'NV', N'32003', N'89052', 36.002692, -115.120462, 2255, 173, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3509, N'Healthsouth Desert Canyon Rehabilitation Hospital', 1, NULL, NULL, N'293033', NULL, NULL, 0, 50, NULL, N'7022527342', N'7027955828', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'9175 West Oquendo Road', N'Las Vegas', N'NV', N'32003', N'89148', 36.166286, -115.149225, 2255, 173, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3510, N'Dini-Townsend Hospital At Nnmh', 1, NULL, NULL, N'294000', NULL, NULL, 0, 70, NULL, N'7756882001', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'480 Galletti Way', N'Sparks', N'NV', N'32031', N'89431', 39.530399, -119.779995, 2256, 174, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3511, N'Southern Nevada Adult Mental Health Services', 1, NULL, NULL, N'294002', NULL, NULL, 0, 293, NULL, N'7024866000', N'7022280226', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6161 W Charleston Blvd', N'Las Vegas', N'NV', N'32003', N'89146', 36.159168, -115.226557, 2255, 173, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3512, N'West Hills Hospital', 1, NULL, NULL, N'294003', NULL, NULL, 0, 95, NULL, N'7753230478', N'7757894405', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'1240 E Ninth St', N'Reno', N'NV', N'32031', N'89512', 39.52927, -119.813674, 2256, 174, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3513, N'Red Rock Behavioral Health Hospital', 1, NULL, NULL, N'294008', NULL, NULL, 0, 21, NULL, N'7022148099', N'7023648183', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5975 West Twain Avenue', N'Las Vegas', N'NV', N'32003', N'89103', 36.166286, -115.149225, 2255, 173, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3514, N'Montevista Hospital', 1, NULL, NULL, N'294009', NULL, NULL, 0, 80, NULL, N'7023641111', N'7023648183', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5900 West Rochelle Avenue', N'Las Vegas', N'NV', N'32003', N'89103', 36.166286, -115.149225, 2255, 173, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3515, N'Spring Mountain Sahara', 1, NULL, NULL, N'294010', NULL, NULL, 0, 30, NULL, N'7028732400', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5460 West Sahara', N'Las Vegas', N'NV', N'32003', N'89146', 36.166286, -115.149225, 2255, 173, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3516, N'Spring Mountain Treatment Center', 1, NULL, NULL, N'294011', NULL, NULL, 0, 82, NULL, N'7028732400', N'7028732710', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7000 West Spring Mountain Road', N'Las Vegas', N'NV', N'32003', N'89117', 36.166286, -115.149225, 2255, 173, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3517, N'Seven Hills Behavioral Institute', 1, NULL, NULL, N'294012', NULL, NULL, 0, 55, NULL, N'7026465000', N'7026465553', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3021 W Horizon Ridge Pkwy', N'Henderson', N'NV', N'32003', N'89052', 35.998854, -115.107871, 2255, 173, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3518, N'Umc Transplantation Services', 1, NULL, NULL, N'299800', NULL, NULL, 0, 0, NULL, N'7023833658', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'1800 W Charleston Blvd', N'Las Vegas', N'NV', N'32003', N'89102', 36.159016, -115.167522, 2255, 173, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3519, N'Concord Hospital', 1, NULL, NULL, N'300001', NULL, NULL, 0, 295, NULL, N'6032252711', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'250 Pleasant St', N'Concord', N'NH', N'33013', N'03301', 43.197724, -71.561862, 2263, 176, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3520, N'Mary Hitchcock Memorial Hospital', 1, NULL, NULL, N'300003', NULL, NULL, 0, 396, NULL, N'6036505000', N'6036531111', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1 Medical Center Drive', N'Lebanon', N'NH', N'33009', N'03756', 43.675701, -72.272995, 2271, 175, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3521, N'Lakes Region General Hospital', 1, NULL, NULL, N'300005', NULL, NULL, 0, 143, NULL, N'6035243211', N'6035272887', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'80 Highland St', N'Laconia', N'NH', N'33001', N'03246', 43.527906, -71.460934, 2269, 176, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3522, N'St Joseph Hospital', 1, NULL, NULL, N'300011', NULL, NULL, 0, 208, NULL, N'6038823000', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'172 Kinsley St', N'Nashua', N'NH', N'33011', N'03060', 42.749279, -71.48047, 2274, 176, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3523, N'Elliot Hospital', 1, NULL, NULL, N'300012', NULL, NULL, 0, 296, NULL, N'6036695300', N'6036474420', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1 Elliot Way', N'Manchester', N'NH', N'33011', N'03103', 42.983993, -71.437882, 2273, 176, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3524, N'Frisbie Memorial Hospital', 1, NULL, NULL, N'300014', NULL, NULL, 0, 122, NULL, N'6033325211', NULL, 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'11 Whitehall Road', N'Rochester', N'NH', N'33017', N'03867', 43.297584, -70.959793, 2280, 129, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3525, N'Parkland Medical Center', 1, NULL, NULL, N'300017', NULL, NULL, 0, 86, NULL, N'6034212100', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1 Parkland Drive', N'Derry', N'NH', N'33015', N'03038', 42.876915, -71.31653, 2264, 176, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3526, N'Wentworth-Douglass Hospital', 1, NULL, NULL, N'300018', NULL, NULL, 0, 178, NULL, N'6037402580', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'789 Central Ave', N'Dover', N'NH', N'33017', N'03820', 43.213332, -70.874191, 2265, 129, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3527, N'Cheshire Medical Center', 1, NULL, NULL, N'300019', NULL, NULL, 0, 169, NULL, N'6033545400', N'6033545402', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'580 Court Street', N'Keene', N'NH', N'33005', N'03431', 42.949087, -72.289853, 2268, 175, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3528, N'Southern Nh Medical Center', 1, NULL, NULL, N'300020', NULL, NULL, 0, 188, NULL, N'6035772000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'8 Prospect Street', N'Nashua', N'NH', N'33011', N'03060', 42.756384, -71.462107, 2274, 176, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3529, N'Exeter Hospital Inc', 1, NULL, NULL, N'300023', NULL, NULL, 0, 100, NULL, N'6037787311', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5 Alumni Drive', N'Exeter', N'NH', N'33015', N'03833', 42.983605, -70.934648, 2266, 176, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3530, N'Portsmouth Regional Hospital', 1, NULL, NULL, N'300029', NULL, NULL, 0, 209, NULL, N'6034365110', NULL, 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'333 Borthwick Ave', N'Portsmouth', N'NH', N'33015', N'03801', 43.064828, -70.790231, 2279, 176, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3531, N'Catholic Medical Center', 1, NULL, NULL, N'300034', NULL, NULL, 0, 330, NULL, N'6036683545', N'6036636547', 1, 1, 1, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'100 Mcgregor Street', N'Manchester', N'NH', N'33011', N'03102', 42.994196, -71.472953, 2273, 176, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3532, N'Upper Connecticut Valley Hospital', 1, NULL, NULL, N'301300', NULL, NULL, 0, 16, NULL, N'6032374971', N'6032374452', 1, 1, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'181 Corliss Lane', N'Colebrook', N'NH', N'33007', N'03576', 44.903261, -71.482872, 2262, 175, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3533, N'Cottage Hospital', 1, NULL, NULL, N'301301', NULL, NULL, 0, 25, NULL, N'6037479000', N'6037473310', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'90 Swiftwater Rd', N'Woodsville', N'NH', N'33009', N'03785', 44.136731, -72.025046, 2282, 175, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3534, N'Littleton Regional Healthcare', 1, NULL, NULL, N'301302', NULL, NULL, 0, 25, NULL, N'6034449000', NULL, 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'600 St Johnsbury Road', N'Littleton', N'NH', N'33009', N'03561', 44.315599, -71.827488, 2272, 175, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3535, N'Weeks Medical Center', 1, NULL, NULL, N'301303', NULL, NULL, 0, 25, NULL, N'6037884911', N'6037885068', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'173 Middle Street', N'Lancaster', N'NH', N'33007', N'03584', 44.486265, -71.554369, 2270, 175, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3536, N'New London Hospital', 1, NULL, NULL, N'301304', NULL, NULL, 0, 25, NULL, N'6035262911', N'6035262990', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'273 County Road', N'New London', N'NH', N'33013', N'03257', 43.420156, -72.002005, 2275, 175, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3537, N'Alice Peck Day Memorial Hospital', 1, NULL, NULL, N'301305', NULL, NULL, 0, 25, NULL, N'6034483121', N'6034487444', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'10 Alice Peck Day Drive', N'Lebanon', N'NH', N'33009', N'03766', 43.642538, -72.251383, 2271, 175, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3538, N'Franklin Regional Hospital', 1, NULL, NULL, N'301306', NULL, NULL, 0, 25, NULL, N'6039342060', NULL, 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'15 Aiken Avenue', N'Franklin', N'NH', N'33013', N'03235', 43.447854, -71.642955, 2267, 176, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3539, N'Memorial Hospital The', 1, NULL, NULL, N'301307', NULL, NULL, 0, 25, NULL, N'6033565461', N'6033568135', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3073 White Mountain Highway', N'North Conway', N'NH', N'33003', N'03860', 44.035462, -71.12176, 2276, 129, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3540, N'Valley Regional Hospital', 1, NULL, NULL, N'301308', NULL, NULL, 0, 25, NULL, N'6035427771', N'6035421814', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'243 Elm Street', N'Claremont', N'NH', N'33019', N'03743', 43.388127, -72.340618, 2261, 175, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3541, N'Monadnock Community Hospital', 1, NULL, NULL, N'301309', NULL, NULL, 0, 25, NULL, N'6039247191', N'6039249586', 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'452 Old Street Road', N'Peterborough', N'NH', N'33011', N'03458', 42.876987, -71.936851, 2277, 176, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3542, N'Androscoggin Valley Hospital', 1, NULL, NULL, N'301310', NULL, NULL, 0, 25, NULL, N'6037522200', N'6037221836', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'59 Page Hill Road', N'Berlin', N'NH', N'33007', N'03570', 44.488329, -71.160914, 2260, 175, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3543, N'Speare Memorial Hospital', 1, NULL, NULL, N'301311', NULL, NULL, 0, 25, NULL, N'6035361120', N'6035364828', 1, 1, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'16 Hospital Road', N'Plymouth', N'NH', N'33009', N'03264', 43.757391, -71.695262, 2278, 176, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3544, N'Huggins Hospital', 1, NULL, NULL, N'301312', NULL, NULL, 0, 25, NULL, N'6035697500', N'6035697509', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'240 South Main Street', N'Wolfeboro', N'NH', N'33003', N'03894', 43.581063, -71.201578, 2281, 176, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3545, N'Northeast Rehabilitation Hospital', 1, NULL, NULL, N'303026', NULL, NULL, 0, 135, NULL, N'6038932900', NULL, 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'70 Butler Street', N'Salem', N'NH', N'33015', N'03079', 42.765753, -71.186762, 1731, 133, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3546, N'Healthsouth Rehabilitation Hospital', 1, NULL, NULL, N'303027', NULL, NULL, 0, 50, NULL, N'6032269800', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'254 Pleasant Street', N'Concord', N'NH', N'33013', N'03301', 43.201267, -71.56306, 2263, 176, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3547, N'New Hampshire Hosp-Psych Unit', 1, NULL, NULL, N'304000', NULL, NULL, 0, 230, NULL, N'6032715300', N'6032715395', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'36 Clinton Street', N'Concord', N'NH', N'33013', N'03301', 43.193076, -71.544149, 2263, 176, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3548, N'Hampstead Hospital', 1, NULL, NULL, N'304001', NULL, NULL, 0, 111, NULL, N'6033295311', N'6033294746', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'218 East Road', N'Hampstead', N'NH', N'33015', N'03841', 42.869042, -71.152585, 2264, 176, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3549, N'Mary Hitchcock Memorial Hospital - Transplant', 1, NULL, NULL, N'309801', NULL, NULL, 0, 0, NULL, N'6036533770', N'6035600924', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'One Medical Center Drive', N'Lebanon', N'NH', N'33009', N'03756', 43.642538, -72.251383, 2271, 175, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3550, N'Hackensack University Medical Center', 1, NULL, NULL, N'310001', NULL, NULL, 0, 670, NULL, N'2019962000', N'2019963450', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'30 Prospect Ave', N'Hackensack', N'NJ', N'34003', N'07601', 40.884312, -74.05768, 2297, 178, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3551, N'Newark Beth Israel Medical Center', 1, NULL, NULL, N'310002', NULL, NULL, 0, 572, NULL, N'9739267850', N'9737053477', 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'201 Lyons Ave', N'Newark', N'NJ', N'34013', N'07112', 40.710227, -74.213813, 2314, 181, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3552, N'Palisades Medical Center', 1, NULL, NULL, N'310003', NULL, NULL, 0, 202, NULL, N'2018545000', N'2018545036', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7600 River Rd', N'North Bergen', N'NJ', N'34017', N'07047', 40.791348, -73.998762, 2316, 178, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3553, N'Hunterdon Medical Center', 1, NULL, NULL, N'310005', NULL, NULL, 0, 176, NULL, N'9087886100', N'9087886111', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2100 Wescott Drive', N'Flemington', N'NJ', N'34019', N'08822', 40.531116, -74.858692, 2295, 233, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3554, N'St Mary''s General Hospital', 1, NULL, NULL, N'310006', NULL, NULL, 0, 286, NULL, N'9733654300', N'9734715531', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'350 Boulevard', N'Passaic', N'NJ', N'34031', N'07055', 40.858391, -74.137231, 2319, 178, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3555, N'Holy Name Medical Center', 1, NULL, NULL, N'310008', NULL, NULL, 0, 336, NULL, N'2018333000', N'2018333230', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'718 Teaneck Rd', N'Teaneck', N'NJ', N'34003', N'07666', 40.881947, -74.009009, 2339, 178, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3556, N'Clara Maass Medical Center', 1, NULL, NULL, N'310009', NULL, NULL, 0, 416, NULL, N'9734502002', N'9734500181', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'One Clara Maas Drive', N'Belleville', N'NJ', N'34013', N'07109', 40.793712, -74.150144, 2285, 181, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3557, N'Univ Medical Center Of Princeton At Plainsboro', 1, NULL, NULL, N'310010', NULL, NULL, 0, 375, NULL, N'8664604776', N'6098537101', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'One-Five Plainsboro Road', N'Plainsboro', N'NJ', N'34023', N'08536', 40.333441, -74.600434, 2326, 180, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3558, N'Cape Regional Medical Center Inc', 1, NULL, NULL, N'310011', NULL, NULL, 0, 242, NULL, N'6094632000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Two Stone Harbor Blvd', N'Cape May Court House', N'NJ', N'34009', N'08210', 39.082614, -74.823786, 2288, 177, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3559, N'Valley Hospital', 1, NULL, NULL, N'310012', NULL, NULL, 0, 421, NULL, N'2014478000', N'2012916194', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'223 N Van Dien Avenue', N'Ridgewood', N'NJ', N'34003', N'07450', 40.98367, -74.100554, 2329, 183, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3560, N'Cooper University Hospital', 1, NULL, NULL, N'310014', NULL, NULL, 0, 522, NULL, N'8563422000', N'8563423299', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1 Cooper Plaza', N'Camden', N'NJ', N'34007', N'08103', 39.940916, -75.115735, 2287, 177, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3561, N'Morristown Medical Center', 1, NULL, NULL, N'310015', NULL, NULL, 0, 483, NULL, N'9739715450', N'9732907010', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'100 Madison Ave', N'Morristown', N'NJ', N'34027', N'07962', 40.788394, -74.468473, 2310, 179, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3562, N'Carepoint Health-Christ Hospital', 1, NULL, NULL, N'310016', NULL, NULL, 0, 401, NULL, N'2017958200', N'2017958796', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'176 Palisade Ave', N'Jersey City', N'NJ', N'34017', N'07306', 40.734957, -74.050237, 2303, 181, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3563, N'Chilton Medical Center', 1, NULL, NULL, N'310017', NULL, NULL, 0, 232, NULL, N'9738315000', N'9738315183', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'97 West Parkway', N'Pompton Plains', N'NJ', N'34027', N'07444', 40.975959, -74.311786, 2325, 182, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3564, N'St Joseph''s Regional Medical Center', 1, NULL, NULL, N'310019', NULL, NULL, 0, 566, NULL, N'9737542010', N'9737542009', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'703 Main St', N'Paterson', N'NJ', N'34031', N'07503', 40.902522, -74.165361, 2320, 182, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3565, N'St Francis Medical Center', 1, NULL, NULL, N'310021', NULL, NULL, 0, 436, NULL, N'6095995000', N'6096952744', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'601 Hamilton Ave', N'Trenton', N'NJ', N'34021', N'08629', 40.213135, -74.758039, 2341, 233, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3566, N'Virtua West Jersey Hospitals Berlin', 1, NULL, NULL, N'310022', NULL, NULL, 0, 765, NULL, N'8563223200', N'8563223201', 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Whitehorse Pike And Townsend Avenue', N'Berlin', N'NJ', N'34007', N'08009', 39.791226, -74.929054, 2287, 177, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3567, N'Robert Wood Johnson University Hospital At Rahway', 1, NULL, NULL, N'310024', NULL, NULL, 0, 281, NULL, N'7323814200', N'7324996337', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'865 Stone St', N'Rahway', N'NJ', N'34039', N'07065', 40.612269, -74.291356, 2327, 181, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3568, N'Carepoint Health - Bayonne Medical Center', 1, NULL, NULL, N'310025', NULL, NULL, 0, 254, NULL, N'2018585000', N'2018587355', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'29 East 29Th St', N'Bayonne', N'NJ', N'34017', N'07002', 40.668094, -74.113274, 2284, 181, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3569, N'Trinitas Regional Medical Center', 1, NULL, NULL, N'310027', NULL, NULL, 0, 384, NULL, N'9089945000', N'9089945756', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'225 Williamson Street', N'Elizabeth', N'NJ', N'34039', N'07207', 40.659469, -74.21448, 2292, 181, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3570, N'Newton Medical Center', 1, NULL, NULL, N'310028', NULL, NULL, 0, 129, NULL, N'9735798300', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'175 High St', N'Newton', N'NJ', N'34037', N'07860', 41.056967, -74.759934, 2315, 179, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3571, N'Our Lady Of Lourdes Medical Center', 1, NULL, NULL, N'310029', NULL, NULL, 0, 376, NULL, N'8567573500', N'8566352400', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1600 Haddon Avenue', N'Camden', N'NJ', N'34007', N'08103', 39.926832, -75.095258, 2287, 177, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3572, N'Deborah Heart And Lung Center', 1, NULL, NULL, N'310031', NULL, NULL, 0, 161, NULL, N'6098936611', N'6098931213', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'200 Trenton Road', N'Browns Mills', N'NJ', N'34005', N'08015', 39.977468, -74.586186, 2311, 177, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3573, N'Inspira Medical Center Vineland', 1, NULL, NULL, N'310032', NULL, NULL, 0, 293, NULL, N'8566416610', N'8565755178', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1505 W Sherman Ave', N'Vineland', N'NJ', N'34011', N'08360', 39.447774, -75.064397, 2343, 177, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3574, N'Riverview Medical Center', 1, NULL, NULL, N'310034', NULL, NULL, 0, 440, NULL, N'7327412700', N'7322248408', 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'One Riverview Plaza', N'Red Bank', N'NJ', N'34025', N'07701', 40.347054, -74.064306, 2328, 177, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3575, N'Robert Wood Johnson University Hospital', 1, NULL, NULL, N'310038', NULL, NULL, 0, 610, NULL, N'7329378900', N'7329378773', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'One Robert Wood Johnson Pl', N'New Brunswick', N'NJ', N'34023', N'08901', 40.486217, -74.451817, 2313, 180, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3576, N'Raritan Bay Medical Center', 1, NULL, NULL, N'310039', NULL, NULL, 0, 522, NULL, N'7324423700', N'7323245330', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'530 New Brunswick Ave', N'Perth Amboy', N'NJ', N'34023', N'08861', 40.509592, -74.26812, 2321, 180, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3577, N'Carepoint Health-Hoboken University Medical Center', 1, NULL, NULL, N'310040', NULL, NULL, 0, 333, NULL, N'2018218701', N'2015267703', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'308 Willow Ave', N'Hoboken', N'NJ', N'34017', N'07030', 40.741063, -74.033765, 2300, 178, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3578, N'Community Medical Center', 1, NULL, NULL, N'310041', NULL, NULL, 0, 596, NULL, N'7325578000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'99 Rt 37 West', N'Toms River', N'NJ', N'34029', N'08755', 39.970462, -74.234714, 2340, 177, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3579, N'Clara Maass Medical Center West Hudson Division', 1, NULL, NULL, N'310042', NULL, NULL, 0, 166, NULL, N'2019557000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'206 Bergen Ave', N'Kearny', N'NJ', N'34017', N'07032', 40.758273, -74.148899, 2304, 181, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3580, N'Capital Health Medical Center - Hopewell', 1, NULL, NULL, N'310044', NULL, NULL, 0, 344, NULL, N'6093034000', N'6093946687', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'One Capital Way', N'Pennington', N'NJ', N'34021', N'08534', 40.32844, -74.790718, 2341, 233, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3581, N'Englewood Hospital And Medical Center', 1, NULL, NULL, N'310045', NULL, NULL, 0, 490, NULL, N'2018943000', N'2018941345', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'350 Engle St', N'Englewood', N'NJ', N'34003', N'07631', 40.905228, -73.966935, 2294, 178, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3582, N'Shore Medical Center', 1, NULL, NULL, N'310047', NULL, NULL, 0, 302, NULL, N'6096533545', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'100 Medical Center Way', N'Somers Point', N'NJ', N'34001', N'08244', 39.317616, -74.594601, 2333, 177, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3583, N'Robert Wood Johnson University Hospital Somerset', 1, NULL, NULL, N'310048', NULL, NULL, 0, 335, NULL, N'9086852200', N'9086852898', 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'110 Rehill Ave', N'Somerville', N'NJ', N'34035', N'08876', 40.568087, -74.595845, 2334, 180, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3584, N'Saint Clare''s Hospital', 1, NULL, NULL, N'310050', NULL, NULL, 0, 106, NULL, N'9736256000', N'9736256184', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'25 Pocono Road', N'Denville', N'NJ', N'34027', N'07834', 40.894554, -74.473714, 2289, 179, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3585, N'Overlook Medical Center', 1, NULL, NULL, N'310051', NULL, NULL, 0, 448, NULL, N'9085222000', N'9082735134', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'99 Beauvoir Avenue', N'Summit', N'NJ', N'34039', N'07902', 40.71253, -74.353438, 2337, 179, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3586, N'Ocean Medical Center', 1, NULL, NULL, N'310052', NULL, NULL, 0, 436, NULL, N'7328402200', N'7328403284', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'425 Jack Martin Blvd', N'Brick', N'NJ', N'34029', N'08724', 40.073564, -74.122226, 2324, 177, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3587, N'Hackensack-Umc Mountainside', 1, NULL, NULL, N'310054', NULL, NULL, 0, 328, NULL, N'9734296000', N'9734296209', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Bay And Highland Ave', N'Montclair', N'NJ', N'34013', N'07042', 40.825933, -74.209034, 2309, 181, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3588, N'Virtua Memorial Hospital Of Burlington County', 1, NULL, NULL, N'310057', NULL, NULL, 0, 341, NULL, N'6099146200', N'6099146201', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'175 Madison Ave', N'Mount Holly', N'NJ', N'34005', N'08060', 39.988148, -74.794688, 2311, 177, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3589, N'Bergen Regional Medical Center', 1, NULL, NULL, N'310058', NULL, NULL, 0, 496, NULL, N'2019674000', N'2012256748', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'230 East Ridgewood Ave', N'Paramus', N'NJ', N'34003', N'07652', 40.969993, -74.079848, 2318, 178, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3590, N'St Luke''s Warren Hospital', 1, NULL, NULL, N'310060', NULL, NULL, 0, 214, NULL, N'9088596700', N'9088594546', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'185 Roseberry St', N'Phillipsburg', N'NJ', N'34041', N'08865', 40.704689, -75.181381, 2322, 226, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3591, N'Lourdes Medical Center Of Burlington County', 1, NULL, NULL, N'310061', NULL, NULL, 0, 221, NULL, N'6098352900', N'6098353061', 1, 1, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'218A Sunset Road', N'Willingboro', N'NJ', N'34005', N'08046', 40.049647, -74.871549, 2346, 177, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3592, N'Atlanticare Regional Medical Center - City Div', 1, NULL, NULL, N'310064', NULL, NULL, 0, 263, NULL, N'6094418020', N'6094412108', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'65 West Jimmie Leeds Road', N'Pomona', N'NJ', N'34001', N'08240', 39.480537, -74.566797, 2283, 177, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3593, N'Inspira Medical Center Elmer', 1, NULL, NULL, N'310069', NULL, NULL, 0, 91, NULL, N'8563631000', N'8563583248', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'501 West Front Street', N'Elmer', N'NJ', N'34033', N'08318', 39.594247, -75.1682, 2293, 177, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3594, N'Saint Peter''s University Hospital', 1, NULL, NULL, N'310070', NULL, NULL, 0, 416, NULL, N'7327458600', N'7327457938', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'254 Easton Ave', N'New Brunswick', N'NJ', N'34023', N'08901', 40.502034, -74.459918, 2313, 180, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3595, N'Jersey Shore University Medical Center', 1, NULL, NULL, N'310073', NULL, NULL, 0, 490, NULL, N'7327764900', N'7327764583', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1945 Rte 33', N'Neptune', N'NJ', N'34025', N'07754', 40.223998, -74.047822, 2312, 177, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3596, N'Jersey City Medical Center', 1, NULL, NULL, N'310074', NULL, NULL, 0, 255, NULL, N'2019152000', N'2019152002', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'355 Grand Street', N'Jersey City', N'NJ', N'34017', N'07302', 40.716612, -74.050129, 2303, 181, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3597, N'Monmouth Medical Center', 1, NULL, NULL, N'310075', NULL, NULL, 0, 450, NULL, N'7322225200', N'7329237511', 1, 1, 0, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'300 Second Avenue', N'Long Branch', N'NJ', N'34025', N'07740', 40.304278, -73.99236, 2307, 177, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3598, N'Saint Barnabas Medical Center', 1, NULL, NULL, N'310076', NULL, NULL, 0, 485, NULL, N'9733225000', N'9733225007', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'94 Old Short Hills Road', N'Livingston', N'NJ', N'34013', N'07039', 40.767136, -74.301436, 2306, 181, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3599, N'Inspira Medical Center Woodbury', 1, NULL, NULL, N'310081', NULL, NULL, 0, 287, NULL, N'8566416616', N'8565755178', 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'509 N Broad St', N'Woodbury', N'NJ', N'34015', N'08096', 39.843515, -75.149221, 2347, 233, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3600, N'East Orange General Hospital', 1, NULL, NULL, N'310083', NULL, NULL, 0, 211, NULL, N'9732664401', N'9732668488', 1, 1, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'300 Central Ave', N'East Orange', N'NJ', N'34013', N'07018', 40.75471, -74.214619, 2317, 181, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3601, N'Monmouth Medical Center-Southern Campus', 1, NULL, NULL, N'310084', NULL, NULL, 0, 350, NULL, N'7323631900', N'7328864406', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'600 River Ave', N'Lakewood', N'NJ', N'34029', N'08701', 40.073107, -74.218579, 2305, 177, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3602, N'Kennedy University Hospital - Stratford Div', 1, NULL, NULL, N'310086', NULL, NULL, 0, 607, NULL, N'8563467802', N'8563466005', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'18 East Laurel Road', N'Stratford', N'NJ', N'34007', N'08084', 39.826748, -75.010171, 2336, 177, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3603, N'Memorial Hospital Of Salem County', 1, NULL, NULL, N'310091', NULL, NULL, 0, 152, NULL, N'8569351000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'310 Woodstown Road', N'Salem', N'NJ', N'34033', N'08079', 39.57178, -75.467142, 2331, 51, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3604, N'Capital Health System-Fuld Campus', 1, NULL, NULL, N'310092', NULL, NULL, 0, 269, NULL, N'6093946000', N'6093946687', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'750 Brunswick Ave', N'Trenton', N'NJ', N'34021', N'08638', 40.235832, -74.752753, 2341, 233, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3605, N'Saint Michael''s Medical Center Inc', 1, NULL, NULL, N'310096', NULL, NULL, 0, 358, NULL, N'9738775350', N'9738775593', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'111 Central Avenue', N'Newark', N'NJ', N'34013', N'07102', 40.748748, -74.195525, 2314, 181, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3606, N'Jfk Medical Ctr - Anthony M. Yelencsics Community', 1, NULL, NULL, N'310108', NULL, NULL, 0, 551, NULL, N'7323217000', N'7325498532', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'65 James Street', N'Edison', N'NJ', N'34023', N'08818', 40.557117, -74.346928, 2291, 180, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3607, N'Robert Wood Johnson University Hospital Hamilton', 1, NULL, NULL, N'310110', NULL, NULL, 0, 248, NULL, N'6095867900', N'6098907638', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'One Hamilton Health Place', N'Hamilton', N'NJ', N'34021', N'08690', 40.207057, -74.081251, 2341, 233, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3608, N'Centrastate Medical Center', 1, NULL, NULL, N'310111', NULL, NULL, 0, 273, NULL, N'7324312000', N'7324625129', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'901 West Main Street', N'Freehold', N'NJ', N'34025', N'07728', 40.246574, -74.294791, 2296, 177, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3609, N'Bayshore Community Hospital', 1, NULL, NULL, N'310112', NULL, NULL, 0, 225, NULL, N'7327395900', N'7327395887', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'727 N Beers St', N'Holmdel', N'NJ', N'34025', N'07733', 40.405475, -74.194226, 2301, 177, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3610, N'Southern Ocean Medical Center', 1, NULL, NULL, N'310113', NULL, NULL, 0, 134, NULL, N'6095976011', N'6099788920', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1140 Rt 72 W', N'Manahawkin', N'NJ', N'34029', N'08050', 39.695397, -74.258753, 2308, 177, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3611, N'Hackettstown Regional Medical Center', 1, NULL, NULL, N'310115', NULL, NULL, 0, 91, NULL, N'9088525100', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'651 Willow Grove St', N'Hackettstown', N'NJ', N'34041', N'07840', 40.862562, -74.812902, 2298, 179, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3612, N'Meadowlands Hospital Medical Center', 1, NULL, NULL, N'310118', NULL, NULL, 0, 208, NULL, N'2013923200', N'2013923527', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'55 Meadowlands Pkwy', N'Secaucus', N'NJ', N'34017', N'07094', 40.784804, -74.076398, 2332, 178, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3613, N'University Hospital', 1, NULL, NULL, N'310119', NULL, NULL, 0, 518, NULL, N'9739725658', N'9739726943', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'150 Bergen St', N'Newark', N'NJ', N'34013', N'07103', 40.740151, -74.192446, 2314, 181, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3614, N'Matheny School & Hospital The', 1, NULL, NULL, N'312014', NULL, NULL, 0, 102, NULL, N'9082340011', N'9087192137', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'65 Highland Avenue', N'Peapack', N'NJ', N'34035', N'07977', 40.708792, -74.64347, 2310, 179, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3615, N'Specialty Hospital Of Central Jersey', 1, NULL, NULL, N'312017', NULL, NULL, 0, 50, NULL, N'7329423594', N'7329423595', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'600 River Avenue 4 West', N'Lakewood', N'NJ', N'34029', N'08701', 40.097893, -74.217643, 2305, 177, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3616, N'Care One At Raritan Bay Medical Center', 1, NULL, NULL, N'312018', NULL, NULL, 0, 51, NULL, N'7323246090', N'7323246091', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'530 New Brunswick Avenue', N'Perth Amboy', N'NJ', N'34023', N'08861', 40.509592, -74.26812, 2321, 180, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3617, N'Select Specialty Hospital Northeast', 1, NULL, NULL, N'312019', NULL, NULL, 0, 62, NULL, N'2012212352', N'2012212495', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'96 Parkway', N'Rochelle Park', N'NJ', N'34003', N'07662', 40.898003, -74.075828, 2297, 178, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3618, N'Kindred Hospital New Jersey - Morris County', 1, NULL, NULL, N'312020', NULL, NULL, 0, 117, NULL, N'9735373816', N'9735373895', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'400 West Blackwell Street', N'Dover', N'NJ', N'34027', N'07801', 40.886142, -74.576714, 2290, 179, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3619, N'Lourdes Specialty Hospital Of Southern New Jerse', 1, NULL, NULL, N'312022', NULL, NULL, 0, 30, NULL, N'6098355782', N'6098355784', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'218 Sunset Road', N'Willingboro', N'NJ', N'34005', N'08046', 40.050428, -74.850715, 2346, 177, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3620, N'Acuity Specialty Hospital Of New Jersey', 1, NULL, NULL, N'312023', NULL, NULL, 0, 30, NULL, N'6094412122', N'6094412169', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1925 Pacific Avenue 5Th Floor', N'Atlantic City', N'NJ', N'34001', N'08401', 39.364285, -74.422935, 2283, 177, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3621, N'Columbus Hospital Ltach', 1, NULL, NULL, N'312024', NULL, NULL, 0, 63, NULL, N'9735877777', N'9735877830', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'495 N 13Th Street', N'Newark', N'NJ', N'34013', N'07107', 40.773025, -74.186868, 2314, 181, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3622, N'Kessler Institute For Rehabilitation - West Fac', 1, NULL, NULL, N'313025', NULL, NULL, 0, 336, NULL, N'9737313600', N'9732436819', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1199 Pleasant Valley Way', N'West Orange', N'NJ', N'34013', N'07052', 40.785378, -74.277092, 2306, 181, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3623, N'St Lawrence Rehabilitation Center', 1, NULL, NULL, N'313027', NULL, NULL, 0, 86, NULL, N'6098969500', N'6098950242', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2381 Lawrenceville Road', N'Lawrenceville', N'NJ', N'34021', N'08648', 40.285995, -74.732374, 2341, 233, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3624, N'Healthsouth Rehabilitation Hospital Of Toms River', 1, NULL, NULL, N'313029', NULL, NULL, 0, 92, NULL, N'8007654772', N'7328184840', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'14 Hospital Drive', N'Toms River', N'NJ', N'34029', N'08755', 39.961306, -74.218249, 2340, 177, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3625, N'Bacharach Institute For Rehabilitation', 1, NULL, NULL, N'313030', NULL, NULL, 0, 80, NULL, N'6096527000', N'6096527487', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'61 W Jimmie Leeds Road', N'Pomona', N'NJ', N'34001', N'08240', 39.480537, -74.566797, 2283, 177, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3626, N'Marlton Rehabilitation Hospital', 1, NULL, NULL, N'313032', NULL, NULL, 0, 46, NULL, N'8569888778', N'8569888254', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'92 Brick Road', N'Marlton', N'NJ', N'34005', N'08053', 39.873346, -74.937635, 2287, 177, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3627, N'Shore Rehabilitation Institute', 1, NULL, NULL, N'313033', NULL, NULL, 0, 40, NULL, N'7328364530', N'7328364531', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'425 Jack Martin Boulevard Second Floor East Wing', N'Brick', N'NJ', N'34029', N'08724', 40.070724, -74.128056, 2324, 177, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3628, N'Healthsouth Rehabilitation Hospital Of Tinton Fall', 1, NULL, NULL, N'313035', NULL, NULL, 0, 60, NULL, N'7324605320', N'7324607446', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2 Centre Plaza', N'Tinton Falls', N'NJ', N'34025', N'07724', 40.286311, -74.078685, 2307, 177, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3629, N'Healthsouth Rehabilitation Hospital Of Vineland', 1, NULL, NULL, N'313036', NULL, NULL, 0, 40, NULL, N'8566967100', N'8566969040', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1237 W Sherman Avenue', N'Vineland', N'NJ', N'34011', N'08360', 39.447774, -75.064397, 2343, 177, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3630, N'Children''s Specialized Hospital', 1, NULL, NULL, N'313300', NULL, NULL, 0, 90, NULL, N'7322587134', N'7322587210', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'200 Somerset Street', N'New Brunswick', N'NJ', N'34023', N'08901', 40.494995, -74.451921, 2313, 180, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3631, N'Weisman Childrens Rehabilitation Hospital', 1, NULL, NULL, N'313302', NULL, NULL, 0, 30, NULL, N'8564894520', N'8564891169', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'92 Brick Road 3Rd Floor', N'Marlton', N'NJ', N'34005', N'08053', 39.891225, -74.921832, 2287, 177, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3632, N'Summit Oaks Hospital', 1, NULL, NULL, N'314001', NULL, NULL, 0, 150, NULL, N'9085227000', N'9085227098', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'19 Prospect St', N'Summit', N'NJ', N'34039', N'07901', 40.713907, -74.362896, 2337, 179, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3633, N'Ancora Psych Hosp', 1, NULL, NULL, N'314005', NULL, NULL, 0, 709, NULL, N'6095611700', NULL, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'Ancora Branch', N'Hammonton', N'NJ', N'34001', N'08037', 39.636506, -74.802385, 2299, 177, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3634, N'University Behavioral Health Care', 1, NULL, NULL, N'314011', NULL, NULL, 0, 48, NULL, N'7322355900', N'7322354594', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'671 Hoes Lane - Po Box 1392', N'Piscataway', N'NJ', N'34023', N'08854', 40.546255, -74.466041, 2313, 180, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3635, N'Carrier Clinic', 1, NULL, NULL, N'314012', NULL, NULL, 0, 281, NULL, N'9082811000', N'9082811680', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'252 Route 601', N'Belle Mead', N'NJ', N'34035', N'08502', 40.466771, -74.660714, 2334, 180, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3636, N'Trenton Psychiatric Hosp', 1, NULL, NULL, N'314013', NULL, NULL, 0, 436, NULL, N'6096331586', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Station A', N'Trenton', N'NJ', N'34021', N'08625', 40.217058, -74.742946, 2341, 233, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3637, N'Greystone Park Psych Hosp', 1, NULL, NULL, N'314016', NULL, NULL, 0, 605, NULL, N'9735381800', NULL, 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Central Ave', N'Greystone Park', N'NJ', N'34027', N'07950', 40.075738, -74.404162, 2310, 179, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3638, N'Northbrook Behavioral Health Hospital', 1, NULL, NULL, N'314018', NULL, NULL, 0, 150, NULL, N'8563746600', N'8563746520', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'425  Woodbury Turnersville Road', N'Blackwood', N'NJ', N'34007', N'08012', 39.792853, -75.080977, 2336, 177, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3639, N'Ramapo Ridge Psych Hosp', 1, NULL, NULL, N'314019', NULL, NULL, 0, 58, NULL, N'2018485805', N'2018975181', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'301 Sicomac Ave', N'Wyckoff', N'NJ', N'34003', N'07481', 40.984593, -74.171671, 2329, 183, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3640, N'Essex County Hospital Center', 1, NULL, NULL, N'314020', NULL, NULL, 0, 180, NULL, N'9735712801', N'9735712864', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'204 Grove Avenue', N'Cedar Grove', N'NJ', N'34013', N'07009', 39.955918, -74.186632, 2309, 181, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3641, N'Hampton Behavioral Health System', 1, NULL, NULL, N'314021', NULL, NULL, 0, 100, NULL, N'8006032194', N'6095182150', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'650 Rancocas Road', N'Westampton', N'NJ', N'34005', N'08060', 40.075738, -74.404162, 2311, 177, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3642, N'St Barnabas Behavioral Health Center', 1, NULL, NULL, N'314022', NULL, NULL, 0, 40, NULL, N'7329141688', N'7329143854', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1691 Highway 9  -  Cn2025', N'Toms River', N'NJ', N'34029', N'08755', 39.953736, -74.197958, 2340, 177, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3643, N'Aspen Hills Healthcare Center', 1, NULL, NULL, N'314023', NULL, NULL, 0, 30, NULL, N'6098366100', N'6098366101', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'600 Pemberton-Browns Mills Road', N'Pemberton', N'NJ', N'34005', N'08068', 39.971561, -74.685644, 2311, 177, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3644, N'Hudson County Meadowview Psychiatric H', 1, NULL, NULL, N'314024', NULL, NULL, 0, 84, NULL, N'2013695252', N'2013695260', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'595 County Avenue', N'Secaucus', N'NJ', N'34017', N'07094', 40.781296, -74.058256, 2332, 178, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3645, N'East Mountain Hospital', 1, NULL, NULL, N'314026', NULL, NULL, 0, 16, NULL, N'9082811500', N'9082811339', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'40 East Mountain Road', N'Belle Mead', N'NJ', N'34035', N'08502', 40.501971, -74.693547, 2334, 180, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3646, N'Runnells Specialized Hospital', 1, NULL, NULL, N'314027', NULL, NULL, 0, 44, NULL, N'9087715700', N'9087719654', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'40 Watchung Way', N'Berkeley Heights', N'NJ', N'34039', N'07922', 40.66499, -74.421574, 2337, 179, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3647, N'Our Lady Of Lourdes Medical Center', 1, NULL, NULL, N'319800', NULL, NULL, 0, 0, NULL, N'8567573500', N'8566352400', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'1600 Haddon Avenue', N'Camden', N'NJ', N'34007', N'08103', 39.926832, -75.095258, 2287, 177, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3648, N'Robert Wood Johnson University Hospital', 1, NULL, NULL, N'319801', NULL, NULL, 0, 0, NULL, N'7324188365', N'7324188225', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'One Robert Wood Johnson Place', N'New Brunswick', N'NJ', N'34023', N'08901', 40.486217, -74.451817, 2313, 180, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3649, N'Hackensack University Medical Center', 1, NULL, NULL, N'319802', NULL, NULL, 0, 0, NULL, N'2019962608', N'2014980148', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'30 Prospect Ave', N'Hackensack', N'NJ', N'34003', N'07601', 40.884312, -74.05768, 2297, 178, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3650, N'Newark Beth Israel Medical Center', 1, NULL, NULL, N'319803', NULL, NULL, 0, 0, NULL, N'9733228988', N'9733222634', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'201 Lyon Avenue At Osborne Terrace', N'Newark', N'NJ', N'34013', N'07112', 40.735657, -74.172367, 2314, 181, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3651, N'St Barnabas Medical Center', 1, NULL, NULL, N'319804', NULL, NULL, 0, 0, NULL, N'9733225502', N'9733225007', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'94 Old Short Hills Road', N'Livingston', N'NJ', N'34013', N'07039', 40.767136, -74.301436, 2306, 181, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3652, N'University Hospital University Of Medicine And De', 1, NULL, NULL, N'319805', NULL, NULL, 0, 0, NULL, N'9739721351', N'9739726227', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'150 Bergen Street', N'Newark', N'NJ', N'34013', N'07103', 40.740151, -74.192446, 2314, 181, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3653, N'Unm Hospital', 1, NULL, NULL, N'320001', NULL, NULL, 0, 527, NULL, N'5052722111', N'5052721827', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2211 Lomas Boulevard Ne', N'Albuquerque', N'NM', N'35001', N'87106', 35.087338, -106.586392, 2349, 184, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3654, N'St Vincent Hospital', 1, NULL, NULL, N'320002', NULL, NULL, 0, 248, NULL, N'5059135201', N'5059135210', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'455 St Michael''s Drive', N'Santa Fe', N'NM', N'35049', N'87505', 35.658437, -105.950379, 2368, 184, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3655, N'Alta Vista Regional Hospital', 1, NULL, NULL, N'320003', NULL, NULL, 0, 62, NULL, N'5054263930', N'5054549502', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'104 Legion Drive', N'Las Vegas', N'NM', N'35047', N'87701', 35.623408, -105.210716, 2362, 184, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3656, N'Gerald Champion Regional Medical Center', 1, NULL, NULL, N'320004', NULL, NULL, 0, 94, NULL, N'5754396100', N'5754437858', 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2669 North Scenic Drive', N'Alamogordo', N'NM', N'35035', N'88310', 32.938139, -105.952204, 2348, 262, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3657, N'San Juan Regional Medical Center', 1, NULL, NULL, N'320005', NULL, NULL, 0, 240, NULL, N'5056092000', N'5056096909', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'801 West Maple Street', N'Farmington', N'NM', N'35045', N'87401', 36.724237, -108.215712, 2356, 184, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3658, N'Eastern New Mexico Medical Center', 1, NULL, NULL, N'320006', NULL, NULL, 0, 149, NULL, N'5756248722', N'5756248726', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'405 W Country Club Road', N'Roswell', N'NM', N'35005', N'88201', 33.423381, -104.528325, 2366, 184, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3659, N'Lovelace Medical Center', 1, NULL, NULL, N'320009', NULL, NULL, 0, 254, NULL, N'5057278000', N'5057278162', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'601 Dr Martin Luther King Jr Ave Ne', N'Albuquerque', N'NM', N'35001', N'87102', 35.084103, -106.650985, 2349, 184, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3660, N'Presbyterian Espanola Hospital', 1, NULL, NULL, N'320011', NULL, NULL, 0, 80, NULL, N'5057531502', N'5053670257', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1010 Spruce Street', N'Espanola', N'NM', N'35039', N'87532', 35.997061, -106.085187, 2355, 184, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3661, N'Holy Cross Hospital A Div Of Taos Health Systems', 1, NULL, NULL, N'320013', NULL, NULL, 0, 42, NULL, N'5757588883', N'5057515719', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1397 Weimer Road', N'Taos', N'NM', N'35055', N'87571', 36.365985, -105.571546, 2372, 184, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3662, N'Gila Regional Medical Center', 1, NULL, NULL, N'320016', NULL, NULL, 0, 68, NULL, N'5755384000', N'5755384096', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1313 E 32Nd St', N'Silver City', N'NM', N'35017', N'88061', 32.795551, -108.266184, 2370, 184, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3663, N'Lovelace Women''s Hospital', 1, NULL, NULL, N'320017', NULL, NULL, 0, 120, NULL, N'5057277805', N'5057277888', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4701 Montgomery Boulevard Ne', N'Albuquerque', N'NM', N'35001', N'87109', 35.13081, -106.558841, 2349, 184, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3664, N'Memorial Medical Center Inc', 1, NULL, NULL, N'320018', NULL, NULL, 0, 286, NULL, N'5755228641', N'5755215013', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2450 South Telshor Blvd', N'Las Cruces', N'NM', N'35013', N'88011', 32.292182, -106.735502, 2361, 262, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3665, N'Presbyterian Hospital', 1, NULL, NULL, N'320021', NULL, NULL, 0, 623, NULL, N'5057248386', N'5058411861', 1, 1, 0, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1100 Central Avenue Se', N'Albuquerque', N'NM', N'35001', N'87106', 35.081665, -106.635439, 2349, 184, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3666, N'Plains Regional Medical Center', 1, NULL, NULL, N'320022', NULL, NULL, 0, 106, NULL, N'5757697155', N'5757697337', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2100 N Martin Luther King Jr Blvd', N'Clovis', N'NM', N'35009', N'88101', 34.405472, -103.205071, 2353, 267, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3667, N'Artesia General Hospital', 1, NULL, NULL, N'320030', NULL, NULL, 0, 38, NULL, N'5757483333', N'5757488540', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'702 N 13Th Street', N'Artesia', N'NM', N'35015', N'88210', 32.845708, -104.412741, 2350, 184, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3668, N'Los Alamos Medical Center', 1, NULL, NULL, N'320033', NULL, NULL, 0, 53, NULL, N'5056624201', N'5056619598', 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3917 West Road', N'Los Alamos', N'NM', N'35028', N'87544', 35.881719, -106.321915, 2363, 184, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3669, N'Rehoboth Mckinley Christian Health Care Services', 1, NULL, NULL, N'320038', NULL, NULL, 0, 69, NULL, N'5058637000', N'5058635806', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1901 Red Rock Drive', N'Gallup', N'NM', N'35031', N'87301', 35.528357, -108.743949, 2358, 184, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3670, N'Santa Fe Phs Indian Hospital', 1, NULL, NULL, N'320057', NULL, NULL, 0, 20, NULL, N'5059889821', NULL, 1, 0, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1700 Cerrillos Road', N'Santa Fe', N'NM', N'35049', N'87501', 35.666705, -105.969999, 2368, 184, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3671, N'Mescalero Phs Indian Hospital', 1, NULL, NULL, N'320058', NULL, NULL, 0, 15, NULL, N'5054644441', NULL, 1, 0, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'P O Box 210', N'Mescalero', N'NM', N'35035', N'88340', 33.157442, -105.774244, 2375, 184, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3672, N'Northern Navajo Medical Center', 1, NULL, NULL, N'320059', NULL, NULL, 0, 69, NULL, N'5053686001', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Us Hwy 491 North', N'Shiprock', N'NM', N'35045', N'87420', 36.786304, -108.684558, 2376, 184, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3673, N'Zuni Comprehensive Community Health Center', 1, NULL, NULL, N'320060', NULL, NULL, 0, 35, NULL, N'5057824431', N'5057827405', 1, 1, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Route 301 North B Street', N'Zuni', N'NM', N'35031', N'87327', 35.069789, -108.847636, 2377, 184, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3674, N'Gallup Indian Medical Center', 1, NULL, NULL, N'320061', NULL, NULL, 0, 85, NULL, N'5057221000', N'5057221397', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'516 E Nizhoni Blvd', N'Gallup', N'NM', N'35031', N'87301', 35.528357, -108.743949, 2358, 184, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3675, N'Crownpoint Healthcare Facility', 1, NULL, NULL, N'320062', NULL, NULL, 0, 20, NULL, N'5057865291', N'5057866440', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Junction Of Hwy 371', N'Crownpoint', N'NM', N'35031', N'87313', 35.679, -108.147205, 2358, 184, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3676, N'Carlsbad Medical Center', 1, NULL, NULL, N'320063', NULL, NULL, 0, 116, NULL, N'5758874570', N'5758874256', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2430 West Pierce Street', N'Carlsbad', N'NM', N'35015', N'88220', 32.442518, -104.257773, 2351, 267, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3677, N'Lea Regional Medical Center', 1, NULL, NULL, N'320065', NULL, NULL, 0, 250, NULL, N'5754925000', N'5754925505', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5419 N Lovington Highway', N'Hobbs', N'NM', N'35025', N'88240', 32.726959, -103.147796, 2360, 267, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3678, N'Guadalupe County Hospital', 1, NULL, NULL, N'320067', NULL, NULL, 0, 12, NULL, N'5754723417', N'5754724587', 1, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'117 Camino De Vida Suite 100', N'Santa Rosa', N'NM', N'35019', N'88435', 34.93867, -104.682489, 2369, 184, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3679, N'Dhhs Usphs Indian Health Services', 1, NULL, NULL, N'320070', NULL, NULL, 0, 32, NULL, N'5055525300', NULL, 1, 1, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Exit #102 Off I-40 1/2 Mile South', N'San Fidel', N'NM', N'35006', N'87049', 35.082801, -107.598048, 2359, 184, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3680, N'Lovelace Westside Hospital', 1, NULL, NULL, N'320074', NULL, NULL, 0, 95, NULL, N'5057272001', N'5057279565', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'10501 Golf Course Road Nw', N'Albuquerque', N'NM', N'35001', N'87114', 35.183561, -106.686949, 2349, 184, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3681, N'Roosevelt General Hospital', 1, NULL, NULL, N'320084', NULL, NULL, 0, 22, NULL, N'5753563412', N'5753569212', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'42121 Us Highway 70', N'Portales', N'NM', N'35041', N'88130', 34.186192, -103.334398, 2364, 267, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3682, N'Mountain View Regional Medical Center', 1, NULL, NULL, N'320085', NULL, NULL, 0, 168, NULL, N'5755567600', N'5755567619', 1, 1, 0, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4311 East Lohman Avenue', N'Las Cruces', N'NM', N'35013', N'88011', 32.323596, -106.728857, 2361, 262, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3683, N'Lovelace Regional Hospital - Roswell', 1, NULL, NULL, N'320086', NULL, NULL, 0, 26, NULL, N'5756277000', N'5756253309', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'117 East 19Th Street', N'Roswell', N'NM', N'35005', N'88201', 33.416039, -104.521499, 2366, 184, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3684, N'Unm Sandoval Regional Medical Center', 1, NULL, NULL, N'320089', NULL, NULL, 0, 72, NULL, N'5052728087', N'5052726507', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3001 Broadmoor Blvd Ne', N'Rio Rancho', N'NM', N'35043', N'87144', 35.233375, -106.664472, 2349, 184, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3685, N'Sierra Vista Hospital', 1, NULL, NULL, N'321300', NULL, NULL, 0, 25, NULL, N'5758942111', N'5758947659', 1, 1, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'800 E Ninth Avenue', N'T Or C', N'NM', N'35051', N'87901', 34.570817, -105.993007, 2373, 262, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3686, N'Socorro General Hospital', 1, NULL, NULL, N'321301', NULL, NULL, 0, 24, NULL, N'5758351140', N'5758358703', 1, 1, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'1202 Highway 60 West', N'Socorro', N'NM', N'35053', N'87801', 34.057279, -106.893052, 2371, 184, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3687, N'Dr Dan C Trigg Memorial Hospital', 1, NULL, NULL, N'321302', NULL, NULL, 0, 25, NULL, N'5754617007', N'5754617272', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'301 East Miel De Luna Avenue', N'Tucumcari', N'NM', N'35037', N'88401', 35.156308, -103.72342, 2374, 256, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3688, N'Union County General Hospital', 1, NULL, NULL, N'321304', NULL, NULL, 0, 25, NULL, N'5753742585', N'5753748146', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'300 Wilson Street', N'Clayton', N'NM', N'35059', N'88415', 36.454682, -103.194225, 2352, 184, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3689, N'Nor-Lea Hospital District', 1, NULL, NULL, N'321305', NULL, NULL, 0, 25, NULL, N'5753966611', N'5753960318', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1600 North Main', N'Lovington', N'NM', N'35025', N'88260', 32.944008, -103.348554, 3326, 267, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3690, N'Lincoln County Medical Center', 1, NULL, NULL, N'321306', NULL, NULL, 0, 25, NULL, N'5752578250', N'5756304233', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'211 Sudderth Drive', N'Ruidoso', N'NM', N'35027', N'88345', 33.322899, -105.631444, 2367, 184, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3691, N'Miners'' Colfax Medical Center', 1, NULL, NULL, N'321307', NULL, NULL, 0, 25, NULL, N'5754453661', N'5754457875', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'203 Hospital Drive', N'Raton', N'NM', N'35007', N'87740', 36.86332, -104.443344, 2365, 184, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3692, N'Cibola General Hospital', 1, NULL, NULL, N'321308', NULL, NULL, 0, 25, NULL, N'5052874446', N'5052875309', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1016 E Roosevelt Avenue', N'Grants', N'NM', N'35006', N'87020', 35.14726, -107.851446, 2359, 184, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3693, N'Mimbres Memorial Hospital', 1, NULL, NULL, N'321309', NULL, NULL, 0, 49, NULL, N'5755465803', N'5755436907', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'900 W Ash', N'Deming', N'NM', N'35029', N'88031', 32.268698, -107.75864, 2354, 262, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3694, N'Kindred Hospital  Albuquerque', 1, NULL, NULL, N'322002', NULL, NULL, 0, 61, NULL, N'5052424444', N'5058437170', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'700 High Street Ne', N'Albuquerque', N'NM', N'35001', N'87102', 35.089151, -106.638524, 2349, 184, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3695, N'Albuquerque - Amg Specialty Hospital Llc', 1, NULL, NULL, N'322003', NULL, NULL, 0, 25, NULL, N'5058425550', N'5052470206', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'235 Elm Street Ne', N'Albuquerque', N'NM', N'35001', N'87102', 35.084463, -106.638398, 2349, 184, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3696, N'Advanced Care Hospital Of Southern New Mexico Llc', 1, NULL, NULL, N'322004', NULL, NULL, 0, 20, NULL, N'5755216600', N'5755325077', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4451 East Lohman Avenue', N'Las Cruces', N'NM', N'35013', N'88011', 32.325773, -106.724827, 2361, 262, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3697, N'New Mexico Rehabilitation Center', 1, NULL, NULL, N'323026', NULL, NULL, 0, 41, NULL, N'5753473400', N'5753475177', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'72 Gail Harris Avenue', N'Roswell', N'NM', N'35005', N'88203', 33.394266, -104.523024, 2366, 184, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3698, N'Healthsouth Rehabilitation Hospital', 1, NULL, NULL, N'323027', NULL, NULL, 0, 61, NULL, N'5053449478', N'5053412717', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7000 Jefferson Street Ne', N'Albuquerque', N'NM', N'35001', N'87109', 35.160577, -106.593142, 2349, 184, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3699, N'Lovelace Rehabilitation Hospital', 1, NULL, NULL, N'323028', NULL, NULL, 0, 52, NULL, N'5057274781', N'5057279404', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'505 Elm Street Ne', N'Albuquerque', N'NM', N'35001', N'87102', 35.087577, -106.637806, 2349, 184, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3700, N'San Juan Regional Rehabilitation Hospital Inc', 1, NULL, NULL, N'323029', NULL, NULL, 0, 18, NULL, N'5056092630', N'5053276562', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'525 South Schwartz Avenue', N'Farmington', N'NM', N'35045', N'87401', 36.724449, -108.215643, 2356, 184, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3701, N'Rehabilitation Hospital Of Southern New Mexico', 1, NULL, NULL, N'323032', NULL, NULL, 0, 56, NULL, N'5755216400', N'5755216423', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4441 East Lohman Avenue', N'Las Cruces', N'NM', N'35013', N'88011', 32.325087, -106.725869, 2361, 262, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3702, N'Bhc Mesilla Valley Hospital Llc', 1, NULL, NULL, N'324010', NULL, NULL, 0, 88, NULL, N'5753823500', N'5753824900', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3751 Del Rey Boulevard', N'Las Cruces', N'NM', N'35013', N'88012', 32.356562, -106.774077, 2361, 262, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3703, N'Peak Behavioral Health Services Llc', 1, NULL, NULL, N'324012', NULL, NULL, 0, 56, NULL, N'5755893000', N'5055896730', 1, 0, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5065 Mcnutt Road', N'Santa Teresa', N'NM', N'35013', N'88008', 31.889517, -106.651966, 3268, 262, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3704, N'Haven Behavioral Hospital Of Albuquerque', 1, NULL, NULL, N'324013', NULL, NULL, 0, 34, NULL, N'5052544503', N'5052544501', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5400 Gibson Boulevard Se 4Th Floor', N'Albuquerque', N'NM', N'35001', N'87108', 35.084103, -106.650985, 2349, 184, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3705, N'Central Desert Behavioral Health Center', 1, NULL, NULL, N'324014', NULL, NULL, 0, 26, NULL, N'5052433387', N'5052477986', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'239 Elm Street Ne', N'Albuquerque', N'NM', N'35001', N'87102', 35.084515, -106.638387, 2349, 184, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3706, N'Presbyterian Healthcare Transplant', 1, NULL, NULL, N'329801', NULL, NULL, 0, 0, NULL, N'5058411275', N'5052222149', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'1100 Central Se', N'Albuquerque', N'NM', N'35001', N'87102', 35.084103, -106.650985, 2349, 184, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3707, N'University Hospital University Of New Mexico Heal', 1, NULL, NULL, N'329802', NULL, NULL, 0, 0, NULL, N'5052722583', N'5052723150', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'2211 Lomas Boulevard Ne', N'Albuquerque', N'NM', N'35001', N'87106', 35.087338, -106.586392, 2349, 184, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3708, N'Albany Memorial Hospital', 1, NULL, NULL, N'330003', NULL, NULL, 0, 165, NULL, N'5184713221', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'600 Northern Boulevard', N'Albany', N'NY', N'36001', N'12204', 42.673563, -73.750206, 2378, 185, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3709, N'Healthalliance Hospital Broadway Campus', 1, NULL, NULL, N'330004', NULL, NULL, 0, 160, NULL, N'9143313131', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'396 Broadway', N'Kingston', N'NY', N'36111', N'12401', 41.926798, -73.996532, 2433, 185, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3710, N'Kaleida Health', 1, NULL, NULL, N'330005', NULL, NULL, 0, 1079, NULL, N'7168598620', N'7168598678', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'726 Exchange Street Suite 522', N'Buffalo', N'NY', N'36029', N'14210', 42.886447, -78.878369, 2392, 188, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3711, N'St Joseph''s Medical Center', 1, NULL, NULL, N'330006', NULL, NULL, 0, 332, NULL, N'9143787000', NULL, 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'127 South Broadway', N'Yonkers', N'NY', N'36119', N'10701', 40.929537, -73.896759, 2509, 194, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3712, N'Wyoming County Community Hospital', 1, NULL, NULL, N'330008', NULL, NULL, 0, 62, NULL, N'5857862233', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'400 North Main Street', N'Warsaw', N'NY', N'36121', N'14569', 42.750504, -78.132559, 2502, 192, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3713, N'Bronx-Lebanon Hospital Center', 1, NULL, NULL, N'330009', NULL, NULL, 0, 579, NULL, N'2125887000', N'7185881686', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1276 Fulton Avenue', N'Bronx', N'NY', N'36005', N'10456', 40.831649, -73.903533, 2389, 187, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3714, N'Our Lady Of Lourdes Memorial Hospital Inc', 1, NULL, NULL, N'330011', NULL, NULL, 0, 267, NULL, N'6077985111', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'169 Riverside Drive', N'Binghamton', N'NY', N'36007', N'13905', 42.092665, -75.936066, 2387, 186, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3715, N'Albany Medical Center Hospital', 1, NULL, NULL, N'330013', NULL, NULL, 0, 714, NULL, N'5182623125', NULL, 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'43 New Scotland Avenue', N'Albany', N'NY', N'36001', N'12208', 42.653178, -73.776211, 2378, 185, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3716, N'Jamaica Hospital Medical Center', 1, NULL, NULL, N'330014', NULL, NULL, 0, 424, NULL, N'7182626000', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'89Th Avenue And Van Wyck Expressway', N'Jamaica', N'NY', N'36081', N'11418', 40.691485, -73.805677, 2430, 190, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3717, N'New York Community Hospital Of Brooklyn Inc.', 1, NULL, NULL, N'330019', NULL, NULL, 0, 134, NULL, N'7186925302', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2525 Kings Highway', N'Brooklyn', N'NY', N'36047', N'11229', 40.613887, -73.948561, 2391, 191, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3718, N'Vassar Brothers Medical Center', 1, NULL, NULL, N'330023', NULL, NULL, 0, 365, NULL, N'8454548500', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'45 Reade Place', N'Poughkeepsie', N'NY', N'36027', N'12601', 41.694375, -73.93394, 2476, 185, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3719, N'Mount Sinai Hospital', 1, NULL, NULL, N'330024', NULL, NULL, 0, 1171, NULL, N'2122417981', NULL, 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'One Gustave L Levy Place', N'New York', N'NY', N'36061', N'10029', 43.102443, -75.291082, 2452, 191, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3720, N'Nassau University Medical Center', 1, NULL, NULL, N'330027', NULL, NULL, 0, 530, NULL, N'5165720123', N'5165725792', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2201 Hempstead Turnpike', N'East Meadow', N'NY', N'36059', N'11554', 40.725382, -73.554252, 2409, 190, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3721, N'Richmond University Medical Center', 1, NULL, NULL, N'330028', NULL, NULL, 0, 473, NULL, N'7188181234', NULL, 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'355 Bard Avenue', N'Staten Island', N'NY', N'36085', N'10304', 40.63591, -74.10552, 2492, 191, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3722, N'Newark-Wayne Community Hospital', 1, NULL, NULL, N'330030', NULL, NULL, 0, 120, NULL, N'3153322022', N'3153322371', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'111 Driving Park Avenue', N'Newark', N'NY', N'36117', N'14513', 43.060716, -77.099614, 2453, 192, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3723, N'Chenango Memorial Hospital Inc', 1, NULL, NULL, N'330033', NULL, NULL, 0, 58, NULL, N'6073354111', N'6073342024', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'179 North Broad Street', N'Norwich', N'NY', N'36017', N'13815', 42.540433, -75.524678, 2459, 186, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3724, N'Lakeside Memorial Hospital', 1, NULL, NULL, N'330037', NULL, NULL, 0, 61, NULL, N'5856373131', N'5853956036', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'156 West Avenue', N'Brockport', N'NY', N'36055', N'14420', 43.219989, -77.95381, 2388, 192, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3725, N'Southside Hospital', 1, NULL, NULL, N'330043', NULL, NULL, 0, 341, NULL, N'6319683000', N'6319683315', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'301 East Main Street', N'Bay Shore', N'NY', N'36103', N'11706', 40.723547, -73.244907, 2385, 190, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3726, N'Faxton-St Luke''s Healthcare', 1, NULL, NULL, N'330044', NULL, NULL, 0, 372, NULL, N'3157986000', NULL, 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1656 Champlin Avenue', N'Utica', N'NY', N'36065', N'13503', 43.097731, -75.274585, 2499, 189, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3727, N'Huntington Hospital', 1, NULL, NULL, N'330045', NULL, NULL, 0, 408, NULL, N'6313512000', N'6313512586', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'270 Park Avenue', N'Huntington', N'NY', N'36103', N'11743', 40.879446, -73.416081, 2427, 190, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3728, N'St Luke''s Roosevelt Hospital', 1, NULL, NULL, N'330046', NULL, NULL, 0, 1028, NULL, N'2125234000', NULL, 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1111 Amsterdam Avenue', N'New York', N'NY', N'36061', N'10025', 40.805361, -73.961994, 2452, 191, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3729, N'St Mary''s Hospital At Amsterdam', 1, NULL, NULL, N'330047', NULL, NULL, 0, 149, NULL, N'5188421900', NULL, 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'427 Guy Park Avenue', N'Amsterdam', N'NY', N'36057', N'12010', 42.953895, -74.216534, 2381, 185, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3730, N'Northern Dutchess Hospital', 1, NULL, NULL, N'330049', NULL, NULL, 0, 68, NULL, N'8458713391', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6511 Springbrook Avenue', N'Rhinebeck', N'NY', N'36027', N'12572', 41.926759, -73.912635, 2477, 185, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3731, N'New York Hospital Medical Center Of Queens', 1, NULL, NULL, N'330055', NULL, NULL, 0, 489, NULL, N'7186701231', NULL, 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'56-45 Main Street', N'Flushing', N'NY', N'36081', N'11355', 40.75957, -73.83014, 2414, 190, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3732, N'Brooklyn Hospital Center At Downtown Campus', 1, NULL, NULL, N'330056', NULL, NULL, 0, 464, NULL, N'7182508000', N'7186254109', 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'121 Dekalb Avenue', N'Brooklyn', N'NY', N'36047', N'11201', 40.690018, -73.977466, 2391, 191, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3733, N'St Peter''s Hospital', 1, NULL, NULL, N'330057', NULL, NULL, 0, 442, NULL, N'5185251550', NULL, 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'315 South Manning Boulevard', N'Albany', N'NY', N'36001', N'12208', 42.656253, -73.803528, 2378, 185, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3734, N'Geneva General Hospital', 1, NULL, NULL, N'330058', NULL, NULL, 0, 132, NULL, N'3157874175', N'3157874029', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'196 -198 North Street', N'Geneva', N'NY', N'36069', N'14456', 42.875504, -76.978227, 2416, 192, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3735, N'Montefiore Medical Center', 1, NULL, NULL, N'330059', NULL, NULL, 0, 1491, NULL, N'7189204321', NULL, 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'111 East 210Th Street', N'Bronx', N'NY', N'36005', N'10467', 40.879996, -73.880623, 2389, 187, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3736, N'Lawrence Hospital Center', 1, NULL, NULL, N'330061', NULL, NULL, 0, 291, NULL, N'9147871000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'55 Palmer Avenue', N'Bronxville', N'NY', N'36119', N'10708', 40.941657, -73.836593, 2390, 194, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3737, N'New York Downtown Hospital', 1, NULL, NULL, N'330064', NULL, NULL, 0, 180, NULL, N'2123125000', N'2123125196', 1, 1, 0, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'170 William Street', N'New York', N'NY', N'36061', N'10038', 40.710751, -74.005133, 2452, 191, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3738, N'Niagara Falls Memorial Medical Center', 1, NULL, NULL, N'330065', NULL, NULL, 0, 171, NULL, N'7162784000', N'7162784054', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'621 Tenth Street', N'Niagara Falls', N'NY', N'36063', N'14302', 43.103093, -79.030262, 2456, 188, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3739, N'St Clare''s Hospital', 1, NULL, NULL, N'330066', NULL, NULL, 0, 200, NULL, N'5183822000', NULL, 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'600 Mcclellan Street', N'Schenectady', N'NY', N'36093', N'12304', 42.805216, -73.917425, 2484, 185, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3740, N'St Francis Hospital', 1, NULL, NULL, N'330067', NULL, NULL, 0, 292, NULL, N'8454835000', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'241 North Road', N'Poughkeepsie', N'NY', N'36027', N'12601', 41.72027, -73.931123, 2476, 185, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3741, N'United Memorial Medical Center', 1, NULL, NULL, N'330073', NULL, NULL, 0, 166, NULL, N'5853436030', N'5853437434', 1, 1, 0, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'127 North Street', N'Batavia', N'NY', N'36037', N'14020', 43.003973, -78.176849, 2383, 188, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3742, N'F F Thompson Hospital', 1, NULL, NULL, N'330074', NULL, NULL, 0, 113, NULL, N'5853966000', N'5853966481', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'350 Parrish Street', N'Canandaigua', N'NY', N'36069', N'14424', 42.874721, -77.29068, 2394, 192, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3743, N'Sisters Of Charity Hospital', 1, NULL, NULL, N'330078', NULL, NULL, 0, 290, NULL, N'7168621000', N'7168621899', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2157 Main Street', N'Buffalo', N'NY', N'36029', N'14214', 42.928221, -78.85076, 2392, 188, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3744, N'Adirondack Medical Center', 1, NULL, NULL, N'330079', NULL, NULL, 0, 95, NULL, N'5188914141', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2233 State Route 86', N'Saranac Lake', N'NY', N'36033', N'12983', 44.329496, -74.131266, 2482, 280, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3745, N'Lincoln Medical & Mental Health Center', 1, NULL, NULL, N'330080', NULL, NULL, 0, 586, NULL, N'7185795000', NULL, 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'234 East 149Th Street', N'Bronx', N'NY', N'36005', N'10451', 40.817575, -73.924218, 2389, 187, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3746, N'Alice Hyde Medical Center', 1, NULL, NULL, N'330084', NULL, NULL, 0, 76, NULL, N'5184833000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'133 Park Street', N'Malone', N'NY', N'36033', N'12953', 44.856815, -74.291871, 2441, 280, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3747, N'Aurelia Osborn Fox Memorial Hospital', 1, NULL, NULL, N'330085', NULL, NULL, 0, 60, NULL, N'6074232000', NULL, 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'One Norton Avenue', N'Oneonta', N'NY', N'36077', N'13820', 42.467321, -75.017164, 2465, 186, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3748, N'Montefiore Mount Vernon Hospital', 1, NULL, NULL, N'330086', NULL, NULL, 0, 245, NULL, N'9146648000', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'12 North 7Th Avenue', N'Mount Vernon', N'NY', N'36119', N'10550', 40.912919, -73.840156, 2450, 194, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3749, N'Eastern Long Island Hospital', 1, NULL, NULL, N'330088', NULL, NULL, 0, 85, NULL, N'6314771000', N'6314771746', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'201 Manor Place', N'Greenport', N'NY', N'36103', N'11944', 41.110904, -72.361363, 2423, 190, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3750, N'Arnot Ogden Medical Center', 1, NULL, NULL, N'330090', NULL, NULL, 0, 256, NULL, N'6077374100', N'6077374447', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'600 Roe Avenue', N'Elmira', N'NY', N'36015', N'14905', 42.099313, -76.826838, 2412, 189, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3751, N'Columbia Memorial Hospital', 1, NULL, NULL, N'330094', NULL, NULL, 0, 124, NULL, N'5188287601', NULL, 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'71 Prospect Avenue', N'Hudson', N'NY', N'36021', N'12534', 42.246192, -73.778574, 2397, 185, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3752, N'Jones Memorial Hospital', 1, NULL, NULL, N'330096', NULL, NULL, 0, 70, NULL, N'5855931100', N'5855964005', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'191 North Main Street', N'Wellsville', N'NY', N'36003', N'14895', 42.123402, -77.950831, 2505, 192, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3753, N'Ny Eye And Ear Infirmary', 1, NULL, NULL, N'330100', NULL, NULL, 0, 69, NULL, N'2129794000', NULL, 1, 0, 1, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'310 East 14Th Street', N'New York', N'NY', N'36061', N'10003', 40.731985, -73.984483, 2452, 191, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3754, N'New York-Presbyterian Hospital', 1, NULL, NULL, N'330101', NULL, NULL, 0, 2262, NULL, N'2127464189', NULL, 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'525 East 68Th Street', N'New York', N'NY', N'36061', N'10021', 40.764625, -73.953923, 2452, 191, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3755, N'Kenmore Mercy Hospital', 1, NULL, NULL, N'330102', NULL, NULL, 0, 184, NULL, N'7164476100', N'7164476090', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2950 Elmwood Avenue', N'Kenmore', N'NY', N'36029', N'14217', 42.977105, -78.878788, 2432, 188, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3756, N'Olean General Hospital', 1, NULL, NULL, N'330103', NULL, NULL, 0, 186, NULL, N'7163732600', N'7163756360', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'515 Main Street', N'Olean', N'NY', N'36009', N'14760', 42.094366, -78.424775, 2463, 188, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3757, N'Nyack Hospital', 1, NULL, NULL, N'330104', NULL, NULL, 0, 375, NULL, N'8453482000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'160 North Midland Avenue', N'Nyack', N'NY', N'36087', N'10960', 41.115624, -73.918715, 2460, 178, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3758, N'North Shore University Hospital', 1, NULL, NULL, N'330106', NULL, NULL, 0, 812, NULL, N'5165620100', N'5165621395', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'300 Community Drive', N'Manhasset', N'NY', N'36059', N'11030', 40.797879, -73.699575, 2442, 190, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3759, N'Peconic Bay Medical Center', 1, NULL, NULL, N'330107', NULL, NULL, 0, 122, NULL, N'6315486000', N'6317278890', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1300 Roanoke Avenue', N'Riverhead', N'NY', N'36103', N'11901', 40.933437, -72.67371, 2478, 190, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3760, N'St Joseph''s Hospital Inc', 1, NULL, NULL, N'330108', NULL, NULL, 0, 204, NULL, N'6077336541', N'6077377837', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'555 St Joseph''s Blvd', N'Elmira', N'NY', N'36015', N'14902', 42.089797, -76.807734, 2412, 189, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3761, N'Bertrand Chaffee Hospital', 1, NULL, NULL, N'330111', NULL, NULL, 0, 49, NULL, N'7165922871', N'7165929674', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'224 East Main Street', N'Springville', N'NY', N'36029', N'14141', 42.508549, -78.656828, 2490, 188, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3762, N'Oneida Healthcare Center', 1, NULL, NULL, N'330115', NULL, NULL, 0, 101, NULL, N'3153636000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'321 Genesee Street', N'Oneida', N'NY', N'36053', N'13421', 43.078746, -75.647177, 2464, 193, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3763, N'Lenox Hill Hospital', 1, NULL, NULL, N'330119', NULL, NULL, 0, 652, NULL, N'2124392345', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'100 East 77Th Street', N'New York', N'NY', N'36061', N'10021', 40.773965, -73.960884, 2452, 191, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3764, N'Rochester General Hospital', 1, NULL, NULL, N'330125', NULL, NULL, 0, 528, NULL, N'5859224000', NULL, 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1425 Portland Avenue', N'Rochester', N'NY', N'36055', N'14621', 43.192287, -77.584287, 2479, 192, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3765, N'Orange Regional Medical Center', 1, NULL, NULL, N'330126', NULL, NULL, 0, 450, NULL, N'8453432424', N'8453332801', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'707 East Main Street', N'Middletown', N'NY', N'36071', N'10940', 41.445635, -74.417779, 2446, 194, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3766, N'Jacobi Medical Center', 1, NULL, NULL, N'330127', NULL, NULL, 0, 457, NULL, N'7189185000', NULL, 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1400 Pelham Parkway South', N'Bronx', N'NY', N'36005', N'10461', 40.8564, -73.847412, 2389, 187, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3767, N'Elmhurst Hospital Center', 1, NULL, NULL, N'330128', NULL, NULL, 0, 545, NULL, N'7183341141', N'7183341810', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'79-01 Broadway', N'Elmhurst', N'NY', N'36081', N'11373', 40.74512, -73.885815, 2414, 190, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3768, N'Tlc Health Network', 1, NULL, NULL, N'330132', NULL, NULL, 0, 45, NULL, N'7165323377', N'7169349604', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'100 Memorial Drive', N'Gowanda', N'NY', N'36009', N'14070', 42.464872, -78.943012, 2422, 188, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3769, N'Bon Secours Community Hospital', 1, NULL, NULL, N'330135', NULL, NULL, 0, 141, NULL, N'8458565351', N'8458587415', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'160 East Main Street', N'Port Jervis', N'NY', N'36071', N'12771', 41.368068, -74.682434, 2474, 179, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3770, N'Mary Imogene Bassett Hospital', 1, NULL, NULL, N'330136', NULL, NULL, 0, 180, NULL, N'6075473456', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'One Atwell Road', N'Cooperstown', N'NY', N'36077', N'13326', 42.70063, -74.924321, 2401, 185, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3771, N'St Joseph''s Hospital Health Center', 1, NULL, NULL, N'330140', NULL, NULL, 0, 431, NULL, N'3154485111', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'301 Prospect Avenue', N'Syracuse', N'NY', N'36067', N'13203', 43.055543, -76.149268, 2496, 193, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3772, N'Brookhaven Memorial Hospital Medical Center', 1, NULL, NULL, N'330141', NULL, NULL, 0, 306, NULL, N'6316547100', N'6314473714', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'101 Hospital Road', N'Patchogue', N'NY', N'36103', N'11772', 40.780887, -72.978178, 2467, 190, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3773, N'Ira Davenport Memorial Hospital Inc', 1, NULL, NULL, N'330144', NULL, NULL, 0, 66, NULL, N'6077768500', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7571 State Route 54', N'Bath', N'NY', N'36101', N'14810', 42.337016, -77.317758, 2384, 192, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3774, N'St James Mercy Hospital', 1, NULL, NULL, N'330151', NULL, NULL, 0, 157, NULL, N'6073248000', N'6073248115', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'411 Canisteo Street', N'Hornell', N'NY', N'36101', N'14843', 42.309227, -77.659301, 2426, 192, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3775, N'Ellis Hospital', 1, NULL, NULL, N'330153', NULL, NULL, 0, 368, NULL, N'5182434196', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1101 Nott Street', N'Schenectady', N'NY', N'36093', N'12308', 42.819875, -73.918926, 2484, 185, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3776, N'Memorial Hospital For Cancer And Allied Diseases', 1, NULL, NULL, N'330154', NULL, NULL, 0, 514, NULL, N'2126392000', NULL, 1, 0, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1275 York Avenue', N'New York', N'NY', N'36061', N'10021', 40.764045, -73.956024, 2452, 191, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3777, N'Samaritan Medical Center', 1, NULL, NULL, N'330157', NULL, NULL, 0, 287, NULL, N'3157854121', NULL, 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'830 Washington Street', N'Watertown', N'NY', N'36045', N'13601', 43.963938, -75.913014, 2504, 193, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3778, N'Good Samaritan Hospital Of Suffern', 1, NULL, NULL, N'330158', NULL, NULL, 0, 269, NULL, N'9143685000', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'255 Lafayette Avenue', N'Suffern', N'NY', N'36087', N'10901', 41.112392, -74.137158, 2494, 183, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3779, N'Community-General Hospital Of Greater Syracuse', 1, NULL, NULL, N'330159', NULL, NULL, 0, 306, NULL, N'3154925011', N'3154925953', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4900 Broad Road', N'Syracuse', N'NY', N'36067', N'13215', 43.048122, -76.147424, 2496, 193, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3780, N'Staten Island University Hospital', 1, NULL, NULL, N'330160', NULL, NULL, 0, 714, NULL, N'7182269000', NULL, 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'475 Seaview Avenue', N'Staten Island', N'NY', N'36085', N'10305', 40.584753, -74.086052, 2492, 191, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3781, N'Northern Westchester Hospital', 1, NULL, NULL, N'330162', NULL, NULL, 0, 259, NULL, N'9146661200', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'400 East Main Street', N'Mount Kisco', N'NY', N'36119', N'10549', 41.194879, -73.725312, 2449, 194, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3782, N'Eastern Niagara Hospital', 1, NULL, NULL, N'330163', NULL, NULL, 0, 148, NULL, N'7165145700', N'7165145549', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'521 East Avenue', N'Lockport', N'NY', N'36063', N'14094', 43.176417, -78.671201, 2437, 188, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3783, N'Highland Hospital', 1, NULL, NULL, N'330164', NULL, NULL, 0, 261, NULL, N'5854732200', NULL, 1, 1, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1000 South Avenue', N'Rochester', N'NY', N'36055', N'14620', 43.135786, -77.607468, 2479, 192, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3784, N'Westfield Memorial Hospital Inc', 1, NULL, NULL, N'330166', NULL, NULL, 0, 4, NULL, N'7163264921', N'7163263802', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'189 East Main Street', N'Westfield', N'NY', N'36013', N'14787', 42.315907, -79.586992, 2507, 229, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3785, N'Winthrop-University Hospital', 1, NULL, NULL, N'330167', NULL, NULL, 0, 591, NULL, N'5166630333', N'5166632953', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'259 First Street', N'Mineola', N'NY', N'36059', N'11501', 40.749268, -73.640684, 2447, 190, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3786, N'Beth Israel Medical Center', 1, NULL, NULL, N'330169', NULL, NULL, 0, 1111, NULL, N'2124202000', N'2124202881', 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'First Avenue At 16Th Street', N'New York', N'NY', N'36061', N'10003', 43.102443, -75.291082, 2452, 191, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3787, N'Cortland Regional Medical Center Inc', 1, NULL, NULL, N'330175', NULL, NULL, 0, 181, NULL, N'6077563500', N'6077563590', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'134 Homer Avenue', N'Cortland', N'NY', N'36023', N'13045', 42.608778, -76.187238, 2404, 193, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3788, N'Samaritan Hospital', 1, NULL, NULL, N'330180', NULL, NULL, 0, 238, NULL, N'5182713225', NULL, 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2215 Burdett Avenue', N'Troy', N'NY', N'36083', N'12180', 42.733745, -73.671455, 2498, 185, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3789, N'Glen Cove Hospital', 1, NULL, NULL, N'330181', NULL, NULL, 0, 247, NULL, N'5166747300', N'5166747588', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'101 St Andrews Lane', N'Glen Cove', N'NY', N'36059', N'11542', 40.871802, -73.621436, 2417, 190, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3790, N'St Francis Hospital Roslyn', 1, NULL, NULL, N'330182', NULL, NULL, 0, 364, NULL, N'5165626000', N'5165626909', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'100 Port Washington Boulevard', N'Roslyn', N'NY', N'36059', N'11576', 40.803506, -73.668571, 2442, 190, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3791, N'Montefiore New Rochelle Hospital', 1, NULL, NULL, N'330184', NULL, NULL, 0, 242, NULL, N'9146325000', NULL, 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'16 Guion Place', N'New Rochelle', N'NY', N'36119', N'10802', 40.913197, -73.787279, 2451, 187, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3792, N'John T Mather Memorial Hospital  Of Port Jefferson', 1, NULL, NULL, N'330185', NULL, NULL, 0, 248, NULL, N'6314731320', N'6314737367', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'75 North Country Road', N'Port Jefferson', N'NY', N'36103', N'11777', 40.936846, -73.055771, 2473, 190, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3793, N'Mount St Mary''s Hospital And  Health Center', 1, NULL, NULL, N'330188', NULL, NULL, 0, 179, NULL, N'7162974800', N'7162982001', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5300 Military Road', N'Lewiston', N'NY', N'36063', N'14092', 43.152758, -79.028646, 2435, 188, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3794, N'Albany Medical Center / South Clinical Campus', 1, NULL, NULL, N'330189', NULL, NULL, 0, 20, NULL, N'5182421461', NULL, 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'25 Hackett Boulevard', N'Albany', N'NY', N'36001', N'12208', 42.65099, -73.799965, 2378, 185, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3795, N'Glens Falls Hospital', 1, NULL, NULL, N'330191', NULL, NULL, 0, 442, NULL, N'5189261000', NULL, 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'100 Park Street', N'Glens Falls', N'NY', N'36113', N'12801', 43.306615, -73.646396, 2418, 185, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3796, N'Flushing Hospital Medical Center', 1, NULL, NULL, N'330193', NULL, NULL, 0, 293, NULL, N'7186705000', N'7186703077', 1, 1, 0, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'45Th Avenue And Parsons Boulevard', N'Flushing', N'NY', N'36081', N'11355', 40.76543, -73.817429, 2414, 190, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3797, N'Maimonides Medical Center', 1, NULL, NULL, N'330194', NULL, NULL, 0, 711, NULL, N'7182836000', NULL, 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4802 Tenth Avenue', N'Brooklyn', N'NY', N'36047', N'11219', 40.650104, -73.949582, 2391, 191, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3798, N'Long Island Jewish Medical Center', 1, NULL, NULL, N'330195', NULL, NULL, 0, 880, NULL, N'7184707000', NULL, 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'270 - 05 76Th Avenue', N'New Hyde Park', N'NY', N'36081', N'11040', 40.735102, -73.687908, 2447, 190, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3799, N'Coney Island Hospital', 1, NULL, NULL, N'330196', NULL, NULL, 0, 371, NULL, N'7186163000', N'7186164439', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2601 Ocean Parkway', N'Brooklyn', N'NY', N'36047', N'11235', 40.586141, -73.964847, 2391, 191, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3800, N'Canton-Potsdam Hospital', 1, NULL, NULL, N'330197', NULL, NULL, 0, 94, NULL, N'3152653300', N'2152650562', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'50 Leroy Street', N'Potsdam', N'NY', N'36089', N'13676', 44.675961, -74.981565, 2475, 280, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3801, N'South Nassau Communities Hospital', 1, NULL, NULL, N'330198', NULL, NULL, 0, 435, NULL, N'5166323000', N'5166323499', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'One Healthy Way', N'Oceanside', N'NY', N'36059', N'11572', 40.638714, -73.64013, 2461, 190, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3802, N'Metropolitan Hospital Center', 1, NULL, NULL, N'330199', NULL, NULL, 0, 363, NULL, N'2124237554', NULL, 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1901 First Avenue', N'New York', N'NY', N'36061', N'10029', 42.802139, -73.952846, 2452, 191, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3803, N'Kingsbrook Jewish Medical Center', 1, NULL, NULL, N'330201', NULL, NULL, 0, 326, NULL, N'7186045789', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'585 Schenectady Avenue', N'Brooklyn', N'NY', N'36047', N'11203', 40.659167, -73.933889, 2391, 191, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3804, N'Kings County Hospital Center', 1, NULL, NULL, N'330202', NULL, NULL, 0, 639, NULL, N'7182453901', NULL, 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'451 Clarkson Avenue', N'Brooklyn', N'NY', N'36047', N'11203', 40.656554, -73.945277, 2391, 191, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3805, N'Crouse Hospital', 1, NULL, NULL, N'330203', NULL, NULL, 0, 466, NULL, N'3154707449', N'3154702651', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'736 Irving Avenue', N'Syracuse', N'NY', N'36067', N'13210', 43.041293, -76.138225, 2496, 193, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3806, N'Bellevue Hospital Center', 1, NULL, NULL, N'330204', NULL, NULL, 0, 912, NULL, N'2125614132', N'2125624036', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'462 First Avenue', N'New York', N'NY', N'36061', N'10016', 42.802139, -73.952846, 2452, 191, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3807, N'St Anthony Community Hospital', 1, NULL, NULL, N'330205', NULL, NULL, 0, 60, NULL, N'8459862276', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'15 - 19  Maple Avenue', N'Warwick', N'NY', N'36071', N'10990', 41.267751, -74.354811, 2503, 183, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3808, N'St John''s Riverside Hospital', 1, NULL, NULL, N'330208', NULL, NULL, 0, 385, NULL, N'9149644444', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'976 North Broadway', N'Yonkers', N'NY', N'36119', N'10701', 40.969811, -73.884331, 2509, 194, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3809, N'Claxton-Hepburn Medical Center', 1, NULL, NULL, N'330211', NULL, NULL, 0, 130, NULL, N'3153933600', N'3153938506', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'214 King Street', N'Ogdensburg', N'NY', N'36089', N'13669', 44.691687, -75.499724, 2462, 193, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3810, N'Nyu Hospitals Center', 1, NULL, NULL, N'330214', NULL, NULL, 0, 1069, NULL, N'2122637300', NULL, 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'550 First Avenue', N'New York', N'NY', N'36061', N'10016', 42.802139, -73.952846, 2452, 191, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3811, N'Rome Memorial Hospital Inc', 1, NULL, NULL, N'330215', NULL, NULL, 0, 144, NULL, N'3153387000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1500 North James Street', N'Rome', N'NY', N'36065', N'13440', 43.229026, -75.44407, 2481, 193, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3812, N'Oswego Hospital', 1, NULL, NULL, N'330218', NULL, NULL, 0, 132, NULL, N'3153495511', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'110 West Sixth Street', N'Oswego', N'NY', N'36075', N'13126', 43.454728, -76.509597, 2466, 193, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3813, N'Erie County Medical Center', 1, NULL, NULL, N'330219', NULL, NULL, 0, 526, NULL, N'7168983936', N'7168983890', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'462 Grider Street', N'Buffalo', N'NY', N'36029', N'14215', 42.927034, -78.829258, 2392, 188, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3814, N'Wyckoff Heights Medical Center', 1, NULL, NULL, N'330221', NULL, NULL, 0, 324, NULL, N'7189637272', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'374 Stockholm Street', N'Brooklyn', N'NY', N'36047', N'11237', 40.704631, -73.917581, 2391, 191, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3815, N'Saratoga Hospital', 1, NULL, NULL, N'330222', NULL, NULL, 0, 171, NULL, N'5185873222', NULL, 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'211 Church Street', N'Saratoga Springs', N'NY', N'36091', N'12866', 43.083734, -73.787046, 2483, 185, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3816, N'Massena Memorial Hospital', 1, NULL, NULL, N'330223', NULL, NULL, 0, 50, NULL, N'3157641711', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1 Hospital Drive', N'Massena', N'NY', N'36089', N'13662', 44.937013, -74.90861, 2444, 280, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3817, N'Health Alliance Hospital Mary''s Avenue Campus', 1, NULL, NULL, N'330224', NULL, NULL, 0, 222, NULL, N'8453382500', N'8453343149', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'105 Mary''s Avenue', N'Kingston', N'NY', N'36111', N'12401', 41.922549, -73.999599, 2433, 185, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3818, N'Unity Hospital Of Rochester', 1, NULL, NULL, N'330226', NULL, NULL, 0, 311, NULL, N'5857237000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1555 Long Pond Road', N'Rochester', N'NY', N'36055', N'14626', 43.248654, -77.69651, 2479, 192, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3819, N'Brooks Memorial Hospital', 1, NULL, NULL, N'330229', NULL, NULL, 0, 65, NULL, N'7163661111', N'7163666919', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'529 Central Avenue', N'Dunkirk', N'NY', N'36013', N'14048', 42.480095, -79.333692, 2408, 188, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3820, N'Queens Hospital Center', 1, NULL, NULL, N'330231', NULL, NULL, 0, 581, NULL, N'7188833000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'82-68 164Th Street', N'Jamaica', N'NY', N'36081', N'11432', 40.691485, -73.805677, 2430, 190, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3821, N'St Mary''s Hospital ( Troy )', 1, NULL, NULL, N'330232', NULL, NULL, 0, 201, NULL, N'5182725000', NULL, 1, 1, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1300 Massachusetts Avenue', N'Troy', N'NY', N'36083', N'12180', 42.743028, -73.675545, 2498, 185, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3822, N'Brookdale Hospital Medical Center', 1, NULL, NULL, N'330233', NULL, NULL, 0, 530, NULL, N'7182405966', N'7182406487', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Linden Boulevard At Brookdale Plaza', N'Brooklyn', N'NY', N'36047', N'11212', 40.650104, -73.949582, 2391, 191, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3823, N'Westchester Medical Center', 1, NULL, NULL, N'330234', NULL, NULL, 0, 643, NULL, N'9142857017', NULL, 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'100 Woods Rd', N'Valhalla', N'NY', N'36119', N'10595', 41.074819, -73.775133, 2508, 194, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3824, N'Auburn Community Hospital', 1, NULL, NULL, N'330235', NULL, NULL, 0, 99, NULL, N'3152557011', N'3152557382', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'17 Lansing Street', N'Auburn', N'NY', N'36011', N'13021', 42.940866, -76.563869, 2382, 193, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3825, N'New York Methodist Hospital', 1, NULL, NULL, N'330236', NULL, NULL, 0, 591, NULL, N'7187803000', NULL, 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'506 Sixth Street', N'Brooklyn', N'NY', N'36047', N'11215', 40.650104, -73.949582, 2391, 191, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3826, N'Nicholas H Noyes Memorial Hospital', 1, NULL, NULL, N'330238', NULL, NULL, 0, 72, NULL, N'5853356001', N'5853355881', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'111  Clara Barton Street', N'Dansville', N'NY', N'36051', N'14437', 42.552017, -77.700191, 2406, 192, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3827, N'Woman''s Christian Association', 1, NULL, NULL, N'330239', NULL, NULL, 0, 88, NULL, N'7164870141', N'7166648336', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'207 Foote Avenue', N'Jamestown', N'NY', N'36013', N'14701', 42.084781, -79.230878, 2431, 229, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3828, N'Harlem Hospital Center', 1, NULL, NULL, N'330240', NULL, NULL, 0, 268, NULL, N'2124918400', N'2129398300', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'506 Lenox Avenue', N'New York', N'NY', N'36061', N'10037', 40.775887, -72.959728, 2452, 191, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3829, N'University Hospital S U N Y Health Science Center', 1, NULL, NULL, N'330241', NULL, NULL, 0, 378, NULL, N'3154734240', NULL, 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'750 East Adams Street', N'Syracuse', N'NY', N'36067', N'13210', 43.042563, -76.140152, 2496, 193, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3830, N'St Elizabeth Medical Center', 1, NULL, NULL, N'330245', NULL, NULL, 0, 217, NULL, N'3157988100', NULL, 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2209 Genesee Street', N'Utica', N'NY', N'36065', N'13501', 43.083446, -75.267357, 2499, 189, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3831, N'St Charles Hospital', 1, NULL, NULL, N'330246', NULL, NULL, 0, 231, NULL, N'6314746000', N'6314746884', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'200 Belle Terre Road', N'Port Jefferson', N'NY', N'36103', N'11777', 40.947668, -73.060315, 2473, 190, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3832, N'Champlain Valley Physicians Hospital Medical Ctr', 1, NULL, NULL, N'330250', NULL, NULL, 0, 300, NULL, N'5185612000', NULL, 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'75 Beekman Street', N'Plattsburgh', N'NY', N'36019', N'12901', 44.700042, -73.46675, 2471, 280, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3833, N'Mercy Medical Center', 1, NULL, NULL, N'330259', NULL, NULL, 0, 375, NULL, N'5167052525', N'5167051406', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1000 North Village Avenue', N'Rockville Centre', N'NY', N'36059', N'11570', 40.657483, -73.647753, 2480, 190, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3834, N'Phelps Memorial Hospital Assn', 1, NULL, NULL, N'330261', NULL, NULL, 0, 235, NULL, N'9143663000', NULL, 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'701 North Broadway', N'Sleepy Hollow', N'NY', N'36119', N'10591', 41.10479, -73.860588, 2457, 194, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3835, N'St Luke''s Cornwall Hospital', 1, NULL, NULL, N'330264', NULL, NULL, 0, 244, NULL, N'8455614400', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'70 Dubois Street', N'Newburgh', N'NY', N'36071', N'12550', 41.50352, -74.015069, 2454, 194, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3836, N'Clifton Springs Hospital And Clinic', 1, NULL, NULL, N'330265', NULL, NULL, 0, 154, NULL, N'3154629561', N'3154623492', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2 Coulter Road', N'Clifton Springs', N'NY', N'36069', N'14432', 42.960185, -77.138622, 2398, 192, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3837, N'Hudson Valley Hospital Center', 1, NULL, NULL, N'330267', NULL, NULL, 0, 128, NULL, N'9147343611', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1980 Crompond Road', N'Cortlandt Manor', N'NY', N'36119', N'10567', 43.156168, -75.844995, 2468, 194, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3838, N'Cobleskill Regional Hospital', 1, NULL, NULL, N'330268', NULL, NULL, 0, 40, NULL, N'5182543270', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'178 Grandview Drive', N'Cobleskill', N'NY', N'36095', N'12043', 42.682407, -74.479253, 2399, 185, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3839, N'Hospital For Special Surgery', 1, NULL, NULL, N'330270', NULL, NULL, 0, 205, NULL, N'2126061000', N'2126061930', 1, 1, 1, 0, 0, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'535 East 70Th Street', N'New York', N'NY', N'36061', N'10021', 40.764897, -73.952927, 2452, 191, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3840, N'Putnam Hospital Center', 1, NULL, NULL, N'330273', NULL, NULL, 0, 164, NULL, N'9142795711', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'670 Stoneleigh Avenue', N'Carmel', N'NY', N'36079', N'10512', 41.388446, -73.663532, 2395, 50, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3841, N'Nathan Littauer Hospital', 1, NULL, NULL, N'330276', NULL, NULL, 0, 74, NULL, N'5187258621', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'99 East State Street', N'Gloversville', N'NY', N'36035', N'12078', 43.052813, -74.34369, 2419, 185, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3842, N'Corning Hospital', 1, NULL, NULL, N'330277', NULL, NULL, 0, 65, NULL, N'6079377200', N'6079377693', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1 Guthrie Drive', N'Corning', N'NY', N'36101', N'14830', 42.142852, -77.05469, 2402, 236, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3843, N'Mercy Hospital', 1, NULL, NULL, N'330279', NULL, NULL, 0, 387, NULL, N'7168267000', N'7168282700', 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'565 Abbott Road', N'Buffalo', N'NY', N'36029', N'14220', 42.848279, -78.812591, 2392, 188, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3844, N'Strong Memorial Hospital', 1, NULL, NULL, N'330285', NULL, NULL, 0, 739, NULL, N'5852752121', NULL, 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'601 Elmwood Ave', N'Rochester', N'NY', N'36055', N'14642', 43.12462, -77.620307, 2479, 192, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3845, N'Good Samaritan Hospital Medical Center', 1, NULL, NULL, N'330286', NULL, NULL, 0, 437, NULL, N'6313763000', N'6313764208', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1000 Montauk Highway', N'West Islip', N'NY', N'36103', N'11795', 40.695872, -73.29399, 2506, 190, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3846, N'Svcmc-St Vincent''s Ctrs  Ny & West Branches', 1, NULL, NULL, N'330290', NULL, NULL, 0, 860, NULL, N'2126047000', NULL, 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'170 West 12Th Street', N'New York', N'NY', N'36061', N'10011', 40.736938, -74.000212, 2452, 191, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3847, N'White Plains Hospital Center', 1, NULL, NULL, N'330304', NULL, NULL, 0, 240, NULL, N'9146810600', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'41 East Post R0ad', N'White Plains', N'NY', N'36119', N'10601', 41.033986, -73.76291, 2508, 194, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3848, N'Lutheran Medical Center', 1, NULL, NULL, N'330306', NULL, NULL, 0, 468, NULL, N'7186308000', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'150 55Th Street', N'Brooklyn', N'NY', N'36047', N'11220', 40.64688, -74.020985, 2391, 191, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3849, N'Cayuga Medical Center At Ithaca', 1, NULL, NULL, N'330307', NULL, NULL, 0, 212, NULL, N'6072744401', N'6072744527', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'101 Dates Drive', N'Ithaca', N'NY', N'36109', N'14850', 42.472156, -76.536878, 2429, 192, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3850, N'Plainview Hospital', 1, NULL, NULL, N'330331', NULL, NULL, 0, 204, NULL, N'5167193000', N'5167192719', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'888 Old Country Road', N'Plainview', N'NY', N'36059', N'11803', 40.774451, -73.47768, 2470, 190, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3851, N'St Joseph Hospital', 1, NULL, NULL, N'330332', NULL, NULL, 0, 203, NULL, N'5165796000', N'5165790739', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4295 Hempstead Turnpike', N'Bethpage', N'NY', N'36059', N'11714', 40.725694, -73.479245, 2386, 190, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3852, N'Southampton Hospital', 1, NULL, NULL, N'330340', NULL, NULL, 0, 125, NULL, N'5167268200', N'6317268886', 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'240 Meeting House Lane', N'Southampton', N'NY', N'36103', N'11968', 40.88563, -72.380968, 2489, 190, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3853, N'University Hospital Of Brooklyn ( Downstate )', 1, NULL, NULL, N'330350', NULL, NULL, 0, 376, NULL, N'7182701000', NULL, 1, 1, 0, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'445 Lenox Road', N'Brooklyn', N'NY', N'36047', N'11203', 40.65473, -73.944186, 2391, 191, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3854, N'Forest Hills Hospital', 1, NULL, NULL, N'330353', NULL, NULL, 0, 302, NULL, N'7188304000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'102 - 01 66Th Road', N'Forest Hills', N'NY', N'36081', N'11375', 40.730557, -73.844791, 2414, 190, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3855, N'Roswell Park Cancer Institute', 1, NULL, NULL, N'330354', NULL, NULL, 0, 133, NULL, N'7168452300', N'7168458261', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Elm And Carlton Streets', N'Buffalo', N'NY', N'36029', N'14203', 42.886447, -78.878369, 2392, 188, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3856, N'Franklin Hospital', 1, NULL, NULL, N'330372', NULL, NULL, 0, 305, NULL, N'5162566000', N'5162566503', 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'900 Franklin Avenue', N'Valley Stream', N'NY', N'36059', N'11580', 40.675953, -73.683365, 2500, 190, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3857, N'North Central Bronx Hospital', 1, NULL, NULL, N'330385', NULL, NULL, 0, 215, NULL, N'2125195000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3424 Kossuth Avenue & 210Th Street', N'Bronx', N'NY', N'36005', N'10467', 40.8501, -73.866246, 2389, 187, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3858, N'Catskill Regional Medical Center', 1, NULL, NULL, N'330386', NULL, NULL, 0, 164, NULL, N'8457943300', N'8457943240', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'68 Harris Bushville Road', N'Harris', N'NY', N'36105', N'12742', 41.714256, -74.726273, 2425, 185, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3859, N'Rockefeller University Hospital', 1, NULL, NULL, N'330387', NULL, NULL, 0, 40, NULL, N'2125708000', NULL, 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1230 York Avenue', N'New York', N'NY', N'36061', N'10021', 40.759284, -73.959263, 2452, 191, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3860, N'North General Hospital', 1, NULL, NULL, N'330390', NULL, NULL, 0, 200, NULL, N'2126504000', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1879 Madison Avenue', N'New York', N'NY', N'36061', N'10035', 40.803402, -73.942074, 2452, 191, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3861, N'University Hospital ( Stony Brook )', 1, NULL, NULL, N'330393', NULL, NULL, 0, 540, NULL, N'6314444000', N'6314442509', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Health Sciences Center Suny', N'Stony Brook', N'NY', N'36103', N'11794', 40.925654, -73.140943, 2493, 190, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3862, N'United Health Services Hospitals Inc', 1, NULL, NULL, N'330394', NULL, NULL, 0, 500, NULL, N'6077636000', NULL, 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'33-57 Harrison Street', N'Johnson City', N'NY', N'36007', N'13790', 42.110345, -75.958617, 2387, 186, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3863, N'St John''s Episcopal Hospital At South Shore', 1, NULL, NULL, N'330395', NULL, NULL, 0, 257, NULL, N'7188697000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'327 Beach 19Th Street', N'Far Rockaway', N'NY', N'36081', N'11691', 40.598667, -73.753137, 2413, 190, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3864, N'Woodhull Medical And Mental Health Center', 1, NULL, NULL, N'330396', NULL, NULL, 0, 411, NULL, N'7189638100', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'760 Broadway', N'Brooklyn', N'NY', N'36047', N'11206', 40.700486, -73.941692, 2391, 191, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3865, N'Interfaith Medical Center', 1, NULL, NULL, N'330397', NULL, NULL, 0, 287, NULL, N'7186134000', N'7189357588', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1545 Atlantic Avenue', N'Brooklyn', N'NY', N'36047', N'11213', 40.678118, -73.937462, 2391, 191, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3866, N'St Barnabas Hospital', 1, NULL, NULL, N'330399', NULL, NULL, 0, 446, NULL, N'2129609000', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4422 Third Avenue', N'Bronx', N'NY', N'36005', N'10457', 40.8501, -73.866246, 2389, 187, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3867, N'St Catherine Of Siena Hospital', 1, NULL, NULL, N'330401', NULL, NULL, 0, 318, NULL, N'6318623000', N'6318623105', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'50 Route 25A', N'Smithtown', N'NY', N'36103', N'11787', 40.855931, -73.200669, 2487, 190, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3868, N'Monroe Community Hospital', 1, NULL, NULL, N'330403', NULL, NULL, 0, 5, NULL, N'5857606500', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'435 East Henrietta Road', N'Rochester', N'NY', N'36055', N'14620', 43.113529, -77.616251, 2479, 192, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3869, N'Winifred Masterson Burke Rehabilitation Hospital', 1, NULL, NULL, N'330404', NULL, NULL, 0, 150, NULL, N'9145972232', NULL, 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'785 Mamaroneck Avenue', N'White Plains', N'NY', N'36119', N'10605', 41.014707, -73.75588, 2508, 194, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3870, N'Helen Hayes Hospital', 1, NULL, NULL, N'330405', NULL, NULL, 0, 130, NULL, N'8457864000', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'51 North Route 9W', N'West Haverstraw', N'NY', N'36087', N'10993', 41.209594, -73.985299, 2460, 178, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3871, N'Sunnyview Hospital And Rehabilitation Center', 1, NULL, NULL, N'330406', NULL, NULL, 0, 115, NULL, N'5183863580', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1270 Belmont Avenue', N'Schenectady', N'NY', N'36093', N'12308', 42.821927, -73.913396, 2484, 185, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3872, N'Tri-Town Regional Healthcare', 1, NULL, NULL, N'330408', NULL, NULL, 0, 4, NULL, N'6075612021', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'43 West Pearl Street', N'Sidney', N'NY', N'36025', N'13838', 42.305207, -75.391637, 2486, 186, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3873, N'Burdett Care Center', 1, NULL, NULL, N'330409', NULL, NULL, 0, 15, NULL, N'5182713655', N'5182713203', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2215 Burdett Ave', N'Troy', N'NY', N'36083', N'12180', 42.733745, -73.671455, 2498, 185, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3874, N'Cuba Memorial Hospital Inc', 1, NULL, NULL, N'331301', NULL, NULL, 0, 20, NULL, N'5859612000', NULL, 1, 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'140 West Main Street', N'Cuba', N'NY', N'36003', N'14727', 42.213441, -78.287512, 2405, 188, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3875, N'Elizabethtown Community Hospital', 1, NULL, NULL, N'331302', NULL, NULL, 0, 15, NULL, N'5188736377', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'75 Park Street', N'Elizabethtown', N'NY', N'36031', N'12932', 44.214115, -73.595414, 2410, 280, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3876, N'Catskill Regional Medical Center - G Hermann Site', 1, NULL, NULL, N'331303', NULL, NULL, 0, 15, NULL, N'8458875530', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'8081 Route 97', N'Callicoon', N'NY', N'36105', N'12723', 41.767311, -75.056278, 2510, 186, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3877, N'Margaretville Memorial Hospital', 1, NULL, NULL, N'331304', NULL, NULL, 0, 22, NULL, N'8455865631', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'42084 State Highway 28', N'Margaretville', N'NY', N'36025', N'12455', 42.147258, -74.647284, 2443, 185, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3878, N'O''connor Hospital', 1, NULL, NULL, N'331305', NULL, NULL, 0, 25, NULL, N'6077460300', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'460 Andes Road', N'Delhi', N'NY', N'36025', N'13753', 42.267382, -74.916111, 2401, 185, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3879, N'Moses-Ludington Hospital', 1, NULL, NULL, N'331306', NULL, NULL, 0, 25, NULL, N'5185852831', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1019 Wicker Street', N'Ticonderoga', N'NY', N'36031', N'12883', 43.848415, -73.435068, 2497, 280, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3880, N'Clifton Fine Hospital', 1, NULL, NULL, N'331307', NULL, NULL, 0, 20, NULL, N'3158483351', N'3158482314', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1014 Oswegatchie Trail', N'Star Lake', N'NY', N'36089', N'13690', 44.159785, -75.031583, 2491, 193, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3881, N'River Hospital Inc', 1, NULL, NULL, N'331309', NULL, NULL, 0, 24, NULL, N'3154822511', N'3154827153', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4 Fuller Street', N'Alexandria Bay', N'NY', N'36045', N'13607', 44.336868, -75.920769, 2379, 193, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3882, N'Ellenville Regional Hospital', 1, NULL, NULL, N'331310', NULL, NULL, 0, 25, NULL, N'8456476400', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'10 Healthy Way', N'Ellenville', N'NY', N'36111', N'12428', 41.717038, -74.39571, 2411, 185, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3883, N'Little Falls Hospital', 1, NULL, NULL, N'331311', NULL, NULL, 0, 25, NULL, N'3158235261', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'140 Burwell Street', N'Little Falls', N'NY', N'36043', N'13365', 43.04421, -74.84885, 2436, 189, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3884, N'Delaware Valley Hospital Inc', 1, NULL, NULL, N'331312', NULL, NULL, 0, 25, NULL, N'6078652100', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1 Titus Place', N'Walton', N'NY', N'36025', N'13856', 42.164484, -75.128414, 2501, 186, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3885, N'Schuyler Hospital Inc', 1, NULL, NULL, N'331313', NULL, NULL, 0, 25, NULL, N'6075307121', N'6075359097', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'220 Steuben Street', N'Montour Falls', N'NY', N'36097', N'14865', 42.351559, -76.858686, 2448, 189, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3886, N'Soldiers And Sailors Memorial Hospital Of Yates', 1, NULL, NULL, N'331314', NULL, NULL, 0, 35, NULL, N'3157874175', N'3155312029', 1, 1, 0, 0, 1, 1, 0, 0, 0, 0, 0, 0, NULL, NULL, N'418 North Main Street', N'Penn Yan', N'NY', N'36123', N'14527', 42.660304, -77.054099, 2469, 192, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3887, N'Gouverneur Hospital', 1, NULL, NULL, N'331315', NULL, NULL, 0, 25, NULL, N'3152871000', N'3152874841', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'77 West Barney Street', N'Gouverneur', N'NY', N'36089', N'13642', 44.33823, -75.474359, 2421, 193, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3888, N'Community Memorial Hospital Inc', 1, NULL, NULL, N'331316', NULL, NULL, 0, 25, NULL, N'3158241100', N'3158423182', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'150 Broad Street', N'Hamilton', N'NY', N'36053', N'13346', 42.813322, -75.543044, 2424, 193, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3889, N'Lewis County General Hospital', 1, NULL, NULL, N'331317', NULL, NULL, 0, 25, NULL, N'3153765200', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7785 North State Street', N'Lowville', N'NY', N'36049', N'13367', 43.795815, -75.498265, 2440, 193, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3890, N'Carthage Area Hospital Inc', 1, NULL, NULL, N'331318', NULL, NULL, 0, 25, NULL, N'3154931000', N'3154934231', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1001 West Street', N'Carthage', N'NY', N'36045', N'13619', 43.983355, -75.601538, 2396, 193, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3891, N'High Ridge House', 1, NULL, NULL, N'331990', NULL, NULL, 0, 20, NULL, N'7187964200', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'5959 Independence Avenue', N'Bronx', N'NY', N'36005', N'10471', 40.90976, -73.906895, 2452, 191, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3892, N'Calvary Hospital Inc', 1, NULL, NULL, N'332006', NULL, NULL, 0, 225, NULL, N'7188636900', N'7185182674', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1740 - 70 Eastchester R0ad', N'Bronx', N'NY', N'36005', N'10461', 40.8501, -73.866246, 2389, 187, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3893, N'Coler-Goldwater  Specialty Hospital', 1, NULL, NULL, N'332008', NULL, NULL, 0, 411, NULL, N'2123188000', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1752 Park Avenue', N'New York', N'NY', N'36061', N'10035', 40.802967, -73.940688, 2452, 191, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3894, N'Summit Park Hospital - Rockland County Infirmary', 1, NULL, NULL, N'332014', NULL, NULL, 0, 108, NULL, N'9143642700', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Sanatorium Road', N'Pomona', N'NY', N'36087', N'10970', 41.160362, -74.03967, 2494, 183, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3895, N'Terence Cardinal Cooke Health Care Center', 1, NULL, NULL, N'332022', NULL, NULL, 0, 50, NULL, N'2123603600', NULL, 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1249 Fifth Avenue', N'New York', N'NY', N'36061', N'10029', 42.798499, -73.950136, 2452, 191, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3896, N'Blythedale Children''s Hospital', 1, NULL, NULL, N'333301', NULL, NULL, 0, 92, NULL, N'9145927555', N'9145920407', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'95 Bradhurst Avenue', N'Valhalla', N'NY', N'36119', N'10595', 41.074819, -73.775133, 2508, 194, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3897, N'Hutchings Psychiatric Ctr', 1, NULL, NULL, N'334001', NULL, NULL, 0, 128, NULL, N'3154734980', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'620 Madison Street', N'Syracuse', N'NY', N'36067', N'13210', 43.045303, -76.139977, 2496, 193, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3898, N'Four Winds', 1, NULL, NULL, N'334002', NULL, NULL, 0, 175, NULL, N'9147638151', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'800 Cross River Rd', N'Katonah', N'NY', N'36119', N'10536', 41.267025, -73.645231, 2449, 194, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3899, N'St Lawrence Psych Center', 1, NULL, NULL, N'334003', NULL, NULL, 0, 108, NULL, N'3155412071', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'One Chimney Point Drive', N'Ogdensburg', N'NY', N'36089', N'13669', 44.694229, -75.486336, 2462, 193, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3900, N'Creedmoor Psychiatric Center', 1, NULL, NULL, N'334004', NULL, NULL, 0, 476, NULL, N'7182644000', NULL, 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'80-45 Winchester Blvd Bldg B', N'Queens Village', N'NY', N'36081', N'11427', 40.726769, -73.741521, 2414, 190, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3901, N'New York State Psychiatric Institute', 1, NULL, NULL, N'334009', NULL, NULL, 0, 22, NULL, N'2125435000', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'722 W 168Th St', N'New York', N'NY', N'36061', N'10032', 40.842445, -73.943349, 2452, 191, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3902, N'Greater Binghamton Health Center', 1, NULL, NULL, N'334012', NULL, NULL, 0, 154, NULL, N'6077241391', NULL, 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'425 Robinson St', N'Binghamton', N'NY', N'36007', N'13901', 42.108026, -75.866485, 2387, 186, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3903, N'Pilgrim Psychiatric Center', 1, NULL, NULL, N'334013', NULL, NULL, 0, 560, NULL, N'6317613500', NULL, 1, 1, 1, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'998 Crooked Hill Road', N'West Brentwood', N'NY', N'36103', N'11717', 43.156168, -75.844995, 2385, 190, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3904, N'Rockland Psych Ctr', 1, NULL, NULL, N'334015', NULL, NULL, 0, 503, NULL, N'8453591000', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'140 Old Orangeburg Rd', N'Orangeburg', N'NY', N'36087', N'10962', 41.046578, -73.949671, 2460, 178, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3905, N'Rochester Psychiatric Center', 1, NULL, NULL, N'334020', NULL, NULL, 0, 247, NULL, N'5852411200', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1600 South Ave', N'Rochester', N'NY', N'36055', N'14620', 43.124063, -77.614501, 2479, 192, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3906, N'Mohawk Valley Psychiatric Center', 1, NULL, NULL, N'334021', NULL, NULL, 0, 189, NULL, N'3157976800', NULL, 1, 1, 0, 1, 0, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1400 Noyes St', N'Utica', N'NY', N'36065', N'13502', 43.100856, -75.257331, 2499, 189, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3907, N'Brylin Hosp', 1, NULL, NULL, N'334022', NULL, NULL, 0, 88, NULL, N'7168868200', N'7168861986', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1263 Delaware Ave', N'Buffalo', N'NY', N'36029', N'14209', 42.918527, -78.868235, 2392, 188, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3908, N'Brunswick Psych Center', 1, NULL, NULL, N'334026', NULL, NULL, 0, 124, NULL, N'5167897000', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'366 Broadway', N'Amityville', N'NY', N'36103', N'11701', 40.684345, -73.418259, 2380, 190, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3909, N'South Oaks Hosp', 1, NULL, NULL, N'334027', NULL, NULL, 0, 245, NULL, N'5162644000', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'400 Sunrise Highway', N'Amityville', N'NY', N'36103', N'11701', 40.686325, -73.425655, 2380, 190, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3910, N'South Beach Psychiatric Center', 1, NULL, NULL, N'334043', NULL, NULL, 0, 290, NULL, N'7186672300', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'777 Seaview Ave', N'Staten Island', N'NY', N'36085', N'10305', 40.583479, -74.082782, 2492, 191, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3911, N'Elmira Psych Center', 1, NULL, NULL, N'334045', NULL, NULL, 0, 95, NULL, N'6077374739', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Washington St', N'Elmira', N'NY', N'36015', N'14901', 42.092391, -76.795991, 2412, 189, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3912, N'Capital District Psych Center', 1, NULL, NULL, N'334046', NULL, NULL, 0, 165, NULL, N'8453985566', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'75 New Scotland Ave', N'Albany', N'NY', N'36001', N'12208', 42.652816, -73.780903, 2378, 185, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3913, N'Gracie Square Hosp', 1, NULL, NULL, N'334048', NULL, NULL, 0, 157, NULL, N'2124345322', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'420 East 76 St', N'New York', N'NY', N'36061', N'10021', 43.102443, -75.291082, 2452, 191, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3914, N'Four Winds', 1, NULL, NULL, N'334049', NULL, NULL, 0, 83, NULL, N'5185843600', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'30 Crescent Ave', N'Saratoga Springs', N'NY', N'36091', N'12866', 43.051218, -73.738214, 2483, 185, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3915, N'Buffalo Psychiatric Center', 1, NULL, NULL, N'334052', NULL, NULL, 0, 260, NULL, N'7168852261', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'400 Forest Ave', N'Buffalo', N'NY', N'36029', N'14213', 42.927955, -78.883324, 2392, 188, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3916, N'Bronx Psychiatric Center', 1, NULL, NULL, N'334053', NULL, NULL, 0, 412, NULL, N'7189310600', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1500 Waters Place', N'Bronx', N'NY', N'36005', N'10461', 40.845217, -73.839832, 2389, 187, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3917, N'Manhattan Psychiatric Center', 1, NULL, NULL, N'334054', NULL, NULL, 0, 509, NULL, N'2123690500', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Ward''s Island', N'New York', N'NY', N'36061', N'10035', 39.78373, -100.445882, 2452, 191, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3918, N'Holliswood Hospitalthe', 1, NULL, NULL, N'334055', NULL, NULL, 0, 133, NULL, N'7187768181', NULL, 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'87-37 Palermo Street', N'Hollis', N'NY', N'36081', N'11423', 40.713436, -73.767077, 2430, 190, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3919, N'Stoney Lodge Hospital', 1, NULL, NULL, N'334059', NULL, NULL, 0, 66, NULL, N'9149417400', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'40 Croton Dam Road', N'Ossining', N'NY', N'36119', N'10562', 41.177553, -73.847999, 2457, 194, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3920, N'Kirby Forensic Psychiatric Center', 1, NULL, NULL, N'334060', NULL, NULL, 0, 164, NULL, N'2124279003', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Ward Island', N'New York', N'NY', N'36061', N'10035', 43.102443, -75.291082, 2452, 191, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3921, N'Mid Hudson Forensic Psychiatric Ctr', 1, NULL, NULL, N'334061', NULL, NULL, 0, 280, NULL, N'8453743171', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Box 158 Route 17M', N'New Hampton', N'NY', N'36071', N'10958', 41.410927, -74.4071, 2446, 194, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3922, N'Kingsboro Psychiatric Hospital', 1, NULL, NULL, N'334063', NULL, NULL, 0, 173, NULL, N'7182217395', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'681 Clarkson Avenue', N'Brooklyn', N'NY', N'36047', N'11203', 40.656499, -73.936501, 2391, 191, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3923, N'University Hospital S U N Y Health Science Ctr T C', 1, NULL, NULL, N'339800', NULL, NULL, 0, 0, NULL, N'3154734240', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'750 East Adams Street', N'Syracuse', N'NY', N'36067', N'13210', 43.042563, -76.140152, 2496, 193, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3924, N'North Shore University Hospital - Manhasset T C', 1, NULL, NULL, N'339801', NULL, NULL, 0, 0, NULL, N'5164652667', N'5164658381', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'300 Community Drive', N'Manhasset', N'NY', N'36059', N'11030', 40.797879, -73.699575, 2442, 190, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3925, N'University Hospital Of Brooklyn ( Downstate) T C', 1, NULL, NULL, N'339802', NULL, NULL, 0, 0, NULL, N'7182701000', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'445 Lenox Road', N'Brooklyn', N'NY', N'36047', N'11203', 40.65473, -73.944186, 2391, 191, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3926, N'New York-Presbyterian Hospital At Columbia T C', 1, NULL, NULL, N'339803', NULL, NULL, 0, 0, NULL, N'2123052500', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'622 West 168Th Street', N'New York', N'NY', N'36061', N'10032', 40.841173, -73.940209, 2452, 191, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3927, N'Nyu Hospitals Center T C', 1, NULL, NULL, N'339804', NULL, NULL, 0, 0, NULL, N'2122638360', N'2122638157', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'550 First Avenue', N'New York', N'NY', N'36061', N'10016', 42.802139, -73.952846, 2452, 191, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3928, N'St Luke''s Roosevelt Hospital - St Luke''s Div T C', 1, NULL, NULL, N'339805', NULL, NULL, 0, 0, NULL, N'2125235700', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'1111 Amsterdam Avenue', N'New York', N'NY', N'36061', N'10025', 40.805361, -73.961994, 2452, 191, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3929, N'Westchester Medical Center T C', 1, NULL, NULL, N'339806', NULL, NULL, 0, 0, NULL, N'9142857017', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'100 Woods Rd', N'Valhalla', N'NY', N'36119', N'10595', 41.074819, -73.775133, 2508, 194, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3930, N'Montefiore Medical Center T C', 1, NULL, NULL, N'339807', NULL, NULL, 0, 0, NULL, N'7189205333', N'7185474773', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'111 East 210Th Street', N'Bronx', N'NY', N'36005', N'10467', 40.879996, -73.880623, 2389, 187, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3931, N'Strong Memorial Hospital T C', 1, NULL, NULL, N'339808', NULL, NULL, 0, 0, NULL, N'5852752121', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'601 Elmwood Avenue', N'Rochester', N'NY', N'36055', N'14642', 43.12462, -77.620307, 2479, 192, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3932, N'University Hospital ( Stony Brook ) T C', 1, NULL, NULL, N'339809', NULL, NULL, 0, 0, NULL, N'6314442209', N'6314446639', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'Nicholls Road Hsc T19040', N'Stony Brook', N'NY', N'36103', N'11794', 40.925654, -73.140943, 2493, 190, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3933, N'New York-Presbyterian Hospital At Cornell T C', 1, NULL, NULL, N'339810', NULL, NULL, 0, 0, NULL, N'2123055551', N'2123422204', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'525 East 68Th Street', N'New York', N'NY', N'36061', N'10021', 40.764625, -73.953923, 2452, 191, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3934, N'Albany Medical Center T C', 1, NULL, NULL, N'339811', NULL, NULL, 0, 0, NULL, N'5182623028', N'5182623398', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'43 New Scotland Avenue', N'Albany', N'NY', N'36001', N'12208', 42.653178, -73.776211, 2378, 185, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3935, N'Kaleida Health - Buffalo General Med Ctr T C', 1, NULL, NULL, N'339812', NULL, NULL, 0, 0, NULL, N'7168591345', N'7168591896', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'100 High Street', N'Buffalo', N'NY', N'36029', N'14203', 42.900407, -78.865273, 2392, 188, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3936, N'Mount Sinai Hospital T C', 1, NULL, NULL, N'339813', NULL, NULL, 0, 0, NULL, N'2122417981', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'1 Gustave Levy Place', N'New York', N'NY', N'36061', N'10029', 43.102443, -75.291082, 2452, 191, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3937, N'Erie County Medical Center T C', 1, NULL, NULL, N'339814', NULL, NULL, 0, 0, NULL, N'7168985240', N'7168986195', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'462 Grider Street', N'Buffalo', N'NY', N'36029', N'14215', 42.927034, -78.829258, 2392, 188, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3938, N'Carolinas Medical Center-Northeast', 1, NULL, NULL, N'340001', NULL, NULL, 0, 457, NULL, N'7047833000', NULL, 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'920 Church St N', N'Concord', N'NC', N'37025', N'28025', 35.408752, -80.579511, 2529, 196, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3939, N'Memorial Mission Hospital And Asheville Surgery Ce', 1, NULL, NULL, N'340002', NULL, NULL, 0, 735, NULL, N'8282131111', N'8282131669', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'509 Biltmore Ave', N'Asheville', N'NC', N'37021', N'28801', 35.577889, -82.548445, 2515, 195, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3940, N'Northern Hospital Of Surry County', 1, NULL, NULL, N'340003', NULL, NULL, 0, 112, NULL, N'3367197000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'830 Rockford St', N'Mount Airy', N'NC', N'37171', N'27030', 36.488721, -80.611217, 2568, 203, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3941, N'High Point Regional Hospital', 1, NULL, NULL, N'340004', NULL, NULL, 0, 354, NULL, N'3368786000', NULL, 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'601 N Elm St', N'High Point', N'NC', N'37081', N'27261', 35.9625, -80.012149, 2549, 203, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3942, N'Scotland Memorial Hospital', 1, NULL, NULL, N'340008', NULL, NULL, 0, 104, NULL, N'9102917000', N'9102917499', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'500 Lauchwood Dr', N'Laurinburg', N'NC', N'37165', N'28352', 34.751759, -79.470456, 2556, 197, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3943, N'Wayne Memorial Hospital', 1, NULL, NULL, N'340010', NULL, NULL, 0, 316, NULL, N'9197361110', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2700 Wayne Memorial Dr', N'Goldsboro', N'NC', N'37191', N'27534', 35.396507, -77.967845, 2542, 201, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3944, N'Rutherford Regional Medical Center', 1, NULL, NULL, N'340013', NULL, NULL, 0, 143, NULL, N'8282865000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'288 South Ridgecrest Ave', N'Rutherfordton', N'NC', N'37161', N'28139', 35.369288, -81.956772, 2581, 196, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3945, N'Novant Health Forsyth Medical Center', 1, NULL, NULL, N'340014', NULL, NULL, 0, 912, NULL, N'3367185000', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3333 Silas Creek Parkway', N'Winston-Salem', N'NC', N'37067', N'27103', 36.066016, -80.254524, 2605, 203, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3946, N'Novant Health Rowan Medical Center', 1, NULL, NULL, N'340015', NULL, NULL, 0, 308, NULL, N'7042105000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'612 Mocksville Ave', N'Salisbury', N'NC', N'37159', N'28144', 35.68165, -80.47113, 2582, 196, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3947, N'Harris Regional Hospital', 1, NULL, NULL, N'340016', NULL, NULL, 0, 86, NULL, N'8285867000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'68 Hospital Rd', N'Sylva', N'NC', N'37099', N'28779', 35.389098, -83.205594, 2592, 195, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3948, N'Margaret R Pardee Memorial Hospital', 1, NULL, NULL, N'340017', NULL, NULL, 0, 222, NULL, N'8286961000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'800 N Justice St', N'Hendersonville', N'NC', N'37089', N'28791', 35.321043, -82.468016, 2547, 195, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3949, N'Central Carolina Hospital', 1, NULL, NULL, N'340020', NULL, NULL, 0, 137, NULL, N'9197742100', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1135 Carthage St', N'Sanford', N'NC', N'37105', N'27330', 35.468639, -79.188753, 2583, 197, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3950, N'Carolinas Healthcare System Cleveland', 1, NULL, NULL, N'340021', NULL, NULL, 0, 241, NULL, N'7044873000', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'201 E Grover St', N'Shelby', N'NC', N'37045', N'28150', 35.301525, -81.537743, 2584, 196, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3951, N'Park Ridge Health', 1, NULL, NULL, N'340023', NULL, NULL, 0, 103, NULL, N'8286848501', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'100 Hospital Drive', N'Hendersonville', N'NC', N'37089', N'28792', 35.318728, -82.460953, 2547, 195, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3952, N'Sampson Regional Medical Center', 1, NULL, NULL, N'340024', NULL, NULL, 0, 146, NULL, N'9105928511', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'607 Beaman St', N'Clinton', N'NC', N'37163', N'28328', 35.008292, -78.323969, 2526, 201, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3953, N'Lenoir Memorial Hospital', 1, NULL, NULL, N'340027', NULL, NULL, 0, 235, NULL, N'2525227000', N'2525227007', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'100 Airport Rd', N'Kinston', N'NC', N'37107', N'28501', 35.290153, -77.580582, 2555, 199, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3954, N'Cape Fear Valley Medical Center', 1, NULL, NULL, N'340028', NULL, NULL, 0, 600, NULL, N'9106094000', NULL, 1, 1, 0, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1638 Owen Drive P O Box 2000', N'Fayetteville', N'NC', N'37051', N'28302', 35.052993, -78.878706, 2539, 201, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3955, N'Duke University Hospital', 1, NULL, NULL, N'340030', NULL, NULL, 0, 1019, NULL, N'9196848111', NULL, 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Po Box 3708 Dumc  Erwin Rd', N'Durham', N'NC', N'37063', N'27710', 35.994033, -78.898619, 2532, 197, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3956, N'Caromont Regional Medical Center', 1, NULL, NULL, N'340032', NULL, NULL, 0, 442, NULL, N'7048344891', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2525 Court Dr', N'Gastonia', N'NC', N'37071', N'28052', 35.273649, -81.137042, 2541, 196, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3957, N'Novant Health Franklin Medical Center', 1, NULL, NULL, N'340036', NULL, NULL, 0, 85, NULL, N'9194965131', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'100 Hospital Dr Box 609', N'Louisburg', N'NC', N'37069', N'27549', 36.099039, -78.301106, 2560, 201, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3958, N'Kings Mountain Hospital Inc', 1, NULL, NULL, N'340037', NULL, NULL, 0, 102, NULL, N'7047393601', N'7047390800', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'706 W King St', N'Kings Mountain', N'NC', N'37045', N'28086', 35.240955, -81.356051, 2554, 196, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3959, N'Iredell Memorial Hospital Inc', 1, NULL, NULL, N'340039', NULL, NULL, 0, 247, NULL, N'7048735661', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'557 Brookdale Dr  P O Box 1828', N'Statesville', N'NC', N'37097', N'28677', 35.782636, -80.887296, 2590, 203, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3960, N'Vidant Medical Center', 1, NULL, NULL, N'340040', NULL, NULL, 0, 909, NULL, N'2528474100', NULL, 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2100 Stantonsburg Rd', N'Greenville', N'NC', N'37147', N'27834', 35.605141, -77.408421, 2544, 199, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3961, N'Caldwell Memorial Hospital', 1, NULL, NULL, N'340041', NULL, NULL, 0, 110, NULL, N'8287575100', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'321 Mulberry St Sw', N'Lenoir', N'NC', N'37027', N'28645', 35.9102, -81.535841, 2557, 200, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3962, N'Onslow Memorial Hospital', 1, NULL, NULL, N'340042', NULL, NULL, 0, 150, NULL, N'9105772345', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'317 Western Boulevard', N'Jacksonville', N'NC', N'37133', N'28540', 34.799288, -77.441082, 2551, 199, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3963, N'North Carolina Baptist Hospital', 1, NULL, NULL, N'340047', NULL, NULL, 0, 885, NULL, N'3367162011', N'3367162067', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Medical Center Boulevard', N'Winston-Salem', N'NC', N'37067', N'27157', 36.089827, -80.271364, 2605, 203, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3964, N'North Carolina Specialty Hospital', 1, NULL, NULL, N'340049', NULL, NULL, 0, 24, NULL, N'9199569300', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3916 Ben Franklin Boulevard', N'Durham', N'NC', N'37063', N'27704', 36.043025, -78.897603, 2532, 197, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3965, N'Southeastern Regional Medical Center', 1, NULL, NULL, N'340050', NULL, NULL, 0, 314, NULL, N'9106715000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'300 W 27 St  Po Box 1408', N'Lumberton', N'NC', N'37155', N'28359', 34.618343, -79.008399, 2561, 197, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3966, N'Watauga Medical Center', 1, NULL, NULL, N'340051', NULL, NULL, 0, 117, NULL, N'8282624100', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'336 Deerfield Road', N'Boone', N'NC', N'37189', N'28607', 36.200294, -81.651359, 2519, 250, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3967, N'Novant Health Presbyterian Medical Center', 1, NULL, NULL, N'340053', NULL, NULL, 0, 877, NULL, N'7043844000', NULL, 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'200 Hawthorne Lane Box 33549', N'Charlotte', N'NC', N'37119', N'28233', 35.227087, -80.843127, 2525, 196, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3968, N'Valdese General Hospital Inc', 1, NULL, NULL, N'340055', NULL, NULL, 0, 172, NULL, N'8288742251', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'720 Malcolm Blvd', N'Valdese', N'NC', N'37023', N'28690', 35.740686, -81.563149, 2597, 200, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3969, N'Morehead Memorial Hospital', 1, NULL, NULL, N'340060', NULL, NULL, 0, 108, NULL, N'3366239711', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'117 E Kings Highway', N'Eden', N'NC', N'37157', N'27288', 36.493287, -79.740284, 2533, 198, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3970, N'University Of North Carolina Hospital', 1, NULL, NULL, N'340061', NULL, NULL, 0, 724, NULL, N'9199664141', N'9199667772', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'101 Manning Drive', N'Chapel Hill', N'NC', N'37135', N'27514', 35.904812, -79.049704, 2524, 197, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3971, N'Wilkes Regional Medical Center', 1, NULL, NULL, N'340064', NULL, NULL, 0, 120, NULL, N'3366518100', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1370 West D St', N'North Wilkesboro', N'NC', N'37193', N'28659', 36.159021, -81.157862, 2571, 203, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3972, N'Columbus Regional Healthcare System', 1, NULL, NULL, N'340068', NULL, NULL, 0, 166, NULL, N'9106428011', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'500 Jefferson St', N'Whiteville', N'NC', N'37047', N'28472', 34.338312, -78.696111, 2600, 202, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3973, N'Wakemed Raleigh Campus', 1, NULL, NULL, N'340069', NULL, NULL, 0, 678, NULL, N'9193508000', NULL, 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3000 New Bern Ave', N'Raleigh', N'NC', N'37183', N'27610', 35.785752, -78.589339, 2575, 201, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3974, N'Alamance Regional Medical Center', 1, NULL, NULL, N'340070', NULL, NULL, 0, 238, NULL, N'3365387000', NULL, 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1240 Huffman Mill Rd', N'Burlington', N'NC', N'37001', N'27216', 36.067089, -79.498673, 2523, 197, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3975, N'Betsy Johnson Regional  Hospital', 1, NULL, NULL, N'340071', NULL, NULL, 0, 108, NULL, N'9108927161', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'800 Tilghman Dr', N'Dunn', N'NC', N'37085', N'28334', 35.306987, -78.633189, 2531, 201, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3976, N'Duke Health Raleigh Hospital', 1, NULL, NULL, N'340073', NULL, NULL, 0, 218, NULL, N'9199543000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3400 Wake Forest Rd', N'Raleigh', N'NC', N'37183', N'27609', 35.830039, -78.618917, 2575, 201, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3977, N'Cmc-Blue Ridge', 1, NULL, NULL, N'340075', NULL, NULL, 0, 204, NULL, N'8285805000', NULL, 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2201 S Sterling St', N'Morganton', N'NC', N'37023', N'28655', 35.727154, -81.664167, 2567, 196, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3978, N'Carolinas Health Care System Anson', 1, NULL, NULL, N'340084', NULL, NULL, 0, 52, NULL, N'7046945131', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2301 Us Highway 74 West', N'Wadesboro', N'NC', N'37007', N'28170', 34.96821, -80.076727, 2598, 196, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3979, N'Novant Health Thomasville Medical Center', 1, NULL, NULL, N'340085', NULL, NULL, 0, 149, NULL, N'3364722000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'207 Old Lexington Rd Box 789', N'Thomasville', N'NC', N'37057', N'27360', 35.882637, -80.081988, 2595, 203, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3980, N'The Mcdowell Hospital', 1, NULL, NULL, N'340087', NULL, NULL, 0, 65, NULL, N'8286595000', NULL, 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'430 Rankin Drive P O Box 730', N'Marion', N'NC', N'37111', N'28752', 35.684013, -82.009274, 2562, 195, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3981, N'Johnston Health', 1, NULL, NULL, N'340090', NULL, NULL, 0, 175, NULL, N'9199348171', NULL, 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'509 Bright Leaf Blvd', N'Smithfield', N'NC', N'37101', N'27577', 35.508572, -78.339293, 2586, 201, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3982, N'Moses H Cone Memorial Hospital The', 1, NULL, NULL, N'340091', NULL, NULL, 0, 1232, NULL, N'3368327000', NULL, 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1200 N Elm St', N'Greensboro', N'NC', N'37081', N'27401', 36.092342, -79.78871, 2543, 198, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3983, N'Lexington Memorial Hospital Inc', 1, NULL, NULL, N'340096', NULL, NULL, 0, 94, NULL, N'3362485161', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'250 Hospital Drive Po Box 1817', N'Lexington', N'NC', N'37057', N'27293', 35.824027, -80.253384, 2558, 203, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3984, N'Hugh Chatham Memorial Hospital', 1, NULL, NULL, N'340097', NULL, NULL, 0, 81, NULL, N'3365277000', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'180 Parkwood Dr', N'Elkin', N'NC', N'37171', N'28621', 36.264213, -80.83772, 2537, 203, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3985, N'Carolinas Medical  Center-Pineville', 1, NULL, NULL, N'340098', NULL, NULL, 0, 344, NULL, N'7043795000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'10628 Park Rd', N'Charlotte', N'NC', N'37119', N'28210', 35.15812, -80.848499, 2525, 196, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3986, N'Vidant Roanoke Chowan Hospital', 1, NULL, NULL, N'340099', NULL, NULL, 0, 124, NULL, N'2522093000', N'2522093049', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'500 S Academy St', N'Ahoskie', N'NC', N'37091', N'27910', 36.286822, -76.984681, 2511, 199, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3987, N'Sandhills Regional Medical Center', 1, NULL, NULL, N'340106', NULL, NULL, 0, 49, NULL, N'9109582361', N'9102058000', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1000 West Hamlet Avenue', N'Hamlet', N'NC', N'37153', N'28345', 34.900626, -79.709523, 2545, 196, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3988, N'Vidant Edgecombe Hospital', 1, NULL, NULL, N'340107', NULL, NULL, 0, 83, NULL, N'2526417700', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'111 Hospital Dr', N'Tarboro', N'NC', N'37065', N'27886', 35.91734, -77.561366, 2593, 199, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3989, N'Sentara Albemarle Medical Center', 1, NULL, NULL, N'340109', NULL, NULL, 0, 182, NULL, N'2523350531', N'2523844693', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1144 N Road St', N'Elizabeth City', N'NC', N'37139', N'27909', 36.32348, -76.218694, 2535, 285, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3990, N'Carolinas Medical Center/Behav Health', 1, NULL, NULL, N'340113', NULL, NULL, 0, 843, NULL, N'7043552000', NULL, 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1000 Blythe Blvd', N'Charlotte', N'NC', N'37119', N'28203', 35.203746, -80.839314, 2525, 196, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3991, N'Rex Hospital', 1, NULL, NULL, N'340114', NULL, NULL, 0, 425, NULL, N'9197843100', N'9197843004', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4420 Lake Boone Trail', N'Raleigh', N'NC', N'37183', N'27607', 35.815549, -78.704034, 2575, 201, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3992, N'Firsthealth Moore Regional Hospital', 1, NULL, NULL, N'340115', NULL, NULL, 0, 395, NULL, N'9107151000', N'9102151926', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'155 Memorial Drive', N'Pinehurst', N'NC', N'37125', N'28374', 35.205813, -79.45962, 2573, 197, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3993, N'Frye Regional Medical Center', 1, NULL, NULL, N'340116', NULL, NULL, 0, 338, NULL, N'8283226070', NULL, 1, 1, 0, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'420 N Center St', N'Hickory', N'NC', N'37035', N'28601', 35.737308, -81.338093, 2548, 200, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3994, N'Stanly Regional Medical Center', 1, NULL, NULL, N'340119', NULL, NULL, 0, 109, NULL, N'7049844000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'301 Yadkin St', N'Albemarle', N'NC', N'37167', N'28001', 35.362645, -80.192955, 2512, 196, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3995, N'Vidant Duplin  Hospital', 1, NULL, NULL, N'340120', NULL, NULL, 0, 101, NULL, N'9102960941', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'401 N Main St', N'Kenansville', N'NC', N'37061', N'28349', 34.965718, -77.960269, 2553, 199, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3996, N'Randolph Hospital', 1, NULL, NULL, N'340123', NULL, NULL, 0, 145, NULL, N'3366255151', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'364 White Oak Street', N'Asheboro', N'NC', N'37151', N'27204', 35.711424, -79.814383, 2514, 198, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3997, N'Wilson Medical Center', 1, NULL, NULL, N'340126', NULL, NULL, 0, 317, NULL, N'2523998040', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1705 S Tarboro St', N'Wilson', N'NC', N'37195', N'27893', 35.721269, -77.915539, 2603, 201, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3998, N'Granville Health Systems', 1, NULL, NULL, N'340127', NULL, NULL, 0, 62, NULL, N'9196903000', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'College St Box 947', N'Oxford', N'NC', N'37077', N'27565', 36.3107, -78.590834, 2572, 197, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3999, N'Lake Norman Regional Medical Center', 1, NULL, NULL, N'340129', NULL, NULL, 0, 105, NULL, N'7046604000', N'7046604009', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'171 Fairview Road', N'Mooresville', N'NC', N'37097', N'28117', 35.549067, -80.854277, 2565, 196, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4000, N'Carolinas Medical Center-Union', 1, NULL, NULL, N'340130', NULL, NULL, 0, 157, NULL, N'7042833100', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'600 Hospital Dr', N'Monroe', N'NC', N'37179', N'28110', 34.974507, -80.522635, 2564, 196, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4001, N'Carolina East Medical Center', 1, NULL, NULL, N'340131', NULL, NULL, 0, 314, NULL, N'2526338640', N'2526365376', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2000 Neuse Blvd', N'New Bern', N'NC', N'37049', N'28560', 35.11203, -77.066284, 2570, 199, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4002, N'Maria Parham Medical Center', 1, NULL, NULL, N'340132', NULL, NULL, 0, 102, NULL, N'2524313708', N'2524313734', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Po Box 59', N'Henderson', N'NC', N'37181', N'27536', 36.329591, -78.399164, 2546, 197, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4003, N'Martin General Hospital', 1, NULL, NULL, N'340133', NULL, NULL, 0, 49, NULL, N'2528096179', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'310 S Mccaskey Rd P O Box 1128', N'Williamston', N'NC', N'37117', N'27892', 35.854604, -77.055511, 2601, 199, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4004, N'Central Regional Hospital', 1, NULL, NULL, N'340138', NULL, NULL, 0, 16, NULL, N'9197335540', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'300 Veazey Road', N'Butner', N'NC', N'37077', N'27509', 36.132089, -78.756671, 2532, 197, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4005, N'New Hanover Regional Medical Center', 1, NULL, NULL, N'340141', NULL, NULL, 0, 769, NULL, N'9103437000', NULL, 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2131 S 17Th St Box 9000', N'Wilmington', N'NC', N'37129', N'28402', 34.225728, -77.944711, 2602, 202, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4006, N'Carteret General Hospital', 1, NULL, NULL, N'340142', NULL, NULL, 0, 117, NULL, N'2528086000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3500 Arendell St', N'Morehead City', N'NC', N'37031', N'28557', 34.72498, -76.755455, 2566, 199, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4007, N'Catawba Valley Medical Center', 1, NULL, NULL, N'340143', NULL, NULL, 0, 258, NULL, N'8283263809', N'8283263371', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'810 Fairgrove Church Rd', N'Hickory', N'NC', N'37035', N'28602', 35.712845, -81.264937, 2548, 200, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4008, N'Davis Regional Medical Center', 1, NULL, NULL, N'340144', NULL, NULL, 0, 136, NULL, N'7048730281', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'218 Old Mocksbville Rd Po Box 1823', N'Statesville', N'NC', N'37097', N'28687', 35.782636, -80.887296, 2590, 203, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4009, N'Carolinas Healthcare System Lincoln', 1, NULL, NULL, N'340145', NULL, NULL, 0, 110, NULL, N'9802122000', N'9082121001', 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'433 Mcalister Rd', N'Lincolnton', N'NC', N'37109', N'28092', 35.473745, -81.254525, 2559, 196, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4010, N'Nash General Hospital', 1, NULL, NULL, N'340147', NULL, NULL, 0, 332, NULL, N'2524438000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2460 Curtis Ellis Drive', N'Rocky Mount', N'NC', N'37127', N'27804', 35.973106, -77.848351, 2579, 201, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4011, N'Novant Health Park Hospital', 1, NULL, NULL, N'340148', NULL, NULL, 0, 136, NULL, N'3367180600', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1950 S Hawthorne Rd', N'Winston-Salem', N'NC', N'37067', N'27103', 36.07826, -80.295613, 2605, 203, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4012, N'Halifax Regional Medical Center Inc', 1, NULL, NULL, N'340151', NULL, NULL, 0, 206, NULL, N'2525358005', N'2525358466', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'250 Smith Church Rd', N'Roanoke Rapids', N'NC', N'37083', N'27870', 36.434308, -77.648654, 2577, 201, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4013, N'Duke Regional Hospital', 1, NULL, NULL, N'340155', NULL, NULL, 0, 391, NULL, N'9196201078', N'9196204921', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3643 N Roxboro Road', N'Durham', N'NC', N'37063', N'27704', 35.994033, -78.898619, 2532, 197, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4014, N'Cherokee Indian Hospital Authority', 1, NULL, NULL, N'340156', NULL, NULL, 0, 26, NULL, N'7044979163', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Caller Box C268', N'Cherokee', N'NC', N'37173', N'28719', 35.474266, -83.314874, 2606, 195, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4015, N'Novant Health Brunswick Medical Center', 1, NULL, NULL, N'340158', NULL, NULL, 0, 60, NULL, N'9107558121', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1 Medical Center Dr  Po Box 139', N'Supply', N'NC', N'37019', N'28462', 34.017672, -78.267499, 2591, 202, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4016, N'Person Memorial Hospital', 1, NULL, NULL, N'340159', NULL, NULL, 0, 50, NULL, N'3365992121', N'3365035765', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'615 Ridge Rd', N'Roxboro', N'NC', N'37145', N'27573', 36.40702, -78.985123, 2580, 197, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4017, N'Carolinas Med Ctr-University', 1, NULL, NULL, N'340166', NULL, NULL, 0, 130, NULL, N'7045486000', N'7045486236', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'8800 North Tyron Street', N'Charlotte', N'NC', N'37119', N'28262', 35.227087, -80.843127, 2525, 196, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4018, N'Wilmington Treatment Center', 1, NULL, NULL, N'340168', NULL, NULL, 0, 44, NULL, N'9197622727', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2520 Troy Drive', N'Wilmington', N'NC', N'37129', N'28401', 34.193267, -77.928697, 2602, 202, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4019, N'Presbyterian Hospital Matthews', 1, NULL, NULL, N'340171', NULL, NULL, 0, 102, NULL, N'7043846500', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1500 Matthews Twnshp Prkwy Box 3310', N'Matthews', N'NC', N'37119', N'28106', 35.116813, -80.72368, 2525, 196, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4020, N'Wakemed Cary Hospital', 1, NULL, NULL, N'340173', NULL, NULL, 0, 156, NULL, N'9193502550', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1900 Kildare Farm Road', N'Cary', N'NC', N'37183', N'27518', 35.788297, -78.781192, 2575, 201, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4021, N'Novant Health Huntersville Medical Center', 1, NULL, NULL, N'340183', NULL, NULL, 0, 75, NULL, N'7043164000', NULL, 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'10030 Gilead Road', N'Huntersville', N'NC', N'37119', N'28078', 35.406466, -80.860016, 2525, 196, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4022, N'Haywood Regional Medical Center', 1, NULL, NULL, N'340184', NULL, NULL, 0, 178, NULL, N'8284567311', NULL, 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'262 Leroy George Drive', N'Clyde', N'NC', N'37087', N'28721', 35.533438, -82.910691, 2527, 195, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4023, N'Vidant Beaufort Hospital', 1, NULL, NULL, N'340186', NULL, NULL, 0, 142, NULL, N'2529754100', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'628 E 12Th St', N'Washington', N'NC', N'37013', N'27889', 35.549504, -77.040124, 2601, 199, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4024, N'Davie Medical Center', 1, NULL, NULL, N'340187', NULL, NULL, 0, 81, NULL, N'3367518100', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'223 Hospital Street', N'Mocksville', N'NC', N'37059', N'27028', 35.899298, -80.571844, 2563, 203, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4025, N'Our Community Hospital', 1, NULL, NULL, N'341302', NULL, NULL, 0, 20, NULL, N'2528264144', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'921 Junior High Road', N'Scotland Neck', N'NC', N'37083', N'27874', 36.1296, -77.420247, 2579, 201, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4026, N'Firsthealth Montgomery Memorial Hosp', 1, NULL, NULL, N'341303', NULL, NULL, 0, 25, NULL, N'9105721301', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'520 Allen Street', N'Troy', N'NC', N'37123', N'27371', 35.364242, -79.891416, 2596, 198, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4027, N'Vidant Bertie  Hospital', 1, NULL, NULL, N'341304', NULL, NULL, 0, 15, NULL, N'2527946600', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1403 South Kings Street', N'Windsor', N'NC', N'37015', N'27983', 35.998493, -76.946064, 2604, 199, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4028, N'Swain County Hospital', 1, NULL, NULL, N'341305', NULL, NULL, 0, 48, NULL, N'8284882155', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'45 Plateau Street', N'Bryson City', N'NC', N'37173', N'28713', 35.434496, -83.444731, 2521, 195, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4029, N'Pender Memorial Hospital', 1, NULL, NULL, N'341307', NULL, NULL, 0, 25, NULL, N'9102595451', N'9102590711', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'507 E Fremont St', N'Burgaw', N'NC', N'37141', N'28425', 34.552111, -77.926098, 2522, 202, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4030, N'Yadkin Valley Community Hospital', 1, NULL, NULL, N'341308', NULL, NULL, 0, 22, NULL, N'3366792041', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'624 West Main St', N'Yadkinville', N'NC', N'37197', N'27055', 36.134509, -80.670313, 2605, 203, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4031, N'Chatham Hospital Inc', 1, NULL, NULL, N'341311', NULL, NULL, 0, 68, NULL, N'9196632113', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'475 Progress Blvd', N'Siler City', N'NC', N'37037', N'27344', 35.723473, -79.462243, 2585, 198, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4032, N'Washington County Hosp Inc', 1, NULL, NULL, N'341314', NULL, NULL, 0, 49, NULL, N'2527934135', N'2527931530', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'958 Us Hwy 64 East', N'Plymouth', N'NC', N'37187', N'27962', 35.862603, -76.729485, 2574, 199, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4033, N'Cape Fear Valley-Bladen County Hospital', 1, NULL, NULL, N'341315', NULL, NULL, 0, 35, NULL, N'9108625100', NULL, 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'501 South Poplar Street', N'Elizabethtown', N'NC', N'37017', N'28337', 34.622965, -78.608841, 2536, 202, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4034, N'Highlands Cashiers Hospital Inc', 1, NULL, NULL, N'341316', NULL, NULL, 0, 25, NULL, N'8285261200', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'190 Hospital Drive', N'Highlands', N'NC', N'37113', N'28741', 35.052591, -83.196817, 2550, 195, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4035, N'Pioneer Community Hospital Of Stokes', 1, NULL, NULL, N'341317', NULL, NULL, 0, 93, NULL, N'3365932831', N'3365935350', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1570 Nc 8 & 89 Hwy North', N'Danbury', N'NC', N'37169', N'27016', 36.409305, -80.205883, 2605, 203, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4036, N'Vidant Chowan Hospital', 1, NULL, NULL, N'341318', NULL, NULL, 0, 25, NULL, N'2524828451', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'211 Virginia Rd', N'Edenton', N'NC', N'37041', N'27932', 36.070088, -76.610987, 2534, 199, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4037, N'Transylvania Regional Hospital Inc', 1, NULL, NULL, N'341319', NULL, NULL, 0, 25, NULL, N'8288835302', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'90 Hospital Drive Po Box 1116', N'Brevard', N'NC', N'37175', N'28712', 35.233447, -82.734292, 2520, 195, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4038, N'Alleghany County Memorial Hospital', 1, NULL, NULL, N'341320', NULL, NULL, 0, 25, NULL, N'3363725511', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'617 Doctors Street', N'Sparta', N'NC', N'37005', N'28675', 36.509562, -81.109183, 2588, 203, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4039, N'St Lukes Hospital', 1, NULL, NULL, N'341322', NULL, NULL, 0, 35, NULL, N'8288943311', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'101 Hospital Drive', N'Columbus', N'NC', N'37149', N'28722', 35.24082, -82.212785, 2528, 245, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4040, N'Charles A Cannon Jr Memorial Hospital', 1, NULL, NULL, N'341323', NULL, NULL, 0, 40, NULL, N'8287377000', N'8287377491', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'434 Hospital Drive', N'Linville', N'NC', N'37011', N'28646', 36.06457, -81.887886, 2530, 195, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4041, N'The Outer Banks Hospital Inc', 1, NULL, NULL, N'341324', NULL, NULL, 0, 19, NULL, N'2524494500', N'2524494555', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4800 South Croatan Highway', N'Nags Head', N'NC', N'37055', N'27959', 35.911171, -75.600279, 2535, 285, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4042, N'Ashe Memorial Hospital', 1, NULL, NULL, N'341325', NULL, NULL, 0, 76, NULL, N'3362467101', NULL, 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'200 Hospital Ave', N'Jefferson', N'NC', N'37009', N'28640', 36.423605, -81.458649, 2552, 203, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4043, N'Angel Medical Center', 1, NULL, NULL, N'341326', NULL, NULL, 0, 25, NULL, N'8285248411', N'8283694492', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'120 Riverview St Po Box 1209', N'Franklin', N'NC', N'37113', N'28734', 35.182317, -83.381543, 2540, 195, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4044, N'J Arthur Dosher Memorial Hospital', 1, NULL, NULL, N'341327', NULL, NULL, 0, 25, NULL, N'9104573800', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'924 Howe St', N'Southport', N'NC', N'37019', N'28461', 33.921563, -78.020268, 2587, 202, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4045, N'Murphy Medical Center Inc', 1, NULL, NULL, N'341328', NULL, NULL, 0, 50, NULL, N'8288378161', N'8288357507', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3990 East Us Highway 64 Alt', N'Murphy', N'NC', N'37039', N'28906', 35.087584, -84.034631, 2569, 72, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4046, N'Blue Ridge Regional Hospital Inc', 1, NULL, NULL, N'341329', NULL, NULL, 0, 85, NULL, N'8287654201', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'125 Hospital Dr', N'Spruce Pine', N'NC', N'37121', N'28777', 35.910777, -82.063345, 2589, 195, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4047, N'Kindred Hospital Greensboro', 1, NULL, NULL, N'342012', NULL, NULL, 0, 101, NULL, N'3362712800', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2401 Southside Blvd', N'Greensboro', N'NC', N'37081', N'27406', 36.072636, -79.791975, 2543, 198, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4048, N'Lifecare Hospitals Of Nc', 1, NULL, NULL, N'342013', NULL, NULL, 0, 50, NULL, N'2524512300', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1031 Noell Lane', N'Rocky Mount', N'NC', N'37127', N'27804', 35.971338, -77.82239, 2579, 201, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4049, N'Highsmith Rainey Memorial Hospital', 1, NULL, NULL, N'342014', NULL, NULL, 0, 112, NULL, N'9106096700', NULL, 1, 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'150 Robeson Street 4Th Floor', N'Fayetteville', N'NC', N'37051', N'28301', 35.052993, -78.878706, 2539, 201, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4050, N'Carolinas Specialty Hospital 7Th Floor South', 1, NULL, NULL, N'342015', NULL, NULL, 0, 40, NULL, N'7043795117', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'10648 Park Rd', N'Charlotte', N'NC', N'37119', N'28210', 35.15812, -80.848499, 2525, 196, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4051, N'Select Specialty Hospital-Winston Salem', 1, NULL, NULL, N'342016', NULL, NULL, 0, 52, NULL, N'9012776970', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3333 Silas Creek Parkway 6Th Flr', N'Winston Salem', N'NC', N'37067', N'27103', 36.099817, -80.244144, 2605, 203, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4052, N'Ashville Specialty Hospital', 1, NULL, NULL, N'342017', NULL, NULL, 0, 34, NULL, N'8282131127', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'428 Biltmore Avenue 4Th Floor', N'Asheville', N'NC', N'37021', N'28802', 35.60095, -82.554016, 2515, 195, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4053, N'Select Specialty Hospital Durham Inc', 1, NULL, NULL, N'342018', NULL, NULL, 0, 30, NULL, N'9194709010', N'9194709020', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3643 North Roxboro Road 6Th Floor', N'Durham', N'NC', N'37063', N'27704', 35.994033, -78.898619, 2532, 197, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4054, N'Crawley Memorial Hospital', 1, NULL, NULL, N'342019', NULL, NULL, 0, 41, NULL, N'7044349466', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'706 West King Street 2Nd Floor', N'Kings Mountain', N'NC', N'37071', N'28086', 35.245134, -81.341194, 2554, 196, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4055, N'Select Specialty Hospital-Greensboro', 1, NULL, NULL, N'342020', NULL, NULL, 0, 30, NULL, N'3368327000', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1200 North Elm Street 2', N'Greensboro', N'NC', N'37081', N'27401', 36.072636, -79.791975, 2543, 198, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4056, N'Carepartners  Rehabilitation Hosp', 1, NULL, NULL, N'343025', NULL, NULL, 0, 80, NULL, N'8282742400', NULL, 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'68 Sweeten Creek Rd', N'Asheville', N'NC', N'37021', N'28813', 35.46903, -82.51611, 2515, 195, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4057, N'Carolinas Rehabilitation', 1, NULL, NULL, N'343026', NULL, NULL, 0, 133, NULL, N'7043554370', NULL, 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1100 Blythe Boulevard', N'Charlotte', N'NC', N'37119', N'28203', 35.20289, -80.837574, 2525, 196, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4058, N'Dorothea Dix Hospital', 1, NULL, NULL, N'344001', NULL, NULL, 0, 838, NULL, N'9197335324', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'820 South Boylan Ave', N'Raleigh', N'NC', N'37183', N'27603', 35.779871, -78.649111, 2575, 201, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4059, N'Central Regional Hospital', 1, NULL, NULL, N'344004', NULL, NULL, 0, 466, NULL, N'9197642000', N'9197647510', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'300 Veazy Rd', N'Butner', N'NC', N'37077', N'27509', 36.132089, -78.756671, 2532, 197, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4060, N'Old Vineyard Youth Services', 1, NULL, NULL, N'344007', NULL, NULL, 0, 104, NULL, N'3367943550', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3637 Old Vineyard Road', N'Winston Salem', N'NC', N'37067', N'27104', 36.078324, -80.31855, 2605, 203, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4061, N'Holly Hill Mental Health Services', 1, NULL, NULL, N'344014', NULL, NULL, 0, 168, NULL, N'9192507000', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3019 Falstaff Rd', N'Raleigh', N'NC', N'37183', N'27610', 35.782242, -78.584307, 2575, 201, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4062, N'Brynn Marr Hosp', 1, NULL, NULL, N'344016', NULL, NULL, 0, 88, NULL, N'9195771400', N'8667849687', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'192 Village Drive', N'Jacksonville', N'NC', N'37133', N'28540', 34.746855, -77.373045, 2551, 199, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4063, N'Julian F Keith Alcohol & Drug Abuse Tx', 1, NULL, NULL, N'344023', NULL, NULL, 0, 80, NULL, N'8286693402', N'8282576300', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'201 Tabernacle Road', N'Black Mountain', N'NC', N'37021', N'28711', 35.609215, -82.346474, 2515, 195, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4064, N'Walter B Jones Alcohol & Drug Abuse', 1, NULL, NULL, N'344024', NULL, NULL, 0, 80, NULL, N'2528303426', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2577 West Fifth Street', N'Greenville', N'NC', N'37147', N'27834', 35.612661, -77.366354, 2544, 199, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4065, N'Broughton Hospital', 1, NULL, NULL, N'344025', NULL, NULL, 0, 737, NULL, N'8284332111', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1000 S Sterling Street', N'Morganton', N'NC', N'37023', N'28655', 35.737511, -81.677916, 2567, 196, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4066, N'Cherry Hospital', 1, NULL, NULL, N'344026', NULL, NULL, 0, 251, NULL, N'9197313203', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'201 Stevens Mills Rd', N'Goldsboro', N'NC', N'37191', N'27530', 35.384884, -77.992765, 2542, 201, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4067, N'Rj Blackley Alcohol And Drug Abuse Treatment Ctr', 1, NULL, NULL, N'344027', NULL, NULL, 0, 80, NULL, N'9195757240', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Bldg 29 30 Barrett Bldg 100 H Street', N'Butner', N'NC', N'37077', N'27509', 36.132089, -78.756671, 2532, 197, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4068, N'Strategic Behavorial Center-Garner', 1, NULL, NULL, N'344028', NULL, NULL, 0, 20, NULL, N'9198004400', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3200 Waterfield Drive', N'Garner', N'NC', N'37101', N'27529', 35.680377, -78.55892, 2575, 201, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4069, N'Good Hope Hospital Inc', 1, NULL, NULL, N'344029', NULL, NULL, 0, 16, NULL, N'9102304011', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'410 Denim Drive', N'Erwin', N'NC', N'37085', N'28339', 35.327065, -78.66833, 2538, 201, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4070, N'Strategic Behavioral Center-Leland', 1, NULL, NULL, N'344030', NULL, NULL, 0, 20, NULL, N'9013712500', N'6013712508', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2050 Mercantile Drive', N'Leland', N'NC', N'37019', N'28451', 34.256281, -78.044714, 2602, 202, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4071, N'University Of North Carolina Hospitals', 1, NULL, NULL, N'349800', NULL, NULL, 0, 0, NULL, N'9199661645', N'9199668481', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'101 Manning Drive', N'Chapel Hill', N'NC', N'37135', N'27514', 35.904812, -79.049704, 2524, 197, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4072, N'Pitt County Memorial Hospital', 1, NULL, NULL, N'349801', NULL, NULL, 0, 0, NULL, N'2528474398', N'2528478147', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'2100 Stantonsburg Road Po Box 6028', N'Greenville', N'NC', N'37147', N'27835', 35.612661, -77.366354, 2544, 199, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4073, N'Carolinas Medical Center', 1, NULL, NULL, N'349802', NULL, NULL, 0, 0, NULL, N'7043556649', N'7043555010', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'Transplant Center Po Box 32861', N'Charlotte', N'NC', N'37119', N'28232', 35.227087, -80.843127, 2525, 196, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4074, N'Wake Forest University Baptist Medical Center', 1, NULL, NULL, N'349803', NULL, NULL, 0, 0, NULL, N'3367135623', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'Medical Center Boulevard', N'Winston Salem', N'NC', N'37067', N'27157', 36.089827, -80.271364, 2605, 203, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4075, N'Duke University Hosptial', 1, NULL, NULL, N'349804', NULL, NULL, 0, 0, NULL, N'9196845926', N'9199849039', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'Duke University Medical Center Po Box 3876', N'Durham', N'NC', N'37063', N'27710', 35.994033, -78.898619, 2532, 197, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4076, N'St Alexius Medical Center', 1, NULL, NULL, N'350002', NULL, NULL, 0, 287, NULL, N'7015307000', N'7015307612', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'900 E Broadway', N'Bismarck', N'ND', N'38015', N'58501', 46.808327, -100.783739, 2608, 204, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4077, N'Trinity Hospitals', 1, NULL, NULL, N'350006', NULL, NULL, 0, 416, NULL, N'7018575000', N'7018575117', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'407 3Rd St Se', N'Minot', N'ND', N'38101', N'58701', 48.231825, -101.288324, 2631, 207, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4078, N'Sanford Medical Center Fargo', 1, NULL, NULL, N'350011', NULL, NULL, 0, 582, NULL, N'7012342000', N'7012346979', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'801 Broadway North', N'Fargo', N'ND', N'38017', N'58122', 46.877229, -96.789821, 2619, 205, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4079, N'Sanford Medical Center Bismarck', 1, NULL, NULL, N'350015', NULL, NULL, 0, 223, NULL, N'7013236000', N'7013235221', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'300 N 7Th St', N'Bismarck', N'ND', N'38015', N'58506', 46.816641, -100.781232, 2608, 204, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4080, N'Altru Hospital', 1, NULL, NULL, N'350019', NULL, NULL, 0, 257, NULL, N'7017805000', N'7017801631', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1200 S Columbia Rd', N'Grand Forks', N'ND', N'38035', N'58201', 47.910195, -97.066576, 2620, 206, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4081, N'P H S Indian Hosp At Belcourt-Quentin N Burdick', 1, NULL, NULL, N'350063', NULL, NULL, 0, 46, NULL, N'7014776111', N'7014778410', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Po Box 160', N'Belcourt', N'ND', N'38079', N'58316', 48.839177, -99.744874, 2635, 206, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4082, N'Standing Rock Indian Health Service Hospital', 1, NULL, NULL, N'350064', NULL, NULL, 0, 12, NULL, N'7018543831', N'7018547567', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'10 North River Road', N'Fort Yates', N'ND', N'38085', N'58538', 46.086941, -100.630127, 2608, 204, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4083, N'Essentia Health-Fargo', 1, NULL, NULL, N'350070', NULL, NULL, 0, 105, NULL, N'7013648000', N'7013644528', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3000 32Nd Ave South', N'Fargo', N'ND', N'38017', N'58104', 46.877229, -96.789821, 2619, 205, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4084, N'Tioga Medical Center', 1, NULL, NULL, N'351300', NULL, NULL, 0, 25, NULL, N'7016643305', N'7016642240', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'810 N Welo St', N'Tioga', N'ND', N'38105', N'58852', 48.397244, -102.938238, 2638, 207, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4085, N'Mountrail County Medical Center', 1, NULL, NULL, N'351301', NULL, NULL, 0, 11, NULL, N'7016282424', N'7016283106', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'615 6Th St Se', N'Stanley', N'ND', N'38061', N'58784', 48.3115, -102.380971, 2637, 207, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4086, N'Mckenzie County Healthcare Systems', 1, NULL, NULL, N'351302', NULL, NULL, 0, 24, NULL, N'7018423000', N'7018426248', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'516 North Main St', N'Watford City', N'ND', N'38053', N'58854', 47.802241, -103.283247, 2641, 204, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4087, N'Garrison Memorial Hospital', 1, NULL, NULL, N'351303', NULL, NULL, 0, 22, NULL, N'7014632275', N'7014636569', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'407 3Rd Ave Se', N'Garrison', N'ND', N'38055', N'58540', 47.648359, -101.412114, 2631, 207, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4088, N'Community Memorial Hospital', 1, NULL, NULL, N'351304', NULL, NULL, 0, 25, NULL, N'7014482331', N'7014482441', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'220 5Th Ave W', N'Turtle Lake', N'ND', N'38055', N'58575', 47.519998, -100.890143, 2639, 204, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4089, N'Kenmare Community Hospital', 1, NULL, NULL, N'351305', NULL, NULL, 0, 25, NULL, N'7013854296', N'7013854341', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Po Box 697', N'Kenmare', N'ND', N'38101', N'58746', 48.674748, -102.082664, 2631, 207, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4090, N'Cooperstown Medical Center', 1, NULL, NULL, N'351306', NULL, NULL, 0, 18, NULL, N'7017972221', N'7017972421', 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'1200 Roberts Ave Ne', N'Cooperstown', N'ND', N'38039', N'58425', 47.44561, -98.119232, 2614, 205, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4091, N'St Andrews Health Center - Cah', 1, NULL, NULL, N'351307', NULL, NULL, 0, 25, NULL, N'7012289300', N'7012289384', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'316 Ohmer Street', N'Bottineau', N'ND', N'38009', N'58318', 48.828928, -100.449267, 2609, 207, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4092, N'Nelson County Health System', 1, NULL, NULL, N'351308', NULL, NULL, 0, 19, NULL, N'7013224328', N'7013222250', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'200 N Main St', N'Mcville', N'ND', N'38063', N'58254', 47.766618, -98.177306, 2630, 206, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4093, N'Sanford Mayville', 1, NULL, NULL, N'351309', NULL, NULL, 0, 25, NULL, N'7017863800', N'7017882145', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'42 6Th Avenue Se', N'Mayville', N'ND', N'38097', N'58257', 47.500804, -97.317544, 2629, 205, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4094, N'Sakakawea Medical Center - Cah', 1, NULL, NULL, N'351310', NULL, NULL, 0, 25, NULL, N'7017482225', N'7017485757', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'510 8Th Avenue Ne', N'Hazen', N'ND', N'38057', N'58545', 47.29831, -101.611409, 2622, 204, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4095, N'Lisbon Area Health Services', 1, NULL, NULL, N'351311', NULL, NULL, 0, 25, NULL, N'7016835241', N'7016834345', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'905 Main St', N'Lisbon', N'ND', N'38073', N'58054', 46.436867, -97.681305, 2628, 205, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4096, N'Northwood Deaconess Health Center', 1, NULL, NULL, N'351312', NULL, NULL, 0, 12, NULL, N'7015876060', N'7015876479', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Po Box 190', N'Northwood', N'ND', N'38035', N'58267', 47.734155, -97.566754, 2632, 206, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4097, N'Southwest Healthcare Services', 1, NULL, NULL, N'351313', NULL, NULL, 0, 23, NULL, N'7015235265', N'7015237104', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'14 6Th Ave Sw', N'Bowman', N'ND', N'38011', N'58623', 46.181432, -103.403847, 2610, 204, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4098, N'Jacobson Memorial Hospital Care Center', 1, NULL, NULL, N'351314', NULL, NULL, 0, 25, NULL, N'7015842792', N'7015843348', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'601 East St N', N'Elgin', N'ND', N'38037', N'58533', 46.406605, -101.842041, 2618, 204, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4099, N'Oakes Community Hospital', 1, NULL, NULL, N'351315', NULL, NULL, 0, 20, NULL, N'7017423291', N'7017423639', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1200 N 7Th St', N'Oakes', N'ND', N'38021', N'58474', 46.138579, -98.090379, 2633, 205, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4100, N'Presentation Medical Center', 1, NULL, NULL, N'351316', NULL, NULL, 0, 25, NULL, N'7014773161', N'7014775564', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'213 Second Ave Ne', N'Rolla', N'ND', N'38079', N'58367', 48.857784, -99.617922, 2635, 206, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4101, N'Carrington Health Center', 1, NULL, NULL, N'351318', NULL, NULL, 0, 25, NULL, N'7016523141', N'7016522884', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Po Box 461', N'Carrington', N'ND', N'38031', N'58421', 47.44972, -99.126223, 2612, 205, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4102, N'Pembina County Memorial Hospital', 1, NULL, NULL, N'351319', NULL, NULL, 0, 24, NULL, N'7012658461', N'7012656269', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Box 380', N'Cavalier', N'ND', N'38067', N'58220', 48.793881, -97.62231, 2613, 206, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4103, N'Unity Medical Center', 1, NULL, NULL, N'351320', NULL, NULL, 0, 14, NULL, N'7013521620', N'7013521671', 1, 1, 1, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'164 W 13Th Street', N'Grafton', N'ND', N'38099', N'58237', 48.411407, -97.41559, 2620, 206, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4104, N'Wishek Community Hospital', 1, NULL, NULL, N'351321', NULL, NULL, 0, 24, NULL, N'7014522326', N'7014522392', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1007 4Th Ave S', N'Wishek', N'ND', N'38051', N'58495', 46.255113, -99.556992, 2643, 204, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4105, N'Ashley Medical Center', 1, NULL, NULL, N'351322', NULL, NULL, 0, 20, NULL, N'7012883433', N'7012883938', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'612 Center Avenue N', N'Ashley', N'ND', N'38051', N'58413', 46.041149, -99.371813, 2607, 204, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4106, N'Cavalier County Memorial Hospital', 1, NULL, NULL, N'351323', NULL, NULL, 0, 20, NULL, N'7012566100', N'7012562170', 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'909 2Nd St', N'Langdon', N'ND', N'38019', N'58249', 48.761359, -98.366569, 2626, 206, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4107, N'Mercy Hospital Of Valley City', 1, NULL, NULL, N'351324', NULL, NULL, 0, 25, NULL, N'7018456400', N'7018456413', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'570 Chautauqua Blvd', N'Valley City', N'ND', N'38003', N'58072', 46.928464, -97.994856, 2640, 205, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4108, N'St Luke''s Hospital', 1, NULL, NULL, N'351325', NULL, NULL, 0, 15, NULL, N'7019656384', N'7019654258', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'702 1St St Sw', N'Crosby', N'ND', N'38023', N'58730', 48.906782, -103.298334, 2615, 207, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4109, N'First Care Health Center', 1, NULL, NULL, N'351326', NULL, NULL, 0, 14, NULL, N'7012847500', N'7012844576', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'115 Vivian St', N'Park River', N'ND', N'38099', N'58270', 48.399142, -97.745893, 2634, 206, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4110, N'St Aloisius Medical Center', 1, NULL, NULL, N'351327', NULL, NULL, 0, 25, NULL, N'7013244651', N'7013244651', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'325 E Brewster St', N'Harvey', N'ND', N'38103', N'58341', 47.767666, -99.924883, 2621, 204, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4111, N'Linton Hospital - Cah', 1, NULL, NULL, N'351328', NULL, NULL, 0, 14, NULL, N'7012544511', N'7012540112', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'518 North Broadway', N'Linton', N'ND', N'38029', N'58552', 46.271591, -100.232952, 2627, 204, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4112, N'Sanford Hillsboro', 1, NULL, NULL, N'351329', NULL, NULL, 0, 16, NULL, N'7016363200', N'7016363206', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'12 Third Street South East', N'Hillsboro', N'ND', N'38097', N'58045', 47.403868, -97.062031, 2624, 205, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4113, N'West River Regional Medical Center-Cah', 1, NULL, NULL, N'351330', NULL, NULL, 0, 25, NULL, N'7015674561', N'7015676368', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1000 Highway 12', N'Hettinger', N'ND', N'38001', N'58639', 46.001395, -102.636824, 2623, 204, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4114, N'Towner County Medical Center', 1, NULL, NULL, N'351331', NULL, NULL, 0, 20, NULL, N'7019684411', N'7019682574', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Hwy 281 N', N'Cando', N'ND', N'38095', N'58324', 48.486668, -99.209859, 2611, 206, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4115, N'Heart Of America Medical Center', 1, NULL, NULL, N'351332', NULL, NULL, 0, 25, NULL, N'7017765261', N'7017765448', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'800 S Main Ave', N'Rugby', N'ND', N'38069', N'58368', 48.364246, -99.996239, 2636, 207, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4116, N'The Mercy Hospital Of Devils Lake', 1, NULL, NULL, N'351333', NULL, NULL, 0, 25, NULL, N'7016622131', N'7016629651', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1031 7Th St Ne', N'Devils Lake', N'ND', N'38071', N'58301', 48.114861, -98.849639, 2616, 205, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4117, N'Mercy Medical Center', 1, NULL, NULL, N'351334', NULL, NULL, 0, 25, NULL, N'7017747400', N'7017747479', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1301 15Th Ave W', N'Williston', N'ND', N'38105', N'58801', 48.155202, -103.645524, 2642, 207, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4118, N'Jamestown Regional Medical Center', 1, NULL, NULL, N'351335', NULL, NULL, 0, 25, NULL, N'7012521050', N'7019523267', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2422 20Th St Sw', N'Jamestown', N'ND', N'38093', N'58401', 46.888795, -98.71163, 2625, 205, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4119, N'St Joseph''s Hospital & Health Center', 1, NULL, NULL, N'351336', NULL, NULL, 0, 25, NULL, N'7014564000', N'7014564800', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2500 Fairway Street', N'Dickinson', N'ND', N'38089', N'58601', 46.887149, -102.819476, 2617, 204, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4120, N'Vibra Hospital Of Fargo', 1, NULL, NULL, N'352004', NULL, NULL, 0, 31, NULL, N'7012419099', N'7012419114', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1720 University Drive South', N'Fargo', N'ND', N'38017', N'58103', 46.877229, -96.789821, 2619, 205, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4121, N'Vibra Hospital Of Central Dakotas', 1, NULL, NULL, N'352005', NULL, NULL, 0, 41, NULL, N'7016672000', N'7016635944', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1000 18Th Street Nw', N'Mandan', N'ND', N'38059', N'58554', 46.841214, -100.907498, 2608, 204, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4122, N'North Dakota State Hospital', 1, NULL, NULL, N'354003', NULL, NULL, 0, 142, NULL, N'7012533650', N'7012533999', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2605 Circle Drive', N'Jamestown', N'ND', N'38093', N'58401', 46.886844, -98.687901, 2625, 205, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4123, N'Prairie St Johns', 1, NULL, NULL, N'354004', NULL, NULL, 0, 94, NULL, N'7014767200', N'7014767261', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'510 4Th Street South', N'Fargo', N'ND', N'38017', N'58103', 46.869301, -96.785553, 2619, 205, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4124, N'Richard P Stadter Psychiatric Center', 1, NULL, NULL, N'354005', NULL, NULL, 0, 70, NULL, N'7017722500', N'7017382531', 1, 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1451 44Th Avenue S', N'Grand Forks', N'ND', N'38035', N'58208', 47.878343, -97.048135, 2620, 206, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4125, N'Sanford Bismarck Transplant Center', 1, NULL, NULL, N'359810', NULL, NULL, 0, 0, NULL, N'7013232828', N'7013232801', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'300 N 7Th St', N'Bismarck', N'ND', N'38015', N'58501', 46.79915, -100.78175, 2608, 204, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4126, N'Sanford Transplant Center', 1, NULL, NULL, N'359811', NULL, NULL, 0, 0, NULL, N'7012342411', N'7012342808', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'736 Broadway', N'Fargo', N'ND', N'38017', N'58122', 46.883695, -96.787879, 2619, 205, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4127, N'Mercy Hospital Anderson', 1, NULL, NULL, N'360001', NULL, NULL, 0, 226, NULL, N'5136244006', N'5136243299', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7500 State Road', N'Cincinnati', N'OH', N'39061', N'45255', 39.101454, -84.51246, 2665, 210, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4128, N'Samaritan Regional Health System', 1, NULL, NULL, N'360002', NULL, NULL, 0, 123, NULL, N'4192890491', N'4192077929', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1025 Center St', N'Ashland', N'OH', N'39005', N'44805', 40.859513, -82.31071, 2646, 212, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4129, N'University Of Cincinnati Medical Center Llc', 1, NULL, NULL, N'360003', NULL, NULL, 0, 771, NULL, N'5135841000', N'5135840526', 1, 1, 1, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'234 Goodman Street', N'Cincinnati', N'OH', N'39061', N'45219', 39.136894, -84.503934, 2665, 210, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4130, N'Riverside Methodist Hospital', 1, NULL, NULL, N'360006', NULL, NULL, 0, 1000, NULL, N'6145665000', N'6145666760', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3535 Olentangy River Rd', N'Columbus', N'OH', N'39049', N'43214', 40.031322, -83.031026, 2669, 212, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4131, N'Southern Ohio Medical Center', 1, NULL, NULL, N'360008', NULL, NULL, 0, 237, NULL, N'7403565000', N'7403532981', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1805 27Th Street', N'Portsmouth', N'OH', N'39145', N'45662', 38.753453, -82.979395, 2731, 212, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4132, N'Lima Memorial Health System', 1, NULL, NULL, N'360009', NULL, NULL, 0, 285, NULL, N'4199984731', N'4199984571', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1001 Bellefontaine Avenue', N'Lima', N'OH', N'39003', N'45804', 40.73724, -84.090236, 2698, 213, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4133, N'Union Hospital', 1, NULL, NULL, N'360010', NULL, NULL, 0, 220, NULL, N'3303433311', N'3303640951', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'659 Boulevard', N'Dover', N'OH', N'39157', N'44622', 40.521338, -81.474147, 2676, 209, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4134, N'Marion General Hospital', 1, NULL, NULL, N'360011', NULL, NULL, 0, 389, NULL, N'7403838400', N'7403838706', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1000 Mckinley Park Drive', N'Marion', N'OH', N'39101', N'43302', 40.573034, -83.128762, 2706, 212, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4135, N'Mount Carmel St Ann''s', 1, NULL, NULL, N'360012', NULL, NULL, 0, 161, NULL, N'6148984000', N'6145464535', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'500 South Cleveland Avenue', N'Westerville', N'OH', N'39049', N'43081', 40.126174, -82.92907, 2669, 212, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4136, N'Wilson Memorial Hospital', 1, NULL, NULL, N'360013', NULL, NULL, 0, 128, NULL, N'9374985418', N'9374975675', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'915 West Michigan Street', N'Sidney', N'OH', N'39149', N'45365', 40.284216, -84.155499, 2736, 213, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4137, N'Ohiohealth O''bleness Hospital', 1, NULL, NULL, N'360014', NULL, NULL, 0, 114, NULL, N'7405929233', N'7405929466', 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'55 Hospital Drive', N'Athens', N'OH', N'39009', N'45701', 39.328328, -82.115296, 2648, 212, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4138, N'Jewish Hospital Llc', 1, NULL, NULL, N'360016', NULL, NULL, 0, 658, NULL, N'5136863003', N'5136863004', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4777 East Galbraith Road', N'Cincinnati', N'OH', N'39061', N'45236', 39.211986, -84.466594, 2665, 210, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4139, N'Grant Medical Center', 1, NULL, NULL, N'360017', NULL, NULL, 0, 645, NULL, N'6145669978', N'6145668043', 1, 1, 1, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'111 South Grant Avenue', N'Columbus', N'OH', N'39049', N'43215', 39.966704, -82.991706, 2669, 212, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4140, N'Summa Barberton Hospital', 1, NULL, NULL, N'360019', NULL, NULL, 0, 270, NULL, N'3306153000', N'3306153033', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'155 5Th Street N E', N'Barberton', N'OH', N'39153', N'44203', 41.012833, -81.605122, 2649, 208, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4141, N'Summa Health Systems Hospitals', 1, NULL, NULL, N'360020', NULL, NULL, 0, 1093, NULL, N'3303753000', N'3303753050', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'525 East Market Street', N'Akron', N'OH', N'39153', N'44309', 41.078916, -81.50122, 2644, 208, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4142, N'Firelands Regional Medical Center', 1, NULL, NULL, N'360025', NULL, NULL, 0, 400, NULL, N'4195577400', N'4195576824', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1111 Hayes Avenue', N'Sandusky', N'OH', N'39043', N'44870', 41.34199, -83.125029, 2734, 211, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4143, N'Greene Memorial Hospital', 1, NULL, NULL, N'360026', NULL, NULL, 0, 235, NULL, N'9373522000', N'9373523230', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1141 North Monroe Drive', N'Xenia', N'OH', N'39057', N'45385', 39.700884, -83.928794, 2757, 215, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4144, N'Akron General Medical Center', 1, NULL, NULL, N'360027', NULL, NULL, 0, 511, NULL, N'3303446000', N'3303764835', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'400 Wabash Avenue', N'Akron', N'OH', N'39153', N'44307', 41.083064, -81.518485, 2644, 208, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4145, N'Wood County Hospital', 1, NULL, NULL, N'360029', NULL, NULL, 0, 168, NULL, N'4193548900', N'4193548957', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'950 West Wooster Street', N'Bowling Green', N'OH', N'39173', N'43402', 41.375484, -83.666265, 2657, 216, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4146, N'Grand Lake Health System', 1, NULL, NULL, N'360032', NULL, NULL, 0, 113, NULL, N'4193943335', N'4193948485', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'200 Saint Clair Street', N'Saint Marys', N'OH', N'39011', N'45885', 40.54227, -84.389396, 2738, 213, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4147, N'Mount Carmel West', 1, NULL, NULL, N'360035', NULL, NULL, 0, 937, NULL, N'6142345000', N'6142345105', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'793 West State Street', N'Columbus', N'OH', N'39049', N'43222', 39.96226, -83.000706, 2669, 212, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4148, N'Wooster Community Hospital', 1, NULL, NULL, N'360036', NULL, NULL, 0, 207, NULL, N'3302638100', N'3302638497', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1761 Beall Avenue', N'Wooster', N'OH', N'39169', N'44691', 40.820521, -81.934133, 2756, 209, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4149, N'St Vincent Charity Medical Center', 1, NULL, NULL, N'360037', NULL, NULL, 0, 458, NULL, N'2168616200', N'2163632796', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2351 East 22Nd Street', N'Cleveland', N'OH', N'39035', N'44115', 41.496126, -81.674031, 2667, 211, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4150, N'Genesis Healthcare System', 1, NULL, NULL, N'360039', NULL, NULL, 0, 767, NULL, N'7404545000', N'7404544914', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2951 Maple Avenue', N'Zanesville', N'OH', N'39119', N'43701', 39.975868, -82.014632, 2759, 212, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4151, N'Knox Community Hospital', 1, NULL, NULL, N'360040', NULL, NULL, 0, 166, NULL, N'7403939000', N'7403993130', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1330 Coshocton Road', N'Mount Vernon', N'OH', N'39083', N'43050', 40.393396, -82.485718, 2716, 212, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4152, N'Parma Community General Hospital', 1, NULL, NULL, N'360041', NULL, NULL, 0, 309, NULL, N'4407433000', N'4407434386', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7007 Powers Boulevard', N'Parma', N'OH', N'39035', N'44129', 41.382739, -81.728556, 2726, 211, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4153, N'Wayne Hospital', 1, NULL, NULL, N'360044', NULL, NULL, 0, 92, NULL, N'9375475722', N'9375475784', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'835 Sweitzer Street', N'Greenville', N'OH', N'39037', N'45331', 40.08801, -84.634955, 2689, 213, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4154, N'Mccullough-Hyde Memorial Hospital', 1, NULL, NULL, N'360046', NULL, NULL, 0, 94, NULL, N'5135232111', N'5135245665', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'110 North Poplar Street', N'Oxford', N'OH', N'39017', N'45056', 39.512663, -84.741622, 2724, 210, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4155, N'Pike County Hospital', 1, NULL, NULL, N'360047', NULL, NULL, 0, 63, NULL, N'6149472186', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'Dawn Lane', N'Waverly', N'OH', N'39131', N'45690', 39.116843, -83.00594, 2751, 212, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4156, N'University Of Toledo Medical Center', 1, NULL, NULL, N'360048', NULL, NULL, 0, 319, NULL, N'4193833407', N'4193833850', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3000 Arlington Avenue', N'Toledo', N'OH', N'39095', N'43699', 41.621362, -83.615671, 2742, 216, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4157, N'Miami Valley Hospital', 1, NULL, NULL, N'360051', NULL, NULL, 0, 848, NULL, N'9372088000', N'9372083000', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'One Wyoming Street', N'Dayton', N'OH', N'39113', N'45409', 39.758948, -84.191607, 2672, 213, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4158, N'Good Samaritan Hospital', 1, NULL, NULL, N'360052', NULL, NULL, 0, 577, NULL, N'9372782612', N'9374997813', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2222 Philadelphia Drive', N'Dayton', N'OH', N'39113', N'45406', 39.787843, -84.234847, 2672, 213, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4159, N'Holzer Medical Center', 1, NULL, NULL, N'360054', NULL, NULL, 0, 287, NULL, N'7404465000', N'7404465522', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'100 Jackson Pike', N'Gallipolis', N'OH', N'39053', N'45631', 38.809803, -82.202369, 2684, 212, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4160, N'Trumbull Memorial Hospital', 1, NULL, NULL, N'360055', NULL, NULL, 0, 346, NULL, N'3308419011', N'3308419281', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1350 East Market Street', N'Warren', N'OH', N'39155', N'44482', 41.236362, -80.799572, 2748, 217, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4161, N'Mercy Hospital Fairfield', 1, NULL, NULL, N'360056', NULL, NULL, 0, 271, NULL, N'5138707197', N'5138707065', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3000 Mack Road', N'Fairfield', N'OH', N'39017', N'45014', 39.310935, -84.519535, 2690, 210, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4162, N'Mercer County Joint Township Community Hospital', 1, NULL, NULL, N'360058', NULL, NULL, 0, 88, NULL, N'4196784843', N'4196783271', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'800 West Main Street', N'Coldwater', N'OH', N'39107', N'45828', 40.47985, -84.638403, 2668, 213, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4163, N'Metrohealth System', 1, NULL, NULL, N'360059', NULL, NULL, 0, 702, NULL, N'2167787089', N'2167787181', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2500 Metrohealth Drive', N'Cleveland', N'OH', N'39035', N'44109', 41.462327, -81.699076, 2667, 211, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4164, N'St Elizabeth Health Center', 1, NULL, NULL, N'360064', NULL, NULL, 0, 628, NULL, N'3307467211', N'3304807974', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1044 Belmont Avenue', N'Youngstown', N'OH', N'39099', N'44501', 41.114112, -80.655807, 2758, 217, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4165, N'Fisher-Titus Hospital', 1, NULL, NULL, N'360065', NULL, NULL, 0, 112, NULL, N'4196688101', N'4916636036', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'272 Benedict Avenue', N'Norwalk', N'OH', N'39077', N'44857', 41.226863, -82.60285, 2720, 211, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4166, N'St Rita''s Medical Center', 1, NULL, NULL, N'360066', NULL, NULL, 0, 424, NULL, N'4192273361', N'4192269750', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'730 West Market Street', N'Lima', N'OH', N'39003', N'45801', 40.73995, -84.10681, 2698, 213, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4167, N'Toledo Hospital The', 1, NULL, NULL, N'360068', NULL, NULL, 0, 794, NULL, N'4192917463', N'4194796000', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2142 North Cove Boulevard', N'Toledo', N'OH', N'39095', N'43606', 41.671063, -83.594625, 2742, 216, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4168, N'Mercy Medical Center', 1, NULL, NULL, N'360070', NULL, NULL, 0, 520, NULL, N'3304891001', N'3304891312', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1320 Mercy Drive Nw', N'Canton', N'OH', N'39151', N'44708', 40.811819, -81.396977, 2662, 209, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4169, N'Van Wert County Hospital', 1, NULL, NULL, N'360071', NULL, NULL, 0, 120, NULL, N'4192388627', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1250 S Washington Street', N'Van Wert', N'OH', N'39161', N'45891', 40.85896, -84.584635, 2746, 95, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4170, N'Fairfield Medical Center', 1, NULL, NULL, N'360072', NULL, NULL, 0, 250, NULL, N'7406878009', N'7406878115', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'401 North Ewing Street', N'Lancaster', N'OH', N'39045', N'43130', 39.718747, -82.576387, 2697, 212, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4171, N'Flower Hospital', 1, NULL, NULL, N'360074', NULL, NULL, 0, 287, NULL, N'4198241444', N'4198822342', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5200 Harroun Road', N'Sylvania', N'OH', N'39095', N'43560', 41.709163, -83.694304, 2740, 216, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4172, N'Uhhs Richmond Heights Hospital', 1, NULL, NULL, N'360075', NULL, NULL, 0, 213, NULL, N'4405856170', N'4405856142', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'27100 Chardon Road', N'Richmond Heights', N'OH', N'39035', N'44143', 41.581906, -81.488524, 2667, 211, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4173, N'Atrium Medical Center', 1, NULL, NULL, N'360076', NULL, NULL, 0, 328, NULL, N'5134205102', N'5134205657', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'One Medical Center Drive', N'Franklin', N'OH', N'39165', N'45005', 39.558947, -84.304107, 2713, 215, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4174, N'Fairview Hospital', 1, NULL, NULL, N'360077', NULL, NULL, 0, 468, NULL, N'2164767000', N'2164767017', 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'18101 Lorain Avenue', N'Cleveland', N'OH', N'39035', N'44111', 41.450327, -81.824025, 2667, 211, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4175, N'Robinson Memorial Hospital', 1, NULL, NULL, N'360078', NULL, NULL, 0, 302, NULL, N'3302972300', N'3302972949', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6847 N Chestnut', N'Ravenna', N'OH', N'39133', N'44266', 41.157557, -81.242047, 2732, 208, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4176, N'Kettering Medical Center', 1, NULL, NULL, N'360079', NULL, NULL, 0, 549, NULL, N'9372984331', N'9373958384', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3535 Southern Boulevard', N'Kettering', N'OH', N'39113', N'45429', 39.698481, -84.190587, 2695, 215, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4177, N'East Ohio Regional Hospital', 1, NULL, NULL, N'360080', NULL, NULL, 0, 161, NULL, N'7406334151', N'7406334512', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'90 North Fourth Street', N'Martins Ferry', N'OH', N'39013', N'43935', 40.095906, -80.724526, 2707, 234, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4178, N'Mercy St Charles Hospital', 1, NULL, NULL, N'360081', NULL, NULL, 0, 342, NULL, N'4196967200', N'4196967328', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2600 Navarre Avenue', N'Oregon', N'OH', N'39095', N'43616', 41.636571, -83.48644, 2722, 216, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4179, N'Euclid Hospital', 1, NULL, NULL, N'360082', NULL, NULL, 0, 301, NULL, N'2165319000', N'2166927425', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'18901 Lake Shore Boulevard', N'Euclid', N'OH', N'39035', N'44119', 41.596938, -81.547249, 2679, 211, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4180, N'Aultman Hospital', 1, NULL, NULL, N'360084', NULL, NULL, 0, 808, NULL, N'3304529911', N'3304554799', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2600 Sixth Street Sw', N'Canton', N'OH', N'39151', N'44710', 40.798952, -81.378444, 2662, 209, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4181, N'Ohio State University Hospitals', 1, NULL, NULL, N'360085', NULL, NULL, 0, 971, NULL, N'6142939700', N'6142933535', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'410 West 10Th Avenue', N'Columbus', N'OH', N'39049', N'43210', 39.96226, -83.000706, 2669, 212, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4182, N'Springfield Regional Medical Center', 1, NULL, NULL, N'360086', NULL, NULL, 0, 254, NULL, N'9375231000', N'9375235950', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'100 Medical Center Drive', N'Springfield', N'OH', N'39023', N'45504', 39.924227, -83.808817, 2737, 213, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4183, N'Lutheran Hospital', 1, NULL, NULL, N'360087', NULL, NULL, 0, 203, NULL, N'2166964300', N'2165237029', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1730 West 25Th Street', N'Cleveland', N'OH', N'39035', N'44113', 41.487424, -81.706091, 2667, 211, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4184, N'Mercy Tiffin Hospital', 1, NULL, NULL, N'360089', NULL, NULL, 0, 120, NULL, N'4194557000', N'4194557066', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'45 St Lawrence Drive', N'Tiffin', N'OH', N'39147', N'44883', 41.10512, -83.217023, 2741, 216, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4185, N'St Luke''s Hospital', 1, NULL, NULL, N'360090', NULL, NULL, 0, 215, NULL, N'4198935900', N'4198918081', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5901 Monclova Road', N'Maumee', N'OH', N'39095', N'43537', 41.558655, -83.681944, 2710, 216, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4186, N'Medina Hospital', 1, NULL, NULL, N'360091', NULL, NULL, 0, 157, NULL, N'3307251000', N'3307214926', 1, 1, 0, 1, 0, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1000 East Washington Street', N'Medina', N'OH', N'39103', N'44256', 41.139013, -81.841204, 2712, 211, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4187, N'Memorial Hospital', 1, NULL, NULL, N'360092', NULL, NULL, 0, 97, NULL, N'9375782289', N'9375782820', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'500 London Avenue', N'Marysville', N'OH', N'39159', N'43040', 40.228697, -83.369666, 2708, 212, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4188, N'Blanchard Valley Hospital', 1, NULL, NULL, N'360095', NULL, NULL, 0, 239, NULL, N'4194234500', N'4194235399', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1900 South Main Street', N'Findlay', N'OH', N'39063', N'45840', 41.040397, -83.650218, 2680, 216, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4189, N'East Liverpool City Hospital', 1, NULL, NULL, N'360096', NULL, NULL, 0, 144, NULL, N'3303857200', N'3303862074', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'425 West 5Th Street', N'East Liverpool', N'OH', N'39029', N'43920', 40.621567, -80.586318, 2677, 234, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4190, N'Lake Health', 1, NULL, NULL, N'360098', NULL, NULL, 0, 399, NULL, N'4409539600', N'4403542400', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7590 Auburn Road', N'Concord', N'OH', N'39085', N'44077', 40.143119, -82.637945, 2725, 211, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4191, N'Bellevue Hospital', 1, NULL, NULL, N'360107', NULL, NULL, 0, 70, NULL, N'4194834040', N'4194839718', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1400 West Main Street', N'Bellevue', N'OH', N'39143', N'44811', 41.284997, -82.881937, 2655, 211, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4192, N'Coshocton County Memorial Hospital', 1, NULL, NULL, N'360109', NULL, NULL, 0, 165, NULL, N'7406226411', N'7406234095', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1460 Orange Street', N'Coshocton', N'OH', N'39031', N'43812', 40.270544, -81.848147, 2671, 212, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4193, N'Mercy St Vincent Medical Center', 1, NULL, NULL, N'360112', NULL, NULL, 0, 568, NULL, N'4192513232', N'4192513812', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2213 Cherry Street', N'Toledo', N'OH', N'39095', N'43608', 41.668332, -83.541448, 2742, 216, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4194, N'Medcentral Health System Mansfield Hospital', 1, NULL, NULL, N'360118', NULL, NULL, 0, 358, NULL, N'4195268000', N'4195217960', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'335 Glessner Avenue', N'Mansfield', N'OH', N'39139', N'44903', 40.752672, -82.528789, 2704, 212, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4195, N'Community Hospitals And Wellness Centers', 1, NULL, NULL, N'360121', NULL, NULL, 0, 70, NULL, N'4196361131', N'4196363100', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'433 West High Street', N'Bryan', N'OH', N'39171', N'43506', 41.474524, -84.557786, 2658, 95, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4196, N'St John Medical Center', 1, NULL, NULL, N'360123', NULL, NULL, 0, 240, NULL, N'4408358000', N'4408275015', 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'29000 Center Ridge Road', N'Westlake', N'OH', N'39035', N'44145', 41.435248, -81.941399, 2753, 211, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4197, N'Ashtabula County Medical Center', 1, NULL, NULL, N'360125', NULL, NULL, 0, 249, NULL, N'4409972262', N'4409976644', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2420 Lake Avenue', N'Ashtabula', N'OH', N'39007', N'44004', 41.887791, -80.804714, 2647, 211, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4198, N'Alliance Community Hospital', 1, NULL, NULL, N'360131', NULL, NULL, 0, 207, NULL, N'3305967527', N'3305967555', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'200 East State Street', N'Alliance', N'OH', N'39151', N'44601', 40.901783, -81.10518, 2645, 209, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4199, N'Fort Hamilton Hughes Memorial Hospital', 1, NULL, NULL, N'360132', NULL, NULL, 0, 310, NULL, N'5138672000', N'5138672119', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'630 Eaton Avenue', N'Hamilton', N'OH', N'39017', N'45013', 39.415084, -84.573687, 2690, 210, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4200, N'Grandview Hospital & Medical Center', 1, NULL, NULL, N'360133', NULL, NULL, 0, 427, NULL, N'9377233312', N'9374610020', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'405 Grand Avenue', N'Dayton', N'OH', N'39113', N'45405', 39.781299, -84.172968, 2672, 213, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4201, N'Good Samaritan Hospital', 1, NULL, NULL, N'360134', NULL, NULL, 0, 672, NULL, N'5138622601', N'5138621190', 1, 1, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'375 Dixmyth Avenue', N'Cincinnati', N'OH', N'39061', N'45220', 39.140079, -84.523413, 2665, 210, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4202, N'University Hospitals Case Medical Center', 1, NULL, NULL, N'360137', NULL, NULL, 0, 1032, NULL, N'2168441000', N'2168442446', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'11100 Euclid Avenue', N'Cleveland', N'OH', N'39035', N'44106', 41.506647, -81.608082, 2667, 211, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4203, N'Northside Medical Center', 1, NULL, NULL, N'360141', NULL, NULL, 0, 398, NULL, N'3308841000', N'3308841020', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'500 Gypsy Lane', N'Youngstown', N'OH', N'39099', N'44501', 41.133709, -80.659269, 2758, 217, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4204, N'Highland District Hospital', 1, NULL, NULL, N'360142', NULL, NULL, 0, 79, NULL, N'9373936100', N'9373936278', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1275 North High Street', N'Hillsboro', N'OH', N'39071', N'45133', 39.22496, -83.609779, 2692, 210, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4205, N'Marymount Hospital', 1, NULL, NULL, N'360143', NULL, NULL, 0, 349, NULL, N'2165810500', N'2165878212', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'12300 Mccracken Road', N'Garfield Heights', N'OH', N'39035', N'44125', 41.422331, -81.597143, 2685, 211, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4206, N'South Pointe Hospital', 1, NULL, NULL, N'360144', NULL, NULL, 0, 180, NULL, N'2164916000', N'2164917260', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'20000 Harvard Road', N'Warrensville Heights', N'OH', N'39035', N'44122', 41.440345, -81.531381, 2667, 211, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4207, N'University Hospitals - Elyria Medical Center', 1, NULL, NULL, N'360145', NULL, NULL, 0, 400, NULL, N'4403297500', N'4403297643', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'630 East River Street', N'Elyria', N'OH', N'39093', N'44035', 41.369302, -82.09684, 2678, 214, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4208, N'Marietta Memorial Hospital', 1, NULL, NULL, N'360147', NULL, NULL, 0, 204, NULL, N'7403741400', N'7403765073', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'401 Matthew Street', N'Marietta', N'OH', N'39167', N'45750', 39.431382, -81.464902, 2705, 212, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4209, N'Pomerene Hospital', 1, NULL, NULL, N'360148', NULL, NULL, 0, 55, NULL, N'3306741015', N'3306743019', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'981 Wooster Road', N'Millersburg', N'OH', N'39075', N'44654', 40.565056, -81.920988, 2714, 209, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4210, N'Summa Western Reserve Hospital', 1, NULL, NULL, N'360150', NULL, NULL, 0, 258, NULL, N'3309717000', N'3309717277', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1900 23Rd Street', N'Cuyahoga Falls', N'OH', N'39153', N'44223', 41.133082, -81.509947, 2644, 208, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4211, N'Affinity Medical Center', 1, NULL, NULL, N'360151', NULL, NULL, 0, 216, NULL, N'3308376863', N'3308376871', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'875 Eighth Street Ne', N'Massillon', N'OH', N'39151', N'44646', 40.796724, -81.521509, 2709, 209, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4212, N'Doctors Hospital', 1, NULL, NULL, N'360152', NULL, NULL, 0, 262, NULL, N'6145441000', N'6145441844', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5100 West  Broad Street', N'Columbus', N'OH', N'39049', N'43228', 39.951088, -83.154778, 2669, 212, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4213, N'Belmont Community Hospital', 1, NULL, NULL, N'360153', NULL, NULL, 0, 129, NULL, N'7406711200', N'7406711210', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4697 Harrison Street', N'Bellaire', N'OH', N'39013', N'43906', 40.029457, -80.741095, 2653, 234, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4214, N'Southwest General Health Center', 1, NULL, NULL, N'360155', NULL, NULL, 0, 346, NULL, N'4408168000', N'4408168063', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'18697 Bagley Road', N'Middleburg Heights', N'OH', N'39035', N'44130', 41.371801, -81.81908, 2726, 211, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4215, N'Memorial Hospital', 1, NULL, NULL, N'360156', NULL, NULL, 0, 179, NULL, N'4193346617', N'4193325875', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'715 South Taft Avenue', N'Fremont', N'OH', N'39143', N'43420', 41.33954, -83.135129, 2682, 216, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4216, N'Adena Regional Medical Center', 1, NULL, NULL, N'360159', NULL, NULL, 0, 261, NULL, N'7407797500', N'7407797476', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'272 Hospital Road', N'Chillicothe', N'OH', N'39141', N'45601', 39.33312, -82.982402, 2664, 212, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4217, N'St Joseph Health Center', 1, NULL, NULL, N'360161', NULL, NULL, 0, 476, NULL, N'3308414000', N'3308414019', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'667 Eastland Ave Se', N'Warren', N'OH', N'39155', N'44481', 41.231597, -80.778238, 2748, 217, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4218, N'Christ Hospital', 1, NULL, NULL, N'360163', NULL, NULL, 0, 621, NULL, N'5135852000', N'5135852793', 1, 1, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2139 Auburn Avenue', N'Cincinnati', N'OH', N'39061', N'45219', 39.121025, -84.508619, 2665, 210, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4219, N'Berger Hospital', 1, NULL, NULL, N'360170', NULL, NULL, 0, 94, NULL, N'7404208585', N'7404208608', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'600 North Pickaway Street', N'Circleville', N'OH', N'39129', N'43113', 39.609226, -82.938129, 2666, 212, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4220, N'Mercy Regional Medical Center', 1, NULL, NULL, N'360172', NULL, NULL, 0, 317, NULL, N'4409604000', N'4409604630', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3700 Kolbe Road', N'Lorain', N'OH', N'39093', N'44053', 41.435222, -82.23529, 2702, 214, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4221, N'Upper Valley Medical Center', 1, NULL, NULL, N'360174', NULL, NULL, 0, 178, NULL, N'9374407853', N'9373395310', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3130 North County Road 25A', N'Troy', N'OH', N'39109', N'45373', 40.039498, -84.203277, 2743, 213, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4222, N'Clinton Memorial Hospital', 1, NULL, NULL, N'360175', NULL, NULL, 0, 143, NULL, N'9373826611', N'9373826633', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'610 West Main Street', N'Wilmington', N'OH', N'39027', N'45177', 39.445451, -83.837005, 2755, 210, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4223, N'Bethesda North', 1, NULL, NULL, N'360179', NULL, NULL, 0, 465, NULL, N'5138651241', N'5138651441', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'10500 Montgomery Road', N'Cincinnati', N'OH', N'39061', N'45242', 39.144553, -84.469438, 2665, 210, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4224, N'Cleveland Clinic', 1, NULL, NULL, N'360180', NULL, NULL, 0, 1267, NULL, N'2164442200', N'2166363333', 1, 1, 0, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'9500 Euclid Avenue', N'Cleveland', N'OH', N'39035', N'44195', 41.502571, -81.62085, 2667, 211, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4225, N'Salem Regional Medical Center', 1, NULL, NULL, N'360185', NULL, NULL, 0, 252, NULL, N'3303321551', N'3303327691', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1995 East State Street', N'Salem', N'OH', N'39029', N'44460', 40.900837, -80.832199, 2733, 217, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4226, N'Madison County Hospital Inc', 1, NULL, NULL, N'360189', NULL, NULL, 0, 107, NULL, N'7408457000', N'7408457001', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'210 North Main Street', N'London', N'OH', N'39097', N'43140', 39.892088, -83.455136, 2701, 212, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4227, N'Uh Geauga Medical Center', 1, NULL, NULL, N'360192', NULL, NULL, 0, 126, NULL, N'4402696000', N'4402867219', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'13207 Ravenna Rd', N'Chardon', N'OH', N'39055', N'44024', 41.615633, -81.221717, 2663, 211, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4228, N'Summa Wadsworth-Rittman Hospital', 1, NULL, NULL, N'360195', NULL, NULL, 0, 96, NULL, N'3303311000', N'3303311942', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'195 Wadsworth Road', N'Wadsworth', N'OH', N'39103', N'44281', 41.027123, -81.754492, 2747, 208, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4229, N'Mary Rutan Hospital', 1, NULL, NULL, N'360197', NULL, NULL, 0, 115, NULL, N'9375924015', N'9375927007', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'205 Palmer Avenue', N'Bellefontaine', N'OH', N'39091', N'43311', 40.368428, -83.757992, 2654, 212, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4230, N'Southeastern Ohio Regional Medical Center', 1, NULL, NULL, N'360203', NULL, NULL, 0, 221, NULL, N'7404398111', N'7404398935', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1341 North Clark Street', N'Cambridge', N'OH', N'39059', N'43725', 40.031183, -81.588456, 2661, 212, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4231, N'Grady Memorial Hospital', 1, NULL, NULL, N'360210', NULL, NULL, 0, 130, NULL, N'7403685145', N'7403685340', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'561 West Central Avenue', N'Delaware', N'OH', N'39041', N'43015', 40.305646, -83.089698, 2674, 212, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4232, N'Trinity Medical Ctr East &Trinity Medical Ctr West', 1, NULL, NULL, N'360211', NULL, NULL, 0, 519, NULL, N'7402837000', N'7402837104', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'380 Summit Avenue', N'Steubenville', N'OH', N'39081', N'43952', 40.356129, -80.625016, 2739, 234, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4233, N'Lakewood Hospital', 1, NULL, NULL, N'360212', NULL, NULL, 0, 224, NULL, N'2165214200', N'2165217161', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'14519 Detroit Avenue', N'Lakewood', N'OH', N'39035', N'44107', 41.48525, -81.795969, 2696, 211, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4234, N'Licking Memorial Hospital', 1, NULL, NULL, N'360218', NULL, NULL, 0, 227, NULL, N'7403484000', N'7403484106', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1320 West Main Street', N'Newark', N'OH', N'39089', N'43055', 40.046548, -82.452288, 2719, 212, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4235, N'Hillcrest Hospital', 1, NULL, NULL, N'360230', NULL, NULL, 0, 280, NULL, N'4403124500', N'4403126407', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6780 Mayfield Road', N'Mayfield Heights', N'OH', N'39035', N'44124', 41.520072, -81.458488, 2711, 211, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4236, N'Mercy Health - West Hospital', 1, NULL, NULL, N'360234', NULL, NULL, 0, 297, NULL, N'5132155000', N'5132150962', 1, 1, 0, 0, 0, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3300 Mercy Health Blvd', N'Cincinnati', N'OH', N'39061', N'45211', 39.101454, -84.51246, 2665, 210, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4237, N'Mercy Hospital Clermont', 1, NULL, NULL, N'360236', NULL, NULL, 0, 157, NULL, N'5137328278', N'5137328537', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3000 Hospital Drive', N'Batavia', N'OH', N'39025', N'45103', 39.080193, -84.146464, 2651, 210, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4238, N'Sycamore Medical Center', 1, NULL, NULL, N'360239', NULL, NULL, 0, 183, NULL, N'9373848776', N'9373848724', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4000 Miamisburg-Centerville Road', N'Miamisburg', N'OH', N'39113', N'45342', 39.640134, -84.234441, 2695, 215, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4239, N'Edwin Shaw Rehab Institute', 1, NULL, NULL, N'360241', NULL, NULL, 0, 160, NULL, N'3304360910', N'3304360925', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'330 Broadway East', N'Cuyahoga Falls', N'OH', N'39153', N'44221', 41.134821, -81.484809, 2644, 208, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4240, N'James Cancer Hospital & Solove Research Institute', 1, NULL, NULL, N'360242', NULL, NULL, 0, 172, NULL, N'6142933121', N'6142933132', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'300 West Tenth Avenue', N'Columbus', N'OH', N'39049', N'43210', 39.99442, -83.016279, 2669, 212, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4241, N'Glenbeigh', 1, NULL, NULL, N'360245', NULL, NULL, 0, 114, NULL, N'4405633400', N'4405639661', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2863 State Route 45', N'Rock Creek', N'OH', N'39007', N'44084', 41.659492, -80.860779, 2686, 211, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4242, N'Woods At Parksidethe', 1, NULL, NULL, N'360247', NULL, NULL, 0, 50, NULL, N'6144712552', N'6143373644', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'349 Olde Ridenour Road', N'Columbus', N'OH', N'39049', N'43230', 39.96226, -83.000706, 2669, 212, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4243, N'Bay Park Community Hospital', 1, NULL, NULL, N'360259', NULL, NULL, 0, 92, NULL, N'4196907700', N'4196976713', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2801 Bay Park Drive', N'Oregon', N'OH', N'39095', N'43616', 41.621735, -83.48379, 2722, 216, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4244, N'Three Gables Surgery Center', 1, NULL, NULL, N'360261', NULL, NULL, 0, 25, NULL, N'7408869911', N'7408869922', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5897 County Road 107', N'Proctorville', N'OH', N'39087', N'45669', 38.437028, -82.377096, 3587, 296, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4245, N'Mercy St Anne Hospital', 1, NULL, NULL, N'360262', NULL, NULL, 0, 25, NULL, N'4194072663', N'4194072400', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3404 Sylvania Avenue', N'Toledo', N'OH', N'39095', N'43623', 41.678675, -83.512728, 2742, 216, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4246, N'Institute For Orthopaedic Surgery', 1, NULL, NULL, N'360263', NULL, NULL, 0, 3, NULL, N'4192247586', N'4192249769', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'801 Medical Drive Suite B', N'Lima', N'OH', N'39003', N'45804', 40.742551, -84.105226, 2698, 213, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4247, N'Mount Carmel New Albany Surgical Hospital', 1, NULL, NULL, N'360266', NULL, NULL, 0, 42, NULL, N'6147756600', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7333 Smith''s Mill Road', N'New Albany', N'OH', N'39049', N'43054', 40.083803, -82.769639, 2669, 212, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4248, N'Mercy Hospital Of Defiance', 1, NULL, NULL, N'360270', NULL, NULL, 0, 23, NULL, N'4197828444', N'4197853998', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1404 East Second Street', N'Defiance', N'OH', N'39039', N'43512', 41.284493, -84.35578, 2673, 95, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4249, N'Medical Center At Elizabeth Place', 1, NULL, NULL, N'360274', NULL, NULL, 0, 27, NULL, N'9378531053', N'9378531055', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'One Elizabeth Place', N'Dayton', N'OH', N'39113', N'45417', 39.758948, -84.191607, 2672, 213, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4250, N'St Elizabeth Boardman Health Center', 1, NULL, NULL, N'360276', NULL, NULL, 0, 65, NULL, N'3307292929', N'3307291563', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'8401 Market Street', N'Boardman', N'OH', N'39099', N'44512', 41.024226, -80.662853, 2758, 217, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4251, N'Medical Center Of Newark Llc', 1, NULL, NULL, N'360347', NULL, NULL, 0, 33, NULL, N'7405227800', N'7405224812', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2000 Tamarack Road', N'Newark', N'OH', N'39089', N'43055', 40.038769, -82.463785, 2719, 212, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4252, N'Dublin Methodist Hospital', 1, NULL, NULL, N'360348', NULL, NULL, 0, 107, NULL, N'6145448000', N'6145448008', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7500 Hospital Avenue', N'Dublin', N'OH', N'39049', N'43016', 40.099229, -83.114077, 2669, 212, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4253, N'Crystal Clinic Orthopaedic Center', 1, NULL, NULL, N'360351', NULL, NULL, 0, 94, NULL, N'3306684040', N'3306669423', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'444 North Main Street', N'Akron', N'OH', N'39153', N'44310', 41.099466, -81.511164, 2644, 208, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4254, N'Surgical Hospital At Southwoods', 1, NULL, NULL, N'360352', NULL, NULL, 0, 36, NULL, N'3307581954', N'3307583254', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7630 Southern Blvd', N'Youngstown', N'OH', N'39099', N'44512', 41.015847, -80.653553, 2758, 217, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4255, N'West Chester Hospital Llc', 1, NULL, NULL, N'360354', NULL, NULL, 0, 162, NULL, N'5132983000', N'5132987726', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7700 University Drive', N'West Chester', N'OH', N'39017', N'45069', 39.330336, -84.408275, 2665, 210, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4256, N'Ohio Valley Medical Center Llc', 1, NULL, NULL, N'360355', NULL, NULL, 0, 24, NULL, N'9375213900', N'9375213910', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'100 West Main Street', N'Springfield', N'OH', N'39023', N'45502', 39.926217, -83.846589, 2737, 213, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4257, N'Diley Ridge Medical Center', 1, NULL, NULL, N'360358', NULL, NULL, 0, 10, NULL, N'6148387910', N'6145464086', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7911 Diley Road', N'Canal Winchester', N'OH', N'39045', N'43110', 39.842822, -82.805646, 2669, 212, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4258, N'University Hospitals Ahuja Medical Center', 1, NULL, NULL, N'360359', NULL, NULL, 0, 72, NULL, N'2167678793', N'2167678778', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3999 Richmond Road', N'Beachwood', N'OH', N'39035', N'44122', 41.451385, -81.497814, 2667, 211, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4259, N'Soin Medical Center Indu & Raj Soin Medical Center', 1, NULL, NULL, N'360360', NULL, NULL, 0, 95, NULL, N'9377024000', N'9377024011', 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3535 Pentagon Park Blvd', N'Beaver Creek', N'OH', N'39057', N'45431', 40.225357, -82.688139, 2672, 213, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4260, N'Kings Daughters Medical Center Ohio', 1, NULL, NULL, N'360361', NULL, NULL, 0, 10, NULL, N'7409914000', NULL, 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1901 Argonne Road', N'Portsmouth', N'OH', N'39145', N'45662', 38.74707, -82.992982, 2731, 212, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4261, N'Trihealth Evendale Hospital', 1, NULL, NULL, N'360362', NULL, NULL, 0, 29, NULL, N'5134542222', N'5134542500', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3155 Glendale Milford Road', N'Cincinnati', N'OH', N'39061', N'45241', 39.101454, -84.51246, 2665, 210, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4262, N'Select Specialty Hospital Youngstown (Boardman)', 1, NULL, NULL, N'360363', NULL, NULL, 0, 24, NULL, N'3307291750', N'3307291750', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'8401 Market Street 7 South', N'Boardman', N'OH', N'39099', N'44512', 41.024226, -80.662853, 2758, 217, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4263, N'Paulding County Hospital', 1, NULL, NULL, N'361300', NULL, NULL, 0, 25, NULL, N'4193994080', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1035 West Wayne St.', N'Paulding', N'OH', N'39125', N'45879', 41.135277, -84.587347, 2727, 95, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4264, N'Community Memorial Hospital', 1, NULL, NULL, N'361301', NULL, NULL, 0, 25, NULL, N'4195426692', N'4195426902', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'208 N Columbus St', N'Hicksville', N'OH', N'39039', N'43526', 41.293106, -84.761903, 2691, 95, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4265, N'Trinity Hospital Twin City', 1, NULL, NULL, N'361302', NULL, NULL, 0, 25, NULL, N'7409222800', N'7409226945', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'819 North First Street', N'Dennison', N'OH', N'39157', N'44621', 40.393399, -81.333721, 2675, 209, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4266, N'Lodi Community Hospital', 1, NULL, NULL, N'361303', NULL, NULL, 0, 25, NULL, N'3309481222', N'3339485545', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'225 Elyria Street', N'Lodi', N'OH', N'39103', N'44254', 41.035267, -82.01322, 2699, 211, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4267, N'Greenfield Area Medical Center', 1, NULL, NULL, N'361304', NULL, NULL, 0, 25, NULL, N'9379819400', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'550 Mirabeau Street', N'Greenfield', N'OH', N'39071', N'45123', 39.349357, -83.387458, 2688, 212, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4268, N'Doctors Hospital Of Nelsonville', 1, NULL, NULL, N'361305', NULL, NULL, 0, 25, NULL, N'7407537300', N'7407531556', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1950 Mount St Marys Drive', N'Nelsonville', N'OH', N'39009', N'45764', 39.463188, -82.243184, 2718, 212, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4269, N'Mercy Allen Hospital', 1, NULL, NULL, N'361306', NULL, NULL, 0, 25, NULL, N'4407751211', N'4407759147', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'200 West Lorain Street', N'Oberlin', N'OH', N'39093', N'44074', 41.294316, -82.226438, 2721, 211, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4270, N'Uhhs Memorial Hospital Of Geneva', 1, NULL, NULL, N'361307', NULL, NULL, 0, 25, NULL, N'4404661141', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'870 West Main Street', N'Geneva', N'OH', N'39007', N'44041', 41.800893, -80.960099, 2686, 211, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4271, N'University Hospitals Conneaut Medical Center', 1, NULL, NULL, N'361308', NULL, NULL, 0, 25, NULL, N'4405931131', N'4405935050', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'158 West Main Road', N'Conneaut', N'OH', N'39007', N'44030', 41.947555, -80.554241, 2670, 229, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4272, N'Henry County Hospital Inc', 1, NULL, NULL, N'361309', NULL, NULL, 0, 25, NULL, N'4195924015', N'4195913869', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1600 East Riverview Avenue', N'Napoleon', N'OH', N'39069', N'43545', 41.392273, -84.125224, 2717, 216, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4273, N'Mercy Willard Hospital', 1, NULL, NULL, N'361310', NULL, NULL, 0, 15, NULL, N'4199645000', N'4199359506', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1100 Neal Zick Road', N'Willard', N'OH', N'39077', N'44890', 41.053113, -82.726296, 2754, 212, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4274, N'Harrison Community Hospital', 1, NULL, NULL, N'361311', NULL, NULL, 0, 25, NULL, N'7409424631', N'7409422749', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'951 East Market Street', N'Cadiz', N'OH', N'39067', N'43907', 40.256962, -80.978275, 2660, 234, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4275, N'Mercy Memorial Hospital', 1, NULL, NULL, N'361312', NULL, NULL, 0, 25, NULL, N'9376535231', N'9374846105', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'904 Scioto Street', N'Urbana', N'OH', N'39021', N'43078', 40.106558, -83.729913, 2745, 213, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4276, N'Morrow County Hospital', 1, NULL, NULL, N'361313', NULL, NULL, 0, 25, NULL, N'4199465015', N'4199493100', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'651 West Marion Road', N'Mount Gilead', N'OH', N'39117', N'43338', 40.549227, -82.827401, 2715, 212, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4277, N'H B Magruder Memorial Hospital', 1, NULL, NULL, N'361314', NULL, NULL, 0, 15, NULL, N'4197343131', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'615 Fulton St', N'Port Clinton', N'OH', N'39123', N'43452', 41.504749, -82.933672, 2730, 216, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4278, N'Hardin Memorial Hospital', 1, NULL, NULL, N'361315', NULL, NULL, 0, 25, NULL, N'4196730761', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'921 East Franklin Street', N'Kenton', N'OH', N'39065', N'43326', 40.646667, -83.595884, 2694, 212, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4279, N'Bucyrus Community Hospital', 1, NULL, NULL, N'361316', NULL, NULL, 0, 15, NULL, N'4195624677', N'4195625598', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'629 North Sandusky Avenue', N'Bucyrus', N'OH', N'39033', N'44820', 40.814083, -82.975774, 2659, 212, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4280, N'Fostoria Community Hospital', 1, NULL, NULL, N'361318', NULL, NULL, 0, 15, NULL, N'4194357734', N'4194366603', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'501 Van Buren Street', N'Fostoria', N'OH', N'39147', N'44830', 41.163127, -83.425551, 2681, 216, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4281, N'Selby General Hospital', 1, NULL, NULL, N'361319', NULL, NULL, 0, 25, NULL, N'7405682000', N'7405682089', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1106 Colegate Drive', N'Marietta', N'OH', N'39167', N'45750', 39.43902, -81.444601, 2705, 212, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4282, N'Holzer Medical Center Jackson', 1, NULL, NULL, N'361320', NULL, NULL, 0, 25, NULL, N'7403958500', N'7403958502', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'500 Burlington Road', N'Jackson', N'OH', N'39079', N'45640', 39.030357, -82.637988, 2684, 212, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4283, N'Barnesville Hospital Association Inc', 1, NULL, NULL, N'361321', NULL, NULL, 0, 25, NULL, N'7404255101', N'7404259213', 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'639 West Main Street', N'Barnesville', N'OH', N'39013', N'43713', 39.992374, -81.18936, 2650, 212, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4284, N'Bluffton Hospital', 1, NULL, NULL, N'361322', NULL, NULL, 0, 25, NULL, N'4193589010', N'4193581532', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'139 Garau Street', N'Bluffton', N'OH', N'39003', N'45817', 40.887501, -83.897353, 2656, 213, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4285, N'Aultman Orrville Hospital', 1, NULL, NULL, N'361323', NULL, NULL, 0, 25, NULL, N'3306823010', N'3306832130', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'832 South Main Street', N'Orrville', N'OH', N'39169', N'44667', 40.832022, -81.764456, 2723, 209, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4286, N'Medcentral Health System Shelby Hospital', 1, NULL, NULL, N'361324', NULL, NULL, 0, 25, NULL, N'4193425015', N'4193421701', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'199 West Main Street', N'Shelby', N'OH', N'39139', N'44875', 40.881313, -82.67355, 2735, 212, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4287, N'Galion Community Hospital', 1, NULL, NULL, N'361325', NULL, NULL, 0, 35, NULL, N'4194684841', N'4194682381', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'269 Portland Way South', N'Galion', N'OH', N'39033', N'44833', 40.731269, -82.803148, 2683, 212, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4288, N'Adams County Regional Medical Center', 1, NULL, NULL, N'361326', NULL, NULL, 0, 25, NULL, N'9373863400', N'9373863019', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'230 Medical Center Drive', N'Seaman', N'OH', N'39001', N'45679', 38.942014, -83.572418, 2651, 210, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4289, N'Community Hospitals And Wellness Centers', 1, NULL, NULL, N'361327', NULL, NULL, 0, 35, NULL, N'4194853154', N'4194853833', 1, 1, 1, 0, 0, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'909 East Snyder Avenue', N'Montpelier', N'OH', N'39171', N'43543', 41.584495, -84.605508, 2658, 95, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4290, N'Defiance Regional Medical Center', 1, NULL, NULL, N'361328', NULL, NULL, 0, 35, NULL, N'4197836955', N'4197836904', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1200 Ralston Avenue', N'Defiance', N'OH', N'39039', N'43512', 41.29992, -84.374523, 2673, 95, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4291, N'Wyandot Memorial Hospital', 1, NULL, NULL, N'361329', NULL, NULL, 0, 25, NULL, N'4192944991', N'4192942233', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'885 North Sandusky Avenue', N'Upper Sandusky', N'OH', N'39175', N'43351', 40.839717, -83.28083, 2744, 212, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4292, N'Hocking Valley Community Hospital', 1, NULL, NULL, N'361330', NULL, NULL, 0, 25, NULL, N'7403808000', N'7403857458', 1, 1, 0, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'601 State Route 664N', N'Logan', N'OH', N'39073', N'43138', 39.539871, -82.408489, 2700, 212, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4293, N'Fayette County Memorial Hospital', 1, NULL, NULL, N'361331', NULL, NULL, 0, 25, NULL, N'7403331210', N'7403332998', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1430 Columbus Avenue', N'Washington Ch', N'OH', N'39047', N'43160', 40.225357, -82.688139, 2749, 212, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4294, N'Highland District Hospital', 1, NULL, NULL, N'361332', NULL, NULL, 0, 35, NULL, N'9373936100', N'9373936278', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1275 North High Street', N'Hillsboro', N'OH', N'39071', N'45133', 39.22496, -83.609779, 2692, 210, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4295, N'Fulton County Health Center', 1, NULL, NULL, N'361333', NULL, NULL, 0, 35, NULL, N'4193352015', N'4193302602', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'725 South Shoop Avenue', N'Wauseon', N'OH', N'39051', N'43567', 41.538864, -84.134175, 2750, 216, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4296, N'Adena Pike Medical Center', 1, NULL, NULL, N'361334', NULL, NULL, 0, 25, NULL, N'7409472186', N'7409476538', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'100 Dawn Lane', N'Waverly', N'OH', N'39131', N'45690', 39.117615, -83.006314, 2751, 212, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4297, N'Glenmont', 1, NULL, NULL, N'361991', NULL, NULL, 0, 37, NULL, N'6148760084', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'4599 Avery Road', N'Hilliard', N'OH', N'39049', N'43026', 40.04119, -83.15696, 2669, 212, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4298, N'Drake Center Inc', 1, NULL, NULL, N'362004', NULL, NULL, 0, 108, NULL, N'5134182500', N'5134182557', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'151 West Galbraith Road', N'Cincinnati', N'OH', N'39061', N'45216', 39.212871, -84.475489, 2665, 210, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4299, N'Elmwood Healthcare Center At The Springs', 1, NULL, NULL, N'362007', NULL, NULL, 0, 36, NULL, N'4196392626', N'4196396225', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'401 North Broadway Street', N'Green Springs', N'OH', N'39147', N'44836', 41.261423, -83.052096, 2682, 216, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4300, N'Heather Hill Care Communities', 1, NULL, NULL, N'362014', NULL, NULL, 0, 56, NULL, N'4402854040', N'4402850946', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'12340 Bass Lake Road', N'Chardon', N'OH', N'39055', N'44024', 41.582466, -81.20334, 2663, 211, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4301, N'Grace Hospital', 1, NULL, NULL, N'362015', NULL, NULL, 0, 104, NULL, N'2164563891', N'2164568981', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2307 West 14Th Street', N'Cleveland', N'OH', N'39035', N'44113', 41.4805, -81.691246, 2667, 211, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4302, N'Select Specialty Hospital-Northeast Ohio Inc', 1, NULL, NULL, N'362016', NULL, NULL, 0, 61, NULL, N'3304898198', N'3304898199', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1320 Mercy Drive 6Th Floor', N'Canton', N'OH', N'39151', N'44708', 40.798952, -81.378444, 2662, 209, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4303, N'Select Specialty Hospital-Cincinnati Inc', 1, NULL, NULL, N'362019', NULL, NULL, 0, 36, NULL, N'5138624444', N'5138624437', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'375 Dixmyth Ave 15Th Floor', N'Cincinnati', N'OH', N'39061', N'45220', 39.101454, -84.51246, 2665, 210, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4304, N'Kindred Hospital Lima', 1, NULL, NULL, N'362020', NULL, NULL, 0, 12, NULL, N'4192241888', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'730 W Market St', N'Lima', N'OH', N'39003', N'45801', 40.73995, -84.10681, 2698, 213, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4305, N'Kindred Hospital Central Ohio', 1, NULL, NULL, N'362021', NULL, NULL, 0, 33, NULL, NULL, N'4195260929', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'335 Glessner Avenue 5Th Floor', N'Mansfield', N'OH', N'39139', N'44903', 40.75839, -82.515447, 2704, 212, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4306, N'Select Specialty Hospital-Columbus Inc', 1, NULL, NULL, N'362022', NULL, NULL, 0, 186, NULL, N'6144589000', N'6144589003', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1087 Dennison Avenue 2Nd Floor', N'Columbus', N'OH', N'39049', N'43201', 39.96226, -83.000706, 2669, 212, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4307, N'Vibra Hospital Of Mahoning Valley', 1, NULL, NULL, N'362023', NULL, NULL, 0, 45, NULL, N'3307265021', N'3307265053', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'8049 South Avenue', N'Boardman', N'OH', N'39099', N'44512', 41.024226, -80.662853, 2758, 217, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4308, N'Select Specialty Hospital - Youngstown', 1, NULL, NULL, N'362024', NULL, NULL, 0, 31, NULL, N'3308414750', N'3308414761', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1044 Belmont Ave', N'Youngstown', N'OH', N'39099', N'44501', 41.114112, -80.655807, 2758, 217, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4309, N'Community Specialty Hospital', 1, NULL, NULL, N'362025', NULL, NULL, 0, 30, NULL, N'4409886141', N'4402452197', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'254 Cleveland Avenue 2Nd Floor', N'Amherst', N'OH', N'39093', N'44001', 41.397822, -82.222377, 2702, 214, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4310, N'Kindred Hospital', 1, NULL, NULL, N'362026', NULL, NULL, 0, 119, NULL, N'2169838030', N'2165922831', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'11900 Fairhill Road', N'Cleveland', N'OH', N'39035', N'44120', 41.492924, -81.599316, 2667, 211, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4311, N'Select Specialty Hospital-Akron', 1, NULL, NULL, N'362027', NULL, NULL, 0, 34, NULL, N'3307617500', N'3307617555', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'200 East Market Street', N'Akron', N'OH', N'39153', N'44308', 41.083122, -81.511237, 2644, 208, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4312, N'Life Care Hospitals Of Dayton', 1, NULL, NULL, N'362028', NULL, NULL, 0, 33, NULL, N'9373848300', N'9373848399', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4000 Miamisburg-Centerville Road', N'Miamisburg', N'OH', N'39113', N'45342', 39.640134, -84.234441, 2695, 215, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4313, N'Regency Hospital Of Cleveland East', 1, NULL, NULL, N'362029', NULL, NULL, 0, 142, NULL, N'3308612065', N'3308969546', 1, 0, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4200 Interchange Corporate Center Road', N'Warrensville Hts', N'OH', N'39035', N'44128', 41.440345, -81.531381, 2667, 211, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4314, N'Select Specialty Hospital-Zanesville Inc', 1, NULL, NULL, N'362031', NULL, NULL, 0, 35, NULL, N'7405887888', N'7405887856', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'800 Forest Avenue-6Th Floor', N'Zanesville', N'OH', N'39119', N'43701', 39.940345, -82.013192, 2759, 212, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4315, N'Acute Care Specialty Hospital - Aultman', 1, NULL, NULL, N'362032', NULL, NULL, 0, 30, NULL, N'3303634000', N'3303634001', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2000 Sixth Street', N'Canton', N'OH', N'39151', N'44710', 40.798952, -81.378444, 2662, 209, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4316, N'Kindred Hospitals-Dayton', 1, NULL, NULL, N'362033', NULL, NULL, 0, 67, NULL, N'9373319265', N'9373319275', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'707 East Edwin C Moses Blvd', N'Dayton', N'OH', N'39113', N'45417', 39.757485, -84.206969, 2672, 213, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4317, N'Regency Hospital Of Cincinnati Llc', 1, NULL, NULL, N'362034', NULL, NULL, 0, 39, NULL, N'5135595957', N'5135595952', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'10500 Montgomery Road', N'Cincinnati', N'OH', N'39061', N'45219', 39.144553, -84.469438, 2665, 210, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4318, N'Acuity Specialty Ohio Valley', 1, NULL, NULL, N'362035', NULL, NULL, 0, 72, NULL, N'7402837499', N'7402837452', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'380 Summit Avenue 3Rd Floor', N'Steubenville', N'OH', N'39081', N'43952', 40.369791, -80.633964, 2739, 234, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4319, N'Regency Hospital Of Toledo', 1, NULL, NULL, N'362036', NULL, NULL, 0, 45, NULL, N'4193185700', N'4198826090', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5220 West Alexis Road', N'Sylvania', N'OH', N'39095', N'43560', 41.715158, -83.686587, 2740, 216, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4320, N'Select Specialty Hospital Columbus', 1, NULL, NULL, N'362037', NULL, NULL, 0, 43, NULL, N'6144560339', N'6144459520', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1430 South High Street', N'Columbus', N'OH', N'39049', N'43207', 39.867363, -83.005191, 2669, 212, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4321, N'Advanced Specialty Hospital Of Toledo', 1, NULL, NULL, N'362038', NULL, NULL, 0, 40, NULL, N'4193810037', N'4193813990', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1015 Garden Lake Parkway', N'Toledo', N'OH', N'39095', N'43614', 41.621607, -83.596349, 2742, 216, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4322, N'Life Line Hospital', 1, NULL, NULL, N'362039', NULL, NULL, 0, 36, NULL, N'7403462600', N'7403462601', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'200 School Street', N'Wintersville', N'OH', N'39081', N'43953', 40.372955, -80.699673, 2739, 234, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4323, N'Hillside Rehabilitation Hospital', 1, NULL, NULL, N'363026', NULL, NULL, 0, 120, NULL, N'3308845879', N'3308845735', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'8747 Squires Lane Ne', N'Warren', N'OH', N'39155', N'44484', 41.237557, -80.818417, 2748, 217, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4324, N'Greenbriar Rehabilitation Hospital', 1, NULL, NULL, N'363032', NULL, NULL, 0, 29, NULL, N'3309656432', N'3309656438', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'8064 South Avenue Suite One', N'Boardman', N'OH', N'39099', N'44512', 41.024226, -80.662853, 2758, 217, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4325, N'Reliant Rehabilitation Hospital Dayton', 1, NULL, NULL, N'363033', NULL, NULL, 0, 50, NULL, N'9374248200', N'9374248250', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'One Elizabeth Place', N'Dayton', N'OH', N'39113', N'45408', 39.758948, -84.191607, NULL, NULL, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4326, N'Healthsouth Rehabilitation Hospital At Drake', 1, NULL, NULL, N'363034', NULL, NULL, 0, 60, NULL, N'5134185600', N'5134185699', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'151 West Galbraith Road', N'Cincinnati', N'OH', N'39061', N'45216', 39.212871, -84.475489, 2665, 210, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4327, N'Summa Rehab Hospital', 1, NULL, NULL, N'363035', NULL, NULL, 0, 60, NULL, N'3305727300', N'3305727310', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'29 North Adams Street', N'Akron', N'OH', N'39153', N'44304', 41.078642, -81.498418, 2644, 208, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4328, N'University Hospitals Rehabilitation Hospital', 1, NULL, NULL, N'363036', NULL, NULL, 0, 50, NULL, N'3303094491', NULL, 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'23333 Harvard Road', N'Beachwood', N'OH', N'39035', N'44122', 41.449848, -81.499245, 2667, 211, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4329, N'Ohiohealth Rehabilitation Hospital', 1, NULL, NULL, N'363037', NULL, NULL, 0, 44, NULL, N'6144589496', N'6144589497', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1087 Dennison Avenue 4Th Floor', N'Columbus', N'OH', N'39049', N'43201', 39.96226, -83.000706, 2669, 212, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4330, N'Children''s Hospital Medical Center', 1, NULL, NULL, N'363300', NULL, NULL, 0, 523, NULL, N'5136363333', N'5136367194', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3333 Burnet Avenue', N'Cincinnati', N'OH', N'39061', N'45229', 39.14102, -84.500494, 2665, 210, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4331, N'Rainbow Babies And Childrens Hospital', 1, NULL, NULL, N'363302', NULL, NULL, 0, 244, NULL, N'2168441000', N'2168447625', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'11100 Euclid Avenue', N'Cleveland', N'OH', N'39035', N'44106', 41.506647, -81.608082, 2667, 211, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4332, N'Akron Children''s Hospital', 1, NULL, NULL, N'363303', NULL, NULL, 0, 253, NULL, N'3305431000', N'3305433008', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1 Perkins Square', N'Akron', N'OH', N'39153', N'44308', 41.083064, -81.518485, 2644, 208, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4333, N'Cleveland Clinic Children''s Hospital For Rehab', 1, NULL, NULL, N'363304', NULL, NULL, 0, 52, NULL, N'2167216400', N'2164486244', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2801 Martin Luther King Jr Drive', N'Cleveland', N'OH', N'39035', N'44104', 41.481624, -81.609657, 2667, 211, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4334, N'Nationwide Children''s Hospital', 1, NULL, NULL, N'363305', NULL, NULL, 0, 378, NULL, N'6147222000', N'6147225995', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'700 Children''s Drive', N'Columbus', N'OH', N'39049', N'43205', 39.95246, -82.979096, 2669, 212, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4335, N'Dayton Children''s Hospital', 1, NULL, NULL, N'363306', NULL, NULL, 0, 155, NULL, N'9376413450', N'9376415400', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'One Childrens Plaza', N'Dayton', N'OH', N'39113', N'45404', 39.758948, -84.191607, 2672, 213, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4336, N'Shriners Hospitals For Children - Cincinnati', 1, NULL, NULL, N'363308', NULL, NULL, 0, 30, NULL, N'5138726000', N'5138726999', 1, 0, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3229 Burnett Avenue', N'Cincinnati', N'OH', N'39061', N'45229', 39.101454, -84.51246, 2665, 210, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4337, N'Twin Valley Behavioral Healthcare', 1, NULL, NULL, N'364007', NULL, NULL, 0, 176, NULL, N'6147520333', N'6147520087', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2200 West Broad Street', N'Columbus', N'OH', N'39049', N'43223', 39.955705, -83.057971, 2669, 212, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4338, N'Northcoast Behavioral Healthcare Northfield Campus', 1, NULL, NULL, N'364011', NULL, NULL, 0, 260, NULL, N'3304677131', N'3304672420', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1756 Sagamore Road', N'Northfield', N'OH', N'39153', N'44067', 41.345055, -81.528452, 2667, 211, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4339, N'Northwest Ohio Psychiatric Hospital', 1, NULL, NULL, N'364014', NULL, NULL, 0, 114, NULL, N'4193811881', N'4193895971', 1, 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'930 South Detroit Avenue', N'Toledo', N'OH', N'39095', N'43614', 41.6225, -83.597213, 2742, 216, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4340, N'Appalachian Behavioral Health Care', 1, NULL, NULL, N'364015', NULL, NULL, 0, 40, NULL, N'6145945000', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'100 Hospital Drive', N'Athens', N'OH', N'39009', N'45701', 39.327798, -82.115116, 2648, 212, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4341, N'Cambridge Behavorial Hospital', 1, NULL, NULL, N'364027', NULL, NULL, 0, 44, NULL, N'7404324906', N'7404325082', 1, 1, 1, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'66755 State Street', N'Cambridge', N'OH', N'39059', N'43725', 40.031183, -81.588456, 2661, 212, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4342, N'Windsor Laurelwood Center For Behavorial Medicine', 1, NULL, NULL, N'364029', NULL, NULL, 0, 160, NULL, N'4409533000', N'4409533938', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'35900 Euclid Avenue', N'Willoughby', N'OH', N'39085', N'44094', 41.632956, -81.411951, 2725, 211, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4343, N'Heartland Behavioral Healthcare', 1, NULL, NULL, N'364031', NULL, NULL, 0, 212, NULL, N'3308333135', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3000 Erie Sw', N'Massillon', N'OH', N'39151', N'44648', 40.796724, -81.521509, 2709, 209, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4344, N'Summit Behavioral Healthcare', 1, NULL, NULL, N'364035', NULL, NULL, 0, 291, NULL, N'5139483600', N'5139483080', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'1101 Summit Road', N'Cincinnati', N'OH', N'39061', N'45237', 39.194558, -84.47371, 2665, 210, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4345, N'Arrowhead Behavioral Health', 1, NULL, NULL, N'364036', NULL, NULL, 0, 42, NULL, N'4198919333', N'4198919330', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1725 Timber Line Road', N'Maumee', N'OH', N'39095', N'43537', 41.562829, -83.653824, 2710, 216, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4346, N'Belmont Pines Hospital', 1, NULL, NULL, N'364038', NULL, NULL, 0, 46, NULL, N'3307592700', N'3307592776', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'615 Churchill-Hubbard Rd', N'Youngstown', N'OH', N'39099', N'44505', 41.09978, -80.649519, 2758, 217, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4347, N'Mental Health Services For Clark And Madison Cos', 1, NULL, NULL, N'364040', NULL, NULL, 0, 26, NULL, N'9373999500', N'9373992701', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'474 North Yellow Springs Street', N'Springfield', N'OH', N'39023', N'45504', 39.931256, -83.818652, 2737, 213, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4348, N'Ohio Hospital For Psychiatry', 1, NULL, NULL, N'364041', NULL, NULL, 0, 78, NULL, N'6144499664', N'6144447919', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'880 Greenlawn Avenue', N'Columbus', N'OH', N'39049', N'43223', 39.939397, -82.997588, 2669, 212, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4349, N'Ten Lakes Center Llc', 1, NULL, NULL, N'364042', NULL, NULL, 0, 14, NULL, N'7409227499', N'7409225181', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'819 North First Street 3Rd Floor', N'Dennison', N'OH', N'39157', N'44621', 40.393399, -81.333721, 2675, 209, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4350, N'Lindner Center Of Hope', 1, NULL, NULL, N'364044', NULL, NULL, 0, 32, NULL, N'5135364673', N'5135360309', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4075 Old Western Row Road', N'Mason', N'OH', N'39165', N'45040', 39.336722, -84.294223, 2665, 210, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4351, N'Pomegranate Health Systems Of Columbus', 1, NULL, NULL, N'364045', NULL, NULL, 0, 10, NULL, N'6145311758', N'8886799808', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'765 Pierce Drive', N'Columbus', N'OH', N'39049', N'43223', 39.946989, -83.018957, 2669, 212, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4352, N'Bridgewell Hospital Of Cincinnati', 1, NULL, NULL, N'364046', NULL, NULL, 0, 24, NULL, N'5135316444', N'5135319444', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5500 Verulam Street', N'Cincinnati', N'OH', N'39061', N'45213', 39.101454, -84.51246, 2665, 210, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4353, N'Ridgeview Hospital', 1, NULL, NULL, N'364047', NULL, NULL, 0, 20, NULL, N'4199682950', N'4199682956', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'17872 Lincoln Highway', N'Middle Point', N'OH', N'39161', N'45863', 40.855605, -84.447175, 2746, 95, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4354, N'Haven Behavioral Senior Care Of Dayton', 1, NULL, NULL, N'364048', NULL, NULL, 0, 32, NULL, N'6152509500', N'6152509515', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'One Elizabeth Place E3 Suite A', N'Dayton', N'OH', N'39113', N'45417', 39.758948, -84.191607, 2672, 213, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4355, N'Dublin Springs', 1, NULL, NULL, N'364049', NULL, NULL, 0, 48, NULL, N'6147171800', N'6147171801', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7625 Hospital Drive', N'Dublin', N'OH', N'39049', N'43016', 40.102197, -83.161896, 2669, 212, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4356, N'Access Hospital Dayton Llc', 1, NULL, NULL, N'364050', NULL, NULL, 0, 110, NULL, N'6143677700', N'6143174689', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2611 Wayne Avenue', N'Dayton', N'OH', N'39113', N'45420', 39.739163, -84.155908, 2672, 213, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4357, N'Beckett Springs', 1, NULL, NULL, N'364051', NULL, NULL, 0, 48, NULL, N'5139429500', N'5139429501', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'8614 Shepherd Farm Drive', N'West Chester', N'OH', N'39017', N'45069', 39.330336, -84.408275, 2665, 210, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4358, N'Cleveland Clinic Transplant Center', 1, NULL, NULL, N'369801', NULL, NULL, 0, 0, NULL, N'2164442200', N'2166363333', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'9500 Euclid Avenue', N'Cleveland', N'OH', N'39035', N'44106', 41.502571, -81.62085, 2667, 211, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4359, N'Ohio State University Hospitals', 1, NULL, NULL, N'369803', NULL, NULL, 0, 0, NULL, N'6142938000', N'6142933535', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'410 West 10Th Avenue', N'Columbus', N'OH', N'39049', N'43210', 39.96226, -83.000706, 2669, 212, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4360, N'University Of Cincinnati Medical Center', 1, NULL, NULL, N'369804', NULL, NULL, 0, 0, NULL, N'5135841000', N'5135840526', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'234 Goodman Street', N'Cincinnati', N'OH', N'39061', N'45267', 39.136894, -84.503934, 2665, 210, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4361, N'University Of Toledo Medical Center', 1, NULL, NULL, N'369805', NULL, NULL, 0, 0, NULL, N'4193833413', N'4193833850', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'3000 Arlington Ave', N'Toledo', N'OH', N'39095', N'43614', 41.621362, -83.615671, 2742, 216, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4362, N'Cincinnati Children''s Hospital Medical Center', 1, NULL, NULL, N'369806', NULL, NULL, 0, 0, NULL, N'5136363333', N'5136367194', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'3333 Burnet Avenue', N'Cincinnati', N'OH', N'39061', N'45229', 39.14102, -84.500494, 2665, 210, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4363, N'University Hospitals Case Medical Center', 1, NULL, NULL, N'369807', NULL, NULL, 0, 0, NULL, N'2168447064', N'2169832053', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'11100 Euclid Avenue', N'Cleveland', N'OH', N'39035', N'44106', 41.506647, -81.608082, 2667, 211, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4364, N'Nationwide Children''s Hospital', 1, NULL, NULL, N'369810', NULL, NULL, 0, 0, NULL, N'6147226592', N'6147223837', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'700 Children''s Drive', N'Columbus', N'OH', N'39049', N'43205', 39.95246, -82.979096, 2669, 212, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4365, N'Christ Hospital - Transplant', 1, NULL, NULL, N'369811', NULL, NULL, 0, 0, NULL, N'5135852771', N'5135853300', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'2139 Auburn Avenue 5Th Floor', N'Cincinnati', N'OH', N'39061', N'45219', 39.101454, -84.51246, 2665, 210, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4366, N'Hillcrest Medical Center', 1, NULL, NULL, N'370001', NULL, NULL, 0, 686, NULL, N'9185791000', N'9185840840', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1120 South Utica Avenue', N'Tulsa', N'OK', N'40143', N'74104', 36.147383, -95.967242, 2832, 220, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4367, N'Woodward Regional Hospital', 1, NULL, NULL, N'370002', NULL, NULL, 0, 87, NULL, N'5802548492', N'5802548418', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'900 17Th Street', N'Woodward', N'OK', N'40153', N'73801', 36.437461, -99.400861, 2840, 219, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4368, N'Integris Baptist Regional Health Center', 1, NULL, NULL, N'370004', NULL, NULL, 0, 117, NULL, N'9185426611', N'9185407605', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'200 Second Avenue Southwest', N'Miami', N'OK', N'40115', N'74355', 36.874618, -94.877374, 2804, 164, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4369, N'Ponca City Medical Center', 1, NULL, NULL, N'370006', NULL, NULL, 0, 140, NULL, N'5807653321', N'5807650379', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1900 North 14Th Street', N'Ponca City', N'OK', N'40071', N'74601', 36.724964, -97.06869, 2815, 219, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4370, N'Newman Memorial Hospital', 1, NULL, NULL, N'370007', NULL, NULL, 0, 79, NULL, N'5809382551', N'5809382309', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'905 South Main Street', N'Shattuck', N'OK', N'40045', N'73858', 36.275873, -99.881232, 2824, 219, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4371, N'Norman Regional Health System', 1, NULL, NULL, N'370008', NULL, NULL, 0, 450, NULL, N'4053211700', N'4053071076', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'901 North Porter', N'Norman', N'OK', N'40027', N'73070', 35.222572, -97.439482, 2807, 219, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4372, N'Mercy Hospital El Reno', 1, NULL, NULL, N'370011', NULL, NULL, 0, 54, NULL, N'4052622640', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2115 Park View Drive', N'El Reno', N'OK', N'40017', N'73036', 35.532274, -97.955049, 2783, 219, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4373, N'Mercy Hospital Oklahoma City Inc', 1, NULL, NULL, N'370013', NULL, NULL, 0, 369, NULL, N'4057523754', N'4057523811', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4300 West Memorial Road', N'Oklahoma City', N'OK', N'40109', N'73120', 35.608941, -97.600765, 2809, 219, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4374, N'Medical Center Of Southeastern Oklahoma', 1, NULL, NULL, N'370014', NULL, NULL, 0, 148, NULL, N'4059243080', N'5809240422', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1800 University Boulevard', N'Durant', N'OK', N'40013', N'74702', 33.993986, -96.370824, 2781, 261, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4375, N'Integris Mayes County Medical Center', 1, NULL, NULL, N'370015', NULL, NULL, 0, 52, NULL, N'9188251600', N'9188246316', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'111 North Bailey Street', N'Pryor', N'OK', N'40097', N'74361', 36.307596, -95.305268, 2818, 220, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4376, N'Integris Bass Baptist Health Center', 1, NULL, NULL, N'370016', NULL, NULL, 0, 183, NULL, N'5802332300', N'5802338802', 1, 1, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'600 South Monroe', N'Enid', N'OK', N'40047', N'73701', 36.396762, -97.879134, 2785, 219, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4377, N'Jane Phillips Medical Center', 1, NULL, NULL, N'370018', NULL, NULL, 0, 140, NULL, N'9183337200', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3500 East Frank Phillips Boulevard', N'Bartlesville', N'OK', N'40147', N'74006', 36.745772, -95.921011, 2767, 220, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4378, N'Great Plains Regional Medical Center', 1, NULL, NULL, N'370019', NULL, NULL, 0, 62, NULL, N'5802252511', N'5802259143', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1801 West 3Rd Street', N'Elk City', N'OK', N'40009', N'73644', 35.411716, -99.42081, 2784, 219, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4379, N'Mercy Hospital Ada Inc', 1, NULL, NULL, N'370020', NULL, NULL, 0, 156, NULL, N'5803322323', N'5804216060', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'430 North Monta Vista', N'Ada', N'OK', N'40123', N'74820', 34.774338, -96.678365, 2760, 219, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4380, N'Jackson County Memorial Hospital Authority', 1, NULL, NULL, N'370022', NULL, NULL, 0, 99, NULL, N'5803795000', N'5804812345', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1200 East Pecan St', N'Altus', N'OK', N'40065', N'73523', 34.634505, -99.326112, 2761, 219, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4381, N'Duncan Regional Hospital Inc', 1, NULL, NULL, N'370023', NULL, NULL, 0, 145, NULL, N'5802525300', NULL, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'1407 Whisenant Drive', N'Duncan', N'OK', N'40137', N'73533', 34.502303, -97.957813, 2780, 218, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4382, N'Eastar Health System', 1, NULL, NULL, N'370025', NULL, NULL, 0, 325, NULL, N'9186825501', N'9186842552', 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'300 Rockefeller Drive', N'Muskogee', N'OK', N'40101', N'74401', 35.753651, -95.406055, 2806, 220, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4383, N'St Mary''s Regional Medical Center', 1, NULL, NULL, N'370026', NULL, NULL, 0, 229, NULL, N'5802336100', N'5802493790', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'305 South 5Th Street', N'Enid', N'OK', N'40047', N'73701', 36.394082, -97.871883, 2785, 219, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4384, N'Integris Baptist Medical Center', 1, NULL, NULL, N'370028', NULL, NULL, 0, 629, NULL, N'4059518110', N'4059493573', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3300 Northwest Expressway', N'Oklahoma City', N'OK', N'40109', N'73112', 35.567613, -97.660205, 2809, 219, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4385, N'Clinton Regional Hospital', 1, NULL, NULL, N'370029', NULL, NULL, 0, 66, NULL, N'5803232363', N'5803238369', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'100 North 30Th Street', N'Clinton', N'OK', N'40039', N'73601', 35.514596, -98.996963, 2775, 219, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4386, N'Blackwell Regional Hospital', 1, NULL, NULL, N'370030', NULL, NULL, 0, 53, NULL, N'5803632311', N'5803632339', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'710 South 13Th Street', N'Blackwell', N'OK', N'40071', N'74631', 36.804477, -97.282821, 2769, 219, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4387, N'Deaconess Hospital', 1, NULL, NULL, N'370032', NULL, NULL, 0, 238, NULL, N'4056046109', N'4056046153', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5501 North Portland Avenue', N'Oklahoma City', N'OK', N'40109', N'73112', 35.521161, -97.583462, 2809, 219, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4388, N'Mcalester Regional Health Center', 1, NULL, NULL, N'370034', NULL, NULL, 0, 187, NULL, N'9184261800', NULL, 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'One Clark Bass Boulevard', N'Mcalester', N'OK', N'40121', N'74501', 34.933498, -95.769793, 2803, 220, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4389, N'Harmon Memorial Hospital', 1, NULL, NULL, N'370036', NULL, NULL, 0, 31, NULL, N'5806883363', N'5806889730', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'400 East Chestnut Street', N'Hollis', N'OK', N'40057', N'73550', 34.691554, -99.913827, 2795, 219, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4390, N'St Anthony Hospital', 1, NULL, NULL, N'370037', NULL, NULL, 0, 686, NULL, N'4052727000', N'4052726592', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1000 North Lee Avenue', N'Oklahoma City', N'OK', N'40109', N'73101', 35.477368, -97.524213, 2809, 219, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4391, N'Hillcrest Hospital Claremore', 1, NULL, NULL, N'370039', NULL, NULL, 0, 81, NULL, N'9183412556', N'9183423330', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1202 N Muskogee Place', N'Claremore', N'OK', N'40131', N'74017', 36.321973, -95.605188, 2774, 220, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4392, N'Eastern Oklahoma Medical Center', 1, NULL, NULL, N'370040', NULL, NULL, 0, 59, NULL, N'9186478161', N'9186353308', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'105 Wall Street', N'Poteau', N'OK', N'40079', N'74953', 35.053709, -94.623558, 2816, 12, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4393, N'Bristow Medical Center', 1, NULL, NULL, N'370041', NULL, NULL, 0, 30, NULL, N'9183672215', N'9183679190', 1, 1, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'700 W. 7Th Street', N'Bristow', N'OK', N'40037', N'74010', 35.830633, -96.391118, 2832, 220, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4394, N'Mercy Hospital Ardmore Inc', 1, NULL, NULL, N'370047', NULL, NULL, 0, 190, NULL, N'5802235400', N'5802206580', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1011 Fourteenth Avenue Northwest', N'Ardmore', N'OK', N'40019', N'73401', 34.174261, -97.143625, 2765, 219, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4395, N'Mccurtain Memorial Hospital', 1, NULL, NULL, N'370048', NULL, NULL, 0, 91, NULL, N'5802867623', N'5802083199', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1301 Lincoln Road', N'Idabel', N'OK', N'40089', N'74745', 33.880974, -94.812036, 2796, 16, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4396, N'Stillwater Medical Center', 1, NULL, NULL, N'370049', NULL, NULL, 0, 117, NULL, N'4053721480', N'4057425631', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1323 West 6Th Street', N'Stillwater', N'OK', N'40119', N'74076', 36.115631, -97.058572, 2827, 220, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4397, N'Memorial Hospital & Physician Group', 1, NULL, NULL, N'370051', NULL, NULL, 0, 37, NULL, N'5803357565', N'5803357329', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'319 East Josephine', N'Frederick', N'OK', N'40141', N'73542', 34.392026, -99.018409, 2789, 218, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4398, N'Grady Memorial Hospital', 1, NULL, NULL, N'370054', NULL, NULL, 0, 99, NULL, N'4052242300', N'4057792413', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2220 Iowa Street', N'Chickasha', N'OK', N'40051', N'73018', 35.052565, -97.936433, 2773, 219, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4399, N'Comanche County Memorial Hospital', 1, NULL, NULL, N'370056', NULL, NULL, 0, 283, NULL, N'5803558620', N'5805855458', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3401 West Gore Blvd', N'Lawton', N'OK', N'40031', N'73505', 34.608685, -98.39033, 2798, 218, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4400, N'Muscogee (Creek) Nation Medical Center', 1, NULL, NULL, N'370057', NULL, NULL, 0, 66, NULL, N'9187564233', N'9187565968', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1401 Morris Drive', N'Okmulgee', N'OK', N'40111', N'74447', 35.610466, -95.953162, 2810, 220, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4401, N'Craig General Hospital', 1, NULL, NULL, N'370065', NULL, NULL, 0, 62, NULL, N'9182567551', N'9182567395', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'735 North Foreman', N'Vinita', N'OK', N'40035', N'74301', 36.638694, -95.154134, 2833, 220, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4402, N'Latimer County General Hospital', 1, NULL, NULL, N'370072', NULL, NULL, 0, 33, NULL, N'9184652391', N'9184653755', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'806 State Highway 2 North', N'Wilburton', N'OK', N'40077', N'74578', 34.91871, -95.309138, 2839, 12, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4403, N'Oklahoma State University Medical Center', 1, NULL, NULL, N'370078', NULL, NULL, 0, 249, NULL, N'9185991000', N'9185991750', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'744 West 9Th Street', N'Tulsa', N'OK', N'40113', N'74127', 36.146419, -95.999941, 2832, 220, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4404, N'Share Medical Center', 1, NULL, NULL, N'370080', NULL, NULL, 0, 25, NULL, N'5803272800', N'5804303332', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'800 Share Drive', N'Alva', N'OK', N'40151', N'73717', 36.787043, -98.670189, 2762, 219, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4405, N'Pushmataha Cty-Tn Of Antlers Hosp Auth', 1, NULL, NULL, N'370083', NULL, NULL, 0, 23, NULL, N'5802983341', N'5802985736', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'510 East Main Street', N'Antlers', N'OK', N'40127', N'74523', 34.231655, -95.615392, 2764, 219, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4406, N'Northeastern Health System', 1, NULL, NULL, N'370089', NULL, NULL, 0, 100, NULL, N'9184560641', N'9184568886', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1400 East Downing Street', N'Tahlequah', N'OK', N'40021', N'74465', 35.915382, -94.955328, 2830, 220, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4407, N'Saint Francis Hospital Inc', 1, NULL, NULL, N'370091', NULL, NULL, 0, 962, NULL, N'9184942200', N'9184942475', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6161 South Yale', N'Tulsa', N'OK', N'40143', N'74136', 36.155681, -95.992911, 2832, 220, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4408, N'O U Medical Center', 1, NULL, NULL, N'370093', NULL, NULL, 0, 750, NULL, N'4052715911', N'4052716753', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'700 Ne 13Th Street', N'Oklahoma City', N'OK', N'40109', N'73104', 35.482262, -97.502757, 2809, 219, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4409, N'Midwest Regional Medical Center', 1, NULL, NULL, N'370094', NULL, NULL, 0, 255, NULL, N'4056108530', N'4056101380', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2825 Parklawn Drive', N'Midwest City', N'OK', N'40109', N'73110', 35.46683, -97.392765, 2805, 219, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4410, N'Southwestern Medical Center', 1, NULL, NULL, N'370097', NULL, NULL, 0, 199, NULL, N'5805314700', N'5805314702', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5602 Southwest Lee Boulevard', N'Lawton', N'OK', N'40031', N'73505', 34.594272, -98.460973, 2798, 218, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4411, N'Hillcrest Hospital Cushing', 1, NULL, NULL, N'370099', NULL, NULL, 0, 99, NULL, N'9182252915', N'9182256550', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1027 East Cherry Street', N'Cushing', N'OK', N'40119', N'74023', 35.978836, -96.756589, 2778, 220, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4412, N'Choctaw Memorial Hospital', 1, NULL, NULL, N'370100', NULL, NULL, 0, 34, NULL, N'5803179500', N'5803263541', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1405 East Kirk Road', N'Hugo', N'OK', N'40023', N'74743', 34.017861, -95.539293, 3352, 261, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4413, N'Sayre Memorial Hospital Inc', 1, NULL, NULL, N'370103', NULL, NULL, 0, 46, NULL, N'5809285541', N'5809283523', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'911 Hospital Drive', N'Sayre', N'OK', N'40009', N'73662', 35.291162, -99.640097, 2822, 219, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4414, N'Integris Southwest Medical Center', 1, NULL, NULL, N'370106', NULL, NULL, 0, 389, NULL, N'4056367000', N'4056367702', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4401 South Western Avenue', N'Oklahoma City', N'OK', N'40109', N'73109', 35.420625, -97.530325, 2809, 219, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4415, N'Sequoyah County City Of Sallisaw Hospital Authorit', 1, NULL, NULL, N'370112', NULL, NULL, 0, 41, NULL, N'9187741100', N'9187741103', 1, 1, 0, 0, 0, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'213 East Redwood', N'Sallisaw', N'OK', N'40135', N'74955', 35.463445, -94.788236, 2820, 12, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4416, N'Integris Grove Hospital', 1, NULL, NULL, N'370113', NULL, NULL, 0, 58, NULL, N'9187862243', N'9187873643', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1001 East 18Th Street', N'Grove', N'OK', N'40041', N'74344', 36.593686, -94.769119, 2790, 164, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4417, N'St John Medical Center Inc', 1, NULL, NULL, N'370114', NULL, NULL, 0, 703, NULL, N'9187443606', N'9187442357', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1923 South Utica Avenue', N'Tulsa', N'OK', N'40143', N'74104', 36.134749, -95.967117, 2832, 220, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4418, N'Memorial Hospital Of Texas County', 1, NULL, NULL, N'370138', NULL, NULL, 0, 47, NULL, N'5803386515', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'520 Medical Drive', N'Guymon', N'OK', N'40139', N'73942', 36.690777, -101.47595, 2792, 256, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4419, N'Perry Memorial Hospital', 1, NULL, NULL, N'370139', NULL, NULL, 0, 26, NULL, N'5803363541', N'5803367209', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'501 Fourteenth Street', N'Perry', N'OK', N'40103', N'73077', 36.289486, -97.288098, 2814, 219, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4420, N'St Anthony Shawnee Hospital', 1, NULL, NULL, N'370149', NULL, NULL, 0, 102, NULL, N'4052732270', N'4058788101', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1102 W Macarthur', N'Shawnee', N'OK', N'40125', N'74804', 35.327293, -96.9253, 2825, 219, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4421, N'Elkview General Hospital', 1, NULL, NULL, N'370153', NULL, NULL, 0, 38, NULL, N'5807263324', N'5807266041', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'429 West Elm Street', N'Hobart', N'OK', N'40075', N'73651', 35.036877, -99.098998, 2793, 219, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4422, N'Pauls Valley General Hospital', 1, NULL, NULL, N'370156', NULL, NULL, 0, 64, NULL, N'4052385501', N'4052385926', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'100 Valley Drive', N'Pauls Valley', N'OK', N'40049', N'73075', 34.740081, -97.222245, 2811, 219, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4423, N'Purcell Municipal Hospital', 1, NULL, NULL, N'370158', NULL, NULL, 0, 39, NULL, N'4055276524', N'4055273529', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1500 North Green Avenue', N'Purcell', N'OK', N'40087', N'73080', 35.028784, -97.365805, 2819, 219, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4424, N'Wagoner Community Hospital', 1, NULL, NULL, N'370166', NULL, NULL, 0, 100, NULL, N'9184855514', N'9184859994', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1200 West Cherokee Street', N'Wagoner', N'OK', N'40145', N'74467', 35.96198, -95.392027, 2834, 220, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4425, N'Epic Medical Center', 1, NULL, NULL, N'370169', NULL, NULL, 0, 33, NULL, N'9186892535', N'9186897285', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1 Hospital Drive', N'Eufaula', N'OK', N'40091', N'74432', 35.310947, -95.591836, 2786, 220, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4426, N'Usphs Lawton Indian Hospital', 1, NULL, NULL, N'370170', NULL, NULL, 0, 26, NULL, N'5803545000', N'5803545105', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1515 Lawrie Tatum Road', N'Lawton', N'OK', N'40031', N'73507', 34.608685, -98.39033, 2798, 218, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4427, N'W W Hastings Indian Hospital', 1, NULL, NULL, N'370171', NULL, NULL, 0, 60, NULL, N'9184583100', N'9184583365', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'100 S Bliss Avenue', N'Tahlequah', N'OK', N'40021', N'74464', 35.913944, -94.948977, 2830, 220, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4428, N'Choctaw Nation Health Services Authority', 1, NULL, NULL, N'370172', NULL, NULL, 0, 44, NULL, N'9185677000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1 Choctaw Way', N'Talihina', N'OK', N'40077', N'74571', 34.751489, -95.048016, 2816, 12, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4429, N'Claremore Indian Hospital', 1, NULL, NULL, N'370173', NULL, NULL, 0, 60, NULL, N'9183418430', NULL, 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'101 South Moore Ave', N'Claremore', N'OK', N'40131', N'74017', 36.316803, -95.628322, 2774, 220, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4430, N'Memorial Hospital', 1, NULL, NULL, N'370178', NULL, NULL, 0, 67, NULL, N'9186963101', N'9186963388', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1401 West Locust', N'Stilwell', N'OK', N'40001', N'74960', 35.814431, -94.628616, 2841, 220, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4431, N'Chickasaw Nation Medical Center', 1, NULL, NULL, N'370180', NULL, NULL, 0, 48, NULL, N'5804363980', N'5804216267', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1921 Stonecipher Blvd', N'Ada', N'OK', N'40123', N'74820', 34.738573, -96.643569, 2760, 219, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4432, N'Hillcrest Hospital Henryetta', 1, NULL, NULL, N'370183', NULL, NULL, 0, 41, NULL, N'9186151100', N'9186501391', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2401 W Main Dewey Bartlett And Main', N'Henryetta', N'OK', N'40111', N'74437', 35.439826, -95.981943, 2832, 220, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4433, N'Southwestern Regional Medical Center', 1, NULL, NULL, N'370190', NULL, NULL, 0, 40, NULL, N'9182865000', N'9182495866', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'10109 East 79Th Street South', N'Tulsa', N'OK', N'40143', N'74133', 36.04915, -95.927378, 2832, 220, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4434, N'Northwest Surgical Hospital', 1, NULL, NULL, N'370192', NULL, NULL, 0, 9, NULL, N'4048481918', N'4058487537', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'9204 North May Avenue', N'Oklahoma City', N'OK', N'40109', N'73120', 35.609543, -97.567223, 2809, 219, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4435, N'Lakeside Women''s Hospital A Member Of Integris He', 1, NULL, NULL, N'370199', NULL, NULL, 0, 23, NULL, N'4059361500', N'4059361584', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'11200 North Portland Avenue', N'Oklahoma City', N'OK', N'40109', N'73120', 35.584962, -97.582852, 2809, 219, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4436, N'Surgical Hospital Of Oklahoma', 1, NULL, NULL, N'370201', NULL, NULL, 0, 12, NULL, N'4056349300', N'4056167049', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'100 Southeast 59Th Street', N'Oklahoma City', N'OK', N'40109', N'73129', 35.406133, -97.509972, 2809, 219, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4437, N'Hillcrest Hospital South', 1, NULL, NULL, N'370202', NULL, NULL, 0, 180, NULL, N'9182944000', N'9182944809', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'8801 South 101St East Avenue', N'Tulsa', N'OK', N'40143', N'74133', 36.065189, -95.864406, 2832, 220, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4438, N'Community Hospital Llc', 1, NULL, NULL, N'370203', NULL, NULL, 0, 49, NULL, N'4056028100', N'4056028158', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3100 Southwest 89Th Street', N'Oklahoma City', N'OK', N'40109', N'73159', 35.377029, -97.570267, 2809, 219, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4439, N'Oklahoma Spine Hospital', 1, NULL, NULL, N'370206', NULL, NULL, 0, 25, NULL, N'4057492700', N'4057492783', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'14101 Parkway Commons Drive', N'Oklahoma City', N'OK', N'40109', N'73134', 35.613704, -97.582319, 2809, 219, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4440, N'Oklahoma Surgical Hospital Llc', 1, NULL, NULL, N'370210', NULL, NULL, 0, 76, NULL, N'9184775000', N'9184775995', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2408 East 81St Street Suite 300', N'Tulsa', N'OK', N'40143', N'74137', 36.155681, -95.992911, 2832, 220, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4441, N'Integris Canadian Valley  Hospital', 1, NULL, NULL, N'370211', NULL, NULL, 0, 75, NULL, N'4057176800', N'4057177964', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1201 Health Center Parkway', N'Yukon', N'OK', N'40017', N'73099', 35.514358, -97.773291, 2809, 219, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4442, N'Oklahoma Center For Orthopaedic & Multi-Sp', 1, NULL, NULL, N'370212', NULL, NULL, 0, 10, NULL, N'4056026500', N'4056068976', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'8100 South Walker Bldg C', N'Oklahoma City', N'OK', N'40027', N'73139', 35.472989, -97.517054, 2809, 219, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4443, N'Lindsay Municipal Hospital', 1, NULL, NULL, N'370214', NULL, NULL, 0, 26, NULL, N'4057561404', N'4057561476', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1305 W Cherokee Street - Highway 19 West', N'Lindsay', N'OK', N'40049', N'73052', 34.834796, -97.602532, 2799, 219, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4444, N'Oklahoma Heart Hospital', 1, NULL, NULL, N'370215', NULL, NULL, 0, 99, NULL, N'4056083200', N'4056081493', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4050 West Memorial Road', N'Oklahoma City', N'OK', N'40109', N'73120', 35.609036, -97.595372, 2809, 219, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4445, N'Tulsa Spine & Specialty Hospital', 1, NULL, NULL, N'370216', NULL, NULL, 0, 38, NULL, N'9183885701', N'9183882734', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6901 South Olympia Avenue', N'Tulsa', N'OK', N'40143', N'74132', 36.061172, -96.004087, 2832, 220, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4446, N'Saint Francis Hospital South Llc', 1, NULL, NULL, N'370218', NULL, NULL, 0, 96, NULL, N'9183076000', N'9183076011', 1, 1, 1, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'10501 East 91St Street South', N'Tulsa', N'OK', N'40143', N'74133', 36.031863, -95.952118, 2832, 220, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4447, N'Onecore Health', 1, NULL, NULL, N'370220', NULL, NULL, 0, 8, NULL, N'4056313085', N'4056162676', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1044 Sw 44Th Suite 350', N'Oklahoma City', N'OK', N'40109', N'73109', 35.472989, -97.517054, 2809, 219, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4448, N'Mcbride Clinic Orthopedic Hospital Llc', 1, NULL, NULL, N'370222', NULL, NULL, 0, 75, NULL, N'4054862100', N'4054862144', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'9600 North Broadway Extension', N'Oklahoma City', N'OK', N'40109', N'73114', 35.579197, -97.512618, 2809, 219, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4449, N'Summit Medical Center', 1, NULL, NULL, N'370225', NULL, NULL, 0, 15, NULL, N'4053592400', N'4057159185', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1800 South Renaissance Boulevard', N'Edmond', N'OK', N'40109', N'73013', 35.657137, -97.464904, 2809, 219, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4450, N'St John Owasso', 1, NULL, NULL, N'370227', NULL, NULL, 0, 36, NULL, N'9182745100', N'9182745999', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'12451 East 100Th Street North', N'Owasso', N'OK', N'40143', N'74055', 36.29846, -95.834695, 2832, 220, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4451, N'Bailey Medical Center Llc', 1, NULL, NULL, N'370228', NULL, NULL, 0, 83, NULL, N'9183768000', N'9183768549', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'10502 North 110Th East Avenue', N'Owasso', N'OK', N'40143', N'74055', 36.312961, -95.851498, 2832, 220, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4452, N'Integris Seminole Medical Center', 1, NULL, NULL, N'370229', NULL, NULL, 0, 32, NULL, N'4053034000', N'4053034150', 1, 1, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'2401 Wrangler Boulevard', N'Seminole', N'OK', N'40133', N'74868', 35.22452, -96.670573, 2809, 219, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4453, N'Pinnacle Specialty Hospital', 1, NULL, NULL, N'370233', NULL, NULL, 0, 4, NULL, N'9183922780', N'9183922782', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2408 East 81St Street Suite 600', N'Tulsa', N'OK', N'40143', N'74137', 36.155681, -95.992911, 2832, 220, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4454, N'Oklahoma Heart Hospital South', 1, NULL, NULL, N'370234', NULL, NULL, 0, 46, NULL, N'4056286000', N'4056081585', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5200 East I-240 Service Road', N'Oklahoma City', N'OK', N'40109', N'73135', 35.472989, -97.517054, 2809, 219, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4455, N'St John Broken Arrow', 1, NULL, NULL, N'370235', NULL, NULL, 0, 44, NULL, N'9189948199', N'9189948199', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1000 West Boise Circle', N'Broken Arrow', N'OK', N'40143', N'74012', 36.052599, -95.790819, 2832, 220, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4456, N'Integris Health Edmond', 1, NULL, NULL, N'370236', NULL, NULL, 0, 40, NULL, N'4056573000', N'4054710003', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4801 Integris Parkway', N'Edmond', N'OK', N'40109', N'73034', 35.657137, -97.464904, 2782, 219, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4457, N'Atoka County Medical Center', 1, NULL, NULL, N'371300', NULL, NULL, 0, 25, NULL, N'5808893333', N'5808898779', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1200 West Liberty Road', N'Atoka', N'OK', N'40005', N'74525', 34.394181, -96.145498, 2766, 219, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4458, N'Prague Community Hospital', 1, NULL, NULL, N'371301', NULL, NULL, 0, 25, NULL, N'4055674922', N'4055674290', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1322 Klabzuba Avenue', N'Prague', N'OK', N'40081', N'74864', 35.490103, -96.684458, 2817, 219, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4459, N'Mercy Hospital Watonga', 1, NULL, NULL, N'371302', NULL, NULL, 0, 25, NULL, N'5806237211', N'5806237206', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'500 North Clarence Nash Boulevard', N'Watonga', N'OK', N'40011', N'73772', 35.848997, -98.419159, 2835, 219, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4460, N'Roger Mills Memorial Hospital', 1, NULL, NULL, N'371303', NULL, NULL, 0, 15, NULL, N'5804973336', N'5804972124', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'501 South L L Males Avenue', N'Cheyenne', N'OK', N'40129', N'73628', 35.613937, -99.671494, 2772, 219, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4461, N'Mercy Hospital Tishomingo Inc', 1, NULL, NULL, N'371304', NULL, NULL, 0, 25, NULL, N'5803712327', N'5803712889', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1000 South Byrd', N'Tishomingo', N'OK', N'40069', N'73460', 34.236206, -96.678613, 2831, 219, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4462, N'Jane Phillips Nowata Health Center', 1, NULL, NULL, N'371305', NULL, NULL, 0, 25, NULL, N'9182733102', N'9182731529', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'237 South Locust Street', N'Nowata', N'OK', N'40105', N'74048', 36.696129, -95.63041, 2767, 220, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4463, N'Mercy Health Love County', 1, NULL, NULL, N'371306', NULL, NULL, 0, 25, NULL, N'5802763347', N'5802762182', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'300 Wanda Street', N'Marietta', N'OK', N'40085', N'73448', 33.942485, -97.130789, 2802, 219, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4464, N'Cimarron Memorial Hospital', 1, NULL, NULL, N'371307', NULL, NULL, 0, 25, NULL, N'5805442501', N'5805443200', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'100 South Ellis', N'Boise City', N'OK', N'40025', N'73933', 36.724677, -102.517529, 3205, 256, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4465, N'Pawhuska Hospital Inc', 1, NULL, NULL, N'371309', NULL, NULL, 0, 25, NULL, N'9182873232', N'9182875161', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1101 East 15Th Street', N'Pawhuska', N'OK', N'40113', N'74056', 36.672897, -96.326054, 2812, 220, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4466, N'Mercy Hospital Healdton Inc', 1, NULL, NULL, N'371310', NULL, NULL, 0, 22, NULL, N'5802290701', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3462 Hospital Rd', N'Healdton', N'OK', N'40019', N'73438', 34.233148, -97.487802, 2765, 219, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4467, N'Jefferson County Hospital', 1, NULL, NULL, N'371311', NULL, NULL, 0, 25, NULL, N'5802282344', N'5082283410', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Intersection Hyws 81 & 70', N'Waurika', N'OK', N'40067', N'73573', 34.167037, -97.997536, 2836, 218, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4468, N'St John Sapulpa', 1, NULL, NULL, N'371312', NULL, NULL, 0, 25, NULL, N'9182244280', N'9182271093', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1004 East Bryan', N'Sapulpa', N'OK', N'40037', N'74066', 36.000504, -96.104961, 2821, 220, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4469, N'Mercy Hospital Kingfisher', 1, NULL, NULL, N'371313', NULL, NULL, 0, 25, NULL, N'4053753141', N'4053757997', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1000 Kingfisher Hospital Drive', N'Kingfisher', N'OK', N'40073', N'73750', 35.861432, -97.93172, 2797, 219, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4470, N'The Physicians'' Hospital In Anadarko', 1, NULL, NULL, N'371314', NULL, NULL, 0, 25, NULL, N'4052472551', N'4052478258', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1002 East Central Boulevard', N'Anadarko', N'OK', N'40015', N'73005', 35.07237, -98.233578, 2763, 218, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4471, N'Stroud Regional Medical Center', 1, NULL, NULL, N'371316', NULL, NULL, 0, 25, NULL, N'9189683571', N'9189684814', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2308 Highway 66 West', N'Stroud', N'OK', N'40081', N'74079', 35.74868, -96.658073, 2828, 219, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4472, N'Mercy Hospital Logan County', 1, NULL, NULL, N'371317', NULL, NULL, 0, 25, NULL, N'4052826700', N'4052826790', 1, 1, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'200 South Academy Road', N'Guthrie', N'OK', N'40083', N'73044', 35.878923, -97.425277, 2791, 219, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4473, N'Fairfax Community Hospital', 1, NULL, NULL, N'371318', NULL, NULL, 0, 15, NULL, N'9186423291', N'9186423694', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'40 Hospital Road', N'Fairfax', N'OK', N'40113', N'74637', 36.562704, -96.705551, 2787, 220, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4474, N'Mary Hurley Hospital', 1, NULL, NULL, N'371319', NULL, NULL, 0, 20, NULL, N'5809272327', N'5809272815', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6 North Covington', N'Coalgate', N'OK', N'40029', N'74538', 34.538709, -96.224424, 2776, 220, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4475, N'Cleveland Area Hospital', 1, NULL, NULL, N'371320', NULL, NULL, 0, 14, NULL, N'9183582501', N'9183589274', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1401 West Pawnee', N'Cleveland', N'OK', N'40117', N'74020', 36.310069, -96.464189, 2832, 220, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4476, N'Holdenville General Hospital', 1, NULL, NULL, N'371321', NULL, NULL, 0, 25, NULL, N'4053794200', N'4053794284', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'100 Mcdougal Drive', N'Holdenville', N'OK', N'40063', N'74848', 35.088741, -96.379601, 2794, 219, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4477, N'Beaver County Memorial Hospital', 1, NULL, NULL, N'371322', NULL, NULL, 0, 24, NULL, N'5806254551', N'5806254212', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'212 East 8Th Street', N'Beaver', N'OK', N'40007', N'73932', 36.816137, -100.519871, 2768, 219, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4478, N'Weatherford Regional Hospital', 1, NULL, NULL, N'371323', NULL, NULL, 0, 25, NULL, N'5807725551', N'5807742314', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3701 E Main', N'Weatherford', N'OK', N'40039', N'73096', 35.526163, -98.707574, 2837, 219, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4479, N'Harper County Community Hospital', 1, NULL, NULL, N'371324', NULL, NULL, 0, 25, NULL, N'5807352555', N'5807352342', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1003 Us Highway 64 North', N'Buffalo', N'OK', N'40059', N'73834', 36.835587, -99.630397, 2770, 219, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4480, N'Cordell Memorial Hospital', 1, NULL, NULL, N'371325', NULL, NULL, 0, 25, NULL, N'5808323339', N'5808325076', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1220 North Glenn English Street', N'Cordell', N'OK', N'40149', N'73632', 35.291251, -98.989545, 2777, 219, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4481, N'Integris Marshall County Medical Center', 1, NULL, NULL, N'371326', NULL, NULL, 0, 25, NULL, N'5807953384', N'5807950173', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'901 S 5Th Ave', N'Madill', N'OK', N'40095', N'73446', 34.085974, -96.776933, 2800, 219, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4482, N'Okeene Municipal Hospital', 1, NULL, NULL, N'371327', NULL, NULL, 0, 17, NULL, N'5808224417', N'5808223927', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'207 East F Street', N'Okeene', N'OK', N'40011', N'73763', 36.116994, -98.330903, 2808, 219, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4483, N'Arbuckle Memorial Hospital', 1, NULL, NULL, N'371328', NULL, NULL, 0, 25, NULL, N'5806222161', N'5806225519', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2011 West Broadway', N'Sulphur', N'OK', N'40099', N'73086', 34.507867, -96.96835, 2829, 219, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4484, N'Fairview Regional Medical Center', 1, NULL, NULL, N'371329', NULL, NULL, 0, 25, NULL, N'5802273721', N'5802272882', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'523 East State Road', N'Fairview', N'OK', N'40093', N'73737', 36.275274, -98.474604, 2788, 219, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4485, N'Quartz Mountain Medical Center', 1, NULL, NULL, N'371330', NULL, NULL, 0, 17, NULL, N'5807823353', N'5807825944', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'One Wickersham Drive', N'Mangum', N'OK', N'40055', N'73554', 34.872004, -99.504256, 2801, 219, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4486, N'Drumright Regional Hospital', 1, NULL, NULL, N'371331', NULL, NULL, 0, 15, NULL, N'9183822300', N'9183522675', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'610 West Bypass', N'Drumright', N'OK', N'40037', N'74030', 36.002026, -96.605922, 2779, 220, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4487, N'Seiling Municipal Hospital', 1, NULL, NULL, N'371332', NULL, NULL, 0, 18, NULL, N'5809227361', N'5809227718', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Highway 60 & 281', N'Seiling', N'OK', N'40043', N'73663', 36.148096, -98.924261, 2823, 219, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4488, N'Creek Nation Community Hospital', 1, NULL, NULL, N'371333', NULL, NULL, 0, 25, NULL, N'9186231424', N'9186231066', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'309 North 14Th Street', N'Okemah', N'OK', N'40107', N'74859', 35.436506, -96.317423, 2832, 220, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4489, N'Carnegie Tri-County Municipal Hospital', 1, NULL, NULL, N'371334', NULL, NULL, 0, 21, NULL, N'5806541050', N'5806542111', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'102 North Broadway', N'Carnegie', N'OK', N'40015', N'73015', 35.10367, -98.603674, 2771, 218, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4490, N'Haskell County Community Hospital', 1, NULL, NULL, N'371335', NULL, NULL, 0, 25, NULL, N'9189674682', N'9189678694', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'401 Northwest H Street', N'Stigler', N'OK', N'40061', N'74462', 35.260876, -95.128377, 2826, 12, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4491, N'Kindred Hospital - Oklahoma City', 1, NULL, NULL, N'372004', NULL, NULL, 0, 93, NULL, N'4052328000', N'4052363839', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1407 North Robinson Avenue', N'Oklahoma City', N'OK', N'40109', N'73103', 35.48255, -97.51608, 2809, 219, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4492, N'Edmond - Amg Specialty Hospital', 1, NULL, NULL, N'372005', NULL, NULL, 0, 43, NULL, N'4053415617', N'4053410105', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1100 East 9Th Street', N'Edmond', N'OK', N'40109', N'73034', 35.645554, -97.48236, 2782, 219, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4493, N'Select Specialty Hospital - Tulsa/Midtown', 1, NULL, NULL, N'372007', NULL, NULL, 0, 56, NULL, N'9185707260', N'9184965629', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1125 South Trenton 2Nd & 3Rd Floor', N'Tulsa', N'OK', N'40143', N'74120', 36.155681, -95.992911, 2832, 220, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4494, N'Select Specialty Hospital - Oklahoma City', 1, NULL, NULL, N'372009', NULL, NULL, 0, 72, NULL, N'4056066700', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3524 Northwest 56Th Street', N'Oklahoma City', N'OK', N'40109', N'73112', 35.527436, -97.578531, 2809, 219, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4495, N'Tulsa-Amg Specialty Hospital Llc', 1, NULL, NULL, N'372011', NULL, NULL, 0, 40, NULL, N'9187103620', N'9187103624', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2408 E 81St Street Ste 2800', N'Tulsa', N'OK', N'40143', N'74137', 36.155681, -95.992911, 2832, 220, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4496, N'Specialty Hospital Of Midwest City', 1, NULL, NULL, N'372012', NULL, NULL, 0, 31, NULL, N'4057390800', N'4057396479', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'8210 National Avenue', N'Midwest City', N'OK', N'40109', N'73110', 35.466332, -97.387693, 2805, 219, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4497, N'Integris Bass Pavilion', 1, NULL, NULL, N'372016', NULL, NULL, 0, 24, NULL, N'5802494260', N'5802494256', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'401 South Third Street', N'Enid', N'OK', N'40047', N'73701', 36.396762, -97.879134, 2785, 219, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4498, N'Lane Frost Health And Rehabilitation Center', 1, NULL, NULL, N'372017', NULL, NULL, 0, 60, NULL, N'5803269200', N'5803268876', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2815 East Jackson', N'Hugo', N'OK', N'40023', N'74743', 34.017861, -95.539293, 3352, 261, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4499, N'Post Acute Medical Specialty Hospital Of Tulsa', 1, NULL, NULL, N'372018', NULL, NULL, 0, 60, NULL, N'9186638183', N'9186605376', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3219 South 79Th East Avenue', N'Tulsa', N'OK', N'40143', N'74145', 36.115966, -95.890424, 2832, 220, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4500, N'Chg Cornerstone Hospital Of Oklahoma - Shawnee', 1, NULL, NULL, N'372019', NULL, NULL, 0, 34, NULL, N'4053955800', N'4053955802', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1900 Gordon Cooper Drive 2Nd Floor', N'Shawnee', N'OK', N'40125', N'74801', 35.327293, -96.9253, 2825, 219, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4501, N'Norman Specialty Hospital', 1, NULL, NULL, N'372021', NULL, NULL, 0, 50, NULL, N'4053218824', N'4057018010', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1210 West Robinson', N'Norman', N'OK', N'40027', N'73069', 35.222572, -97.439482, 2807, 219, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4502, N'Cornerstone Hospital Of Oklahoma- Muskogee', 1, NULL, NULL, N'372022', NULL, NULL, 0, 64, NULL, N'9186826161', N'9186826164', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'351 South 40Th Street', N'Muskogee', N'OK', N'40101', N'74401', 35.753649, -95.411709, 2806, 220, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4503, N'Muscogee (Creek) Nation Long Term Acute Care Hospi', 1, NULL, NULL, N'372023', NULL, NULL, 0, 4, NULL, N'9187569211', N'9187569452', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'900 East Airport Road', N'Okmulgee', N'OK', N'40111', N'74447', 35.667969, -95.960325, 2810, 220, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4504, N'Valir Rehabilitation Hospital Of O K C', 1, NULL, NULL, N'373025', NULL, NULL, 0, 81, NULL, N'4052363131', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'700 Northwest 7Th Street', N'Oklahoma City', N'OK', N'40109', N'73102', 35.475023, -97.514901, 2809, 219, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4505, N'Muscogee (Creek) Nation Physical Rehabilitation Ce', 1, NULL, NULL, N'373026', NULL, NULL, 0, 26, NULL, N'9187569211', N'9187569452', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'900 East Airport Road', N'Okmulgee', N'OK', N'40111', N'74447', 35.667969, -95.960325, 2810, 220, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4506, N'Mercy Rehabilitation Hospital Oklahoma City', 1, NULL, NULL, N'373033', NULL, NULL, 0, 50, NULL, N'4054342609', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5401 West Memorial Road', N'Oklahoma City', N'OK', N'40109', N'73142', 35.608869, -97.615865, 2809, 219, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4507, N'J D Mccarty Center For Children', 1, NULL, NULL, N'373300', NULL, NULL, 0, 36, NULL, N'4053072800', N'4053072801', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2002  East Robinson', N'Norman', N'OK', N'40027', N'73071', 35.222572, -97.439482, 2807, 219, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4508, N'The Children''s Center', 1, NULL, NULL, N'373302', NULL, NULL, 0, 120, NULL, N'4057896711', N'4057890690', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6800 Northwest 39Th Expressway', N'Bethany', N'OK', N'40109', N'73008', 35.512078, -97.63221, 2809, 219, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4509, N'Griffin Memorial Hospital', 1, NULL, NULL, N'374000', NULL, NULL, 0, 182, NULL, N'4053214880', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'900 East Main Street', N'Norman', N'OK', N'40027', N'73070', 35.225479, -97.432272, 2807, 219, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4510, N'Northwest Center For Behavioral Health (Ncbh)', 1, NULL, NULL, N'374001', NULL, NULL, 0, 130, NULL, N'5807662311', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'1 Mile East Us Highway 270', N'Fort Supply', N'OK', N'40153', N'73841', 36.573411, -99.574693, 2840, 219, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4511, N'Carl Albert Community Mental Health Center', 1, NULL, NULL, N'374006', NULL, NULL, 0, 15, NULL, N'9184267800', N'9184265521', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1101 East Monroe', N'Mcalester', N'OK', N'40121', N'74501', 34.933498, -95.769793, 2803, 220, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4512, N'Jim Taliaferro Comm Mental Health Ctr', 1, NULL, NULL, N'374008', NULL, NULL, 0, 30, NULL, N'5802485780', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'602 Southwest 38Th Street', N'Lawton', N'OK', N'40031', N'73505', 34.602791, -98.439681, 2798, 218, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4513, N'Brookhaven Hospital Inc', 1, NULL, NULL, N'374012', NULL, NULL, 0, 64, NULL, N'9184384257', N'9184388016', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'201 South Garnett Road', N'Tulsa', N'OK', N'40143', N'74128', 36.146068, -95.851036, 2832, 220, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4514, N'Rolling Hills Hospital Llc', 1, NULL, NULL, N'374016', NULL, NULL, 0, 60, NULL, N'5804363600', N'5804363958', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'1000 Rolling Hills Lane', N'Ada', N'OK', N'40123', N'74820', 34.784016, -96.629488, 2760, 219, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4515, N'Willow Crest Hospital', 1, NULL, NULL, N'374017', NULL, NULL, 0, 50, NULL, N'9185421836', N'9185428730', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'130 A Street Southwest', N'Miami', N'OK', N'40115', N'74354', 36.872285, -94.87879, 2804, 164, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4516, N'Laureate Psychiatric Clinic And Hospital Inc', 1, NULL, NULL, N'374020', NULL, NULL, 0, 90, NULL, N'9184814000', N'9184814063', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6655 South Yale Avenue', N'Tulsa', N'OK', N'40143', N'74136', 36.066445, -95.922042, 2832, 220, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4517, N'Parkside Inc', 1, NULL, NULL, N'374021', NULL, NULL, 0, 51, NULL, N'9185822131', N'9185888822', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1619 East 13Th Street', N'Tulsa', N'OK', N'40143', N'74120', 36.144315, -95.969192, 2832, 220, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4518, N'Cedar Ridge', 1, NULL, NULL, N'374023', NULL, NULL, 0, 60, NULL, N'4056056111', N'4056050457', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6501 Northeast 50Th Street', N'Oklahoma City', N'OK', N'40109', N'73141', 35.522411, -97.422971, 2809, 219, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4519, N'O U Medical Center', 1, NULL, NULL, N'379801', NULL, NULL, 0, 0, NULL, N'4052711773', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'1200 Everett Dr', N'Oklahoma City', N'OK', N'40109', N'73117', 35.605522, -97.454471, 2809, 219, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4520, N'St Anthony Hospital', 1, NULL, NULL, N'379802', NULL, NULL, 0, 0, NULL, N'4052727000', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'1000 North Lee Ave', N'Oklahoma City', N'OK', N'40109', N'73101', 35.477368, -97.524213, 2809, 219, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4521, N'Integris Baptist Medical Center', 1, NULL, NULL, N'379803', NULL, NULL, 0, 0, NULL, N'4059493011', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'3300 Northwest Expressway', N'Oklahoma City', N'OK', N'40109', N'73112', 35.567613, -97.660205, 2809, 219, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4522, N'St John Medical Center-Transplant', 1, NULL, NULL, N'379804', NULL, NULL, 0, 0, NULL, N'9187443537', N'9187443341', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'1923 S Utica Ave', N'Tulsa', N'OK', N'40143', N'74104', 36.134749, -95.967117, 2832, 220, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4523, N'Saint Francis Hospital', 1, NULL, NULL, N'379805', NULL, NULL, 0, 0, NULL, N'9184948467', N'9184946326', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'6161 South Yale Avenue', N'Tulsa', N'OK', N'40143', N'74136', 36.0751, -95.922039, 2832, 220, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4524, N'Ou Medical Center - Presbyterian Tower', 1, NULL, NULL, N'379806', NULL, NULL, 0, 0, NULL, N'4052717498', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'700 Ne 13Th Street', N'Oklahoma City', N'OK', N'40109', N'73104', 35.482262, -97.502757, 2809, 219, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4525, N'Mid-Columbia Medical Center', 1, NULL, NULL, N'380001', NULL, NULL, 0, 49, NULL, N'5412961111', N'5412967650', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1700 E 19Th Street', N'The Dalles', N'OR', N'41065', N'97058', 45.587801, -121.165555, 2883, 224, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4526, N'Asante Three Rivers Medical Center', 1, NULL, NULL, N'380002', NULL, NULL, 0, 150, NULL, N'5414727000', N'5414727317', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'500 Sw Ramsey Avenue', N'Grants Pass', N'OR', N'41033', N'97527', 42.439371, -123.327249, 2856, 223, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4527, N'Providence St Vincent Medical Center', 1, NULL, NULL, N'380004', NULL, NULL, 0, 523, NULL, N'5032161234', N'5032162468', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'9205 Sw Barnes Road', N'Portland', N'OR', N'41067', N'97225', 45.515786, -122.745592, 2875, 224, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4528, N'Asante Ashland Community Hospital', 1, NULL, NULL, N'380005', NULL, NULL, 0, 49, NULL, N'5412014001', N'5414887411', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'280 Maple Street', N'Ashland', N'OR', N'41029', N'97520', 42.205764, -122.724944, 2843, 223, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4529, N'Legacy Emanuel Medical Center', 1, NULL, NULL, N'380007', NULL, NULL, 0, 554, NULL, N'5034132200', N'5034133003', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2801 N Gantenbein Avenue', N'Portland', N'OR', N'41051', N'97227', 45.544516, -122.670157, 2875, 224, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4530, N'Ohsu Hospital And Clinics', 1, NULL, NULL, N'380009', NULL, NULL, 0, 560, NULL, N'5034944036', N'5034948020', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3181 Sw Sam Jackson Park Road', N'Portland', N'OR', N'41051', N'97239', 45.500563, -122.688027, 2875, 224, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4531, N'Good Samaritan Regional Medical Center', 1, NULL, NULL, N'380014', NULL, NULL, 0, 188, NULL, N'5417685111', N'5417685100', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3600 Nw Samaritan Drive', N'Corvallis', N'OR', N'41003', N'97330', 44.600548, -123.249488, 2849, 222, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4532, N'Legacy Good Samaritan Medical Center', 1, NULL, NULL, N'380017', NULL, NULL, 0, 539, NULL, N'5034137682', N'5034136347', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1015 Nw 22Nd Avenue W121', N'Portland', N'OR', N'41051', N'97210', 45.520247, -122.674195, 2875, 224, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4533, N'Asante Rogue Regional Medical Center', 1, NULL, NULL, N'380018', NULL, NULL, 0, 378, NULL, N'5417897000', N'5417895870', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2825 E Barnett Road', N'Medford', N'OR', N'41029', N'97504', 42.31656, -122.829928, 2869, 223, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4534, N'Mckenzie-Willamette Medical Center', 1, NULL, NULL, N'380020', NULL, NULL, 0, 113, NULL, N'5417264400', N'5417264540', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1460 G Street', N'Springfield', N'OR', N'41039', N'97477', 44.052487, -123.004133, 2882, 222, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4535, N'Tuality Community Hospital', 1, NULL, NULL, N'380021', NULL, NULL, 0, 215, NULL, N'5036811111', N'5036811608', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'335 Se 8Th Avenue', N'Hillsboro', N'OR', N'41067', N'97123', 45.519487, -122.978113, 2859, 224, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4536, N'Samaritan Albany General Hospital', 1, NULL, NULL, N'380022', NULL, NULL, 0, 79, NULL, N'5418124000', N'5418124447', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1046 6Th Avenue Sw', N'Albany', N'OR', N'41043', N'97321', 44.632022, -123.116411, 2842, 222, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4537, N'Legacy Mount Hood Medical Center', 1, NULL, NULL, N'380025', NULL, NULL, 0, 115, NULL, N'5036741122', N'5036741575', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'24800 Se Stark Street', N'Gresham', N'OR', N'41051', N'97030', 45.519088, -122.439265, 2875, 224, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4538, N'Mercy Medical Center', 1, NULL, NULL, N'380027', NULL, NULL, 0, 174, NULL, N'5416730611', N'5416772391', 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2700 Nw Stewart Parkway', N'Roseburg', N'OR', N'41019', N'97471', 43.240118, -123.366041, 2878, 222, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4539, N'Silverton Hospital', 1, NULL, NULL, N'380029', NULL, NULL, 0, 48, NULL, N'5038731500', N'5038731534', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'342 Fairview Street', N'Silverton', N'OR', N'41047', N'97381', 45.004043, -122.790627, 2881, 224, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4540, N'Sacred Heart University District', 1, NULL, NULL, N'380033', NULL, NULL, 0, 104, NULL, N'5416867300', N'5414347449', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1255 Hilyard Street', N'Eugene', N'OR', N'41039', N'97401', 44.046023, -123.082011, 2853, 222, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4541, N'Providence Newberg Medical Center', 1, NULL, NULL, N'380037', NULL, NULL, 0, 40, NULL, N'5035371555', N'5035371811', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1001 Providence Drive', N'Newberg', N'OR', N'41071', N'97132', 45.309911, -122.935473, 2870, 224, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4542, N'Providence Willamette Falls Medical Center', 1, NULL, NULL, N'380038', NULL, NULL, 0, 143, NULL, N'5036576915', N'5036506807', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1500 Division Street', N'Oregon City', N'OR', N'41005', N'97045', 45.356741, -122.588234, 2873, 224, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4543, N'St Charles Medical Center - Redmond', 1, NULL, NULL, N'380040', NULL, NULL, 0, 48, NULL, N'5415488131', N'5415266673', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1253 N Canal Blvd', N'Redmond', N'OR', N'41017', N'97756', 44.287753, -121.169017, 2877, 221, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4544, N'St Charles Medical Center - Bend', 1, NULL, NULL, N'380047', NULL, NULL, 0, 231, NULL, N'5413824321', N'5417065807', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2500 Ne Neff Road', N'Bend', N'OR', N'41017', N'97701', 44.065821, -121.270389, 2846, 221, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4545, N'Sky Lakes Medical Center', 1, NULL, NULL, N'380050', NULL, NULL, 0, 176, NULL, N'5412746150', N'5412746725', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2865 Daggett Avenue', N'Klamath Falls', N'OR', N'41035', N'97601', 42.252703, -121.786469, 2862, 223, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4546, N'Salem Hospital', 1, NULL, NULL, N'380051', NULL, NULL, 0, 434, NULL, N'5035615200', N'5035614844', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'890 Oak Street  Se', N'Salem', N'OR', N'41047', N'97301', 44.933125, -123.033644, 2879, 225, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4547, N'St Alphonsus Medical Center - Ontario Inc', 1, NULL, NULL, N'380052', NULL, NULL, 0, 49, NULL, N'5418817000', N'5418817184', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'351 Sw 9Th Street', N'Ontario', N'OR', N'41045', N'97914', 44.024789, -116.974809, 2872, 79, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4548, N'Santiam Memorial Hospital', 1, NULL, NULL, N'380056', NULL, NULL, 0, 40, NULL, N'5037692175', N'5037695877', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1401 N 10Th Avenue', N'Stayton', N'OR', N'41047', N'97383', 44.800678, -122.794533, 2879, 225, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4549, N'Adventist Medical Center', 1, NULL, NULL, N'380060', NULL, NULL, 0, 302, NULL, N'5032572500', N'5032616638', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'10123 Se Market Street', N'Portland', N'OR', N'41051', N'97216', 45.511339, -122.559381, 2875, 224, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4550, N'Providence Portland Medical Center', 1, NULL, NULL, N'380061', NULL, NULL, 0, 483, NULL, N'5032151111', N'5032156858', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4805 Ne Glisan Street', N'Portland', N'OR', N'41051', N'97213', 45.526572, -122.613845, 2875, 224, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4551, N'Willamette Valley Medical Center', 1, NULL, NULL, N'380071', NULL, NULL, 0, 88, NULL, N'5034726131', N'5034728691', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2700 Se Stratus Ave.', N'Mcminnville', N'OR', N'41071', N'97128', 45.200398, -123.165085, 2868, 224, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4552, N'Providence Medford Medical Center', 1, NULL, NULL, N'380075', NULL, NULL, 0, 168, NULL, N'5417325196', N'5417325872', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1111 Crater Lake Avenue', N'Medford', N'OR', N'41029', N'97504', 42.339546, -122.861147, 2869, 223, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4553, N'Providence Milwaukie Hospital', 1, NULL, NULL, N'380082', NULL, NULL, 0, 77, NULL, N'5035138336', N'5035138191', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'10150 Se 32Nd Avenue', N'Milwaukie', N'OR', N'41005', N'97222', 45.450091, -122.62991, 2875, 224, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4554, N'Legacy Meridian Park Medical Center', 1, NULL, NULL, N'380089', NULL, NULL, 0, 150, NULL, N'5036922182', N'5036910919', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'19300 Sw 65Th Avenue', N'Tualatin', N'OR', N'41067', N'97062', 45.380568, -122.74395, 2885, 224, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4555, N'Bay Area Hospital', 1, NULL, NULL, N'380090', NULL, NULL, 0, 172, NULL, N'5412698111', N'5412677057', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1775 Thompson Road', N'Coos Bay', N'OR', N'41011', N'97420', 43.385757, -124.232853, 2848, 222, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4556, N'Kaiser Sunnyside Medical Center', 1, NULL, NULL, N'380091', NULL, NULL, 0, 329, NULL, N'5035712880', N'5035712671', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'10180 Se Sunnyside Road', N'Clackamas', N'OR', N'41005', N'97015', 45.433447, -122.557935, 2875, 224, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4557, N'Sacred Heart Medical Center - Riverbend', 1, NULL, NULL, N'380102', NULL, NULL, 0, 347, NULL, N'5412227300', N'5412222006', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3333 Riverbend Drive', N'Springfield', N'OR', N'41039', N'97477', 44.080332, -123.028745, 2882, 222, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4558, N'Kaiser Foundation Hospital - Westside', 1, NULL, NULL, N'380103', NULL, NULL, 0, 122, NULL, N'9713105700', N'9713105701', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2875 Nw Stucki Ave', N'Hillsboro', N'OR', N'41067', N'97124', 45.538192, -122.876366, 2859, 224, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4559, N'Peacehealth Cottage Grove Community Medical Center', 1, NULL, NULL, N'381301', NULL, NULL, 0, 11, NULL, N'5417675500', N'5417675439', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1515 Village Drive', N'Cottage Grove', N'OR', N'41039', N'97424', 43.807261, -123.038565, 2850, 222, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4560, N'Samaritan North Lincoln Hospital', 1, NULL, NULL, N'381302', NULL, NULL, 0, 15, NULL, N'5419943661', N'5419967383', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3043 Ne 28Th Street', N'Lincoln City', N'OR', N'41041', N'97367', 44.985283, -123.99515, 2866, 224, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4561, N'Providence Seaside Hospital', 1, NULL, NULL, N'381303', NULL, NULL, 0, 34, NULL, N'5037177000', N'5037177505', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'725 S Wahanna Road', N'Seaside', N'OR', N'41007', N'97138', 45.991664, -123.912567, 2880, 224, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4562, N'Southern Coos Hospital & Health Center', 1, NULL, NULL, N'381304', NULL, NULL, 0, 24, NULL, N'5413472426', N'5413473923', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'900 11Th Street Se', N'Bandon', N'OR', N'41011', N'97411', 43.113142, -124.402869, 2848, 222, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4563, N'Blue Mountain Hospital', 1, NULL, NULL, N'381305', NULL, NULL, 0, 39, NULL, N'5415751311', N'5415750650', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'170 Ford Road', N'John Day', N'OR', N'41023', N'97845', 44.418242, -118.961341, 2861, 221, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4564, N'Wallowa Memorial Hospital', 1, NULL, NULL, N'381306', NULL, NULL, 0, 25, NULL, N'5414263111', N'5414261901', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'601 Medical Parkway', N'Enterprise', N'OR', N'41063', N'97828', 45.431715, -117.284632, 2852, 292, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4565, N'Harney District Hospital', 1, NULL, NULL, N'381307', NULL, NULL, 0, 44, NULL, N'5415737281', N'5415738627', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'557 W Washington Street', N'Burns', N'OR', N'41025', N'97720', 43.588647, -119.060754, 2847, 221, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4566, N'West Valley Hospital', 1, NULL, NULL, N'381308', NULL, NULL, 0, 25, NULL, N'5036238301', N'5038313485', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'525 Se Washington Street', N'Dallas', N'OR', N'41053', N'97338', 44.919459, -123.309808, 2851, 225, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4567, N'Lake District Hospital', 1, NULL, NULL, N'381309', NULL, NULL, 0, 21, NULL, N'5419472114', N'5419472433', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'700 South J Street', N'Lakeview', N'OR', N'41037', N'97630', 42.181434, -120.351516, 2864, 223, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4568, N'Pioneer Memorial Hospital', 1, NULL, NULL, N'381310', NULL, NULL, 0, 21, NULL, N'5416769133', N'5416762901', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'564 E Pioneer Drive', N'Heppner', N'OR', N'41049', N'97836', 45.356304, -119.549329, 2857, 224, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4569, N'Lower Umpqua Hospital District', 1, NULL, NULL, N'381311', NULL, NULL, 0, 24, NULL, N'5412712171', N'5412716380', 1, 1, 1, 0, 0, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'600 Ranch Road', N'Reedsport', N'OR', N'41019', N'97467', 43.695278, -124.135688, 2848, 222, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4570, N'Coquille Valley Hospital District', 1, NULL, NULL, N'381312', NULL, NULL, 0, 30, NULL, N'5413963101', N'5413961783', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'940 East 5Th Street', N'Coquille', N'OR', N'41011', N'97423', 43.179056, -124.179561, 2848, 222, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4571, N'Pioneer Memorial Hospital', 1, NULL, NULL, N'381313', NULL, NULL, 0, 35, NULL, N'5414476254', N'5414476705', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1201 Ne Elm Street', N'Prineville', N'OR', N'41013', N'97754', 44.310318, -120.842639, 2876, 221, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4572, N'Samaritan Pacific Community Hospital', 1, NULL, NULL, N'381314', NULL, NULL, 0, 48, NULL, N'5412652244', N'5415741832', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'930 Sw Abbey Street', N'Newport', N'OR', N'41041', N'97365', 44.629685, -124.058945, 2871, 224, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4573, N'St Alphonsus Medical Center - Baker City Inc', 1, NULL, NULL, N'381315', NULL, NULL, 0, 36, NULL, N'5415236461', N'5415238151', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3325 Pocahontas Road', N'Baker City', N'OR', N'41001', N'97814', 44.774875, -117.834385, 2845, 79, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4574, N'Peace Harbor Medical Center', 1, NULL, NULL, N'381316', NULL, NULL, 0, 21, NULL, N'5419978412', N'5419972913', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'400 9Th Street', N'Florence', N'OR', N'41039', N'97439', 43.974582, -124.11835, 2854, 222, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4575, N'Tillamook Regional Medical Center', 1, NULL, NULL, N'381317', NULL, NULL, 0, 49, NULL, N'5038424444', N'5038423062', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1000 Third Street', N'Tillamook', N'OR', N'41057', N'97141', 45.455921, -123.844429, 2884, 224, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4576, N'Providence Hood River Memorial Hospital', 1, NULL, NULL, N'381318', NULL, NULL, 0, 32, NULL, N'5413863911', N'5413876462', 1, 1, 1, 0, 0, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'810 12Th Street', N'Hood River', N'OR', N'41027', N'97031', 45.696507, -121.523662, 2860, 224, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4577, N'St Anthony Hospital', 1, NULL, NULL, N'381319', NULL, NULL, 0, 49, NULL, N'5412765121', N'5412783678', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2801 St Anthony Way', N'Pendleton', N'OR', N'41059', N'97801', 45.672075, -118.788597, 2874, 224, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4578, N'Columbia Memorial Hospital', 1, NULL, NULL, N'381320', NULL, NULL, 0, 49, NULL, N'5033254321', N'5033254042', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2111 Exchange Street', N'Astoria', N'OR', N'41007', N'97103', 46.188454, -123.818101, 2844, 224, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4579, N'Grande Ronde Hospital', 1, NULL, NULL, N'381321', NULL, NULL, 0, 49, NULL, N'5419638421', N'5419631476', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'900 Sunset Drive', N'La Grande', N'OR', N'41061', N'97850', 45.318104, -118.104416, 2863, 224, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4580, N'Curry General Hospital', 1, NULL, NULL, N'381322', NULL, NULL, 0, 24, NULL, N'5412473000', N'5412473101', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'94220 Fourth Street', N'Gold Beach', N'OR', N'41015', N'97444', 42.407333, -124.421774, 2855, 223, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4581, N'Samaritan Lebanon Community Hospital', 1, NULL, NULL, N'381323', NULL, NULL, 0, 49, NULL, N'5412582101', N'5414517862', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'525 N Santiam Highway', N'Lebanon', N'OR', N'41043', N'97355', 44.536512, -122.907034, 2865, 222, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4582, N'St Charles - Madras', 1, NULL, NULL, N'381324', NULL, NULL, 0, 36, NULL, N'5414604200', N'5414604014', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'470 Ne A Street', N'Madras', N'OR', N'41031', N'97741', 44.637467, -121.12043, 2867, 221, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4583, N'Good Shepherd Medical Center', 1, NULL, NULL, N'381325', NULL, NULL, 0, 49, NULL, N'5416673400', N'5416673414', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'610 Nw 11Th Street', N'Hermiston', N'OR', N'41059', N'97838', 45.846482, -119.310804, 2858, 224, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4584, N'Vibra Specialty Hospital Of Portland', 1, NULL, NULL, N'382004', NULL, NULL, 0, 73, NULL, N'5032575500', N'5032575673', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'10300 Ne Hancock Street', N'Portland', N'OR', N'41051', N'97220', 45.535736, -122.5564, 2875, 224, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4585, N'Shriners Hospital For Children-Portland', 1, NULL, NULL, N'383300', NULL, NULL, 0, 29, NULL, N'5032415090', N'5032213701', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3101 Sw Sam Jackson Park Road', N'Portland', N'OR', N'41051', N'97239', 45.501116, -122.684377, 2875, 224, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4586, N'Oregon State Hospital Distinct Part', 1, NULL, NULL, N'384008', NULL, NULL, 0, 604, NULL, N'5039452870', N'5039452900', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2600 Center Street Ne', N'Salem', N'OR', N'41047', N'97301', 44.942706, -123.034752, 2879, 225, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4587, N'Cedar Hills Hospital', 1, NULL, NULL, N'384012', NULL, NULL, 0, 78, NULL, N'5039445000', N'5039442224', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'10300 Sw Eastridge Street', N'Portland', N'OR', N'41067', N'97225', 45.520247, -122.674195, 2875, 224, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4588, N'Ohsu Transplant Hospital', 1, NULL, NULL, N'389800', NULL, NULL, 0, 0, NULL, N'5034946096', N'5034944725', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'3181 Sw Sam Jackson Park Road', N'Portland', N'OR', N'41051', N'97239', 45.500563, -122.688027, 2875, 224, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4589, N'Legacy Transplant Services', 1, NULL, NULL, N'389801', NULL, NULL, 0, 0, NULL, N'5034136722', N'5034136563', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'1015 Nw 22 Ave', N'Portland', N'OR', N'41051', N'97210', 45.520247, -122.674195, 2875, 224, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4590, N'Geisinger - Community Medical Center', 1, NULL, NULL, N'390001', NULL, NULL, 0, 297, NULL, N'5709698240', N'5709698951', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1822 Mulberry Street', N'Scranton', N'PA', N'42069', N'18510', 41.400739, -75.646061, 2984, 237, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4591, N'Upmc Mckeesport', 1, NULL, NULL, N'390002', NULL, NULL, 0, 200, NULL, N'4126642000', N'4126642600', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1500 Fifth Avenue', N'Mc Keesport', N'PA', N'42003', N'15132', 40.969989, -77.727883, 2954, 234, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4592, N'Geisinger - Bloomsburg Hospital', 1, NULL, NULL, N'390003', NULL, NULL, 0, 72, NULL, N'5703872100', N'5703872444', 1, 1, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'549 East Fair Street', N'Bloomsburg', N'PA', N'42037', N'17815', 41.00795, -76.454084, 2894, 228, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4593, N'Holy Spirit Hospital', 1, NULL, NULL, N'390004', NULL, NULL, 0, 315, NULL, N'7177632100', N'7177632180', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'503 North 21St Street', N'Camp Hill', N'PA', N'42041', N'17011', 40.250168, -76.922581, 2903, 230, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4594, N'Geisinger Medical Center', 1, NULL, NULL, N'390006', NULL, NULL, 0, 530, NULL, N'5702716211', N'5702716490', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'100 North Academy Avenue', N'Danville', N'PA', N'42093', N'17822', 40.966481, -76.613147, 2914, 228, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4595, N'Ellwood City Hospital', 1, NULL, NULL, N'390008', NULL, NULL, 0, 70, NULL, N'7247520081', N'7247520966', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'724 Pershing Street', N'Ellwood City', N'PA', N'42073', N'16117', 40.868305, -80.274546, 2921, 234, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4596, N'Saint Vincent Hospital', 1, NULL, NULL, N'390009', NULL, NULL, 0, 428, NULL, N'8144525000', N'8144525102', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'232 West 25Th Street', N'Erie', N'PA', N'42049', N'16544', 42.111194, -80.078779, 2923, 229, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4597, N'Lansdale Hospital', 1, NULL, NULL, N'390012', NULL, NULL, 0, 150, NULL, N'2153682100', N'2153614933', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'100 Medical Campus Drive', N'Lansdale', N'PA', N'42091', N'19446', 40.241495, -75.283786, 2945, 233, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4598, N'Evangelical Community Hospital', 1, NULL, NULL, N'390013', NULL, NULL, 0, 181, NULL, N'5705222200', N'5705222745', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'One Hospital Drive', N'Lewisburg', N'PA', N'42119', N'17837', 40.964529, -76.88441, 2949, 228, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4599, N'Jameson Memorial Hospital', 1, NULL, NULL, N'390016', NULL, NULL, 0, 175, NULL, N'7246589001', N'7246564241', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1211 Wilmington Avenue', N'New Castle', N'PA', N'42073', N'16105', 41.003672, -80.347009, 2964, 217, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4600, N'Palmerton Hospital', 1, NULL, NULL, N'390019', NULL, NULL, 0, 70, NULL, N'6108263141', N'6108261282', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'135 Lafayette Avenue', N'Palmerton', N'PA', N'42025', N'18071', 40.802343, -75.615068, 2967, 226, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4601, N'Kensington Hospital', 1, NULL, NULL, N'390025', NULL, NULL, 0, 45, NULL, N'2154268100', NULL, 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'136 W Diamond Street', N'Philadelphia', N'PA', N'42101', N'19122', 39.985148, -75.159811, 2970, 233, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4602, N'Chestnut Hill Hospital', 1, NULL, NULL, N'390026', NULL, NULL, 0, 179, NULL, N'2152488200', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'8835 Germantown Ave', N'Philadelphia', N'PA', N'42101', N'19118', 40.07953, -75.214413, 2970, 233, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4603, N'Temple University Hospital', 1, NULL, NULL, N'390027', NULL, NULL, 0, 677, NULL, N'2157072000', N'2157077351', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3401 North Broad Street', N'Philadelphia', N'PA', N'42101', N'19140', 40.004797, -75.152104, 2970, 233, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4604, N'Upmc Mercy', 1, NULL, NULL, N'390028', NULL, NULL, 0, 605, NULL, N'4122328111', N'4122327380', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1400 Locust Street', N'Pittsburgh', N'PA', N'42003', N'15219', 40.436737, -79.985049, 2973, 234, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4605, N'Schuylkill Medical Center - South Jackson Street', 1, NULL, NULL, N'390030', NULL, NULL, 0, 180, NULL, N'5706215000', N'5706228221', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'420 South Jackson Street', N'Pottsville', N'PA', N'42107', N'17901', 40.68378, -76.188905, 2975, 235, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4606, N'Schuylkill Medical Center - East Norwegian Street', 1, NULL, NULL, N'390031', NULL, NULL, 0, 174, NULL, N'5706214000', N'5706227950', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'700 East Norwegian Street', N'Pottsville', N'PA', N'42107', N'17901', 40.690312, -76.187762, 2975, 235, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4607, N'Allegheny Valley Hospital', 1, NULL, NULL, N'390032', NULL, NULL, 0, 250, NULL, N'4122245100', N'7242267490', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1301 Carlisle St', N'Natrona', N'PA', N'42003', N'15065', 40.618449, -79.734741, 2963, 234, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4608, N'St Luke''s Quakertown Hospital', 1, NULL, NULL, N'390035', NULL, NULL, 0, 62, NULL, N'2155384500', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1021 Park Avenue', N'Quakertown', N'PA', N'42017', N'18951', 40.437954, -75.349568, 2977, 226, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4609, N'Heritage Valley Beaver', 1, NULL, NULL, N'390036', NULL, NULL, 0, 361, NULL, N'4127287000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1000 Dutch Ridge Road', N'Beaver', N'PA', N'42007', N'15009', 40.709412, -80.322823, 2891, 234, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4610, N'Heritage Valley Sewickley', 1, NULL, NULL, N'390037', NULL, NULL, 0, 186, NULL, N'4127416600', N'4127497400', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'720 Blackburn Road', N'Sewickley', N'PA', N'42003', N'15143', 40.543321, -80.178923, 2986, 234, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4611, N'Somerset Hospital', 1, NULL, NULL, N'390039', NULL, NULL, 0, 111, NULL, N'8144435000', N'8144434937', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'225 South Center Avenue', N'Somerset', N'PA', N'42111', N'15501', 40.006907, -79.07852, 2989, 231, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4612, N'Uniontown Hospital', 1, NULL, NULL, N'390041', NULL, NULL, 0, 190, NULL, N'7244305000', N'7244303342', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'500 West Berkeley Street', N'Uniontown', N'PA', N'42051', N'15401', 39.897295, -79.731852, 3000, 234, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4613, N'Washington Hospital The', 1, NULL, NULL, N'390042', NULL, NULL, 0, 265, NULL, N'7242257000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'155 Wilson Avenue', N'Washington', N'PA', N'42125', N'15301', 40.182986, -80.247781, 3004, 234, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4614, N'Soldiers And Sailors Memorial Hospital', 1, NULL, NULL, N'390043', NULL, NULL, 0, 103, NULL, N'5707241631', N'5707242126', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'32-36 Central Avenue', N'Wellsboro', N'PA', N'42117', N'16901', 41.745198, -77.298968, 3007, 236, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4615, N'Reading Hospital', 1, NULL, NULL, N'390044', NULL, NULL, 0, 639, NULL, N'6109888000', N'6109885192', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Sixth Avenue And Spruce St', N'Reading', N'PA', N'42011', N'19603', 40.335345, -75.927949, 2978, 235, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4616, N'Williamsport Regional Medical Center', 1, NULL, NULL, N'390045', NULL, NULL, 0, 238, NULL, N'5703211000', N'5703213719', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'700 High Street', N'Williamsport', N'PA', N'42081', N'17701', 41.245539, -77.014543, 3011, 228, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4617, N'York Hospital', 1, NULL, NULL, N'390046', NULL, NULL, 0, 572, NULL, N'7178512345', N'7178513020', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1001 South George Street', N'York', N'PA', N'42133', N'17403', 39.945869, -76.718464, 3013, 239, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4618, N'Lewistown Hospital', 1, NULL, NULL, N'390048', NULL, NULL, 0, 244, NULL, N'7172485411', N'7172427132', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'400 Highland Avenue', N'Lewistown', N'PA', N'42087', N'17044', 40.59924, -77.571382, 2950, 230, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4619, N'St Luke''s Hospital Bethlehem', 1, NULL, NULL, N'390049', NULL, NULL, 0, 638, NULL, N'6109544000', NULL, 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'801 Ostrum Street', N'Bethlehem', N'PA', N'42095', N'18015', -1.45056, -48.468245, 2893, 226, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4620, N'Allegheny General Hospital', 1, NULL, NULL, N'390050', NULL, NULL, 0, 829, NULL, N'4123593131', N'4123593888', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'320 East North Avenue', N'Pittsburgh', N'PA', N'42003', N'15212', 40.456725, -80.003245, 2973, 234, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4621, N'Clearfield Hospital', 1, NULL, NULL, N'390052', NULL, NULL, 0, 89, NULL, N'8147682497', N'8147682421', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'809 Turnpike Ave', N'Clearfield', N'PA', N'42033', N'16830', 41.03313, -78.449953, 2909, 227, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4622, N'J C Blair Memorial Hospital', 1, NULL, NULL, N'390056', NULL, NULL, 0, 100, NULL, N'8146432290', N'8146439718', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1225 Warm Springs Ave', N'Huntingdon', N'PA', N'42061', N'16652', 40.493318, -78.014046, 2935, 227, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4623, N'Grand View Hospital', 1, NULL, NULL, N'390057', NULL, NULL, 0, 250, NULL, N'2154534615', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'700 Lawn Avenue', N'Sellersville', N'PA', N'42017', N'18960', 40.36243, -75.324125, 2985, 226, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4624, N'Carlisle Regional Medical Center', 1, NULL, NULL, N'390058', NULL, NULL, 0, 165, NULL, N'7172491212', N'7172490770', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'361 Alexander Spring Road', N'Carlisle', N'PA', N'42041', N'17015', 40.201824, -77.189389, 2906, 230, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4625, N'Lancaster Regional Medical Center', 1, NULL, NULL, N'390061', NULL, NULL, 0, 290, NULL, N'7172918123', N'7172918090', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'250 College Avenue', N'Lancaster', N'PA', N'42071', N'17604', 40.040533, -76.320776, 2943, 232, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4626, N'Nason Hospital', 1, NULL, NULL, N'390062', NULL, NULL, 0, 42, NULL, N'8142242141', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'105 Nason Drive', N'Roaring Spring', N'PA', N'42013', N'16673', 40.337686, -78.387004, 2982, 227, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4627, N'Upmc Hamot', 1, NULL, NULL, N'390063', NULL, NULL, 0, 343, NULL, N'8148776000', N'8148774150', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'201 State Street', N'Erie', N'PA', N'42049', N'16550', 42.133261, -80.087652, 2923, 229, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4628, N'Gettysburg Hospital', 1, NULL, NULL, N'390065', NULL, NULL, 0, 76, NULL, N'7173342121', N'7173374142', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'147 Gettys Street', N'Gettysburg', N'PA', N'42001', N'17325', 39.823359, -77.233809, 2926, 230, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4629, N'Good Samaritan Hospital', 1, NULL, NULL, N'390066', NULL, NULL, 0, 196, NULL, N'7172707500', N'7172702239', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Fourth And Walnut Streets', N'Lebanon', N'PA', N'42075', N'17042', 40.34655, -76.428381, 2947, 230, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4630, N'Pinnacle Health Hospitals', 1, NULL, NULL, N'390067', NULL, NULL, 0, 717, NULL, N'7177825181', N'7172318860', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'409 South Second Street', N'Harrisburg', N'PA', N'42043', N'17105', 40.266311, -76.886112, 2931, 230, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4631, N'Heart Of Lancaster Regional Medical Center', 1, NULL, NULL, N'390068', NULL, NULL, 0, 206, NULL, N'7176255000', N'7172394301', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1500 Highlands Drive', N'Lititz', N'PA', N'42071', N'17543', 40.157127, -76.307167, 2943, 232, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4632, N'Lower Bucks Hospital', 1, NULL, NULL, N'390070', NULL, NULL, 0, 186, NULL, N'2157859200', N'2157859175', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'501 Bath Road', N'Bristol', N'PA', N'42017', N'19007', 40.104284, -74.864818, 2897, 233, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4633, N'Lock Haven Hospital', 1, NULL, NULL, N'390071', NULL, NULL, 0, 47, NULL, N'5708935000', N'5708935172', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'24 Cree Drive', N'Lock Haven', N'PA', N'42035', N'17745', 41.132668, -77.47035, 2951, 228, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4634, N'Berwick Hospital Center', 1, NULL, NULL, N'390072', NULL, NULL, 0, 130, NULL, N'5707595000', N'5707593473', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'701 East 16Th Street', N'Berwick', N'PA', N'42037', N'18603', 41.060202, -76.246126, 2892, 228, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4635, N'Upmc Altoona', 1, NULL, NULL, N'390073', NULL, NULL, 0, 433, NULL, N'8148892011', N'8148897808', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'620 Howard Avenue', N'Altoona', N'PA', N'42013', N'16601', 40.521448, -78.398019, 2889, 227, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4636, N'Brandywine Hospital', 1, NULL, NULL, N'390076', NULL, NULL, 0, 208, NULL, N'6103838000', N'6103838360', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'201 Reeceville Road', N'Coatesville', N'PA', N'42029', N'19320', 39.983162, -75.823835, 2902, 232, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4637, N'Robert Packer Hospital', 1, NULL, NULL, N'390079', NULL, NULL, 0, 366, NULL, N'5708886666', N'5708825091', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'One Guthrie Square', N'Sayre', N'PA', N'42015', N'18840', 41.978963, -76.515499, 2983, 236, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4638, N'Jeanes Hospital', 1, NULL, NULL, N'390080', NULL, NULL, 0, 176, NULL, N'2157282000', N'2157282026', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7600 Central Avenue', N'Philadelphia', N'PA', N'42101', N'19111', 40.06839, -75.087231, 2970, 233, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4639, N'Delaware County Memorial Hospital', 1, NULL, NULL, N'390081', NULL, NULL, 0, 247, NULL, N'2152848100', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'501 North Lansdowne Ave', N'Drexel Hill', N'PA', N'42045', N'19026', 39.954017, -75.283907, 2917, 233, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4640, N'Sunbury Community Hospital', 1, NULL, NULL, N'390084', NULL, NULL, 0, 96, NULL, N'5702863333', N'5708632128', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'350 North 11Th Street', N'Sunbury', N'PA', N'42097', N'17801', 40.861975, -76.793625, 2993, 228, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4641, N'Penn Highlands Dubois', 1, NULL, NULL, N'390086', NULL, NULL, 0, 250, NULL, N'8143712200', N'8143753488', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'100 Hospital Avenue', N'Dubois', N'PA', N'42033', N'15801', 41.113969, -78.774935, 2918, 234, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4642, N'Western Pennsylvania Hospital', 1, NULL, NULL, N'390090', NULL, NULL, 0, 500, NULL, N'4125785000', N'4125784441', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4800 Friendship Avenue', N'Pittsburgh', N'PA', N'42003', N'15224', 40.461511, -79.946343, 2973, 234, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4643, N'Upmc Northwest', 1, NULL, NULL, N'390091', NULL, NULL, 0, 173, NULL, N'8146767600', N'8146767150', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'100 Fairfield Drive', N'Seneca', N'PA', N'42121', N'16346', 41.378671, -79.70394, 2925, 229, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4644, N'Clarion Hospital', 1, NULL, NULL, N'390093', NULL, NULL, 0, 82, NULL, N'8142269500', N'8142261224', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'271 Perkins Road', N'Clarion', N'PA', N'42031', N'16214', 41.190034, -79.39833, 2908, 234, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4645, N'St Joseph Medical Center', 1, NULL, NULL, N'390096', NULL, NULL, 0, 240, NULL, N'6103782300', N'6103782798', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2500 Bernville Road', N'Reading', N'PA', N'42011', N'19605', 40.335345, -75.927949, 2978, 235, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4646, N'Holy Redeemer Hospital And Medical Center', 1, NULL, NULL, N'390097', NULL, NULL, 0, 268, NULL, N'2159473000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1648 Huntingdon Pike', N'Meadowbrook', N'PA', N'42091', N'19046', 40.10894, -75.081256, 2886, 233, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4647, N'Lancaster General Hospital', 1, NULL, NULL, N'390100', NULL, NULL, 0, 463, NULL, N'7172995511', N'7172904189', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'555 North Duke Street', N'Lancaster', N'PA', N'42071', N'17604', 40.044583, -76.304896, 2943, 232, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4648, N'Memorial Hospital', 1, NULL, NULL, N'390101', NULL, NULL, 0, 150, NULL, N'7178438623', N'7178495329', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'325 South Belmont Street', N'York', N'PA', N'42133', N'17403', 39.970029, -76.694365, 3013, 239, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4649, N'Upmc St Margaret', 1, NULL, NULL, N'390102', NULL, NULL, 0, 237, NULL, N'4127844000', N'4127844008', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'815 Freeport Road', N'Pittsburgh', N'PA', N'42003', N'15215', 40.48886, -79.896068, 2973, 234, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4650, N'Kane Community Hospital', 1, NULL, NULL, N'390104', NULL, NULL, 0, 31, NULL, N'8148378585', N'8148377992', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4372 Route 6', N'Kane', N'PA', N'42083', N'16735', 41.662839, -78.811143, 2940, 229, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4651, N'Upmc Passavant', 1, NULL, NULL, N'390107', NULL, NULL, 0, 346, NULL, N'4123676700', N'4123676527', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'9100 Babcock Boulevard', N'Pittsburgh', N'PA', N'42003', N'15237', 40.441694, -79.990086, 2973, 234, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4652, N'Memorial Medical Center', 1, NULL, NULL, N'390110', NULL, NULL, 0, 486, NULL, N'8145349000', N'8145346121', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1086 Franklin Street', N'Johnstown', N'PA', N'42021', N'15905', 40.305122, -78.918567, 2939, 231, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4653, N'Hospital Of Univ Of Pennsylvania', 1, NULL, NULL, N'390111', NULL, NULL, 0, 782, NULL, N'2156623227', NULL, 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'34Th & Spruce Sts', N'Philadelphia', N'PA', N'42101', N'19104', 39.952335, -75.163789, 2970, 233, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4654, N'Windber Hospital', 1, NULL, NULL, N'390112', NULL, NULL, 0, 54, NULL, N'8144673000', N'8144673451', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'600 Somerset Avenue', N'Windber', N'PA', N'42111', N'15963', 40.24195, -78.837877, 3012, 231, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4655, N'Meadville Medical Center', 1, NULL, NULL, N'390113', NULL, NULL, 0, 217, NULL, N'8143335000', N'8143335496', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'751 Liberty Street', N'Meadville', N'PA', N'42039', N'16335', 41.641811, -80.146218, 2955, 229, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4656, N'Magee Womens Hospital Of Upmc Health System', 1, NULL, NULL, N'390114', NULL, NULL, 0, 341, NULL, N'4126414010', N'4126411221', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'300 Halket Street', N'Pittsburgh', N'PA', N'42003', N'15213', 40.436908, -79.961364, 2973, 234, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4657, N'Aria Health', 1, NULL, NULL, N'390115', NULL, NULL, 0, 557, NULL, N'2156124129', N'2156124942', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'10800 Knights Road', N'Philadelphia', N'PA', N'42101', N'19114', 40.069651, -74.981657, 2970, 233, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4658, N'Mercy Suburban Hospital', 1, NULL, NULL, N'390116', NULL, NULL, 0, 130, NULL, N'2152782000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2701 Dekalb Pike', N'Norristown', N'PA', N'42091', N'19401', 40.129522, -75.324639, 2966, 233, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4659, N'Upmc Bedford Memorial', 1, NULL, NULL, N'390117', NULL, NULL, 0, 95, NULL, N'8146236161', N'8146237202', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'10455 Lincoln Highway', N'Everett', N'PA', N'42009', N'15537', 40.011471, -78.373348, 2924, 227, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4660, N'Bradford Regional Medical Center', 1, NULL, NULL, N'390118', NULL, NULL, 0, 109, NULL, N'8143684143', N'8143685722', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'116 Interstate Parkway', N'Bradford', N'PA', N'42083', N'16701', 41.960926, -78.660005, 2896, 229, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4661, N'Moses Taylor Hospital', 1, NULL, NULL, N'390119', NULL, NULL, 0, 290, NULL, N'5703402100', N'5709692629', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'700 Quincy Avenue', N'Scranton', N'PA', N'42069', N'18510', 41.413758, -75.647443, 2984, 237, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4662, N'Pottstown Memorial Medical Center', 1, NULL, NULL, N'390123', NULL, NULL, 0, 205, NULL, N'6103277000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1600 East High Street And Armand Hammer Blvd', N'Pottstown', N'PA', N'42091', N'19464', 40.245298, -75.649642, 2974, 235, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4663, N'Wayne Memorial Hospital', 1, NULL, NULL, N'390125', NULL, NULL, 0, 112, NULL, N'5702538100', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'601 Park Street', N'Honesdale', N'PA', N'42127', N'18431', 41.578429, -75.254571, 2934, 237, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4664, N'Phoenixville Hospital', 1, NULL, NULL, N'390127', NULL, NULL, 0, 206, NULL, N'6109831000', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'140 Nutt Road', N'Phoenixville', N'PA', N'42029', N'19460', 40.1238, -75.51359, 2972, 233, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4665, N'Miners Medical Center', 1, NULL, NULL, N'390130', NULL, NULL, 0, 30, NULL, N'8142473100', N'8142473119', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'290 Haida Avenue', N'Hastings', N'PA', N'42021', N'16646', 40.658955, -78.706817, 2990, 231, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4666, N'St Joseph''s Hospital', 1, NULL, NULL, N'390132', NULL, NULL, 0, 146, NULL, N'2157872000', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1600 West Girard Avenue', N'Philadelphia', N'PA', N'42101', N'19130', 39.971649, -75.163561, 2970, 233, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4667, N'Lehigh Valley Hospital', 1, NULL, NULL, N'390133', NULL, NULL, 0, 797, NULL, N'6104022273', NULL, 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1200 South Cedar Crest Boulvard', N'Allentown', N'PA', N'42077', N'18105', 40.602206, -75.471279, 2888, 226, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4668, N'Wilkes-Barre General Hospital', 1, NULL, NULL, N'390137', NULL, NULL, 0, 412, NULL, N'5708298111', N'5705523030', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'575 North River Street', N'Wilkes-Barre', N'PA', N'42079', N'18764', 41.258564, -75.867968, 3010, 238, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4669, N'Waynesboro Hospital', 1, NULL, NULL, N'390138', NULL, NULL, 0, 69, NULL, N'7177654000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'501 East Main St', N'Waynesboro', N'PA', N'42055', N'17268', 39.754494, -77.575648, 3005, 230, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4670, N'Main Line Hospital Bryn Mawr Campus', 1, NULL, NULL, N'390139', NULL, NULL, 0, 320, NULL, N'6105263000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'130 South Bryn Mawr Ave', N'Bryn Mawr', N'PA', N'42045', N'19010', 40.018903, -75.320182, 2900, 233, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4671, N'Albert Einstein Medical Center', 1, NULL, NULL, N'390142', NULL, NULL, 0, 783, NULL, N'2154566090', N'2154566199', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5501 Old York Road', N'Philadelphia', N'PA', N'42101', N'19141', 40.015874, -75.147201, 2970, 233, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4672, N'Excela Health Westmoreland Hospital', 1, NULL, NULL, N'390145', NULL, NULL, 0, 364, NULL, N'4128325050', N'4128325051', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'532 West Pittsburgh Street', N'Greensburg', N'PA', N'42129', N'15601', 40.30096, -79.554516, 2927, 234, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4673, N'Warren General Hospital', 1, NULL, NULL, N'390146', NULL, NULL, 0, 87, NULL, N'8147233300', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Two Crescent Park West', N'Warren', N'PA', N'42123', N'16365', 41.843949, -79.145044, 3003, 229, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4674, N'Monongahela Valley Hospital', 1, NULL, NULL, N'390147', NULL, NULL, 0, 222, NULL, N'7242581000', N'7242581365', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1163 Country Club Road', N'Monongahela', N'PA', N'42125', N'15063', 40.192362, -79.915243, 2958, 234, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4675, N'Southwest Regional Medical Center', 1, NULL, NULL, N'390150', NULL, NULL, 0, 69, NULL, N'7246272602', N'7246277639', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'350 Bonar Avenue', N'Waynesburg', N'PA', N'42059', N'15370', 39.896464, -80.17923, 3006, 297, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4676, N'Chambersburg Hospital', 1, NULL, NULL, N'390151', NULL, NULL, 0, 217, NULL, N'7172673000', N'7172677704', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'112 North Seventh Street', N'Chambersburg', N'PA', N'42055', N'17201', 39.94059, -77.659862, 2907, 230, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4677, N'Main Line Hospital Paoli', 1, NULL, NULL, N'390153', NULL, NULL, 0, 157, NULL, N'6106481000', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'255 West Lancaster Avenue', N'Paoli', N'PA', N'42029', N'19301', 40.043129, -75.509637, 2968, 233, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4678, N'Penn Highlands Elk', 1, NULL, NULL, N'390154', NULL, NULL, 0, 80, NULL, N'8147888000', N'8147888040', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'763 Johnsonburg Road', N'St Marys', N'PA', N'42047', N'15857', 41.425239, -78.575669, 2991, 229, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4679, N'Mercy Fitzgerald Hospital', 1, NULL, NULL, N'390156', NULL, NULL, 0, 447, NULL, N'2152374000', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Lansdowne & Baily Rds', N'Darby', N'PA', N'42045', N'19023', 39.918446, -75.259072, 2915, 233, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4680, N'Ohio Valley General Hospital', 1, NULL, NULL, N'390157', NULL, NULL, 0, 138, NULL, N'4127776161', N'4127776189', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'25 Heckel Road', N'Mckees Rocks', N'PA', N'42003', N'15136', 40.465624, -80.065611, 2953, 234, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4681, N'Canonsburg General Hospital', 1, NULL, NULL, N'390160', NULL, NULL, 0, 104, NULL, N'7248735892', N'7247437211', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'100 Medical Boulevard', N'Canonsburg', N'PA', N'42125', N'15317', 40.26257, -80.18728, 2904, 234, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4682, N'Easton Hospital', 1, NULL, NULL, N'390162', NULL, NULL, 0, 254, NULL, N'6102504076', N'6102504957', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'250 South 21St Street', N'Easton', N'PA', N'42095', N'18042', 40.691608, -75.209987, 2920, 226, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4683, N'Acmh Hospital', 1, NULL, NULL, N'390163', NULL, NULL, 0, 154, NULL, N'7245438500', N'7245438535', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'One Nolte Drive', N'Kittanning', N'PA', N'42005', N'16201', 40.816453, -79.521989, 2942, 234, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4684, N'Upmc Presbyterian Shadyside', 1, NULL, NULL, N'390164', NULL, NULL, 0, 1571, NULL, N'4126478788', N'4126475551', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'200 Lothrop Street', N'Pittsburgh', N'PA', N'42003', N'15213', 40.442627, -79.960432, 2973, 234, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4685, N'Butler Memorial Hospital', 1, NULL, NULL, N'390168', NULL, NULL, 0, 296, NULL, N'7242836666', N'7242844645', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'One Hospital Way', N'Butler', N'PA', N'42019', N'16001', 40.861021, -79.895225, 2901, 234, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4686, N'Indiana Regional Medical Center', 1, NULL, NULL, N'390173', NULL, NULL, 0, 164, NULL, N'7243577000', NULL, 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'835 Hospital Road', N'Indiana', N'PA', N'42063', N'15701', 40.608034, -79.158883, 2936, 234, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4687, N'Thomas Jefferson University Hospital', 1, NULL, NULL, N'390174', NULL, NULL, 0, 925, NULL, N'2159556000', NULL, 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'111 South 11Th Street', N'Philadelphia', N'PA', N'42101', N'19107', 39.949836, -75.158565, 2970, 233, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4688, N'Upmc Horizon', 1, NULL, NULL, N'390178', NULL, NULL, 0, 201, NULL, N'7245882100', N'7245882289', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'110 North Main Street', N'Greenville', N'PA', N'42085', N'16125', 41.41063, -80.374583, 2928, 229, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4689, N'Chester County Hospital', 1, NULL, NULL, N'390179', NULL, NULL, 0, 263, NULL, N'6104315000', N'6107382554', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'701 East Marshall Street', N'West Chester', N'PA', N'42029', N'19380', 39.970548, -75.601376, 3008, 233, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4690, N'Crozer Chester Medical Center', 1, NULL, NULL, N'390180', NULL, NULL, 0, 672, NULL, N'6104472000', NULL, 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'One Medical Center Boulevard', N'Upland', N'PA', N'42045', N'19013', 39.852612, -75.382692, 3001, 233, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4691, N'St Luke''s Miners Memorial Hospital', 1, NULL, NULL, N'390183', NULL, NULL, 0, 108, NULL, N'5706452131', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'360 W Ruddle Street', N'Coaldale', N'PA', N'42107', N'18218', 40.821301, -75.91404, 2910, 226, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4692, N'Highlands Hospital', 1, NULL, NULL, N'390184', NULL, NULL, 0, 71, NULL, N'7246281500', N'7246262334', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'401 East Murphy Avenue', N'Connellsville', N'PA', N'42051', N'15425', 40.023111, -79.587203, 2911, 234, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4693, N'Lehigh Valley Hospital - Hazleton', 1, NULL, NULL, N'390185', NULL, NULL, 0, 120, NULL, N'5705014000', N'5705016203', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'700 East Broad Street', N'Hazleton', N'PA', N'42079', N'18201', 40.950046, -75.962955, 2932, 226, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4694, N'Tyler Memorial Hospital', 1, NULL, NULL, N'390192', NULL, NULL, 0, 60, NULL, N'5708362161', N'5708367057', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5950 State Route 6 West', N'Tunkhannock', N'PA', N'42131', N'18657', 41.538688, -75.946588, 2997, 236, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4695, N'Gnaden Huetten Memorial Hospital', 1, NULL, NULL, N'390194', NULL, NULL, 0, 105, NULL, N'6073771300', N'6103777920', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'211 North 12Th Street', N'Lehighton', N'PA', N'42025', N'18235', 40.832583, -75.726724, 2948, 226, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4696, N'Main Line Hospital Lankenau', 1, NULL, NULL, N'390195', NULL, NULL, 0, 331, NULL, N'6106452000', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'100 Lancaster Ave', N'Wynnewood', N'PA', N'42091', N'19096', 39.980803, -75.235689, 2970, 233, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4697, N'Hospital Of The Fox Chase Cancer Center', 1, NULL, NULL, N'390196', NULL, NULL, 0, 100, NULL, N'2157282660', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'333 Cottman Avenue', N'Philadelphia', N'PA', N'42101', N'19111', 40.066732, -75.092688, 2970, 233, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4698, N'Sacred Heart Hospital', 1, NULL, NULL, N'390197', NULL, NULL, 0, 215, NULL, N'6107764900', N'6107764559', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'421 Chew Street', N'Allentown', N'PA', N'42077', N'18102', 40.602206, -75.471279, 2888, 226, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4699, N'Millcreek Community Hospital', 1, NULL, NULL, N'390198', NULL, NULL, 0, 144, NULL, N'8148644031', N'8148688249', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5515 Peach Street', N'Erie', N'PA', N'42049', N'16509', 42.073876, -80.093567, 2923, 229, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4700, N'Punxsutawney Area Hospital', 1, NULL, NULL, N'390199', NULL, NULL, 0, 49, NULL, N'8149381800', N'8149381630', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'81 Hillcrest Drive', N'Punxsutawney', N'PA', N'42065', N'15767', 40.94363, -78.971078, 2976, 234, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4701, N'Pocono Medical Center', 1, NULL, NULL, N'390201', NULL, NULL, 0, 235, NULL, N'5704763348', N'5704763478', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'206 East Brown Street', N'East Stroudsburg', N'PA', N'42089', N'18301', 40.993131, -75.184514, 2919, 226, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4702, N'Doylestown Hospital', 1, NULL, NULL, N'390203', NULL, NULL, 0, 239, NULL, N'2153452200', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'595 West State St', N'Doylestown', N'PA', N'42017', N'18901', 40.305581, -75.146216, 2916, 233, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4703, N'Nazareth Hospital', 1, NULL, NULL, N'390204', NULL, NULL, 0, 203, NULL, N'2153356000', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2601 Holme Ave', N'Philadelphia', N'PA', N'42101', N'19152', 40.05832, -75.042664, 2970, 233, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4704, N'Sharon Regional Health System', 1, NULL, NULL, N'390211', NULL, NULL, 0, 201, NULL, N'7249833800', N'7249833958', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'740 East State Street', N'Sharon', N'PA', N'42085', N'16146', 41.232923, -80.505714, 2988, 217, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4705, N'Excela Health Frick Hospital', 1, NULL, NULL, N'390217', NULL, NULL, 0, 210, NULL, N'7245471500', N'7248321266', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'508 South Church Street', N'Mount Pleasant', N'PA', N'42129', N'15666', 40.145867, -79.548087, 2961, 234, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4706, N'Excela Health Latrobe Hospital', 1, NULL, NULL, N'390219', NULL, NULL, 0, 188, NULL, N'7245371000', N'7245371447', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'One Mellon Way', N'Latrobe', N'PA', N'42129', N'15650', 40.321181, -79.379481, 2946, 234, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4707, N'Jennersville Regional Hospital', 1, NULL, NULL, N'390220', NULL, NULL, 0, 59, NULL, N'6108691000', N'6108691362', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1015 West Baltimore Pike', N'West Grove', N'PA', N'42029', N'19390', 39.822054, -75.827441, 3009, 232, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4708, N'Riddle Memorial Hospital', 1, NULL, NULL, N'390222', NULL, NULL, 0, 212, NULL, N'6105669400', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1068 West Baltimore Pike', N'Media', N'PA', N'42045', N'19063', 39.916778, -75.387693, 2956, 233, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4709, N'Penn Presbyterian Medical Center', 1, NULL, NULL, N'390223', NULL, NULL, 0, 305, NULL, N'2156628000', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'51 North 39Th Street', N'Philadelphia', N'PA', N'42101', N'19104', 39.957199, -75.199443, 2970, 233, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4710, N'Ephrata Community Hospital', 1, NULL, NULL, N'390225', NULL, NULL, 0, 130, NULL, N'7177330311', N'7177836675', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'169 Martin Avenue', N'Ephrata', N'PA', N'42071', N'17522', 40.187196, -76.18441, 2922, 232, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4711, N'Pennsylvania Hosp Of The Univ Of Pa Health Sys', 1, NULL, NULL, N'390226', NULL, NULL, 0, 460, NULL, N'2158293000', N'2158293614', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'800 Spruce Street', N'Philadelphia', N'PA', N'42101', N'19107', 39.944912, -75.155642, 2970, 233, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4712, N'St Clair Memorial Hospital', 1, NULL, NULL, N'390228', NULL, NULL, 0, 328, NULL, N'4129426209', N'4129426219', 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1000 Bower Hill Road', N'Pittsburgh', N'PA', N'42003', N'15243', 40.441694, -79.990086, 2973, 234, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4713, N'Abington Memorial Hospital', 1, NULL, NULL, N'390231', NULL, NULL, 0, 880, NULL, N'2154812000', N'2154814014', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1200 Old York Road', N'Abington', N'PA', N'42091', N'19001', 40.117497, -75.120268, 2886, 233, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4714, N'Hanover Hospital', 1, NULL, NULL, N'390233', NULL, NULL, 0, 111, NULL, N'7176373711', N'7176332217', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'300 Highland Ave', N'Hanover', N'PA', N'42133', N'17331', 39.808088, -76.983578, 2930, 239, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4715, N'Memorial Hospital Inc  Towanda', 1, NULL, NULL, N'390236', NULL, NULL, 0, 41, NULL, N'5702652191', N'5702655763', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'91 Hospital Drive', N'Towanda', N'PA', N'42015', N'18848', 41.78371, -76.448909, 2996, 236, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4716, N'Regional Hospital Of Scranton', 1, NULL, NULL, N'390237', NULL, NULL, 0, 198, NULL, N'5703487100', NULL, 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'746 Jefferson Avenue', N'Scranton', N'PA', N'42069', N'18501', 41.41281, -75.653961, 2984, 237, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4717, N'Milton S Hershey Medical Center', 1, NULL, NULL, N'390256', NULL, NULL, 0, 504, NULL, N'7175318521', N'7175313991', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'500 University Drive', N'Hershey', N'PA', N'42043', N'17033', 40.263655, -76.67257, 2933, 230, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4718, N'St Mary Medical Center', 1, NULL, NULL, N'390258', NULL, NULL, 0, 287, NULL, N'2157502003', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Langhorne-Newtown Rd', N'Langhorne', N'PA', N'42017', N'19047', 40.200277, -74.929484, 2944, 233, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4719, N'Lehigh Valley Hospital - Muhlenberg', 1, NULL, NULL, N'390263', NULL, NULL, 0, 184, NULL, N'6104022273', NULL, 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2545 Schoenersville Road', N'Bethlehem', N'PA', N'42077', N'18017', 40.64486, -75.405081, 2893, 226, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4720, N'Jefferson Regional Medical Center', 1, NULL, NULL, N'390265', NULL, NULL, 0, 390, NULL, N'4124695000', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'565 Coal Valley Rd', N'Pittsburgh', N'PA', N'42003', N'15236', 40.441694, -79.990086, 2973, 234, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4721, N'Grove City Medical Center', 1, NULL, NULL, N'390266', NULL, NULL, 0, 90, NULL, N'7244507000', N'7244507179', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'631 North Broad Street Ext.', N'Grove City', N'PA', N'42085', N'16127', 41.157838, -80.08867, 2929, 234, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4722, N'Forbes Hospital', 1, NULL, NULL, N'390267', NULL, NULL, 0, 353, NULL, N'4128582000', N'4128582532', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2570 Haymaker Road', N'Monroeville', N'PA', N'42003', N'15146', 40.427982, -79.751173, 2959, 234, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4723, N'Mount Nittany Medical Center', 1, NULL, NULL, N'390268', NULL, NULL, 0, 260, NULL, N'8142317000', N'8142317200', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1800 East Park Ave', N'State College', N'PA', N'42027', N'16803', 40.805601, -77.864829, 2992, 228, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4724, N'Geisinger Wyoming Valley Medical Center', 1, NULL, NULL, N'390270', NULL, NULL, 0, 177, NULL, N'5708267300', NULL, 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1000 East Mountain Boulevard', N'Wilkes Barre', N'PA', N'42079', N'18711', 41.246482, -75.881732, 3010, 238, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4725, N'Valley Forge Medical Center And Hospital', 1, NULL, NULL, N'390272', NULL, NULL, 0, 67, NULL, N'2155398500', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1033 W Germantown Pike', N'Norristown', N'PA', N'42091', N'19401', 40.121497, -75.339905, 2966, 233, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4726, N'Eagleville Hospital', 1, NULL, NULL, N'390278', NULL, NULL, 0, 83, NULL, N'2155396000', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'100 Eagleville Rd', N'Eagleville', N'PA', N'42091', N'19408', 40.155285, -75.412102, 2966, 233, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4727, N'Hahnemann University Hospital', 1, NULL, NULL, N'390290', NULL, NULL, 0, 541, NULL, N'2157627000', NULL, 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'230 North Broad Street', N'Philadelphia', N'PA', N'42101', N'19102', 39.956754, -75.162818, 2970, 233, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4728, N'Barix Clinics Of Pennsylvania', 1, NULL, NULL, N'390302', NULL, NULL, 0, 47, NULL, N'2675723100', N'2675723113', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'280 Middletown Road', N'Langhorne', N'PA', N'42017', N'19047', 40.174554, -74.922666, 2944, 233, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4729, N'Roxborough Memorial Hospital', 1, NULL, NULL, N'390304', NULL, NULL, 0, 137, NULL, N'2154839900', N'2154874274', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5800 Ridge Ave', N'Philadelphia', N'PA', N'42101', N'19128', 40.063769, -75.239593, 2970, 233, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4730, N'Edgewood Surgical Hospital', 1, NULL, NULL, N'390307', NULL, NULL, 0, 10, NULL, N'7246460400', N'7246460413', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'239 Edgewood Drive Extension', N'Transfer', N'PA', N'42085', N'16154', 41.328944, -80.432846, 2928, 229, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4731, N'Cancer Treatment Centers Of America', 1, NULL, NULL, N'390312', NULL, NULL, 0, 22, NULL, N'2157446728', N'2157446715', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1331 East Wyoming Avenue', N'Philadelphia', N'PA', N'42101', N'19124', 40.018497, -75.099252, 2970, 233, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4732, N'Coordinated Health Orthopedic Hospital', 1, NULL, NULL, N'390314', NULL, NULL, 0, 20, NULL, N'6106914300', N'6106916257', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2310 Highland Avenue', N'Bethlehem', N'PA', N'42077', N'18017', 40.674198, -75.364756, 2893, 226, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4733, N'Surgical Institute Of Reading', 1, NULL, NULL, N'390316', NULL, NULL, 0, 15, NULL, N'7179999999', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2752 Century Boulevard', N'Wyomissing', N'PA', N'42011', N'19610', 40.329537, -75.965212, 2978, 235, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4734, N'Surgical Specialty Center At Coordinated Health', 1, NULL, NULL, N'390321', NULL, NULL, 0, 20, NULL, N'6108719110', N'6108415020', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1503 Cedar Crest Boulevard', N'Allentown', N'PA', N'42077', N'18104', 40.602206, -75.471279, 2888, 226, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4735, N'Bucks County Specialty Hospital', 1, NULL, NULL, N'390322', NULL, NULL, 0, 24, NULL, N'2152447400', N'2152447480', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3300 Tillman Drive', N'Bensalem', N'PA', N'42017', N'19020', 40.114043, -74.960342, 2970, 233, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4736, N'Advanced Surgical Hospital', 1, NULL, NULL, N'390323', NULL, NULL, 0, 32, NULL, N'7248840710', N'7248840722', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'100 Trich Drive', N'Washington', N'PA', N'42125', N'15301', 40.17396, -80.246171, 3004, 234, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4737, N'Physician''s Care Surgical Hospital', 1, NULL, NULL, N'390324', NULL, NULL, 0, 12, NULL, N'6104954793', N'6104953323', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'454 Enterprise Drive', N'Royersford', N'PA', N'42091', N'19468', 40.184269, -75.537964, 2972, 233, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4738, N'Oss Orthopaedic Hospital', 1, NULL, NULL, N'390325', NULL, NULL, 0, 38, NULL, N'7177182000', N'7177183640', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1861 Powder Mill Rd', N'York', N'PA', N'42133', N'17402', 39.917689, -76.697119, 3013, 239, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4739, N'St Luke''s Hospital - Anderson Campus', 1, NULL, NULL, N'390326', NULL, NULL, 0, 72, NULL, N'6109543850', N'6109546063', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1872 Riverside Circle', N'Easton', N'PA', N'42095', N'18045', 40.691608, -75.209987, 2920, 226, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4740, N'Wellspan Surgery And Rehabilitation Hospital', 1, NULL, NULL, N'390327', NULL, NULL, 0, 73, NULL, N'7178126100', N'7177472994', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'55 Monument Road', N'York', N'PA', N'42133', N'17403', 39.923267, -76.717191, 3013, 239, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4741, N'Upmc East', 1, NULL, NULL, N'390328', NULL, NULL, 0, 156, NULL, N'4123573000', N'4123723024', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2775 Mosside Boulevard', N'Monroeville', N'PA', N'42003', N'15146', 40.437612, -79.759667, 2959, 234, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4742, N'Einstein Medical Center Montgomery', 1, NULL, NULL, N'390329', NULL, NULL, 0, 146, NULL, N'4846621000', N'4846624261', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'559 West Germantown Pike', N'East Norriton', N'PA', N'42091', N'19403', 40.153654, -75.344971, 2966, 233, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4743, N'Jersey Shore Hospital', 1, NULL, NULL, N'391300', NULL, NULL, 0, 25, NULL, N'5703980100', N'5703984412', 1, 1, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1020 Thompson Street', N'Jersey Shore', N'PA', N'42081', N'17740', 41.201831, -77.268925, 2938, 228, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4744, N'Muncy Valley Hospital', 1, NULL, NULL, N'391301', NULL, NULL, 0, 20, NULL, N'5705468282', N'5705464150', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'215 East Water Street', N'Muncy', N'PA', N'42081', N'17756', 41.209539, -76.774428, 2962, 228, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4745, N'Meyersdale Medical Center', 1, NULL, NULL, N'391302', NULL, NULL, 0, 20, NULL, N'8146345911', N'8146340435', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'200 Hospital Drive', N'Myersdale', N'PA', N'42111', N'15552', 40.969989, -77.727883, 2957, 231, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4746, N'Fulton County Medical Center', 1, NULL, NULL, N'391303', NULL, NULL, 0, 21, NULL, N'7174853155', N'7174855605', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'214 Peach Orchard Road', N'Mcconnellsburg', N'PA', N'42057', N'17233', 39.932589, -77.998891, 2952, 230, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4747, N'Bucktail Medical Center', 1, NULL, NULL, N'391304', NULL, NULL, 0, 21, NULL, N'5709231000', N'5709230835', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1001 Pine Street', N'Renovo', N'PA', N'42035', N'17764', 41.32685, -77.738087, 2979, 228, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4748, N'Troy Community Hospital', 1, NULL, NULL, N'391305', NULL, NULL, 0, 25, NULL, N'5702972121', N'5702973970', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'275 Guthrie Drive', N'Troy', N'PA', N'42015', N'16947', 31.764098, -85.956653, 2983, 236, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4749, N'Endless Mountains Health Systems', 1, NULL, NULL, N'391306', NULL, NULL, 0, 25, NULL, N'5702783801', N'5702783648', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'100 Hospital Drive', N'Montrose', N'PA', N'42115', N'18801', 41.833965, -75.877139, 2960, 186, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4750, N'Tyrone Hospital', 1, NULL, NULL, N'391307', NULL, NULL, 0, 25, NULL, N'8146841255', N'8146846395', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'221 Hospital Drive', N'Tyrone', N'PA', N'42013', N'16686', 40.670551, -78.238348, 2998, 227, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4751, N'Corry Memorial Hospital', 1, NULL, NULL, N'391308', NULL, NULL, 0, 20, NULL, N'8146644641', N'8146647967', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'965 Shamrock Lane', N'Corry', N'PA', N'42049', N'16407', 41.920334, -79.640329, 2912, 229, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4752, N'Barnes-Kasson County Hospital', 1, NULL, NULL, N'391309', NULL, NULL, 0, 25, NULL, N'5708533135', N'5708533695', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2872 Turnpike Street', N'Susquehanna', N'PA', N'42115', N'18847', 41.92993, -75.590402, 2994, 237, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4753, N'Penn Highlands Brookville', 1, NULL, NULL, N'391312', NULL, NULL, 0, 35, NULL, N'8148492312', N'8148494841', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'100 Hospital Road', N'Brookville', N'PA', N'42065', N'15825', 41.156506, -79.092713, 2898, 234, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4754, N'Charles Cole Memorial Hospital', 1, NULL, NULL, N'391313', NULL, NULL, 0, 59, NULL, N'8142749301', N'8142740884', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1001 East Second Street', N'Coudersport', N'PA', N'42105', N'16915', 41.770121, -78.021039, 2913, 229, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4755, N'Titusville Hospital', 1, NULL, NULL, N'391314', NULL, NULL, 0, 25, NULL, N'8148271851', N'8148273099', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'406 West Oak Street', N'Titusville', N'PA', N'42039', N'16354', 41.633162, -79.679174, 2995, 229, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4756, N'Lifecare Hospitals Of Pittsburgh', 1, NULL, NULL, N'392024', NULL, NULL, 0, 196, NULL, N'4122472356', N'4122472333', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'225 Penn Avenue', N'Pittsburgh', N'PA', N'42003', N'15221', 40.449995, -79.903754, 2973, 234, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4757, N'Post Acute Medical Specialty  Hospital', 1, NULL, NULL, N'392025', NULL, NULL, 0, 67, NULL, N'5702083310', N'5702080317', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'275 North River St', N'Wilkes-Barre', N'PA', N'42079', N'18702', 41.252618, -75.875839, 3010, 238, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4758, N'Kindred Hospital Philadelphia', 1, NULL, NULL, N'392027', NULL, NULL, 0, 52, NULL, N'2157228555', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6129 Palmetto Street', N'Lawncrest', N'PA', N'42101', N'19111', 40.045639, -75.097703, 2970, 233, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4759, N'Kindred Hospital - Pittsburgh', 1, NULL, NULL, N'392028', NULL, NULL, 0, 63, NULL, N'4124945500', N'4124947682', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7777 Steubenville Pike', N'Oakdale', N'PA', N'42003', N'15071', 40.398125, -80.185613, 2973, 234, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4760, N'Select Specialty Hospital - Johnstown', 1, NULL, NULL, N'392031', NULL, NULL, 0, 39, NULL, N'8145345000', N'8145349965', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'320 Main Street', N'Johnstown', N'PA', N'42021', N'15901', 40.32399, -78.915109, 2939, 231, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4761, N'Good Shepherd Specialty Hospital', 1, NULL, NULL, N'392033', NULL, NULL, 0, 32, NULL, N'4848845051', N'4848845085', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2545 Schoenersville Road', N'Bethlehem', N'PA', N'42077', N'18017', 40.64486, -75.405081, 2893, 226, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4762, N'Select Specialty Hospital Laurel Highlands Inc', 1, NULL, NULL, N'392036', NULL, NULL, 0, 40, NULL, N'7248308649', N'7248308645', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'One Mellon Way', N'Latrobe', N'PA', N'42129', N'15650', 40.321181, -79.379481, 2946, 234, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4763, N'Select Specialty Hospital - Erie', 1, NULL, NULL, N'392037', NULL, NULL, 0, 50, NULL, N'8148745300', N'8148745303', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'252 West 11Th Street', N'Erie', N'PA', N'42049', N'16501', 42.122648, -80.087178, 2923, 229, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4764, N'Lifecare Hospitals Of Mechanicsburg', 1, NULL, NULL, N'392038', NULL, NULL, 0, 68, NULL, N'7177908540', N'7177908635', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4950 Wilson Lane', N'Mechanicsburg', N'PA', N'42041', N'17055', 40.210197, -77.004728, 2903, 230, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4765, N'Select Specialty Hospital - Central Pa (Camp Hill)', 1, NULL, NULL, N'392039', NULL, NULL, 0, 31, NULL, N'7179724560', N'7179724561', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'503 North 21St Street Fifth Floor', N'Camp Hill', N'PA', N'42041', N'17011', 40.239812, -76.919974, 2903, 230, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4766, N'Lifecare Hospitals Of Pittsburgh- Monroeville', 1, NULL, NULL, N'392041', NULL, NULL, 0, 89, NULL, N'4128562400', N'8148569320', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2380 Mcginley Road', N'Monroeville', N'PA', N'42003', N'15146', 40.425289, -79.744951, 2959, 234, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4767, N'Kindred Hospital At Heritage Valley', 1, NULL, NULL, N'392043', NULL, NULL, 0, 35, NULL, N'7247738480', N'7247756906', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1000 Dutch Ridge Road', N'Beaver', N'PA', N'42007', N'15009', 40.709412, -80.322823, 2891, 234, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4768, N'Select Specialty Hospital - Pittsburgh/Upmc', 1, NULL, NULL, N'392044', NULL, NULL, 0, 32, NULL, N'4125869821', N'4125869811', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'200 Lothrop Street Muh E824', N'Pittsburgh', N'PA', N'42003', N'15213', 40.441694, -79.990086, 2973, 234, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4769, N'Select Specialty Hospital - Mckeesport Inc', 1, NULL, NULL, N'392045', NULL, NULL, 0, 30, NULL, N'4126642900', N'4126642927', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1500 Fifth Avenue', N'Mc Keesport', N'PA', N'42003', N'15132', 40.969989, -77.727883, 2954, 234, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4770, N'Kindred Hospital South Philadelphia', 1, NULL, NULL, N'392046', NULL, NULL, 0, 58, NULL, N'2675705200', N'2154631028', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1930 South Broad Street Unit #12', N'Philadelphia', N'PA', N'42101', N'19145', 39.952335, -75.163789, 2970, 233, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4771, N'Select Specialty Hospital - Danville', 1, NULL, NULL, N'392047', NULL, NULL, 0, 30, NULL, N'5702149648', N'5702149661', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'100 North Academy Avenue 3Rd Flr Bush & Geisinger', N'Danville', N'PA', N'42093', N'17822', 40.966481, -76.613147, 2914, 228, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4772, N'Lifecare Hospitals Of Chester County', 1, NULL, NULL, N'392048', NULL, NULL, 0, 39, NULL, N'4848260400', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'400 East Marshal Street', N'West Chester', N'PA', N'42029', N'19380', 39.960922, -75.618914, 3008, 233, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4773, N'Good Shepherd Penn Partners', 1, NULL, NULL, N'392050', NULL, NULL, 0, 38, NULL, N'2158932548', N'2158932549', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1800 Lombard Street', N'Philadelphia', N'PA', N'42101', N'19146', 39.945393, -75.171868, 2970, 233, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4774, N'Bryn Mawr Rehabilitation Hospital', 1, NULL, NULL, N'393025', NULL, NULL, 0, 148, NULL, N'6102515400', N'6108890943', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'414 Paoli Pike', N'Malvern', N'PA', N'42029', N'19355', 40.036202, -75.513896, 2968, 233, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4775, N'Healthsouth Reading Rehabilitation Hospital', 1, NULL, NULL, N'393026', NULL, NULL, 0, 60, NULL, N'6107966000', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1623 Morgantown Road', N'Reading', N'PA', N'42011', N'19607', 40.310838, -75.924198, 2978, 235, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4776, N'Healthsouth Harmarville Rehabilitation Hospital', 1, NULL, NULL, N'393027', NULL, NULL, 0, 162, NULL, N'4128281300', N'4128287705', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'320 Guys Run Road', N'Pittsburgh', N'PA', N'42003', N'15238', 40.441694, -79.990086, 2973, 234, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4777, N'Allied Services Institute Of Rehabilitati Medicine', 1, NULL, NULL, N'393030', NULL, NULL, 0, 135, NULL, N'5703481367', N'5703414551', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'475 Morgan Highway', N'Scranton', N'PA', N'42069', N'18508', 41.408687, -75.662129, 2984, 237, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4778, N'Healthsouth Rehab Hospital Of Mechanicsburg', 1, NULL, NULL, N'393031', NULL, NULL, 0, 75, NULL, N'7176913720', N'7176976524', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'175 Lancaster Boulevard', N'Mechanicsburg', N'PA', N'42041', N'17055', 40.210197, -77.004728, 2903, 230, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4779, N'Good Shepherd Rehabilitation Hospital The', 1, NULL, NULL, N'393035', NULL, NULL, 0, 102, NULL, N'6107763223', N'6107763595', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'850 South Fifth Street', N'Allentown', N'PA', N'42077', N'18103', 40.602206, -75.471279, 2888, 226, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4780, N'John Heinz Institute Of Rehabilitation', 1, NULL, NULL, N'393036', NULL, NULL, 0, 71, NULL, N'5708263800', N'5708269108', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'150 Mundy Street', N'Wilkes Barre Townshi', N'PA', N'42079', N'18702', 40.969989, -77.727883, 3010, 238, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4781, N'Healthsouth Rehabilitation Hospital Of York', 1, NULL, NULL, N'393037', NULL, NULL, 0, 90, NULL, N'7177676941', N'7177641341', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1850 Normandie Drive', N'York', N'PA', N'42133', N'17404', 39.98007, -76.783636, 3013, 239, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4782, N'Magee Rehabilitation Hospital', 1, NULL, NULL, N'393038', NULL, NULL, 0, 96, NULL, N'2155873034', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Six Franklin Plaza', N'Philadelphia', N'PA', N'42101', N'19102', 39.952335, -75.163789, 2970, 233, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4783, N'Healthsouth Nittany Valley Rehabilitation Hospital', 1, NULL, NULL, N'393039', NULL, NULL, 0, 73, NULL, N'8143593421', N'8143595898', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'550 West College Avenue', N'Pleasant Gap', N'PA', N'42027', N'16823', 40.868118, -77.746666, 2992, 228, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4784, N'Healthsouth Rehab Hosp Of Altoona', 1, NULL, NULL, N'393040', NULL, NULL, 0, 80, NULL, N'8149443535', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2005 Valley View Boulevard', N'Altoona', N'PA', N'42013', N'16602', 40.498193, -78.391692, 2889, 227, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4785, N'Healthsouth Rehabilitation Hospital Of Sewickley', 1, NULL, NULL, N'393045', NULL, NULL, 0, 44, NULL, N'4127419500', N'4127492323', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'303 Camp Meeting Road', N'Sewickley', N'PA', N'42003', N'15143', 40.536457, -80.184503, 2986, 234, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4786, N'Healthsouth Rehabilitation Hospital Of Erie', 1, NULL, NULL, N'393046', NULL, NULL, 0, 108, NULL, N'8148781200', N'8148781399', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'143 East Second Street', N'Erie', N'PA', N'42049', N'16507', 42.129461, -80.085239, 2923, 229, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4787, N'Geisinger Healthsouth Rehabilitation Hospital', 1, NULL, NULL, N'393047', NULL, NULL, 0, 42, NULL, N'5702716110', N'5702716796', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2 Rehab Lane', N'Danville', N'PA', N'42093', N'17821', 40.966481, -76.613147, 2914, 228, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4788, N'Penn State Hershey Rehabilitation Llc', 1, NULL, NULL, N'393053', NULL, NULL, 0, 54, NULL, N'7178322600', N'7175831190', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'1135 Old West Chocolate Ave', N'Hummelstown', N'PA', N'42043', N'17036', 40.265368, -76.708303, 2931, 230, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4789, N'Lancaster Rehabilitation Hospital', 1, NULL, NULL, N'393054', NULL, NULL, 0, 59, NULL, N'7175444819', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'675 Good Drive', N'Lancaster', N'PA', N'42071', N'17604', 40.064442, -76.349084, 2943, 232, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4790, N'St Mary Rehabilitation Hospital', 1, NULL, NULL, N'393055', NULL, NULL, 0, 50, NULL, N'2676880711', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1208 Langhorne-Newtown Road', N'Langhorne', N'PA', N'42017', N'19047', 40.201389, -74.929478, 2944, 233, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4791, N'Helen M Simpson Rehabilitation Hospital', 1, NULL, NULL, N'393056', NULL, NULL, 0, 55, NULL, N'7179204300', N'7179204367', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4300 Londonderry Road', N'Harrisburg', N'PA', N'42043', N'17109', 40.266311, -76.886112, 2931, 230, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4792, N'Children''s Hospital Of Pittsburgh Of Upmc', 1, NULL, NULL, N'393302', NULL, NULL, 0, 312, NULL, N'4126925325', N'4126927589', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4401 Penn Avenue', N'Pittsburgh', N'PA', N'42003', N'15224', 40.465984, -79.953741, 2973, 234, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4793, N'Children''s Hospital Of Philadelphia', 1, NULL, NULL, N'393303', NULL, NULL, 0, 514, NULL, N'2155903745', NULL, 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'34Th St & Civic Center Blvd', N'Philadelphia', N'PA', N'42101', N'19104', 39.952335, -75.163789, 2970, 233, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4794, N'Children''s Home Of Pittsburgh', 1, NULL, NULL, N'393304', NULL, NULL, 0, 16, NULL, N'4124414884', N'4124410167', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5324 Penn Avenue', N'Pittsburgh', N'PA', N'42003', N'15224', 40.464512, -79.937987, 2973, 234, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4795, N'St Christopher''s Hospital For Children', 1, NULL, NULL, N'393307', NULL, NULL, 0, 189, NULL, N'2154275000', N'2154274444', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'120 East Erie Ave', N'Philadelphia', N'PA', N'42101', N'19133', 40.006814, -75.130955, 2970, 233, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4796, N'Children''s Institute Of Pittsburgh The', 1, NULL, NULL, N'393308', NULL, NULL, 0, 62, NULL, N'4124202400', N'4124202524', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6301 Northumberland Street', N'Pittsburgh', N'PA', N'42003', N'15217', 40.442061, -79.918934, 2973, 234, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4797, N'Shriners Hospitals For Children - Philadelphia', 1, NULL, NULL, N'393309', NULL, NULL, 0, 53, NULL, N'2154304000', N'2154304131', 1, 0, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3551 N Broad Street', N'Philadelphia', N'PA', N'42101', N'19104', 39.958004, -75.162314, 2970, 233, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4798, N'Norristown State Hospital', 1, NULL, NULL, N'394001', NULL, NULL, 0, 455, NULL, N'6103131000', N'6103131013', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1001 Sterigere Street', N'Norristown', N'PA', N'42091', N'19401', 40.129284, -75.348229, 2966, 233, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4799, N'Danville State Hospital', 1, NULL, NULL, N'394004', NULL, NULL, 0, 174, NULL, N'5702714500', N'5702714514', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'200 State Hospital Drive', N'Danville', N'PA', N'42093', N'17821', 40.966481, -76.613147, 2914, 228, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4800, N'Kirkbride Center', 1, NULL, NULL, N'394007', NULL, NULL, 0, 74, NULL, N'2154712358', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'111 N 49Th St', N'Philadelphia', N'PA', N'42101', N'19139', 39.961203, -75.219589, 2970, 233, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4801, N'Friends Hospital', 1, NULL, NULL, N'394008', NULL, NULL, 0, 192, NULL, N'2158314600', N'2158314538', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4641 Roosevelt Boulevard', N'Philadelphia', N'PA', N'42101', N'19124', 40.028923, -75.101382, 2970, 233, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4802, N'Clarks Summit State Hospital', 1, NULL, NULL, N'394012', NULL, NULL, 0, 214, NULL, N'5705862011', N'5705877415', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1451 Hillside Drive', N'Clarks Summit', N'PA', N'42069', N'18411', 41.488689, -75.708525, 2984, 237, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4803, N'Wernersville State Hospital', 1, NULL, NULL, N'394014', NULL, NULL, 0, 268, NULL, N'6106704100', N'6106704101', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'160 Main Street', N'Wernersville', N'PA', N'42011', N'19565', 40.330092, -76.080497, 2978, 235, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4804, N'Warren State Hospital', 1, NULL, NULL, N'394016', NULL, NULL, 0, 162, NULL, N'8147235500', N'8147264378', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'33 Main Drive', N'North Warren', N'PA', N'42123', N'16365', 41.878876, -79.145212, 3003, 229, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4805, N'Philhaven', 1, NULL, NULL, N'394020', NULL, NULL, 0, 91, NULL, N'7172738871', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'283 S Butler Road Po Box 550', N'Mt Gretna', N'PA', N'42075', N'17064', 40.246359, -76.470321, 2943, 232, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4806, N'Belmont Center For Comprehensive Treatment', 1, NULL, NULL, N'394023', NULL, NULL, 0, 147, NULL, N'2158772000', N'2155813827', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4200 Monument Avenue', N'Philadelphia', N'PA', N'42101', N'19131', 39.952335, -75.163789, 2970, 233, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4807, N'Torrance State Hospital', 1, NULL, NULL, N'394026', NULL, NULL, 0, 372, NULL, N'7244594511', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Po Box 111', N'Torrance', N'PA', N'42129', N'15779', 40.417291, -79.222812, 2946, 234, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4808, N'Fairmount Behavioral Health System', 1, NULL, NULL, N'394027', NULL, NULL, 0, 239, NULL, N'2154874000', N'2154838187', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'561 Fairthorne Avenue', N'Philadelphia', N'PA', N'42101', N'19128', 40.042566, -75.223583, 2970, 233, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4809, N'Montgomery County Emergency Service Inc', 1, NULL, NULL, N'394033', NULL, NULL, 0, 73, NULL, N'6102796100', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'50 Beech Drive', N'Norristown', N'PA', N'42091', N'19403', 40.121497, -75.339905, 2966, 233, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4810, N'Horsham Clinic', 1, NULL, NULL, N'394034', NULL, NULL, 0, 146, NULL, N'2156437800', N'2156541256', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'722 East Butler Pike', N'Ambler', N'PA', N'42091', N'19002', 40.154554, -75.221565, 2970, 233, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4811, N'Foundations Behavioral Health', 1, NULL, NULL, N'394038', NULL, NULL, 0, 54, NULL, N'2153450444', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'833 East Butler Ave', N'Doylestown', N'PA', N'42017', N'18901', 40.310004, -75.130484, 2916, 233, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4812, N'First Hospital Of Wyoming Valley', 1, NULL, NULL, N'394039', NULL, NULL, 0, 107, NULL, N'5705523900', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'562 Wyoming Avenue', N'Kingston', N'PA', N'42079', N'18704', 41.269609, -75.889161, 2941, 238, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4813, N'Meadows Psychiatric Center', 1, NULL, NULL, N'394040', NULL, NULL, 0, 101, NULL, N'8143642161', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'132 Meadows Drive', N'Centre Hall', N'PA', N'42027', N'16828', 40.847564, -77.686109, 2992, 228, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4814, N'Clarion Psychiatric Center', 1, NULL, NULL, N'394043', NULL, NULL, 0, 74, NULL, N'8142269545', N'8142269622', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Two Hospital Dr Rd#3 Box 188', N'Clarion', N'PA', N'42031', N'16214', 41.214785, -79.385322, 2908, 234, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4815, N'Kidspeace Orchard Hills Campus', 1, NULL, NULL, N'394047', NULL, NULL, 0, 80, NULL, N'6107998800', N'6107998801', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5300 Kidspeace Drive', N'Orefield', N'PA', N'42077', N'18069', 40.634818, -75.584353, 2888, 226, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4816, N'Divine Providence Hospital', 1, NULL, NULL, N'394048', NULL, NULL, 0, 31, NULL, N'5703268000', N'5703207979', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1100 Grampian Boulevard', N'Williamsport', N'PA', N'42081', N'17701', 41.257064, -76.998049, 3011, 228, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4817, N'Brooke Glen Behavioral Hospital', 1, NULL, NULL, N'394049', NULL, NULL, 0, 146, NULL, N'2156415300', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7170 Lafayette Avenue', N'Fort Washington', N'PA', N'42091', N'19034', 40.134892, -75.216311, 2970, 233, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4818, N'Roxbury Treatment Center', 1, NULL, NULL, N'394050', NULL, NULL, 0, 26, NULL, N'7175324217', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'601 Roxbury Road', N'Shippensburg', N'PA', N'42041', N'17257', 40.051632, -77.528063, 2907, 230, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4819, N'Pennsylvania Psychiatric Institute', 1, NULL, NULL, N'394051', NULL, NULL, 0, 60, NULL, N'7177824742', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2501 North Third Street', N'Harrisburg', N'PA', N'42043', N'17110', 40.266311, -76.886112, 2931, 230, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4820, N'Haven Behavioral Services Of Reading Llc', 1, NULL, NULL, N'394052', NULL, NULL, 0, 48, NULL, N'6103782400', N'6103782402', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'145 North 6Th Street', N'Reading', N'PA', N'42011', N'19601', 40.337618, -75.925731, 2978, 235, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4821, N'Haven Behavioral Services Of Philadelphia', 1, NULL, NULL, N'394053', NULL, NULL, 0, 36, NULL, N'9199999999', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3300 Henry Avenue Unit 4', N'Philadelphia', N'PA', N'42101', N'19129', 39.952335, -75.163789, 2970, 233, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4822, N'Geisinger Medical Center - Transplant Center', 1, NULL, NULL, N'399800', NULL, NULL, 0, 0, NULL, N'5702716211', N'5702716490', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'100 North Academy Avenue', N'Danville', N'PA', N'42093', N'17822', 40.966481, -76.613147, 2914, 228, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4823, N'Upmc Presbyterian Shadyside', 1, NULL, NULL, N'399801', NULL, NULL, 0, 0, NULL, N'4126478788', N'4126475551', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'200 Lothrop Street', N'Pittsburgh', N'PA', N'42003', N'15213', 40.442627, -79.960432, 2973, 234, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4824, N'Hahnemann University Hospital Transplant Center', 1, NULL, NULL, N'399805', NULL, NULL, 0, 0, NULL, N'2157627167', N'2152465451', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'Broad And Vine Streets', N'Philadelphia', N'PA', N'42101', N'19102', 39.952335, -75.163789, 2970, 233, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4825, N'Temple University Hospital - Transplant Center', 1, NULL, NULL, N'399806', NULL, NULL, 0, 0, NULL, N'2157072000', N'2157077061', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'3401 North Broad Street', N'Philadelphia', N'PA', N'42101', N'19140', 40.004797, -75.152104, 2970, 233, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4826, N'Hospital Of The University Of Pennsylvania', 1, NULL, NULL, N'399808', NULL, NULL, 0, 0, NULL, N'2156623227', N'2156140028', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'3400 Spruce Street', N'Philadelphia', N'PA', N'42101', N'19104', 39.949606, -75.193197, 2970, 233, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4827, N'Pinnacle Health Hospitals Transplant Center', 1, NULL, NULL, N'399809', NULL, NULL, 0, 0, NULL, N'7177825181', N'7172318240', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'409 South Second Street', N'Harrisburg', N'PA', N'42043', N'17105', 40.266311, -76.886112, 2931, 230, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4828, N'Main Line Hospital Lankenau Transplant Center', 1, NULL, NULL, N'399811', NULL, NULL, 0, 0, NULL, N'6106452000', N'6106458007', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'100 Lancaster Avenue', N'Wynnewood', N'PA', N'42091', N'19096', 39.980803, -75.235689, 2970, 233, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4829, N'Children''s Hospital Of Philadelphia Transplant', 1, NULL, NULL, N'399812', NULL, NULL, 0, 0, NULL, N'2674266922', N'2674266990', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'34Th Street And Civic Center Blvd', N'Philadelphia', N'PA', N'42101', N'19104', 39.952335, -75.163789, 2970, 233, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4830, N'Albert Einstein Medical Center Transplant Center', 1, NULL, NULL, N'399813', NULL, NULL, 0, 0, NULL, N'2154567010', N'2154566199', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'5501 Old York Road', N'Philadelphia', N'PA', N'42101', N'19141', 40.015874, -75.147201, 2970, 233, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4831, N'Lehigh Valley Hospital - Transplant Center', 1, NULL, NULL, N'399815', NULL, NULL, 0, 0, NULL, N'6104022273', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'1200 South Cedar Crest Boulevard Po Box 689', N'Allentown', N'PA', N'42077', N'18105', 40.602206, -75.471279, 2888, 226, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4832, N'Crozer Chester Medical Center - Transplant Center', 1, NULL, NULL, N'399816', NULL, NULL, 0, 0, NULL, N'6104472000', N'6104472234', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'One Medical Center Boulevard', N'Upland', N'PA', N'42045', N'19013', 39.852612, -75.382692, 3001, 233, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4833, N'Memorial Hospital Of Rhode Island', 1, NULL, NULL, N'410001', NULL, NULL, 0, 294, NULL, N'4017292000', N'4017288216', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'111 Brewster Street', N'Pawtucket', N'RI', N'44007', N'02860', 41.870652, -71.374982, 3015, 240, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4834, N'Roger Williams Medical Center', 1, NULL, NULL, N'410004', NULL, NULL, 0, 220, NULL, N'4014562000', N'4014562029', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'825 Chalkstone Avenue', N'Providence', N'RI', N'44007', N'02908', 41.83389, -71.435216, 3016, 240, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4835, N'Our Lady Of Fatima Hospital', 1, NULL, NULL, N'410005', NULL, NULL, 0, 359, NULL, N'4014563000', N'4014563028', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'200 High Service Avenue', N'North Providence', N'RI', N'44007', N'02904', 41.856087, -71.458838, 3016, 240, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4836, N'Newport Hospital', 1, NULL, NULL, N'410006', NULL, NULL, 0, 129, NULL, N'4018466400', N'4018451088', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Friendship Street', N'Newport', N'RI', N'44005', N'02840', 41.497182, -71.305045, 3014, 240, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4837, N'Rhode Island Hospital', 1, NULL, NULL, N'410007', NULL, NULL, 0, 719, NULL, N'4014444000', N'4014444218', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'593 Eddy Street', N'Providence', N'RI', N'44007', N'02903', 41.811815, -71.407168, 3016, 240, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4838, N'South County Hospital Inc', 1, NULL, NULL, N'410008', NULL, NULL, 0, 100, NULL, N'4017828000', N'4017899765', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'100 Kenyon Ave', N'Wakefield', N'RI', N'44009', N'02879', 41.432166, -71.496699, 3017, 240, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4839, N'Kent County Memorial Hospital', 1, NULL, NULL, N'410009', NULL, NULL, 0, 359, NULL, N'4017377000', N'4017361000', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'455 Toll Gate Rd', N'Warwick', N'RI', N'44003', N'02886', 41.70449, -71.477773, 3018, 240, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4840, N'Women And Infants Hospital Of Rhode Island', 1, NULL, NULL, N'410010', NULL, NULL, 0, 167, NULL, N'4012741100', N'4014537666', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'101 Dudley Street', N'Providence', N'RI', N'44007', N'02905', 41.810331, -71.411068, 3016, 240, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4841, N'Landmark Medical Center Inc', 1, NULL, NULL, N'410011', NULL, NULL, 0, 214, NULL, N'4017694100', N'4017665488', 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'115 Cass Ave', N'Woonsocket', N'RI', N'44007', N'02895', 42.005208, -71.496354, 3020, 240, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4842, N'Miriam Hospital', 1, NULL, NULL, N'410012', NULL, NULL, 0, 247, NULL, N'4017932500', N'4017937587', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'164 Summit Avenue', N'Providence', N'RI', N'44007', N'02906', 41.85145, -71.397799, 3016, 240, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4843, N'Westerly Hospital', 1, NULL, NULL, N'410013', NULL, NULL, 0, 116, NULL, N'4015966000', N'4013483716', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'25 Wells Street', N'Westerly', N'RI', N'44009', N'02891', 41.362952, -71.823769, 3019, 240, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4844, N'Eleanor Slater Hospital', 1, NULL, NULL, N'412001', NULL, NULL, 0, 495, NULL, N'4014623666', N'4014623679', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'111Howard Ave', N'Cranston', N'RI', N'44007', N'02921', 41.780959, -71.437126, 3016, 240, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4845, N'Rehabilitation Hospital Of Rhode Island', 1, NULL, NULL, N'413025', NULL, NULL, 0, 82, NULL, N'4017660800', N'4017665488', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'116 Eddie Dowling Highway', N'North Smithfield', N'RI', N'44007', N'02896', 41.966765, -71.549507, 3020, 240, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4846, N'Butler Hospital', 1, NULL, NULL, N'414000', NULL, NULL, 0, 143, NULL, N'4014556270', N'4014556252', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'345 Blackstone Blvd', N'Providence', N'RI', N'44007', N'02906', 41.845494, -71.386604, 3016, 240, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4847, N'Emma Pendleton Bradley Hospital', 1, NULL, NULL, N'414003', NULL, NULL, 0, 60, NULL, N'4014343400', N'4014321500', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1011 Veterans Memorial Parkway', N'East Providence', N'RI', N'44007', N'02915', 41.792179, -71.365851, 3016, 240, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4848, N'Rhode Island Hospital - Transplant Center', 1, NULL, NULL, N'419801', NULL, NULL, 0, 0, NULL, N'4014444000', N'4014444218', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'593 Eddy Street', N'Providence', N'RI', N'44007', N'02905', 41.811815, -71.407168, 3016, 240, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4849, N'Piedmont Medical Center', 1, NULL, NULL, N'420002', NULL, NULL, 0, 288, NULL, N'8033291234', N'8033290979', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'222 S Herlong Ave', N'Rock Hill', N'SC', N'45091', N'29730', 34.924867, -81.025078, 3060, 196, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4850, N'Musc Medical Center', 1, NULL, NULL, N'420004', NULL, NULL, 0, 709, NULL, N'8437922300', N'8437921931', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'169 Ashley Ave', N'Charleston', N'SC', N'45019', N'29425', 32.785398, -79.946661, 3030, 241, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4851, N'Mcleod Medical Center - Dillon', 1, NULL, NULL, N'420005', NULL, NULL, 0, 92, NULL, N'8437744111', NULL, 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'301 E Jackson St', N'Dillon', N'SC', N'45033', N'29536', 34.4209, -79.365164, 3036, 243, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4852, N'Spartanburg Regional Medical Center', 1, NULL, NULL, N'420007', NULL, NULL, 0, 540, NULL, N'8645606000', N'8645604023', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'101 E Wood St', N'Spartanburg', N'SC', N'45083', N'29303', 34.990665, -81.981964, 3062, 245, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4853, N'Ghs Oconee Memorial  Hospital', 1, NULL, NULL, N'420009', NULL, NULL, 0, 169, NULL, N'8644823100', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'298 Memorial Drive', N'Seneca', N'SC', N'45073', N'29672', 34.686532, -82.952729, 3061, 244, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4854, N'Carolina Pines Regional Medical Center', 1, NULL, NULL, N'420010', NULL, NULL, 0, 116, NULL, N'8643392100', N'8433394116', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1304 W Bobo Newsom Hwy', N'Hartsville', N'SC', N'45031', N'29550', 34.374043, -80.0734, 3046, 242, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4855, N'Cannon Memorial Hospital', 1, NULL, NULL, N'420011', NULL, NULL, 0, 55, NULL, N'8648784791', N'8648981047', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'123 Medical Park Drive Po Box 188', N'Pickens', N'SC', N'45077', N'29671', 34.883449, -82.707357, 3058, 244, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4856, N'Baptist Easley Hospital', 1, NULL, NULL, N'420015', NULL, NULL, 0, 109, NULL, N'8644427200', N'8644427521', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Po Box 2129', N'Easley', N'SC', N'45077', N'29641', 34.826928, -82.581705, 3037, 244, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4857, N'Southern Palmetto Hospital', 1, NULL, NULL, N'420016', NULL, NULL, 0, 53, NULL, N'8032591000', N'8035414388', 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Po Box 588  811  Reynolds Road', N'Barnwell', N'SC', N'45011', N'29812', 33.244873, -81.358718, 3025, 242, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4858, N'Palmetto Health Richland', 1, NULL, NULL, N'420018', NULL, NULL, 0, 649, NULL, N'8032965678', NULL, 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5 Richland Medical Park', N'Columbia', N'SC', N'45079', N'29203', 34.000749, -81.034331, 3034, 242, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4859, N'Chester Regional Medical Center', 1, NULL, NULL, N'420019', NULL, NULL, 0, 82, NULL, N'8035813151', N'8035812565', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1 Medical Park Drive', N'Chester', N'SC', N'45023', N'29706', 34.704861, -81.214256, 3032, 242, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4860, N'Georgetown Memorial Hospital', 1, NULL, NULL, N'420020', NULL, NULL, 0, 131, NULL, N'8435277000', N'8435208403', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'606 Black River Rd Drawer 1718', N'Georgetown', N'SC', N'45043', N'29440', 33.376834, -79.294496, 3042, 241, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4861, N'St Francis-Downtown', 1, NULL, NULL, N'420023', NULL, NULL, 0, 338, NULL, N'8642551000', N'8642551137', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'One St Francis Dr', N'Greenville', N'SC', N'45045', N'29601', 34.851354, -82.398488, 3043, 244, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4862, N'Sisters Of Charity Providence Hospitals', 1, NULL, NULL, N'420026', NULL, NULL, 0, 258, NULL, N'8032565300', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2435 Forest Dr', N'Columbia', N'SC', N'45079', N'29204', 34.023319, -80.950023, 3034, 242, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4863, N'Anmed Health', 1, NULL, NULL, N'420027', NULL, NULL, 0, 533, NULL, N'8642611109', NULL, 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'800 N Fant St', N'Anderson', N'SC', N'45007', N'29621', 34.511173, -82.647461, 3023, 244, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4864, N'Colleton Medical Center', 1, NULL, NULL, N'420030', NULL, NULL, 0, 135, NULL, N'8437822000', N'8435497562', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'501 Robertson Boulevard', N'Walterboro', N'SC', N'45029', N'29488', 32.922235, -80.675225, 3066, 241, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4865, N'Ghs Greer Memorial Hospital', 1, NULL, NULL, N'420033', NULL, NULL, 0, 82, NULL, N'8648488200', NULL, 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'830 South Buncombe Road', N'Greer', N'SC', N'45045', N'29650', 34.92183, -82.243204, 3045, 244, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4866, N'Springs Memorial Hospital', 1, NULL, NULL, N'420036', NULL, NULL, 0, 217, NULL, N'8032861481', N'8032861367', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'800 W Meeting St', N'Lancaster', N'SC', N'45057', N'29720', 34.71645, -80.789957, 3049, 196, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4867, N'Ghs-Hillcrest Memorial Hospital', 1, NULL, NULL, N'420037', NULL, NULL, 0, 43, NULL, N'8644546151', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'729 South East Main Street', N'Simpsonville', N'SC', N'45045', N'29681', 34.72423, -82.253888, 3043, 244, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4868, N'Ghs  Laurens County Memorial Hospital', 1, NULL, NULL, N'420038', NULL, NULL, 0, 76, NULL, N'8648339100', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'22725 Highway 76 East', N'Clinton', N'SC', N'45059', N'29325', 34.472628, -81.880656, 3033, 244, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4869, N'Wallace Thomson Hospital', 1, NULL, NULL, N'420039', NULL, NULL, 0, 143, NULL, N'8644270351', N'8643012676', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'322 W South St Po Box 789', N'Union', N'SC', N'45087', N'29379', 34.715066, -81.62362, 3064, 245, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4870, N'Novant Health Gaffney Medical Center', 1, NULL, NULL, N'420043', NULL, NULL, 0, 125, NULL, N'8644874271', N'8644890585', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1530 N Limestone St', N'Gaffney', N'SC', N'45021', N'29340', 35.091737, -81.634457, 3041, 245, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4871, N'Kershaw Health', 1, NULL, NULL, N'420048', NULL, NULL, 0, 121, NULL, N'8034324311', NULL, 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Haile And Roberts Streets Box 7003', N'Camden', N'SC', N'45055', N'29020', 34.246539, -80.607024, 3029, 242, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4872, N'Conway Medical Center', 1, NULL, NULL, N'420049', NULL, NULL, 0, 210, NULL, N'8433478037', NULL, 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'300 Singleton Ridge Road', N'Conway', N'SC', N'45051', N'29526', 33.789521, -78.998249, 3035, 241, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4873, N'Mcleod Regional Medical Center-Pee Dee', 1, NULL, NULL, N'420051', NULL, NULL, 0, 453, NULL, N'8437772900', NULL, 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'555 E Cheves St Box 8700', N'Florence', N'SC', N'45041', N'29506', 34.1987, -79.7677, 3040, 243, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4874, N'Newberry County Memorial Hospital', 1, NULL, NULL, N'420053', NULL, NULL, 0, 90, NULL, N'8034057145', N'8032766885', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2669 Kinard St Po Box 497', N'Newberry', N'SC', N'45071', N'29108', 34.275325, -81.618863, 3056, 242, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4875, N'Marlboro Park Hospital', 1, NULL, NULL, N'420054', NULL, NULL, 0, 102, NULL, N'8434792881', N'8434795860', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1138 Cheraw Highway', N'Bennettsville', N'SC', N'45069', N'29512', 34.634738, -79.698236, 3027, 243, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4876, N'Carolinas Hospital System Marion', 1, NULL, NULL, N'420055', NULL, NULL, 0, 124, NULL, N'8434312000', N'8434312414', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2829 E Hwy 76', N'Mullins', N'SC', N'45067', N'29574', 34.206059, -79.255989, 3054, 243, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4877, N'Mcleod Medical Center - Darlington', 1, NULL, NULL, N'420057', NULL, NULL, 0, 72, NULL, N'8433951100', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'701 Cashua Ferry Road', N'Darlington', N'SC', N'45031', N'29540', 34.312321, -79.840104, 3040, 243, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4878, N'Chesterfield General Hospital', 1, NULL, NULL, N'420062', NULL, NULL, 0, 59, NULL, N'8435377881', N'8433203479', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'711 Chesterfield Highway', N'Cheraw', N'SC', N'45025', N'29520', 34.697656, -79.883397, 3031, 243, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4879, N'Bon Secours-St Francis Xavier Hospital', 1, NULL, NULL, N'420065', NULL, NULL, 0, 204, NULL, N'8434021006', N'8434021945', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2095 Henry Tecklenburg Drive', N'Charleston', N'SC', N'45019', N'29414', 32.787601, -79.940273, 3030, 241, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4880, N'Lake City Community Hospital', 1, NULL, NULL, N'420066', NULL, NULL, 0, 48, NULL, N'8433742036', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'258 N Ron Mcnair Blvd', N'Lake City', N'SC', N'45041', N'29560', 33.880176, -79.759067, 3040, 243, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4881, N'Beaufort County Memorial Hospital', 1, NULL, NULL, N'420067', NULL, NULL, 0, 197, NULL, N'8435225200', N'8435225765', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'955 Ribaut Rd', N'Beaufort', N'SC', N'45013', N'29902', 32.416497, -80.688442, 3026, 77, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4882, N'Trmc Of Orangeburg & Calhoun', 1, NULL, NULL, N'420068', NULL, NULL, 0, 286, NULL, N'8035332460', NULL, 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3000 St Matthews Rd Box 1806', N'Orangeburg', N'SC', N'45075', N'29115', 33.49182, -80.855648, 3057, 242, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4883, N'Clarendon Memorial Hospital', 1, NULL, NULL, N'420069', NULL, NULL, 0, 56, NULL, N'8034358463', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'10 Hospital St Box 550', N'Manning', N'SC', N'45027', N'29102', 33.695163, -80.210913, 3051, 242, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4884, N'Tuomey Healthcare System', 1, NULL, NULL, N'420070', NULL, NULL, 0, 283, NULL, N'8037748900', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'129 N Washington St', N'Sumter', N'SC', N'45085', N'29150', 33.923577, -80.344231, 3063, 242, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4885, N'Self Regional Healthcare', 1, NULL, NULL, N'420071', NULL, NULL, 0, 414, NULL, N'8642274111', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1325 Spring Street', N'Greenwood', N'SC', N'45047', N'29646', 34.174389, -82.156846, 3044, 242, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4886, N'Hampton Regional Medical Center', 1, NULL, NULL, N'420072', NULL, NULL, 0, 32, NULL, N'8039432771', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'595 West Carolina Avenue', N'Varnville', N'SC', N'45049', N'29944', 32.852048, -81.082977, 3065, 241, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4887, N'Lexington Medical Center', 1, NULL, NULL, N'420073', NULL, NULL, 0, 414, NULL, N'8037912000', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2720 Sunset Blvd', N'West Columbia', N'SC', N'45063', N'29169', 33.998573, -81.083992, 3067, 242, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4888, N'Ghs Greenville Memorial Hospital', 1, NULL, NULL, N'420078', NULL, NULL, 0, 845, NULL, N'8644557000', NULL, 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'701 Grove Rd', N'Greenville', N'SC', N'45045', N'29605', 34.821426, -82.413679, 3043, 244, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4889, N'Trident Medical Center', 1, NULL, NULL, N'420079', NULL, NULL, 0, 390, NULL, N'8437978800', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'9330 Medical Plaza Dr', N'Charleston', N'SC', N'45019', N'29406', 32.975478, -80.075096, 3030, 241, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4890, N'Hilton Head Regional Medical Center', 1, NULL, NULL, N'420080', NULL, NULL, 0, 93, NULL, N'8436816122', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'25 Hospital Center Blvd', N'Hilton Head Island', N'SC', N'45013', N'29925', 32.221745, -80.714405, 3047, 77, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4891, N'Aiken Regional Medical Center', 1, NULL, NULL, N'420082', NULL, NULL, 0, 230, NULL, N'8036415900', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'302 University Parkway', N'Aiken', N'SC', N'45003', N'29801', 33.581895, -81.762018, 3022, 73, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4892, N'Mary Black Memorial Hospital', 1, NULL, NULL, N'420083', NULL, NULL, 0, 207, NULL, N'8645733000', N'8645733155', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1700 Skylyn Dr Box 3217', N'Spartanburg', N'SC', N'45083', N'29307', 34.949801, -81.932016, 3062, 245, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4893, N'Grand Strand Regional Medical Center', 1, NULL, NULL, N'420085', NULL, NULL, 0, 269, NULL, N'8436921000', N'8436921109', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'809 82Nd Parkway', N'Myrtle Beach', N'SC', N'45051', N'29572', 33.749567, -78.810517, 3055, 241, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4894, N'Palmetto Health Baptist', 1, NULL, NULL, N'420086', NULL, NULL, 0, 467, NULL, N'8032965678', N'8032965462', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Taylor At Marion St', N'Columbia', N'SC', N'45079', N'29220', 34.000749, -81.034331, 3034, 242, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4895, N'Roper Hospital', 1, NULL, NULL, N'420087', NULL, NULL, 0, 368, NULL, N'8437242800', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'316 Calhoun St', N'Charleston', N'SC', N'45019', N'29401', 32.782066, -79.950127, 3030, 241, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4896, N'East Cooper Medical Center', 1, NULL, NULL, N'420089', NULL, NULL, 0, 140, NULL, N'8438810100', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2000 Hospital Dr', N'Mount Pleasant', N'SC', N'45019', N'29464', 32.820923, -79.849582, 3053, 241, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4897, N'Carolinas Hospital System', 1, NULL, NULL, N'420091', NULL, NULL, 0, 420, NULL, N'8436742500', N'8436742519', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'805 Pamplico Hwy Box 100550', N'Florence', N'SC', N'45041', N'29505', 34.1987, -79.7677, 3040, 243, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4898, N'Waccamaw Community Hospital', 1, NULL, NULL, N'420098', NULL, NULL, 0, 167, NULL, N'8436521000', N'8435208403', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4070 Highway 17 Bypass', N'Murrells Inlet', N'SC', N'45043', N'29576', 33.547481, -79.064006, 3055, 241, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4899, N'Coastal Carolina Hospital', 1, NULL, NULL, N'420101', NULL, NULL, 0, 41, NULL, N'8437848000', N'8437848001', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1000 Medical Center Drive', N'Hardeeville', N'SC', N'45053', N'29927', 32.321081, -81.056793, 1001, 77, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4900, N'Ghs Patewood Memorial Hospital', 1, NULL, NULL, N'420102', NULL, NULL, 0, 72, NULL, N'8647971000', N'8644541130', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'175 Patewood Drive', N'Greenville', N'SC', N'45045', N'29615', 34.852386, -82.326004, 3043, 244, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4901, N'Village Hospital', 1, NULL, NULL, N'420103', NULL, NULL, 0, 48, NULL, N'8645306000', N'8645304665', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'250 Westmoreland Road', N'Greer', N'SC', N'45045', N'29651', 34.863668, -82.220845, 3045, 244, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4902, N'Mount Pleasant Hospital', 1, NULL, NULL, N'420104', NULL, NULL, 0, 85, NULL, N'8437242954', N'8438813070', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3500 Highway 17 North', N'Mount Pleasant', N'SC', N'45019', N'29466', 32.794065, -79.862585, 3053, 241, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4903, N'Mcleod Loris Seacoast Hospital', 1, NULL, NULL, N'420105', NULL, NULL, 0, 105, NULL, N'8437167000', N'8437167195', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3655 Mitchell Street', N'Loris', N'SC', N'45051', N'29569', 34.057438, -78.898071, 3050, 243, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4904, N'Palmetto Health Baptist Parkridge', 1, NULL, NULL, N'420106', NULL, NULL, 0, 57, NULL, N'8032962548', N'8032962548', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'400 Palmetto Health Parkway', N'Columbia', N'SC', N'45063', N'29212', 34.089403, -81.160598, 3034, 242, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4905, N'Allendale County Hospital', 1, NULL, NULL, N'421300', NULL, NULL, 0, 25, NULL, N'8036323311', N'8036322410', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1787 Allendale Fairfax Rd', N'Fairfax', N'SC', N'45005', N'29827', 32.958538, -81.237212, 3039, 73, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4906, N'Abbeville Area Medical Center', 1, NULL, NULL, N'421301', NULL, NULL, 0, 25, NULL, N'8643665011', N'8643663343', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'420 Thomson Circle', N'Abbeville', N'SC', N'45001', N'29620', 34.154314, -82.373096, 3021, 242, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4907, N'Fairfield Memorial Hospital', 1, NULL, NULL, N'421302', NULL, NULL, 0, 25, NULL, N'8036350233', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'321 Bypass Po Box 620', N'Winnsboro', N'SC', N'45039', N'29180', 34.380701, -81.086478, 3068, 242, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4908, N'Williamsburg Regional Hospital', 1, NULL, NULL, N'421303', NULL, NULL, 0, 25, NULL, N'8433558888', N'8433550056', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'500 Nelson Boulevard', N'Kingstree', N'SC', N'45089', N'29556', 33.659286, -79.830943, 3048, 243, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4909, N'Edgefield County Hospital', 1, NULL, NULL, N'421304', NULL, NULL, 0, 25, NULL, N'8036371193', N'8036371171', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'300 Ridge Medical Plaza', N'Edgefield', N'SC', N'45037', N'29824', 33.778969, -81.929028, 3038, 73, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4910, N'Spartanburg Hosp For Restorative Care', 1, NULL, NULL, N'422004', NULL, NULL, 0, 97, NULL, N'8645603235', NULL, 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'389 Serpentine Dr', N'Spartanburg', N'SC', N'45083', N'29303', 34.967701, -81.935932, 3062, 245, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4911, N'Vibra Hospital Of Charleston', 1, NULL, NULL, N'422005', NULL, NULL, 0, 59, NULL, N'8438814047', N'8438814738', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1200 Hospital Drive', N'Mount Pleasant', N'SC', N'45019', N'29464', 32.817117, -79.85219, 3053, 241, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4912, N'Intermedical Hospital Of Sc', 1, NULL, NULL, N'422006', NULL, NULL, 0, 35, NULL, N'8032963097', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Taylor At Marion Street', N'Columbia', N'SC', N'45079', N'29220', 34.000749, -81.034331, 3034, 242, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4913, N'Regency Hospital Of Florence', 1, NULL, NULL, N'422007', NULL, NULL, 0, 40, NULL, N'8436613481', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'121 East Cedar St 4Th Fl', N'Florence', N'SC', N'45041', N'29501', 34.1987, -79.7677, 3040, 243, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4914, N'Ghs North Greenville Long Term Acute Care Hospital', 1, NULL, NULL, N'422008', NULL, NULL, 0, 45, NULL, N'8648345132', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'807 North Main Street', N'Travelers Rest', N'SC', N'45045', N'29690', 34.975041, -82.450033, 3043, 244, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4915, N'Regency Hospital Of Greenville', 1, NULL, NULL, N'422009', NULL, NULL, 0, 32, NULL, N'8642551401', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1 St Francis Drive 4Th Floor', N'Greenville', N'SC', N'45045', N'29601', 34.851354, -82.398488, 3043, 244, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4916, N'Healthsouth Rehabilitation Hospital Of Columbia', 1, NULL, NULL, N'423025', NULL, NULL, 0, 96, NULL, N'8032547777', N'8034011414', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2935 Colonial Drive', N'Columbia', N'SC', N'45079', N'29203', 34.022166, -81.031782, 3034, 242, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4917, N'Healthsouth Rehabilitation Hospital Of Florence', 1, NULL, NULL, N'423026', NULL, NULL, 0, 88, NULL, N'8436799000', N'8436783787', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'900 East Cheves St', N'Florence', N'SC', N'45041', N'29506', 34.195994, -79.755799, 3040, 243, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4918, N'Healthsouth Rehabilitation Hosp Of Charleston Inc', 1, NULL, NULL, N'423027', NULL, NULL, 0, 49, NULL, N'8438207777', N'8435534025', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'9181 Medcom St', N'North Charleston', N'SC', N'45019', N'29406', 32.976394, -80.070079, 3030, 241, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4919, N'Healthsouth Rehabilitation Hospital Of Rock Hill', 1, NULL, NULL, N'423028', NULL, NULL, 0, 50, NULL, N'8033263500', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1795 Frank Gaston Blvd', N'Rock Hill', N'SC', N'45091', N'29732', 34.924867, -81.025078, 3060, 196, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4920, N'Anmed Healthsouth Rehabilitation Hospital', 1, NULL, NULL, N'423029', NULL, NULL, 0, 55, NULL, N'8647162600', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1 Springback Way', N'Anderson', N'SC', N'45007', N'29621', 34.50686, -82.650626, 3023, 244, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4921, N'Greenwood Regional Rehabilitation Hospital Inc', 1, NULL, NULL, N'423030', NULL, NULL, 0, 34, NULL, N'8643309070', N'8643309075', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1530 Parkway', N'Greenwood', N'SC', N'45047', N'29646', 34.167782, -82.156498, 3044, 242, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4922, N'Spartanburg Rehabilitation Institute Inc', 1, NULL, NULL, N'423031', NULL, NULL, 0, 40, NULL, N'8646416510', N'8646416512', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'160 Harold Fleming Court', N'Spartanburg', N'SC', N'45083', N'29303', 34.949801, -81.932016, 3062, 245, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4923, N'Shriners Hospitals For Children', 1, NULL, NULL, N'423300', NULL, NULL, 0, 50, NULL, N'8602713444', N'8642714471', 1, 0, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'950 West Faris Road', N'Greenville', N'SC', N'45045', N'29605', 34.817887, -82.417704, 3043, 244, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4924, N'Lighthouse Care Center Of Conway', 1, NULL, NULL, N'424002', NULL, NULL, 0, 52, NULL, N'8433478871', N'8432346100', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'152 Waccamaw Medical Park Drive', N'Conway', N'SC', N'45051', N'29526', 33.836004, -79.047814, 3035, 241, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4925, N'William S Hall Psychiatric Institute', 1, NULL, NULL, N'424003', NULL, NULL, 0, 89, NULL, N'8038981725', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1800 Colonial Drive', N'Columbia', N'SC', N'45079', N'29202', 34.022166, -81.031782, 3034, 242, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4926, N'G Werber Bryan Psych Hosp', 1, NULL, NULL, N'424005', NULL, NULL, 0, 543, NULL, N'8039357143', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'220 Faison Dr', N'Columbia', N'SC', N'45079', N'29203', 34.082385, -80.995702, 3034, 242, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4927, N'Palmetto Lowcountry Behavioral Health', 1, NULL, NULL, N'424006', NULL, NULL, 0, 112, NULL, N'8437475830', NULL, 1, 0, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2777 Speissegger Drive', N'Charleston', N'SC', N'45019', N'29405', 32.839183, -79.975052, 3030, 241, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4928, N'Springbrook Behavioral Health System', 1, NULL, NULL, N'424007', NULL, NULL, 0, 44, NULL, N'8648348013', N'8648346977', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'One Havenwood Lane  Po Box 1005', N'Travelers Rest', N'SC', N'45045', N'29690', 34.967617, -82.443455, 3043, 244, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4929, N'Three Rivers Behavioral Health', 1, NULL, NULL, N'424008', NULL, NULL, 0, 98, NULL, N'8037969911', N'8037917622', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2900 Sunset Boulevard', N'West Columbia', N'SC', N'45063', N'29169', 33.998573, -81.083992, 3067, 242, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4930, N'Carolina Ctr For Behavioral Health The', 1, NULL, NULL, N'424010', NULL, NULL, 0, 125, NULL, N'8642352335', N'8642771260', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'2700 E Phillips Rd', N'Greer', N'SC', N'45045', N'29650', 34.873831, -82.235159, 3045, 244, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4931, N'Patrick B Harris Psychiatric Hospital', 1, NULL, NULL, N'424011', NULL, NULL, 0, 206, NULL, N'8032312600', NULL, 1, 1, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'130 Highway 252', N'Anderson', N'SC', N'45007', N'29622', 34.449883, -82.498659, 3023, 244, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4932, N'The William J Mccord Adolescent Treatment Facility', 1, NULL, NULL, N'424013', NULL, NULL, 0, 15, NULL, N'8035342328', N'8035318419', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'910 Cook Road', N'Orangeburg', N'SC', N'45075', N'29118', 33.535879, -80.823727, 3057, 242, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4933, N'Rebound Behavioral Health', 1, NULL, NULL, N'424014', NULL, NULL, 0, 42, NULL, N'8033133700', N'8032890912', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'134 East Rebound Road', N'Lancaster', N'SC', N'45057', N'29720', 34.865251, -80.803182, 3049, 196, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4934, N'Musc Medical Center', 1, NULL, NULL, N'429800', NULL, NULL, 0, 0, NULL, N'8437922300', N'8438762968', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'169 Ashley Avenue', N'Charleston', N'SC', N'45019', N'29425', 32.785398, -79.946661, 3030, 241, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4935, N'Prairie Lakes Hospital', 1, NULL, NULL, N'430005', NULL, NULL, 0, 81, NULL, N'6058827000', N'6058827607', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'401 9Th Avenue Nw  Post Office Box 1210', N'Watertown', N'SD', N'46029', N'57201', 44.899211, -97.115289, 3109, 247, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4936, N'Brookings Health System', 1, NULL, NULL, N'430008', NULL, NULL, 0, 49, NULL, N'6056969000', N'6056967776', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'300 22Nd Ave', N'Brookings', N'SD', N'46011', N'57006', 44.307747, -96.768221, 3075, 247, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4937, N'Avera Sacred Heart Hospital', 1, NULL, NULL, N'430012', NULL, NULL, 0, 144, NULL, N'6056688000', N'6056680170', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'501 Summit', N'Yankton', N'SD', N'46135', N'57078', 42.875399, -97.407512, 3113, 247, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4938, N'Avera Queen Of Peace', 1, NULL, NULL, N'430013', NULL, NULL, 0, 120, NULL, N'6059952000', N'6059955765', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'525 N Foster', N'Mitchell', N'SD', N'46035', N'57301', 43.70953, -98.025379, 3092, 247, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4939, N'Avera St Lukes', 1, NULL, NULL, N'430014', NULL, NULL, 0, 133, NULL, N'6056225000', N'6056225127', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'305 S State St  Post Office Box 4450', N'Aberdeen', N'SD', N'46013', N'57401', 45.464981, -98.487813, 3070, 247, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4940, N'Avera St Mary''s Hospital', 1, NULL, NULL, N'430015', NULL, NULL, 0, 60, NULL, N'6052243100', N'6052248339', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'801 E Sioux', N'Pierre', N'SD', N'46065', N'57501', 44.369727, -100.358961, 3096, 247, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4941, N'Avera Mckennan Hospital & University Health Center', 1, NULL, NULL, N'430016', NULL, NULL, 0, 505, NULL, N'6053228000', N'6053227810', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1325 S Cliff Ave  Post Office Box 5045', N'Sioux Falls', N'SD', N'46099', N'57117', 43.549975, -96.700327, 3101, 247, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4942, N'Sanford Usd Medical Center', 1, NULL, NULL, N'430027', NULL, NULL, 0, 537, NULL, N'6053331000', N'6053331531', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1305 W 18Th St  Post Office Box 5039', N'Sioux Falls', N'SD', N'46099', N'57117', 43.549975, -96.700327, 3101, 247, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4943, N'Spearfish Regional Hospital', 1, NULL, NULL, N'430048', NULL, NULL, 0, 40, NULL, N'6056444000', N'6056444011', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1440 N Main St', N'Spearfish', N'SD', N'46081', N'57783', 44.494085, -103.86014, 3103, 246, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4944, N'Rapid City Regional Hospital', 1, NULL, NULL, N'430077', NULL, NULL, 0, 417, NULL, N'6057551000', N'6057198053', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'353 Fairmont Blvd  Post Office Box 6000', N'Rapid City', N'SD', N'46103', N'57701', 44.081176, -103.228006, 3098, 246, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4945, N'Phs Indian Hospital At Pine Ridge', 1, NULL, NULL, N'430081', NULL, NULL, 0, 45, NULL, N'6058675131', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'East Highway 18', N'Pine Ridge', N'SD', N'46113', N'57770', 43.028378, -102.552263, 3115, 246, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4946, N'Phs Indian Hospital At Rapid City - Sioux San', 1, NULL, NULL, N'430082', NULL, NULL, 0, 39, NULL, N'6053552500', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3200 Canyon Lake Dr', N'Rapid City', N'SD', N'46103', N'57702', 44.075381, -103.2678, 3098, 246, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4947, N'Phs Indian Hospital At Eagle Butte', 1, NULL, NULL, N'430083', NULL, NULL, 0, 35, NULL, N'6059643005', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'317 Main Street', N'Eagle Butte', N'SD', N'46041', N'57625', 44.998981, -101.234795, 3114, 204, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4948, N'Phs Indian Hospital At Rosebud', 1, NULL, NULL, N'430084', NULL, NULL, 0, 29, NULL, N'6057472231', N'6057472216', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'400 Soldier Creek Road', N'Rosebud', N'SD', N'46121', N'57570', 43.232782, -100.853478, 3116, 247, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4949, N'Siouxland Surgery Center Limited Partnership', 1, NULL, NULL, N'430089', NULL, NULL, 0, 40, NULL, N'6052323332', N'6052320854', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'600 Sioux Point Road', N'Dakota Dunes', N'SD', N'46127', N'57049', 42.487495, -96.48642, 1365, 109, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4950, N'Sioux Falls Specialty Hospital Llp', 1, NULL, NULL, N'430090', NULL, NULL, 0, 35, NULL, N'6053346730', N'6053348096', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'910 East 20Th Street', N'Sioux Falls', N'SD', N'46099', N'57105', 43.534915, -96.715093, 3101, 247, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4951, N'Black Hills Surgical Hospital Llp', 1, NULL, NULL, N'430091', NULL, NULL, 0, 26, NULL, N'6057214700', N'6057214964', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'216 Anamaria Dr', N'Rapid City', N'SD', N'46103', N'57703', 44.046228, -103.222729, 3098, 246, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4952, N'Dakota Plains Surgical Center Llp', 1, NULL, NULL, N'430092', NULL, NULL, 0, 15, NULL, N'6052253300', N'6052253877', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'701 8Th Avenue Nw Suite C', N'Aberdeen', N'SD', N'46013', N'57401', 45.464981, -98.487813, 3070, 247, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4953, N'Same Day Surgery Center Llc', 1, NULL, NULL, N'430093', NULL, NULL, 0, 6, NULL, N'6057559900', N'6057559955', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'651 Cathedral Drive', N'Rapid City', N'SD', N'46103', N'57701', 44.058662, -103.228883, 3098, 246, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4954, N'Avera Heart Hospital Of South Dakota', 1, NULL, NULL, N'430095', NULL, NULL, 0, 53, NULL, N'6059777000', N'6059777001', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4500 W 69Th St', N'Sioux Falls', N'SD', N'46099', N'57108', 43.489543, -96.728365, 3101, 247, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4955, N'Lewis And Clark Specialty Hospital', 1, NULL, NULL, N'430096', NULL, NULL, 0, 10, NULL, N'6056655100', N'6056655200', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2601 Fox Run Parkway', N'Yankton', N'SD', N'46135', N'57078', 42.900704, -97.399763, 3113, 247, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4956, N'Sanford Aberdeen Medical Center', 1, NULL, NULL, N'430097', NULL, NULL, 0, 48, NULL, N'6056264200', N'6056264211', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2905 3Rd Ave Se', N'Aberdeen', N'SD', N'46013', N'57402', 45.462956, -98.445834, 3070, 247, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4957, N'Madison Community Hospital - Cah', 1, NULL, NULL, N'431300', NULL, NULL, 0, 25, NULL, N'6052566551', N'6052566469', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'917 N Washington Ave', N'Madison', N'SD', N'46079', N'57042', 44.006085, -97.11395, 3088, 247, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4958, N'Faulkton Area Medical Center', 1, NULL, NULL, N'431301', NULL, NULL, 0, 12, NULL, N'6055986262', N'6055984186', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1300 Oak Street  Post Office Box 100', N'Faulkton', N'SD', N'46049', N'57438', 45.034974, -99.123998, 3082, 247, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4959, N'Avera Gettysburg Hospital', 1, NULL, NULL, N'431302', NULL, NULL, 0, 10, NULL, N'6057652480', N'6057652704', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'606 East Garfield', N'Gettysburg', N'SD', N'46107', N'57442', 45.013517, -99.951263, 3084, 247, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4960, N'Douglas County Memorial Hospital-Cah', 1, NULL, NULL, N'431305', NULL, NULL, 0, 11, NULL, N'6057242159', N'6057242985', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'708 8Th St', N'Armour', N'SD', N'46043', N'57313', 43.324927, -98.345054, 3071, 247, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4961, N'Platte Health Center - Cah', 1, NULL, NULL, N'431306', NULL, NULL, 0, 17, NULL, N'6053373364', N'6053372670', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'601 E 7Th St', N'Platte', N'SD', N'46023', N'57369', 43.38694, -98.84453, 3097, 247, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4962, N'Sanford Clear Lake Medical Center', 1, NULL, NULL, N'431307', NULL, NULL, 0, 20, NULL, N'6058742141', N'6058748441', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'701 Third Avenue South', N'Clear Lake', N'SD', N'46039', N'57226', 44.759559, -96.682644, 3078, 247, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4963, N'Eureka Community Health Services - Cah', 1, NULL, NULL, N'431308', NULL, NULL, 0, 6, NULL, N'6052842661', N'6052842054', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'410 9Th St Post Office Box 517', N'Eureka', N'SD', N'46089', N'57437', 45.769426, -99.619562, 3081, 204, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4964, N'Community Memorial Hospital - Cah', 1, NULL, NULL, N'431309', NULL, NULL, 0, 16, NULL, N'6057752621', N'6057752754', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'809 Jackson  Post Office Box 319', N'Burke', N'SD', N'46053', N'57523', 43.1825, -99.292045, 3076, 247, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4965, N'Avera Flandreau Hospital - Cah', 1, NULL, NULL, N'431310', NULL, NULL, 0, 18, NULL, N'6059972433', N'6059973611', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'214 North Prairie Street', N'Flandreau', N'SD', N'46101', N'57028', 44.049678, -96.591572, 3101, 247, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4966, N'Sanford Hospital Webster - Cah', 1, NULL, NULL, N'431311', NULL, NULL, 0, 25, NULL, N'6053453336', N'6053452402', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1401 W First St Post Office Box 489', N'Webster', N'SD', N'46037', N'57274', 45.33218, -97.520089, 3110, 247, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4967, N'Marshall County Healthcare Center - Cah', 1, NULL, NULL, N'431312', NULL, NULL, 0, 20, NULL, N'6054482253', N'6054482304', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'413 9Th Street', N'Britton', N'SD', N'46091', N'57430', 45.789065, -97.747395, 3074, 205, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4968, N'Freeman Medical Center - Cah', 1, NULL, NULL, N'431313', NULL, NULL, 0, 25, NULL, N'6059254000', N'6059252137', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'510 E 8Th St  Post Office Box 370', N'Freeman', N'SD', N'46067', N'57029', 43.352487, -97.437286, 3083, 247, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4969, N'Bennett County Hospital And Nursing Home - Cah', 1, NULL, NULL, N'431314', NULL, NULL, 0, 11, NULL, N'6056856622', N'6056856915', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'102 Major Allen   Post Office Box 70D', N'Martin', N'SD', N'46007', N'57551', 43.172498, -101.732648, 3089, 246, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4970, N'Wagner Community Memorial Hospital - Cah', 1, NULL, NULL, N'431315', NULL, NULL, 0, 20, NULL, N'6053843611', N'6053843232', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'513 3Rd St Sw  Post Office Box 280', N'Wagner', N'SD', N'46023', N'57380', 43.079716, -98.293134, 3108, 247, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4971, N'Community Memorial Hospital - Cah', 1, NULL, NULL, N'431316', NULL, NULL, 0, 25, NULL, N'6054721110', N'6054720331', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'111 W 10Th Ave  Post Office Box 420', N'Redfield', N'SD', N'46115', N'57469', 44.87581, -98.518706, 3099, 247, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4972, N'Landmann-Jungman Memorial Hospital - Cah', 1, NULL, NULL, N'431317', NULL, NULL, 0, 25, NULL, N'6055832226', N'6055834557', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'600 Billars St', N'Scotland', N'SD', N'46009', N'57059', 43.149715, -97.717567, 3100, 247, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4973, N'Bowdle Hospital - Cah', 1, NULL, NULL, N'431318', NULL, NULL, 0, 12, NULL, N'6052856146', N'6052856410', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'8001 W 5Th  Post Office Box 556', N'Bowdle', N'SD', N'46045', N'57428', 45.453038, -99.654007, 3073, 204, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4974, N'Hans P Peterson Memorial Hospital - Cah', 1, NULL, NULL, N'431319', NULL, NULL, 0, 18, NULL, N'6058592511', N'6058593506', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'503 W Pine  Post Office Box 790', N'Philip', N'SD', N'46055', N'57567', 44.039433, -101.665144, 3095, 247, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4975, N'Lead - Deadwood Regional Hospital - Cah', 1, NULL, NULL, N'431320', NULL, NULL, 0, 18, NULL, N'6057226101', N'6057196133', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'61 Charles Street', N'Deadwood', N'SD', N'46081', N'57732', 44.369752, -103.72868, 3079, 246, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4976, N'Sturgis Regional Hospital', 1, NULL, NULL, N'431321', NULL, NULL, 0, 25, NULL, N'6057202400', N'6057200338', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'949 Harmon Street', N'Sturgis', N'SD', N'46093', N'57785', 44.401977, -103.507574, 3104, 246, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4977, N'Fall River Hospital - Cah', 1, NULL, NULL, N'431322', NULL, NULL, 0, 25, NULL, N'6057458910', N'6057453957', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1201 Highway 71 South', N'Hot Springs', N'SD', N'46047', N'57747', 43.431646, -103.474362, 3098, 246, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4978, N'Custer Regional Hospital - Cah', 1, NULL, NULL, N'431323', NULL, NULL, 0, 16, NULL, N'6056739400', N'6056733586', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1039 Montgomery Street', N'Custer', N'SD', N'46033', N'57730', 43.772099, -103.593571, 3098, 246, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4979, N'Avera Weskota Memorial Medical Center - Cah', 1, NULL, NULL, N'431324', NULL, NULL, 0, 16, NULL, N'6055391201', N'6055394580', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'604 1St St Ne', N'Wessington Springs', N'SD', N'46073', N'57382', 44.080488, -98.564956, 3111, 247, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4980, N'Mobridge Regional Hospital - Cah', 1, NULL, NULL, N'431325', NULL, NULL, 0, 25, NULL, N'6058453692', N'6058458252', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1401 10Th Ave West', N'Mobridge', N'SD', N'46129', N'57601', 45.546772, -100.448391, 3093, 204, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4981, N'Milbank Area Hospital/Avera Health - Cah', 1, NULL, NULL, N'431326', NULL, NULL, 0, 25, NULL, N'6054324538', N'6054325412', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'901 E Virgil Ave', N'Milbank', N'SD', N'46051', N'57252', 45.221885, -96.624351, 3090, 247, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4982, N'St Michael''s Hospital - Cah', 1, NULL, NULL, N'431327', NULL, NULL, 0, 25, NULL, N'6055893341', N'6055893288', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'410 W 16Th Ave', N'Tyndall', N'SD', N'46009', N'57066', 42.991303, -97.867078, 3105, 247, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4983, N'Pioneer Memorial Hospital - Cah', 1, NULL, NULL, N'431328', NULL, NULL, 0, 12, NULL, N'6053265161', N'6053265734', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'315 N Washington Ave  Post Office Box 368', N'Viborg', N'SD', N'46125', N'57070', 43.170266, -97.08144, 3107, 247, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4984, N'Sanford Chamberlain Medical Center', 1, NULL, NULL, N'431329', NULL, NULL, 0, 25, NULL, N'6052345511', N'6052347118', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'300 S Byron', N'Chamberlain', N'SD', N'46015', N'57325', 43.810817, -99.330178, 3077, 247, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4985, N'Avera St Benedict Health Center - Cah', 1, NULL, NULL, N'431330', NULL, NULL, 0, 25, NULL, N'6059283311', N'6059287368', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'401 West Glynn Drive', N'Parkston', N'SD', N'46067', N'57366', 43.399026, -97.990269, 3094, 247, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4986, N'Avera Dells Area Hospital  - Cah', 1, NULL, NULL, N'431331', NULL, NULL, 0, 23, NULL, N'6054285431', N'6054283906', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'909 N Iowa Ave', N'Dell Rapids', N'SD', N'46099', N'57022', 43.825306, -96.715454, 3080, 247, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4987, N'Avera Desmet Memorial Hospital - Cah', 1, NULL, NULL, N'431332', NULL, NULL, 0, 17, NULL, N'6058543329', N'6058543161', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'306 Prairie Avenue Sw Post Office Box 160', N'De Smet', N'SD', N'46077', N'57231', 44.38747, -97.550354, 3101, 247, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4988, N'Sanford Canton-Inwood Medical Center - Cah', 1, NULL, NULL, N'431333', NULL, NULL, 0, 16, NULL, N'6057641400', N'6057641450', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'440 North Hiawatha Drive', N'Canton', N'SD', N'46083', N'57013', 43.30332, -96.558947, 3101, 247, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4989, N'Winner Regional Healthcare Center - Cah', 1, NULL, NULL, N'431334', NULL, NULL, 0, 25, NULL, N'6058427100', N'6058427211', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'745 East 8Th Street', N'Winner', N'SD', N'46123', N'57580', 43.370813, -99.847064, 3112, 247, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4990, N'Huron Regional Medical Center', 1, NULL, NULL, N'431335', NULL, NULL, 0, 25, NULL, N'6053536200', N'6053536300', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'172 Fourth Street Se', N'Huron', N'SD', N'46005', N'57350', 44.36308, -98.214388, 3087, 247, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4991, N'Sanford Vermillion Hospital', 1, NULL, NULL, N'431336', NULL, NULL, 0, 25, NULL, N'6056242611', N'6056248684', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'20 South Plum Street', N'Vermillion', N'SD', N'46027', N'57069', 42.778315, -96.919821, 3106, 247, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4992, N'Avera Hand County Memorial Hospital And Clinic', 1, NULL, NULL, N'431337', NULL, NULL, 0, 25, NULL, N'6058532421', N'6058530333', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'300 W 5Th St', N'Miller', N'SD', N'46059', N'57362', 44.520536, -98.992194, 3091, 247, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4993, N'Avera Gregory Hospital', 1, NULL, NULL, N'431338', NULL, NULL, 0, 25, NULL, N'6058358394', N'6058359422', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'400 Park Street  Post Office Box 408', N'Gregory', N'SD', N'46053', N'57533', 43.232223, -99.430383, 3085, 247, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4994, N'Coteau Des Prairies Health Care System', 1, NULL, NULL, N'431339', NULL, NULL, 0, 25, NULL, N'6056987647', N'6056984626', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'205 Orchard Dr', N'Sisseton', N'SD', N'46109', N'57262', 45.65733, -97.050763, 3102, 205, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4995, N'Select Specialty Hospital - Sioux Falls', 1, NULL, NULL, N'432002', NULL, NULL, 0, 24, NULL, N'6053129520', N'6053129501', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1305 West 18Th Street', N'Sioux Falls', N'SD', N'46099', N'57105', 43.536597, -96.743919, 3101, 247, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4996, N'Lifescape', 1, NULL, NULL, N'433300', NULL, NULL, 0, 18, NULL, N'6054449500', N'6054449501', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2501 W 26Th St', N'Sioux Falls', N'SD', N'46099', N'57105', 43.529342, -96.756029, 3101, 247, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4997, N'South Dakota Human Services Center', 1, NULL, NULL, N'434003', NULL, NULL, 0, 133, NULL, N'6056683100', N'6056683460', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3515 Broadway Ave   Post Office Box 7600', N'Yankton', N'SD', N'46135', N'57078', 42.871205, -97.397112, 3113, 247, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4998, N'Sanford Usd Medical Center', 1, NULL, NULL, N'439801', NULL, NULL, 0, 0, NULL, N'6053289292', N'6053289291', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'1205 South Grange Avenue Suite 201', N'Sioux Falls', N'SD', N'46099', N'57105', 43.549975, -96.700327, 3101, 247, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4999, N'Avera Mckennan Transplant Institute', 1, NULL, NULL, N'439802', NULL, NULL, 0, 0, NULL, N'6053227814', N'6053227810', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'1315 S Cliff Ave  Ste 1000  Po Box 5045', N'Sioux Falls', N'SD', N'46099', N'57117', 43.549975, -96.700327, 3101, 247, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5000, N'Unicoi County Memorial Hospital', 1, NULL, NULL, N'440001', NULL, NULL, 0, 48, NULL, N'4237433141', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Greenway Circle', N'Erwin', N'TN', N'47171', N'37650', 36.133267, -82.412187, 3136, 250, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5001, N'Jackson-Madison County General Hospital', 1, NULL, NULL, N'440002', NULL, NULL, 0, 635, NULL, N'7315415000', N'7314254990', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'620 Skyline Drive', N'Jackson', N'TN', N'47113', N'38301', 35.639463, -88.832773, 3147, 249, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5002, N'Sumner Regional Medical Center', 1, NULL, NULL, N'440003', NULL, NULL, 0, 155, NULL, N'6154524210', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'555 Hartsville Pike', N'Gallatin', N'TN', N'47165', N'37066', 36.388303, -86.44759, 3141, 254, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5003, N'Tristar Skyline Medical Center', 1, NULL, NULL, N'440006', NULL, NULL, 0, 395, NULL, N'6157692000', N'6157697102', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3441 Dickerson Pike', N'Nashville', N'TN', N'47037', N'37207', 36.240762, -86.757469, 3172, 254, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5004, N'United Regional Medical Center', 1, NULL, NULL, N'440007', NULL, NULL, 0, 54, NULL, N'9317283586', N'9317286877', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1001 Mcarthur St', N'Manchester', N'TN', N'47031', N'37355', 35.468271, -86.085519, 3163, 254, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5005, N'Henderson County Community Hospital', 1, NULL, NULL, N'440008', NULL, NULL, 0, 45, NULL, N'7319681801', N'7319688113', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'200 W Church St', N'Lexington', N'TN', N'47077', N'38351', 35.654279, -88.398831, 3159, 249, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5006, N'Cumberland Medical Center', 1, NULL, NULL, N'440009', NULL, NULL, 0, 189, NULL, N'9314849511', N'9317078150', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'421 S Main St', N'Crossville', N'TN', N'47035', N'38555', 35.942226, -85.022464, 3131, 254, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5007, N'Wayne Medical Center', 1, NULL, NULL, N'440010', NULL, NULL, 0, 80, NULL, N'9317225411', N'7312856400', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'103 J V Mangubat Dr', N'Waynesboro', N'TN', N'47181', N'38485', 35.319522, -87.762247, 3197, 254, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5008, N'Blount Memorial Hospital', 1, NULL, NULL, N'440011', NULL, NULL, 0, 304, NULL, N'8659837211', N'8659812333', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'907 E Lamar Alexander Parkway', N'Maryville', N'TN', N'47009', N'37804', 35.755231, -83.962482, 3165, 252, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5009, N'Wellmont Bristol Regional Medical Center', 1, NULL, NULL, N'440012', NULL, NULL, 0, 282, NULL, N'4238441121', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'One Medical Park Blvd', N'Bristol', N'TN', N'47163', N'37620', 36.595106, -82.188744, 3118, 251, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5010, N'The University Of Tn Medical Center', 1, NULL, NULL, N'440015', NULL, NULL, 0, 581, NULL, N'8655449000', N'8653056968', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1924 Alcoa Highway', N'Knoxville', N'TN', N'47093', N'37920', 35.943462, -83.948844, 3153, 252, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5011, N'Baptist Memorial Hospital Huntingdon', 1, NULL, NULL, N'440016', NULL, NULL, 0, 70, NULL, N'7319864461', N'7319867288', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'631 Rb Wilson Dr', N'Huntingdon', N'TN', N'47017', N'38344', 36.000618, -88.428106, 3146, 249, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5012, N'Wellmont Holston Valley Medical Center', 1, NULL, NULL, N'440017', NULL, NULL, 0, 519, NULL, N'4232244000', NULL, 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'130 West Ravine Road', N'Kingsport', N'TN', N'47163', N'37662', 36.554268, -82.554874, 3152, 251, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5013, N'Sycamore Shoals Hospital', 1, NULL, NULL, N'440018', NULL, NULL, 0, 109, NULL, N'4235421300', N'4235421439', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1501 West Elk Avenue', N'Elizabethton', N'TN', N'47019', N'37643', 36.34387, -82.249703, 3151, 250, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5014, N'Southern Tennessee Regional Health System Pulaski', 1, NULL, NULL, N'440020', NULL, NULL, 0, 95, NULL, N'9313637531', N'9316369303', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1265 E College St', N'Pulaski', N'TN', N'47055', N'38478', 35.191998, -87.006365, 3180, 254, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5015, N'Laughlin Memorial Hospital Inc', 1, NULL, NULL, N'440025', NULL, NULL, 0, 140, NULL, N'4237875000', N'4237986545', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1420 Tusculum Blvd', N'Greeneville', N'TN', N'47059', N'37745', 36.17369, -82.789989, 3142, 252, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5016, N'Williamson Medical Center', 1, NULL, NULL, N'440029', NULL, NULL, 0, 185, NULL, N'6154355000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4321 Carothers Parkway', N'Franklin', N'TN', N'47187', N'37067', 35.916569, -86.817162, 3139, 254, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5017, N'Morristown Hamblen Hospital Association', 1, NULL, NULL, N'440030', NULL, NULL, 0, 155, NULL, N'4235864231', N'4234925001', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'908 W 4Th North St', N'Morristown', N'TN', N'47063', N'37814', 36.212092, -83.304248, 3170, 252, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5018, N'Roane Medical Center', 1, NULL, NULL, N'440031', NULL, NULL, 0, 109, NULL, N'8653161000', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'8045 Roane Medical Center Drive', N'Harriman', N'TN', N'47145', N'37748', 35.933964, -84.552436, 3143, 252, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5019, N'Wellmont Hawkins County Memorial Hospital', 1, NULL, NULL, N'440032', NULL, NULL, 0, 50, NULL, N'4239217000', N'4239217034', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'851 Locust Street', N'Rogersville', N'TN', N'47073', N'37857', 36.399957, -83.01415, 3183, 252, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5020, N'Tennova Healthcare-Lafollett Medical Center', 1, NULL, NULL, N'440033', NULL, NULL, 0, 67, NULL, N'4239071440', N'4239071163', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'923 East Central Avenue', N'La Follette', N'TN', N'47013', N'37766', 36.388029, -84.112912, 3154, 252, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5021, N'Methodist Medical Center Of Oak Ridge', 1, NULL, NULL, N'440034', NULL, NULL, 0, 301, NULL, N'8658351000', N'8658354054', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'990 Oak Ridge Turnpike Box 529', N'Oak Ridge', N'TN', N'47001', N'37830', 36.010356, -84.269645, 3174, 252, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5022, N'Gateway Medical Center', 1, NULL, NULL, N'440035', NULL, NULL, 0, 270, NULL, N'9315021000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'651 Dunlop Lane', N'Clarksville', N'TN', N'47125', N'37040', 36.580053, -87.269821, 3125, 254, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5023, N'Vanderbilt University Hospital', 1, NULL, NULL, N'440039', NULL, NULL, 0, 985, NULL, N'6153223454', N'6153437317', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1161 21St Avenue South', N'Nashville', N'TN', N'47037', N'37232', 36.144569, -86.799879, 3172, 254, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5024, N'Perry Community Hospital', 1, NULL, NULL, N'440040', NULL, NULL, 0, 53, NULL, N'9315892121', NULL, 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2718 Squirrel Hollow Drive', N'Linden', N'TN', N'47135', N'37096', 35.617292, -87.83947, 3160, 254, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5025, N'Tristar Horizon Medical Center', 1, NULL, NULL, N'440046', NULL, NULL, 0, 157, NULL, N'6154460446', N'6154412514', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'111 Highway 70 East', N'Dickson', N'TN', N'47043', N'37055', 36.074472, -87.338565, 3133, 254, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5026, N'Baptist Memorial Hospital', 1, NULL, NULL, N'440048', NULL, NULL, 0, 927, NULL, N'9012265000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6019 Walnut Grove Road', N'Memphis', N'TN', N'47157', N'38120', 35.130876, -89.860255, 3168, 253, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5027, N'Methodist Healthcare Memphis Hospitals', 1, NULL, NULL, N'440049', NULL, NULL, 0, 1537, NULL, N'9015168274', N'9015160842', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1265 Union Ave Suite 700', N'Memphis', N'TN', N'47157', N'38104', 35.149022, -90.051628, 3168, 253, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5028, N'Takoma Regional Hospital', 1, NULL, NULL, N'440050', NULL, NULL, 0, 94, NULL, N'4236393151', N'4236362374', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'401 Takoma Ave', N'Greeneville', N'TN', N'47059', N'37743', 36.15225, -82.845085, 3142, 252, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5029, N'Mcnairy Regional Hospital', 1, NULL, NULL, N'440051', NULL, NULL, 0, 86, NULL, N'7316453221', N'7316458275', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'705 E Poplar Ave', N'Selmer', N'TN', N'47109', N'38375', 35.165182, -88.563327, 3185, 253, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5030, N'Saint Thomas Rutherford Hospital', 1, NULL, NULL, N'440053', NULL, NULL, 0, 286, NULL, N'6153964100', NULL, 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1700 Medical Center Parkway', N'Murfreesboro', N'TN', N'47149', N'37129', 35.860389, -86.424732, 3171, 254, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5031, N'Tennova Healthcare-Jefferson Memorial Hospital', 1, NULL, NULL, N'440056', NULL, NULL, 0, 58, NULL, N'8654712500', N'8654712450', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'110 Hospital Drive', N'Jefferson City', N'TN', N'47089', N'37760', 36.122311, -83.492396, 3149, 252, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5032, N'Claiborne Medical Center', 1, NULL, NULL, N'440057', NULL, NULL, 0, 85, NULL, N'4236264211', N'4236269926', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1850 Old Knoxville Highway', N'Tazewell', N'TN', N'47025', N'37879', 36.440691, -83.594626, 3193, 252, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5033, N'Southern Tennessee Regional Hlth System Winchester', 1, NULL, NULL, N'440058', NULL, NULL, 0, 145, NULL, N'9319678295', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'185 Hospital Road', N'Winchester', N'TN', N'47051', N'37398', 35.176196, -86.09087, 3198, 254, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5034, N'Cookeville Regional Medical Center', 1, NULL, NULL, N'440059', NULL, NULL, 0, 227, NULL, N'9316462000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1 Medical Center Boulevard', N'Cookeville', N'TN', N'47141', N'38501', 36.162839, -85.501642, 3128, 254, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5035, N'Milan General Hospital', 1, NULL, NULL, N'440060', NULL, NULL, 0, 70, NULL, N'7316861591', N'7316865129', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4039 Highland St', N'Milan', N'TN', N'47053', N'38358', 35.919789, -88.758949, 3169, 249, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5036, N'Volunteer Community Hospital', 1, NULL, NULL, N'440061', NULL, NULL, 0, 100, NULL, N'7315874261', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'161 Mount Pelia Rd', N'Martin', N'TN', N'47183', N'38237', 36.333661, -88.869008, 3164, 249, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5037, N'Johnson City Medical Center', 1, NULL, NULL, N'440063', NULL, NULL, 0, 555, NULL, N'4234316111', N'4234311037', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'400 N State Of Franklin Rd', N'Johnson City', N'TN', N'47179', N'37604', 36.308664, -82.386436, 3151, 250, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5038, N'Grandview Medical Center', 1, NULL, NULL, N'440064', NULL, NULL, 0, 70, NULL, N'4238379500', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1000 Highway 28', N'Jasper', N'TN', N'47115', N'37347', 35.074245, -85.626079, 3189, 248, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5039, N'Northcrest Medical Center', 1, NULL, NULL, N'440065', NULL, NULL, 0, 109, NULL, N'6153842411', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'100 Northcrest Drive', N'Springfield', N'TN', N'47147', N'37172', 36.509212, -86.884998, 3191, 254, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5040, N'Lakeway Regional Hospital', 1, NULL, NULL, N'440067', NULL, NULL, 0, 135, NULL, N'4235226000', N'4235878548', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'726 Mcfarland St', N'Morristown', N'TN', N'47063', N'37814', 36.214655, -83.304231, 3170, 252, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5041, N'Starr Regional Medical Center Athens', 1, NULL, NULL, N'440068', NULL, NULL, 0, 118, NULL, N'4237451411', N'4237443362', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1114 W Madison Ave', N'Athens', N'TN', N'47107', N'37371', 35.440298, -84.607695, 3117, 252, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5042, N'Decatur County General Hospital', 1, NULL, NULL, N'440070', NULL, NULL, 0, 40, NULL, N'7318473031', N'7318471122', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'969 Tennessee Ave S', N'Parsons', N'TN', N'47039', N'38363', 35.649791, -88.126702, 3177, 249, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5043, N'Dyersburg Regional Medical Center', 1, NULL, NULL, N'440072', NULL, NULL, 0, 225, NULL, N'7312852410', N'7312884705', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'400 Tickle St', N'Dyersburg', N'TN', N'47045', N'38024', 36.034516, -89.385628, 3134, 253, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5044, N'Maury Regional Hospital', 1, NULL, NULL, N'440073', NULL, NULL, 0, 258, NULL, N'9313811111', N'9315404160', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1224 Trotwood Ave', N'Columbia', N'TN', N'47119', N'38401', 35.607148, -87.066991, 3127, 254, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5045, N'Leconte Medical Center', 1, NULL, NULL, N'440081', NULL, NULL, 0, 79, NULL, N'8654467500', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'742 Middlecreek Road', N'Sevierville', N'TN', N'47035', N'37862', 35.868146, -83.561835, 3186, 252, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5046, N'Saint Thomas West Hospital', 1, NULL, NULL, N'440082', NULL, NULL, 0, 571, NULL, N'6152222111', N'6152226502', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4220 Harding Rd Po Box 380', N'Nashville', N'TN', N'47037', N'37205', 36.16223, -86.774353, 3172, 254, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5047, N'Jamestown Regional Medical Center', 1, NULL, NULL, N'440083', NULL, NULL, 0, 85, NULL, N'9318793352', N'9318794896', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'436 Central Avenue West', N'Jamestown', N'TN', N'47049', N'38556', 36.42757, -84.931892, 3148, 254, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5048, N'Sweetwater Hospital Association', 1, NULL, NULL, N'440084', NULL, NULL, 0, 59, NULL, N'8652138200', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'304 Wright St', N'Sweetwater', N'TN', N'47123', N'37874', 35.600367, -84.464267, 3192, 252, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5049, N'Memorial Healthcare System Inc', 1, NULL, NULL, N'440091', NULL, NULL, 0, 405, NULL, N'4234952525', N'4234957726', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2525 Desales Ave', N'Chattanooga', N'TN', N'47065', N'37404', 35.040221, -85.261357, 3124, 248, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5050, N'Lincoln Medical Center', 1, NULL, NULL, N'440102', NULL, NULL, 0, 91, NULL, N'9314381100', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'106 Medical Center Blvd', N'Fayetteville', N'TN', N'47103', N'37334', 35.152027, -86.570551, 3138, 3, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5051, N'Erlanger Medical Center', 1, NULL, NULL, N'440104', NULL, NULL, 0, 760, NULL, N'4237787000', NULL, 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'975 E 3Rd St', N'Chattanooga', N'TN', N'47065', N'37403', 35.04778, -85.290336, 3124, 248, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5052, N'Hardin Medical Center', 1, NULL, NULL, N'440109', NULL, NULL, 0, 58, NULL, N'7319268121', N'7319268303', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'935 Wayne Road', N'Savannah', N'TN', N'47071', N'38372', 35.227142, -88.229891, 3184, 253, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5053, N'Fort Loudon Medical Center', 1, NULL, NULL, N'440110', NULL, NULL, 0, 50, NULL, N'8652716000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'550 Fort Loudon Medical Center Dr', N'Lenoir City', N'TN', N'47105', N'37772', 35.82389, -84.270987, 3153, 252, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5054, N'Metro Nashville General Hospital', 1, NULL, NULL, N'440111', NULL, NULL, 0, 150, NULL, N'6153414490', N'6153414202', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1818 Albion Street', N'Nashville', N'TN', N'47037', N'37208', 36.166323, -86.805671, 3172, 254, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5055, N'Tennova Healthcare', 1, NULL, NULL, N'440120', NULL, NULL, 0, 610, NULL, N'8655458000', N'8655457380', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'900 East Oak Hill Avenue', N'Knoxville', N'TN', N'47093', N'37917', 35.988463, -83.932577, 3153, 252, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5056, N'Fort Sanders Regional Medical Center', 1, NULL, NULL, N'440125', NULL, NULL, 0, 553, NULL, N'8655411101', N'8655411853', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1901 W Clinch Ave', N'Knoxville', N'TN', N'47093', N'37916', 35.960395, -83.921026, 3153, 252, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5057, N'Baptist Memorial Hospital Union City', 1, NULL, NULL, N'440130', NULL, NULL, 0, 137, NULL, N'7318852410', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1201 Bishop St Po Box 310', N'Union City', N'TN', N'47131', N'38261', 36.42423, -89.05701, 3195, 253, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5058, N'Baptist Memorial Hospital Tipton', 1, NULL, NULL, N'440131', NULL, NULL, 0, 100, NULL, N'9014762621', N'9014755504', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1995 Highway 51 S', N'Covington', N'TN', N'47167', N'38019', 35.564247, -89.646467, 3130, 253, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5059, N'Henry County Medical Center', 1, NULL, NULL, N'440132', NULL, NULL, 0, 142, NULL, N'7316421220', N'7316429588', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'301 Tyson Av', N'Paris', N'TN', N'47079', N'38242', 36.296841, -88.310064, 3176, 249, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5060, N'Saint Thomas Midtown Hospital', 1, NULL, NULL, N'440133', NULL, NULL, 0, 683, NULL, N'6152845555', N'6152841592', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2000 Church St', N'Nashville', N'TN', N'47037', N'37236', 36.153406, -86.801018, 3172, 254, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5061, N'Heritage Medical Center', 1, NULL, NULL, N'440137', NULL, NULL, 0, 104, NULL, N'9316855433', N'9316858257', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2835 Hwy 231 N', N'Shelbyville', N'TN', N'47003', N'37160', 35.483406, -86.460272, 3187, 254, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5062, N'Cumberland River Hospital', 1, NULL, NULL, N'440141', NULL, NULL, 0, 36, NULL, N'9312433581', N'9312435219', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'100 Old Jefferson St', N'Celina', N'TN', N'47027', N'38551', 36.544389, -85.50123, 3122, 254, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5063, N'Harton Regional Medical Center', 1, NULL, NULL, N'440144', NULL, NULL, 0, 137, NULL, N'9313933000', N'9313937855', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1801 N Jackson St Box 460', N'Tullahoma', N'TN', N'47031', N'37388', 35.362024, -86.209434, 3194, 254, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5064, N'Baptist Rehabilitation Germantown', 1, NULL, NULL, N'440147', NULL, NULL, 0, 1, NULL, N'9017571350', N'9017573496', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2100 Exeter Road', N'Germantown', N'TN', N'47157', N'38138', 35.094657, -89.801991, 3168, 253, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5065, N'Stones River Hospital And Dekalb Community Hosp', 1, NULL, NULL, N'440148', NULL, NULL, 0, 71, NULL, N'6152155000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'520 W Main St', N'Smithville', N'TN', N'47041', N'37166', 35.959409, -85.829232, 3188, 254, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5066, N'Tristar Summit Medical Center', 1, NULL, NULL, N'440150', NULL, NULL, 0, 188, NULL, N'6153163000', N'6153164912', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5655 Frist Blvd', N'Hermitage', N'TN', N'47037', N'37076', 36.178358, -86.606175, 3172, 254, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5067, N'River Park Hospital', 1, NULL, NULL, N'440151', NULL, NULL, 0, 152, NULL, N'9318154101', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1559 Sparta Street', N'Mc Minnville', N'TN', N'47177', N'37110', 35.773008, -86.282008, 3167, 254, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5068, N'Regional One Health', 1, NULL, NULL, N'440152', NULL, NULL, 0, 631, NULL, N'9015457928', NULL, 1, 1, 1, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'877 Jefferson Avenue', N'Memphis', N'TN', N'47157', N'38103', 35.146521, -90.049505, 3168, 253, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5069, N'Tennova Healthcare-Newport Medical Center', 1, NULL, NULL, N'440153', NULL, NULL, 0, 74, NULL, N'4236252200', N'4236252215', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'435 2Nd St', N'Newport', N'TN', N'47029', N'37821', 35.964743, -83.181368, 3173, 252, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5070, N'Parkridge Medical Center', 1, NULL, NULL, N'440156', NULL, NULL, 0, 621, NULL, N'4238944220', N'4234931208', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2333 Mccallie Ave', N'Chattanooga', N'TN', N'47065', N'37404', 35.033152, -85.267024, 3124, 248, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5071, N'Delta Medical Center', 1, NULL, NULL, N'440159', NULL, NULL, 0, 243, NULL, N'9013698100', N'9013698503', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3000 Getwell Rd', N'Memphis', N'TN', N'47157', N'38118', 35.067376, -89.932311, 3168, 253, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5072, N'Tristar Centennial Medical Center', 1, NULL, NULL, N'440161', NULL, NULL, 0, 586, NULL, N'6153421000', N'6153421045', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2300 Patterson Street', N'Nashville', N'TN', N'47037', N'37203', 36.151885, -86.809746, 3172, 254, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5073, N'Healthsouth Chattanooga Rehab Hospital', 1, NULL, NULL, N'440162', NULL, NULL, 0, 80, NULL, N'4236980221', N'4236979117', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2412 Mccallie Ave', N'Chattanooga', N'TN', N'47065', N'37404', 35.033065, -85.267277, 3124, 248, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5074, N'Methodist Healthcare Fayette Hospital', 1, NULL, NULL, N'440168', NULL, NULL, 0, 50, NULL, N'9015164014', N'9015164057', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'214 Lakeview Rd', N'Somerville', N'TN', N'47047', N'38068', 35.246167, -89.363772, 3168, 253, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5075, N'Parkwest Medical Center', 1, NULL, NULL, N'440173', NULL, NULL, 0, 555, NULL, N'8659709800', N'8653731012', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'9352 Park West Blvd', N'Knoxville', N'TN', N'47093', N'37923', 35.918191, -84.099027, 3153, 252, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5076, N'Southern Tennessee Regional Health System Lawrence', 1, NULL, NULL, N'440175', NULL, NULL, 0, 99, NULL, N'9317626571', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Hwy 43 S Box 847', N'Lawrenceburg', N'TN', N'47099', N'38464', 35.242302, -87.334739, 3156, 254, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5077, N'Indian Path Medical Center', 1, NULL, NULL, N'440176', NULL, NULL, 0, 300, NULL, N'4234311941', N'4234311244', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2000 Brookside Dr', N'Kingsport', N'TN', N'47163', N'37660', 36.5618, -82.511225, 3152, 251, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5078, N'Jellico Community Hospital', 1, NULL, NULL, N'440180', NULL, NULL, 0, 54, NULL, N'4237847252', N'4237841136', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'188 Hospital Lane', N'Jellico', N'TN', N'47013', N'37762', 36.574267999999996, -84.12751, 3150, 252, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5079, N'Bolivar General Hospital', 1, NULL, NULL, N'440181', NULL, NULL, 0, 61, NULL, N'7316583100', N'7316590259', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'650 Nuckolls Road', N'Bolivar', N'TN', N'47069', N'38008', 35.284409, -89.005932, 3147, 249, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5080, N'Mckenzie Regional Hospital', 1, NULL, NULL, N'440182', NULL, NULL, 0, 45, NULL, N'7313525344', N'7313522733', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'161 Hospital Drive', N'Mc Kenzie', N'TN', N'47017', N'38201', 35.773008, -86.282008, 3166, 249, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5081, N'St Francis Hospital', 1, NULL, NULL, N'440183', NULL, NULL, 0, 519, NULL, N'9017651000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5959 Park Ave', N'Memphis', N'TN', N'47157', N'38119', 35.10057, -89.865115, 3168, 253, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5082, N'Franklin Woods Community Hospital', 1, NULL, NULL, N'440184', NULL, NULL, 0, 139, NULL, N'4233021120', N'4233021129', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'300 Med Tech Parkway', N'Johnson City', N'TN', N'47179', N'37604', 36.338779, -82.403616, 3151, 250, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5083, N'Skyridge Medical Center', 1, NULL, NULL, N'440185', NULL, NULL, 0, 351, NULL, N'4233394132', N'4235596653', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2305 Chambliss Ave Nw', N'Cleveland', N'TN', N'47011', N'37311', 35.176108, -84.869002, 3126, 248, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5084, N'Livingston Regional Hospital', 1, NULL, NULL, N'440187', NULL, NULL, 0, 110, NULL, N'9318235611', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'315 Oak St Box 550', N'Livingston', N'TN', N'47133', N'38570', 36.383396, -85.323022, 3161, 254, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5085, N'Regional Hospital Of Jackson', 1, NULL, NULL, N'440189', NULL, NULL, 0, 154, NULL, N'7316612000', N'7316612187', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'367 Hospital Blvd', N'Jackson', N'TN', N'47113', N'38305', 35.683935, -88.852789, 3147, 249, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5086, N'Highlands Medical Center', 1, NULL, NULL, N'440192', NULL, NULL, 0, 60, NULL, N'9317389211', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'401 Sewell Dr', N'Sparta', N'TN', N'47185', N'38583', 35.94821, -85.477098, 3190, 254, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5087, N'University Medical Center', 1, NULL, NULL, N'440193', NULL, NULL, 0, 250, NULL, N'6154448262', N'6154491215', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1411 Baddour Parkway', N'Lebanon', N'TN', N'47189', N'37087', 36.219393, -86.328728, 3157, 254, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5088, N'Tristar Hendersonville Medical Center', 1, NULL, NULL, N'440194', NULL, NULL, 0, 148, NULL, N'6153381000', N'6152644281', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'355 New Shackle Island Rd', N'Hendersonville', N'TN', N'47165', N'37075', 36.324462, -86.620162, 3145, 254, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5089, N'Tristar Southern Hills Medical Center', 1, NULL, NULL, N'440197', NULL, NULL, 0, 180, NULL, N'6157814000', N'6157814113', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'391 Wallace Rd', N'Nashville', N'TN', N'47037', N'37211', 36.07788, -86.723675, 3172, 254, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5090, N'Stones River Hospital & Dekalb Community Hospital', 1, NULL, NULL, N'440200', NULL, NULL, 0, 55, NULL, N'6155634001', N'6155633151', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'324 Doolittle Road', N'Woodbury', N'TN', N'47015', N'37190', 35.827567, -86.071656, 3199, 254, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5091, N'Saint Thomas Hospital For Specialty Surgery', 1, NULL, NULL, N'440218', NULL, NULL, 0, 23, NULL, N'6155158200', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2011 Murphy Avenue', N'Nashville', N'TN', N'47037', N'37203', 36.15545, -86.804373, 3172, 254, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5092, N'Tristar Stonecrest Medical Center', 1, NULL, NULL, N'440227', NULL, NULL, 0, 75, NULL, N'6157682000', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'200 Stonecrest Boulevard', N'Smyrna', N'TN', N'47149', N'37167', 35.982841, -86.518604, 3172, 254, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5093, N'Saint Francis Bartlett Medical Center', 1, NULL, NULL, N'440228', NULL, NULL, 0, 196, NULL, N'9018207050', N'9017651799', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2986 Kate Bond Rd', N'Bartlett', N'TN', N'47157', N'38133', 35.206684, -89.802244, 3168, 253, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5094, N'(Closed) Behavioral Healthcare Center At Clark', 1, NULL, NULL, N'440229', NULL, NULL, 0, 26, NULL, N'9315386420', N'9315386447', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'930 Professonial Park Drive', N'Clarksville', N'TN', N'47125', N'37040', 36.528592, -87.30987, 3125, 254, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5095, N'Behavioral Healthcare Center At Columbia', 1, NULL, NULL, N'440230', NULL, NULL, 0, 16, NULL, N'9313886593', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1400 Rosewood Drive', N'Columbia', N'TN', N'47119', N'38401', 35.605503, -87.059478, 3127, 254, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5096, N'Trustpoint Hospital', 1, NULL, NULL, N'440231', NULL, NULL, 0, 86, NULL, N'6155771111', N'6155774945', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1009 North Thompson Lane', N'Murfreesboro', N'TN', N'47149', N'37129', 35.877168, -86.424213, 3171, 254, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5097, N'Houston County Community Hospital', 1, NULL, NULL, N'440232', NULL, NULL, 0, 25, NULL, N'9312894211', N'9312894337', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5001 East Main Street', N'Erin', N'TN', N'47083', N'37061', 36.319968, -87.68772, 3135, 254, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5098, N'Saint Thomas Hickman Hospital', 1, NULL, NULL, N'441300', NULL, NULL, 0, 25, NULL, N'9317294271', N'9317294612', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'135 East Swan Street', N'Centerville', N'TN', N'47081', N'37033', 35.77984, -87.460352, 3123, 254, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5099, N'Trousdale Medical Center', 1, NULL, NULL, N'441301', NULL, NULL, 0, 25, NULL, N'6153742221', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'500 Church Street', N'Hartsville', N'TN', N'47169', N'37074', 36.388461, -86.167797, 3144, 254, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5100, N'Three Rivers Hospital', 1, NULL, NULL, N'441303', NULL, NULL, 0, 25, NULL, N'9312964203', N'9312961013', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'451 Highway 13 South', N'Waverly', N'TN', N'47085', N'37185', 36.082931, -87.794643, 3196, 254, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5101, N'Johnson County Community Hospital', 1, NULL, NULL, N'441304', NULL, NULL, 0, 2, NULL, N'4237271110', N'4237271112', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1901 S Shady St', N'Mountain City', N'TN', N'47091', N'37683', 36.443935, -81.796699, 2519, 250, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5102, N'Macon County General Hospital', 1, NULL, NULL, N'441305', NULL, NULL, 0, 25, NULL, N'6156662147', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'204 Medical Drive', N'Lafayette', N'TN', N'47111', N'37083', 36.51967, -86.025528, 3155, 254, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5103, N'Erlanger Bledsoe Hospital', 1, NULL, NULL, N'441306', NULL, NULL, 0, 31, NULL, N'4234472112', N'4234475289', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'71 Wheelertown Avenue', N'Pikeville', N'TN', N'47007', N'37367', 35.621399, -85.190396, 3178, 248, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5104, N'Riverview Regional Medical Center', 1, NULL, NULL, N'441307', NULL, NULL, 0, 35, NULL, N'6157359815', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'158 Hospital Drive', N'Carthage', N'TN', N'47159', N'37030', 36.262283, -85.950673, 3121, 254, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5105, N'Medical Center Of Manchester', 1, NULL, NULL, N'441308', NULL, NULL, 0, 25, NULL, N'9317286354', N'9317286354', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'481 Interstate Drive', N'Manchester', N'TN', N'47031', N'37355', 35.497764, -86.077923, 3163, 254, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5106, N'Marshall Medical Center', 1, NULL, NULL, N'441309', NULL, NULL, 0, 25, NULL, N'9313596276', N'9313599522', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1080 North Ellington Parkway', N'Lewisburg', N'TN', N'47117', N'37091', 35.466778, -86.789565, 3158, 254, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5107, N'Rhea Medical Center', 1, NULL, NULL, N'441310', NULL, NULL, 0, 25, NULL, N'4237751121', N'4238434500', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'9400 Rhea County Highway', N'Dayton', N'TN', N'47143', N'37321', 35.530188, -84.982423, 3132, 248, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5108, N'Tristar Ashland City Medical Center', 1, NULL, NULL, N'441311', NULL, NULL, 0, 12, NULL, N'6157923030', N'6157922490', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'313 North Main St', N'Ashland City', N'TN', N'47021', N'37015', 36.277502, -87.066268, 3200, 254, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5109, N'Wellmont Hancock County Hospital', 1, NULL, NULL, N'441313', NULL, NULL, 0, 25, NULL, N'4237335001', N'4237335092', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1517 Main Street Hwy 33', N'Sneedville', N'TN', N'47067', N'37869', 36.529811, -83.217397, 3170, 252, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5110, N'Lauderdale Community Hospital', 1, NULL, NULL, N'441314', NULL, NULL, 0, 25, NULL, N'7312212200', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'326 Asbury Avenue', N'Ripley', N'TN', N'47097', N'38063', 35.745355, -89.529797, 3181, 253, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5111, N'Copper Basin Medical Center', 1, NULL, NULL, N'441315', NULL, NULL, 0, 25, NULL, N'4234965511', NULL, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'Highway 68', N'Copperhill', N'TN', N'47139', N'37317', 34.988969, -84.370756, 3129, 248, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5112, N'Camden General Hospital', 1, NULL, NULL, N'441316', NULL, NULL, 0, 25, NULL, N'7315840109', N'7315840124', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'175 Hospital Drive', N'Camden', N'TN', N'47005', N'38320', 36.055533, -88.11111, 3120, 254, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5113, N'Pioneer Community Hospital Of Scott', 1, NULL, NULL, N'441318', NULL, NULL, 0, 25, NULL, N'4232865300', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'18797 Alberta Street', N'Oneida', N'TN', N'47151', N'37841', 36.525773, -84.496001, 3175, 252, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5114, N'Kindred Hospital - Nashville', 1, NULL, NULL, N'442006', NULL, NULL, 0, 60, NULL, N'6156872600', N'6158626933', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1412 County Hospital Road B-1', N'Nashville', N'TN', N'47037', N'37218', 36.16223, -86.774353, 3172, 254, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5115, N'Kindred Hospital - Chattanooga', 1, NULL, NULL, N'442007', NULL, NULL, 0, 49, NULL, N'4232667721', N'4232267516', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'709 Walnut Street', N'Chattanooga', N'TN', N'47065', N'37402', 35.048236, -85.307506, 3124, 248, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5116, N'Baptist Memorial Restorative Care Hospital', 1, NULL, NULL, N'442010', NULL, NULL, 0, 30, NULL, N'9012261400', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6019 Walnut Grove Road 1 West', N'Memphis', N'TN', N'47157', N'38120', 35.149022, -90.051628, 3168, 253, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5117, N'Select Specialty Hospital-Nashville', 1, NULL, NULL, N'442011', NULL, NULL, 0, 70, NULL, N'6152844599', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2000 Hayes Street', N'Nashville', N'TN', N'47037', N'37203', 36.152386, -86.800259, 3172, 254, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5118, N'Select Specialty Hospital-Knoxville', 1, NULL, NULL, N'442012', NULL, NULL, 0, 35, NULL, N'8655472615', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1901 Clinch Ave Forth Floor N', N'Knoxville', N'TN', N'47093', N'37916', 35.960395, -83.921026, 3153, 252, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5119, N'Methodist Extended Care Hospital', 1, NULL, NULL, N'442013', NULL, NULL, 0, 36, NULL, N'9015162152', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'225 South Claybrook', N'Memphis', N'TN', N'47157', N'38104', 35.149022, -90.051628, 3168, 253, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5120, N'Select Specialty Hospital Memphis', 1, NULL, NULL, N'442014', NULL, NULL, 0, 30, NULL, N'9017651245', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5959 Park Avenue', N'Memphis', N'TN', N'47157', N'38119', 35.10057, -89.865115, 3168, 253, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5121, N'Select Specialty Hospital-North Knoxville', 1, NULL, NULL, N'442015', NULL, NULL, 0, 33, NULL, N'8655457370', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'900 Oak Hill Avenue-4Th Floor', N'Knoxville', N'TN', N'47093', N'37917', 35.960395, -83.921026, 3153, 252, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5122, N'Select Specialty Hospital-Tricities', 1, NULL, NULL, N'442016', NULL, NULL, 0, 25, NULL, N'4238445900', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'One Medical Park Boulevard 5Th Floor', N'Bristol', N'TN', N'47163', N'37620', 36.595106, -82.188744, 3118, 251, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5123, N'Regional One Health Extended Care Hospital', 1, NULL, NULL, N'442017', NULL, NULL, 0, 24, NULL, N'9015133000', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'890 Madison Avenue 4Th Floor', N'Memphis', N'TN', N'47157', N'38103', 35.149022, -90.051628, 3168, 253, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5124, N'Siskin Hospital For Physical Rehabilitation', 1, NULL, NULL, N'443025', NULL, NULL, 0, 80, NULL, N'4236341200', N'4236341209', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1 Siskin Plaza', N'Chattanooga', N'TN', N'47065', N'37403', 35.04563, -85.30968, 3124, 248, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5125, N'Healthsouth Rehabilitation Hospital', 1, NULL, NULL, N'443027', NULL, NULL, 0, 50, NULL, N'4232467240', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'113 Cassel Drive', N'Kingsport', N'TN', N'47163', N'37660', 36.555634, -82.55661, 3152, 251, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5126, N'Vanderbilt Stallworth Rehab Hospital', 1, NULL, NULL, N'443028', NULL, NULL, 0, 80, NULL, N'6153207600', N'6153279289', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2201 Childrens Way', N'Nashville', N'TN', N'47037', N'37212', 36.138765, -86.802831, 3172, 254, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5127, N'Healthsouth Rehabilitation Hospital Of Memphis', 1, NULL, NULL, N'443029', NULL, NULL, 0, 80, NULL, N'9017222000', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1282 Union Avenue', N'Memphis', N'TN', N'47157', N'38104', 35.137142, -90.01885, 3168, 253, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5128, N'Healthsouth Cane Creek Rehab Hospital', 1, NULL, NULL, N'443030', NULL, NULL, 0, 40, NULL, N'7315874231', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'180 Mt Pelia Road', N'Martin', N'TN', N'47183', N'38237', 36.332813, -88.870848, 3164, 249, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5129, N'Healthsouth Rehabilitation Hospital - North', 1, NULL, NULL, N'443031', NULL, NULL, 0, 40, NULL, N'9012135400', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4100 Austin Peay Highway', N'Memphis', N'TN', N'47157', N'38128', 35.238452, -89.891962, 3168, 253, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5130, N'Healthsouth Chattanooga Rehab Hospital', 1, NULL, NULL, N'443032', NULL, NULL, 0, 69, NULL, N'4236980221', N'4236979117', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2412 Mccallie Avenue', N'Chattanooga', N'TN', N'47065', N'37404', 35.033065, -85.267277, 3124, 248, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5131, N'Quillen Rehabilitation Hospital', 1, NULL, NULL, N'443033', NULL, NULL, 0, 26, NULL, N'4239521700', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2511 Wesley Street', N'Johnson City', N'TN', N'47179', N'37601', 36.35124, -82.376753, 3151, 250, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5132, N'Baptist Memorial Rehabilitation Hospital', 1, NULL, NULL, N'443034', NULL, NULL, 0, 49, NULL, N'9017571350', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1240 S Germantown Road', N'Germantown', N'TN', N'47157', N'38138', 35.116497, -89.801187, 3168, 253, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5133, N'St Jude Childrens Research Hospital', 1, NULL, NULL, N'443302', NULL, NULL, 0, 78, NULL, N'9014953300', NULL, 1, 0, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'262 Danny Thomas Place', N'Memphis', N'TN', N'47157', N'38105', 35.154729, -90.043132, 3168, 253, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5134, N'East Tennessee Childrens Hospital', 1, NULL, NULL, N'443303', NULL, NULL, 0, 122, NULL, N'8655418000', N'8655418343', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2018 Clinch Ave Sw', N'Knoxville', N'TN', N'47093', N'37916', 35.960395, -83.921026, 3153, 252, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5135, N'Memphis Mental Health Institute', 1, NULL, NULL, N'444001', NULL, NULL, 0, 135, NULL, N'9015771800', N'9015771434', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'951 Court Avenue', N'Memphis', N'TN', N'47157', N'38103', 35.141466, -90.029287, 3168, 253, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5136, N'Moccassin Bend Mental Health Institute', 1, NULL, NULL, N'444002', NULL, NULL, 0, 172, NULL, N'4237852271', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'100 Moccasin Bend Road', N'Chattanooga', N'TN', N'47065', N'37405', 35.02822, -85.335395, 3124, 248, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5137, N'Ridgeview Psychiatric Hospital And Center', 1, NULL, NULL, N'444003', NULL, NULL, 0, 44, NULL, N'8654821076', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'240 W Tyrone Rd', N'Oak Ridge', N'TN', N'47001', N'37830', 36.024957, -84.243568, 3174, 252, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5138, N'Lakeside Behavioral Health System', 1, NULL, NULL, N'444004', NULL, NULL, 0, 290, NULL, N'9013774700', N'9013730987', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2911 Brunswick Rd', N'Memphis', N'TN', N'47157', N'38133', 35.204394, -89.777713, 3168, 253, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5139, N'Behavioral Healthcare Center At Martin', 1, NULL, NULL, N'444005', NULL, NULL, 0, 16, NULL, N'7315882830', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'458 Hannings Lane P O Box 1006', N'Martin', N'TN', N'47183', N'38237', 36.343397, -88.850338, 3164, 249, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5140, N'Rolling Hills Psychiatric Hospital', 1, NULL, NULL, N'444007', NULL, NULL, 0, 80, NULL, N'6152264930', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2014 Quail Hollow Circle', N'Franklin', N'TN', N'47187', N'37067', 35.914521, -86.816624, 3139, 254, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5141, N'Western Mental Health Institute', 1, NULL, NULL, N'444008', NULL, NULL, 0, 247, NULL, N'7312282000', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'11100 Old Hwy 64 West', N'Bolivar', N'TN', N'47069', N'38008', 35.256194, -88.987839, 3147, 249, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5142, N'Pathways Of Tennessee Inc', 1, NULL, NULL, N'444010', NULL, NULL, 0, 25, NULL, N'7319358200', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'238 Summar Dr', N'Jackson', N'TN', N'47113', N'38301', 35.636763, -88.834158, 3147, 249, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5143, N'Middle Tn Mental Health Institute', 1, NULL, NULL, N'444014', NULL, NULL, 0, 100, NULL, N'6159027565', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'221 Stewarts Ferry Pike', N'Nashville', N'TN', N'47037', N'37214', 36.160463, -86.646299, 3172, 254, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5144, N'Behavioral Healthcare Center At Clarksville', 1, NULL, NULL, N'444019', NULL, NULL, 0, 26, NULL, N'9315386420', N'9315386447', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'930 Professional Park Drive', N'Clarksville', N'TN', N'47125', N'37040', 36.574042, -87.272006, 3125, 254, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5145, N'Behavioral Healthcare Center At Columbia', 1, NULL, NULL, N'444021', NULL, NULL, 0, 16, NULL, N'9313886593', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1400 Rosewood Drive', N'Columbia', N'TN', N'47119', N'38401', 35.605503, -87.059478, 3127, 254, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5146, N'Ten Broeck Tennessee', 1, NULL, NULL, N'444022', NULL, NULL, 0, 32, NULL, N'9317832075', N'9317832521', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1 Medical Center Blvd 5 West', N'Cookeville', N'TN', N'47141', N'38501', 36.162839, -85.501642, 3128, 254, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5147, N'University Of Tn Transplant Center At Knoxville', 1, NULL, NULL, N'449800', NULL, NULL, 0, 0, NULL, N'8655449000', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'1924 Alcoa Highway', N'Knoxville', N'TN', N'47093', N'37920', 35.943462, -83.948844, 3153, 252, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5148, N'Vanderbilt University Transplant Center', 1, NULL, NULL, N'449802', NULL, NULL, 0, 0, NULL, N'6153223454', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'1161 21St Ave South', N'Nashville', N'TN', N'47037', N'37232', 36.144569, -86.799879, 3172, 254, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5149, N'Baptist Memorial Hospital Transplant Center', 1, NULL, NULL, N'449803', NULL, NULL, 0, 0, NULL, N'9012265000', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'6019 Walnut Grove', N'Memphis', N'TN', N'47157', N'38120', 35.149022, -90.051628, 3168, 253, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5150, N'Centennial Medical Transplant Center', 1, NULL, NULL, N'449804', NULL, NULL, 0, 0, NULL, N'6153421000', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'2300 Patterson Street', N'Nashville', N'TN', N'47037', N'37203', 36.151885, -86.809746, 3172, 254, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5151, N'Lebonheur Children''s Medical Transplant Center', 1, NULL, NULL, N'449805', NULL, NULL, 0, 0, NULL, N'9015167270', N'9015188590', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'50 North Dunlap', N'Memphis', N'TN', N'47157', N'38103', 35.149022, -90.051628, 3168, 253, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5152, N'Methodist Hc Transplant', 1, NULL, NULL, N'449806', NULL, NULL, 0, 0, NULL, N'9015167270', N'9015162036', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'1265 Union Avenue', N'Memphis', N'TN', N'47157', N'38104', 35.136931, -90.018397, 3168, 253, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5153, N'Erlanger Regional Kidney Transplant', 1, NULL, NULL, N'449807', NULL, NULL, 0, 0, NULL, N'4237782174', N'4237786674', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'975 East Third Street', N'Chattanooga', N'TN', N'47065', N'37403', 35.04563, -85.30968, 3124, 248, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5154, N'St Thomas Hospital Transplant', 1, NULL, NULL, N'449808', NULL, NULL, 0, 0, NULL, N'6152225480', N'6152228074', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'4220 Harding Road', N'Nashville', N'TN', N'47037', N'37205', 36.16223, -86.774353, 3172, 254, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5155, N'Providence Memorial Hospital', 1, NULL, NULL, N'450002', NULL, NULL, 0, 486, NULL, N'9155776011', N'9155776109', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2001 N Oregon St', N'El Paso', N'TX', N'48141', N'79902', 31.771508999999998, -106.499782, 3268, 262, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5156, N'Memorial Hermann Baptist Orange Hospital', 1, NULL, NULL, N'450005', NULL, NULL, 0, 112, NULL, N'4098839361', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'608 Strickland Drive', N'Orange', N'TX', N'48361', N'77630', 30.097485, -93.765753, 3348, 258, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5157, N'Peterson Regional Medical Center', 1, NULL, NULL, N'450007', NULL, NULL, 0, 145, NULL, N'8308964200', N'8302587381', 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'551 Hill Country Drive', N'Kerrville', N'TX', N'48265', N'78028', 30.040836, -99.146618, 3312, 271, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5158, N'Children''s Hospital -Scott & White Healthcare', 1, NULL, NULL, N'450008', NULL, NULL, 0, 138, NULL, N'2547718600', N'2547718665', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1901 Sw H K Dodgen Loop', N'Temple', N'TX', N'48027', N'76502', 31.074732, -97.375526, 3382, 272, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5159, N'United Regional Health Care System', 1, NULL, NULL, N'450010', NULL, NULL, 0, 565, NULL, N'9407643055', N'9407643041', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1600 11Th Street', N'Wichita Falls', N'TX', N'48485', N'76301', 33.902946, -98.500506, 3402, 276, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5160, N'St Joseph Regional Health Center', 1, NULL, NULL, N'450011', NULL, NULL, 0, 316, NULL, N'9797763912', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2801 Franciscan Dr', N'Bryan', N'TX', N'48041', N'77802', 30.655606, -96.347298, 3231, 259, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5161, N'Parkland Health And Hospital System', 1, NULL, NULL, N'450015', NULL, NULL, 0, 968, NULL, N'2145908000', N'2145908096', 1, 1, 1, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5201 Harry Hines Blvd', N'Dallas', N'TX', N'48113', N'75235', 32.81088, -96.835826, 3255, 261, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5162, N'University Of Texas Medical Branch', 1, NULL, NULL, N'450018', NULL, NULL, 0, 1236, NULL, N'4097721011', NULL, 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'301 University Boulevard', N'Galveston', N'TX', N'48167', N'77555', 29.310307, -94.774521, 3278, 265, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5163, N'Baylor University Medical Center', 1, NULL, NULL, N'450021', NULL, NULL, 0, 997, NULL, N'2148200111', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3500 Gaston Ave', N'Dallas', N'TX', N'48113', N'75246', 32.790462, -96.780872, 3255, 261, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5164, N'Citizens Medical Center', 1, NULL, NULL, N'450023', NULL, NULL, 0, 344, NULL, N'3615725113', N'3615725070', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2701 Hospital Drive', N'Victoria', N'TX', N'48469', N'77901', 28.813648, -96.976757, 3391, 274, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5165, N'University Medical Center Of El Paso', 1, NULL, NULL, N'450024', NULL, NULL, 0, 346, NULL, N'9155217602', NULL, 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4815 Alameda Ave', N'El Paso', N'TX', N'48141', N'79905', 31.771245, -106.43578, 3268, 262, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5166, N'Vhs Brownsville Hospital Company Llc', 1, NULL, NULL, N'450028', NULL, NULL, 0, 280, NULL, N'9565441400', N'9565542001', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1040 W Jefferson St', N'Brownsville', N'TX', N'48061', N'78520', 25.916721, -97.510803, 3229, 264, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5167, N'Laredo Medical Center', 1, NULL, NULL, N'450029', NULL, NULL, 0, 326, NULL, N'9567965000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1700 East Saunders', N'Laredo', N'TX', N'48479', N'78044', 27.506099, -99.508898, 3320, 271, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5168, N'Good Shepherd Medical Center Marshall', 1, NULL, NULL, N'450032', NULL, NULL, 0, 149, NULL, N'9039276712', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'811 S Washington', N'Marshall', N'TX', N'48203', N'75670', 32.488285, -94.360346, 3331, 126, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5169, N'Vhs Harlingen Hospital Company Llc', 1, NULL, NULL, N'450033', NULL, NULL, 0, 602, NULL, N'9563891100', N'9563891632', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2101 Pease St', N'Harlingen', N'TX', N'48061', N'78550', 26.174531, -97.671551, 3294, 264, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5170, N'Christus Hospital', 1, NULL, NULL, N'450034', NULL, NULL, 0, 658, NULL, N'4098927171', NULL, 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2830 Calder Avenue', N'Beaumont', N'TX', N'48245', N'77702', 30.085677, -94.131252, 3219, 258, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5171, N'St Joseph Medical Center', 1, NULL, NULL, N'450035', NULL, NULL, 0, 792, NULL, N'7137571000', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1401 St. Joseph Parkway', N'Houston', N'TX', N'48201', N'77002', 29.748152, -95.366627, 3299, 265, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5172, N'Good Shepherd Medical Center', 1, NULL, NULL, N'450037', NULL, NULL, 0, 425, NULL, N'9033152000', NULL, 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'700 East Marshall Avenue', N'Longview', N'TX', N'48183', N'75601', 32.501464, -94.731284, 3325, 266, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5173, N'Jps Health Network', 1, NULL, NULL, N'450039', NULL, NULL, 0, 429, NULL, N'8179213431', NULL, 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1500 S Main St', N'Fort Worth', N'TX', N'48439', N'76104', 32.72807, -97.326503, 3274, 263, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5174, N'Covenant Medical Center', 1, NULL, NULL, N'450040', NULL, NULL, 0, 868, NULL, N'8067256000', N'8067237361', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3615 19Th Street', N'Lubbock', N'TX', N'48303', N'79410', 33.577728, -101.892655, 3326, 267, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5175, N'Providence Health Center', 1, NULL, NULL, N'450042', NULL, NULL, 0, 278, NULL, N'2547514000', NULL, 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6901 Medical Parkway', N'Waco', N'TX', N'48309', N'76712', 31.514791, -97.197967, 3392, 275, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5176, N'Ut Southwestern University Hospital St Paul', 1, NULL, NULL, N'450044', NULL, NULL, 0, 550, NULL, N'2146335555', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6201 Harry Hines Blvd', N'Dallas', N'TX', N'48113', N'75390', 32.819472, -96.846871, 3255, 261, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5177, N'Christus Spohn Hospital Corpus Christi', 1, NULL, NULL, N'450046', NULL, NULL, 0, 1049, NULL, N'3619024103', N'3619024949', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'600 Elizabeth Street', N'Corpus Christi', N'TX', N'48355', N'78404', 27.777363, -97.3971, 3250, 260, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5178, N'Methodist Dallas Medical Center', 1, NULL, NULL, N'450051', NULL, NULL, 0, 478, NULL, N'2149472879', N'2149472519', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1441 North Beckley Avenue', N'Dallas', N'TX', N'48113', N'75203', 32.761651, -96.823094, 3255, 261, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5179, N'Goodall Witcher Hospital', 1, NULL, NULL, N'450052', NULL, NULL, 0, 33, NULL, N'2546758322', NULL, 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'101 Posey Avenue', N'Clifton', N'TX', N'48035', N'76634', 31.78238, -97.576686, 3244, 275, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5180, N'Scott & White Memorial Hospital', 1, NULL, NULL, N'450054', NULL, NULL, 0, 732, NULL, N'2547242111', N'2547246120', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2401 31St St', N'Temple', N'TX', N'48027', N'76508', 31.098207, -97.342785, 3382, 272, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5181, N'Rolling Plains Memorial Hospital', 1, NULL, NULL, N'450055', NULL, NULL, 0, 85, NULL, N'3252351701', NULL, 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'200 E Arizona', N'Sweetwater', N'TX', N'48353', N'79556', 32.454536, -100.39492, 3380, 255, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5182, N'Seton Medical Center Austin', 1, NULL, NULL, N'450056', NULL, NULL, 0, 471, NULL, N'5123241000', N'5123241924', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1201 W 38Th St', N'Austin', N'TX', N'48453', N'78705', 30.305992, -97.744969, 3215, 257, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5183, N'Baptist Medical Center', 1, NULL, NULL, N'450058', NULL, NULL, 0, 1741, NULL, N'2102971020', N'2102970005', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'111 Dallas Street', N'San Antonio', N'TX', N'48029', N'78205', 29.433045, -98.492681, 3370, 271, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5184, N'Texas Health Arlington Memorial Hospital', 1, NULL, NULL, N'450064', NULL, NULL, 0, 369, NULL, N'8175486100', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'800 W Randol Mill Rd', N'Arlington', N'TX', N'48439', N'76012', 32.750053, -97.115918, 3211, 263, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5185, N'Memorial Hermann Texas Medical Center', 1, NULL, NULL, N'450068', NULL, NULL, 0, 908, NULL, N'7137043700', NULL, 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6411 Fannin', N'Houston', N'TX', N'48201', N'77030', 29.714753, -95.396766, 3299, 265, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5186, N'Brazosport Regional Health System', 1, NULL, NULL, N'450072', NULL, NULL, 0, 165, NULL, N'9792974411', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'100 Medical Drive', N'Lake Jackson', N'TX', N'48039', N'77566', 29.030003, -95.452401, 3318, 265, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5187, N'Cogdell Memorial Hospital', 1, NULL, NULL, N'450073', NULL, NULL, 0, 49, NULL, N'3255747437', N'3255747433', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1700 Cogdell Blvd', N'Snyder', N'TX', N'48415', N'79549', 32.688478, -100.917746, 3376, 267, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5188, N'University Of Texas M D Anderson Cancer Center The', 1, NULL, NULL, N'450076', NULL, NULL, 0, 656, NULL, N'7137922121', NULL, 1, 1, 0, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1515 Holcombe Blvd', N'Houston', N'TX', N'48201', N'77030', 29.706311, -95.397153, 3299, 265, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5189, N'Anson General Hospital', 1, NULL, NULL, N'450078', NULL, NULL, 0, 45, NULL, N'3258233231', N'3258233098', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'101 Avenue J', N'Anson', N'TX', N'48253', N'79501', 32.766629, -99.895401, 3209, 255, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5190, N'Baylor Medical Center At Irving', 1, NULL, NULL, N'450079', NULL, NULL, 0, 288, NULL, N'9725798100', N'9725795290', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1901 N Macarthur Blvd', N'Irving', N'TX', N'48113', N'75061', 32.835159, -96.960431, 3303, 261, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5191, N'Titus Regional Medical Center', 1, NULL, NULL, N'450080', NULL, NULL, 0, 165, NULL, N'9035776000', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2001 N Jefferson', N'Mount Pleasant', N'TX', N'48449', N'75455', 33.156786, -94.968269, 3339, 273, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5192, N'Christus Spohn Hospital Beeville', 1, NULL, NULL, N'450082', NULL, NULL, 0, 69, NULL, N'3613542000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1500 E Houston Hwy', N'Beeville', N'TX', N'48025', N'78102', 28.400832, -97.748331, 3221, 260, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5193, N'East Texas Medical Center', 1, NULL, NULL, N'450083', NULL, NULL, 0, 536, NULL, N'9035970351', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1000 South Beckham Street', N'Tyler', N'TX', N'48423', N'75701', 32.35126, -95.301062, 3388, 273, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5194, N'Graham Regional Medical Center', 1, NULL, NULL, N'450085', NULL, NULL, 0, 42, NULL, N'9405493400', N'9405215156', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1301 Montgomery Road', N'Graham', N'TX', N'48503', N'76450', 33.089271, -98.58364, 3285, 263, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5195, N'North Hills Hospital', 1, NULL, NULL, N'450087', NULL, NULL, 0, 140, NULL, N'8172551000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4401 Booth Calloway Road', N'North Richland Hills', N'TX', N'48439', N'76180', 32.829371, -97.212307, 3274, 263, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5196, N'North Texas Medical Center', 1, NULL, NULL, N'450090', NULL, NULL, 0, 60, NULL, N'9406128600', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1900 Hospital Blvd', N'Gainesville', N'TX', N'48097', N'76240', 33.646242, -97.161624, 3277, 261, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5197, N'Fort Duncan Medical Center', 1, NULL, NULL, N'450092', NULL, NULL, 0, 101, NULL, N'8307735321', N'8308722517', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3333 N Foster Maldonado Blvd', N'Eagle Pass', N'TX', N'48323', N'78852', 28.709143, -100.499521, 3264, 271, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5198, N'Bayshore Medical Center', 1, NULL, NULL, N'450097', NULL, NULL, 0, 476, NULL, N'7133591000', NULL, 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4000 Spencer Hwy', N'Pasadena', N'TX', N'48201', N'77504', 29.665073, -95.182418, 3353, 265, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5199, N'Pampa Regional Medical Center', 1, NULL, NULL, N'450099', NULL, NULL, 0, 115, NULL, N'8066653721', N'8066635514', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1 Medical Plaza', N'Pampa', N'TX', N'48179', N'79065', 35.536156, -100.959871, 3351, 256, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5200, N'Hillcrest Baptist Medical Center', 1, NULL, NULL, N'450101', NULL, NULL, 0, 393, NULL, N'2542022000', N'2542029441', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'100 Hillcrest Medical Blvd', N'Waco', N'TX', N'48309', N'76712', 31.549333, -97.146669, 3392, 275, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5201, N'Mother Frances Hospital', 1, NULL, NULL, N'450102', NULL, NULL, 0, 474, NULL, N'9035938441', NULL, 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'800 East Dawson', N'Tyler', N'TX', N'48423', N'75701', 32.341524, -95.286599, 3388, 273, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5202, N'Guadalupe Regional Medical Center', 1, NULL, NULL, N'450104', NULL, NULL, 0, 117, NULL, N'8303792411', N'8303721582', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1215 E Court St', N'Seguin', N'TX', N'48187', N'78155', 29.568977, -97.950962, 3372, 271, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5203, N'Las Palmas Medical Center', 1, NULL, NULL, N'450107', NULL, NULL, 0, 550, NULL, N'9155211200', N'9155445203', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1801 North Oregon Street', N'El Paso', N'TX', N'48141', N'79902', 31.769937, -106.498394, 3268, 262, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5204, N'Connally Memorial Medical Center', 1, NULL, NULL, N'450108', NULL, NULL, 0, 44, NULL, N'8303931300', N'8303931301', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'499 10Th Street', N'Floresville', N'TX', N'48493', N'78114', 29.148747, -98.160541, 3370, 271, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5205, N'South Texas Health System', 1, NULL, NULL, N'450119', NULL, NULL, 0, 848, NULL, N'9566324000', N'9562892002', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1102 W Trenton Road', N'Edinburg', N'TX', N'48215', N'78539', 26.263306, -98.183191, 3266, 268, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5206, N'University Medical Center At Brackenridge', 1, NULL, NULL, N'450124', NULL, NULL, 0, 399, NULL, N'5123247000', N'5123247051', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'601 E 15Th Street', N'Austin', N'TX', N'48453', N'78701', 30.274315, -97.732447, 3215, 257, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5207, N'Knapp Medical Center', 1, NULL, NULL, N'450128', NULL, NULL, 0, 233, NULL, N'9569688567', N'9569692293', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1401 East Eight Street', N'Weslaco', N'TX', N'48215', N'78596', 26.163237, -98.01578, 3398, 264, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5208, N'Nix Health Care System', 1, NULL, NULL, N'450130', NULL, NULL, 0, 294, NULL, N'2102712188', N'2102712023', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'414 Navarro Suite 600', N'San Antonio', N'TX', N'48029', N'78205', 29.4246, -98.49514, 3370, 271, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5209, N'Medical Center Hospital', 1, NULL, NULL, N'450132', NULL, NULL, 0, 396, NULL, N'4326404000', NULL, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'500 W 4Th Street', N'Odessa', N'TX', N'48135', N'79761', 31.844766, -102.374387, 3346, 269, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5210, N'Midland Memorial Hospital', 1, NULL, NULL, N'450133', NULL, NULL, 0, 321, NULL, N'4326851111', N'4326854970', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'400 Rosalind Redfern Grover Parkway', N'Midland', N'TX', N'48329', N'79701', 31.997366, -102.077948, 3336, 269, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5211, N'Texas Health Harris Methodist Fort Worth', 1, NULL, NULL, N'450135', NULL, NULL, 0, 610, NULL, N'8172502100', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1301 Pennsylvania Avenue', N'Fort Worth', N'TX', N'48439', N'76104', 32.738406, -97.339167, 3274, 263, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5212, N'Baylor All Saints Medical Center At Fw', 1, NULL, NULL, N'450137', NULL, NULL, 0, 537, NULL, N'8179262544', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1400 Eighth Ave', N'Fort Worth', N'TX', N'48439', N'76104', 32.753177, -97.332746, 3274, 263, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5213, N'Seton Smithville Regional Hospital', 1, NULL, NULL, N'450143', NULL, NULL, 0, 36, NULL, N'5122373214', N'5122375708', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'800 East Highway 71', N'Smithville', N'TX', N'48021', N'78957', 30.008554, -97.159432, 3215, 257, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5214, N'Permian Regional Medical Center Andrews County Ho', 1, NULL, NULL, N'450144', NULL, NULL, 0, 85, NULL, N'4325232200', N'4324642180', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'720 Hospital Drive', N'Andrews', N'TX', N'48003', N'79714', 32.318716, -102.545715, 3207, 267, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5215, N'Detar Hospital Navarro', 1, NULL, NULL, N'450147', NULL, NULL, 0, 308, NULL, N'3615757441', NULL, 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'506 E San Antonio St', N'Victoria', N'TX', N'48469', N'77902', 28.807463, -97.001664, 3391, 274, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5216, N'Texas Health Harris Methodist Hospital Cleburne', 1, NULL, NULL, N'450148', NULL, NULL, 0, 137, NULL, N'8176412551', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'201 Walls Drive', N'Cleburne', N'TX', N'48251', N'76033', 32.33158, -97.438486, 3242, 263, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5217, N'Metroplex Hospital', 1, NULL, NULL, N'450152', NULL, NULL, 0, 177, NULL, N'2545267523', N'2545263483', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2201 S Clear Creek Road', N'Killeen', N'TX', N'48027', N'76542', 31.117144, -97.727796, 3314, 272, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5218, N'Val Verde Regional Medical Center', 1, NULL, NULL, N'450154', NULL, NULL, 0, 93, NULL, N'8307758566', N'8307031704', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'801 Bedell Ave', N'Del Rio', N'TX', N'48465', N'78840', 29.36273, -100.896761, 3258, 271, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5219, N'Hereford Regional Medical Center', 1, NULL, NULL, N'450155', NULL, NULL, 0, 40, NULL, N'8063642141', N'8063499387', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'801 East Third', N'Hereford', N'TX', N'48117', N'79045', 34.815062, -102.397704, 3205, 256, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5220, N'Grace Medical Center', 1, NULL, NULL, N'450162', NULL, NULL, 0, 123, NULL, N'8067884100', N'8067884278', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2412 50Th St', N'Lubbock', N'TX', N'48303', N'79412', 33.548816, -101.868521, 3326, 267, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5221, N'Christus Spohn Hospital Kleberg', 1, NULL, NULL, N'450163', NULL, NULL, 0, 106, NULL, N'3615951661', N'3615955005', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1311 East General Cavazos Blvd', N'Kingsville', N'TX', N'48273', N'78363', 27.491316, -97.852222, 3315, 260, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5222, N'South Texas Regional Medical Center', 1, NULL, NULL, N'450165', NULL, NULL, 0, 30, NULL, N'8307693515', N'8307695264', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1905 Hwy 97 East', N'Jourdanton', N'TX', N'48013', N'78026', 28.918029, -98.546407, 3306, 271, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5223, N'Mission Regional Medical Center', 1, NULL, NULL, N'450176', NULL, NULL, 0, 297, NULL, N'9563239000', N'9565809102', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'900 South Bryan Road', N'Mission', N'TX', N'48215', N'78572', 26.198901, -98.312415, 3332, 268, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5224, N'Uvalde Memorial Hospital', 1, NULL, NULL, N'450177', NULL, NULL, 0, 66, NULL, N'8302786251', N'8302788529', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1025 Garner Field Road', N'Uvalde', N'TX', N'48463', N'78801', 29.214884, -99.769304, 3389, 271, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5225, N'Pecos County Memorial Hospital', 1, NULL, NULL, N'450178', NULL, NULL, 0, 27, NULL, N'4323364201', N'4323364545', 1, 1, 1, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'387 West I 10', N'Fort Stockton', N'TX', N'48371', N'79735', 30.894043, -102.879322, 3273, 269, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5226, N'Memorial Hermann Hospital System', 1, NULL, NULL, N'450184', NULL, NULL, 0, 1368, NULL, N'7134486796', NULL, 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1635  North Loop West', N'Houston', N'TX', N'48201', N'77008', 29.812882, -95.422342, 3299, 265, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5227, N'Scott & White Hospital Brenham', 1, NULL, NULL, N'450187', NULL, NULL, 0, 99, NULL, N'9798366173', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'700 Medical Parkway', N'Brenham', N'TX', N'48477', N'77833', 30.145778, -96.39854, 3228, 265, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5228, N'Hill Regional Hospital', 1, NULL, NULL, N'450192', NULL, NULL, 0, 92, NULL, N'2545808500', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'101 Circle Drive', N'Hillsboro', N'TX', N'48217', N'76645', 32.010989, -97.130006, 3298, 275, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5229, N'Chi St Luke''s Health Baylor College Of Medicine Me', 1, NULL, NULL, N'450193', NULL, NULL, 0, 850, NULL, N'8323551000', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6720 Bertner', N'Houston', N'TX', N'48201', N'77030', 29.706776, -95.399023, 3299, 265, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5230, N'East Texas Medical Center Jacksonville', 1, NULL, NULL, N'450194', NULL, NULL, 0, 74, NULL, N'9035415000', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'501 S Ragsdale', N'Jacksonville', N'TX', N'48073', N'75766', 31.963778, -95.270504, 3304, 273, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5231, N'Paris Regional Medical Center', 1, NULL, NULL, N'450196', NULL, NULL, 0, 368, NULL, N'9037854521', N'9037373848', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'820 Clarksville St', N'Paris', N'TX', N'48277', N'75460', 33.660152, -95.546536, 3352, 261, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5232, N'Wadley Regional Medical Center', 1, NULL, NULL, N'450200', NULL, NULL, 0, 370, NULL, N'9037988000', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1000 Pine Street', N'Texarkana', N'TX', N'48037', N'75501', 33.428067, -94.046783, 3384, 16, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5233, N'Weatherford Regional Medical Center', 1, NULL, NULL, N'450203', NULL, NULL, 0, 99, NULL, N'8175991190', N'8175991162', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'713 E Anderson St', N'Weatherford', N'TX', N'48367', N'76086', 32.747548, -97.786008, 3394, 263, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5234, N'Northwest Texas Hospital', 1, NULL, NULL, N'450209', NULL, NULL, 0, 475, NULL, N'8063541110', N'8063541109', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1501 Coulter Road', N'Amarillo', N'TX', N'48375', N'79106', 35.207219, -101.833825, 3205, 256, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5235, N'Etmc Carthage', 1, NULL, NULL, N'450210', NULL, NULL, 0, 42, NULL, N'936933841', N'9036944633', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'409 West Cottage', N'Carthage', N'TX', N'48365', N'75633', 32.157041, -94.338114, 3238, 126, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5236, N'Memorial Medical Center Of East Texas', 1, NULL, NULL, N'450211', NULL, NULL, 0, 271, NULL, N'9366348111', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1201 West Frank Street', N'Lufkin', N'TX', N'48005', N'75901', 31.338241, -94.729097, 3327, 265, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5237, N'University Health System', 1, NULL, NULL, N'450213', NULL, NULL, 0, 604, NULL, N'2103584000', N'2103584020', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4502 Medical Dr', N'San Antonio', N'TX', N'48029', N'78229', 29.508958, -98.574765, 3370, 271, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5238, N'Gulf Coast Medical Center', 1, NULL, NULL, N'450214', NULL, NULL, 0, 161, NULL, N'9795322500', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'10141 Us 59 North', N'Wharton', N'TX', N'48481', N'77488', 29.30524, -96.075482, 3399, 265, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5239, N'Scott & White Hospital-Llano', 1, NULL, NULL, N'450219', NULL, NULL, 0, 30, NULL, N'3252475040', N'9152472313', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'200 W Ollie', N'Llano', N'TX', N'48299', N'78643', 30.743325, -98.680405, 3324, 257, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5240, N'Moore County Hospital District', 1, NULL, NULL, N'450221', NULL, NULL, 0, 60, NULL, N'8069357171', N'8069356458', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'224 E Second Street', N'Dumas', N'TX', N'48341', N'79029', 35.865595, -101.973235, 3262, 256, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5241, N'Conroe Regional Medical Center', 1, NULL, NULL, N'450222', NULL, NULL, 0, 260, NULL, N'9365391111', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'504 Medical Center Blvd', N'Conroe', N'TX', N'48339', N'77304', 30.284719, -95.466099, 3249, 265, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5242, N'Hendrick Medical Center', 1, NULL, NULL, N'450229', NULL, NULL, 0, 511, NULL, N'3256702000', N'3256702293', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1900 Pine', N'Abilene', N'TX', N'48441', N'79601', 32.446453, -99.733348, 3201, 255, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5243, N'Baptist St Anthony''s Hospital', 1, NULL, NULL, N'450231', NULL, NULL, 0, 452, NULL, N'8062122000', N'8062122919', 1, 1, 0, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1600 Wallace Blvd', N'Amarillo', N'TX', N'48375', N'79106', 35.196373, -101.920403, 3205, 256, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5244, N'Memorial Hospital', 1, NULL, NULL, N'450235', NULL, NULL, 0, 35, NULL, N'8306727581', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1110 North Sarah Dewitt Drive', N'Gonzales', N'TX', N'48177', N'78629', 29.515056, -97.465798, 3284, 271, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5245, N'Hopkins County Memorial Hospital', 1, NULL, NULL, N'450236', NULL, NULL, 0, 96, NULL, N'9038857671', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'115 Airport Rd', N'Sulphur Springs', N'TX', N'48223', N'75482', 33.15622, -95.599317, 3379, 261, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5246, N'Christus Santa Rosa Hospital', 1, NULL, NULL, N'450237', NULL, NULL, 0, 601, NULL, N'2107043342', N'2107043466', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'333 North Santa Rosa Steet', N'San Antonio', N'TX', N'48029', N'78207', 29.4246, -98.49514, 3370, 271, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5247, N'Faith Community Hospital', 1, NULL, NULL, N'450241', NULL, NULL, 0, 41, NULL, N'9405676633', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'717 Magnolia St', N'Jacksboro', N'TX', N'48237', N'76458', 33.225268, -98.170002, 3402, 276, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5248, N'Hamlin Memorial Hospital', 1, NULL, NULL, N'450243', NULL, NULL, 0, 25, NULL, N'3255763646', N'3255762922', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'632 N W Second Street', N'Hamlin', N'TX', N'48253', N'79520', 32.88483, -100.126491, 3293, 255, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5249, N'Bellville General Hospital', 1, NULL, NULL, N'450253', NULL, NULL, 0, 32, NULL, N'9798653141', NULL, 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'44 N Cummings', N'Bellville', N'TX', N'48015', N'77418', 29.950225, -96.257186, 3222, 265, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5250, N'Wise Regional Health System', 1, NULL, NULL, N'450271', NULL, NULL, 0, 85, NULL, N'9406275921', N'9406260101', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'609 Medical Center Drive', N'Decatur', N'TX', N'48497', N'76234', 33.219931, -97.593815, 3257, 261, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5251, N'Central Texas Medical Center', 1, NULL, NULL, N'450272', NULL, NULL, 0, 113, NULL, N'5127533690', N'5127533598', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1301 Wonder World Drive', N'San Marcos', N'TX', N'48209', N'78666', 29.852505, -97.9478, 3371, 257, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5252, N'Baylor Medical Center At Garland', 1, NULL, NULL, N'450280', NULL, NULL, 0, 243, NULL, N'9724875000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2300 Marie Curie Drive', N'Garland', N'TX', N'48113', N'75042', 32.918681, -96.662062, 3279, 261, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5253, N'Harris Health System', 1, NULL, NULL, N'450289', NULL, NULL, 0, 975, NULL, N'7135666417', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2525 Holly Hall', N'Houston', N'TX', N'48201', N'77054', 29.758938, -95.367697, 3299, 265, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5254, N'Texas Health Presbyterian Hospital Kaufman', 1, NULL, NULL, N'450292', NULL, NULL, 0, 91, NULL, N'9729327200', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'850 Ed Hall', N'Kaufman', N'TX', N'48257', N'75142', 32.567088, -96.307332, 3309, 261, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5255, N'Frio Regional Hospital', 1, NULL, NULL, N'450293', NULL, NULL, 0, 22, NULL, N'8303343617', N'8303349812', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'200 S Ih 35', N'Pearsall', N'TX', N'48163', N'78061', 28.892194, -99.095033, 3370, 271, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5256, N'College Station Medical Center', 1, NULL, NULL, N'450299', NULL, NULL, 0, 167, NULL, N'9797645151', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1604 Rock Prairie Road', N'College Station', N'TX', N'48041', N'77842', 30.626262, -96.334725, 3231, 259, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5257, N'Stamford Memorial Hospital', 1, NULL, NULL, N'450306', NULL, NULL, 0, 25, NULL, N'3257732725', N'3257733781', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1601 Columbia Street', N'Stamford', N'TX', N'48253', N'79553', 32.934613, -99.785258, 3201, 255, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5258, N'Texoma Medical Center', 1, NULL, NULL, N'450324', NULL, NULL, 0, 251, NULL, N'9034164000', NULL, 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5016 S Us Highway 75', N'Denison', N'TX', N'48181', N'75020', 33.706208, -96.584453, 3259, 261, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5259, N'Oakbend Medical Center', 1, NULL, NULL, N'450330', NULL, NULL, 0, 243, NULL, N'2813413000', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1705 Jackson St', N'Richmond', N'TX', N'48157', N'77469', 29.577034, -95.77168, 3364, 265, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5260, N'San Angelo Community Medical Center', 1, NULL, NULL, N'450340', NULL, NULL, 0, 171, NULL, N'3259499511', N'3259476550', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3501 Knickerbocker Road', N'San Angelo', N'TX', N'48451', N'76904', 31.381516, -100.490596, 3369, 270, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5261, N'Baptist Beaumont Hospital', 1, NULL, NULL, N'450346', NULL, NULL, 0, 507, NULL, N'4092125012', N'4092125022', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3080 College Street', N'Beaumont', N'TX', N'48245', N'77701', 30.068542, -94.120501, 3219, 258, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5262, N'Huntsville Memorial Hospital', 1, NULL, NULL, N'450347', NULL, NULL, 0, 144, NULL, N'9362913411', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'110 Memorial Hospital Drive', N'Huntsville', N'TX', N'48471', N'77340', 30.697776, -95.557365, 3301, 265, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5263, N'Falls Community Hospital And Clinic', 1, NULL, NULL, N'450348', NULL, NULL, 0, 44, NULL, N'2548033561', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'322 Coleman Street', N'Marlin', N'TX', N'48145', N'76661', 31.307382, -96.893163, 3330, 275, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5264, N'Texas Health Harris Methodist Hospital Stephenvill', 1, NULL, NULL, N'450351', NULL, NULL, 0, 98, NULL, N'2549651500', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'411 N Belknap St', N'Stephenville', N'TX', N'48143', N'76401', 32.222313, -98.204167, 3378, 263, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5265, N'Hunt Regional Medical Center', 1, NULL, NULL, N'450352', NULL, NULL, 0, 192, NULL, N'9034085000', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4215 Joe Ramsey Blvd', N'Greenville', N'TX', N'48231', N'75401', 33.123453, -96.123541, 3289, 261, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5266, N'Methodist Hospital The', 1, NULL, NULL, N'450358', NULL, NULL, 0, 1299, NULL, N'7137902221', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6565 Fannin', N'Houston', N'TX', N'48201', N'77030', 29.710741, -95.399149, 3299, 265, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5267, N'Childress Regional Medical Center', 1, NULL, NULL, N'450369', NULL, NULL, 0, 39, NULL, N'9409376371', N'9409379133', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Hwy 83 North', N'Childress', N'TX', N'48075', N'79201', 34.426453, -100.204002, 3239, 256, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5268, N'Columbus Community Hospital', 1, NULL, NULL, N'450370', NULL, NULL, 0, 40, NULL, N'9797322371', NULL, 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'110 Shult Dr', N'Columbus', N'TX', N'48089', N'78934', 29.694364, -96.542532, 3247, 265, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5269, N'Baylor Scott & White Medical Center- Waxahachie', 1, NULL, NULL, N'450372', NULL, NULL, 0, 69, NULL, N'9729237000', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2400 N Interstate Highway 35E', N'Waxahachie', N'TX', N'48139', N'75165', 32.386531, -96.848331, 3393, 261, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5270, N'East Texas Medical Center Mount Vernon', 1, NULL, NULL, N'450373', NULL, NULL, 0, 49, NULL, N'9035374552', NULL, 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'500 S State Hwy 37', N'Mount Vernon', N'TX', N'48159', N'75457', 33.188727, -95.221332, 3340, 273, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5271, N'Dallas Medical Center', 1, NULL, NULL, N'450379', NULL, NULL, 0, 155, NULL, N'9722471000', N'9728887090', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7 Medical Parkway', N'Dallas', N'TX', N'48113', N'75234', 32.914894, -96.87054, 3255, 261, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5272, N'Methodist Hospital', 1, NULL, NULL, N'450388', NULL, NULL, 0, 1887, NULL, N'2105754000', N'2105756420', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7700 Floyd Curl Dr', N'San Antonio', N'TX', N'48029', N'78229', 29.507341, -98.573582, 3370, 271, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5273, N'East Texas Medical Center Athens', 1, NULL, NULL, N'450389', NULL, NULL, 0, 127, NULL, N'9036761000', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2000 South Palestine', N'Athens', N'TX', N'48213', N'75751', 32.204873, -95.855521, 3213, 261, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5274, N'Memorial Medical Center Livingston', 1, NULL, NULL, N'450395', NULL, NULL, 0, 66, NULL, N'9363274381', N'9363298730', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1717 Hwy 59 Bypass', N'Livingston', N'TX', N'48373', N'77351', 30.711029, -94.93299, 3327, 265, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5275, N'Brownfield Regional Medical Center', 1, NULL, NULL, N'450399', NULL, NULL, 0, 71, NULL, N'8066373551', N'8066371779', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'705 East Felt Street', N'Brownfield', N'TX', N'48445', N'79316', 33.187147, -102.2677, 3326, 267, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5276, N'Parkview Regional Hospital', 1, NULL, NULL, N'450400', NULL, NULL, 0, 59, NULL, N'2545625332', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'600 South Bonham Street', N'Mexia', N'TX', N'48293', N'76667', 31.672444, -96.479739, 3335, 275, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5277, N'Medical Center Of Mckinney', 1, NULL, NULL, N'450403', NULL, NULL, 0, 225, NULL, N'9725478000', NULL, 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4500 Medical Center Drive', N'Mckinney', N'TX', N'48085', N'75069', 33.19765, -96.615447, 3334, 261, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5278, N'Eastland Memorial Hospital', 1, NULL, NULL, N'450411', NULL, NULL, 0, 83, NULL, N'2546292601', NULL, 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'304 S Daugherty', N'Eastland', N'TX', N'48133', N'76448', 32.402548, -98.812875, 3265, 255, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5279, N'Texas Health Harris Methodist Hospital Azle', 1, NULL, NULL, N'450419', NULL, NULL, 0, 36, NULL, N'8174448700', NULL, 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'108 Denver Trail', N'Azle', N'TX', N'48439', N'76020', 32.881176, -97.531778, 3216, 263, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5280, N'Baylor Medical Center At Uptown', 1, NULL, NULL, N'450422', NULL, NULL, 0, 28, NULL, N'2144433000', N'2144433049', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2727 East Lemmon Avenue Building I', N'Dallas', N'TX', N'48113', N'75204', 32.776196, -96.796899, 3255, 261, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5281, N'San Jacinto Methodist Hospital', 1, NULL, NULL, N'450424', NULL, NULL, 0, 318, NULL, N'2814208600', NULL, 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4401 Garth Road', N'Baytown', N'TX', N'48201', N'77521', 29.769101, -94.977634, 3218, 265, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5282, N'St David''s Medical Center', 1, NULL, NULL, N'450431', NULL, NULL, 0, 570, NULL, N'5124767111', N'5124048102', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'919 E 32Nd St', N'Austin', N'TX', N'48453', N'78705', 30.290842, -97.726884, 3215, 257, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5283, N'Navarro Regional Hospital', 1, NULL, NULL, N'450447', NULL, NULL, 0, 162, NULL, N'9036546800', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3201 West Highway 22', N'Corsicana', N'TX', N'48349', N'75110', 32.091299, -96.464682, 3251, 261, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5284, N'Glen Rose Medical Center', 1, NULL, NULL, N'450451', NULL, NULL, 0, 16, NULL, N'2548972215', N'2548971427', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1021 Holden Street', N'Glen Rose', N'TX', N'48425', N'76043', 32.240635, -97.748666, 3283, 263, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5285, N'Tyler County Hospital', 1, NULL, NULL, N'450460', NULL, NULL, 0, 25, NULL, N'4092838141', NULL, 1, 0, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1100 West Bluff', N'Woodville', N'TX', N'48457', N'75979', 30.77526, -94.426934, 3406, 258, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5286, N'Texas Health Presbyterian Hospital  Dallas', 1, NULL, NULL, N'450462', NULL, NULL, 0, 866, NULL, N'2143456789', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'8200 Walnut Hill Lane', N'Dallas', N'TX', N'48113', N'75231', 32.883172, -96.762011, 3255, 261, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5287, N'Matagorda Regional Medical Center', 1, NULL, NULL, N'450465', NULL, NULL, 0, 58, NULL, N'9792456383', N'9792451525', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'104 7Th Street', N'Bay City', N'TX', N'48321', N'77414', 28.982748, -95.981991, 3217, 265, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5288, N'Wilson N Jones Regional Medical Center', 1, NULL, NULL, N'450469', NULL, NULL, 0, 241, NULL, N'9038704611', N'9038912030', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'500 N Highland Avenue', N'Sherman', N'TX', N'48181', N'75091', 33.650091, -96.625593, 3375, 261, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5289, N'Etmc Henderson', 1, NULL, NULL, N'450475', NULL, NULL, 0, 158, NULL, N'9036577541', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'300 Wilson Street', N'Henderson', N'TX', N'48401', N'75652', 32.161545, -94.796278, 3297, 273, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5290, N'Woodland Heights Medical Center', 1, NULL, NULL, N'450484', NULL, NULL, 0, 117, NULL, N'9366348311', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'505 South John Redditt Drive', N'Lufkin', N'TX', N'48005', N'75904', 31.338241, -94.729097, 3327, 265, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5291, N'Allegiance Specialty Hospital Of Kilgore', 1, NULL, NULL, N'450488', NULL, NULL, 0, 60, NULL, N'9039843505', N'9039834354', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1612 South Henderson Blvd', N'Kilgore', N'TX', N'48183', N'75662', 32.374598, -94.869074, 3313, 266, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5292, N'Medical Arts Hospital', 1, NULL, NULL, N'450489', NULL, NULL, 0, 44, NULL, N'8068722183', NULL, 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2200 N Bryan Ave', N'Lamesa', N'TX', N'48115', N'79331', 32.73221, -101.96098, 3326, 267, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5293, N'Bowie Memorial Hospital', 1, NULL, NULL, N'450497', NULL, NULL, 0, 49, NULL, N'9408721126', NULL, 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'705 East Greenwood Av', N'Bowie', N'TX', N'48337', N'76230', 33.561446, -97.834615, 3225, 276, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5294, N'Stephens Memorial Hospital', 1, NULL, NULL, N'450498', NULL, NULL, 0, 40, NULL, N'2545592241', N'2545596536', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'200 South Geneva Street', N'Breckenridge', N'TX', N'48429', N'76424', 32.753741, -98.88766, 3227, 255, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5295, N'Memorial Hospital', 1, NULL, NULL, N'450508', NULL, NULL, 0, 216, NULL, N'9365644611', N'9365688588', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1204 Mound St', N'Nacogdoches', N'TX', N'48347', N'75961', 31.603513, -94.655487, 3342, 265, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5296, N'The Medical Center Of Southeast Texas', 1, NULL, NULL, N'450518', NULL, NULL, 0, 424, NULL, N'4098535900', N'4098535910', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2555 Jimmy Johnson Blvd', N'Port Arthur', N'TX', N'48245', N'77640', 29.898826, -93.928781, 3358, 258, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5297, N'Methodist Richardson Medical Center', 1, NULL, NULL, N'450537', NULL, NULL, 0, 205, NULL, N'4692041000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2831 E President George Bush Highway', N'Richardson', N'TX', N'48113', N'75082', 32.948179, -96.729721, 3255, 261, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5298, N'Covenant Hospital Plainview', 1, NULL, NULL, N'450539', NULL, NULL, 0, 100, NULL, N'8062965531', N'8062931885', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2601 Dimmitt Rd', N'Plainview', N'TX', N'48189', N'79072', 34.206789, -101.731133, 3326, 267, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5299, N'Abilene Regional Medical Center', 1, NULL, NULL, N'450558', NULL, NULL, 0, 231, NULL, N'3254281000', N'3254281029', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6250 Hwy 83/84', N'Abilene', N'TX', N'48441', N'79606', 32.446453, -99.733348, 3201, 255, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5300, N'Baylor Regional Medical Center At Grapevine', 1, NULL, NULL, N'450563', NULL, NULL, 0, 273, NULL, N'8174811588', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1650 W College St', N'Grapevine', N'TX', N'48439', N'76051', 32.93567, -97.09337, 3288, 261, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5301, N'Palo Pinto General Hospital', 1, NULL, NULL, N'450565', NULL, NULL, 0, 99, NULL, N'9403257891', NULL, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'400 Southwest 25 Ave', N'Mineral Wells', N'TX', N'48363', N'76067', 32.808461, -98.112822, 3337, 263, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5302, N'Shannon Medical Center', 1, NULL, NULL, N'450571', NULL, NULL, 0, 401, NULL, N'3256536741', N'3256588295', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'120 East Harris Avenue', N'San Angelo', N'TX', N'48451', N'76903', 31.464551, -100.435164, 3369, 270, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5303, N'Christus Jasper Memorial Hospital', 1, NULL, NULL, N'450573', NULL, NULL, 0, 59, NULL, N'4093845461', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1275 Marvin Hancock Drive', N'Jasper', N'TX', N'48241', N'75951', 30.916705, -94.008248, 3305, 258, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5304, N'Hemphill County Hospital', 1, NULL, NULL, N'450578', NULL, NULL, 0, 26, NULL, N'8063236622', N'8063238061', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1020 S 4Th St', N'Canadian', N'TX', N'48211', N'79014', 35.902693, -100.387494, 3235, 256, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5305, N'East Texas Medical Center Crockett', 1, NULL, NULL, N'450580', NULL, NULL, 0, 93, NULL, N'9365463862', NULL, 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1100 Loop 304 East', N'Crockett', N'TX', N'48225', N'75835', 31.318033, -95.457566, 3252, 273, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5306, N'Wilbarger General Hospital', 1, NULL, NULL, N'450584', NULL, NULL, 0, 47, NULL, N'9405529351', N'9405532981', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'920 Hillcrest Dr', N'Vernon', N'TX', N'48487', N'76384', 34.158679, -99.314558, 3390, 276, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5307, N'Seymour Hospital', 1, NULL, NULL, N'450586', NULL, NULL, 0, 49, NULL, N'9408895572', N'9408893337', 1, 1, 1, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'200 Stadium Drive', N'Seymour', N'TX', N'48023', N'76380', 33.590087, -99.248894, 3373, 276, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5308, N'Brownwood Regional Medical Center', 1, NULL, NULL, N'450587', NULL, NULL, 0, 216, NULL, N'3256468541', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1501 Burnet Dr', N'Brownwood', N'TX', N'48049', N'76801', 29.769946, -95.036303, 3230, 255, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5309, N'Lake Granbury Medical Center', 1, NULL, NULL, N'450596', NULL, NULL, 0, 59, NULL, N'8175732683', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1310 Paluxy Rd', N'Granbury', N'TX', N'48221', N'76048', 32.431229, -97.803641, 3286, 263, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5310, N'Cuero Community Hospital', 1, NULL, NULL, N'450597', NULL, NULL, 0, 49, NULL, N'3612756191', N'3602753999', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2550 N Esplanade', N'Cuero', N'TX', N'48123', N'77954', 29.093804, -97.290056, 3254, 274, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5311, N'Hill Country Memorial Hospital Inc', 1, NULL, NULL, N'450604', NULL, NULL, 0, 88, NULL, N'8309974353', N'8309971348', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1020 South State Highway 16', N'Fredericksburg', N'TX', N'48171', N'78624', 30.275201, -98.871984, 3275, 271, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5312, N'Care Regional Medical Center', 1, NULL, NULL, N'450605', NULL, NULL, 0, 75, NULL, N'3617588585', N'3617580477', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1711 W Wheeler Avenue', N'Aransas Pass', N'TX', N'48409', N'78336', 27.916559, -97.163196, 3210, 260, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5313, N'Memorial Hermann Memorial City Medical Center', 1, NULL, NULL, N'450610', NULL, NULL, 0, 821, NULL, N'7132423000', NULL, 1, 1, 0, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'921 Gessner', N'Houston', N'TX', N'48201', N'77024', 29.779978, -95.544585, 3299, 265, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5314, N'Clear Lake Regional Medical Center', 1, NULL, NULL, N'450617', NULL, NULL, 0, 528, NULL, N'2813322511', NULL, 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'500 Medical Center Blvd', N'Webster', N'TX', N'48201', N'77598', 29.538851, -95.129514, 3395, 265, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5315, N'Dimmit Regional Hospital', 1, NULL, NULL, N'450620', NULL, NULL, 0, 48, NULL, N'8308762424', N'8308765774', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'704 Hospital Drive', N'Carrizo Springs', N'TX', N'48127', N'78834', 28.519987, -99.861588, 3237, 271, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5316, N'Denton Regional Medical Center', 1, NULL, NULL, N'450634', NULL, NULL, 0, 202, NULL, N'9403843535', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3535 South I35 East', N'Denton', N'TX', N'48121', N'76210', 33.168116, -97.235995, 3260, 261, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5317, N'Houston Northwest Medical Center', 1, NULL, NULL, N'450638', NULL, NULL, 0, 494, NULL, N'2814401000', NULL, 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'710 Cypress Creek Parkway', N'Houston', N'TX', N'48201', N'77090', 29.962014, -95.546105, 3299, 265, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5318, N'Texas Health Harris Methodist Hurst-Euless-Bedford', 1, NULL, NULL, N'450639', NULL, NULL, 0, 286, NULL, N'8178484000', N'8178484890', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1600 Hospital Parkway', N'Bedford', N'TX', N'48439', N'76022', 32.836468, -97.125196, 3220, 263, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5319, N'Nocona General Hospital', 1, NULL, NULL, N'450641', NULL, NULL, 0, 38, NULL, N'9408253235', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'100 Park Road', N'Nocona', N'TX', N'48337', N'76255', 33.776256, -97.731588, 3345, 261, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5320, N'Doctors Hospital Of Laredo', 1, NULL, NULL, N'450643', NULL, NULL, 0, 297, NULL, N'9565232000', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'10700 Mcpherson Road', N'Laredo', N'TX', N'48479', N'78041', 27.607644, -99.476446, 3320, 271, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5321, N'West Houston Medical Center', 1, NULL, NULL, N'450644', NULL, NULL, 0, 238, NULL, N'2815888080', NULL, 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'12141 Richmond Ave', N'Houston', N'TX', N'48201', N'77082', 29.730213, -95.595056, 3299, 265, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5322, N'Medical City Dallas Hospital', 1, NULL, NULL, N'450647', NULL, NULL, 0, 592, NULL, N'9725666222', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7777 Forest Lane', N'Dallas', N'TX', N'48113', N'75230', 32.909449, -96.771223, 3255, 261, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5323, N'Medical Center Of Plano', 1, NULL, NULL, N'450651', NULL, NULL, 0, 427, NULL, N'9725966800', NULL, 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3901 W 15Th St', N'Plano', N'TX', N'48085', N'75075', 33.013676, -96.69251, 3357, 261, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5324, N'Scenic Mountain Medical Center', 1, NULL, NULL, N'450653', NULL, NULL, 0, 150, NULL, N'4322631211', N'4322530151', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1601 W 11Th Place', N'Big Spring', N'TX', N'48227', N'79720', 32.250398, -101.478736, 3223, 267, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5325, N'Starr County Memorial Hospital', 1, NULL, NULL, N'450654', NULL, NULL, 0, 48, NULL, N'9564875561', N'9567168710', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'128  N Fm Rd 3167', N'Rio Grande City', N'TX', N'48427', N'78582', 26.385149, -98.829691, 3332, 268, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5326, N'Nacogdoches Medical Center', 1, NULL, NULL, N'450656', NULL, NULL, 0, 150, NULL, N'9365699481', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4920 Ne Stallings Drive', N'Nacogdoches', N'TX', N'48347', N'75961', 31.603513, -94.655487, 3342, 265, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5327, N'East Texas Medical Center - Fairfield', 1, NULL, NULL, N'450658', NULL, NULL, 0, 48, NULL, N'9033891612', NULL, 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'125 Newman St', N'Fairfield', N'TX', N'48161', N'75840', 31.725089, -96.169681, 3271, 275, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5328, N'Park Plaza Hospital', 1, NULL, NULL, N'450659', NULL, NULL, 0, 508, NULL, N'7135275019', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1313 Hermann Dr', N'Houston', N'TX', N'48201', N'77004', 29.722694, -95.387553, 3299, 265, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5329, N'Odessa Regional Hospital', 1, NULL, NULL, N'450661', NULL, NULL, 0, 230, NULL, N'4325828340', N'4325828900', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'520 E 6Th Street', N'Odessa', N'TX', N'48135', N'79761', 31.851175, -102.366331, 3346, 269, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5330, N'Valley Regional Medical Center', 1, NULL, NULL, N'450662', NULL, NULL, 0, 214, NULL, N'9563507000', N'9563507111', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'100 A Alton Gloor', N'Brownsville', N'TX', N'48061', N'78526', 25.979882, -97.497606, 3229, 264, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5331, N'Sierra Medical Center', 1, NULL, NULL, N'450668', NULL, NULL, 0, 331, NULL, N'9157474000', N'9157472550', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1625 Medical Center Dr', N'El Paso', N'TX', N'48141', N'79902', 31.760037, -106.487287, 3268, 262, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5332, N'Medical Center Of Lewisville', 1, NULL, NULL, N'450669', NULL, NULL, 0, 202, NULL, N'9724201000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'500 West Main Street', N'Lewisville', N'TX', N'48121', N'75057', 33.04623, -97.006211, 3321, 261, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5333, N'Tomball Regional Medical Center', 1, NULL, NULL, N'450670', NULL, NULL, 0, 289, NULL, N'2813511623', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'605 Holderrieth', N'Tomball', N'TX', N'48201', N'77375', 30.090328, -95.62397, 3386, 265, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5334, N'Plaza Medical Center Of Fort Worth', 1, NULL, NULL, N'450672', NULL, NULL, 0, 320, NULL, N'8173362100', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'900 Eighth Avenue', N'Fort Worth', N'TX', N'48439', N'76104', 32.753177, -97.332746, 3274, 263, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5335, N'Womans Hospital Of Texas The', 1, NULL, NULL, N'450674', NULL, NULL, 0, 397, NULL, N'7137901234', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7600 Fannin', N'Houston', N'TX', N'48201', N'77054', 29.690945, -95.403225, 3299, 265, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5336, N'Medical Center Of Arlington', 1, NULL, NULL, N'450675', NULL, NULL, 0, 326, NULL, N'8174653241', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3301 Matlock Road', N'Arlington', N'TX', N'48439', N'76015', 32.677845, -97.114859, 3211, 263, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5337, N'Huguley Memorial Medical Center', 1, NULL, NULL, N'450677', NULL, NULL, 0, 213, NULL, N'8175685317', N'8175686545', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'11801 South Freeway', N'Burleson', N'TX', N'48251', N'76028', 32.58628, -97.318985, 3274, 263, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5338, N'Doctors Hospital', 1, NULL, NULL, N'450678', NULL, NULL, 0, 232, NULL, N'2143246100', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'9440 Poppy Dr', N'Dallas', N'TX', N'48113', N'75218', 32.834802, -96.707094, 3255, 261, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5339, N'Memorial Hermann Northeast', 1, NULL, NULL, N'450684', NULL, NULL, 0, 237, NULL, N'2815407700', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'18951 Memorial North', N'Humble', N'TX', N'48201', N'77338', 29.998831, -95.262155, 3300, 265, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5340, N'University Medical Center', 1, NULL, NULL, N'450686', NULL, NULL, 0, 499, NULL, N'8067758200', NULL, 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'602 Indiana Avenue', N'Lubbock', N'TX', N'48303', N'79415', 33.580634, -101.887981, 3326, 267, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5341, N'Dallas Regional Medical Center', 1, NULL, NULL, N'450688', NULL, NULL, 0, 172, NULL, N'2143207000', N'2142899468', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1011 North Galloway Avenue', N'Mesquite', N'TX', N'48113', N'75149', 32.778232, -96.600014, 3255, 261, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5342, N'University Of Texas Health Science Center At Tyler', 1, NULL, NULL, N'450690', NULL, NULL, 0, 107, NULL, N'9038777777', NULL, 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'11937 Us Highway 271', N'Tyler', N'TX', N'48423', N'75708', 32.428604, -95.198279, 3388, 273, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5343, N'El Campo Memorial Hospital', 1, NULL, NULL, N'450694', NULL, NULL, 0, 49, NULL, N'9795785251', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'303 Sandy Corner Rd', N'El Campo', N'TX', N'48481', N'77437', 29.196641, -96.269687, 3267, 265, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5344, N'Southwest General Hospital', 1, NULL, NULL, N'450697', NULL, NULL, 0, 289, NULL, N'2109212000', N'2109213508', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7400 Barlite Blvd', N'San Antonio', N'TX', N'48029', N'78224', 29.356577, -98.546143, 3370, 271, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5345, N'Lamb Healthcare Center', 1, NULL, NULL, N'450698', NULL, NULL, 0, 75, NULL, N'8063856411', N'8063853998', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1500 S Sunset', N'Littlefield', N'TX', N'48279', N'79339', 33.931791, -102.345252, 3326, 267, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5346, N'Longview Regional Medical Center', 1, NULL, NULL, N'450702', NULL, NULL, 0, 230, NULL, N'9037581818', NULL, 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2901 N Fourth St', N'Longview', N'TX', N'48183', N'75605', 32.500704, -94.740489, 3325, 266, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5347, N'Houston Methodist St John Hospital', 1, NULL, NULL, N'450709', NULL, NULL, 0, 178, NULL, N'2813335503', NULL, 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'18300 St John Drive', N'Nassau Bay', N'TX', N'48201', N'77058', 29.544675, -95.091041, 3395, 265, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5348, N'Rio Grande Regional Hospital', 1, NULL, NULL, N'450711', NULL, NULL, 0, 320, NULL, N'9566326000', N'9566326621', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'101 E Ridge Rd', N'Mcallen', N'TX', N'48215', N'78503', 26.184759, -98.215658, 3332, 268, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5349, N'St David''s South Austin Medical Center', 1, NULL, NULL, N'450713', NULL, NULL, 0, 225, NULL, N'5124487107', N'5124487326', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'901 West Ben White Blvd', N'Austin', N'TX', N'48453', N'78704', 30.227234, -97.77362, 3215, 257, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5350, N'Cypress Fairbanks Medical Center', 1, NULL, NULL, N'450716', NULL, NULL, 0, 181, NULL, N'2818973100', N'2818905341', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'10655 Steepletop Drive', N'Houston', N'TX', N'48201', N'77065', 29.758938, -95.367697, 3299, 265, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5351, N'Round Rock Medical Center', 1, NULL, NULL, N'450718', NULL, NULL, 0, 170, NULL, N'5123411000', N'5122381799', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2400 Round Rock Ave', N'Round Rock', N'TX', N'48491', N'78681', 30.509606, -97.685576, 3367, 257, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5352, N'Methodist Charlton Medical Center', 1, NULL, NULL, N'450723', NULL, NULL, 0, 285, NULL, N'2149477777', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3500 W Wheatland Road', N'Dallas', N'TX', N'48113', N'75237', 32.647498, -96.877447, 3255, 261, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5353, N'Baylor Medical Center At Carrollton', 1, NULL, NULL, N'450730', NULL, NULL, 0, 197, NULL, N'9724921010', N'9723944783', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4343 North Josey Lane', N'Carrollton', N'TX', N'48121', N'75010', 33.029065, -96.883979, 3255, 261, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5354, N'Lake Pointe Medical Center', 1, NULL, NULL, N'450742', NULL, NULL, 0, 112, NULL, N'9724122273', N'9724123276', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6800 Scenic Dr', N'Rowlett', N'TX', N'48113', N'75088', 32.918226, -96.509442, 3368, 261, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5355, N'Texas Health Presbyterian Hospital Denton', 1, NULL, NULL, N'450743', NULL, NULL, 0, 255, NULL, N'9408987000', N'9728987071', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3000 N I-35', N'Denton', N'TX', N'48121', N'76201', 33.168116, -97.235995, 3260, 261, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5356, N'Knox County Hospital', 1, NULL, NULL, N'450746', NULL, NULL, 0, 28, NULL, N'9406573535', N'9406575521', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'701 Se 5Th Street', N'Knox City', N'TX', N'48275', N'79529', 33.418151, -99.81898, 3316, 276, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5357, N'Palestine Regional Medical Center', 1, NULL, NULL, N'450747', NULL, NULL, 0, 156, NULL, N'9037311000', NULL, 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2900 S Loop 256', N'Palestine', N'TX', N'48001', N'75801', 31.762115, -95.630789, 3350, 273, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5358, N'East Texas Medical Center Trinity', 1, NULL, NULL, N'450749', NULL, NULL, 0, 45, NULL, N'9365943541', NULL, 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'317 Prospect Dr/Po Box 3169', N'Trinity', N'TX', N'48455', N'75862', 30.945186, -95.375496, 3387, 265, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5359, N'Hamilton General Hospital', 1, NULL, NULL, N'450754', NULL, NULL, 0, 34, NULL, N'2543863151', NULL, 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'400 N Brown', N'Hamilton', N'TX', N'48193', N'76531', 31.703766, -98.123923, 3292, 275, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5360, N'Covenant Hospital Levelland', 1, NULL, NULL, N'450755', NULL, NULL, 0, 78, NULL, N'8068944963', N'8068946461', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1900 College Ave', N'Levelland', N'TX', N'48219', N'79336', 33.573098, -102.367662, 3326, 267, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5361, N'Ut Southwestern University Hospital-Zale Lipshy', 1, NULL, NULL, N'450766', NULL, NULL, 0, 152, NULL, N'2148793758', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5151 Harry Hines Blvd', N'Dallas', N'TX', N'48113', N'75390', 32.815376, -96.841645, 3255, 261, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5362, N'Texas Health Presbyterian Hospital Plano', 1, NULL, NULL, N'450771', NULL, NULL, 0, 203, NULL, N'9729818000', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'6200 W Parker Rd', N'Plano', N'TX', N'48085', N'75093', 33.041134, -96.728923, 3357, 261, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5363, N'Tops Surgical Specialty Hospital', 1, NULL, NULL, N'450774', NULL, NULL, 0, 15, NULL, N'2815392900', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'17080 Red Oak Drive', N'Houston', N'TX', N'48201', N'77090', 31.403898, -95.578236, 3299, 265, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5364, N'Kingwood Medical Center', 1, NULL, NULL, N'450775', NULL, NULL, 0, 211, NULL, N'2813597500', NULL, 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'22999 Us Hwy 59', N'Kingwood', N'TX', N'48201', N'77325', 30.033553, -95.261044, 3299, 265, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5365, N'Texas Health Harris Methodist Hospital Southwest F', 1, NULL, NULL, N'450779', NULL, NULL, 0, 630, NULL, N'8174335000', NULL, 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6100 Harris Pkwy', N'Fort Worth', N'TX', N'48439', N'76132', 32.660129, -97.419119, 3274, 263, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5366, N'Methodist Ambulatory Surgery Hospital Nw', 1, NULL, NULL, N'450780', NULL, NULL, 0, 31, NULL, N'2105755000', N'2105755190', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'9150 Huebner Rd Suite 100', N'San Antonio', N'TX', N'48029', N'78240', 29.4246, -98.49514, 3370, 271, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5367, N'Corpus Christi Medical Center The', 1, NULL, NULL, N'450788', NULL, NULL, 0, 583, NULL, N'3617611501', N'3618575960', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7101 S Padre Island Dr', N'Corpus Christi', N'TX', N'48355', N'78412', 27.663674, -97.272735, 3250, 260, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5368, N'Northwest Texas Surgery Center', 1, NULL, NULL, N'450796', NULL, NULL, 0, 4, NULL, N'8063597999', N'8063557598', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3501 Soncy Rd Suite 118', N'Amarillo', N'TX', N'48381', N'79109', 35.207219, -101.833825, 3205, 256, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5369, N'Houston Hospital For Specialized Surgery', 1, NULL, NULL, N'450797', NULL, NULL, 0, 7, NULL, N'7135286800', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5445 Labranch Street', N'Houston', N'TX', N'48201', N'77004', 29.758938, -95.367697, 3299, 265, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5370, N'Christus St Michael Health System', 1, NULL, NULL, N'450801', NULL, NULL, 0, 376, NULL, N'9036141000', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2600 St Michael Dr', N'Texarkana', N'TX', N'48037', N'75504', 33.464069, -94.075662, 3384, 16, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5371, N'Doctors Hospital Tidwell', 1, NULL, NULL, N'450803', NULL, NULL, 0, 117, NULL, N'7136911111', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'510 W Tidwell', N'Houston', N'TX', N'48201', N'77091', 29.758938, -95.367697, 3299, 265, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5372, N'Texas Orthopedic Hospital', 1, NULL, NULL, N'450804', NULL, NULL, 0, 49, NULL, N'7137998600', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7401 South Main Street', N'Houston', N'TX', N'48201', N'77030', 29.701104, -95.409001, 3299, 265, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5373, N'Northwest Hills Surgical Hospital', 1, NULL, NULL, N'450808', NULL, NULL, 0, 8, NULL, N'5123461994', N'5123452760', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6818 Austin Ctr Blvd Suite 100', N'Austin', N'TX', N'48453', N'78731', 30.271129, -97.743699, 3215, 257, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5374, N'North Austin Medical Center', 1, NULL, NULL, N'450809', NULL, NULL, 0, 332, NULL, N'5129011000', N'5129011995', 1, 1, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'12221 Mopac Expressway North', N'Austin', N'TX', N'48453', N'78758', 30.271129, -97.743699, 3215, 257, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5375, N'Methodist Sugar Land Hospital', 1, NULL, NULL, N'450820', NULL, NULL, 0, 243, NULL, N'2812748000', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'16655 Southwest Freeway', N'Sugar Land', N'TX', N'48157', N'77479', 29.589926, -95.634192, 3299, 265, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5376, N'Las Colinas Medical Center', 1, NULL, NULL, N'450822', NULL, NULL, 0, 100, NULL, N'9729692000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6800 N Macarthur Blvd', N'Irving', N'TX', N'48113', N'75039', 32.902991, -96.958773, 3255, 261, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5377, N'Cornerstone Regional Hospital', 1, NULL, NULL, N'450825', NULL, NULL, 0, 14, NULL, N'9566184444', N'9566184242', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2302 Cornerstone Boulevard', N'Edinburg', N'TX', N'48215', N'78539', 26.263942, -98.201832, 3266, 268, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5378, N'Kell West Regional Hospital', 1, NULL, NULL, N'450827', NULL, NULL, 0, 41, NULL, N'9406925888', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5402 Kell West Boulevard', N'Wichita Falls', N'TX', N'48485', N'76310', 33.913709, -98.493387, 3402, 276, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5379, N'Christus Spohn Hospital Alice', 1, NULL, NULL, N'450828', NULL, NULL, 0, 135, NULL, N'3616618016', N'3616618073', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2500 E Main Street', N'Alice', N'TX', N'48249', N'78332', 27.764777, -98.044928, 3202, 260, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5380, N'Surgery Specialty Hospitals Of America Se Houston', 1, NULL, NULL, N'450831', NULL, NULL, 0, 37, NULL, N'7133783000', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4301 B Vista', N'Pasadena', N'TX', N'48201', N'77504', 29.691063, -95.209101, 3353, 265, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5381, N'Houston Methodist St Catherine Hospital', 1, NULL, NULL, N'450832', NULL, NULL, 0, 102, NULL, N'2815995700', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'701 South Fry Road', N'Katy', N'TX', N'48201', N'77450', 29.785785, -95.824396, 3299, 265, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5382, N'Ennis Regional Medical Center', 1, NULL, NULL, N'450833', NULL, NULL, 0, 45, NULL, N'9728750900', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2201 West Lampasas Street', N'Ennis', N'TX', N'48139', N'75119', 32.315003, -96.639007, 3270, 261, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5383, N'Physicians Centre The', 1, NULL, NULL, N'450834', NULL, NULL, 0, 16, NULL, N'9797313100', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3131 University Drive East', N'Bryan', N'TX', N'48041', N'77802', 30.693444, -96.400802, 3231, 259, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5384, N'Texas Health Presbyterian Hospital Allen', 1, NULL, NULL, N'450840', NULL, NULL, 0, 29, NULL, N'9727476197', N'2146454187', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1105 Central Expressway North', N'Allen', N'TX', N'48085', N'75013', 33.103174, -96.67055, 3357, 261, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5385, N'Methodist Willowbrook Hospital', 1, NULL, NULL, N'450844', NULL, NULL, 0, 251, NULL, N'2814771000', NULL, 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'18220 Tomball Parkway', N'Houston', N'TX', N'48201', N'77070', 29.957543, -95.543823, 3299, 265, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5386, N'El Paso Specialty Hospital', 1, NULL, NULL, N'450845', NULL, NULL, 0, 31, NULL, N'9155443636', N'9155446114', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1755 Curie Suite A', N'El Paso', N'TX', N'48141', N'79902', 31.760037, -106.487287, 3268, 262, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5387, N'Memorial Hermann Katy Hospital', 1, NULL, NULL, N'450847', NULL, NULL, 0, 142, NULL, N'2813921111', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'23900 Katy Freeway', N'Katy', N'TX', N'48201', N'77494', 29.784995, -95.789976, 3308, 265, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5388, N'Memorial Hermann Sugar Land Hospital', 1, NULL, NULL, N'450848', NULL, NULL, 0, 81, NULL, N'2814994800', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'17500 W Grand Parkway South', N'Sugar Land', N'TX', N'48157', N'77479', 29.619679, -95.634946, 3299, 265, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5389, N'Baylor Heart And Vascular Hospital', 1, NULL, NULL, N'450851', NULL, NULL, 0, 61, NULL, N'2148200670', N'2148200690', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'621 North Hall Street', N'Dallas', N'TX', N'48113', N'75226', 32.798534, -96.792766, 3255, 261, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5390, N'Baylor Medical Center At Frisco', 1, NULL, NULL, N'450853', NULL, NULL, 0, 25, NULL, N'2146182000', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5601 Warren Parkway', N'Frisco', N'TX', N'48085', N'75034', 33.106662, -96.829406, 3334, 261, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5391, N'Harlingen Medical Center', 1, NULL, NULL, N'450855', NULL, NULL, 0, 112, NULL, N'9563651000', N'9563651875', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5501 South Expressway 77', N'Harlingen', N'TX', N'48061', N'78550', 26.190631, -97.696103, 3294, 264, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5392, N'South Texas Spine And Surgical Hospital', 1, NULL, NULL, N'450856', NULL, NULL, 0, 30, NULL, N'2104040800', N'2104040802', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'18600 North Hardy Oak Blvd', N'San Antonio', N'TX', N'48029', N'78258', 29.4246, -98.49514, 3370, 271, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5393, N'Sugar Land Surgical Hospital Llp', 1, NULL, NULL, N'450860', NULL, NULL, 0, 6, NULL, N'2812431000', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'16906 Southwest Freeway', N'Sugar Land', N'TX', N'48157', N'77479', 29.593365, -95.628624, 3299, 265, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5394, N'St Luke''s The Woodlands Hospital', 1, NULL, NULL, N'450862', NULL, NULL, 0, 184, NULL, N'9362664050', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'17200 St Luke''s Way', N'The Woodlands', N'TX', N'48339', N'77384', 30.204854, -95.45949, 3249, 265, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5395, N'Texas Spine And Joint Hospital', 1, NULL, NULL, N'450864', NULL, NULL, 0, 20, NULL, N'9035253300', N'9035253391', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1814 Roseland Boulevard', N'Tyler', N'TX', N'48423', N'75701', 32.329639, -95.29936, 3388, 273, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5396, N'Seton Southwest Hospital', 1, NULL, NULL, N'450865', NULL, NULL, 0, 17, NULL, N'5123249000', N'5123249002', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7900 Fm 1826', N'Austin', N'TX', N'48453', N'78737', 30.271129, -97.743699, 3215, 257, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5397, N'Seton Northwest Hospital', 1, NULL, NULL, N'450867', NULL, NULL, 0, 124, NULL, N'5123246000', N'5123246924', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'11113 Research Boulevard', N'Austin', N'TX', N'48453', N'78759', 30.405209, -97.743376, 3215, 257, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5398, N'Doctors Hospital At Renaissance', 1, NULL, NULL, N'450869', NULL, NULL, 0, 506, NULL, N'9563628677', N'9566617331', 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5501 South Mccoll', N'Edinburg', N'TX', N'48215', N'78539', 26.349186, -98.144779, 3266, 268, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5399, N'Arise Austin Medical Center', 1, NULL, NULL, N'450871', NULL, NULL, 0, 23, NULL, N'5123479888', N'5123479869', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3003 Bee Caves Road', N'Austin', N'TX', N'48453', N'78746', 30.296005, -97.829535, 3215, 257, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5400, N'Usmd Hospital At Arlington L P', 1, NULL, NULL, N'450872', NULL, NULL, 0, 34, NULL, N'8174723400', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'801 W Interstate 20', N'Arlington', N'TX', N'48439', N'76017', 32.735582, -97.107119, 3211, 263, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5401, N'Promise Specialty Hospital Of San Antonio (452090)', 1, NULL, NULL, N'450873', NULL, NULL, 0, 26, NULL, N'2109254165', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7400 Barlite Boulevard  2Nd Floor', N'San Antonio', N'TX', N'48029', N'78224', 29.4246, -98.49514, 3370, 271, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5402, N'Baylor Surgical Hospital At Las Colinas', 1, NULL, NULL, N'450874', NULL, NULL, 0, 20, NULL, N'9728684000', N'9728384009', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'400 West Interstate 635 Suite 101', N'Irving', N'TX', N'48113', N'75063', 32.862919, -96.97917, 3255, 261, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5403, N'Quail Creek Surgical Hospital', 1, NULL, NULL, N'450875', NULL, NULL, 0, 41, NULL, N'8063546100', N'8063546101', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6819 Plum Creek', N'Amarillo', N'TX', N'48375', N'79124', 35.207219, -101.833825, 3205, 256, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5404, N'Lubbock Heart Hospital Lp', 1, NULL, NULL, N'450876', NULL, NULL, 0, 74, NULL, N'8066877777', N'8066877778', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4810 North Loop 289', N'Lubbock', N'TX', N'48303', N'79416', 33.616736, -101.893696, 3326, 267, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5405, N'Foundation Surgical Hospital Of El Paso', 1, NULL, NULL, N'450877', NULL, NULL, 0, 40, NULL, N'9155984240', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1416 George Dieter', N'El Paso', N'TX', N'48141', N'79936', 31.735368, -106.301494, 3268, 262, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5406, N'Baylor Surgical Hospital At Fort Worth', 1, NULL, NULL, N'450880', NULL, NULL, 0, 34, NULL, N'6827035600', N'6827035612', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1800 Park Place Avenue', N'Fort Worth', N'TX', N'48439', N'76110', 32.725893, -97.345695, 3274, 263, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5407, N'Baylor Medical Center At Trophy Club', 1, NULL, NULL, N'450883', NULL, NULL, 0, 20, NULL, N'8178374600', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2850  E State Highway 114', N'Trophy Club', N'TX', N'48121', N'76262', 32.997901, -97.183625, 3288, 261, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5408, N'Centennial Medical Center', 1, NULL, NULL, N'450885', NULL, NULL, 0, 118, NULL, N'9729633333', NULL, 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'12505 Lebanon Road', N'Frisco', N'TX', N'48085', N'75035', 33.121904, -96.806896, 3334, 261, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5409, N'Southwest Surgical Hospital', 1, NULL, NULL, N'450886', NULL, NULL, 0, 23, NULL, N'8173454100', N'8176561490', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1612 Hurst Town Center Drive', N'Hurst', N'TX', N'48439', N'76054', 32.841595, -97.188701, 3220, 263, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5410, N'Texas Health Harris Methodist Hospital Southlake', 1, NULL, NULL, N'450888', NULL, NULL, 0, 6, NULL, N'8177488700', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1545 E Southlake Blvd', N'Southlake', N'TX', N'48439', N'76092', 32.940983, -97.132887, 3288, 261, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5411, N'Texas Institute For Surgery At Presbyterian Hospit', 1, NULL, NULL, N'450889', NULL, NULL, 0, 9, NULL, N'2146475300', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7115 Greenville Avenue Suite 100', N'Dallas', N'TX', N'48113', N'75231', 32.776196, -96.796899, 3255, 261, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5412, N'Baylor Regional Medical Center At Plano', 1, NULL, NULL, N'450890', NULL, NULL, 0, 96, NULL, N'4698142000', N'4698142999', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4700 Alliance Boulevard', N'Plano', N'TX', N'48085', N'75093', 33.013676, -96.69251, 3357, 261, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5413, N'Texas Health Center For Diagnostics & Surgery Plan', 1, NULL, NULL, N'450891', NULL, NULL, 0, 18, NULL, N'9724032700', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6020 W Parker Road', N'Plano', N'TX', N'48085', N'75093', 33.041134, -96.728923, 3357, 261, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5414, N'The Heart Hospital Baylor Denton', 1, NULL, NULL, N'450893', NULL, NULL, 0, 16, NULL, N'9402200600', N'9402200605', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2801 South Mayhill Road', N'Denton', N'TX', N'48121', N'76208', 33.19511, -97.08477, 3260, 261, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5415, N'Pine Creek Medical Center Llp', 1, NULL, NULL, N'450894', NULL, NULL, 0, 18, NULL, N'2142312273', N'2142312274', 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'9032 Harry Hines Blvd', N'Dallas', N'TX', N'48113', N'75235', 32.840378, -96.868962, 3255, 261, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5416, N'Parmer County Community Hospital', 1, NULL, NULL, N'451300', NULL, NULL, 0, 25, NULL, N'8062502754', N'8062502031', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1307 Cleveland Street', N'Friona', N'TX', N'48369', N'79035', 34.641734, -102.724105, 3276, 256, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5417, N'Reagan Memorial Hospital', 1, NULL, NULL, N'451301', NULL, NULL, 0, 14, NULL, N'3258442561', N'3258842891', 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'805 North Main', N'Big Lake', N'TX', N'48383', N'76932', 31.191544, -101.460394, 3369, 270, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5418, N'Limestone Medical Center', 1, NULL, NULL, N'451303', NULL, NULL, 0, 20, NULL, N'2547293281', NULL, 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'701 Mcclintic Drive', N'Groesbeck', N'TX', N'48293', N'76642', 31.531446, -96.529959, 3290, 275, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5419, N'Schleicher County Medical Center', 1, NULL, NULL, N'451304', NULL, NULL, 0, 14, NULL, N'3258532507', N'3258533166', 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'102 North Us Highway 277', N'Eldorado', N'TX', N'48413', N'76936', 30.860159, -100.600857, 3369, 270, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5420, N'Burleson St Joseph Health Center', 1, NULL, NULL, N'451305', NULL, NULL, 0, 25, NULL, N'9795673245', NULL, 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1101 Woodson Drive', N'Caldwell', N'TX', N'48051', N'77836', 30.521207, -96.716482, 3233, 259, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5421, N'Kimble Hospital', 1, NULL, NULL, N'451306', NULL, NULL, 0, 15, NULL, N'3254463321', N'3254463769', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'349 Reid Road', N'Junction', N'TX', N'48267', N'76849', 30.489356, -99.772011, 3307, 271, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5422, N'Iraan General Hospital', 1, NULL, NULL, N'451307', NULL, NULL, 0, 14, NULL, N'4326392575', N'4326392664', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'600 Highway 349 North', N'Iraan', N'TX', N'48371', N'79744', 30.914048, -101.897906, 3302, 270, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5423, N'Yoakum County Hospital', 1, NULL, NULL, N'451308', NULL, NULL, 0, 24, NULL, N'8065922121', N'8065922891', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'412 Mustang Avenue', N'Denver City', N'TX', N'48501', N'79323', 32.964548, -102.829096, 3326, 267, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5424, N'Mccamey Hospital', 1, NULL, NULL, N'451309', NULL, NULL, 0, 14, NULL, N'4326528626', N'4326523465', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2500 Hwy 305 South', N'Mccamey', N'TX', N'48461', N'79752', 31.135591, -102.224443, 3333, 269, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5425, N'Ballinger Memorial Hospital', 1, NULL, NULL, N'451310', NULL, NULL, 0, 25, NULL, N'3253652531', N'3253652662', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'608 Avenue B', N'Ballinger', N'TX', N'48399', N'76821', 31.748885, -99.963008, 3369, 270, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5426, N'Sweeny Community Hospital', 1, NULL, NULL, N'451311', NULL, NULL, 0, 20, NULL, N'9795483311', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'305 North Mckinney', N'Sweeny', N'TX', N'48039', N'77480', 29.038862, -95.698561, 3299, 265, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5427, N'Rice Medical Center', 1, NULL, NULL, N'451312', NULL, NULL, 0, 25, NULL, N'9792345571', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'600 South Austin Road', N'Eagle Lake', N'TX', N'48089', N'77434', 29.589684, -96.333577, 3263, 265, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5428, N'Fisher County Hospital District', 1, NULL, NULL, N'451313', NULL, NULL, 0, 14, NULL, N'3257352256', N'3257353070', 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'774 State Highway 70 N', N'Rotan', N'TX', N'48151', N'79546', 32.85205, -100.465665, 3366, 255, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5429, N'Winkler County Memorial Hospital', 1, NULL, NULL, N'451314', NULL, NULL, 0, 25, NULL, N'4325865865', N'4325865031', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'821 Jeffee Drive', N'Kermit', N'TX', N'48495', N'79745', 31.849331, -103.089826, 3311, 269, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5430, N'North Runnels Hospital', 1, NULL, NULL, N'451315', NULL, NULL, 0, 25, NULL, N'3257544553', N'3257545097', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7821 East Highway 153', N'Winters', N'TX', N'48399', N'79567', 31.956534, -99.962313, 3405, 270, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5431, N'Madison St Joseph Health Center', 1, NULL, NULL, N'451316', NULL, NULL, 0, 25, NULL, N'9363482631', NULL, 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'100 West Cross Street', N'Madisonville', N'TX', N'48313', N'77864', 30.941568, -95.911307, 3329, 259, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5432, N'Refugio County Memorial Hospital', 1, NULL, NULL, N'451317', NULL, NULL, 0, 20, NULL, N'3615262321', N'3615262420', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'107 Swift Street', N'Refugio', N'TX', N'48391', N'78377', 28.306538, -97.279506, 3363, 274, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5433, N'Stonewall Memorial Hospital', 1, NULL, NULL, N'451318', NULL, NULL, 0, 20, NULL, N'9409893551', N'9409893395', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'821 North Broadway', N'Aspermont', N'TX', N'48433', N'79502', 33.133431, -100.227328, 3212, 255, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5434, N'Mother Frances Hospital Jacksonville', 1, NULL, NULL, N'451319', NULL, NULL, 0, 25, NULL, N'9035414500', NULL, 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2026 S Jackson Street', N'Jacksonville', N'TX', N'48073', N'75766', 31.938501, -95.247767, 3304, 273, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5435, N'Bayside Community Hospital', 1, NULL, NULL, N'451320', NULL, NULL, 0, 14, NULL, N'4092673143', NULL, 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'200 Hospital Drive', N'Anahuac', N'TX', N'48071', N'77514', 29.752118, -94.686891, 3206, 265, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5436, N'Hunt Regional Community Hospital', 1, NULL, NULL, N'451321', NULL, NULL, 0, 15, NULL, N'9034081881', N'9034085082', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2900 Sterling Hart Drive', N'Commerce', N'TX', N'48231', N'75428', 33.231289, -95.90008, 3289, 261, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5437, N'Grimes St Joseph Health Center', 1, NULL, NULL, N'451322', NULL, NULL, 0, 25, NULL, N'9368256585', NULL, 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'210 Judson St', N'Navasota', N'TX', N'48185', N'77868', 30.392501, -96.076718, 3343, 259, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5438, N'Rollins Brook Community Hospital', 1, NULL, NULL, N'451323', NULL, NULL, 0, 25, NULL, N'5125563682', N'5125568869', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'608 North Key Avenue', N'Lampasas', N'TX', N'48281', N'76550', 31.063784, -98.181696, 3314, 272, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5439, N'Lillian M Hudspeth Memorial Hospital', 1, NULL, NULL, N'451324', NULL, NULL, 0, 12, NULL, N'3253872521', N'3253872396', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'308 Hudspeth', N'Sonora', N'TX', N'48435', N'76950', 30.56423, -100.634783, 3377, 270, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5440, N'Concho County Hospital', 1, NULL, NULL, N'451325', NULL, NULL, 0, 16, NULL, N'9158695911', N'9158693861', 1, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'614 Eaker Street', N'Eden', N'TX', N'48095', N'76837', 31.220781, -99.847622, 3369, 270, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5441, N'Chillicothe Hospital District', 1, NULL, NULL, N'451326', NULL, NULL, 0, 21, NULL, N'9408525131', N'9408525252', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'303 Avenue I', N'Chillicothe', N'TX', N'48197', N'79225', 34.254679, -99.516197, 3240, 276, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5442, N'Winnie Community Hospital', 1, NULL, NULL, N'451328', NULL, NULL, 0, 25, NULL, N'4092966000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'538 Broadway', N'Winnie', N'TX', N'48071', N'77665', 29.820447, -94.376095, 3403, 258, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5443, N'Rankin Hospital Medical Clinic', 1, NULL, NULL, N'451329', NULL, NULL, 0, 15, NULL, N'4326932443', N'4326932178', 1, 1, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1105 Elizabeth', N'Rankin', N'TX', N'48461', N'79778', 31.227007, -101.946957, 3362, 270, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5444, N'Medina Regional Hospital', 1, NULL, NULL, N'451330', NULL, NULL, 0, 25, NULL, N'8304267700', N'8304267860', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3100 Avenue E', N'Hondo', N'TX', N'48325', N'78861', 29.334249, -99.133497, 3370, 271, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5445, N'Coon Memorial Hospital', 1, NULL, NULL, N'451331', NULL, NULL, 0, 25, NULL, N'8062444571', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1411 Denver Avenue', N'Dalhart', N'TX', N'48111', N'79022', 36.052166, -102.521715, 3205, 256, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5446, N'Palacios Community Medical Center', 1, NULL, NULL, N'451332', NULL, NULL, 0, 17, NULL, N'3619722511', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'311 Green Avenue', N'Palacios', N'TX', N'48321', N'77465', 28.708046, -96.217467, 3349, 265, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5447, N'Martin County Hospital District', 1, NULL, NULL, N'451333', NULL, NULL, 0, 25, NULL, N'4327563345', N'9157562349', 1, 1, 1, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'600 E Interstate 20     Po Box 640', N'Stanton', N'TX', N'48317', N'79782', 32.129289, -101.788464, 3336, 269, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5448, N'Parkview Hospital', 1, NULL, NULL, N'451334', NULL, NULL, 0, 16, NULL, N'8068265581', N'8068263201', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'901 S. Sweetwater', N'Wheeler', N'TX', N'48483', N'79096', 35.445326, -100.270955, 3400, 256, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5449, N'Muenster Memorial Hospital', 1, NULL, NULL, N'451335', NULL, NULL, 0, 18, NULL, N'9407592271', NULL, 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'605 N Maple Street', N'Muenster', N'TX', N'48097', N'76252', 33.654749, -97.379937, 3341, 261, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5450, N'W J Mangold Memorial Hospital', 1, NULL, NULL, N'451337', NULL, NULL, 0, 25, NULL, N'8066523373', N'8066522172', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'320 North Main', N'Lockney', N'TX', N'48153', N'79241', 34.124518, -101.441552, 3326, 267, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5451, N'Culberson Hospital', 1, NULL, NULL, N'451338', NULL, NULL, 0, 25, NULL, N'4322832760', N'4322832581', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Eisenhower Road And Fm 2185', N'Van Horn', N'TX', N'48109', N'79855', 31.038006, -104.830369, 3268, 262, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5452, N'Throckmorton County Memorial Hospital', 1, NULL, NULL, N'451339', NULL, NULL, 0, 14, NULL, N'9408492151', N'9408497141', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'802 N Minter Avenue', N'Throckmorton', N'TX', N'48447', N'76483', 33.19047, -99.177181, 3402, 276, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5453, N'Shamrock General Hospital', 1, NULL, NULL, N'451340', NULL, NULL, 0, 25, NULL, N'8062562114', N'8062562423', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1000 South Main Street', N'Shamrock', N'TX', N'48483', N'79079', 35.197569, -100.249046, 3374, 256, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5454, N'Haskell Memorial Hospital', 1, NULL, NULL, N'451341', NULL, NULL, 0, 25, NULL, N'9408642621', N'9408643713', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1 North Avenue N  Po Box 1117', N'Haskell', N'TX', N'48207', N'79521', 33.157603, -99.733701, 3295, 255, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5455, N'Mitchell County Hospital District', 1, NULL, NULL, N'451342', NULL, NULL, 0, 25, NULL, N'3257283431', N'3257288974', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'997 West I-20', N'Colorado City', N'TX', N'48335', N'79512', 32.388174, -100.864558, 3246, 267, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5456, N'Electra Memorial Hospital', 1, NULL, NULL, N'451343', NULL, NULL, 0, 25, NULL, N'9404953981', NULL, 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1207 S Bailey Street', N'Electra', N'TX', N'48485', N'76360', 34.015529, -98.923617, 3269, 276, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5457, N'Hansford County Hospital', 1, NULL, NULL, N'451344', NULL, NULL, 0, 25, NULL, N'8066592535', N'8066591027', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'707 Roland St', N'Spearman', N'TX', N'48195', N'79081', 36.196858, -101.200274, 3205, 256, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5458, N'Crosbyton Clinic Hospital', 1, NULL, NULL, N'451345', NULL, NULL, 0, 25, NULL, N'8066752382', N'8066752645', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'710 West Main Street', N'Crosbyton', N'TX', N'48107', N'79322', 33.660067, -101.245766, 3253, 267, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5459, N'Yoakum Community Hospital', 1, NULL, NULL, N'451346', NULL, NULL, 0, 25, NULL, N'3612932321', N'3612936172', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1200 Carl Ramert Drive', N'Yoakum', N'TX', N'48123', N'77995', 29.305511, -97.128805, 3391, 274, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5460, N'Coleman County Medical Center Company', 1, NULL, NULL, N'451347', NULL, NULL, 0, 25, NULL, N'3256252135', N'3256253895', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'310 South Pecos Street', N'Coleman', N'TX', N'48083', N'76834', 31.828343, -99.425292, 3245, 255, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5461, N'Heart Of Texas Memorial Hospital', 1, NULL, NULL, N'451348', NULL, NULL, 0, 25, NULL, N'3255972901', N'3255972280', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2008 Nine Road', N'Brady', N'TX', N'48307', N'76825', 31.114883, -99.348032, 3226, 270, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5462, N'Swisher Memorial Hospital', 1, NULL, NULL, N'451349', NULL, NULL, 0, 20, NULL, N'8069953581', N'8069958283', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'539 Southeast 2Nd', N'Tulia', N'TX', N'48437', N'79088', 34.535894, -101.758516, 3205, 256, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5463, N'Plains Memorial Hospital', 1, NULL, NULL, N'451350', NULL, NULL, 0, 25, NULL, N'8066472191', N'8066472282', 1, 0, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'310 West Halsell Street', N'Dimmitt', N'TX', N'48069', N'79027', 34.555656, -102.315235, 3261, 267, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5464, N'Lynn County Hospital District', 1, NULL, NULL, N'451351', NULL, NULL, 0, 24, NULL, N'8069984533', N'8065614049', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2600 Lockwood Street', N'Tahoka', N'TX', N'48305', N'79373', 33.166585, -101.815474, 3326, 267, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5465, N'Hardeman County Memorial Hospital', 1, NULL, NULL, N'451352', NULL, NULL, 0, 24, NULL, N'9406632795', N'9406635149', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'402 Mercer St', N'Quanah', N'TX', N'48197', N'79252', 34.296119, -99.741266, 3360, 276, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5466, N'Crane County Hospital District', 1, NULL, NULL, N'451353', NULL, NULL, 0, 25, NULL, N'4325583555', N'9155581159', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1310 S Alford St', N'Crane', N'TX', N'48103', N'79731', 31.390004, -102.349246, 3346, 269, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5467, N'Hamilton Hospital', 1, NULL, NULL, N'451354', NULL, NULL, 0, 25, NULL, N'9405645521', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'901 West Hamilton', N'Olney', N'TX', N'48503', N'76374', 33.35887, -98.751826, 3347, 276, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5468, N'Collingsworth General Hospital', 1, NULL, NULL, N'451355', NULL, NULL, 0, 16, NULL, N'8064472521', N'8064472421', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1013 15Th St', N'Wellington', N'TX', N'48087', N'79095', 34.856166, -100.213726, 3397, 256, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5469, N'Memorial Medical Center', 1, NULL, NULL, N'451356', NULL, NULL, 0, 25, NULL, N'3615526713', N'3615520220', 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'815 N Virginia Street', N'Port Lavaca', N'TX', N'48057', N'77979', 28.621142, -96.631799, 3359, 265, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5470, N'Little River Healthcare', 1, NULL, NULL, N'451357', NULL, NULL, 0, 25, NULL, N'5124464500', N'5124460084', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1700 Brazos', N'Rockdale', N'TX', N'48331', N'76567', 30.650195, -97.022021, 3365, 272, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5471, N'Memorial Hospital', 1, NULL, NULL, N'451358', NULL, NULL, 0, 25, NULL, N'4327584854', N'4327584880', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'209 Northwest 8Th Street', N'Seminole', N'TX', N'48165', N'79360', 32.72278, -102.65385, 3326, 267, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5472, N'Ochiltree General Hospital', 1, NULL, NULL, N'451359', NULL, NULL, 0, 25, NULL, N'8064353606', N'8064352813', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3101 Garrett Drive', N'Perryton', N'TX', N'48357', N'79070', 36.370534, -100.7997, 3355, 256, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5473, N'Chi St Lukes Health Memorial San Augustine', 1, NULL, NULL, N'451360', NULL, NULL, 0, 18, NULL, N'9362753446', N'9362759921', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'511 Hospital St', N'San Augustine', N'TX', N'48405', N'75972', 31.531475, -94.105005, 3342, 265, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5474, N'Sabine County Hospital', 1, NULL, NULL, N'451361', NULL, NULL, 0, 25, NULL, N'4097873300', N'4097875003', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Po Box 750 2301 Hwy 83 W', N'Hemphill', N'TX', N'48403', N'75948', 31.34074, -93.846852, 3296, 265, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5475, N'Clay County Memorial Hospital', 1, NULL, NULL, N'451362', NULL, NULL, 0, 25, NULL, N'9405385621', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'310 W South Street', N'Henrietta', N'TX', N'48077', N'76365', 33.813974, -98.197595, 3402, 276, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5476, N'Jackson Healthcare Center', 1, NULL, NULL, N'451363', NULL, NULL, 0, 25, NULL, N'3617827800', N'3617827495', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1013 S Wells', N'Edna', N'TX', N'48239', N'77957', 28.978595, -96.646088, 3391, 274, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5477, N'Otto Kaiser Memorial Hospital', 1, NULL, NULL, N'451364', NULL, NULL, 0, 25, NULL, N'8305833401', N'8305839053', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3349 S Highway 181', N'Kenedy', N'TX', N'48255', N'78119', 28.814658, -97.847911, 3310, 271, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5478, N'Seton Highland Lakes', 1, NULL, NULL, N'451365', NULL, NULL, 0, 25, NULL, N'5127153000', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Highway 281 South', N'Burnet', N'TX', N'48053', N'78611', 30.757311, -98.228901, 3232, 257, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5479, N'Cochran Memorial Hospital', 1, NULL, NULL, N'451366', NULL, NULL, 0, 18, NULL, N'8062665565', N'8062665342', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'205 E Grant Street', N'Morton', N'TX', N'48079', N'79346', 33.725098, -102.759376, 3326, 267, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5480, N'East Texas Medical Center Pittsburg', 1, NULL, NULL, N'451367', NULL, NULL, 0, 25, NULL, N'9038564520', N'9038564598', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2701 Us Hwy 271 N', N'Pittsburg', N'TX', N'48063', N'75686', 33.00067, -94.966664, 3356, 273, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5481, N'Golden Plains Community Hospital', 1, NULL, NULL, N'451369', NULL, NULL, 0, 25, NULL, N'8062731100', N'8062731104', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'100 Medical Drive', N'Borger', N'TX', N'48233', N'79007', 35.662923, -101.392291, 3205, 256, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5482, N'Red River Regional Hospital', 1, NULL, NULL, N'451370', NULL, NULL, 0, 25, NULL, N'9036407311', N'9036407601', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'504 Lipscomb Street', N'Bonham', N'TX', N'48147', N'75418', 33.576736, -96.167421, 3224, 261, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5483, N'Seton Edgar B Davis Hospital', 1, NULL, NULL, N'451371', NULL, NULL, 0, 25, NULL, N'8308757000', N'8308757053', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'130 Hays Street', N'Luling', N'TX', N'48055', N'78648', 29.672668, -97.653924, 3328, 257, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5484, N'Muleshoe Area Medical Center', 1, NULL, NULL, N'451372', NULL, NULL, 0, 25, NULL, N'8062724524', N'8062724938', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'708 S 1St St', N'Muleshoe', N'TX', N'48017', N'79347', 34.222014, -102.727729, 3326, 267, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5485, N'Ward Memorial Hospital', 1, NULL, NULL, N'451373', NULL, NULL, 0, 25, NULL, N'4329432511', N'4329434767', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'406 South Gary St', N'Monahans', N'TX', N'48475', N'79756', 31.594299, -102.892654, 3338, 269, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5486, N'Scott & White Hospital-Taylor', 1, NULL, NULL, N'451374', NULL, NULL, 0, 25, NULL, N'5123527611', N'5123524216', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'305 Mallard', N'Taylor', N'TX', N'48491', N'76574', 30.591071, -97.417735, 3381, 272, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5487, N'Liberty Dayton Regional Medical Center Llc', 1, NULL, NULL, N'451375', NULL, NULL, 0, 25, NULL, N'9363367316', N'9363367772', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1353 N Travis St', N'Liberty', N'TX', N'48291', N'77575', 30.068223, -94.797978, 3322, 265, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5488, N'Lavaca Medical Center', 1, NULL, NULL, N'451376', NULL, NULL, 0, 25, NULL, N'3617983671', N'3617982682', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1400 North Texana Street', N'Hallettsville', N'TX', N'48285', N'77964', 29.443853, -96.941093, 3291, 265, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5489, N'Reeves County Hospital District', 1, NULL, NULL, N'451377', NULL, NULL, 0, 25, NULL, N'4324473551', N'4324475434', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2323 Texas Street', N'Pecos', N'TX', N'48389', N'79772', 31.400253, -103.513047, 3354, 269, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5490, N'Big Bend Regional Medical Center', 1, NULL, NULL, N'451378', NULL, NULL, 0, 25, NULL, N'4328373447', N'4328370330', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2600 Highway 118 North', N'Alpine', N'TX', N'48043', N'79830', 30.35738, -103.660937, 3203, 269, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5491, N'Coryell Memorial Healthcare System', 1, NULL, NULL, N'451379', NULL, NULL, 0, 25, NULL, N'2548658251', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1507 W Main Street', N'Gatesville', N'TX', N'48099', N'76528', 31.486814, -97.70427, 3280, 272, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5492, N'East Texas Medical Center Quitman', 1, NULL, NULL, N'451380', NULL, NULL, 0, 25, NULL, N'9037634500', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'117 Winnsboro Street', N'Quitman', N'TX', N'48499', N'75783', 32.796063, -95.445312, 3361, 273, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5493, N'Mother Frances Hospital- Winnsboro', 1, NULL, NULL, N'451381', NULL, NULL, 0, 35, NULL, N'9033425227', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'719 West Coke Road', N'Winnsboro', N'TX', N'48499', N'75494', 32.946398, -95.309476, 3404, 273, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5494, N'Comanche County Medical Center', 1, NULL, NULL, N'451382', NULL, NULL, 0, 38, NULL, N'2548794900', N'2548794992', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'10201 Hwy 16', N'Comanche', N'TX', N'48093', N'76442', 31.897369, -98.603658, 3248, 255, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5495, N'Leaves The', 1, NULL, NULL, N'451990', NULL, NULL, 0, 27, NULL, N'9722314864', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'1230 West Spring Valley Road', N'Richardson', N'TX', N'48113', N'75080', 32.9401, -96.744449, 3255, 261, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5496, N'Kindred Hospital Dallas', 1, NULL, NULL, N'452015', NULL, NULL, 0, 140, NULL, N'2143552600', N'2143552634', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'9525 Greenville Avenue', N'Dallas', N'TX', N'48113', N'75218', 32.905226, -96.74855, 3255, 261, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5497, N'Kindred Hospital San Antonio', 1, NULL, NULL, N'452016', NULL, NULL, 0, 59, NULL, N'2106160616', N'2105930661', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3636 Medical Drive', N'San Antonio', N'TX', N'48029', N'78229', 29.520767, -98.558246, 3370, 271, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5498, N'Texas Health Specialty Hospital Fort Worth', 1, NULL, NULL, N'452018', NULL, NULL, 0, 15, NULL, N'8178785500', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1300 Pennsylvania 4Th Floor Main Bldg', N'Fort Worth', N'TX', N'48439', N'76104', 32.753177, -97.332746, 3274, 263, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5499, N'Kindred Hospital Fort Worth- Mansfield', 1, NULL, NULL, N'452019', NULL, NULL, 0, 55, NULL, N'8173324812', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1802 Highway 157 North', N'Mansfield', N'TX', N'48439', N'76063', 32.563192, -97.141677, 3211, 263, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5500, N'Select Specialty Hospital-Dallas', 1, NULL, NULL, N'452022', NULL, NULL, 0, 60, NULL, N'9728842407', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'2329 Parker Road', N'Carrollton', N'TX', N'48121', N'75010', 33.04459, -96.890137, 3255, 261, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5501, N'Kindred Hospital Houston Medical Center', 1, NULL, NULL, N'452023', NULL, NULL, 0, 110, NULL, N'7137900500', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6441 Main St', N'Houston', N'TX', N'48201', N'77030', 29.714323, -95.398752, 3299, 265, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5502, N'Kindred Hospital-Tarrant County', 1, NULL, NULL, N'452028', NULL, NULL, 0, 80, NULL, N'8175430200', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1000 N Cooper St', N'Arlington', N'TX', N'48439', N'76011', 32.750196, -97.113916, 3211, 263, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5503, N'Continue Care Hospital At Hendrick Medical Center', 1, NULL, NULL, N'452029', NULL, NULL, 0, 19, NULL, N'3256705151', N'3256705157', 1, 1, 1, 1, 0, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1900 Pine St 5Th Floor', N'Abilene', N'TX', N'48441', N'79601', 32.446453, -99.733348, 3201, 255, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5504, N'Memorial Specialty Hospital', 1, NULL, NULL, N'452031', NULL, NULL, 0, 26, NULL, N'9366397975', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1201 Frank St Suite D', N'Lufkin', N'TX', N'48005', N'75901', 31.338241, -94.729097, 3327, 265, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5505, N'Cornerstone Hospital Of Houston', 1, NULL, NULL, N'452032', NULL, NULL, 0, 148, NULL, N'7135515300', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'709 Medical Center Blvd', N'Webster', N'TX', N'48201', N'77598', 29.538727, -95.129836, 3395, 265, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5506, N'Texas Center For Infectious Disease', 1, NULL, NULL, N'452033', NULL, NULL, 0, 75, NULL, N'2105348857', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2303 Se Military Dr P O Box 23340', N'San Antonio', N'TX', N'48029', N'78223', 29.4246, -98.49514, 3370, 271, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5507, N'Chg Cornerstone Hospital Of Austin', 1, NULL, NULL, N'452034', NULL, NULL, 0, 157, NULL, N'5127061900', N'5124218282', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4207 Burnet Rd', N'Austin', N'TX', N'48453', N'78756', 30.312218, -97.743531, 3215, 257, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5508, N'Mesa Hill Specialty Hospital', 1, NULL, NULL, N'452035', NULL, NULL, 0, 32, NULL, N'9155481823', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2311 N Oregon Street', N'El Paso', N'TX', N'48141', N'79902', 31.773617, -106.50164, 3268, 262, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5509, N'Texas Neuro Rehabilitation Center', 1, NULL, NULL, N'452038', NULL, NULL, 0, 47, NULL, N'5124444835', N'5124626636', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1106 W Dittmar', N'Austin', N'TX', N'48453', N'78745', 30.271129, -97.743699, 3215, 257, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5510, N'Kindred Hospital', 1, NULL, NULL, N'452039', NULL, NULL, 0, 74, NULL, N'2818978114', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'11297 Fallbrook', N'Houston', N'TX', N'48201', N'77065', 29.925274, -95.588061, 3299, 265, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5511, N'Acuity Hospital Of South Texas', 1, NULL, NULL, N'452040', NULL, NULL, 0, 30, NULL, N'2103080261', N'2103085927', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7310 Oak Manor', N'San Antonio', N'TX', N'48029', N'78229', 29.4246, -98.49514, 3370, 271, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5512, N'Carrus Specialty Hospital', 1, NULL, NULL, N'452041', NULL, NULL, 0, 16, NULL, N'9034164441', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1810 West Highway 82', N'Sherman', N'TX', N'48181', N'75092', 33.670661, -96.644499, 3375, 261, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5513, N'Christus Dubuis Hospital Of Beaumont', 1, NULL, NULL, N'452042', NULL, NULL, 0, 51, NULL, N'4098997680', NULL, 1, 1, 1, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2830 Calder Avenue 4Th Floor', N'Beaumont', N'TX', N'48245', N'77702', 30.086046, -94.101846, 3219, 258, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5514, N'Promise Hospital Of Houston', 1, NULL, NULL, N'452043', NULL, NULL, 0, 59, NULL, N'7136402400', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6160 S Loop East', N'Houston', N'TX', N'48201', N'77087', 29.700866, -95.280329, 3299, 265, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5515, N'Lifecare Hospitals Of Dallas', 1, NULL, NULL, N'452044', NULL, NULL, 0, 64, NULL, N'2145256300', N'2145250602', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1950 Record Crossing', N'Dallas', N'TX', N'48113', N'75235', 32.817498, -96.849274, 3255, 261, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5516, N'Plaza Specialty Hosp', 1, NULL, NULL, N'452046', NULL, NULL, 0, 65, NULL, N'7132851000', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1300 Binz', N'Houston', N'TX', N'48201', N'77004', 29.724108, -95.386941, 3299, 265, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5517, N'Select Specialty Hospital-Houston Heig', 1, NULL, NULL, N'452049', NULL, NULL, 0, 300, NULL, N'7138616161', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1917 Ashland', N'Houston', N'TX', N'48201', N'77008', 29.803096, -95.403712, 3299, 265, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5518, N'Llano Specialty Hospital', 1, NULL, NULL, N'452050', NULL, NULL, 0, 30, NULL, N'8067679133', N'8067679033', 1, 1, 1, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1409 9Th St', N'Lubbock', N'TX', N'48303', N'79401', 33.587283, -101.850472, 3326, 267, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5519, N'Etmc Specialty', 1, NULL, NULL, N'452051', NULL, NULL, 0, 36, NULL, N'9035356551', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1000 S Beckham 5Th Floor', N'Tyler', N'TX', N'48423', N'75701', 32.35126, -95.301062, 3388, 273, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5520, N'Plano Specialty Hospital', 1, NULL, NULL, N'452054', NULL, NULL, 0, 30, NULL, N'9727585200', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1621 Coit Road', N'Plano', N'TX', N'48085', N'75075', 33.041319, -96.770094, 3357, 261, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5521, N'Cornerstone Hospital Of South Houston', 1, NULL, NULL, N'452055', NULL, NULL, 0, 35, NULL, N'8326496200', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2001 Hermann Drive', N'Houston', N'TX', N'48201', N'77004', 29.717703, -95.382989, 3299, 265, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5522, N'Post Acute Medical Specialty Hospital Of Victoria', 1, NULL, NULL, N'452056', NULL, NULL, 0, 23, NULL, N'3615751445', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'506 E San Antonio Street  3 East Floor', N'Victoria', N'TX', N'48469', N'77901', 28.829714, -96.972537, 3391, 274, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5523, N'Nexus Specialty Hospital The Woodlands', 1, NULL, NULL, N'452057', NULL, NULL, 0, 75, NULL, N'7133640317', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'9182 Six Pines Drive', N'The Woodlands', N'TX', N'48339', N'77380', 30.175711, -95.459965, 3299, 265, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5524, N'Lifecare Hospital Of San Antonio', 1, NULL, NULL, N'452059', NULL, NULL, 0, 62, NULL, N'2106907000', N'2106907128', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'8902 Floyd Curl Drive', N'San Antonio', N'TX', N'48029', N'78240', 29.52571, -98.590874, 3370, 271, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5525, N'Vibra Hospital Of Amarillo', 1, NULL, NULL, N'452060', NULL, NULL, 0, 72, NULL, N'8063511600', N'8063539106', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7500 Wallace Blvd', N'Amarillo', N'TX', N'48375', N'79120', 35.195303, -101.926207, 3205, 256, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5526, N'Post Acute Medical Specialty Hospital Of Texarkana', 1, NULL, NULL, N'452061', NULL, NULL, 0, 49, NULL, N'9036147600', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2400 St Michael Drive 2Nd Floor', N'Texarkana', N'TX', N'48037', N'75503', 33.425125, -94.047688, 3384, 16, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5527, N'Warm Spring Speciality Hosptial At Luling', 1, NULL, NULL, N'452062', NULL, NULL, 0, 34, NULL, N'5126726592', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'200 Memorial Drive', N'Luling', N'TX', N'48055', N'78648', 29.673413, -97.653766, 3328, 257, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5528, N'Lifecare Hospitals Of South Tx', 1, NULL, NULL, N'452063', NULL, NULL, 0, 62, NULL, N'9569267000', N'9566884530', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2001 M Street', N'Mc Allen', N'TX', N'48215', N'78504', 31.816038, -99.512099, 3332, 268, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5529, N'Plum Creek Specialty  Hospital', 1, NULL, NULL, N'452066', NULL, NULL, 0, 47, NULL, N'8063511000', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5601 Plum Creek Drive', N'Amarillo', N'TX', N'48375', N'79124', 35.216709, -101.900399, 3205, 256, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5530, N'Promise Hospital Of Dallas', 1, NULL, NULL, N'452067', NULL, NULL, 0, 66, NULL, N'2146370000', N'2146376512', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7955 Harry Hines Blvd', N'Dallas', N'TX', N'48113', N'75235', 32.83315, -96.860771, 3255, 261, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5531, N'Promise Hospital Of Wichita Falls', 1, NULL, NULL, N'452068', NULL, NULL, 0, 31, NULL, N'9407637901', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1103 Grace Street', N'Wichita Falls', N'TX', N'48485', N'76301', 33.902875, -98.50015, 3402, 276, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5532, N'Kindred Hospital-White Rock', 1, NULL, NULL, N'452071', NULL, NULL, 0, 25, NULL, N'2143246730', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'9440 Poppy Drive 5Th Floor', N'Dallas', N'TX', N'48113', N'75218', 32.776196, -96.796899, 3255, 261, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5533, N'Select Specialty Hospital San Antonio', 1, NULL, NULL, N'452073', NULL, NULL, 0, 44, NULL, N'2102977182', N'2102970949', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'111 Dallas Street  4Th Floor', N'San Antonio', N'TX', N'48029', N'78205', 29.4246, -98.49514, 3370, 271, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5534, N'Kindred Hospital Tomball', 1, NULL, NULL, N'452074', NULL, NULL, 0, 288, NULL, N'2817652622', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'505 Graham Drive', N'Tomball', N'TX', N'48201', N'77375', 30.088718, -95.625705, 3386, 265, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5535, N'Kindred Hospital Clear Lake', 1, NULL, NULL, N'452075', NULL, NULL, 0, 147, NULL, N'2813167800', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'350 Blossom St', N'Webster', N'TX', N'48201', N'77598', 29.540751, -95.130079, 3395, 265, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5536, N'Select Specialty Hospital South Dallas', 1, NULL, NULL, N'452078', NULL, NULL, 0, 100, NULL, N'9727806506', N'9725726359', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3500 West Wheatland Road 4Th Floor', N'Dallas', N'TX', N'48113', N'75237', 32.776196, -96.796899, 3255, 261, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5537, N'Kindred Hosptial El Paso', 1, NULL, NULL, N'452079', NULL, NULL, 0, 62, NULL, N'9153519044', N'9153519066', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1740 Curie Drive', N'El Paso', N'TX', N'48141', N'79902', 31.779278, -106.477454, 3268, 262, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5538, N'Kindred Hospital Sugar Land', 1, NULL, NULL, N'452080', NULL, NULL, 0, 171, NULL, N'2812756000', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1550 First Colony Boulevard', N'Sugar Land', N'TX', N'48157', N'77479', 29.598836, -95.637076, 3299, 265, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5539, N'Dubuis Hospital Of Paris', 1, NULL, NULL, N'452082', NULL, NULL, 0, 25, NULL, N'9037822961', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'820 Clarksville St 6Th Floor', N'Paris', N'TX', N'48277', N'75460', 33.661796, -95.555513, 3352, 261, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5540, N'Mid-Jefferson Extended Care Hospital', 1, NULL, NULL, N'452083', NULL, NULL, 0, 48, NULL, N'4097268702', N'4099850579', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2600 Hwy 365', N'Nederland', N'TX', N'48245', N'77627', 29.97438, -93.992396, 3358, 258, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5541, N'Post Acute Medical Specialty Hospital Corpus Ch', 1, NULL, NULL, N'452086', NULL, NULL, 0, 22, NULL, N'3618813223', N'3618838901', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'600 Elizabeth Street 3Rd Floor', N'Corpus Christi', N'TX', N'48355', N'78404', 27.800254, -97.395574, 3250, 260, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5542, N'Select Speciality Hospital Of Longview', 1, NULL, NULL, N'452087', NULL, NULL, 0, 32, NULL, N'9033151111', NULL, 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'700 East Marshall Ave First Floor West Wing', N'Longview', N'TX', N'48183', N'75601', 32.500704, -94.740489, 3325, 266, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5543, N'Kindred Hospital Fort Worth', 1, NULL, NULL, N'452088', NULL, NULL, 0, 67, NULL, N'8173324812', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'815 Eighth Avenue', N'Fort Worth', N'TX', N'48439', N'76104', 32.753177, -97.332746, 3274, 263, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5544, N'Warm Springs Specialty Hospital Of San Antonio', 1, NULL, NULL, N'452090', NULL, NULL, 0, 26, NULL, N'2109213550', N'2109213578', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7400 Barlite Blvd 2Nd Floor', N'San Antonio', N'TX', N'48029', N'78224', 29.4246, -98.49514, 3370, 271, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5545, N'Tyler Continuecare Hospital (At Mother Frances)', 1, NULL, NULL, N'452091', NULL, NULL, 0, 51, NULL, N'9035314942', N'9035251580', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'800 East Dawson 4Th Floor', N'Tyler', N'TX', N'48423', N'75701', 32.35126, -95.301062, 3388, 273, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5546, N'Post Acute Specialty Hospital Of  Corpus Christi', 1, NULL, NULL, N'452092', NULL, NULL, 0, 74, NULL, N'3619861600', N'3619850330', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6226 Saratoga Boulevard', N'Corpus Christi', N'TX', N'48355', N'78414', 27.679395, -97.371366, 3250, 260, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5547, N'Harbor Hospital Of Southeast Texas Lp', 1, NULL, NULL, N'452093', NULL, NULL, 0, 30, NULL, N'4098403200', N'4098403290', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'860 S 8Th St', N'Beaumont', N'TX', N'48245', N'77701', 30.06877, -94.124727, 3219, 258, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5548, N'Warm Springs Specialty Hospital Of Victoria Llc', 1, NULL, NULL, N'452094', NULL, NULL, 0, 26, NULL, N'3615766200', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'102 Medical Drive', N'Victoria', N'TX', N'48469', N'77904', 28.854479, -97.021331, 3391, 274, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5549, N'Solara Hospital Mcallen', 1, NULL, NULL, N'452095', NULL, NULL, 0, 78, NULL, N'9566324880', N'9566324891', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'301 West Expressway 83-8Th Floor', N'Mc Allen', N'TX', N'48215', N'78503', 31.816038, -99.512099, 3332, 268, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5550, N'Laredo Specialty Hospital Lp', 1, NULL, NULL, N'452096', NULL, NULL, 0, 60, NULL, N'9567535353', N'9567535300', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2005 Bustamante Street', N'Laredo', N'TX', N'48479', N'78041', 27.506099, -99.508898, 3320, 271, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5551, N'Vibra Specialty Hospital', 1, NULL, NULL, N'452097', NULL, NULL, 0, 60, NULL, N'2146381500', N'2146384545', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2700 Walker Way', N'De Soto', N'TX', N'48113', N'75115', 32.589858, -96.856945, 3255, 261, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5552, N'Regency Hospital Of Fort Worth Lllp', 1, NULL, NULL, N'452099', NULL, NULL, 0, 44, NULL, N'8178402500', NULL, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'6801 Oakmont Blvd', N'Fort Worth', N'TX', N'48439', N'76132', 32.662759, -97.414802, 3274, 263, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5553, N'Mesquite Specialty Hospital', 1, NULL, NULL, N'452100', NULL, NULL, 0, 40, NULL, N'9722162300', N'9722887578', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1024  N Galloway Avenue', N'Mesquite', N'TX', N'48113', N'75149', 32.777717, -96.599664, 3255, 261, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5554, N'Solara Hospital Harlingen', 1, NULL, NULL, N'452101', NULL, NULL, 0, 41, NULL, N'6828319670', N'6828319595', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'508 Victoria Lane', N'Harlingen', N'TX', N'48061', N'78550', 26.190631, -97.696103, 3294, 264, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5555, N'Covenant Specialty Hospital', 1, NULL, NULL, N'452102', NULL, NULL, 0, 56, NULL, N'8067259200', N'8067259201', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3815 20Th Street', N'Lubbock', N'TX', N'48303', N'79410', 33.576771, -101.89682, 3326, 267, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5556, N'El Paso Ltac Hosptial', 1, NULL, NULL, N'452103', NULL, NULL, 0, 33, NULL, N'9154969687', N'9154969695', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1221 N Cotton St 3Rd Floor', N'El Paso', N'TX', N'48141', N'79902', 31.760037, -106.487287, 3268, 262, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5557, N'Scott & White Continuing Care Hospital', 1, NULL, NULL, N'452105', NULL, NULL, 0, 50, NULL, N'2542150900', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'546 N Kegley Road', N'Temple', N'TX', N'48027', N'76502', 31.119626, -97.397152, 3382, 272, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5558, N'Warm Springs Specialty Hospital At New Braunfels', 1, NULL, NULL, N'452106', NULL, NULL, 0, 40, NULL, N'8306277600', N'8306277603', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1445 Hanz Drive', N'New Braunfels', N'TX', N'48091', N'78130', 29.727461, -98.101563, 3344, 271, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5559, N'Chg Cornerstone- Conroe', 1, NULL, NULL, N'452107', NULL, NULL, 0, 41, NULL, N'6828319670', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1500 Grand Lake Drive', N'Conroe', N'TX', N'48339', N'77304', 30.282308, -95.464444, 3249, 265, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5560, N'Dallas Ltach Llc', 1, NULL, NULL, N'452108', NULL, NULL, 0, 60, NULL, N'4692326500', N'4692326501', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'8050 Meadows Road', N'Dallas', N'TX', N'48113', N'75231', 32.776196, -96.796899, 3255, 261, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5561, N'Integrity Transitional Hospital', 1, NULL, NULL, N'452109', NULL, NULL, 0, 24, NULL, N'8167292740', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2813 South Mayhill Road', N'Denton', N'TX', N'48121', N'76208', 33.19511, -97.08477, 3260, 261, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5562, N'Ethicus Hospital - Grapevine', 1, NULL, NULL, N'452110', NULL, NULL, 0, 60, NULL, N'8172881300', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4201 William D Tate Avenue', N'Grapevine', N'TX', N'48439', N'76051', 32.913423, -97.096945, 3288, 261, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5563, N'Atrium Medical Center At Corinth', 1, NULL, NULL, N'452111', NULL, NULL, 0, 60, NULL, N'9402704100', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3305 Corinth Parkway', N'Corinth', N'TX', N'48121', N'76208', 33.153458, -97.050735, 3260, 261, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5564, N'Icon Hospital', 1, NULL, NULL, N'452112', NULL, NULL, 0, 54, NULL, N'7048877283', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'19211 Mckay Blvd', N'Humble', N'TX', N'48201', N'77338', 29.998831, -95.262155, 3300, 265, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5565, N'Christus Dubuis Hospital Of Bryan', 1, NULL, NULL, N'452113', NULL, NULL, 0, 30, NULL, N'9798217592', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1600 Joseph Drive 2Nd Floor', N'Bryan', N'TX', N'48041', N'77802', 30.693444, -96.400802, 3231, 259, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5566, N'Atrium Medical Center', 1, NULL, NULL, N'452114', NULL, NULL, 0, 68, NULL, N'2812078200', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'11929 W Airport Blvd Suite 110', N'Stafford', N'TX', N'48157', N'77477', 29.616067, -95.557722, 3299, 265, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5567, N'Texas Specialty Hospital At Lubbock', 1, NULL, NULL, N'452116', NULL, NULL, 0, 37, NULL, N'8067238731', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4302 B Princeton St', N'Lubbock', N'TX', N'48303', N'79415', 33.577863, -101.855166, 3326, 267, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5568, N'Tirr Memorial Hermann', 1, NULL, NULL, N'453025', NULL, NULL, 0, 119, NULL, N'7137997022', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1333 Moursund Ave', N'Houston', N'TX', N'48201', N'77030', 29.758938, -95.367697, 3299, 265, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5569, N'Healthsouth Rehabilitation Hospital Of Humble', 1, NULL, NULL, N'453029', NULL, NULL, 0, 90, NULL, N'2813199509', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'19002 Mckay Drive', N'Humble', N'TX', N'48201', N'77338', 29.998831, -95.262155, 3300, 265, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5570, N'Healthsouth Rehab Institute Of San Antonio', 1, NULL, NULL, N'453031', NULL, NULL, 0, 108, NULL, N'2106910737', N'2105581297', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'9119 Cinnamon Hill', N'San Antonio', N'TX', N'48029', N'78240', 29.4246, -98.49514, 3370, 271, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5571, N'Warm Springs Rehab Hospital Of San Antonio Llc', 1, NULL, NULL, N'453035', NULL, NULL, 0, 65, NULL, N'2106160100', NULL, 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5101 Medical Dr', N'San Antonio', N'TX', N'48029', N'78229', 29.509098, -98.58974, 3370, 271, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5572, N'Baylor Institute For Rehabilitation', 1, NULL, NULL, N'453036', NULL, NULL, 0, 92, NULL, N'2148209543', N'2148209295', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'909 North Washington Avenue', N'Dallas', N'TX', N'48113', N'75246', 32.792009, -96.779451, 3255, 261, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5573, N'Healthsouth Rehabilitation Hospital Of Arlington', 1, NULL, NULL, N'453040', NULL, NULL, 0, 85, NULL, N'8174684000', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3200 Matlock', N'Arlington', N'TX', N'48439', N'76015', 32.696273, -97.115097, 3211, 263, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5574, N'Healthsouth Rehabilitation Hospital Of Fort Worth', 1, NULL, NULL, N'453041', NULL, NULL, 0, 60, NULL, N'8178702336', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1212 West Lancaster', N'Fort Worth', N'TX', N'48439', N'76102', 32.753177, -97.332746, 3274, 263, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5575, N'Healthsouth City View Rehab Hospital', 1, NULL, NULL, N'453042', NULL, NULL, 0, 62, NULL, N'8173704700', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6701 Oakmont Boulevard', N'Fort Worth', N'TX', N'48439', N'76132', 32.662748, -97.41206, 3274, 263, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5576, N'Healthsouth Rehabilitation Hospital Of Austin', 1, NULL, NULL, N'453044', NULL, NULL, 0, 83, NULL, N'5124793713', N'5124742720', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1215 Red River', N'Austin', N'TX', N'48453', N'78701', 30.271129, -97.743699, 3215, 257, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5577, N'Healthsouth Plano Rehabilitation Hospital', 1, NULL, NULL, N'453047', NULL, NULL, 0, 83, NULL, N'9726129000', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2800 W 15Th St', N'Plano', N'TX', N'48085', N'75075', 33.013676, -96.69251, 3357, 261, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5578, N'Healthsouth Rehabilitation Hospital Of Beaumont', 1, NULL, NULL, N'453048', NULL, NULL, 0, 61, NULL, N'4098350835', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3340 Plaza 10 Blvd Ste B', N'Beaumont', N'TX', N'48245', N'77707', 30.086046, -94.101846, 3219, 258, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5579, N'Kindred Rehabilitation Hospital Clear Lake', 1, NULL, NULL, N'453052', NULL, NULL, 0, 60, NULL, N'2812861500', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'655 E Medical Center Blvd', N'Webster', N'TX', N'48201', N'77598', 29.538851, -95.129514, 3395, 265, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5580, N'Healthsouth  Rehabilitation Hospital Of Texarkana', 1, NULL, NULL, N'453053', NULL, NULL, 0, 60, NULL, N'9037930088', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'515 West 12Th St', N'Texarkana', N'TX', N'48037', N'75501', 33.430878, -94.047455, 3384, 16, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5581, N'Healthsouth Rehab Hospital Of Wichita Falls', 1, NULL, NULL, N'453054', NULL, NULL, 0, 63, NULL, N'9407205700', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3901 Armory Road', N'Wichita Falls', N'TX', N'48485', N'76301', 33.874684, -98.485502, 3402, 276, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5582, N'Trinity Mother Frances Rehabilitation Hospital', 1, NULL, NULL, N'453056', NULL, NULL, 0, 74, NULL, N'9035107000', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3131 Troup Hwy', N'Tyler', N'TX', N'48423', N'75701', 32.315304, -95.276708, 3388, 273, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5583, N'Healthsouth Rehabilitation Of Midland Odessa', 1, NULL, NULL, N'453057', NULL, NULL, 0, 60, NULL, N'9155201600', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1800 Heritage Boulevard', N'Midland', N'TX', N'48329', N'79707', 32.000103, -102.157545, 3336, 269, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5584, N'Healthsouth Rehab Hospital The Woodlands', 1, NULL, NULL, N'453059', NULL, NULL, 0, 96, NULL, N'2813643304', N'2813648947', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'18550 I 45 South', N'Conroe', N'TX', N'48339', N'77384', 30.39338, -95.47042, 3249, 265, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5585, N'Christus St Michael Rehab Hospital', 1, NULL, NULL, N'453065', NULL, NULL, 0, 50, NULL, N'9036144000', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2400 St Michael Drive', N'Texarkana', N'TX', N'48037', N'75503', 33.46459, -94.069672, 3384, 16, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5586, N'Etmc Rehab', 1, NULL, NULL, N'453072', NULL, NULL, 0, 49, NULL, N'9035963000', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'701 Olympic Plaza Circle', N'Tyler', N'TX', N'48423', N'75701', 32.337078, -95.292046, 3388, 273, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5587, N'Highlands Regional Rehabilitation Hospital', 1, NULL, NULL, N'453086', NULL, NULL, 0, 41, NULL, N'9152987222', N'9152987237', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1395 George Dieter Drive', N'El Paso', N'TX', N'48141', N'79936', 31.73387, -106.301838, 3268, 262, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5588, N'Weslaco Rehabilitation Hospital', 1, NULL, NULL, N'453091', NULL, NULL, 0, 26, NULL, N'9569692222', N'9569692221', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'906 South James', N'Weslaco', N'TX', N'48215', N'78596', 26.163237, -98.01578, 3398, 264, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5589, N'South Texas Rehabiltation Hospital', 1, NULL, NULL, N'453092', NULL, NULL, 0, 40, NULL, N'9565546000', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'425 East Alton Gloor Blvd', N'Brownsville', N'TX', N'48061', N'78526', 25.979882, -97.497606, 3229, 264, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5590, N'Kindred  Rehabilitation Hospital Arlington', 1, NULL, NULL, N'453094', NULL, NULL, 0, 24, NULL, N'8178044410', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2601 West Randol  Mill Road # 101', N'Arlington', N'TX', N'48439', N'76012', 32.735582, -97.107119, 3211, 263, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5591, N'Vibra Rehabilitation Hospital Of Amarillo', 1, NULL, NULL, N'453096', NULL, NULL, 0, 44, NULL, N'8064682981', N'8067142642', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7200 West 9Th Street', N'Amarillo', N'TX', N'48375', N'79106', 35.207219, -101.833825, 3205, 256, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5592, N'Cook Childrens Medical Center', 1, NULL, NULL, N'453300', NULL, NULL, 0, 282, NULL, N'6828854000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'801 Seventh Avenue', N'Fort Worth', N'TX', N'48439', N'76104', 32.753177, -97.332746, 3274, 263, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5593, N'Driscoll Childrens Hospital', 1, NULL, NULL, N'453301', NULL, NULL, 0, 200, NULL, N'3617394846', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3533 S Alameda Box 6530', N'Corpus Christi', N'TX', N'48355', N'78411', 27.800254, -97.395574, 3250, 260, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5594, N'Childrens Medical Ctr Of Dallas', 1, NULL, NULL, N'453302', NULL, NULL, 0, 406, NULL, N'2144567000', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1935 Medical District Drive', N'Dallas', N'TX', N'48113', N'75235', 32.809496, -96.837518, 3255, 261, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5595, N'Texas Childrens Hosp', 1, NULL, NULL, N'453304', NULL, NULL, 0, 606, NULL, N'8328241000', NULL, 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6621 Fannin Street', N'Houston', N'TX', N'48201', N'77030', 29.709777, -95.400712, 3299, 265, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5596, N'Covenant Childrens Hospital', 1, NULL, NULL, N'453306', NULL, NULL, 0, 73, NULL, N'8067250532', N'8067237183', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4015 22Nd Place', N'Lubbock', N'TX', N'48303', N'79410', 33.574022, -101.900419, 3326, 267, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5597, N'Our Childrens House At Baylor', 1, NULL, NULL, N'453308', NULL, NULL, 0, 38, NULL, N'2148284747', NULL, 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3301 Swiss Ave', N'Dallas', N'TX', N'48113', N'75204', 32.791197, -96.782966, 3255, 261, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5598, N'Healthbridge Childrens''s Hospital Of Houston', 1, NULL, NULL, N'453309', NULL, NULL, 0, 40, NULL, N'2812937774', NULL, 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2929 Woodland Park Drive', N'Houston', N'TX', N'48201', N'77082', 29.733148, -95.580499, 3299, 265, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5599, N'Dell Children''s Medical Center Of Central Texas', 1, NULL, NULL, N'453310', NULL, NULL, 0, 176, NULL, N'5123240000', NULL, 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4900 Mueller Blvd', N'Austin', N'TX', N'48453', N'78723', 30.303564, -97.707051, 3215, 257, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5600, N'Shriners Hospitals For Children', 1, NULL, NULL, N'453311', NULL, NULL, 0, 30, NULL, N'4097706600', N'4097706977', 1, 0, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'815 Market Street', N'Galveston', N'TX', N'48167', N'77550', 29.730132, -95.008407, 3278, 265, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5601, N'Shriners Hospitals For Children', 1, NULL, NULL, N'453312', NULL, NULL, 0, 40, NULL, N'7137971616', N'7137971029', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6977 Main Street', N'Houston', N'TX', N'48201', N'77030', 29.704337, -95.405749, 3299, 265, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5602, N'El Paso Children''s Hospital', 1, NULL, NULL, N'453313', NULL, NULL, 0, 122, NULL, N'9155217148', N'9155217849', 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4845 Alameda Avenue', N'El Paso', N'TX', N'48141', N'79905', 31.770324, -106.432954, 3268, 262, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5603, N'Texas Scottish Rite Hospital For Children', 1, NULL, NULL, N'453314', NULL, NULL, 0, 100, NULL, N'2145595000', NULL, 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2222 Welborn Street', N'Dallas', N'TX', N'48113', N'75219', 32.802014, -96.814555, 3255, 261, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5604, N'Children''s Hospital Of San Antonio', 1, NULL, NULL, N'453315', NULL, NULL, 0, 120, NULL, N'2107043342', N'2107043466', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'333 North Santa Rosa Street', N'San Antonio', N'TX', N'48029', N'78207', 29.428172, -98.497842, 3370, 271, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5605, N'Big Spring State Hospital', 1, NULL, NULL, N'454000', NULL, NULL, 0, 160, NULL, N'4322687222', N'4322687259', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1901 North Highway 87', N'Big Spring', N'TX', N'48227', N'79721', 32.250398, -101.478736, 3223, 267, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5606, N'Terrell State Hospital', 1, NULL, NULL, N'454006', NULL, NULL, 0, 74, NULL, N'9725246452', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1200 E Brin Street', N'Terrell', N'TX', N'48257', N'75160', 32.738354, -96.262675, 3383, 261, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5607, N'North Texas State Hospital', 1, NULL, NULL, N'454008', NULL, NULL, 0, 354, NULL, N'9406921220', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6515 Kemp Blvd', N'Wichita Falls', N'TX', N'48485', N'76308', 33.840533, -98.527873, 3402, 276, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5608, N'Rusk State Hosp', 1, NULL, NULL, N'454009', NULL, NULL, 0, 380, NULL, N'9036833421', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'805 N Dickinson Dr', N'Rusk', N'TX', N'48073', N'75785', 31.809813, -95.156774, 3304, 273, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5609, N'San Antonio State Hosp  State School', 1, NULL, NULL, N'454011', NULL, NULL, 0, 302, NULL, N'2105317711', N'2105317876', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6711 S New Braunfels Ave', N'San Antonio', N'TX', N'48029', N'78223', 29.365783, -98.459812, 3370, 271, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5610, N'Millwood Hospital', 1, NULL, NULL, N'454012', NULL, NULL, 0, 122, NULL, N'8172613121', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'1011 North Cooper Street', N'Arlington', N'TX', N'48439', N'76011', 32.750327, -97.113704, 3211, 263, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5611, N'Kerrville State Hosp', 1, NULL, NULL, N'454014', NULL, NULL, 0, 233, NULL, N'8308962211', N'8307924926', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'721 Thompson Dr', N'Kerrville', N'TX', N'48265', N'78028', 30.046969, -99.151302, 3312, 271, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5612, N'Red River Hospital', 1, NULL, NULL, N'454018', NULL, NULL, 0, 66, NULL, N'9403223171', N'9403227010', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1505 8Th St', N'Wichita Falls', N'TX', N'48485', N'76301', 33.906648, -98.501173, 3402, 276, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5613, N'West Oaks Hospital', 1, NULL, NULL, N'454026', NULL, NULL, 0, 144, NULL, N'7139950909', N'7137785253', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6500 Hornwood', N'Houston', N'TX', N'48201', N'77074', 29.708962, -95.49698, 3299, 265, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5614, N'Seton Shoal Creek Hospital', 1, NULL, NULL, N'454029', NULL, NULL, 0, 151, NULL, N'5123242000', NULL, 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3501 Mills Ave', N'Austin', N'TX', N'48453', N'78731', 30.305784, -97.749061, 3215, 257, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5615, N'Glen Oaks Hospital', 1, NULL, NULL, N'454050', NULL, NULL, 0, 54, NULL, N'9034546000', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'301 E Division Box 1885', N'Greenville', N'TX', N'48231', N'75401', 33.138449, -96.110807, 3289, 261, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5616, N'Laurel Ridge Treatment Center', 1, NULL, NULL, N'454060', NULL, NULL, 0, 190, NULL, N'5124919400', N'2104913350', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'17720 Corporate Woods Drive', N'San Antonio', N'TX', N'48029', N'78259', 29.4246, -98.49514, 3370, 271, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5617, N'River Crest Hosp', 1, NULL, NULL, N'454064', NULL, NULL, 0, 80, NULL, N'9159495722', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1636 Hunters Glen Road', N'San Angelo', N'TX', N'48451', N'76901', 31.445959, -100.511246, 3369, 270, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5618, N'Hickory Trail Hospital', 1, NULL, NULL, N'454065', NULL, NULL, 0, 76, NULL, N'9722987323', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2000 N Old Hickory Trail', N'Desoto', N'TX', N'48113', N'75115', 31.816038, -99.512099, 3255, 261, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5619, N'Austin Lakes Hospital', 1, NULL, NULL, N'454069', NULL, NULL, 0, 58, NULL, N'5128675800', N'5124048102', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1025 East 32Nd Street', N'Austin', N'TX', N'48453', N'78765', 30.289382, -97.723827, 3215, 257, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5620, N'Harris Cty Psychiatric Ctr', 1, NULL, NULL, N'454076', NULL, NULL, 0, 272, NULL, N'7137415000', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2800 Macgregor Way', N'Houston', N'TX', N'48201', N'77021', 29.758938, -95.367697, 3299, 265, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5621, N'Timberlawn Mental Health System', 1, NULL, NULL, N'454081', NULL, NULL, 0, 144, NULL, N'2143817181', N'2143886453', 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'4600 Samuell Blvd Po Box 151489', N'Dallas', N'TX', N'48113', N'75315', 32.776196, -96.796899, 3255, 261, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5622, N'Intracare North Hospital', 1, NULL, NULL, N'454083', NULL, NULL, 0, 90, NULL, N'2818937200', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1120 Cypress Station Dr', N'Houston', N'TX', N'48201', N'77090', 29.758938, -95.367697, 3299, 265, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5623, N'Austin State Hospital', 1, NULL, NULL, N'454084', NULL, NULL, 0, 352, NULL, N'5124192100', N'5124192139', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4110 Guadalupe', N'Austin', N'TX', N'48453', N'78751', 30.306322, -97.735948, 3215, 257, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5624, N'Devereux Texas Treatment Network', 1, NULL, NULL, N'454085', NULL, NULL, 0, 132, NULL, N'2813351000', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1150 Devereux Dr', N'League City', N'TX', N'48167', N'77573', 29.506495, -95.106458, 3395, 265, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5625, N'Rio Grande State Center', 1, NULL, NULL, N'454088', NULL, NULL, 0, 160, NULL, N'9563648000', N'9563648245', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1401 Rangerville Road', N'Harlingen', N'TX', N'48061', N'78550', 26.164851, -97.705776, 3294, 264, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5626, N'Sunrise Canyon Hospital', 1, NULL, NULL, N'454093', NULL, NULL, 0, 30, NULL, N'8067660268', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1950 Aspen Avenue', N'Lubbock', N'TX', N'48303', N'79408', 33.574137, -101.807455, 3326, 267, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5627, N'Green Oaks Hospital', 1, NULL, NULL, N'454094', NULL, NULL, 0, 106, NULL, N'9729919504', N'4694842132', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7808 Clodus Fields Drive', N'Dallas', N'TX', N'48113', N'75251', 32.913458, -96.770853, 3255, 261, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5628, N'Abilene Behavioral Health Llc', 1, NULL, NULL, N'454098', NULL, NULL, 0, 92, NULL, N'3256986600', N'3256988200', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4225 Woods Place', N'Abilene', N'TX', N'48441', N'79608', 32.400107, -99.739868, 3201, 255, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5629, N'El Paso Psychiatric Center', 1, NULL, NULL, N'454100', NULL, NULL, 0, 85, NULL, N'9155322202', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4615 Alameda Avenue', N'El Paso', N'TX', N'48141', N'79905', 31.771389, -106.436204, 3268, 262, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5630, N'Allegiance Behavioral Health Center Of Plainview', 1, NULL, NULL, N'454101', NULL, NULL, 0, 20, NULL, N'8062969191', N'8062969292', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'2601 Dimmitt Road Suite 400', N'Plainview', N'TX', N'48189', N'79072', 34.184794, -101.706842, 3326, 267, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5631, N'Kingwood Pines Hospital', 1, NULL, NULL, N'454103', NULL, NULL, 0, 116, NULL, N'2813581495', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2001 Ladbrook', N'Kingwood', N'TX', N'48201', N'77339', 30.045284, -95.228863, 3299, 265, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5632, N'University Behavioral Health', 1, NULL, NULL, N'454104', NULL, NULL, 0, 104, NULL, N'9403208100', N'9403840307', 1, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'2026 West University Drive', N'Denton', N'TX', N'48121', N'76201', 33.22973, -97.156303, 3260, 261, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5633, N'Behavioral Hospital Of Longview', 1, NULL, NULL, N'454105', NULL, NULL, 0, 76, NULL, N'9032913456', N'9036631722', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'22 Bermuda Lane', N'Longview', N'TX', N'48183', N'75605', 32.564875, -94.764979, 3325, 266, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5634, N'Behavioral Hospital Of Bellaire', 1, NULL, NULL, N'454107', NULL, NULL, 0, 124, NULL, N'7136009500', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'5314 Dashwood Suite 200', N'Houston', N'TX', N'48201', N'77081', 29.758938, -95.367697, 3299, 265, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5635, N'Cypress Creek Hospital', 1, NULL, NULL, N'454108', NULL, NULL, 0, 96, NULL, N'2815867600', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'17750 Cali Drive', N'Houston', N'TX', N'48201', N'77090', 29.758938, -95.367697, 3299, 265, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5636, N'El Paso Behavioral Health System', 1, NULL, NULL, N'454109', NULL, NULL, 0, 163, NULL, N'9155444000', N'9155320733', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1900 Denver Ave', N'El Paso', N'TX', N'48141', N'79902', 31.781368, -106.47597, 3268, 262, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5637, N'Oceans Behavioral  Hospital Of Permian Basin', 1, NULL, NULL, N'454110', NULL, NULL, 0, 64, NULL, N'4325615915', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'3300 S Fm 1788', N'Midland', N'TX', N'48329', N'79706', 31.997366, -102.077948, 3336, 269, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5638, N'Texas Star Recovery', 1, NULL, NULL, N'454111', NULL, NULL, 0, 60, NULL, N'5124444835', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1106  West Dittmar Rd', N'Austin', N'TX', N'48453', N'78745', 30.271129, -97.743699, 3215, 257, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5639, N'Sundance Hospital', 1, NULL, NULL, N'454113', NULL, NULL, 0, 56, NULL, N'8175838080', N'8174831572', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'7000 Us Highway 287', N'Arlington', N'TX', N'48439', N'76001', 32.735582, -97.107119, 3211, 263, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5640, N'Cedar Crest Hospital & Rtc', 1, NULL, NULL, N'454114', NULL, NULL, 0, 70, NULL, N'2549392100', N'2549392334', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'3500 South Ih-35', N'Belton', N'TX', N'48027', N'76513', 31.056013, -97.464453, 3382, 272, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5641, N'Oceans Behavioral Hospital Of Longview', 1, NULL, NULL, N'454117', NULL, NULL, 0, 24, NULL, N'9032123105', N'9032122930', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'615 Clinic Dr', N'Longview', N'TX', N'48183', N'75605', 32.500704, -94.740489, 3325, 266, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5642, N'Lone Star Behavioral Health Cypress', 1, NULL, NULL, N'454118', NULL, NULL, 0, 24, NULL, N'2815166186', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'16303 Grant Road', N'Cypress', N'TX', N'48201', N'77429', 29.969112, -95.697169, 3299, 265, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5643, N'Carrollton Springs', 1, NULL, NULL, N'454119', NULL, NULL, 0, 45, NULL, N'9722424114', N'9722424117', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2225 Parker Road', N'Carrollton', N'TX', N'48121', N'75010', 33.04459, -96.890137, 3255, 261, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5644, N'Cambridge Hospital Llc', 1, NULL, NULL, N'454120', NULL, NULL, 0, 148, NULL, N'7137955025', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7601 Fannin', N'Houston', N'TX', N'48201', N'77054', 29.690945, -95.403227, 3299, 265, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5645, N'Austin Oaks Hospital', 1, NULL, NULL, N'454121', NULL, NULL, 0, 80, NULL, N'5123838939', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1407 West Stassney Lane', N'Austin', N'TX', N'48453', N'78745', 30.21199, -97.790888, 3215, 257, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5646, N'Oceans Behavioral Hospital Of Abilene', 1, NULL, NULL, N'454122', NULL, NULL, 0, 35, NULL, N'3296910030', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6401 Directors Parkway', N'Abilene', N'TX', N'48441', N'79606', 32.371325, -99.745065, 3201, 255, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5647, N'Oceans Behavioral Hospital Of Lufkin Llc', 1, NULL, NULL, N'454123', NULL, NULL, 0, 24, NULL, N'9366322276', N'9366322295', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'302 Gobblers Knob Rd', N'Lufkin', N'TX', N'48005', N'75904', 31.338241, -94.729097, 3327, 265, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5648, N'Mesa Springs', 1, NULL, NULL, N'454124', NULL, NULL, 0, 72, NULL, N'8172924600', N'8172924604', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5560 Mesa Springs Drive', N'Fort Worth', N'TX', N'48439', N'76123', 32.753177, -97.332746, 3274, 263, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5649, N'Rock Prairie Behavioral Health', 1, NULL, NULL, N'454125', NULL, NULL, 0, 105, NULL, N'9797038848', N'9797036485', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3550 Normand Drive', N'College Station', N'TX', N'48041', N'77845', 30.626262, -96.334725, 3231, 259, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5650, N'Dallas Behavioral Healthcare Hospital Llc', 1, NULL, NULL, N'454126', NULL, NULL, 0, 116, NULL, N'9722961005', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'800 Kirnwood Drive', N'De Soto', N'TX', N'48113', N'75115', 32.589858, -96.856945, 3255, 261, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5651, N'Oceans Behavioral Hospital Of Fort Worth', 1, NULL, NULL, N'454128', NULL, NULL, 0, 48, NULL, N'8173611991', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6200 Overton Ridge Blvd', N'Fort Worth', N'TX', N'48439', N'76132', 32.680406, -97.420018, 3274, 263, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5652, N'Georgetown Behavioral Health Institute', 1, NULL, NULL, N'454129', NULL, NULL, 0, 118, NULL, N'2489055091', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'3101 S Austin Avenue', N'Georgetown', N'TX', N'48491', N'78626', 30.632244, -97.67797, 3381, 272, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5653, N'Oceans Behavioral Hospital Of Plano', 1, NULL, NULL, N'454130', NULL, NULL, 0, 48, NULL, N'9725965445', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4301 Mapleshade Lane', N'Plano', N'TX', N'48085', N'75093', 33.006155, -96.805811, 3357, 261, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5654, N'Westpark Springs Llc', 1, NULL, NULL, N'454131', NULL, NULL, 0, 72, NULL, N'8325352770', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'6902 S Peek Road', N'Richmond', N'TX', N'48157', N'77407', 29.582181, -95.760783, 3364, 265, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5655, N'Medical City Hospital', 1, NULL, NULL, N'459801', NULL, NULL, 0, 0, NULL, N'9725667199', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'7777 Forest Lane', N'Dallas', N'TX', N'48113', N'75230', 32.909449, -96.771223, 3255, 261, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5656, N'Methodist Dallas Medical Center', 1, NULL, NULL, N'459802', NULL, NULL, 0, 0, NULL, N'2149472879', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'1441 N Beckley Avenue', N'Dallas', N'TX', N'48113', N'75203', 32.761651, -96.823094, 3255, 261, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5657, N'University Hospital Transplant', 1, NULL, NULL, N'459803', NULL, NULL, 0, 0, NULL, N'2105675772', N'2105675122', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'4502 Medical Drive', N'San Antonio', N'TX', N'48029', N'78229', 29.508958, -98.574765, 3370, 271, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5658, N'St Lukes Episcopal Hospital Transplant', 1, NULL, NULL, N'459805', NULL, NULL, 0, 0, NULL, N'8323551000', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'6720 Bertner', N'Houston', N'TX', N'48201', N'77030', 29.706776, -95.399023, 3299, 265, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5659, N'Christus Santa Rosa Medical Center Transplant', 1, NULL, NULL, N'459806', NULL, NULL, 0, 0, NULL, N'2108889999', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'333 Santa Rosa Street', N'San Antonio', N'TX', N'48029', N'78207', 29.4246, -98.49514, 3370, 271, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5660, N'North Austin Medical Center', 1, NULL, NULL, N'459807', NULL, NULL, 0, 0, NULL, N'5129012896', N'5129011995', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'12221 North Mopac Expressway', N'Austin', N'TX', N'48453', N'78758', 30.366167, -97.743499, 3215, 257, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5661, N'Baylor University Medical Center', 1, NULL, NULL, N'459808', NULL, NULL, 0, 0, NULL, N'2148202657', N'2148204527', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'3500 Gaston Ave', N'Dallas', N'TX', N'48113', N'75246', 32.790462, -96.780872, 3255, 261, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5662, N'The Methodist Hospital Transplant', 1, NULL, NULL, N'459809', NULL, NULL, 0, 0, NULL, N'7137902221', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'6565 Fannin', N'Houston', N'TX', N'48201', N'77030', 29.710741, -95.399149, 3299, 265, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5663, N'Seton Medical Center', 1, NULL, NULL, N'459810', NULL, NULL, 0, 0, NULL, N'5123241902', N'5124595629', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'1201 West 38Th Street', N'Austin', N'TX', N'48453', N'78705', 30.305992, -97.744969, 3215, 257, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5664, N'Harris Methodist Ft Worth Transplant', 1, NULL, NULL, N'459811', NULL, NULL, 0, 552, NULL, N'8178822100', N'8178822149', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'1301 Pennsylvania Ave', N'Fort Worth', N'TX', N'48439', N'76104', 32.738406, -97.339167, 3274, 263, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5665, N'Cook Childrens Medical Center Transplant Services', 1, NULL, NULL, N'459812', NULL, NULL, 0, 0, NULL, N'6828854286', N'6828857883', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'801 Seventh Ave', N'Fort Worth', N'TX', N'48439', N'76104', 32.753177, -97.332746, 3274, 263, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5666, N'Utmb Galveston Transplant', 1, NULL, NULL, N'459813', NULL, NULL, 0, 0, NULL, N'4097721011', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'301 University Blvd', N'Galveston', N'TX', N'48167', N'77555', 29.310307, -94.774521, 3278, 265, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5667, N'Children''s Medical Center Dallas', 1, NULL, NULL, N'459814', NULL, NULL, 0, 0, NULL, N'2144566332', N'2144568586', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'1935 Motor St', N'Dallas', N'TX', N'48113', N'75235', 32.809496, -96.837518, 3255, 261, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5668, N'Texas Children''s Hospital Transplant', 1, NULL, NULL, N'459815', NULL, NULL, 0, 0, NULL, N'8328241120', N'8328251005', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'6621 Fannin', N'Houston', N'TX', N'48201', N'77030', 29.709777, -95.400712, 3299, 265, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5669, N'Ut Southwestern Medical Center University Hospital', 1, NULL, NULL, N'459816', NULL, NULL, 0, 0, NULL, N'2146451914', N'2146451900', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'5909 Harry Hines Blvd', N'Dallas', N'TX', N'48113', N'75390', 32.817634, -96.844658, 3255, 261, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5670, N'East Texas Medical Center Transplant', 1, NULL, NULL, N'459817', NULL, NULL, 0, 0, NULL, N'9035318643', N'9035356703', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'1000 S Beckham', N'Tyler', N'TX', N'48423', N'75701', 32.35126, -95.301062, 3388, 273, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5671, N'Methodist Hospital', 1, NULL, NULL, N'459818', NULL, NULL, 0, 0, NULL, N'2105756275', N'2105754410', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'7700 Floyd Curl Drive', N'San Antonio', N'TX', N'48029', N'78229', 29.507341, -98.573582, 3370, 271, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5672, N'Parkland Hospital', 1, NULL, NULL, N'459819', NULL, NULL, 0, 0, NULL, N'2145906773', N'2145904595', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'5201 Harry Hines', N'Dallas', N'TX', N'48113', N'75235', 32.81088, -96.835826, 3255, 261, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5673, N'Mcallen Medical Center - S Texas Transplant Center', 1, NULL, NULL, N'459820', NULL, NULL, 0, 0, NULL, N'9569715726', N'9569715840', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'301 W Expressway 83', N'Mcallen', N'TX', N'48215', N'78503', 26.188846, -98.224641, 3332, 268, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5674, N'Scott & White Transplant', 1, NULL, NULL, N'459821', NULL, NULL, 0, 0, NULL, N'2547247545', N'2547248772', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'2401 S 31St St', N'Temple', N'TX', N'48027', N'76508', 31.077909, -97.366162, 3382, 272, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5675, N'Baylor All Saints Medical Center Of Fort Worth', 1, NULL, NULL, N'459822', NULL, NULL, 0, 0, NULL, N'8179224650', N'8179224655', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'1400 Eighth Ave', N'Fort Worth', N'TX', N'48439', N'76104', 32.753177, -97.332746, 3274, 263, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5676, N'Driscoll Children''s Hospital Transplant Center', 1, NULL, NULL, N'459823', NULL, NULL, 0, 0, NULL, N'3616946852', N'3616946859', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'3533 S Alameda', N'Corpus Christi', N'TX', N'48355', N'78466', 27.715689, -97.338327, 3250, 260, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5677, N'Memorial Hermann Hospital', 1, NULL, NULL, N'459824', NULL, NULL, 0, 0, NULL, N'7137041735', N'7137046374', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'6411 Fannin Drive', N'Houston', N'TX', N'48201', N'77030', 29.758938, -95.367697, 3299, 265, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5678, N'Las Palmas Medical Center (Transplant)', 1, NULL, NULL, N'459825', NULL, NULL, 0, 0, NULL, N'9155211828', N'9155994381', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'1700 North Oregon Suite 680', N'El Paso', N'TX', N'48141', N'79902', 31.760037, -106.487287, 3268, 262, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5679, N'Plaza Medical Center Of Fort Worth', 1, NULL, NULL, N'459826', NULL, NULL, 0, 0, NULL, N'8178775292', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'900 Eighth Avenue', N'Fort Worth', N'TX', N'48439', N'76104', 32.753177, -97.332746, 3274, 263, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5680, N'Utah Valley Regional Medical Center', 1, NULL, NULL, N'460001', NULL, NULL, 0, 395, NULL, N'8013737850', N'8013577780', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1034 North 500 West', N'Provo', N'UT', N'49049', N'84604', 40.247557, -111.667308, 3429, 278, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5681, N'Salt Lake Regional Medical Center', 1, NULL, NULL, N'460003', NULL, NULL, 0, 158, NULL, N'8013504111', N'8013504522', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1050 East South Temple', N'Salt Lake City', N'UT', N'49035', N'84102', 40.769374, -111.861066, 3432, 279, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5682, N'Mckay Dee Hospital', 1, NULL, NULL, N'460004', NULL, NULL, 0, 304, NULL, N'8013872800', N'8013873725', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4401 Harrison Boulevard', N'Ogden', N'UT', N'49057', N'84403', 41.183358, -111.949203, 3425, 277, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5683, N'Ogden Regional Medical Center', 1, NULL, NULL, N'460005', NULL, NULL, 0, 227, NULL, N'8014792111', N'8014792007', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5475 South 500 East', N'Ogden', N'UT', N'49057', N'84405', 41.223005, -111.973843, 3425, 277, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5684, N'Lds Hospital', 1, NULL, NULL, N'460006', NULL, NULL, 0, 213, NULL, N'8014081100', N'8014081665', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'8Th Avenue And C Street', N'Salt Lake City', N'UT', N'49035', N'84143', 40.767013, -111.890431, 3432, 279, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5685, N'Valley View Medical Center', 1, NULL, NULL, N'460007', NULL, NULL, 0, 42, NULL, N'4358685800', N'4355865803', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1303 North Main Street', N'Cedar City', N'UT', N'49021', N'84721', 37.699696, -113.064012, 3412, 279, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5686, N'University Health Care/Univ Hospitals And  Clinics', 1, NULL, NULL, N'460009', NULL, NULL, 0, 425, NULL, N'8015812121', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'50 North Medical Drive', N'Salt Lake City', N'UT', N'49035', N'84132', 40.772592, -111.838627, 3432, 279, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5687, N'Intermountain Medical Center', 1, NULL, NULL, N'460010', NULL, NULL, 0, 520, NULL, N'8015077000', N'8015077995', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5121 South Cottonwood Street', N'Murray', N'UT', N'49035', N'84107', 40.666784, -111.888417, 3432, 279, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5688, N'Castleview Hospital', 1, NULL, NULL, N'460011', NULL, NULL, 0, 84, NULL, N'4356374800', N'4356379513', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'300 North Hospital Drive', N'Price', N'UT', N'49007', N'84501', 39.606186, -110.832465, 3428, 279, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5689, N'Mountain View Hospital', 1, NULL, NULL, N'460013', NULL, NULL, 0, 126, NULL, N'8014657100', N'8014657170', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1000 East 100 North', N'Payson', N'UT', N'49049', N'84651', 40.044835, -111.713951, 3427, 278, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5690, N'Mountain West Medical Center', 1, NULL, NULL, N'460014', NULL, NULL, 0, 44, NULL, N'4358433700', N'4358828770', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2055 North Main Street', N'Tooele', N'UT', N'49045', N'84074', 40.56194, -112.296405, 3432, 279, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5691, N'Logan Regional Hospital', 1, NULL, NULL, N'460015', NULL, NULL, 0, 148, NULL, N'4357161000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'500 East 1400 North', N'Logan', N'UT', N'49005', N'84341', 41.757336, -111.819219, 3418, 279, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5692, N'Brigham City Community Hospital', 1, NULL, NULL, N'460017', NULL, NULL, 0, 52, NULL, N'4357349471', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'950 South Medical Drive', N'Brigham City', N'UT', N'49003', N'84302', 41.489586, -112.025748, 3411, 277, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5693, N'Uintah Basin Medical Center', 1, NULL, NULL, N'460019', NULL, NULL, 0, 49, NULL, N'4357226163', N'4357229291', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'250 West 300 North (75-2)', N'Roosevelt', N'UT', N'49013', N'84066', 40.299403, -109.98876, 3431, 279, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5694, N'Dixie Regional Medical Center', 1, NULL, NULL, N'460021', NULL, NULL, 0, 245, NULL, N'4352512100', N'4352512115', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1380 East Medical Center Drive', N'St George', N'UT', N'49053', N'84790', 37.104153, -113.584131, 3433, 279, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5695, N'American Fork Hospital', 1, NULL, NULL, N'460023', NULL, NULL, 0, 76, NULL, N'8018553305', N'8018553548', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'170 North 1100 East', N'American Fork', N'UT', N'49049', N'84003', 40.402367, -111.769005, 3408, 278, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5696, N'Sevier Valley Medical Center', 1, NULL, NULL, N'460026', NULL, NULL, 0, 42, NULL, N'4358934100', N'4358930540', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1000 North Main Street', N'Richfield', N'UT', N'49041', N'84701', 38.782122, -112.084652, 3430, 279, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5697, N'Ashley Regional Medical Center', 1, NULL, NULL, N'460030', NULL, NULL, 0, 39, NULL, N'4357893342', N'4357891314', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'150 West 100 North', N'Vernal', N'UT', N'49047', N'84078', 40.457198, -109.531628, 3435, 279, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5698, N'Garfield Memorial Hospital', 1, NULL, NULL, N'460033', NULL, NULL, 0, 41, NULL, N'4356768811', N'4356761541', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'200 North 400 East', N'Panguitch', N'UT', N'49017', N'84759', 37.822755, -112.435764, 3426, 279, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5699, N'Beaver Valley Hospital', 1, NULL, NULL, N'460035', NULL, NULL, 0, 57, NULL, N'4354387102', N'4354387166', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1109 North 100 West', N'Beaver', N'UT', N'49001', N'84713', 37.825813, -112.437635, 3409, 278, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5700, N'Bear River Valley Hospital', 1, NULL, NULL, N'460039', NULL, NULL, 0, 16, NULL, N'4352074708', N'4352074715', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'905 North 1000 West', N'Tremonton', N'UT', N'49003', N'84337', 41.724529, -112.182865, 3434, 277, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5701, N'Davis Hospital And Medical Center', 1, NULL, NULL, N'460041', NULL, NULL, 0, 120, NULL, N'8018071000', N'8018077045', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1600 West Antelope Drive', N'Layton', N'UT', N'49011', N'84041', 41.089237, -111.994836, 3417, 277, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5702, N'Lakeview Hospital', 1, NULL, NULL, N'460042', NULL, NULL, 0, 117, NULL, N'8012992211', N'8012992534', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'630 East Medical Drive', N'Bountiful', N'UT', N'49011', N'84010', 40.889461, -111.880482, 3410, 279, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5703, N'Orem Community Hospital', 1, NULL, NULL, N'460043', NULL, NULL, 0, 20, NULL, N'8017143307', N'8012267831', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'331 North 400 West', N'Orem', N'UT', N'49049', N'84057', 40.303481, -111.705478, 3429, 278, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5704, N'Alta View Hospital', 1, NULL, NULL, N'460044', NULL, NULL, 0, 70, NULL, N'8015012600', N'8015014327', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'9660 South 1300 East', N'Sandy', N'UT', N'49035', N'84094', 40.577805, -111.85323, 3432, 279, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5705, N'St Marks Hospital', 1, NULL, NULL, N'460047', NULL, NULL, 0, 276, NULL, N'8012687700', N'8012703489', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1200 East 3900 South', N'Salt Lake City', N'UT', N'49035', N'84124', 40.767013, -111.890431, 3432, 279, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5706, N'The Orthopedic Specialty Hospital', 1, NULL, NULL, N'460049', NULL, NULL, 0, 14, NULL, N'8013144100', N'8013144149', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5848 South 300 East', N'Murray', N'UT', N'49035', N'84107', 40.63384, -111.882217, 3432, 279, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5707, N'Jordan Valley Medical Center', 1, NULL, NULL, N'460051', NULL, NULL, 0, 322, NULL, N'8015618888', N'8015698723', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3580 West 9000 South', N'West Jordan', N'UT', N'49035', N'84088', 40.587914, -111.976434, 3432, 279, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5708, N'Timpanogos Regional Hospital', 1, NULL, NULL, N'460052', NULL, NULL, 0, 122, NULL, N'8017146800', N'8017146597', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'750 West 800 North', N'Orem', N'UT', N'49049', N'84057', 40.312105, -111.714591, 3429, 278, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5709, N'Cache Valley  Hospital', 1, NULL, NULL, N'460054', NULL, NULL, 0, 22, NULL, N'4357139580', N'4357139589', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2380 North 400 East', N'North Logan', N'UT', N'49005', N'84341', 41.775971, -111.822937, 3418, 279, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5710, N'Park City Medical Center', 1, NULL, NULL, N'460057', NULL, NULL, 0, 30, NULL, N'4356586700', N'4356586739', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'900 Round Valley Drive', N'Park City', N'UT', N'49043', N'84060', 40.689154, -111.46842, 3432, 279, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5711, N'Riverton Hospital', 1, NULL, NULL, N'460058', NULL, NULL, 0, 48, NULL, N'8012854000', N'8012852025', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3741 West 12600 South', N'Riverton', N'UT', N'49035', N'84065', 40.522169, -111.980103, 3432, 279, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5712, N'Lone Peak Hospital', 1, NULL, NULL, N'460060', NULL, NULL, 0, 30, NULL, N'8015458000', N'8015458009', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'11925 S State Street', N'Draper', N'UT', N'49035', N'84020', 40.53444, -111.891355, 3432, 279, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5713, N'Delta Community Medical Center', 1, NULL, NULL, N'461300', NULL, NULL, 0, 20, NULL, N'4358645591', N'4358644186', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'126 South White Sage Avenue', N'Delta', N'UT', N'49027', N'84624', 39.352178, -112.57717, 3413, 278, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5714, N'Fillmore Community Medical Center', 1, NULL, NULL, N'461301', NULL, NULL, 0, 19, NULL, N'4357435591', N'4357436312', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'674 South Highway 99', N'Fillmore', N'UT', N'49027', N'84631', 38.968852, -112.323549, 3414, 278, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5715, N'Moab Regional Hospital', 1, NULL, NULL, N'461302', NULL, NULL, 0, 17, NULL, N'4357193501', N'4357193509', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'450 West Williams Way', N'Moab', N'UT', N'49019', N'84532', 38.575036, -109.559249, 3420, 279, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5716, N'Sanpete Valley Hospital - Cah', 1, NULL, NULL, N'461303', NULL, NULL, 0, 18, NULL, N'4354624123', N'4354624637', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1100 South Medical Drive', N'Mount Pleasant', N'UT', N'49039', N'84647', 39.532188, -111.46129, 3423, 278, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5717, N'Central Valley Medical Center - Cah', 1, NULL, NULL, N'461304', NULL, NULL, 0, 25, NULL, N'4356233000', N'4356233290', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'48 West 1500 North', N'Nephi', N'UT', N'49023', N'84648', 39.730677, -111.837823, 3424, 278, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5718, N'Milford Valley Memorial Hospital', 1, NULL, NULL, N'461305', NULL, NULL, 0, 23, NULL, N'4353872411', N'4354386380', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'850 North Main Street', N'Milford', N'UT', N'49001', N'84751', 38.399997, -113.010153, 3419, 279, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5719, N'Gunnison Valley Hospital', 1, NULL, NULL, N'461306', NULL, NULL, 0, 25, NULL, N'4355287246', N'4355282197', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'64 East 100 North', N'Gunnison', N'UT', N'49039', N'84634', 39.156477, -111.809728, 3415, 278, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5720, N'Heber Valley Medical Center', 1, NULL, NULL, N'461307', NULL, NULL, 0, 19, NULL, N'4356542500', N'4356542576', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1485 South Highway 40', N'Heber City', N'UT', N'49051', N'84032', 40.506526, -111.413309, 3429, 278, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5721, N'San Juan Hospital', 1, NULL, NULL, N'461308', NULL, NULL, 0, 25, NULL, N'4355872116', N'4355873004', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'380 West 100 North', N'Monticello', N'UT', N'49037', N'84535', 37.874143, -109.346765, 3421, 279, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5722, N'Kane County Hospital', 1, NULL, NULL, N'461309', NULL, NULL, 0, 25, NULL, N'4356445811', N'4356443588', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'355 North Main Street', N'Kanab', N'UT', N'49025', N'84741', 37.049857, -112.528579, 3416, 279, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5723, N'Blue Mountain Hospital', 1, NULL, NULL, N'461310', NULL, NULL, 0, 11, NULL, N'4356783993', N'4356783992', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'802 South 200 West', N'Blanding', N'UT', N'49037', N'84511', 37.619702, -109.481586, 3421, 279, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5724, N'South Davis Community Hospital', 1, NULL, NULL, N'462003', NULL, NULL, 0, 39, NULL, N'8012952361', N'8012951398', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'401 South 400 East', N'Bountiful', N'UT', N'49011', N'84010', 40.885323, -111.872272, 3410, 279, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5725, N'Promise Hospital Of Salt Lake', 1, NULL, NULL, N'462004', NULL, NULL, 0, 32, NULL, N'8014087100', N'8014087113', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'8Th Avenue C Street', N'Salt Lake City', N'UT', N'49035', N'84143', 40.767013, -111.890431, 3432, 279, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5726, N'Utah Valley Specialty Hospital', 1, NULL, NULL, N'462005', NULL, NULL, 0, 40, NULL, N'8012268880', N'8012268890', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'306 West River Bend Lane', N'Provo', N'UT', N'49049', N'84604', 40.233844, -111.658534, 3429, 278, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5727, N'Landmark Hospital Of Salt Lake City Llc', 1, NULL, NULL, N'462006', NULL, NULL, 0, 38, NULL, N'8012685400', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4252 S Birkhill Blvd', N'Murray', N'UT', N'49035', N'84107', 40.666784, -111.888417, 3432, 279, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5728, N'Healthsouth Rehabilitation Hospital Of Utah', 1, NULL, NULL, N'463025', NULL, NULL, 0, 84, NULL, N'8015613400', N'8015656551', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'8074 South 1300 East', N'Sandy', N'UT', N'49035', N'84094', 40.604645, -111.853225, 3432, 279, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5729, N'Northern Utah Rehabilitation Hospital', 1, NULL, NULL, N'463027', NULL, NULL, 0, 40, NULL, N'8014755254', N'8014755259', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5825 Harrison Boulevard', N'South Ogden', N'UT', N'49057', N'84403', 41.191893, -111.971343, 3425, 277, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5730, N'Primary Childrens Hospital', 1, NULL, NULL, N'463301', NULL, NULL, 0, 232, NULL, N'8016626200', N'8016626202', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'100 North Mario Capecchi Drive', N'Salt Lake City', N'UT', N'49035', N'84113', 40.771332, -111.840354, 3432, 279, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5731, N'Shriners Hospitals For Children - S L C', 1, NULL, NULL, N'463302', NULL, NULL, 0, 45, NULL, N'8015363500', N'8015363782', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Fairfax Road At Virginia Street', N'Salt Lake City', N'UT', N'49035', N'84103', 40.767013, -111.890431, 3432, 279, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5732, N'Utah State Hospital', 1, NULL, NULL, N'464001', NULL, NULL, 0, 384, NULL, N'8013444200', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1300 East Center Street', N'Provo', N'UT', N'49057', N'84605', 40.233472, -111.635524, 3429, 278, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5733, N'University Of Utah Neuropsychiatric Institute', 1, NULL, NULL, N'464009', NULL, NULL, 0, 90, NULL, N'8015832500', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'501 Chipeta Way', N'Salt Lake City', N'UT', N'49035', N'84108', 40.758066, -111.823547, 3432, 279, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5734, N'Marian Center', 1, NULL, NULL, N'464012', NULL, NULL, 0, 12, NULL, N'8014686856', N'8014686850', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'451 East Bishop Federal Lane', N'Salt Lake City', N'UT', N'49035', N'84115', 40.727941, -111.877286, 3432, 279, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5735, N'Salt Lake Behavioral Health', 1, NULL, NULL, N'464013', NULL, NULL, 0, 118, NULL, N'8012646000', N'8012646062', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3802 South 700 East', N'Salt Lake City', N'UT', N'49035', N'84106', 40.725408, -111.871097, 3432, 279, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5736, N'Provo Canyon Behavioral Hospital', 1, NULL, NULL, N'464014', NULL, NULL, 0, 80, NULL, N'8018522273', N'8012272199', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1350 East 750 North', N'Orem', N'UT', N'49049', N'84097', 40.311167, -111.664224, 3429, 278, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5737, N'Highland Ridge Hospital', 1, NULL, NULL, N'464015', NULL, NULL, 0, 41, NULL, N'8015692153', N'8015679006', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'7309 South 180 West', N'Midvale', N'UT', N'49035', N'84047', 40.618602, -111.89652, 3432, 279, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5738, N'University Of Utah Hospital - Tc', 1, NULL, NULL, N'469810', NULL, NULL, 0, 0, NULL, N'8015812121', N'8015855280', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'50 North Medical Drive', N'Salt Lake City', N'UT', N'49035', N'84132', 40.772592, -111.838627, 3432, 279, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5739, N'Intermountain Medical Center', 1, NULL, NULL, N'469811', NULL, NULL, 0, 0, NULL, N'8015074060', N'8015074810', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'5121 South Cottonwood Street', N'Murray', N'UT', N'49035', N'84107', 40.666784, -111.888417, 3432, 279, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5740, N'Primary Childrens Medical Center', 1, NULL, NULL, N'469812', NULL, NULL, 0, 0, NULL, N'8016626513', N'8016626202', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'100 North Medical Drive', N'Salt Lake City', N'UT', N'49035', N'84113', 40.773184, -111.837128, 3432, 279, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5741, N'Central Vermont Medical Center', 1, NULL, NULL, N'470001', NULL, NULL, 0, 175, NULL, N'8023714100', N'8023714401', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Box 547', N'Barre', N'VT', N'50023', N'05641', 44.197006, -72.502049, 3437, 280, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5742, N'University Of Vermont Medical Center', 1, NULL, NULL, N'470003', NULL, NULL, 0, 615, NULL, N'8028470000', N'8028475252', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'111 Colchester Ave', N'Burlington', N'VT', N'50007', N'05401', 44.480616, -73.197268, 3439, 280, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5743, N'Rutland Regional Medical Center', 1, NULL, NULL, N'470005', NULL, NULL, 0, 301, NULL, N'8027757111', N'8027471620', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'160 Allen St', N'Rutland', N'VT', N'50021', N'05701', 43.597651, -72.962742, 3444, 280, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5744, N'Brattleboro Memorial Hospital', 1, NULL, NULL, N'470011', NULL, NULL, 0, 104, NULL, N'8022570341', N'8022578822', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'17 Belmont Ave', N'Brattleboro', N'VT', N'50025', N'05301', 42.842459, -72.566214, 3438, 175, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5745, N'Southwestern Vermont Medical Center', 1, NULL, NULL, N'470012', NULL, NULL, 0, 180, NULL, N'8024426361', N'8024428331', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'100 Hospital Drive', N'Bennington', N'VT', N'50003', N'05201', 42.873416, -73.206846, 3436, 185, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5746, N'Northwestern Medical Center Inc', 1, NULL, NULL, N'470024', NULL, NULL, 0, 70, NULL, N'8025245911', N'8025241238', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'133 Fairfield Street', N'Saint Albans', N'VT', N'50011', N'05478', 44.808728, -73.078329, 3446, 280, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5747, N'Grace Cottage Hospital', 1, NULL, NULL, N'471300', NULL, NULL, 0, 19, NULL, N'8023657920', N'8023657031', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Po Box 216', N'Townshend', N'VT', N'50025', N'05353', 43.047301, -72.667593, 3448, 175, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5748, N'Gifford Medical Center', 1, NULL, NULL, N'471301', NULL, NULL, 0, 25, NULL, N'8027284441', N'8027284245', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'44 South Main Street', N'Randolph', N'VT', N'50017', N'05060', 43.925065, -72.665938, 3443, 175, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5749, N'Mt Ascutney Hospital', 1, NULL, NULL, N'471302', NULL, NULL, 0, 25, NULL, N'8026746711', N'8026747155', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'289 County Road', N'Windsor', N'VT', N'50027', N'05089', 43.533894, -72.434794, 3449, 175, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5750, N'Northeastern Vermont Regional Hospital', 1, NULL, NULL, N'471303', NULL, NULL, 0, 25, NULL, N'8027487400', N'8027487398', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1315 Hospital Drive', N'Saint Johnsbury', N'VT', N'50005', N'05819', 44.445365, -72.009744, 3447, 175, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5751, N'North Country Hospital And Health Center', 1, NULL, NULL, N'471304', NULL, NULL, 0, 25, NULL, N'8023347331', N'8023343240', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'189 Prouty Drive', N'Newport', N'VT', N'50019', N'05855', 44.954282, -72.197841, 3442, 175, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5752, N'Copley Hospital', 1, NULL, NULL, N'471305', NULL, NULL, 0, 25, NULL, N'8028884231', N'8028888223', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'528 Washington Highway', N'Morrisville', N'VT', N'50015', N'05661', 44.554046, -72.590631, 3441, 280, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5753, N'Springfield Hospital', 1, NULL, NULL, N'471306', NULL, NULL, 0, 25, NULL, N'8028852151', N'8028853959', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Po Box 2003', N'Springfield', N'VT', N'50027', N'05156', 43.298408, -72.482312, 3445, 175, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5754, N'Porter Hospital Inc', 1, NULL, NULL, N'471307', NULL, NULL, 0, 25, NULL, N'8023884701', N'8023884799', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'115 Porter Drive', N'Middlebury', N'VT', N'50001', N'05753', 43.999474, -73.169506, 3440, 280, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5755, N'Brattleboro Retreat', 1, NULL, NULL, N'474001', NULL, NULL, 0, 149, NULL, N'8022577785', N'8022583791', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Anna Marsh Lane Po Box 803', N'Brattleboro', N'VT', N'50025', N'05301', 42.850915, -72.557868, 3438, 175, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5756, N'Vermont Psychiatric Care Hospital', 1, NULL, NULL, N'474004', NULL, NULL, 0, 25, NULL, N'8028886770', N'8028886799', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'350 Fisher Road', N'Berlin', N'VT', N'50023', N'05602', 44.222576, -72.566348, 3437, 280, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5757, N'University Of Vermont Medical  Center - Transplant', 1, NULL, NULL, N'479801', NULL, NULL, 0, 0, NULL, N'8028474771', N'8028473607', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'111 Colchester Avenue', N'Burlington', N'VT', N'50007', N'05401', 44.480616, -73.197268, 3439, 280, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5758, N'Gov Juan F Luis Hospital & Medical Ctr', 1, NULL, NULL, N'480002', NULL, NULL, 0, 160, NULL, N'3407786311', NULL, 1, 1, 0, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'#4007 Est Diamond Ruby Christiansted', N'St Croix', N'VA', NULL, N'00820', 45.567195, -67.425314, NULL, NULL, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5759, N'Norton Community Hospital', 1, NULL, NULL, N'490001', NULL, NULL, 0, 129, NULL, N'7036798865', N'2766799664', 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'100  15Th St Nw', N'Norton', N'VA', N'51720', N'24273', 36.932147, -82.642605, 3488, 251, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5760, N'Russell County Medical Center', 1, NULL, NULL, N'490002', NULL, NULL, 0, 78, NULL, N'2768838100', N'2768894336', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'58 Carroll Street', N'Lebanon', N'VA', N'51167', N'24266', 36.900908, -82.080126, 3476, 251, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5761, N'Sentara Rmh Medical Center', 1, NULL, NULL, N'490004', NULL, NULL, 0, 238, NULL, N'5406891000', N'5406891220', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2010 Health Campus Drive', N'Harrisonburg', N'VA', N'51660', N'22801', 38.406247, -78.858041, 3472, 282, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5762, N'Winchester Medical Center', 1, NULL, NULL, N'490005', NULL, NULL, 0, 399, NULL, N'5405368000', N'5405367847', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1840 Amherst St', N'Winchester', N'VA', N'51840', N'22601', 39.194575, -78.193111, 3511, 288, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5763, N'Sentara Norfolk General Hospital', 1, NULL, NULL, N'490007', NULL, NULL, 0, 525, NULL, N'7573883000', N'7573884319', 1, 1, 1, 0, 0, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'600 Gresham Dr', N'Norfolk', N'VA', N'51710', N'23507', 36.862513, -76.304431, 3487, 285, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5764, N'University Of Virginia Medical Center', 1, NULL, NULL, N'490009', NULL, NULL, 0, 622, NULL, N'8002513627', N'4349823759', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Jefferson Park Ave', N'Charlottesville', N'VA', N'51540', N'22908', 38.028106, -78.510718, 3456, 282, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5765, N'Bon Secours Depaul Medical Center', 1, NULL, NULL, N'490011', NULL, NULL, 0, 204, NULL, N'7578895000', N'7578895837', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'150 Kingsley Lane', N'Norfolk', N'VA', N'51710', N'23505', 36.898548, -76.280916, 3487, 285, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5766, N'Halifax Regional Hospital', 1, NULL, NULL, N'490013', NULL, NULL, 0, 192, NULL, N'4345173100', N'4345173626', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2204 Wilborn Avenue', N'Halifax', N'VA', N'51083', N'24558', 36.713765, -78.913576, 3501, 197, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5767, N'Bon Secours Maryview Medical Center', 1, NULL, NULL, N'490017', NULL, NULL, 0, 346, NULL, N'7573982200', N'7573982359', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3636 High Street', N'Portsmouth', N'VA', N'51740', N'23707', 36.836451, -76.348439, 3492, 285, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5768, N'Augusta Health', 1, NULL, NULL, N'490018', NULL, NULL, 0, 255, NULL, N'5409324000', N'5409324809', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'78 Medical Center Drive', N'Fishersville', N'VA', N'51015', N'22939', 38.093895, -78.985004, 3503, 282, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5769, N'Culpeper Regional Hospital', 1, NULL, NULL, N'490019', NULL, NULL, 0, 70, NULL, N'5408294100', N'5408294353', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'501 Sunset Lane', N'Culpeper', N'VA', N'51047', N'22701', 38.454922, -78.011449, 3459, 282, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5770, N'John Randolph Medical Center', 1, NULL, NULL, N'490020', NULL, NULL, 0, 147, NULL, N'8045411600', N'8044523346', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'411 West Randolph Road', N'Hopewell', N'VA', N'51670', N'23860', 37.30752, -77.292094, 3473, 286, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5771, N'Centra  Health Inc', 1, NULL, NULL, N'490021', NULL, NULL, 0, 161, NULL, N'4342004789', N'4342004706', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1920 Atherholt Road', N'Lynchburg', N'VA', N'51680', N'24501', 37.413416, -79.170038, 3481, 283, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5772, N'Mary Washington Hospital Inc', 1, NULL, NULL, N'490022', NULL, NULL, 0, 437, NULL, N'5407411100', N'5407411097', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1001 Sam Perry Boulevard', N'Fredericksburg', N'VA', N'51630', N'22401', 38.310759, -77.481223, 3466, 286, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5773, N'Fauquier Hospital', 1, NULL, NULL, N'490023', NULL, NULL, 0, 97, NULL, N'5403165000', N'5403165001', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'500 Hospital Drive', N'Warrenton', N'VA', N'51061', N'20186', 38.713188, -77.80926, 3509, 281, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5774, N'Carilion Roanoke Memorial Hospital', 1, NULL, NULL, N'490024', NULL, NULL, 0, 703, NULL, N'5409817000', N'5409817862', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1906 Belleview Avenue Se', N'Roanoke', N'VA', N'51770', N'24014', 37.270973, -79.941431, 3498, 287, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5775, N'Medical College Of Virginia Hospitals', 1, NULL, NULL, N'490032', NULL, NULL, 0, 779, NULL, N'8048280938', N'8048281657', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1250 East Marshall Street - Box 980510', N'Richmond', N'VA', N'51760', N'23298', 37.538509, -77.43428, 3497, 286, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5776, N'Warren Memorial Hospital', 1, NULL, NULL, N'490033', NULL, NULL, 0, 196, NULL, N'7036360300', N'5406360258', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1000 North Shenandoah Ave', N'Front Royal', N'VA', N'51187', N'22630', 38.937855, -78.199251, 3467, 288, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5777, N'Riverside Shore Memorial Hospital', 1, NULL, NULL, N'490037', NULL, NULL, 0, 143, NULL, N'7574148000', N'7574148566', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'9507 Hospital Avenue', N'Nassawadox', N'VA', N'51131', N'23413', 37.474044, -75.864579, 3485, 285, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5778, N'Smyth County Community Hospital', 1, NULL, NULL, N'490038', NULL, NULL, 0, 170, NULL, N'2763781000', N'2767821436', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'245 Medical Park Drive', N'Marion', N'VA', N'51173', N'24354', 36.834838, -81.514837, 3483, 251, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5779, N'Inova Alexandria Hospital', 1, NULL, NULL, N'490040', NULL, NULL, 0, 318, NULL, N'7035043167', N'7035043700', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4320 Seminary Rd', N'Alexandria', N'VA', N'51510', N'22304', 38.824141, -77.104852, 3451, 281, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5780, N'Mary Immaculate Hospital', 1, NULL, NULL, N'490041', NULL, NULL, 0, 110, NULL, N'7578866000', N'7578866751', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2 Bernardine Drive', N'Newport News', N'VA', N'51700', N'23602', 37.143141, -76.513117, 3486, 284, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5781, N'Carilion New River Valley Medical Center', 1, NULL, NULL, N'490042', NULL, NULL, 0, 146, NULL, N'5407312000', N'5407312505', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2900 Lamb Circle', N'Christiansburg', N'VA', N'51121', N'24073', 37.129852, -80.408939, 3455, 287, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5782, N'Inova Loudoun Hospital', 1, NULL, NULL, N'490043', NULL, NULL, 0, 183, NULL, N'7038586600', N'7038586610', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'44045 Riverside Parkway', N'Leesburg', N'VA', N'51107', N'20176', 39.11545, -77.564545, 3477, 281, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5783, N'Sentara Obici Hospital', 1, NULL, NULL, N'490044', NULL, NULL, 0, 168, NULL, N'7579344000', N'7579344284', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2800 Godwin Boulevard', N'Suffolk', N'VA', N'51800', N'23439', 36.775158, -76.582771, 3505, 285, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5784, N'Novant Health Prince William Medical Center', 1, NULL, NULL, N'490045', NULL, NULL, 0, 170, NULL, N'7033698000', N'7033698010', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'8700 Sudley Rd', N'Manassas', N'VA', N'51683', N'20110', 38.767186, -77.486911, 3482, 281, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5785, N'Sentara Leigh Hospital', 1, NULL, NULL, N'490046', NULL, NULL, 0, 250, NULL, N'7572616601', N'7574616796', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'830 Kempsville Road', N'Norfolk', N'VA', N'51710', N'23502', 36.848136, -76.190914, 3487, 285, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5786, N'Lewisgale Medical Center', 1, NULL, NULL, N'490048', NULL, NULL, 0, 506, NULL, N'5407764000', N'5407764785', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1900 Electric Road', N'Salem', N'VA', N'51775', N'24153', 37.265362, -80.033114, 3500, 287, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5787, N'Virginia Hospital Center', 1, NULL, NULL, N'490050', NULL, NULL, 0, 342, NULL, N'7035585000', N'7035586583', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1701 North George Mason Drive', N'Arlington', N'VA', N'51013', N'22205', 38.888487, -77.128357, 3452, 281, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5788, N'Riverside Regional Medical Center', 1, NULL, NULL, N'490052', NULL, NULL, 0, 510, NULL, N'7575942000', N'7575942084', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'500 J Clyde Morris Blvd', N'Newport News', N'VA', N'51700', N'23601', 37.064215, -76.483008, 3486, 284, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5789, N'Johnston Memorial Hospital', 1, NULL, NULL, N'490053', NULL, NULL, 0, 116, NULL, N'2762581000', N'2762582805', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'16000 Johnston Memorial Drive', N'Abingdon', N'VA', N'51191', N'24211', 36.709579, -81.977488, 3450, 251, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5790, N'Sentara Virginia Beach General Hospital', 1, NULL, NULL, N'490057', NULL, NULL, 0, 276, NULL, N'7573958000', N'7573956106', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1060 First Colonial Road', N'Virginia Beach', N'VA', N'51810', N'23454', 36.864567, -76.028411, 3508, 285, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5791, N'Bon Secours St Marys Hospital', 1, NULL, NULL, N'490059', NULL, NULL, 0, 391, NULL, N'8042852011', N'8042858327', 1, 0, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5801 Bremo Rd', N'Richmond', N'VA', N'51087', N'23226', 37.58491, -77.512584, 3497, 286, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5792, N'Clinch Valley Medical Center', 1, NULL, NULL, N'490060', NULL, NULL, 0, 175, NULL, N'2765966000', N'2765966009', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2949 West Front Street', N'Richlands', N'VA', N'51185', N'24641', 37.093169, -81.793727, 3496, 251, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5793, N'Inova Fairfax Hospital', 1, NULL, NULL, N'490063', NULL, NULL, 0, 833, NULL, N'7037763332', N'7037763623', 1, 0, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'8110 Gatehouse Road 400 West', N'Falls Church', N'VA', N'51059', N'22042', 38.882334, -77.171091, 3463, 281, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5794, N'Sentara Williamsburg Regional Medical Center', 1, NULL, NULL, N'490066', NULL, NULL, 0, 145, NULL, N'7579846000', N'7579848145', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'100 Sentara Circle', N'Williamsburg', N'VA', N'51095', N'23188', 37.270703, -76.70745, 3510, 284, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5795, N'Southside Regional Medical Center', 1, NULL, NULL, N'490067', NULL, NULL, 0, 300, NULL, N'8047655000', N'8047655948', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'200 Medical Park Boulevard', N'Petersburg', N'VA', N'51730', N'23805', 37.183155, -77.36227, 3491, 286, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5796, N'Bon Secours Memorial Regional Medical Center', 1, NULL, NULL, N'490069', NULL, NULL, 0, 225, NULL, N'8047646000', N'8047646420', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'8260 Atlee Road', N'Mechanicsville', N'VA', N'51085', N'23116', 37.6272, -77.388776, 3497, 286, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5797, N'Danville Regional Medical Center', 1, NULL, NULL, N'490075', NULL, NULL, 0, 250, NULL, N'4347992100', N'4347992260', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'142 South Main Street', N'Danville', N'VA', N'51590', N'24541', 36.578273, -79.404306, 3460, 197, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5798, N'Martha Jefferson Hospital', 1, NULL, NULL, N'490077', NULL, NULL, 0, 176, NULL, N'4346547000', N'4346547324', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'500 Martha Jefferson Drive', N'Charlottesville', N'VA', N'51003', N'22911', 38.024266, -78.442324, 3456, 282, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5799, N'Memorial Hospital Of Martinsville & Henry County', 1, NULL, NULL, N'490079', NULL, NULL, 0, 220, NULL, N'2766667200', N'2766667600', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'320 Hospital Drive', N'Martinsville', N'VA', N'51089', N'24115', 36.699432, -79.866151, 3484, 197, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5800, N'Riverside Tappahannock Hospital', 1, NULL, NULL, N'490084', NULL, NULL, 0, 67, NULL, N'8044436189', N'8044436150', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'618 Hospital Road', N'Tappahannock', N'VA', N'51057', N'22560', 37.925417, -76.859136, 3506, 286, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5801, N'Bedford Memorial Hospital', 1, NULL, NULL, N'490088', NULL, NULL, 0, 161, NULL, N'4342006366', N'4342004763', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1613 Oakwood Street', N'Bedford', N'VA', N'51515', N'24523', 37.352027, -79.516425, 3453, 283, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5802, N'Carilion Franklin Memorial Hospital', 1, NULL, NULL, N'490089', NULL, NULL, 0, 37, NULL, N'5404835277', N'5404836479', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'180 Floyd Avenue', N'Rocky Mount', N'VA', N'51067', N'24151', 36.995933, -79.892366, 3499, 287, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5803, N'Southside Community Hospital Inc', 1, NULL, NULL, N'490090', NULL, NULL, 0, 116, NULL, N'4343928811', N'4343927654', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'800 Oak Street', N'Farmville', N'VA', N'51147', N'23901', 37.302592, -78.401374, 3464, 286, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5804, N'Southampton Memorial Hospital', 1, NULL, NULL, N'490092', NULL, NULL, 0, 221, NULL, N'7575696100', N'7575696390', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'100 Fairview Drive - Po Box 817', N'Franklin', N'VA', N'51620', N'23851', 36.677651, -76.922461, 3465, 285, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5805, N'Sentara Careplex Hospital', 1, NULL, NULL, N'490093', NULL, NULL, 0, 224, NULL, N'7577361000', N'7577362659', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3000 Coliseum Drive', N'Hampton', N'VA', N'51650', N'23666', 37.0573, -76.389945, 3486, 284, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5806, N'Bon Secours Richmond Community Hospital', 1, NULL, NULL, N'490094', NULL, NULL, 0, 104, NULL, N'8042251700', N'8042251725', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1500 N. 28Th Street', N'Richmond', N'VA', N'51760', N'23223', 37.540407, -77.406234, 3497, 286, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5807, N'Southern Virginia Regional Medical Center', 1, NULL, NULL, N'490097', NULL, NULL, 0, 80, NULL, N'4343484400', N'4343484933', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'727 North Main Street', N'Emporia', N'VA', N'51595', N'23847', 36.702117, -77.53581, 3461, 286, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5808, N'Community Memorial Healthcenter Inc', 1, NULL, NULL, N'490098', NULL, NULL, 0, 260, NULL, N'4344473151', N'4347742401', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'125 Buena Vista Circle', N'South Hill', N'VA', N'51117', N'23970', 36.734266, -78.133436, 3502, 286, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5809, N'Inova Fair Oaks Hospital', 1, NULL, NULL, N'490101', NULL, NULL, 0, 182, NULL, N'7033914170', N'7033914116', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3600 Joseph Siewick Drive', N'Fairfax', N'VA', N'51059', N'22033', 38.887468, -77.379256, 3462, 281, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5810, N'Hiram W Davis Medical Center', 1, NULL, NULL, N'490104', NULL, NULL, 0, 10, NULL, N'8045247344', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'P O Box 4030', N'Petersburg', N'VA', N'51730', N'23803', 38.909278, -78.053331, 3491, 286, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5811, N'Reston Hospital Center', 1, NULL, NULL, N'490107', NULL, NULL, 0, 187, NULL, N'7036899000', N'7036890840', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1850 Town Center Parkway', N'Reston', N'VA', N'51059', N'20190', 38.962255, -77.362403, 3495, 281, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5812, N'Central Virginia Training Center', 1, NULL, NULL, N'490108', NULL, NULL, 0, 46, NULL, N'4349476000', NULL, 1, 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Po Box 1098', N'Lynchburg', N'VA', N'51680', N'24505', 37.413754, -79.142246, 3481, 283, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5813, N'Eastern State Hospital', 1, NULL, NULL, N'490109', NULL, NULL, 0, 5, NULL, N'7572535161', N'7572535065', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4601 Ironbound Road', N'Williamsburg', N'VA', N'51095', N'23188', 37.28945, -76.728003, 3510, 284, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5814, N'Lewisgale Hospital Montgomery', 1, NULL, NULL, N'490110', NULL, NULL, 0, 146, NULL, N'5409511111', N'5409535295', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3700 South Main Street', N'Blacksburg', N'VA', N'51121', N'24060', 37.192842, -80.403378, 3455, 287, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5815, N'Wythe County Community Hospital', 1, NULL, NULL, N'490111', NULL, NULL, 0, 100, NULL, N'2762280200', N'2762280397', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'600 West Ridge Road', N'Wytheville', N'VA', N'51197', N'24382', 36.953312, -81.095857, 3514, 287, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5816, N'Cjw Medical Center', 1, NULL, NULL, N'490112', NULL, NULL, 0, 758, NULL, N'8043302001', N'8043302313', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7101 Jahnke Road', N'Richmond', N'VA', N'51041', N'23235', 37.515995, -77.527321, 3497, 286, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5817, N'Sentara Northern Virginia Medical Center', 1, NULL, NULL, N'490113', NULL, NULL, 0, 183, NULL, N'7035231000', N'7036707643', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2300 Opitz Boulevard', N'Woodbridge', N'VA', N'51153', N'22191', 38.634742, -77.28378, 3512, 281, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5818, N'Wellmont Lonesome Pine Hospital', 1, NULL, NULL, N'490114', NULL, NULL, 0, 60, NULL, N'2765233111', N'2765238726', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1990 Holton Avenue East', N'Big Stone Gap', N'VA', N'51195', N'24219', 36.875979, -82.758243, 3454, 251, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5819, N'Twin County Regional Hospital', 1, NULL, NULL, N'490115', NULL, NULL, 0, 141, NULL, N'2762368181', N'2762361715', 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'200 Hospital Drive', N'Galax', N'VA', N'51640', N'24333', 36.671699, -80.923769, 3468, 203, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5820, N'Lewisgale Hospital Pulaski', 1, NULL, NULL, N'490116', NULL, NULL, 0, 147, NULL, N'5409948100', N'5409948333', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2400 Lee Highway', N'Pulaski', N'VA', N'51155', N'24301', 37.069003, -80.758267, 3493, 287, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5821, N'Carilion Tazewell Community Hospital', 1, NULL, NULL, N'490117', NULL, NULL, 0, 56, NULL, N'2769888700', N'2769886239', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'141 Ben Bolt Avenue', N'Tazewell', N'VA', N'51185', N'24651', 37.12557, -81.491591, 3507, 287, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5822, N'Henrico Doctors'' Hospital', 1, NULL, NULL, N'490118', NULL, NULL, 0, 340, NULL, N'8042894500', N'8042894801', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1602 Skipwith Road', N'Richmond', N'VA', N'51087', N'23229', 37.602086, -77.537818, 3497, 286, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5823, N'Sentara Princess Anne Hospital', 1, NULL, NULL, N'490119', NULL, NULL, 0, 160, NULL, N'7575071520', N'7577163954', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2025 Glenn Mitchell Drive', N'Virginia Beach', N'VA', N'51810', N'23456', 36.852984, -75.977418, 3508, 285, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5824, N'Chesapeake General Hospital', 1, NULL, NULL, N'490120', NULL, NULL, 0, 310, NULL, N'7573128121', N'7573126300', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'736 Battlefield Blvd North', N'Chesapeake', N'VA', N'51550', N'23320', 36.745865, -76.246345, 3457, 285, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5825, N'Inova Mount Vernon Hospital', 1, NULL, NULL, N'490122', NULL, NULL, 0, 237, NULL, N'7036647000', N'7036647235', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2501 Parkers Lane', N'Alexandria', N'VA', N'51059', N'22306', 38.80511, -77.047023, 3451, 281, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5826, N'Rappahannock General Hospital', 1, NULL, NULL, N'490123', NULL, NULL, 0, 76, NULL, N'8044358000', N'8044358543', 1, 1, 0, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'101 Harris Road', N'Kilmarnock', N'VA', N'51103', N'22482', 37.704185, -76.393003, 3475, 286, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5827, N'Lewisgale Hospital Alleghany', 1, NULL, NULL, N'490126', NULL, NULL, 0, 205, NULL, N'5408626011', N'5408626589', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'One Arh Lane - Po Box 7', N'Low Moor', N'VA', N'51005', N'24457', 37.788738, -79.883664, 3479, 287, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5828, N'Buchanan General Hospital', 1, NULL, NULL, N'490127', NULL, NULL, 0, 134, NULL, N'2769351000', N'2769354959', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1535 Slate Creek Road', N'Grundy', N'VA', N'51027', N'24614', 37.277889, -82.099022, 3470, 251, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5829, N'Capital Hospice', 1, NULL, NULL, N'490129', NULL, NULL, 0, 15, NULL, N'7035257070', N'7035254127', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4715 North 15 Street', N'Arlington', N'VA', N'51013', N'22205', 38.890396, -77.084158, 3452, 281, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5830, N'Riverside Walter Reed Hospital', 1, NULL, NULL, N'490130', NULL, NULL, 0, 67, NULL, N'8046938800', N'7576938812', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7519 Hospital Road', N'Gloucester', N'VA', N'51073', N'23061', 37.413752, -76.525506, 3469, 284, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5831, N'Catawba Hospital', 1, NULL, NULL, N'490135', NULL, NULL, 0, 270, NULL, N'7033754201', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Po Box 200', N'Catawba', N'VA', N'51161', N'24070', 36.922362, -78.95029, 3500, 287, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5832, N'Bon Secours St Francis Medical Center', 1, NULL, NULL, N'490136', NULL, NULL, 0, 130, NULL, N'8045947400', N'8045947410', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'13710 St Francis Boulevard', N'Midlothian', N'VA', N'51041', N'23114', 37.466641, -77.658919, 3497, 286, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5833, N'Stafford Hospital Llc', 1, NULL, NULL, N'490140', NULL, NULL, 0, 100, NULL, N'5407419000', N'5407411097', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'101 Hospital Center Boulevard Suite 307', N'Stafford', N'VA', N'51179', N'22554', 38.422069, -77.408316, 3466, 286, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5834, N'Spotsylvania Regional Medical Center', 1, NULL, NULL, N'490141', NULL, NULL, 0, 126, NULL, N'5404984000', N'5404984066', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4600 Spotsylvania Parkway', N'Fredericksburg', N'VA', N'51177', N'22408', 38.303184, -77.46054, 3466, 286, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5835, N'Riverside Doctors'' Hospital Of Williamsburg', 1, NULL, NULL, N'490143', NULL, NULL, 0, 40, NULL, N'7573453000', N'7573450138', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1500 Commonwealth Avenue', N'Williamsburg', N'VA', N'51095', N'23185', 37.251014, -76.668508, 3510, 284, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5836, N'Novant Health Haymarket Medical Center', 1, NULL, NULL, N'490144', NULL, NULL, 0, 60, NULL, N'5712841000', N'5712841009', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'15225 Healthcote Boulevard', N'Haymarket', N'VA', N'51153', N'20169', 38.812101, -77.636677, 3482, 281, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5837, N'Bath Community Hospital', 1, NULL, NULL, N'491300', NULL, NULL, 0, 25, NULL, N'5408397000', N'5408397060', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'106 Park Drive- Po Drawer Z', N'Hot Springs', N'VA', N'51017', N'24445', 37.99957, -79.831719, 3474, 282, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5838, N'Carilion Giles Community Hospital', 1, NULL, NULL, N'491302', NULL, NULL, 0, 25, NULL, N'5409216000', N'5409215606', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'159 Hartley Way', N'Pearisburg', N'VA', N'51071', N'24134', 37.326511, -80.735071, 3489, 287, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5839, N'Dickenson Community Hospital', 1, NULL, NULL, N'491303', NULL, NULL, 0, 25, NULL, N'2769260300', N'2769260329', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'312 Hospital Drive', N'Clintwood', N'VA', N'51051', N'24228', 37.150107, -82.455985, 3458, 251, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5840, N'Carilion Stonewall Jackson Hospital', 1, NULL, NULL, N'491304', NULL, NULL, 0, 25, NULL, N'5404583503', N'5404583535', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1 Health Circle', N'Lexington', N'VA', N'51678', N'24450', 37.779357, -79.442707, 3478, 287, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5841, N'Shenandoah Memorial Hospital', 1, NULL, NULL, N'491305', NULL, NULL, 0, 25, NULL, N'5404591100', N'5404591121', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'759 South Main Street', N'Woodstock', N'VA', N'51171', N'22664', 38.871392, -78.51398, 3513, 288, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5842, N'Pioneer Health Services Of Patrick County Inc', 1, NULL, NULL, N'491306', NULL, NULL, 0, 25, NULL, N'2766943151', N'2766948655', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'18688 Jeb Stuart Highway', N'Stuart', N'VA', N'51141', N'24171', 36.646334, -80.282242, 3504, 203, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5843, N'Page Memorial Hospital Inc', 1, NULL, NULL, N'491307', NULL, NULL, 0, 25, NULL, N'5407434561', N'5407433812', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'200 Memorial Drive', N'Luray', N'VA', N'51139', N'22835', 38.662284, -78.468665, 3480, 288, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5844, N'Lynn House Of Potomac Valley', 1, NULL, NULL, N'491991', NULL, NULL, 0, 16, NULL, N'7033796000', N'7036718897', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'4400 West Braddock Road', N'Alexandria', N'VA', N'51510', N'22304', 38.829724, -77.104779, 3451, 281, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5845, N'Lake Taylor Transitional Care Hospital', 1, NULL, NULL, N'492001', NULL, NULL, 0, 296, NULL, N'7574615001', N'7574614282', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1309 Kempsville Road', N'Norfolk', N'VA', N'51710', N'23502', 36.869002, -76.204528, 3487, 285, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5846, N'Hospital For Extended Recovery', 1, NULL, NULL, N'492007', NULL, NULL, 0, 35, NULL, N'7573881700', N'7573881371', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'600 Gresham Drive Suite 700', N'Norfolk', N'VA', N'51710', N'23507', 36.846509, -76.291643, 3487, 285, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5847, N'Hampton Roads Specialty Hospital', 1, NULL, NULL, N'492008', NULL, NULL, 0, 25, NULL, N'7575345000', N'7579288271', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'245 Chesapeake Avenue', N'Newport News', N'VA', N'51700', N'23607', 36.986201, -76.392833, 3486, 284, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5848, N'Vibra Hospital Of Richmond', 1, NULL, NULL, N'492009', NULL, NULL, 0, 60, NULL, N'8046787000', N'8042541972', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2220 Edward Holland Drive', N'Richmond', N'VA', N'51087', N'23230', 37.58955, -77.490113, 3497, 286, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5849, N'Centra Specialty Hospital', 1, NULL, NULL, N'492010', NULL, NULL, 0, 36, NULL, N'4342001960', N'4342001980', 1, 1, 1, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3300 Rivermont Avenue  Krise Building 5Th Floor', N'Lynchburg', N'VA', N'51680', N'24503', 37.413754, -79.142246, 3481, 283, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5850, N'Uva Health Sciences Center', 1, NULL, NULL, N'492011', NULL, NULL, 0, 10, NULL, N'4349247897', N'4349242078', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2965 Ivy Road', N'Charlottesville', N'VA', N'51540', N'22908', 38.040664, -78.508174, 3456, 282, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5851, N'Sheltering Arms Hospital', 1, NULL, NULL, N'493025', NULL, NULL, 0, 40, NULL, N'8043424320', N'8043424316', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'8254 Atlee Road', N'Mechanicsville', N'VA', N'51085', N'23116', 37.62752, -77.388659, 3497, 286, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5852, N'Riverside Rehabilitation Institute', 1, NULL, NULL, N'493027', NULL, NULL, 0, 50, NULL, N'7579288100', N'7579288108', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'245 Chesapeake Avenue', N'Newport News', N'VA', N'51700', N'23607', 36.986201, -76.392833, 3486, 284, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5853, N'Healthsouth Rehabilitation Hospital Of Virginia', 1, NULL, NULL, N'493028', NULL, NULL, 0, 40, NULL, N'8042885700', N'8042886713', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5700 Fitzhugh Avenue', N'Richmond', N'VA', N'51087', N'23226', 37.592255, -77.518827, 3497, 286, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5854, N'University Of Virginia - Healthsouth Llc', 1, NULL, NULL, N'493029', NULL, NULL, 0, 50, NULL, N'4342442000', N'4342442001', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'515 Ray C Hunt Drive', N'Charlottesville', N'VA', N'51540', N'22903', 39.536162, -84.853012, 3456, 282, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5855, N'Sheltering Arms Hospital South', 1, NULL, NULL, N'493030', NULL, NULL, 0, 28, NULL, N'8043424320', N'8043424316', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'13700 Saint Francis Blvd Suite 400', N'Midlothian', N'VA', N'51041', N'23114', 37.505982, -77.649158, 3497, 286, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5856, N'Healthsouth Rehabilitation Hospital Of Petersburg', 1, NULL, NULL, N'493031', NULL, NULL, 0, 64, NULL, N'8045048100', N'8045048101', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'95 Medical Park Blvd', N'Petersburg', N'VA', N'51730', N'23805', 37.183411, -77.361925, 3491, 286, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5857, N'Healthsouth Rehabilitation Hospital Of Fredericks', 1, NULL, NULL, N'493032', NULL, NULL, 0, 52, NULL, N'5403687300', N'5403687596', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'300 Park Hill Drive', N'Fredericksburg', N'VA', N'51630', N'22401', 38.313126, -77.486456, 3466, 286, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5858, N'Healthsouth Rehabilitation Hospital Of Northern Va', 1, NULL, NULL, N'493033', NULL, NULL, 0, 55, NULL, N'7039572000', N'7039572394', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'24430 Millstream Drive', N'Aldie', N'VA', N'51107', N'20105', 38.975806, -77.64284, 3477, 281, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5859, N'The Rehabilitation Hospital Of Southwest Va', 1, NULL, NULL, N'493034', NULL, NULL, 0, 25, NULL, N'2766427900', N'2766428094', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'103 North Street', N'Bristol', N'VA', N'51520', N'24201', 36.596516, -82.216868, 3118, 251, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5860, N'Cumberland Hospital Llc', 1, NULL, NULL, N'493300', NULL, NULL, 0, 94, NULL, N'8049662242', N'8049665639', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'9407 Cumberland Road', N'New Kent', N'VA', N'51127', N'23124', 37.536952, -76.979492, 3497, 286, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5861, N'Childrens Hospital Of The Kings Daughters Inc', 1, NULL, NULL, N'493301', NULL, NULL, 0, 206, NULL, N'7576687000', N'7576689450', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'601 Children''s Lane', N'Norfolk', N'VA', N'51710', N'23507', 36.862277, -76.301967, 3487, 285, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5862, N'Children''s Hosp Of Richmond Of The Vcu Health Sys', 1, NULL, NULL, N'493302', NULL, NULL, 0, 60, NULL, N'8043217474', N'8043212728', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2924 Brook Road', N'Richmond', N'VA', N'51760', N'23220', 37.570712, -77.449336, 3497, 286, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5863, N'Riverside Behaviorial Health Center', 1, NULL, NULL, N'494001', NULL, NULL, 0, 125, NULL, N'7578271001', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2244 Executive Drive', N'Hampton', N'VA', N'51650', N'23666', 37.053608, -76.398481, 3486, 284, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5864, N'Northern Virginia Mental Health Insti', 1, NULL, NULL, N'494010', NULL, NULL, 0, 129, NULL, N'7032077100', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3302 Gallows Rd', N'Falls Church', N'VA', N'51059', N'22042', 38.882334, -77.171091, 3463, 281, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5865, N'Southern Virginia Mental Health Institute', 1, NULL, NULL, N'494017', NULL, NULL, 0, 96, NULL, N'4347996220', N'4347734274', 1, 1, 1, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'382 Taylor Drive', N'Danville', N'VA', N'51590', N'24541', 36.555728, -79.410547, 3460, 197, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5866, N'Western State Hospital', 1, NULL, NULL, N'494021', NULL, NULL, 0, 246, NULL, N'5403328000', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1301 Richmond Road', N'Staunton', N'VA', N'51790', N'24402', 38.14935, -79.071646, 3503, 282, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5867, N'Poplar Springs Hospital', 1, NULL, NULL, N'494022', NULL, NULL, 0, 130, NULL, N'8047336874', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'350 Poplar Drive  Po Box 3060', N'Petersburg', N'VA', N'51730', N'23805', 38.909278, -78.053331, 3491, 286, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5868, N'Dominion Hospital', 1, NULL, NULL, N'494023', NULL, NULL, 0, 100, NULL, N'7035362000', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2960 Sleepy Hollow Road', N'Falls Church', N'VA', N'51059', N'22044', 38.882334, -77.171091, 3452, 281, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5869, N'Virginia Beach Psychiatric Center', 1, NULL, NULL, N'494025', NULL, NULL, 0, 100, NULL, N'7574966000', NULL, 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1100 First Colonial Road', N'Virginia Beach', N'VA', N'51810', N'23454', 36.865786, -76.028975, 3508, 285, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5870, N'Southwestern Virginia Mental Health Institute', 1, NULL, NULL, N'494029', NULL, NULL, 0, 109, NULL, N'2767831200', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'340 Bagley Circle', N'Marion', N'VA', N'51173', N'24354', 36.833734, -81.512147, 3483, 251, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5871, N'Eastern State Hospital', 1, NULL, NULL, N'494030', NULL, NULL, 0, 302, NULL, N'7572535241', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4601 Ironbound Road', N'Williamsburg', N'VA', N'51830', N'23187', 37.28945, -76.728003, 3510, 284, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5872, N'The Pavilion At Williamsburg Place', 1, NULL, NULL, N'494032', NULL, NULL, 0, 57, NULL, N'7579416400', N'7579416419', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5483 Mooretown Road', N'Williamsburg', N'VA', N'51095', N'23188', 37.270703, -76.70745, 3510, 284, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5873, N'Inova Fairfax Hospital', 1, NULL, NULL, N'499801', NULL, NULL, 0, 0, NULL, N'7039702600', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'3300 Gallows Road', N'Falls Church', N'VA', N'51059', N'22042', 38.882334, -77.171091, 3463, 281, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5874, N'University Of Virginia Health System', 1, NULL, NULL, N'499802', NULL, NULL, 0, 0, NULL, N'4342439308', N'4342439328', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'1215 Less Street Po Box 800265', N'Charlottesville', N'VA', N'51540', N'22908', 39.536162, -84.853012, 3456, 282, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5875, N'Henrico Doctors Hospital - Transplant', 1, NULL, NULL, N'499804', NULL, NULL, 0, 0, NULL, N'8042894800', N'8042894801', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'1602 Skipwith Road', N'Richmond', N'VA', N'51087', N'23229', 37.602086, -77.537818, 3497, 286, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5876, N'Medical College Of Virginia', 1, NULL, NULL, N'499805', NULL, NULL, 0, 0, NULL, N'8046282430', N'8048289371', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'1200 E Broad Street Po Box 980510', N'Richmond', N'VA', N'51760', N'23298', 37.538509, -77.43428, 3497, 286, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5877, N'Northwest Hospital', 1, NULL, NULL, N'500001', NULL, NULL, 0, 194, NULL, N'2063681700', N'2063681949', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1550 North 115Th Street', N'Seattle', N'WA', N'53033', N'98133', 47.714129, -122.337146, 3561, 291, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5878, N'Providence St Mary Medical Center', 1, NULL, NULL, N'500002', NULL, NULL, 0, 146, NULL, N'5095225900', N'5095225789', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'401 W Poplar St', N'Walla Walla', N'WA', N'53071', N'99362', 46.062404, -118.34424, 3570, 292, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5879, N'Skagit Valley Hospital', 1, NULL, NULL, N'500003', NULL, NULL, 0, 234, NULL, N'3604244111', N'3604282459', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1415 Kincaid Street', N'Mount Vernon', N'WA', N'53057', N'98274', 48.419999, -122.326114, 3547, 289, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5880, N'Virginia Mason Medical Center', 1, NULL, NULL, N'500005', NULL, NULL, 0, 336, NULL, N'2062236867', N'2062237540', 1, 1, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'925 Seneca St', N'Seattle', N'WA', N'53033', N'98101', 47.609952, -122.327199, 3561, 291, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5881, N'Island Hospital', 1, NULL, NULL, N'500007', NULL, NULL, 0, 43, NULL, N'3602991300', N'3602991339', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1211  24Th Street', N'Anacortes', N'WA', N'53057', N'98221', 48.502822, -122.615646, 3516, 289, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5882, N'University Of Washington Medical Ctr', 1, NULL, NULL, N'500008', NULL, NULL, 0, 450, NULL, N'2065983300', N'2065986364', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1959 Ne Pacific St  Box 356151', N'Seattle', N'WA', N'53033', N'98195', 47.603832, -122.330062, 3561, 291, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5883, N'Highline Medical Center', 1, NULL, NULL, N'500011', NULL, NULL, 0, 279, NULL, N'2062449970', N'2062465385', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'16251 Sylvester Road Sw', N'Burien', N'WA', N'53033', N'98166', 47.456692, -122.341619, 3561, 291, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5884, N'Yakima Regional Medical And Cardiac Center', 1, NULL, NULL, N'500012', NULL, NULL, 0, 125, NULL, N'5095755102', N'5094546193', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'110 South Ninth Ave', N'Yakima', N'WA', N'53077', N'98902', 46.596449, -120.55318, 3573, 294, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5885, N'Providence Regional Medical Center Everett', 1, NULL, NULL, N'500014', NULL, NULL, 0, 268, NULL, N'4252612000', N'4252614051', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1321 Colby Avenue', N'Everett', N'WA', N'53061', N'98201', 48.000022, -122.20797, 3535, 289, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5886, N'Multicare Auburn Medical Center', 1, NULL, NULL, N'500015', NULL, NULL, 0, 195, NULL, N'2538337711', N'2539392376', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'202 North Division Street Plaza One', N'Auburn', N'WA', N'53033', N'98001', 47.307537, -122.230181, 3518, 291, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5887, N'Central Washington Hospital', 1, NULL, NULL, N'500016', NULL, NULL, 0, 198, NULL, N'5096621511', N'5096656017', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1201 South Miller Street', N'Wenatchee', N'WA', N'53007', N'98807', 47.407835, -120.324436, 3571, 292, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5888, N'Providence Centralia Hospital', 1, NULL, NULL, N'500019', NULL, NULL, 0, 191, NULL, N'3607362803', N'3603308614', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'914 S Scheuber Road', N'Centralia', N'WA', N'53041', N'98531', 46.720449, -122.96143, 3523, 290, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5889, N'St Clare Hospital', 1, NULL, NULL, N'500021', NULL, NULL, 0, 105, NULL, N'2535881711', N'2535122833', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'11315 Bridgeport Way S W', N'Lakewood', N'WA', N'53053', N'98499', 47.171409, -122.5164, 3566, 293, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5890, N'Providence St Peter Hospital', 1, NULL, NULL, N'500024', NULL, NULL, 0, 340, NULL, N'3604919480', N'3604934277', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'413 Lilly Road Ne', N'Olympia', N'WA', N'53067', N'98506', 47.052786, -122.844547, 3548, 290, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5891, N'Swedish Medical Center / Cherry Hill', 1, NULL, NULL, N'500025', NULL, NULL, 0, 376, NULL, N'2063202000', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'500 17Th Avenue', N'Seattle', N'WA', N'53033', N'98122', 47.60785, -122.310937, 3561, 291, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5892, N'Swedish Edmonds Hospital', 1, NULL, NULL, N'500026', NULL, NULL, 0, 217, NULL, N'4256404000', N'4256404010', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'21601 76Th Avenue West', N'Edmonds', N'WA', N'53061', N'98026', 47.787753, -122.335446, 3532, 291, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5893, N'Swedish Medical Center', 1, NULL, NULL, N'500027', NULL, NULL, 0, 697, NULL, N'2063866000', N'2063862479', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'747 Broadway', N'Seattle', N'WA', N'53033', N'98122', 47.60868, -122.322662, 3561, 291, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5894, N'Peacehealth St Joseph Medical Center', 1, NULL, NULL, N'500030', NULL, NULL, 0, 253, NULL, N'3607345400', N'3607386393', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2901 Squalicum Parkway', N'Bellingham', N'WA', N'53073', N'98225', 48.772309, -122.474631, 3520, 291, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5895, N'Grays Harbor Community Hospital', 1, NULL, NULL, N'500031', NULL, NULL, 0, 70, NULL, N'3605328330', N'5098431234', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'915 Anderson Drive', N'Aberdeen', N'WA', N'53027', N'98520', 46.979468, -123.847213, 3515, 291, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5896, N'Samaritan Hospital', 1, NULL, NULL, N'500033', NULL, NULL, 0, 50, NULL, N'5097655606', N'5097656507', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'801 East Wheeler Road', N'Moses Lake', N'WA', N'53025', N'98837', 47.131013, -119.264538, 3546, 292, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5897, N'Yakima Valley Memorial Hospital', 1, NULL, NULL, N'500036', NULL, NULL, 0, 218, NULL, N'5095758000', N'5095745800', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2811 Tieton Drive', N'Yakima', N'WA', N'53077', N'98902', 46.592782, -120.546358, 3573, 294, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5898, N'Toppenish Community Hospital', 1, NULL, NULL, N'500037', NULL, NULL, 0, 63, NULL, N'5098651520', N'5098651519', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'502 W Fourth Ave', N'Toppenish', N'WA', N'53077', N'98948', 46.377351, -120.308667, 3568, 294, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5899, N'Harrison Memorial Hospital', 1, NULL, NULL, N'500039', NULL, NULL, 0, 297, NULL, N'3603773911', N'3607926515', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2520 Cherry Avenue', N'Bremerton', N'WA', N'53035', N'98310', 47.582718, -122.625116, 3521, 291, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5900, N'Peachealth St John Medical Center', 1, NULL, NULL, N'500041', NULL, NULL, 0, 368, NULL, N'3604142000', N'3604147550', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1615 Delaware Street', N'Longview', N'WA', N'53015', N'98632', 46.130951, -122.941418, 3543, 224, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5901, N'Deaconess Hospital', 1, NULL, NULL, N'500044', NULL, NULL, 0, 388, NULL, N'5094735800', N'5094737286', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'W 800 Fifth Avenue', N'Spokane', N'WA', N'53063', N'99210', 47.65886, -117.424713, 3564, 292, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5902, N'Walla Walla General Hospital', 1, NULL, NULL, N'500049', NULL, NULL, 0, 72, NULL, N'5095250480', N'5095278258', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1025 S Second Ave', N'Walla Walla', N'WA', N'53071', N'99362', 46.065, -118.330278, 3570, 292, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5903, N'Peacehealth Southwest Medical Center', 1, NULL, NULL, N'500050', NULL, NULL, 0, 275, NULL, N'3602562000', N'3605142006', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'400 Ne Mother Joseph Place', N'Vancouver', N'WA', N'53011', N'98668', 45.623949, -122.58012, 3569, 224, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5904, N'Overlake Hospital Medical Center', 1, NULL, NULL, N'500051', NULL, NULL, 0, 218, NULL, N'4256885000', NULL, 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1035-116Th Ave Ne', N'Bellevue', N'WA', N'53033', N'98004', 47.620556, -122.185762, 3519, 291, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5905, N'Group Health Central Hospital', 1, NULL, NULL, N'500052', NULL, NULL, 0, 346, NULL, N'2063263000', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'201 - 16Th Avenue East', N'Seattle', N'WA', N'53033', N'98112', 47.62009, -122.312045, 3561, 291, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5906, N'Kennewick General Hospital', 1, NULL, NULL, N'500053', NULL, NULL, 0, 71, NULL, N'5095866111', N'5095865892', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'900 South Auburn Street', N'Kennewick', N'WA', N'53005', N'99336', 46.199224, -119.118643, 3541, 292, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5907, N'Providence Sacred Heart Medical Center', 1, NULL, NULL, N'500054', NULL, NULL, 0, 615, NULL, N'5094743040', N'5094744925', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'101 West 8Th Avenue', N'Spokane', N'WA', N'53063', N'99204', 47.648409, -117.460421, 3564, 292, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5908, N'Kadlec Regional Medical Center', 1, NULL, NULL, N'500058', NULL, NULL, 0, 141, NULL, N'5099464611', N'5099422679', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'888 Swift Blvd', N'Richland', N'WA', N'53005', N'99352', 46.281157, -119.282258, 3559, 292, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5909, N'Cascade Valley Hospital', 1, NULL, NULL, N'500060', NULL, NULL, 0, 48, NULL, N'3604352133', N'3604350513', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'330 S Stillaguamish Ave', N'Arlington', N'WA', N'53061', N'98223', 48.189961, -122.11756, 3517, 289, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5910, N'Harborview Medical Center', 1, NULL, NULL, N'500064', NULL, NULL, 0, 413, NULL, N'2067313000', N'2067318551', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'325 9Th Avenue', N'Seattle', N'WA', N'53033', N'98104', 47.603968, -122.323953, 3561, 291, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5911, N'Olympic Medical Center', 1, NULL, NULL, N'500072', NULL, NULL, 0, 126, NULL, N'3604177000', N'3604527391', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'939 Caroline St', N'Port Angeles', N'WA', N'53009', N'98362', 48.117127, -123.420232, 3552, 291, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5912, N'Providence Holy Family Hospital', 1, NULL, NULL, N'500077', NULL, NULL, 0, 272, NULL, N'5094822450', N'5094822456', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5633 North Lidgerwood', N'Spokane', N'WA', N'53063', N'99208', 47.65886, -117.424713, 3564, 292, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5913, N'Multicare Good Samaritan Hospital', 1, NULL, NULL, N'500079', NULL, NULL, 0, 225, NULL, N'2536972102', N'2536975174', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'401 15Th Avenue Se', N'Puyallup', N'WA', N'53053', N'98372', 47.177484, -122.288821, 3556, 293, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5914, N'Valley General Hospital', 1, NULL, NULL, N'500084', NULL, NULL, 0, 72, NULL, N'3607947497', N'3607941486', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'14701 179Th Se', N'Monroe', N'WA', N'53061', N'98272', 47.856027, -121.970615, 3544, 289, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5915, N'Valley Medical Center', 1, NULL, NULL, N'500088', NULL, NULL, 0, 303, NULL, N'4252283450', N'4256564202', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'400 S 43Rd St', N'Renton', N'WA', N'53033', N'98055', 47.441204, -122.214224, 3557, 291, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5916, N'St Joseph Medical Center', 1, NULL, NULL, N'500108', NULL, NULL, 0, 340, NULL, N'2536274101', N'2534266880', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1717 South J Street', N'Tacoma', N'WA', N'53053', N'98405', 47.245737, -122.448706, 3566, 293, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5917, N'Valley Hospital', 1, NULL, NULL, N'500119', NULL, NULL, 0, 123, NULL, N'5099246650', N'5094737286', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'12606 East Mission Avenue', N'Spokane', N'WA', N'53063', N'99216', 47.67155, -117.235121, 3564, 292, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5918, N'Evergreen Hospital Medical Center', 1, NULL, NULL, N'500124', NULL, NULL, 0, 227, NULL, N'4258991000', N'4258992624', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'12040 Ne 128Th Street', N'Kirkland', N'WA', N'53033', N'98034', 47.715548, -122.179736, 3542, 291, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5919, N'Tacoma General Allenmore Hospital', 1, NULL, NULL, N'500129', NULL, NULL, 0, 521, NULL, N'2534031000', N'2534031366', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'315 S Mlk Jr Way', N'Tacoma', N'WA', N'53053', N'98415', 47.24958, -122.439875, 3566, 293, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5920, N'Seattle Cancer Care Alliance', 1, NULL, NULL, N'500138', NULL, NULL, 0, 20, NULL, N'2066675000', N'2062881025', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'825 Eastlake Avenue East', N'Seattle', N'WA', N'53033', N'98109', 47.626482, -122.329606, 3561, 291, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5921, N'Capital Medical Center', 1, NULL, NULL, N'500139', NULL, NULL, 0, 110, NULL, N'3607545858', N'3609562574', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3900 Capital Mall Dr Sw', N'Olympia', N'WA', N'53067', N'98502', 47.04502, -122.894872, 3548, 290, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5922, N'St Francis Community Hospital', 1, NULL, NULL, N'500141', NULL, NULL, 0, 110, NULL, N'2539448100', N'2539447988', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'34515 9Th Avenue South', N'Federal Way', N'WA', N'53033', N'98003', 47.295186, -122.32196, 3536, 291, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5923, N'Confluence Health- Wenatchee Valley Hosp & Clinics', 1, NULL, NULL, N'500148', NULL, NULL, 0, 20, NULL, N'5096638711', N'5096647178', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'820 North Chelan Avenue', N'Wenatchee', N'WA', N'53007', N'98801', 47.432399, -120.321153, 3571, 292, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5924, N'Legacy Salmon Creek Medical Center', 1, NULL, NULL, N'500150', NULL, NULL, 0, 165, NULL, N'3604871000', N'3604873459', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2211 Ne 139Th Street', N'Vancouver', N'WA', N'53011', N'98686', 45.630695, -122.674456, 3569, 224, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5925, N'St Anthony Hospital', 1, NULL, NULL, N'500151', NULL, NULL, 0, 80, NULL, N'2535302050', N'2535302068', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'11567 Canterwood Boulevard Nw', N'Gig Harbor', N'WA', N'53053', N'98332', 47.32597, -122.587866, 3566, 293, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5926, N'Swedish Issaquah', 1, NULL, NULL, N'500152', NULL, NULL, 0, 120, NULL, N'4253134000', N'4253862277', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'751 Ne Blakely Dr', N'Issaquah', N'WA', N'53033', N'98029', 47.534878, -122.043297, 3519, 291, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5927, N'Garfield County Memorial Hospital', 1, NULL, NULL, N'501301', NULL, NULL, 0, 25, NULL, N'5098431591', N'5098431234', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'66 North Sixth Street', N'Pomeroy', N'WA', N'53023', N'99347', 42.551089, -94.683869, 1044, 292, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5928, N'Dayton General Hospital', 1, NULL, NULL, N'501302', NULL, NULL, 0, 25, NULL, N'5093822531', N'5093823209', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1012 South 3Rd Street', N'Dayton', N'WA', N'53013', N'99328', 46.312518, -117.968965, 3531, 292, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5929, N'Willapa Harbor Hospital', 1, NULL, NULL, N'501303', NULL, NULL, 0, 25, NULL, N'3608755526', N'3608756336', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'800 Alder Street', N'South Bend', N'WA', N'53049', N'98586', 46.663796, -123.813111, 3563, 290, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5930, N'Summit Pacific Medical Center-Swing Bed Unit', 1, NULL, NULL, N'501304', NULL, NULL, 0, 24, NULL, N'3603462222', N'3603462160', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'600 East Main Street', N'Elma', N'WA', N'53027', N'98541', 47.006452, -123.391342, 3548, 290, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5931, N'Lincoln Hospital', 1, NULL, NULL, N'501305', NULL, NULL, 0, 25, NULL, N'5097257101', N'5097252112', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'10 Nichols Street', N'Davenport', N'WA', N'53043', N'99122', 47.657311, -118.146252, 3530, 292, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5932, N'Odessa Memorial Healthcare Center', 1, NULL, NULL, N'501307', NULL, NULL, 0, 25, NULL, N'5099822611', N'5099822616', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'502 E Amende Drive', N'Odessa', N'WA', N'53043', N'99159', 47.333202, -118.690827, 3564, 292, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5933, N'Coulee Community Hospital', 1, NULL, NULL, N'501308', NULL, NULL, 0, 48, NULL, N'5096331753', N'5096330951', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'411 Fortuyn Road', N'Grand Coulee', N'WA', N'53025', N'99133', 47.942293, -119.005582, 3539, 292, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5934, N'Providence St Joseph Hospital', 1, NULL, NULL, N'501309', NULL, NULL, 0, 65, NULL, N'5099358211', N'5099355257', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'500 East Webster', N'Chewelah', N'WA', N'53065', N'99109', 48.278188, -117.713555, 3525, 292, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5935, N'Newport Community Hospital', 1, NULL, NULL, N'501310', NULL, NULL, 0, 25, NULL, N'5094472441', N'5094475527', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'714 West Pine Street', N'Newport', N'WA', N'53051', N'99156', 48.179628, -117.043258, 3564, 292, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5936, N'East Adams Rural Hospital', 1, NULL, NULL, N'501311', NULL, NULL, 0, 20, NULL, N'5096591200', N'5096591252', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'903 South Adams', N'Ritzville', N'WA', N'53001', N'99169', 47.127372, -118.379975, 3560, 292, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5937, N'Prosser Memorial Hospital', 1, NULL, NULL, N'501312', NULL, NULL, 0, 25, NULL, N'5097862222', N'5097866683', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'723 Memorial Street', N'Prosser', N'WA', N'53005', N'99350', 46.208109, -119.764031, 3554, 294, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5938, N'Cascade Medical Center', 1, NULL, NULL, N'501313', NULL, NULL, 0, 12, NULL, N'5095485815', N'5095481411', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'817 Commercial Street', N'Leavenworth', N'WA', N'53007', N'98826', 47.594495, -120.661211, 3571, 292, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5939, N'Ocean Beach Hospital', 1, NULL, NULL, N'501314', NULL, NULL, 0, 15, NULL, N'3606423181', N'3606426309', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'174 First Avenue North', N'Ilwaco', N'WA', N'53049', N'98624', 46.309036, -124.043664, 3540, 224, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5940, N'Skyline Hospital', 1, NULL, NULL, N'501315', NULL, NULL, 0, 25, NULL, N'5094911101', N'5094934607', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'211 Skyline Drive', N'White Salmon', N'WA', N'53039', N'98672', 45.727619, -121.486462, 3572, 224, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5941, N'Klickitat Valley Hospital', 1, NULL, NULL, N'501316', NULL, NULL, 0, 25, NULL, N'5097734022', N'5097734714', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'310 South Roosevelt', N'Goldendale', N'WA', N'53039', N'98620', 45.813574, -120.812371, 3538, 224, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5942, N'Columbia Basin Hospital', 1, NULL, NULL, N'501317', NULL, NULL, 0, 28, NULL, N'5097544631', N'5097546356', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'200 Nat Washington Way', N'Ephrata', N'WA', N'53025', N'98823', 47.314269, -119.544744, 3571, 292, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5943, N'Othello Community Hospital', 1, NULL, NULL, N'501318', NULL, NULL, 0, 49, NULL, N'5094882636', N'5093312617', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'315 North 14Th Avenue', N'Othello', N'WA', N'53001', N'99344', 46.829559, -119.15447, 3550, 292, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5944, N'Morton General Hospital', 1, NULL, NULL, N'501319', NULL, NULL, 0, 31, NULL, N'3604965112', N'3604963537', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'521 Adams Street', N'Morton', N'WA', N'53041', N'98356', 39.909835, -75.323521, 3545, 290, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5945, N'Quincy Valley Hospital', 1, NULL, NULL, N'501320', NULL, NULL, 0, 29, NULL, N'5097873531', N'5097872016', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'908 10Th Avenue Southwest', N'Quincy', N'WA', N'53025', N'98848', 47.231108, -119.869063, 3571, 292, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5946, N'North Valley Hospital', 1, NULL, NULL, N'501321', NULL, NULL, 0, 85, NULL, N'5094862151', N'5094863119', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'203 South Western', N'Tonasket', N'WA', N'53047', N'98855', 48.705162, -119.438961, 3567, 292, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5947, N'Ferry County Memorial Hospital', 1, NULL, NULL, N'501322', NULL, NULL, 0, 25, NULL, N'5097753333', N'5097753866', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'36 Klondike Road', N'Republic', N'WA', N'53019', N'99166', 48.649783, -118.737205, 3558, 292, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5948, N'Jefferson Healthcare', 1, NULL, NULL, N'501323', NULL, NULL, 0, 25, NULL, N'3603852200', N'3603792242', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'834 Sheridan Street', N'Port Townsend', N'WA', N'53031', N'98368', 48.105935, -122.790192, 3553, 291, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5949, N'Three Rivers Hospital', 1, NULL, NULL, N'501324', NULL, NULL, 0, 43, NULL, N'5096892517', N'5096892086', 1, 1, 1, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'507 Hospital Way', N'Brewster', N'WA', N'53047', N'98812', 48.105514, -119.783837, 3522, 292, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5950, N'Forks Community Hospital', 1, NULL, NULL, N'501325', NULL, NULL, 0, 45, NULL, N'3603746271', N'3603745220', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'530 Bogachiel Way', N'Forks', N'WA', N'53009', N'98331', 47.948944, -124.387057, 3537, 291, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5951, N'Providence Mount Carmel Hospital', 1, NULL, NULL, N'501326', NULL, NULL, 0, 25, NULL, N'5096842561', N'5096852492', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'982 East Columbia', N'Colville', N'WA', N'53065', N'99114', 48.54657, -117.905537, 3528, 292, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5952, N'Whitman Hospital And Medical Center', 1, NULL, NULL, N'501327', NULL, NULL, 0, 25, NULL, N'5093973435', N'5093972563', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1200 West Fairview', N'Colfax', N'WA', N'53075', N'99111', 46.872225, -117.368012, 3527, 292, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5953, N'Mid Valley Hospital', 1, NULL, NULL, N'501328', NULL, NULL, 0, 25, NULL, N'5098261760', N'5098267379', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'810 Jasmine Street', N'Omak', N'WA', N'53047', N'98841', 48.396212, -119.545488, 3549, 292, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5954, N'Peacehealth United General Medical Center', 1, NULL, NULL, N'501329', NULL, NULL, 0, 30, NULL, N'3608566021', N'3608567204', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2000 Hospital Drive', N'Sedro Woolley', N'WA', N'53057', N'98284', 48.496015, -122.275115, 3547, 289, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5955, N'Sunnyside Community Hospital', 1, NULL, NULL, N'501330', NULL, NULL, 0, 25, NULL, N'5098371500', N'5098371740', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1016 Tacoma Avenue', N'Sunnyside', N'WA', N'53077', N'98944', 46.321823, -120.006235, 3565, 294, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5956, N'Pullman Regional Hospital', 1, NULL, NULL, N'501331', NULL, NULL, 0, 25, NULL, N'5093322541', N'5093324242', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'835 S Bishop Blvd', N'Pullman', N'WA', N'53075', N'99163', 46.731315, -117.164548, 3555, 292, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5957, N'Tri-State Memorial Hospital', 1, NULL, NULL, N'501332', NULL, NULL, 0, 25, NULL, N'5097585511', N'5097583566', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1221 Highland Avenue', N'Clarkston', N'WA', N'53003', N'99403', 46.403712, -117.054637, 3526, 292, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5958, N'Kittitas Valley Community Hospital', 1, NULL, NULL, N'501333', NULL, NULL, 0, 25, NULL, N'5099629841', N'5099258485', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'603 South Chestnut', N'Ellensburg', N'WA', N'53037', N'98926', 46.997064, -120.545122, 3533, 294, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5959, N'Lake Chelan Community Hospital', 1, NULL, NULL, N'501334', NULL, NULL, 0, 25, NULL, N'5096823300', N'5096823475', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'503 East Highland', N'Chelan', N'WA', N'53007', N'98816', 47.84097, -120.016459, 3524, 292, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5960, N'St Elizabeth Hospital', 1, NULL, NULL, N'501335', NULL, NULL, 0, 25, NULL, N'3608252505', N'3602724018', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1450 Battersby Avenue', N'Enumclaw', N'WA', N'53033', N'98022', 47.208351, -121.988159, 3534, 291, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5961, N'Mason General Hospital & Family Of Clinics', 1, NULL, NULL, N'501336', NULL, NULL, 0, 25, NULL, N'3604261611', N'3604271921', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'901 Mt View Drive', N'Shelton', N'WA', N'53045', N'98584', 47.215095, -123.100707, 3562, 290, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5962, N'Lourdes Medical Center', 1, NULL, NULL, N'501337', NULL, NULL, 0, 35, NULL, N'5095462278', N'5095462291', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'520 N Fourth Avenue', N'Pasco', N'WA', N'53021', N'99301', 46.239579, -119.100566, 3551, 292, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5963, N'Snoqualmie Valley Hospital', 1, NULL, NULL, N'501338', NULL, NULL, 0, 21, NULL, N'4258312300', N'4258311994', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'9575 Ethan Wade Way Se', N'Snoqualmie', N'WA', N'53033', N'98065', 47.533207, -121.843493, 3519, 291, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5964, N'Whidbey General Hospital', 1, NULL, NULL, N'501339', NULL, NULL, 0, 25, NULL, N'3606785151', N'3606780945', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'101 North Main Street', N'Coupeville', N'WA', N'53029', N'98239', 48.21819, -122.685807, 3529, 289, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5965, N'Peacehealth Peace Island Medical Center', 1, NULL, NULL, N'501340', NULL, NULL, 0, 10, NULL, N'3603782141', NULL, 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1117 Spring Street', N'Friday Harbor', N'WA', N'53055', N'98250', 48.535226, -123.015447, 3516, 289, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5966, N'Sunrise Haven', 1, NULL, NULL, N'501992', NULL, NULL, 0, 8, NULL, N'2538132096', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'Po Box 6057  24423 100Th Avenue South', N'Kent', N'WA', N'53033', N'98064', 47.38269, -122.227027, 3557, 291, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5967, N'Regional Hospital For Respiratory And Complex Care', 1, NULL, NULL, N'502001', NULL, NULL, 0, 40, NULL, N'2062484548', N'2064394688', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'16251 Sylvester Sw Road', N'Burien', N'WA', N'53033', N'98166', 47.469918, -122.348527, 3561, 291, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5968, N'Kindred Hospital-Seattle', 1, NULL, NULL, N'502002', NULL, NULL, 0, 80, NULL, N'2063642050', N'2063615722', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'10631 8Th Ave Ne', N'Seattle', N'WA', N'53033', N'98125', 47.706559, -122.321468, 3561, 291, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5969, N'St Lukes Rehabilitation Institute', 1, NULL, NULL, N'503025', NULL, NULL, 0, 102, NULL, N'5094736000', N'5094736978', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'711 South Cowley St', N'Spokane', N'WA', N'53063', N'99202', 47.649766, -117.408023, 3564, 292, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5970, N'Seattle Children''s Hospital', 1, NULL, NULL, N'503300', NULL, NULL, 0, 250, NULL, N'2069872000', N'2069873830', 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4800 Sand Point Way Ne Po Box C-5371', N'Seattle', N'WA', N'53033', N'98105', 47.603832, -122.330062, 3561, 291, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5971, N'Mary Bridge Children''s Hospital', 1, NULL, NULL, N'503301', NULL, NULL, 0, 68, NULL, N'2534031400', N'2534031930', 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'317 Martin Luther King Jr W Box 5299', N'Tacoma', N'WA', N'53053', N'98415', 47.24958, -122.439875, 3566, 293, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5972, N'Shriners Hospital For Children', 1, NULL, NULL, N'503302', NULL, NULL, 0, 30, NULL, N'5096230422', N'5096230474', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'911 West 5Th Avenue', N'Spokane', N'WA', N'53063', N'99204', 47.650955, -117.425653, 3564, 292, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5973, N'Bhc Fairfax Hospital', 1, NULL, NULL, N'504002', NULL, NULL, 0, 133, NULL, N'4258212000', N'4258219010', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'10200 Ne 132Nd Street', N'Kirkland', N'WA', N'53033', N'98034', 47.718987, -122.204291, 3542, 291, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5974, N'Western State Hospital', 1, NULL, NULL, N'504003', NULL, NULL, 0, 895, NULL, N'2537562350', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'9601 Steilacoom Blvd Sw', N'Tacoma', N'WA', N'53053', N'98498', 47.24958, -122.439875, 3566, 293, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5975, N'Eastern State Hospital', 1, NULL, NULL, N'504004', NULL, NULL, 0, 317, NULL, N'5092993121', N'5092997015', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'850 Maple Street - P O Box  A', N'Medical Lake', N'WA', N'53063', N'99022', 47.568504, -117.685763, 3564, 292, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5976, N'Lourdes Counseling Center', 1, NULL, NULL, N'504008', NULL, NULL, 0, 32, NULL, N'5099439104', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1175 Carondelet Drive', N'Richland', N'WA', N'53005', N'99352', 46.283486, -119.281664, 3559, 292, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5977, N'Navos', 1, NULL, NULL, N'504009', NULL, NULL, 0, 68, NULL, N'2069337299', N'2069337005', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2600 Southwest Holden', N'Seattle', N'WA', N'53033', N'98126', 47.603832, -122.330062, 3561, 291, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5978, N'Cascade Behavioral Hospital', 1, NULL, NULL, N'504011', NULL, NULL, 0, 63, NULL, N'2062440180', N'2062437002', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'12844 Military Road South', N'Tukwila', N'WA', N'53033', N'98168', 47.462736, -122.255916, 3561, 291, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5979, N'Virginia Mason Medical Center', 1, NULL, NULL, N'509800', NULL, NULL, 0, 0, NULL, N'2065836544', N'2063410886', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'1100 9Th Ave Mailstop C1-Tx', N'Seattle', N'WA', N'53033', N'98111', 47.603832, -122.330062, 3561, 291, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5980, N'Swedish Medical Center Transplant Services', 1, NULL, NULL, N'509801', NULL, NULL, 0, 0, NULL, N'2062153005', N'2062153101', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'1101 Madison St Suite 200', N'Seattle', N'WA', N'53033', N'98104', 47.603832, -122.330062, 3561, 291, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5981, N'University Of Washington Medical Center', 1, NULL, NULL, N'509802', NULL, NULL, 0, 0, NULL, N'2065986364', N'2065986292', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'1959 Ne Pacific Street', N'Seattle', N'WA', N'53033', N'98195', 47.649235, -122.308347, 3561, 291, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5982, N'Seattle Childrens Hospital - Transplant', 1, NULL, NULL, N'509803', NULL, NULL, 0, 0, NULL, N'2069875090', N'2069873925', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'4800 Sand Point Way Ne (Mail Stop Mb9-420)', N'Seattle', N'WA', N'53033', N'98105', 47.603832, -122.330062, 3561, 291, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5983, N'Providence Sacred Heart Medical Center', 1, NULL, NULL, N'509804', NULL, NULL, 0, 0, NULL, N'5094744500', N'5094744487', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'101 W Eighth Avenue', N'Spokane', N'WA', N'53063', N'99204', 47.65886, -117.424713, 3564, 292, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5984, N'West Virginia University Hospitals', 1, NULL, NULL, N'510001', NULL, NULL, 0, 531, NULL, N'3045984000', N'3045984124', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Medical Center Drive', N'Morgantown', N'WV', N'54061', N'26506', 39.651385, -79.959392, 3595, 297, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5985, N'Greenbrier Valley Medical Center', 1, NULL, NULL, N'510002', NULL, NULL, 0, 122, NULL, N'3046474411', NULL, 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'202 Maplewood Avenue  Po Box 497', N'Ronceverte', N'WV', N'54025', N'24970', 37.749754, -80.462839, 3607, 295, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5986, N'United Hospital Center', 1, NULL, NULL, N'510006', NULL, NULL, 0, 375, NULL, N'6813421000', N'6813421625', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'327 Medical Park Drive', N'Bridgeport', N'WV', N'54033', N'26330', 39.286479, -80.256198, 3579, 297, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5987, N'St Mary''s Medical Center', 1, NULL, NULL, N'510007', NULL, NULL, 0, 440, NULL, N'3045261234', N'3045261538', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2900 1St Avenue', N'Huntington', N'WV', N'54011', N'25702', 38.431874, -82.402246, 3587, 296, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5988, N'Berkeley Medical Center', 1, NULL, NULL, N'510008', NULL, NULL, 0, 241, NULL, N'3042641000', N'3042641255', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2500 Hospital Drive', N'Martinsburg', N'WV', N'54003', N'25401', 39.456076, -77.963771, 3593, 288, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5989, N'Pleasant Valley Hospital', 1, NULL, NULL, N'510012', NULL, NULL, 0, 201, NULL, N'3046754340', N'3046751328', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2520 Valley Drive', N'Point Pleasant', N'WV', N'54053', N'25550', 38.8687, -82.123809, 3601, 296, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5990, N'Reynolds Memorial Hospital', 1, NULL, NULL, N'510013', NULL, NULL, 0, 127, NULL, N'3048433230', N'3048433202', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'800 Wheeling Ave', N'Glen Dale', N'WV', N'54051', N'26038', 39.946564, -80.754142, 3583, 234, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5991, N'Charleston Area Medical Center', 1, NULL, NULL, N'510022', NULL, NULL, 0, 908, NULL, N'3043886203', N'3043883604', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'501 Morris Street', N'Charleston', N'WV', N'54039', N'25301', 38.347645, -81.625643, 3578, 295, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5992, N'Weirton Medical Center', 1, NULL, NULL, N'510023', NULL, NULL, 0, 238, NULL, N'3047976000', N'3047976176', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'601 Colliers Way', N'Weirton', N'WV', N'54029', N'26062', 40.403398, -80.524596, 3613, 234, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5993, N'Monongalia County General Hospital', 1, NULL, NULL, N'510024', NULL, NULL, 0, 189, NULL, N'3045981200', N'3045988382', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1200 Jd Anderson Dr', N'Morgantown', N'WV', N'54061', N'26505', 39.629526, -79.955897, 3595, 297, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5994, N'Thomas Memorial Hospital', 1, NULL, NULL, N'510029', NULL, NULL, 0, 266, NULL, N'3047663600', N'3047663477', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4605 Maccorkle Ave Sw', N'South Charleston', N'WV', N'54039', N'25309', 38.367305, -81.701655, 3609, 295, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5995, N'Davis Memorial Hospital', 1, NULL, NULL, N'510030', NULL, NULL, 0, 90, NULL, N'3046363300', N'3046373184', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Po Box 1484', N'Elkins', N'WV', N'54083', N'26241', 38.925882, -79.84665, 3580, 297, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5996, N'St Francis Hospital', 1, NULL, NULL, N'510031', NULL, NULL, 0, 155, NULL, N'3043476500', N'3043476885', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'333 Laidley St', N'Charleston', N'WV', N'54039', N'25301', 38.353187, -81.633198, 3578, 295, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5997, N'Stonewall Jackson Memorial Hospital', 1, NULL, NULL, N'510038', NULL, NULL, 0, 70, NULL, N'3042698080', N'3042698090', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'230 Hospital Plaza', N'Weston', N'WV', N'54041', N'26452', 39.048296, -80.492626, 3614, 295, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5998, N'Ohio Valley Medical Center', 1, NULL, NULL, N'510039', NULL, NULL, 0, 453, NULL, N'3042340123', N'3042341830', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2000 Eoff Street', N'Wheeling', N'WV', N'54069', N'26003', 40.059954, -80.721294, 3615, 234, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5999, N'Princeton Community Hospital', 1, NULL, NULL, N'510046', NULL, NULL, 0, 267, NULL, N'3044877260', N'3044872161', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'122 12Th Street', N'Princeton', N'WV', N'54055', N'24740', 37.366328, -81.102577, 3602, 287, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6000, N'Fairmont Regional Medical Center', 1, NULL, NULL, N'510047', NULL, NULL, 0, 252, NULL, N'3043677100', N'3043677167', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1325 Locust Avenue', N'Fairmont', N'WV', N'54049', N'26554', 39.482039, -80.160396, 3581, 297, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6001, N'Logan Regional Medical Center', 1, NULL, NULL, N'510048', NULL, NULL, 0, 140, NULL, N'3048311350', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'20 Hospital Drive', N'Logan', N'WV', N'54045', N'25601', 37.846157, -81.994033, 3590, 295, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6002, N'Wheeling Hospital', 1, NULL, NULL, N'510050', NULL, NULL, 0, 277, NULL, N'3042433000', N'3042433060', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1 Medical Park', N'Wheeling', N'WV', N'54069', N'26003', 40.066918, -80.695972, 3615, 234, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6003, N'Cabell Huntington Hospital Inc', 1, NULL, NULL, N'510055', NULL, NULL, 0, 322, NULL, N'3045262000', N'3045262008', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1340 Hal Greer Boulevard', N'Huntington', N'WV', N'54011', N'25701', 38.418278, -82.430566, 3587, 296, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6004, N'Camden Clark Medical Center', 1, NULL, NULL, N'510058', NULL, NULL, 0, 343, NULL, N'3044242111', N'3044242688', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'800 Garfield Ave', N'Parkersburg', N'WV', N'54107', N'26101', 39.270333, -81.560166, 3598, 295, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6005, N'Beckley Arh Hospital', 1, NULL, NULL, N'510062', NULL, NULL, 0, 173, NULL, N'3042553456', N'3042553544', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'306 Stanaford Road', N'Beckley', N'WV', N'54081', N'25801', 37.7968, -81.171789, 3574, 295, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6006, N'Raleigh General Hospital', 1, NULL, NULL, N'510070', NULL, NULL, 0, 300, NULL, N'3042564100', N'3042564009', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1710 Harper Road', N'Beckley', N'WV', N'54081', N'25801', 37.786211, -81.202988, 3574, 295, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6007, N'Bluefield Regional Medical Center', 1, NULL, NULL, N'510071', NULL, NULL, 0, 240, NULL, N'3043271100', N'3043271709', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'500 Cherry St', N'Bluefield', N'WV', N'54055', N'24701', 37.25465, -81.233787, 3576, 287, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6008, N'Wetzel County Hospital', 1, NULL, NULL, N'510072', NULL, NULL, 0, 68, NULL, N'3044558000', N'3044554259', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'#3 East Benjamin Drive', N'New Martinsville', N'WV', N'54103', N'26155', 39.680473, -80.857257, 3596, 234, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6009, N'Williamson Memorial Hospital', 1, NULL, NULL, N'510077', NULL, NULL, 0, 76, NULL, N'3042352500', N'3042350538', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'859 Alderson Street', N'Williamson', N'WV', N'54059', N'25661', 37.678041, -82.272167, 3616, 295, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6010, N'Summersville Regional Medical Center', 1, NULL, NULL, N'510082', NULL, NULL, 0, 105, NULL, N'3048722891', N'3048722080', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'400 Fairview Heights Road', N'Summersville', N'WV', N'54067', N'26651', 38.29214, -80.832228, 3611, 295, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6011, N'Welch Community Hospital', 1, NULL, NULL, N'510086', NULL, NULL, 0, 124, NULL, N'3044368461', N'3044366380', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'454 Mcdowell Street', N'Welch', N'WV', N'54047', N'24801', 37.432889, -81.584436, 3576, 287, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6012, N'Charleston Surgical Hospital', 1, NULL, NULL, N'510091', NULL, NULL, 0, 35, NULL, N'3043434371', N'3043530215', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1306 Kanawha Boulevard East', N'Charleston', N'WV', N'54039', N'25301', 38.343183, -81.630831, 3578, 295, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6013, N'Broaddus Hospital Association Inc', 1, NULL, NULL, N'511300', NULL, NULL, 0, 72, NULL, N'3044571760', N'3044573781', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Mansfield Hill P O Box 930', N'Philippi', N'WV', N'54001', N'26416', 39.15232, -80.040358, 3600, 297, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6014, N'Webster County Memorial Hospital', 1, NULL, NULL, N'511301', NULL, NULL, 0, 15, NULL, N'3048475682', N'3048477660', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'P O Box 312 (Miller Mountain Drive)', N'Webster Springs', N'WV', N'54101', N'26288', 38.479275, -80.413416, 3612, 295, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6015, N'Minnie Hamilton Health Care Center', 1, NULL, NULL, N'511303', NULL, NULL, 0, 43, NULL, N'3043549244', NULL, 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'186 Hospital Drive', N'Grantsville', N'WV', N'54013', N'26147', 38.92342, -81.095946, 3585, 295, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6016, N'Sistersville General Hospital', 1, NULL, NULL, N'511304', NULL, NULL, 0, 25, NULL, N'3046522611', N'3046521448', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'314 South Wells Street', N'Sistersville', N'WV', N'54095', N'26175', 39.558846, -81.003624, 3608, 295, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6017, N'Roane General Hospital', 1, NULL, NULL, N'511306', NULL, NULL, 0, 60, NULL, N'3049274444', N'3049275345', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'200 Hospital Drive', N'Spencer', N'WV', N'54087', N'25276', 38.802145, -81.350978, 3610, 295, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6018, N'Grafton City Hospital', 1, NULL, NULL, N'511307', NULL, NULL, 0, 102, NULL, N'3042650400', N'3042653926', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1 Hospital Plaza', N'Grafton', N'WV', N'54091', N'26354', 39.340925, -80.018966, 3584, 297, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6019, N'Braxton County Memorial Hospital', 1, NULL, NULL, N'511308', NULL, NULL, 0, 25, NULL, N'3043645156', N'3043644129', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'100 Hoylman Drive', N'Gassaway', N'WV', N'54007', N'26624', 38.673353, -80.774855, 3582, 295, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6020, N'War Memorial Hospital Inc', 1, NULL, NULL, N'511309', NULL, NULL, 0, 25, NULL, N'3042581234', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1 Healthy Way', N'Berkeley Springs', N'WV', N'54065', N'25411', 39.626872, -78.227747, 3575, 288, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6021, N'Summers County Arh Hospital', 1, NULL, NULL, N'511310', NULL, NULL, 0, 25, NULL, N'3044661000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Terrace Street   P O Box 940', N'Hinton', N'WV', N'54089', N'25951', 37.674008, -80.889254, 3586, 295, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6022, N'Hampshire Memorial Hospital', 1, NULL, NULL, N'511311', NULL, NULL, 0, 44, NULL, N'3048224561', N'3048227809', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'363 Sunrise Boulevard', N'Romney', N'WV', N'54027', N'26757', 39.341917, -78.756757, 3606, 288, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6023, N'Preston Memorial Hospital', 1, NULL, NULL, N'511312', NULL, NULL, 0, 25, NULL, N'3043291400', N'3043291175', 1, 1, 1, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'300 S Price Street', N'Kingwood', N'WV', N'54077', N'26537', 39.463485, -79.686963, 3589, 297, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6024, N'Boone Memorial Hospital', 1, NULL, NULL, N'511313', NULL, NULL, 0, 25, NULL, N'3043691230', N'3043691525', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'701 Madison Avenue', N'Madison', N'WV', N'54005', N'25130', 38.048269, -81.806198, 3578, 295, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6025, N'Pocahontas Memorial Hospital', 1, NULL, NULL, N'511314', NULL, NULL, 0, 25, NULL, N'3047997400', N'3047996636', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Rr Box 52 West', N'Buckeye', N'WV', N'54075', N'24924', 38.185953, -80.134512, 3592, 282, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6026, N'Potomac Valley Hospital', 1, NULL, NULL, N'511315', NULL, NULL, 0, 25, NULL, N'3045973500', N'3047880141', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'100 Pin Oak Lane', N'Keyser', N'WV', N'54057', N'26726', 39.440928, -78.973916, 1680, 52, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6027, N'Grant Memorial Hospital', 1, NULL, NULL, N'511316', NULL, NULL, 0, 45, NULL, N'3042571026', N'3042579776', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'P O Box 1019', N'Petersburg', N'WV', N'54023', N'26847', 38.992489, -79.123975, 3599, 288, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6028, N'Plateau Medical Center', 1, NULL, NULL, N'511317', NULL, NULL, 0, 25, NULL, N'3044698600', N'3044698605', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'430 Main Street', N'Oak Hill', N'WV', N'54019', N'25901', 37.976175, -81.140953, 3597, 295, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6029, N'Montgomery General Hospital Inc', 1, NULL, NULL, N'511318', NULL, NULL, 0, 69, NULL, N'3044425151', N'3044427494', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'401 Sixth Avenue Fayette County', N'Montgomery', N'WV', N'54019', N'25136', 38.180383, -81.328445, 3594, 295, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6030, N'Jefferson Medical Center', 1, NULL, NULL, N'511319', NULL, NULL, 0, 25, NULL, N'3047281600', NULL, 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'300 South Preston Street', N'Ranson', N'WV', N'54037', N'25438', 39.296646, -77.858788, 3603, 288, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6031, N'Jackson General Hospital', 1, NULL, NULL, N'511320', NULL, NULL, 0, 25, NULL, N'3043722731', N'3043722749', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'122 Pinnell St', N'Ripley', N'WV', N'54035', N'25271', 38.81864, -81.710323, 3605, 295, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6032, N'St Joseph Hospital', 1, NULL, NULL, N'511321', NULL, NULL, 0, 51, NULL, N'3044722000', NULL, 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1 Amalia Drive', N'Buckhannon', N'WV', N'54097', N'26201', 38.992242, -80.23588, 3577, 295, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6033, N'Select Specialty Hospital', 1, NULL, NULL, N'512002', NULL, NULL, 0, 32, NULL, N'3043886671', N'3043883604', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'333 Laidley Street', N'Charleston', N'WV', N'54039', N'25301', 38.353187, -81.633198, 3578, 295, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6034, N'Cornerstone Hospital Of Huntington', 1, NULL, NULL, N'512003', NULL, NULL, 0, 28, NULL, N'3043992600', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2900 First Avenue 2E', N'Huntington', N'WV', N'54011', N'25702', 38.41925, -82.445154, 3587, 296, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6035, N'Peterson Rehabilitation Hospital & Geriatric Cen', 1, NULL, NULL, N'513025', NULL, NULL, 0, 22, NULL, N'3042340500', N'3042340591', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Homestead Avenue', N'Wheeling', N'WV', N'54069', N'26003', 40.080511, -80.694173, 3615, 234, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6036, N'Healthsouth Southern Hills Regional Rehab', 1, NULL, NULL, N'513026', NULL, NULL, 0, 60, NULL, N'3044878000', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'120 12Th St', N'Princeton', N'WV', N'54055', N'24740', 37.366328, -81.102577, 3602, 287, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6037, N'Healthsouth Western Hills Regional Rehab Hospital', 1, NULL, NULL, N'513027', NULL, NULL, 0, 50, NULL, N'3044201300', N'3044201374', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'#3 Western Hills Drive', N'Parkersburg', N'WV', N'54107', N'26105', 39.266742, -81.561513, 3598, 295, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6038, N'Healthsouth Rehabilitation Hospital Of Huntington', 1, NULL, NULL, N'513028', NULL, NULL, 0, 62, NULL, N'3047331060', N'3047339284', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6900 West Country Club Drive', N'Huntington', N'WV', N'54011', N'25705', 38.41925, -82.445154, 3587, 296, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6039, N'Healthsouth Mountainview Regional Rehab Hospital', 1, NULL, NULL, N'513030', NULL, NULL, 0, 96, NULL, N'3045981100', N'3045981103', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1160 Van Voorhis Road', N'Morgantown', N'WV', N'54061', N'26504', 39.65739, -79.963218, 3595, 297, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6040, N'Highland Hospital', 1, NULL, NULL, N'514001', NULL, NULL, 0, 80, NULL, N'3049261600', N'3049261649', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1418A Maccorkle Avenue Sw', N'Charleston', N'WV', N'54039', N'25303', 38.358797, -81.658278, 3578, 295, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6041, N'River Park Hospital', 1, NULL, NULL, N'514008', NULL, NULL, 0, 165, NULL, N'3045269100', N'3045269140', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1230 Sixth Avenue', N'Huntington', N'WV', N'54011', N'25701', 38.41925, -82.445154, 3587, 296, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6042, N'Mildred Mitchell-Bateman Hospital', 1, NULL, NULL, N'514009', NULL, NULL, 0, 110, NULL, N'3045257801', N'3045257249', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1530 Norway Avenue', N'Huntington', N'WV', N'54099', N'25709', 38.401631, -82.387976, 3587, 296, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6043, N'William R Sharpe Jr Hospital', 1, NULL, NULL, N'514010', NULL, NULL, 0, 150, NULL, N'3042691210', N'3042696235', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'936 Sharpe Hospital Road', N'Weston', N'WV', N'54041', N'26452', 39.040927, -80.497336, 3614, 295, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6044, N'Highland-Clarksburg Hospital Inc', 1, NULL, NULL, N'514011', NULL, NULL, 0, 150, NULL, N'3046224951', N'3046224955', 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'3 Hospital Plaza', N'Clarksburg', N'WV', N'54033', N'26301', 39.280645, -80.344534, 3579, 297, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6045, N'Ministry St Michaels Hospital Of Stevens Point', 1, NULL, NULL, N'520002', NULL, NULL, 0, 181, NULL, N'7153465000', N'7153465088', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'900 Illinois Ave', N'Stevens Point', N'WI', N'55097', N'54481', 44.526908, -89.567079, 3700, 302, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6046, N'Mayo Clinic Hlth System  Franciscan Med Ctr', 1, NULL, NULL, N'520004', NULL, NULL, 0, 345, NULL, N'6087850940', N'6083929429', 1, 1, 0, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'700 West Avenue South', N'La Crosse', N'WI', N'55063', N'54601', 43.804509, -91.239603, 3657, 300, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6047, N'Waukesha Memorial Hospital', 1, NULL, NULL, N'520008', NULL, NULL, 0, 400, NULL, N'2629281000', N'2629287810', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'725 American Ave', N'Waukesha', N'WI', N'55133', N'53188', 43.011194, -88.242415, 3707, 303, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6048, N'St Elizabeth Hospital', 1, NULL, NULL, N'520009', NULL, NULL, 0, 332, NULL, N'9207382000', N'9208318916', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1506 S Oneida St', N'Appleton', N'WI', N'55087', N'54915', 44.248351, -88.402633, 3619, 298, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6049, N'Lakeview Medical Center', 1, NULL, NULL, N'520011', NULL, NULL, 0, 75, NULL, N'7152341515', N'7152366342', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1700 West Stout Street', N'Rice Lake', N'WI', N'55005', N'54868', 45.506828, -91.758086, 3690, 302, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6050, N'Sacred Heart Hospital', 1, NULL, NULL, N'520013', NULL, NULL, 0, 344, NULL, N'7157174121', N'7157176076', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'900 W Clairemont Ave', N'Eau Claire', N'WI', N'55035', N'54701', 44.793193, -91.508989, 3642, 152, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6051, N'St Josephs Hospital', 1, NULL, NULL, N'520017', NULL, NULL, 0, 217, NULL, N'7157177200', N'7157171694', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2661 County Hwy I', N'Chippewa Falls', N'WI', N'55017', N'54729', 44.951634, -91.36774, 3634, 302, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6052, N'Ministry Saint Marys Hospital', 1, NULL, NULL, N'520019', NULL, NULL, 0, 99, NULL, N'7153612000', N'7153614877', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2251 North Shore Dr', N'Rhinelander', N'WI', N'55085', N'54501', 45.636829, -89.379159, 3689, 305, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6053, N'United Hospital System', 1, NULL, NULL, N'520021', NULL, NULL, 0, 380, NULL, N'2626562011', N'2626535852', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6308 Eighth Ave', N'Kenosha', N'WI', N'55059', N'53143', 42.584677, -87.821226, 3655, 303, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6054, N'Columbia St Marys Hospital Ozaukee', 1, NULL, NULL, N'520027', NULL, NULL, 0, 118, NULL, N'2622437300', N'2622437329', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'13111 N Port Washington Rd', N'Mequon', N'WI', N'55089', N'53097', 43.25617, -87.924248, 3669, 303, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6055, N'The Monroe Clinic', 1, NULL, NULL, N'520028', NULL, NULL, 0, 100, NULL, N'6083241000', N'6083241114', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2005 5Th Street', N'Monroe', N'WI', N'55045', N'53566', 42.607478, -89.653488, 3670, 301, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6056, N'Aspirus Wausau Hospital', 1, NULL, NULL, N'520030', NULL, NULL, 0, 321, NULL, N'7158472121', N'7158472108', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'333 Pine Ridge Blvd', N'Wausau', N'WI', N'55073', N'54401', 44.965483, -89.670237, 3710, 305, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6057, N'Riverview Hospital Assoc', 1, NULL, NULL, N'520033', NULL, NULL, 0, 99, NULL, N'7154236060', N'7154217512', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'410 Dewey St', N'Wisconsin Rapids', N'WI', N'55141', N'54495', 44.382294, -89.830314, 3715, 302, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6058, N'Aurora Medical Ctr Manitowoc County', 1, NULL, NULL, N'520034', NULL, NULL, 0, 69, NULL, N'9207945000', N'9207945487', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5000 Memorial Drive', N'Two Rivers', N'WI', N'55071', N'54241', 44.125275, -87.617124, 3704, 299, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6059, N'Aurora Sheboygan Memorial Medical Ctr', 1, NULL, NULL, N'520035', NULL, NULL, 0, 185, NULL, N'9204515000', N'9204515333', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2629 N 7Th St', N'Sheboygan', N'WI', N'55117', N'53083', 43.77297, -87.711157, 3695, 303, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6060, N'Ministry Saint Josephs Hospital', 1, NULL, NULL, N'520037', NULL, NULL, 0, 504, NULL, N'7153877850', N'7153878601', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'611 St Joseph Ave', N'Marshfield', N'WI', N'55141', N'54449', 44.678265, -90.176497, 3663, 302, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6061, N'Aurora Medical Ctr Washington County', 1, NULL, NULL, N'520038', NULL, NULL, 0, 71, NULL, N'2626732300', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1032 E Sumner St', N'Hartford', N'WI', N'55131', N'53027', 43.317714, -88.362839, 3650, 303, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6062, N'Divine Savior Healthcare', 1, NULL, NULL, N'520041', NULL, NULL, 0, 73, NULL, N'6087424131', N'6087426098', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2817 New Pinery Road', N'Portage', N'WI', N'55021', N'53901', 43.567024, -89.466418, 3684, 301, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6063, N'St Nicholas Hospital', 1, NULL, NULL, N'520044', NULL, NULL, 0, 185, NULL, N'9204598300', N'9204528336', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3100 Superior Ave', N'Sheboygan', N'WI', N'55117', N'53081', 43.761208, -87.747312, 3695, 303, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6064, N'Theda Clark Medical Center', 1, NULL, NULL, N'520045', NULL, NULL, 0, 182, NULL, N'9207293100', N'9207293167', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'130 2Nd St', N'Neenah', N'WI', N'55139', N'54956', 44.192077, -88.453416, 3671, 304, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6065, N'Mercy Medical Center Of Oshkosh', 1, NULL, NULL, N'520048', NULL, NULL, 0, 157, NULL, N'9202232000', N'9202230508', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'500 S Oakwood Rd', N'Oshkosh', N'WI', N'55139', N'54904', 44.01393, -88.602947, 3678, 304, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6066, N'Bellin Memorial Hospital', 1, NULL, NULL, N'520049', NULL, NULL, 0, 242, NULL, N'9204333500', N'9204333707', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'744 S Webster Ave', N'Green Bay', N'WI', N'55009', N'54305', 44.50142, -88.011003, 3649, 299, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6067, N'Columbia St Marys Hospital Milwaukee', 1, NULL, NULL, N'520051', NULL, NULL, 0, 422, NULL, N'4142911210', N'4142911444', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2323 N Lake Dr', N'Milwaukee', N'WI', N'55079', N'53211', 43.062432, -87.878157, 3669, 303, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6068, N'St Clare Hospital', 1, NULL, NULL, N'520057', NULL, NULL, 0, 100, NULL, N'6083561400', N'6083561367', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'707 14Th St', N'Baraboo', N'WI', N'55111', N'53913', 43.480664, -89.729433, 3623, 301, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6069, N'Aurora Memorial Hospital Burlington', 1, NULL, NULL, N'520059', NULL, NULL, 0, 123, NULL, N'2627676000', N'2627676380', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'252 Mchenry St', N'Burlington', N'WI', N'55101', N'53105', 42.678073, -88.276203, 3632, 303, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6070, N'Oconomowoc Memorial Hospital', 1, NULL, NULL, N'520062', NULL, NULL, 0, 156, NULL, N'2625699400', N'2625690336', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'791 E Summit Ave', N'Oconomowoc', N'WI', N'55133', N'53066', 43.111673, -88.499266, 3675, 303, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6071, N'St Josephs Community Hospital Of West Bend', 1, NULL, NULL, N'520063', NULL, NULL, 0, 121, NULL, N'2623345533', N'2628367118', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3200 Pleasant Valley Road', N'West Bend', N'WI', N'55131', N'53095', 43.425278, -88.183428, 3712, 303, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6072, N'Mercy Health System Corp', 1, NULL, NULL, N'520066', NULL, NULL, 0, 240, NULL, N'6087566080', N'6087566168', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1000 Mineral Point Ave', N'Janesville', N'WI', N'55105', N'53548', 42.686808, -89.034227, 3654, 301, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6073, N'Mayo Clinic Health System Eau Claire Hospital', 1, NULL, NULL, N'520070', NULL, NULL, 0, 304, NULL, N'7158383311', NULL, 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1221 Whipple St', N'Eau Claire', N'WI', N'55035', N'54703', 44.812122, -91.513357, 3642, 152, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6074, N'Fort Memorial Hospital', 1, NULL, NULL, N'520071', NULL, NULL, 0, 82, NULL, N'9205685000', N'9205685412', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'611 Sherman Ave E', N'Fort Atkinson', N'WI', N'55055', N'53538', 42.930072, -88.827294, 3646, 301, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6075, N'St Vincent Hospital', 1, NULL, NULL, N'520075', NULL, NULL, 0, 523, NULL, N'9204330111', N'9204313215', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'835 S Van Buren St', N'Green Bay', N'WI', N'55009', N'54301', 44.501414, -88.012763, 3649, 299, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6076, N'Beaver Dam Community Hospital', 1, NULL, NULL, N'520076', NULL, NULL, 0, 125, NULL, N'9208877181', N'9208877973', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'707 S University Ave', N'Beaver Dam', N'WI', N'55027', N'53916', 43.449855, -88.828411, 3625, 301, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6077, N'Wheaton Franciscan Healthcare St Francis', 1, NULL, NULL, N'520078', NULL, NULL, 0, 270, NULL, N'4146475000', N'4146475565', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3237 S 16Th St', N'Milwaukee', N'WI', N'55079', N'53215', 43.008342, -87.933129, 3669, 303, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6078, N'St Marys Hospital', 1, NULL, NULL, N'520083', NULL, NULL, 0, 440, NULL, N'6082516100', N'6082586731', 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'700 South Park St', N'Madison', N'WI', N'55025', N'53715', 43.059762, -89.400858, 3660, 301, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6079, N'Gundersen Lutheran Medical Center', 1, NULL, NULL, N'520087', NULL, NULL, 0, 325, NULL, N'6087827300', NULL, 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1910 South Ave', N'La Crosse', N'WI', N'55063', N'54601', 43.794973, -91.246524, 3657, 300, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6080, N'St Agnes Hospital', 1, NULL, NULL, N'520088', NULL, NULL, 0, 151, NULL, N'9209292300', N'9209264866', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'430 E Divison St', N'Fond Du Lac', N'WI', N'55039', N'54935', 43.774876, -88.445803, 3645, 303, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6081, N'Meriter Hospital', 1, NULL, NULL, N'520089', NULL, NULL, 0, 448, NULL, N'6084176000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'202 S Park St', N'Madison', N'WI', N'55025', N'53715', 43.06529, -89.400868, 3660, 301, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6082, N'Howard Young Medical Ctr', 1, NULL, NULL, N'520091', NULL, NULL, 0, 109, NULL, N'7153568000', N'7153566097', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'240 Maple St', N'Woodruff', N'WI', N'55085', N'54568', 45.894119, -89.701536, 3716, 302, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6083, N'Sauk Prairie Hospital', 1, NULL, NULL, N'520095', NULL, NULL, 0, 36, NULL, N'6086433311', N'6086437680', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'260 26Th Street', N'Prairie Du Sac', N'WI', N'55111', N'53578', 43.286933, -89.724012, 3686, 301, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6084, N'Wheaton Franciscan Healthcare All Saints', 1, NULL, NULL, N'520096', NULL, NULL, 0, 553, NULL, N'2626874011', NULL, 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3801 Spring St', N'Racine', N'WI', N'55101', N'53405', 42.733403, -87.82535, 3687, 303, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6085, N'St Marys Hospital Medical Ctr', 1, NULL, NULL, N'520097', NULL, NULL, 0, 158, NULL, N'9204984200', N'9208845712', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1726 Shawano Ave', N'Green Bay', N'WI', N'55009', N'54303', 44.533891, -88.066432, 3649, 299, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6086, N'University Of Wi  Hospitals & Clinics Authority', 1, NULL, NULL, N'520098', NULL, NULL, 0, 536, NULL, N'6082638991', N'6082657248', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'600 Highland Avenue', N'Madison', N'WI', N'55025', N'53792', 43.076379, -89.432009, 3660, 301, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6087, N'Beloit Memorial Hospital', 1, NULL, NULL, N'520100', NULL, NULL, 0, 256, NULL, N'6083645011', N'6083645356', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1969 W Hart Rd', N'Beloit', N'WI', N'55105', N'53511', 42.508327, -89.031784, 3626, 301, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6088, N'Aurora Lakeland Medical Center', 1, NULL, NULL, N'520102', NULL, NULL, 0, 99, NULL, N'2627412000', N'2627412180', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'W3985 County Road Nn', N'Elkhorn', N'WI', N'55127', N'53121', 42.672793, -88.544545, 3644, 303, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6089, N'Community Memorial Hospital', 1, NULL, NULL, N'520103', NULL, NULL, 0, 237, NULL, N'2622511000', N'2622537169', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'W180 N8085 Town Hall Rd', N'Menomonee Falls', N'WI', N'55133', N'53051', 43.178932, -88.116715, 3666, 303, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6090, N'Holy Family Memorial', 1, NULL, NULL, N'520107', NULL, NULL, 0, 167, NULL, N'9203202011', N'9203205129', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2300 Western Ave', N'Manitowoc', N'WI', N'55071', N'54221', 44.095143, -87.6764, 3661, 299, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6091, N'Mile Bluff Medical Center', 1, NULL, NULL, N'520109', NULL, NULL, 0, 40, NULL, N'6088476161', N'6088473881', 1, 1, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1050 Division St', N'Mauston', N'WI', N'55057', N'53948', 43.784058, -90.074462, 3664, 301, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6092, N'Bay Area Medical Center', 1, NULL, NULL, N'520113', NULL, NULL, 0, 99, NULL, N'7157356621', N'7157358083', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3100 Shore Drive', N'Marinette', N'WI', N'55075', N'54143', 45.099959, -87.630726, 3662, 299, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6093, N'Uw Health Partners  Watertown Regional Med Ctr', 1, NULL, NULL, N'520116', NULL, NULL, 0, 95, NULL, N'9202614210', N'9202613940', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'125 Hospital Drive', N'Watertown', N'WI', N'55027', N'53098', 43.203786, -88.696619, 3706, 301, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6094, N'Wheaton Franciscan St Joseph', 1, NULL, NULL, N'520136', NULL, NULL, 0, 538, NULL, N'4144472000', NULL, 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5000 W Chambers St', N'Milwaukee', N'WI', N'55079', N'53210', 43.073542, -87.976262, 3669, 303, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6095, N'Aurora St Lukes Medical Center', 1, NULL, NULL, N'520138', NULL, NULL, 0, 1213, NULL, N'4146496000', NULL, 1, 1, 1, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2900 W Oklahoma Ave', N'Milwaukee', N'WI', N'55079', N'53215', 42.98862, -87.950865, 3669, 303, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6096, N'Aurora West Allis Medical Center', 1, NULL, NULL, N'520139', NULL, NULL, 0, 149, NULL, N'4143286000', N'4143288536', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'8901 W Lincoln Ave', N'West Allis', N'WI', N'55079', N'53227', 43.001221, -88.024377, 3711, 303, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6097, N'Appleton Medical Center', 1, NULL, NULL, N'520160', NULL, NULL, 0, 160, NULL, N'9207314101', NULL, 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1818 N Meade St', N'Appleton', N'WI', N'55087', N'54911', 44.278831, -88.393172, 3619, 298, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6098, N'Froedtert Memorial Lutheran Hospital', 1, NULL, NULL, N'520177', NULL, NULL, 0, 596, NULL, N'4148053000', N'4148058910', 1, 1, 1, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'9200 W Wisconsin Ave', N'Milwaukee', N'WI', N'55079', N'53226', 43.038695, -87.97189, 3669, 303, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6099, N'Aurora Medical Ctr Kenosha', 1, NULL, NULL, N'520189', NULL, NULL, 0, 74, NULL, N'2629485600', N'2629485828', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'10400 75Th St', N'Kenosha', N'WI', N'55059', N'53142', 42.566031, -87.84014, 3655, 303, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6100, N'Aurora Baycare Medical Ctr', 1, NULL, NULL, N'520193', NULL, NULL, 0, 132, NULL, N'9202888000', NULL, 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2845 Greenbrier Rd', N'Green Bay', N'WI', N'55009', N'54311', 44.529941, -88.024832, 3649, 299, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6101, N'Orthopaedic Hospital Of Wisconsin', 1, NULL, NULL, N'520194', NULL, NULL, 0, 25, NULL, N'4149616800', N'4149616778', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'475 W River Woods Pkwy', N'Glendale', N'WI', N'55079', N'53212', 43.135288, -87.935642, 3669, 303, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6102, N'Columbia Center', 1, NULL, NULL, N'520195', NULL, NULL, 0, 92, NULL, N'2622437408', N'2622436670', 1, 0, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'13125 N Port Washington Rd', N'Mequon', N'WI', N'55089', N'53097', 43.256422, -87.924253, 3669, 303, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6103, N'Oakleaf Surgical Hospital', 1, NULL, NULL, N'520196', NULL, NULL, 0, 13, NULL, N'7158318130', N'7158317894', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1000 Oakleaf Way', N'Altoona', N'WI', N'55035', N'54720', 44.815288, -91.451632, 3642, 152, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6104, N'Aurora Medical Ctr Oshkosh', 1, NULL, NULL, N'520198', NULL, NULL, 0, 84, NULL, N'9204566000', N'9204567601', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'855 N Westhaven Drive', N'Oshkosh', N'WI', N'55139', N'54904', 44.020692, -88.540857, 3678, 304, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6105, N'St Clares Hospital Of Weston', 1, NULL, NULL, N'520202', NULL, NULL, 0, 86, NULL, N'7153933000', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3400 Ministry Parkway', N'Weston', N'WI', N'55073', N'54476', 44.890445, -89.580301, 3710, 305, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6106, N'Wheaton Franciscan Healthcare Franklin', 1, NULL, NULL, N'520204', NULL, NULL, 0, 52, NULL, N'4143254500', N'4143254511', 1, 1, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'10101 South 27Th St', N'Franklin', N'WI', N'55079', N'53132', 42.861545, -87.951645, 3669, 303, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6107, N'Midwest Orthopedic Specialty Hospital', 1, NULL, NULL, N'520205', NULL, NULL, 0, 16, NULL, N'4148175800', N'4143254511', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'10101 South 27Th St  2Nd Floor', N'Franklin', N'WI', N'55079', N'53132', 44.212737, -91.123762, 3669, 303, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6108, N'Aurora Medical Center', 1, NULL, NULL, N'520206', NULL, NULL, 0, 66, NULL, N'2624341000', N'2624341221', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'36500 Aurora Drive', N'Summit', N'WI', N'55133', N'53066', 45.336683, -89.363194, 3675, 303, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6109, N'Aurora Medical Center', 1, NULL, NULL, N'520207', NULL, NULL, 0, 62, NULL, N'2623291000', N'2623291001', 1, 1, 1, 0, 0, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'975 Port Washington Road', N'Grafton', N'WI', N'55089', N'53024', 43.319727, -87.953423, 3683, 303, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6110, N'St Marys Janesville Hospital', 1, NULL, NULL, N'520208', NULL, NULL, 0, 50, NULL, N'6083738000', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3400 East Racine Street', N'Janesville', N'WI', N'55105', N'53546', 42.678966, -89.009568, 3654, 301, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6111, N'Ministry Eagle River Memorial Hospital', 1, NULL, NULL, N'521300', NULL, NULL, 0, 25, NULL, N'7154797411', N'7153566097', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'201 Hospital Road', N'Eagle River', N'WI', N'55125', N'54521', 45.917176, -89.244299, 3641, 305, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6112, N'Mayo Clinic Health System Oakridge', 1, NULL, NULL, N'521302', NULL, NULL, 0, 18, NULL, N'7155973121', N'7155976250', 1, 1, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'13025 8Th St', N'Osseo', N'WI', N'55121', N'54758', 44.577823, -91.216635, 3642, 152, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6113, N'Wild Rose Community Memorial Hospital', 1, NULL, NULL, N'521303', NULL, NULL, 0, 25, NULL, N'9206223257', N'9206225593', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'601 Grove Ave', N'Wild Rose', N'WI', N'55137', N'54984', 44.183012, -89.246211, 3714, 304, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6114, N'St Josephs Health Services', 1, NULL, NULL, N'521304', NULL, NULL, 0, 25, NULL, N'6084898000', N'6084898181', 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'400 Water Ave', N'Hillsboro', N'WI', N'55123', N'54634', 43.648936, -90.34601, 3652, 301, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6115, N'Mayo Clinic Hlth Systm Franciscan Hlthcare Sparta', 1, NULL, NULL, N'521305', NULL, NULL, 0, 25, NULL, N'6082692132', N'6082694562', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'310 W Main St', N'Sparta', N'WI', N'55081', N'54656', 43.944376, -90.814228, 3657, 300, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6116, N'Chippewa Valley Hospital', 1, NULL, NULL, N'521307', NULL, NULL, 0, 25, NULL, N'7156724211', N'7156725112', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1220 3Rd Ave W', N'Durand', N'WI', N'55091', N'54736', 44.620405, -91.96202, 3640, 153, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6117, N'Amery Regional Medical Ctr', 1, NULL, NULL, N'521308', NULL, NULL, 0, 25, NULL, N'7152680300', N'7152680311', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'265 Griffin Street East', N'Amery', N'WI', N'55095', N'54001', 45.29594, -92.36223, 3617, 155, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6118, N'Moundview Memorial Hospital And Clinics', 1, NULL, NULL, N'521309', NULL, NULL, 0, 25, NULL, N'6083393331', N'6083399385', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'402 W Lake St', N'Friendship', N'WI', N'55001', N'53934', 43.974147, -89.820927, 3647, 301, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6119, N'Hshs St Clare Memorial Hospital', 1, NULL, NULL, N'521310', NULL, NULL, 0, 15, NULL, N'9208463444', N'9208460250', 1, 1, 1, 1, 0, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'855 S Main St', N'Oconto Falls', N'WI', N'55083', N'54154', 44.867958, -88.130704, 3676, 299, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6120, N'Our Lady Of Victory Hospital', 1, NULL, NULL, N'521311', NULL, NULL, 0, 24, NULL, N'7156445571', N'7156446221', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1120 Pine St', N'Stanley', N'WI', N'55017', N'54768', 44.955281, -90.929105, 3699, 302, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6121, N'Memorial Hospital Of Lafayette County', 1, NULL, NULL, N'521312', NULL, NULL, 0, 15, NULL, N'6087764466', NULL, 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'800 Clay St', N'Darlington', N'WI', N'55065', N'53530', 42.683818, -90.110568, 3638, 301, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6122, N'Ministry Sacred Heart Hospital', 1, NULL, NULL, N'521313', NULL, NULL, 0, 18, NULL, N'7154537700', N'7154537716', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'401 W Mohawk Dr  Suite 100', N'Tomahawk', N'WI', N'55069', N'54487', 45.471079, -89.729859, 3689, 305, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6123, N'Mayo Clinic Health System  Chippewa Valley', 1, NULL, NULL, N'521314', NULL, NULL, 0, 15, NULL, N'7155682000', N'7155686129', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1501 Thompson St', N'Bloomer', N'WI', N'55017', N'54724', 45.102181, -91.501679, 3629, 152, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6124, N'Mayo Clinic Health System  Northland', 1, NULL, NULL, N'521315', NULL, NULL, 0, 29, NULL, N'7155373186', N'7155376902', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1222 E Woodland Ave', N'Barron', N'WI', N'55005', N'54812', 45.398327, -91.842533, 3624, 152, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6125, N'Tri County Memorial Hospital', 1, NULL, NULL, N'521316', NULL, NULL, 0, 26, NULL, N'7155384361', N'7155382271', 1, 1, 1, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'18601 Lincoln St', N'Whitehall', N'WI', N'55121', N'54773', 44.364632, -91.319091, 3713, 300, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6126, N'Calumet Medical Center', 1, NULL, NULL, N'521317', NULL, NULL, 0, 29, NULL, N'9208492386', N'9208497510', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'614 Memorial Drive', N'Chilton', N'WI', N'55015', N'53014', 44.024953, -88.154282, 3633, 298, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6127, N'Ladd Memorial Hospital', 1, NULL, NULL, N'521318', NULL, NULL, 0, 23, NULL, N'7152942111', N'7152943694', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2600 65Th Avenue', N'Osceola', N'WI', N'55095', N'54020', 45.301585, -92.700381, 3677, 155, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6128, N'Edgerton Hospital And Health Services', 1, NULL, NULL, N'521319', NULL, NULL, 0, 29, NULL, N'6088843441', N'6088841659', 1, 1, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'11101 N Sherman Road', N'Edgerton', N'WI', N'55105', N'53534', 42.835284, -89.067612, 3643, 301, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6129, N'Tomah Memorial Hospital', 1, NULL, NULL, N'521320', NULL, NULL, 0, 15, NULL, N'6083722181', N'6083740289', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'321 Butts Ave', N'Tomah', N'WI', N'55081', N'54660', 43.979786, -90.514794, 3703, 300, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6130, N'Ripon Medical Center', 1, NULL, NULL, N'521321', NULL, NULL, 0, 15, NULL, N'9207483101', N'9207480452', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'845 Parkside St', N'Ripon', N'WI', N'55039', N'54971', 43.84245, -88.837297, 3692, 304, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6131, N'Grant Regional Health Center', 1, NULL, NULL, N'521322', NULL, NULL, 0, 15, NULL, N'6087232143', N'6087234464', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'507 S Monroe St', N'Lancaster', N'WI', N'55043', N'53813', 42.843959, -90.708934, 3659, 301, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6132, N'Memorial Medical Center', 1, NULL, NULL, N'521323', NULL, NULL, 0, 25, NULL, N'7157433101', N'7157438015', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'216 Sunset Place', N'Neillsville', N'WI', N'55019', N'54456', 44.557381, -90.607054, 3672, 302, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6133, N'Aspirus Medford Hospital & Clinics  Inc', 1, NULL, NULL, N'521324', NULL, NULL, 0, 15, NULL, N'7157488100', N'7157488199', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'135 S Gibson St', N'Medford', N'WI', N'55119', N'54451', 45.134952, -90.354166, 3665, 302, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6134, N'Flambeau Hospital', 1, NULL, NULL, N'521325', NULL, NULL, 0, 15, NULL, N'7157627500', N'7157627518', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'98 Sherry Ave', N'Park Falls', N'WI', N'55099', N'54552', 45.93051, -90.441275, 3679, 302, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6135, N'Thedacare Medical Center New London', 1, NULL, NULL, N'521326', NULL, NULL, 0, 15, NULL, N'9205312000', N'9205312098', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1405 Mill St', N'New London', N'WI', N'55087', N'54961', 44.390128, -88.73338, 3673, 298, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6136, N'Waupun Memorial Hospital', 1, NULL, NULL, N'521327', NULL, NULL, 0, 15, NULL, N'9203246530', N'9203242085', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'620 W Brown St', N'Waupun', N'WI', N'55027', N'53963', 43.631071, -88.745391, 3709, 304, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6137, N'Rusk County Memorial Hospital', 1, NULL, NULL, N'521328', NULL, NULL, 0, 25, NULL, N'7155325561', N'7155329809', 1, 1, 0, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'900 College Ave West', N'Ladysmith', N'WI', N'55107', N'54848', 45.455344, -91.110685, 3658, 302, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6138, N'St Marys Hospital Of Superior', 1, NULL, NULL, N'521329', NULL, NULL, 0, 15, NULL, N'7158177000', NULL, 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3500 Tower Ave', N'Superior', N'WI', N'55031', N'54880', 46.682627, -92.104197, 1903, 151, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6139, N'Crossing Rivers Health Medical Center', 1, NULL, NULL, N'521330', NULL, NULL, 0, 25, NULL, N'6083572000', N'6083572100', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'705 E Taylor St', N'Prairie Du Chien', N'WI', N'55023', N'53821', 43.044117, -91.137862, 3685, 300, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6140, N'Burnett Medical Center', 1, NULL, NULL, N'521331', NULL, NULL, 0, 25, NULL, N'7154635353', N'7154632423', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'257 W St George Ave', N'Grantsburg', N'WI', N'55013', N'54840', 45.775195, -92.688087, 3648, 152, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6141, N'Spooner Health System', 1, NULL, NULL, N'521332', NULL, NULL, 0, 25, NULL, N'7156352111', NULL, 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'819 Ash Street', N'Spooner', N'WI', N'55129', N'54801', 45.825884, -91.895495, 3697, 152, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6142, N'Black River Memorial Hospital', 1, NULL, NULL, N'521333', NULL, NULL, 0, 25, NULL, N'7152845361', N'7152841390', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'711 W Adams St', N'Black River Falls', N'WI', N'55053', N'54615', 44.30349, -90.854905, 3628, 302, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6143, N'Riverside Medical Center', 1, NULL, NULL, N'521334', NULL, NULL, 0, 25, NULL, N'7152581000', N'7152581009', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'800 Riverside Drive', N'Waupaca', N'WI', N'55135', N'54981', 44.345244, -89.075784, 3708, 298, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6144, N'Hudson Hospital', 1, NULL, NULL, N'521335', NULL, NULL, 0, 25, NULL, N'7155316000', N'7155316011', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'405 Stageline Road', N'Hudson', N'WI', N'55109', N'54016', 44.961059, -92.717932, 3653, 155, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6145, N'Hayward Area Memorial Hospital', 1, NULL, NULL, N'521336', NULL, NULL, 0, 25, NULL, N'7159344321', N'7159344270', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'11040 N State Rd 77', N'Hayward', N'WI', N'55113', N'54843', 46.012968, -91.484873, 3651, 151, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6146, N'St Croix Regional Medical Ctr', 1, NULL, NULL, N'521337', NULL, NULL, 0, 25, NULL, N'7154833261', N'7154830295', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'235 State Street', N'Saint Croix Falls', N'WI', N'55095', N'54024', 44.853603, -92.630947, 3698, 155, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6147, N'Columbus Community Hospital', 1, NULL, NULL, N'521338', NULL, NULL, 0, 25, NULL, N'9206232200', N'9206233546', 1, 1, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1515 Park Ave', N'Columbus', N'WI', N'55021', N'53925', 43.324108, -89.035499, 3635, 301, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6148, N'Good Samaritan Health Center', 1, NULL, NULL, N'521339', NULL, NULL, 0, 25, NULL, N'7155365511', N'7155392107', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'601 S Center Ave', N'Merrill', N'WI', N'55069', N'54452', 45.175276, -89.683192, 3668, 305, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6149, N'Mayo Clinic Health System  Red Cedar', 1, NULL, NULL, N'521340', NULL, NULL, 0, 25, NULL, N'7152355531', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2321 Stout Rd', N'Menomonie', N'WI', N'55033', N'54751', 44.882712, -91.901358, 3667, 152, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6150, N'Richland Hospital', 1, NULL, NULL, N'521341', NULL, NULL, 0, 25, NULL, N'6086476321', N'6086476235', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'333 E Second St', N'Richland Center', N'WI', N'55103', N'53581', 43.334705, -90.386793, 3691, 301, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6151, N'Indianhead Medical Ctr', 1, NULL, NULL, N'521342', NULL, NULL, 0, 25, NULL, N'7154687833', N'7154687303', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'113 4Th Ave', N'Shell Lake', N'WI', N'55129', N'54871', 45.742302, -91.926367, 3696, 152, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6152, N'Stoughton Hospital', 1, NULL, NULL, N'521343', NULL, NULL, 0, 25, NULL, N'6088736611', N'6088732315', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'900 Ridge St', N'Stoughton', N'WI', N'55025', N'53589', 42.920173, -89.211149, 3701, 301, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6153, N'Gundersen Boscobel Area Hospital And Clinics', 1, NULL, NULL, N'521344', NULL, NULL, 0, 25, NULL, N'6083754112', N'6083755463', 1, 1, 1, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'205 Parker St', N'Boscobel', N'WI', N'55043', N'53805', 43.133374, -90.708038, 3630, 301, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6154, N'Westfields Hospital And Clinic', 1, NULL, NULL, N'521345', NULL, NULL, 0, 25, NULL, N'7152432600', N'7152432851', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'535 Hospital Rd', N'New Richmond', N'WI', N'55109', N'54017', 45.1182, -92.553319, 3674, 155, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6155, N'Shawano Medical Ctr', 1, NULL, NULL, N'521346', NULL, NULL, 0, 25, NULL, N'7155262111', N'7155267205', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'309 N Bartlette St', N'Shawano', N'WI', N'55115', N'54166', 44.782206, -88.608992, 3694, 298, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6156, N'Baldwin Area Medical Center', 1, NULL, NULL, N'521347', NULL, NULL, 0, 25, NULL, N'7156843311', N'7156844757', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'730 10Th Ave', N'Baldwin', N'WI', N'55109', N'54002', 44.970861, -92.373668, 3622, 155, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6157, N'Vernon Memorial Hospital', 1, NULL, NULL, N'521348', NULL, NULL, 0, 25, NULL, N'6086372101', N'6086372141', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'507 South Main St', N'Viroqua', N'WI', N'55123', N'54665', 43.551713, -90.88819, 3705, 300, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6158, N'River Falls Area Hospital', 1, NULL, NULL, N'521349', NULL, NULL, 0, 25, NULL, N'7153076000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1629 E Division St', N'River Falls', N'WI', N'55093', N'54022', 44.864986, -92.602953, 3693, 155, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6159, N'Langlade Hospital', 1, NULL, NULL, N'521350', NULL, NULL, 0, 25, NULL, N'7156232331', N'7156239440', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'112 E Fifth St', N'Antigo', N'WI', N'55067', N'54409', 45.140245, -89.152335, 3618, 298, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6160, N'Reedsburg Area Medical Ctr', 1, NULL, NULL, N'521351', NULL, NULL, 0, 25, NULL, N'6085246487', NULL, 1, 1, 0, 0, 1, 1, 0, 0, 0, 0, 0, 0, NULL, NULL, N'2000 N Dewey Ave', N'Reedsburg', N'WI', N'55111', N'53959', 43.549917, -89.994455, 3688, 301, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6161, N'Upland Hills Health', 1, NULL, NULL, N'521352', NULL, NULL, 0, 25, NULL, N'6089308000', N'6089307250', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'800 Compassion Way', N'Dodgeville', N'WI', N'55049', N'53533', 42.951009, -90.129449, 3639, 301, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6162, N'Cumberland Memorial Hospital', 1, NULL, NULL, N'521353', NULL, NULL, 0, 25, NULL, N'7158222741', N'7158226299', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1110 7Th Avenue', N'Cumberland', N'WI', N'55005', N'54829', 45.536301, -92.030547, 3637, 152, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6163, N'Southwest Health Center', 1, NULL, NULL, N'521354', NULL, NULL, 0, 25, NULL, N'6083482331', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1400 East Side Rd', N'Platteville', N'WI', N'55043', N'53818', 42.734294, -90.478445, 3681, 106, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6164, N'Berlin Memorial Hospital', 1, NULL, NULL, N'521355', NULL, NULL, 0, 25, NULL, N'9203611313', N'9203615579', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'225 Memorial Drive', N'Berlin', N'WI', N'55047', N'54923', 43.977723, -88.939917, 3627, 304, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6165, N'Bellin Health Oconto Hospital', 1, NULL, NULL, N'521356', NULL, NULL, 0, 4, NULL, N'9208351100', N'9205167088', 1, 1, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'820 Arbutus Ave', N'Oconto', N'WI', N'55083', N'54153', 44.896307, -87.86559, 3649, 299, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6166, N'Mercy Walworth Hospital & Medical Center', 1, NULL, NULL, N'521357', NULL, NULL, 0, 25, NULL, N'2622450535', N'2622452198', 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'N2950 State Road 67', N'Lake Geneva', N'WI', N'55127', N'53147', 42.591684, -88.43343, 3644, 303, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6167, N'Ministry Door County Medical Center', 1, NULL, NULL, N'521358', NULL, NULL, 0, 25, NULL, N'9207435566', NULL, 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'323 South 18Th Avenue', N'Sturgeon Bay', N'WI', N'55029', N'54235', 44.834376, -87.351587, 3702, 299, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6168, N'Memorial Medical Center', 1, NULL, NULL, N'521359', NULL, NULL, 0, 25, NULL, N'7156855500', N'7156824022', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1615 Maple Lane', N'Ashland', N'WI', N'55003', N'54806', 46.56696, -90.888141, 3621, 151, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6169, N'Clearview Home Corporation', 1, NULL, NULL, N'521990', NULL, NULL, 0, 12, NULL, N'2626463361', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'935 Main St', N'Delafield', N'WI', N'55133', N'53018', 43.060804, -88.405889, 3707, 303, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6170, N'Post Acute Medical Specialty Hospital Of Milwaukee', 1, NULL, NULL, N'522004', NULL, NULL, 0, 62, NULL, N'4144278282', N'4145296656', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5017 S 110Th St', N'Greenfield', N'WI', N'55079', N'53228', 42.953824, -88.050402, 3669, 303, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6171, N'Lakeview Specialty Hospital & Rehab Center', 1, NULL, NULL, N'522005', NULL, NULL, 0, 39, NULL, N'2625347297', N'2625347257', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1701 Sharp Road', N'Waterford', N'WI', N'55101', N'53185', 42.763072, -88.214256, 3632, 303, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6172, N'Select Specialty Hospital Milwaukee', 1, NULL, NULL, N'522006', NULL, NULL, 0, 63, NULL, N'4143287700', N'4143287434', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'8901 W Lincoln Ave  2Nd Floor', N'West Allis', N'WI', N'55079', N'53227', 43.016681, -88.007031, 3711, 303, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6173, N'Lifecare Hospitals Of Wisconsin', 1, NULL, NULL, N'522007', NULL, NULL, 0, 17, NULL, N'2625242600', N'2625242631', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2400 Golf Road', N'Pewaukee', N'WI', N'55133', N'53072', 43.050566, -88.294749, 3707, 303, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6174, N'Select Specialty Hospital Madison', 1, NULL, NULL, N'522008', NULL, NULL, 0, 23, NULL, N'6082602700', N'6082569865', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'801 Braxton Place', N'Madison', N'WI', N'55025', N'53715', 43.066263, -89.399847, 3660, 301, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6175, N'Sacred Heart Rehabilitation Institute', 1, NULL, NULL, N'523025', NULL, NULL, 0, 81, NULL, N'4142986700', N'4142986737', 1, 1, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'2301 N Lake Drive  8Th Floor', N'Milwaukee', N'WI', N'55079', N'53211', 43.034993, -87.922497, 3669, 303, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6176, N'Rehabilitation Hospital Of Wisconsin', 1, NULL, NULL, N'523027', NULL, NULL, 0, 40, NULL, N'2625218800', N'2625218876', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1625 Cold Water Creek Drive', N'Waukesha', N'WI', N'55133', N'53188', 43.011678, -88.231481, 3707, 303, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6177, N'Childrens Hospital Of Wisconsin', 1, NULL, NULL, N'523300', NULL, NULL, 0, 296, NULL, N'4142662000', N'4142666409', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'9000 W Wisconsin Ave', N'Milwaukee', N'WI', N'55079', N'53226', 43.038604, -88.021454, 3669, 303, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6178, N'Childrens Hospital Of Wisconsin Fox Valley', 1, NULL, NULL, N'523302', NULL, NULL, 0, 42, NULL, N'9209697900', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'130 Second St', N'Neenah', N'WI', N'55139', N'54956', 44.185819, -88.462609, 3671, 304, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6179, N'Aurora Psychiatric Hospital', 1, NULL, NULL, N'524000', NULL, NULL, 0, 105, NULL, N'4144546600', N'4144546450', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'1220 Dewey Ave', N'Wauwatosa', N'WI', N'55079', N'53213', 43.046545, -88.009412, 3669, 303, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6180, N'Milwaukee County Behavioral Health Division', 1, NULL, NULL, N'524001', NULL, NULL, 0, 234, NULL, N'4142575202', N'4142578018', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'9455 W Watertown Plank Rd', N'Milwaukee', N'WI', N'55079', N'53226', 43.045578, -88.023586, 3669, 303, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6181, N'Winnebago Mental Health Institute', 1, NULL, NULL, N'524002', NULL, NULL, 0, 315, NULL, N'9202354910', N'9202372043', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1300 South Drive', N'Winnebago', N'WI', N'55139', N'54985', 44.073686, -88.52263, 3678, 304, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6182, N'Mendota Mental Health Institute', 1, NULL, NULL, N'524008', NULL, NULL, 0, 36, NULL, N'6083011000', N'6083011390', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'301 Troy Dr', N'Madison', N'WI', N'55025', N'53704', 43.129298, -89.400423, 3660, 301, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6183, N'Brown County Community Treatment Ctr', 1, NULL, NULL, N'524014', NULL, NULL, 0, 88, NULL, N'9203914700', N'9203914870', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3150 Gershwin Drive', N'Green Bay', N'WI', N'55009', N'54311', 44.529941, -88.024832, 3649, 299, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6184, N'North Central Health Care', 1, NULL, NULL, N'524017', NULL, NULL, 0, 16, NULL, N'7158484600', N'7158482362', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1100 Lakeview Dr', N'Wausau', N'WI', N'55073', N'54403', 44.959602, -89.629824, 3710, 305, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6185, N'Rogers Memorial Hospital', 1, NULL, NULL, N'524018', NULL, NULL, 0, 168, NULL, N'2626464411', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'34700 Valley Rd', N'Oconomowoc', N'WI', N'55133', N'53066', 43.111673, -88.499266, 3675, 303, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6186, N'Norwood Health Center', 1, NULL, NULL, N'524019', NULL, NULL, 0, 16, NULL, N'7153842188', N'7153871533', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1600 N Chestnut Ave', N'Marshfield', N'WI', N'55141', N'54449', 44.681776, -90.164872, 3663, 302, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6187, N'Fond Du Lac County Acute Psych Unit', 1, NULL, NULL, N'524025', NULL, NULL, 0, 25, NULL, N'9209293500', N'9209064768', 1, 1, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'459 E First St', N'Fond Du Lac', N'WI', N'55039', N'54935', 43.774876, -88.445803, 3645, 303, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6188, N'Waukesha County Mental Health Ctr', 1, NULL, NULL, N'524026', NULL, NULL, 0, 28, NULL, N'2625487950', N'2628968046', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1501 Airport Rd', N'Waukesha', N'WI', N'55133', N'53188', 43.025117, -88.233523, 3707, 303, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6189, N'Bellin Psychiatric Center', 1, NULL, NULL, N'524038', NULL, NULL, 0, 80, NULL, N'9204333630', N'9204370533', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'301 E St Joseph St', N'Green Bay', N'WI', N'55009', N'54301', 44.529941, -88.024832, 3649, 299, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6190, N'Aurora St Lukes Medical Center', 1, NULL, NULL, N'529801', NULL, NULL, 0, 0, NULL, N'4146461865', N'4146465452', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'2900 W Oklahoma Ave  5Th Floor Galleria Building', N'Milwaukee', N'WI', N'55079', N'53215', 43.034993, -87.922497, 3669, 303, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6191, N'University Of Wisconsin Hospitals And Clinics', 1, NULL, NULL, N'529802', NULL, NULL, 0, 0, NULL, N'6082657050', N'6082655568', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'600 Highland Ave', N'Madison', N'WI', N'55025', N'53792', 43.076379, -89.432009, 3660, 301, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6192, N'Childrens Hospital Of Wisconsin', 1, NULL, NULL, N'529803', NULL, NULL, 0, 0, NULL, N'4142662000', N'4142666409', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'9000 W Wisconsin Aveune', N'Milwaukee', N'WI', N'55079', N'53226', 43.034993, -87.922497, 3669, 303, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6193, N'Froedtert Memorial Lutheran Hospital', 1, NULL, NULL, N'529804', NULL, NULL, 0, 0, NULL, N'4148050008', N'4148057790', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'9200 W Wisconsin Ave', N'Milwaukee', N'WI', N'55079', N'53226', 43.038695, -87.97189, 3669, 303, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6194, N'Campbell County Memorial Hospital', 1, NULL, NULL, N'530002', NULL, NULL, 0, 119, NULL, N'3076881551', N'3076881570', 1, 1, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'501 South Burma Avenue', N'Gillette', N'WY', N'56005', N'82716', 44.290635, -105.501876, 3724, 168, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6195, N'Sheridan Memorial Hospital', 1, NULL, NULL, N'530006', NULL, NULL, 0, 88, NULL, N'3076721044', N'3076721007', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1401 W 5Th St', N'Sheridan', N'WY', N'56033', N'82801', 44.80752, -106.976466, 3736, 168, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6196, N'Sagewest Health Care', 1, NULL, NULL, N'530008', NULL, NULL, 0, 159, NULL, N'3078564161', N'3078573571', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2100 W Sunset Dr', N'Riverton', N'WY', N'56013', N'82501', 43.033745, -108.418673, 3734, 306, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6197, N'Memorial Hospital Sweetwater County', 1, NULL, NULL, N'530011', NULL, NULL, 0, 99, NULL, N'3073623711', N'3073628180', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1200 College Drive', N'Rock Springs', N'WY', N'56037', N'82901', 41.597278, -109.241623, 3735, 279, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6198, N'Wyoming Medical Center', 1, NULL, NULL, N'530012', NULL, NULL, 0, 192, NULL, N'3075777201', N'3072371703', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1233 East 2Nd St', N'Casper', N'WY', N'56025', N'82601', 42.847587, -106.307843, 3719, 306, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6199, N'Cheyenne Regional Medical Center', 1, NULL, NULL, N'530014', NULL, NULL, 0, 206, NULL, N'3076342273', N'3076337715', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'214 East 23Rd Street', N'Cheyenne', N'WY', N'56021', N'82001', 41.140068, -104.816918, 3720, 44, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6200, N'St Johns Medical Center', 1, NULL, NULL, N'530015', NULL, NULL, 0, 42, NULL, N'3077333636', N'3077397596', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'625 East Broadway', N'Jackson', N'WY', N'56039', N'83001', 43.480405, -110.750456, 3725, 279, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6201, N'Ivinson Memorial Hospital', 1, NULL, NULL, N'530025', NULL, NULL, 0, 99, NULL, N'3077422141', N'3077420678', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'255 N 30Th', N'Laramie', N'WY', N'56001', N'82072', 41.311367, -105.591101, 3728, 44, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6202, N'Evanston Regional Hospital', 1, NULL, NULL, N'530032', NULL, NULL, 0, 42, NULL, N'3077893636', N'3077898187', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'190 Arrowhead Dr', N'Evanston', N'WY', N'56041', N'82930', 41.242297, -110.991174, 3723, 279, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6203, N'Mountain View Regional Hospital', 1, NULL, NULL, N'530033', NULL, NULL, 0, 23, NULL, N'3079958100', N'3079958112', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6550 East 2Nd Street', N'Casper', N'WY', N'56025', N'82605', 42.839828, -106.226466, 3719, 306, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6204, N'South Big Horn County Critical Access Hospital', 1, NULL, NULL, N'531301', NULL, NULL, 0, 6, NULL, N'3075683311', N'3075682139', 1, 1, 1, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'388 Us Highway 20 South', N'Basin', N'WY', N'56003', N'82410', 44.379956, -108.038989, 3741, 168, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6205, N'Memorial Hospital Of Converse County', 1, NULL, NULL, N'531302', NULL, NULL, 0, 25, NULL, N'3073582122', N'3073583630', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'111 South 5Th Street', N'Douglas', N'WY', N'56009', N'82633', 42.758315, -105.381172, 3722, 306, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6206, N'Weston County Health Services', 1, NULL, NULL, N'531303', NULL, NULL, 0, 21, NULL, N'3077464491', N'3077463728', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1124 Washington Boulevard', N'Newcastle', N'WY', N'56045', N'82701', 43.848746, -104.188434, 3731, 306, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6207, N'Hot Springs County Memorial Hospital', 1, NULL, NULL, N'531304', NULL, NULL, 0, 25, NULL, N'3078643121', N'3078645050', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'150 East Arapahoe', N'Thermopolis', N'WY', N'56017', N'82443', 43.647206, -108.203553, 3738, 306, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6208, N'Platte County Memorial Hospital', 1, NULL, NULL, N'531305', NULL, NULL, 0, 25, NULL, N'3073223636', N'3073221504', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'201 14Th Street', N'Wheatland', N'WY', N'56031', N'82201', 42.04991, -104.960277, 3740, 306, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6209, N'Washakie Medical Center', 1, NULL, NULL, N'531306', NULL, NULL, 0, 25, NULL, N'3073473221', N'3073476937', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'400 South 15Th Street', N'Worland', N'WY', N'56043', N'82401', 44.012141, -107.948514, 3741, 168, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6210, N'Community Hospital', 1, NULL, NULL, N'531307', NULL, NULL, 0, 25, NULL, N'3075324181', N'3075323800', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2000 Campbell Drive', N'Torrington', N'WY', N'56015', N'82240', 42.082841, -104.192952, 3739, 306, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6211, N'Johnson County Healthcare Center', 1, NULL, NULL, N'531308', NULL, NULL, 0, 25, NULL, N'3076845521', N'3076845385', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'497 West Lott', N'Buffalo', N'WY', N'56019', N'82834', 44.348308, -106.698938, 3718, 306, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6212, N'North Big Horn Hospital District', 1, NULL, NULL, N'531309', NULL, NULL, 0, 15, NULL, N'3075485200', N'3075485205', 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'1115 Lane 12', N'Lovell', N'WY', N'56003', N'82431', 44.837377, -108.389548, 3729, 168, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6213, N'Powell Valley Hospital', 1, NULL, NULL, N'531310', NULL, NULL, 0, 25, NULL, N'3077542267', N'3077547790', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'777 Avenue H', N'Powell', N'WY', N'56029', N'82435', 44.756669, -108.77135, 3732, 168, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6214, N'Crook County Memorial Hospital', 1, NULL, NULL, N'531311', NULL, NULL, 0, 16, NULL, N'3072833501', N'3072833506', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'713 Oak Street', N'Sundance', N'WY', N'56011', N'82729', 44.406371, -104.375788, 3737, 306, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6215, N'West Park Hospital District', 1, NULL, NULL, N'531312', NULL, NULL, 0, 25, NULL, N'3075782488', N'3075782485', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'707 Sheridan Avenue', N'Cody', N'WY', N'56029', N'82414', 44.526109, -109.073926, 3721, 168, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6216, N'Star Valley Medical Center', 1, NULL, NULL, N'531313', NULL, NULL, 0, 20, NULL, N'3078855800', N'3078855889', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'901 Adams Street', N'Afton', N'WY', N'56023', N'83110', 42.716283, -110.931317, 3717, 279, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6217, N'Niobrara Health & Life Center', 1, NULL, NULL, N'531314', NULL, NULL, 0, 24, NULL, N'3073344000', N'3073340124', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'921 South Ballancee Avenue', N'Lusk', N'WY', N'56027', N'82225', 42.762467, -104.452175, 3730, 306, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6218, N'South Lincoln Medical Center - Cah', 1, NULL, NULL, N'531315', NULL, NULL, 0, 16, NULL, N'3078774401', N'3078773236', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'711 Onyx Street', N'Kemmerer', N'WY', N'56023', N'83101', 41.789567, -110.540828, 3726, 279, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6219, N'Memorial Hospital Of Carbon County', 1, NULL, NULL, N'531316', NULL, NULL, 0, 25, NULL, N'3073242221', N'3073248232', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2221 West Elm Street', N'Rawlins', N'WY', N'56007', N'82301', 41.786858, -107.262144, 3733, 306, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6220, N'Elkhorn Valley Rehabilitation Hospital Llc', 1, NULL, NULL, N'533027', NULL, NULL, 0, 41, NULL, N'3072650005', N'3072652860', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5715 East 2Nd Street', N'Casper', N'WY', N'56025', N'82609', 42.848719, -106.303224, 3719, 306, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6221, N'Wyoming State Hospital', 1, NULL, NULL, N'534001', NULL, NULL, 0, 183, NULL, N'3077893464', N'3077895277', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'831 Hwy 150 South', N'Evanston', N'WY', N'56041', N'82931', 41.268047, -110.963323, 3723, 279, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6222, N'Wyoming Behavioral Institute', 1, NULL, NULL, N'534004', NULL, NULL, 0, 85, NULL, N'3072377444', N'3072655525', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2521 East 15Th Street', N'Casper', N'WY', N'56025', N'82609', 42.835414, -106.294691, 3719, 306, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6223, N'St Marks Medical Center', 1, NULL, NULL, N'670004', NULL, NULL, 0, 65, NULL, N'9792422200', N'9792422299', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'One St Mark''s Place', N'La Grange', N'TX', N'48149', N'78945', 29.905503, -96.876647, 3317, 265, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6224, N'Memorial Hermann Surgical Hospital Kingwood', 1, NULL, NULL, N'670005', NULL, NULL, 0, 10, NULL, N'2813124000', N'2813582461', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'300 Kingwood Medical Drive', N'Kingwood', N'TX', N'48201', N'77339', 30.033553, -95.261044, 3299, 265, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6225, N'The Hospital At Westlake Medical Center', 1, NULL, NULL, N'670006', NULL, NULL, 0, 23, NULL, N'5123270000', N'5123296688', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5656 Bee Caves Road Suite M-302', N'Austin', N'TX', N'48453', N'78746', 30.271129, -97.743699, 3215, 257, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6226, N'Houston Physicians'' Hospital', 1, NULL, NULL, N'670008', NULL, NULL, 0, 21, NULL, N'2813351700', N'2813341708', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'333 N Texas Avenue', N'Webster', N'TX', N'48201', N'77598', 29.53575, -95.126468, 3395, 265, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6227, N'Mayhill Hospital', 1, NULL, NULL, N'670010', NULL, NULL, 0, 57, NULL, N'9402393000', N'9402393090', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2809 South Mayhill Road', N'Denton', N'TX', N'48121', N'76208', 33.19511, -97.08477, 3260, 261, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6228, N'Houston Orthopedic And Spine Hospital', 1, NULL, NULL, N'670012', NULL, NULL, 0, 64, NULL, N'7136222262', N'7136223131', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5410 West Loop South', N'Bellaire', N'TX', N'48201', N'77401', 29.698754, -95.459215, 3299, 265, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6229, N'University General Hospital', 1, NULL, NULL, N'670019', NULL, NULL, 0, 72, NULL, N'7136523800', N'7136523888', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7501 Fannin', N'Houston', N'TX', N'48201', N'77054', 29.693241, -95.400597, 3299, 265, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6230, N'Innova Hospital San Antonio', 1, NULL, NULL, N'670021', NULL, NULL, 0, 4, NULL, N'2103687487', N'2103687446', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4243 Southcross Blvd', N'San Antonio', N'TX', N'48029', N'78222', 29.4246, -98.49514, 3370, 271, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6231, N'Methodist Mansfield Medical Center', 1, NULL, NULL, N'670023', NULL, NULL, 0, 88, NULL, N'6826222059', N'6886222051', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2700 E Broad Street', N'Mansfield', N'TX', N'48439', N'76063', 32.568007, -97.094638, 3211, 263, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6232, N'North Cypress Medical Center', 1, NULL, NULL, N'670024', NULL, NULL, 0, 139, NULL, N'2818900203', N'7134666050', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'21214 Northwest Freeway', N'Cypress', N'TX', N'48201', N'77429', 29.967438, -95.690994, 3299, 265, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6233, N'The Heart Hospital Baylor Plano', 1, NULL, NULL, N'670025', NULL, NULL, 0, 68, NULL, N'4698143278', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1100 Allied Drive', N'Plano', N'TX', N'48085', N'75093', 33.013676, -96.69251, 3357, 261, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6234, N'Acuity Hospital Of Houston', 1, NULL, NULL, N'670027', NULL, NULL, 0, 18, NULL, N'7137950200', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2001 Hermann Drive', N'Houston', N'TX', N'48201', N'77004', 29.717703, -95.382989, 3299, 265, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6235, N'St Luke''s Patients Medical Center', 1, NULL, NULL, N'670031', NULL, NULL, 0, 61, NULL, N'2814870700', N'2814870788', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4600 East Sam Houston Parkway South', N'Pasadena', N'TX', N'48201', N'77505', 29.640091, -95.161466, 3353, 265, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6236, N'Scott & White Hospital-Round Rock', 1, NULL, NULL, N'670034', NULL, NULL, 0, 101, NULL, N'5125090100', N'5125090257', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'300 University Blvd', N'Round Rock', N'TX', N'48491', N'78664', 30.522864, -97.677604, 3367, 257, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6237, N'Seton Medical Center Williamson', 1, NULL, NULL, N'670041', NULL, NULL, 0, 149, NULL, N'5123240000', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'201 Seton Parkway', N'Round Rock', N'TX', N'48491', N'78664', 30.522864, -97.677604, 3367, 257, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6238, N'Cedar Park Regional Medical Center', 1, NULL, NULL, N'670043', NULL, NULL, 0, 85, NULL, N'5125287000', N'5122599772', 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1401 Medical Parkway', N'Cedar Park', N'TX', N'48491', N'78613', 30.531536, -97.813893, 3215, 257, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6239, N'Texas Health Presbyterian Hospital Rockwall', 1, NULL, NULL, N'670044', NULL, NULL, 0, 50, NULL, N'4696981000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3150 Horizon Road', N'Rockwall', N'TX', N'48397', N'75032', 32.885727, -96.46447, 3368, 261, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6240, N'Cook Childrens Northeast Hospital Llc', 1, NULL, NULL, N'670045', NULL, NULL, 0, 3, NULL, N'8176052500', N'8176052985', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6316 Precinct Line Rd', N'Hurst', N'TX', N'48439', N'76054', 32.846954, -97.186254, 3220, 263, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6241, N'Usmd Hospital  At Fort Worth Lp', 1, NULL, NULL, N'670046', NULL, NULL, 0, 8, NULL, N'8174339100', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5900 Altamesa Blvd', N'Fort Worth', N'TX', N'48439', N'76132', 32.650705, -97.330063, 3274, 263, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6242, N'Sierra Providence East Medical Center', 1, NULL, NULL, N'670047', NULL, NULL, 0, 110, NULL, N'9158567349', N'9158567334', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3280 Joe Battle Blvd', N'El Paso', N'TX', N'48141', N'79938', 31.80524, -106.268743, 3268, 262, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6243, N'North Central Surgical Center Llp', 1, NULL, NULL, N'670049', NULL, NULL, 0, 17, NULL, N'2142652810', N'2148534385', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'9301 North Central Expressway Suite 100', N'Dallas', N'TX', N'48113', N'75231', 32.776196, -96.796899, 3255, 261, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6244, N'Trustpoint Hospital', 1, NULL, NULL, N'670050', NULL, NULL, 0, 71, NULL, N'8067492222', N'8067495555', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4302 Princeton', N'Lubbock', N'TX', N'48303', N'79415', 33.616788, -101.870455, 3326, 267, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6245, N'Doctors Hospital', 1, NULL, NULL, N'670052', NULL, NULL, 0, 36, NULL, N'9406835423', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1901 Doctors Hospital Drive', N'Bridgeport', N'TX', N'48497', N'76426', 33.230302, -97.785063, 3257, 261, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6246, N'St Luke''s Sugar Land Hospital', 1, NULL, NULL, N'670053', NULL, NULL, 0, 100, NULL, N'2816377000', N'2816377938', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1317 Lake Pointe Parkway', N'Sugar Land', N'TX', N'48157', N'77478', 29.605143, -95.621295, 3299, 265, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6247, N'Foundation Surgical Hospital Of San Antonio', 1, NULL, NULL, N'670054', NULL, NULL, 0, 20, NULL, N'2104785400', N'2104785401', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'9522 Huebner Road', N'San Antonio', N'TX', N'48029', N'78240', 29.531783, -98.591821, 3370, 271, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6248, N'Methodist Stone Oak Hospital', 1, NULL, NULL, N'670055', NULL, NULL, 0, 140, NULL, N'2106382100', N'2106383876', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1139 E Sonterra Blvd', N'San Antonio', N'TX', N'48029', N'78258', 29.61534, -98.471167, 3370, 271, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6249, N'Seton Medical Center Hays', 1, NULL, NULL, N'670056', NULL, NULL, 0, 112, NULL, N'5123245000', N'5123807556', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6001 Kyle Pkwy', N'Kyle', N'TX', N'48209', N'78640', 30.012787, -97.860442, 3215, 257, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6250, N'Emerus Hospital', 1, NULL, NULL, N'670058', NULL, NULL, 0, 7, NULL, N'2815160911', N'2815164511', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'16000 Southwest Freeway', N'Sugar Land', N'TX', N'48157', N'77479', 29.598343, -95.622849, 3299, 265, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6251, N'St Lukes Lakeside Hospital', 1, NULL, NULL, N'670059', NULL, NULL, 0, 30, NULL, N'9362664055', N'9362664051', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'17400 St Lukes Way', N'The Woodlands', N'TX', N'48339', N'77384', 30.204854, -95.45949, 3249, 265, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6252, N'Texas Regional Medical Center At Sunnyvale', 1, NULL, NULL, N'670060', NULL, NULL, 0, 20, NULL, N'9728923000', N'9728924401', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'231 South Collins Road', N'Sunnyvale', N'TX', N'48113', N'75182', 32.796517, -96.560824, 3255, 261, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6253, N'South Texas Surgical Hospital', 1, NULL, NULL, N'670061', NULL, NULL, 0, 33, NULL, N'3619932000', N'3619856834', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6130 Parkway Drive', N'Corpus Christi', N'TX', N'48355', N'78414', 27.686991, -97.374997, 3250, 260, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6254, N'Baylor Emergency Medical Center', 1, NULL, NULL, N'670062', NULL, NULL, 0, 2, NULL, N'9723472525', N'9723476725', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'26791 Highway 380', N'Aubrey', N'TX', N'48121', N'76227', 33.304283, -96.986118, 3260, 261, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6255, N'Basin Healthcare Center Llc', 1, NULL, NULL, N'670066', NULL, NULL, 0, 14, NULL, N'4324259510', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'900 East 4Th Street', N'Odessa', N'TX', N'48135', N'79761', 31.851829, -102.360295, 3346, 269, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6256, N'Baylor Orthopedic And Spine Hospital At Arlington', 1, NULL, NULL, N'670067', NULL, NULL, 0, 24, NULL, N'8175492364', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'707 Highlander Blvd', N'Arlington', N'TX', N'48439', N'76015', 32.682709, -97.11531, 3211, 263, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6257, N'Texas Health Presbyterian Hospital Flower Mound', 1, NULL, NULL, N'670068', NULL, NULL, 0, 103, NULL, N'9724191530', N'9724191545', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4400 Long Prairie Road', N'Flower Mound', N'TX', N'48121', N'75028', 33.046231, -97.069262, 3321, 261, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6258, N'Methodist Mckinney Hospital', 1, NULL, NULL, N'670069', NULL, NULL, 0, 12, NULL, N'4694246400', N'4694246401', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'8000 W Eldorado Pkwy', N'Mc Kinney', N'TX', N'48085', N'75070', 31.816038, -99.512099, 3334, 261, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6259, N'Texas Health Heart & Vascular Hospital Arlington', 1, NULL, NULL, N'670071', NULL, NULL, 0, 48, NULL, N'8179603500', N'8179603589', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'811 Wright Street', N'Arlington', N'TX', N'48439', N'76012', 32.748287, -97.116986, 3211, 263, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6260, N'Hopebridge Hospital', 1, NULL, NULL, N'670072', NULL, NULL, 0, 137, NULL, N'7134222650', N'7135903395', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5556 Gasmer Drive', N'Houston', N'TX', N'48201', N'77035', 29.651317, -95.460642, 3299, 265, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6261, N'Methodist Hospital For Surgery', 1, NULL, NULL, N'670073', NULL, NULL, 0, 32, NULL, N'4692483900', N'4692483901', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'17101 Dallas Parkway', N'Addison', N'TX', N'48113', N'75001', 32.96179, -96.829168, 3255, 261, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6262, N'St Luke''s Hospital At The Vintage', 1, NULL, NULL, N'670075', NULL, NULL, 0, 106, NULL, N'8325345000', N'7138522210', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'20171 Chasewood Park Drive', N'Houston', N'TX', N'48201', N'77070', 29.758938, -95.367697, 3299, 265, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6263, N'Heritage Park Surgical Hospital', 1, NULL, NULL, N'670076', NULL, NULL, 0, 14, NULL, N'9038133728', N'9038133784', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3601 Calais Drive', N'Sherman', N'TX', N'48181', N'75090', 33.617501, -96.595493, 3375, 261, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6264, N'Methodist West Houston Hospital', 1, NULL, NULL, N'670077', NULL, NULL, 0, 100, NULL, N'8325221000', N'8325220351', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'18500 Katy Freeway', N'Houston', N'TX', N'48201', N'77094', 29.785569, -95.689728, 3299, 265, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6265, N'Baptist Emergency Hospital', 1, NULL, NULL, N'670078', NULL, NULL, 0, 42, NULL, N'2104024092', N'2104024056', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'16088 San Pedro', N'San Antonio', N'TX', N'48029', N'78232', 29.4246, -98.49514, 3370, 271, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6266, N'Lakeway Regional Medical Center Llc', 1, NULL, NULL, N'670079', NULL, NULL, 0, 106, NULL, N'5122058102', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'100  Medical Parkway', N'Lakeway', N'TX', N'48453', N'78734', 30.374973, -97.96297, 3215, 257, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6267, N'Seton Medical Center Harker Heights', 1, NULL, NULL, N'670080', NULL, NULL, 0, 84, NULL, N'2549538342', N'2549538344', 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'850 W Central Texas Expressway', N'Harker Heights', N'TX', N'48027', N'76548', 31.08351, -97.659738, 3314, 272, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6268, N'Baylor Medical Center At Mckinney', 1, NULL, NULL, N'670082', NULL, NULL, 0, 95, NULL, N'4697422200', N'4697429685', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5252 West University Drive', N'Mc Kinney', N'TX', N'48085', N'75071', 31.816038, -99.512099, 3334, 261, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6269, N'Texas General Hospital', 1, NULL, NULL, N'670083', NULL, NULL, 0, 41, NULL, N'4696352073', NULL, 1, 1, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'2709 Hospital Blvd', N'Grand Prairie', N'TX', N'48113', N'75051', 32.732886, -97.049138, 3287, 261, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6270, N'Texas Health Harris Methodist Hospital Alliance', 1, NULL, NULL, N'670085', NULL, NULL, 0, 58, NULL, N'6822122004', N'6822129201', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'10864 Texas Health Trail', N'Fort Worth', N'TX', N'48439', N'76244', 32.753177, -97.332746, 3274, 263, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6271, N'Baylor Scott & White Emergency Medical Center At C', 1, NULL, NULL, N'670087', NULL, NULL, 0, 8, NULL, N'5126844911', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'900 East Whitestone Blvd', N'Cedar Park', N'TX', N'48491', N'78613', 30.524855, -97.813544, 3215, 257, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6272, N'Scott & White Hospital- College Station', 1, NULL, NULL, N'670088', NULL, NULL, 0, 119, NULL, N'9796913701', N'9796913615', 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'700 Scott & White Drive', N'College Station', N'TX', N'48041', N'77845', 30.626262, -96.334725, 3231, 259, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6273, N'Nix Community General Hospital', 1, NULL, NULL, N'670089', NULL, NULL, 0, 18, NULL, N'2102712190', N'2102712023', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'230 West Miller Street', N'Dilley', N'TX', N'48163', N'78017', 28.670056, -99.172843, 3370, 271, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6274, N'Crescent Medical Center Lancaster', 1, NULL, NULL, N'670090', NULL, NULL, 0, 84, NULL, N'9722308888', N'4692975702', 1, 1, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2600 West Pleasant Run Road', N'Lancaster', N'TX', N'48113', N'75146', 32.603915, -96.76105, 3319, 261, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6275, N'Continuecare Hospital Of Midland', 1, NULL, NULL, N'670091', NULL, NULL, 0, 29, NULL, N'4322211111', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4214 Andrews Highway', N'Midland', N'TX', N'48329', N'79703', 32.002328, -102.135226, 3336, 269, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6276, N'Walnut Hill Medical Center', 1, NULL, NULL, N'670092', NULL, NULL, 0, 100, NULL, N'9728636000', N'9728636020', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7502 Greenville Avenue', N'Dallas', N'TX', N'48113', N'75231', 32.883457, -96.759131, 3255, 261, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6277, N'Aspire Behavioral Health Of Conroe Llc', 1, NULL, NULL, N'670093', NULL, NULL, 0, 30, NULL, N'9366473500', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2006 South Loop 336 West Suite 500', N'Conroe', N'TX', N'48339', N'77304', 30.39338, -95.47042, 3249, 265, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6278, N'Little River Healthcare Cameron Hospital', 1, NULL, NULL, N'670094', NULL, NULL, 0, 10, NULL, N'2546050025', N'2546050029', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'806 N Crockett Ave', N'Cameron', N'TX', N'48331', N'76520', 30.856869, -96.976914, 3234, 272, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6279, N'Emerus Community Hospital', 1, NULL, NULL, N'670095', NULL, NULL, 0, 8, NULL, N'2815160911', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'24429 Tomball Parkway Suite 100', N'Tomball', N'TX', N'48201', N'77375', 30.073947, -95.627947, 3386, 265, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6280, N'Bay Area Regional Medical Center Llc', 1, NULL, NULL, N'670096', NULL, NULL, 0, 104, NULL, N'2815257000', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'200 Blossom Street', N'Webster', N'TX', N'48201', N'77598', 29.540506, -95.130447, 3395, 265, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6281, N'Baylor Emergency Medical Center', 1, NULL, NULL, N'670097', NULL, NULL, 0, 8, NULL, N'2142946200', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1975 Alpha Ste 100', N'Rockwall', N'TX', N'48397', N'75087', 32.931234, -96.459709, 3368, 261, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6282, N'Emil J Freireich Cancer Center', 1, NULL, NULL, N'670099', NULL, NULL, 0, 5, NULL, N'8553532201', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'9201 Pinecroft', N'Shenandoah', N'TX', N'48339', N'77380', 30.177507, -95.456784, 3299, 265, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6283, N'Warm Springs Rehabilitation Hospital Of Allen', 1, NULL, NULL, N'673025', NULL, NULL, 0, 40, NULL, N'9729082015', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1001 Raintree Circle', N'Allen', N'TX', N'48085', N'75013', 33.103174, -96.67055, 3357, 261, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6284, N'Gulf States Ltac Of New Braunfels', 1, NULL, NULL, N'673026', NULL, NULL, 0, 40, NULL, N'8306277600', N'8306277603', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1445 Hanz Drive', N'New Braunfels', N'TX', N'48091', N'78130', 29.727461, -98.101563, 3344, 271, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6285, N'Central Texas Rehabilitation Hospital', 1, NULL, NULL, N'673027', NULL, NULL, 0, 50, NULL, N'5124072101', N'5123230790', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'700 W 45Th St', N'Austin', N'TX', N'48453', N'78705', 30.320095, -97.751722, 3215, 257, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6286, N'Dallas Ltach Llc', 1, NULL, NULL, N'673028', NULL, NULL, 0, 60, NULL, N'4692326500', N'4692326501', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'8050 Meadow Road', N'Dallas', N'TX', N'48113', N'75231', 32.88737, -96.767572, 3255, 261, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6287, N'Reliant Rehabilitation Hospital North Texas', 1, NULL, NULL, N'673029', NULL, NULL, 0, 50, NULL, N'9723985700', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3351 Waterview Parkway', N'Richardson', N'TX', N'48113', N'75080', 32.98229, -96.756736, 3255, 261, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6288, N'Kate Dishman Rehabilitation Hospital', 1, NULL, NULL, N'673030', NULL, NULL, 0, 27, NULL, N'4098998380', N'4098998381', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2830  Calder St 6Th Fl South', N'Beaumont', N'TX', N'48245', N'77702', 30.086046, -94.101846, 3219, 258, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6289, N'Methodist Rehabilitation Hospital', 1, NULL, NULL, N'673031', NULL, NULL, 0, 40, NULL, N'9727088600', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3020 West Wheatland Road', N'Dallas', N'TX', N'48113', N'75237', 32.647493, -96.870175, 3255, 261, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6290, N'Reliant Rehabilitation Hospital Of Central Texas', 1, NULL, NULL, N'673032', NULL, NULL, 0, 75, NULL, N'9723088517', N'9723088509', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1400 Hester''s Crossing', N'Round Rock', N'TX', N'48491', N'78681', 30.488469, -97.67772, 3367, 257, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6291, N'Baylor Institute For Rehabilitation At Northwest D', 1, NULL, NULL, N'673033', NULL, NULL, 0, 42, NULL, N'2148797300', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1340 Empire Central Drive', N'Dallas', N'TX', N'48113', N'75247', 32.826707, -96.871191, 3255, 261, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6292, N'Reliant Rehabilitation Hospital North Houston', 1, NULL, NULL, N'673034', NULL, NULL, 0, 60, NULL, N'9364441700', N'9364441980', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'117 Vision Park Blvd', N'Shenandoah', N'TX', N'48339', N'77302', 30.190123, -95.459675, 3299, 265, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6293, N'Baylor Institute For Rehabilitation At Fort Worth', 1, NULL, NULL, N'673035', NULL, NULL, 0, 42, NULL, N'2145250619', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6601 Harris Parkway', N'Fort Worth', N'TX', N'48439', N'76132', 32.653419, -97.419215, 3274, 263, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6294, N'Select Rehabilitation Hospital Of Denton', 1, NULL, NULL, N'673036', NULL, NULL, 0, 44, NULL, N'9402976500', N'9409276565', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2620 Scripture Street', N'Denton', N'TX', N'48121', N'76201', 33.219155, -97.165546, 3260, 261, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6295, N'Memorial Hermann Rehabilitation Hospital Katy', 1, NULL, NULL, N'673038', NULL, NULL, 0, 118, NULL, N'2815795678', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'21720 Kingsland Blvd  Suite 102', N'Katy', N'TX', N'48201', N'77450', 29.785785, -95.824396, 3299, 265, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6296, N'Reliant Rehabilitation Hospital  Abilene', 1, NULL, NULL, N'673039', NULL, NULL, 0, 30, NULL, N'3256911600', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6401 Directors Parkway', N'Abilene', N'TX', N'48441', N'79606', 32.371325, -99.745065, 3201, 255, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6297, N'Select Rehabilitation Hospital Of San Antonio', 1, NULL, NULL, N'673040', NULL, NULL, 0, 42, NULL, N'2104823400', N'2103823401', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'19126 Stone Hue', N'San Antonio', N'TX', N'48029', N'78258', 29.4246, -98.49514, 3370, 271, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6298, N'Carrus Rehabilitation Hospital', 1, NULL, NULL, N'673041', NULL, NULL, 0, 24, NULL, N'9038702600', N'9038702601', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1810 West Highway 82', N'Sherman', N'TX', N'48181', N'75092', 33.670661, -96.644499, 3375, 261, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6299, N'Healthsouth Sugar Land Rehabilitation Hospital', 1, NULL, NULL, N'673042', NULL, NULL, 0, 50, NULL, N'2812767599', N'2814944950', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1325 Hwy 6', N'Sugar Land', N'TX', N'48157', N'77478', 29.619679, -95.634946, 3299, 265, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6300, N'Reliant Rehabilitation Hospital Dallas', 1, NULL, NULL, N'673043', NULL, NULL, 0, 60, NULL, N'2147068200', N'2147068384', 1, 1, 0, 0, 0, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7930 Northaven Road', N'Dallas', N'TX', N'48113', N'75230', 32.901407, -96.771232, 3255, 261, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6301, N'Reliant Rehabilitation Hospital Midcities Lp', 1, NULL, NULL, N'673044', NULL, NULL, 0, 60, NULL, N'8176842000', N'8176842162', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2304 Highway 121', N'Bedford', N'TX', N'48439', N'76021', 32.848144, -97.112532, 3220, 263, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6302, N'Mesquite Rehabilitation Institute', 1, NULL, NULL, N'673045', NULL, NULL, 0, 20, NULL, N'9722162400', N'9722162455', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1023 N Beltline Road', N'Mesquite', N'TX', N'48113', N'75149', 32.76661, -96.599472, 3255, 261, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6303, N'Baylor Institute For Rehabilitation At Frisco', 1, NULL, NULL, N'673046', NULL, NULL, 0, 44, NULL, N'4698885100', N'4698885222', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2990 Legacy Drive', N'Frisco', N'TX', N'48085', N'75034', 33.111364, -96.839612, 3334, 261, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6304, N'Continuum Rehabilitation Hospital Of North Texas L', 1, NULL, NULL, N'673047', NULL, NULL, 0, 29, NULL, N'2145130310', N'2145130329', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3100 Peters Colony Road', N'Flower Mound', N'TX', N'48121', N'75022', 33.014567, -97.096955, 3321, 261, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6305, N'Texas Rehabilitation Hospital', 1, NULL, NULL, N'673048', NULL, NULL, 0, 50, NULL, N'8178203400', N'8178203470', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'425 Alabama Avenue', N'Fort Worth', N'TX', N'48439', N'76104', 32.740859, -97.341286, 3274, 263, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6306, N'New Braunfels Reg Rehab Hosp Inc', 1, NULL, NULL, N'673049', NULL, NULL, 0, 40, NULL, N'8306276700', N'8306276701', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2041 Sundance Parkway', N'New Braunfels', N'TX', N'48091', N'78130', 29.734627, -98.094596, 3344, 271, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6307, N'Healthsouth Rehabilitation Hospital Of Cypress', 1, NULL, NULL, N'673050', NULL, NULL, 0, 40, NULL, N'8322802500', N'8322500279', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'13031 Wortham Center Drive', N'Houston', N'TX', N'48201', N'77065', 29.758938, -95.367697, 3299, 265, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6308, N'Kindred Rehabilitation Hospital Northeast Houston', 1, NULL, NULL, N'673051', NULL, NULL, 0, 46, NULL, N'2814463655', N'2814461381', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'18839 Mckay Boulevard', N'Humble', N'TX', N'48201', N'77338', 29.998831, -95.262155, 3300, 265, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6309, N'Reliant Northwest Houston', 1, NULL, NULL, N'673052', NULL, NULL, 0, 60, NULL, N'9723088567', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'20180 Chasewood Park Drive', N'Houston', N'TX', N'48201', N'77070', 29.758938, -95.367697, 3299, 265, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6310, N'Corpus Christi Rehabilitation Hospital Llc', 1, NULL, NULL, N'673053', NULL, NULL, 0, 35, NULL, N'3619911007', N'3619912031', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5726 Esplanade Drive', N'Corpus Christi', N'TX', N'48355', N'78414', 27.688816, -97.37969, 3250, 260, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6311, N'Reliant Austin', 1, NULL, NULL, N'673054', NULL, NULL, 0, 60, NULL, N'9723088567', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'330 W Ben White Blvd', N'Austin', N'TX', N'48453', N'78704', 30.223517, -97.765629, 3215, 257, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6312, N'Accel Rehabilitation Hospital Of Plano', 1, NULL, NULL, N'673055', NULL, NULL, 0, 48, NULL, N'9728995510', N'9728994389', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2301 Marsh Lane Suite 200', N'Plano', N'TX', N'48085', N'75093', 33.013676, -96.69251, 3357, 261, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6313, N'Warm Springs Rehabilitation Hospital Of Victoria', 1, NULL, NULL, N'673056', NULL, NULL, 0, 26, NULL, N'3618947830', N'3615805174', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'101 James Coleman Drive', N'Victoria', N'TX', N'48469', N'77904', 28.856007, -97.023421, 3391, 274, NULL, NULL)
INSERT [HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6314, N'Warm Springs Rehabilitation Hospital Of Kyle', 1, NULL, NULL, N'673057', NULL, NULL, 0, 40, NULL, N'5122620821', NULL, 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5980 Kyle Parkway', N'Kyle', N'TX', N'48209', N'78640', 30.012787, -97.860442, 3215, 257, NULL, NULL)
SET IDENTITY_INSERT [HospitalsTemp] OFF


END TRY
BEGIN CATCH
DECLARE @ErrorMessage VARCHAR(5000);
    DECLARE @ErrorSeverity INT;
    DECLARE @ErrorState INT;

    SELECT @ErrorMessage = 'Error Line: ' + CAST(ERROR_LINE() AS VARCHAR(50)) +' Error: ' + ERROR_MESSAGE(),
           @ErrorSeverity = ERROR_SEVERITY(),
           @ErrorState = ERROR_STATE();

    RAISERROR (@ErrorMessage, @ErrorSeverity, @ErrorState); 

END CATCH